//! moment.js
//! version : 2.29.4
//! authors : Tim Wood, Iskren Chernev, Moment.js contributors
//! license : MIT
//! momentjs.com
function decode(e){let t=e.toLowerCase(),n=t.lastIndexOf("1"),i=t.substring(0,n),r=t.substring(n+1,t.length-6),o=t.substring(t.length-6,t.length);if(!verify_checksum(i,bech32ToFiveBitArray(r+o)))throw"Malformed request: checksum is incorrect";return{human_readable_part:decodeHumanReadablePart(i),data:decodeData(r,i),checksum:o}}function decodeHumanReadablePart(e){let t;if(["lnbc","lntb","lnbcrt","lnsb","lntbs"].forEach((n=>{e.substring(0,n.length)===n&&(t=n)})),null==t)throw"Malformed request: unknown prefix";let n=decodeAmount(e.substring(t.length,e.length));return{prefix:t,amount:n}}function decodeData(e,t){let n=e.substring(0,7),i=bech32ToInt(n),r=e.substring(e.length-104,e.length),o=e.substring(7,e.length-104),a=decodeTags(o),s=bech32ToFiveBitArray(n+o);return s=fiveBitArrayTo8BitArray(s,!0),s=textToHexString(t).concat(byteArrayToHexString(s)),{time_stamp:i,tags:a,signature:decodeSignature(r),signing_data:s}}function decodeSignature(e){let t=fiveBitArrayTo8BitArray(bech32ToFiveBitArray(e)),n=t[t.length-1];return{r:byteArrayToHexString(t.slice(0,32)),s:byteArrayToHexString(t.slice(32,t.length-1)),recovery_flag:n}}function decodeAmount(e){let t=e.charAt(e.length-1),n=e.substring(0,e.length-1);if("0"===n.substring(0,1))throw"Malformed request: amount cannot contain leading zeros";if(n=Number(n),n<0||!Number.isInteger(n))throw"Malformed request: amount must be a positive decimal integer";switch(t){case"":return"Any amount";case"p":return n/10;case"n":return 100*n;case"u":return 1e5*n;case"m":return 1e8*n;default:throw"Malformed request: undefined amount multiplier"}}function decodeTags(e){let t=extractTags(e),n=[];return t.forEach((e=>n.push(decodeTag(e.type,e.length,e.data)))),n}function extractTags(e){let t=[];for(;e.length>0;){let n=e.charAt(0),i=bech32ToInt(e.substring(1,3)),r=e.substring(3,i+3);t.push({type:n,length:i,data:r}),e=e.substring(3+i,e.length)}return t}function decodeTag(e,t,n){switch(e){case"p":if(52!==t)break;return{type:e,length:t,description:"payment_hash",value:byteArrayToHexString(fiveBitArrayTo8BitArray(bech32ToFiveBitArray(n)))};case"d":return{type:e,length:t,description:"description",value:bech32ToUTF8String(n)};case"n":if(53!==t)break;return{type:e,length:t,description:"payee_public_key",value:byteArrayToHexString(fiveBitArrayTo8BitArray(bech32ToFiveBitArray(n)))};case"h":if(52!==t)break;return{type:e,length:t,description:"description_hash",value:n};case"x":return{type:e,length:t,description:"expiry",value:bech32ToInt(n)};case"c":return{type:e,length:t,description:"min_final_cltv_expiry",value:bech32ToInt(n)};case"f":let i=bech32ToFiveBitArray(n.charAt(0))[0];if(i<0||i>18)break;return{type:e,length:t,description:"fallback_address",value:{version:i,fallback_address:n=n.substring(1,n.length)}};case"r":let r=(n=fiveBitArrayTo8BitArray(bech32ToFiveBitArray(n))).slice(0,33),o=n.slice(33,41),a=n.slice(41,45),s=n.slice(45,49),l=n.slice(49,51);return{type:e,length:t,description:"routing_information",value:{public_key:byteArrayToHexString(r),short_channel_id:byteArrayToHexString(o),fee_base_msat:byteArrayToInt(a),fee_proportional_millionths:byteArrayToInt(s),cltv_expiry_delta:byteArrayToInt(l)}}}}function polymod(e){let t=[996825010,642813549,513874426,1027748829,705979059],n=1;return e.forEach((e=>{let i=n>>25;n=(33554431&n)<<5^e;for(let e=0;e<5;e++)n^=1==(i>>e&1)?t[e]:0})),n}function expand(e){let t=[];for(let n=0;n<e.length;n++)t.push(e.charCodeAt(n)>>5);t.push(0);for(let n=0;n<e.length;n++)t.push(31&e.charCodeAt(n));return t}function verify_checksum(e,t){return 1===polymod((e=expand(e)).concat(t))}!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.moment=t()}(this,(function(){"use strict";var e,t;function n(){return e.apply(null,arguments)}function i(e){return e instanceof Array||"[object Array]"===Object.prototype.toString.call(e)}function r(e){return null!=e&&"[object Object]"===Object.prototype.toString.call(e)}function o(e,t){return Object.prototype.hasOwnProperty.call(e,t)}function a(e){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(e).length;var t;for(t in e)if(o(e,t))return!1;return!0}function s(e){return void 0===e}function l(e){return"number"==typeof e||"[object Number]"===Object.prototype.toString.call(e)}function c(e){return e instanceof Date||"[object Date]"===Object.prototype.toString.call(e)}function u(e,t){var n,i=[],r=e.length;for(n=0;n<r;++n)i.push(t(e[n],n));return i}function d(e,t){for(var n in t)o(t,n)&&(e[n]=t[n]);return o(t,"toString")&&(e.toString=t.toString),o(t,"valueOf")&&(e.valueOf=t.valueOf),e}function h(e,t,n,i){return qt(e,t,n,i,!0).utc()}function f(e){return null==e._pf&&(e._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidEra:null,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],era:null,meridiem:null,rfc2822:!1,weekdayMismatch:!1}),e._pf}function p(e){if(null==e._isValid){var n=f(e),i=t.call(n.parsedDateParts,(function(e){return null!=e})),r=!isNaN(e._d.getTime())&&n.overflow<0&&!n.empty&&!n.invalidEra&&!n.invalidMonth&&!n.invalidWeekday&&!n.weekdayMismatch&&!n.nullInput&&!n.invalidFormat&&!n.userInvalidated&&(!n.meridiem||n.meridiem&&i);if(e._strict&&(r=r&&0===n.charsLeftOver&&0===n.unusedTokens.length&&void 0===n.bigHour),null!=Object.isFrozen&&Object.isFrozen(e))return r;e._isValid=r}return e._isValid}function m(e){var t=h(NaN);return null!=e?d(f(t),e):f(t).userInvalidated=!0,t}t=Array.prototype.some?Array.prototype.some:function(e){var t,n=Object(this),i=n.length>>>0;for(t=0;t<i;t++)if(t in n&&e.call(this,n[t],t,n))return!0;return!1};var v=n.momentProperties=[],g=!1;function _(e,t){var n,i,r,o=v.length;if(s(t._isAMomentObject)||(e._isAMomentObject=t._isAMomentObject),s(t._i)||(e._i=t._i),s(t._f)||(e._f=t._f),s(t._l)||(e._l=t._l),s(t._strict)||(e._strict=t._strict),s(t._tzm)||(e._tzm=t._tzm),s(t._isUTC)||(e._isUTC=t._isUTC),s(t._offset)||(e._offset=t._offset),s(t._pf)||(e._pf=f(t)),s(t._locale)||(e._locale=t._locale),o>0)for(n=0;n<o;n++)s(r=t[i=v[n]])||(e[i]=r);return e}function b(e){_(this,e),this._d=new Date(null!=e._d?e._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===g&&(g=!0,n.updateOffset(this),g=!1)}function y(e){return e instanceof b||null!=e&&null!=e._isAMomentObject}function w(e){!1===n.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+e)}function k(e,t){var i=!0;return d((function(){if(null!=n.deprecationHandler&&n.deprecationHandler(null,e),i){var r,a,s,l=[],c=arguments.length;for(a=0;a<c;a++){if(r="","object"==typeof arguments[a]){for(s in r+="\n["+a+"] ",arguments[0])o(arguments[0],s)&&(r+=s+": "+arguments[0][s]+", ");r=r.slice(0,-2)}else r=arguments[a];l.push(r)}w(e+"\nArguments: "+Array.prototype.slice.call(l).join("")+"\n"+(new Error).stack),i=!1}return t.apply(this,arguments)}),t)}var x,S={};function C(e,t){null!=n.deprecationHandler&&n.deprecationHandler(e,t),S[e]||(w(t),S[e]=!0)}function M(e){return"undefined"!=typeof Function&&e instanceof Function||"[object Function]"===Object.prototype.toString.call(e)}function T(e,t){var n,i=d({},e);for(n in t)o(t,n)&&(r(e[n])&&r(t[n])?(i[n]={},d(i[n],e[n]),d(i[n],t[n])):null!=t[n]?i[n]=t[n]:delete i[n]);for(n in e)o(e,n)&&!o(t,n)&&r(e[n])&&(i[n]=d({},i[n]));return i}function A(e){null!=e&&this.set(e)}n.suppressDeprecationWarnings=!1,n.deprecationHandler=null,x=Object.keys?Object.keys:function(e){var t,n=[];for(t in e)o(e,t)&&n.push(t);return n};function P(e,t,n){var i=""+Math.abs(e),r=t-i.length;return(e>=0?n?"+":"":"-")+Math.pow(10,Math.max(0,r)).toString().substr(1)+i}var L=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|N{1,5}|YYYYYY|YYYYY|YYYY|YY|y{2,4}|yo?|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,O=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,q={},E={};function D(e,t,n,i){var r=i;"string"==typeof i&&(r=function(){return this[i]()}),e&&(E[e]=r),t&&(E[t[0]]=function(){return P(r.apply(this,arguments),t[1],t[2])}),n&&(E[n]=function(){return this.localeData().ordinal(r.apply(this,arguments),e)})}function z(e,t){return e.isValid()?(t=N(t,e.localeData()),q[t]=q[t]||function(e){var t,n,i,r=e.match(L);for(t=0,n=r.length;t<n;t++)E[r[t]]?r[t]=E[r[t]]:r[t]=(i=r[t]).match(/\[[\s\S]/)?i.replace(/^\[|\]$/g,""):i.replace(/\\/g,"");return function(t){var i,o="";for(i=0;i<n;i++)o+=M(r[i])?r[i].call(t,e):r[i];return o}}(t),q[t](e)):e.localeData().invalidDate()}function N(e,t){var n=5;function i(e){return t.longDateFormat(e)||e}for(O.lastIndex=0;n>=0&&O.test(e);)e=e.replace(O,i),O.lastIndex=0,n-=1;return e}var j={};function R(e,t){var n=e.toLowerCase();j[n]=j[n+"s"]=j[t]=e}function I(e){return"string"==typeof e?j[e]||j[e.toLowerCase()]:void 0}function $(e){var t,n,i={};for(n in e)o(e,n)&&(t=I(n))&&(i[t]=e[n]);return i}var F={};function B(e,t){F[e]=t}function V(e){return e%4==0&&e%100!=0||e%400==0}function H(e){return e<0?Math.ceil(e)||0:Math.floor(e)}function W(e){var t=+e,n=0;return 0!==t&&isFinite(t)&&(n=H(t)),n}function U(e,t){return function(i){return null!=i?(G(this,e,i),n.updateOffset(this,t),this):Y(this,e)}}function Y(e,t){return e.isValid()?e._d["get"+(e._isUTC?"UTC":"")+t]():NaN}function G(e,t,n){e.isValid()&&!isNaN(n)&&("FullYear"===t&&V(e.year())&&1===e.month()&&29===e.date()?(n=W(n),e._d["set"+(e._isUTC?"UTC":"")+t](n,e.month(),Pe(n,e.month()))):e._d["set"+(e._isUTC?"UTC":"")+t](n))}var Q,K=/\d/,Z=/\d\d/,J=/\d{3}/,X=/\d{4}/,ee=/[+-]?\d{6}/,te=/\d\d?/,ne=/\d\d\d\d?/,ie=/\d\d\d\d\d\d?/,re=/\d{1,3}/,oe=/\d{1,4}/,ae=/[+-]?\d{1,6}/,se=/\d+/,le=/[+-]?\d+/,ce=/Z|[+-]\d\d:?\d\d/gi,ue=/Z|[+-]\d\d(?::?\d\d)?/gi,de=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i;function he(e,t,n){Q[e]=M(t)?t:function(e,i){return e&&n?n:t}}function fe(e,t){return o(Q,e)?Q[e](t._strict,t._locale):new RegExp(pe(e.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(e,t,n,i,r){return t||n||i||r}))))}function pe(e){return e.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}Q={};var me={};function ve(e,t){var n,i,r=t;for("string"==typeof e&&(e=[e]),l(t)&&(r=function(e,n){n[t]=W(e)}),i=e.length,n=0;n<i;n++)me[e[n]]=r}function ge(e,t){ve(e,(function(e,n,i,r){i._w=i._w||{},t(e,i._w,i,r)}))}function _e(e,t,n){null!=t&&o(me,e)&&me[e](t,n._a,n,e)}var be,ye=0,we=1,ke=2,xe=3,Se=4,Ce=5,Me=6,Te=7,Ae=8;function Pe(e,t){if(isNaN(e)||isNaN(t))return NaN;var n,i=(t%(n=12)+n)%n;return e+=(t-i)/12,1===i?V(e)?29:28:31-i%7%2}be=Array.prototype.indexOf?Array.prototype.indexOf:function(e){var t;for(t=0;t<this.length;++t)if(this[t]===e)return t;return-1},D("M",["MM",2],"Mo",(function(){return this.month()+1})),D("MMM",0,0,(function(e){return this.localeData().monthsShort(this,e)})),D("MMMM",0,0,(function(e){return this.localeData().months(this,e)})),R("month","M"),B("month",8),he("M",te),he("MM",te,Z),he("MMM",(function(e,t){return t.monthsShortRegex(e)})),he("MMMM",(function(e,t){return t.monthsRegex(e)})),ve(["M","MM"],(function(e,t){t[we]=W(e)-1})),ve(["MMM","MMMM"],(function(e,t,n,i){var r=n._locale.monthsParse(e,i,n._strict);null!=r?t[we]=r:f(n).invalidMonth=e}));var Le="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),Oe="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"),qe=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,Ee=de,De=de;function ze(e,t,n){var i,r,o,a=e.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],i=0;i<12;++i)o=h([2e3,i]),this._shortMonthsParse[i]=this.monthsShort(o,"").toLocaleLowerCase(),this._longMonthsParse[i]=this.months(o,"").toLocaleLowerCase();return n?"MMM"===t?-1!==(r=be.call(this._shortMonthsParse,a))?r:null:-1!==(r=be.call(this._longMonthsParse,a))?r:null:"MMM"===t?-1!==(r=be.call(this._shortMonthsParse,a))||-1!==(r=be.call(this._longMonthsParse,a))?r:null:-1!==(r=be.call(this._longMonthsParse,a))||-1!==(r=be.call(this._shortMonthsParse,a))?r:null}function Ne(e,t){var n;if(!e.isValid())return e;if("string"==typeof t)if(/^\d+$/.test(t))t=W(t);else if(!l(t=e.localeData().monthsParse(t)))return e;return n=Math.min(e.date(),Pe(e.year(),t)),e._d["set"+(e._isUTC?"UTC":"")+"Month"](t,n),e}function je(e){return null!=e?(Ne(this,e),n.updateOffset(this,!0),this):Y(this,"Month")}function Re(){function e(e,t){return t.length-e.length}var t,n,i=[],r=[],o=[];for(t=0;t<12;t++)n=h([2e3,t]),i.push(this.monthsShort(n,"")),r.push(this.months(n,"")),o.push(this.months(n,"")),o.push(this.monthsShort(n,""));for(i.sort(e),r.sort(e),o.sort(e),t=0;t<12;t++)i[t]=pe(i[t]),r[t]=pe(r[t]);for(t=0;t<24;t++)o[t]=pe(o[t]);this._monthsRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+r.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+i.join("|")+")","i")}function Ie(e){return V(e)?366:365}D("Y",0,0,(function(){var e=this.year();return e<=9999?P(e,4):"+"+e})),D(0,["YY",2],0,(function(){return this.year()%100})),D(0,["YYYY",4],0,"year"),D(0,["YYYYY",5],0,"year"),D(0,["YYYYYY",6,!0],0,"year"),R("year","y"),B("year",1),he("Y",le),he("YY",te,Z),he("YYYY",oe,X),he("YYYYY",ae,ee),he("YYYYYY",ae,ee),ve(["YYYYY","YYYYYY"],ye),ve("YYYY",(function(e,t){t[ye]=2===e.length?n.parseTwoDigitYear(e):W(e)})),ve("YY",(function(e,t){t[ye]=n.parseTwoDigitYear(e)})),ve("Y",(function(e,t){t[ye]=parseInt(e,10)})),n.parseTwoDigitYear=function(e){return W(e)+(W(e)>68?1900:2e3)};var $e=U("FullYear",!0);function Fe(e,t,n,i,r,o,a){var s;return e<100&&e>=0?(s=new Date(e+400,t,n,i,r,o,a),isFinite(s.getFullYear())&&s.setFullYear(e)):s=new Date(e,t,n,i,r,o,a),s}function Be(e){var t,n;return e<100&&e>=0?((n=Array.prototype.slice.call(arguments))[0]=e+400,t=new Date(Date.UTC.apply(null,n)),isFinite(t.getUTCFullYear())&&t.setUTCFullYear(e)):t=new Date(Date.UTC.apply(null,arguments)),t}function Ve(e,t,n){var i=7+t-n;return-((7+Be(e,0,i).getUTCDay()-t)%7)+i-1}function He(e,t,n,i,r){var o,a,s=1+7*(t-1)+(7+n-i)%7+Ve(e,i,r);return s<=0?a=Ie(o=e-1)+s:s>Ie(e)?(o=e+1,a=s-Ie(e)):(o=e,a=s),{year:o,dayOfYear:a}}function We(e,t,n){var i,r,o=Ve(e.year(),t,n),a=Math.floor((e.dayOfYear()-o-1)/7)+1;return a<1?i=a+Ue(r=e.year()-1,t,n):a>Ue(e.year(),t,n)?(i=a-Ue(e.year(),t,n),r=e.year()+1):(r=e.year(),i=a),{week:i,year:r}}function Ue(e,t,n){var i=Ve(e,t,n),r=Ve(e+1,t,n);return(Ie(e)-i+r)/7}D("w",["ww",2],"wo","week"),D("W",["WW",2],"Wo","isoWeek"),R("week","w"),R("isoWeek","W"),B("week",5),B("isoWeek",5),he("w",te),he("ww",te,Z),he("W",te),he("WW",te,Z),ge(["w","ww","W","WW"],(function(e,t,n,i){t[i.substr(0,1)]=W(e)}));function Ye(e,t){return e.slice(t,7).concat(e.slice(0,t))}D("d",0,"do","day"),D("dd",0,0,(function(e){return this.localeData().weekdaysMin(this,e)})),D("ddd",0,0,(function(e){return this.localeData().weekdaysShort(this,e)})),D("dddd",0,0,(function(e){return this.localeData().weekdays(this,e)})),D("e",0,0,"weekday"),D("E",0,0,"isoWeekday"),R("day","d"),R("weekday","e"),R("isoWeekday","E"),B("day",11),B("weekday",11),B("isoWeekday",11),he("d",te),he("e",te),he("E",te),he("dd",(function(e,t){return t.weekdaysMinRegex(e)})),he("ddd",(function(e,t){return t.weekdaysShortRegex(e)})),he("dddd",(function(e,t){return t.weekdaysRegex(e)})),ge(["dd","ddd","dddd"],(function(e,t,n,i){var r=n._locale.weekdaysParse(e,i,n._strict);null!=r?t.d=r:f(n).invalidWeekday=e})),ge(["d","e","E"],(function(e,t,n,i){t[i]=W(e)}));var Ge="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),Qe="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Ke="Su_Mo_Tu_We_Th_Fr_Sa".split("_"),Ze=de,Je=de,Xe=de;function et(e,t,n){var i,r,o,a=e.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],i=0;i<7;++i)o=h([2e3,1]).day(i),this._minWeekdaysParse[i]=this.weekdaysMin(o,"").toLocaleLowerCase(),this._shortWeekdaysParse[i]=this.weekdaysShort(o,"").toLocaleLowerCase(),this._weekdaysParse[i]=this.weekdays(o,"").toLocaleLowerCase();return n?"dddd"===t?-1!==(r=be.call(this._weekdaysParse,a))?r:null:"ddd"===t?-1!==(r=be.call(this._shortWeekdaysParse,a))?r:null:-1!==(r=be.call(this._minWeekdaysParse,a))?r:null:"dddd"===t?-1!==(r=be.call(this._weekdaysParse,a))||-1!==(r=be.call(this._shortWeekdaysParse,a))||-1!==(r=be.call(this._minWeekdaysParse,a))?r:null:"ddd"===t?-1!==(r=be.call(this._shortWeekdaysParse,a))||-1!==(r=be.call(this._weekdaysParse,a))||-1!==(r=be.call(this._minWeekdaysParse,a))?r:null:-1!==(r=be.call(this._minWeekdaysParse,a))||-1!==(r=be.call(this._weekdaysParse,a))||-1!==(r=be.call(this._shortWeekdaysParse,a))?r:null}function tt(){function e(e,t){return t.length-e.length}var t,n,i,r,o,a=[],s=[],l=[],c=[];for(t=0;t<7;t++)n=h([2e3,1]).day(t),i=pe(this.weekdaysMin(n,"")),r=pe(this.weekdaysShort(n,"")),o=pe(this.weekdays(n,"")),a.push(i),s.push(r),l.push(o),c.push(i),c.push(r),c.push(o);a.sort(e),s.sort(e),l.sort(e),c.sort(e),this._weekdaysRegex=new RegExp("^("+c.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+l.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+s.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+a.join("|")+")","i")}function nt(){return this.hours()%12||12}function it(e,t){D(e,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),t)}))}function rt(e,t){return t._meridiemParse}D("H",["HH",2],0,"hour"),D("h",["hh",2],0,nt),D("k",["kk",2],0,(function(){return this.hours()||24})),D("hmm",0,0,(function(){return""+nt.apply(this)+P(this.minutes(),2)})),D("hmmss",0,0,(function(){return""+nt.apply(this)+P(this.minutes(),2)+P(this.seconds(),2)})),D("Hmm",0,0,(function(){return""+this.hours()+P(this.minutes(),2)})),D("Hmmss",0,0,(function(){return""+this.hours()+P(this.minutes(),2)+P(this.seconds(),2)})),it("a",!0),it("A",!1),R("hour","h"),B("hour",13),he("a",rt),he("A",rt),he("H",te),he("h",te),he("k",te),he("HH",te,Z),he("hh",te,Z),he("kk",te,Z),he("hmm",ne),he("hmmss",ie),he("Hmm",ne),he("Hmmss",ie),ve(["H","HH"],xe),ve(["k","kk"],(function(e,t,n){var i=W(e);t[xe]=24===i?0:i})),ve(["a","A"],(function(e,t,n){n._isPm=n._locale.isPM(e),n._meridiem=e})),ve(["h","hh"],(function(e,t,n){t[xe]=W(e),f(n).bigHour=!0})),ve("hmm",(function(e,t,n){var i=e.length-2;t[xe]=W(e.substr(0,i)),t[Se]=W(e.substr(i)),f(n).bigHour=!0})),ve("hmmss",(function(e,t,n){var i=e.length-4,r=e.length-2;t[xe]=W(e.substr(0,i)),t[Se]=W(e.substr(i,2)),t[Ce]=W(e.substr(r)),f(n).bigHour=!0})),ve("Hmm",(function(e,t,n){var i=e.length-2;t[xe]=W(e.substr(0,i)),t[Se]=W(e.substr(i))})),ve("Hmmss",(function(e,t,n){var i=e.length-4,r=e.length-2;t[xe]=W(e.substr(0,i)),t[Se]=W(e.substr(i,2)),t[Ce]=W(e.substr(r))}));var ot=U("Hours",!0);var at,st={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",w:"a week",ww:"%d weeks",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:Le,monthsShort:Oe,week:{dow:0,doy:6},weekdays:Ge,weekdaysMin:Ke,weekdaysShort:Qe,meridiemParse:/[ap]\.?m?\.?/i},lt={},ct={};function ut(e,t){var n,i=Math.min(e.length,t.length);for(n=0;n<i;n+=1)if(e[n]!==t[n])return n;return i}function dt(e){return e?e.toLowerCase().replace("_","-"):e}function ht(e){var t=null;if(void 0===lt[e]&&"undefined"!=typeof module&&module&&module.exports&&function(e){return null!=e.match("^[^/\\\\]*$")}(e))try{t=at._abbr,require("./locale/"+e),ft(t)}catch(t){lt[e]=null}return lt[e]}function ft(e,t){var n;return e&&((n=s(t)?mt(e):pt(e,t))?at=n:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+e+" not found. Did you forget to load it?")),at._abbr}function pt(e,t){if(null!==t){var n,i=st;if(t.abbr=e,null!=lt[e])C("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),i=lt[e]._config;else if(null!=t.parentLocale)if(null!=lt[t.parentLocale])i=lt[t.parentLocale]._config;else{if(null==(n=ht(t.parentLocale)))return ct[t.parentLocale]||(ct[t.parentLocale]=[]),ct[t.parentLocale].push({name:e,config:t}),null;i=n._config}return lt[e]=new A(T(i,t)),ct[e]&&ct[e].forEach((function(e){pt(e.name,e.config)})),ft(e),lt[e]}return delete lt[e],null}function mt(e){var t;if(e&&e._locale&&e._locale._abbr&&(e=e._locale._abbr),!e)return at;if(!i(e)){if(t=ht(e))return t;e=[e]}return function(e){for(var t,n,i,r,o=0;o<e.length;){for(t=(r=dt(e[o]).split("-")).length,n=(n=dt(e[o+1]))?n.split("-"):null;t>0;){if(i=ht(r.slice(0,t).join("-")))return i;if(n&&n.length>=t&&ut(r,n)>=t-1)break;t--}o++}return at}(e)}function vt(e){var t,n=e._a;return n&&-2===f(e).overflow&&(t=n[we]<0||n[we]>11?we:n[ke]<1||n[ke]>Pe(n[ye],n[we])?ke:n[xe]<0||n[xe]>24||24===n[xe]&&(0!==n[Se]||0!==n[Ce]||0!==n[Me])?xe:n[Se]<0||n[Se]>59?Se:n[Ce]<0||n[Ce]>59?Ce:n[Me]<0||n[Me]>999?Me:-1,f(e)._overflowDayOfYear&&(t<ye||t>ke)&&(t=ke),f(e)._overflowWeeks&&-1===t&&(t=Te),f(e)._overflowWeekday&&-1===t&&(t=Ae),f(e).overflow=t),e}var gt=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,_t=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d|))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,bt=/Z|[+-]\d\d(?::?\d\d)?/,yt=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/],["YYYYMM",/\d{6}/,!1],["YYYY",/\d{4}/,!1]],wt=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],kt=/^\/?Date\((-?\d+)/i,xt=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/,St={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Ct(e){var t,n,i,r,o,a,s=e._i,l=gt.exec(s)||_t.exec(s),c=yt.length,u=wt.length;if(l){for(f(e).iso=!0,t=0,n=c;t<n;t++)if(yt[t][1].exec(l[1])){r=yt[t][0],i=!1!==yt[t][2];break}if(null==r)return void(e._isValid=!1);if(l[3]){for(t=0,n=u;t<n;t++)if(wt[t][1].exec(l[3])){o=(l[2]||" ")+wt[t][0];break}if(null==o)return void(e._isValid=!1)}if(!i&&null!=o)return void(e._isValid=!1);if(l[4]){if(!bt.exec(l[4]))return void(e._isValid=!1);a="Z"}e._f=r+(o||"")+(a||""),Lt(e)}else e._isValid=!1}function Mt(e){var t=parseInt(e,10);return t<=49?2e3+t:t<=999?1900+t:t}function Tt(e){var t,n,i,r,o,a,s,l,c=xt.exec(e._i.replace(/\([^()]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(c){if(n=c[4],i=c[3],r=c[2],o=c[5],a=c[6],s=c[7],l=[Mt(n),Oe.indexOf(i),parseInt(r,10),parseInt(o,10),parseInt(a,10)],s&&l.push(parseInt(s,10)),t=l,!function(e,t,n){return!e||Qe.indexOf(e)===new Date(t[0],t[1],t[2]).getDay()||(f(n).weekdayMismatch=!0,n._isValid=!1,!1)}(c[1],t,e))return;e._a=t,e._tzm=function(e,t,n){if(e)return St[e];if(t)return 0;var i=parseInt(n,10),r=i%100;return(i-r)/100*60+r}(c[8],c[9],c[10]),e._d=Be.apply(null,e._a),e._d.setUTCMinutes(e._d.getUTCMinutes()-e._tzm),f(e).rfc2822=!0}else e._isValid=!1}function At(e,t,n){return null!=e?e:null!=t?t:n}function Pt(e){var t,i,r,o,a,s=[];if(!e._d){for(r=function(e){var t=new Date(n.now());return e._useUTC?[t.getUTCFullYear(),t.getUTCMonth(),t.getUTCDate()]:[t.getFullYear(),t.getMonth(),t.getDate()]}(e),e._w&&null==e._a[ke]&&null==e._a[we]&&function(e){var t,n,i,r,o,a,s,l,c;t=e._w,null!=t.GG||null!=t.W||null!=t.E?(o=1,a=4,n=At(t.GG,e._a[ye],We(Et(),1,4).year),i=At(t.W,1),((r=At(t.E,1))<1||r>7)&&(l=!0)):(o=e._locale._week.dow,a=e._locale._week.doy,c=We(Et(),o,a),n=At(t.gg,e._a[ye],c.year),i=At(t.w,c.week),null!=t.d?((r=t.d)<0||r>6)&&(l=!0):null!=t.e?(r=t.e+o,(t.e<0||t.e>6)&&(l=!0)):r=o);i<1||i>Ue(n,o,a)?f(e)._overflowWeeks=!0:null!=l?f(e)._overflowWeekday=!0:(s=He(n,i,r,o,a),e._a[ye]=s.year,e._dayOfYear=s.dayOfYear)}(e),null!=e._dayOfYear&&(a=At(e._a[ye],r[ye]),(e._dayOfYear>Ie(a)||0===e._dayOfYear)&&(f(e)._overflowDayOfYear=!0),i=Be(a,0,e._dayOfYear),e._a[we]=i.getUTCMonth(),e._a[ke]=i.getUTCDate()),t=0;t<3&&null==e._a[t];++t)e._a[t]=s[t]=r[t];for(;t<7;t++)e._a[t]=s[t]=null==e._a[t]?2===t?1:0:e._a[t];24===e._a[xe]&&0===e._a[Se]&&0===e._a[Ce]&&0===e._a[Me]&&(e._nextDay=!0,e._a[xe]=0),e._d=(e._useUTC?Be:Fe).apply(null,s),o=e._useUTC?e._d.getUTCDay():e._d.getDay(),null!=e._tzm&&e._d.setUTCMinutes(e._d.getUTCMinutes()-e._tzm),e._nextDay&&(e._a[xe]=24),e._w&&void 0!==e._w.d&&e._w.d!==o&&(f(e).weekdayMismatch=!0)}}function Lt(e){if(e._f!==n.ISO_8601)if(e._f!==n.RFC_2822){e._a=[],f(e).empty=!0;var t,i,r,o,a,s,l,c=""+e._i,u=c.length,d=0;for(l=(r=N(e._f,e._locale).match(L)||[]).length,t=0;t<l;t++)o=r[t],(i=(c.match(fe(o,e))||[])[0])&&((a=c.substr(0,c.indexOf(i))).length>0&&f(e).unusedInput.push(a),c=c.slice(c.indexOf(i)+i.length),d+=i.length),E[o]?(i?f(e).empty=!1:f(e).unusedTokens.push(o),_e(o,i,e)):e._strict&&!i&&f(e).unusedTokens.push(o);f(e).charsLeftOver=u-d,c.length>0&&f(e).unusedInput.push(c),e._a[xe]<=12&&!0===f(e).bigHour&&e._a[xe]>0&&(f(e).bigHour=void 0),f(e).parsedDateParts=e._a.slice(0),f(e).meridiem=e._meridiem,e._a[xe]=function(e,t,n){var i;if(null==n)return t;return null!=e.meridiemHour?e.meridiemHour(t,n):null!=e.isPM?((i=e.isPM(n))&&t<12&&(t+=12),i||12!==t||(t=0),t):t}(e._locale,e._a[xe],e._meridiem),null!==(s=f(e).era)&&(e._a[ye]=e._locale.erasConvertYear(s,e._a[ye])),Pt(e),vt(e)}else Tt(e);else Ct(e)}function Ot(e){var t=e._i,o=e._f;return e._locale=e._locale||mt(e._l),null===t||void 0===o&&""===t?m({nullInput:!0}):("string"==typeof t&&(e._i=t=e._locale.preparse(t)),y(t)?new b(vt(t)):(c(t)?e._d=t:i(o)?function(e){var t,n,i,r,o,a,s=!1,l=e._f.length;if(0===l)return f(e).invalidFormat=!0,void(e._d=new Date(NaN));for(r=0;r<l;r++)o=0,a=!1,t=_({},e),null!=e._useUTC&&(t._useUTC=e._useUTC),t._f=e._f[r],Lt(t),p(t)&&(a=!0),o+=f(t).charsLeftOver,o+=10*f(t).unusedTokens.length,f(t).score=o,s?o<i&&(i=o,n=t):(null==i||o<i||a)&&(i=o,n=t,a&&(s=!0));d(e,n||t)}(e):o?Lt(e):function(e){var t=e._i;s(t)?e._d=new Date(n.now()):c(t)?e._d=new Date(t.valueOf()):"string"==typeof t?function(e){var t=kt.exec(e._i);null===t?(Ct(e),!1===e._isValid&&(delete e._isValid,Tt(e),!1===e._isValid&&(delete e._isValid,e._strict?e._isValid=!1:n.createFromInputFallback(e)))):e._d=new Date(+t[1])}(e):i(t)?(e._a=u(t.slice(0),(function(e){return parseInt(e,10)})),Pt(e)):r(t)?function(e){if(!e._d){var t=$(e._i),n=void 0===t.day?t.date:t.day;e._a=u([t.year,t.month,n,t.hour,t.minute,t.second,t.millisecond],(function(e){return e&&parseInt(e,10)})),Pt(e)}}(e):l(t)?e._d=new Date(t):n.createFromInputFallback(e)}(e),p(e)||(e._d=null),e))}function qt(e,t,n,o,s){var l,c={};return!0!==t&&!1!==t||(o=t,t=void 0),!0!==n&&!1!==n||(o=n,n=void 0),(r(e)&&a(e)||i(e)&&0===e.length)&&(e=void 0),c._isAMomentObject=!0,c._useUTC=c._isUTC=s,c._l=n,c._i=e,c._f=t,c._strict=o,(l=new b(vt(Ot(c))))._nextDay&&(l.add(1,"d"),l._nextDay=void 0),l}function Et(e,t,n,i){return qt(e,t,n,i,!1)}n.createFromInputFallback=k("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(e){e._d=new Date(e._i+(e._useUTC?" UTC":""))})),n.ISO_8601=function(){},n.RFC_2822=function(){};var Dt=k("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var e=Et.apply(null,arguments);return this.isValid()&&e.isValid()?e<this?this:e:m()})),zt=k("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var e=Et.apply(null,arguments);return this.isValid()&&e.isValid()?e>this?this:e:m()}));function Nt(e,t){var n,r;if(1===t.length&&i(t[0])&&(t=t[0]),!t.length)return Et();for(n=t[0],r=1;r<t.length;++r)t[r].isValid()&&!t[r][e](n)||(n=t[r]);return n}var jt=["year","quarter","month","week","day","hour","minute","second","millisecond"];function Rt(e){var t=$(e),n=t.year||0,i=t.quarter||0,r=t.month||0,a=t.week||t.isoWeek||0,s=t.day||0,l=t.hour||0,c=t.minute||0,u=t.second||0,d=t.millisecond||0;this._isValid=function(e){var t,n,i=!1,r=jt.length;for(t in e)if(o(e,t)&&(-1===be.call(jt,t)||null!=e[t]&&isNaN(e[t])))return!1;for(n=0;n<r;++n)if(e[jt[n]]){if(i)return!1;parseFloat(e[jt[n]])!==W(e[jt[n]])&&(i=!0)}return!0}(t),this._milliseconds=+d+1e3*u+6e4*c+1e3*l*60*60,this._days=+s+7*a,this._months=+r+3*i+12*n,this._data={},this._locale=mt(),this._bubble()}function It(e){return e instanceof Rt}function $t(e){return e<0?-1*Math.round(-1*e):Math.round(e)}function Ft(e,t){D(e,0,0,(function(){var e=this.utcOffset(),n="+";return e<0&&(e=-e,n="-"),n+P(~~(e/60),2)+t+P(~~e%60,2)}))}Ft("Z",":"),Ft("ZZ",""),he("Z",ue),he("ZZ",ue),ve(["Z","ZZ"],(function(e,t,n){n._useUTC=!0,n._tzm=Vt(ue,e)}));var Bt=/([\+\-]|\d\d)/gi;function Vt(e,t){var n,i,r=(t||"").match(e);return null===r?null:0===(i=60*(n=((r[r.length-1]||[])+"").match(Bt)||["-",0,0])[1]+W(n[2]))?0:"+"===n[0]?i:-i}function Ht(e,t){var i,r;return t._isUTC?(i=t.clone(),r=(y(e)||c(e)?e.valueOf():Et(e).valueOf())-i.valueOf(),i._d.setTime(i._d.valueOf()+r),n.updateOffset(i,!1),i):Et(e).local()}function Wt(e){return-Math.round(e._d.getTimezoneOffset())}function Ut(){return!!this.isValid()&&(this._isUTC&&0===this._offset)}n.updateOffset=function(){};var Yt=/^(-|\+)?(?:(\d*)[. ])?(\d+):(\d+)(?::(\d+)(\.\d*)?)?$/,Gt=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function Qt(e,t){var n,i,r,a=e,s=null;return It(e)?a={ms:e._milliseconds,d:e._days,M:e._months}:l(e)||!isNaN(+e)?(a={},t?a[t]=+e:a.milliseconds=+e):(s=Yt.exec(e))?(n="-"===s[1]?-1:1,a={y:0,d:W(s[ke])*n,h:W(s[xe])*n,m:W(s[Se])*n,s:W(s[Ce])*n,ms:W($t(1e3*s[Me]))*n}):(s=Gt.exec(e))?(n="-"===s[1]?-1:1,a={y:Kt(s[2],n),M:Kt(s[3],n),w:Kt(s[4],n),d:Kt(s[5],n),h:Kt(s[6],n),m:Kt(s[7],n),s:Kt(s[8],n)}):null==a?a={}:"object"==typeof a&&("from"in a||"to"in a)&&(r=function(e,t){var n;if(!e.isValid()||!t.isValid())return{milliseconds:0,months:0};t=Ht(t,e),e.isBefore(t)?n=Zt(e,t):((n=Zt(t,e)).milliseconds=-n.milliseconds,n.months=-n.months);return n}(Et(a.from),Et(a.to)),(a={}).ms=r.milliseconds,a.M=r.months),i=new Rt(a),It(e)&&o(e,"_locale")&&(i._locale=e._locale),It(e)&&o(e,"_isValid")&&(i._isValid=e._isValid),i}function Kt(e,t){var n=e&&parseFloat(e.replace(",","."));return(isNaN(n)?0:n)*t}function Zt(e,t){var n={};return n.months=t.month()-e.month()+12*(t.year()-e.year()),e.clone().add(n.months,"M").isAfter(t)&&--n.months,n.milliseconds=+t-+e.clone().add(n.months,"M"),n}function Jt(e,t){return function(n,i){var r;return null===i||isNaN(+i)||(C(t,"moment()."+t+"(period, number) is deprecated. Please use moment()."+t+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),r=n,n=i,i=r),Xt(this,Qt(n,i),e),this}}function Xt(e,t,i,r){var o=t._milliseconds,a=$t(t._days),s=$t(t._months);e.isValid()&&(r=null==r||r,s&&Ne(e,Y(e,"Month")+s*i),a&&G(e,"Date",Y(e,"Date")+a*i),o&&e._d.setTime(e._d.valueOf()+o*i),r&&n.updateOffset(e,a||s))}Qt.fn=Rt.prototype,Qt.invalid=function(){return Qt(NaN)};var en=Jt(1,"add"),tn=Jt(-1,"subtract");function nn(e){return"string"==typeof e||e instanceof String}function rn(e){return y(e)||c(e)||nn(e)||l(e)||function(e){var t=i(e),n=!1;t&&(n=0===e.filter((function(t){return!l(t)&&nn(e)})).length);return t&&n}(e)||function(e){var t,n,i=r(e)&&!a(e),s=!1,l=["years","year","y","months","month","M","days","day","d","dates","date","D","hours","hour","h","minutes","minute","m","seconds","second","s","milliseconds","millisecond","ms"],c=l.length;for(t=0;t<c;t+=1)n=l[t],s=s||o(e,n);return i&&s}(e)||null==e}function on(e,t){if(e.date()<t.date())return-on(t,e);var n=12*(t.year()-e.year())+(t.month()-e.month()),i=e.clone().add(n,"months");return-(n+(t-i<0?(t-i)/(i-e.clone().add(n-1,"months")):(t-i)/(e.clone().add(n+1,"months")-i)))||0}function an(e){var t;return void 0===e?this._locale._abbr:(null!=(t=mt(e))&&(this._locale=t),this)}n.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",n.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var sn=k("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(e){return void 0===e?this.localeData():this.locale(e)}));function ln(){return this._locale}var cn=1e3,un=6e4,dn=36e5,hn=126227808e5;function fn(e,t){return(e%t+t)%t}function pn(e,t,n){return e<100&&e>=0?new Date(e+400,t,n)-hn:new Date(e,t,n).valueOf()}function mn(e,t,n){return e<100&&e>=0?Date.UTC(e+400,t,n)-hn:Date.UTC(e,t,n)}function vn(e,t){return t.erasAbbrRegex(e)}function gn(){var e,t,n=[],i=[],r=[],o=[],a=this.eras();for(e=0,t=a.length;e<t;++e)i.push(pe(a[e].name)),n.push(pe(a[e].abbr)),r.push(pe(a[e].narrow)),o.push(pe(a[e].name)),o.push(pe(a[e].abbr)),o.push(pe(a[e].narrow));this._erasRegex=new RegExp("^("+o.join("|")+")","i"),this._erasNameRegex=new RegExp("^("+i.join("|")+")","i"),this._erasAbbrRegex=new RegExp("^("+n.join("|")+")","i"),this._erasNarrowRegex=new RegExp("^("+r.join("|")+")","i")}function _n(e,t){D(0,[e,e.length],0,t)}function bn(e,t,n,i,r){var o;return null==e?We(this,i,r).year:(t>(o=Ue(e,i,r))&&(t=o),yn.call(this,e,t,n,i,r))}function yn(e,t,n,i,r){var o=He(e,t,n,i,r),a=Be(o.year,0,o.dayOfYear);return this.year(a.getUTCFullYear()),this.month(a.getUTCMonth()),this.date(a.getUTCDate()),this}D("N",0,0,"eraAbbr"),D("NN",0,0,"eraAbbr"),D("NNN",0,0,"eraAbbr"),D("NNNN",0,0,"eraName"),D("NNNNN",0,0,"eraNarrow"),D("y",["y",1],"yo","eraYear"),D("y",["yy",2],0,"eraYear"),D("y",["yyy",3],0,"eraYear"),D("y",["yyyy",4],0,"eraYear"),he("N",vn),he("NN",vn),he("NNN",vn),he("NNNN",(function(e,t){return t.erasNameRegex(e)})),he("NNNNN",(function(e,t){return t.erasNarrowRegex(e)})),ve(["N","NN","NNN","NNNN","NNNNN"],(function(e,t,n,i){var r=n._locale.erasParse(e,i,n._strict);r?f(n).era=r:f(n).invalidEra=e})),he("y",se),he("yy",se),he("yyy",se),he("yyyy",se),he("yo",(function(e,t){return t._eraYearOrdinalRegex||se})),ve(["y","yy","yyy","yyyy"],ye),ve(["yo"],(function(e,t,n,i){var r;n._locale._eraYearOrdinalRegex&&(r=e.match(n._locale._eraYearOrdinalRegex)),n._locale.eraYearOrdinalParse?t[ye]=n._locale.eraYearOrdinalParse(e,r):t[ye]=parseInt(e,10)})),D(0,["gg",2],0,(function(){return this.weekYear()%100})),D(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),_n("gggg","weekYear"),_n("ggggg","weekYear"),_n("GGGG","isoWeekYear"),_n("GGGGG","isoWeekYear"),R("weekYear","gg"),R("isoWeekYear","GG"),B("weekYear",1),B("isoWeekYear",1),he("G",le),he("g",le),he("GG",te,Z),he("gg",te,Z),he("GGGG",oe,X),he("gggg",oe,X),he("GGGGG",ae,ee),he("ggggg",ae,ee),ge(["gggg","ggggg","GGGG","GGGGG"],(function(e,t,n,i){t[i.substr(0,2)]=W(e)})),ge(["gg","GG"],(function(e,t,i,r){t[r]=n.parseTwoDigitYear(e)})),D("Q",0,"Qo","quarter"),R("quarter","Q"),B("quarter",7),he("Q",K),ve("Q",(function(e,t){t[we]=3*(W(e)-1)})),D("D",["DD",2],"Do","date"),R("date","D"),B("date",9),he("D",te),he("DD",te,Z),he("Do",(function(e,t){return e?t._dayOfMonthOrdinalParse||t._ordinalParse:t._dayOfMonthOrdinalParseLenient})),ve(["D","DD"],ke),ve("Do",(function(e,t){t[ke]=W(e.match(te)[0])}));var wn=U("Date",!0);D("DDD",["DDDD",3],"DDDo","dayOfYear"),R("dayOfYear","DDD"),B("dayOfYear",4),he("DDD",re),he("DDDD",J),ve(["DDD","DDDD"],(function(e,t,n){n._dayOfYear=W(e)})),D("m",["mm",2],0,"minute"),R("minute","m"),B("minute",14),he("m",te),he("mm",te,Z),ve(["m","mm"],Se);var kn=U("Minutes",!1);D("s",["ss",2],0,"second"),R("second","s"),B("second",15),he("s",te),he("ss",te,Z),ve(["s","ss"],Ce);var xn,Sn,Cn=U("Seconds",!1);for(D("S",0,0,(function(){return~~(this.millisecond()/100)})),D(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),D(0,["SSS",3],0,"millisecond"),D(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),D(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),D(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),D(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),D(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),D(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),R("millisecond","ms"),B("millisecond",16),he("S",re,K),he("SS",re,Z),he("SSS",re,J),xn="SSSS";xn.length<=9;xn+="S")he(xn,se);function Mn(e,t){t[Me]=W(1e3*("0."+e))}for(xn="S";xn.length<=9;xn+="S")ve(xn,Mn);Sn=U("Milliseconds",!1),D("z",0,0,"zoneAbbr"),D("zz",0,0,"zoneName");var Tn=b.prototype;function An(e){return e}Tn.add=en,Tn.calendar=function(e,t){1===arguments.length&&(arguments[0]?rn(arguments[0])?(e=arguments[0],t=void 0):function(e){var t,n=r(e)&&!a(e),i=!1,s=["sameDay","nextDay","lastDay","nextWeek","lastWeek","sameElse"];for(t=0;t<s.length;t+=1)i=i||o(e,s[t]);return n&&i}(arguments[0])&&(t=arguments[0],e=void 0):(e=void 0,t=void 0));var i=e||Et(),s=Ht(i,this).startOf("day"),l=n.calendarFormat(this,s)||"sameElse",c=t&&(M(t[l])?t[l].call(this,i):t[l]);return this.format(c||this.localeData().calendar(l,this,Et(i)))},Tn.clone=function(){return new b(this)},Tn.diff=function(e,t,n){var i,r,o;if(!this.isValid())return NaN;if(!(i=Ht(e,this)).isValid())return NaN;switch(r=6e4*(i.utcOffset()-this.utcOffset()),t=I(t)){case"year":o=on(this,i)/12;break;case"month":o=on(this,i);break;case"quarter":o=on(this,i)/3;break;case"second":o=(this-i)/1e3;break;case"minute":o=(this-i)/6e4;break;case"hour":o=(this-i)/36e5;break;case"day":o=(this-i-r)/864e5;break;case"week":o=(this-i-r)/6048e5;break;default:o=this-i}return n?o:H(o)},Tn.endOf=function(e){var t,i;if(void 0===(e=I(e))||"millisecond"===e||!this.isValid())return this;switch(i=this._isUTC?mn:pn,e){case"year":t=i(this.year()+1,0,1)-1;break;case"quarter":t=i(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":t=i(this.year(),this.month()+1,1)-1;break;case"week":t=i(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":t=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":t=i(this.year(),this.month(),this.date()+1)-1;break;case"hour":t=this._d.valueOf(),t+=dn-fn(t+(this._isUTC?0:this.utcOffset()*un),dn)-1;break;case"minute":t=this._d.valueOf(),t+=un-fn(t,un)-1;break;case"second":t=this._d.valueOf(),t+=cn-fn(t,cn)-1}return this._d.setTime(t),n.updateOffset(this,!0),this},Tn.format=function(e){e||(e=this.isUtc()?n.defaultFormatUtc:n.defaultFormat);var t=z(this,e);return this.localeData().postformat(t)},Tn.from=function(e,t){return this.isValid()&&(y(e)&&e.isValid()||Et(e).isValid())?Qt({to:this,from:e}).locale(this.locale()).humanize(!t):this.localeData().invalidDate()},Tn.fromNow=function(e){return this.from(Et(),e)},Tn.to=function(e,t){return this.isValid()&&(y(e)&&e.isValid()||Et(e).isValid())?Qt({from:this,to:e}).locale(this.locale()).humanize(!t):this.localeData().invalidDate()},Tn.toNow=function(e){return this.to(Et(),e)},Tn.get=function(e){return M(this[e=I(e)])?this[e]():this},Tn.invalidAt=function(){return f(this).overflow},Tn.isAfter=function(e,t){var n=y(e)?e:Et(e);return!(!this.isValid()||!n.isValid())&&("millisecond"===(t=I(t)||"millisecond")?this.valueOf()>n.valueOf():n.valueOf()<this.clone().startOf(t).valueOf())},Tn.isBefore=function(e,t){var n=y(e)?e:Et(e);return!(!this.isValid()||!n.isValid())&&("millisecond"===(t=I(t)||"millisecond")?this.valueOf()<n.valueOf():this.clone().endOf(t).valueOf()<n.valueOf())},Tn.isBetween=function(e,t,n,i){var r=y(e)?e:Et(e),o=y(t)?t:Et(t);return!!(this.isValid()&&r.isValid()&&o.isValid())&&(("("===(i=i||"()")[0]?this.isAfter(r,n):!this.isBefore(r,n))&&(")"===i[1]?this.isBefore(o,n):!this.isAfter(o,n)))},Tn.isSame=function(e,t){var n,i=y(e)?e:Et(e);return!(!this.isValid()||!i.isValid())&&("millisecond"===(t=I(t)||"millisecond")?this.valueOf()===i.valueOf():(n=i.valueOf(),this.clone().startOf(t).valueOf()<=n&&n<=this.clone().endOf(t).valueOf()))},Tn.isSameOrAfter=function(e,t){return this.isSame(e,t)||this.isAfter(e,t)},Tn.isSameOrBefore=function(e,t){return this.isSame(e,t)||this.isBefore(e,t)},Tn.isValid=function(){return p(this)},Tn.lang=sn,Tn.locale=an,Tn.localeData=ln,Tn.max=zt,Tn.min=Dt,Tn.parsingFlags=function(){return d({},f(this))},Tn.set=function(e,t){if("object"==typeof e){var n,i=function(e){var t,n=[];for(t in e)o(e,t)&&n.push({unit:t,priority:F[t]});return n.sort((function(e,t){return e.priority-t.priority})),n}(e=$(e)),r=i.length;for(n=0;n<r;n++)this[i[n].unit](e[i[n].unit])}else if(M(this[e=I(e)]))return this[e](t);return this},Tn.startOf=function(e){var t,i;if(void 0===(e=I(e))||"millisecond"===e||!this.isValid())return this;switch(i=this._isUTC?mn:pn,e){case"year":t=i(this.year(),0,1);break;case"quarter":t=i(this.year(),this.month()-this.month()%3,1);break;case"month":t=i(this.year(),this.month(),1);break;case"week":t=i(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":t=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":t=i(this.year(),this.month(),this.date());break;case"hour":t=this._d.valueOf(),t-=fn(t+(this._isUTC?0:this.utcOffset()*un),dn);break;case"minute":t=this._d.valueOf(),t-=fn(t,un);break;case"second":t=this._d.valueOf(),t-=fn(t,cn)}return this._d.setTime(t),n.updateOffset(this,!0),this},Tn.subtract=tn,Tn.toArray=function(){var e=this;return[e.year(),e.month(),e.date(),e.hour(),e.minute(),e.second(),e.millisecond()]},Tn.toObject=function(){var e=this;return{years:e.year(),months:e.month(),date:e.date(),hours:e.hours(),minutes:e.minutes(),seconds:e.seconds(),milliseconds:e.milliseconds()}},Tn.toDate=function(){return new Date(this.valueOf())},Tn.toISOString=function(e){if(!this.isValid())return null;var t=!0!==e,n=t?this.clone().utc():this;return n.year()<0||n.year()>9999?z(n,t?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):M(Date.prototype.toISOString)?t?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",z(n,"Z")):z(n,t?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},Tn.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var e,t,n,i="moment",r="";return this.isLocal()||(i=0===this.utcOffset()?"moment.utc":"moment.parseZone",r="Z"),e="["+i+'("]',t=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY","-MM-DD[T]HH:mm:ss.SSS",n=r+'[")]',this.format(e+t+"-MM-DD[T]HH:mm:ss.SSS"+n)},"undefined"!=typeof Symbol&&null!=Symbol.for&&(Tn[Symbol.for("nodejs.util.inspect.custom")]=function(){return"Moment<"+this.format()+">"}),Tn.toJSON=function(){return this.isValid()?this.toISOString():null},Tn.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},Tn.unix=function(){return Math.floor(this.valueOf()/1e3)},Tn.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},Tn.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},Tn.eraName=function(){var e,t,n,i=this.localeData().eras();for(e=0,t=i.length;e<t;++e){if(n=this.clone().startOf("day").valueOf(),i[e].since<=n&&n<=i[e].until)return i[e].name;if(i[e].until<=n&&n<=i[e].since)return i[e].name}return""},Tn.eraNarrow=function(){var e,t,n,i=this.localeData().eras();for(e=0,t=i.length;e<t;++e){if(n=this.clone().startOf("day").valueOf(),i[e].since<=n&&n<=i[e].until)return i[e].narrow;if(i[e].until<=n&&n<=i[e].since)return i[e].narrow}return""},Tn.eraAbbr=function(){var e,t,n,i=this.localeData().eras();for(e=0,t=i.length;e<t;++e){if(n=this.clone().startOf("day").valueOf(),i[e].since<=n&&n<=i[e].until)return i[e].abbr;if(i[e].until<=n&&n<=i[e].since)return i[e].abbr}return""},Tn.eraYear=function(){var e,t,i,r,o=this.localeData().eras();for(e=0,t=o.length;e<t;++e)if(i=o[e].since<=o[e].until?1:-1,r=this.clone().startOf("day").valueOf(),o[e].since<=r&&r<=o[e].until||o[e].until<=r&&r<=o[e].since)return(this.year()-n(o[e].since).year())*i+o[e].offset;return this.year()},Tn.year=$e,Tn.isLeapYear=function(){return V(this.year())},Tn.weekYear=function(e){return bn.call(this,e,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},Tn.isoWeekYear=function(e){return bn.call(this,e,this.isoWeek(),this.isoWeekday(),1,4)},Tn.quarter=Tn.quarters=function(e){return null==e?Math.ceil((this.month()+1)/3):this.month(3*(e-1)+this.month()%3)},Tn.month=je,Tn.daysInMonth=function(){return Pe(this.year(),this.month())},Tn.week=Tn.weeks=function(e){var t=this.localeData().week(this);return null==e?t:this.add(7*(e-t),"d")},Tn.isoWeek=Tn.isoWeeks=function(e){var t=We(this,1,4).week;return null==e?t:this.add(7*(e-t),"d")},Tn.weeksInYear=function(){var e=this.localeData()._week;return Ue(this.year(),e.dow,e.doy)},Tn.weeksInWeekYear=function(){var e=this.localeData()._week;return Ue(this.weekYear(),e.dow,e.doy)},Tn.isoWeeksInYear=function(){return Ue(this.year(),1,4)},Tn.isoWeeksInISOWeekYear=function(){return Ue(this.isoWeekYear(),1,4)},Tn.date=wn,Tn.day=Tn.days=function(e){if(!this.isValid())return null!=e?this:NaN;var t=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=e?(e=function(e,t){return"string"!=typeof e?e:isNaN(e)?"number"==typeof(e=t.weekdaysParse(e))?e:null:parseInt(e,10)}(e,this.localeData()),this.add(e-t,"d")):t},Tn.weekday=function(e){if(!this.isValid())return null!=e?this:NaN;var t=(this.day()+7-this.localeData()._week.dow)%7;return null==e?t:this.add(e-t,"d")},Tn.isoWeekday=function(e){if(!this.isValid())return null!=e?this:NaN;if(null!=e){var t=function(e,t){return"string"==typeof e?t.weekdaysParse(e)%7||7:isNaN(e)?null:e}(e,this.localeData());return this.day(this.day()%7?t:t-7)}return this.day()||7},Tn.dayOfYear=function(e){var t=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==e?t:this.add(e-t,"d")},Tn.hour=Tn.hours=ot,Tn.minute=Tn.minutes=kn,Tn.second=Tn.seconds=Cn,Tn.millisecond=Tn.milliseconds=Sn,Tn.utcOffset=function(e,t,i){var r,o=this._offset||0;if(!this.isValid())return null!=e?this:NaN;if(null!=e){if("string"==typeof e){if(null===(e=Vt(ue,e)))return this}else Math.abs(e)<16&&!i&&(e*=60);return!this._isUTC&&t&&(r=Wt(this)),this._offset=e,this._isUTC=!0,null!=r&&this.add(r,"m"),o!==e&&(!t||this._changeInProgress?Xt(this,Qt(e-o,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,n.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?o:Wt(this)},Tn.utc=function(e){return this.utcOffset(0,e)},Tn.local=function(e){return this._isUTC&&(this.utcOffset(0,e),this._isUTC=!1,e&&this.subtract(Wt(this),"m")),this},Tn.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var e=Vt(ce,this._i);null!=e?this.utcOffset(e):this.utcOffset(0,!0)}return this},Tn.hasAlignedHourOffset=function(e){return!!this.isValid()&&(e=e?Et(e).utcOffset():0,(this.utcOffset()-e)%60==0)},Tn.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},Tn.isLocal=function(){return!!this.isValid()&&!this._isUTC},Tn.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},Tn.isUtc=Ut,Tn.isUTC=Ut,Tn.zoneAbbr=function(){return this._isUTC?"UTC":""},Tn.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},Tn.dates=k("dates accessor is deprecated. Use date instead.",wn),Tn.months=k("months accessor is deprecated. Use month instead",je),Tn.years=k("years accessor is deprecated. Use year instead",$e),Tn.zone=k("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",(function(e,t){return null!=e?("string"!=typeof e&&(e=-e),this.utcOffset(e,t),this):-this.utcOffset()})),Tn.isDSTShifted=k("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",(function(){if(!s(this._isDSTShifted))return this._isDSTShifted;var e,t={};return _(t,this),(t=Ot(t))._a?(e=t._isUTC?h(t._a):Et(t._a),this._isDSTShifted=this.isValid()&&function(e,t,n){var i,r=Math.min(e.length,t.length),o=Math.abs(e.length-t.length),a=0;for(i=0;i<r;i++)(n&&e[i]!==t[i]||!n&&W(e[i])!==W(t[i]))&&a++;return a+o}(t._a,e.toArray())>0):this._isDSTShifted=!1,this._isDSTShifted}));var Pn=A.prototype;function Ln(e,t,n,i){var r=mt(),o=h().set(i,t);return r[n](o,e)}function On(e,t,n){if(l(e)&&(t=e,e=void 0),e=e||"",null!=t)return Ln(e,t,n,"month");var i,r=[];for(i=0;i<12;i++)r[i]=Ln(e,i,n,"month");return r}function qn(e,t,n,i){"boolean"==typeof e?(l(t)&&(n=t,t=void 0),t=t||""):(n=t=e,e=!1,l(t)&&(n=t,t=void 0),t=t||"");var r,o=mt(),a=e?o._week.dow:0,s=[];if(null!=n)return Ln(t,(n+a)%7,i,"day");for(r=0;r<7;r++)s[r]=Ln(t,(r+a)%7,i,"day");return s}Pn.calendar=function(e,t,n){var i=this._calendar[e]||this._calendar.sameElse;return M(i)?i.call(t,n):i},Pn.longDateFormat=function(e){var t=this._longDateFormat[e],n=this._longDateFormat[e.toUpperCase()];return t||!n?t:(this._longDateFormat[e]=n.match(L).map((function(e){return"MMMM"===e||"MM"===e||"DD"===e||"dddd"===e?e.slice(1):e})).join(""),this._longDateFormat[e])},Pn.invalidDate=function(){return this._invalidDate},Pn.ordinal=function(e){return this._ordinal.replace("%d",e)},Pn.preparse=An,Pn.postformat=An,Pn.relativeTime=function(e,t,n,i){var r=this._relativeTime[n];return M(r)?r(e,t,n,i):r.replace(/%d/i,e)},Pn.pastFuture=function(e,t){var n=this._relativeTime[e>0?"future":"past"];return M(n)?n(t):n.replace(/%s/i,t)},Pn.set=function(e){var t,n;for(n in e)o(e,n)&&(M(t=e[n])?this[n]=t:this["_"+n]=t);this._config=e,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},Pn.eras=function(e,t){var i,r,o,a=this._eras||mt("en")._eras;for(i=0,r=a.length;i<r;++i){if("string"==typeof a[i].since)o=n(a[i].since).startOf("day"),a[i].since=o.valueOf();switch(typeof a[i].until){case"undefined":a[i].until=1/0;break;case"string":o=n(a[i].until).startOf("day").valueOf(),a[i].until=o.valueOf()}}return a},Pn.erasParse=function(e,t,n){var i,r,o,a,s,l=this.eras();for(e=e.toUpperCase(),i=0,r=l.length;i<r;++i)if(o=l[i].name.toUpperCase(),a=l[i].abbr.toUpperCase(),s=l[i].narrow.toUpperCase(),n)switch(t){case"N":case"NN":case"NNN":if(a===e)return l[i];break;case"NNNN":if(o===e)return l[i];break;case"NNNNN":if(s===e)return l[i]}else if([o,a,s].indexOf(e)>=0)return l[i]},Pn.erasConvertYear=function(e,t){var i=e.since<=e.until?1:-1;return void 0===t?n(e.since).year():n(e.since).year()+(t-e.offset)*i},Pn.erasAbbrRegex=function(e){return o(this,"_erasAbbrRegex")||gn.call(this),e?this._erasAbbrRegex:this._erasRegex},Pn.erasNameRegex=function(e){return o(this,"_erasNameRegex")||gn.call(this),e?this._erasNameRegex:this._erasRegex},Pn.erasNarrowRegex=function(e){return o(this,"_erasNarrowRegex")||gn.call(this),e?this._erasNarrowRegex:this._erasRegex},Pn.months=function(e,t){return e?i(this._months)?this._months[e.month()]:this._months[(this._months.isFormat||qe).test(t)?"format":"standalone"][e.month()]:i(this._months)?this._months:this._months.standalone},Pn.monthsShort=function(e,t){return e?i(this._monthsShort)?this._monthsShort[e.month()]:this._monthsShort[qe.test(t)?"format":"standalone"][e.month()]:i(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},Pn.monthsParse=function(e,t,n){var i,r,o;if(this._monthsParseExact)return ze.call(this,e,t,n);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),i=0;i<12;i++){if(r=h([2e3,i]),n&&!this._longMonthsParse[i]&&(this._longMonthsParse[i]=new RegExp("^"+this.months(r,"").replace(".","")+"$","i"),this._shortMonthsParse[i]=new RegExp("^"+this.monthsShort(r,"").replace(".","")+"$","i")),n||this._monthsParse[i]||(o="^"+this.months(r,"")+"|^"+this.monthsShort(r,""),this._monthsParse[i]=new RegExp(o.replace(".",""),"i")),n&&"MMMM"===t&&this._longMonthsParse[i].test(e))return i;if(n&&"MMM"===t&&this._shortMonthsParse[i].test(e))return i;if(!n&&this._monthsParse[i].test(e))return i}},Pn.monthsRegex=function(e){return this._monthsParseExact?(o(this,"_monthsRegex")||Re.call(this),e?this._monthsStrictRegex:this._monthsRegex):(o(this,"_monthsRegex")||(this._monthsRegex=De),this._monthsStrictRegex&&e?this._monthsStrictRegex:this._monthsRegex)},Pn.monthsShortRegex=function(e){return this._monthsParseExact?(o(this,"_monthsRegex")||Re.call(this),e?this._monthsShortStrictRegex:this._monthsShortRegex):(o(this,"_monthsShortRegex")||(this._monthsShortRegex=Ee),this._monthsShortStrictRegex&&e?this._monthsShortStrictRegex:this._monthsShortRegex)},Pn.week=function(e){return We(e,this._week.dow,this._week.doy).week},Pn.firstDayOfYear=function(){return this._week.doy},Pn.firstDayOfWeek=function(){return this._week.dow},Pn.weekdays=function(e,t){var n=i(this._weekdays)?this._weekdays:this._weekdays[e&&!0!==e&&this._weekdays.isFormat.test(t)?"format":"standalone"];return!0===e?Ye(n,this._week.dow):e?n[e.day()]:n},Pn.weekdaysMin=function(e){return!0===e?Ye(this._weekdaysMin,this._week.dow):e?this._weekdaysMin[e.day()]:this._weekdaysMin},Pn.weekdaysShort=function(e){return!0===e?Ye(this._weekdaysShort,this._week.dow):e?this._weekdaysShort[e.day()]:this._weekdaysShort},Pn.weekdaysParse=function(e,t,n){var i,r,o;if(this._weekdaysParseExact)return et.call(this,e,t,n);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),i=0;i<7;i++){if(r=h([2e3,1]).day(i),n&&!this._fullWeekdaysParse[i]&&(this._fullWeekdaysParse[i]=new RegExp("^"+this.weekdays(r,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[i]=new RegExp("^"+this.weekdaysShort(r,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[i]=new RegExp("^"+this.weekdaysMin(r,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[i]||(o="^"+this.weekdays(r,"")+"|^"+this.weekdaysShort(r,"")+"|^"+this.weekdaysMin(r,""),this._weekdaysParse[i]=new RegExp(o.replace(".",""),"i")),n&&"dddd"===t&&this._fullWeekdaysParse[i].test(e))return i;if(n&&"ddd"===t&&this._shortWeekdaysParse[i].test(e))return i;if(n&&"dd"===t&&this._minWeekdaysParse[i].test(e))return i;if(!n&&this._weekdaysParse[i].test(e))return i}},Pn.weekdaysRegex=function(e){return this._weekdaysParseExact?(o(this,"_weekdaysRegex")||tt.call(this),e?this._weekdaysStrictRegex:this._weekdaysRegex):(o(this,"_weekdaysRegex")||(this._weekdaysRegex=Ze),this._weekdaysStrictRegex&&e?this._weekdaysStrictRegex:this._weekdaysRegex)},Pn.weekdaysShortRegex=function(e){return this._weekdaysParseExact?(o(this,"_weekdaysRegex")||tt.call(this),e?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(o(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=Je),this._weekdaysShortStrictRegex&&e?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},Pn.weekdaysMinRegex=function(e){return this._weekdaysParseExact?(o(this,"_weekdaysRegex")||tt.call(this),e?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(o(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=Xe),this._weekdaysMinStrictRegex&&e?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},Pn.isPM=function(e){return"p"===(e+"").toLowerCase().charAt(0)},Pn.meridiem=function(e,t,n){return e>11?n?"pm":"PM":n?"am":"AM"},ft("en",{eras:[{since:"0001-01-01",until:1/0,offset:1,name:"Anno Domini",narrow:"AD",abbr:"AD"},{since:"0000-12-31",until:-1/0,offset:1,name:"Before Christ",narrow:"BC",abbr:"BC"}],dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(e){var t=e%10;return e+(1===W(e%100/10)?"th":1===t?"st":2===t?"nd":3===t?"rd":"th")}}),n.lang=k("moment.lang is deprecated. Use moment.locale instead.",ft),n.langData=k("moment.langData is deprecated. Use moment.localeData instead.",mt);var En=Math.abs;function Dn(e,t,n,i){var r=Qt(t,n);return e._milliseconds+=i*r._milliseconds,e._days+=i*r._days,e._months+=i*r._months,e._bubble()}function zn(e){return e<0?Math.floor(e):Math.ceil(e)}function Nn(e){return 4800*e/146097}function jn(e){return 146097*e/4800}function Rn(e){return function(){return this.as(e)}}var In=Rn("ms"),$n=Rn("s"),Fn=Rn("m"),Bn=Rn("h"),Vn=Rn("d"),Hn=Rn("w"),Wn=Rn("M"),Un=Rn("Q"),Yn=Rn("y");function Gn(e){return function(){return this.isValid()?this._data[e]:NaN}}var Qn=Gn("milliseconds"),Kn=Gn("seconds"),Zn=Gn("minutes"),Jn=Gn("hours"),Xn=Gn("days"),ei=Gn("months"),ti=Gn("years");var ni=Math.round,ii={ss:44,s:45,m:45,h:22,d:26,w:null,M:11};function ri(e,t,n,i,r){return r.relativeTime(t||1,!!n,e,i)}var oi=Math.abs;function ai(e){return(e>0)-(e<0)||+e}function si(){if(!this.isValid())return this.localeData().invalidDate();var e,t,n,i,r,o,a,s,l=oi(this._milliseconds)/1e3,c=oi(this._days),u=oi(this._months),d=this.asSeconds();return d?(e=H(l/60),t=H(e/60),l%=60,e%=60,n=H(u/12),u%=12,i=l?l.toFixed(3).replace(/\.?0+$/,""):"",r=d<0?"-":"",o=ai(this._months)!==ai(d)?"-":"",a=ai(this._days)!==ai(d)?"-":"",s=ai(this._milliseconds)!==ai(d)?"-":"",r+"P"+(n?o+n+"Y":"")+(u?o+u+"M":"")+(c?a+c+"D":"")+(t||e||l?"T":"")+(t?s+t+"H":"")+(e?s+e+"M":"")+(l?s+i+"S":"")):"P0D"}var li=Rt.prototype;return li.isValid=function(){return this._isValid},li.abs=function(){var e=this._data;return this._milliseconds=En(this._milliseconds),this._days=En(this._days),this._months=En(this._months),e.milliseconds=En(e.milliseconds),e.seconds=En(e.seconds),e.minutes=En(e.minutes),e.hours=En(e.hours),e.months=En(e.months),e.years=En(e.years),this},li.add=function(e,t){return Dn(this,e,t,1)},li.subtract=function(e,t){return Dn(this,e,t,-1)},li.as=function(e){if(!this.isValid())return NaN;var t,n,i=this._milliseconds;if("month"===(e=I(e))||"quarter"===e||"year"===e)switch(t=this._days+i/864e5,n=this._months+Nn(t),e){case"month":return n;case"quarter":return n/3;case"year":return n/12}else switch(t=this._days+Math.round(jn(this._months)),e){case"week":return t/7+i/6048e5;case"day":return t+i/864e5;case"hour":return 24*t+i/36e5;case"minute":return 1440*t+i/6e4;case"second":return 86400*t+i/1e3;case"millisecond":return Math.floor(864e5*t)+i;default:throw new Error("Unknown unit "+e)}},li.asMilliseconds=In,li.asSeconds=$n,li.asMinutes=Fn,li.asHours=Bn,li.asDays=Vn,li.asWeeks=Hn,li.asMonths=Wn,li.asQuarters=Un,li.asYears=Yn,li.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*W(this._months/12):NaN},li._bubble=function(){var e,t,n,i,r,o=this._milliseconds,a=this._days,s=this._months,l=this._data;return o>=0&&a>=0&&s>=0||o<=0&&a<=0&&s<=0||(o+=864e5*zn(jn(s)+a),a=0,s=0),l.milliseconds=o%1e3,e=H(o/1e3),l.seconds=e%60,t=H(e/60),l.minutes=t%60,n=H(t/60),l.hours=n%24,a+=H(n/24),s+=r=H(Nn(a)),a-=zn(jn(r)),i=H(s/12),s%=12,l.days=a,l.months=s,l.years=i,this},li.clone=function(){return Qt(this)},li.get=function(e){return e=I(e),this.isValid()?this[e+"s"]():NaN},li.milliseconds=Qn,li.seconds=Kn,li.minutes=Zn,li.hours=Jn,li.days=Xn,li.weeks=function(){return H(this.days()/7)},li.months=ei,li.years=ti,li.humanize=function(e,t){if(!this.isValid())return this.localeData().invalidDate();var n,i,r=!1,o=ii;return"object"==typeof e&&(t=e,e=!1),"boolean"==typeof e&&(r=e),"object"==typeof t&&(o=Object.assign({},ii,t),null!=t.s&&null==t.ss&&(o.ss=t.s-1)),i=function(e,t,n,i){var r=Qt(e).abs(),o=ni(r.as("s")),a=ni(r.as("m")),s=ni(r.as("h")),l=ni(r.as("d")),c=ni(r.as("M")),u=ni(r.as("w")),d=ni(r.as("y")),h=o<=n.ss&&["s",o]||o<n.s&&["ss",o]||a<=1&&["m"]||a<n.m&&["mm",a]||s<=1&&["h"]||s<n.h&&["hh",s]||l<=1&&["d"]||l<n.d&&["dd",l];return null!=n.w&&(h=h||u<=1&&["w"]||u<n.w&&["ww",u]),(h=h||c<=1&&["M"]||c<n.M&&["MM",c]||d<=1&&["y"]||["yy",d])[2]=t,h[3]=+e>0,h[4]=i,ri.apply(null,h)}(this,!r,o,n=this.localeData()),r&&(i=n.pastFuture(+this,i)),n.postformat(i)},li.toISOString=si,li.toString=si,li.toJSON=si,li.locale=an,li.localeData=ln,li.toIsoString=k("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",si),li.lang=sn,D("X",0,0,"unix"),D("x",0,0,"valueOf"),he("x",le),he("X",/[+-]?\d+(\.\d{1,3})?/),ve("X",(function(e,t,n){n._d=new Date(1e3*parseFloat(e))})),ve("x",(function(e,t,n){n._d=new Date(W(e))})),
//! moment.js
n.version="2.29.4",e=Et,n.fn=Tn,n.min=function(){return Nt("isBefore",[].slice.call(arguments,0))},n.max=function(){return Nt("isAfter",[].slice.call(arguments,0))},n.now=function(){return Date.now?Date.now():+new Date},n.utc=h,n.unix=function(e){return Et(1e3*e)},n.months=function(e,t){return On(e,t,"months")},n.isDate=c,n.locale=ft,n.invalid=m,n.duration=Qt,n.isMoment=y,n.weekdays=function(e,t,n){return qn(e,t,n,"weekdays")},n.parseZone=function(){return Et.apply(null,arguments).parseZone()},n.localeData=mt,n.isDuration=It,n.monthsShort=function(e,t){return On(e,t,"monthsShort")},n.weekdaysMin=function(e,t,n){return qn(e,t,n,"weekdaysMin")},n.defineLocale=pt,n.updateLocale=function(e,t){if(null!=t){var n,i,r=st;null!=lt[e]&&null!=lt[e].parentLocale?lt[e].set(T(lt[e]._config,t)):(null!=(i=ht(e))&&(r=i._config),t=T(r,t),null==i&&(t.abbr=e),(n=new A(t)).parentLocale=lt[e],lt[e]=n),ft(e)}else null!=lt[e]&&(null!=lt[e].parentLocale?(lt[e]=lt[e].parentLocale,e===ft()&&ft(e)):null!=lt[e]&&delete lt[e]);return lt[e]},n.locales=function(){return x(lt)},n.weekdaysShort=function(e,t,n){return qn(e,t,n,"weekdaysShort")},n.normalizeUnits=I,n.relativeTimeRounding=function(e){return void 0===e?ni:"function"==typeof e&&(ni=e,!0)},n.relativeTimeThreshold=function(e,t){return void 0!==ii[e]&&(void 0===t?ii[e]:(ii[e]=t,"s"===e&&(ii.ss=t-1),!0))},n.calendarFormat=function(e,t){var n=e.diff(t,"days",!0);return n<-6?"sameElse":n<-1?"lastWeek":n<0?"lastDay":n<1?"sameDay":n<2?"nextDay":n<7?"nextWeek":"sameElse"},n.prototype=Tn,n.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},n})),function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define("underscore",t):(e="undefined"!=typeof globalThis?globalThis:e||self,function(){var n=e._,i=e._=t();i.noConflict=function(){return e._=n,i}}())}(this,(function(){var e="1.13.6",t="object"==typeof self&&self.self===self&&self||"object"==typeof global&&global.global===global&&global||Function("return this")()||{},n=Array.prototype,i=Object.prototype,r="undefined"!=typeof Symbol?Symbol.prototype:null,o=n.push,a=n.slice,s=i.toString,l=i.hasOwnProperty,c="undefined"!=typeof ArrayBuffer,u="undefined"!=typeof DataView,d=Array.isArray,h=Object.keys,f=Object.create,p=c&&ArrayBuffer.isView,m=isNaN,v=isFinite,g=!{toString:null}.propertyIsEnumerable("toString"),_=["valueOf","isPrototypeOf","toString","propertyIsEnumerable","hasOwnProperty","toLocaleString"],b=Math.pow(2,53)-1;function y(e,t){return t=null==t?e.length-1:+t,function(){for(var n=Math.max(arguments.length-t,0),i=Array(n),r=0;r<n;r++)i[r]=arguments[r+t];switch(t){case 0:return e.call(this,i);case 1:return e.call(this,arguments[0],i);case 2:return e.call(this,arguments[0],arguments[1],i)}var o=Array(t+1);for(r=0;r<t;r++)o[r]=arguments[r];return o[t]=i,e.apply(this,o)}}function w(e){var t=typeof e;return"function"===t||"object"===t&&!!e}function k(e){return void 0===e}function x(e){return!0===e||!1===e||"[object Boolean]"===s.call(e)}function S(e){var t="[object "+e+"]";return function(e){return s.call(e)===t}}var C=S("String"),M=S("Number"),T=S("Date"),A=S("RegExp"),P=S("Error"),L=S("Symbol"),O=S("ArrayBuffer"),q=S("Function"),E=t.document&&t.document.childNodes;"function"!=typeof/./&&"object"!=typeof Int8Array&&"function"!=typeof E&&(q=function(e){return"function"==typeof e||!1});var D=q,z=S("Object"),N=u&&z(new DataView(new ArrayBuffer(8))),j="undefined"!=typeof Map&&z(new Map),R=S("DataView");var I=N?function(e){return null!=e&&D(e.getInt8)&&O(e.buffer)}:R,$=d||S("Array");function F(e,t){return null!=e&&l.call(e,t)}var B=S("Arguments");!function(){B(arguments)||(B=function(e){return F(e,"callee")})}();var V=B;function H(e){return M(e)&&m(e)}function W(e){return function(){return e}}function U(e){return function(t){var n=e(t);return"number"==typeof n&&n>=0&&n<=b}}function Y(e){return function(t){return null==t?void 0:t[e]}}var G=Y("byteLength"),Q=U(G),K=/\[object ((I|Ui)nt(8|16|32)|Float(32|64)|Uint8Clamped|Big(I|Ui)nt64)Array\]/;var Z=c?function(e){return p?p(e)&&!I(e):Q(e)&&K.test(s.call(e))}:W(!1),J=Y("length");function X(e,t){t=function(e){for(var t={},n=e.length,i=0;i<n;++i)t[e[i]]=!0;return{contains:function(e){return!0===t[e]},push:function(n){return t[n]=!0,e.push(n)}}}(t);var n=_.length,r=e.constructor,o=D(r)&&r.prototype||i,a="constructor";for(F(e,a)&&!t.contains(a)&&t.push(a);n--;)(a=_[n])in e&&e[a]!==o[a]&&!t.contains(a)&&t.push(a)}function ee(e){if(!w(e))return[];if(h)return h(e);var t=[];for(var n in e)F(e,n)&&t.push(n);return g&&X(e,t),t}function te(e,t){var n=ee(t),i=n.length;if(null==e)return!i;for(var r=Object(e),o=0;o<i;o++){var a=n[o];if(t[a]!==r[a]||!(a in r))return!1}return!0}function ne(e){return e instanceof ne?e:this instanceof ne?void(this._wrapped=e):new ne(e)}function ie(e){return new Uint8Array(e.buffer||e,e.byteOffset||0,G(e))}ne.VERSION=e,ne.prototype.value=function(){return this._wrapped},ne.prototype.valueOf=ne.prototype.toJSON=ne.prototype.value,ne.prototype.toString=function(){return String(this._wrapped)};var re="[object DataView]";function oe(e,t,n,i){if(e===t)return 0!==e||1/e==1/t;if(null==e||null==t)return!1;if(e!=e)return t!=t;var r=typeof e;return("function"===r||"object"===r||"object"==typeof t)&&ae(e,t,n,i)}function ae(e,t,n,i){e instanceof ne&&(e=e._wrapped),t instanceof ne&&(t=t._wrapped);var o=s.call(e);if(o!==s.call(t))return!1;if(N&&"[object Object]"==o&&I(e)){if(!I(t))return!1;o=re}switch(o){case"[object RegExp]":case"[object String]":return""+e==""+t;case"[object Number]":return+e!=+e?+t!=+t:0==+e?1/+e==1/t:+e==+t;case"[object Date]":case"[object Boolean]":return+e==+t;case"[object Symbol]":return r.valueOf.call(e)===r.valueOf.call(t);case"[object ArrayBuffer]":case re:return ae(ie(e),ie(t),n,i)}var a="[object Array]"===o;if(!a&&Z(e)){if(G(e)!==G(t))return!1;if(e.buffer===t.buffer&&e.byteOffset===t.byteOffset)return!0;a=!0}if(!a){if("object"!=typeof e||"object"!=typeof t)return!1;var l=e.constructor,c=t.constructor;if(l!==c&&!(D(l)&&l instanceof l&&D(c)&&c instanceof c)&&"constructor"in e&&"constructor"in t)return!1}i=i||[];for(var u=(n=n||[]).length;u--;)if(n[u]===e)return i[u]===t;if(n.push(e),i.push(t),a){if((u=e.length)!==t.length)return!1;for(;u--;)if(!oe(e[u],t[u],n,i))return!1}else{var d,h=ee(e);if(u=h.length,ee(t).length!==u)return!1;for(;u--;)if(!F(t,d=h[u])||!oe(e[d],t[d],n,i))return!1}return n.pop(),i.pop(),!0}function se(e){if(!w(e))return[];var t=[];for(var n in e)t.push(n);return g&&X(e,t),t}function le(e){var t=J(e);return function(n){if(null==n)return!1;var i=se(n);if(J(i))return!1;for(var r=0;r<t;r++)if(!D(n[e[r]]))return!1;return e!==fe||!D(n[ce])}}var ce="forEach",ue=["clear","delete"],de=["get","has","set"],he=ue.concat(ce,de),fe=ue.concat(de),pe=["add"].concat(ue,ce,"has"),me=j?le(he):S("Map"),ve=j?le(fe):S("WeakMap"),ge=j?le(pe):S("Set"),_e=S("WeakSet");function be(e){for(var t=ee(e),n=t.length,i=Array(n),r=0;r<n;r++)i[r]=e[t[r]];return i}function ye(e){for(var t={},n=ee(e),i=0,r=n.length;i<r;i++)t[e[n[i]]]=n[i];return t}function we(e){var t=[];for(var n in e)D(e[n])&&t.push(n);return t.sort()}function ke(e,t){return function(n){var i=arguments.length;if(t&&(n=Object(n)),i<2||null==n)return n;for(var r=1;r<i;r++)for(var o=arguments[r],a=e(o),s=a.length,l=0;l<s;l++){var c=a[l];t&&void 0!==n[c]||(n[c]=o[c])}return n}}var xe=ke(se),Se=ke(ee),Ce=ke(se,!0);function Me(e){if(!w(e))return{};if(f)return f(e);var t=function(){};t.prototype=e;var n=new t;return t.prototype=null,n}function Te(e){return $(e)?e:[e]}function Ae(e){return ne.toPath(e)}function Pe(e,t){for(var n=t.length,i=0;i<n;i++){if(null==e)return;e=e[t[i]]}return n?e:void 0}function Le(e,t,n){var i=Pe(e,Ae(t));return k(i)?n:i}function Oe(e){return e}function qe(e){return e=Se({},e),function(t){return te(t,e)}}function Ee(e){return e=Ae(e),function(t){return Pe(t,e)}}function De(e,t,n){if(void 0===t)return e;switch(null==n?3:n){case 1:return function(n){return e.call(t,n)};case 3:return function(n,i,r){return e.call(t,n,i,r)};case 4:return function(n,i,r,o){return e.call(t,n,i,r,o)}}return function(){return e.apply(t,arguments)}}function ze(e,t,n){return null==e?Oe:D(e)?De(e,t,n):w(e)&&!$(e)?qe(e):Ee(e)}function Ne(e,t){return ze(e,t,1/0)}function je(e,t,n){return ne.iteratee!==Ne?ne.iteratee(e,t):ze(e,t,n)}function Re(){}function Ie(e,t){return null==t&&(t=e,e=0),e+Math.floor(Math.random()*(t-e+1))}ne.toPath=Te,ne.iteratee=Ne;var $e=Date.now||function(){return(new Date).getTime()};function Fe(e){var t=function(t){return e[t]},n="(?:"+ee(e).join("|")+")",i=RegExp(n),r=RegExp(n,"g");return function(e){return e=null==e?"":""+e,i.test(e)?e.replace(r,t):e}}var Be={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","`":"&#x60;"},Ve=Fe(Be),He=Fe(ye(Be)),We=ne.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g},Ue=/(.)^/,Ye={"'":"'","\\":"\\","\r":"r","\n":"n","\u2028":"u2028","\u2029":"u2029"},Ge=/\\|'|\r|\n|\u2028|\u2029/g;function Qe(e){return"\\"+Ye[e]}var Ke=/^\s*(\w|\$)+\s*$/;var Ze=0;function Je(e,t,n,i,r){if(!(i instanceof t))return e.apply(n,r);var o=Me(e.prototype),a=e.apply(o,r);return w(a)?a:o}var Xe=y((function(e,t){var n=Xe.placeholder,i=function(){for(var r=0,o=t.length,a=Array(o),s=0;s<o;s++)a[s]=t[s]===n?arguments[r++]:t[s];for(;r<arguments.length;)a.push(arguments[r++]);return Je(e,i,this,this,a)};return i}));Xe.placeholder=ne;var et=y((function(e,t,n){if(!D(e))throw new TypeError("Bind must be called on a function");var i=y((function(r){return Je(e,i,t,this,n.concat(r))}));return i})),tt=U(J);function nt(e,t,n,i){if(i=i||[],t||0===t){if(t<=0)return i.concat(e)}else t=1/0;for(var r=i.length,o=0,a=J(e);o<a;o++){var s=e[o];if(tt(s)&&($(s)||V(s)))if(t>1)nt(s,t-1,n,i),r=i.length;else for(var l=0,c=s.length;l<c;)i[r++]=s[l++];else n||(i[r++]=s)}return i}var it=y((function(e,t){var n=(t=nt(t,!1,!1)).length;if(n<1)throw new Error("bindAll must be passed function names");for(;n--;){var i=t[n];e[i]=et(e[i],e)}return e}));var rt=y((function(e,t,n){return setTimeout((function(){return e.apply(null,n)}),t)})),ot=Xe(rt,ne,1);function at(e){return function(){return!e.apply(this,arguments)}}function st(e,t){var n;return function(){return--e>0&&(n=t.apply(this,arguments)),e<=1&&(t=null),n}}var lt=Xe(st,2);function ct(e,t,n){t=je(t,n);for(var i,r=ee(e),o=0,a=r.length;o<a;o++)if(t(e[i=r[o]],i,e))return i}function ut(e){return function(t,n,i){n=je(n,i);for(var r=J(t),o=e>0?0:r-1;o>=0&&o<r;o+=e)if(n(t[o],o,t))return o;return-1}}var dt=ut(1),ht=ut(-1);function ft(e,t,n,i){for(var r=(n=je(n,i,1))(t),o=0,a=J(e);o<a;){var s=Math.floor((o+a)/2);n(e[s])<r?o=s+1:a=s}return o}function pt(e,t,n){return function(i,r,o){var s=0,l=J(i);if("number"==typeof o)e>0?s=o>=0?o:Math.max(o+l,s):l=o>=0?Math.min(o+1,l):o+l+1;else if(n&&o&&l)return i[o=n(i,r)]===r?o:-1;if(r!=r)return(o=t(a.call(i,s,l),H))>=0?o+s:-1;for(o=e>0?s:l-1;o>=0&&o<l;o+=e)if(i[o]===r)return o;return-1}}var mt=pt(1,dt,ft),vt=pt(-1,ht);function gt(e,t,n){var i=(tt(e)?dt:ct)(e,t,n);if(void 0!==i&&-1!==i)return e[i]}function _t(e,t,n){var i,r;if(t=De(t,n),tt(e))for(i=0,r=e.length;i<r;i++)t(e[i],i,e);else{var o=ee(e);for(i=0,r=o.length;i<r;i++)t(e[o[i]],o[i],e)}return e}function bt(e,t,n){t=je(t,n);for(var i=!tt(e)&&ee(e),r=(i||e).length,o=Array(r),a=0;a<r;a++){var s=i?i[a]:a;o[a]=t(e[s],s,e)}return o}function yt(e){return function(t,n,i,r){var o=arguments.length>=3;return function(t,n,i,r){var o=!tt(t)&&ee(t),a=(o||t).length,s=e>0?0:a-1;for(r||(i=t[o?o[s]:s],s+=e);s>=0&&s<a;s+=e){var l=o?o[s]:s;i=n(i,t[l],l,t)}return i}(t,De(n,r,4),i,o)}}var wt=yt(1),kt=yt(-1);function xt(e,t,n){var i=[];return t=je(t,n),_t(e,(function(e,n,r){t(e,n,r)&&i.push(e)})),i}function St(e,t,n){t=je(t,n);for(var i=!tt(e)&&ee(e),r=(i||e).length,o=0;o<r;o++){var a=i?i[o]:o;if(!t(e[a],a,e))return!1}return!0}function Ct(e,t,n){t=je(t,n);for(var i=!tt(e)&&ee(e),r=(i||e).length,o=0;o<r;o++){var a=i?i[o]:o;if(t(e[a],a,e))return!0}return!1}function Mt(e,t,n,i){return tt(e)||(e=be(e)),("number"!=typeof n||i)&&(n=0),mt(e,t,n)>=0}var Tt=y((function(e,t,n){var i,r;return D(t)?r=t:(t=Ae(t),i=t.slice(0,-1),t=t[t.length-1]),bt(e,(function(e){var o=r;if(!o){if(i&&i.length&&(e=Pe(e,i)),null==e)return;o=e[t]}return null==o?o:o.apply(e,n)}))}));function At(e,t){return bt(e,Ee(t))}function Pt(e,t,n){var i,r,o=-1/0,a=-1/0;if(null==t||"number"==typeof t&&"object"!=typeof e[0]&&null!=e)for(var s=0,l=(e=tt(e)?e:be(e)).length;s<l;s++)null!=(i=e[s])&&i>o&&(o=i);else t=je(t,n),_t(e,(function(e,n,i){((r=t(e,n,i))>a||r===-1/0&&o===-1/0)&&(o=e,a=r)}));return o}var Lt=/[^\ud800-\udfff]|[\ud800-\udbff][\udc00-\udfff]|[\ud800-\udfff]/g;function Ot(e){return e?$(e)?a.call(e):C(e)?e.match(Lt):tt(e)?bt(e,Oe):be(e):[]}function qt(e,t,n){if(null==t||n)return tt(e)||(e=be(e)),e[Ie(e.length-1)];var i=Ot(e),r=J(i);t=Math.max(Math.min(t,r),0);for(var o=r-1,a=0;a<t;a++){var s=Ie(a,o),l=i[a];i[a]=i[s],i[s]=l}return i.slice(0,t)}function Et(e,t){return function(n,i,r){var o=t?[[],[]]:{};return i=je(i,r),_t(n,(function(t,r){var a=i(t,r,n);e(o,t,a)})),o}}var Dt=Et((function(e,t,n){F(e,n)?e[n].push(t):e[n]=[t]})),zt=Et((function(e,t,n){e[n]=t})),Nt=Et((function(e,t,n){F(e,n)?e[n]++:e[n]=1})),jt=Et((function(e,t,n){e[n?0:1].push(t)}),!0);function Rt(e,t,n){return t in n}var It=y((function(e,t){var n={},i=t[0];if(null==e)return n;D(i)?(t.length>1&&(i=De(i,t[1])),t=se(e)):(i=Rt,t=nt(t,!1,!1),e=Object(e));for(var r=0,o=t.length;r<o;r++){var a=t[r],s=e[a];i(s,a,e)&&(n[a]=s)}return n})),$t=y((function(e,t){var n,i=t[0];return D(i)?(i=at(i),t.length>1&&(n=t[1])):(t=bt(nt(t,!1,!1),String),i=function(e,n){return!Mt(t,n)}),It(e,i,n)}));function Ft(e,t,n){return a.call(e,0,Math.max(0,e.length-(null==t||n?1:t)))}function Bt(e,t,n){return null==e||e.length<1?null==t||n?void 0:[]:null==t||n?e[0]:Ft(e,e.length-t)}function Vt(e,t,n){return a.call(e,null==t||n?1:t)}var Ht=y((function(e,t){return t=nt(t,!0,!0),xt(e,(function(e){return!Mt(t,e)}))})),Wt=y((function(e,t){return Ht(e,t)}));function Ut(e,t,n,i){x(t)||(i=n,n=t,t=!1),null!=n&&(n=je(n,i));for(var r=[],o=[],a=0,s=J(e);a<s;a++){var l=e[a],c=n?n(l,a,e):l;t&&!n?(a&&o===c||r.push(l),o=c):n?Mt(o,c)||(o.push(c),r.push(l)):Mt(r,l)||r.push(l)}return r}var Yt=y((function(e){return Ut(nt(e,!0,!0))}));function Gt(e){for(var t=e&&Pt(e,J).length||0,n=Array(t),i=0;i<t;i++)n[i]=At(e,i);return n}var Qt=y(Gt);function Kt(e,t){return e._chain?ne(t).chain():t}function Zt(e){return _t(we(e),(function(t){var n=ne[t]=e[t];ne.prototype[t]=function(){var e=[this._wrapped];return o.apply(e,arguments),Kt(this,n.apply(ne,e))}})),ne}_t(["pop","push","reverse","shift","sort","splice","unshift"],(function(e){var t=n[e];ne.prototype[e]=function(){var n=this._wrapped;return null!=n&&(t.apply(n,arguments),"shift"!==e&&"splice"!==e||0!==n.length||delete n[0]),Kt(this,n)}})),_t(["concat","join","slice"],(function(e){var t=n[e];ne.prototype[e]=function(){var e=this._wrapped;return null!=e&&(e=t.apply(e,arguments)),Kt(this,e)}}));var Jt={__proto__:null,VERSION:e,restArguments:y,isObject:w,isNull:function(e){return null===e},isUndefined:k,isBoolean:x,isElement:function(e){return!(!e||1!==e.nodeType)},isString:C,isNumber:M,isDate:T,isRegExp:A,isError:P,isSymbol:L,isArrayBuffer:O,isDataView:I,isArray:$,isFunction:D,isArguments:V,isFinite:function(e){return!L(e)&&v(e)&&!isNaN(parseFloat(e))},isNaN:H,isTypedArray:Z,isEmpty:function(e){if(null==e)return!0;var t=J(e);return"number"==typeof t&&($(e)||C(e)||V(e))?0===t:0===J(ee(e))},isMatch:te,isEqual:function(e,t){return oe(e,t)},isMap:me,isWeakMap:ve,isSet:ge,isWeakSet:_e,keys:ee,allKeys:se,values:be,pairs:function(e){for(var t=ee(e),n=t.length,i=Array(n),r=0;r<n;r++)i[r]=[t[r],e[t[r]]];return i},invert:ye,functions:we,methods:we,extend:xe,extendOwn:Se,assign:Se,defaults:Ce,create:function(e,t){var n=Me(e);return t&&Se(n,t),n},clone:function(e){return w(e)?$(e)?e.slice():xe({},e):e},tap:function(e,t){return t(e),e},get:Le,has:function(e,t){for(var n=(t=Ae(t)).length,i=0;i<n;i++){var r=t[i];if(!F(e,r))return!1;e=e[r]}return!!n},mapObject:function(e,t,n){t=je(t,n);for(var i=ee(e),r=i.length,o={},a=0;a<r;a++){var s=i[a];o[s]=t(e[s],s,e)}return o},identity:Oe,constant:W,noop:Re,toPath:Te,property:Ee,propertyOf:function(e){return null==e?Re:function(t){return Le(e,t)}},matcher:qe,matches:qe,times:function(e,t,n){var i=Array(Math.max(0,e));t=De(t,n,1);for(var r=0;r<e;r++)i[r]=t(r);return i},random:Ie,now:$e,escape:Ve,unescape:He,templateSettings:We,template:function(e,t,n){!t&&n&&(t=n),t=Ce({},t,ne.templateSettings);var i=RegExp([(t.escape||Ue).source,(t.interpolate||Ue).source,(t.evaluate||Ue).source].join("|")+"|$","g"),r=0,o="__p+='";e.replace(i,(function(t,n,i,a,s){return o+=e.slice(r,s).replace(Ge,Qe),r=s+t.length,n?o+="'+\n((__t=("+n+"))==null?'':_.escape(__t))+\n'":i?o+="'+\n((__t=("+i+"))==null?'':__t)+\n'":a&&(o+="';\n"+a+"\n__p+='"),t})),o+="';\n";var a,s=t.variable;if(s){if(!Ke.test(s))throw new Error("variable is not a bare identifier: "+s)}else o="with(obj||{}){\n"+o+"}\n",s="obj";o="var __t,__p='',__j=Array.prototype.join,print=function(){__p+=__j.call(arguments,'');};\n"+o+"return __p;\n";try{a=new Function(s,"_",o)}catch(e){throw e.source=o,e}var l=function(e){return a.call(this,e,ne)};return l.source="function("+s+"){\n"+o+"}",l},result:function(e,t,n){var i=(t=Ae(t)).length;if(!i)return D(n)?n.call(e):n;for(var r=0;r<i;r++){var o=null==e?void 0:e[t[r]];void 0===o&&(o=n,r=i),e=D(o)?o.call(e):o}return e},uniqueId:function(e){var t=++Ze+"";return e?e+t:t},chain:function(e){var t=ne(e);return t._chain=!0,t},iteratee:Ne,partial:Xe,bind:et,bindAll:it,memoize:function(e,t){var n=function(i){var r=n.cache,o=""+(t?t.apply(this,arguments):i);return F(r,o)||(r[o]=e.apply(this,arguments)),r[o]};return n.cache={},n},delay:rt,defer:ot,throttle:function(e,t,n){var i,r,o,a,s=0;n||(n={});var l=function(){s=!1===n.leading?0:$e(),i=null,a=e.apply(r,o),i||(r=o=null)},c=function(){var c=$e();s||!1!==n.leading||(s=c);var u=t-(c-s);return r=this,o=arguments,u<=0||u>t?(i&&(clearTimeout(i),i=null),s=c,a=e.apply(r,o),i||(r=o=null)):i||!1===n.trailing||(i=setTimeout(l,u)),a};return c.cancel=function(){clearTimeout(i),s=0,i=r=o=null},c},debounce:function(e,t,n){var i,r,o,a,s,l=function(){var c=$e()-r;t>c?i=setTimeout(l,t-c):(i=null,n||(a=e.apply(s,o)),i||(o=s=null))},c=y((function(c){return s=this,o=c,r=$e(),i||(i=setTimeout(l,t),n&&(a=e.apply(s,o))),a}));return c.cancel=function(){clearTimeout(i),i=o=s=null},c},wrap:function(e,t){return Xe(t,e)},negate:at,compose:function(){var e=arguments,t=e.length-1;return function(){for(var n=t,i=e[t].apply(this,arguments);n--;)i=e[n].call(this,i);return i}},after:function(e,t){return function(){if(--e<1)return t.apply(this,arguments)}},before:st,once:lt,findKey:ct,findIndex:dt,findLastIndex:ht,sortedIndex:ft,indexOf:mt,lastIndexOf:vt,find:gt,detect:gt,findWhere:function(e,t){return gt(e,qe(t))},each:_t,forEach:_t,map:bt,collect:bt,reduce:wt,foldl:wt,inject:wt,reduceRight:kt,foldr:kt,filter:xt,select:xt,reject:function(e,t,n){return xt(e,at(je(t)),n)},every:St,all:St,some:Ct,any:Ct,contains:Mt,includes:Mt,include:Mt,invoke:Tt,pluck:At,where:function(e,t){return xt(e,qe(t))},max:Pt,min:function(e,t,n){var i,r,o=1/0,a=1/0;if(null==t||"number"==typeof t&&"object"!=typeof e[0]&&null!=e)for(var s=0,l=(e=tt(e)?e:be(e)).length;s<l;s++)null!=(i=e[s])&&i<o&&(o=i);else t=je(t,n),_t(e,(function(e,n,i){((r=t(e,n,i))<a||r===1/0&&o===1/0)&&(o=e,a=r)}));return o},shuffle:function(e){return qt(e,1/0)},sample:qt,sortBy:function(e,t,n){var i=0;return t=je(t,n),At(bt(e,(function(e,n,r){return{value:e,index:i++,criteria:t(e,n,r)}})).sort((function(e,t){var n=e.criteria,i=t.criteria;if(n!==i){if(n>i||void 0===n)return 1;if(n<i||void 0===i)return-1}return e.index-t.index})),"value")},groupBy:Dt,indexBy:zt,countBy:Nt,partition:jt,toArray:Ot,size:function(e){return null==e?0:tt(e)?e.length:ee(e).length},pick:It,omit:$t,first:Bt,head:Bt,take:Bt,initial:Ft,last:function(e,t,n){return null==e||e.length<1?null==t||n?void 0:[]:null==t||n?e[e.length-1]:Vt(e,Math.max(0,e.length-t))},rest:Vt,tail:Vt,drop:Vt,compact:function(e){return xt(e,Boolean)},flatten:function(e,t){return nt(e,t,!1)},without:Wt,uniq:Ut,unique:Ut,union:Yt,intersection:function(e){for(var t=[],n=arguments.length,i=0,r=J(e);i<r;i++){var o=e[i];if(!Mt(t,o)){var a;for(a=1;a<n&&Mt(arguments[a],o);a++);a===n&&t.push(o)}}return t},difference:Ht,unzip:Gt,transpose:Gt,zip:Qt,object:function(e,t){for(var n={},i=0,r=J(e);i<r;i++)t?n[e[i]]=t[i]:n[e[i][0]]=e[i][1];return n},range:function(e,t,n){null==t&&(t=e||0,e=0),n||(n=t<e?-1:1);for(var i=Math.max(Math.ceil((t-e)/n),0),r=Array(i),o=0;o<i;o++,e+=n)r[o]=e;return r},chunk:function(e,t){if(null==t||t<1)return[];for(var n=[],i=0,r=e.length;i<r;)n.push(a.call(e,i,i+=t));return n},mixin:Zt,default:ne},Xt=Zt(Jt);return Xt._=Xt,Xt})),function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e="undefined"!=typeof globalThis?globalThis:e||self).axios=t()}(this,(function(){"use strict";function e(t){return e="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},e(t)}function t(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function n(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}function i(e,t,i){return t&&n(e.prototype,t),i&&n(e,i),Object.defineProperty(e,"prototype",{writable:!1}),e}function r(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var n=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null==n)return;var i,r,o=[],a=!0,s=!1;try{for(n=n.call(e);!(a=(i=n.next()).done)&&(o.push(i.value),!t||o.length!==t);a=!0);}catch(e){s=!0,r=e}finally{try{a||null==n.return||n.return()}finally{if(s)throw r}}return o}(e,t)||function(e,t){if(!e)return;if("string"==typeof e)return o(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);"Object"===n&&e.constructor&&(n=e.constructor.name);if("Map"===n||"Set"===n)return Array.from(e);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return o(e,t)}(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function o(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,i=new Array(t);n<t;n++)i[n]=e[n];return i}function a(e,t){return function(){return e.apply(t,arguments)}}var s,l=Object.prototype.toString,c=Object.getPrototypeOf,u=(s=Object.create(null),function(e){var t=l.call(e);return s[t]||(s[t]=t.slice(8,-1).toLowerCase())}),d=function(e){return e=e.toLowerCase(),function(t){return u(t)===e}},h=function(t){return function(n){return e(n)===t}},f=Array.isArray,p=h("undefined");var m=d("ArrayBuffer");var v=h("string"),g=h("function"),_=h("number"),b=function(t){return null!==t&&"object"===e(t)},y=function(e){if("object"!==u(e))return!1;var t=c(e);return!(null!==t&&t!==Object.prototype&&null!==Object.getPrototypeOf(t)||Symbol.toStringTag in e||Symbol.iterator in e)},w=d("Date"),k=d("File"),x=d("Blob"),S=d("FileList"),C=d("URLSearchParams");function M(t,n){var i,r,o=(arguments.length>2&&void 0!==arguments[2]?arguments[2]:{}).allOwnKeys,a=void 0!==o&&o;if(null!=t)if("object"!==e(t)&&(t=[t]),f(t))for(i=0,r=t.length;i<r;i++)n.call(null,t[i],i,t);else{var s,l=a?Object.getOwnPropertyNames(t):Object.keys(t),c=l.length;for(i=0;i<c;i++)s=l[i],n.call(null,t[s],s,t)}}function T(e,t){t=t.toLowerCase();for(var n,i=Object.keys(e),r=i.length;r-- >0;)if(t===(n=i[r]).toLowerCase())return n;return null}var A="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self?self:"undefined"!=typeof window?window:global,P=function(e){return!p(e)&&e!==A};var L,O=(L="undefined"!=typeof Uint8Array&&c(Uint8Array),function(e){return L&&e instanceof L}),q=d("HTMLFormElement"),E=function(e){var t=Object.prototype.hasOwnProperty;return function(e,n){return t.call(e,n)}}(),D=d("RegExp"),z=function(e,t){var n=Object.getOwnPropertyDescriptors(e),i={};M(n,(function(n,r){var o;!1!==(o=t(n,r,e))&&(i[r]=o||n)})),Object.defineProperties(e,i)},N="abcdefghijklmnopqrstuvwxyz",j="0123456789",R={DIGIT:j,ALPHA:N,ALPHA_DIGIT:N+N.toUpperCase()+j};var I=d("AsyncFunction"),$={isArray:f,isArrayBuffer:m,isBuffer:function(e){return null!==e&&!p(e)&&null!==e.constructor&&!p(e.constructor)&&g(e.constructor.isBuffer)&&e.constructor.isBuffer(e)},isFormData:function(e){var t;return e&&("function"==typeof FormData&&e instanceof FormData||g(e.append)&&("formdata"===(t=u(e))||"object"===t&&g(e.toString)&&"[object FormData]"===e.toString()))},isArrayBufferView:function(e){return"undefined"!=typeof ArrayBuffer&&ArrayBuffer.isView?ArrayBuffer.isView(e):e&&e.buffer&&m(e.buffer)},isString:v,isNumber:_,isBoolean:function(e){return!0===e||!1===e},isObject:b,isPlainObject:y,isUndefined:p,isDate:w,isFile:k,isBlob:x,isRegExp:D,isFunction:g,isStream:function(e){return b(e)&&g(e.pipe)},isURLSearchParams:C,isTypedArray:O,isFileList:S,forEach:M,merge:function e(){for(var t=(P(this)&&this||{}).caseless,n={},i=function(i,r){var o=t&&T(n,r)||r;y(n[o])&&y(i)?n[o]=e(n[o],i):y(i)?n[o]=e({},i):f(i)?n[o]=i.slice():n[o]=i},r=0,o=arguments.length;r<o;r++)arguments[r]&&M(arguments[r],i);return n},extend:function(e,t,n){return M(t,(function(t,i){n&&g(t)?e[i]=a(t,n):e[i]=t}),{allOwnKeys:(arguments.length>3&&void 0!==arguments[3]?arguments[3]:{}).allOwnKeys}),e},trim:function(e){return e.trim?e.trim():e.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,"")},stripBOM:function(e){return 65279===e.charCodeAt(0)&&(e=e.slice(1)),e},inherits:function(e,t,n,i){e.prototype=Object.create(t.prototype,i),e.prototype.constructor=e,Object.defineProperty(e,"super",{value:t.prototype}),n&&Object.assign(e.prototype,n)},toFlatObject:function(e,t,n,i){var r,o,a,s={};if(t=t||{},null==e)return t;do{for(o=(r=Object.getOwnPropertyNames(e)).length;o-- >0;)a=r[o],i&&!i(a,e,t)||s[a]||(t[a]=e[a],s[a]=!0);e=!1!==n&&c(e)}while(e&&(!n||n(e,t))&&e!==Object.prototype);return t},kindOf:u,kindOfTest:d,endsWith:function(e,t,n){e=String(e),(void 0===n||n>e.length)&&(n=e.length),n-=t.length;var i=e.indexOf(t,n);return-1!==i&&i===n},toArray:function(e){if(!e)return null;if(f(e))return e;var t=e.length;if(!_(t))return null;for(var n=new Array(t);t-- >0;)n[t]=e[t];return n},forEachEntry:function(e,t){for(var n,i=(e&&e[Symbol.iterator]).call(e);(n=i.next())&&!n.done;){var r=n.value;t.call(e,r[0],r[1])}},matchAll:function(e,t){for(var n,i=[];null!==(n=e.exec(t));)i.push(n);return i},isHTMLForm:q,hasOwnProperty:E,hasOwnProp:E,reduceDescriptors:z,freezeMethods:function(e){z(e,(function(t,n){if(g(e)&&-1!==["arguments","caller","callee"].indexOf(n))return!1;var i=e[n];g(i)&&(t.enumerable=!1,"writable"in t?t.writable=!1:t.set||(t.set=function(){throw Error("Can not rewrite read-only method '"+n+"'")}))}))},toObjectSet:function(e,t){var n={},i=function(e){e.forEach((function(e){n[e]=!0}))};return f(e)?i(e):i(String(e).split(t)),n},toCamelCase:function(e){return e.toLowerCase().replace(/[-_\s]([a-z\d])(\w*)/g,(function(e,t,n){return t.toUpperCase()+n}))},noop:function(){},toFiniteNumber:function(e,t){return e=+e,Number.isFinite(e)?e:t},findKey:T,global:A,isContextDefined:P,ALPHABET:R,generateString:function(){for(var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:16,t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:R.ALPHA_DIGIT,n="",i=t.length;e--;)n+=t[Math.random()*i|0];return n},isSpecCompliantForm:function(e){return!!(e&&g(e.append)&&"FormData"===e[Symbol.toStringTag]&&e[Symbol.iterator])},toJSONObject:function(e){var t=new Array(10);return function e(n,i){if(b(n)){if(t.indexOf(n)>=0)return;if(!("toJSON"in n)){t[i]=n;var r=f(n)?[]:{};return M(n,(function(t,n){var o=e(t,i+1);!p(o)&&(r[n]=o)})),t[i]=void 0,r}}return n}(e,0)},isAsyncFn:I,isThenable:function(e){return e&&(b(e)||g(e))&&g(e.then)&&g(e.catch)}};function F(e,t,n,i,r){Error.call(this),Error.captureStackTrace?Error.captureStackTrace(this,this.constructor):this.stack=(new Error).stack,this.message=e,this.name="AxiosError",t&&(this.code=t),n&&(this.config=n),i&&(this.request=i),r&&(this.response=r)}$.inherits(F,Error,{toJSON:function(){return{message:this.message,name:this.name,description:this.description,number:this.number,fileName:this.fileName,lineNumber:this.lineNumber,columnNumber:this.columnNumber,stack:this.stack,config:$.toJSONObject(this.config),code:this.code,status:this.response&&this.response.status?this.response.status:null}}});var B=F.prototype,V={};["ERR_BAD_OPTION_VALUE","ERR_BAD_OPTION","ECONNABORTED","ETIMEDOUT","ERR_NETWORK","ERR_FR_TOO_MANY_REDIRECTS","ERR_DEPRECATED","ERR_BAD_RESPONSE","ERR_BAD_REQUEST","ERR_CANCELED","ERR_NOT_SUPPORT","ERR_INVALID_URL"].forEach((function(e){V[e]={value:e}})),Object.defineProperties(F,V),Object.defineProperty(B,"isAxiosError",{value:!0}),F.from=function(e,t,n,i,r,o){var a=Object.create(B);return $.toFlatObject(e,a,(function(e){return e!==Error.prototype}),(function(e){return"isAxiosError"!==e})),F.call(a,e.message,t,n,i,r),a.cause=e,a.name=e.name,o&&Object.assign(a,o),a};function H(e){return $.isPlainObject(e)||$.isArray(e)}function W(e){return $.endsWith(e,"[]")?e.slice(0,-2):e}function U(e,t,n){return e?e.concat(t).map((function(e,t){return e=W(e),!n&&t?"["+e+"]":e})).join(n?".":""):t}var Y=$.toFlatObject($,{},null,(function(e){return/^is[A-Z]/.test(e)}));function G(t,n,i){if(!$.isObject(t))throw new TypeError("target must be an object");n=n||new FormData;var r=(i=$.toFlatObject(i,{metaTokens:!0,dots:!1,indexes:!1},!1,(function(e,t){return!$.isUndefined(t[e])}))).metaTokens,o=i.visitor||u,a=i.dots,s=i.indexes,l=(i.Blob||"undefined"!=typeof Blob&&Blob)&&$.isSpecCompliantForm(n);if(!$.isFunction(o))throw new TypeError("visitor must be a function");function c(e){if(null===e)return"";if($.isDate(e))return e.toISOString();if(!l&&$.isBlob(e))throw new F("Blob is not supported. Use a Buffer instead.");return $.isArrayBuffer(e)||$.isTypedArray(e)?l&&"function"==typeof Blob?new Blob([e]):Buffer.from(e):e}function u(t,i,o){var l=t;if(t&&!o&&"object"===e(t))if($.endsWith(i,"{}"))i=r?i:i.slice(0,-2),t=JSON.stringify(t);else if($.isArray(t)&&function(e){return $.isArray(e)&&!e.some(H)}(t)||($.isFileList(t)||$.endsWith(i,"[]"))&&(l=$.toArray(t)))return i=W(i),l.forEach((function(e,t){!$.isUndefined(e)&&null!==e&&n.append(!0===s?U([i],t,a):null===s?i:i+"[]",c(e))})),!1;return!!H(t)||(n.append(U(o,i,a),c(t)),!1)}var d=[],h=Object.assign(Y,{defaultVisitor:u,convertValue:c,isVisitable:H});if(!$.isObject(t))throw new TypeError("data must be an object");return function e(t,i){if(!$.isUndefined(t)){if(-1!==d.indexOf(t))throw Error("Circular reference detected in "+i.join("."));d.push(t),$.forEach(t,(function(t,r){!0===(!($.isUndefined(t)||null===t)&&o.call(n,t,$.isString(r)?r.trim():r,i,h))&&e(t,i?i.concat(r):[r])})),d.pop()}}(t),n}function Q(e){var t={"!":"%21","'":"%27","(":"%28",")":"%29","~":"%7E","%20":"+","%00":"\0"};return encodeURIComponent(e).replace(/[!'()~]|%20|%00/g,(function(e){return t[e]}))}function K(e,t){this._pairs=[],e&&G(e,this,t)}var Z=K.prototype;function J(e){return encodeURIComponent(e).replace(/%3A/gi,":").replace(/%24/g,"$").replace(/%2C/gi,",").replace(/%20/g,"+").replace(/%5B/gi,"[").replace(/%5D/gi,"]")}function X(e,t,n){if(!t)return e;var i,r=n&&n.encode||J,o=n&&n.serialize;if(i=o?o(t,n):$.isURLSearchParams(t)?t.toString():new K(t,n).toString(r)){var a=e.indexOf("#");-1!==a&&(e=e.slice(0,a)),e+=(-1===e.indexOf("?")?"?":"&")+i}return e}Z.append=function(e,t){this._pairs.push([e,t])},Z.toString=function(e){var t=e?function(t){return e.call(this,t,Q)}:Q;return this._pairs.map((function(e){return t(e[0])+"="+t(e[1])}),"").join("&")};var ee,te=function(){function e(){t(this,e),this.handlers=[]}return i(e,[{key:"use",value:function(e,t,n){return this.handlers.push({fulfilled:e,rejected:t,synchronous:!!n&&n.synchronous,runWhen:n?n.runWhen:null}),this.handlers.length-1}},{key:"eject",value:function(e){this.handlers[e]&&(this.handlers[e]=null)}},{key:"clear",value:function(){this.handlers&&(this.handlers=[])}},{key:"forEach",value:function(e){$.forEach(this.handlers,(function(t){null!==t&&e(t)}))}}]),e}(),ne={silentJSONParsing:!0,forcedJSONParsing:!0,clarifyTimeoutError:!1},ie={isBrowser:!0,classes:{URLSearchParams:"undefined"!=typeof URLSearchParams?URLSearchParams:K,FormData:"undefined"!=typeof FormData?FormData:null,Blob:"undefined"!=typeof Blob?Blob:null},isStandardBrowserEnv:("undefined"==typeof navigator||"ReactNative"!==(ee=navigator.product)&&"NativeScript"!==ee&&"NS"!==ee)&&"undefined"!=typeof window&&"undefined"!=typeof document,isStandardBrowserWebWorkerEnv:"undefined"!=typeof WorkerGlobalScope&&self instanceof WorkerGlobalScope&&"function"==typeof self.importScripts,protocols:["http","https","file","blob","url","data"]};function re(e){function t(e,n,i,r){var o=e[r++],a=Number.isFinite(+o),s=r>=e.length;return o=!o&&$.isArray(i)?i.length:o,s?($.hasOwnProp(i,o)?i[o]=[i[o],n]:i[o]=n,!a):(i[o]&&$.isObject(i[o])||(i[o]=[]),t(e,n,i[o],r)&&$.isArray(i[o])&&(i[o]=function(e){var t,n,i={},r=Object.keys(e),o=r.length;for(t=0;t<o;t++)i[n=r[t]]=e[n];return i}(i[o])),!a)}if($.isFormData(e)&&$.isFunction(e.entries)){var n={};return $.forEachEntry(e,(function(e,i){t(function(e){return $.matchAll(/\w+|\[(\w*)]/g,e).map((function(e){return"[]"===e[0]?"":e[1]||e[0]}))}(e),i,n,0)})),n}return null}var oe={transitional:ne,adapter:["xhr","http"],transformRequest:[function(e,t){var n,i=t.getContentType()||"",r=i.indexOf("application/json")>-1,o=$.isObject(e);if(o&&$.isHTMLForm(e)&&(e=new FormData(e)),$.isFormData(e))return r&&r?JSON.stringify(re(e)):e;if($.isArrayBuffer(e)||$.isBuffer(e)||$.isStream(e)||$.isFile(e)||$.isBlob(e))return e;if($.isArrayBufferView(e))return e.buffer;if($.isURLSearchParams(e))return t.setContentType("application/x-www-form-urlencoded;charset=utf-8",!1),e.toString();if(o){if(i.indexOf("application/x-www-form-urlencoded")>-1)return function(e,t){return G(e,new ie.classes.URLSearchParams,Object.assign({visitor:function(e,t,n,i){return ie.isNode&&$.isBuffer(e)?(this.append(t,e.toString("base64")),!1):i.defaultVisitor.apply(this,arguments)}},t))}(e,this.formSerializer).toString();if((n=$.isFileList(e))||i.indexOf("multipart/form-data")>-1){var a=this.env&&this.env.FormData;return G(n?{"files[]":e}:e,a&&new a,this.formSerializer)}}return o||r?(t.setContentType("application/json",!1),function(e,t,n){if($.isString(e))try{return(t||JSON.parse)(e),$.trim(e)}catch(e){if("SyntaxError"!==e.name)throw e}return(n||JSON.stringify)(e)}(e)):e}],transformResponse:[function(e){var t=this.transitional||oe.transitional,n=t&&t.forcedJSONParsing,i="json"===this.responseType;if(e&&$.isString(e)&&(n&&!this.responseType||i)){var r=!(t&&t.silentJSONParsing)&&i;try{return JSON.parse(e)}catch(e){if(r){if("SyntaxError"===e.name)throw F.from(e,F.ERR_BAD_RESPONSE,this,null,this.response);throw e}}}return e}],timeout:0,xsrfCookieName:"XSRF-TOKEN",xsrfHeaderName:"X-XSRF-TOKEN",maxContentLength:-1,maxBodyLength:-1,env:{FormData:ie.classes.FormData,Blob:ie.classes.Blob},validateStatus:function(e){return e>=200&&e<300},headers:{common:{Accept:"application/json, text/plain, */*","Content-Type":void 0}}};$.forEach(["delete","get","head","post","put","patch"],(function(e){oe.headers[e]={}}));var ae=oe,se=$.toObjectSet(["age","authorization","content-length","content-type","etag","expires","from","host","if-modified-since","if-unmodified-since","last-modified","location","max-forwards","proxy-authorization","referer","retry-after","user-agent"]),le=Symbol("internals");function ce(e){return e&&String(e).trim().toLowerCase()}function ue(e){return!1===e||null==e?e:$.isArray(e)?e.map(ue):String(e)}function de(e,t,n,i,r){return $.isFunction(i)?i.call(this,t,n):(r&&(t=n),$.isString(t)?$.isString(i)?-1!==t.indexOf(i):$.isRegExp(i)?i.test(t):void 0:void 0)}var he=function(e,n){function o(e){t(this,o),e&&this.set(e)}return i(o,[{key:"set",value:function(e,t,n){var i=this;function r(e,t,n){var r=ce(t);if(!r)throw new Error("header name must be a non-empty string");var o=$.findKey(i,r);(!o||void 0===i[o]||!0===n||void 0===n&&!1!==i[o])&&(i[o||t]=ue(e))}var o,a,s,l,c,u=function(e,t){return $.forEach(e,(function(e,n){return r(e,n,t)}))};return $.isPlainObject(e)||e instanceof this.constructor?u(e,t):$.isString(e)&&(e=e.trim())&&!/^[-_a-zA-Z0-9^`|~,!#$%&'*+.]+$/.test(e.trim())?u((c={},(o=e)&&o.split("\n").forEach((function(e){l=e.indexOf(":"),a=e.substring(0,l).trim().toLowerCase(),s=e.substring(l+1).trim(),!a||c[a]&&se[a]||("set-cookie"===a?c[a]?c[a].push(s):c[a]=[s]:c[a]=c[a]?c[a]+", "+s:s)})),c),t):null!=e&&r(t,e,n),this}},{key:"get",value:function(e,t){if(e=ce(e)){var n=$.findKey(this,e);if(n){var i=this[n];if(!t)return i;if(!0===t)return function(e){for(var t,n=Object.create(null),i=/([^\s,;=]+)\s*(?:=\s*([^,;]+))?/g;t=i.exec(e);)n[t[1]]=t[2];return n}(i);if($.isFunction(t))return t.call(this,i,n);if($.isRegExp(t))return t.exec(i);throw new TypeError("parser must be boolean|regexp|function")}}}},{key:"has",value:function(e,t){if(e=ce(e)){var n=$.findKey(this,e);return!(!n||void 0===this[n]||t&&!de(0,this[n],n,t))}return!1}},{key:"delete",value:function(e,t){var n=this,i=!1;function r(e){if(e=ce(e)){var r=$.findKey(n,e);!r||t&&!de(0,n[r],r,t)||(delete n[r],i=!0)}}return $.isArray(e)?e.forEach(r):r(e),i}},{key:"clear",value:function(e){for(var t=Object.keys(this),n=t.length,i=!1;n--;){var r=t[n];e&&!de(0,this[r],r,e,!0)||(delete this[r],i=!0)}return i}},{key:"normalize",value:function(e){var t=this,n={};return $.forEach(this,(function(i,r){var o=$.findKey(n,r);if(o)return t[o]=ue(i),void delete t[r];var a=e?function(e){return e.trim().toLowerCase().replace(/([a-z\d])(\w*)/g,(function(e,t,n){return t.toUpperCase()+n}))}(r):String(r).trim();a!==r&&delete t[r],t[a]=ue(i),n[a]=!0})),this}},{key:"concat",value:function(){for(var e,t=arguments.length,n=new Array(t),i=0;i<t;i++)n[i]=arguments[i];return(e=this.constructor).concat.apply(e,[this].concat(n))}},{key:"toJSON",value:function(e){var t=Object.create(null);return $.forEach(this,(function(n,i){null!=n&&!1!==n&&(t[i]=e&&$.isArray(n)?n.join(", "):n)})),t}},{key:Symbol.iterator,value:function(){return Object.entries(this.toJSON())[Symbol.iterator]()}},{key:"toString",value:function(){return Object.entries(this.toJSON()).map((function(e){var t=r(e,2);return t[0]+": "+t[1]})).join("\n")}},{key:Symbol.toStringTag,get:function(){return"AxiosHeaders"}}],[{key:"from",value:function(e){return e instanceof this?e:new this(e)}},{key:"concat",value:function(e){for(var t=new this(e),n=arguments.length,i=new Array(n>1?n-1:0),r=1;r<n;r++)i[r-1]=arguments[r];return i.forEach((function(e){return t.set(e)})),t}},{key:"accessor",value:function(e){var t=(this[le]=this[le]={accessors:{}}).accessors,n=this.prototype;function i(e){var i=ce(e);t[i]||(!function(e,t){var n=$.toCamelCase(" "+t);["get","set","has"].forEach((function(i){Object.defineProperty(e,i+n,{value:function(e,n,r){return this[i].call(this,t,e,n,r)},configurable:!0})}))}(n,e),t[i]=!0)}return $.isArray(e)?e.forEach(i):i(e),this}}]),o}();he.accessor(["Content-Type","Content-Length","Accept","Accept-Encoding","User-Agent","Authorization"]),$.reduceDescriptors(he.prototype,(function(e,t){var n=e.value,i=t[0].toUpperCase()+t.slice(1);return{get:function(){return n},set:function(e){this[i]=e}}})),$.freezeMethods(he);var fe=he;function pe(e,t){var n=this||ae,i=t||n,r=fe.from(i.headers),o=i.data;return $.forEach(e,(function(e){o=e.call(n,o,r.normalize(),t?t.status:void 0)})),r.normalize(),o}function me(e){return!(!e||!e.__CANCEL__)}function ve(e,t,n){F.call(this,null==e?"canceled":e,F.ERR_CANCELED,t,n),this.name="CanceledError"}$.inherits(ve,F,{__CANCEL__:!0});var ge=ie.isStandardBrowserEnv?{write:function(e,t,n,i,r,o){var a=[];a.push(e+"="+encodeURIComponent(t)),$.isNumber(n)&&a.push("expires="+new Date(n).toGMTString()),$.isString(i)&&a.push("path="+i),$.isString(r)&&a.push("domain="+r),!0===o&&a.push("secure"),document.cookie=a.join("; ")},read:function(e){var t=document.cookie.match(new RegExp("(^|;\\s*)("+e+")=([^;]*)"));return t?decodeURIComponent(t[3]):null},remove:function(e){this.write(e,"",Date.now()-864e5)}}:{write:function(){},read:function(){return null},remove:function(){}};function _e(e,t){return e&&!/^([a-z][a-z\d+\-.]*:)?\/\//i.test(t)?function(e,t){return t?e.replace(/\/+$/,"")+"/"+t.replace(/^\/+/,""):e}(e,t):t}var be=ie.isStandardBrowserEnv?function(){var e,t=/(msie|trident)/i.test(navigator.userAgent),n=document.createElement("a");function i(e){var i=e;return t&&(n.setAttribute("href",i),i=n.href),n.setAttribute("href",i),{href:n.href,protocol:n.protocol?n.protocol.replace(/:$/,""):"",host:n.host,search:n.search?n.search.replace(/^\?/,""):"",hash:n.hash?n.hash.replace(/^#/,""):"",hostname:n.hostname,port:n.port,pathname:"/"===n.pathname.charAt(0)?n.pathname:"/"+n.pathname}}return e=i(window.location.href),function(t){var n=$.isString(t)?i(t):t;return n.protocol===e.protocol&&n.host===e.host}}():function(){return!0};function ye(e,t){var n=0,i=function(e,t){e=e||10;var n,i=new Array(e),r=new Array(e),o=0,a=0;return t=void 0!==t?t:1e3,function(s){var l=Date.now(),c=r[a];n||(n=l),i[o]=s,r[o]=l;for(var u=a,d=0;u!==o;)d+=i[u++],u%=e;if((o=(o+1)%e)===a&&(a=(a+1)%e),!(l-n<t)){var h=c&&l-c;return h?Math.round(1e3*d/h):void 0}}}(50,250);return function(r){var o=r.loaded,a=r.lengthComputable?r.total:void 0,s=o-n,l=i(s);n=o;var c={loaded:o,total:a,progress:a?o/a:void 0,bytes:s,rate:l||void 0,estimated:l&&a&&o<=a?(a-o)/l:void 0,event:r};c[t?"download":"upload"]=!0,e(c)}}var we={http:null,xhr:"undefined"!=typeof XMLHttpRequest&&function(e){return new Promise((function(t,n){var i,r,o=e.data,a=fe.from(e.headers).normalize(),s=e.responseType;function l(){e.cancelToken&&e.cancelToken.unsubscribe(i),e.signal&&e.signal.removeEventListener("abort",i)}$.isFormData(o)&&(ie.isStandardBrowserEnv||ie.isStandardBrowserWebWorkerEnv?a.setContentType(!1):a.getContentType(/^\s*multipart\/form-data/)?$.isString(r=a.getContentType())&&a.setContentType(r.replace(/^\s*(multipart\/form-data);+/,"$1")):a.setContentType("multipart/form-data"));var c=new XMLHttpRequest;if(e.auth){var u=e.auth.username||"",d=e.auth.password?unescape(encodeURIComponent(e.auth.password)):"";a.set("Authorization","Basic "+btoa(u+":"+d))}var h=_e(e.baseURL,e.url);function f(){if(c){var i=fe.from("getAllResponseHeaders"in c&&c.getAllResponseHeaders());!function(e,t,n){var i=n.config.validateStatus;n.status&&i&&!i(n.status)?t(new F("Request failed with status code "+n.status,[F.ERR_BAD_REQUEST,F.ERR_BAD_RESPONSE][Math.floor(n.status/100)-4],n.config,n.request,n)):e(n)}((function(e){t(e),l()}),(function(e){n(e),l()}),{data:s&&"text"!==s&&"json"!==s?c.response:c.responseText,status:c.status,statusText:c.statusText,headers:i,config:e,request:c}),c=null}}if(c.open(e.method.toUpperCase(),X(h,e.params,e.paramsSerializer),!0),c.timeout=e.timeout,"onloadend"in c?c.onloadend=f:c.onreadystatechange=function(){c&&4===c.readyState&&(0!==c.status||c.responseURL&&0===c.responseURL.indexOf("file:"))&&setTimeout(f)},c.onabort=function(){c&&(n(new F("Request aborted",F.ECONNABORTED,e,c)),c=null)},c.onerror=function(){n(new F("Network Error",F.ERR_NETWORK,e,c)),c=null},c.ontimeout=function(){var t=e.timeout?"timeout of "+e.timeout+"ms exceeded":"timeout exceeded",i=e.transitional||ne;e.timeoutErrorMessage&&(t=e.timeoutErrorMessage),n(new F(t,i.clarifyTimeoutError?F.ETIMEDOUT:F.ECONNABORTED,e,c)),c=null},ie.isStandardBrowserEnv){var p=be(h)&&e.xsrfCookieName&&ge.read(e.xsrfCookieName);p&&a.set(e.xsrfHeaderName,p)}void 0===o&&a.setContentType(null),"setRequestHeader"in c&&$.forEach(a.toJSON(),(function(e,t){c.setRequestHeader(t,e)})),$.isUndefined(e.withCredentials)||(c.withCredentials=!!e.withCredentials),s&&"json"!==s&&(c.responseType=e.responseType),"function"==typeof e.onDownloadProgress&&c.addEventListener("progress",ye(e.onDownloadProgress,!0)),"function"==typeof e.onUploadProgress&&c.upload&&c.upload.addEventListener("progress",ye(e.onUploadProgress)),(e.cancelToken||e.signal)&&(i=function(t){c&&(n(!t||t.type?new ve(null,e,c):t),c.abort(),c=null)},e.cancelToken&&e.cancelToken.subscribe(i),e.signal&&(e.signal.aborted?i():e.signal.addEventListener("abort",i)));var m,v=(m=/^([-+\w]{1,25})(:?\/\/|:)/.exec(h))&&m[1]||"";v&&-1===ie.protocols.indexOf(v)?n(new F("Unsupported protocol "+v+":",F.ERR_BAD_REQUEST,e)):c.send(o||null)}))}};$.forEach(we,(function(e,t){if(e){try{Object.defineProperty(e,"name",{value:t})}catch(e){}Object.defineProperty(e,"adapterName",{value:t})}}));var ke=function(e){return"- ".concat(e)},xe=function(e){return $.isFunction(e)||null===e||!1===e},Se={getAdapter:function(e){for(var t,n,i=(e=$.isArray(e)?e:[e]).length,o={},a=0;a<i;a++){var s=void 0;if(n=t=e[a],!xe(t)&&void 0===(n=we[(s=String(t)).toLowerCase()]))throw new F("Unknown adapter '".concat(s,"'"));if(n)break;o[s||"#"+a]=n}if(!n){var l=Object.entries(o).map((function(e){var t=r(e,2),n=t[0],i=t[1];return"adapter ".concat(n," ")+(!1===i?"is not supported by the environment":"is not available in the build")}));throw new F("There is no suitable adapter to dispatch the request "+(i?l.length>1?"since :\n"+l.map(ke).join("\n"):" "+ke(l[0]):"as no adapter specified"),"ERR_NOT_SUPPORT")}return n},adapters:we};function Ce(e){if(e.cancelToken&&e.cancelToken.throwIfRequested(),e.signal&&e.signal.aborted)throw new ve(null,e)}function Me(e){return Ce(e),e.headers=fe.from(e.headers),e.data=pe.call(e,e.transformRequest),-1!==["post","put","patch"].indexOf(e.method)&&e.headers.setContentType("application/x-www-form-urlencoded",!1),Se.getAdapter(e.adapter||ae.adapter)(e).then((function(t){return Ce(e),t.data=pe.call(e,e.transformResponse,t),t.headers=fe.from(t.headers),t}),(function(t){return me(t)||(Ce(e),t&&t.response&&(t.response.data=pe.call(e,e.transformResponse,t.response),t.response.headers=fe.from(t.response.headers))),Promise.reject(t)}))}var Te=function(e){return e instanceof fe?e.toJSON():e};function Ae(e,t){t=t||{};var n={};function i(e,t,n){return $.isPlainObject(e)&&$.isPlainObject(t)?$.merge.call({caseless:n},e,t):$.isPlainObject(t)?$.merge({},t):$.isArray(t)?t.slice():t}function r(e,t,n){return $.isUndefined(t)?$.isUndefined(e)?void 0:i(void 0,e,n):i(e,t,n)}function o(e,t){if(!$.isUndefined(t))return i(void 0,t)}function a(e,t){return $.isUndefined(t)?$.isUndefined(e)?void 0:i(void 0,e):i(void 0,t)}function s(n,r,o){return o in t?i(n,r):o in e?i(void 0,n):void 0}var l={url:o,method:o,data:o,baseURL:a,transformRequest:a,transformResponse:a,paramsSerializer:a,timeout:a,timeoutMessage:a,withCredentials:a,adapter:a,responseType:a,xsrfCookieName:a,xsrfHeaderName:a,onUploadProgress:a,onDownloadProgress:a,decompress:a,maxContentLength:a,maxBodyLength:a,beforeRedirect:a,transport:a,httpAgent:a,httpsAgent:a,cancelToken:a,socketPath:a,responseEncoding:a,validateStatus:s,headers:function(e,t){return r(Te(e),Te(t),!0)}};return $.forEach(Object.keys(Object.assign({},e,t)),(function(i){var o=l[i]||r,a=o(e[i],t[i],i);$.isUndefined(a)&&o!==s||(n[i]=a)})),n}var Pe="1.6.0",Le={};["object","boolean","number","function","string","symbol"].forEach((function(t,n){Le[t]=function(i){return e(i)===t||"a"+(n<1?"n ":" ")+t}}));var Oe={};Le.transitional=function(e,t,n){function i(e,t){return"[Axios v1.6.0] Transitional option '"+e+"'"+t+(n?". "+n:"")}return function(n,r,o){if(!1===e)throw new F(i(r," has been removed"+(t?" in "+t:"")),F.ERR_DEPRECATED);return t&&!Oe[r]&&(Oe[r]=!0,console.warn(i(r," has been deprecated since v"+t+" and will be removed in the near future"))),!e||e(n,r,o)}};var qe={assertOptions:function(t,n,i){if("object"!==e(t))throw new F("options must be an object",F.ERR_BAD_OPTION_VALUE);for(var r=Object.keys(t),o=r.length;o-- >0;){var a=r[o],s=n[a];if(s){var l=t[a],c=void 0===l||s(l,a,t);if(!0!==c)throw new F("option "+a+" must be "+c,F.ERR_BAD_OPTION_VALUE)}else if(!0!==i)throw new F("Unknown option "+a,F.ERR_BAD_OPTION)}},validators:Le},Ee=qe.validators,De=function(){function e(n){t(this,e),this.defaults=n,this.interceptors={request:new te,response:new te}}return i(e,[{key:"request",value:function(e,t){"string"==typeof e?(t=t||{}).url=e:t=e||{};var n=t=Ae(this.defaults,t),i=n.transitional,r=n.paramsSerializer,o=n.headers;void 0!==i&&qe.assertOptions(i,{silentJSONParsing:Ee.transitional(Ee.boolean),forcedJSONParsing:Ee.transitional(Ee.boolean),clarifyTimeoutError:Ee.transitional(Ee.boolean)},!1),null!=r&&($.isFunction(r)?t.paramsSerializer={serialize:r}:qe.assertOptions(r,{encode:Ee.function,serialize:Ee.function},!0)),t.method=(t.method||this.defaults.method||"get").toLowerCase();var a=o&&$.merge(o.common,o[t.method]);o&&$.forEach(["delete","get","head","post","put","patch","common"],(function(e){delete o[e]})),t.headers=fe.concat(a,o);var s=[],l=!0;this.interceptors.request.forEach((function(e){"function"==typeof e.runWhen&&!1===e.runWhen(t)||(l=l&&e.synchronous,s.unshift(e.fulfilled,e.rejected))}));var c,u=[];this.interceptors.response.forEach((function(e){u.push(e.fulfilled,e.rejected)}));var d,h=0;if(!l){var f=[Me.bind(this),void 0];for(f.unshift.apply(f,s),f.push.apply(f,u),d=f.length,c=Promise.resolve(t);h<d;)c=c.then(f[h++],f[h++]);return c}d=s.length;var p=t;for(h=0;h<d;){var m=s[h++],v=s[h++];try{p=m(p)}catch(e){v.call(this,e);break}}try{c=Me.call(this,p)}catch(e){return Promise.reject(e)}for(h=0,d=u.length;h<d;)c=c.then(u[h++],u[h++]);return c}},{key:"getUri",value:function(e){return X(_e((e=Ae(this.defaults,e)).baseURL,e.url),e.params,e.paramsSerializer)}}]),e}();$.forEach(["delete","get","head","options"],(function(e){De.prototype[e]=function(t,n){return this.request(Ae(n||{},{method:e,url:t,data:(n||{}).data}))}})),$.forEach(["post","put","patch"],(function(e){function t(t){return function(n,i,r){return this.request(Ae(r||{},{method:e,headers:t?{"Content-Type":"multipart/form-data"}:{},url:n,data:i}))}}De.prototype[e]=t(),De.prototype[e+"Form"]=t(!0)}));var ze=De,Ne=function(){function e(n){if(t(this,e),"function"!=typeof n)throw new TypeError("executor must be a function.");var i;this.promise=new Promise((function(e){i=e}));var r=this;this.promise.then((function(e){if(r._listeners){for(var t=r._listeners.length;t-- >0;)r._listeners[t](e);r._listeners=null}})),this.promise.then=function(e){var t,n=new Promise((function(e){r.subscribe(e),t=e})).then(e);return n.cancel=function(){r.unsubscribe(t)},n},n((function(e,t,n){r.reason||(r.reason=new ve(e,t,n),i(r.reason))}))}return i(e,[{key:"throwIfRequested",value:function(){if(this.reason)throw this.reason}},{key:"subscribe",value:function(e){this.reason?e(this.reason):this._listeners?this._listeners.push(e):this._listeners=[e]}},{key:"unsubscribe",value:function(e){if(this._listeners){var t=this._listeners.indexOf(e);-1!==t&&this._listeners.splice(t,1)}}}],[{key:"source",value:function(){var t;return{token:new e((function(e){t=e})),cancel:t}}}]),e}();var je={Continue:100,SwitchingProtocols:101,Processing:102,EarlyHints:103,Ok:200,Created:201,Accepted:202,NonAuthoritativeInformation:203,NoContent:204,ResetContent:205,PartialContent:206,MultiStatus:207,AlreadyReported:208,ImUsed:226,MultipleChoices:300,MovedPermanently:301,Found:302,SeeOther:303,NotModified:304,UseProxy:305,Unused:306,TemporaryRedirect:307,PermanentRedirect:308,BadRequest:400,Unauthorized:401,PaymentRequired:402,Forbidden:403,NotFound:404,MethodNotAllowed:405,NotAcceptable:406,ProxyAuthenticationRequired:407,RequestTimeout:408,Conflict:409,Gone:410,LengthRequired:411,PreconditionFailed:412,PayloadTooLarge:413,UriTooLong:414,UnsupportedMediaType:415,RangeNotSatisfiable:416,ExpectationFailed:417,ImATeapot:418,MisdirectedRequest:421,UnprocessableEntity:422,Locked:423,FailedDependency:424,TooEarly:425,UpgradeRequired:426,PreconditionRequired:428,TooManyRequests:429,RequestHeaderFieldsTooLarge:431,UnavailableForLegalReasons:451,InternalServerError:500,NotImplemented:501,BadGateway:502,ServiceUnavailable:503,GatewayTimeout:504,HttpVersionNotSupported:505,VariantAlsoNegotiates:506,InsufficientStorage:507,LoopDetected:508,NotExtended:510,NetworkAuthenticationRequired:511};Object.entries(je).forEach((function(e){var t=r(e,2),n=t[0],i=t[1];je[i]=n}));var Re=je;var Ie=function e(t){var n=new ze(t),i=a(ze.prototype.request,n);return $.extend(i,ze.prototype,n,{allOwnKeys:!0}),$.extend(i,n,null,{allOwnKeys:!0}),i.create=function(n){return e(Ae(t,n))},i}(ae);return Ie.Axios=ze,Ie.CanceledError=ve,Ie.CancelToken=Ne,Ie.isCancel=me,Ie.VERSION=Pe,Ie.toFormData=G,Ie.AxiosError=F,Ie.Cancel=Ie.CanceledError,Ie.all=function(e){return Promise.all(e)},Ie.spread=function(e){return function(t){return e.apply(null,t)}},Ie.isAxiosError=function(e){return $.isObject(e)&&!0===e.isAxiosError},Ie.mergeConfig=Ae,Ie.AxiosHeaders=fe,Ie.formToJSON=function(e){return re($.isHTMLForm(e)?new FormData(e):e)},Ie.getAdapter=Se.getAdapter,Ie.HttpStatusCode=Re,Ie.default=Ie,Ie})),
/*!
 * Vue.js v2.6.12
 * (c) 2014-2020 Evan You
 * Released under the MIT License.
 */
function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e=e||self).Vue=t()}(this,(function(){"use strict";var e=Object.freeze({});function t(e){return null==e}function n(e){return null!=e}function i(e){return!0===e}function r(e){return"string"==typeof e||"number"==typeof e||"symbol"==typeof e||"boolean"==typeof e}function o(e){return null!==e&&"object"==typeof e}var a=Object.prototype.toString;function s(e){return a.call(e).slice(8,-1)}function l(e){return"[object Object]"===a.call(e)}function c(e){return"[object RegExp]"===a.call(e)}function u(e){var t=parseFloat(String(e));return t>=0&&Math.floor(t)===t&&isFinite(e)}function d(e){return n(e)&&"function"==typeof e.then&&"function"==typeof e.catch}function h(e){return null==e?"":Array.isArray(e)||l(e)&&e.toString===a?JSON.stringify(e,null,2):String(e)}function f(e){var t=parseFloat(e);return isNaN(t)?e:t}function p(e,t){for(var n=Object.create(null),i=e.split(","),r=0;r<i.length;r++)n[i[r]]=!0;return t?function(e){return n[e.toLowerCase()]}:function(e){return n[e]}}var m=p("slot,component",!0),v=p("key,ref,slot,slot-scope,is");function g(e,t){if(e.length){var n=e.indexOf(t);if(n>-1)return e.splice(n,1)}}var _=Object.prototype.hasOwnProperty;function b(e,t){return _.call(e,t)}function y(e){var t=Object.create(null);return function(n){return t[n]||(t[n]=e(n))}}var w=/-(\w)/g,k=y((function(e){return e.replace(w,(function(e,t){return t?t.toUpperCase():""}))})),x=y((function(e){return e.charAt(0).toUpperCase()+e.slice(1)})),S=/\B([A-Z])/g,C=y((function(e){return e.replace(S,"-$1").toLowerCase()}));var M=Function.prototype.bind?function(e,t){return e.bind(t)}:function(e,t){function n(n){var i=arguments.length;return i?i>1?e.apply(t,arguments):e.call(t,n):e.call(t)}return n._length=e.length,n};function T(e,t){t=t||0;for(var n=e.length-t,i=new Array(n);n--;)i[n]=e[n+t];return i}function A(e,t){for(var n in t)e[n]=t[n];return e}function P(e){for(var t={},n=0;n<e.length;n++)e[n]&&A(t,e[n]);return t}function L(e,t,n){}var O=function(e,t,n){return!1},q=function(e){return e};function E(e,t){if(e===t)return!0;var n=o(e),i=o(t);if(!n||!i)return!n&&!i&&String(e)===String(t);try{var r=Array.isArray(e),a=Array.isArray(t);if(r&&a)return e.length===t.length&&e.every((function(e,n){return E(e,t[n])}));if(e instanceof Date&&t instanceof Date)return e.getTime()===t.getTime();if(r||a)return!1;var s=Object.keys(e),l=Object.keys(t);return s.length===l.length&&s.every((function(n){return E(e[n],t[n])}))}catch(e){return!1}}function D(e,t){for(var n=0;n<e.length;n++)if(E(e[n],t))return n;return-1}function z(e){var t=!1;return function(){t||(t=!0,e.apply(this,arguments))}}var N="data-server-rendered",j=["component","directive","filter"],R=["beforeCreate","created","beforeMount","mounted","beforeUpdate","updated","beforeDestroy","destroyed","activated","deactivated","errorCaptured","serverPrefetch"],I={optionMergeStrategies:Object.create(null),silent:!1,productionTip:!0,devtools:!0,performance:!1,errorHandler:null,warnHandler:null,ignoredElements:[],keyCodes:Object.create(null),isReservedTag:O,isReservedAttr:O,isUnknownElement:O,getTagNamespace:L,parsePlatformTagName:q,mustUseProp:O,async:!0,_lifecycleHooks:R},$=/a-zA-Z\u00B7\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u037D\u037F-\u1FFF\u200C-\u200D\u203F-\u2040\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD/;function F(e){var t=(e+"").charCodeAt(0);return 36===t||95===t}function B(e,t,n,i){Object.defineProperty(e,t,{value:n,enumerable:!!i,writable:!0,configurable:!0})}var V=new RegExp("[^"+$.source+".$_\\d]");var H,W="__proto__"in{},U="undefined"!=typeof window,Y="undefined"!=typeof WXEnvironment&&!!WXEnvironment.platform,G=Y&&WXEnvironment.platform.toLowerCase(),Q=U&&window.navigator.userAgent.toLowerCase(),K=Q&&/msie|trident/.test(Q),Z=Q&&Q.indexOf("msie 9.0")>0,J=Q&&Q.indexOf("edge/")>0,X=(Q&&Q.indexOf("android"),Q&&/iphone|ipad|ipod|ios/.test(Q)||"ios"===G),ee=(Q&&/chrome\/\d+/.test(Q),Q&&/phantomjs/.test(Q),Q&&Q.match(/firefox\/(\d+)/)),te={}.watch,ne=!1;if(U)try{var ie={};Object.defineProperty(ie,"passive",{get:function(){ne=!0}}),window.addEventListener("test-passive",null,ie)}catch(e){}var re=function(){return void 0===H&&(H=!U&&!Y&&"undefined"!=typeof global&&(global.process&&"server"===global.process.env.VUE_ENV)),H},oe=U&&window.__VUE_DEVTOOLS_GLOBAL_HOOK__;function ae(e){return"function"==typeof e&&/native code/.test(e.toString())}var se,le="undefined"!=typeof Symbol&&ae(Symbol)&&"undefined"!=typeof Reflect&&ae(Reflect.ownKeys);se="undefined"!=typeof Set&&ae(Set)?Set:function(){function e(){this.set=Object.create(null)}return e.prototype.has=function(e){return!0===this.set[e]},e.prototype.add=function(e){this.set[e]=!0},e.prototype.clear=function(){this.set=Object.create(null)},e}();var ce=L,ue=L,de=L,he=L,fe="undefined"!=typeof console,pe=/(?:^|[-_])(\w)/g;ce=function(e,t){var n=t?de(t):"";I.warnHandler?I.warnHandler.call(null,e,t,n):fe&&!I.silent&&console.error("[Vue warn]: "+e+n)},ue=function(e,t){fe&&!I.silent&&console.warn("[Vue tip]: "+e+(t?de(t):""))},he=function(e,t){if(e.$root===e)return"<Root>";var n="function"==typeof e&&null!=e.cid?e.options:e._isVue?e.$options||e.constructor.options:e,i=n.name||n._componentTag,r=n.__file;if(!i&&r){var o=r.match(/([^/\\]+)\.vue$/);i=o&&o[1]}return(i?"<"+function(e){return e.replace(pe,(function(e){return e.toUpperCase()})).replace(/[-_]/g,"")}(i)+">":"<Anonymous>")+(r&&!1!==t?" at "+r:"")};de=function(e){if(e._isVue&&e.$parent){for(var t=[],n=0;e;){if(t.length>0){var i=t[t.length-1];if(i.constructor===e.constructor){n++,e=e.$parent;continue}n>0&&(t[t.length-1]=[i,n],n=0)}t.push(e),e=e.$parent}return"\n\nfound in\n\n"+t.map((function(e,t){return""+(0===t?"---\x3e ":function(e,t){for(var n="";t;)t%2==1&&(n+=e),t>1&&(e+=e),t>>=1;return n}(" ",5+2*t))+(Array.isArray(e)?he(e[0])+"... ("+e[1]+" recursive calls)":he(e))})).join("\n")}return"\n\n(found in "+he(e)+")"};var me=0,ve=function(){this.id=me++,this.subs=[]};ve.prototype.addSub=function(e){this.subs.push(e)},ve.prototype.removeSub=function(e){g(this.subs,e)},ve.prototype.depend=function(){ve.target&&ve.target.addDep(this)},ve.prototype.notify=function(){var e=this.subs.slice();I.async||e.sort((function(e,t){return e.id-t.id}));for(var t=0,n=e.length;t<n;t++)e[t].update()},ve.target=null;var ge=[];function _e(e){ge.push(e),ve.target=e}function be(){ge.pop(),ve.target=ge[ge.length-1]}var ye=function(e,t,n,i,r,o,a,s){this.tag=e,this.data=t,this.children=n,this.text=i,this.elm=r,this.ns=void 0,this.context=o,this.fnContext=void 0,this.fnOptions=void 0,this.fnScopeId=void 0,this.key=t&&t.key,this.componentOptions=a,this.componentInstance=void 0,this.parent=void 0,this.raw=!1,this.isStatic=!1,this.isRootInsert=!0,this.isComment=!1,this.isCloned=!1,this.isOnce=!1,this.asyncFactory=s,this.asyncMeta=void 0,this.isAsyncPlaceholder=!1},we={child:{configurable:!0}};we.child.get=function(){return this.componentInstance},Object.defineProperties(ye.prototype,we);var ke=function(e){void 0===e&&(e="");var t=new ye;return t.text=e,t.isComment=!0,t};function xe(e){return new ye(void 0,void 0,void 0,String(e))}function Se(e){var t=new ye(e.tag,e.data,e.children&&e.children.slice(),e.text,e.elm,e.context,e.componentOptions,e.asyncFactory);return t.ns=e.ns,t.isStatic=e.isStatic,t.key=e.key,t.isComment=e.isComment,t.fnContext=e.fnContext,t.fnOptions=e.fnOptions,t.fnScopeId=e.fnScopeId,t.asyncMeta=e.asyncMeta,t.isCloned=!0,t}var Ce=Array.prototype,Me=Object.create(Ce);["push","pop","shift","unshift","splice","sort","reverse"].forEach((function(e){var t=Ce[e];B(Me,e,(function(){for(var n=[],i=arguments.length;i--;)n[i]=arguments[i];var r,o=t.apply(this,n),a=this.__ob__;switch(e){case"push":case"unshift":r=n;break;case"splice":r=n.slice(2)}return r&&a.observeArray(r),a.dep.notify(),o}))}));var Te=Object.getOwnPropertyNames(Me),Ae=!0;function Pe(e){Ae=e}var Le=function(e){this.value=e,this.dep=new ve,this.vmCount=0,B(e,"__ob__",this),Array.isArray(e)?(W?function(e,t){e.__proto__=t}(e,Me):function(e,t,n){for(var i=0,r=n.length;i<r;i++){var o=n[i];B(e,o,t[o])}}(e,Me,Te),this.observeArray(e)):this.walk(e)};function Oe(e,t){var n;if(o(e)&&!(e instanceof ye))return b(e,"__ob__")&&e.__ob__ instanceof Le?n=e.__ob__:Ae&&!re()&&(Array.isArray(e)||l(e))&&Object.isExtensible(e)&&!e._isVue&&(n=new Le(e)),t&&n&&n.vmCount++,n}function qe(e,t,n,i,r){var o=new ve,a=Object.getOwnPropertyDescriptor(e,t);if(!a||!1!==a.configurable){var s=a&&a.get,l=a&&a.set;s&&!l||2!==arguments.length||(n=e[t]);var c=!r&&Oe(n);Object.defineProperty(e,t,{enumerable:!0,configurable:!0,get:function(){var t=s?s.call(e):n;return ve.target&&(o.depend(),c&&(c.dep.depend(),Array.isArray(t)&&ze(t))),t},set:function(t){var a=s?s.call(e):n;t===a||t!=t&&a!=a||(i&&i(),s&&!l||(l?l.call(e,t):n=t,c=!r&&Oe(t),o.notify()))}})}}function Ee(e,n,i){if((t(e)||r(e))&&ce("Cannot set reactive property on undefined, null, or primitive value: "+e),Array.isArray(e)&&u(n))return e.length=Math.max(e.length,n),e.splice(n,1,i),i;if(n in e&&!(n in Object.prototype))return e[n]=i,i;var o=e.__ob__;return e._isVue||o&&o.vmCount?(ce("Avoid adding reactive properties to a Vue instance or its root $data at runtime - declare it upfront in the data option."),i):o?(qe(o.value,n,i),o.dep.notify(),i):(e[n]=i,i)}function De(e,n){if((t(e)||r(e))&&ce("Cannot delete reactive property on undefined, null, or primitive value: "+e),Array.isArray(e)&&u(n))e.splice(n,1);else{var i=e.__ob__;e._isVue||i&&i.vmCount?ce("Avoid deleting properties on a Vue instance or its root $data - just set it to null."):b(e,n)&&(delete e[n],i&&i.dep.notify())}}function ze(e){for(var t=void 0,n=0,i=e.length;n<i;n++)(t=e[n])&&t.__ob__&&t.__ob__.dep.depend(),Array.isArray(t)&&ze(t)}Le.prototype.walk=function(e){for(var t=Object.keys(e),n=0;n<t.length;n++)qe(e,t[n])},Le.prototype.observeArray=function(e){for(var t=0,n=e.length;t<n;t++)Oe(e[t])};var Ne=I.optionMergeStrategies;function je(e,t){if(!t)return e;for(var n,i,r,o=le?Reflect.ownKeys(t):Object.keys(t),a=0;a<o.length;a++)"__ob__"!==(n=o[a])&&(i=e[n],r=t[n],b(e,n)?i!==r&&l(i)&&l(r)&&je(i,r):Ee(e,n,r));return e}function Re(e,t,n){return n?function(){var i="function"==typeof t?t.call(n,n):t,r="function"==typeof e?e.call(n,n):e;return i?je(i,r):r}:t?e?function(){return je("function"==typeof t?t.call(this,this):t,"function"==typeof e?e.call(this,this):e)}:t:e}function Ie(e,t){var n=t?e?e.concat(t):Array.isArray(t)?t:[t]:e;return n?function(e){for(var t=[],n=0;n<e.length;n++)-1===t.indexOf(e[n])&&t.push(e[n]);return t}(n):n}function $e(e,t,n,i){var r=Object.create(e||null);return t?(Ve(i,t,n),A(r,t)):r}Ne.el=Ne.propsData=function(e,t,n,i){return n||ce('option "'+i+'" can only be used during instance creation with the `new` keyword.'),Fe(e,t)},Ne.data=function(e,t,n){return n?Re(e,t,n):t&&"function"!=typeof t?(ce('The "data" option should be a function that returns a per-instance value in component definitions.',n),e):Re(e,t)},R.forEach((function(e){Ne[e]=Ie})),j.forEach((function(e){Ne[e+"s"]=$e})),Ne.watch=function(e,t,n,i){if(e===te&&(e=void 0),t===te&&(t=void 0),!t)return Object.create(e||null);if(Ve(i,t,n),!e)return t;var r={};for(var o in A(r,e),t){var a=r[o],s=t[o];a&&!Array.isArray(a)&&(a=[a]),r[o]=a?a.concat(s):Array.isArray(s)?s:[s]}return r},Ne.props=Ne.methods=Ne.inject=Ne.computed=function(e,t,n,i){if(t&&Ve(i,t,n),!e)return t;var r=Object.create(null);return A(r,e),t&&A(r,t),r},Ne.provide=Re;var Fe=function(e,t){return void 0===t?e:t};function Be(e){new RegExp("^[a-zA-Z][\\-\\.0-9_"+$.source+"]*$").test(e)||ce('Invalid component name: "'+e+'". Component names should conform to valid custom element name in html5 specification.'),(m(e)||I.isReservedTag(e))&&ce("Do not use built-in or reserved HTML elements as component id: "+e)}function Ve(e,t,n){l(t)||ce('Invalid value for option "'+e+'": expected an Object, but got '+s(t)+".",n)}function He(e,t,n){if(function(e){for(var t in e.components)Be(t)}(t),"function"==typeof t&&(t=t.options),function(e,t){var n=e.props;if(n){var i,r,o={};if(Array.isArray(n))for(i=n.length;i--;)"string"==typeof(r=n[i])?o[k(r)]={type:null}:ce("props must be strings when using array syntax.");else if(l(n))for(var a in n)r=n[a],o[k(a)]=l(r)?r:{type:r};else ce('Invalid value for option "props": expected an Array or an Object, but got '+s(n)+".",t);e.props=o}}(t,n),function(e,t){var n=e.inject;if(n){var i=e.inject={};if(Array.isArray(n))for(var r=0;r<n.length;r++)i[n[r]]={from:n[r]};else if(l(n))for(var o in n){var a=n[o];i[o]=l(a)?A({from:o},a):{from:a}}else ce('Invalid value for option "inject": expected an Array or an Object, but got '+s(n)+".",t)}}(t,n),function(e){var t=e.directives;if(t)for(var n in t){var i=t[n];"function"==typeof i&&(t[n]={bind:i,update:i})}}(t),!t._base&&(t.extends&&(e=He(e,t.extends,n)),t.mixins))for(var i=0,r=t.mixins.length;i<r;i++)e=He(e,t.mixins[i],n);var o,a={};for(o in e)c(o);for(o in t)b(e,o)||c(o);function c(i){var r=Ne[i]||Fe;a[i]=r(e[i],t[i],n,i)}return a}function We(e,t,n,i){if("string"==typeof n){var r=e[t];if(b(r,n))return r[n];var o=k(n);if(b(r,o))return r[o];var a=x(o);if(b(r,a))return r[a];var s=r[n]||r[o]||r[a];return i&&!s&&ce("Failed to resolve "+t.slice(0,-1)+": "+n,e),s}}function Ue(e,t,n,i){var r=t[e],a=!b(n,e),l=n[e],c=Ze(Boolean,r.type);if(c>-1)if(a&&!b(r,"default"))l=!1;else if(""===l||l===C(e)){var u=Ze(String,r.type);(u<0||c<u)&&(l=!0)}if(void 0===l){l=function(e,t,n){if(!b(t,"default"))return;var i=t.default;o(i)&&ce('Invalid default value for prop "'+n+'": Props with type Object/Array must use a factory function to return the default value.',e);if(e&&e.$options.propsData&&void 0===e.$options.propsData[n]&&void 0!==e._props[n])return e._props[n];return"function"==typeof i&&"Function"!==Qe(t.type)?i.call(e):i}(i,r,e);var d=Ae;Pe(!0),Oe(l),Pe(d)}return function(e,t,n,i,r){if(e.required&&r)return void ce('Missing required prop: "'+t+'"',i);if(null==n&&!e.required)return;var o=e.type,a=!o||!0===o,l=[];if(o){Array.isArray(o)||(o=[o]);for(var c=0;c<o.length&&!a;c++){var u=Ge(n,o[c]);l.push(u.expectedType||""),a=u.valid}}if(!a)return void ce(function(e,t,n){var i='Invalid prop: type check failed for prop "'+e+'". Expected '+n.map(x).join(", "),r=n[0],o=s(t),a=Je(t,r),l=Je(t,o);1===n.length&&Xe(r)&&!function(){var e=[],t=arguments.length;for(;t--;)e[t]=arguments[t];return e.some((function(e){return"boolean"===e.toLowerCase()}))}(r,o)&&(i+=" with value "+a);i+=", got "+o+" ",Xe(o)&&(i+="with value "+l+".");return i}(t,n,l),i);var d=e.validator;d&&(d(n)||ce('Invalid prop: custom validator check failed for prop "'+t+'".',i))}(r,e,l,i,a),l}var Ye=/^(String|Number|Boolean|Function|Symbol)$/;function Ge(e,t){var n,i=Qe(t);if(Ye.test(i)){var r=typeof e;(n=r===i.toLowerCase())||"object"!==r||(n=e instanceof t)}else n="Object"===i?l(e):"Array"===i?Array.isArray(e):e instanceof t;return{valid:n,expectedType:i}}function Qe(e){var t=e&&e.toString().match(/^\s*function (\w+)/);return t?t[1]:""}function Ke(e,t){return Qe(e)===Qe(t)}function Ze(e,t){if(!Array.isArray(t))return Ke(t,e)?0:-1;for(var n=0,i=t.length;n<i;n++)if(Ke(t[n],e))return n;return-1}function Je(e,t){return"String"===t?'"'+e+'"':"Number"===t?""+Number(e):""+e}function Xe(e){return["string","number","boolean"].some((function(t){return e.toLowerCase()===t}))}function et(e,t,n){_e();try{if(t)for(var i=t;i=i.$parent;){var r=i.$options.errorCaptured;if(r)for(var o=0;o<r.length;o++)try{if(!1===r[o].call(i,e,t,n))return}catch(e){nt(e,i,"errorCaptured hook")}}nt(e,t,n)}finally{be()}}function tt(e,t,n,i,r){var o;try{(o=n?e.apply(t,n):e.call(t))&&!o._isVue&&d(o)&&!o._handled&&(o.catch((function(e){return et(e,i,r+" (Promise/async)")})),o._handled=!0)}catch(e){et(e,i,r)}return o}function nt(e,t,n){if(I.errorHandler)try{return I.errorHandler.call(null,e,t,n)}catch(t){t!==e&&it(t,null,"config.errorHandler")}it(e,t,n)}function it(e,t,n){if(ce("Error in "+n+': "'+e.toString()+'"',t),!U&&!Y||"undefined"==typeof console)throw e;console.error(e)}var rt,ot,at,st=!1,lt=[],ct=!1;function ut(){ct=!1;var e=lt.slice(0);lt.length=0;for(var t=0;t<e.length;t++)e[t]()}if("undefined"!=typeof Promise&&ae(Promise)){var dt=Promise.resolve();rt=function(){dt.then(ut),X&&setTimeout(L)},st=!0}else if(K||"undefined"==typeof MutationObserver||!ae(MutationObserver)&&"[object MutationObserverConstructor]"!==MutationObserver.toString())rt="undefined"!=typeof setImmediate&&ae(setImmediate)?function(){setImmediate(ut)}:function(){setTimeout(ut,0)};else{var ht=1,ft=new MutationObserver(ut),pt=document.createTextNode(String(ht));ft.observe(pt,{characterData:!0}),rt=function(){ht=(ht+1)%2,pt.data=String(ht)},st=!0}function mt(e,t){var n;if(lt.push((function(){if(e)try{e.call(t)}catch(e){et(e,t,"nextTick")}else n&&n(t)})),ct||(ct=!0,rt()),!e&&"undefined"!=typeof Promise)return new Promise((function(e){n=e}))}var vt,gt=U&&window.performance;gt&&gt.mark&&gt.measure&&gt.clearMarks&&gt.clearMeasures&&(ot=function(e){return gt.mark(e)},at=function(e,t,n){gt.measure(e,t,n),gt.clearMarks(t),gt.clearMarks(n)});var _t=p("Infinity,undefined,NaN,isFinite,isNaN,parseFloat,parseInt,decodeURI,decodeURIComponent,encodeURI,encodeURIComponent,Math,Number,Date,Array,Object,Boolean,String,RegExp,Map,Set,JSON,Intl,require"),bt=function(e,t){ce('Property or method "'+t+'" is not defined on the instance but referenced during render. Make sure that this property is reactive, either in the data option, or for class-based components, by initializing the property. See: https://vuejs.org/v2/guide/reactivity.html#Declaring-Reactive-Properties.',e)},yt=function(e,t){ce('Property "'+t+'" must be accessed with "$data.'+t+'" because properties starting with "$" or "_" are not proxied in the Vue instance to prevent conflicts with Vue internals. See: https://vuejs.org/v2/api/#data',e)},wt="undefined"!=typeof Proxy&&ae(Proxy);if(wt){var kt=p("stop,prevent,self,ctrl,shift,alt,meta,exact");I.keyCodes=new Proxy(I.keyCodes,{set:function(e,t,n){return kt(t)?(ce("Avoid overwriting built-in modifier in config.keyCodes: ."+t),!1):(e[t]=n,!0)}})}var xt={has:function(e,t){var n=t in e,i=_t(t)||"string"==typeof t&&"_"===t.charAt(0)&&!(t in e.$data);return n||i||(t in e.$data?yt(e,t):bt(e,t)),n||!i}},St={get:function(e,t){return"string"!=typeof t||t in e||(t in e.$data?yt(e,t):bt(e,t)),e[t]}};vt=function(e){if(wt){var t=e.$options,n=t.render&&t.render._withStripped?St:xt;e._renderProxy=new Proxy(e,n)}else e._renderProxy=e};var Ct=new se;function Mt(e){Tt(e,Ct),Ct.clear()}function Tt(e,t){var n,i,r=Array.isArray(e);if(!(!r&&!o(e)||Object.isFrozen(e)||e instanceof ye)){if(e.__ob__){var a=e.__ob__.dep.id;if(t.has(a))return;t.add(a)}if(r)for(n=e.length;n--;)Tt(e[n],t);else for(n=(i=Object.keys(e)).length;n--;)Tt(e[i[n]],t)}}var At=y((function(e){var t="&"===e.charAt(0),n="~"===(e=t?e.slice(1):e).charAt(0),i="!"===(e=n?e.slice(1):e).charAt(0);return{name:e=i?e.slice(1):e,once:n,capture:i,passive:t}}));function Pt(e,t){function n(){var e=arguments,i=n.fns;if(!Array.isArray(i))return tt(i,null,arguments,t,"v-on handler");for(var r=i.slice(),o=0;o<r.length;o++)tt(r[o],null,e,t,"v-on handler")}return n.fns=e,n}function Lt(e,n,r,o,a,s){var l,c,u,d;for(l in e)c=e[l],u=n[l],d=At(l),t(c)?ce('Invalid handler for event "'+d.name+'": got '+String(c),s):t(u)?(t(c.fns)&&(c=e[l]=Pt(c,s)),i(d.once)&&(c=e[l]=a(d.name,c,d.capture)),r(d.name,c,d.capture,d.passive,d.params)):c!==u&&(u.fns=c,e[l]=u);for(l in n)t(e[l])&&o((d=At(l)).name,n[l],d.capture)}function Ot(e,r,o){var a;e instanceof ye&&(e=e.data.hook||(e.data.hook={}));var s=e[r];function l(){o.apply(this,arguments),g(a.fns,l)}t(s)?a=Pt([l]):n(s.fns)&&i(s.merged)?(a=s).fns.push(l):a=Pt([s,l]),a.merged=!0,e[r]=a}function qt(e,t,i,r,o){if(n(t)){if(b(t,i))return e[i]=t[i],o||delete t[i],!0;if(b(t,r))return e[i]=t[r],o||delete t[r],!0}return!1}function Et(e){return r(e)?[xe(e)]:Array.isArray(e)?zt(e):void 0}function Dt(e){return n(e)&&n(e.text)&&!1===e.isComment}function zt(e,o){var a,s,l,c,u=[];for(a=0;a<e.length;a++)t(s=e[a])||"boolean"==typeof s||(c=u[l=u.length-1],Array.isArray(s)?s.length>0&&(Dt((s=zt(s,(o||"")+"_"+a))[0])&&Dt(c)&&(u[l]=xe(c.text+s[0].text),s.shift()),u.push.apply(u,s)):r(s)?Dt(c)?u[l]=xe(c.text+s):""!==s&&u.push(xe(s)):Dt(s)&&Dt(c)?u[l]=xe(c.text+s.text):(i(e._isVList)&&n(s.tag)&&t(s.key)&&n(o)&&(s.key="__vlist"+o+"_"+a+"__"),u.push(s)));return u}function Nt(e,t){if(e){for(var n=Object.create(null),i=le?Reflect.ownKeys(e):Object.keys(e),r=0;r<i.length;r++){var o=i[r];if("__ob__"!==o){for(var a=e[o].from,s=t;s;){if(s._provided&&b(s._provided,a)){n[o]=s._provided[a];break}s=s.$parent}if(!s)if("default"in e[o]){var l=e[o].default;n[o]="function"==typeof l?l.call(t):l}else ce('Injection "'+o+'" not found',t)}}return n}}function jt(e,t){if(!e||!e.length)return{};for(var n={},i=0,r=e.length;i<r;i++){var o=e[i],a=o.data;if(a&&a.attrs&&a.attrs.slot&&delete a.attrs.slot,o.context!==t&&o.fnContext!==t||!a||null==a.slot)(n.default||(n.default=[])).push(o);else{var s=a.slot,l=n[s]||(n[s]=[]);"template"===o.tag?l.push.apply(l,o.children||[]):l.push(o)}}for(var c in n)n[c].every(Rt)&&delete n[c];return n}function Rt(e){return e.isComment&&!e.asyncFactory||" "===e.text}function It(t,n,i){var r,o=Object.keys(n).length>0,a=t?!!t.$stable:!o,s=t&&t.$key;if(t){if(t._normalized)return t._normalized;if(a&&i&&i!==e&&s===i.$key&&!o&&!i.$hasNormal)return i;for(var l in r={},t)t[l]&&"$"!==l[0]&&(r[l]=$t(n,l,t[l]))}else r={};for(var c in n)c in r||(r[c]=Ft(n,c));return t&&Object.isExtensible(t)&&(t._normalized=r),B(r,"$stable",a),B(r,"$key",s),B(r,"$hasNormal",o),r}function $t(e,t,n){var i=function(){var e=arguments.length?n.apply(null,arguments):n({});return(e=e&&"object"==typeof e&&!Array.isArray(e)?[e]:Et(e))&&(0===e.length||1===e.length&&e[0].isComment)?void 0:e};return n.proxy&&Object.defineProperty(e,t,{get:i,enumerable:!0,configurable:!0}),i}function Ft(e,t){return function(){return e[t]}}function Bt(e,t){var i,r,a,s,l;if(Array.isArray(e)||"string"==typeof e)for(i=new Array(e.length),r=0,a=e.length;r<a;r++)i[r]=t(e[r],r);else if("number"==typeof e)for(i=new Array(e),r=0;r<e;r++)i[r]=t(r+1,r);else if(o(e))if(le&&e[Symbol.iterator]){i=[];for(var c=e[Symbol.iterator](),u=c.next();!u.done;)i.push(t(u.value,i.length)),u=c.next()}else for(s=Object.keys(e),i=new Array(s.length),r=0,a=s.length;r<a;r++)l=s[r],i[r]=t(e[l],l,r);return n(i)||(i=[]),i._isVList=!0,i}function Vt(e,t,n,i){var r,a=this.$scopedSlots[e];a?(n=n||{},i&&(o(i)||ce("slot v-bind without argument expects an Object",this),n=A(A({},i),n)),r=a(n)||t):r=this.$slots[e]||t;var s=n&&n.slot;return s?this.$createElement("template",{slot:s},r):r}function Ht(e){return We(this.$options,"filters",e,!0)||q}function Wt(e,t){return Array.isArray(e)?-1===e.indexOf(t):e!==t}function Ut(e,t,n,i,r){var o=I.keyCodes[t]||n;return r&&i&&!I.keyCodes[t]?Wt(r,i):o?Wt(o,e):i?C(i)!==t:void 0}function Yt(e,t,n,i,r){if(n)if(o(n)){var a;Array.isArray(n)&&(n=P(n));var s=function(o){if("class"===o||"style"===o||v(o))a=e;else{var s=e.attrs&&e.attrs.type;a=i||I.mustUseProp(t,s,o)?e.domProps||(e.domProps={}):e.attrs||(e.attrs={})}var l=k(o),c=C(o);l in a||c in a||(a[o]=n[o],r&&((e.on||(e.on={}))["update:"+o]=function(e){n[o]=e}))};for(var l in n)s(l)}else ce("v-bind without argument expects an Object or Array value",this);return e}function Gt(e,t){var n=this._staticTrees||(this._staticTrees=[]),i=n[e];return i&&!t||Kt(i=n[e]=this.$options.staticRenderFns[e].call(this._renderProxy,null,this),"__static__"+e,!1),i}function Qt(e,t,n){return Kt(e,"__once__"+t+(n?"_"+n:""),!0),e}function Kt(e,t,n){if(Array.isArray(e))for(var i=0;i<e.length;i++)e[i]&&"string"!=typeof e[i]&&Zt(e[i],t+"_"+i,n);else Zt(e,t,n)}function Zt(e,t,n){e.isStatic=!0,e.key=t,e.isOnce=n}function Jt(e,t){if(t)if(l(t)){var n=e.on=e.on?A({},e.on):{};for(var i in t){var r=n[i],o=t[i];n[i]=r?[].concat(r,o):o}}else ce("v-on without argument expects an Object value",this);return e}function Xt(e,t,n,i){t=t||{$stable:!n};for(var r=0;r<e.length;r++){var o=e[r];Array.isArray(o)?Xt(o,t,n):o&&(o.proxy&&(o.fn.proxy=!0),t[o.key]=o.fn)}return i&&(t.$key=i),t}function en(e,t){for(var n=0;n<t.length;n+=2){var i=t[n];"string"==typeof i&&i?e[t[n]]=t[n+1]:""!==i&&null!==i&&ce("Invalid value for dynamic directive argument (expected string or null): "+i,this)}return e}function tn(e,t){return"string"==typeof e?t+e:e}function nn(e){e._o=Qt,e._n=f,e._s=h,e._l=Bt,e._t=Vt,e._q=E,e._i=D,e._m=Gt,e._f=Ht,e._k=Ut,e._b=Yt,e._v=xe,e._e=ke,e._u=Xt,e._g=Jt,e._d=en,e._p=tn}function rn(t,n,r,o,a){var s,l=this,c=a.options;b(o,"_uid")?(s=Object.create(o))._original=o:(s=o,o=o._original);var u=i(c._compiled),d=!u;this.data=t,this.props=n,this.children=r,this.parent=o,this.listeners=t.on||e,this.injections=Nt(c.inject,o),this.slots=function(){return l.$slots||It(t.scopedSlots,l.$slots=jt(r,o)),l.$slots},Object.defineProperty(this,"scopedSlots",{enumerable:!0,get:function(){return It(t.scopedSlots,this.slots())}}),u&&(this.$options=c,this.$slots=this.slots(),this.$scopedSlots=It(t.scopedSlots,this.$slots)),c._scopeId?this._c=function(e,t,n,i){var r=fn(s,e,t,n,i,d);return r&&!Array.isArray(r)&&(r.fnScopeId=c._scopeId,r.fnContext=o),r}:this._c=function(e,t,n,i){return fn(s,e,t,n,i,d)}}function on(e,t,n,i,r){var o=Se(e);return o.fnContext=n,o.fnOptions=i,(o.devtoolsMeta=o.devtoolsMeta||{}).renderContext=r,t.slot&&((o.data||(o.data={})).slot=t.slot),o}function an(e,t){for(var n in t)e[k(n)]=t[n]}nn(rn.prototype);var sn={init:function(e,t){if(e.componentInstance&&!e.componentInstance._isDestroyed&&e.data.keepAlive){var i=e;sn.prepatch(i,i)}else{(e.componentInstance=function(e,t){var i={_isComponent:!0,_parentVnode:e,parent:t},r=e.data.inlineTemplate;n(r)&&(i.render=r.render,i.staticRenderFns=r.staticRenderFns);return new e.componentOptions.Ctor(i)}(e,Sn)).$mount(t?e.elm:void 0,t)}},prepatch:function(t,n){var i=n.componentOptions;!function(t,n,i,r,o){Cn=!0;var a=r.data.scopedSlots,s=t.$scopedSlots,l=!!(a&&!a.$stable||s!==e&&!s.$stable||a&&t.$scopedSlots.$key!==a.$key),c=!!(o||t.$options._renderChildren||l);t.$options._parentVnode=r,t.$vnode=r,t._vnode&&(t._vnode.parent=r);if(t.$options._renderChildren=o,t.$attrs=r.data.attrs||e,t.$listeners=i||e,n&&t.$options.props){Pe(!1);for(var u=t._props,d=t.$options._propKeys||[],h=0;h<d.length;h++){var f=d[h],p=t.$options.props;u[f]=Ue(f,p,n,t)}Pe(!0),t.$options.propsData=n}i=i||e;var m=t.$options._parentListeners;t.$options._parentListeners=i,xn(t,i,m),c&&(t.$slots=jt(o,r.context),t.$forceUpdate());Cn=!1}(n.componentInstance=t.componentInstance,i.propsData,i.listeners,n,i.children)},insert:function(e){var t,n=e.context,i=e.componentInstance;i._isMounted||(i._isMounted=!0,Ln(i,"mounted")),e.data.keepAlive&&(n._isMounted?((t=i)._inactive=!1,En.push(t)):An(i,!0))},destroy:function(e){var t=e.componentInstance;t._isDestroyed||(e.data.keepAlive?Pn(t,!0):t.$destroy())}},ln=Object.keys(sn);function cn(r,a,s,l,c){if(!t(r)){var u=s.$options._base;if(o(r)&&(r=u.extend(r)),"function"==typeof r){var h;if(t(r.cid)&&(r=function(e,r){if(i(e.error)&&n(e.errorComp))return e.errorComp;if(n(e.resolved))return e.resolved;var a=vn;a&&n(e.owners)&&-1===e.owners.indexOf(a)&&e.owners.push(a);if(i(e.loading)&&n(e.loadingComp))return e.loadingComp;if(a&&!n(e.owners)){var s=e.owners=[a],l=!0,c=null,u=null;a.$on("hook:destroyed",(function(){return g(s,a)}));var h=function(e){for(var t=0,n=s.length;t<n;t++)s[t].$forceUpdate();e&&(s.length=0,null!==c&&(clearTimeout(c),c=null),null!==u&&(clearTimeout(u),u=null))},f=z((function(t){e.resolved=gn(t,r),l?s.length=0:h(!0)})),p=z((function(t){ce("Failed to resolve async component: "+String(e)+(t?"\nReason: "+t:"")),n(e.errorComp)&&(e.error=!0,h(!0))})),m=e(f,p);return o(m)&&(d(m)?t(e.resolved)&&m.then(f,p):d(m.component)&&(m.component.then(f,p),n(m.error)&&(e.errorComp=gn(m.error,r)),n(m.loading)&&(e.loadingComp=gn(m.loading,r),0===m.delay?e.loading=!0:c=setTimeout((function(){c=null,t(e.resolved)&&t(e.error)&&(e.loading=!0,h(!1))}),m.delay||200)),n(m.timeout)&&(u=setTimeout((function(){u=null,t(e.resolved)&&p("timeout ("+m.timeout+"ms)")}),m.timeout)))),l=!1,e.loading?e.loadingComp:e.resolved}}(h=r,u),void 0===r))return function(e,t,n,i,r){var o=ke();return o.asyncFactory=e,o.asyncMeta={data:t,context:n,children:i,tag:r},o}(h,a,s,l,c);a=a||{},ei(r),n(a.model)&&function(e,t){var i=e.model&&e.model.prop||"value",r=e.model&&e.model.event||"input";(t.attrs||(t.attrs={}))[i]=t.model.value;var o=t.on||(t.on={}),a=o[r],s=t.model.callback;n(a)?(Array.isArray(a)?-1===a.indexOf(s):a!==s)&&(o[r]=[s].concat(a)):o[r]=s}(r.options,a);var f=function(e,i,r){var o=i.options.props;if(!t(o)){var a={},s=e.attrs,l=e.props;if(n(s)||n(l))for(var c in o){var u=C(c),d=c.toLowerCase();c!==d&&s&&b(s,d)&&ue('Prop "'+d+'" is passed to component '+he(r||i)+', but the declared prop name is "'+c+'". Note that HTML attributes are case-insensitive and camelCased props need to use their kebab-case equivalents when using in-DOM templates. You should probably use "'+u+'" instead of "'+c+'".'),qt(a,l,c,u,!0)||qt(a,s,c,u,!1)}return a}}(a,r,c);if(i(r.options.functional))return function(t,i,r,o,a){var s=t.options,l={},c=s.props;if(n(c))for(var u in c)l[u]=Ue(u,c,i||e);else n(r.attrs)&&an(l,r.attrs),n(r.props)&&an(l,r.props);var d=new rn(r,l,a,o,t),h=s.render.call(null,d._c,d);if(h instanceof ye)return on(h,r,d.parent,s,d);if(Array.isArray(h)){for(var f=Et(h)||[],p=new Array(f.length),m=0;m<f.length;m++)p[m]=on(f[m],r,d.parent,s,d);return p}}(r,f,a,s,l);var p=a.on;if(a.on=a.nativeOn,i(r.options.abstract)){var m=a.slot;a={},m&&(a.slot=m)}!function(e){for(var t=e.hook||(e.hook={}),n=0;n<ln.length;n++){var i=ln[n],r=t[i],o=sn[i];r===o||r&&r._merged||(t[i]=r?un(o,r):o)}}(a);var v=r.options.name||c;return new ye("vue-component-"+r.cid+(v?"-"+v:""),a,void 0,void 0,void 0,s,{Ctor:r,propsData:f,listeners:p,tag:c,children:l},h)}ce("Invalid Component definition: "+String(r),s)}}function un(e,t){var n=function(n,i){e(n,i),t(n,i)};return n._merged=!0,n}var dn=1,hn=2;function fn(e,t,a,s,l,c){return(Array.isArray(a)||r(a))&&(l=s,s=a,a=void 0),i(c)&&(l=hn),function(e,t,i,a,s){if(n(i)&&n(i.__ob__))return ce("Avoid using observed data object as vnode data: "+JSON.stringify(i)+"\nAlways create fresh vnode data objects in each render!",e),ke();n(i)&&n(i.is)&&(t=i.is);if(!t)return ke();n(i)&&n(i.key)&&!r(i.key)&&ce("Avoid using non-primitive value as key, use string/number value instead.",e);Array.isArray(a)&&"function"==typeof a[0]&&((i=i||{}).scopedSlots={default:a[0]},a.length=0);s===hn?a=Et(a):s===dn&&(a=function(e){for(var t=0;t<e.length;t++)if(Array.isArray(e[t]))return Array.prototype.concat.apply([],e);return e}(a));var l,c;if("string"==typeof t){var u;c=e.$vnode&&e.$vnode.ns||I.getTagNamespace(t),I.isReservedTag(t)?(n(i)&&n(i.nativeOn)&&ce("The .native modifier for v-on is only valid on components but it was used on <"+t+">.",e),l=new ye(I.parsePlatformTagName(t),i,a,void 0,void 0,e)):l=i&&i.pre||!n(u=We(e.$options,"components",t))?new ye(t,i,a,void 0,void 0,e):cn(u,i,e,a,t)}else l=cn(t,i,e,a);return Array.isArray(l)?l:n(l)?(n(c)&&pn(l,c),n(i)&&function(e){o(e.style)&&Mt(e.style);o(e.class)&&Mt(e.class)}(i),l):ke()}(e,t,a,s,l)}function pn(e,r,o){if(e.ns=r,"foreignObject"===e.tag&&(r=void 0,o=!0),n(e.children))for(var a=0,s=e.children.length;a<s;a++){var l=e.children[a];n(l.tag)&&(t(l.ns)||i(o)&&"svg"!==l.tag)&&pn(l,r,o)}}var mn,vn=null;function gn(e,t){return(e.__esModule||le&&"Module"===e[Symbol.toStringTag])&&(e=e.default),o(e)?t.extend(e):e}function _n(e){return e.isComment&&e.asyncFactory}function bn(e){if(Array.isArray(e))for(var t=0;t<e.length;t++){var i=e[t];if(n(i)&&(n(i.componentOptions)||_n(i)))return i}}function yn(e,t){mn.$on(e,t)}function wn(e,t){mn.$off(e,t)}function kn(e,t){var n=mn;return function i(){null!==t.apply(null,arguments)&&n.$off(e,i)}}function xn(e,t,n){mn=e,Lt(t,n||{},yn,wn,kn,e),mn=void 0}var Sn=null,Cn=!1;function Mn(e){var t=Sn;return Sn=e,function(){Sn=t}}function Tn(e){for(;e&&(e=e.$parent);)if(e._inactive)return!0;return!1}function An(e,t){if(t){if(e._directInactive=!1,Tn(e))return}else if(e._directInactive)return;if(e._inactive||null===e._inactive){e._inactive=!1;for(var n=0;n<e.$children.length;n++)An(e.$children[n]);Ln(e,"activated")}}function Pn(e,t){if(!(t&&(e._directInactive=!0,Tn(e))||e._inactive)){e._inactive=!0;for(var n=0;n<e.$children.length;n++)Pn(e.$children[n]);Ln(e,"deactivated")}}function Ln(e,t){_e();var n=e.$options[t],i=t+" hook";if(n)for(var r=0,o=n.length;r<o;r++)tt(n[r],e,null,e,i);e._hasHookEvent&&e.$emit("hook:"+t),be()}var On=100,qn=[],En=[],Dn={},zn={},Nn=!1,jn=!1,Rn=0;var In=0,$n=Date.now;if(U&&!K){var Fn=window.performance;Fn&&"function"==typeof Fn.now&&$n()>document.createEvent("Event").timeStamp&&($n=function(){return Fn.now()})}function Bn(){var e,t;for(In=$n(),jn=!0,qn.sort((function(e,t){return e.id-t.id})),Rn=0;Rn<qn.length;Rn++)if((e=qn[Rn]).before&&e.before(),t=e.id,Dn[t]=null,e.run(),null!=Dn[t]&&(zn[t]=(zn[t]||0)+1,zn[t]>On)){ce("You may have an infinite update loop "+(e.user?'in watcher with expression "'+e.expression+'"':"in a component render function."),e.vm);break}var n=En.slice(),i=qn.slice();Rn=qn.length=En.length=0,Dn={},zn={},Nn=jn=!1,function(e){for(var t=0;t<e.length;t++)e[t]._inactive=!0,An(e[t],!0)}(n),function(e){var t=e.length;for(;t--;){var n=e[t],i=n.vm;i._watcher===n&&i._isMounted&&!i._isDestroyed&&Ln(i,"updated")}}(i),oe&&I.devtools&&oe.emit("flush")}var Vn=0,Hn=function(e,t,n,i,r){this.vm=e,r&&(e._watcher=this),e._watchers.push(this),i?(this.deep=!!i.deep,this.user=!!i.user,this.lazy=!!i.lazy,this.sync=!!i.sync,this.before=i.before):this.deep=this.user=this.lazy=this.sync=!1,this.cb=n,this.id=++Vn,this.active=!0,this.dirty=this.lazy,this.deps=[],this.newDeps=[],this.depIds=new se,this.newDepIds=new se,this.expression=t.toString(),"function"==typeof t?this.getter=t:(this.getter=function(e){if(!V.test(e)){var t=e.split(".");return function(e){for(var n=0;n<t.length;n++){if(!e)return;e=e[t[n]]}return e}}}(t),this.getter||(this.getter=L,ce('Failed watching path: "'+t+'" Watcher only accepts simple dot-delimited paths. For full control, use a function instead.',e))),this.value=this.lazy?void 0:this.get()};Hn.prototype.get=function(){var e;_e(this);var t=this.vm;try{e=this.getter.call(t,t)}catch(e){if(!this.user)throw e;et(e,t,'getter for watcher "'+this.expression+'"')}finally{this.deep&&Mt(e),be(),this.cleanupDeps()}return e},Hn.prototype.addDep=function(e){var t=e.id;this.newDepIds.has(t)||(this.newDepIds.add(t),this.newDeps.push(e),this.depIds.has(t)||e.addSub(this))},Hn.prototype.cleanupDeps=function(){for(var e=this.deps.length;e--;){var t=this.deps[e];this.newDepIds.has(t.id)||t.removeSub(this)}var n=this.depIds;this.depIds=this.newDepIds,this.newDepIds=n,this.newDepIds.clear(),n=this.deps,this.deps=this.newDeps,this.newDeps=n,this.newDeps.length=0},Hn.prototype.update=function(){this.lazy?this.dirty=!0:this.sync?this.run():function(e){var t=e.id;if(null==Dn[t]){if(Dn[t]=!0,jn){for(var n=qn.length-1;n>Rn&&qn[n].id>e.id;)n--;qn.splice(n+1,0,e)}else qn.push(e);if(!Nn){if(Nn=!0,!I.async)return void Bn();mt(Bn)}}}(this)},Hn.prototype.run=function(){if(this.active){var e=this.get();if(e!==this.value||o(e)||this.deep){var t=this.value;if(this.value=e,this.user)try{this.cb.call(this.vm,e,t)}catch(e){et(e,this.vm,'callback for watcher "'+this.expression+'"')}else this.cb.call(this.vm,e,t)}}},Hn.prototype.evaluate=function(){this.value=this.get(),this.dirty=!1},Hn.prototype.depend=function(){for(var e=this.deps.length;e--;)this.deps[e].depend()},Hn.prototype.teardown=function(){if(this.active){this.vm._isBeingDestroyed||g(this.vm._watchers,this);for(var e=this.deps.length;e--;)this.deps[e].removeSub(this);this.active=!1}};var Wn={enumerable:!0,configurable:!0,get:L,set:L};function Un(e,t,n){Wn.get=function(){return this[t][n]},Wn.set=function(e){this[t][n]=e},Object.defineProperty(e,n,Wn)}function Yn(e){e._watchers=[];var t=e.$options;t.props&&function(e,t){var n=e.$options.propsData||{},i=e._props={},r=e.$options._propKeys=[],o=!e.$parent;o||Pe(!1);var a=function(a){r.push(a);var s=Ue(a,t,n,e),l=C(a);(v(l)||I.isReservedAttr(l))&&ce('"'+l+'" is a reserved attribute and cannot be used as component prop.',e),qe(i,a,s,(function(){o||Cn||ce("Avoid mutating a prop directly since the value will be overwritten whenever the parent component re-renders. Instead, use a data or computed property based on the prop's value. Prop being mutated: \""+a+'"',e)})),a in e||Un(e,"_props",a)};for(var s in t)a(s);Pe(!0)}(e,t.props),t.methods&&function(e,t){var n=e.$options.props;for(var i in t)"function"!=typeof t[i]&&ce('Method "'+i+'" has type "'+typeof t[i]+'" in the component definition. Did you reference the function correctly?',e),n&&b(n,i)&&ce('Method "'+i+'" has already been defined as a prop.',e),i in e&&F(i)&&ce('Method "'+i+'" conflicts with an existing Vue instance method. Avoid defining component methods that start with _ or $.'),e[i]="function"!=typeof t[i]?L:M(t[i],e)}(e,t.methods),t.data?function(e){var t=e.$options.data;t=e._data="function"==typeof t?function(e,t){_e();try{return e.call(t,t)}catch(e){return et(e,t,"data()"),{}}finally{be()}}(t,e):t||{},l(t)||(t={},ce("data functions should return an object:\nhttps://vuejs.org/v2/guide/components.html#data-Must-Be-a-Function",e));var n=Object.keys(t),i=e.$options.props,r=e.$options.methods,o=n.length;for(;o--;){var a=n[o];r&&b(r,a)&&ce('Method "'+a+'" has already been defined as a data property.',e),i&&b(i,a)?ce('The data property "'+a+'" is already declared as a prop. Use prop default value instead.',e):F(a)||Un(e,"_data",a)}Oe(t,!0)}(e):Oe(e._data={},!0),t.computed&&function(e,t){var n=e._computedWatchers=Object.create(null),i=re();for(var r in t){var o=t[r],a="function"==typeof o?o:o.get;null==a&&ce('Getter is missing for computed property "'+r+'".',e),i||(n[r]=new Hn(e,a||L,L,Gn)),r in e?r in e.$data?ce('The computed property "'+r+'" is already defined in data.',e):e.$options.props&&r in e.$options.props&&ce('The computed property "'+r+'" is already defined as a prop.',e):Qn(e,r,o)}}(e,t.computed),t.watch&&t.watch!==te&&function(e,t){for(var n in t){var i=t[n];if(Array.isArray(i))for(var r=0;r<i.length;r++)Jn(e,n,i[r]);else Jn(e,n,i)}}(e,t.watch)}var Gn={lazy:!0};function Qn(e,t,n){var i=!re();"function"==typeof n?(Wn.get=i?Kn(t):Zn(n),Wn.set=L):(Wn.get=n.get?i&&!1!==n.cache?Kn(t):Zn(n.get):L,Wn.set=n.set||L),Wn.set===L&&(Wn.set=function(){ce('Computed property "'+t+'" was assigned to but it has no setter.',this)}),Object.defineProperty(e,t,Wn)}function Kn(e){return function(){var t=this._computedWatchers&&this._computedWatchers[e];if(t)return t.dirty&&t.evaluate(),ve.target&&t.depend(),t.value}}function Zn(e){return function(){return e.call(this,this)}}function Jn(e,t,n,i){return l(n)&&(i=n,n=n.handler),"string"==typeof n&&(n=e[n]),e.$watch(t,n,i)}var Xn=0;function ei(e){var t=e.options;if(e.super){var n=ei(e.super);if(n!==e.superOptions){e.superOptions=n;var i=function(e){var t,n=e.options,i=e.sealedOptions;for(var r in n)n[r]!==i[r]&&(t||(t={}),t[r]=n[r]);return t}(e);i&&A(e.extendOptions,i),(t=e.options=He(n,e.extendOptions)).name&&(t.components[t.name]=e)}}return t}function ti(e){this instanceof ti||ce("Vue is a constructor and should be called with the `new` keyword"),this._init(e)}function ni(e){e.cid=0;var t=1;e.extend=function(e){e=e||{};var n=this,i=n.cid,r=e._Ctor||(e._Ctor={});if(r[i])return r[i];var o=e.name||n.options.name;o&&Be(o);var a=function(e){this._init(e)};return(a.prototype=Object.create(n.prototype)).constructor=a,a.cid=t++,a.options=He(n.options,e),a.super=n,a.options.props&&function(e){var t=e.options.props;for(var n in t)Un(e.prototype,"_props",n)}(a),a.options.computed&&function(e){var t=e.options.computed;for(var n in t)Qn(e.prototype,n,t[n])}(a),a.extend=n.extend,a.mixin=n.mixin,a.use=n.use,j.forEach((function(e){a[e]=n[e]})),o&&(a.options.components[o]=a),a.superOptions=n.options,a.extendOptions=e,a.sealedOptions=A({},a.options),r[i]=a,a}}function ii(e){return e&&(e.Ctor.options.name||e.tag)}function ri(e,t){return Array.isArray(e)?e.indexOf(t)>-1:"string"==typeof e?e.split(",").indexOf(t)>-1:!!c(e)&&e.test(t)}function oi(e,t){var n=e.cache,i=e.keys,r=e._vnode;for(var o in n){var a=n[o];if(a){var s=ii(a.componentOptions);s&&!t(s)&&ai(n,o,i,r)}}}function ai(e,t,n,i){var r=e[t];!r||i&&r.tag===i.tag||r.componentInstance.$destroy(),e[t]=null,g(n,t)}!function(t){t.prototype._init=function(t){var n,i,r=this;r._uid=Xn++,I.performance&&ot&&(n="vue-perf-start:"+r._uid,i="vue-perf-end:"+r._uid,ot(n)),r._isVue=!0,t&&t._isComponent?function(e,t){var n=e.$options=Object.create(e.constructor.options),i=t._parentVnode;n.parent=t.parent,n._parentVnode=i;var r=i.componentOptions;n.propsData=r.propsData,n._parentListeners=r.listeners,n._renderChildren=r.children,n._componentTag=r.tag,t.render&&(n.render=t.render,n.staticRenderFns=t.staticRenderFns)}(r,t):r.$options=He(ei(r.constructor),t||{},r),vt(r),r._self=r,function(e){var t=e.$options,n=t.parent;if(n&&!t.abstract){for(;n.$options.abstract&&n.$parent;)n=n.$parent;n.$children.push(e)}e.$parent=n,e.$root=n?n.$root:e,e.$children=[],e.$refs={},e._watcher=null,e._inactive=null,e._directInactive=!1,e._isMounted=!1,e._isDestroyed=!1,e._isBeingDestroyed=!1}(r),function(e){e._events=Object.create(null),e._hasHookEvent=!1;var t=e.$options._parentListeners;t&&xn(e,t)}(r),function(t){t._vnode=null,t._staticTrees=null;var n=t.$options,i=t.$vnode=n._parentVnode,r=i&&i.context;t.$slots=jt(n._renderChildren,r),t.$scopedSlots=e,t._c=function(e,n,i,r){return fn(t,e,n,i,r,!1)},t.$createElement=function(e,n,i,r){return fn(t,e,n,i,r,!0)};var o=i&&i.data;qe(t,"$attrs",o&&o.attrs||e,(function(){!Cn&&ce("$attrs is readonly.",t)}),!0),qe(t,"$listeners",n._parentListeners||e,(function(){!Cn&&ce("$listeners is readonly.",t)}),!0)}(r),Ln(r,"beforeCreate"),function(e){var t=Nt(e.$options.inject,e);t&&(Pe(!1),Object.keys(t).forEach((function(n){qe(e,n,t[n],(function(){ce('Avoid mutating an injected value directly since the changes will be overwritten whenever the provided component re-renders. injection being mutated: "'+n+'"',e)}))})),Pe(!0))}(r),Yn(r),function(e){var t=e.$options.provide;t&&(e._provided="function"==typeof t?t.call(e):t)}(r),Ln(r,"created"),I.performance&&ot&&(r._name=he(r,!1),ot(i),at("vue "+r._name+" init",n,i)),r.$options.el&&r.$mount(r.$options.el)}}(ti),function(e){var t={get:function(){return this._data}},n={get:function(){return this._props}};t.set=function(){ce("Avoid replacing instance root $data. Use nested data properties instead.",this)},n.set=function(){ce("$props is readonly.",this)},Object.defineProperty(e.prototype,"$data",t),Object.defineProperty(e.prototype,"$props",n),e.prototype.$set=Ee,e.prototype.$delete=De,e.prototype.$watch=function(e,t,n){var i=this;if(l(t))return Jn(i,e,t,n);(n=n||{}).user=!0;var r=new Hn(i,e,t,n);if(n.immediate)try{t.call(i,r.value)}catch(e){et(e,i,'callback for immediate watcher "'+r.expression+'"')}return function(){r.teardown()}}}(ti),function(e){var t=/^hook:/;e.prototype.$on=function(e,n){var i=this;if(Array.isArray(e))for(var r=0,o=e.length;r<o;r++)i.$on(e[r],n);else(i._events[e]||(i._events[e]=[])).push(n),t.test(e)&&(i._hasHookEvent=!0);return i},e.prototype.$once=function(e,t){var n=this;function i(){n.$off(e,i),t.apply(n,arguments)}return i.fn=t,n.$on(e,i),n},e.prototype.$off=function(e,t){var n=this;if(!arguments.length)return n._events=Object.create(null),n;if(Array.isArray(e)){for(var i=0,r=e.length;i<r;i++)n.$off(e[i],t);return n}var o,a=n._events[e];if(!a)return n;if(!t)return n._events[e]=null,n;for(var s=a.length;s--;)if((o=a[s])===t||o.fn===t){a.splice(s,1);break}return n},e.prototype.$emit=function(e){var t=this,n=e.toLowerCase();n!==e&&t._events[n]&&ue('Event "'+n+'" is emitted in component '+he(t)+' but the handler is registered for "'+e+'". Note that HTML attributes are case-insensitive and you cannot use v-on to listen to camelCase events when using in-DOM templates. You should probably use "'+C(e)+'" instead of "'+e+'".');var i=t._events[e];if(i){i=i.length>1?T(i):i;for(var r=T(arguments,1),o='event handler for "'+e+'"',a=0,s=i.length;a<s;a++)tt(i[a],t,r,t,o)}return t}}(ti),function(e){e.prototype._update=function(e,t){var n=this,i=n.$el,r=n._vnode,o=Mn(n);n._vnode=e,n.$el=r?n.__patch__(r,e):n.__patch__(n.$el,e,t,!1),o(),i&&(i.__vue__=null),n.$el&&(n.$el.__vue__=n),n.$vnode&&n.$parent&&n.$vnode===n.$parent._vnode&&(n.$parent.$el=n.$el)},e.prototype.$forceUpdate=function(){this._watcher&&this._watcher.update()},e.prototype.$destroy=function(){var e=this;if(!e._isBeingDestroyed){Ln(e,"beforeDestroy"),e._isBeingDestroyed=!0;var t=e.$parent;!t||t._isBeingDestroyed||e.$options.abstract||g(t.$children,e),e._watcher&&e._watcher.teardown();for(var n=e._watchers.length;n--;)e._watchers[n].teardown();e._data.__ob__&&e._data.__ob__.vmCount--,e._isDestroyed=!0,e.__patch__(e._vnode,null),Ln(e,"destroyed"),e.$off(),e.$el&&(e.$el.__vue__=null),e.$vnode&&(e.$vnode.parent=null)}}}(ti),function(e){nn(e.prototype),e.prototype.$nextTick=function(e){return mt(e,this)},e.prototype._render=function(){var e,t=this,n=t.$options,i=n.render,r=n._parentVnode;r&&(t.$scopedSlots=It(r.data.scopedSlots,t.$slots,t.$scopedSlots)),t.$vnode=r;try{vn=t,e=i.call(t._renderProxy,t.$createElement)}catch(n){if(et(n,t,"render"),t.$options.renderError)try{e=t.$options.renderError.call(t._renderProxy,t.$createElement,n)}catch(n){et(n,t,"renderError"),e=t._vnode}else e=t._vnode}finally{vn=null}return Array.isArray(e)&&1===e.length&&(e=e[0]),e instanceof ye||(Array.isArray(e)&&ce("Multiple root nodes returned from render function. Render function should return a single root node.",t),e=ke()),e.parent=r,e}}(ti);var si=[String,RegExp,Array],li={KeepAlive:{name:"keep-alive",abstract:!0,props:{include:si,exclude:si,max:[String,Number]},created:function(){this.cache=Object.create(null),this.keys=[]},destroyed:function(){for(var e in this.cache)ai(this.cache,e,this.keys)},mounted:function(){var e=this;this.$watch("include",(function(t){oi(e,(function(e){return ri(t,e)}))})),this.$watch("exclude",(function(t){oi(e,(function(e){return!ri(t,e)}))}))},render:function(){var e=this.$slots.default,t=bn(e),n=t&&t.componentOptions;if(n){var i=ii(n),r=this.include,o=this.exclude;if(r&&(!i||!ri(r,i))||o&&i&&ri(o,i))return t;var a=this.cache,s=this.keys,l=null==t.key?n.Ctor.cid+(n.tag?"::"+n.tag:""):t.key;a[l]?(t.componentInstance=a[l].componentInstance,g(s,l),s.push(l)):(a[l]=t,s.push(l),this.max&&s.length>parseInt(this.max)&&ai(a,s[0],s,this._vnode)),t.data.keepAlive=!0}return t||e&&e[0]}}};!function(e){var t={get:function(){return I},set:function(){ce("Do not replace the Vue.config object, set individual fields instead.")}};Object.defineProperty(e,"config",t),e.util={warn:ce,extend:A,mergeOptions:He,defineReactive:qe},e.set=Ee,e.delete=De,e.nextTick=mt,e.observable=function(e){return Oe(e),e},e.options=Object.create(null),j.forEach((function(t){e.options[t+"s"]=Object.create(null)})),e.options._base=e,A(e.options.components,li),function(e){e.use=function(e){var t=this._installedPlugins||(this._installedPlugins=[]);if(t.indexOf(e)>-1)return this;var n=T(arguments,1);return n.unshift(this),"function"==typeof e.install?e.install.apply(e,n):"function"==typeof e&&e.apply(null,n),t.push(e),this}}(e),function(e){e.mixin=function(e){return this.options=He(this.options,e),this}}(e),ni(e),function(e){j.forEach((function(t){e[t]=function(e,n){return n?("component"===t&&Be(e),"component"===t&&l(n)&&(n.name=n.name||e,n=this.options._base.extend(n)),"directive"===t&&"function"==typeof n&&(n={bind:n,update:n}),this.options[t+"s"][e]=n,n):this.options[t+"s"][e]}}))}(e)}(ti),Object.defineProperty(ti.prototype,"$isServer",{get:re}),Object.defineProperty(ti.prototype,"$ssrContext",{get:function(){return this.$vnode&&this.$vnode.ssrContext}}),Object.defineProperty(ti,"FunctionalRenderContext",{value:rn}),ti.version="2.6.12";var ci=p("style,class"),ui=p("input,textarea,option,select,progress"),di=function(e,t,n){return"value"===n&&ui(e)&&"button"!==t||"selected"===n&&"option"===e||"checked"===n&&"input"===e||"muted"===n&&"video"===e},hi=p("contenteditable,draggable,spellcheck"),fi=p("events,caret,typing,plaintext-only"),pi=function(e,t){return bi(t)||"false"===t?"false":"contenteditable"===e&&fi(t)?t:"true"},mi=p("allowfullscreen,async,autofocus,autoplay,checked,compact,controls,declare,default,defaultchecked,defaultmuted,defaultselected,defer,disabled,enabled,formnovalidate,hidden,indeterminate,inert,ismap,itemscope,loop,multiple,muted,nohref,noresize,noshade,novalidate,nowrap,open,pauseonexit,readonly,required,reversed,scoped,seamless,selected,sortable,translate,truespeed,typemustmatch,visible"),vi="http://www.w3.org/1999/xlink",gi=function(e){return":"===e.charAt(5)&&"xlink"===e.slice(0,5)},_i=function(e){return gi(e)?e.slice(6,e.length):""},bi=function(e){return null==e||!1===e};function yi(e){for(var t=e.data,i=e,r=e;n(r.componentInstance);)(r=r.componentInstance._vnode)&&r.data&&(t=wi(r.data,t));for(;n(i=i.parent);)i&&i.data&&(t=wi(t,i.data));return function(e,t){if(n(e)||n(t))return ki(e,xi(t));return""}(t.staticClass,t.class)}function wi(e,t){return{staticClass:ki(e.staticClass,t.staticClass),class:n(e.class)?[e.class,t.class]:t.class}}function ki(e,t){return e?t?e+" "+t:e:t||""}function xi(e){return Array.isArray(e)?function(e){for(var t,i="",r=0,o=e.length;r<o;r++)n(t=xi(e[r]))&&""!==t&&(i&&(i+=" "),i+=t);return i}(e):o(e)?function(e){var t="";for(var n in e)e[n]&&(t&&(t+=" "),t+=n);return t}(e):"string"==typeof e?e:""}var Si={svg:"http://www.w3.org/2000/svg",math:"http://www.w3.org/1998/Math/MathML"},Ci=p("html,body,base,head,link,meta,style,title,address,article,aside,footer,header,h1,h2,h3,h4,h5,h6,hgroup,nav,section,div,dd,dl,dt,figcaption,figure,picture,hr,img,li,main,ol,p,pre,ul,a,b,abbr,bdi,bdo,br,cite,code,data,dfn,em,i,kbd,mark,q,rp,rt,rtc,ruby,s,samp,small,span,strong,sub,sup,time,u,var,wbr,area,audio,map,track,video,embed,object,param,source,canvas,script,noscript,del,ins,caption,col,colgroup,table,thead,tbody,td,th,tr,button,datalist,fieldset,form,input,label,legend,meter,optgroup,option,output,progress,select,textarea,details,dialog,menu,menuitem,summary,content,element,shadow,template,blockquote,iframe,tfoot"),Mi=p("svg,animate,circle,clippath,cursor,defs,desc,ellipse,filter,font-face,foreignObject,g,glyph,image,line,marker,mask,missing-glyph,path,pattern,polygon,polyline,rect,switch,symbol,text,textpath,tspan,use,view",!0),Ti=function(e){return Ci(e)||Mi(e)};function Ai(e){return Mi(e)?"svg":"math"===e?"math":void 0}var Pi=Object.create(null);var Li=p("text,number,password,search,email,tel,url");function Oi(e){if("string"==typeof e){var t=document.querySelector(e);return t||(ce("Cannot find element: "+e),document.createElement("div"))}return e}var qi=Object.freeze({createElement:function(e,t){var n=document.createElement(e);return"select"!==e||t.data&&t.data.attrs&&void 0!==t.data.attrs.multiple&&n.setAttribute("multiple","multiple"),n},createElementNS:function(e,t){return document.createElementNS(Si[e],t)},createTextNode:function(e){return document.createTextNode(e)},createComment:function(e){return document.createComment(e)},insertBefore:function(e,t,n){e.insertBefore(t,n)},removeChild:function(e,t){e.removeChild(t)},appendChild:function(e,t){e.appendChild(t)},parentNode:function(e){return e.parentNode},nextSibling:function(e){return e.nextSibling},tagName:function(e){return e.tagName},setTextContent:function(e,t){e.textContent=t},setStyleScope:function(e,t){e.setAttribute(t,"")}}),Ei={create:function(e,t){Di(t)},update:function(e,t){e.data.ref!==t.data.ref&&(Di(e,!0),Di(t))},destroy:function(e){Di(e,!0)}};function Di(e,t){var i=e.data.ref;if(n(i)){var r=e.context,o=e.componentInstance||e.elm,a=r.$refs;t?Array.isArray(a[i])?g(a[i],o):a[i]===o&&(a[i]=void 0):e.data.refInFor?Array.isArray(a[i])?a[i].indexOf(o)<0&&a[i].push(o):a[i]=[o]:a[i]=o}}var zi=new ye("",{},[]),Ni=["create","activate","update","remove","destroy"];function ji(e,r){return e.key===r.key&&(e.tag===r.tag&&e.isComment===r.isComment&&n(e.data)===n(r.data)&&function(e,t){if("input"!==e.tag)return!0;var i,r=n(i=e.data)&&n(i=i.attrs)&&i.type,o=n(i=t.data)&&n(i=i.attrs)&&i.type;return r===o||Li(r)&&Li(o)}(e,r)||i(e.isAsyncPlaceholder)&&e.asyncFactory===r.asyncFactory&&t(r.asyncFactory.error))}function Ri(e,t,i){var r,o,a={};for(r=t;r<=i;++r)n(o=e[r].key)&&(a[o]=r);return a}var Ii={create:$i,update:$i,destroy:function(e){$i(e,zi)}};function $i(e,t){(e.data.directives||t.data.directives)&&function(e,t){var n,i,r,o=e===zi,a=t===zi,s=Bi(e.data.directives,e.context),l=Bi(t.data.directives,t.context),c=[],u=[];for(n in l)i=s[n],r=l[n],i?(r.oldValue=i.value,r.oldArg=i.arg,Hi(r,"update",t,e),r.def&&r.def.componentUpdated&&u.push(r)):(Hi(r,"bind",t,e),r.def&&r.def.inserted&&c.push(r));if(c.length){var d=function(){for(var n=0;n<c.length;n++)Hi(c[n],"inserted",t,e)};o?Ot(t,"insert",d):d()}u.length&&Ot(t,"postpatch",(function(){for(var n=0;n<u.length;n++)Hi(u[n],"componentUpdated",t,e)}));if(!o)for(n in s)l[n]||Hi(s[n],"unbind",e,e,a)}(e,t)}var Fi=Object.create(null);function Bi(e,t){var n,i,r=Object.create(null);if(!e)return r;for(n=0;n<e.length;n++)(i=e[n]).modifiers||(i.modifiers=Fi),r[Vi(i)]=i,i.def=We(t.$options,"directives",i.name,!0);return r}function Vi(e){return e.rawName||e.name+"."+Object.keys(e.modifiers||{}).join(".")}function Hi(e,t,n,i,r){var o=e.def&&e.def[t];if(o)try{o(n.elm,e,n,i,r)}catch(i){et(i,n.context,"directive "+e.name+" "+t+" hook")}}var Wi=[Ei,Ii];function Ui(e,i){var r=i.componentOptions;if(!(n(r)&&!1===r.Ctor.options.inheritAttrs||t(e.data.attrs)&&t(i.data.attrs))){var o,a,s=i.elm,l=e.data.attrs||{},c=i.data.attrs||{};for(o in n(c.__ob__)&&(c=i.data.attrs=A({},c)),c)a=c[o],l[o]!==a&&Yi(s,o,a);for(o in(K||J)&&c.value!==l.value&&Yi(s,"value",c.value),l)t(c[o])&&(gi(o)?s.removeAttributeNS(vi,_i(o)):hi(o)||s.removeAttribute(o))}}function Yi(e,t,n){e.tagName.indexOf("-")>-1?Gi(e,t,n):mi(t)?bi(n)?e.removeAttribute(t):(n="allowfullscreen"===t&&"EMBED"===e.tagName?"true":t,e.setAttribute(t,n)):hi(t)?e.setAttribute(t,pi(t,n)):gi(t)?bi(n)?e.removeAttributeNS(vi,_i(t)):e.setAttributeNS(vi,t,n):Gi(e,t,n)}function Gi(e,t,n){if(bi(n))e.removeAttribute(t);else{if(K&&!Z&&"TEXTAREA"===e.tagName&&"placeholder"===t&&""!==n&&!e.__ieph){var i=function(t){t.stopImmediatePropagation(),e.removeEventListener("input",i)};e.addEventListener("input",i),e.__ieph=!0}e.setAttribute(t,n)}}var Qi={create:Ui,update:Ui};function Ki(e,i){var r=i.elm,o=i.data,a=e.data;if(!(t(o.staticClass)&&t(o.class)&&(t(a)||t(a.staticClass)&&t(a.class)))){var s=yi(i),l=r._transitionClasses;n(l)&&(s=ki(s,xi(l))),s!==r._prevClass&&(r.setAttribute("class",s),r._prevClass=s)}}var Zi,Ji,Xi,er,tr,nr,ir,rr={create:Ki,update:Ki},or=/[\w).+\-_$\]]/;function ar(e){var t,n,i,r,o,a=!1,s=!1,l=!1,c=!1,u=0,d=0,h=0,f=0;for(i=0;i<e.length;i++)if(n=t,t=e.charCodeAt(i),a)39===t&&92!==n&&(a=!1);else if(s)34===t&&92!==n&&(s=!1);else if(l)96===t&&92!==n&&(l=!1);else if(c)47===t&&92!==n&&(c=!1);else if(124!==t||124===e.charCodeAt(i+1)||124===e.charCodeAt(i-1)||u||d||h){switch(t){case 34:s=!0;break;case 39:a=!0;break;case 96:l=!0;break;case 40:h++;break;case 41:h--;break;case 91:d++;break;case 93:d--;break;case 123:u++;break;case 125:u--}if(47===t){for(var p=i-1,m=void 0;p>=0&&" "===(m=e.charAt(p));p--);m&&or.test(m)||(c=!0)}}else void 0===r?(f=i+1,r=e.slice(0,i).trim()):v();function v(){(o||(o=[])).push(e.slice(f,i).trim()),f=i+1}if(void 0===r?r=e.slice(0,i).trim():0!==f&&v(),o)for(i=0;i<o.length;i++)r=sr(r,o[i]);return r}function sr(e,t){var n=t.indexOf("(");if(n<0)return'_f("'+t+'")('+e+")";var i=t.slice(0,n),r=t.slice(n+1);return'_f("'+i+'")('+e+(")"!==r?","+r:r)}function lr(e,t){console.error("[Vue compiler]: "+e)}function cr(e,t){return e?e.map((function(e){return e[t]})).filter((function(e){return e})):[]}function ur(e,t,n,i,r){(e.props||(e.props=[])).push(yr({name:t,value:n,dynamic:r},i)),e.plain=!1}function dr(e,t,n,i,r){(r?e.dynamicAttrs||(e.dynamicAttrs=[]):e.attrs||(e.attrs=[])).push(yr({name:t,value:n,dynamic:r},i)),e.plain=!1}function hr(e,t,n,i){e.attrsMap[t]=n,e.attrsList.push(yr({name:t,value:n},i))}function fr(e,t,n,i,r,o,a,s){(e.directives||(e.directives=[])).push(yr({name:t,rawName:n,value:i,arg:r,isDynamicArg:o,modifiers:a},s)),e.plain=!1}function pr(e,t,n){return n?"_p("+t+',"'+e+'")':e+t}function mr(t,n,i,r,o,a,s,l){var c;r=r||e,a&&r.prevent&&r.passive&&a("passive and prevent can't be used together. Passive handler can't prevent default event.",s),r.right?l?n="("+n+")==='click'?'contextmenu':("+n+")":"click"===n&&(n="contextmenu",delete r.right):r.middle&&(l?n="("+n+")==='click'?'mouseup':("+n+")":"click"===n&&(n="mouseup")),r.capture&&(delete r.capture,n=pr("!",n,l)),r.once&&(delete r.once,n=pr("~",n,l)),r.passive&&(delete r.passive,n=pr("&",n,l)),r.native?(delete r.native,c=t.nativeEvents||(t.nativeEvents={})):c=t.events||(t.events={});var u=yr({value:i.trim(),dynamic:l},s);r!==e&&(u.modifiers=r);var d=c[n];Array.isArray(d)?o?d.unshift(u):d.push(u):c[n]=d?o?[u,d]:[d,u]:u,t.plain=!1}function vr(e,t){return e.rawAttrsMap[":"+t]||e.rawAttrsMap["v-bind:"+t]||e.rawAttrsMap[t]}function gr(e,t,n){var i=_r(e,":"+t)||_r(e,"v-bind:"+t);if(null!=i)return ar(i);if(!1!==n){var r=_r(e,t);if(null!=r)return JSON.stringify(r)}}function _r(e,t,n){var i;if(null!=(i=e.attrsMap[t]))for(var r=e.attrsList,o=0,a=r.length;o<a;o++)if(r[o].name===t){r.splice(o,1);break}return n&&delete e.attrsMap[t],i}function br(e,t){for(var n=e.attrsList,i=0,r=n.length;i<r;i++){var o=n[i];if(t.test(o.name))return n.splice(i,1),o}}function yr(e,t){return t&&(null!=t.start&&(e.start=t.start),null!=t.end&&(e.end=t.end)),e}function wr(e,t,n){var i=n||{},r=i.number,o="$$v",a=o;i.trim&&(a="(typeof $$v === 'string'? $$v.trim(): $$v)"),r&&(a="_n("+a+")");var s=kr(t,a);e.model={value:"("+t+")",expression:JSON.stringify(t),callback:"function ($$v) {"+s+"}"}}function kr(e,t){var n=function(e){if(e=e.trim(),Zi=e.length,e.indexOf("[")<0||e.lastIndexOf("]")<Zi-1)return(er=e.lastIndexOf("."))>-1?{exp:e.slice(0,er),key:'"'+e.slice(er+1)+'"'}:{exp:e,key:null};Ji=e,er=tr=nr=0;for(;!Sr();)Cr(Xi=xr())?Tr(Xi):91===Xi&&Mr(Xi);return{exp:e.slice(0,tr),key:e.slice(tr+1,nr)}}(e);return null===n.key?e+"="+t:"$set("+n.exp+", "+n.key+", "+t+")"}function xr(){return Ji.charCodeAt(++er)}function Sr(){return er>=Zi}function Cr(e){return 34===e||39===e}function Mr(e){var t=1;for(tr=er;!Sr();)if(Cr(e=xr()))Tr(e);else if(91===e&&t++,93===e&&t--,0===t){nr=er;break}}function Tr(e){for(var t=e;!Sr()&&(e=xr())!==t;);}var Ar,Pr="__r",Lr="__c";function Or(e,t,n){var i=Ar;return function r(){null!==t.apply(null,arguments)&&Dr(e,r,n,i)}}var qr=st&&!(ee&&Number(ee[1])<=53);function Er(e,t,n,i){if(qr){var r=In,o=t;t=o._wrapper=function(e){if(e.target===e.currentTarget||e.timeStamp>=r||e.timeStamp<=0||e.target.ownerDocument!==document)return o.apply(this,arguments)}}Ar.addEventListener(e,t,ne?{capture:n,passive:i}:n)}function Dr(e,t,n,i){(i||Ar).removeEventListener(e,t._wrapper||t,n)}function zr(e,i){if(!t(e.data.on)||!t(i.data.on)){var r=i.data.on||{},o=e.data.on||{};Ar=i.elm,function(e){if(n(e[Pr])){var t=K?"change":"input";e[t]=[].concat(e[Pr],e[t]||[]),delete e[Pr]}n(e[Lr])&&(e.change=[].concat(e[Lr],e.change||[]),delete e[Lr])}(r),Lt(r,o,Er,Dr,Or,i.context),Ar=void 0}}var Nr,jr={create:zr,update:zr};function Rr(e,i){if(!t(e.data.domProps)||!t(i.data.domProps)){var r,o,a=i.elm,s=e.data.domProps||{},l=i.data.domProps||{};for(r in n(l.__ob__)&&(l=i.data.domProps=A({},l)),s)r in l||(a[r]="");for(r in l){if(o=l[r],"textContent"===r||"innerHTML"===r){if(i.children&&(i.children.length=0),o===s[r])continue;1===a.childNodes.length&&a.removeChild(a.childNodes[0])}if("value"===r&&"PROGRESS"!==a.tagName){a._value=o;var c=t(o)?"":String(o);Ir(a,c)&&(a.value=c)}else if("innerHTML"===r&&Mi(a.tagName)&&t(a.innerHTML)){(Nr=Nr||document.createElement("div")).innerHTML="<svg>"+o+"</svg>";for(var u=Nr.firstChild;a.firstChild;)a.removeChild(a.firstChild);for(;u.firstChild;)a.appendChild(u.firstChild)}else if(o!==s[r])try{a[r]=o}catch(e){}}}}function Ir(e,t){return!e.composing&&("OPTION"===e.tagName||function(e,t){var n=!0;try{n=document.activeElement!==e}catch(e){}return n&&e.value!==t}(e,t)||function(e,t){var i=e.value,r=e._vModifiers;if(n(r)){if(r.number)return f(i)!==f(t);if(r.trim)return i.trim()!==t.trim()}return i!==t}(e,t))}var $r={create:Rr,update:Rr},Fr=y((function(e){var t={},n=/:(.+)/;return e.split(/;(?![^(]*\))/g).forEach((function(e){if(e){var i=e.split(n);i.length>1&&(t[i[0].trim()]=i[1].trim())}})),t}));function Br(e){var t=Vr(e.style);return e.staticStyle?A(e.staticStyle,t):t}function Vr(e){return Array.isArray(e)?P(e):"string"==typeof e?Fr(e):e}var Hr,Wr=/^--/,Ur=/\s*!important$/,Yr=function(e,t,n){if(Wr.test(t))e.style.setProperty(t,n);else if(Ur.test(n))e.style.setProperty(C(t),n.replace(Ur,""),"important");else{var i=Qr(t);if(Array.isArray(n))for(var r=0,o=n.length;r<o;r++)e.style[i]=n[r];else e.style[i]=n}},Gr=["Webkit","Moz","ms"],Qr=y((function(e){if(Hr=Hr||document.createElement("div").style,"filter"!==(e=k(e))&&e in Hr)return e;for(var t=e.charAt(0).toUpperCase()+e.slice(1),n=0;n<Gr.length;n++){var i=Gr[n]+t;if(i in Hr)return i}}));function Kr(e,i){var r=i.data,o=e.data;if(!(t(r.staticStyle)&&t(r.style)&&t(o.staticStyle)&&t(o.style))){var a,s,l=i.elm,c=o.staticStyle,u=o.normalizedStyle||o.style||{},d=c||u,h=Vr(i.data.style)||{};i.data.normalizedStyle=n(h.__ob__)?A({},h):h;var f=function(e,t){var n,i={};if(t)for(var r=e;r.componentInstance;)(r=r.componentInstance._vnode)&&r.data&&(n=Br(r.data))&&A(i,n);(n=Br(e.data))&&A(i,n);for(var o=e;o=o.parent;)o.data&&(n=Br(o.data))&&A(i,n);return i}(i,!0);for(s in d)t(f[s])&&Yr(l,s,"");for(s in f)(a=f[s])!==d[s]&&Yr(l,s,null==a?"":a)}}var Zr={create:Kr,update:Kr},Jr=/\s+/;function Xr(e,t){if(t&&(t=t.trim()))if(e.classList)t.indexOf(" ")>-1?t.split(Jr).forEach((function(t){return e.classList.add(t)})):e.classList.add(t);else{var n=" "+(e.getAttribute("class")||"")+" ";n.indexOf(" "+t+" ")<0&&e.setAttribute("class",(n+t).trim())}}function eo(e,t){if(t&&(t=t.trim()))if(e.classList)t.indexOf(" ")>-1?t.split(Jr).forEach((function(t){return e.classList.remove(t)})):e.classList.remove(t),e.classList.length||e.removeAttribute("class");else{for(var n=" "+(e.getAttribute("class")||"")+" ",i=" "+t+" ";n.indexOf(i)>=0;)n=n.replace(i," ");(n=n.trim())?e.setAttribute("class",n):e.removeAttribute("class")}}function to(e){if(e){if("object"==typeof e){var t={};return!1!==e.css&&A(t,no(e.name||"v")),A(t,e),t}return"string"==typeof e?no(e):void 0}}var no=y((function(e){return{enterClass:e+"-enter",enterToClass:e+"-enter-to",enterActiveClass:e+"-enter-active",leaveClass:e+"-leave",leaveToClass:e+"-leave-to",leaveActiveClass:e+"-leave-active"}})),io=U&&!Z,ro="transition",oo="animation",ao="transition",so="transitionend",lo="animation",co="animationend";io&&(void 0===window.ontransitionend&&void 0!==window.onwebkittransitionend&&(ao="WebkitTransition",so="webkitTransitionEnd"),void 0===window.onanimationend&&void 0!==window.onwebkitanimationend&&(lo="WebkitAnimation",co="webkitAnimationEnd"));var uo=U?window.requestAnimationFrame?window.requestAnimationFrame.bind(window):setTimeout:function(e){return e()};function ho(e){uo((function(){uo(e)}))}function fo(e,t){var n=e._transitionClasses||(e._transitionClasses=[]);n.indexOf(t)<0&&(n.push(t),Xr(e,t))}function po(e,t){e._transitionClasses&&g(e._transitionClasses,t),eo(e,t)}function mo(e,t,n){var i=go(e,t),r=i.type,o=i.timeout,a=i.propCount;if(!r)return n();var s=r===ro?so:co,l=0,c=function(){e.removeEventListener(s,u),n()},u=function(t){t.target===e&&++l>=a&&c()};setTimeout((function(){l<a&&c()}),o+1),e.addEventListener(s,u)}var vo=/\b(transform|all)(,|$)/;function go(e,t){var n,i=window.getComputedStyle(e),r=(i[ao+"Delay"]||"").split(", "),o=(i[ao+"Duration"]||"").split(", "),a=_o(r,o),s=(i[lo+"Delay"]||"").split(", "),l=(i[lo+"Duration"]||"").split(", "),c=_o(s,l),u=0,d=0;return t===ro?a>0&&(n=ro,u=a,d=o.length):t===oo?c>0&&(n=oo,u=c,d=l.length):d=(n=(u=Math.max(a,c))>0?a>c?ro:oo:null)?n===ro?o.length:l.length:0,{type:n,timeout:u,propCount:d,hasTransform:n===ro&&vo.test(i[ao+"Property"])}}function _o(e,t){for(;e.length<t.length;)e=e.concat(e);return Math.max.apply(null,t.map((function(t,n){return bo(t)+bo(e[n])})))}function bo(e){return 1e3*Number(e.slice(0,-1).replace(",","."))}function yo(e,i){var r=e.elm;n(r._leaveCb)&&(r._leaveCb.cancelled=!0,r._leaveCb());var a=to(e.data.transition);if(!t(a)&&!n(r._enterCb)&&1===r.nodeType){for(var s=a.css,l=a.type,c=a.enterClass,u=a.enterToClass,d=a.enterActiveClass,h=a.appearClass,p=a.appearToClass,m=a.appearActiveClass,v=a.beforeEnter,g=a.enter,_=a.afterEnter,b=a.enterCancelled,y=a.beforeAppear,w=a.appear,k=a.afterAppear,x=a.appearCancelled,S=a.duration,C=Sn,M=Sn.$vnode;M&&M.parent;)C=M.context,M=M.parent;var T=!C._isMounted||!e.isRootInsert;if(!T||w||""===w){var A=T&&h?h:c,P=T&&m?m:d,L=T&&p?p:u,O=T&&y||v,q=T&&"function"==typeof w?w:g,E=T&&k||_,D=T&&x||b,N=f(o(S)?S.enter:S);null!=N&&ko(N,"enter",e);var j=!1!==s&&!Z,R=So(q),I=r._enterCb=z((function(){j&&(po(r,L),po(r,P)),I.cancelled?(j&&po(r,A),D&&D(r)):E&&E(r),r._enterCb=null}));e.data.show||Ot(e,"insert",(function(){var t=r.parentNode,n=t&&t._pending&&t._pending[e.key];n&&n.tag===e.tag&&n.elm._leaveCb&&n.elm._leaveCb(),q&&q(r,I)})),O&&O(r),j&&(fo(r,A),fo(r,P),ho((function(){po(r,A),I.cancelled||(fo(r,L),R||(xo(N)?setTimeout(I,N):mo(r,l,I)))}))),e.data.show&&(i&&i(),q&&q(r,I)),j||R||I()}}}function wo(e,i){var r=e.elm;n(r._enterCb)&&(r._enterCb.cancelled=!0,r._enterCb());var a=to(e.data.transition);if(t(a)||1!==r.nodeType)return i();if(!n(r._leaveCb)){var s=a.css,l=a.type,c=a.leaveClass,u=a.leaveToClass,d=a.leaveActiveClass,h=a.beforeLeave,p=a.leave,m=a.afterLeave,v=a.leaveCancelled,g=a.delayLeave,_=a.duration,b=!1!==s&&!Z,y=So(p),w=f(o(_)?_.leave:_);n(w)&&ko(w,"leave",e);var k=r._leaveCb=z((function(){r.parentNode&&r.parentNode._pending&&(r.parentNode._pending[e.key]=null),b&&(po(r,u),po(r,d)),k.cancelled?(b&&po(r,c),v&&v(r)):(i(),m&&m(r)),r._leaveCb=null}));g?g(x):x()}function x(){k.cancelled||(!e.data.show&&r.parentNode&&((r.parentNode._pending||(r.parentNode._pending={}))[e.key]=e),h&&h(r),b&&(fo(r,c),fo(r,d),ho((function(){po(r,c),k.cancelled||(fo(r,u),y||(xo(w)?setTimeout(k,w):mo(r,l,k)))}))),p&&p(r,k),b||y||k())}}function ko(e,t,n){"number"!=typeof e?ce("<transition> explicit "+t+" duration is not a valid number - got "+JSON.stringify(e)+".",n.context):isNaN(e)&&ce("<transition> explicit "+t+" duration is NaN - the duration expression might be incorrect.",n.context)}function xo(e){return"number"==typeof e&&!isNaN(e)}function So(e){if(t(e))return!1;var i=e.fns;return n(i)?So(Array.isArray(i)?i[0]:i):(e._length||e.length)>1}function Co(e,t){!0!==t.data.show&&yo(t)}var Mo=function(e){var o,a,s={},l=e.modules,u=e.nodeOps;for(o=0;o<Ni.length;++o)for(s[Ni[o]]=[],a=0;a<l.length;++a)n(l[a][Ni[o]])&&s[Ni[o]].push(l[a][Ni[o]]);function d(e){var t=u.parentNode(e);n(t)&&u.removeChild(t,e)}function h(e,t){return!t&&!e.ns&&!(I.ignoredElements.length&&I.ignoredElements.some((function(t){return c(t)?t.test(e.tag):t===e.tag})))&&I.isUnknownElement(e.tag)}var f=0;function m(e,t,r,o,a,l,c){if(n(e.elm)&&n(l)&&(e=l[c]=Se(e)),e.isRootInsert=!a,!function(e,t,r,o){var a=e.data;if(n(a)){var l=n(e.componentInstance)&&a.keepAlive;if(n(a=a.hook)&&n(a=a.init)&&a(e,!1),n(e.componentInstance))return v(e,t),g(r,e.elm,o),i(l)&&function(e,t,i,r){var o,a=e;for(;a.componentInstance;)if(n(o=(a=a.componentInstance._vnode).data)&&n(o=o.transition)){for(o=0;o<s.activate.length;++o)s.activate[o](zi,a);t.push(a);break}g(i,e.elm,r)}(e,t,r,o),!0}}(e,t,r,o)){var d=e.data,p=e.children,m=e.tag;n(m)?(d&&d.pre&&f++,h(e,f)&&ce("Unknown custom element: <"+m+'> - did you register the component correctly? For recursive components, make sure to provide the "name" option.',e.context),e.elm=e.ns?u.createElementNS(e.ns,m):u.createElement(m,e),w(e),_(e,p,t),n(d)&&y(e,t),g(r,e.elm,o),d&&d.pre&&f--):i(e.isComment)?(e.elm=u.createComment(e.text),g(r,e.elm,o)):(e.elm=u.createTextNode(e.text),g(r,e.elm,o))}}function v(e,t){n(e.data.pendingInsert)&&(t.push.apply(t,e.data.pendingInsert),e.data.pendingInsert=null),e.elm=e.componentInstance.$el,b(e)?(y(e,t),w(e)):(Di(e),t.push(e))}function g(e,t,i){n(e)&&(n(i)?u.parentNode(i)===e&&u.insertBefore(e,t,i):u.appendChild(e,t))}function _(e,t,n){if(Array.isArray(t)){M(t);for(var i=0;i<t.length;++i)m(t[i],n,e.elm,null,!0,t,i)}else r(e.text)&&u.appendChild(e.elm,u.createTextNode(String(e.text)))}function b(e){for(;e.componentInstance;)e=e.componentInstance._vnode;return n(e.tag)}function y(e,t){for(var i=0;i<s.create.length;++i)s.create[i](zi,e);n(o=e.data.hook)&&(n(o.create)&&o.create(zi,e),n(o.insert)&&t.push(e))}function w(e){var t;if(n(t=e.fnScopeId))u.setStyleScope(e.elm,t);else for(var i=e;i;)n(t=i.context)&&n(t=t.$options._scopeId)&&u.setStyleScope(e.elm,t),i=i.parent;n(t=Sn)&&t!==e.context&&t!==e.fnContext&&n(t=t.$options._scopeId)&&u.setStyleScope(e.elm,t)}function k(e,t,n,i,r,o){for(;i<=r;++i)m(n[i],o,e,t,!1,n,i)}function x(e){var t,i,r=e.data;if(n(r))for(n(t=r.hook)&&n(t=t.destroy)&&t(e),t=0;t<s.destroy.length;++t)s.destroy[t](e);if(n(t=e.children))for(i=0;i<e.children.length;++i)x(e.children[i])}function S(e,t,i){for(;t<=i;++t){var r=e[t];n(r)&&(n(r.tag)?(C(r),x(r)):d(r.elm))}}function C(e,t){if(n(t)||n(e.data)){var i,r=s.remove.length+1;for(n(t)?t.listeners+=r:t=function(e,t){function n(){0==--n.listeners&&d(e)}return n.listeners=t,n}(e.elm,r),n(i=e.componentInstance)&&n(i=i._vnode)&&n(i.data)&&C(i,t),i=0;i<s.remove.length;++i)s.remove[i](e,t);n(i=e.data.hook)&&n(i=i.remove)?i(e,t):t()}else d(e.elm)}function M(e){for(var t={},i=0;i<e.length;i++){var r=e[i],o=r.key;n(o)&&(t[o]?ce("Duplicate keys detected: '"+o+"'. This may cause an update error.",r.context):t[o]=!0)}}function T(e,t,i,r){for(var o=i;o<r;o++){var a=t[o];if(n(a)&&ji(e,a))return o}}function A(e,r,o,a,l,c){if(e!==r){n(r.elm)&&n(a)&&(r=a[l]=Se(r));var d=r.elm=e.elm;if(i(e.isAsyncPlaceholder))n(r.asyncFactory.resolved)?q(e.elm,r,o):r.isAsyncPlaceholder=!0;else if(i(r.isStatic)&&i(e.isStatic)&&r.key===e.key&&(i(r.isCloned)||i(r.isOnce)))r.componentInstance=e.componentInstance;else{var h,f=r.data;n(f)&&n(h=f.hook)&&n(h=h.prepatch)&&h(e,r);var p=e.children,v=r.children;if(n(f)&&b(r)){for(h=0;h<s.update.length;++h)s.update[h](e,r);n(h=f.hook)&&n(h=h.update)&&h(e,r)}t(r.text)?n(p)&&n(v)?p!==v&&function(e,i,r,o,a){var s,l,c,d=0,h=0,f=i.length-1,p=i[0],v=i[f],g=r.length-1,_=r[0],b=r[g],y=!a;for(M(r);d<=f&&h<=g;)t(p)?p=i[++d]:t(v)?v=i[--f]:ji(p,_)?(A(p,_,o,r,h),p=i[++d],_=r[++h]):ji(v,b)?(A(v,b,o,r,g),v=i[--f],b=r[--g]):ji(p,b)?(A(p,b,o,r,g),y&&u.insertBefore(e,p.elm,u.nextSibling(v.elm)),p=i[++d],b=r[--g]):ji(v,_)?(A(v,_,o,r,h),y&&u.insertBefore(e,v.elm,p.elm),v=i[--f],_=r[++h]):(t(s)&&(s=Ri(i,d,f)),t(l=n(_.key)?s[_.key]:T(_,i,d,f))?m(_,o,e,p.elm,!1,r,h):ji(c=i[l],_)?(A(c,_,o,r,h),i[l]=void 0,y&&u.insertBefore(e,c.elm,p.elm)):m(_,o,e,p.elm,!1,r,h),_=r[++h]);d>f?k(e,t(r[g+1])?null:r[g+1].elm,r,h,g,o):h>g&&S(i,d,f)}(d,p,v,o,c):n(v)?(M(v),n(e.text)&&u.setTextContent(d,""),k(d,null,v,0,v.length-1,o)):n(p)?S(p,0,p.length-1):n(e.text)&&u.setTextContent(d,""):e.text!==r.text&&u.setTextContent(d,r.text),n(f)&&n(h=f.hook)&&n(h=h.postpatch)&&h(e,r)}}}function P(e,t,r){if(i(r)&&n(e.parent))e.parent.data.pendingInsert=t;else for(var o=0;o<t.length;++o)t[o].data.hook.insert(t[o])}var L=!1,O=p("attrs,class,staticClass,staticStyle,key");function q(e,t,r,o){var a,s=t.tag,l=t.data,c=t.children;if(o=o||l&&l.pre,t.elm=e,i(t.isComment)&&n(t.asyncFactory))return t.isAsyncPlaceholder=!0,!0;if(!function(e,t,i){return n(t.tag)?0===t.tag.indexOf("vue-component")||!h(t,i)&&t.tag.toLowerCase()===(e.tagName&&e.tagName.toLowerCase()):e.nodeType===(t.isComment?8:3)}(e,t,o))return!1;if(n(l)&&(n(a=l.hook)&&n(a=a.init)&&a(t,!0),n(a=t.componentInstance)))return v(t,r),!0;if(n(s)){if(n(c))if(e.hasChildNodes())if(n(a=l)&&n(a=a.domProps)&&n(a=a.innerHTML)){if(a!==e.innerHTML)return"undefined"==typeof console||L||(L=!0,console.warn("Parent: ",e),console.warn("server innerHTML: ",a),console.warn("client innerHTML: ",e.innerHTML)),!1}else{for(var u=!0,d=e.firstChild,f=0;f<c.length;f++){if(!d||!q(d,c[f],r,o)){u=!1;break}d=d.nextSibling}if(!u||d)return"undefined"==typeof console||L||(L=!0,console.warn("Parent: ",e),console.warn("Mismatching childNodes vs. VNodes: ",e.childNodes,c)),!1}else _(t,c,r);if(n(l)){var p=!1;for(var m in l)if(!O(m)){p=!0,y(t,r);break}!p&&l.class&&Mt(l.class)}}else e.data!==t.text&&(e.data=t.text);return!0}return function(e,r,o,a){if(!t(r)){var l,c=!1,d=[];if(t(e))c=!0,m(r,d);else{var h=n(e.nodeType);if(!h&&ji(e,r))A(e,r,d,null,null,a);else{if(h){if(1===e.nodeType&&e.hasAttribute(N)&&(e.removeAttribute(N),o=!0),i(o)){if(q(e,r,d))return P(r,d,!0),e;ce("The client-side rendered virtual DOM tree is not matching server-rendered content. This is likely caused by incorrect HTML markup, for example nesting block-level elements inside <p>, or missing <tbody>. Bailing hydration and performing full client-side render.")}l=e,e=new ye(u.tagName(l).toLowerCase(),{},[],void 0,l)}var f=e.elm,p=u.parentNode(f);if(m(r,d,f._leaveCb?null:p,u.nextSibling(f)),n(r.parent))for(var v=r.parent,g=b(r);v;){for(var _=0;_<s.destroy.length;++_)s.destroy[_](v);if(v.elm=r.elm,g){for(var y=0;y<s.create.length;++y)s.create[y](zi,v);var w=v.data.hook.insert;if(w.merged)for(var k=1;k<w.fns.length;k++)w.fns[k]()}else Di(v);v=v.parent}n(p)?S([e],0,0):n(e.tag)&&x(e)}}return P(r,d,c),r.elm}n(e)&&x(e)}}({nodeOps:qi,modules:[Qi,rr,jr,$r,Zr,U?{create:Co,activate:Co,remove:function(e,t){!0!==e.data.show?wo(e,t):t()}}:{}].concat(Wi)});Z&&document.addEventListener("selectionchange",(function(){var e=document.activeElement;e&&e.vmodel&&Do(e,"input")}));var To={inserted:function(e,t,n,i){"select"===n.tag?(i.elm&&!i.elm._vOptions?Ot(n,"postpatch",(function(){To.componentUpdated(e,t,n)})):Ao(e,t,n.context),e._vOptions=[].map.call(e.options,Oo)):("textarea"===n.tag||Li(e.type))&&(e._vModifiers=t.modifiers,t.modifiers.lazy||(e.addEventListener("compositionstart",qo),e.addEventListener("compositionend",Eo),e.addEventListener("change",Eo),Z&&(e.vmodel=!0)))},componentUpdated:function(e,t,n){if("select"===n.tag){Ao(e,t,n.context);var i=e._vOptions,r=e._vOptions=[].map.call(e.options,Oo);if(r.some((function(e,t){return!E(e,i[t])})))(e.multiple?t.value.some((function(e){return Lo(e,r)})):t.value!==t.oldValue&&Lo(t.value,r))&&Do(e,"change")}}};function Ao(e,t,n){Po(e,t,n),(K||J)&&setTimeout((function(){Po(e,t,n)}),0)}function Po(e,t,n){var i=t.value,r=e.multiple;if(!r||Array.isArray(i)){for(var o,a,s=0,l=e.options.length;s<l;s++)if(a=e.options[s],r)o=D(i,Oo(a))>-1,a.selected!==o&&(a.selected=o);else if(E(Oo(a),i))return void(e.selectedIndex!==s&&(e.selectedIndex=s));r||(e.selectedIndex=-1)}else ce('<select multiple v-model="'+t.expression+'"> expects an Array value for its binding, but got '+Object.prototype.toString.call(i).slice(8,-1),n)}function Lo(e,t){return t.every((function(t){return!E(t,e)}))}function Oo(e){return"_value"in e?e._value:e.value}function qo(e){e.target.composing=!0}function Eo(e){e.target.composing&&(e.target.composing=!1,Do(e.target,"input"))}function Do(e,t){var n=document.createEvent("HTMLEvents");n.initEvent(t,!0,!0),e.dispatchEvent(n)}function zo(e){return!e.componentInstance||e.data&&e.data.transition?e:zo(e.componentInstance._vnode)}var No={bind:function(e,t,n){var i=t.value,r=(n=zo(n)).data&&n.data.transition,o=e.__vOriginalDisplay="none"===e.style.display?"":e.style.display;i&&r?(n.data.show=!0,yo(n,(function(){e.style.display=o}))):e.style.display=i?o:"none"},update:function(e,t,n){var i=t.value;!i!=!t.oldValue&&((n=zo(n)).data&&n.data.transition?(n.data.show=!0,i?yo(n,(function(){e.style.display=e.__vOriginalDisplay})):wo(n,(function(){e.style.display="none"}))):e.style.display=i?e.__vOriginalDisplay:"none")},unbind:function(e,t,n,i,r){r||(e.style.display=e.__vOriginalDisplay)}},jo={model:To,show:No},Ro={name:String,appear:Boolean,css:Boolean,mode:String,type:String,enterClass:String,leaveClass:String,enterToClass:String,leaveToClass:String,enterActiveClass:String,leaveActiveClass:String,appearClass:String,appearActiveClass:String,appearToClass:String,duration:[Number,String,Object]};function Io(e){var t=e&&e.componentOptions;return t&&t.Ctor.options.abstract?Io(bn(t.children)):e}function $o(e){var t={},n=e.$options;for(var i in n.propsData)t[i]=e[i];var r=n._parentListeners;for(var o in r)t[k(o)]=r[o];return t}function Fo(e,t){if(/\d-keep-alive$/.test(t.tag))return e("keep-alive",{props:t.componentOptions.propsData})}var Bo=function(e){return e.tag||_n(e)},Vo=function(e){return"show"===e.name},Ho={name:"transition",props:Ro,abstract:!0,render:function(e){var t=this,n=this.$slots.default;if(n&&(n=n.filter(Bo)).length){n.length>1&&ce("<transition> can only be used on a single element. Use <transition-group> for lists.",this.$parent);var i=this.mode;i&&"in-out"!==i&&"out-in"!==i&&ce("invalid <transition> mode: "+i,this.$parent);var o=n[0];if(function(e){for(;e=e.parent;)if(e.data.transition)return!0}(this.$vnode))return o;var a=Io(o);if(!a)return o;if(this._leaving)return Fo(e,o);var s="__transition-"+this._uid+"-";a.key=null==a.key?a.isComment?s+"comment":s+a.tag:r(a.key)?0===String(a.key).indexOf(s)?a.key:s+a.key:a.key;var l=(a.data||(a.data={})).transition=$o(this),c=this._vnode,u=Io(c);if(a.data.directives&&a.data.directives.some(Vo)&&(a.data.show=!0),u&&u.data&&!function(e,t){return t.key===e.key&&t.tag===e.tag}(a,u)&&!_n(u)&&(!u.componentInstance||!u.componentInstance._vnode.isComment)){var d=u.data.transition=A({},l);if("out-in"===i)return this._leaving=!0,Ot(d,"afterLeave",(function(){t._leaving=!1,t.$forceUpdate()})),Fo(e,o);if("in-out"===i){if(_n(a))return c;var h,f=function(){h()};Ot(l,"afterEnter",f),Ot(l,"enterCancelled",f),Ot(d,"delayLeave",(function(e){h=e}))}}return o}}},Wo=A({tag:String,moveClass:String},Ro);delete Wo.mode;var Uo={props:Wo,beforeMount:function(){var e=this,t=this._update;this._update=function(n,i){var r=Mn(e);e.__patch__(e._vnode,e.kept,!1,!0),e._vnode=e.kept,r(),t.call(e,n,i)}},render:function(e){for(var t=this.tag||this.$vnode.data.tag||"span",n=Object.create(null),i=this.prevChildren=this.children,r=this.$slots.default||[],o=this.children=[],a=$o(this),s=0;s<r.length;s++){var l=r[s];if(l.tag)if(null!=l.key&&0!==String(l.key).indexOf("__vlist"))o.push(l),n[l.key]=l,(l.data||(l.data={})).transition=a;else{var c=l.componentOptions,u=c?c.Ctor.options.name||c.tag||"":l.tag;ce("<transition-group> children must be keyed: <"+u+">")}}if(i){for(var d=[],h=[],f=0;f<i.length;f++){var p=i[f];p.data.transition=a,p.data.pos=p.elm.getBoundingClientRect(),n[p.key]?d.push(p):h.push(p)}this.kept=e(t,null,d),this.removed=h}return e(t,null,o)},updated:function(){var e=this.prevChildren,t=this.moveClass||(this.name||"v")+"-move";e.length&&this.hasMove(e[0].elm,t)&&(e.forEach(Yo),e.forEach(Go),e.forEach(Qo),this._reflow=document.body.offsetHeight,e.forEach((function(e){if(e.data.moved){var n=e.elm,i=n.style;fo(n,t),i.transform=i.WebkitTransform=i.transitionDuration="",n.addEventListener(so,n._moveCb=function e(i){i&&i.target!==n||i&&!/transform$/.test(i.propertyName)||(n.removeEventListener(so,e),n._moveCb=null,po(n,t))})}})))},methods:{hasMove:function(e,t){if(!io)return!1;if(this._hasMove)return this._hasMove;var n=e.cloneNode();e._transitionClasses&&e._transitionClasses.forEach((function(e){eo(n,e)})),Xr(n,t),n.style.display="none",this.$el.appendChild(n);var i=go(n);return this.$el.removeChild(n),this._hasMove=i.hasTransform}}};function Yo(e){e.elm._moveCb&&e.elm._moveCb(),e.elm._enterCb&&e.elm._enterCb()}function Go(e){e.data.newPos=e.elm.getBoundingClientRect()}function Qo(e){var t=e.data.pos,n=e.data.newPos,i=t.left-n.left,r=t.top-n.top;if(i||r){e.data.moved=!0;var o=e.elm.style;o.transform=o.WebkitTransform="translate("+i+"px,"+r+"px)",o.transitionDuration="0s"}}var Ko={Transition:Ho,TransitionGroup:Uo};ti.config.mustUseProp=di,ti.config.isReservedTag=Ti,ti.config.isReservedAttr=ci,ti.config.getTagNamespace=Ai,ti.config.isUnknownElement=function(e){if(!U)return!0;if(Ti(e))return!1;if(e=e.toLowerCase(),null!=Pi[e])return Pi[e];var t=document.createElement(e);return e.indexOf("-")>-1?Pi[e]=t.constructor===window.HTMLUnknownElement||t.constructor===window.HTMLElement:Pi[e]=/HTMLUnknownElement/.test(t.toString())},A(ti.options.directives,jo),A(ti.options.components,Ko),ti.prototype.__patch__=U?Mo:L,ti.prototype.$mount=function(e,t){return function(e,t,n){var i;return e.$el=t,e.$options.render||(e.$options.render=ke,e.$options.template&&"#"!==e.$options.template.charAt(0)||e.$options.el||t?ce("You are using the runtime-only build of Vue where the template compiler is not available. Either pre-compile the templates into render functions, or use the compiler-included build.",e):ce("Failed to mount component: template or render function not defined.",e)),Ln(e,"beforeMount"),i=I.performance&&ot?function(){var t=e._name,i=e._uid,r="vue-perf-start:"+i,o="vue-perf-end:"+i;ot(r);var a=e._render();ot(o),at("vue "+t+" render",r,o),ot(r),e._update(a,n),ot(o),at("vue "+t+" patch",r,o)}:function(){e._update(e._render(),n)},new Hn(e,i,L,{before:function(){e._isMounted&&!e._isDestroyed&&Ln(e,"beforeUpdate")}},!0),n=!1,null==e.$vnode&&(e._isMounted=!0,Ln(e,"mounted")),e}(this,e=e&&U?Oi(e):void 0,t)},U&&setTimeout((function(){I.devtools&&(oe?oe.emit("init",ti):console[console.info?"info":"log"]("Download the Vue Devtools extension for a better development experience:\nhttps://github.com/vuejs/vue-devtools")),!1!==I.productionTip&&"undefined"!=typeof console&&console[console.info?"info":"log"]("You are running Vue in development mode.\nMake sure to turn on production mode when deploying for production.\nSee more tips at https://vuejs.org/guide/deployment.html")}),0);var Zo=/\{\{((?:.|\r?\n)+?)\}\}/g,Jo=/[-.*+?^${}()|[\]\/\\]/g,Xo=y((function(e){var t=e[0].replace(Jo,"\\$&"),n=e[1].replace(Jo,"\\$&");return new RegExp(t+"((?:.|\\n)+?)"+n,"g")}));function ea(e,t){var n=t?Xo(t):Zo;if(n.test(e)){for(var i,r,o,a=[],s=[],l=n.lastIndex=0;i=n.exec(e);){(r=i.index)>l&&(s.push(o=e.slice(l,r)),a.push(JSON.stringify(o)));var c=ar(i[1].trim());a.push("_s("+c+")"),s.push({"@binding":c}),l=r+i[0].length}return l<e.length&&(s.push(o=e.slice(l)),a.push(JSON.stringify(o))),{expression:a.join("+"),tokens:s}}}var ta={staticKeys:["staticClass"],transformNode:function(e,t){var n=t.warn||lr,i=_r(e,"class");i&&ea(i,t.delimiters)&&n('class="'+i+'": Interpolation inside attributes has been removed. Use v-bind or the colon shorthand instead. For example, instead of <div class="{{ val }}">, use <div :class="val">.',e.rawAttrsMap.class),i&&(e.staticClass=JSON.stringify(i));var r=gr(e,"class",!1);r&&(e.classBinding=r)},genData:function(e){var t="";return e.staticClass&&(t+="staticClass:"+e.staticClass+","),e.classBinding&&(t+="class:"+e.classBinding+","),t}};var na,ia={staticKeys:["staticStyle"],transformNode:function(e,t){var n=t.warn||lr,i=_r(e,"style");i&&(ea(i,t.delimiters)&&n('style="'+i+'": Interpolation inside attributes has been removed. Use v-bind or the colon shorthand instead. For example, instead of <div style="{{ val }}">, use <div :style="val">.',e.rawAttrsMap.style),e.staticStyle=JSON.stringify(Fr(i)));var r=gr(e,"style",!1);r&&(e.styleBinding=r)},genData:function(e){var t="";return e.staticStyle&&(t+="staticStyle:"+e.staticStyle+","),e.styleBinding&&(t+="style:("+e.styleBinding+"),"),t}},ra=function(e){return(na=na||document.createElement("div")).innerHTML=e,na.textContent},oa=p("area,base,br,col,embed,frame,hr,img,input,isindex,keygen,link,meta,param,source,track,wbr"),aa=p("colgroup,dd,dt,li,options,p,td,tfoot,th,thead,tr,source"),sa=p("address,article,aside,base,blockquote,body,caption,col,colgroup,dd,details,dialog,div,dl,dt,fieldset,figcaption,figure,footer,form,h1,h2,h3,h4,h5,h6,head,header,hgroup,hr,html,legend,li,menuitem,meta,optgroup,option,param,rp,rt,source,style,summary,tbody,td,tfoot,th,thead,title,tr,track"),la=/^\s*([^\s"'<>\/=]+)(?:\s*(=)\s*(?:"([^"]*)"+|'([^']*)'+|([^\s"'=<>`]+)))?/,ca=/^\s*((?:v-[\w-]+:|@|:|#)\[[^=]+\][^\s"'<>\/=]*)(?:\s*(=)\s*(?:"([^"]*)"+|'([^']*)'+|([^\s"'=<>`]+)))?/,ua="[a-zA-Z_][\\-\\.0-9_a-zA-Z"+$.source+"]*",da="((?:"+ua+"\\:)?"+ua+")",ha=new RegExp("^<"+da),fa=/^\s*(\/?)>/,pa=new RegExp("^<\\/"+da+"[^>]*>"),ma=/^<!DOCTYPE [^>]+>/i,va=/^<!\--/,ga=/^<!\[/,_a=p("script,style,textarea",!0),ba={},ya={"&lt;":"<","&gt;":">","&quot;":'"',"&amp;":"&","&#10;":"\n","&#9;":"\t","&#39;":"'"},wa=/&(?:lt|gt|quot|amp|#39);/g,ka=/&(?:lt|gt|quot|amp|#39|#10|#9);/g,xa=p("pre,textarea",!0),Sa=function(e,t){return e&&xa(e)&&"\n"===t[0]};function Ca(e,t){var n=t?ka:wa;return e.replace(n,(function(e){return ya[e]}))}var Ma,Ta,Aa,Pa,La,Oa,qa,Ea,Da,za=/^@|^v-on:/,Na=/^v-|^@|^:|^#/,ja=/([\s\S]*?)\s+(?:in|of)\s+([\s\S]*)/,Ra=/,([^,\}\]]*)(?:,([^,\}\]]*))?$/,Ia=/^\(|\)$/g,$a=/^\[.*\]$/,Fa=/:(.*)$/,Ba=/^:|^\.|^v-bind:/,Va=/\.[^.\]]+(?=[^\]]*$)/g,Ha=/^v-slot(:|$)|^#/,Wa=/[\r\n]/,Ua=/\s+/g,Ya=/[\s"'<>\/=]/,Ga=y(ra),Qa="_empty_";function Ka(e,t,n){return{type:1,tag:e,attrsList:t,attrsMap:is(t),rawAttrsMap:{},parent:n,children:[]}}function Za(e,t){Ma=t.warn||lr,Oa=t.isPreTag||O,qa=t.mustUseProp||O,Ea=t.getTagNamespace||O;var n=t.isReservedTag||O;Da=function(e){return!!e.component||!n(e.tag)},Aa=cr(t.modules,"transformNode"),Pa=cr(t.modules,"preTransformNode"),La=cr(t.modules,"postTransformNode"),Ta=t.delimiters;var i,r,o=[],a=!1!==t.preserveWhitespace,s=t.whitespace,l=!1,c=!1,u=!1;function d(e,t){u||(u=!0,Ma(e,t))}function h(e){if(f(e),l||e.processed||(e=Ja(e,t)),o.length||e===i||(i.if&&(e.elseif||e.else)?(p(e),es(i,{exp:e.elseif,block:e})):d("Component template should contain exactly one root element. If you are using v-if on multiple elements, use v-else-if to chain them instead.",{start:e.start})),r&&!e.forbidden)if(e.elseif||e.else)a=e,s=function(e){for(var t=e.length;t--;){if(1===e[t].type)return e[t];" "!==e[t].text&&Ma('text "'+e[t].text.trim()+'" between v-if and v-else(-if) will be ignored.',e[t]),e.pop()}}(r.children),s&&s.if?es(s,{exp:a.elseif,block:a}):Ma("v-"+(a.elseif?'else-if="'+a.elseif+'"':"else")+" used on element <"+a.tag+"> without corresponding v-if.",a.rawAttrsMap[a.elseif?"v-else-if":"v-else"]);else{if(e.slotScope){var n=e.slotTarget||'"default"';(r.scopedSlots||(r.scopedSlots={}))[n]=e}r.children.push(e),e.parent=r}var a,s;e.children=e.children.filter((function(e){return!e.slotScope})),f(e),e.pre&&(l=!1),Oa(e.tag)&&(c=!1);for(var u=0;u<La.length;u++)La[u](e,t)}function f(e){if(!c)for(var t;(t=e.children[e.children.length-1])&&3===t.type&&" "===t.text;)e.children.pop()}function p(e){"slot"!==e.tag&&"template"!==e.tag||d("Cannot use <"+e.tag+"> as component root element because it may contain multiple nodes.",{start:e.start}),e.attrsMap.hasOwnProperty("v-for")&&d("Cannot use v-for on stateful component root element because it renders multiple elements.",e.rawAttrsMap["v-for"])}return function(e,t){for(var n,i,r=[],o=t.expectHTML,a=t.isUnaryTag||O,s=t.canBeLeftOpenTag||O,l=0;e;){if(n=e,i&&_a(i)){var c=0,u=i.toLowerCase(),d=ba[u]||(ba[u]=new RegExp("([\\s\\S]*?)(</"+u+"[^>]*>)","i")),h=e.replace(d,(function(e,n,i){return c=i.length,_a(u)||"noscript"===u||(n=n.replace(/<!\--([\s\S]*?)-->/g,"$1").replace(/<!\[CDATA\[([\s\S]*?)]]>/g,"$1")),Sa(u,n)&&(n=n.slice(1)),t.chars&&t.chars(n),""}));l+=e.length-h.length,e=h,M(u,l-c,l)}else{var f=e.indexOf("<");if(0===f){if(va.test(e)){var p=e.indexOf("--\x3e");if(p>=0){t.shouldKeepComment&&t.comment(e.substring(4,p),l,l+p+3),x(p+3);continue}}if(ga.test(e)){var m=e.indexOf("]>");if(m>=0){x(m+2);continue}}var v=e.match(ma);if(v){x(v[0].length);continue}var g=e.match(pa);if(g){var _=l;x(g[0].length),M(g[1],_,l);continue}var b=S();if(b){C(b),Sa(b.tagName,e)&&x(1);continue}}var y=void 0,w=void 0,k=void 0;if(f>=0){for(w=e.slice(f);!(pa.test(w)||ha.test(w)||va.test(w)||ga.test(w)||(k=w.indexOf("<",1))<0);)f+=k,w=e.slice(f);y=e.substring(0,f)}f<0&&(y=e),y&&x(y.length),t.chars&&y&&t.chars(y,l-y.length,l)}if(e===n){t.chars&&t.chars(e),!r.length&&t.warn&&t.warn('Mal-formatted tag at end of template: "'+e+'"',{start:l+e.length});break}}function x(t){l+=t,e=e.substring(t)}function S(){var t=e.match(ha);if(t){var n,i,r={tagName:t[1],attrs:[],start:l};for(x(t[0].length);!(n=e.match(fa))&&(i=e.match(ca)||e.match(la));)i.start=l,x(i[0].length),i.end=l,r.attrs.push(i);if(n)return r.unarySlash=n[1],x(n[0].length),r.end=l,r}}function C(e){var n=e.tagName,l=e.unarySlash;o&&("p"===i&&sa(n)&&M(i),s(n)&&i===n&&M(n));for(var c=a(n)||!!l,u=e.attrs.length,d=new Array(u),h=0;h<u;h++){var f=e.attrs[h],p=f[3]||f[4]||f[5]||"",m="a"===n&&"href"===f[1]?t.shouldDecodeNewlinesForHref:t.shouldDecodeNewlines;d[h]={name:f[1],value:Ca(p,m)},t.outputSourceRange&&(d[h].start=f.start+f[0].match(/^\s*/).length,d[h].end=f.end)}c||(r.push({tag:n,lowerCasedTag:n.toLowerCase(),attrs:d,start:e.start,end:e.end}),i=n),t.start&&t.start(n,d,c,e.start,e.end)}function M(e,n,o){var a,s;if(null==n&&(n=l),null==o&&(o=l),e)for(s=e.toLowerCase(),a=r.length-1;a>=0&&r[a].lowerCasedTag!==s;a--);else a=0;if(a>=0){for(var c=r.length-1;c>=a;c--)(c>a||!e&&t.warn)&&t.warn("tag <"+r[c].tag+"> has no matching end tag.",{start:r[c].start,end:r[c].end}),t.end&&t.end(r[c].tag,n,o);r.length=a,i=a&&r[a-1].tag}else"br"===s?t.start&&t.start(e,[],!0,n,o):"p"===s&&(t.start&&t.start(e,[],!1,n,o),t.end&&t.end(e,n,o))}M()}(e,{warn:Ma,expectHTML:t.expectHTML,isUnaryTag:t.isUnaryTag,canBeLeftOpenTag:t.canBeLeftOpenTag,shouldDecodeNewlines:t.shouldDecodeNewlines,shouldDecodeNewlinesForHref:t.shouldDecodeNewlinesForHref,shouldKeepComment:t.comments,outputSourceRange:t.outputSourceRange,start:function(e,n,a,s,u){var d=r&&r.ns||Ea(e);K&&"svg"===d&&(n=function(e){for(var t=[],n=0;n<e.length;n++){var i=e[n];rs.test(i.name)||(i.name=i.name.replace(os,""),t.push(i))}return t}(n));var f,m=Ka(e,n,r);d&&(m.ns=d),t.outputSourceRange&&(m.start=s,m.end=u,m.rawAttrsMap=m.attrsList.reduce((function(e,t){return e[t.name]=t,e}),{})),n.forEach((function(e){Ya.test(e.name)&&Ma("Invalid dynamic argument expression: attribute names cannot contain spaces, quotes, <, >, / or =.",{start:e.start+e.name.indexOf("["),end:e.start+e.name.length})})),"style"!==(f=m).tag&&("script"!==f.tag||f.attrsMap.type&&"text/javascript"!==f.attrsMap.type)||re()||(m.forbidden=!0,Ma("Templates should only be responsible for mapping the state to the UI. Avoid placing tags with side-effects in your templates, such as <"+e+">, as they will not be parsed.",{start:m.start}));for(var v=0;v<Pa.length;v++)m=Pa[v](m,t)||m;l||(!function(e){null!=_r(e,"v-pre")&&(e.pre=!0)}(m),m.pre&&(l=!0)),Oa(m.tag)&&(c=!0),l?function(e){var t=e.attrsList,n=t.length;if(n)for(var i=e.attrs=new Array(n),r=0;r<n;r++)i[r]={name:t[r].name,value:JSON.stringify(t[r].value)},null!=t[r].start&&(i[r].start=t[r].start,i[r].end=t[r].end);else e.pre||(e.plain=!0)}(m):m.processed||(Xa(m),function(e){var t=_r(e,"v-if");if(t)e.if=t,es(e,{exp:t,block:e});else{null!=_r(e,"v-else")&&(e.else=!0);var n=_r(e,"v-else-if");n&&(e.elseif=n)}}(m),function(e){var t=_r(e,"v-once");null!=t&&(e.once=!0)}(m)),i||p(i=m),a?h(m):(r=m,o.push(m))},end:function(e,n,i){var a=o[o.length-1];o.length-=1,r=o[o.length-1],t.outputSourceRange&&(a.end=i),h(a)},chars:function(n,i,o){if(r){if(!K||"textarea"!==r.tag||r.attrsMap.placeholder!==n){var u,h,f,p=r.children;if(n=c||n.trim()?"script"===(u=r).tag||"style"===u.tag?n:Ga(n):p.length?s?"condense"===s&&Wa.test(n)?"":" ":a?" ":"":"")c||"condense"!==s||(n=n.replace(Ua," ")),!l&&" "!==n&&(h=ea(n,Ta))?f={type:2,expression:h.expression,tokens:h.tokens,text:n}:" "===n&&p.length&&" "===p[p.length-1].text||(f={type:3,text:n}),f&&(t.outputSourceRange&&(f.start=i,f.end=o),p.push(f))}}else n===e?d("Component template requires a root element, rather than just text.",{start:i}):(n=n.trim())&&d('text "'+n+'" outside root element will be ignored.',{start:i})},comment:function(e,n,i){if(r){var o={type:3,text:e,isComment:!0};t.outputSourceRange&&(o.start=n,o.end=i),r.children.push(o)}}}),i}function Ja(e,t){var n;!function(e){var t=gr(e,"key");if(t){if("template"===e.tag&&Ma("<template> cannot be keyed. Place the key on real elements instead.",vr(e,"key")),e.for){var n=e.iterator2||e.iterator1,i=e.parent;n&&n===t&&i&&"transition-group"===i.tag&&Ma("Do not use v-for index as key on <transition-group> children, this is the same as not using keys.",vr(e,"key"),!0)}e.key=t}}(e),e.plain=!e.key&&!e.scopedSlots&&!e.attrsList.length,function(e){var t=gr(e,"ref");t&&(e.ref=t,e.refInFor=function(e){var t=e;for(;t;){if(void 0!==t.for)return!0;t=t.parent}return!1}(e))}(e),function(e){var t;"template"===e.tag?((t=_r(e,"scope"))&&Ma('the "scope" attribute for scoped slots have been deprecated and replaced by "slot-scope" since 2.5. The new "slot-scope" attribute can also be used on plain elements in addition to <template> to denote scoped slots.',e.rawAttrsMap.scope,!0),e.slotScope=t||_r(e,"slot-scope")):(t=_r(e,"slot-scope"))&&(e.attrsMap["v-for"]&&Ma("Ambiguous combined usage of slot-scope and v-for on <"+e.tag+"> (v-for takes higher priority). Use a wrapper <template> for the scoped slot to make it clearer.",e.rawAttrsMap["slot-scope"],!0),e.slotScope=t);var n=gr(e,"slot");n&&(e.slotTarget='""'===n?'"default"':n,e.slotTargetDynamic=!(!e.attrsMap[":slot"]&&!e.attrsMap["v-bind:slot"]),"template"===e.tag||e.slotScope||dr(e,"slot",n,vr(e,"slot")));if("template"===e.tag){var i=br(e,Ha);if(i){(e.slotTarget||e.slotScope)&&Ma("Unexpected mixed usage of different slot syntaxes.",e),e.parent&&!Da(e.parent)&&Ma("<template v-slot> can only appear at the root level inside the receiving component",e);var r=ts(i),o=r.name,a=r.dynamic;e.slotTarget=o,e.slotTargetDynamic=a,e.slotScope=i.value||Qa}}else{var s=br(e,Ha);if(s){Da(e)||Ma("v-slot can only be used on components or <template>.",s),(e.slotScope||e.slotTarget)&&Ma("Unexpected mixed usage of different slot syntaxes.",e),e.scopedSlots&&Ma("To avoid scope ambiguity, the default slot should also use <template> syntax when there are other named slots.",s);var l=e.scopedSlots||(e.scopedSlots={}),c=ts(s),u=c.name,d=c.dynamic,h=l[u]=Ka("template",[],e);h.slotTarget=u,h.slotTargetDynamic=d,h.children=e.children.filter((function(e){if(!e.slotScope)return e.parent=h,!0})),h.slotScope=s.value||Qa,e.children=[],e.plain=!1}}}(e),"slot"===(n=e).tag&&(n.slotName=gr(n,"name"),n.key&&Ma("`key` does not work on <slot> because slots are abstract outlets and can possibly expand into multiple elements. Use the key on a wrapping element instead.",vr(n,"key"))),function(e){var t;(t=gr(e,"is"))&&(e.component=t);null!=_r(e,"inline-template")&&(e.inlineTemplate=!0)}(e);for(var i=0;i<Aa.length;i++)e=Aa[i](e,t)||e;return function(e){var t,n,i,r,o,a,s,l,c=e.attrsList;for(t=0,n=c.length;t<n;t++){if(i=r=c[t].name,o=c[t].value,Na.test(i))if(e.hasBindings=!0,(a=ns(i.replace(Na,"")))&&(i=i.replace(Va,"")),Ba.test(i))i=i.replace(Ba,""),o=ar(o),(l=$a.test(i))&&(i=i.slice(1,-1)),0===o.trim().length&&Ma('The value for a v-bind expression cannot be empty. Found in "v-bind:'+i+'"'),a&&(a.prop&&!l&&"innerHtml"===(i=k(i))&&(i="innerHTML"),a.camel&&!l&&(i=k(i)),a.sync&&(s=kr(o,"$event"),l?mr(e,'"update:"+('+i+")",s,null,!1,Ma,c[t],!0):(mr(e,"update:"+k(i),s,null,!1,Ma,c[t]),C(i)!==k(i)&&mr(e,"update:"+C(i),s,null,!1,Ma,c[t])))),a&&a.prop||!e.component&&qa(e.tag,e.attrsMap.type,i)?ur(e,i,o,c[t],l):dr(e,i,o,c[t],l);else if(za.test(i))i=i.replace(za,""),(l=$a.test(i))&&(i=i.slice(1,-1)),mr(e,i,o,a,!1,Ma,c[t],l);else{var u=(i=i.replace(Na,"")).match(Fa),d=u&&u[1];l=!1,d&&(i=i.slice(0,-(d.length+1)),$a.test(d)&&(d=d.slice(1,-1),l=!0)),fr(e,i,r,o,d,l,a,c[t]),"model"===i&&as(e,o)}else ea(o,Ta)&&Ma(i+'="'+o+'": Interpolation inside attributes has been removed. Use v-bind or the colon shorthand instead. For example, instead of <div id="{{ val }}">, use <div :id="val">.',c[t]),dr(e,i,JSON.stringify(o),c[t]),!e.component&&"muted"===i&&qa(e.tag,e.attrsMap.type,i)&&ur(e,i,"true",c[t])}}(e),e}function Xa(e){var t;if(t=_r(e,"v-for")){var n=function(e){var t=e.match(ja);if(!t)return;var n={};n.for=t[2].trim();var i=t[1].trim().replace(Ia,""),r=i.match(Ra);r?(n.alias=i.replace(Ra,"").trim(),n.iterator1=r[1].trim(),r[2]&&(n.iterator2=r[2].trim())):n.alias=i;return n}(t);n?A(e,n):Ma("Invalid v-for expression: "+t,e.rawAttrsMap["v-for"])}}function es(e,t){e.ifConditions||(e.ifConditions=[]),e.ifConditions.push(t)}function ts(e){var t=e.name.replace(Ha,"");return t||("#"!==e.name[0]?t="default":Ma("v-slot shorthand syntax requires a slot name.",e)),$a.test(t)?{name:t.slice(1,-1),dynamic:!0}:{name:'"'+t+'"',dynamic:!1}}function ns(e){var t=e.match(Va);if(t){var n={};return t.forEach((function(e){n[e.slice(1)]=!0})),n}}function is(e){for(var t={},n=0,i=e.length;n<i;n++)!t[e[n].name]||K||J||Ma("duplicate attribute: "+e[n].name,e[n]),t[e[n].name]=e[n].value;return t}var rs=/^xmlns:NS\d+/,os=/^NS\d+:/;function as(e,t){for(var n=e;n;)n.for&&n.alias===t&&Ma("<"+e.tag+' v-model="'+t+'">: You are binding v-model directly to a v-for iteration alias. This will not be able to modify the v-for source array because writing to the alias is like modifying a function local variable. Consider using an array of objects and use v-model on an object property instead.',e.rawAttrsMap["v-model"]),n=n.parent}function ss(e){return Ka(e.tag,e.attrsList.slice(),e.parent)}var ls=[ta,ia,{preTransformNode:function(e,t){if("input"===e.tag){var n,i=e.attrsMap;if(!i["v-model"])return;if((i[":type"]||i["v-bind:type"])&&(n=gr(e,"type")),i.type||n||!i["v-bind"]||(n="("+i["v-bind"]+").type"),n){var r=_r(e,"v-if",!0),o=r?"&&("+r+")":"",a=null!=_r(e,"v-else",!0),s=_r(e,"v-else-if",!0),l=ss(e);Xa(l),hr(l,"type","checkbox"),Ja(l,t),l.processed=!0,l.if="("+n+")==='checkbox'"+o,es(l,{exp:l.if,block:l});var c=ss(e);_r(c,"v-for",!0),hr(c,"type","radio"),Ja(c,t),es(l,{exp:"("+n+")==='radio'"+o,block:c});var u=ss(e);return _r(u,"v-for",!0),hr(u,":type",n),Ja(u,t),es(l,{exp:r,block:u}),a?l.else=!0:s&&(l.elseif=s),l}}}}];var cs,us,ds={model:function(e,t,n){ir=n;var i=t.value,r=t.modifiers,o=e.tag,a=e.attrsMap.type;if("input"===o&&"file"===a&&ir("<"+e.tag+' v-model="'+i+'" type="file">:\nFile inputs are read only. Use a v-on:change listener instead.',e.rawAttrsMap["v-model"]),e.component)return wr(e,i,r),!1;if("select"===o)!function(e,t,n){var i=n&&n.number,r='var $$selectedVal = Array.prototype.filter.call($event.target.options,function(o){return o.selected}).map(function(o){var val = "_value" in o ? o._value : o.value;return '+(i?"_n(val)":"val")+"});";r=r+" "+kr(t,"$event.target.multiple ? $$selectedVal : $$selectedVal[0]"),mr(e,"change",r,null,!0)}(e,i,r);else if("input"===o&&"checkbox"===a)!function(e,t,n){var i=n&&n.number,r=gr(e,"value")||"null",o=gr(e,"true-value")||"true",a=gr(e,"false-value")||"false";ur(e,"checked","Array.isArray("+t+")?_i("+t+","+r+")>-1"+("true"===o?":("+t+")":":_q("+t+","+o+")")),mr(e,"change","var $$a="+t+",$$el=$event.target,$$c=$$el.checked?("+o+"):("+a+");if(Array.isArray($$a)){var $$v="+(i?"_n("+r+")":r)+",$$i=_i($$a,$$v);if($$el.checked){$$i<0&&("+kr(t,"$$a.concat([$$v])")+")}else{$$i>-1&&("+kr(t,"$$a.slice(0,$$i).concat($$a.slice($$i+1))")+")}}else{"+kr(t,"$$c")+"}",null,!0)}(e,i,r);else if("input"===o&&"radio"===a)!function(e,t,n){var i=n&&n.number,r=gr(e,"value")||"null";ur(e,"checked","_q("+t+","+(r=i?"_n("+r+")":r)+")"),mr(e,"change",kr(t,r),null,!0)}(e,i,r);else if("input"===o||"textarea"===o)!function(e,t,n){var i=e.attrsMap.type,r=e.attrsMap["v-bind:value"]||e.attrsMap[":value"],o=e.attrsMap["v-bind:type"]||e.attrsMap[":type"];if(r&&!o){var a=e.attrsMap["v-bind:value"]?"v-bind:value":":value";ir(a+'="'+r+'" conflicts with v-model on the same element because the latter already expands to a value binding internally',e.rawAttrsMap[a])}var s=n||{},l=s.lazy,c=s.number,u=s.trim,d=!l&&"range"!==i,h=l?"change":"range"===i?Pr:"input",f="$event.target.value";u&&(f="$event.target.value.trim()");c&&(f="_n("+f+")");var p=kr(t,f);d&&(p="if($event.target.composing)return;"+p);ur(e,"value","("+t+")"),mr(e,h,p,null,!0),(u||c)&&mr(e,"blur","$forceUpdate()")}(e,i,r);else{if(!I.isReservedTag(o))return wr(e,i,r),!1;ir("<"+e.tag+' v-model="'+i+"\">: v-model is not supported on this element type. If you are working with contenteditable, it's recommended to wrap a library dedicated for that purpose inside a custom component.",e.rawAttrsMap["v-model"])}return!0},text:function(e,t){t.value&&ur(e,"textContent","_s("+t.value+")",t)},html:function(e,t){t.value&&ur(e,"innerHTML","_s("+t.value+")",t)}},hs={expectHTML:!0,modules:ls,directives:ds,isPreTag:function(e){return"pre"===e},isUnaryTag:oa,mustUseProp:di,canBeLeftOpenTag:aa,isReservedTag:Ti,getTagNamespace:Ai,staticKeys:function(e){return e.reduce((function(e,t){return e.concat(t.staticKeys||[])}),[]).join(",")}(ls)},fs=y((function(e){return p("type,tag,attrsList,attrsMap,plain,parent,children,attrs,start,end,rawAttrsMap"+(e?","+e:""))}));function ps(e,t){e&&(cs=fs(t.staticKeys||""),us=t.isReservedTag||O,ms(e),vs(e,!1))}function ms(e){if(e.static=function(e){if(2===e.type)return!1;if(3===e.type)return!0;return!(!e.pre&&(e.hasBindings||e.if||e.for||m(e.tag)||!us(e.tag)||function(e){for(;e.parent;){if("template"!==(e=e.parent).tag)return!1;if(e.for)return!0}return!1}(e)||!Object.keys(e).every(cs)))}(e),1===e.type){if(!us(e.tag)&&"slot"!==e.tag&&null==e.attrsMap["inline-template"])return;for(var t=0,n=e.children.length;t<n;t++){var i=e.children[t];ms(i),i.static||(e.static=!1)}if(e.ifConditions)for(var r=1,o=e.ifConditions.length;r<o;r++){var a=e.ifConditions[r].block;ms(a),a.static||(e.static=!1)}}}function vs(e,t){if(1===e.type){if((e.static||e.once)&&(e.staticInFor=t),e.static&&e.children.length&&(1!==e.children.length||3!==e.children[0].type))return void(e.staticRoot=!0);if(e.staticRoot=!1,e.children)for(var n=0,i=e.children.length;n<i;n++)vs(e.children[n],t||!!e.for);if(e.ifConditions)for(var r=1,o=e.ifConditions.length;r<o;r++)vs(e.ifConditions[r].block,t)}}var gs=/^([\w$_]+|\([^)]*?\))\s*=>|^function(?:\s+[\w$]+)?\s*\(/,_s=/\([^)]*?\);*$/,bs=/^[A-Za-z_$][\w$]*(?:\.[A-Za-z_$][\w$]*|\['[^']*?']|\["[^"]*?"]|\[\d+]|\[[A-Za-z_$][\w$]*])*$/,ys={esc:27,tab:9,enter:13,space:32,up:38,left:37,right:39,down:40,delete:[8,46]},ws={esc:["Esc","Escape"],tab:"Tab",enter:"Enter",space:[" ","Spacebar"],up:["Up","ArrowUp"],left:["Left","ArrowLeft"],right:["Right","ArrowRight"],down:["Down","ArrowDown"],delete:["Backspace","Delete","Del"]},ks=function(e){return"if("+e+")return null;"},xs={stop:"$event.stopPropagation();",prevent:"$event.preventDefault();",self:ks("$event.target !== $event.currentTarget"),ctrl:ks("!$event.ctrlKey"),shift:ks("!$event.shiftKey"),alt:ks("!$event.altKey"),meta:ks("!$event.metaKey"),left:ks("'button' in $event && $event.button !== 0"),middle:ks("'button' in $event && $event.button !== 1"),right:ks("'button' in $event && $event.button !== 2")};function Ss(e,t){var n=t?"nativeOn:":"on:",i="",r="";for(var o in e){var a=Cs(e[o]);e[o]&&e[o].dynamic?r+=o+","+a+",":i+='"'+o+'":'+a+","}return i="{"+i.slice(0,-1)+"}",r?n+"_d("+i+",["+r.slice(0,-1)+"])":n+i}function Cs(e){if(!e)return"function(){}";if(Array.isArray(e))return"["+e.map((function(e){return Cs(e)})).join(",")+"]";var t=bs.test(e.value),n=gs.test(e.value),i=bs.test(e.value.replace(_s,""));if(e.modifiers){var r="",o="",a=[];for(var s in e.modifiers)if(xs[s])o+=xs[s],ys[s]&&a.push(s);else if("exact"===s){var l=e.modifiers;o+=ks(["ctrl","shift","alt","meta"].filter((function(e){return!l[e]})).map((function(e){return"$event."+e+"Key"})).join("||"))}else a.push(s);return a.length&&(r+=function(e){return"if(!$event.type.indexOf('key')&&"+e.map(Ms).join("&&")+")return null;"}(a)),o&&(r+=o),"function($event){"+r+(t?"return "+e.value+"($event)":n?"return ("+e.value+")($event)":i?"return "+e.value:e.value)+"}"}return t||n?e.value:"function($event){"+(i?"return "+e.value:e.value)+"}"}function Ms(e){var t=parseInt(e,10);if(t)return"$event.keyCode!=="+t;var n=ys[e],i=ws[e];return"_k($event.keyCode,"+JSON.stringify(e)+","+JSON.stringify(n)+",$event.key,"+JSON.stringify(i)+")"}var Ts={on:function(e,t){t.modifiers&&ce("v-on without argument does not support modifiers."),e.wrapListeners=function(e){return"_g("+e+","+t.value+")"}},bind:function(e,t){e.wrapData=function(n){return"_b("+n+",'"+e.tag+"',"+t.value+","+(t.modifiers&&t.modifiers.prop?"true":"false")+(t.modifiers&&t.modifiers.sync?",true":"")+")"}},cloak:L},As=function(e){this.options=e,this.warn=e.warn||lr,this.transforms=cr(e.modules,"transformCode"),this.dataGenFns=cr(e.modules,"genData"),this.directives=A(A({},Ts),e.directives);var t=e.isReservedTag||O;this.maybeComponent=function(e){return!!e.component||!t(e.tag)},this.onceId=0,this.staticRenderFns=[],this.pre=!1};function Ps(e,t){var n=new As(t);return{render:"with(this){return "+(e?Ls(e,n):'_c("div")')+"}",staticRenderFns:n.staticRenderFns}}function Ls(e,t){if(e.parent&&(e.pre=e.pre||e.parent.pre),e.staticRoot&&!e.staticProcessed)return Os(e,t);if(e.once&&!e.onceProcessed)return qs(e,t);if(e.for&&!e.forProcessed)return zs(e,t);if(e.if&&!e.ifProcessed)return Es(e,t);if("template"!==e.tag||e.slotTarget||t.pre){if("slot"===e.tag)return function(e,t){var n=e.slotName||'"default"',i=Is(e,t),r="_t("+n+(i?","+i:""),o=e.attrs||e.dynamicAttrs?Bs((e.attrs||[]).concat(e.dynamicAttrs||[]).map((function(e){return{name:k(e.name),value:e.value,dynamic:e.dynamic}}))):null,a=e.attrsMap["v-bind"];!o&&!a||i||(r+=",null");o&&(r+=","+o);a&&(r+=(o?"":",null")+","+a);return r+")"}(e,t);var n;if(e.component)n=function(e,t,n){var i=t.inlineTemplate?null:Is(t,n,!0);return"_c("+e+","+Ns(t,n)+(i?","+i:"")+")"}(e.component,e,t);else{var i;(!e.plain||e.pre&&t.maybeComponent(e))&&(i=Ns(e,t));var r=e.inlineTemplate?null:Is(e,t,!0);n="_c('"+e.tag+"'"+(i?","+i:"")+(r?","+r:"")+")"}for(var o=0;o<t.transforms.length;o++)n=t.transforms[o](e,n);return n}return Is(e,t)||"void 0"}function Os(e,t){e.staticProcessed=!0;var n=t.pre;return e.pre&&(t.pre=e.pre),t.staticRenderFns.push("with(this){return "+Ls(e,t)+"}"),t.pre=n,"_m("+(t.staticRenderFns.length-1)+(e.staticInFor?",true":"")+")"}function qs(e,t){if(e.onceProcessed=!0,e.if&&!e.ifProcessed)return Es(e,t);if(e.staticInFor){for(var n="",i=e.parent;i;){if(i.for){n=i.key;break}i=i.parent}return n?"_o("+Ls(e,t)+","+t.onceId+++","+n+")":(t.warn("v-once can only be used inside v-for that is keyed. ",e.rawAttrsMap["v-once"]),Ls(e,t))}return Os(e,t)}function Es(e,t,n,i){return e.ifProcessed=!0,Ds(e.ifConditions.slice(),t,n,i)}function Ds(e,t,n,i){if(!e.length)return i||"_e()";var r=e.shift();return r.exp?"("+r.exp+")?"+o(r.block)+":"+Ds(e,t,n,i):""+o(r.block);function o(e){return n?n(e,t):e.once?qs(e,t):Ls(e,t)}}function zs(e,t,n,i){var r=e.for,o=e.alias,a=e.iterator1?","+e.iterator1:"",s=e.iterator2?","+e.iterator2:"";return t.maybeComponent(e)&&"slot"!==e.tag&&"template"!==e.tag&&!e.key&&t.warn("<"+e.tag+' v-for="'+o+" in "+r+'">: component lists rendered with v-for should have explicit keys. See https://vuejs.org/guide/list.html#key for more info.',e.rawAttrsMap["v-for"],!0),e.forProcessed=!0,(i||"_l")+"(("+r+"),function("+o+a+s+"){return "+(n||Ls)(e,t)+"})"}function Ns(e,t){var n="{",i=function(e,t){var n=e.directives;if(!n)return;var i,r,o,a,s="directives:[",l=!1;for(i=0,r=n.length;i<r;i++){o=n[i],a=!0;var c=t.directives[o.name];c&&(a=!!c(e,o,t.warn)),a&&(l=!0,s+='{name:"'+o.name+'",rawName:"'+o.rawName+'"'+(o.value?",value:("+o.value+"),expression:"+JSON.stringify(o.value):"")+(o.arg?",arg:"+(o.isDynamicArg?o.arg:'"'+o.arg+'"'):"")+(o.modifiers?",modifiers:"+JSON.stringify(o.modifiers):"")+"},")}if(l)return s.slice(0,-1)+"]"}(e,t);i&&(n+=i+","),e.key&&(n+="key:"+e.key+","),e.ref&&(n+="ref:"+e.ref+","),e.refInFor&&(n+="refInFor:true,"),e.pre&&(n+="pre:true,"),e.component&&(n+='tag:"'+e.tag+'",');for(var r=0;r<t.dataGenFns.length;r++)n+=t.dataGenFns[r](e);if(e.attrs&&(n+="attrs:"+Bs(e.attrs)+","),e.props&&(n+="domProps:"+Bs(e.props)+","),e.events&&(n+=Ss(e.events,!1)+","),e.nativeEvents&&(n+=Ss(e.nativeEvents,!0)+","),e.slotTarget&&!e.slotScope&&(n+="slot:"+e.slotTarget+","),e.scopedSlots&&(n+=function(e,t,n){var i=e.for||Object.keys(t).some((function(e){var n=t[e];return n.slotTargetDynamic||n.if||n.for||js(n)})),r=!!e.if;if(!i)for(var o=e.parent;o;){if(o.slotScope&&o.slotScope!==Qa||o.for){i=!0;break}o.if&&(r=!0),o=o.parent}var a=Object.keys(t).map((function(e){return Rs(t[e],n)})).join(",");return"scopedSlots:_u(["+a+"]"+(i?",null,true":"")+(!i&&r?",null,false,"+function(e){var t=5381,n=e.length;for(;n;)t=33*t^e.charCodeAt(--n);return t>>>0}(a):"")+")"}(e,e.scopedSlots,t)+","),e.model&&(n+="model:{value:"+e.model.value+",callback:"+e.model.callback+",expression:"+e.model.expression+"},"),e.inlineTemplate){var o=function(e,t){var n=e.children[0];1===e.children.length&&1===n.type||t.warn("Inline-template components must have exactly one child element.",{start:e.start});if(n&&1===n.type){var i=Ps(n,t.options);return"inlineTemplate:{render:function(){"+i.render+"},staticRenderFns:["+i.staticRenderFns.map((function(e){return"function(){"+e+"}"})).join(",")+"]}"}}(e,t);o&&(n+=o+",")}return n=n.replace(/,$/,"")+"}",e.dynamicAttrs&&(n="_b("+n+',"'+e.tag+'",'+Bs(e.dynamicAttrs)+")"),e.wrapData&&(n=e.wrapData(n)),e.wrapListeners&&(n=e.wrapListeners(n)),n}function js(e){return 1===e.type&&("slot"===e.tag||e.children.some(js))}function Rs(e,t){var n=e.attrsMap["slot-scope"];if(e.if&&!e.ifProcessed&&!n)return Es(e,t,Rs,"null");if(e.for&&!e.forProcessed)return zs(e,t,Rs);var i=e.slotScope===Qa?"":String(e.slotScope),r="function("+i+"){return "+("template"===e.tag?e.if&&n?"("+e.if+")?"+(Is(e,t)||"undefined")+":undefined":Is(e,t)||"undefined":Ls(e,t))+"}",o=i?"":",proxy:true";return"{key:"+(e.slotTarget||'"default"')+",fn:"+r+o+"}"}function Is(e,t,n,i,r){var o=e.children;if(o.length){var a=o[0];if(1===o.length&&a.for&&"template"!==a.tag&&"slot"!==a.tag){var s=n?t.maybeComponent(a)?",1":",0":"";return""+(i||Ls)(a,t)+s}var l=n?function(e,t){for(var n=0,i=0;i<e.length;i++){var r=e[i];if(1===r.type){if($s(r)||r.ifConditions&&r.ifConditions.some((function(e){return $s(e.block)}))){n=2;break}(t(r)||r.ifConditions&&r.ifConditions.some((function(e){return t(e.block)})))&&(n=1)}}return n}(o,t.maybeComponent):0,c=r||Fs;return"["+o.map((function(e){return c(e,t)})).join(",")+"]"+(l?","+l:"")}}function $s(e){return void 0!==e.for||"template"===e.tag||"slot"===e.tag}function Fs(e,t){return 1===e.type?Ls(e,t):3===e.type&&e.isComment?function(e){return"_e("+JSON.stringify(e.text)+")"}(e):function(e){return"_v("+(2===e.type?e.expression:Vs(JSON.stringify(e.text)))+")"}(e)}function Bs(e){for(var t="",n="",i=0;i<e.length;i++){var r=e[i],o=Vs(r.value);r.dynamic?n+=r.name+","+o+",":t+='"'+r.name+'":'+o+","}return t="{"+t.slice(0,-1)+"}",n?"_d("+t+",["+n.slice(0,-1)+"])":t}function Vs(e){return e.replace(/\u2028/g,"\\u2028").replace(/\u2029/g,"\\u2029")}var Hs=new RegExp("\\b"+"do,if,for,let,new,try,var,case,else,with,await,break,catch,class,const,super,throw,while,yield,delete,export,import,return,switch,default,extends,finally,continue,debugger,function,arguments".split(",").join("\\b|\\b")+"\\b"),Ws=new RegExp("\\b"+"delete,typeof,void".split(",").join("\\s*\\([^\\)]*\\)|\\b")+"\\s*\\([^\\)]*\\)"),Us=/'(?:[^'\\]|\\.)*'|"(?:[^"\\]|\\.)*"|`(?:[^`\\]|\\.)*\$\{|\}(?:[^`\\]|\\.)*`|`(?:[^`\\]|\\.)*`/g;function Ys(e,t){e&&Gs(e,t)}function Gs(e,t){if(1===e.type){for(var n in e.attrsMap)if(Na.test(n)){var i=e.attrsMap[n];if(i){var r=e.rawAttrsMap[n];"v-for"===n?Ks(e,'v-for="'+i+'"',t,r):"v-slot"===n||"#"===n[0]?Xs(i,n+'="'+i+'"',t,r):za.test(n)?Qs(i,n+'="'+i+'"',t,r):Js(i,n+'="'+i+'"',t,r)}}if(e.children)for(var o=0;o<e.children.length;o++)Gs(e.children[o],t)}else 2===e.type&&Js(e.expression,e.text,t,e)}function Qs(e,t,n,i){var r=e.replace(Us,""),o=r.match(Ws);o&&"$"!==r.charAt(o.index-1)&&n('avoid using JavaScript unary operator as property name: "'+o[0]+'" in expression '+t.trim(),i),Js(e,t,n,i)}function Ks(e,t,n,i){Js(e.for||"",t,n,i),Zs(e.alias,"v-for alias",t,n,i),Zs(e.iterator1,"v-for iterator",t,n,i),Zs(e.iterator2,"v-for iterator",t,n,i)}function Zs(e,t,n,i,r){if("string"==typeof e)try{new Function("var "+e+"=_")}catch(o){i("invalid "+t+' "'+e+'" in expression: '+n.trim(),r)}}function Js(e,t,n,i){try{new Function("return "+e)}catch(o){var r=e.replace(Us,"").match(Hs);n(r?'avoid using JavaScript keyword as property name: "'+r[0]+'"\n  Raw expression: '+t.trim():"invalid expression: "+o.message+" in\n\n    "+e+"\n\n  Raw expression: "+t.trim()+"\n",i)}}function Xs(e,t,n,i){try{new Function(e,"")}catch(r){n("invalid function parameter expression: "+r.message+" in\n\n    "+e+"\n\n  Raw expression: "+t.trim()+"\n",i)}}var el=2;function tl(e,t){var n="";if(t>0)for(;1&t&&(n+=e),!((t>>>=1)<=0);)e+=e;return n}function nl(e,t){try{return new Function(e)}catch(n){return t.push({err:n,code:e}),L}}function il(e){var t=Object.create(null);return function(n,i,r){var o=(i=A({},i)).warn||ce;delete i.warn;try{new Function("return 1")}catch(e){e.toString().match(/unsafe-eval|CSP/)&&o("It seems you are using the standalone build of Vue.js in an environment with Content Security Policy that prohibits unsafe-eval. The template compiler cannot work in this environment. Consider relaxing the policy to allow unsafe-eval or pre-compiling your templates into render functions.")}var a=i.delimiters?String(i.delimiters)+n:n;if(t[a])return t[a];var s=e(n,i);s.errors&&s.errors.length&&(i.outputSourceRange?s.errors.forEach((function(e){o("Error compiling template:\n\n"+e.msg+"\n\n"+function(e,t,n){void 0===t&&(t=0),void 0===n&&(n=e.length);for(var i=e.split(/\r?\n/),r=0,o=[],a=0;a<i.length;a++)if((r+=i[a].length+1)>=t){for(var s=a-el;s<=a+el||n>r;s++)if(!(s<0||s>=i.length)){o.push(""+(s+1)+tl(" ",3-String(s+1).length)+"|  "+i[s]);var l=i[s].length;if(s===a){var c=t-(r-l)+1,u=n>r?l-c:n-t;o.push("   |  "+tl(" ",c)+tl("^",u))}else if(s>a){if(n>r){var d=Math.min(n-r,l);o.push("   |  "+tl("^",d))}r+=l+1}}break}return o.join("\n")}(n,e.start,e.end),r)})):o("Error compiling template:\n\n"+n+"\n\n"+s.errors.map((function(e){return"- "+e})).join("\n")+"\n",r)),s.tips&&s.tips.length&&(i.outputSourceRange?s.tips.forEach((function(e){return ue(e.msg,r)})):s.tips.forEach((function(e){return ue(e,r)})));var l={},c=[];return l.render=nl(s.render,c),l.staticRenderFns=s.staticRenderFns.map((function(e){return nl(e,c)})),s.errors&&s.errors.length||!c.length||o("Failed to generate render function:\n\n"+c.map((function(e){var t=e.err,n=e.code;return t.toString()+" in\n\n"+n+"\n"})).join("\n"),r),t[a]=l}}var rl,ol,al=(rl=function(e,t){var n=Za(e.trim(),t);!1!==t.optimize&&ps(n,t);var i=Ps(n,t);return{ast:n,render:i.render,staticRenderFns:i.staticRenderFns}},function(e){function t(t,n){var i=Object.create(e),r=[],o=[],a=function(e,t,n){(n?o:r).push(e)};if(n){if(n.outputSourceRange){var s=t.match(/^\s*/)[0].length;a=function(e,t,n){var i={msg:e};t&&(null!=t.start&&(i.start=t.start+s),null!=t.end&&(i.end=t.end+s)),(n?o:r).push(i)}}for(var l in n.modules&&(i.modules=(e.modules||[]).concat(n.modules)),n.directives&&(i.directives=A(Object.create(e.directives||null),n.directives)),n)"modules"!==l&&"directives"!==l&&(i[l]=n[l])}i.warn=a;var c=rl(t.trim(),i);return Ys(c.ast,a),c.errors=r,c.tips=o,c}return{compile:t,compileToFunctions:il(t)}}),sl=al(hs),ll=(sl.compile,sl.compileToFunctions);function cl(e){return(ol=ol||document.createElement("div")).innerHTML=e?'<a href="\n"/>':'<div a="\n"/>',ol.innerHTML.indexOf("&#10;")>0}var ul=!!U&&cl(!1),dl=!!U&&cl(!0),hl=y((function(e){var t=Oi(e);return t&&t.innerHTML})),fl=ti.prototype.$mount;return ti.prototype.$mount=function(e,t){if((e=e&&Oi(e))===document.body||e===document.documentElement)return ce("Do not mount Vue to <html> or <body> - mount to normal elements instead."),this;var n=this.$options;if(!n.render){var i=n.template;if(i)if("string"==typeof i)"#"===i.charAt(0)&&((i=hl(i))||ce("Template element not found or is empty: "+n.template,this));else{if(!i.nodeType)return ce("invalid template option:"+i,this),this;i=i.innerHTML}else e&&(i=function(e){if(e.outerHTML)return e.outerHTML;var t=document.createElement("div");return t.appendChild(e.cloneNode(!0)),t.innerHTML}(e));if(i){I.performance&&ot&&ot("compile");var r=ll(i,{outputSourceRange:!0,shouldDecodeNewlines:ul,shouldDecodeNewlinesForHref:dl,delimiters:n.delimiters,comments:n.comments},this),o=r.render,a=r.staticRenderFns;n.render=o,n.staticRenderFns=a,I.performance&&ot&&(ot("compile end"),at("vue "+this._name+" compile","compile","compile end"))}}return fl.call(this,e,t)},ti.compile=ll,ti})),
/*!
  * vue-router v3.4.3
  * (c) 2020 Evan You
  * @license MIT
  */
function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e=e||self).VueRouter=t()}(this,(function(){"use strict";function e(e,t){if(!e)throw new Error("[vue-router] "+t)}function t(e,t){e||"undefined"!=typeof console&&console.warn("[vue-router] "+t)}function n(e,t){for(var n in t)e[n]=t[n];return e}var i={name:"RouterView",functional:!0,props:{name:{type:String,default:"default"}},render:function(e,t){var i=t.props,o=t.children,a=t.parent,s=t.data;s.routerView=!0;for(var l=a.$createElement,c=i.name,u=a.$route,d=a._routerViewCache||(a._routerViewCache={}),h=0,f=!1;a&&a._routerRoot!==a;){var p=a.$vnode?a.$vnode.data:{};p.routerView&&h++,p.keepAlive&&a._directInactive&&a._inactive&&(f=!0),a=a.$parent}if(s.routerViewDepth=h,f){var m=d[c],v=m&&m.component;return v?(m.configProps&&r(v,s,m.route,m.configProps),l(v,s,o)):l()}var g=u.matched[h],_=g&&g.components[c];if(!g||!_)return d[c]=null,l();d[c]={component:_},s.registerRouteInstance=function(e,t){var n=g.instances[c];(t&&n!==e||!t&&n===e)&&(g.instances[c]=t)},(s.hook||(s.hook={})).prepatch=function(e,t){g.instances[c]=t.componentInstance},s.hook.init=function(e){e.data.keepAlive&&e.componentInstance&&e.componentInstance!==g.instances[c]&&(g.instances[c]=e.componentInstance)};var b=g.props&&g.props[c];return b&&(n(d[c],{route:u,configProps:b}),r(_,s,u,b)),l(_,s,o)}};function r(e,i,r,o){var a=i.props=function(e,n){switch(typeof n){case"undefined":return;case"object":return n;case"function":return n(e);case"boolean":return n?e.params:void 0;default:t(!1,'props in "'+e.path+'" is a '+typeof n+", expecting an object, function or boolean.")}}(r,o);if(a){a=i.props=n({},a);var s=i.attrs=i.attrs||{};for(var l in a)e.props&&l in e.props||(s[l]=a[l],delete a[l])}}var o=/[!'()*]/g,a=function(e){return"%"+e.charCodeAt(0).toString(16)},s=/%2C/g,l=function(e){return encodeURIComponent(e).replace(o,a).replace(s,",")},c=decodeURIComponent;var u=function(e){return null==e||"object"==typeof e?e:String(e)};function d(e){var t={};return(e=e.trim().replace(/^(\?|#|&)/,""))?(e.split("&").forEach((function(e){var n=e.replace(/\+/g," ").split("="),i=c(n.shift()),r=n.length>0?c(n.join("=")):null;void 0===t[i]?t[i]=r:Array.isArray(t[i])?t[i].push(r):t[i]=[t[i],r]})),t):t}function h(e){var t=e?Object.keys(e).map((function(t){var n=e[t];if(void 0===n)return"";if(null===n)return l(t);if(Array.isArray(n)){var i=[];return n.forEach((function(e){void 0!==e&&(null===e?i.push(l(t)):i.push(l(t)+"="+l(e)))})),i.join("&")}return l(t)+"="+l(n)})).filter((function(e){return e.length>0})).join("&"):null;return t?"?"+t:""}var f=/\/?$/;function p(e,t,n,i){var r=i&&i.options.stringifyQuery,o=t.query||{};try{o=m(o)}catch(e){}var a={name:t.name||e&&e.name,meta:e&&e.meta||{},path:t.path||"/",hash:t.hash||"",query:o,params:t.params||{},fullPath:_(t,r),matched:e?g(e):[]};return n&&(a.redirectedFrom=_(n,r)),Object.freeze(a)}function m(e){if(Array.isArray(e))return e.map(m);if(e&&"object"==typeof e){var t={};for(var n in e)t[n]=m(e[n]);return t}return e}var v=p(null,{path:"/"});function g(e){for(var t=[];e;)t.unshift(e),e=e.parent;return t}function _(e,t){var n=e.path,i=e.query;void 0===i&&(i={});var r=e.hash;return void 0===r&&(r=""),(n||"/")+(t||h)(i)+r}function b(e,t){return t===v?e===t:!!t&&(e.path&&t.path?e.path.replace(f,"")===t.path.replace(f,"")&&e.hash===t.hash&&y(e.query,t.query):!(!e.name||!t.name)&&(e.name===t.name&&e.hash===t.hash&&y(e.query,t.query)&&y(e.params,t.params)))}function y(e,t){if(void 0===e&&(e={}),void 0===t&&(t={}),!e||!t)return e===t;var n=Object.keys(e),i=Object.keys(t);return n.length===i.length&&n.every((function(n){var i=e[n],r=t[n];return null==i||null==r?i===r:"object"==typeof i&&"object"==typeof r?y(i,r):String(i)===String(r)}))}function w(e,t,n){var i=e.charAt(0);if("/"===i)return e;if("?"===i||"#"===i)return t+e;var r=t.split("/");n&&r[r.length-1]||r.pop();for(var o=e.replace(/^\//,"").split("/"),a=0;a<o.length;a++){var s=o[a];".."===s?r.pop():"."!==s&&r.push(s)}return""!==r[0]&&r.unshift(""),r.join("/")}function k(e){return e.replace(/\/\//g,"/")}var x=Array.isArray||function(e){return"[object Array]"==Object.prototype.toString.call(e)},S=R,C=L,M=function(e,t){return q(L(e,t),t)},T=q,A=j,P=new RegExp(["(\\\\.)","([\\/.])?(?:(?:\\:(\\w+)(?:\\(((?:\\\\.|[^\\\\()])+)\\))?|\\(((?:\\\\.|[^\\\\()])+)\\))([+*?])?|(\\*))"].join("|"),"g");function L(e,t){for(var n,i=[],r=0,o=0,a="",s=t&&t.delimiter||"/";null!=(n=P.exec(e));){var l=n[0],c=n[1],u=n.index;if(a+=e.slice(o,u),o=u+l.length,c)a+=c[1];else{var d=e[o],h=n[2],f=n[3],p=n[4],m=n[5],v=n[6],g=n[7];a&&(i.push(a),a="");var _=null!=h&&null!=d&&d!==h,b="+"===v||"*"===v,y="?"===v||"*"===v,w=n[2]||s,k=p||m;i.push({name:f||r++,prefix:h||"",delimiter:w,optional:y,repeat:b,partial:_,asterisk:!!g,pattern:k?D(k):g?".*":"[^"+E(w)+"]+?"})}}return o<e.length&&(a+=e.substr(o)),a&&i.push(a),i}function O(e){return encodeURI(e).replace(/[\/?#]/g,(function(e){return"%"+e.charCodeAt(0).toString(16).toUpperCase()}))}function q(e,t){for(var n=new Array(e.length),i=0;i<e.length;i++)"object"==typeof e[i]&&(n[i]=new RegExp("^(?:"+e[i].pattern+")$",N(t)));return function(t,i){for(var r="",o=t||{},a=(i||{}).pretty?O:encodeURIComponent,s=0;s<e.length;s++){var l=e[s];if("string"!=typeof l){var c,u=o[l.name];if(null==u){if(l.optional){l.partial&&(r+=l.prefix);continue}throw new TypeError('Expected "'+l.name+'" to be defined')}if(x(u)){if(!l.repeat)throw new TypeError('Expected "'+l.name+'" to not repeat, but received `'+JSON.stringify(u)+"`");if(0===u.length){if(l.optional)continue;throw new TypeError('Expected "'+l.name+'" to not be empty')}for(var d=0;d<u.length;d++){if(c=a(u[d]),!n[s].test(c))throw new TypeError('Expected all "'+l.name+'" to match "'+l.pattern+'", but received `'+JSON.stringify(c)+"`");r+=(0===d?l.prefix:l.delimiter)+c}}else{if(c=l.asterisk?encodeURI(u).replace(/[?#]/g,(function(e){return"%"+e.charCodeAt(0).toString(16).toUpperCase()})):a(u),!n[s].test(c))throw new TypeError('Expected "'+l.name+'" to match "'+l.pattern+'", but received "'+c+'"');r+=l.prefix+c}}else r+=l}return r}}function E(e){return e.replace(/([.+*?=^!:${}()[\]|\/\\])/g,"\\$1")}function D(e){return e.replace(/([=!:$\/()])/g,"\\$1")}function z(e,t){return e.keys=t,e}function N(e){return e&&e.sensitive?"":"i"}function j(e,t,n){x(t)||(n=t||n,t=[]);for(var i=(n=n||{}).strict,r=!1!==n.end,o="",a=0;a<e.length;a++){var s=e[a];if("string"==typeof s)o+=E(s);else{var l=E(s.prefix),c="(?:"+s.pattern+")";t.push(s),s.repeat&&(c+="(?:"+l+c+")*"),o+=c=s.optional?s.partial?l+"("+c+")?":"(?:"+l+"("+c+"))?":l+"("+c+")"}}var u=E(n.delimiter||"/"),d=o.slice(-u.length)===u;return i||(o=(d?o.slice(0,-u.length):o)+"(?:"+u+"(?=$))?"),o+=r?"$":i&&d?"":"(?="+u+"|$)",z(new RegExp("^"+o,N(n)),t)}function R(e,t,n){return x(t)||(n=t||n,t=[]),n=n||{},e instanceof RegExp?function(e,t){var n=e.source.match(/\((?!\?)/g);if(n)for(var i=0;i<n.length;i++)t.push({name:i,prefix:null,delimiter:null,optional:!1,repeat:!1,partial:!1,asterisk:!1,pattern:null});return z(e,t)}(e,t):x(e)?function(e,t,n){for(var i=[],r=0;r<e.length;r++)i.push(R(e[r],t,n).source);return z(new RegExp("(?:"+i.join("|")+")",N(n)),t)}(e,t,n):function(e,t,n){return j(L(e,n),t,n)}(e,t,n)}S.parse=C,S.compile=M,S.tokensToFunction=T,S.tokensToRegExp=A;var I=Object.create(null);function $(e,n,i){n=n||{};try{var r=I[e]||(I[e]=S.compile(e));return"string"==typeof n.pathMatch&&(n[0]=n.pathMatch),r(n,{pretty:!0})}catch(e){return t("string"==typeof n.pathMatch,"missing param for "+i+": "+e.message),""}finally{delete n[0]}}function F(e,i,r,o){var a="string"==typeof e?{path:e}:e;if(a._normalized)return a;if(a.name){var s=(a=n({},e)).params;return s&&"object"==typeof s&&(a.params=n({},s)),a}if(!a.path&&a.params&&i){(a=n({},a))._normalized=!0;var l=n(n({},i.params),a.params);if(i.name)a.name=i.name,a.params=l;else if(i.matched.length){var c=i.matched[i.matched.length-1].path;a.path=$(c,l,"path "+i.path)}else t(!1,"relative params navigation requires a current route.");return a}var h=function(e){var t="",n="",i=e.indexOf("#");i>=0&&(t=e.slice(i),e=e.slice(0,i));var r=e.indexOf("?");return r>=0&&(n=e.slice(r+1),e=e.slice(0,r)),{path:e,query:n,hash:t}}(a.path||""),f=i&&i.path||"/",p=h.path?w(h.path,f,r||a.append):f,m=function(e,n,i){void 0===n&&(n={});var r,o=i||d;try{r=o(e||"")}catch(e){t(!1,e.message),r={}}for(var a in n){var s=n[a];r[a]=Array.isArray(s)?s.map(u):u(s)}return r}(h.query,a.query,o&&o.options.parseQuery),v=a.hash||h.hash;return v&&"#"!==v.charAt(0)&&(v="#"+v),{_normalized:!0,path:p,query:m,hash:v}}var B,V=function(){},H={name:"RouterLink",props:{to:{type:[String,Object],required:!0},tag:{type:String,default:"a"},exact:Boolean,append:Boolean,replace:Boolean,activeClass:String,exactActiveClass:String,ariaCurrentValue:{type:String,default:"page"},event:{type:[String,Array],default:"click"}},render:function(e){var i=this,r=this.$router,o=this.$route,a=r.resolve(this.to,o,this.append),s=a.location,l=a.route,c=a.href,u={},d=r.options.linkActiveClass,h=r.options.linkExactActiveClass,m=null==d?"router-link-active":d,v=null==h?"router-link-exact-active":h,g=null==this.activeClass?m:this.activeClass,_=null==this.exactActiveClass?v:this.exactActiveClass,y=l.redirectedFrom?p(null,F(l.redirectedFrom),null,r):l;u[_]=b(o,y),u[g]=this.exact?u[_]:function(e,t){return 0===e.path.replace(f,"/").indexOf(t.path.replace(f,"/"))&&(!t.hash||e.hash===t.hash)&&function(e,t){for(var n in t)if(!(n in e))return!1;return!0}(e.query,t.query)}(o,y);var w=u[_]?this.ariaCurrentValue:null,k=function(e){W(e)&&(i.replace?r.replace(s,V):r.push(s,V))},x={click:W};Array.isArray(this.event)?this.event.forEach((function(e){x[e]=k})):x[this.event]=k;var S={class:u},C=!this.$scopedSlots.$hasNormal&&this.$scopedSlots.default&&this.$scopedSlots.default({href:c,route:l,navigate:k,isActive:u[g],isExactActive:u[_]});if(C){if(1===C.length)return C[0];if(C.length>1||!C.length)return t(!1,'RouterLink with to="'+this.to+"\" is trying to use a scoped slot but it didn't provide exactly one child. Wrapping the content with a span element."),0===C.length?e():e("span",{},C)}if("a"===this.tag)S.on=x,S.attrs={href:c,"aria-current":w};else{var M=U(this.$slots.default);if(M){M.isStatic=!1;var T=M.data=n({},M.data);for(var A in T.on=T.on||{},T.on){var P=T.on[A];A in x&&(T.on[A]=Array.isArray(P)?P:[P])}for(var L in x)L in T.on?T.on[L].push(x[L]):T.on[L]=k;var O=M.data.attrs=n({},M.data.attrs);O.href=c,O["aria-current"]=w}else S.on=x}return e(this.tag,S,this.$slots.default)}};function W(e){if(!(e.metaKey||e.altKey||e.ctrlKey||e.shiftKey||e.defaultPrevented||void 0!==e.button&&0!==e.button)){if(e.currentTarget&&e.currentTarget.getAttribute){var t=e.currentTarget.getAttribute("target");if(/\b_blank\b/i.test(t))return}return e.preventDefault&&e.preventDefault(),!0}}function U(e){if(e)for(var t,n=0;n<e.length;n++){if("a"===(t=e[n]).tag)return t;if(t.children&&(t=U(t.children)))return t}}function Y(e){if(!Y.installed||B!==e){Y.installed=!0,B=e;var t=function(e){return void 0!==e},n=function(e,n){var i=e.$options._parentVnode;t(i)&&t(i=i.data)&&t(i=i.registerRouteInstance)&&i(e,n)};e.mixin({beforeCreate:function(){t(this.$options.router)?(this._routerRoot=this,this._router=this.$options.router,this._router.init(this),e.util.defineReactive(this,"_route",this._router.history.current)):this._routerRoot=this.$parent&&this.$parent._routerRoot||this,n(this,this)},destroyed:function(){n(this)}}),Object.defineProperty(e.prototype,"$router",{get:function(){return this._routerRoot._router}}),Object.defineProperty(e.prototype,"$route",{get:function(){return this._routerRoot._route}}),e.component("RouterView",i),e.component("RouterLink",H);var r=e.config.optionMergeStrategies;r.beforeRouteEnter=r.beforeRouteLeave=r.beforeRouteUpdate=r.created}}var G="undefined"!=typeof window;function Q(e,n,i,r){var o=n||[],a=i||Object.create(null),s=r||Object.create(null);e.forEach((function(e){K(o,a,s,e)}));for(var l=0,c=o.length;l<c;l++)"*"===o[l]&&(o.push(o.splice(l,1)[0]),c--,l--);var u=o.filter((function(e){return e&&"*"!==e.charAt(0)&&"/"!==e.charAt(0)}));u.length>0&&t(!1,"Non-nested routes must include a leading slash character. Fix the following routes: \n"+u.map((function(e){return"- "+e})).join("\n"));return{pathList:o,pathMap:a,nameMap:s}}function K(n,i,r,o,a,s){var l=o.path,c=o.name;e(null!=l,'"path" is required in a route configuration.'),e("string"!=typeof o.component,'route config "component" for path: '+String(l||c)+" cannot be a string id. Use an actual component instead.");var u=o.pathToRegexpOptions||{},d=function(e,t,n){n||(e=e.replace(/\/$/,""));if("/"===e[0])return e;if(null==t)return e;return k(t.path+"/"+e)}(l,a,u.strict);"boolean"==typeof o.caseSensitive&&(u.sensitive=o.caseSensitive);var h={path:d,regex:Z(d,u),components:o.components||{default:o.component},instances:{},name:c,parent:a,matchAs:s,redirect:o.redirect,beforeEnter:o.beforeEnter,meta:o.meta||{},props:null==o.props?{}:o.components?o.props:{default:o.props}};if(o.children&&(o.name&&!o.redirect&&o.children.some((function(e){return/^\/?$/.test(e.path)}))&&t(!1,"Named Route '"+o.name+"' has a default child route. When navigating to this named route (:to=\"{name: '"+o.name+"'\"), the default child route will not be rendered. Remove the name from this route and use the name of the default child route for named links instead."),o.children.forEach((function(e){var t=s?k(s+"/"+e.path):void 0;K(n,i,r,e,h,t)}))),i[h.path]||(n.push(h.path),i[h.path]=h),void 0!==o.alias)for(var f=Array.isArray(o.alias)?o.alias:[o.alias],p=0;p<f.length;++p){var m=f[p];if(m!==l){var v={path:m,children:o.children};K(n,i,r,v,a,h.path||"/")}else t(!1,'Found an alias with the same value as the path: "'+l+'". You have to remove that alias. It will be ignored in development.')}c&&(r[c]?s||t(!1,'Duplicate named routes definition: { name: "'+c+'", path: "'+h.path+'" }'):r[c]=h)}function Z(e,n){var i=S(e,[],n),r=Object.create(null);return i.keys.forEach((function(n){t(!r[n.name],'Duplicate param keys in route with path: "'+e+'"'),r[n.name]=!0})),i}function J(n,i){var r=Q(n),o=r.pathList,a=r.pathMap,s=r.nameMap;function l(e,n,r){var l=F(e,n,!1,i),c=l.name;if(c){var d=s[c];if(t(d,"Route with name '"+c+"' does not exist"),!d)return u(null,l);var h=d.regex.keys.filter((function(e){return!e.optional})).map((function(e){return e.name}));if("object"!=typeof l.params&&(l.params={}),n&&"object"==typeof n.params)for(var f in n.params)!(f in l.params)&&h.indexOf(f)>-1&&(l.params[f]=n.params[f]);return l.path=$(d.path,l.params,'named route "'+c+'"'),u(d,l,r)}if(l.path){l.params={};for(var p=0;p<o.length;p++){var m=o[p],v=a[m];if(X(v.regex,l.path,l.params))return u(v,l,r)}}return u(null,l)}function c(n,r){var o=n.redirect,a="function"==typeof o?o(p(n,r,null,i)):o;if("string"==typeof a&&(a={path:a}),!a||"object"!=typeof a)return t(!1,"invalid redirect option: "+JSON.stringify(a)),u(null,r);var c=a,d=c.name,h=c.path,f=r.query,m=r.hash,v=r.params;if(f=c.hasOwnProperty("query")?c.query:f,m=c.hasOwnProperty("hash")?c.hash:m,v=c.hasOwnProperty("params")?c.params:v,d)return e(s[d],'redirect failed: named route "'+d+'" not found.'),l({_normalized:!0,name:d,query:f,hash:m,params:v},void 0,r);if(h){var g=function(e,t){return w(e,t.parent?t.parent.path:"/",!0)}(h,n);return l({_normalized:!0,path:$(g,v,'redirect route with path "'+g+'"'),query:f,hash:m},void 0,r)}return t(!1,"invalid redirect option: "+JSON.stringify(a)),u(null,r)}function u(e,t,n){return e&&e.redirect?c(e,n||t):e&&e.matchAs?function(e,t,n){var i=l({_normalized:!0,path:$(n,t.params,'aliased route with path "'+n+'"')});if(i){var r=i.matched,o=r[r.length-1];return t.params=i.params,u(o,t)}return u(null,t)}(0,t,e.matchAs):p(e,t,n,i)}return{match:l,addRoutes:function(e){Q(e,o,a,s)}}}function X(e,t,n){var i=t.match(e);if(!i)return!1;if(!n)return!0;for(var r=1,o=i.length;r<o;++r){var a=e.keys[r-1],s="string"==typeof i[r]?decodeURIComponent(i[r]):i[r];a&&(n[a.name||"pathMatch"]=s)}return!0}var ee=G&&window.performance&&window.performance.now?window.performance:Date;function te(){return ee.now().toFixed(3)}var ne=te();function ie(){return ne}function re(e){return ne=e}var oe=Object.create(null);function ae(){"scrollRestoration"in window.history&&(window.history.scrollRestoration="manual");var e=window.location.protocol+"//"+window.location.host,t=window.location.href.replace(e,""),i=n({},window.history.state);return i.key=ie(),window.history.replaceState(i,"",t),window.addEventListener("popstate",ce),function(){window.removeEventListener("popstate",ce)}}function se(t,n,i,r){if(t.app){var o=t.options.scrollBehavior;o&&(e("function"==typeof o,"scrollBehavior must be a function"),t.app.$nextTick((function(){var a=function(){var e=ie();if(e)return oe[e]}(),s=o.call(t,n,i,r?a:null);s&&("function"==typeof s.then?s.then((function(e){pe(e,a)})).catch((function(t){e(!1,t.toString())})):pe(s,a))})))}}function le(){var e=ie();e&&(oe[e]={x:window.pageXOffset,y:window.pageYOffset})}function ce(e){le(),e.state&&e.state.key&&re(e.state.key)}function ue(e){return he(e.x)||he(e.y)}function de(e){return{x:he(e.x)?e.x:window.pageXOffset,y:he(e.y)?e.y:window.pageYOffset}}function he(e){return"number"==typeof e}var fe=/^#\d/;function pe(e,t){var n="object"==typeof e;if(n&&"string"==typeof e.selector){var i=fe.test(e.selector)?document.getElementById(e.selector.slice(1)):document.querySelector(e.selector);if(i){var r=e.offset&&"object"==typeof e.offset?e.offset:{};t=function(e,t){var n=document.documentElement.getBoundingClientRect(),i=e.getBoundingClientRect();return{x:i.left-n.left-t.x,y:i.top-n.top-t.y}}(i,r=function(e){return{x:he(e.x)?e.x:0,y:he(e.y)?e.y:0}}(r))}else ue(e)&&(t=de(e))}else n&&ue(e)&&(t=de(e));t&&window.scrollTo(t.x,t.y)}var me,ve=G&&((-1===(me=window.navigator.userAgent).indexOf("Android 2.")&&-1===me.indexOf("Android 4.0")||-1===me.indexOf("Mobile Safari")||-1!==me.indexOf("Chrome")||-1!==me.indexOf("Windows Phone"))&&window.history&&"function"==typeof window.history.pushState);function ge(e,t){le();var i=window.history;try{if(t){var r=n({},i.state);r.key=ie(),i.replaceState(r,"",e)}else i.pushState({key:re(te())},"",e)}catch(n){window.location[t?"replace":"assign"](e)}}function _e(e){ge(e,!0)}function be(e,t,n){var i=function(r){r>=e.length?n():e[r]?t(e[r],(function(){i(r+1)})):i(r+1)};i(0)}var ye={redirected:2,aborted:4,cancelled:8,duplicated:16};function we(e,t){return xe(e,t,ye.redirected,'Redirected when going from "'+e.fullPath+'" to "'+function(e){if("string"==typeof e)return e;if("path"in e)return e.path;var t={};return Se.forEach((function(n){n in e&&(t[n]=e[n])})),JSON.stringify(t,null,2)}(t)+'" via a navigation guard.')}function ke(e,t){return xe(e,t,ye.cancelled,'Navigation cancelled from "'+e.fullPath+'" to "'+t.fullPath+'" with a new navigation.')}function xe(e,t,n,i){var r=new Error(i);return r._isRouter=!0,r.from=e,r.to=t,r.type=n,r}var Se=["params","query","hash"];function Ce(e){return Object.prototype.toString.call(e).indexOf("Error")>-1}function Me(e,t){return Ce(e)&&e._isRouter&&(null==t||e.type===t)}function Te(e){return function(n,i,r){var o=!1,a=0,s=null;Ae(e,(function(e,n,i,l){if("function"==typeof e&&void 0===e.cid){o=!0,a++;var c,u=Oe((function(t){(function(e){return e.__esModule||Le&&"Module"===e[Symbol.toStringTag]})(t)&&(t=t.default),e.resolved="function"==typeof t?t:B.extend(t),i.components[l]=t,--a<=0&&r()})),d=Oe((function(e){var n="Failed to resolve async component "+l+": "+e;t(!1,n),s||(s=Ce(e)?e:new Error(n),r(s))}));try{c=e(u,d)}catch(e){d(e)}if(c)if("function"==typeof c.then)c.then(u,d);else{var h=c.component;h&&"function"==typeof h.then&&h.then(u,d)}}})),o||r()}}function Ae(e,t){return Pe(e.map((function(e){return Object.keys(e.components).map((function(n){return t(e.components[n],e.instances[n],e,n)}))})))}function Pe(e){return Array.prototype.concat.apply([],e)}var Le="function"==typeof Symbol&&"symbol"==typeof Symbol.toStringTag;function Oe(e){var t=!1;return function(){for(var n=[],i=arguments.length;i--;)n[i]=arguments[i];if(!t)return t=!0,e.apply(this,n)}}var qe=function(e,t){this.router=e,this.base=function(e){if(!e)if(G){var t=document.querySelector("base");e=(e=t&&t.getAttribute("href")||"/").replace(/^https?:\/\/[^\/]+/,"")}else e="/";"/"!==e.charAt(0)&&(e="/"+e);return e.replace(/\/$/,"")}(t),this.current=v,this.pending=null,this.ready=!1,this.readyCbs=[],this.readyErrorCbs=[],this.errorCbs=[],this.listeners=[]};function Ee(e,t,n,i){var r=Ae(e,(function(e,i,r,o){var a=function(e,t){"function"!=typeof e&&(e=B.extend(e));return e.options[t]}(e,t);if(a)return Array.isArray(a)?a.map((function(e){return n(e,i,r,o)})):n(a,i,r,o)}));return Pe(i?r.reverse():r)}function De(e,t){if(t)return function(){return e.apply(t,arguments)}}function ze(e,t,n,i){t[n]&&!t[n]._isBeingDestroyed?e(t[n]):i()&&setTimeout((function(){ze(e,t,n,i)}),16)}qe.prototype.listen=function(e){this.cb=e},qe.prototype.onReady=function(e,t){this.ready?e():(this.readyCbs.push(e),t&&this.readyErrorCbs.push(t))},qe.prototype.onError=function(e){this.errorCbs.push(e)},qe.prototype.transitionTo=function(e,t,n){var i,r=this;try{i=this.router.match(e,this.current)}catch(e){throw this.errorCbs.forEach((function(t){t(e)})),e}this.confirmTransition(i,(function(){var e=r.current;r.updateRoute(i),t&&t(i),r.ensureURL(),r.router.afterHooks.forEach((function(t){t&&t(i,e)})),r.ready||(r.ready=!0,r.readyCbs.forEach((function(e){e(i)})))}),(function(e){n&&n(e),e&&!r.ready&&(r.ready=!0,Me(e,ye.redirected)?r.readyCbs.forEach((function(e){e(i)})):r.readyErrorCbs.forEach((function(t){t(e)})))}))},qe.prototype.confirmTransition=function(e,n,i){var r,o,a=this,s=this.current,l=function(e){!Me(e)&&Ce(e)&&(a.errorCbs.length?a.errorCbs.forEach((function(t){t(e)})):(t(!1,"uncaught error during route navigation:"),console.error(e))),i&&i(e)},c=e.matched.length-1,u=s.matched.length-1;if(b(e,s)&&c===u&&e.matched[c]===s.matched[u])return this.ensureURL(),l(((o=xe(r=s,e,ye.duplicated,'Avoided redundant navigation to current location: "'+r.fullPath+'".')).name="NavigationDuplicated",o));var d=function(e,t){var n,i=Math.max(e.length,t.length);for(n=0;n<i&&e[n]===t[n];n++);return{updated:t.slice(0,n),activated:t.slice(n),deactivated:e.slice(n)}}(this.current.matched,e.matched),h=d.updated,f=d.deactivated,p=d.activated,m=[].concat(function(e){return Ee(e,"beforeRouteLeave",De,!0)}(f),this.router.beforeHooks,function(e){return Ee(e,"beforeRouteUpdate",De)}(h),p.map((function(e){return e.beforeEnter})),Te(p));this.pending=e;var v=function(t,n){if(a.pending!==e)return l(ke(s,e));try{t(e,s,(function(t){!1===t?(a.ensureURL(!0),l(function(e,t){return xe(e,t,ye.aborted,'Navigation aborted from "'+e.fullPath+'" to "'+t.fullPath+'" via a navigation guard.')}(s,e))):Ce(t)?(a.ensureURL(!0),l(t)):"string"==typeof t||"object"==typeof t&&("string"==typeof t.path||"string"==typeof t.name)?(l(we(s,e)),"object"==typeof t&&t.replace?a.replace(t):a.push(t)):n(t)}))}catch(e){l(e)}};be(m,v,(function(){var t=[],i=function(e,t,n){return Ee(e,"beforeRouteEnter",(function(e,i,r,o){return function(e,t,n,i,r){return function(o,a,s){return e(o,a,(function(e){"function"==typeof e&&i.push((function(){ze(e,t.instances,n,r)})),s(e)}))}}(e,r,o,t,n)}))}(p,t,(function(){return a.current===e}));be(i.concat(a.router.resolveHooks),v,(function(){if(a.pending!==e)return l(ke(s,e));a.pending=null,n(e),a.router.app&&a.router.app.$nextTick((function(){t.forEach((function(e){e()}))}))}))}))},qe.prototype.updateRoute=function(e){this.current=e,this.cb&&this.cb(e)},qe.prototype.setupListeners=function(){},qe.prototype.teardownListeners=function(){this.listeners.forEach((function(e){e()})),this.listeners=[]};var Ne=function(e){function t(t,n){e.call(this,t,n),this._startLocation=je(this.base)}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.setupListeners=function(){var e=this;if(!(this.listeners.length>0)){var t=this.router,n=t.options.scrollBehavior,i=ve&&n;i&&this.listeners.push(ae());var r=function(){var n=e.current,r=je(e.base);e.current===v&&r===e._startLocation||e.transitionTo(r,(function(e){i&&se(t,e,n,!0)}))};window.addEventListener("popstate",r),this.listeners.push((function(){window.removeEventListener("popstate",r)}))}},t.prototype.go=function(e){window.history.go(e)},t.prototype.push=function(e,t,n){var i=this,r=this.current;this.transitionTo(e,(function(e){ge(k(i.base+e.fullPath)),se(i.router,e,r,!1),t&&t(e)}),n)},t.prototype.replace=function(e,t,n){var i=this,r=this.current;this.transitionTo(e,(function(e){_e(k(i.base+e.fullPath)),se(i.router,e,r,!1),t&&t(e)}),n)},t.prototype.ensureURL=function(e){if(je(this.base)!==this.current.fullPath){var t=k(this.base+this.current.fullPath);e?ge(t):_e(t)}},t.prototype.getCurrentLocation=function(){return je(this.base)},t}(qe);function je(e){var t=decodeURI(window.location.pathname);return e&&0===t.toLowerCase().indexOf(e.toLowerCase())&&(t=t.slice(e.length)),(t||"/")+window.location.search+window.location.hash}var Re=function(e){function t(t,n,i){e.call(this,t,n),i&&function(e){var t=je(e);if(!/^\/#/.test(t))return window.location.replace(k(e+"/#"+t)),!0}(this.base)||Ie()}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.setupListeners=function(){var e=this;if(!(this.listeners.length>0)){var t=this.router.options.scrollBehavior,n=ve&&t;n&&this.listeners.push(ae());var i=function(){var t=e.current;Ie()&&e.transitionTo($e(),(function(i){n&&se(e.router,i,t,!0),ve||Ve(i.fullPath)}))},r=ve?"popstate":"hashchange";window.addEventListener(r,i),this.listeners.push((function(){window.removeEventListener(r,i)}))}},t.prototype.push=function(e,t,n){var i=this,r=this.current;this.transitionTo(e,(function(e){Be(e.fullPath),se(i.router,e,r,!1),t&&t(e)}),n)},t.prototype.replace=function(e,t,n){var i=this,r=this.current;this.transitionTo(e,(function(e){Ve(e.fullPath),se(i.router,e,r,!1),t&&t(e)}),n)},t.prototype.go=function(e){window.history.go(e)},t.prototype.ensureURL=function(e){var t=this.current.fullPath;$e()!==t&&(e?Be(t):Ve(t))},t.prototype.getCurrentLocation=function(){return $e()},t}(qe);function Ie(){var e=$e();return"/"===e.charAt(0)||(Ve("/"+e),!1)}function $e(){var e=window.location.href,t=e.indexOf("#");if(t<0)return"";var n=(e=e.slice(t+1)).indexOf("?");if(n<0){var i=e.indexOf("#");e=i>-1?decodeURI(e.slice(0,i))+e.slice(i):decodeURI(e)}else e=decodeURI(e.slice(0,n))+e.slice(n);return e}function Fe(e){var t=window.location.href,n=t.indexOf("#");return(n>=0?t.slice(0,n):t)+"#"+e}function Be(e){ve?ge(Fe(e)):window.location.hash=e}function Ve(e){ve?_e(Fe(e)):window.location.replace(Fe(e))}var He=function(e){function t(t,n){e.call(this,t,n),this.stack=[],this.index=-1}return e&&(t.__proto__=e),t.prototype=Object.create(e&&e.prototype),t.prototype.constructor=t,t.prototype.push=function(e,t,n){var i=this;this.transitionTo(e,(function(e){i.stack=i.stack.slice(0,i.index+1).concat(e),i.index++,t&&t(e)}),n)},t.prototype.replace=function(e,t,n){var i=this;this.transitionTo(e,(function(e){i.stack=i.stack.slice(0,i.index).concat(e),t&&t(e)}),n)},t.prototype.go=function(e){var t=this,n=this.index+e;if(!(n<0||n>=this.stack.length)){var i=this.stack[n];this.confirmTransition(i,(function(){t.index=n,t.updateRoute(i)}),(function(e){Me(e,ye.duplicated)&&(t.index=n)}))}},t.prototype.getCurrentLocation=function(){var e=this.stack[this.stack.length-1];return e?e.fullPath:"/"},t.prototype.ensureURL=function(){},t}(qe),We=function(t){void 0===t&&(t={}),this.app=null,this.apps=[],this.options=t,this.beforeHooks=[],this.resolveHooks=[],this.afterHooks=[],this.matcher=J(t.routes||[],this);var n=t.mode||"hash";switch(this.fallback="history"===n&&!ve&&!1!==t.fallback,this.fallback&&(n="hash"),G||(n="abstract"),this.mode=n,n){case"history":this.history=new Ne(this,t.base);break;case"hash":this.history=new Re(this,t.base,this.fallback);break;case"abstract":this.history=new He(this,t.base);break;default:e(!1,"invalid mode: "+n)}},Ue={currentRoute:{configurable:!0}};function Ye(e,t){return e.push(t),function(){var n=e.indexOf(t);n>-1&&e.splice(n,1)}}return We.prototype.match=function(e,t,n){return this.matcher.match(e,t,n)},Ue.currentRoute.get=function(){return this.history&&this.history.current},We.prototype.init=function(t){var n=this;if(e(Y.installed,"not installed. Make sure to call `Vue.use(VueRouter)` before creating root instance."),this.apps.push(t),t.$once("hook:destroyed",(function(){var e=n.apps.indexOf(t);e>-1&&n.apps.splice(e,1),n.app===t&&(n.app=n.apps[0]||null),n.app||n.history.teardownListeners()})),!this.app){this.app=t;var i=this.history;if(i instanceof Ne||i instanceof Re){var r=function(e){i.setupListeners(),function(e){var t=i.current,r=n.options.scrollBehavior;ve&&r&&"fullPath"in e&&se(n,e,t,!1)}(e)};i.transitionTo(i.getCurrentLocation(),r,r)}i.listen((function(e){n.apps.forEach((function(t){t._route=e}))}))}},We.prototype.beforeEach=function(e){return Ye(this.beforeHooks,e)},We.prototype.beforeResolve=function(e){return Ye(this.resolveHooks,e)},We.prototype.afterEach=function(e){return Ye(this.afterHooks,e)},We.prototype.onReady=function(e,t){this.history.onReady(e,t)},We.prototype.onError=function(e){this.history.onError(e)},We.prototype.push=function(e,t,n){var i=this;if(!t&&!n&&"undefined"!=typeof Promise)return new Promise((function(t,n){i.history.push(e,t,n)}));this.history.push(e,t,n)},We.prototype.replace=function(e,t,n){var i=this;if(!t&&!n&&"undefined"!=typeof Promise)return new Promise((function(t,n){i.history.replace(e,t,n)}));this.history.replace(e,t,n)},We.prototype.go=function(e){this.history.go(e)},We.prototype.back=function(){this.go(-1)},We.prototype.forward=function(){this.go(1)},We.prototype.getMatchedComponents=function(e){var t=e?e.matched?e:this.resolve(e).route:this.currentRoute;return t?[].concat.apply([],t.matched.map((function(e){return Object.keys(e.components).map((function(t){return e.components[t]}))}))):[]},We.prototype.resolve=function(e,t,n){var i=F(e,t=t||this.history.current,n,this),r=this.match(i,t),o=r.redirectedFrom||r.fullPath,a=function(e,t,n){var i="hash"===n?"#"+t:t;return e?k(e+"/"+i):i}(this.history.base,o,this.mode);return{location:i,route:r,href:a,normalizedTo:i,resolved:r}},We.prototype.addRoutes=function(e){this.matcher.addRoutes(e),this.history.current!==v&&this.history.transitionTo(this.history.getCurrentLocation())},Object.defineProperties(We.prototype,Ue),We.install=Y,We.version="3.4.3",We.isNavigationFailure=Me,We.NavigationFailureType=ye,G&&window.Vue&&window.Vue.use(We),We})),function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?exports.VueQrcodeReader=t():e.VueQrcodeReader=t()}("undefined"!=typeof self?self:this,(function(){return function(e){var t={};function n(i){if(t[i])return t[i].exports;var r=t[i]={i:i,l:!1,exports:{}};return e[i].call(r.exports,r,r.exports,n),r.l=!0,r.exports}return n.m=e,n.c=t,n.d=function(e,t,i){n.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:i})},n.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},n.t=function(e,t){if(1&t&&(e=n(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var i=Object.create(null);if(n.r(i),Object.defineProperty(i,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var r in e)n.d(i,r,function(t){return e[t]}.bind(null,r));return i},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,"a",t),t},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n.p="",n(n.s="fb15")}({"00ee":function(e,t,n){var i={};i[n("b622")("toStringTag")]="z",e.exports="[object z]"===String(i)},"0366":function(e,t,n){var i=n("1c0b");e.exports=function(e,t,n){if(i(e),void 0===t)return e;switch(n){case 0:return function(){return e.call(t)};case 1:return function(n){return e.call(t,n)};case 2:return function(n,i){return e.call(t,n,i)};case 3:return function(n,i,r){return e.call(t,n,i,r)}}return function(){return e.apply(t,arguments)}}},"0538":function(e,t,n){"use strict";var i=n("1c0b"),r=n("861d"),o=[].slice,a={};e.exports=Function.bind||function(e){var t=i(this),n=o.call(arguments,1),s=function(){var i=n.concat(o.call(arguments));return this instanceof s?function(e,t,n){if(!(t in a)){for(var i=[],r=0;r<t;r++)i[r]="a["+r+"]";a[t]=Function("C,a","return new C("+i.join(",")+")")}return a[t](e,n)}(t,i.length,i):t.apply(e,i)};return r(t.prototype)&&(s.prototype=t.prototype),s}},"057f":function(e,t,n){var i=n("fc6a"),r=n("241c").f,o={}.toString,a="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[];e.exports.f=function(e){return a&&"[object Window]"==o.call(e)?function(e){try{return r(e)}catch(e){return a.slice()}}(e):r(i(e))}},"06c5":function(e,t,n){"use strict";n.d(t,"a",(function(){return r}));n("a630"),n("fb6a"),n("b0c0"),n("d3b7"),n("25f0"),n("3ca3");var i=n("6b75");function r(e,t){if(e){if("string"==typeof e)return Object(i.a)(e,t);var n=Object.prototype.toString.call(e).slice(8,-1);return"Object"===n&&e.constructor&&(n=e.constructor.name),"Map"===n||"Set"===n?Array.from(e):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Object(i.a)(e,t):void 0}}},"06cf":function(e,t,n){var i=n("83ab"),r=n("d1e7"),o=n("5c6c"),a=n("fc6a"),s=n("c04e"),l=n("5135"),c=n("0cfb"),u=Object.getOwnPropertyDescriptor;t.f=i?u:function(e,t){if(e=a(e),t=s(t,!0),c)try{return u(e,t)}catch(e){}if(l(e,t))return o(!r.f.call(e,t),e[t])}},"0cfb":function(e,t,n){var i=n("83ab"),r=n("d039"),o=n("cc12");e.exports=!i&&!r((function(){return 7!=Object.defineProperty(o("div"),"a",{get:function(){return 7}}).a}))},"0d0e":function(e,t,n){"use strict";n("caad"),n("d3b7"),n("e6cf"),n("96cf");var i=n("1da1"),r=n("a180");n("4de4"),n("4160"),n("e260"),n("3ca3"),n("159b"),n("ddb0"),n("2b3d"),n("a4d3"),n("e439"),n("dbb4"),n("b64b");function o(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}function a(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);t&&(i=i.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,i)}return n}function s(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{};t%2?a(Object(n),!0).forEach((function(t){o(e,t,n[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(n)):a(Object(n)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(n,t))}))}return e}n("e01a"),n("d28b");var l=n("06c5");function c(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){if("undefined"!=typeof Symbol&&Symbol.iterator in Object(e)){var n=[],i=!0,r=!1,o=void 0;try{for(var a,s=e[Symbol.iterator]();!(i=(a=s.next()).done)&&(n.push(a.value),!t||n.length!==t);i=!0);}catch(e){r=!0,o=e}finally{try{i||null==s.return||s.return()}finally{if(r)throw o}}return n}}(e,t)||Object(l.a)(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}var u=n("d4ec");function d(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var h=n("1cc0"),f=n("f718"),p=n("c036"),m=(n("99af"),n("7db0"),n("fb6a"),n("45fc"),n("b0c0"),n("2532"),n("53ca")),v=(n("13d5"),n("4ec9"),n("cca6"),n("ac1f"),n("25f0"),n("8a79"),n("466d"),!0),g=!0;function _(e,t,n){var i=e.match(t);return i&&i.length>=n&&parseInt(i[n],10)}function b(e,t){g&&console.warn(e+" is deprecated, please use "+t+" instead.")}function y(e){var t={browser:null,version:null};if(void 0===e||!e.navigator)return t.browser="Not a browser.",t;var n=e.navigator;if(n.mozGetUserMedia)t.browser="firefox",t.version=_(n.userAgent,/Firefox\/(\d+)\./,1);else if(n.webkitGetUserMedia||!1===e.isSecureContext&&e.webkitRTCPeerConnection&&!e.RTCIceGatherer)t.browser="chrome",t.version=_(n.userAgent,/Chrom(e|ium)\/(\d+)\./,2);else if(n.mediaDevices&&n.userAgent.match(/Edge\/(\d+).(\d+)$/))t.browser="edge",t.version=_(n.userAgent,/Edge\/(\d+).(\d+)$/,2);else{if(!e.RTCPeerConnection||!n.userAgent.match(/AppleWebKit\/(\d+)\./))return t.browser="Not a supported browser.",t;t.browser="safari",t.version=_(n.userAgent,/AppleWebKit\/(\d+)\./,1),t.supportsUnifiedPlan=e.RTCRtpTransceiver&&"currentDirection"in e.RTCRtpTransceiver.prototype}return t}function w(e){return"[object Object]"===Object.prototype.toString.call(e)}function k(e){return w(e)?Object.keys(e).reduce((function(t,n){var i=w(e[n]),r=i?k(e[n]):e[n],a=i&&!Object.keys(r).length;return void 0===r||a?t:Object.assign(t,o({},n,r))}),{}):e}var x=function(){if("object"===("undefined"==typeof window?"undefined":Object(m.a)(window))){if(v)return;"undefined"!=typeof console&&"function"==typeof console.log&&console.log.apply(console,arguments)}};n("c975"),n("a434");function S(e){var t=e&&e.navigator;if(t.mediaDevices&&t.mediaDevices.getUserMedia){var n=t.mediaDevices,i=n.getUserMedia.bind(n);t.mediaDevices.getUserMedia=function(e){return i(function(e){if(e&&void 0!==e.video)return Object.assign({},e,{video:k(e.video)});return e}(e))}}!t.getUserMedia&&t.mediaDevices&&t.mediaDevices.getUserMedia&&(t.getUserMedia=function(e,n,i){t.mediaDevices.getUserMedia(e).then(n,i)}.bind(t))}var C,M,T,A=(C=function(){switch(y(window).browser){case"chrome":!function(e){var t=e&&e.navigator;if(t.mediaDevices){var n=y(e),i=function(e){if("object"!==Object(m.a)(e)||e.mandatory||e.optional)return e;var t={};return Object.keys(e).forEach((function(n){if("require"!==n&&"advanced"!==n&&"mediaSource"!==n){var i="object"===Object(m.a)(e[n])?e[n]:{ideal:e[n]};void 0!==i.exact&&"number"==typeof i.exact&&(i.min=i.max=i.exact);var r=function(e,t){return e?e+t.charAt(0).toUpperCase()+t.slice(1):"deviceId"===t?"sourceId":t};if(void 0!==i.ideal){t.optional=t.optional||[];var o={};"number"==typeof i.ideal?(o[r("min",n)]=i.ideal,t.optional.push(o),(o={})[r("max",n)]=i.ideal,t.optional.push(o)):(o[r("",n)]=i.ideal,t.optional.push(o))}void 0!==i.exact&&"number"!=typeof i.exact?(t.mandatory=t.mandatory||{},t.mandatory[r("",n)]=i.exact):["min","max"].forEach((function(e){void 0!==i[e]&&(t.mandatory=t.mandatory||{},t.mandatory[r(e,n)]=i[e])}))}})),e.advanced&&(t.optional=(t.optional||[]).concat(e.advanced)),t},r=function(e,r){if(n.version>=61)return r(e);if((e=JSON.parse(JSON.stringify(e)))&&"object"===Object(m.a)(e.audio)){var o=function(e,t,n){t in e&&!(n in e)&&(e[n]=e[t],delete e[t])};o((e=JSON.parse(JSON.stringify(e))).audio,"autoGainControl","googAutoGainControl"),o(e.audio,"noiseSuppression","googNoiseSuppression"),e.audio=i(e.audio)}if(e&&"object"===Object(m.a)(e.video)){var a=e.video.facingMode;a=a&&("object"===Object(m.a)(a)?a:{ideal:a});var s,l=n.version<66;if(a&&("user"===a.exact||"environment"===a.exact||"user"===a.ideal||"environment"===a.ideal)&&(!t.mediaDevices.getSupportedConstraints||!t.mediaDevices.getSupportedConstraints().facingMode||l)&&(delete e.video.facingMode,"environment"===a.exact||"environment"===a.ideal?s=["back","rear"]:"user"!==a.exact&&"user"!==a.ideal||(s=["front"]),s))return t.mediaDevices.enumerateDevices().then((function(t){var n=(t=t.filter((function(e){return"videoinput"===e.kind}))).find((function(e){return s.some((function(t){return e.label.toLowerCase().includes(t)}))}));return!n&&t.length&&s.includes("back")&&(n=t[t.length-1]),n&&(e.video.deviceId=a.exact?{exact:n.deviceId}:{ideal:n.deviceId}),e.video=i(e.video),x("chrome: "+JSON.stringify(e)),r(e)}));e.video=i(e.video)}return x("chrome: "+JSON.stringify(e)),r(e)},o=function(e){return n.version>=64?e:{name:{PermissionDeniedError:"NotAllowedError",PermissionDismissedError:"NotAllowedError",InvalidStateError:"NotAllowedError",DevicesNotFoundError:"NotFoundError",ConstraintNotSatisfiedError:"OverconstrainedError",TrackStartError:"NotReadableError",MediaDeviceFailedDueToShutdown:"NotAllowedError",MediaDeviceKillSwitchOn:"NotAllowedError",TabCaptureError:"AbortError",ScreenCaptureError:"AbortError",DeviceCaptureError:"AbortError"}[e.name]||e.name,message:e.message,constraint:e.constraint||e.constraintName,toString:function(){return this.name+(this.message&&": ")+this.message}}};if(t.getUserMedia=function(e,n,i){r(e,(function(e){t.webkitGetUserMedia(e,n,(function(e){i&&i(o(e))}))}))}.bind(t),t.mediaDevices.getUserMedia){var a=t.mediaDevices.getUserMedia.bind(t.mediaDevices);t.mediaDevices.getUserMedia=function(e){return r(e,(function(e){return a(e).then((function(t){if(e.audio&&!t.getAudioTracks().length||e.video&&!t.getVideoTracks().length)throw t.getTracks().forEach((function(e){e.stop()})),new DOMException("","NotFoundError");return t}),(function(e){return Promise.reject(o(e))}))}))}}}}(window);break;case"firefox":!function(e){var t=y(e),n=e&&e.navigator,i=e&&e.MediaStreamTrack;if(n.getUserMedia=function(e,t,i){b("navigator.getUserMedia","navigator.mediaDevices.getUserMedia"),n.mediaDevices.getUserMedia(e).then(t,i)},!(t.version>55&&"autoGainControl"in n.mediaDevices.getSupportedConstraints())){var r=function(e,t,n){t in e&&!(n in e)&&(e[n]=e[t],delete e[t])},o=n.mediaDevices.getUserMedia.bind(n.mediaDevices);if(n.mediaDevices.getUserMedia=function(e){return"object"===Object(m.a)(e)&&"object"===Object(m.a)(e.audio)&&(e=JSON.parse(JSON.stringify(e)),r(e.audio,"autoGainControl","mozAutoGainControl"),r(e.audio,"noiseSuppression","mozNoiseSuppression")),o(e)},i&&i.prototype.getSettings){var a=i.prototype.getSettings;i.prototype.getSettings=function(){var e=a.apply(this,arguments);return r(e,"mozAutoGainControl","autoGainControl"),r(e,"mozNoiseSuppression","noiseSuppression"),e}}if(i&&i.prototype.applyConstraints){var s=i.prototype.applyConstraints;i.prototype.applyConstraints=function(e){return"audio"===this.kind&&"object"===Object(m.a)(e)&&(e=JSON.parse(JSON.stringify(e)),r(e,"autoGainControl","mozAutoGainControl"),r(e,"noiseSuppression","mozNoiseSuppression")),s.apply(this,[e])}}}}(window);break;case"edge":!function(e){var t=e&&e.navigator,n=t.mediaDevices.getUserMedia.bind(t.mediaDevices);t.mediaDevices.getUserMedia=function(e){return n(e).catch((function(e){return Promise.reject(function(e){return{name:{PermissionDeniedError:"NotAllowedError"}[e.name]||e.name,message:e.message,constraint:e.constraint,toString:function(){return this.name}}}(e))}))}}(window);break;case"safari":S(window);break;default:throw new h.d}},M=!1,T=void 0,function(){return M||(T=C.apply(void 0,arguments),M=!0),T}),P=function(){function e(t,n){Object(u.a)(this,e),this.videoEl=t,this.stream=n}var t,n,i;return t=e,(n=[{key:"stop",value:function(){var e=this;this.videoEl.srcObject=null,this.stream.getTracks().forEach((function(t){e.stream.removeTrack(t),t.stop()}))}},{key:"captureFrame",value:function(){return Object(f.c)(this.videoEl)}},{key:"getCapabilities",value:function(){var e,t,n=c(this.stream.getVideoTracks(),1)[0];return null!==(e=null==n||null===(t=n.getCapabilities)||void 0===t?void 0:t.call(n))&&void 0!==e?e:{}}}])&&d(t.prototype,n),i&&d(t,i),e}(),L=function(){var e=Object(i.a)(regeneratorRuntime.mark((function e(t){var n,i,r;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return e.next=2,navigator.mediaDevices.enumerateDevices();case 2:if(!((n=e.sent.filter((function(e){return"videoinput"===e.kind}))).length>2)){e.next=15;break}i=n[0],r=n[n.length-1],e.t0=t,e.next="auto"===e.t0?9:"rear"===e.t0?10:"front"===e.t0?11:12;break;case 9:case 10:return e.abrupt("return",{deviceId:{exact:r.deviceId}});case 11:return e.abrupt("return",{deviceId:{exact:i.deviceId}});case 12:case 21:return e.abrupt("return",void 0);case 13:e.next=22;break;case 15:e.t1=t,e.next="auto"===e.t1?18:"rear"===e.t1?19:"front"===e.t1?20:21;break;case 18:return e.abrupt("return",{facingMode:{ideal:"environment"}});case 19:return e.abrupt("return",{facingMode:{exact:"environment"}});case 20:return e.abrupt("return",{facingMode:{exact:"user"}});case 22:case"end":return e.stop()}}),e)})));return function(t){return e.apply(this,arguments)}}(),O=function(e,t){return q.apply(this,arguments)};function q(){return(q=Object(i.a)(regeneratorRuntime.mark((function e(t,n){var i,r,o,a,l,u,d,f,m;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(o=n.camera,a=n.torch,!0===window.isSecureContext){e.next=3;break}throw new h.c;case 3:if(void 0!==(null===(i=navigator)||void 0===i||null===(r=i.mediaDevices)||void 0===r?void 0:r.getUserMedia)){e.next=5;break}throw new h.d;case 5:return e.next=7,A();case 7:return e.t0=s,e.t1={width:{min:360,ideal:640,max:1920},height:{min:240,ideal:480,max:1080}},e.next=11,L(o);case 11:return e.t2=e.sent,e.t3=(0,e.t0)(e.t1,e.t2),l={audio:!1,video:e.t3},e.next=16,navigator.mediaDevices.getUserMedia(l);case 16:return u=e.sent,void 0!==t.srcObject?t.srcObject=u:void 0!==t.mozSrcObject?t.mozSrcObject=u:window.URL.createObjectURL?t.src=window.URL.createObjectURL(u):window.webkitURL?t.src=window.webkitURL.createObjectURL(u):t.src=u,e.next=20,Object(p.a)(t,"loadeddata");case 20:return e.next=22,Object(p.b)(500);case 22:return a&&(d=u.getVideoTracks(),f=c(d,1),m=f[0],m.getCapabilities().torch?m.applyConstraints({advanced:[{torch:!0}]}):console.warn("device does not support torch capability")),e.abrupt("return",new P(t,u));case 24:case"end":return e.stop()}}),e)})))).apply(this,arguments)}var E=n("b3af"),D=n("3c85"),z={name:"qrcode-stream",mixins:[E.a],props:{camera:{type:String,default:"auto",validator:function(e){return["auto","rear","front","off"].includes(e)}},torch:{type:Boolean,default:!1},track:{type:[Function,Boolean],default:!0},worker:{type:Function,default:D.a}},data:function(){return{cameraInstance:null,destroyed:!1,stopScanning:function(){}}},computed:{shouldStream:function(){return!1===this.destroyed&&"off"!==this.camera},shouldScan:function(){return!0===this.shouldStream&&null!==this.cameraInstance},scanInterval:function(){return!1===this.track?500:40},trackRepaintFunction:function(){return!0===this.track?(e={color:"#ff0000"}.color,function(t,n){var i=t.topLeftCorner,r=t.topRightCorner,o=t.bottomLeftCorner,a=t.bottomRightCorner;n.strokeStyle=e,n.beginPath(),n.moveTo(i.x,i.y),n.lineTo(o.x,o.y),n.lineTo(a.x,a.y),n.lineTo(r.x,r.y),n.lineTo(i.x,i.y),n.closePath(),n.stroke()}):!1===this.track?void 0:this.track;var e}},watch:{shouldStream:function(e){if(!e){var t=this.cameraInstance.captureFrame();this.paintPauseFrame(t)}},shouldScan:function(e){e?(this.clearPauseFrame(),this.clearTrackingLayer(),this.startScanning()):this.stopScanning()},torch:function(){this.init()},camera:function(){this.init()}},mounted:function(){this.init()},beforeDestroy:function(){this.beforeResetCamera(),this.stopScanning(),this.destroyed=!0},methods:{init:function(){var e=this,t=Object(i.a)(regeneratorRuntime.mark((function t(){var n;return regeneratorRuntime.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:if(e.beforeResetCamera(),"off"!==e.camera){t.next=6;break}return e.cameraInstance=null,t.abrupt("return",{capabilities:{}});case 6:return t.next=8,O(e.$refs.video,{camera:e.camera,torch:e.torch});case 8:return e.cameraInstance=t.sent,n=e.cameraInstance.getCapabilities(),e.destroyed&&e.cameraInstance.stop(),t.abrupt("return",{capabilities:n});case 12:case"end":return t.stop()}}),t)})))();this.$emit("init",t)},startScanning:function(){var e=this;this.stopScanning=Object(r.a)(this.worker,this.cameraInstance,{detectHandler:function(t){e.onDetect(Promise.resolve(t))},locateHandler:this.onLocate,minDelay:this.scanInterval})},beforeResetCamera:function(){null!==this.cameraInstance&&(this.cameraInstance.stop(),this.cameraInstance=null)},onLocate:function(e){void 0===this.trackRepaintFunction||null===e?this.clearTrackingLayer():this.repaintTrackingLayer(e)},repaintTrackingLayer:function(e){var t=this,n=this.$refs.video,i=this.$refs.trackingLayer,r=i.getContext("2d"),o=n.offsetWidth,a=n.offsetHeight,s=n.videoWidth,l=n.videoHeight,c=Math.max(o/s,a/l),u=s*c,d=l*c,h=u/s,f=d/l,p=(o-u)/2,m=(a-d)/2,v={};for(var g in e)v[g]={x:Math.floor(e[g].x*h+p),y:Math.floor(e[g].y*f+m)};window.requestAnimationFrame((function(){i.width=o,i.height=a,t.trackRepaintFunction(v,r)}))},clearTrackingLayer:function(){var e=this.$refs.trackingLayer,t=e.getContext("2d");window.requestAnimationFrame((function(){t.clearRect(0,0,e.width,e.height)}))},paintPauseFrame:function(e){var t=this.$refs.pauseFrame,n=t.getContext("2d");window.requestAnimationFrame((function(){t.width=e.width,t.height=e.height,n.putImageData(e,0,0)}))},clearPauseFrame:function(){var e=this.$refs.pauseFrame,t=e.getContext("2d");window.requestAnimationFrame((function(){t.clearRect(0,0,e.width,e.height)}))}}},N=z,j=(n("c244"),n("2877")),R=Object(j.a)(N,(function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",{staticClass:"qrcode-stream-wrapper"},[n("video",{directives:[{name:"show",rawName:"v-show",value:e.shouldScan,expression:"shouldScan"}],ref:"video",staticClass:"qrcode-stream-camera",attrs:{autoplay:"",muted:"",playsinline:""},domProps:{muted:!0}}),n("canvas",{directives:[{name:"show",rawName:"v-show",value:!e.shouldScan,expression:"!shouldScan"}],ref:"pauseFrame",staticClass:"qrcode-stream-camera"}),n("canvas",{ref:"trackingLayer",staticClass:"qrcode-stream-overlay"}),n("div",{staticClass:"qrcode-stream-overlay"},[e._t("default")],2)])}),[],!1,null,"7a81005d",null);t.a=R.exports},"0d3b":function(e,t,n){var i=n("d039"),r=n("b622"),o=n("c430"),a=r("iterator");e.exports=!i((function(){var e=new URL("b?a=1&b=2&c=3","http://a"),t=e.searchParams,n="";return e.pathname="c%20d",t.forEach((function(e,i){t.delete("b"),n+=i+e})),o&&!e.toJSON||!t.sort||"http://a/c%20d?a=1&c=3"!==e.href||"3"!==t.get("c")||"a=1"!==String(new URLSearchParams("?a=1"))||!t[a]||"a"!==new URL("https://a@b").username||"b"!==new URLSearchParams(new URLSearchParams("a=b")).get("a")||"xn--e1aybc"!==new URL("http://тест").host||"#%D0%B1"!==new URL("http://a#б").hash||"a1c3"!==n||"x"!==new URL("http://x",void 0).host}))},"131a":function(e,t,n){n("23e7")({target:"Object",stat:!0},{setPrototypeOf:n("d2bb")})},"13d5":function(e,t,n){"use strict";var i=n("23e7"),r=n("d58f").left,o=n("a640"),a=n("ae40"),s=o("reduce"),l=a("reduce",{1:0});i({target:"Array",proto:!0,forced:!s||!l},{reduce:function(e){return r(this,e,arguments.length,arguments.length>1?arguments[1]:void 0)}})},"14c3":function(e,t,n){var i=n("c6b6"),r=n("9263");e.exports=function(e,t){var n=e.exec;if("function"==typeof n){var o=n.call(e,t);if("object"!=typeof o)throw TypeError("RegExp exec method returned something other than an Object or null");return o}if("RegExp"!==i(e))throw TypeError("RegExp#exec called on incompatible receiver");return r.call(e,t)}},"159b":function(e,t,n){var i=n("da84"),r=n("fdbc"),o=n("17c2"),a=n("9112");for(var s in r){var l=i[s],c=l&&l.prototype;if(c&&c.forEach!==o)try{a(c,"forEach",o)}catch(e){c.forEach=o}}},"17c2":function(e,t,n){"use strict";var i=n("b727").forEach,r=n("a640"),o=n("ae40"),a=r("forEach"),s=o("forEach");e.exports=a&&s?[].forEach:function(e){return i(this,e,arguments.length>1?arguments[1]:void 0)}},"19aa":function(e,t){e.exports=function(e,t,n){if(!(e instanceof t))throw TypeError("Incorrect "+(n?n+" ":"")+"invocation");return e}},"1be4":function(e,t,n){var i=n("d066");e.exports=i("document","documentElement")},"1c0b":function(e,t){e.exports=function(e){if("function"!=typeof e)throw TypeError(String(e)+" is not a function");return e}},"1c7e":function(e,t,n){var i=n("b622")("iterator"),r=!1;try{var o=0,a={next:function(){return{done:!!o++}},return:function(){r=!0}};a[i]=function(){return this},Array.from(a,(function(){throw 2}))}catch(e){}e.exports=function(e,t){if(!t&&!r)return!1;var n=!1;try{var o={};o[i]=function(){return{next:function(){return{done:n=!0}}}},e(o)}catch(e){}return n}},"1cc0":function(e,t,n){"use strict";n.d(t,"b",(function(){return f})),n.d(t,"a",(function(){return p})),n.d(t,"d",(function(){return m})),n.d(t,"c",(function(){return v}));n("b0c0");var i=n("d4ec");n("131a");function r(e,t){return r=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e},r(e,t)}function o(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&r(e,t)}n("4ae1"),n("3410");function a(e){return a=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)},a(e)}n("d3b7"),n("25f0");function s(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(Reflect.construct(Date,[],(function(){}))),!0}catch(e){return!1}}var l=n("53ca");function c(e,t){return!t||"object"!==Object(l.a)(t)&&"function"!=typeof t?function(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}(e):t}function u(e){var t=s();return function(){var n,i=a(e);if(t){var r=a(this).constructor;n=Reflect.construct(i,arguments,r)}else n=i.apply(this,arguments);return c(this,n)}}n("e260"),n("4ec9"),n("3ca3"),n("ddb0"),n("c975");function d(e,t,n){return d=s()?Reflect.construct:function(e,t,n){var i=[null];i.push.apply(i,t);var o=new(Function.bind.apply(e,i));return n&&r(o,n.prototype),o},d.apply(null,arguments)}function h(e){var t="function"==typeof Map?new Map:void 0;return h=function(e){if(null===e||(n=e,-1===Function.toString.call(n).indexOf("[native code]")))return e;var n;if("function"!=typeof e)throw new TypeError("Super expression must either be null or a function");if(void 0!==t){if(t.has(e))return t.get(e);t.set(e,i)}function i(){return d(e,arguments,a(this).constructor)}return i.prototype=Object.create(e.prototype,{constructor:{value:i,enumerable:!1,writable:!0,configurable:!0}}),r(i,e)},h(e)}var f=function(e){o(n,e);var t=u(n);function n(){var e;return Object(i.a)(this,n),(e=t.call(this,"can't process cross-origin image")).name="DropImageFetchError",e}return n}(h(Error)),p=function(e){o(n,e);var t=u(n);function n(){var e;return Object(i.a)(this,n),(e=t.call(this,"drag-and-dropped file is not of type image and can't be decoded")).name="DropImageDecodeError",e}return n}(h(Error)),m=function(e){o(n,e);var t=u(n);function n(){var e;return Object(i.a)(this,n),(e=t.call(this,"this browser has no Stream API support")).name="StreamApiNotSupportedError",e}return n}(h(Error)),v=function(e){o(n,e);var t=u(n);function n(){var e;return Object(i.a)(this,n),(e=t.call(this,"camera access is only permitted in secure context. Use HTTPS or localhost rather than HTTP.")).name="InsecureContextError",e}return n}(h(Error))},"1cdc":function(e,t,n){var i=n("342f");e.exports=/(iphone|ipod|ipad).*applewebkit/i.test(i)},"1d80":function(e,t){e.exports=function(e){if(null==e)throw TypeError("Can't call method on "+e);return e}},"1da1":function(e,t,n){"use strict";n.d(t,"a",(function(){return r}));n("d3b7"),n("e6cf");function i(e,t,n,i,r,o,a){try{var s=e[o](a),l=s.value}catch(e){return void n(e)}s.done?t(l):Promise.resolve(l).then(i,r)}function r(e){return function(){var t=this,n=arguments;return new Promise((function(r,o){var a=e.apply(t,n);function s(e){i(a,r,o,s,l,"next",e)}function l(e){i(a,r,o,s,l,"throw",e)}s(void 0)}))}}},"1dde":function(e,t,n){var i=n("d039"),r=n("b622"),o=n("2d00"),a=r("species");e.exports=function(e){return o>=51||!i((function(){var t=[];return(t.constructor={})[a]=function(){return{foo:1}},1!==t[e](Boolean).foo}))}},2266:function(e,t,n){var i=n("825a"),r=n("e95a"),o=n("50c4"),a=n("0366"),s=n("35a1"),l=n("9bdd"),c=function(e,t){this.stopped=e,this.result=t};(e.exports=function(e,t,n,u,d){var h,f,p,m,v,g,_,b=a(t,n,u?2:1);if(d)h=e;else{if("function"!=typeof(f=s(e)))throw TypeError("Target is not iterable");if(r(f)){for(p=0,m=o(e.length);m>p;p++)if((v=u?b(i(_=e[p])[0],_[1]):b(e[p]))&&v instanceof c)return v;return new c(!1)}h=f.call(e)}for(g=h.next;!(_=g.call(h)).done;)if("object"==typeof(v=l(h,b,_.value,u))&&v&&v instanceof c)return v;return new c(!1)}).stop=function(e){return new c(!0,e)}},"23cb":function(e,t,n){var i=n("a691"),r=Math.max,o=Math.min;e.exports=function(e,t){var n=i(e);return n<0?r(n+t,0):o(n,t)}},"23e7":function(e,t,n){var i=n("da84"),r=n("06cf").f,o=n("9112"),a=n("6eeb"),s=n("ce4e"),l=n("e893"),c=n("94ca");e.exports=function(e,t){var n,u,d,h,f,p=e.target,m=e.global,v=e.stat;if(n=m?i:v?i[p]||s(p,{}):(i[p]||{}).prototype)for(u in t){if(h=t[u],d=e.noTargetGet?(f=r(n,u))&&f.value:n[u],!c(m?u:p+(v?".":"#")+u,e.forced)&&void 0!==d){if(typeof h==typeof d)continue;l(h,d)}(e.sham||d&&d.sham)&&o(h,"sham",!0),a(n,u,h,e)}}},"241c":function(e,t,n){var i=n("ca84"),r=n("7839").concat("length","prototype");t.f=Object.getOwnPropertyNames||function(e){return i(e,r)}},2493:function(e,t,n){var i=n("ede3");"string"==typeof i&&(i=[[e.i,i,""]]),i.locals&&(e.exports=i.locals);(0,n("499e").default)("4c9ea657",i,!0,{sourceMap:!1,shadowMode:!1})},"24fb":function(e,t,n){"use strict";e.exports=function(e){var t=[];return t.toString=function(){return this.map((function(t){var n=function(e,t){var n=e[1]||"",i=e[3];if(!i)return n;if(t&&"function"==typeof btoa){var r=(a=i,s=btoa(unescape(encodeURIComponent(JSON.stringify(a)))),l="sourceMappingURL=data:application/json;charset=utf-8;base64,".concat(s),"/*# ".concat(l," */")),o=i.sources.map((function(e){return"/*# sourceURL=".concat(i.sourceRoot||"").concat(e," */")}));return[n].concat(o).concat([r]).join("\n")}var a,s,l;return[n].join("\n")}(t,e);return t[2]?"@media ".concat(t[2]," {").concat(n,"}"):n})).join("")},t.i=function(e,n,i){"string"==typeof e&&(e=[[null,e,""]]);var r={};if(i)for(var o=0;o<this.length;o++){var a=this[o][0];null!=a&&(r[a]=!0)}for(var s=0;s<e.length;s++){var l=[].concat(e[s]);i&&r[l[0]]||(n&&(l[2]?l[2]="".concat(n," and ").concat(l[2]):l[2]=n),t.push(l))}},t}},2532:function(e,t,n){"use strict";var i=n("23e7"),r=n("5a34"),o=n("1d80");i({target:"String",proto:!0,forced:!n("ab13")("includes")},{includes:function(e){return!!~String(o(this)).indexOf(r(e),arguments.length>1?arguments[1]:void 0)}})},"25f0":function(e,t,n){"use strict";var i=n("6eeb"),r=n("825a"),o=n("d039"),a=n("ad6d"),s="toString",l=RegExp.prototype,c=l[s],u=o((function(){return"/a/b"!=c.call({source:"a",flags:"b"})})),d=c.name!=s;(u||d)&&i(RegExp.prototype,s,(function(){var e=r(this),t=String(e.source),n=e.flags;return"/"+t+"/"+String(void 0===n&&e instanceof RegExp&&!("flags"in l)?a.call(e):n)}),{unsafe:!0})},2626:function(e,t,n){"use strict";var i=n("d066"),r=n("9bf2"),o=n("b622"),a=n("83ab"),s=o("species");e.exports=function(e){var t=i(e),n=r.f;a&&t&&!t[s]&&n(t,s,{configurable:!0,get:function(){return this}})}},2877:function(e,t,n){"use strict";function i(e,t,n,i,r,o,a,s){var l,c="function"==typeof e?e.options:e;if(t&&(c.render=t,c.staticRenderFns=n,c._compiled=!0),i&&(c.functional=!0),o&&(c._scopeId="data-v-"+o),a?(l=function(e){(e=e||this.$vnode&&this.$vnode.ssrContext||this.parent&&this.parent.$vnode&&this.parent.$vnode.ssrContext)||"undefined"==typeof __VUE_SSR_CONTEXT__||(e=__VUE_SSR_CONTEXT__),r&&r.call(this,e),e&&e._registeredComponents&&e._registeredComponents.add(a)},c._ssrRegister=l):r&&(l=s?function(){r.call(this,(c.functional?this.parent:this).$root.$options.shadowRoot)}:r),l)if(c.functional){c._injectStyles=l;var u=c.render;c.render=function(e,t){return l.call(t),u(e,t)}}else{var d=c.beforeCreate;c.beforeCreate=d?[].concat(d,l):[l]}return{exports:e,options:c}}n.d(t,"a",(function(){return i}))},2909:function(e,t,n){"use strict";n.d(t,"a",(function(){return o}));var i=n("6b75");n("a4d3"),n("e01a"),n("d28b"),n("a630"),n("e260"),n("d3b7"),n("3ca3"),n("ddb0");var r=n("06c5");function o(e){return function(e){if(Array.isArray(e))return Object(i.a)(e)}(e)||function(e){if("undefined"!=typeof Symbol&&Symbol.iterator in Object(e))return Array.from(e)}(e)||Object(r.a)(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}},"2b3d":function(e,t,n){"use strict";n("3ca3");var i,r=n("23e7"),o=n("83ab"),a=n("0d3b"),s=n("da84"),l=n("37e8"),c=n("6eeb"),u=n("19aa"),d=n("5135"),h=n("60da"),f=n("4df4"),p=n("6547").codeAt,m=n("5fb2"),v=n("d44e"),g=n("9861"),_=n("69f3"),b=s.URL,y=g.URLSearchParams,w=g.getState,k=_.set,x=_.getterFor("URL"),S=Math.floor,C=Math.pow,M="Invalid scheme",T="Invalid host",A="Invalid port",P=/[A-Za-z]/,L=/[\d+-.A-Za-z]/,O=/\d/,q=/^(0x|0X)/,E=/^[0-7]+$/,D=/^\d+$/,z=/^[\dA-Fa-f]+$/,N=/[\u0000\u0009\u000A\u000D #%/:?@[\\]]/,j=/[\u0000\u0009\u000A\u000D #/:?@[\\]]/,R=/^[\u0000-\u001F ]+|[\u0000-\u001F ]+$/g,I=/[\u0009\u000A\u000D]/g,$=function(e,t){var n,i,r;if("["==t.charAt(0)){if("]"!=t.charAt(t.length-1))return T;if(!(n=B(t.slice(1,-1))))return T;e.host=n}else if(K(e)){if(t=m(t),N.test(t))return T;if(null===(n=F(t)))return T;e.host=n}else{if(j.test(t))return T;for(n="",i=f(t),r=0;r<i.length;r++)n+=G(i[r],H);e.host=n}},F=function(e){var t,n,i,r,o,a,s,l=e.split(".");if(l.length&&""==l[l.length-1]&&l.pop(),(t=l.length)>4)return e;for(n=[],i=0;i<t;i++){if(""==(r=l[i]))return e;if(o=10,r.length>1&&"0"==r.charAt(0)&&(o=q.test(r)?16:8,r=r.slice(8==o?1:2)),""===r)a=0;else{if(!(10==o?D:8==o?E:z).test(r))return e;a=parseInt(r,o)}n.push(a)}for(i=0;i<t;i++)if(a=n[i],i==t-1){if(a>=C(256,5-t))return null}else if(a>255)return null;for(s=n.pop(),i=0;i<n.length;i++)s+=n[i]*C(256,3-i);return s},B=function(e){var t,n,i,r,o,a,s,l=[0,0,0,0,0,0,0,0],c=0,u=null,d=0,h=function(){return e.charAt(d)};if(":"==h()){if(":"!=e.charAt(1))return;d+=2,u=++c}for(;h();){if(8==c)return;if(":"!=h()){for(t=n=0;n<4&&z.test(h());)t=16*t+parseInt(h(),16),d++,n++;if("."==h()){if(0==n)return;if(d-=n,c>6)return;for(i=0;h();){if(r=null,i>0){if(!("."==h()&&i<4))return;d++}if(!O.test(h()))return;for(;O.test(h());){if(o=parseInt(h(),10),null===r)r=o;else{if(0==r)return;r=10*r+o}if(r>255)return;d++}l[c]=256*l[c]+r,2!=++i&&4!=i||c++}if(4!=i)return;break}if(":"==h()){if(d++,!h())return}else if(h())return;l[c++]=t}else{if(null!==u)return;d++,u=++c}}if(null!==u)for(a=c-u,c=7;0!=c&&a>0;)s=l[c],l[c--]=l[u+a-1],l[u+--a]=s;else if(8!=c)return;return l},V=function(e){var t,n,i,r;if("number"==typeof e){for(t=[],n=0;n<4;n++)t.unshift(e%256),e=S(e/256);return t.join(".")}if("object"==typeof e){for(t="",i=function(e){for(var t=null,n=1,i=null,r=0,o=0;o<8;o++)0!==e[o]?(r>n&&(t=i,n=r),i=null,r=0):(null===i&&(i=o),++r);return r>n&&(t=i,n=r),t}(e),n=0;n<8;n++)r&&0===e[n]||(r&&(r=!1),i===n?(t+=n?":":"::",r=!0):(t+=e[n].toString(16),n<7&&(t+=":")));return"["+t+"]"}return e},H={},W=h({},H,{" ":1,'"':1,"<":1,">":1,"`":1}),U=h({},W,{"#":1,"?":1,"{":1,"}":1}),Y=h({},U,{"/":1,":":1,";":1,"=":1,"@":1,"[":1,"\\":1,"]":1,"^":1,"|":1}),G=function(e,t){var n=p(e,0);return n>32&&n<127&&!d(t,e)?e:encodeURIComponent(e)},Q={ftp:21,file:null,http:80,https:443,ws:80,wss:443},K=function(e){return d(Q,e.scheme)},Z=function(e){return""!=e.username||""!=e.password},J=function(e){return!e.host||e.cannotBeABaseURL||"file"==e.scheme},X=function(e,t){var n;return 2==e.length&&P.test(e.charAt(0))&&(":"==(n=e.charAt(1))||!t&&"|"==n)},ee=function(e){var t;return e.length>1&&X(e.slice(0,2))&&(2==e.length||"/"===(t=e.charAt(2))||"\\"===t||"?"===t||"#"===t)},te=function(e){var t=e.path,n=t.length;!n||"file"==e.scheme&&1==n&&X(t[0],!0)||t.pop()},ne=function(e){return"."===e||"%2e"===e.toLowerCase()},ie={},re={},oe={},ae={},se={},le={},ce={},ue={},de={},he={},fe={},pe={},me={},ve={},ge={},_e={},be={},ye={},we={},ke={},xe={},Se=function(e,t,n,r){var o,a,s,l,c,u=n||ie,h=0,p="",m=!1,v=!1,g=!1;for(n||(e.scheme="",e.username="",e.password="",e.host=null,e.port=null,e.path=[],e.query=null,e.fragment=null,e.cannotBeABaseURL=!1,t=t.replace(R,"")),t=t.replace(I,""),o=f(t);h<=o.length;){switch(a=o[h],u){case ie:if(!a||!P.test(a)){if(n)return M;u=oe;continue}p+=a.toLowerCase(),u=re;break;case re:if(a&&(L.test(a)||"+"==a||"-"==a||"."==a))p+=a.toLowerCase();else{if(":"!=a){if(n)return M;p="",u=oe,h=0;continue}if(n&&(K(e)!=d(Q,p)||"file"==p&&(Z(e)||null!==e.port)||"file"==e.scheme&&!e.host))return;if(e.scheme=p,n)return void(K(e)&&Q[e.scheme]==e.port&&(e.port=null));p="","file"==e.scheme?u=ve:K(e)&&r&&r.scheme==e.scheme?u=ae:K(e)?u=ue:"/"==o[h+1]?(u=se,h++):(e.cannotBeABaseURL=!0,e.path.push(""),u=we)}break;case oe:if(!r||r.cannotBeABaseURL&&"#"!=a)return M;if(r.cannotBeABaseURL&&"#"==a){e.scheme=r.scheme,e.path=r.path.slice(),e.query=r.query,e.fragment="",e.cannotBeABaseURL=!0,u=xe;break}u="file"==r.scheme?ve:le;continue;case ae:if("/"!=a||"/"!=o[h+1]){u=le;continue}u=de,h++;break;case se:if("/"==a){u=he;break}u=ye;continue;case le:if(e.scheme=r.scheme,a==i)e.username=r.username,e.password=r.password,e.host=r.host,e.port=r.port,e.path=r.path.slice(),e.query=r.query;else if("/"==a||"\\"==a&&K(e))u=ce;else if("?"==a)e.username=r.username,e.password=r.password,e.host=r.host,e.port=r.port,e.path=r.path.slice(),e.query="",u=ke;else{if("#"!=a){e.username=r.username,e.password=r.password,e.host=r.host,e.port=r.port,e.path=r.path.slice(),e.path.pop(),u=ye;continue}e.username=r.username,e.password=r.password,e.host=r.host,e.port=r.port,e.path=r.path.slice(),e.query=r.query,e.fragment="",u=xe}break;case ce:if(!K(e)||"/"!=a&&"\\"!=a){if("/"!=a){e.username=r.username,e.password=r.password,e.host=r.host,e.port=r.port,u=ye;continue}u=he}else u=de;break;case ue:if(u=de,"/"!=a||"/"!=p.charAt(h+1))continue;h++;break;case de:if("/"!=a&&"\\"!=a){u=he;continue}break;case he:if("@"==a){m&&(p="%40"+p),m=!0,s=f(p);for(var _=0;_<s.length;_++){var b=s[_];if(":"!=b||g){var y=G(b,Y);g?e.password+=y:e.username+=y}else g=!0}p=""}else if(a==i||"/"==a||"?"==a||"#"==a||"\\"==a&&K(e)){if(m&&""==p)return"Invalid authority";h-=f(p).length+1,p="",u=fe}else p+=a;break;case fe:case pe:if(n&&"file"==e.scheme){u=_e;continue}if(":"!=a||v){if(a==i||"/"==a||"?"==a||"#"==a||"\\"==a&&K(e)){if(K(e)&&""==p)return T;if(n&&""==p&&(Z(e)||null!==e.port))return;if(l=$(e,p))return l;if(p="",u=be,n)return;continue}"["==a?v=!0:"]"==a&&(v=!1),p+=a}else{if(""==p)return T;if(l=$(e,p))return l;if(p="",u=me,n==pe)return}break;case me:if(!O.test(a)){if(a==i||"/"==a||"?"==a||"#"==a||"\\"==a&&K(e)||n){if(""!=p){var w=parseInt(p,10);if(w>65535)return A;e.port=K(e)&&w===Q[e.scheme]?null:w,p=""}if(n)return;u=be;continue}return A}p+=a;break;case ve:if(e.scheme="file","/"==a||"\\"==a)u=ge;else{if(!r||"file"!=r.scheme){u=ye;continue}if(a==i)e.host=r.host,e.path=r.path.slice(),e.query=r.query;else if("?"==a)e.host=r.host,e.path=r.path.slice(),e.query="",u=ke;else{if("#"!=a){ee(o.slice(h).join(""))||(e.host=r.host,e.path=r.path.slice(),te(e)),u=ye;continue}e.host=r.host,e.path=r.path.slice(),e.query=r.query,e.fragment="",u=xe}}break;case ge:if("/"==a||"\\"==a){u=_e;break}r&&"file"==r.scheme&&!ee(o.slice(h).join(""))&&(X(r.path[0],!0)?e.path.push(r.path[0]):e.host=r.host),u=ye;continue;case _e:if(a==i||"/"==a||"\\"==a||"?"==a||"#"==a){if(!n&&X(p))u=ye;else if(""==p){if(e.host="",n)return;u=be}else{if(l=$(e,p))return l;if("localhost"==e.host&&(e.host=""),n)return;p="",u=be}continue}p+=a;break;case be:if(K(e)){if(u=ye,"/"!=a&&"\\"!=a)continue}else if(n||"?"!=a)if(n||"#"!=a){if(a!=i&&(u=ye,"/"!=a))continue}else e.fragment="",u=xe;else e.query="",u=ke;break;case ye:if(a==i||"/"==a||"\\"==a&&K(e)||!n&&("?"==a||"#"==a)){if(".."===(c=(c=p).toLowerCase())||"%2e."===c||".%2e"===c||"%2e%2e"===c?(te(e),"/"==a||"\\"==a&&K(e)||e.path.push("")):ne(p)?"/"==a||"\\"==a&&K(e)||e.path.push(""):("file"==e.scheme&&!e.path.length&&X(p)&&(e.host&&(e.host=""),p=p.charAt(0)+":"),e.path.push(p)),p="","file"==e.scheme&&(a==i||"?"==a||"#"==a))for(;e.path.length>1&&""===e.path[0];)e.path.shift();"?"==a?(e.query="",u=ke):"#"==a&&(e.fragment="",u=xe)}else p+=G(a,U);break;case we:"?"==a?(e.query="",u=ke):"#"==a?(e.fragment="",u=xe):a!=i&&(e.path[0]+=G(a,H));break;case ke:n||"#"!=a?a!=i&&("'"==a&&K(e)?e.query+="%27":e.query+="#"==a?"%23":G(a,H)):(e.fragment="",u=xe);break;case xe:a!=i&&(e.fragment+=G(a,W))}h++}},Ce=function(e){var t,n,i=u(this,Ce,"URL"),r=arguments.length>1?arguments[1]:void 0,a=String(e),s=k(i,{type:"URL"});if(void 0!==r)if(r instanceof Ce)t=x(r);else if(n=Se(t={},String(r)))throw TypeError(n);if(n=Se(s,a,null,t))throw TypeError(n);var l=s.searchParams=new y,c=w(l);c.updateSearchParams(s.query),c.updateURL=function(){s.query=String(l)||null},o||(i.href=Te.call(i),i.origin=Ae.call(i),i.protocol=Pe.call(i),i.username=Le.call(i),i.password=Oe.call(i),i.host=qe.call(i),i.hostname=Ee.call(i),i.port=De.call(i),i.pathname=ze.call(i),i.search=Ne.call(i),i.searchParams=je.call(i),i.hash=Re.call(i))},Me=Ce.prototype,Te=function(){var e=x(this),t=e.scheme,n=e.username,i=e.password,r=e.host,o=e.port,a=e.path,s=e.query,l=e.fragment,c=t+":";return null!==r?(c+="//",Z(e)&&(c+=n+(i?":"+i:"")+"@"),c+=V(r),null!==o&&(c+=":"+o)):"file"==t&&(c+="//"),c+=e.cannotBeABaseURL?a[0]:a.length?"/"+a.join("/"):"",null!==s&&(c+="?"+s),null!==l&&(c+="#"+l),c},Ae=function(){var e=x(this),t=e.scheme,n=e.port;if("blob"==t)try{return new URL(t.path[0]).origin}catch(e){return"null"}return"file"!=t&&K(e)?t+"://"+V(e.host)+(null!==n?":"+n:""):"null"},Pe=function(){return x(this).scheme+":"},Le=function(){return x(this).username},Oe=function(){return x(this).password},qe=function(){var e=x(this),t=e.host,n=e.port;return null===t?"":null===n?V(t):V(t)+":"+n},Ee=function(){var e=x(this).host;return null===e?"":V(e)},De=function(){var e=x(this).port;return null===e?"":String(e)},ze=function(){var e=x(this),t=e.path;return e.cannotBeABaseURL?t[0]:t.length?"/"+t.join("/"):""},Ne=function(){var e=x(this).query;return e?"?"+e:""},je=function(){return x(this).searchParams},Re=function(){var e=x(this).fragment;return e?"#"+e:""},Ie=function(e,t){return{get:e,set:t,configurable:!0,enumerable:!0}};if(o&&l(Me,{href:Ie(Te,(function(e){var t=x(this),n=String(e),i=Se(t,n);if(i)throw TypeError(i);w(t.searchParams).updateSearchParams(t.query)})),origin:Ie(Ae),protocol:Ie(Pe,(function(e){var t=x(this);Se(t,String(e)+":",ie)})),username:Ie(Le,(function(e){var t=x(this),n=f(String(e));if(!J(t)){t.username="";for(var i=0;i<n.length;i++)t.username+=G(n[i],Y)}})),password:Ie(Oe,(function(e){var t=x(this),n=f(String(e));if(!J(t)){t.password="";for(var i=0;i<n.length;i++)t.password+=G(n[i],Y)}})),host:Ie(qe,(function(e){var t=x(this);t.cannotBeABaseURL||Se(t,String(e),fe)})),hostname:Ie(Ee,(function(e){var t=x(this);t.cannotBeABaseURL||Se(t,String(e),pe)})),port:Ie(De,(function(e){var t=x(this);J(t)||(""==(e=String(e))?t.port=null:Se(t,e,me))})),pathname:Ie(ze,(function(e){var t=x(this);t.cannotBeABaseURL||(t.path=[],Se(t,e+"",be))})),search:Ie(Ne,(function(e){var t=x(this);""==(e=String(e))?t.query=null:("?"==e.charAt(0)&&(e=e.slice(1)),t.query="",Se(t,e,ke)),w(t.searchParams).updateSearchParams(t.query)})),searchParams:Ie(je),hash:Ie(Re,(function(e){var t=x(this);""!=(e=String(e))?("#"==e.charAt(0)&&(e=e.slice(1)),t.fragment="",Se(t,e,xe)):t.fragment=null}))}),c(Me,"toJSON",(function(){return Te.call(this)}),{enumerable:!0}),c(Me,"toString",(function(){return Te.call(this)}),{enumerable:!0}),b){var $e=b.createObjectURL,Fe=b.revokeObjectURL;$e&&c(Ce,"createObjectURL",(function(e){return $e.apply(b,arguments)})),Fe&&c(Ce,"revokeObjectURL",(function(e){return Fe.apply(b,arguments)}))}v(Ce,"URL"),r({global:!0,forced:!a,sham:!o},{URL:Ce})},"2ca0":function(e,t,n){"use strict";var i,r=n("23e7"),o=n("06cf").f,a=n("50c4"),s=n("5a34"),l=n("1d80"),c=n("ab13"),u=n("c430"),d="".startsWith,h=Math.min,f=c("startsWith");r({target:"String",proto:!0,forced:!!(u||f||(i=o(String.prototype,"startsWith"),!i||i.writable))&&!f},{startsWith:function(e){var t=String(l(this));s(e);var n=a(h(arguments.length>1?arguments[1]:void 0,t.length)),i=String(e);return d?d.call(t,i,n):t.slice(n,n+i.length)===i}})},"2cf4":function(e,t,n){var i,r,o,a=n("da84"),s=n("d039"),l=n("c6b6"),c=n("0366"),u=n("1be4"),d=n("cc12"),h=n("1cdc"),f=a.location,p=a.setImmediate,m=a.clearImmediate,v=a.process,g=a.MessageChannel,_=a.Dispatch,b=0,y={},w="onreadystatechange",k=function(e){if(y.hasOwnProperty(e)){var t=y[e];delete y[e],t()}},x=function(e){return function(){k(e)}},S=function(e){k(e.data)},C=function(e){a.postMessage(e+"",f.protocol+"//"+f.host)};p&&m||(p=function(e){for(var t=[],n=1;arguments.length>n;)t.push(arguments[n++]);return y[++b]=function(){("function"==typeof e?e:Function(e)).apply(void 0,t)},i(b),b},m=function(e){delete y[e]},"process"==l(v)?i=function(e){v.nextTick(x(e))}:_&&_.now?i=function(e){_.now(x(e))}:g&&!h?(o=(r=new g).port2,r.port1.onmessage=S,i=c(o.postMessage,o,1)):!a.addEventListener||"function"!=typeof postMessage||a.importScripts||s(C)||"file:"===f.protocol?i=w in d("script")?function(e){u.appendChild(d("script"))[w]=function(){u.removeChild(this),k(e)}}:function(e){setTimeout(x(e),0)}:(i=C,a.addEventListener("message",S,!1))),e.exports={set:p,clear:m}},"2d00":function(e,t,n){var i,r,o=n("da84"),a=n("342f"),s=o.process,l=s&&s.versions,c=l&&l.v8;c?r=(i=c.split("."))[0]+i[1]:a&&(!(i=a.match(/Edge\/(\d+)/))||i[1]>=74)&&(i=a.match(/Chrome\/(\d+)/))&&(r=i[1]),e.exports=r&&+r},3410:function(e,t,n){var i=n("23e7"),r=n("d039"),o=n("7b0b"),a=n("e163"),s=n("e177");i({target:"Object",stat:!0,forced:r((function(){a(1)})),sham:!s},{getPrototypeOf:function(e){return a(o(e))}})},"342f":function(e,t,n){var i=n("d066");e.exports=i("navigator","userAgent")||""},"35a1":function(e,t,n){var i=n("f5df"),r=n("3f8c"),o=n("b622")("iterator");e.exports=function(e){if(null!=e)return e[o]||e["@@iterator"]||r[i(e)]}},"37e8":function(e,t,n){var i=n("83ab"),r=n("9bf2"),o=n("825a"),a=n("df75");e.exports=i?Object.defineProperties:function(e,t){o(e);for(var n,i=a(t),s=i.length,l=0;s>l;)r.f(e,n=i[l++],t[n]);return e}},"3bbe":function(e,t,n){var i=n("861d");e.exports=function(e){if(!i(e)&&null!==e)throw TypeError("Can't set "+String(e)+" as a prototype");return e}},"3c85":function(e,t,n){"use strict";n("e260"),n("d3b7"),n("ac1f"),n("25f0"),n("3ca3"),n("466d"),n("498a"),n("ddb0"),n("2b3d");t.a=function(){return e=function(){self.importScripts("https://cdn.jsdelivr.net/npm/jsqr@1.3.1/dist/jsQR.min.js"),self.addEventListener("message",(function(e){var t=e.data,n=null;try{n=jsQR(t.data,t.width,t.height)}catch(e){if(!(e instanceof RangeError))throw e}var i=null,r=null;null!==n&&(i=n.data,r=n.location);var o={content:i,location:r,imageData:t};self.postMessage(o,[t.data.buffer])}))}.toString().trim().match(/^function\s*\w*\s*\([\w\s,]*\)\s*{([\w\W]*?)}$/)[1],new Worker(URL.createObjectURL(new Blob([e],{type:"text/javascript"})));var e}},"3ca3":function(e,t,n){"use strict";var i=n("6547").charAt,r=n("69f3"),o=n("7dd0"),a="String Iterator",s=r.set,l=r.getterFor(a);o(String,"String",(function(e){s(this,{type:a,string:String(e),index:0})}),(function(){var e,t=l(this),n=t.string,r=t.index;return r>=n.length?{value:void 0,done:!0}:(e=i(n,r),t.index+=e.length,{value:e,done:!1})}))},"3f8c":function(e,t){e.exports={}},4160:function(e,t,n){"use strict";var i=n("23e7"),r=n("17c2");i({target:"Array",proto:!0,forced:[].forEach!=r},{forEach:r})},"428f":function(e,t,n){var i=n("da84");e.exports=i},"44ad":function(e,t,n){var i=n("d039"),r=n("c6b6"),o="".split;e.exports=i((function(){return!Object("z").propertyIsEnumerable(0)}))?function(e){return"String"==r(e)?o.call(e,""):Object(e)}:Object},"44d2":function(e,t,n){var i=n("b622"),r=n("7c73"),o=n("9bf2"),a=i("unscopables"),s=Array.prototype;null==s[a]&&o.f(s,a,{configurable:!0,value:r(null)}),e.exports=function(e){s[a][e]=!0}},"44de":function(e,t,n){var i=n("da84");e.exports=function(e,t){var n=i.console;n&&n.error&&(1===arguments.length?n.error(e):n.error(e,t))}},"44e7":function(e,t,n){var i=n("861d"),r=n("c6b6"),o=n("b622")("match");e.exports=function(e){var t;return i(e)&&(void 0!==(t=e[o])?!!t:"RegExp"==r(e))}},"45fc":function(e,t,n){"use strict";var i=n("23e7"),r=n("b727").some,o=n("a640"),a=n("ae40"),s=o("some"),l=a("some");i({target:"Array",proto:!0,forced:!s||!l},{some:function(e){return r(this,e,arguments.length>1?arguments[1]:void 0)}})},"466d":function(e,t,n){"use strict";var i=n("d784"),r=n("825a"),o=n("50c4"),a=n("1d80"),s=n("8aa5"),l=n("14c3");i("match",1,(function(e,t,n){return[function(t){var n=a(this),i=null==t?void 0:t[e];return void 0!==i?i.call(t,n):new RegExp(t)[e](String(n))},function(e){var i=n(t,e,this);if(i.done)return i.value;var a=r(e),c=String(this);if(!a.global)return l(a,c);var u=a.unicode;a.lastIndex=0;for(var d,h=[],f=0;null!==(d=l(a,c));){var p=String(d[0]);h[f]=p,""===p&&(a.lastIndex=s(c,o(a.lastIndex),u)),f++}return 0===f?null:h}]}))},4840:function(e,t,n){var i=n("825a"),r=n("1c0b"),o=n("b622")("species");e.exports=function(e,t){var n,a=i(e).constructor;return void 0===a||null==(n=i(a)[o])?t:r(n)}},4930:function(e,t,n){var i=n("d039");e.exports=!!Object.getOwnPropertySymbols&&!i((function(){return!String(Symbol())}))},"498a":function(e,t,n){"use strict";var i=n("23e7"),r=n("58a8").trim;i({target:"String",proto:!0,forced:n("c8d2")("trim")},{trim:function(){return r(this)}})},"499e":function(e,t,n){"use strict";function i(e,t){for(var n=[],i={},r=0;r<t.length;r++){var o=t[r],a=o[0],s={id:e+":"+r,css:o[1],media:o[2],sourceMap:o[3]};i[a]?i[a].parts.push(s):n.push(i[a]={id:a,parts:[s]})}return n}n.r(t),n.d(t,"default",(function(){return p}));var r="undefined"!=typeof document;if("undefined"!=typeof DEBUG&&DEBUG&&!r)throw new Error("vue-style-loader cannot be used in a non-browser environment. Use { target: 'node' } in your Webpack config to indicate a server-rendering environment.");var o={},a=r&&(document.head||document.getElementsByTagName("head")[0]),s=null,l=0,c=!1,u=function(){},d=null,h="data-vue-ssr-id",f="undefined"!=typeof navigator&&/msie [6-9]\b/.test(navigator.userAgent.toLowerCase());function p(e,t,n,r){c=n,d=r||{};var a=i(e,t);return m(a),function(t){for(var n=[],r=0;r<a.length;r++){var s=a[r];(l=o[s.id]).refs--,n.push(l)}t?m(a=i(e,t)):a=[];for(r=0;r<n.length;r++){var l;if(0===(l=n[r]).refs){for(var c=0;c<l.parts.length;c++)l.parts[c]();delete o[l.id]}}}}function m(e){for(var t=0;t<e.length;t++){var n=e[t],i=o[n.id];if(i){i.refs++;for(var r=0;r<i.parts.length;r++)i.parts[r](n.parts[r]);for(;r<n.parts.length;r++)i.parts.push(g(n.parts[r]));i.parts.length>n.parts.length&&(i.parts.length=n.parts.length)}else{var a=[];for(r=0;r<n.parts.length;r++)a.push(g(n.parts[r]));o[n.id]={id:n.id,refs:1,parts:a}}}}function v(){var e=document.createElement("style");return e.type="text/css",a.appendChild(e),e}function g(e){var t,n,i=document.querySelector("style["+h+'~="'+e.id+'"]');if(i){if(c)return u;i.parentNode.removeChild(i)}if(f){var r=l++;i=s||(s=v()),t=y.bind(null,i,r,!1),n=y.bind(null,i,r,!0)}else i=v(),t=w.bind(null,i),n=function(){i.parentNode.removeChild(i)};return t(e),function(i){if(i){if(i.css===e.css&&i.media===e.media&&i.sourceMap===e.sourceMap)return;t(e=i)}else n()}}var _,b=(_=[],function(e,t){return _[e]=t,_.filter(Boolean).join("\n")});function y(e,t,n,i){var r=n?"":i.css;if(e.styleSheet)e.styleSheet.cssText=b(t,r);else{var o=document.createTextNode(r),a=e.childNodes;a[t]&&e.removeChild(a[t]),a.length?e.insertBefore(o,a[t]):e.appendChild(o)}}function w(e,t){var n=t.css,i=t.media,r=t.sourceMap;if(i&&e.setAttribute("media",i),d.ssrId&&e.setAttribute(h,t.id),r&&(n+="\n/*# sourceURL="+r.sources[0]+" */",n+="\n/*# sourceMappingURL=data:application/json;base64,"+btoa(unescape(encodeURIComponent(JSON.stringify(r))))+" */"),e.styleSheet)e.styleSheet.cssText=n;else{for(;e.firstChild;)e.removeChild(e.firstChild);e.appendChild(document.createTextNode(n))}}},"4ae1":function(e,t,n){var i=n("23e7"),r=n("d066"),o=n("1c0b"),a=n("825a"),s=n("861d"),l=n("7c73"),c=n("0538"),u=n("d039"),d=r("Reflect","construct"),h=u((function(){function e(){}return!(d((function(){}),[],e)instanceof e)})),f=!u((function(){d((function(){}))})),p=h||f;i({target:"Reflect",stat:!0,forced:p,sham:p},{construct:function(e,t){o(e),a(t);var n=arguments.length<3?e:o(arguments[2]);if(f&&!h)return d(e,t,n);if(e==n){switch(t.length){case 0:return new e;case 1:return new e(t[0]);case 2:return new e(t[0],t[1]);case 3:return new e(t[0],t[1],t[2]);case 4:return new e(t[0],t[1],t[2],t[3])}var i=[null];return i.push.apply(i,t),new(c.apply(e,i))}var r=n.prototype,u=l(s(r)?r:Object.prototype),p=Function.apply.call(e,u,t);return s(p)?p:u}})},"4d64":function(e,t,n){var i=n("fc6a"),r=n("50c4"),o=n("23cb"),a=function(e){return function(t,n,a){var s,l=i(t),c=r(l.length),u=o(a,c);if(e&&n!=n){for(;c>u;)if((s=l[u++])!=s)return!0}else for(;c>u;u++)if((e||u in l)&&l[u]===n)return e||u||0;return!e&&-1}};e.exports={includes:a(!0),indexOf:a(!1)}},"4de4":function(e,t,n){"use strict";var i=n("23e7"),r=n("b727").filter,o=n("1dde"),a=n("ae40"),s=o("filter"),l=a("filter");i({target:"Array",proto:!0,forced:!s||!l},{filter:function(e){return r(this,e,arguments.length>1?arguments[1]:void 0)}})},"4df4":function(e,t,n){"use strict";var i=n("0366"),r=n("7b0b"),o=n("9bdd"),a=n("e95a"),s=n("50c4"),l=n("8418"),c=n("35a1");e.exports=function(e){var t,n,u,d,h,f,p=r(e),m="function"==typeof this?this:Array,v=arguments.length,g=v>1?arguments[1]:void 0,_=void 0!==g,b=c(p),y=0;if(_&&(g=i(g,v>2?arguments[2]:void 0,2)),null==b||m==Array&&a(b))for(n=new m(t=s(p.length));t>y;y++)f=_?g(p[y],y):p[y],l(n,y,f);else for(h=(d=b.call(p)).next,n=new m;!(u=h.call(d)).done;y++)f=_?o(d,g,[u.value,y],!0):u.value,l(n,y,f);return n.length=y,n}},"4ec9":function(e,t,n){"use strict";var i=n("6d61"),r=n("6566");e.exports=i("Map",(function(e){return function(){return e(this,arguments.length?arguments[0]:void 0)}}),r)},"50c4":function(e,t,n){var i=n("a691"),r=Math.min;e.exports=function(e){return e>0?r(i(e),9007199254740991):0}},5135:function(e,t){var n={}.hasOwnProperty;e.exports=function(e,t){return n.call(e,t)}},"53ca":function(e,t,n){"use strict";n.d(t,"a",(function(){return i}));n("a4d3"),n("e01a"),n("d28b"),n("e260"),n("d3b7"),n("3ca3"),n("ddb0");function i(e){return i="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e},i(e)}},5692:function(e,t,n){var i=n("c430"),r=n("c6cd");(e.exports=function(e,t){return r[e]||(r[e]=void 0!==t?t:{})})("versions",[]).push({version:"3.6.5",mode:i?"pure":"global",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})},"56ef":function(e,t,n){var i=n("d066"),r=n("241c"),o=n("7418"),a=n("825a");e.exports=i("Reflect","ownKeys")||function(e){var t=r.f(a(e)),n=o.f;return n?t.concat(n(e)):t}},5899:function(e,t){e.exports="\t\n\v\f\r                　\u2028\u2029\ufeff"},"58a8":function(e,t,n){var i=n("1d80"),r="["+n("5899")+"]",o=RegExp("^"+r+r+"*"),a=RegExp(r+r+"*$"),s=function(e){return function(t){var n=String(i(t));return 1&e&&(n=n.replace(o,"")),2&e&&(n=n.replace(a,"")),n}};e.exports={start:s(1),end:s(2),trim:s(3)}},"5a34":function(e,t,n){var i=n("44e7");e.exports=function(e){if(i(e))throw TypeError("The method doesn't accept regular expressions");return e}},"5c0b":function(e,t,n){"use strict";n("4160"),n("d81d"),n("159b"),n("96cf");var i=n("1da1"),r=n("2909"),o=n("a180"),a=n("f718"),s=n("b3af"),l=n("3c85"),c={name:"qrcode-capture",mixins:[s.a],props:{worker:{type:Function,default:l.a}},methods:{onChangeInput:function(e){Object(r.a)(e.target.files).map(this.processFile).forEach(this.onDetect)},processFile:function(e){var t=this;return Object(i.a)(regeneratorRuntime.mark((function n(){var i,r;return regeneratorRuntime.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:return n.next=2,Object(a.a)(e);case 2:return i=n.sent,n.next=5,Object(o.b)(t.worker,i);case 5:return r=n.sent,n.abrupt("return",r);case 7:case"end":return n.stop()}}),n)})))()}}},u=n("2877"),d=Object(u.a)(c,(function(){var e=this,t=e.$createElement;return(e._self._c||t)("input",{attrs:{type:"file",name:"image",accept:"image/*",capture:"environment",multiple:""},on:{change:e.onChangeInput}})}),[],!1,null,null,null);t.a=d.exports},"5c6c":function(e,t){e.exports=function(e,t){return{enumerable:!(1&e),configurable:!(2&e),writable:!(4&e),value:t}}},"5fb2":function(e,t,n){"use strict";var i=2147483647,r=/[^\0-\u007E]/,o=/[.\u3002\uFF0E\uFF61]/g,a="Overflow: input needs wider integers to process",s=Math.floor,l=String.fromCharCode,c=function(e){return e+22+75*(e<26)},u=function(e,t,n){var i=0;for(e=n?s(e/700):e>>1,e+=s(e/t);e>455;i+=36)e=s(e/35);return s(i+36*e/(e+38))},d=function(e){var t=[];e=function(e){for(var t=[],n=0,i=e.length;n<i;){var r=e.charCodeAt(n++);if(r>=55296&&r<=56319&&n<i){var o=e.charCodeAt(n++);56320==(64512&o)?t.push(((1023&r)<<10)+(1023&o)+65536):(t.push(r),n--)}else t.push(r)}return t}(e);var n,r,o=e.length,d=128,h=0,f=72;for(n=0;n<e.length;n++)(r=e[n])<128&&t.push(l(r));var p=t.length,m=p;for(p&&t.push("-");m<o;){var v=i;for(n=0;n<e.length;n++)(r=e[n])>=d&&r<v&&(v=r);var g=m+1;if(v-d>s((i-h)/g))throw RangeError(a);for(h+=(v-d)*g,d=v,n=0;n<e.length;n++){if((r=e[n])<d&&++h>i)throw RangeError(a);if(r==d){for(var _=h,b=36;;b+=36){var y=b<=f?1:b>=f+26?26:b-f;if(_<y)break;var w=_-y,k=36-y;t.push(l(c(y+w%k))),_=s(w/k)}t.push(l(c(_))),f=u(h,g,m==p),h=0,++m}}++h,++d}return t.join("")};e.exports=function(e){var t,n,i=[],a=e.toLowerCase().replace(o,".").split(".");for(t=0;t<a.length;t++)n=a[t],i.push(r.test(n)?"xn--"+d(n):n);return i.join(".")}},"60da":function(e,t,n){"use strict";var i=n("83ab"),r=n("d039"),o=n("df75"),a=n("7418"),s=n("d1e7"),l=n("7b0b"),c=n("44ad"),u=Object.assign,d=Object.defineProperty;e.exports=!u||r((function(){if(i&&1!==u({b:1},u(d({},"a",{enumerable:!0,get:function(){d(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var e={},t={},n=Symbol(),r="abcdefghijklmnopqrst";return e[n]=7,r.split("").forEach((function(e){t[e]=e})),7!=u({},e)[n]||o(u({},t)).join("")!=r}))?function(e,t){for(var n=l(e),r=arguments.length,u=1,d=a.f,h=s.f;r>u;)for(var f,p=c(arguments[u++]),m=d?o(p).concat(d(p)):o(p),v=m.length,g=0;v>g;)f=m[g++],i&&!h.call(p,f)||(n[f]=p[f]);return n}:u},6547:function(e,t,n){var i=n("a691"),r=n("1d80"),o=function(e){return function(t,n){var o,a,s=String(r(t)),l=i(n),c=s.length;return l<0||l>=c?e?"":void 0:(o=s.charCodeAt(l))<55296||o>56319||l+1===c||(a=s.charCodeAt(l+1))<56320||a>57343?e?s.charAt(l):o:e?s.slice(l,l+2):a-56320+(o-55296<<10)+65536}};e.exports={codeAt:o(!1),charAt:o(!0)}},6566:function(e,t,n){"use strict";var i=n("9bf2").f,r=n("7c73"),o=n("e2cc"),a=n("0366"),s=n("19aa"),l=n("2266"),c=n("7dd0"),u=n("2626"),d=n("83ab"),h=n("f183").fastKey,f=n("69f3"),p=f.set,m=f.getterFor;e.exports={getConstructor:function(e,t,n,c){var u=e((function(e,i){s(e,u,t),p(e,{type:t,index:r(null),first:void 0,last:void 0,size:0}),d||(e.size=0),null!=i&&l(i,e[c],e,n)})),f=m(t),v=function(e,t,n){var i,r,o=f(e),a=g(e,t);return a?a.value=n:(o.last=a={index:r=h(t,!0),key:t,value:n,previous:i=o.last,next:void 0,removed:!1},o.first||(o.first=a),i&&(i.next=a),d?o.size++:e.size++,"F"!==r&&(o.index[r]=a)),e},g=function(e,t){var n,i=f(e),r=h(t);if("F"!==r)return i.index[r];for(n=i.first;n;n=n.next)if(n.key==t)return n};return o(u.prototype,{clear:function(){for(var e=f(this),t=e.index,n=e.first;n;)n.removed=!0,n.previous&&(n.previous=n.previous.next=void 0),delete t[n.index],n=n.next;e.first=e.last=void 0,d?e.size=0:this.size=0},delete:function(e){var t=this,n=f(t),i=g(t,e);if(i){var r=i.next,o=i.previous;delete n.index[i.index],i.removed=!0,o&&(o.next=r),r&&(r.previous=o),n.first==i&&(n.first=r),n.last==i&&(n.last=o),d?n.size--:t.size--}return!!i},forEach:function(e){for(var t,n=f(this),i=a(e,arguments.length>1?arguments[1]:void 0,3);t=t?t.next:n.first;)for(i(t.value,t.key,this);t&&t.removed;)t=t.previous},has:function(e){return!!g(this,e)}}),o(u.prototype,n?{get:function(e){var t=g(this,e);return t&&t.value},set:function(e,t){return v(this,0===e?0:e,t)}}:{add:function(e){return v(this,e=0===e?0:e,e)}}),d&&i(u.prototype,"size",{get:function(){return f(this).size}}),u},setStrong:function(e,t,n){var i=t+" Iterator",r=m(t),o=m(i);c(e,t,(function(e,t){p(this,{type:i,target:e,state:r(e),kind:t,last:void 0})}),(function(){for(var e=o(this),t=e.kind,n=e.last;n&&n.removed;)n=n.previous;return e.target&&(e.last=n=n?n.next:e.state.first)?"keys"==t?{value:n.key,done:!1}:"values"==t?{value:n.value,done:!1}:{value:[n.key,n.value],done:!1}:(e.target=void 0,{value:void 0,done:!0})}),n?"entries":"values",!n,!0),u(t)}}},"65f0":function(e,t,n){var i=n("861d"),r=n("e8b5"),o=n("b622")("species");e.exports=function(e,t){var n;return r(e)&&("function"!=typeof(n=e.constructor)||n!==Array&&!r(n.prototype)?i(n)&&null===(n=n[o])&&(n=void 0):n=void 0),new(void 0===n?Array:n)(0===t?0:t)}},"69f3":function(e,t,n){var i,r,o,a=n("7f9a"),s=n("da84"),l=n("861d"),c=n("9112"),u=n("5135"),d=n("f772"),h=n("d012"),f=s.WeakMap;if(a){var p=new f,m=p.get,v=p.has,g=p.set;i=function(e,t){return g.call(p,e,t),t},r=function(e){return m.call(p,e)||{}},o=function(e){return v.call(p,e)}}else{var _=d("state");h[_]=!0,i=function(e,t){return c(e,_,t),t},r=function(e){return u(e,_)?e[_]:{}},o=function(e){return u(e,_)}}e.exports={set:i,get:r,has:o,enforce:function(e){return o(e)?r(e):i(e,{})},getterFor:function(e){return function(t){var n;if(!l(t)||(n=r(t)).type!==e)throw TypeError("Incompatible receiver, "+e+" required");return n}}}},"6b75":function(e,t,n){"use strict";function i(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,i=new Array(t);n<t;n++)i[n]=e[n];return i}n.d(t,"a",(function(){return i}))},"6d61":function(e,t,n){"use strict";var i=n("23e7"),r=n("da84"),o=n("94ca"),a=n("6eeb"),s=n("f183"),l=n("2266"),c=n("19aa"),u=n("861d"),d=n("d039"),h=n("1c7e"),f=n("d44e"),p=n("7156");e.exports=function(e,t,n){var m=-1!==e.indexOf("Map"),v=-1!==e.indexOf("Weak"),g=m?"set":"add",_=r[e],b=_&&_.prototype,y=_,w={},k=function(e){var t=b[e];a(b,e,"add"==e?function(e){return t.call(this,0===e?0:e),this}:"delete"==e?function(e){return!(v&&!u(e))&&t.call(this,0===e?0:e)}:"get"==e?function(e){return v&&!u(e)?void 0:t.call(this,0===e?0:e)}:"has"==e?function(e){return!(v&&!u(e))&&t.call(this,0===e?0:e)}:function(e,n){return t.call(this,0===e?0:e,n),this})};if(o(e,"function"!=typeof _||!(v||b.forEach&&!d((function(){(new _).entries().next()})))))y=n.getConstructor(t,e,m,g),s.REQUIRED=!0;else if(o(e,!0)){var x=new y,S=x[g](v?{}:-0,1)!=x,C=d((function(){x.has(1)})),M=h((function(e){new _(e)})),T=!v&&d((function(){for(var e=new _,t=5;t--;)e[g](t,t);return!e.has(-0)}));M||((y=t((function(t,n){c(t,y,e);var i=p(new _,t,y);return null!=n&&l(n,i[g],i,m),i}))).prototype=b,b.constructor=y),(C||T)&&(k("delete"),k("has"),m&&k("get")),(T||S)&&k(g),v&&b.clear&&delete b.clear}return w[e]=y,i({global:!0,forced:y!=_},w),f(y,e),v||n.setStrong(y,e,m),y}},"6eeb":function(e,t,n){var i=n("da84"),r=n("9112"),o=n("5135"),a=n("ce4e"),s=n("8925"),l=n("69f3"),c=l.get,u=l.enforce,d=String(String).split("String");(e.exports=function(e,t,n,s){var l=!!s&&!!s.unsafe,c=!!s&&!!s.enumerable,h=!!s&&!!s.noTargetGet;"function"==typeof n&&("string"!=typeof t||o(n,"name")||r(n,"name",t),u(n).source=d.join("string"==typeof t?t:"")),e!==i?(l?!h&&e[t]&&(c=!0):delete e[t],c?e[t]=n:r(e,t,n)):c?e[t]=n:a(t,n)})(Function.prototype,"toString",(function(){return"function"==typeof this&&c(this).source||s(this)}))},7156:function(e,t,n){var i=n("861d"),r=n("d2bb");e.exports=function(e,t,n){var o,a;return r&&"function"==typeof(o=t.constructor)&&o!==n&&i(a=o.prototype)&&a!==n.prototype&&r(e,a),e}},7418:function(e,t){t.f=Object.getOwnPropertySymbols},"746f":function(e,t,n){var i=n("428f"),r=n("5135"),o=n("e538"),a=n("9bf2").f;e.exports=function(e){var t=i.Symbol||(i.Symbol={});r(t,e)||a(t,e,{value:o.f(e)})}},7839:function(e,t){e.exports=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"]},"7b0b":function(e,t,n){var i=n("1d80");e.exports=function(e){return Object(i(e))}},"7c73":function(e,t,n){var i,r=n("825a"),o=n("37e8"),a=n("7839"),s=n("d012"),l=n("1be4"),c=n("cc12"),u=n("f772"),d="prototype",h="script",f=u("IE_PROTO"),p=function(){},m=function(e){return"<"+h+">"+e+"</"+h+">"},v=function(){try{i=document.domain&&new ActiveXObject("htmlfile")}catch(e){}var e,t,n;v=i?function(e){e.write(m("")),e.close();var t=e.parentWindow.Object;return e=null,t}(i):(t=c("iframe"),n="java"+h+":",t.style.display="none",l.appendChild(t),t.src=String(n),(e=t.contentWindow.document).open(),e.write(m("document.F=Object")),e.close(),e.F);for(var r=a.length;r--;)delete v[d][a[r]];return v()};s[f]=!0,e.exports=Object.create||function(e,t){var n;return null!==e?(p[d]=r(e),n=new p,p[d]=null,n[f]=e):n=v(),void 0===t?n:o(n,t)}},"7db0":function(e,t,n){"use strict";var i=n("23e7"),r=n("b727").find,o=n("44d2"),a=n("ae40"),s="find",l=!0,c=a(s);s in[]&&Array(1)[s]((function(){l=!1})),i({target:"Array",proto:!0,forced:l||!c},{find:function(e){return r(this,e,arguments.length>1?arguments[1]:void 0)}}),o(s)},"7dd0":function(e,t,n){"use strict";var i=n("23e7"),r=n("9ed3"),o=n("e163"),a=n("d2bb"),s=n("d44e"),l=n("9112"),c=n("6eeb"),u=n("b622"),d=n("c430"),h=n("3f8c"),f=n("ae93"),p=f.IteratorPrototype,m=f.BUGGY_SAFARI_ITERATORS,v=u("iterator"),g="keys",_="values",b="entries",y=function(){return this};e.exports=function(e,t,n,u,f,w,k){r(n,t,u);var x,S,C,M=function(e){if(e===f&&O)return O;if(!m&&e in P)return P[e];switch(e){case g:case _:case b:return function(){return new n(this,e)}}return function(){return new n(this)}},T=t+" Iterator",A=!1,P=e.prototype,L=P[v]||P["@@iterator"]||f&&P[f],O=!m&&L||M(f),q="Array"==t&&P.entries||L;if(q&&(x=o(q.call(new e)),p!==Object.prototype&&x.next&&(d||o(x)===p||(a?a(x,p):"function"!=typeof x[v]&&l(x,v,y)),s(x,T,!0,!0),d&&(h[T]=y))),f==_&&L&&L.name!==_&&(A=!0,O=function(){return L.call(this)}),d&&!k||P[v]===O||l(P,v,O),h[t]=O,f)if(S={values:M(_),keys:w?O:M(g),entries:M(b)},k)for(C in S)(m||A||!(C in P))&&c(P,C,S[C]);else i({target:t,proto:!0,forced:m||A},S);return S}},"7f9a":function(e,t,n){var i=n("da84"),r=n("8925"),o=i.WeakMap;e.exports="function"==typeof o&&/native code/.test(r(o))},"825a":function(e,t,n){var i=n("861d");e.exports=function(e){if(!i(e))throw TypeError(String(e)+" is not an object");return e}},"83ab":function(e,t,n){var i=n("d039");e.exports=!i((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]}))},8418:function(e,t,n){"use strict";var i=n("c04e"),r=n("9bf2"),o=n("5c6c");e.exports=function(e,t,n){var a=i(t);a in e?r.f(e,a,o(0,n)):e[a]=n}},"861d":function(e,t){e.exports=function(e){return"object"==typeof e?null!==e:"function"==typeof e}},8875:function(e,t,n){var i,r,o;"undefined"!=typeof self&&self,r=[],void 0===(o="function"==typeof(i=function(){function e(){var t=Object.getOwnPropertyDescriptor(document,"currentScript");if(!t&&"currentScript"in document&&document.currentScript)return document.currentScript;if(t&&t.get!==e&&document.currentScript)return document.currentScript;try{throw new Error}catch(e){var n,i,r,o=/@([^@]*):(\d+):(\d+)\s*$/gi,a=/.*at [^(]*\((.*):(.+):(.+)\)$/gi.exec(e.stack)||o.exec(e.stack),s=a&&a[1]||!1,l=a&&a[2]||!1,c=document.location.href.replace(document.location.hash,""),u=document.getElementsByTagName("script");s===c&&(n=document.documentElement.outerHTML,i=new RegExp("(?:[^\\n]+?\\n){0,"+(l-2)+"}[^<]*<script>([\\d\\D]*?)<\\/script>[\\d\\D]*","i"),r=n.replace(i,"$1").trim());for(var d=0;d<u.length;d++){if("interactive"===u[d].readyState)return u[d];if(u[d].src===s)return u[d];if(s===c&&u[d].innerHTML&&u[d].innerHTML.trim()===r)return u[d]}return null}}return e})?i.apply(t,r):i)||(e.exports=o)},8925:function(e,t,n){var i=n("c6cd"),r=Function.toString;"function"!=typeof i.inspectSource&&(i.inspectSource=function(e){return r.call(e)}),e.exports=i.inspectSource},"8a79":function(e,t,n){"use strict";var i,r=n("23e7"),o=n("06cf").f,a=n("50c4"),s=n("5a34"),l=n("1d80"),c=n("ab13"),u=n("c430"),d="".endsWith,h=Math.min,f=c("endsWith");r({target:"String",proto:!0,forced:!!(u||f||(i=o(String.prototype,"endsWith"),!i||i.writable))&&!f},{endsWith:function(e){var t=String(l(this));s(e);var n=arguments.length>1?arguments[1]:void 0,i=a(t.length),r=void 0===n?i:h(a(n),i),o=String(e);return d?d.call(t,o,r):t.slice(r-o.length,r)===o}})},"8aa5":function(e,t,n){"use strict";var i=n("6547").charAt;e.exports=function(e,t,n){return t+(n?i(e,t).length:1)}},"90e3":function(e,t){var n=0,i=Math.random();e.exports=function(e){return"Symbol("+String(void 0===e?"":e)+")_"+(++n+i).toString(36)}},9112:function(e,t,n){var i=n("83ab"),r=n("9bf2"),o=n("5c6c");e.exports=i?function(e,t,n){return r.f(e,t,o(1,n))}:function(e,t,n){return e[t]=n,e}},9263:function(e,t,n){"use strict";var i,r,o=n("ad6d"),a=n("9f7f"),s=RegExp.prototype.exec,l=String.prototype.replace,c=s,u=(i=/a/,r=/b*/g,s.call(i,"a"),s.call(r,"a"),0!==i.lastIndex||0!==r.lastIndex),d=a.UNSUPPORTED_Y||a.BROKEN_CARET,h=void 0!==/()??/.exec("")[1];(u||h||d)&&(c=function(e){var t,n,i,r,a=this,c=d&&a.sticky,f=o.call(a),p=a.source,m=0,v=e;return c&&(-1===(f=f.replace("y","")).indexOf("g")&&(f+="g"),v=String(e).slice(a.lastIndex),a.lastIndex>0&&(!a.multiline||a.multiline&&"\n"!==e[a.lastIndex-1])&&(p="(?: "+p+")",v=" "+v,m++),n=new RegExp("^(?:"+p+")",f)),h&&(n=new RegExp("^"+p+"$(?!\\s)",f)),u&&(t=a.lastIndex),i=s.call(c?n:a,v),c?i?(i.input=i.input.slice(m),i[0]=i[0].slice(m),i.index=a.lastIndex,a.lastIndex+=i[0].length):a.lastIndex=0:u&&i&&(a.lastIndex=a.global?i.index+i[0].length:t),h&&i&&i.length>1&&l.call(i[0],n,(function(){for(r=1;r<arguments.length-2;r++)void 0===arguments[r]&&(i[r]=void 0)})),i}),e.exports=c},"94ca":function(e,t,n){var i=n("d039"),r=/#|\.prototype\./,o=function(e,t){var n=s[a(e)];return n==c||n!=l&&("function"==typeof t?i(t):!!t)},a=o.normalize=function(e){return String(e).replace(r,".").toLowerCase()},s=o.data={},l=o.NATIVE="N",c=o.POLYFILL="P";e.exports=o},"96cf":function(e,t,n){var i=function(e){"use strict";var t,n=Object.prototype,i=n.hasOwnProperty,r="function"==typeof Symbol?Symbol:{},o=r.iterator||"@@iterator",a=r.asyncIterator||"@@asyncIterator",s=r.toStringTag||"@@toStringTag";function l(e,t,n,i){var r=t&&t.prototype instanceof m?t:m,o=Object.create(r.prototype),a=new T(i||[]);return o._invoke=function(e,t,n){var i=u;return function(r,o){if(i===h)throw new Error("Generator is already running");if(i===f){if("throw"===r)throw o;return P()}for(n.method=r,n.arg=o;;){var a=n.delegate;if(a){var s=S(a,n);if(s){if(s===p)continue;return s}}if("next"===n.method)n.sent=n._sent=n.arg;else if("throw"===n.method){if(i===u)throw i=f,n.arg;n.dispatchException(n.arg)}else"return"===n.method&&n.abrupt("return",n.arg);i=h;var l=c(e,t,n);if("normal"===l.type){if(i=n.done?f:d,l.arg===p)continue;return{value:l.arg,done:n.done}}"throw"===l.type&&(i=f,n.method="throw",n.arg=l.arg)}}}(e,n,a),o}function c(e,t,n){try{return{type:"normal",arg:e.call(t,n)}}catch(e){return{type:"throw",arg:e}}}e.wrap=l;var u="suspendedStart",d="suspendedYield",h="executing",f="completed",p={};function m(){}function v(){}function g(){}var _={};_[o]=function(){return this};var b=Object.getPrototypeOf,y=b&&b(b(A([])));y&&y!==n&&i.call(y,o)&&(_=y);var w=g.prototype=m.prototype=Object.create(_);function k(e){["next","throw","return"].forEach((function(t){e[t]=function(e){return this._invoke(t,e)}}))}function x(e,t){function n(r,o,a,s){var l=c(e[r],e,o);if("throw"!==l.type){var u=l.arg,d=u.value;return d&&"object"==typeof d&&i.call(d,"__await")?t.resolve(d.__await).then((function(e){n("next",e,a,s)}),(function(e){n("throw",e,a,s)})):t.resolve(d).then((function(e){u.value=e,a(u)}),(function(e){return n("throw",e,a,s)}))}s(l.arg)}var r;this._invoke=function(e,i){function o(){return new t((function(t,r){n(e,i,t,r)}))}return r=r?r.then(o,o):o()}}function S(e,n){var i=e.iterator[n.method];if(i===t){if(n.delegate=null,"throw"===n.method){if(e.iterator.return&&(n.method="return",n.arg=t,S(e,n),"throw"===n.method))return p;n.method="throw",n.arg=new TypeError("The iterator does not provide a 'throw' method")}return p}var r=c(i,e.iterator,n.arg);if("throw"===r.type)return n.method="throw",n.arg=r.arg,n.delegate=null,p;var o=r.arg;return o?o.done?(n[e.resultName]=o.value,n.next=e.nextLoc,"return"!==n.method&&(n.method="next",n.arg=t),n.delegate=null,p):o:(n.method="throw",n.arg=new TypeError("iterator result is not an object"),n.delegate=null,p)}function C(e){var t={tryLoc:e[0]};1 in e&&(t.catchLoc=e[1]),2 in e&&(t.finallyLoc=e[2],t.afterLoc=e[3]),this.tryEntries.push(t)}function M(e){var t=e.completion||{};t.type="normal",delete t.arg,e.completion=t}function T(e){this.tryEntries=[{tryLoc:"root"}],e.forEach(C,this),this.reset(!0)}function A(e){if(e){var n=e[o];if(n)return n.call(e);if("function"==typeof e.next)return e;if(!isNaN(e.length)){var r=-1,a=function n(){for(;++r<e.length;)if(i.call(e,r))return n.value=e[r],n.done=!1,n;return n.value=t,n.done=!0,n};return a.next=a}}return{next:P}}function P(){return{value:t,done:!0}}return v.prototype=w.constructor=g,g.constructor=v,g[s]=v.displayName="GeneratorFunction",e.isGeneratorFunction=function(e){var t="function"==typeof e&&e.constructor;return!!t&&(t===v||"GeneratorFunction"===(t.displayName||t.name))},e.mark=function(e){return Object.setPrototypeOf?Object.setPrototypeOf(e,g):(e.__proto__=g,s in e||(e[s]="GeneratorFunction")),e.prototype=Object.create(w),e},e.awrap=function(e){return{__await:e}},k(x.prototype),x.prototype[a]=function(){return this},e.AsyncIterator=x,e.async=function(t,n,i,r,o){void 0===o&&(o=Promise);var a=new x(l(t,n,i,r),o);return e.isGeneratorFunction(n)?a:a.next().then((function(e){return e.done?e.value:a.next()}))},k(w),w[s]="Generator",w[o]=function(){return this},w.toString=function(){return"[object Generator]"},e.keys=function(e){var t=[];for(var n in e)t.push(n);return t.reverse(),function n(){for(;t.length;){var i=t.pop();if(i in e)return n.value=i,n.done=!1,n}return n.done=!0,n}},e.values=A,T.prototype={constructor:T,reset:function(e){if(this.prev=0,this.next=0,this.sent=this._sent=t,this.done=!1,this.delegate=null,this.method="next",this.arg=t,this.tryEntries.forEach(M),!e)for(var n in this)"t"===n.charAt(0)&&i.call(this,n)&&!isNaN(+n.slice(1))&&(this[n]=t)},stop:function(){this.done=!0;var e=this.tryEntries[0].completion;if("throw"===e.type)throw e.arg;return this.rval},dispatchException:function(e){if(this.done)throw e;var n=this;function r(i,r){return s.type="throw",s.arg=e,n.next=i,r&&(n.method="next",n.arg=t),!!r}for(var o=this.tryEntries.length-1;o>=0;--o){var a=this.tryEntries[o],s=a.completion;if("root"===a.tryLoc)return r("end");if(a.tryLoc<=this.prev){var l=i.call(a,"catchLoc"),c=i.call(a,"finallyLoc");if(l&&c){if(this.prev<a.catchLoc)return r(a.catchLoc,!0);if(this.prev<a.finallyLoc)return r(a.finallyLoc)}else if(l){if(this.prev<a.catchLoc)return r(a.catchLoc,!0)}else{if(!c)throw new Error("try statement without catch or finally");if(this.prev<a.finallyLoc)return r(a.finallyLoc)}}}},abrupt:function(e,t){for(var n=this.tryEntries.length-1;n>=0;--n){var r=this.tryEntries[n];if(r.tryLoc<=this.prev&&i.call(r,"finallyLoc")&&this.prev<r.finallyLoc){var o=r;break}}o&&("break"===e||"continue"===e)&&o.tryLoc<=t&&t<=o.finallyLoc&&(o=null);var a=o?o.completion:{};return a.type=e,a.arg=t,o?(this.method="next",this.next=o.finallyLoc,p):this.complete(a)},complete:function(e,t){if("throw"===e.type)throw e.arg;return"break"===e.type||"continue"===e.type?this.next=e.arg:"return"===e.type?(this.rval=this.arg=e.arg,this.method="return",this.next="end"):"normal"===e.type&&t&&(this.next=t),p},finish:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var n=this.tryEntries[t];if(n.finallyLoc===e)return this.complete(n.completion,n.afterLoc),M(n),p}},catch:function(e){for(var t=this.tryEntries.length-1;t>=0;--t){var n=this.tryEntries[t];if(n.tryLoc===e){var i=n.completion;if("throw"===i.type){var r=i.arg;M(n)}return r}}throw new Error("illegal catch attempt")},delegateYield:function(e,n,i){return this.delegate={iterator:A(e),resultName:n,nextLoc:i},"next"===this.method&&(this.arg=t),p}},e}(e.exports);try{regeneratorRuntime=i}catch(e){Function("r","regeneratorRuntime = r")(i)}},9861:function(e,t,n){"use strict";n("e260");var i=n("23e7"),r=n("d066"),o=n("0d3b"),a=n("6eeb"),s=n("e2cc"),l=n("d44e"),c=n("9ed3"),u=n("69f3"),d=n("19aa"),h=n("5135"),f=n("0366"),p=n("f5df"),m=n("825a"),v=n("861d"),g=n("7c73"),_=n("5c6c"),b=n("9a1f"),y=n("35a1"),w=n("b622"),k=r("fetch"),x=r("Headers"),S=w("iterator"),C="URLSearchParams",M=C+"Iterator",T=u.set,A=u.getterFor(C),P=u.getterFor(M),L=/\+/g,O=Array(4),q=function(e){return O[e-1]||(O[e-1]=RegExp("((?:%[\\da-f]{2}){"+e+"})","gi"))},E=function(e){try{return decodeURIComponent(e)}catch(t){return e}},D=function(e){var t=e.replace(L," "),n=4;try{return decodeURIComponent(t)}catch(e){for(;n;)t=t.replace(q(n--),E);return t}},z=/[!'()~]|%20/g,N={"!":"%21","'":"%27","(":"%28",")":"%29","~":"%7E","%20":"+"},j=function(e){return N[e]},R=function(e){return encodeURIComponent(e).replace(z,j)},I=function(e,t){if(t)for(var n,i,r=t.split("&"),o=0;o<r.length;)(n=r[o++]).length&&(i=n.split("="),e.push({key:D(i.shift()),value:D(i.join("="))}))},$=function(e){this.entries.length=0,I(this.entries,e)},F=function(e,t){if(e<t)throw TypeError("Not enough arguments")},B=c((function(e,t){T(this,{type:M,iterator:b(A(e).entries),kind:t})}),"Iterator",(function(){var e=P(this),t=e.kind,n=e.iterator.next(),i=n.value;return n.done||(n.value="keys"===t?i.key:"values"===t?i.value:[i.key,i.value]),n})),V=function(){d(this,V,C);var e,t,n,i,r,o,a,s,l,c=arguments.length>0?arguments[0]:void 0,u=[];if(T(this,{type:C,entries:u,updateURL:function(){},updateSearchParams:$}),void 0!==c)if(v(c))if("function"==typeof(e=y(c)))for(n=(t=e.call(c)).next;!(i=n.call(t)).done;){if((a=(o=(r=b(m(i.value))).next).call(r)).done||(s=o.call(r)).done||!o.call(r).done)throw TypeError("Expected sequence with length 2");u.push({key:a.value+"",value:s.value+""})}else for(l in c)h(c,l)&&u.push({key:l,value:c[l]+""});else I(u,"string"==typeof c?"?"===c.charAt(0)?c.slice(1):c:c+"")},H=V.prototype;s(H,{append:function(e,t){F(arguments.length,2);var n=A(this);n.entries.push({key:e+"",value:t+""}),n.updateURL()},delete:function(e){F(arguments.length,1);for(var t=A(this),n=t.entries,i=e+"",r=0;r<n.length;)n[r].key===i?n.splice(r,1):r++;t.updateURL()},get:function(e){F(arguments.length,1);for(var t=A(this).entries,n=e+"",i=0;i<t.length;i++)if(t[i].key===n)return t[i].value;return null},getAll:function(e){F(arguments.length,1);for(var t=A(this).entries,n=e+"",i=[],r=0;r<t.length;r++)t[r].key===n&&i.push(t[r].value);return i},has:function(e){F(arguments.length,1);for(var t=A(this).entries,n=e+"",i=0;i<t.length;)if(t[i++].key===n)return!0;return!1},set:function(e,t){F(arguments.length,1);for(var n,i=A(this),r=i.entries,o=!1,a=e+"",s=t+"",l=0;l<r.length;l++)(n=r[l]).key===a&&(o?r.splice(l--,1):(o=!0,n.value=s));o||r.push({key:a,value:s}),i.updateURL()},sort:function(){var e,t,n,i=A(this),r=i.entries,o=r.slice();for(r.length=0,n=0;n<o.length;n++){for(e=o[n],t=0;t<n;t++)if(r[t].key>e.key){r.splice(t,0,e);break}t===n&&r.push(e)}i.updateURL()},forEach:function(e){for(var t,n=A(this).entries,i=f(e,arguments.length>1?arguments[1]:void 0,3),r=0;r<n.length;)i((t=n[r++]).value,t.key,this)},keys:function(){return new B(this,"keys")},values:function(){return new B(this,"values")},entries:function(){return new B(this,"entries")}},{enumerable:!0}),a(H,S,H.entries),a(H,"toString",(function(){for(var e,t=A(this).entries,n=[],i=0;i<t.length;)e=t[i++],n.push(R(e.key)+"="+R(e.value));return n.join("&")}),{enumerable:!0}),l(V,C),i({global:!0,forced:!o},{URLSearchParams:V}),o||"function"!=typeof k||"function"!=typeof x||i({global:!0,enumerable:!0,forced:!0},{fetch:function(e){var t,n,i,r=[e];return arguments.length>1&&(v(t=arguments[1])&&(n=t.body,p(n)===C&&((i=t.headers?new x(t.headers):new x).has("content-type")||i.set("content-type","application/x-www-form-urlencoded;charset=UTF-8"),t=g(t,{body:_(0,String(n)),headers:_(0,i)}))),r.push(t)),k.apply(this,r)}}),e.exports={URLSearchParams:V,getState:A}},"99af":function(e,t,n){"use strict";var i=n("23e7"),r=n("d039"),o=n("e8b5"),a=n("861d"),s=n("7b0b"),l=n("50c4"),c=n("8418"),u=n("65f0"),d=n("1dde"),h=n("b622"),f=n("2d00"),p=h("isConcatSpreadable"),m=9007199254740991,v="Maximum allowed index exceeded",g=f>=51||!r((function(){var e=[];return e[p]=!1,e.concat()[0]!==e})),_=d("concat"),b=function(e){if(!a(e))return!1;var t=e[p];return void 0!==t?!!t:o(e)};i({target:"Array",proto:!0,forced:!g||!_},{concat:function(e){var t,n,i,r,o,a=s(this),d=u(a,0),h=0;for(t=-1,i=arguments.length;t<i;t++)if(b(o=-1===t?a:arguments[t])){if(h+(r=l(o.length))>m)throw TypeError(v);for(n=0;n<r;n++,h++)n in o&&c(d,h,o[n])}else{if(h>=m)throw TypeError(v);c(d,h++,o)}return d.length=h,d}})},"9a1f":function(e,t,n){var i=n("825a"),r=n("35a1");e.exports=function(e){var t=r(e);if("function"!=typeof t)throw TypeError(String(e)+" is not iterable");return i(t.call(e))}},"9bdd":function(e,t,n){var i=n("825a");e.exports=function(e,t,n,r){try{return r?t(i(n)[0],n[1]):t(n)}catch(t){var o=e.return;throw void 0!==o&&i(o.call(e)),t}}},"9bf2":function(e,t,n){var i=n("83ab"),r=n("0cfb"),o=n("825a"),a=n("c04e"),s=Object.defineProperty;t.f=i?s:function(e,t,n){if(o(e),t=a(t,!0),o(n),r)try{return s(e,t,n)}catch(e){}if("get"in n||"set"in n)throw TypeError("Accessors not supported");return"value"in n&&(e[t]=n.value),e}},"9ed3":function(e,t,n){"use strict";var i=n("ae93").IteratorPrototype,r=n("7c73"),o=n("5c6c"),a=n("d44e"),s=n("3f8c"),l=function(){return this};e.exports=function(e,t,n){var c=t+" Iterator";return e.prototype=r(i,{next:o(1,n)}),a(e,c,!1,!0),s[c]=l,e}},"9f7f":function(e,t,n){"use strict";var i=n("d039");function r(e,t){return RegExp(e,t)}t.UNSUPPORTED_Y=i((function(){var e=r("a","y");return e.lastIndex=2,null!=e.exec("abcd")})),t.BROKEN_CARET=i((function(){var e=r("^r","gy");return e.lastIndex=2,null!=e.exec("str")}))},a180:function(e,t,n){"use strict";n.d(t,"b",(function(){return o})),n.d(t,"a",(function(){return a}));n("96cf");var i=n("1da1"),r=n("c036"),o=function(){var e=Object(i.a)(regeneratorRuntime.mark((function e(t,n){var i,o;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:return(i=t()).postMessage(n,[n.data.buffer]),e.next=4,Object(r.a)(i,"message");case 4:return o=e.sent,i.terminate(),e.abrupt("return",o.data);case 7:case"end":return e.stop()}}),e)})));return function(t,n){return e.apply(this,arguments)}}(),a=function(e,t,n){var i=n.detectHandler,r=n.locateHandler,o=n.minDelay,a=null,s=null,l=performance.now(),c=e(),u=!1,d=!0;c.onmessage=function(e){u=!1;var t=e.data,n=t.content,o=t.location;null!==n&&n!==a&&i(e.data),o!==s&&r(o),a=n||a,s=o};return function e(n){if(d){if(window.requestAnimationFrame(e),n-l>=o&&(l=n,!1===u)){u=!0;var i=t.captureFrame();c.postMessage(i,[i.data.buffer])}}else c.terminate()}(),function(){d=!1}}},a434:function(e,t,n){"use strict";var i=n("23e7"),r=n("23cb"),o=n("a691"),a=n("50c4"),s=n("7b0b"),l=n("65f0"),c=n("8418"),u=n("1dde"),d=n("ae40"),h=u("splice"),f=d("splice",{ACCESSORS:!0,0:0,1:2}),p=Math.max,m=Math.min;i({target:"Array",proto:!0,forced:!h||!f},{splice:function(e,t){var n,i,u,d,h,f,v=s(this),g=a(v.length),_=r(e,g),b=arguments.length;if(0===b?n=i=0:1===b?(n=0,i=g-_):(n=b-2,i=m(p(o(t),0),g-_)),g+n-i>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(u=l(v,i),d=0;d<i;d++)(h=_+d)in v&&c(u,d,v[h]);if(u.length=i,n<i){for(d=_;d<g-i;d++)f=d+n,(h=d+i)in v?v[f]=v[h]:delete v[f];for(d=g;d>g-i+n;d--)delete v[d-1]}else if(n>i)for(d=g-i;d>_;d--)f=d+n-1,(h=d+i-1)in v?v[f]=v[h]:delete v[f];for(d=0;d<n;d++)v[d+_]=arguments[d+2];return v.length=g-i+n,u}})},a4d3:function(e,t,n){"use strict";var i=n("23e7"),r=n("da84"),o=n("d066"),a=n("c430"),s=n("83ab"),l=n("4930"),c=n("fdbf"),u=n("d039"),d=n("5135"),h=n("e8b5"),f=n("861d"),p=n("825a"),m=n("7b0b"),v=n("fc6a"),g=n("c04e"),_=n("5c6c"),b=n("7c73"),y=n("df75"),w=n("241c"),k=n("057f"),x=n("7418"),S=n("06cf"),C=n("9bf2"),M=n("d1e7"),T=n("9112"),A=n("6eeb"),P=n("5692"),L=n("f772"),O=n("d012"),q=n("90e3"),E=n("b622"),D=n("e538"),z=n("746f"),N=n("d44e"),j=n("69f3"),R=n("b727").forEach,I=L("hidden"),$="Symbol",F="prototype",B=E("toPrimitive"),V=j.set,H=j.getterFor($),W=Object[F],U=r.Symbol,Y=o("JSON","stringify"),G=S.f,Q=C.f,K=k.f,Z=M.f,J=P("symbols"),X=P("op-symbols"),ee=P("string-to-symbol-registry"),te=P("symbol-to-string-registry"),ne=P("wks"),ie=r.QObject,re=!ie||!ie[F]||!ie[F].findChild,oe=s&&u((function(){return 7!=b(Q({},"a",{get:function(){return Q(this,"a",{value:7}).a}})).a}))?function(e,t,n){var i=G(W,t);i&&delete W[t],Q(e,t,n),i&&e!==W&&Q(W,t,i)}:Q,ae=function(e,t){var n=J[e]=b(U[F]);return V(n,{type:$,tag:e,description:t}),s||(n.description=t),n},se=c?function(e){return"symbol"==typeof e}:function(e){return Object(e)instanceof U},le=function(e,t,n){e===W&&le(X,t,n),p(e);var i=g(t,!0);return p(n),d(J,i)?(n.enumerable?(d(e,I)&&e[I][i]&&(e[I][i]=!1),n=b(n,{enumerable:_(0,!1)})):(d(e,I)||Q(e,I,_(1,{})),e[I][i]=!0),oe(e,i,n)):Q(e,i,n)},ce=function(e,t){p(e);var n=v(t),i=y(n).concat(fe(n));return R(i,(function(t){s&&!ue.call(n,t)||le(e,t,n[t])})),e},ue=function(e){var t=g(e,!0),n=Z.call(this,t);return!(this===W&&d(J,t)&&!d(X,t))&&(!(n||!d(this,t)||!d(J,t)||d(this,I)&&this[I][t])||n)},de=function(e,t){var n=v(e),i=g(t,!0);if(n!==W||!d(J,i)||d(X,i)){var r=G(n,i);return!r||!d(J,i)||d(n,I)&&n[I][i]||(r.enumerable=!0),r}},he=function(e){var t=K(v(e)),n=[];return R(t,(function(e){d(J,e)||d(O,e)||n.push(e)})),n},fe=function(e){var t=e===W,n=K(t?X:v(e)),i=[];return R(n,(function(e){!d(J,e)||t&&!d(W,e)||i.push(J[e])})),i};(l||(U=function(){if(this instanceof U)throw TypeError("Symbol is not a constructor");var e=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,t=q(e),n=function(e){this===W&&n.call(X,e),d(this,I)&&d(this[I],t)&&(this[I][t]=!1),oe(this,t,_(1,e))};return s&&re&&oe(W,t,{configurable:!0,set:n}),ae(t,e)},A(U[F],"toString",(function(){return H(this).tag})),A(U,"withoutSetter",(function(e){return ae(q(e),e)})),M.f=ue,C.f=le,S.f=de,w.f=k.f=he,x.f=fe,D.f=function(e){return ae(E(e),e)},s&&(Q(U[F],"description",{configurable:!0,get:function(){return H(this).description}}),a||A(W,"propertyIsEnumerable",ue,{unsafe:!0}))),i({global:!0,wrap:!0,forced:!l,sham:!l},{Symbol:U}),R(y(ne),(function(e){z(e)})),i({target:$,stat:!0,forced:!l},{for:function(e){var t=String(e);if(d(ee,t))return ee[t];var n=U(t);return ee[t]=n,te[n]=t,n},keyFor:function(e){if(!se(e))throw TypeError(e+" is not a symbol");if(d(te,e))return te[e]},useSetter:function(){re=!0},useSimple:function(){re=!1}}),i({target:"Object",stat:!0,forced:!l,sham:!s},{create:function(e,t){return void 0===t?b(e):ce(b(e),t)},defineProperty:le,defineProperties:ce,getOwnPropertyDescriptor:de}),i({target:"Object",stat:!0,forced:!l},{getOwnPropertyNames:he,getOwnPropertySymbols:fe}),i({target:"Object",stat:!0,forced:u((function(){x.f(1)}))},{getOwnPropertySymbols:function(e){return x.f(m(e))}}),Y)&&i({target:"JSON",stat:!0,forced:!l||u((function(){var e=U();return"[null]"!=Y([e])||"{}"!=Y({a:e})||"{}"!=Y(Object(e))}))},{stringify:function(e,t,n){for(var i,r=[e],o=1;arguments.length>o;)r.push(arguments[o++]);if(i=t,(f(t)||void 0!==e)&&!se(e))return h(t)||(t=function(e,t){if("function"==typeof i&&(t=i.call(this,e,t)),!se(t))return t}),r[1]=t,Y.apply(null,r)}});U[F][B]||T(U[F],B,U[F].valueOf),N(U,$),O[I]=!0},a630:function(e,t,n){var i=n("23e7"),r=n("4df4");i({target:"Array",stat:!0,forced:!n("1c7e")((function(e){Array.from(e)}))},{from:r})},a640:function(e,t,n){"use strict";var i=n("d039");e.exports=function(e,t){var n=[][e];return!!n&&i((function(){n.call(null,t||function(){throw 1},1)}))}},a691:function(e,t){var n=Math.ceil,i=Math.floor;e.exports=function(e){return isNaN(e=+e)?0:(e>0?i:n)(e)}},ab13:function(e,t,n){var i=n("b622")("match");e.exports=function(e){var t=/./;try{"/./"[e](t)}catch(n){try{return t[i]=!1,"/./"[e](t)}catch(e){}}return!1}},ac1f:function(e,t,n){"use strict";var i=n("23e7"),r=n("9263");i({target:"RegExp",proto:!0,forced:/./.exec!==r},{exec:r})},ad6d:function(e,t,n){"use strict";var i=n("825a");e.exports=function(){var e=i(this),t="";return e.global&&(t+="g"),e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),e.dotAll&&(t+="s"),e.unicode&&(t+="u"),e.sticky&&(t+="y"),t}},ae40:function(e,t,n){var i=n("83ab"),r=n("d039"),o=n("5135"),a=Object.defineProperty,s={},l=function(e){throw e};e.exports=function(e,t){if(o(s,e))return s[e];t||(t={});var n=[][e],c=!!o(t,"ACCESSORS")&&t.ACCESSORS,u=o(t,0)?t[0]:l,d=o(t,1)?t[1]:void 0;return s[e]=!!n&&!r((function(){if(c&&!i)return!0;var e={length:-1};c?a(e,1,{enumerable:!0,get:l}):e[1]=1,n.call(e,u,d)}))}},ae93:function(e,t,n){"use strict";var i,r,o,a=n("e163"),s=n("9112"),l=n("5135"),c=n("b622"),u=n("c430"),d=c("iterator"),h=!1;[].keys&&("next"in(o=[].keys())?(r=a(a(o)))!==Object.prototype&&(i=r):h=!0),null==i&&(i={}),u||l(i,d)||s(i,d,(function(){return this})),e.exports={IteratorPrototype:i,BUGGY_SAFARI_ITERATORS:h}},b041:function(e,t,n){"use strict";var i=n("00ee"),r=n("f5df");e.exports=i?{}.toString:function(){return"[object "+r(this)+"]"}},b0c0:function(e,t,n){var i=n("83ab"),r=n("9bf2").f,o=Function.prototype,a=o.toString,s=/^\s*function ([^ (]*)/,l="name";i&&!(l in o)&&r(o,l,{configurable:!0,get:function(){try{return a.call(this).match(s)[1]}catch(e){return""}}})},b3af:function(e,t,n){"use strict";n("96cf");var i=n("1da1"),r={methods:{onDetect:function(e){var t=this;return Object(i.a)(regeneratorRuntime.mark((function n(){var i,r;return regeneratorRuntime.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:return t.$emit("detect",e),n.prev=1,n.next=4,e;case 4:i=n.sent,null!==(r=i.content)&&t.$emit("decode",r),n.next=11;break;case 9:n.prev=9,n.t0=n.catch(1);case 11:case"end":return n.stop()}}),n,null,[[1,9]])})))()}}},o=n("2877"),a=Object(o.a)(r,undefined,undefined,!1,null,null,null);t.a=a.exports},b575:function(e,t,n){var i,r,o,a,s,l,c,u,d=n("da84"),h=n("06cf").f,f=n("c6b6"),p=n("2cf4").set,m=n("1cdc"),v=d.MutationObserver||d.WebKitMutationObserver,g=d.process,_=d.Promise,b="process"==f(g),y=h(d,"queueMicrotask"),w=y&&y.value;w||(i=function(){var e,t;for(b&&(e=g.domain)&&e.exit();r;){t=r.fn,r=r.next;try{t()}catch(e){throw r?a():o=void 0,e}}o=void 0,e&&e.enter()},b?a=function(){g.nextTick(i)}:v&&!m?(s=!0,l=document.createTextNode(""),new v(i).observe(l,{characterData:!0}),a=function(){l.data=s=!s}):_&&_.resolve?(c=_.resolve(void 0),u=c.then,a=function(){u.call(c,i)}):a=function(){p.call(d,i)}),e.exports=w||function(e){var t={fn:e,next:void 0};o&&(o.next=t),r||(r=t,a()),o=t}},b622:function(e,t,n){var i=n("da84"),r=n("5692"),o=n("5135"),a=n("90e3"),s=n("4930"),l=n("fdbf"),c=r("wks"),u=i.Symbol,d=l?u:u&&u.withoutSetter||a;e.exports=function(e){return o(c,e)||(s&&o(u,e)?c[e]=u[e]:c[e]=d("Symbol."+e)),c[e]}},b635:function(e,t,n){"use strict";(function(e){n.d(t,"e",(function(){return a}));var i=n("0d0e");n.d(t,"c",(function(){return i.a}));var r=n("5c0b");n.d(t,"a",(function(){return r.a}));var o=n("fe6b");function a(e){e.component("qrcode-stream",i.a),e.component("qrcode-capture",r.a),e.component("qrcode-drop-zone",o.a)}n.d(t,"b",(function(){return o.a}));var s={install:a};t.d=s;var l=null;"undefined"!=typeof window?l=window.Vue:void 0!==e&&(l=e.Vue),l&&l.use(s)}).call(this,n("c8ba"))},b64b:function(e,t,n){var i=n("23e7"),r=n("7b0b"),o=n("df75");i({target:"Object",stat:!0,forced:n("d039")((function(){o(1)}))},{keys:function(e){return o(r(e))}})},b727:function(e,t,n){var i=n("0366"),r=n("44ad"),o=n("7b0b"),a=n("50c4"),s=n("65f0"),l=[].push,c=function(e){var t=1==e,n=2==e,c=3==e,u=4==e,d=6==e,h=5==e||d;return function(f,p,m,v){for(var g,_,b=o(f),y=r(b),w=i(p,m,3),k=a(y.length),x=0,S=v||s,C=t?S(f,k):n?S(f,0):void 0;k>x;x++)if((h||x in y)&&(_=w(g=y[x],x,b),e))if(t)C[x]=_;else if(_)switch(e){case 3:return!0;case 5:return g;case 6:return x;case 2:l.call(C,g)}else if(u)return!1;return d?-1:c||u?u:C}};e.exports={forEach:c(0),map:c(1),filter:c(2),some:c(3),every:c(4),find:c(5),findIndex:c(6)}},bb2f:function(e,t,n){var i=n("d039");e.exports=!i((function(){return Object.isExtensible(Object.preventExtensions({}))}))},c036:function(e,t,n){"use strict";function i(e,t,n){var i,r;void 0===n&&(n="error");var o=new Promise((function(e,t){i=e,r=t}));return e.addEventListener(t,i),e.addEventListener(n,r),o.finally((function(){e.removeEventListener(t,i),e.removeEventListener(n,r)})),o}function r(e){return new Promise((function(t){return setTimeout(t,e)}))}n.d(t,"a",(function(){return i})),n.d(t,"b",(function(){return r}))},c04e:function(e,t,n){var i=n("861d");e.exports=function(e,t){if(!i(e))return e;var n,r;if(t&&"function"==typeof(n=e.toString)&&!i(r=n.call(e)))return r;if("function"==typeof(n=e.valueOf)&&!i(r=n.call(e)))return r;if(!t&&"function"==typeof(n=e.toString)&&!i(r=n.call(e)))return r;throw TypeError("Can't convert object to primitive value")}},c244:function(e,t,n){"use strict";var i=n("2493");n.n(i).a},c430:function(e,t){e.exports=!1},c6b6:function(e,t){var n={}.toString;e.exports=function(e){return n.call(e).slice(8,-1)}},c6cd:function(e,t,n){var i=n("da84"),r=n("ce4e"),o="__core-js_shared__",a=i[o]||r(o,{});e.exports=a},c8ba:function(e,t){var n;n=function(){return this}();try{n=n||new Function("return this")()}catch(e){"object"==typeof window&&(n=window)}e.exports=n},c8d2:function(e,t,n){var i=n("d039"),r=n("5899");e.exports=function(e){return i((function(){return!!r[e]()||"​᠎"!="​᠎"[e]()||r[e].name!==e}))}},c975:function(e,t,n){"use strict";var i=n("23e7"),r=n("4d64").indexOf,o=n("a640"),a=n("ae40"),s=[].indexOf,l=!!s&&1/[1].indexOf(1,-0)<0,c=o("indexOf"),u=a("indexOf",{ACCESSORS:!0,1:0});i({target:"Array",proto:!0,forced:l||!c||!u},{indexOf:function(e){return l?s.apply(this,arguments)||0:r(this,e,arguments.length>1?arguments[1]:void 0)}})},ca84:function(e,t,n){var i=n("5135"),r=n("fc6a"),o=n("4d64").indexOf,a=n("d012");e.exports=function(e,t){var n,s=r(e),l=0,c=[];for(n in s)!i(a,n)&&i(s,n)&&c.push(n);for(;t.length>l;)i(s,n=t[l++])&&(~o(c,n)||c.push(n));return c}},caad:function(e,t,n){"use strict";var i=n("23e7"),r=n("4d64").includes,o=n("44d2");i({target:"Array",proto:!0,forced:!n("ae40")("indexOf",{ACCESSORS:!0,1:0})},{includes:function(e){return r(this,e,arguments.length>1?arguments[1]:void 0)}}),o("includes")},cc12:function(e,t,n){var i=n("da84"),r=n("861d"),o=i.document,a=r(o)&&r(o.createElement);e.exports=function(e){return a?o.createElement(e):{}}},cca6:function(e,t,n){var i=n("23e7"),r=n("60da");i({target:"Object",stat:!0,forced:Object.assign!==r},{assign:r})},cdf9:function(e,t,n){var i=n("825a"),r=n("861d"),o=n("f069");e.exports=function(e,t){if(i(e),r(t)&&t.constructor===e)return t;var n=o.f(e);return(0,n.resolve)(t),n.promise}},ce4e:function(e,t,n){var i=n("da84"),r=n("9112");e.exports=function(e,t){try{r(i,e,t)}catch(n){i[e]=t}return t}},d012:function(e,t){e.exports={}},d039:function(e,t){e.exports=function(e){try{return!!e()}catch(e){return!0}}},d066:function(e,t,n){var i=n("428f"),r=n("da84"),o=function(e){return"function"==typeof e?e:void 0};e.exports=function(e,t){return arguments.length<2?o(i[e])||o(r[e]):i[e]&&i[e][t]||r[e]&&r[e][t]}},d1e7:function(e,t,n){"use strict";var i={}.propertyIsEnumerable,r=Object.getOwnPropertyDescriptor,o=r&&!i.call({1:2},1);t.f=o?function(e){var t=r(this,e);return!!t&&t.enumerable}:i},d28b:function(e,t,n){n("746f")("iterator")},d2bb:function(e,t,n){var i=n("825a"),r=n("3bbe");e.exports=Object.setPrototypeOf||("__proto__"in{}?function(){var e,t=!1,n={};try{(e=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(n,[]),t=n instanceof Array}catch(e){}return function(n,o){return i(n),r(o),t?e.call(n,o):n.__proto__=o,n}}():void 0)},d3b7:function(e,t,n){var i=n("00ee"),r=n("6eeb"),o=n("b041");i||r(Object.prototype,"toString",o,{unsafe:!0})},d44e:function(e,t,n){var i=n("9bf2").f,r=n("5135"),o=n("b622")("toStringTag");e.exports=function(e,t,n){e&&!r(e=n?e:e.prototype,o)&&i(e,o,{configurable:!0,value:t})}},d4ec:function(e,t,n){"use strict";function i(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}n.d(t,"a",(function(){return i}))},d58f:function(e,t,n){var i=n("1c0b"),r=n("7b0b"),o=n("44ad"),a=n("50c4"),s=function(e){return function(t,n,s,l){i(n);var c=r(t),u=o(c),d=a(c.length),h=e?d-1:0,f=e?-1:1;if(s<2)for(;;){if(h in u){l=u[h],h+=f;break}if(h+=f,e?h<0:d<=h)throw TypeError("Reduce of empty array with no initial value")}for(;e?h>=0:d>h;h+=f)h in u&&(l=n(l,u[h],h,c));return l}};e.exports={left:s(!1),right:s(!0)}},d784:function(e,t,n){"use strict";n("ac1f");var i=n("6eeb"),r=n("d039"),o=n("b622"),a=n("9263"),s=n("9112"),l=o("species"),c=!r((function(){var e=/./;return e.exec=function(){var e=[];return e.groups={a:"7"},e},"7"!=="".replace(e,"$<a>")})),u="$0"==="a".replace(/./,"$0"),d=o("replace"),h=!!/./[d]&&""===/./[d]("a","$0"),f=!r((function(){var e=/(?:)/,t=e.exec;e.exec=function(){return t.apply(this,arguments)};var n="ab".split(e);return 2!==n.length||"a"!==n[0]||"b"!==n[1]}));e.exports=function(e,t,n,d){var p=o(e),m=!r((function(){var t={};return t[p]=function(){return 7},7!=""[e](t)})),v=m&&!r((function(){var t=!1,n=/a/;return"split"===e&&((n={}).constructor={},n.constructor[l]=function(){return n},n.flags="",n[p]=/./[p]),n.exec=function(){return t=!0,null},n[p](""),!t}));if(!m||!v||"replace"===e&&(!c||!u||h)||"split"===e&&!f){var g=/./[p],_=n(p,""[e],(function(e,t,n,i,r){return t.exec===a?m&&!r?{done:!0,value:g.call(t,n,i)}:{done:!0,value:e.call(n,t,i)}:{done:!1}}),{REPLACE_KEEPS_$0:u,REGEXP_REPLACE_SUBSTITUTES_UNDEFINED_CAPTURE:h}),b=_[0],y=_[1];i(String.prototype,e,b),i(RegExp.prototype,p,2==t?function(e,t){return y.call(e,this,t)}:function(e){return y.call(e,this)})}d&&s(RegExp.prototype[p],"sham",!0)}},d81d:function(e,t,n){"use strict";var i=n("23e7"),r=n("b727").map,o=n("1dde"),a=n("ae40"),s=o("map"),l=a("map");i({target:"Array",proto:!0,forced:!s||!l},{map:function(e){return r(this,e,arguments.length>1?arguments[1]:void 0)}})},da84:function(e,t,n){(function(t){var n=function(e){return e&&e.Math==Math&&e};e.exports=n("object"==typeof globalThis&&globalThis)||n("object"==typeof window&&window)||n("object"==typeof self&&self)||n("object"==typeof t&&t)||Function("return this")()}).call(this,n("c8ba"))},dbb4:function(e,t,n){var i=n("23e7"),r=n("83ab"),o=n("56ef"),a=n("fc6a"),s=n("06cf"),l=n("8418");i({target:"Object",stat:!0,sham:!r},{getOwnPropertyDescriptors:function(e){for(var t,n,i=a(e),r=s.f,c=o(i),u={},d=0;c.length>d;)void 0!==(n=r(i,t=c[d++]))&&l(u,t,n);return u}})},ddb0:function(e,t,n){var i=n("da84"),r=n("fdbc"),o=n("e260"),a=n("9112"),s=n("b622"),l=s("iterator"),c=s("toStringTag"),u=o.values;for(var d in r){var h=i[d],f=h&&h.prototype;if(f){if(f[l]!==u)try{a(f,l,u)}catch(e){f[l]=u}if(f[c]||a(f,c,d),r[d])for(var p in o)if(f[p]!==o[p])try{a(f,p,o[p])}catch(e){f[p]=o[p]}}}},df75:function(e,t,n){var i=n("ca84"),r=n("7839");e.exports=Object.keys||function(e){return i(e,r)}},e01a:function(e,t,n){"use strict";var i=n("23e7"),r=n("83ab"),o=n("da84"),a=n("5135"),s=n("861d"),l=n("9bf2").f,c=n("e893"),u=o.Symbol;if(r&&"function"==typeof u&&(!("description"in u.prototype)||void 0!==u().description)){var d={},h=function(){var e=arguments.length<1||void 0===arguments[0]?void 0:String(arguments[0]),t=this instanceof h?new u(e):void 0===e?u():u(e);return""===e&&(d[t]=!0),t};c(h,u);var f=h.prototype=u.prototype;f.constructor=h;var p=f.toString,m="Symbol(test)"==String(u("test")),v=/^Symbol\((.*)\)[^)]+$/;l(f,"description",{configurable:!0,get:function(){var e=s(this)?this.valueOf():this,t=p.call(e);if(a(d,e))return"";var n=m?t.slice(7,-1):t.replace(v,"$1");return""===n?void 0:n}}),i({global:!0,forced:!0},{Symbol:h})}},e163:function(e,t,n){var i=n("5135"),r=n("7b0b"),o=n("f772"),a=n("e177"),s=o("IE_PROTO"),l=Object.prototype;e.exports=a?Object.getPrototypeOf:function(e){return e=r(e),i(e,s)?e[s]:"function"==typeof e.constructor&&e instanceof e.constructor?e.constructor.prototype:e instanceof Object?l:null}},e177:function(e,t,n){var i=n("d039");e.exports=!i((function(){function e(){}return e.prototype.constructor=null,Object.getPrototypeOf(new e)!==e.prototype}))},e260:function(e,t,n){"use strict";var i=n("fc6a"),r=n("44d2"),o=n("3f8c"),a=n("69f3"),s=n("7dd0"),l="Array Iterator",c=a.set,u=a.getterFor(l);e.exports=s(Array,"Array",(function(e,t){c(this,{type:l,target:i(e),index:0,kind:t})}),(function(){var e=u(this),t=e.target,n=e.kind,i=e.index++;return!t||i>=t.length?(e.target=void 0,{value:void 0,done:!0}):"keys"==n?{value:i,done:!1}:"values"==n?{value:t[i],done:!1}:{value:[i,t[i]],done:!1}}),"values"),o.Arguments=o.Array,r("keys"),r("values"),r("entries")},e2cc:function(e,t,n){var i=n("6eeb");e.exports=function(e,t,n){for(var r in t)i(e,r,t[r],n);return e}},e439:function(e,t,n){var i=n("23e7"),r=n("d039"),o=n("fc6a"),a=n("06cf").f,s=n("83ab"),l=r((function(){a(1)}));i({target:"Object",stat:!0,forced:!s||l,sham:!s},{getOwnPropertyDescriptor:function(e,t){return a(o(e),t)}})},e538:function(e,t,n){var i=n("b622");t.f=i},e667:function(e,t){e.exports=function(e){try{return{error:!1,value:e()}}catch(e){return{error:!0,value:e}}}},e6cf:function(e,t,n){"use strict";var i,r,o,a,s=n("23e7"),l=n("c430"),c=n("da84"),u=n("d066"),d=n("fea9"),h=n("6eeb"),f=n("e2cc"),p=n("d44e"),m=n("2626"),v=n("861d"),g=n("1c0b"),_=n("19aa"),b=n("c6b6"),y=n("8925"),w=n("2266"),k=n("1c7e"),x=n("4840"),S=n("2cf4").set,C=n("b575"),M=n("cdf9"),T=n("44de"),A=n("f069"),P=n("e667"),L=n("69f3"),O=n("94ca"),q=n("b622"),E=n("2d00"),D=q("species"),z="Promise",N=L.get,j=L.set,R=L.getterFor(z),I=d,$=c.TypeError,F=c.document,B=c.process,V=u("fetch"),H=A.f,W=H,U="process"==b(B),Y=!!(F&&F.createEvent&&c.dispatchEvent),G="unhandledrejection",Q=O(z,(function(){if(!(y(I)!==String(I))){if(66===E)return!0;if(!U&&"function"!=typeof PromiseRejectionEvent)return!0}if(l&&!I.prototype.finally)return!0;if(E>=51&&/native code/.test(I))return!1;var e=I.resolve(1),t=function(e){e((function(){}),(function(){}))};return(e.constructor={})[D]=t,!(e.then((function(){}))instanceof t)})),K=Q||!k((function(e){I.all(e).catch((function(){}))})),Z=function(e){var t;return!(!v(e)||"function"!=typeof(t=e.then))&&t},J=function(e,t,n){if(!t.notified){t.notified=!0;var i=t.reactions;C((function(){for(var r=t.value,o=1==t.state,a=0;i.length>a;){var s,l,c,u=i[a++],d=o?u.ok:u.fail,h=u.resolve,f=u.reject,p=u.domain;try{d?(o||(2===t.rejection&&ne(e,t),t.rejection=1),!0===d?s=r:(p&&p.enter(),s=d(r),p&&(p.exit(),c=!0)),s===u.promise?f($("Promise-chain cycle")):(l=Z(s))?l.call(s,h,f):h(s)):f(r)}catch(e){p&&!c&&p.exit(),f(e)}}t.reactions=[],t.notified=!1,n&&!t.rejection&&ee(e,t)}))}},X=function(e,t,n){var i,r;Y?((i=F.createEvent("Event")).promise=t,i.reason=n,i.initEvent(e,!1,!0),c.dispatchEvent(i)):i={promise:t,reason:n},(r=c["on"+e])?r(i):e===G&&T("Unhandled promise rejection",n)},ee=function(e,t){S.call(c,(function(){var n,i=t.value;if(te(t)&&(n=P((function(){U?B.emit("unhandledRejection",i,e):X(G,e,i)})),t.rejection=U||te(t)?2:1,n.error))throw n.value}))},te=function(e){return 1!==e.rejection&&!e.parent},ne=function(e,t){S.call(c,(function(){U?B.emit("rejectionHandled",e):X("rejectionhandled",e,t.value)}))},ie=function(e,t,n,i){return function(r){e(t,n,r,i)}},re=function(e,t,n,i){t.done||(t.done=!0,i&&(t=i),t.value=n,t.state=2,J(e,t,!0))},oe=function(e,t,n,i){if(!t.done){t.done=!0,i&&(t=i);try{if(e===n)throw $("Promise can't be resolved itself");var r=Z(n);r?C((function(){var i={done:!1};try{r.call(n,ie(oe,e,i,t),ie(re,e,i,t))}catch(n){re(e,i,n,t)}})):(t.value=n,t.state=1,J(e,t,!1))}catch(n){re(e,{done:!1},n,t)}}};Q&&(I=function(e){_(this,I,z),g(e),i.call(this);var t=N(this);try{e(ie(oe,this,t),ie(re,this,t))}catch(e){re(this,t,e)}},(i=function(e){j(this,{type:z,done:!1,notified:!1,parent:!1,reactions:[],rejection:!1,state:0,value:void 0})}).prototype=f(I.prototype,{then:function(e,t){var n=R(this),i=H(x(this,I));return i.ok="function"!=typeof e||e,i.fail="function"==typeof t&&t,i.domain=U?B.domain:void 0,n.parent=!0,n.reactions.push(i),0!=n.state&&J(this,n,!1),i.promise},catch:function(e){return this.then(void 0,e)}}),r=function(){var e=new i,t=N(e);this.promise=e,this.resolve=ie(oe,e,t),this.reject=ie(re,e,t)},A.f=H=function(e){return e===I||e===o?new r(e):W(e)},l||"function"!=typeof d||(a=d.prototype.then,h(d.prototype,"then",(function(e,t){var n=this;return new I((function(e,t){a.call(n,e,t)})).then(e,t)}),{unsafe:!0}),"function"==typeof V&&s({global:!0,enumerable:!0,forced:!0},{fetch:function(e){return M(I,V.apply(c,arguments))}}))),s({global:!0,wrap:!0,forced:Q},{Promise:I}),p(I,z,!1,!0),m(z),o=u(z),s({target:z,stat:!0,forced:Q},{reject:function(e){var t=H(this);return t.reject.call(void 0,e),t.promise}}),s({target:z,stat:!0,forced:l||Q},{resolve:function(e){return M(l&&this===o?I:this,e)}}),s({target:z,stat:!0,forced:K},{all:function(e){var t=this,n=H(t),i=n.resolve,r=n.reject,o=P((function(){var n=g(t.resolve),o=[],a=0,s=1;w(e,(function(e){var l=a++,c=!1;o.push(void 0),s++,n.call(t,e).then((function(e){c||(c=!0,o[l]=e,--s||i(o))}),r)})),--s||i(o)}));return o.error&&r(o.value),n.promise},race:function(e){var t=this,n=H(t),i=n.reject,r=P((function(){var r=g(t.resolve);w(e,(function(e){r.call(t,e).then(n.resolve,i)}))}));return r.error&&i(r.value),n.promise}})},e893:function(e,t,n){var i=n("5135"),r=n("56ef"),o=n("06cf"),a=n("9bf2");e.exports=function(e,t){for(var n=r(t),s=a.f,l=o.f,c=0;c<n.length;c++){var u=n[c];i(e,u)||s(e,u,l(t,u))}}},e8b5:function(e,t,n){var i=n("c6b6");e.exports=Array.isArray||function(e){return"Array"==i(e)}},e95a:function(e,t,n){var i=n("b622"),r=n("3f8c"),o=i("iterator"),a=Array.prototype;e.exports=function(e){return void 0!==e&&(r.Array===e||a[o]===e)}},ede3:function(e,t,n){(t=n("24fb")(!1)).push([e.i,".qrcode-stream-wrapper[data-v-7a81005d]{width:100%;height:100%;position:relative;z-index:0}.qrcode-stream-overlay[data-v-7a81005d]{width:100%;height:100%;position:absolute;top:0;left:0}.qrcode-stream-camera[data-v-7a81005d]{width:100%;height:100%;display:block;-o-object-fit:cover;object-fit:cover}",""]),e.exports=t},f069:function(e,t,n){"use strict";var i=n("1c0b"),r=function(e){var t,n;this.promise=new e((function(e,i){if(void 0!==t||void 0!==n)throw TypeError("Bad Promise constructor");t=e,n=i})),this.resolve=i(t),this.reject=i(n)};e.exports.f=function(e){return new r(e)}},f183:function(e,t,n){var i=n("d012"),r=n("861d"),o=n("5135"),a=n("9bf2").f,s=n("90e3"),l=n("bb2f"),c=s("meta"),u=0,d=Object.isExtensible||function(){return!0},h=function(e){a(e,c,{value:{objectID:"O"+ ++u,weakData:{}}})},f=e.exports={REQUIRED:!1,fastKey:function(e,t){if(!r(e))return"symbol"==typeof e?e:("string"==typeof e?"S":"P")+e;if(!o(e,c)){if(!d(e))return"F";if(!t)return"E";h(e)}return e[c].objectID},getWeakData:function(e,t){if(!o(e,c)){if(!d(e))return!0;if(!t)return!1;h(e)}return e[c].weakData},onFreeze:function(e){return l&&f.REQUIRED&&d(e)&&!o(e,c)&&h(e),e}};i[c]=!0},f5df:function(e,t,n){var i=n("00ee"),r=n("c6b6"),o=n("b622")("toStringTag"),a="Arguments"==r(function(){return arguments}());e.exports=i?r:function(e){var t,n,i;return void 0===e?"Undefined":null===e?"Null":"string"==typeof(n=function(e,t){try{return e[t]}catch(e){}}(t=Object(e),o))?n:a?r(t):"Object"==(i=r(t))&&"function"==typeof t.callee?"Arguments":i}},f718:function(e,t,n){"use strict";n.d(t,"c",(function(){return c})),n.d(t,"b",(function(){return u})),n.d(t,"a",(function(){return h}));n("caad"),n("2532"),n("2ca0"),n("96cf");var i=n("1da1"),r=n("1cc0"),o=n("c036"),a=document.createElement("canvas"),s=a.getContext("2d");function l(e,t,n){var i=Math.min(1,a.width/t,a.height/n),r=i*t,o=i*n;return s.drawImage(e,0,0,r,o),s.getImageData(0,0,r,o)}function c(e){return l(e,e.videoWidth,e.videoHeight)}function u(e){return d.apply(this,arguments)}function d(){return(d=Object(i.a)(regeneratorRuntime.mark((function e(t){var n;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(!t.startsWith("http")||!1!==t.includes(location.host)){e.next=2;break}throw new r.b;case 2:return(n=document.createElement("img")).src=t,e.next=6,Object(o.a)(n,"load");case 6:return e.abrupt("return",l(i=n,i.naturalWidth,i.naturalHeight));case 7:case"end":return e.stop()}var i}),e)})))).apply(this,arguments)}function h(e){return f.apply(this,arguments)}function f(){return(f=Object(i.a)(regeneratorRuntime.mark((function e(t){var n,i,a;return regeneratorRuntime.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(!/image.*/.test(t.type)){e.next=10;break}return(n=new FileReader).readAsDataURL(t),e.next=5,Object(o.a)(n,"load");case 5:return i=e.sent,a=i.target.result,e.abrupt("return",u(a));case 10:throw new r.a;case 11:case"end":return e.stop()}}),e)})))).apply(this,arguments)}a.width=1920,a.height=1080},f772:function(e,t,n){var i=n("5692"),r=n("90e3"),o=i("keys");e.exports=function(e){return o[e]||(o[e]=r(e))}},fb15:function(e,t,n){"use strict";if(n.r(t),n.d(t,"install",(function(){return a.e})),n.d(t,"QrcodeStream",(function(){return a.c})),n.d(t,"QrcodeCapture",(function(){return a.a})),n.d(t,"QrcodeDropZone",(function(){return a.b})),"undefined"!=typeof window){var i=window.document.currentScript,r=n("8875");i=r(),"currentScript"in document||Object.defineProperty(document,"currentScript",{get:r});var o=i&&i.src.match(/(.+\/)[^/]+\.js(\?.*)?$/);o&&(n.p=o[1])}var a=n("b635");t.default=a.d},fb6a:function(e,t,n){"use strict";var i=n("23e7"),r=n("861d"),o=n("e8b5"),a=n("23cb"),s=n("50c4"),l=n("fc6a"),c=n("8418"),u=n("b622"),d=n("1dde"),h=n("ae40"),f=d("slice"),p=h("slice",{ACCESSORS:!0,0:0,1:2}),m=u("species"),v=[].slice,g=Math.max;i({target:"Array",proto:!0,forced:!f||!p},{slice:function(e,t){var n,i,u,d=l(this),h=s(d.length),f=a(e,h),p=a(void 0===t?h:t,h);if(o(d)&&("function"!=typeof(n=d.constructor)||n!==Array&&!o(n.prototype)?r(n)&&null===(n=n[m])&&(n=void 0):n=void 0,n===Array||void 0===n))return v.call(d,f,p);for(i=new(void 0===n?Array:n)(g(p-f,0)),u=0;f<p;f++,u++)f in d&&c(i,u,d[f]);return i.length=u,i}})},fc6a:function(e,t,n){var i=n("44ad"),r=n("1d80");e.exports=function(e){return i(r(e))}},fdbc:function(e,t){e.exports={CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}},fdbf:function(e,t,n){var i=n("4930");e.exports=i&&!Symbol.sham&&"symbol"==typeof Symbol.iterator},fe6b:function(e,t,n){"use strict";n("4160"),n("159b"),n("96cf");var i=n("1da1"),r=n("2909"),o=n("a180"),a=n("f718"),s=n("b3af"),l=n("3c85"),c={name:"qrcode-drop-zone",mixins:[s.a],props:{worker:{type:Function,default:l.a}},methods:{onDragOver:function(e){this.$emit("dragover",e)},onDrop:function(e){var t=this,n=e.dataTransfer;this.onDragOver(!1);var i=Object(r.a)(n.files),o=n.getData("text/uri-list");i.forEach((function(e){t.onDetect(t.processFile(e))})),""!==o&&this.onDetect(this.processUrl(o))},processFile:function(e){var t=this;return Object(i.a)(regeneratorRuntime.mark((function n(){var i,r;return regeneratorRuntime.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:return n.next=2,Object(a.a)(e);case 2:return i=n.sent,n.next=5,Object(o.b)(t.worker,i);case 5:return r=n.sent,n.abrupt("return",r);case 7:case"end":return n.stop()}}),n)})))()},processUrl:function(e){var t=this;return Object(i.a)(regeneratorRuntime.mark((function n(){var i,r;return regeneratorRuntime.wrap((function(n){for(;;)switch(n.prev=n.next){case 0:return n.next=2,Object(a.b)(e);case 2:return i=n.sent,n.next=5,Object(o.b)(t.worker,i);case 5:return r=n.sent,n.abrupt("return",r);case 7:case"end":return n.stop()}}),n)})))()}}},u=n("2877"),d=Object(u.a)(c,(function(){var e=this,t=e.$createElement;return(e._self._c||t)("div",{on:{drop:function(t){return t.preventDefault(),t.stopPropagation(),e.onDrop(t)},dragenter:function(t){return t.preventDefault(),t.stopPropagation(),e.onDragOver(!0)},dragleave:function(t){return t.preventDefault(),t.stopPropagation(),e.onDragOver(!1)},dragover:function(e){e.preventDefault(),e.stopPropagation()}}},[e._t("default")],2)}),[],!1,null,null,null);t.a=d.exports},fea9:function(e,t,n){var i=n("da84");e.exports=i.Promise}})})),
/*!
 * vue-qrcode v1.0.2
 * https://fengyuanchen.github.io/vue-qrcode
 *
 * Copyright 2018-present Chen Fengyuan
 * Released under the MIT license
 *
 * Date: 2020-01-18T06:04:33.222Z
 */
function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e=e||self).VueQrcode=t()}(this,(function(){"use strict";function e(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}var t=function(e,t){return e(t={exports:{}},t.exports),t.exports}((function(t,n){t.exports=function(){function t(n,i,r){function o(s,l){if(!i[s]){if(!n[s]){if(!l&&e)return e();if(a)return a(s,!0);var c=new Error("Cannot find module '"+s+"'");throw c.code="MODULE_NOT_FOUND",c}var u=i[s]={exports:{}};n[s][0].call(u.exports,(function(e){return o(n[s][1][e]||e)}),u,u.exports,t,n,i,r)}return i[s].exports}for(var a=e,s=0;s<r.length;s++)o(r[s]);return o}return t}()({1:[function(e,t,n){t.exports=function(){return"function"==typeof Promise&&Promise.prototype&&Promise.prototype.then}},{}],2:[function(e,t,n){var i=e("./utils").getSymbolSize;n.getRowColCoords=function(e){if(1===e)return[];for(var t=Math.floor(e/7)+2,n=i(e),r=145===n?26:2*Math.ceil((n-13)/(2*t-2)),o=[n-7],a=1;a<t-1;a++)o[a]=o[a-1]-r;return o.push(6),o.reverse()},n.getPositions=function(e){for(var t=[],i=n.getRowColCoords(e),r=i.length,o=0;o<r;o++)for(var a=0;a<r;a++)0===o&&0===a||0===o&&a===r-1||o===r-1&&0===a||t.push([i[o],i[a]]);return t}},{"./utils":21}],3:[function(e,t,n){var i=e("./mode"),r=["0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"," ","$","%","*","+","-",".","/",":"];function o(e){this.mode=i.ALPHANUMERIC,this.data=e}o.getBitsLength=function(e){return 11*Math.floor(e/2)+e%2*6},o.prototype.getLength=function(){return this.data.length},o.prototype.getBitsLength=function(){return o.getBitsLength(this.data.length)},o.prototype.write=function(e){var t;for(t=0;t+2<=this.data.length;t+=2){var n=45*r.indexOf(this.data[t]);n+=r.indexOf(this.data[t+1]),e.put(n,11)}this.data.length%2&&e.put(r.indexOf(this.data[t]),6)},t.exports=o},{"./mode":14}],4:[function(e,t,n){function i(){this.buffer=[],this.length=0}i.prototype={get:function(e){var t=Math.floor(e/8);return 1==(this.buffer[t]>>>7-e%8&1)},put:function(e,t){for(var n=0;n<t;n++)this.putBit(1==(e>>>t-n-1&1))},getLengthInBits:function(){return this.length},putBit:function(e){var t=Math.floor(this.length/8);this.buffer.length<=t&&this.buffer.push(0),e&&(this.buffer[t]|=128>>>this.length%8),this.length++}},t.exports=i},{}],5:[function(e,t,n){var i=e("../utils/buffer");function r(e){if(!e||e<1)throw new Error("BitMatrix size must be defined and greater than 0");this.size=e,this.data=i.alloc(e*e),this.reservedBit=i.alloc(e*e)}r.prototype.set=function(e,t,n,i){var r=e*this.size+t;this.data[r]=n,i&&(this.reservedBit[r]=!0)},r.prototype.get=function(e,t){return this.data[e*this.size+t]},r.prototype.xor=function(e,t,n){this.data[e*this.size+t]^=n},r.prototype.isReserved=function(e,t){return this.reservedBit[e*this.size+t]},t.exports=r},{"../utils/buffer":28}],6:[function(e,t,n){var i=e("../utils/buffer"),r=e("./mode");function o(e){this.mode=r.BYTE,this.data=i.from(e)}o.getBitsLength=function(e){return 8*e},o.prototype.getLength=function(){return this.data.length},o.prototype.getBitsLength=function(){return o.getBitsLength(this.data.length)},o.prototype.write=function(e){for(var t=0,n=this.data.length;t<n;t++)e.put(this.data[t],8)},t.exports=o},{"../utils/buffer":28,"./mode":14}],7:[function(e,t,n){var i=e("./error-correction-level"),r=[1,1,1,1,1,1,1,1,1,1,2,2,1,2,2,4,1,2,4,4,2,4,4,4,2,4,6,5,2,4,6,6,2,5,8,8,4,5,8,8,4,5,8,11,4,8,10,11,4,9,12,16,4,9,16,16,6,10,12,18,6,10,17,16,6,11,16,19,6,13,18,21,7,14,21,25,8,16,20,25,8,17,23,25,9,17,23,34,9,18,25,30,10,20,27,32,12,21,29,35,12,23,34,37,12,25,34,40,13,26,35,42,14,28,38,45,15,29,40,48,16,31,43,51,17,33,45,54,18,35,48,57,19,37,51,60,19,38,53,63,20,40,56,66,21,43,59,70,22,45,62,74,24,47,65,77,25,49,68,81],o=[7,10,13,17,10,16,22,28,15,26,36,44,20,36,52,64,26,48,72,88,36,64,96,112,40,72,108,130,48,88,132,156,60,110,160,192,72,130,192,224,80,150,224,264,96,176,260,308,104,198,288,352,120,216,320,384,132,240,360,432,144,280,408,480,168,308,448,532,180,338,504,588,196,364,546,650,224,416,600,700,224,442,644,750,252,476,690,816,270,504,750,900,300,560,810,960,312,588,870,1050,336,644,952,1110,360,700,1020,1200,390,728,1050,1260,420,784,1140,1350,450,812,1200,1440,480,868,1290,1530,510,924,1350,1620,540,980,1440,1710,570,1036,1530,1800,570,1064,1590,1890,600,1120,1680,1980,630,1204,1770,2100,660,1260,1860,2220,720,1316,1950,2310,750,1372,2040,2430];n.getBlocksCount=function(e,t){switch(t){case i.L:return r[4*(e-1)+0];case i.M:return r[4*(e-1)+1];case i.Q:return r[4*(e-1)+2];case i.H:return r[4*(e-1)+3];default:return}},n.getTotalCodewordsCount=function(e,t){switch(t){case i.L:return o[4*(e-1)+0];case i.M:return o[4*(e-1)+1];case i.Q:return o[4*(e-1)+2];case i.H:return o[4*(e-1)+3];default:return}}},{"./error-correction-level":8}],8:[function(e,t,n){function i(e){if("string"!=typeof e)throw new Error("Param is not a string");switch(e.toLowerCase()){case"l":case"low":return n.L;case"m":case"medium":return n.M;case"q":case"quartile":return n.Q;case"h":case"high":return n.H;default:throw new Error("Unknown EC Level: "+e)}}n.L={bit:1},n.M={bit:0},n.Q={bit:3},n.H={bit:2},n.isValid=function(e){return e&&void 0!==e.bit&&e.bit>=0&&e.bit<4},n.from=function(e,t){if(n.isValid(e))return e;try{return i(e)}catch(e){return t}}},{}],9:[function(e,t,n){var i=e("./utils").getSymbolSize,r=7;n.getPositions=function(e){var t=i(e);return[[0,0],[t-r,0],[0,t-r]]}},{"./utils":21}],10:[function(e,t,n){var i=e("./utils"),r=1335,o=21522,a=i.getBCHDigit(r);n.getEncodedBits=function(e,t){for(var n=e.bit<<3|t,s=n<<10;i.getBCHDigit(s)-a>=0;)s^=r<<i.getBCHDigit(s)-a;return(n<<10|s)^o}},{"./utils":21}],11:[function(e,t,n){var i=e("../utils/buffer"),r=i.alloc(512),o=i.alloc(256);!function(){for(var e=1,t=0;t<255;t++)r[t]=e,o[e]=t,256&(e<<=1)&&(e^=285);for(t=255;t<512;t++)r[t]=r[t-255]}(),n.log=function(e){if(e<1)throw new Error("log("+e+")");return o[e]},n.exp=function(e){return r[e]},n.mul=function(e,t){return 0===e||0===t?0:r[o[e]+o[t]]}},{"../utils/buffer":28}],12:[function(e,t,n){var i=e("./mode"),r=e("./utils");function o(e){this.mode=i.KANJI,this.data=e}o.getBitsLength=function(e){return 13*e},o.prototype.getLength=function(){return this.data.length},o.prototype.getBitsLength=function(){return o.getBitsLength(this.data.length)},o.prototype.write=function(e){var t;for(t=0;t<this.data.length;t++){var n=r.toSJIS(this.data[t]);if(n>=33088&&n<=40956)n-=33088;else{if(!(n>=57408&&n<=60351))throw new Error("Invalid SJIS character: "+this.data[t]+"\nMake sure your charset is UTF-8");n-=49472}n=192*(n>>>8&255)+(255&n),e.put(n,13)}},t.exports=o},{"./mode":14,"./utils":21}],13:[function(e,t,n){n.Patterns={PATTERN000:0,PATTERN001:1,PATTERN010:2,PATTERN011:3,PATTERN100:4,PATTERN101:5,PATTERN110:6,PATTERN111:7};var i={N1:3,N2:3,N3:40,N4:10};function r(e,t,i){switch(e){case n.Patterns.PATTERN000:return(t+i)%2==0;case n.Patterns.PATTERN001:return t%2==0;case n.Patterns.PATTERN010:return i%3==0;case n.Patterns.PATTERN011:return(t+i)%3==0;case n.Patterns.PATTERN100:return(Math.floor(t/2)+Math.floor(i/3))%2==0;case n.Patterns.PATTERN101:return t*i%2+t*i%3==0;case n.Patterns.PATTERN110:return(t*i%2+t*i%3)%2==0;case n.Patterns.PATTERN111:return(t*i%3+(t+i)%2)%2==0;default:throw new Error("bad maskPattern:"+e)}}n.isValid=function(e){return null!=e&&""!==e&&!isNaN(e)&&e>=0&&e<=7},n.from=function(e){return n.isValid(e)?parseInt(e,10):void 0},n.getPenaltyN1=function(e){for(var t=e.size,n=0,r=0,o=0,a=null,s=null,l=0;l<t;l++){r=o=0,a=s=null;for(var c=0;c<t;c++){var u=e.get(l,c);u===a?r++:(r>=5&&(n+=i.N1+(r-5)),a=u,r=1),(u=e.get(c,l))===s?o++:(o>=5&&(n+=i.N1+(o-5)),s=u,o=1)}r>=5&&(n+=i.N1+(r-5)),o>=5&&(n+=i.N1+(o-5))}return n},n.getPenaltyN2=function(e){for(var t=e.size,n=0,r=0;r<t-1;r++)for(var o=0;o<t-1;o++){var a=e.get(r,o)+e.get(r,o+1)+e.get(r+1,o)+e.get(r+1,o+1);4!==a&&0!==a||n++}return n*i.N2},n.getPenaltyN3=function(e){for(var t=e.size,n=0,r=0,o=0,a=0;a<t;a++){r=o=0;for(var s=0;s<t;s++)r=r<<1&2047|e.get(a,s),s>=10&&(1488===r||93===r)&&n++,o=o<<1&2047|e.get(s,a),s>=10&&(1488===o||93===o)&&n++}return n*i.N3},n.getPenaltyN4=function(e){for(var t=0,n=e.data.length,r=0;r<n;r++)t+=e.data[r];return Math.abs(Math.ceil(100*t/n/5)-10)*i.N4},n.applyMask=function(e,t){for(var n=t.size,i=0;i<n;i++)for(var o=0;o<n;o++)t.isReserved(o,i)||t.xor(o,i,r(e,o,i))},n.getBestMask=function(e,t){for(var i=Object.keys(n.Patterns).length,r=0,o=1/0,a=0;a<i;a++){t(a),n.applyMask(a,e);var s=n.getPenaltyN1(e)+n.getPenaltyN2(e)+n.getPenaltyN3(e)+n.getPenaltyN4(e);n.applyMask(a,e),s<o&&(o=s,r=a)}return r}},{}],14:[function(e,t,n){var i=e("./version-check"),r=e("./regex");function o(e){if("string"!=typeof e)throw new Error("Param is not a string");switch(e.toLowerCase()){case"numeric":return n.NUMERIC;case"alphanumeric":return n.ALPHANUMERIC;case"kanji":return n.KANJI;case"byte":return n.BYTE;default:throw new Error("Unknown mode: "+e)}}n.NUMERIC={id:"Numeric",bit:1,ccBits:[10,12,14]},n.ALPHANUMERIC={id:"Alphanumeric",bit:2,ccBits:[9,11,13]},n.BYTE={id:"Byte",bit:4,ccBits:[8,16,16]},n.KANJI={id:"Kanji",bit:8,ccBits:[8,10,12]},n.MIXED={bit:-1},n.getCharCountIndicator=function(e,t){if(!e.ccBits)throw new Error("Invalid mode: "+e);if(!i.isValid(t))throw new Error("Invalid version: "+t);return t>=1&&t<10?e.ccBits[0]:t<27?e.ccBits[1]:e.ccBits[2]},n.getBestModeForData=function(e){return r.testNumeric(e)?n.NUMERIC:r.testAlphanumeric(e)?n.ALPHANUMERIC:r.testKanji(e)?n.KANJI:n.BYTE},n.toString=function(e){if(e&&e.id)return e.id;throw new Error("Invalid mode")},n.isValid=function(e){return e&&e.bit&&e.ccBits},n.from=function(e,t){if(n.isValid(e))return e;try{return o(e)}catch(e){return t}}},{"./regex":19,"./version-check":22}],15:[function(e,t,n){var i=e("./mode");function r(e){this.mode=i.NUMERIC,this.data=e.toString()}r.getBitsLength=function(e){return 10*Math.floor(e/3)+(e%3?e%3*3+1:0)},r.prototype.getLength=function(){return this.data.length},r.prototype.getBitsLength=function(){return r.getBitsLength(this.data.length)},r.prototype.write=function(e){var t,n,i;for(t=0;t+3<=this.data.length;t+=3)n=this.data.substr(t,3),i=parseInt(n,10),e.put(i,10);var r=this.data.length-t;r>0&&(n=this.data.substr(t),i=parseInt(n,10),e.put(i,3*r+1))},t.exports=r},{"./mode":14}],16:[function(e,t,n){var i=e("../utils/buffer"),r=e("./galois-field");n.mul=function(e,t){for(var n=i.alloc(e.length+t.length-1),o=0;o<e.length;o++)for(var a=0;a<t.length;a++)n[o+a]^=r.mul(e[o],t[a]);return n},n.mod=function(e,t){for(var n=i.from(e);n.length-t.length>=0;){for(var o=n[0],a=0;a<t.length;a++)n[a]^=r.mul(t[a],o);for(var s=0;s<n.length&&0===n[s];)s++;n=n.slice(s)}return n},n.generateECPolynomial=function(e){for(var t=i.from([1]),o=0;o<e;o++)t=n.mul(t,[1,r.exp(o)]);return t}},{"../utils/buffer":28,"./galois-field":11}],17:[function(e,t,n){var i=e("../utils/buffer"),r=e("./utils"),o=e("./error-correction-level"),a=e("./bit-buffer"),s=e("./bit-matrix"),l=e("./alignment-pattern"),c=e("./finder-pattern"),u=e("./mask-pattern"),d=e("./error-correction-code"),h=e("./reed-solomon-encoder"),f=e("./version"),p=e("./format-info"),m=e("./mode"),v=e("./segments"),g=e("isarray");function _(e,t){for(var n=e.size,i=c.getPositions(t),r=0;r<i.length;r++)for(var o=i[r][0],a=i[r][1],s=-1;s<=7;s++)if(!(o+s<=-1||n<=o+s))for(var l=-1;l<=7;l++)a+l<=-1||n<=a+l||(s>=0&&s<=6&&(0===l||6===l)||l>=0&&l<=6&&(0===s||6===s)||s>=2&&s<=4&&l>=2&&l<=4?e.set(o+s,a+l,!0,!0):e.set(o+s,a+l,!1,!0))}function b(e){for(var t=e.size,n=8;n<t-8;n++){var i=n%2==0;e.set(n,6,i,!0),e.set(6,n,i,!0)}}function y(e,t){for(var n=l.getPositions(t),i=0;i<n.length;i++)for(var r=n[i][0],o=n[i][1],a=-2;a<=2;a++)for(var s=-2;s<=2;s++)-2===a||2===a||-2===s||2===s||0===a&&0===s?e.set(r+a,o+s,!0,!0):e.set(r+a,o+s,!1,!0)}function w(e,t){for(var n,i,r,o=e.size,a=f.getEncodedBits(t),s=0;s<18;s++)n=Math.floor(s/3),i=s%3+o-8-3,r=1==(a>>s&1),e.set(n,i,r,!0),e.set(i,n,r,!0)}function k(e,t,n){var i,r,o=e.size,a=p.getEncodedBits(t,n);for(i=0;i<15;i++)r=1==(a>>i&1),i<6?e.set(i,8,r,!0):i<8?e.set(i+1,8,r,!0):e.set(o-15+i,8,r,!0),i<8?e.set(8,o-i-1,r,!0):i<9?e.set(8,15-i-1+1,r,!0):e.set(8,15-i-1,r,!0);e.set(o-8,8,1,!0)}function x(e,t){for(var n=e.size,i=-1,r=n-1,o=7,a=0,s=n-1;s>0;s-=2)for(6===s&&s--;;){for(var l=0;l<2;l++)if(!e.isReserved(r,s-l)){var c=!1;a<t.length&&(c=1==(t[a]>>>o&1)),e.set(r,s-l,c),-1==--o&&(a++,o=7)}if((r+=i)<0||n<=r){r-=i,i=-i;break}}}function S(e,t,n){var i=new a;n.forEach((function(t){i.put(t.mode.bit,4),i.put(t.getLength(),m.getCharCountIndicator(t.mode,e)),t.write(i)}));var o=8*(r.getSymbolTotalCodewords(e)-d.getTotalCodewordsCount(e,t));for(i.getLengthInBits()+4<=o&&i.put(0,4);i.getLengthInBits()%8!=0;)i.putBit(0);for(var s=(o-i.getLengthInBits())/8,l=0;l<s;l++)i.put(l%2?17:236,8);return C(i,e,t)}function C(e,t,n){for(var o=r.getSymbolTotalCodewords(t),a=o-d.getTotalCodewordsCount(t,n),s=d.getBlocksCount(t,n),l=s-o%s,c=Math.floor(o/s),u=Math.floor(a/s),f=u+1,p=c-u,m=new h(p),v=0,g=new Array(s),_=new Array(s),b=0,y=i.from(e.buffer),w=0;w<s;w++){var k=w<l?u:f;g[w]=y.slice(v,v+k),_[w]=m.encode(g[w]),v+=k,b=Math.max(b,k)}var x,S,C=i.alloc(o),M=0;for(x=0;x<b;x++)for(S=0;S<s;S++)x<g[S].length&&(C[M++]=g[S][x]);for(x=0;x<p;x++)for(S=0;S<s;S++)C[M++]=_[S][x];return C}function M(e,t,n,i){var o;if(g(e))o=v.fromArray(e);else{if("string"!=typeof e)throw new Error("Invalid data");var a=t;if(!a){var l=v.rawSplit(e);a=f.getBestVersionForData(l,n)}o=v.fromString(e,a||40)}var c=f.getBestVersionForData(o,n);if(!c)throw new Error("The amount of data is too big to be stored in a QR Code");if(t){if(t<c)throw new Error("\nThe chosen QR Code version cannot contain this amount of data.\nMinimum version required to store current data is: "+c+".\n")}else t=c;var d=S(t,n,o),h=r.getSymbolSize(t),p=new s(h);return _(p,t),b(p),y(p,t),k(p,n,0),t>=7&&w(p,t),x(p,d),isNaN(i)&&(i=u.getBestMask(p,k.bind(null,p,n))),u.applyMask(i,p),k(p,n,i),{modules:p,version:t,errorCorrectionLevel:n,maskPattern:i,segments:o}}n.create=function(e,t){if(void 0===e||""===e)throw new Error("No input text");var n,i,a=o.M;return void 0!==t&&(a=o.from(t.errorCorrectionLevel,o.M),n=f.from(t.version),i=u.from(t.maskPattern),t.toSJISFunc&&r.setToSJISFunction(t.toSJISFunc)),M(e,n,a,i)}},{"../utils/buffer":28,"./alignment-pattern":2,"./bit-buffer":4,"./bit-matrix":5,"./error-correction-code":7,"./error-correction-level":8,"./finder-pattern":9,"./format-info":10,"./mask-pattern":13,"./mode":14,"./reed-solomon-encoder":18,"./segments":20,"./utils":21,"./version":23,isarray:33}],18:[function(e,t,n){var i=e("../utils/buffer"),r=e("./polynomial"),o=e("buffer").Buffer;function a(e){this.genPoly=void 0,this.degree=e,this.degree&&this.initialize(this.degree)}a.prototype.initialize=function(e){this.degree=e,this.genPoly=r.generateECPolynomial(this.degree)},a.prototype.encode=function(e){if(!this.genPoly)throw new Error("Encoder not initialized");var t=i.alloc(this.degree),n=o.concat([e,t],e.length+this.degree),a=r.mod(n,this.genPoly),s=this.degree-a.length;if(s>0){var l=i.alloc(this.degree);return a.copy(l,s),l}return a},t.exports=a},{"../utils/buffer":28,"./polynomial":16,buffer:30}],19:[function(e,t,n){var i="[0-9]+",r="[A-Z $%*+\\-./:]+",o="(?:[u3000-u303F]|[u3040-u309F]|[u30A0-u30FF]|[uFF00-uFFEF]|[u4E00-u9FAF]|[u2605-u2606]|[u2190-u2195]|u203B|[u2010u2015u2018u2019u2025u2026u201Cu201Du2225u2260]|[u0391-u0451]|[u00A7u00A8u00B1u00B4u00D7u00F7])+",a="(?:(?![A-Z0-9 $%*+\\-./:]|"+(o=o.replace(/u/g,"\\u"))+")(?:.|[\r\n]))+";n.KANJI=new RegExp(o,"g"),n.BYTE_KANJI=new RegExp("[^A-Z0-9 $%*+\\-./:]+","g"),n.BYTE=new RegExp(a,"g"),n.NUMERIC=new RegExp(i,"g"),n.ALPHANUMERIC=new RegExp(r,"g");var s=new RegExp("^"+o+"$"),l=new RegExp("^"+i+"$"),c=new RegExp("^[A-Z0-9 $%*+\\-./:]+$");n.testKanji=function(e){return s.test(e)},n.testNumeric=function(e){return l.test(e)},n.testAlphanumeric=function(e){return c.test(e)}},{}],20:[function(e,t,n){var i=e("./mode"),r=e("./numeric-data"),o=e("./alphanumeric-data"),a=e("./byte-data"),s=e("./kanji-data"),l=e("./regex"),c=e("./utils"),u=e("dijkstrajs");function d(e){return unescape(encodeURIComponent(e)).length}function h(e,t,n){for(var i,r=[];null!==(i=e.exec(n));)r.push({data:i[0],index:i.index,mode:t,length:i[0].length});return r}function f(e){var t,n,r=h(l.NUMERIC,i.NUMERIC,e),o=h(l.ALPHANUMERIC,i.ALPHANUMERIC,e);return c.isKanjiModeEnabled()?(t=h(l.BYTE,i.BYTE,e),n=h(l.KANJI,i.KANJI,e)):(t=h(l.BYTE_KANJI,i.BYTE,e),n=[]),r.concat(o,t,n).sort((function(e,t){return e.index-t.index})).map((function(e){return{data:e.data,mode:e.mode,length:e.length}}))}function p(e,t){switch(t){case i.NUMERIC:return r.getBitsLength(e);case i.ALPHANUMERIC:return o.getBitsLength(e);case i.KANJI:return s.getBitsLength(e);case i.BYTE:return a.getBitsLength(e)}}function m(e){return e.reduce((function(e,t){var n=e.length-1>=0?e[e.length-1]:null;return n&&n.mode===t.mode?(e[e.length-1].data+=t.data,e):(e.push(t),e)}),[])}function v(e){for(var t=[],n=0;n<e.length;n++){var r=e[n];switch(r.mode){case i.NUMERIC:t.push([r,{data:r.data,mode:i.ALPHANUMERIC,length:r.length},{data:r.data,mode:i.BYTE,length:r.length}]);break;case i.ALPHANUMERIC:t.push([r,{data:r.data,mode:i.BYTE,length:r.length}]);break;case i.KANJI:t.push([r,{data:r.data,mode:i.BYTE,length:d(r.data)}]);break;case i.BYTE:t.push([{data:r.data,mode:i.BYTE,length:d(r.data)}])}}return t}function g(e,t){for(var n={},r={start:{}},o=["start"],a=0;a<e.length;a++){for(var s=e[a],l=[],c=0;c<s.length;c++){var u=s[c],d=""+a+c;l.push(d),n[d]={node:u,lastCount:0},r[d]={};for(var h=0;h<o.length;h++){var f=o[h];n[f]&&n[f].node.mode===u.mode?(r[f][d]=p(n[f].lastCount+u.length,u.mode)-p(n[f].lastCount,u.mode),n[f].lastCount+=u.length):(n[f]&&(n[f].lastCount=u.length),r[f][d]=p(u.length,u.mode)+4+i.getCharCountIndicator(u.mode,t))}}o=l}for(h=0;h<o.length;h++)r[o[h]].end=0;return{map:r,table:n}}function _(e,t){var n,l=i.getBestModeForData(e);if((n=i.from(t,l))!==i.BYTE&&n.bit<l.bit)throw new Error('"'+e+'" cannot be encoded with mode '+i.toString(n)+".\n Suggested mode is: "+i.toString(l));switch(n!==i.KANJI||c.isKanjiModeEnabled()||(n=i.BYTE),n){case i.NUMERIC:return new r(e);case i.ALPHANUMERIC:return new o(e);case i.KANJI:return new s(e);case i.BYTE:return new a(e)}}n.fromArray=function(e){return e.reduce((function(e,t){return"string"==typeof t?e.push(_(t,null)):t.data&&e.push(_(t.data,t.mode)),e}),[])},n.fromString=function(e,t){for(var i=g(v(f(e,c.isKanjiModeEnabled())),t),r=u.find_path(i.map,"start","end"),o=[],a=1;a<r.length-1;a++)o.push(i.table[r[a]].node);return n.fromArray(m(o))},n.rawSplit=function(e){return n.fromArray(f(e,c.isKanjiModeEnabled()))}},{"./alphanumeric-data":3,"./byte-data":6,"./kanji-data":12,"./mode":14,"./numeric-data":15,"./regex":19,"./utils":21,dijkstrajs:31}],21:[function(e,t,n){var i,r=[0,26,44,70,100,134,172,196,242,292,346,404,466,532,581,655,733,815,901,991,1085,1156,1258,1364,1474,1588,1706,1828,1921,2051,2185,2323,2465,2611,2761,2876,3034,3196,3362,3532,3706];n.getSymbolSize=function(e){if(!e)throw new Error('"version" cannot be null or undefined');if(e<1||e>40)throw new Error('"version" should be in range from 1 to 40');return 4*e+17},n.getSymbolTotalCodewords=function(e){return r[e]},n.getBCHDigit=function(e){for(var t=0;0!==e;)t++,e>>>=1;return t},n.setToSJISFunction=function(e){if("function"!=typeof e)throw new Error('"toSJISFunc" is not a valid function.');i=e},n.isKanjiModeEnabled=function(){return void 0!==i},n.toSJIS=function(e){return i(e)}},{}],22:[function(e,t,n){n.isValid=function(e){return!isNaN(e)&&e>=1&&e<=40}},{}],23:[function(e,t,n){var i=e("./utils"),r=e("./error-correction-code"),o=e("./error-correction-level"),a=e("./mode"),s=e("./version-check"),l=e("isarray"),c=7973,u=i.getBCHDigit(c);function d(e,t,i){for(var r=1;r<=40;r++)if(t<=n.getCapacity(r,i,e))return r}function h(e,t){return a.getCharCountIndicator(e,t)+4}function f(e,t){var n=0;return e.forEach((function(e){var i=h(e.mode,t);n+=i+e.getBitsLength()})),n}function p(e,t){for(var i=1;i<=40;i++)if(f(e,i)<=n.getCapacity(i,t,a.MIXED))return i}n.from=function(e,t){return s.isValid(e)?parseInt(e,10):t},n.getCapacity=function(e,t,n){if(!s.isValid(e))throw new Error("Invalid QR Code version");void 0===n&&(n=a.BYTE);var o=8*(i.getSymbolTotalCodewords(e)-r.getTotalCodewordsCount(e,t));if(n===a.MIXED)return o;var l=o-h(n,e);switch(n){case a.NUMERIC:return Math.floor(l/10*3);case a.ALPHANUMERIC:return Math.floor(l/11*2);case a.KANJI:return Math.floor(l/13);case a.BYTE:default:return Math.floor(l/8)}},n.getBestVersionForData=function(e,t){var n,i=o.from(t,o.M);if(l(e)){if(e.length>1)return p(e,i);if(0===e.length)return 1;n=e[0]}else n=e;return d(n.mode,n.getLength(),i)},n.getEncodedBits=function(e){if(!s.isValid(e)||e<7)throw new Error("Invalid QR Code version");for(var t=e<<12;i.getBCHDigit(t)-u>=0;)t^=c<<i.getBCHDigit(t)-u;return e<<12|t}},{"./error-correction-code":7,"./error-correction-level":8,"./mode":14,"./utils":21,"./version-check":22,isarray:33}],24:[function(e,t,n){var i=e("./can-promise"),r=e("./core/qrcode"),o=e("./renderer/canvas"),a=e("./renderer/svg-tag.js");function s(e,t,n,o,a){var s=[].slice.call(arguments,1),l=s.length,c="function"==typeof s[l-1];if(!c&&!i())throw new Error("Callback required as last argument");if(!c){if(l<1)throw new Error("Too few arguments provided");return 1===l?(n=t,t=o=void 0):2!==l||t.getContext||(o=n,n=t,t=void 0),new Promise((function(i,a){try{var s=r.create(n,o);i(e(s,t,o))}catch(e){a(e)}}))}if(l<2)throw new Error("Too few arguments provided");2===l?(a=n,n=t,t=o=void 0):3===l&&(t.getContext&&void 0===a?(a=o,o=void 0):(a=o,o=n,n=t,t=void 0));try{var u=r.create(n,o);a(null,e(u,t,o))}catch(e){a(e)}}n.create=r.create,n.toCanvas=s.bind(null,o.render),n.toDataURL=s.bind(null,o.renderToDataURL),n.toString=s.bind(null,(function(e,t,n){return a.render(e,n)}))},{"./can-promise":1,"./core/qrcode":17,"./renderer/canvas":25,"./renderer/svg-tag.js":26}],25:[function(e,t,n){var i=e("./utils");function r(e,t,n){e.clearRect(0,0,t.width,t.height),t.style||(t.style={}),t.height=n,t.width=n,t.style.height=n+"px",t.style.width=n+"px"}function o(){try{return document.createElement("canvas")}catch(e){throw new Error("You need to specify a canvas element")}}n.render=function(e,t,n){var a=n,s=t;void 0!==a||t&&t.getContext||(a=t,t=void 0),t||(s=o()),a=i.getOptions(a);var l=i.getImageWidth(e.modules.size,a),c=s.getContext("2d"),u=c.createImageData(l,l);return i.qrToImageData(u.data,e,a),r(c,s,l),c.putImageData(u,0,0),s},n.renderToDataURL=function(e,t,i){var r=i;void 0!==r||t&&t.getContext||(r=t,t=void 0),r||(r={});var o=n.render(e,t,r),a=r.type||"image/png",s=r.rendererOpts||{};return o.toDataURL(a,s.quality)}},{"./utils":27}],26:[function(e,t,n){var i=e("./utils");function r(e,t){var n=e.a/255,i=t+'="'+e.hex+'"';return n<1?i+" "+t+'-opacity="'+n.toFixed(2).slice(1)+'"':i}function o(e,t,n){var i=e+t;return void 0!==n&&(i+=" "+n),i}function a(e,t,n){for(var i="",r=0,a=!1,s=0,l=0;l<e.length;l++){var c=Math.floor(l%t),u=Math.floor(l/t);c||a||(a=!0),e[l]?(s++,l>0&&c>0&&e[l-1]||(i+=a?o("M",c+n,.5+u+n):o("m",r,0),r=0,a=!1),c+1<t&&e[l+1]||(i+=o("h",s),s=0)):r++}return i}n.render=function(e,t,n){var o=i.getOptions(t),s=e.modules.size,l=e.modules.data,c=s+2*o.margin,u=o.color.light.a?"<path "+r(o.color.light,"fill")+' d="M0 0h'+c+"v"+c+'H0z"/>':"",d="<path "+r(o.color.dark,"stroke")+' d="'+a(l,s,o.margin)+'"/>',h='viewBox="0 0 '+c+" "+c+'"',f='<svg xmlns="http://www.w3.org/2000/svg" '+(o.width?'width="'+o.width+'" height="'+o.width+'" ':"")+h+' shape-rendering="crispEdges">'+u+d+"</svg>\n";return"function"==typeof n&&n(null,f),f}},{"./utils":27}],27:[function(e,t,n){function i(e){if("number"==typeof e&&(e=e.toString()),"string"!=typeof e)throw new Error("Color should be defined as hex string");var t=e.slice().replace("#","").split("");if(t.length<3||5===t.length||t.length>8)throw new Error("Invalid hex color: "+e);3!==t.length&&4!==t.length||(t=Array.prototype.concat.apply([],t.map((function(e){return[e,e]})))),6===t.length&&t.push("F","F");var n=parseInt(t.join(""),16);return{r:n>>24&255,g:n>>16&255,b:n>>8&255,a:255&n,hex:"#"+t.slice(0,6).join("")}}n.getOptions=function(e){e||(e={}),e.color||(e.color={});var t=void 0===e.margin||null===e.margin||e.margin<0?4:e.margin,n=e.width&&e.width>=21?e.width:void 0,r=e.scale||4;return{width:n,scale:n?4:r,margin:t,color:{dark:i(e.color.dark||"#000000ff"),light:i(e.color.light||"#ffffffff")},type:e.type,rendererOpts:e.rendererOpts||{}}},n.getScale=function(e,t){return t.width&&t.width>=e+2*t.margin?t.width/(e+2*t.margin):t.scale},n.getImageWidth=function(e,t){var i=n.getScale(e,t);return Math.floor((e+2*t.margin)*i)},n.qrToImageData=function(e,t,i){for(var r=t.modules.size,o=t.modules.data,a=n.getScale(r,i),s=Math.floor((r+2*i.margin)*a),l=i.margin*a,c=[i.color.light,i.color.dark],u=0;u<s;u++)for(var d=0;d<s;d++){var h=4*(u*s+d),f=i.color.light;u>=l&&d>=l&&u<s-l&&d<s-l&&(f=c[o[Math.floor((u-l)/a)*r+Math.floor((d-l)/a)]?1:0]),e[h++]=f.r,e[h++]=f.g,e[h++]=f.b,e[h]=f.a}}},{}],28:[function(e,t,n){var i=e("isarray");function r(){try{var e=new Uint8Array(1);return e.__proto__={__proto__:Uint8Array.prototype,foo:function(){return 42}},42===e.foo()}catch(e){return!1}}a.TYPED_ARRAY_SUPPORT=r();var o=a.TYPED_ARRAY_SUPPORT?2147483647:1073741823;function a(e,t,n){return a.TYPED_ARRAY_SUPPORT||this instanceof a?"number"==typeof e?u(this,e):b(this,e,t,n):new a(e,t,n)}function s(e){if(e>=o)throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+o.toString(16)+" bytes");return 0|e}function l(e){return e!=e}function c(e,t){var n;return a.TYPED_ARRAY_SUPPORT?(n=new Uint8Array(t)).__proto__=a.prototype:(null===(n=e)&&(n=new a(t)),n.length=t),n}function u(e,t){var n=c(e,t<0?0:0|s(t));if(!a.TYPED_ARRAY_SUPPORT)for(var i=0;i<t;++i)n[i]=0;return n}function d(e,t){var n=0|v(t),i=c(e,n),r=i.write(t);return r!==n&&(i=i.slice(0,r)),i}function h(e,t){for(var n=t.length<0?0:0|s(t.length),i=c(e,n),r=0;r<n;r+=1)i[r]=255&t[r];return i}function f(e,t,n,i){if(n<0||t.byteLength<n)throw new RangeError("'offset' is out of bounds");if(t.byteLength<n+(i||0))throw new RangeError("'length' is out of bounds");var r;return r=void 0===n&&void 0===i?new Uint8Array(t):void 0===i?new Uint8Array(t,n):new Uint8Array(t,n,i),a.TYPED_ARRAY_SUPPORT?r.__proto__=a.prototype:r=h(e,r),r}function p(e,t){if(a.isBuffer(t)){var n=0|s(t.length),i=c(e,n);return 0===i.length||t.copy(i,0,0,n),i}if(t){if("undefined"!=typeof ArrayBuffer&&t.buffer instanceof ArrayBuffer||"length"in t)return"number"!=typeof t.length||l(t.length)?c(e,0):h(e,t);if("Buffer"===t.type&&Array.isArray(t.data))return h(e,t.data)}throw new TypeError("First argument must be a string, Buffer, ArrayBuffer, Array, or array-like object.")}function m(e,t){var n;t=t||1/0;for(var i=e.length,r=null,o=[],a=0;a<i;++a){if((n=e.charCodeAt(a))>55295&&n<57344){if(!r){if(n>56319){(t-=3)>-1&&o.push(239,191,189);continue}if(a+1===i){(t-=3)>-1&&o.push(239,191,189);continue}r=n;continue}if(n<56320){(t-=3)>-1&&o.push(239,191,189),r=n;continue}n=65536+(r-55296<<10|n-56320)}else r&&(t-=3)>-1&&o.push(239,191,189);if(r=null,n<128){if((t-=1)<0)break;o.push(n)}else if(n<2048){if((t-=2)<0)break;o.push(n>>6|192,63&n|128)}else if(n<65536){if((t-=3)<0)break;o.push(n>>12|224,n>>6&63|128,63&n|128)}else{if(!(n<1114112))throw new Error("Invalid code point");if((t-=4)<0)break;o.push(n>>18|240,n>>12&63|128,n>>6&63|128,63&n|128)}}return o}function v(e){return a.isBuffer(e)?e.length:"undefined"!=typeof ArrayBuffer&&"function"==typeof ArrayBuffer.isView&&(ArrayBuffer.isView(e)||e instanceof ArrayBuffer)?e.byteLength:("string"!=typeof e&&(e=""+e),0===e.length?0:m(e).length)}function g(e,t,n,i){for(var r=0;r<i&&!(r+n>=t.length||r>=e.length);++r)t[r+n]=e[r];return r}function _(e,t,n,i){return g(m(t,e.length-n),e,n,i)}function b(e,t,n,i){if("number"==typeof t)throw new TypeError('"value" argument must not be a number');return"undefined"!=typeof ArrayBuffer&&t instanceof ArrayBuffer?f(e,t,n,i):"string"==typeof t?d(e,t):p(e,t)}a.TYPED_ARRAY_SUPPORT&&(a.prototype.__proto__=Uint8Array.prototype,a.__proto__=Uint8Array,"undefined"!=typeof Symbol&&Symbol.species&&a[Symbol.species]===a&&Object.defineProperty(a,Symbol.species,{value:null,configurable:!0,enumerable:!1,writable:!1})),a.prototype.write=function(e,t,n){void 0===t||void 0===n&&"string"==typeof t?(n=this.length,t=0):isFinite(t)&&(t|=0,isFinite(n)?n|=0:n=void 0);var i=this.length-t;if((void 0===n||n>i)&&(n=i),e.length>0&&(n<0||t<0)||t>this.length)throw new RangeError("Attempt to write outside buffer bounds");return _(this,e,t,n)},a.prototype.slice=function(e,t){var n,i=this.length;if((e=~~e)<0?(e+=i)<0&&(e=0):e>i&&(e=i),(t=void 0===t?i:~~t)<0?(t+=i)<0&&(t=0):t>i&&(t=i),t<e&&(t=e),a.TYPED_ARRAY_SUPPORT)(n=this.subarray(e,t)).__proto__=a.prototype;else{var r=t-e;n=new a(r,void 0);for(var o=0;o<r;++o)n[o]=this[o+e]}return n},a.prototype.copy=function(e,t,n,i){if(n||(n=0),i||0===i||(i=this.length),t>=e.length&&(t=e.length),t||(t=0),i>0&&i<n&&(i=n),i===n)return 0;if(0===e.length||0===this.length)return 0;if(t<0)throw new RangeError("targetStart out of bounds");if(n<0||n>=this.length)throw new RangeError("sourceStart out of bounds");if(i<0)throw new RangeError("sourceEnd out of bounds");i>this.length&&(i=this.length),e.length-t<i-n&&(i=e.length-t+n);var r,o=i-n;if(this===e&&n<t&&t<i)for(r=o-1;r>=0;--r)e[r+t]=this[r+n];else if(o<1e3||!a.TYPED_ARRAY_SUPPORT)for(r=0;r<o;++r)e[r+t]=this[r+n];else Uint8Array.prototype.set.call(e,this.subarray(n,n+o),t);return o},a.prototype.fill=function(e,t,n){if("string"==typeof e){if("string"==typeof t?(t=0,n=this.length):"string"==typeof n&&(n=this.length),1===e.length){var i=e.charCodeAt(0);i<256&&(e=i)}}else"number"==typeof e&&(e&=255);if(t<0||this.length<t||this.length<n)throw new RangeError("Out of range index");if(n<=t)return this;var r;if(t>>>=0,n=void 0===n?this.length:n>>>0,e||(e=0),"number"==typeof e)for(r=t;r<n;++r)this[r]=e;else{var o=a.isBuffer(e)?e:new a(e),s=o.length;for(r=0;r<n-t;++r)this[r+t]=o[r%s]}return this},a.concat=function(e,t){if(!i(e))throw new TypeError('"list" argument must be an Array of Buffers');if(0===e.length)return c(null,0);var n;if(void 0===t)for(t=0,n=0;n<e.length;++n)t+=e[n].length;var r=u(null,t),o=0;for(n=0;n<e.length;++n){var s=e[n];if(!a.isBuffer(s))throw new TypeError('"list" argument must be an Array of Buffers');s.copy(r,o),o+=s.length}return r},a.byteLength=v,a.prototype._isBuffer=!0,a.isBuffer=function(e){return!(null==e||!e._isBuffer)},t.exports.alloc=function(e){var t=new a(e);return t.fill(0),t},t.exports.from=function(e){return new a(e)}},{isarray:33}],29:[function(e,t,n){n.byteLength=u,n.toByteArray=h,n.fromByteArray=m;for(var i=[],r=[],o="undefined"!=typeof Uint8Array?Uint8Array:Array,a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s=0,l=a.length;s<l;++s)i[s]=a[s],r[a.charCodeAt(s)]=s;function c(e){var t=e.length;if(t%4>0)throw new Error("Invalid string. Length must be a multiple of 4");var n=e.indexOf("=");return-1===n&&(n=t),[n,n===t?0:4-n%4]}function u(e){var t=c(e),n=t[0],i=t[1];return 3*(n+i)/4-i}function d(e,t,n){return 3*(t+n)/4-n}function h(e){var t,n,i=c(e),a=i[0],s=i[1],l=new o(d(e,a,s)),u=0,h=s>0?a-4:a;for(n=0;n<h;n+=4)t=r[e.charCodeAt(n)]<<18|r[e.charCodeAt(n+1)]<<12|r[e.charCodeAt(n+2)]<<6|r[e.charCodeAt(n+3)],l[u++]=t>>16&255,l[u++]=t>>8&255,l[u++]=255&t;return 2===s&&(t=r[e.charCodeAt(n)]<<2|r[e.charCodeAt(n+1)]>>4,l[u++]=255&t),1===s&&(t=r[e.charCodeAt(n)]<<10|r[e.charCodeAt(n+1)]<<4|r[e.charCodeAt(n+2)]>>2,l[u++]=t>>8&255,l[u++]=255&t),l}function f(e){return i[e>>18&63]+i[e>>12&63]+i[e>>6&63]+i[63&e]}function p(e,t,n){for(var i,r=[],o=t;o<n;o+=3)i=(e[o]<<16&16711680)+(e[o+1]<<8&65280)+(255&e[o+2]),r.push(f(i));return r.join("")}function m(e){for(var t,n=e.length,r=n%3,o=[],a=16383,s=0,l=n-r;s<l;s+=a)o.push(p(e,s,s+a>l?l:s+a));return 1===r?(t=e[n-1],o.push(i[t>>2]+i[t<<4&63]+"==")):2===r&&(t=(e[n-2]<<8)+e[n-1],o.push(i[t>>10]+i[t>>4&63]+i[t<<2&63]+"=")),o.join("")}r["-".charCodeAt(0)]=62,r["_".charCodeAt(0)]=63},{}],30:[function(e,t,n){var i=e("base64-js"),r=e("ieee754"),o="function"==typeof Symbol&&"function"==typeof Symbol.for?Symbol.for("nodejs.util.inspect.custom"):null;n.Buffer=c,n.SlowBuffer=b,n.INSPECT_MAX_BYTES=50;var a=2147483647;function s(){try{var e=new Uint8Array(1),t={foo:function(){return 42}};return Object.setPrototypeOf(t,Uint8Array.prototype),Object.setPrototypeOf(e,t),42===e.foo()}catch(e){return!1}}function l(e){if(e>a)throw new RangeError('The value "'+e+'" is invalid for option "size"');var t=new Uint8Array(e);return Object.setPrototypeOf(t,c.prototype),t}function c(e,t,n){if("number"==typeof e){if("string"==typeof t)throw new TypeError('The "string" argument must be of type string. Received type number');return f(e)}return u(e,t,n)}function u(e,t,n){if("string"==typeof e)return p(e,t);if(ArrayBuffer.isView(e))return m(e);if(null==e)throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type "+typeof e);if(Z(e,ArrayBuffer)||e&&Z(e.buffer,ArrayBuffer))return v(e,t,n);if("number"==typeof e)throw new TypeError('The "value" argument must not be of type number. Received type number');var i=e.valueOf&&e.valueOf();if(null!=i&&i!==e)return c.from(i,t,n);var r=g(e);if(r)return r;if("undefined"!=typeof Symbol&&null!=Symbol.toPrimitive&&"function"==typeof e[Symbol.toPrimitive])return c.from(e[Symbol.toPrimitive]("string"),t,n);throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type "+typeof e)}function d(e){if("number"!=typeof e)throw new TypeError('"size" argument must be of type number');if(e<0)throw new RangeError('The value "'+e+'" is invalid for option "size"')}function h(e,t,n){return d(e),e<=0?l(e):void 0!==t?"string"==typeof n?l(e).fill(t,n):l(e).fill(t):l(e)}function f(e){return d(e),l(e<0?0:0|_(e))}function p(e,t){if("string"==typeof t&&""!==t||(t="utf8"),!c.isEncoding(t))throw new TypeError("Unknown encoding: "+t);var n=0|y(e,t),i=l(n),r=i.write(e,t);return r!==n&&(i=i.slice(0,r)),i}function m(e){for(var t=e.length<0?0:0|_(e.length),n=l(t),i=0;i<t;i+=1)n[i]=255&e[i];return n}function v(e,t,n){if(t<0||e.byteLength<t)throw new RangeError('"offset" is outside of buffer bounds');if(e.byteLength<t+(n||0))throw new RangeError('"length" is outside of buffer bounds');var i;return i=void 0===t&&void 0===n?new Uint8Array(e):void 0===n?new Uint8Array(e,t):new Uint8Array(e,t,n),Object.setPrototypeOf(i,c.prototype),i}function g(e){if(c.isBuffer(e)){var t=0|_(e.length),n=l(t);return 0===n.length||e.copy(n,0,0,t),n}return void 0!==e.length?"number"!=typeof e.length||J(e.length)?l(0):m(e):"Buffer"===e.type&&Array.isArray(e.data)?m(e.data):void 0}function _(e){if(e>=a)throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+a.toString(16)+" bytes");return 0|e}function b(e){return+e!=e&&(e=0),c.alloc(+e)}function y(e,t){if(c.isBuffer(e))return e.length;if(ArrayBuffer.isView(e)||Z(e,ArrayBuffer))return e.byteLength;if("string"!=typeof e)throw new TypeError('The "string" argument must be one of type string, Buffer, or ArrayBuffer. Received type '+typeof e);var n=e.length,i=arguments.length>2&&!0===arguments[2];if(!i&&0===n)return 0;for(var r=!1;;)switch(t){case"ascii":case"latin1":case"binary":return n;case"utf8":case"utf-8":return U(e).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return 2*n;case"hex":return n>>>1;case"base64":return Q(e).length;default:if(r)return i?-1:U(e).length;t=(""+t).toLowerCase(),r=!0}}function w(e,t,n){var i=!1;if((void 0===t||t<0)&&(t=0),t>this.length)return"";if((void 0===n||n>this.length)&&(n=this.length),n<=0)return"";if((n>>>=0)<=(t>>>=0))return"";for(e||(e="utf8");;)switch(e){case"hex":return j(this,t,n);case"utf8":case"utf-8":return q(this,t,n);case"ascii":return z(this,t,n);case"latin1":case"binary":return N(this,t,n);case"base64":return O(this,t,n);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return R(this,t,n);default:if(i)throw new TypeError("Unknown encoding: "+e);e=(e+"").toLowerCase(),i=!0}}function k(e,t,n){var i=e[t];e[t]=e[n],e[n]=i}function x(e,t,n,i,r){if(0===e.length)return-1;if("string"==typeof n?(i=n,n=0):n>2147483647?n=2147483647:n<-2147483648&&(n=-2147483648),J(n=+n)&&(n=r?0:e.length-1),n<0&&(n=e.length+n),n>=e.length){if(r)return-1;n=e.length-1}else if(n<0){if(!r)return-1;n=0}if("string"==typeof t&&(t=c.from(t,i)),c.isBuffer(t))return 0===t.length?-1:S(e,t,n,i,r);if("number"==typeof t)return t&=255,"function"==typeof Uint8Array.prototype.indexOf?r?Uint8Array.prototype.indexOf.call(e,t,n):Uint8Array.prototype.lastIndexOf.call(e,t,n):S(e,[t],n,i,r);throw new TypeError("val must be string, number or Buffer")}function S(e,t,n,i,r){var o,a=1,s=e.length,l=t.length;if(void 0!==i&&("ucs2"===(i=String(i).toLowerCase())||"ucs-2"===i||"utf16le"===i||"utf-16le"===i)){if(e.length<2||t.length<2)return-1;a=2,s/=2,l/=2,n/=2}function c(e,t){return 1===a?e[t]:e.readUInt16BE(t*a)}if(r){var u=-1;for(o=n;o<s;o++)if(c(e,o)===c(t,-1===u?0:o-u)){if(-1===u&&(u=o),o-u+1===l)return u*a}else-1!==u&&(o-=o-u),u=-1}else for(n+l>s&&(n=s-l),o=n;o>=0;o--){for(var d=!0,h=0;h<l;h++)if(c(e,o+h)!==c(t,h)){d=!1;break}if(d)return o}return-1}function C(e,t,n,i){n=Number(n)||0;var r=e.length-n;i?(i=Number(i))>r&&(i=r):i=r;var o=t.length;i>o/2&&(i=o/2);for(var a=0;a<i;++a){var s=parseInt(t.substr(2*a,2),16);if(J(s))return a;e[n+a]=s}return a}function M(e,t,n,i){return K(U(t,e.length-n),e,n,i)}function T(e,t,n,i){return K(Y(t),e,n,i)}function A(e,t,n,i){return T(e,t,n,i)}function P(e,t,n,i){return K(Q(t),e,n,i)}function L(e,t,n,i){return K(G(t,e.length-n),e,n,i)}function O(e,t,n){return 0===t&&n===e.length?i.fromByteArray(e):i.fromByteArray(e.slice(t,n))}function q(e,t,n){n=Math.min(e.length,n);for(var i=[],r=t;r<n;){var o,a,s,l,c=e[r],u=null,d=c>239?4:c>223?3:c>191?2:1;if(r+d<=n)switch(d){case 1:c<128&&(u=c);break;case 2:128==(192&(o=e[r+1]))&&(l=(31&c)<<6|63&o)>127&&(u=l);break;case 3:o=e[r+1],a=e[r+2],128==(192&o)&&128==(192&a)&&(l=(15&c)<<12|(63&o)<<6|63&a)>2047&&(l<55296||l>57343)&&(u=l);break;case 4:o=e[r+1],a=e[r+2],s=e[r+3],128==(192&o)&&128==(192&a)&&128==(192&s)&&(l=(15&c)<<18|(63&o)<<12|(63&a)<<6|63&s)>65535&&l<1114112&&(u=l)}null===u?(u=65533,d=1):u>65535&&(u-=65536,i.push(u>>>10&1023|55296),u=56320|1023&u),i.push(u),r+=d}return D(i)}n.kMaxLength=a,c.TYPED_ARRAY_SUPPORT=s(),c.TYPED_ARRAY_SUPPORT||"undefined"==typeof console||"function"!=typeof console.error||console.error("This browser lacks typed array (Uint8Array) support which is required by `buffer` v5.x. Use `buffer` v4.x if you require old browser support."),Object.defineProperty(c.prototype,"parent",{enumerable:!0,get:function(){if(c.isBuffer(this))return this.buffer}}),Object.defineProperty(c.prototype,"offset",{enumerable:!0,get:function(){if(c.isBuffer(this))return this.byteOffset}}),"undefined"!=typeof Symbol&&null!=Symbol.species&&c[Symbol.species]===c&&Object.defineProperty(c,Symbol.species,{value:null,configurable:!0,enumerable:!1,writable:!1}),c.poolSize=8192,c.from=function(e,t,n){return u(e,t,n)},Object.setPrototypeOf(c.prototype,Uint8Array.prototype),Object.setPrototypeOf(c,Uint8Array),c.alloc=function(e,t,n){return h(e,t,n)},c.allocUnsafe=function(e){return f(e)},c.allocUnsafeSlow=function(e){return f(e)},c.isBuffer=function(e){return null!=e&&!0===e._isBuffer&&e!==c.prototype},c.compare=function(e,t){if(Z(e,Uint8Array)&&(e=c.from(e,e.offset,e.byteLength)),Z(t,Uint8Array)&&(t=c.from(t,t.offset,t.byteLength)),!c.isBuffer(e)||!c.isBuffer(t))throw new TypeError('The "buf1", "buf2" arguments must be one of type Buffer or Uint8Array');if(e===t)return 0;for(var n=e.length,i=t.length,r=0,o=Math.min(n,i);r<o;++r)if(e[r]!==t[r]){n=e[r],i=t[r];break}return n<i?-1:i<n?1:0},c.isEncoding=function(e){switch(String(e).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"latin1":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}},c.concat=function(e,t){if(!Array.isArray(e))throw new TypeError('"list" argument must be an Array of Buffers');if(0===e.length)return c.alloc(0);var n;if(void 0===t)for(t=0,n=0;n<e.length;++n)t+=e[n].length;var i=c.allocUnsafe(t),r=0;for(n=0;n<e.length;++n){var o=e[n];if(Z(o,Uint8Array)&&(o=c.from(o)),!c.isBuffer(o))throw new TypeError('"list" argument must be an Array of Buffers');o.copy(i,r),r+=o.length}return i},c.byteLength=y,c.prototype._isBuffer=!0,c.prototype.swap16=function(){var e=this.length;if(e%2!=0)throw new RangeError("Buffer size must be a multiple of 16-bits");for(var t=0;t<e;t+=2)k(this,t,t+1);return this},c.prototype.swap32=function(){var e=this.length;if(e%4!=0)throw new RangeError("Buffer size must be a multiple of 32-bits");for(var t=0;t<e;t+=4)k(this,t,t+3),k(this,t+1,t+2);return this},c.prototype.swap64=function(){var e=this.length;if(e%8!=0)throw new RangeError("Buffer size must be a multiple of 64-bits");for(var t=0;t<e;t+=8)k(this,t,t+7),k(this,t+1,t+6),k(this,t+2,t+5),k(this,t+3,t+4);return this},c.prototype.toString=function(){var e=this.length;return 0===e?"":0===arguments.length?q(this,0,e):w.apply(this,arguments)},c.prototype.toLocaleString=c.prototype.toString,c.prototype.equals=function(e){if(!c.isBuffer(e))throw new TypeError("Argument must be a Buffer");return this===e||0===c.compare(this,e)},c.prototype.inspect=function(){var e="",t=n.INSPECT_MAX_BYTES;return e=this.toString("hex",0,t).replace(/(.{2})/g,"$1 ").trim(),this.length>t&&(e+=" ... "),"<Buffer "+e+">"},o&&(c.prototype[o]=c.prototype.inspect),c.prototype.compare=function(e,t,n,i,r){if(Z(e,Uint8Array)&&(e=c.from(e,e.offset,e.byteLength)),!c.isBuffer(e))throw new TypeError('The "target" argument must be one of type Buffer or Uint8Array. Received type '+typeof e);if(void 0===t&&(t=0),void 0===n&&(n=e?e.length:0),void 0===i&&(i=0),void 0===r&&(r=this.length),t<0||n>e.length||i<0||r>this.length)throw new RangeError("out of range index");if(i>=r&&t>=n)return 0;if(i>=r)return-1;if(t>=n)return 1;if(this===e)return 0;for(var o=(r>>>=0)-(i>>>=0),a=(n>>>=0)-(t>>>=0),s=Math.min(o,a),l=this.slice(i,r),u=e.slice(t,n),d=0;d<s;++d)if(l[d]!==u[d]){o=l[d],a=u[d];break}return o<a?-1:a<o?1:0},c.prototype.includes=function(e,t,n){return-1!==this.indexOf(e,t,n)},c.prototype.indexOf=function(e,t,n){return x(this,e,t,n,!0)},c.prototype.lastIndexOf=function(e,t,n){return x(this,e,t,n,!1)},c.prototype.write=function(e,t,n,i){if(void 0===t)i="utf8",n=this.length,t=0;else if(void 0===n&&"string"==typeof t)i=t,n=this.length,t=0;else{if(!isFinite(t))throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");t>>>=0,isFinite(n)?(n>>>=0,void 0===i&&(i="utf8")):(i=n,n=void 0)}var r=this.length-t;if((void 0===n||n>r)&&(n=r),e.length>0&&(n<0||t<0)||t>this.length)throw new RangeError("Attempt to write outside buffer bounds");i||(i="utf8");for(var o=!1;;)switch(i){case"hex":return C(this,e,t,n);case"utf8":case"utf-8":return M(this,e,t,n);case"ascii":return T(this,e,t,n);case"latin1":case"binary":return A(this,e,t,n);case"base64":return P(this,e,t,n);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return L(this,e,t,n);default:if(o)throw new TypeError("Unknown encoding: "+i);i=(""+i).toLowerCase(),o=!0}},c.prototype.toJSON=function(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};var E=4096;function D(e){var t=e.length;if(t<=E)return String.fromCharCode.apply(String,e);for(var n="",i=0;i<t;)n+=String.fromCharCode.apply(String,e.slice(i,i+=E));return n}function z(e,t,n){var i="";n=Math.min(e.length,n);for(var r=t;r<n;++r)i+=String.fromCharCode(127&e[r]);return i}function N(e,t,n){var i="";n=Math.min(e.length,n);for(var r=t;r<n;++r)i+=String.fromCharCode(e[r]);return i}function j(e,t,n){var i=e.length;(!t||t<0)&&(t=0),(!n||n<0||n>i)&&(n=i);for(var r="",o=t;o<n;++o)r+=X[e[o]];return r}function R(e,t,n){for(var i=e.slice(t,n),r="",o=0;o<i.length;o+=2)r+=String.fromCharCode(i[o]+256*i[o+1]);return r}function I(e,t,n){if(e%1!=0||e<0)throw new RangeError("offset is not uint");if(e+t>n)throw new RangeError("Trying to access beyond buffer length")}function $(e,t,n,i,r,o){if(!c.isBuffer(e))throw new TypeError('"buffer" argument must be a Buffer instance');if(t>r||t<o)throw new RangeError('"value" argument is out of bounds');if(n+i>e.length)throw new RangeError("Index out of range")}function F(e,t,n,i,r,o){if(n+i>e.length)throw new RangeError("Index out of range");if(n<0)throw new RangeError("Index out of range")}function B(e,t,n,i,o){return t=+t,n>>>=0,o||F(e,t,n,4),r.write(e,t,n,i,23,4),n+4}function V(e,t,n,i,o){return t=+t,n>>>=0,o||F(e,t,n,8),r.write(e,t,n,i,52,8),n+8}c.prototype.slice=function(e,t){var n=this.length;(e=~~e)<0?(e+=n)<0&&(e=0):e>n&&(e=n),(t=void 0===t?n:~~t)<0?(t+=n)<0&&(t=0):t>n&&(t=n),t<e&&(t=e);var i=this.subarray(e,t);return Object.setPrototypeOf(i,c.prototype),i},c.prototype.readUIntLE=function(e,t,n){e>>>=0,t>>>=0,n||I(e,t,this.length);for(var i=this[e],r=1,o=0;++o<t&&(r*=256);)i+=this[e+o]*r;return i},c.prototype.readUIntBE=function(e,t,n){e>>>=0,t>>>=0,n||I(e,t,this.length);for(var i=this[e+--t],r=1;t>0&&(r*=256);)i+=this[e+--t]*r;return i},c.prototype.readUInt8=function(e,t){return e>>>=0,t||I(e,1,this.length),this[e]},c.prototype.readUInt16LE=function(e,t){return e>>>=0,t||I(e,2,this.length),this[e]|this[e+1]<<8},c.prototype.readUInt16BE=function(e,t){return e>>>=0,t||I(e,2,this.length),this[e]<<8|this[e+1]},c.prototype.readUInt32LE=function(e,t){return e>>>=0,t||I(e,4,this.length),(this[e]|this[e+1]<<8|this[e+2]<<16)+16777216*this[e+3]},c.prototype.readUInt32BE=function(e,t){return e>>>=0,t||I(e,4,this.length),16777216*this[e]+(this[e+1]<<16|this[e+2]<<8|this[e+3])},c.prototype.readIntLE=function(e,t,n){e>>>=0,t>>>=0,n||I(e,t,this.length);for(var i=this[e],r=1,o=0;++o<t&&(r*=256);)i+=this[e+o]*r;return i>=(r*=128)&&(i-=Math.pow(2,8*t)),i},c.prototype.readIntBE=function(e,t,n){e>>>=0,t>>>=0,n||I(e,t,this.length);for(var i=t,r=1,o=this[e+--i];i>0&&(r*=256);)o+=this[e+--i]*r;return o>=(r*=128)&&(o-=Math.pow(2,8*t)),o},c.prototype.readInt8=function(e,t){return e>>>=0,t||I(e,1,this.length),128&this[e]?-1*(255-this[e]+1):this[e]},c.prototype.readInt16LE=function(e,t){e>>>=0,t||I(e,2,this.length);var n=this[e]|this[e+1]<<8;return 32768&n?4294901760|n:n},c.prototype.readInt16BE=function(e,t){e>>>=0,t||I(e,2,this.length);var n=this[e+1]|this[e]<<8;return 32768&n?4294901760|n:n},c.prototype.readInt32LE=function(e,t){return e>>>=0,t||I(e,4,this.length),this[e]|this[e+1]<<8|this[e+2]<<16|this[e+3]<<24},c.prototype.readInt32BE=function(e,t){return e>>>=0,t||I(e,4,this.length),this[e]<<24|this[e+1]<<16|this[e+2]<<8|this[e+3]},c.prototype.readFloatLE=function(e,t){return e>>>=0,t||I(e,4,this.length),r.read(this,e,!0,23,4)},c.prototype.readFloatBE=function(e,t){return e>>>=0,t||I(e,4,this.length),r.read(this,e,!1,23,4)},c.prototype.readDoubleLE=function(e,t){return e>>>=0,t||I(e,8,this.length),r.read(this,e,!0,52,8)},c.prototype.readDoubleBE=function(e,t){return e>>>=0,t||I(e,8,this.length),r.read(this,e,!1,52,8)},c.prototype.writeUIntLE=function(e,t,n,i){e=+e,t>>>=0,n>>>=0,i||$(this,e,t,n,Math.pow(2,8*n)-1,0);var r=1,o=0;for(this[t]=255&e;++o<n&&(r*=256);)this[t+o]=e/r&255;return t+n},c.prototype.writeUIntBE=function(e,t,n,i){e=+e,t>>>=0,n>>>=0,i||$(this,e,t,n,Math.pow(2,8*n)-1,0);var r=n-1,o=1;for(this[t+r]=255&e;--r>=0&&(o*=256);)this[t+r]=e/o&255;return t+n},c.prototype.writeUInt8=function(e,t,n){return e=+e,t>>>=0,n||$(this,e,t,1,255,0),this[t]=255&e,t+1},c.prototype.writeUInt16LE=function(e,t,n){return e=+e,t>>>=0,n||$(this,e,t,2,65535,0),this[t]=255&e,this[t+1]=e>>>8,t+2},c.prototype.writeUInt16BE=function(e,t,n){return e=+e,t>>>=0,n||$(this,e,t,2,65535,0),this[t]=e>>>8,this[t+1]=255&e,t+2},c.prototype.writeUInt32LE=function(e,t,n){return e=+e,t>>>=0,n||$(this,e,t,4,4294967295,0),this[t+3]=e>>>24,this[t+2]=e>>>16,this[t+1]=e>>>8,this[t]=255&e,t+4},c.prototype.writeUInt32BE=function(e,t,n){return e=+e,t>>>=0,n||$(this,e,t,4,4294967295,0),this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e,t+4},c.prototype.writeIntLE=function(e,t,n,i){if(e=+e,t>>>=0,!i){var r=Math.pow(2,8*n-1);$(this,e,t,n,r-1,-r)}var o=0,a=1,s=0;for(this[t]=255&e;++o<n&&(a*=256);)e<0&&0===s&&0!==this[t+o-1]&&(s=1),this[t+o]=(e/a>>0)-s&255;return t+n},c.prototype.writeIntBE=function(e,t,n,i){if(e=+e,t>>>=0,!i){var r=Math.pow(2,8*n-1);$(this,e,t,n,r-1,-r)}var o=n-1,a=1,s=0;for(this[t+o]=255&e;--o>=0&&(a*=256);)e<0&&0===s&&0!==this[t+o+1]&&(s=1),this[t+o]=(e/a>>0)-s&255;return t+n},c.prototype.writeInt8=function(e,t,n){return e=+e,t>>>=0,n||$(this,e,t,1,127,-128),e<0&&(e=255+e+1),this[t]=255&e,t+1},c.prototype.writeInt16LE=function(e,t,n){return e=+e,t>>>=0,n||$(this,e,t,2,32767,-32768),this[t]=255&e,this[t+1]=e>>>8,t+2},c.prototype.writeInt16BE=function(e,t,n){return e=+e,t>>>=0,n||$(this,e,t,2,32767,-32768),this[t]=e>>>8,this[t+1]=255&e,t+2},c.prototype.writeInt32LE=function(e,t,n){return e=+e,t>>>=0,n||$(this,e,t,4,2147483647,-2147483648),this[t]=255&e,this[t+1]=e>>>8,this[t+2]=e>>>16,this[t+3]=e>>>24,t+4},c.prototype.writeInt32BE=function(e,t,n){return e=+e,t>>>=0,n||$(this,e,t,4,2147483647,-2147483648),e<0&&(e=4294967295+e+1),this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e,t+4},c.prototype.writeFloatLE=function(e,t,n){return B(this,e,t,!0,n)},c.prototype.writeFloatBE=function(e,t,n){return B(this,e,t,!1,n)},c.prototype.writeDoubleLE=function(e,t,n){return V(this,e,t,!0,n)},c.prototype.writeDoubleBE=function(e,t,n){return V(this,e,t,!1,n)},c.prototype.copy=function(e,t,n,i){if(!c.isBuffer(e))throw new TypeError("argument should be a Buffer");if(n||(n=0),i||0===i||(i=this.length),t>=e.length&&(t=e.length),t||(t=0),i>0&&i<n&&(i=n),i===n)return 0;if(0===e.length||0===this.length)return 0;if(t<0)throw new RangeError("targetStart out of bounds");if(n<0||n>=this.length)throw new RangeError("Index out of range");if(i<0)throw new RangeError("sourceEnd out of bounds");i>this.length&&(i=this.length),e.length-t<i-n&&(i=e.length-t+n);var r=i-n;if(this===e&&"function"==typeof Uint8Array.prototype.copyWithin)this.copyWithin(t,n,i);else if(this===e&&n<t&&t<i)for(var o=r-1;o>=0;--o)e[o+t]=this[o+n];else Uint8Array.prototype.set.call(e,this.subarray(n,i),t);return r},c.prototype.fill=function(e,t,n,i){if("string"==typeof e){if("string"==typeof t?(i=t,t=0,n=this.length):"string"==typeof n&&(i=n,n=this.length),void 0!==i&&"string"!=typeof i)throw new TypeError("encoding must be a string");if("string"==typeof i&&!c.isEncoding(i))throw new TypeError("Unknown encoding: "+i);if(1===e.length){var r=e.charCodeAt(0);("utf8"===i&&r<128||"latin1"===i)&&(e=r)}}else"number"==typeof e?e&=255:"boolean"==typeof e&&(e=Number(e));if(t<0||this.length<t||this.length<n)throw new RangeError("Out of range index");if(n<=t)return this;var o;if(t>>>=0,n=void 0===n?this.length:n>>>0,e||(e=0),"number"==typeof e)for(o=t;o<n;++o)this[o]=e;else{var a=c.isBuffer(e)?e:c.from(e,i),s=a.length;if(0===s)throw new TypeError('The value "'+e+'" is invalid for argument "value"');for(o=0;o<n-t;++o)this[o+t]=a[o%s]}return this};var H=/[^+/0-9A-Za-z-_]/g;function W(e){if((e=(e=e.split("=")[0]).trim().replace(H,"")).length<2)return"";for(;e.length%4!=0;)e+="=";return e}function U(e,t){var n;t=t||1/0;for(var i=e.length,r=null,o=[],a=0;a<i;++a){if((n=e.charCodeAt(a))>55295&&n<57344){if(!r){if(n>56319){(t-=3)>-1&&o.push(239,191,189);continue}if(a+1===i){(t-=3)>-1&&o.push(239,191,189);continue}r=n;continue}if(n<56320){(t-=3)>-1&&o.push(239,191,189),r=n;continue}n=65536+(r-55296<<10|n-56320)}else r&&(t-=3)>-1&&o.push(239,191,189);if(r=null,n<128){if((t-=1)<0)break;o.push(n)}else if(n<2048){if((t-=2)<0)break;o.push(n>>6|192,63&n|128)}else if(n<65536){if((t-=3)<0)break;o.push(n>>12|224,n>>6&63|128,63&n|128)}else{if(!(n<1114112))throw new Error("Invalid code point");if((t-=4)<0)break;o.push(n>>18|240,n>>12&63|128,n>>6&63|128,63&n|128)}}return o}function Y(e){for(var t=[],n=0;n<e.length;++n)t.push(255&e.charCodeAt(n));return t}function G(e,t){for(var n,i,r,o=[],a=0;a<e.length&&!((t-=2)<0);++a)i=(n=e.charCodeAt(a))>>8,r=n%256,o.push(r),o.push(i);return o}function Q(e){return i.toByteArray(W(e))}function K(e,t,n,i){for(var r=0;r<i&&!(r+n>=t.length||r>=e.length);++r)t[r+n]=e[r];return r}function Z(e,t){return e instanceof t||null!=e&&null!=e.constructor&&null!=e.constructor.name&&e.constructor.name===t.name}function J(e){return e!=e}var X=function(){for(var e="0123456789abcdef",t=new Array(256),n=0;n<16;++n)for(var i=16*n,r=0;r<16;++r)t[i+r]=e[n]+e[r];return t}()},{"base64-js":29,ieee754:32}],31:[function(e,t,n){var i={single_source_shortest_paths:function(e,t,n){var r={},o={};o[t]=0;var a,s,l,c,u,d,h,f=i.PriorityQueue.make();for(f.push(t,0);!f.empty();)for(l in s=(a=f.pop()).value,c=a.cost,u=e[s]||{})u.hasOwnProperty(l)&&(d=c+u[l],h=o[l],(void 0===o[l]||h>d)&&(o[l]=d,f.push(l,d),r[l]=s));if(void 0!==n&&void 0===o[n]){var p=["Could not find a path from ",t," to ",n,"."].join("");throw new Error(p)}return r},extract_shortest_path_from_predecessor_list:function(e,t){for(var n=[],i=t;i;)n.push(i),e[i],i=e[i];return n.reverse(),n},find_path:function(e,t,n){var r=i.single_source_shortest_paths(e,t,n);return i.extract_shortest_path_from_predecessor_list(r,n)},PriorityQueue:{make:function(e){var t,n=i.PriorityQueue,r={};for(t in e=e||{},n)n.hasOwnProperty(t)&&(r[t]=n[t]);return r.queue=[],r.sorter=e.sorter||n.default_sorter,r},default_sorter:function(e,t){return e.cost-t.cost},push:function(e,t){var n={value:e,cost:t};this.queue.push(n),this.queue.sort(this.sorter)},pop:function(){return this.queue.shift()},empty:function(){return 0===this.queue.length}}};void 0!==t&&(t.exports=i)},{}],32:[function(e,t,n){n.read=function(e,t,n,i,r){var o,a,s=8*r-i-1,l=(1<<s)-1,c=l>>1,u=-7,d=n?r-1:0,h=n?-1:1,f=e[t+d];for(d+=h,o=f&(1<<-u)-1,f>>=-u,u+=s;u>0;o=256*o+e[t+d],d+=h,u-=8);for(a=o&(1<<-u)-1,o>>=-u,u+=i;u>0;a=256*a+e[t+d],d+=h,u-=8);if(0===o)o=1-c;else{if(o===l)return a?NaN:1/0*(f?-1:1);a+=Math.pow(2,i),o-=c}return(f?-1:1)*a*Math.pow(2,o-i)},n.write=function(e,t,n,i,r,o){var a,s,l,c=8*o-r-1,u=(1<<c)-1,d=u>>1,h=23===r?Math.pow(2,-24)-Math.pow(2,-77):0,f=i?0:o-1,p=i?1:-1,m=t<0||0===t&&1/t<0?1:0;for(t=Math.abs(t),isNaN(t)||t===1/0?(s=isNaN(t)?1:0,a=u):(a=Math.floor(Math.log(t)/Math.LN2),t*(l=Math.pow(2,-a))<1&&(a--,l*=2),(t+=a+d>=1?h/l:h*Math.pow(2,1-d))*l>=2&&(a++,l/=2),a+d>=u?(s=0,a=u):a+d>=1?(s=(t*l-1)*Math.pow(2,r),a+=d):(s=t*Math.pow(2,d-1)*Math.pow(2,r),a=0));r>=8;e[n+f]=255&s,f+=p,s/=256,r-=8);for(a=a<<r|s,c+=r;c>0;e[n+f]=255&a,f+=p,a/=256,c-=8);e[n+f-p]|=128*m}},{}],33:[function(e,t,n){var i={}.toString;t.exports=Array.isArray||function(e){return"[object Array]"==i.call(e)}},{}]},{},[24])(24)}));return{name:"qrcode",props:{value:null,options:Object,tag:{type:String,default:"canvas"}},render:function(e){return e(this.tag,this.$slots.default)},watch:{$props:{deep:!0,immediate:!0,handler:function(){this.$el&&this.generate()}}},methods:{generate:function(){var e=this,n=this.options,i=this.tag,r=String(this.value);"canvas"===i?t.toCanvas(this.$el,r,n,(function(e){if(e)throw e})):"img"===i?t.toDataURL(r,n,(function(t,n){if(t)throw t;e.$el.src=n})):t.toString(r,n,(function(t,n){if(t)throw t;e.$el.innerHTML=n}))}},mounted:function(){this.generate()}}})),
/*!
 * vuex v3.5.1
 * (c) 2020 Evan You
 * @license MIT
 */
function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e=e||self).Vuex=t()}(this,(function(){"use strict";var e=("undefined"!=typeof window?window:"undefined"!=typeof global?global:{}).__VUE_DEVTOOLS_GLOBAL_HOOK__;function t(e,n){if(void 0===n&&(n=[]),null===e||"object"!=typeof e)return e;var i,r=(i=function(t){return t.original===e},n.filter(i)[0]);if(r)return r.copy;var o=Array.isArray(e)?[]:{};return n.push({original:e,copy:o}),Object.keys(e).forEach((function(i){o[i]=t(e[i],n)})),o}function n(e,t){Object.keys(e).forEach((function(n){return t(e[n],n)}))}function i(e){return null!==e&&"object"==typeof e}function r(e,t){if(!e)throw new Error("[vuex] "+t)}var o=function(e,t){this.runtime=t,this._children=Object.create(null),this._rawModule=e;var n=e.state;this.state=("function"==typeof n?n():n)||{}},a={namespaced:{configurable:!0}};a.namespaced.get=function(){return!!this._rawModule.namespaced},o.prototype.addChild=function(e,t){this._children[e]=t},o.prototype.removeChild=function(e){delete this._children[e]},o.prototype.getChild=function(e){return this._children[e]},o.prototype.hasChild=function(e){return e in this._children},o.prototype.update=function(e){this._rawModule.namespaced=e.namespaced,e.actions&&(this._rawModule.actions=e.actions),e.mutations&&(this._rawModule.mutations=e.mutations),e.getters&&(this._rawModule.getters=e.getters)},o.prototype.forEachChild=function(e){n(this._children,e)},o.prototype.forEachGetter=function(e){this._rawModule.getters&&n(this._rawModule.getters,e)},o.prototype.forEachAction=function(e){this._rawModule.actions&&n(this._rawModule.actions,e)},o.prototype.forEachMutation=function(e){this._rawModule.mutations&&n(this._rawModule.mutations,e)},Object.defineProperties(o.prototype,a);var s=function(e){this.register([],e,!1)};function l(e,t,n){if(h(e,n),t.update(n),n.modules)for(var i in n.modules){if(!t.getChild(i))return void console.warn("[vuex] trying to add a new module '"+i+"' on hot reloading, manual reload is needed");l(e.concat(i),t.getChild(i),n.modules[i])}}s.prototype.get=function(e){return e.reduce((function(e,t){return e.getChild(t)}),this.root)},s.prototype.getNamespace=function(e){var t=this.root;return e.reduce((function(e,n){return e+((t=t.getChild(n)).namespaced?n+"/":"")}),"")},s.prototype.update=function(e){l([],this.root,e)},s.prototype.register=function(e,t,i){var r=this;void 0===i&&(i=!0),h(e,t);var a=new o(t,i);0===e.length?this.root=a:this.get(e.slice(0,-1)).addChild(e[e.length-1],a);t.modules&&n(t.modules,(function(t,n){r.register(e.concat(n),t,i)}))},s.prototype.unregister=function(e){var t=this.get(e.slice(0,-1)),n=e[e.length-1],i=t.getChild(n);i?i.runtime&&t.removeChild(n):console.warn("[vuex] trying to unregister module '"+n+"', which is not registered")},s.prototype.isRegistered=function(e){var t=this.get(e.slice(0,-1)),n=e[e.length-1];return t.hasChild(n)};var c,u={assert:function(e){return"function"==typeof e},expected:"function"},d={getters:u,mutations:u,actions:{assert:function(e){return"function"==typeof e||"object"==typeof e&&"function"==typeof e.handler},expected:'function or object with "handler" function'}};function h(e,t){Object.keys(d).forEach((function(i){if(t[i]){var o=d[i];n(t[i],(function(t,n){r(o.assert(t),function(e,t,n,i,r){var o=t+" should be "+r+' but "'+t+"."+n+'"';e.length>0&&(o+=' in module "'+e.join(".")+'"');return o+=" is "+JSON.stringify(i)+".",o}(e,i,n,t,o.expected))}))}}))}var f=function t(n){var i=this;void 0===n&&(n={}),!c&&"undefined"!=typeof window&&window.Vue&&w(window.Vue),r(c,"must call Vue.use(Vuex) before creating a store instance."),r("undefined"!=typeof Promise,"vuex requires a Promise polyfill in this browser."),r(this instanceof t,"store must be called with the new operator.");var o=n.plugins;void 0===o&&(o=[]);var a=n.strict;void 0===a&&(a=!1),this._committing=!1,this._actions=Object.create(null),this._actionSubscribers=[],this._mutations=Object.create(null),this._wrappedGetters=Object.create(null),this._modules=new s(n),this._modulesNamespaceMap=Object.create(null),this._subscribers=[],this._watcherVM=new c,this._makeLocalGettersCache=Object.create(null);var l=this,u=this.dispatch,d=this.commit;this.dispatch=function(e,t){return u.call(l,e,t)},this.commit=function(e,t,n){return d.call(l,e,t,n)},this.strict=a;var h=this._modules.root.state;_(this,h,[],this._modules.root),g(this,h),o.forEach((function(e){return e(i)})),(void 0!==n.devtools?n.devtools:c.config.devtools)&&function(t){e&&(t._devtoolHook=e,e.emit("vuex:init",t),e.on("vuex:travel-to-state",(function(e){t.replaceState(e)})),t.subscribe((function(t,n){e.emit("vuex:mutation",t,n)}),{prepend:!0}),t.subscribeAction((function(t,n){e.emit("vuex:action",t,n)}),{prepend:!0}))}(this)},p={state:{configurable:!0}};function m(e,t,n){return t.indexOf(e)<0&&(n&&n.prepend?t.unshift(e):t.push(e)),function(){var n=t.indexOf(e);n>-1&&t.splice(n,1)}}function v(e,t){e._actions=Object.create(null),e._mutations=Object.create(null),e._wrappedGetters=Object.create(null),e._modulesNamespaceMap=Object.create(null);var n=e.state;_(e,n,[],e._modules.root,!0),g(e,n,t)}function g(e,t,i){var o=e._vm;e.getters={},e._makeLocalGettersCache=Object.create(null);var a=e._wrappedGetters,s={};n(a,(function(t,n){s[n]=function(e,t){return function(){return e(t)}}(t,e),Object.defineProperty(e.getters,n,{get:function(){return e._vm[n]},enumerable:!0})}));var l=c.config.silent;c.config.silent=!0,e._vm=new c({data:{$$state:t},computed:s}),c.config.silent=l,e.strict&&function(e){e._vm.$watch((function(){return this._data.$$state}),(function(){r(e._committing,"do not mutate vuex store state outside mutation handlers.")}),{deep:!0,sync:!0})}(e),o&&(i&&e._withCommit((function(){o._data.$$state=null})),c.nextTick((function(){return o.$destroy()})))}function _(e,t,n,i,r){var o=!n.length,a=e._modules.getNamespace(n);if(i.namespaced&&(e._modulesNamespaceMap[a]&&console.error("[vuex] duplicate namespace "+a+" for the namespaced module "+n.join("/")),e._modulesNamespaceMap[a]=i),!o&&!r){var s=b(t,n.slice(0,-1)),l=n[n.length-1];e._withCommit((function(){l in s&&console.warn('[vuex] state field "'+l+'" was overridden by a module with the same name at "'+n.join(".")+'"'),c.set(s,l,i.state)}))}var u=i.context=function(e,t,n){var i=""===t,r={dispatch:i?e.dispatch:function(n,i,r){var o=y(n,i,r),a=o.payload,s=o.options,l=o.type;if(s&&s.root||(l=t+l,e._actions[l]))return e.dispatch(l,a);console.error("[vuex] unknown local action type: "+o.type+", global type: "+l)},commit:i?e.commit:function(n,i,r){var o=y(n,i,r),a=o.payload,s=o.options,l=o.type;s&&s.root||(l=t+l,e._mutations[l])?e.commit(l,a,s):console.error("[vuex] unknown local mutation type: "+o.type+", global type: "+l)}};return Object.defineProperties(r,{getters:{get:i?function(){return e.getters}:function(){return function(e,t){if(!e._makeLocalGettersCache[t]){var n={},i=t.length;Object.keys(e.getters).forEach((function(r){if(r.slice(0,i)===t){var o=r.slice(i);Object.defineProperty(n,o,{get:function(){return e.getters[r]},enumerable:!0})}})),e._makeLocalGettersCache[t]=n}return e._makeLocalGettersCache[t]}(e,t)}},state:{get:function(){return b(e.state,n)}}}),r}(e,a,n);i.forEachMutation((function(t,n){!function(e,t,n,i){var r=e._mutations[t]||(e._mutations[t]=[]);r.push((function(t){n.call(e,i.state,t)}))}(e,a+n,t,u)})),i.forEachAction((function(t,n){var i=t.root?n:a+n,r=t.handler||t;!function(e,t,n,i){var r=e._actions[t]||(e._actions[t]=[]);r.push((function(t){var r,o=n.call(e,{dispatch:i.dispatch,commit:i.commit,getters:i.getters,state:i.state,rootGetters:e.getters,rootState:e.state},t);return(r=o)&&"function"==typeof r.then||(o=Promise.resolve(o)),e._devtoolHook?o.catch((function(t){throw e._devtoolHook.emit("vuex:error",t),t})):o}))}(e,i,r,u)})),i.forEachGetter((function(t,n){!function(e,t,n,i){if(e._wrappedGetters[t])return void console.error("[vuex] duplicate getter key: "+t);e._wrappedGetters[t]=function(e){return n(i.state,i.getters,e.state,e.getters)}}(e,a+n,t,u)})),i.forEachChild((function(i,o){_(e,t,n.concat(o),i,r)}))}function b(e,t){return t.reduce((function(e,t){return e[t]}),e)}function y(e,t,n){return i(e)&&e.type&&(n=t,t=e,e=e.type),r("string"==typeof e,"expects string as the type, but found "+typeof e+"."),{type:e,payload:t,options:n}}function w(e){c&&e===c?console.error("[vuex] already installed. Vue.use(Vuex) should be called only once."):function(e){if(Number(e.version.split(".")[0])>=2)e.mixin({beforeCreate:n});else{var t=e.prototype._init;e.prototype._init=function(e){void 0===e&&(e={}),e.init=e.init?[n].concat(e.init):n,t.call(this,e)}}function n(){var e=this.$options;e.store?this.$store="function"==typeof e.store?e.store():e.store:e.parent&&e.parent.$store&&(this.$store=e.parent.$store)}}(c=e)}p.state.get=function(){return this._vm._data.$$state},p.state.set=function(e){r(!1,"use store.replaceState() to explicit replace store state.")},f.prototype.commit=function(e,t,n){var i=this,r=y(e,t,n),o=r.type,a=r.payload,s=r.options,l={type:o,payload:a},c=this._mutations[o];c?(this._withCommit((function(){c.forEach((function(e){e(a)}))})),this._subscribers.slice().forEach((function(e){return e(l,i.state)})),s&&s.silent&&console.warn("[vuex] mutation type: "+o+". Silent option has been removed. Use the filter functionality in the vue-devtools")):console.error("[vuex] unknown mutation type: "+o)},f.prototype.dispatch=function(e,t){var n=this,i=y(e,t),r=i.type,o=i.payload,a={type:r,payload:o},s=this._actions[r];if(s){try{this._actionSubscribers.slice().filter((function(e){return e.before})).forEach((function(e){return e.before(a,n.state)}))}catch(e){console.warn("[vuex] error in before action subscribers: "),console.error(e)}var l=s.length>1?Promise.all(s.map((function(e){return e(o)}))):s[0](o);return new Promise((function(e,t){l.then((function(t){try{n._actionSubscribers.filter((function(e){return e.after})).forEach((function(e){return e.after(a,n.state)}))}catch(e){console.warn("[vuex] error in after action subscribers: "),console.error(e)}e(t)}),(function(e){try{n._actionSubscribers.filter((function(e){return e.error})).forEach((function(t){return t.error(a,n.state,e)}))}catch(e){console.warn("[vuex] error in error action subscribers: "),console.error(e)}t(e)}))}))}console.error("[vuex] unknown action type: "+r)},f.prototype.subscribe=function(e,t){return m(e,this._subscribers,t)},f.prototype.subscribeAction=function(e,t){return m("function"==typeof e?{before:e}:e,this._actionSubscribers,t)},f.prototype.watch=function(e,t,n){var i=this;return r("function"==typeof e,"store.watch only accepts a function."),this._watcherVM.$watch((function(){return e(i.state,i.getters)}),t,n)},f.prototype.replaceState=function(e){var t=this;this._withCommit((function(){t._vm._data.$$state=e}))},f.prototype.registerModule=function(e,t,n){void 0===n&&(n={}),"string"==typeof e&&(e=[e]),r(Array.isArray(e),"module path must be a string or an Array."),r(e.length>0,"cannot register the root module by using registerModule."),this._modules.register(e,t),_(this,this.state,e,this._modules.get(e),n.preserveState),g(this,this.state)},f.prototype.unregisterModule=function(e){var t=this;"string"==typeof e&&(e=[e]),r(Array.isArray(e),"module path must be a string or an Array."),this._modules.unregister(e),this._withCommit((function(){var n=b(t.state,e.slice(0,-1));c.delete(n,e[e.length-1])})),v(this)},f.prototype.hasModule=function(e){return"string"==typeof e&&(e=[e]),r(Array.isArray(e),"module path must be a string or an Array."),this._modules.isRegistered(e)},f.prototype.hotUpdate=function(e){this._modules.update(e),v(this,!0)},f.prototype._withCommit=function(e){var t=this._committing;this._committing=!0,e(),this._committing=t},Object.defineProperties(f.prototype,p);var k=A((function(e,t){var n={};return T(t)||console.error("[vuex] mapState: mapper parameter must be either an Array or an Object"),M(t).forEach((function(t){var i=t.key,r=t.val;n[i]=function(){var t=this.$store.state,n=this.$store.getters;if(e){var i=P(this.$store,"mapState",e);if(!i)return;t=i.context.state,n=i.context.getters}return"function"==typeof r?r.call(this,t,n):t[r]},n[i].vuex=!0})),n})),x=A((function(e,t){var n={};return T(t)||console.error("[vuex] mapMutations: mapper parameter must be either an Array or an Object"),M(t).forEach((function(t){var i=t.key,r=t.val;n[i]=function(){for(var t=[],n=arguments.length;n--;)t[n]=arguments[n];var i=this.$store.commit;if(e){var o=P(this.$store,"mapMutations",e);if(!o)return;i=o.context.commit}return"function"==typeof r?r.apply(this,[i].concat(t)):i.apply(this.$store,[r].concat(t))}})),n})),S=A((function(e,t){var n={};return T(t)||console.error("[vuex] mapGetters: mapper parameter must be either an Array or an Object"),M(t).forEach((function(t){var i=t.key,r=t.val;r=e+r,n[i]=function(){if(!e||P(this.$store,"mapGetters",e)){if(r in this.$store.getters)return this.$store.getters[r];console.error("[vuex] unknown getter: "+r)}},n[i].vuex=!0})),n})),C=A((function(e,t){var n={};return T(t)||console.error("[vuex] mapActions: mapper parameter must be either an Array or an Object"),M(t).forEach((function(t){var i=t.key,r=t.val;n[i]=function(){for(var t=[],n=arguments.length;n--;)t[n]=arguments[n];var i=this.$store.dispatch;if(e){var o=P(this.$store,"mapActions",e);if(!o)return;i=o.context.dispatch}return"function"==typeof r?r.apply(this,[i].concat(t)):i.apply(this.$store,[r].concat(t))}})),n}));function M(e){return T(e)?Array.isArray(e)?e.map((function(e){return{key:e,val:e}})):Object.keys(e).map((function(t){return{key:t,val:e[t]}})):[]}function T(e){return Array.isArray(e)||i(e)}function A(e){return function(t,n){return"string"!=typeof t?(n=t,t=""):"/"!==t.charAt(t.length-1)&&(t+="/"),e(t,n)}}function P(e,t,n){var i=e._modulesNamespaceMap[n];return i||console.error("[vuex] module namespace not found in "+t+"(): "+n),i}function L(e,t,n){var i=n?e.groupCollapsed:e.group;try{i.call(e,t)}catch(n){e.log(t)}}function O(e){try{e.groupEnd()}catch(t){e.log("—— log end ——")}}function q(){var e=new Date;return" @ "+E(e.getHours(),2)+":"+E(e.getMinutes(),2)+":"+E(e.getSeconds(),2)+"."+E(e.getMilliseconds(),3)}function E(e,t){return n="0",i=t-e.toString().length,new Array(i+1).join(n)+e;var n,i}return{Store:f,install:w,version:"3.5.1",mapState:k,mapMutations:x,mapGetters:S,mapActions:C,createNamespacedHelpers:function(e){return{mapState:k.bind(null,e),mapGetters:S.bind(null,e),mapMutations:x.bind(null,e),mapActions:C.bind(null,e)}},createLogger:function(e){void 0===e&&(e={});var n=e.collapsed;void 0===n&&(n=!0);var i=e.filter;void 0===i&&(i=function(e,t,n){return!0});var r=e.transformer;void 0===r&&(r=function(e){return e});var o=e.mutationTransformer;void 0===o&&(o=function(e){return e});var a=e.actionFilter;void 0===a&&(a=function(e,t){return!0});var s=e.actionTransformer;void 0===s&&(s=function(e){return e});var l=e.logMutations;void 0===l&&(l=!0);var c=e.logActions;void 0===c&&(c=!0);var u=e.logger;return void 0===u&&(u=console),function(e){var d=t(e.state);void 0!==u&&(l&&e.subscribe((function(e,a){var s=t(a);if(i(e,d,s)){var l=q(),c=o(e),h="mutation "+e.type+l;L(u,h,n),u.log("%c prev state","color: #9E9E9E; font-weight: bold",r(d)),u.log("%c mutation","color: #03A9F4; font-weight: bold",c),u.log("%c next state","color: #4CAF50; font-weight: bold",r(s)),O(u)}d=s})),c&&e.subscribeAction((function(e,t){if(a(e,t)){var i=q(),r=s(e),o="action "+e.type+i;L(u,o,n),u.log("%c action","color: #03A9F4; font-weight: bold",r),O(u)}})))}}}})),function(e){"function"==typeof define&&define.amd?define(e):e()}((function(){"use strict";function e(e){return"function"==typeof e}"undefined"!=typeof window&&function(e){[Element.prototype,CharacterData.prototype,DocumentType.prototype].forEach((function(e){e.hasOwnProperty("remove")||Object.defineProperty(e,"remove",{configurable:!0,enumerable:!0,writable:!0,value:function(){null!==this.parentNode&&this.parentNode.removeChild(this)}})}));try{new MouseEvent("test")}catch(n){var t=function(t,n){n=n||{bubbles:!1,cancelable:!1};var i=document.createEvent("MouseEvent");return i.initMouseEvent(t,n.bubbles,n.cancelable,e,0,n.screenX||0,n.screenY||0,n.clientX||0,n.clientY||0,n.ctrlKey||!1,n.altKey||!1,n.shiftKey||!1,n.metaKey||!1,n.button||0,n.relatedTarget||null),i};t.prototype=Event.prototype,e.MouseEvent=t}"function"!=typeof Object.assign&&Object.defineProperty(Object,"assign",{value:function(e,t){var n=arguments;if(null==e)throw new TypeError("Cannot convert undefined or null to object");for(var i=Object(e),r=1;r<arguments.length;r++){var o=n[r];if(null!=o)for(var a in o)Object.prototype.hasOwnProperty.call(o,a)&&(i[a]=o[a])}return i},writable:!0,configurable:!0}),String.prototype.startsWith||Object.defineProperty(String.prototype,"startsWith",{value:function(e,t){var n=t>0?0|t:0;return this.substring(n,n+e.length)===e}}),String.prototype.endsWith||(String.prototype.endsWith=function(e,t){return(void 0===t||t>this.length)&&(t=this.length),this.substring(t-e.length,t)===e}),Number.isInteger||(Number.isInteger=function(e){return"number"==typeof e&&isFinite(e)&&Math.floor(e)===e}),Array.prototype.includes||(Array.prototype.includes=function(e){return!!~this.indexOf(e)}),Element.prototype.matches||(Element.prototype.matches=Element.prototype.msMatchesSelector||Element.prototype.webkitMatchesSelector),Element.prototype.closest||(Element.prototype.closest=function(e){var t=this;do{if(t.matches(e))return t;t=t.parentElement||t.parentNode}while(null!==t&&1===t.nodeType);return null}),Array.prototype.find||Object.defineProperty(Array.prototype,"find",{value:function(e){if(null==this)throw TypeError('"this" is null or not defined');var t=Object(this),n=t.length>>>0;if("function"!=typeof e)throw TypeError("predicate must be a function");for(var i=arguments[1],r=0;r<n;){var o=t[r];if(e.call(i,o,r,t))return o;r++}},configurable:!0,writable:!0}),Array.prototype.findIndex||Object.defineProperty(Array.prototype,"findIndex",{value:function(e){if(null==this)throw new TypeError("Array.prototype.findIndex called on null or undefined");if("function"!=typeof e)throw new TypeError("predicate must be a function");for(var t=Object(this),n=t.length>>>0,i=arguments[1],r=0;r<n;r++)if(e.call(i,t[r],r,t))return r;return-1}}),"classList"in SVGElement.prototype||Object.defineProperty(SVGElement.prototype,"classList",{get:function(){var e=this;return{contains:function(t){return-1!==e.className.baseVal.split(" ").indexOf(t)},add:function(t){return e.setAttribute("class",e.getAttribute("class")+" "+t)},remove:function(t){var n=e.getAttribute("class").replace(new RegExp("(\\s|^)".concat(t,"(\\s|$)"),"g"),"$2");e.classList.contains(t)&&e.setAttribute("class",n)},toggle:function(e){this.contains(e)?this.remove(e):this.add(e)}}}})}(window);var t=Array.isArray?Array.isArray:function(e){return"[object Array]"===Object.prototype.toString.call(e)},n=0,i=void 0,r=void 0,o=function(e,t){h[n]=e,h[n+1]=t,2===(n+=2)&&(r?r(f):_())},a="undefined"!=typeof window?window:void 0,s=a||{},l=s.MutationObserver||s.WebKitMutationObserver,c="undefined"==typeof self&&"undefined"!=typeof process&&"[object process]"==={}.toString.call(process),u="undefined"!=typeof Uint8ClampedArray&&"undefined"!=typeof importScripts&&"undefined"!=typeof MessageChannel;function d(){var e=setTimeout;return function(){return e(f,1)}}var h=new Array(1e3);function f(){for(var e=0;e<n;e+=2)(0,h[e])(h[e+1]),h[e]=void 0,h[e+1]=void 0;n=0}var p,m,v,g,_=void 0;function b(e,t){var n=this,i=new this.constructor(k);void 0===i[w]&&j(i);var r=n._state;if(r){var a=arguments[r-1];o((function(){return z(r,i,a,n._result)}))}else E(n,i,e,t);return i}function y(e){if(e&&"object"==typeof e&&e.constructor===this)return e;var t=new this(k);return P(t,e),t}c?_=function(){return process.nextTick(f)}:l?(m=0,v=new l(f),g=document.createTextNode(""),v.observe(g,{characterData:!0}),_=function(){g.data=m=++m%2}):u?((p=new MessageChannel).port1.onmessage=f,_=function(){return p.port2.postMessage(0)}):_=void 0===a&&"function"==typeof require?function(){try{var e=Function("return this")().require("vertx");return void 0!==(i=e.runOnLoop||e.runOnContext)?function(){i(f)}:d()}catch(e){return d()}}():d();var w=Math.random().toString(36).substring(2);function k(){}var x=void 0,S=1,C=2,M={error:null};function T(e){try{return e.then}catch(e){return M.error=e,M}}function A(t,n,i){n.constructor===t.constructor&&i===b&&n.constructor.resolve===y?function(e,t){t._state===S?O(e,t._result):t._state===C?q(e,t._result):E(t,void 0,(function(t){return P(e,t)}),(function(t){return q(e,t)}))}(t,n):i===M?(q(t,M.error),M.error=null):void 0===i?O(t,n):e(i)?function(e,t,n){o((function(e){var i=!1,r=function(e,t,n,i){try{e.call(t,n,i)}catch(e){return e}}(n,t,(function(n){i||(i=!0,t!==n?P(e,n):O(e,n))}),(function(t){i||(i=!0,q(e,t))}),e._label);!i&&r&&(i=!0,q(e,r))}),e)}(t,n,i):O(t,n)}function P(e,t){var n,i;e===t?q(e,new TypeError("You cannot resolve a promise with itself")):(i=typeof(n=t),null===n||"object"!==i&&"function"!==i?O(e,t):A(e,t,T(t)))}function L(e){e._onerror&&e._onerror(e._result),D(e)}function O(e,t){e._state===x&&(e._result=t,e._state=S,0!==e._subscribers.length&&o(D,e))}function q(e,t){e._state===x&&(e._state=C,e._result=t,o(L,e))}function E(e,t,n,i){var r=e._subscribers,a=r.length;e._onerror=null,r[a]=t,r[a+S]=n,r[a+C]=i,0===a&&e._state&&o(D,e)}function D(e){var t=e._subscribers,n=e._state;if(0!==t.length){for(var i=void 0,r=void 0,o=e._result,a=0;a<t.length;a+=3)i=t[a],r=t[a+n],i?z(n,i,r,o):r(o);e._subscribers.length=0}}function z(t,n,i,r){var o=e(i),a=void 0,s=void 0,l=void 0,c=void 0;if(o){if((a=function(e,t){try{return e(t)}catch(e){return M.error=e,M}}(i,r))===M?(c=!0,s=a.error,a.error=null):l=!0,n===a)return void q(n,new TypeError("A promises callback cannot return that same promise."))}else a=r,l=!0;n._state!==x||(o&&l?P(n,a):c?q(n,s):t===S?O(n,a):t===C&&q(n,a))}var N=0;function j(e){e[w]=id++,e._state=void 0,e._result=void 0,e._subscribers=[]}var R=function(){function e(e,n){this._instanceConstructor=e,this.promise=new e(k),this.promise[w]||j(this.promise),t(n)?(this.length=n.length,this._remaining=n.length,this._result=new Array(this.length),0===this.length?O(this.promise,this._result):(this.length=this.length||0,this._enumerate(n),0===this._remaining&&O(this.promise,this._result))):q(this.promise,new Error("Array Methods must be provided an Array"))}return e.prototype._enumerate=function(e){for(var t=0;this._state===x&&t<e.length;t++)this._eachEntry(e[t],t)},e.prototype._eachEntry=function(e,t){var n=this._instanceConstructor,i=n.resolve;if(i===y){var r=T(e);if(r===b&&e._state!==x)this._settledAt(e._state,t,e._result);else if("function"!=typeof r)this._remaining--,this._result[t]=e;else if(n===I){var o=new n(k);A(o,e,r),this._willSettleAt(o,t)}else this._willSettleAt(new n((function(t){return t(e)})),t)}else this._willSettleAt(i(e),t)},e.prototype._settledAt=function(e,t,n){var i=this.promise;i._state===x&&(this._remaining--,e===C?q(i,n):this._result[t]=n),0===this._remaining&&O(i,this._result)},e.prototype._willSettleAt=function(e,t){var n=this;E(e,void 0,(function(e){return n._settledAt(S,t,e)}),(function(e){return n._settledAt(C,t,e)}))},e}(),I=function(){function e(t){this[w]=N++,this._result=this._state=void 0,this._subscribers=[],k!==t&&("function"!=typeof t&&function(){throw new TypeError("You must pass a resolver function as the first argument to the promise constructor")}(),this instanceof e?function(e,t){try{t((function(t){P(e,t)}),(function(t){q(e,t)}))}catch(t){q(e,t)}}(this,t):function(){throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.")}())}return e.prototype.catch=function(e){return this.then(null,e)},e.prototype.finally=function(e){var t=this.constructor;return this.then((function(n){return t.resolve(e()).then((function(){return n}))}),(function(n){return t.resolve(e()).then((function(){throw n}))}))},e}();I.prototype.then=b,I.all=function(e){return new R(this,e).promise},I.race=function(e){var n=this;return t(e)?new n((function(t,i){for(var r=e.length,o=0;o<r;o++)n.resolve(e[o]).then(t,i)})):new n((function(e,t){return t(new TypeError("You must pass an array to race."))}))},I.resolve=y,I.reject=function(e){var t=new this(k);return q(t,e),t},I._setScheduler=function(e){r=e},I._setAsap=function(e){o=e},I._asap=o,function(){var e=void 0;if("undefined"!=typeof global)e=global;else if("undefined"!=typeof self)e=self;else try{e=Function("return this")()}catch(e){throw new Error("polyfill failed because global object is unavailable in this environment")}var t=e.Promise;if(t){var n=null;try{n=Object.prototype.toString.call(t.resolve())}catch(e){}if("[object Promise]"===n&&!t.cast)return}e.Promise=I}()})),
/*!
 * Quasar Framework v1.13.2
 * (c) 2015-present Razvan Stoenescu
 * Released under the MIT License.
 */
function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t(require("vue")):"function"==typeof define&&define.amd?define(["vue"],t):(e=e||self).Quasar=t(e.Vue)}(this,(function(e){"use strict";e=e&&Object.prototype.hasOwnProperty.call(e,"default")?e.default:e;var t,n="1.13.2",i="undefined"==typeof window,r=!1,o=i,a=!1;var s=!1===i&&("ontouchstart"in window||window.navigator.maxTouchPoints>0);function l(e){var n=e.toLowerCase(),a=function(e){return/(ipad)/.exec(e)||/(ipod)/.exec(e)||/(windows phone)/.exec(e)||/(iphone)/.exec(e)||/(kindle)/.exec(e)||/(silk)/.exec(e)||/(android)/.exec(e)||/(win)/.exec(e)||/(mac)/.exec(e)||/(linux)/.exec(e)||/(cros)/.exec(e)||/(playbook)/.exec(e)||/(bb)/.exec(e)||/(blackberry)/.exec(e)||[]}(n),l=function(e,t){var n=/(edge|edga|edgios)\/([\w.]+)/.exec(e)||/(opr)[\/]([\w.]+)/.exec(e)||/(vivaldi)[\/]([\w.]+)/.exec(e)||/(chrome|crios)[\/]([\w.]+)/.exec(e)||/(iemobile)[\/]([\w.]+)/.exec(e)||/(version)(applewebkit)[\/]([\w.]+).*(safari)[\/]([\w.]+)/.exec(e)||/(webkit)[\/]([\w.]+).*(version)[\/]([\w.]+).*(safari)[\/]([\w.]+)/.exec(e)||/(firefox|fxios)[\/]([\w.]+)/.exec(e)||/(webkit)[\/]([\w.]+)/.exec(e)||/(opera)(?:.*version|)[\/]([\w.]+)/.exec(e)||/(msie) ([\w.]+)/.exec(e)||e.indexOf("trident")>=0&&/(rv)(?::| )([\w.]+)/.exec(e)||e.indexOf("compatible")<0&&/(mozilla)(?:.*? rv:([\w.]+)|)/.exec(e)||[];return{browser:n[5]||n[3]||n[1]||"",version:n[2]||n[4]||"0",versionNumber:n[4]||n[2]||"0",platform:t[0]||""}}(n,a),c={};l.browser&&(c[l.browser]=!0,c.version=l.version,c.versionNumber=parseInt(l.versionNumber,10)),l.platform&&(c[l.platform]=!0);var u=c.android||c.ios||c.bb||c.blackberry||c.ipad||c.iphone||c.ipod||c.kindle||c.playbook||c.silk||c["windows phone"];return!0===u||n.indexOf("mobile")>-1?(c.mobile=!0,c.edga||c.edgios?(c.edge=!0,l.browser="edge"):c.crios?(c.chrome=!0,l.browser="chrome"):c.fxios&&(c.firefox=!0,l.browser="firefox")):c.desktop=!0,(c.ipod||c.ipad||c.iphone)&&(c.ios=!0),c["windows phone"]&&(c.winphone=!0,delete c["windows phone"]),(c.chrome||c.opr||c.safari||c.vivaldi||!0===c.mobile&&!0!==c.ios&&!0!==u)&&(c.webkit=!0),(c.rv||c.iemobile)&&(l.browser="ie",c.ie=!0),(c.safari&&c.blackberry||c.bb)&&(l.browser="blackberry",c.blackberry=!0),c.safari&&c.playbook&&(l.browser="playbook",c.playbook=!0),c.opr&&(l.browser="opera",c.opera=!0),c.safari&&c.android&&(l.browser="android",c.android=!0),c.safari&&c.kindle&&(l.browser="kindle",c.kindle=!0),c.safari&&c.silk&&(l.browser="silk",c.silk=!0),c.vivaldi&&(l.browser="vivaldi",c.vivaldi=!0),c.name=l.browser,c.platform=l.platform,!1===i&&(n.indexOf("electron")>-1?c.electron=!0:document.location.href.indexOf("-extension://")>-1?c.bex=!0:(void 0!==window.Capacitor?(c.capacitor=!0,c.nativeMobile=!0,c.nativeMobileWrapper="capacitor"):void 0===window._cordovaNative&&void 0===window.cordova||(c.cordova=!0,c.nativeMobile=!0,c.nativeMobileWrapper="cordova"),!0===s&&!0===c.mac&&(!0===c.desktop&&!0===c.safari||!0===c.nativeMobile&&!0!==c.android&&!0!==c.ios&&!0!==c.ipad)&&function(e){var n;t={is:Object.assign({},e)},delete e.mac,delete e.desktop;var i=Math.min(window.innerHeight,window.innerWidth)>414?"ipad":"iphone";Object.assign(e,((n={mobile:!0,ios:!0,platform:i})[i]=!0,n))}(c)),!0===(r=void 0===c.nativeMobile&&void 0===c.electron&&null!==document.querySelector("[data-server-rendered]"))&&(o=!0)),c}var c=!0!==i?navigator.userAgent||navigator.vendor||window.opera:"",u={has:{touch:!1,webStorage:!1},within:{iframe:!1}},d=!1===i?{userAgent:c,is:l(c),has:{touch:s,webStorage:function(){try{if(window.localStorage)return!0}catch(e){}return!1}()},within:{iframe:window.self!==window.top}}:u,h={install:function(n,a){var s=this;!0===i?a.server.push((function(e,t){e.platform=s.parseSSR(t.ssr)})):!0===r?(Object.assign(this,d,t,u),a.takeover.push((function(e){o=r=!1,Object.assign(e.platform,d),t=void 0})),e.util.defineReactive(n,"platform",this)):(Object.assign(this,d),n.platform=this)}};!0===i?h.parseSSR=function(e){var t=e.req.headers["user-agent"]||e.req.headers["User-Agent"]||"";return Object.assign({},d,{userAgent:t,is:l(t)})}:a=!0===d.is.ios&&-1===window.navigator.vendor.toLowerCase().indexOf("apple");var f={hasPassive:!1,passiveCapture:!0,notPassiveCapture:!0};try{var p=Object.defineProperty({},"passive",{get:function(){Object.assign(f,{hasPassive:!0,passive:{passive:!0},notPassive:{passive:!1},passiveCapture:{passive:!0,capture:!0},notPassiveCapture:{passive:!1,capture:!0}})}});window.addEventListener("qtest",null,p),window.removeEventListener("qtest",null,p)}catch(e){}function m(){}function v(e){return 0===e.button}function g(e){return e.touches&&e.touches[0]?e=e.touches[0]:e.changedTouches&&e.changedTouches[0]?e=e.changedTouches[0]:e.targetTouches&&e.targetTouches[0]&&(e=e.targetTouches[0]),{top:e.clientY,left:e.clientX}}function _(e){if(e.path)return e.path;if(e.composedPath)return e.composedPath();for(var t=[],n=e.target;n;){if(t.push(n),"HTML"===n.tagName)return t.push(document),t.push(window),t;n=n.parentElement}}function b(e){e.stopPropagation()}function y(e){!1!==e.cancelable&&e.preventDefault()}function w(e){!1!==e.cancelable&&e.preventDefault(),e.stopPropagation()}function k(e,t){if(void 0!==e&&(!0!==t||!0!==e.__dragPrevented)){var n=!0===t?function(e){e.__dragPrevented=!0,e.addEventListener("dragstart",y,f.notPassiveCapture)}:function(e){delete e.__dragPrevented,e.removeEventListener("dragstart",y,f.notPassiveCapture)};e.querySelectorAll("a, img").forEach(n)}}function x(e,t){void 0===t&&(t={});var n=t.bubbles;void 0===n&&(n=!1);var i=t.cancelable;void 0===i&&(i=!1);try{return new Event(e,{bubbles:n,cancelable:i})}catch(t){var r=document.createEvent("Event");return r.initEvent(e,n,i),r}}function S(e,t,n){var i="__q_"+t+"_evt";e[i]=void 0!==e[i]?e[i].concat(n):n,n.forEach((function(t){t[0].addEventListener(t[1],e[t[2]],f[t[3]])}))}function C(e,t){var n="__q_"+t+"_evt";void 0!==e[n]&&(e[n].forEach((function(t){t[0].removeEventListener(t[1],e[t[2]],f[t[3]])})),e[n]=void 0)}var M={listenOpts:f,leftClick:v,middleClick:function(e){return 1===e.button},rightClick:function(e){return 2===e.button},position:g,getEventPath:_,getMouseWheelDistance:function(e){var t,n=e.deltaX,i=e.deltaY;if((n||i)&&e.deltaMode){var r=1===e.deltaMode?40:800;n*=r,i*=r}return e.shiftKey&&!n&&(i=(t=[n,i])[0],n=t[1]),{x:n,y:i}},stop:b,prevent:y,stopAndPrevent:w,preventDraggable:k,create:x};function T(e,t,n){var i;function r(){var r=this,o=arguments;clearTimeout(i),!0===n&&void 0===i&&e.apply(this,o),i=setTimeout((function(){i=void 0,!0!==n&&e.apply(r,o)}),t)}return void 0===t&&(t=250),r.cancel=function(){clearTimeout(i)},r}var A=["sm","md","lg","xl"],P=f.passive,L={width:0,height:0,name:"xs",sizes:{sm:600,md:1024,lg:1440,xl:1920},lt:{sm:!0,md:!0,lg:!0,xl:!0},gt:{xs:!1,sm:!1,md:!1,lg:!1},xs:!0,sm:!1,md:!1,lg:!1,xl:!1,setSizes:m,setDebounce:m,install:function(t,n,o){var a=this;if(!0!==i){var s,l=void 0!==o.screen&&!0===o.screen.bodyClasses,c=function(e){var t=window.innerWidth,n=window.innerHeight;if(n!==a.height&&(a.height=n),t!==a.width)a.width=t;else if(!0!==e)return;var i=a.sizes;a.gt.xs=t>=i.sm,a.gt.sm=t>=i.md,a.gt.md=t>=i.lg,a.gt.lg=t>=i.xl,a.lt.sm=t<i.sm,a.lt.md=t<i.md,a.lt.lg=t<i.lg,a.lt.xl=t<i.xl,a.xs=a.lt.sm,a.sm=!0===a.gt.xs&&!0===a.lt.md,a.md=!0===a.gt.sm&&!0===a.lt.lg,a.lg=!0===a.gt.md&&!0===a.lt.xl,a.xl=a.gt.lg,(i=(!0===a.xs?"xs":!0===a.sm&&"sm")||!0===a.md&&"md"||!0===a.lg&&"lg"||"xl")!==a.name&&(!0===l&&(document.body.classList.remove("screen--"+a.name),document.body.classList.add("screen--"+i)),a.name=i)},u={},d=16;this.setSizes=function(e){A.forEach((function(t){void 0!==e[t]&&(u[t]=e[t])}))},this.setDebounce=function(e){d=e};var h=function(){var e=getComputedStyle(document.body),t=void 0!==window.visualViewport?window.visualViewport:window;e.getPropertyValue("--q-size-sm")&&A.forEach((function(t){a.sizes[t]=parseInt(e.getPropertyValue("--q-size-"+t),10)})),a.setSizes=function(e){A.forEach((function(t){e[t]&&(a.sizes[t]=e[t])})),c(!0)},a.setDebounce=function(e){void 0!==s&&t.removeEventListener("resize",s,P),s=e>0?T(c,e):c,t.addEventListener("resize",s,P)},a.setDebounce(d),Object.keys(u).length>0?(a.setSizes(u),u=void 0):c(),!0===l&&"xs"===a.name&&document.body.classList.add("screen--xs")};!0===r?n.takeover.push(h):h(),e.util.defineReactive(t,"screen",this)}else t.screen=this}},O={isActive:!1,mode:!1,install:function(t,n,o){var a=this,s=o.dark;if(this.isActive=!0===s,!0===i)return n.server.push((function(e,t){e.dark={isActive:!1,mode:!1,set:function(n){t.ssr.Q_BODY_CLASSES=t.ssr.Q_BODY_CLASSES.replace(" body--light","").replace(" body--dark","")+" body--"+(!0===n?"dark":"light"),e.dark.isActive=!0===n,e.dark.mode=n},toggle:function(){e.dark.set(!1===e.dark.isActive)}},e.dark.set(s)})),void(this.set=m);var l=void 0!==s&&s;if(!0===r){var c=function(e){a.__fromSSR=e},u=this.set;this.set=c,c(l),n.takeover.push((function(){a.set=u,a.set(a.__fromSSR)}))}else this.set(l);e.util.defineReactive(this,"isActive",this.isActive),e.util.defineReactive(t,"dark",this)},set:function(e){var t=this;this.mode=e,"auto"===e?(void 0===this.__media&&(this.__media=window.matchMedia("(prefers-color-scheme: dark)"),this.__updateMedia=function(){t.set("auto")},this.__media.addListener(this.__updateMedia)),e=this.__media.matches):void 0!==this.__media&&(this.__media.removeListener(this.__updateMedia),this.__media=void 0),this.isActive=!0===e,document.body.classList.remove("body--"+(!0===e?"light":"dark")),document.body.classList.add("body--"+(!0===e?"dark":"light"))},toggle:function(){O.set(!1===O.isActive)},__media:void 0},q=function(){return!0};function E(e){return"string"==typeof e&&""!==e&&"/"!==e&&"#/"!==e}function D(e){return!0===e.startsWith("#")&&(e=e.substr(1)),!1===e.startsWith("/")&&(e="/"+e),!0===e.endsWith("/")&&(e=e.substr(0,e.length-1)),"#"+e}var z={__history:[],add:m,remove:m,install:function(e){var t=this;if(!0!==i){var n=d.is,r=n.cordova,o=n.capacitor;if(!0===r||!0===o){this.add=function(e){void 0===e.condition&&(e.condition=q),t.__history.push(e)},this.remove=function(e){var n=t.__history.indexOf(e);n>=0&&t.__history.splice(n,1)};var a=function(e){if(!1===e.backButtonExit)return function(){return!1};if("*"===e.backButtonExit)return q;var t=["#/"];return!0===Array.isArray(e.backButtonExit)&&t.push.apply(t,e.backButtonExit.filter(E).map(D)),function(){return t.includes(window.location.hash)}}(Object.assign({backButtonExit:!0},e[!0===r?"cordova":"capacitor"])),s=function(){if(t.__history.length){var e=t.__history[t.__history.length-1];!0===e.condition()&&(t.__history.pop(),e.handler())}else!0===a()?navigator.app.exitApp():window.history.back()};!0===r?document.addEventListener("deviceready",(function(){document.addEventListener("backbutton",s,!1)})):window.Capacitor.Plugins.App.addListener("backButton",s)}}}},N={isoName:"en-us",nativeName:"English (US)",label:{clear:"Clear",ok:"OK",cancel:"Cancel",close:"Close",set:"Set",select:"Select",reset:"Reset",remove:"Remove",update:"Update",create:"Create",search:"Search",filter:"Filter",refresh:"Refresh"},date:{days:"Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),daysShort:"Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),months:"January_February_March_April_May_June_July_August_September_October_November_December".split("_"),monthsShort:"Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"),firstDayOfWeek:0,format24h:!1,pluralDay:"days"},table:{noData:"No data available",noResults:"No matching records found",loading:"Loading...",selectedRecords:function(e){return 1===e?"1 record selected.":(0===e?"No":e)+" records selected."},recordsPerPage:"Records per page:",allRows:"All",pagination:function(e,t,n){return e+"-"+t+" of "+n},columns:"Columns"},editor:{url:"URL",bold:"Bold",italic:"Italic",strikethrough:"Strikethrough",underline:"Underline",unorderedList:"Unordered List",orderedList:"Ordered List",subscript:"Subscript",superscript:"Superscript",hyperlink:"Hyperlink",toggleFullscreen:"Toggle Fullscreen",quote:"Quote",left:"Left align",center:"Center align",right:"Right align",justify:"Justify align",print:"Print",outdent:"Decrease indentation",indent:"Increase indentation",removeFormat:"Remove formatting",formatting:"Formatting",fontSize:"Font Size",align:"Align",hr:"Insert Horizontal Rule",undo:"Undo",redo:"Redo",heading1:"Heading 1",heading2:"Heading 2",heading3:"Heading 3",heading4:"Heading 4",heading5:"Heading 5",heading6:"Heading 6",paragraph:"Paragraph",code:"Code",size1:"Very small",size2:"A bit small",size3:"Normal",size4:"Medium-large",size5:"Big",size6:"Very big",size7:"Maximum",defaultFont:"Default Font",viewSource:"View Source"},tree:{noNodes:"No nodes available",noResults:"No matching nodes found"}};function j(){if(!0!==i){var e=navigator.language||navigator.languages[0]||navigator.browserLanguage||navigator.userLanguage||navigator.systemLanguage;return e?e.toLowerCase():void 0}}var R={getLocale:j,install:function(t,n,o){var a=this,s=o||N;this.set=function(e,n){void 0===e&&(e=N);var o=Object.assign({},e,{rtl:!0===e.rtl,getLocale:j});if(!0===i){if(void 0===n)return void console.error("SSR ERROR: second param required: Quasar.lang.set(lang, ssrContext)");var s=!0===o.rtl?"rtl":"ltr",l="lang="+o.isoName+" dir="+s;o.set=n.$q.lang.set,n.Q_HTML_ATTRS=void 0!==n.Q_PREV_LANG?n.Q_HTML_ATTRS.replace(n.Q_PREV_LANG,l):l,n.Q_PREV_LANG=l,n.$q.lang=o}else{if(!1===r){var c=document.documentElement;c.setAttribute("dir",!0===o.rtl?"rtl":"ltr"),c.setAttribute("lang",o.isoName)}o.set=a.set,t.lang=a.props=o,a.isoName=o.isoName,a.nativeName=o.nativeName}},!0===i?(n.server.push((function(e,t){e.lang={},e.lang.set=function(e){a.set(e,t.ssr)},e.lang.set(s)})),this.isoName=s.isoName,this.nativeName=s.nativeName,this.props=s):(e.util.defineReactive(t,"lang",{}),this.set(s))}},I=/^rgb(a)?\((\d{1,3}),(\d{1,3}),(\d{1,3}),?([01]?\.?\d*?)?\)$/;function $(e){var t=e.r,n=e.g,i=e.b,r=e.a,o=void 0!==r;if(t=Math.round(t),n=Math.round(n),i=Math.round(i),t>255||n>255||i>255||o&&r>100)throw new TypeError("Expected 3 numbers below 256 (and optionally one below 100)");return r=o?(256|Math.round(255*r/100)).toString(16).slice(1):"","#"+(i|n<<8|t<<16|1<<24).toString(16).slice(1)+r}function F(e){var t=e.r,n=e.g,i=e.b,r=e.a;return"rgb"+(void 0!==r?"a":"")+"("+t+","+n+","+i+(void 0!==r?","+r/100:"")+")"}function B(e){if("string"!=typeof e)throw new TypeError("Expected a string");3===(e=e.replace(/^#/,"")).length?e=e[0]+e[0]+e[1]+e[1]+e[2]+e[2]:4===e.length&&(e=e[0]+e[0]+e[1]+e[1]+e[2]+e[2]+e[3]+e[3]);var t=parseInt(e,16);return e.length>6?{r:t>>24&255,g:t>>16&255,b:t>>8&255,a:Math.round((255&t)/2.55)}:{r:t>>16,g:t>>8&255,b:255&t}}function V(e){var t,n,i,r=e.h,o=e.s,a=e.v,s=e.a;o/=100,a/=100,r/=360;var l=Math.floor(6*r),c=6*r-l,u=a*(1-o),d=a*(1-c*o),h=a*(1-(1-c)*o);switch(l%6){case 0:t=a,n=h,i=u;break;case 1:t=d,n=a,i=u;break;case 2:t=u,n=a,i=h;break;case 3:t=u,n=d,i=a;break;case 4:t=h,n=u,i=a;break;case 5:t=a,n=u,i=d}return{r:Math.round(255*t),g:Math.round(255*n),b:Math.round(255*i),a:s}}function H(e){var t,n=e.r,i=e.g,r=e.b,o=e.a,a=Math.max(n,i,r),s=Math.min(n,i,r),l=a-s,c=0===a?0:l/a,u=a/255;switch(a){case s:t=0;break;case n:t=i-r+l*(i<r?6:0),t/=6*l;break;case i:t=r-n+2*l,t/=6*l;break;case r:t=n-i+4*l,t/=6*l}return{h:Math.round(360*t),s:Math.round(100*c),v:Math.round(100*u),a:o}}function W(e){if("string"!=typeof e)throw new TypeError("Expected a string");var t=e.replace(/ /g,""),n=I.exec(t);if(null===n)return B(t);var i={r:Math.min(255,parseInt(n[2],10)),g:Math.min(255,parseInt(n[3],10)),b:Math.min(255,parseInt(n[4],10))};if(n[1]){var r=parseFloat(n[5]);i.a=100*Math.min(1,!0===isNaN(r)?1:r)}return i}function U(e){if("string"!=typeof e&&(!e||void 0===e.r))throw new TypeError("Expected a string or a {r, g, b} object as color");var t="string"==typeof e?W(e):e,n=t.r/255,i=t.g/255,r=t.b/255;return.2126*(n<=.03928?n/12.92:Math.pow((n+.055)/1.055,2.4))+.7152*(i<=.03928?i/12.92:Math.pow((i+.055)/1.055,2.4))+.0722*(r<=.03928?r/12.92:Math.pow((r+.055)/1.055,2.4))}function Y(e,t,n){if(void 0===n&&(n=document.body),"string"!=typeof e)throw new TypeError("Expected a string as color");if("string"!=typeof t)throw new TypeError("Expected a string as value");if(!(n instanceof Element))throw new TypeError("Expected a DOM element");n.style.setProperty("--q-color-"+e,t)}function G(e,t){if(void 0===t&&(t=document.body),"string"!=typeof e)throw new TypeError("Expected a string as color");if(!(t instanceof Element))throw new TypeError("Expected a DOM element");return getComputedStyle(t).getPropertyValue("--q-color-"+e).trim()||null}var Q={rgbToHex:$,hexToRgb:B,hsvToRgb:V,rgbToHsv:H,textToRgb:W,lighten:function(e,t){if("string"!=typeof e)throw new TypeError("Expected a string as color");if("number"!=typeof t)throw new TypeError("Expected a numeric percent");var n=W(e),i=t<0?0:255,r=Math.abs(t)/100,o=n.r,a=n.g,s=n.b;return"#"+(16777216+65536*(Math.round((i-o)*r)+o)+256*(Math.round((i-a)*r)+a)+(Math.round((i-s)*r)+s)).toString(16).slice(1)},luminosity:U,brightness:function(e){if("string"!=typeof e&&(!e||void 0===e.r))throw new TypeError("Expected a string or a {r, g, b} object as color");var t="string"==typeof e?W(e):e;return(299*t.r+587*t.g+114*t.b)/1e3},blend:function(e,t){if("string"!=typeof e&&(!e||void 0===e.r))throw new TypeError("Expected a string or a {r, g, b[, a]} object as fgColor");if("string"!=typeof t&&(!t||void 0===t.r))throw new TypeError("Expected a string or a {r, g, b[, a]} object as bgColor");var n="string"==typeof e?W(e):e,i=n.r/255,r=n.g/255,o=n.b/255,a=void 0!==n.a?n.a/100:1,s="string"==typeof t?W(t):t,l=s.r/255,c=s.g/255,u=s.b/255,d=void 0!==s.a?s.a/100:1,h=a+d*(1-a),f={r:Math.round((i*a+l*d*(1-a))/h*255),g:Math.round((r*a+c*d*(1-a))/h*255),b:Math.round((o*a+u*d*(1-a))/h*255),a:Math.round(100*h)};return"string"==typeof e?$(f):f},changeAlpha:function(e,t){if("string"!=typeof e)throw new TypeError("Expected a string as color");if(void 0===t||t<-1||t>1)throw new TypeError("Expected offset to be between -1 and 1");var n=W(e),i=n.r,r=n.g,o=n.b,a=n.a,s=void 0!==a?a/100:0;return $({r:i,g:r,b:o,a:Math.round(100*Math.min(1,Math.max(0,s+t)))})},setBrand:Y,getBrand:G,getPaletteColor:function(e){if("string"!=typeof e)throw new TypeError("Expected a string as color");var t=document.createElement("div");t.className="text-"+e+" invisible fixed no-pointer-events",document.body.appendChild(t);var n=getComputedStyle(t).getPropertyValue("color");return t.remove(),$(W(n))}},K=!1;function Z(e){K=!0===e.isComposing}function J(e){return!0===K||e!==Object(e)||!0===e.isComposing||!0===e.qKeyEvent}function X(e,t){return!0!==J(e)&&[].concat(t).includes(e.keyCode)}function ee(e,t){var n=e.is,i=e.has,r=e.within,o=[!0===n.desktop?"desktop":"mobile",(!1===i.touch?"no-":"")+"touch"];if(!0===n.mobile){var a=function(e){return!0===e.ios?"ios":!0===e.android?"android":void 0}(n);void 0!==a&&o.push("platform-"+a)}if(!0===n.nativeMobile){var s=n.nativeMobileWrapper;o.push(s),o.push("native-mobile"),!0!==n.ios||void 0!==t[s]&&!1===t[s].iosStatusBarPadding||o.push("q-ios-padding")}else!0===n.electron?o.push("electron"):!0===n.bex&&o.push("bex");return!0===r.iframe&&o.push("within-iframe"),o}var te=function(e,n){if(!0!==i){if(!0===r)a=document.body.className,s=a,void 0!==t&&(s=s.replace("desktop","platform-ios mobile")),!0===d.has.touch&&(s=s.replace("no-touch","touch")),!0===d.within.iframe&&(s+=" within-iframe"),a!==s&&(document.body.className=s);else{var o=ee(d,n);!0===d.is.ie&&11===d.is.versionNumber?o.forEach((function(e){return document.body.classList.add(e)})):document.body.classList.add.apply(document.body.classList,o)}var a,s;void 0!==n.brand&&function(e){for(var t in e)Y(t,e[t])}(n.brand),!0===d.is.ios&&document.body.addEventListener("touchstart",m),window.addEventListener("keydown",Z,!0)}else e.server.push((function(e,t){var i=ee(e.platform,n),r=t.ssr.setBodyClasses;void 0!==n.screen&&!0===n.screen.bodyClass&&i.push("screen--xs"),"function"==typeof r?r(i):t.ssr.Q_BODY_CLASSES=i.join(" ")}))},ne={name:"material-icons",type:{positive:"check_circle",negative:"warning",info:"info",warning:"priority_high"},arrow:{up:"arrow_upward",right:"arrow_forward",down:"arrow_downward",left:"arrow_back",dropdown:"arrow_drop_down"},chevron:{left:"chevron_left",right:"chevron_right"},colorPicker:{spectrum:"gradient",tune:"tune",palette:"style"},pullToRefresh:{icon:"refresh"},carousel:{left:"chevron_left",right:"chevron_right",up:"keyboard_arrow_up",down:"keyboard_arrow_down",navigationIcon:"lens"},chip:{remove:"cancel",selected:"check"},datetime:{arrowLeft:"chevron_left",arrowRight:"chevron_right",now:"access_time",today:"today"},editor:{bold:"format_bold",italic:"format_italic",strikethrough:"strikethrough_s",underline:"format_underlined",unorderedList:"format_list_bulleted",orderedList:"format_list_numbered",subscript:"vertical_align_bottom",superscript:"vertical_align_top",hyperlink:"link",toggleFullscreen:"fullscreen",quote:"format_quote",left:"format_align_left",center:"format_align_center",right:"format_align_right",justify:"format_align_justify",print:"print",outdent:"format_indent_decrease",indent:"format_indent_increase",removeFormat:"format_clear",formatting:"text_format",fontSize:"format_size",align:"format_align_left",hr:"remove",undo:"undo",redo:"redo",heading:"format_size",code:"code",size:"format_size",font:"font_download",viewSource:"code"},expansionItem:{icon:"keyboard_arrow_down",denseIcon:"arrow_drop_down"},fab:{icon:"add",activeIcon:"close"},field:{clear:"cancel",error:"error"},pagination:{first:"first_page",prev:"keyboard_arrow_left",next:"keyboard_arrow_right",last:"last_page"},rating:{icon:"grade"},stepper:{done:"check",active:"edit",error:"warning"},tabs:{left:"chevron_left",right:"chevron_right",up:"keyboard_arrow_up",down:"keyboard_arrow_down"},table:{arrowUp:"arrow_upward",warning:"warning",firstPage:"first_page",prevPage:"chevron_left",nextPage:"chevron_right",lastPage:"last_page"},tree:{icon:"play_arrow"},uploader:{done:"done",clear:"clear",add:"add_box",upload:"cloud_upload",removeQueue:"clear_all",removeUploaded:"done_all"}},ie={install:function(t,n,r){var o=this,a=r||ne;this.set=function(e,n){var r=Object.assign({},e);if(!0===i){if(void 0===n)return void console.error("SSR ERROR: second param required: Quasar.iconSet.set(iconSet, ssrContext)");r.set=n.$q.iconSet.set,n.$q.iconSet=r}else r.set=o.set,t.iconSet=r},!0===i?n.server.push((function(e,t){e.iconSet={},e.iconSet.set=function(e){o.set(e,t.ssr)},e.iconSet.set(a)})):(e.util.defineReactive(t,"iconMapFn",void 0),e.util.defineReactive(t,"iconSet",{}),this.set(a))}},re=[h,L,O],oe={server:[],takeover:[]},ae={version:n,config:{}};var se=["B","KB","MB","GB","TB","PB"];function le(e){for(var t=0;parseInt(e,10)>=1024&&t<se.length-1;)e/=1024,++t;return""+e.toFixed(1)+se[t]}function ce(e){return e.charAt(0).toUpperCase()+e.slice(1)}function ue(e,t,n){return n<=t?t:Math.min(n,Math.max(t,e))}function de(e,t,n){if(n<=t)return t;var i=n-t+1,r=t+(e-t)%i;return r<t&&(r=i+r),0===r?0:r}function he(e,t,n){if(void 0===t&&(t=2),void 0===n&&(n="0"),null==e)return e;var i=""+e;return i.length>=t?i:new Array(t-i.length+1).join(n)+i}var fe={humanStorageSize:le,capitalize:ce,between:ue,normalizeToInterval:de,pad:he};function pe(e,t,n){if(!0===i)return n;var r="__qcache_"+t;return void 0===e[r]?e[r]=n:e[r]}function me(e,t,n){if(!0===i)return n();var r="__qcache_"+t;return void 0===e[r]?e[r]=n():e[r]}function ve(e,t){var n;return{data:function(){var n,i={},r=this[e];for(var o in r)i[o]=r[o];return(n={})[t]=i,n},watch:(n={},n[e]=function(e,n){var i=this[t];if(void 0!==n)for(var r in n)void 0===e[r]&&this.$delete(i,r);for(var o in e)i[o]!==e[o]&&this.$set(i,o,e[o])},n)}}var ge={"aria-hidden":"true"},_e=ve("$attrs","qAttrs"),be=i?null:XMLHttpRequest,ye=i?null:be.prototype.send,we=[],ke=[],xe=0;var Se=e.extend({name:"QAjaxBar",props:{position:{type:String,default:"top",validator:function(e){return["top","right","bottom","left"].includes(e)}},size:{type:String,default:"2px"},color:String,skipHijack:Boolean,reverse:Boolean},data:function(){return{calls:0,progress:0,onScreen:!1,animate:!0}},computed:{classes:function(){return"q-loading-bar q-loading-bar--"+this.position+(void 0!==this.color?" bg-"+this.color:"")+(!0===this.animate?"":" no-transition")},style:function(){var e=this.onScreen,t=function(e){var t=e.p,n=e.pos,i=e.active,r=e.horiz,o=e.reverse,a=e.dir,s=1,l=1;return r?(o&&(s=-1),"bottom"===n&&(l=-1),{transform:"translate3d("+s*(t-100)+"%,"+(i?0:-200*l)+"%,0)"}):(o&&(l=-1),"right"===n&&(s=-1),{transform:"translate3d("+(i?0:a*s*-200)+"%,"+l*(t-100)+"%,0)"})}({p:this.progress,pos:this.position,active:e,horiz:this.horizontal,reverse:!0===this.$q.lang.rtl&&["top","bottom"].includes(this.position)?!this.reverse:this.reverse,dir:!0===this.$q.lang.rtl?-1:1});return t[this.sizeProp]=this.size,t.opacity=e?1:0,t},horizontal:function(){return"top"===this.position||"bottom"===this.position},sizeProp:function(){return this.horizontal?"height":"width"},attrs:function(){return!0===this.onScreen?{role:"progressbar","aria-valuemin":0,"aria-valuemax":100,"aria-valuenow":this.progress}:ge}},methods:{start:function(e){var t=this;void 0===e&&(e=300);var n=this.speed;this.speed=Math.max(0,e)||0,this.calls++,this.calls>1?0===n&&e>0?this.__work():n>0&&e<=0&&clearTimeout(this.timer):(clearTimeout(this.timer),this.$emit("start"),this.progress=0,!0!==this.onScreen&&(this.onScreen=!0,this.animate=!1,this.timer=setTimeout((function(){t.animate=!0,e>0&&t.__work()}),100)))},increment:function(e){this.calls>0&&(this.progress=function(e,t){return"number"!=typeof t&&(t=e<25?3*Math.random()+3:e<65?3*Math.random():e<85?2*Math.random():e<99?.6:0),ue(e+t,0,100)}(this.progress,e))},stop:function(){var e=this;if(this.calls=Math.max(0,this.calls-1),!(this.calls>0)){clearTimeout(this.timer),this.$emit("stop");var t=function(){e.animate=!0,e.progress=100,e.timer=setTimeout((function(){e.onScreen=!1}),1e3)};0===this.progress?this.timer=setTimeout(t,1):t()}},__work:function(){var e=this;this.progress<100&&(this.timer=setTimeout((function(){e.increment(),e.__work()}),this.speed))}},mounted:function(){!0!==this.skipHijack&&(this.hijacked=!0,function(e,t){function n(){ke.forEach((function(e){e()}))}we.push(e),ke.push(t),++xe>1||(be.prototype.send=function(){we.forEach((function(e){e()})),this.addEventListener("loadend",n,!1),ye.apply(this,arguments)})}(this.start,this.stop))},beforeDestroy:function(){clearTimeout(this.timer),!0===this.hijacked&&function(e,t){we.splice(we.indexOf(e),1),ke.splice(ke.indexOf(t),1),(xe=Math.max(0,xe-1))||(be.prototype.send=ye)}(this.start,this.stop)},render:function(e){return e("div",{class:this.classes,style:this.style,attrs:this.attrs})}}),Ce={xs:18,sm:24,md:32,lg:38,xl:46};function Me(e){return{props:{size:String},computed:{sizeStyle:function(){if(void 0!==this.size)return{fontSize:this.size in e?e[this.size]+"px":this.size}}}}}var Te=Me(Ce),Ae={props:{tag:{type:String,default:"div"}}},Pe=ve("$listeners","qListeners");function Le(e,t,n){return void 0!==e.$scopedSlots[t]?e.$scopedSlots[t]():n}function Oe(e,t,n){return void 0!==e.$scopedSlots[t]?e.$scopedSlots[t]().slice():n}function qe(e,t,n){return void 0!==t.$scopedSlots[n]?e.concat(t.$scopedSlots[n]()):e}function Ee(e,t,n){if(void 0===t.$scopedSlots[n])return e;var i=t.$scopedSlots[n]();return void 0!==e?e.concat(i):i}var De=e.extend({name:"QIcon",mixins:[Pe,Te,Ae],props:{tag:{default:"i"},name:String,color:String,left:Boolean,right:Boolean},computed:{classes:function(){return"q-icon notranslate"+(!0===this.left?" on-left":"")+(!0===this.right?" on-right":"")+(void 0!==this.color?" text-"+this.color:"")},type:function(){var e,t=this,n=this.name;if(!n)return{none:!0,cls:this.classes};if(void 0!==this.$q.iconMapFn){var i=this.$q.iconMapFn(n);if(void 0!==i){if(void 0===i.icon)return{cls:i.cls+" "+this.classes,content:void 0!==i.content?i.content:" "};n=i.icon}}if(!0===n.startsWith("M")){var r=n.split("|"),o=r[0],a=r[1];return{svg:!0,cls:this.classes,nodes:o.split("&&").map((function(e){var n=e.split("@@"),i=n[0],r=n[1],o=n[2];return t.$createElement("path",{attrs:{d:i,transform:o},style:r})})),viewBox:void 0!==a?a:"0 0 24 24"}}if(!0===n.startsWith("img:"))return{img:!0,cls:this.classes,src:n.substring(4)};if(!0===n.startsWith("svguse:")){var s=n.split("|"),l=s[0],c=s[1];return{svguse:!0,cls:this.classes,src:l.substring(7),viewBox:void 0!==c?c:"0 0 24 24"}}var u=" ";return/^[l|f]a[s|r|l|b|d]{0,1} /.test(n)||!0===n.startsWith("icon-")?e=n:!0===n.startsWith("bt-")?e="bt "+n:!0===n.startsWith("eva-")?e="eva "+n:!0===/^ion-(md|ios|logo)/.test(n)?e="ionicons "+n:!0===n.startsWith("ion-")?e="ionicons ion-"+(!0===this.$q.platform.is.ios?"ios":"md")+n.substr(3):!0===n.startsWith("mdi-")?e="mdi "+n:!0===n.startsWith("iconfont ")?e=""+n:!0===n.startsWith("ti-")?e="themify-icon "+n:(e="material-icons",!0===n.startsWith("o_")?(n=n.substring(2),e+="-outlined"):!0===n.startsWith("r_")?(n=n.substring(2),e+="-round"):!0===n.startsWith("s_")&&(n=n.substring(2),e+="-sharp"),u=n),{cls:e+" "+this.classes,content:u}}},render:function(e){var t={class:this.type.cls,style:this.sizeStyle,on:Object.assign({},this.qListeners),attrs:{"aria-hidden":"true",role:"presentation"}};return!0===this.type.none?e(this.tag,t,Le(this,"default")):!0===this.type.img?(t.attrs.src=this.type.src,e("img",t)):!0===this.type.svg?(t.attrs.focusable="false",t.attrs.viewBox=this.type.viewBox,e("svg",t,qe(this.type.nodes,this,"default"))):!0===this.type.svguse?(t.attrs.focusable="false",t.attrs.viewBox=this.type.viewBox,e("svg",t,[e("use",{attrs:{"xlink:href":this.type.src}}),qe(this.type.nodes,this,"default")])):e(this.tag,t,qe([this.type.content],this,"default"))}}),ze=e.extend({name:"QAvatar",mixins:[Pe,Te],props:{fontSize:String,color:String,textColor:String,icon:String,square:Boolean,rounded:Boolean},computed:{classes:function(){var e;return(e={})["bg-"+this.color]=this.color,e["text-"+this.textColor+" q-chip--colored"]=this.textColor,e["q-avatar--square"]=this.square,e["rounded-borders"]=this.rounded,e},contentStyle:function(){if(this.fontSize)return{fontSize:this.fontSize}}},render:function(e){var t=void 0!==this.icon?[e(De,{props:{name:this.icon}})]:void 0;return e("div",{staticClass:"q-avatar",style:this.sizeStyle,class:this.classes,on:Object.assign({},this.qListeners)},[e("div",{staticClass:"q-avatar__content row flex-center overflow-hidden",style:this.contentStyle},Ee(t,this,"default"))])}}),Ne=e.extend({name:"QBadge",mixins:[Pe],props:{color:String,textColor:String,floating:Boolean,transparent:Boolean,multiLine:Boolean,outline:Boolean,label:[Number,String],align:{type:String,validator:function(e){return["top","middle","bottom"].includes(e)}}},computed:{style:function(){if(void 0!==this.align)return{verticalAlign:this.align}},classes:function(){var e=!0===this.outline&&this.color||this.textColor;return"q-badge flex inline items-center no-wrap q-badge--"+(!0===this.multiLine?"multi":"single")+"-line"+(!0===this.outline?" q-badge--outline":void 0!==this.color?" bg-"+this.color:"")+(void 0!==e?" text-"+e:"")+(!0===this.floating?" q-badge--floating":"")+(!0===this.transparent?" q-badge--transparent":"")},attrs:function(){return{role:"alert","aria-label":this.label}}},render:function(e){return e("div",{style:this.style,class:this.classes,attrs:this.attrs,on:Object.assign({},this.qListeners)},void 0!==this.label?[this.label]:Le(this,"default"))}}),je={props:{dark:{type:Boolean,default:null}},computed:{isDark:function(){return null===this.dark?this.$q.dark.isActive:this.dark}}},Re={role:"alert"},Ie=e.extend({name:"QBanner",mixins:[Pe,je],props:{inlineActions:Boolean,dense:Boolean,rounded:Boolean},render:function(e){var t=Le(this,"action"),n=[e("div",{staticClass:"q-banner__avatar col-auto row items-center self-start"},Le(this,"avatar")),e("div",{staticClass:"q-banner__content col text-body2"},Le(this,"default"))];return void 0!==t&&n.push(e("div",{staticClass:"q-banner__actions row items-center justify-end",class:"col-"+(!0===this.inlineActions?"auto":"all")},t)),e("div",{staticClass:"q-banner row items-center",class:{"q-banner--top-padding":void 0!==t&&!this.inlineActions,"q-banner--dense":this.dense,"q-banner--dark q-dark":this.isDark,"rounded-borders":this.rounded},attrs:Re,on:Object.assign({},this.qListeners)},n)}}),$e={role:"toolbar"},Fe=e.extend({name:"QBar",mixins:[Pe,je],props:{dense:Boolean},computed:{classes:function(){return"q-bar--"+(!0===this.dense?"dense":"standard")+" q-bar--"+(!0===this.isDark?"dark":"light")}},render:function(e){return e("div",{staticClass:"q-bar row no-wrap items-center",class:this.classes,attrs:$e,on:Object.assign({},this.qListeners)},Le(this,"default"))}}),Be={left:"start",center:"center",right:"end",between:"between",around:"around",evenly:"evenly",stretch:"stretch"},Ve=Object.keys(Be),He={props:{align:{type:String,validator:function(e){return Ve.includes(e)}}},computed:{alignClass:function(){var e=void 0===this.align?!0===this.vertical?"stretch":"left":this.align;return(!0===this.vertical?"items":"justify")+"-"+Be[e]}}},We=e.extend({name:"QBreadcrumbs",mixins:[Pe,He],props:{separator:{type:String,default:"/"},separatorColor:String,activeColor:{type:String,default:"primary"},gutter:{type:String,validator:function(e){return["none","xs","sm","md","lg","xl"].includes(e)},default:"sm"}},computed:{classes:function(){return this.alignClass+("none"===this.gutter?"":" q-gutter-"+this.gutter)},sepClass:function(){if(this.separatorColor)return"text-"+this.separatorColor},activeClass:function(){return"text-"+this.activeColor}},render:function(e){var t=this,n=Le(this,"default");if(void 0!==n){var i=1,r=[],o=n.filter((function(e){return void 0!==e.tag&&e.tag.endsWith("-QBreadcrumbsEl")})).length,a=void 0!==this.$scopedSlots.separator?this.$scopedSlots.separator:function(){return t.separator};return n.forEach((function(n){if(void 0!==n.tag&&n.tag.endsWith("-QBreadcrumbsEl")){var s=i<o;i++,r.push(e("div",{staticClass:"flex items-center",class:s?t.activeClass:"q-breadcrumbs--last"},[n])),s&&r.push(e("div",{staticClass:"q-breadcrumbs__separator",class:t.sepClass},a()))}else r.push(n)})),e("div",{staticClass:"q-breadcrumbs",on:Object.assign({},this.qListeners)},[e("div",{staticClass:"flex items-center",class:this.classes},r)])}}}),Ue={props:{to:[String,Object],exact:Boolean,append:Boolean,replace:Boolean,activeClass:String,exactActiveClass:String,disable:Boolean},computed:{hasRouterLink:function(){return!0!==this.disable&&void 0!==this.to&&null!==this.to&&""!==this.to},routerLinkProps:function(){return{to:this.to,exact:this.exact,append:this.append,replace:this.replace,activeClass:this.activeClass||"q-router-link--active",exactActiveClass:this.exactActiveClass||"q-router-link--exact-active",event:!0===this.disable?"":void 0}}}},Ye=e.extend({name:"QBreadcrumbsEl",mixins:[Pe,Ue],props:{label:String,icon:String},render:function(e){var t,n=[];return void 0!==this.icon&&n.push(e(De,{staticClass:"q-breadcrumbs__el-icon",class:void 0!==this.label?"q-breadcrumbs__el-icon--with-label":null,props:{name:this.icon}})),this.label&&n.push(this.label),e(!0===this.hasRouterLink?"router-link":"span",((t={staticClass:"q-breadcrumbs__el q-link flex inline items-center relative-position",props:!0===this.hasRouterLink?this.routerLinkProps:null})[!0===this.hasRouterLink?"nativeOn":"on"]=Object.assign({},this.qListeners),t),qe(n,this,"default"))}}),Ge={mixins:[Pe],props:{color:String,size:{type:[Number,String],default:"1em"}},computed:{cSize:function(){return this.size in Ce?Ce[this.size]+"px":this.size},classes:function(){if(this.color)return"text-"+this.color}}},Qe=e.extend({name:"QSpinner",mixins:[Ge],props:{thickness:{type:Number,default:5}},render:function(e){return e("svg",{staticClass:"q-spinner q-spinner-mat",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"25 25 50 50"}},[e("circle",{staticClass:"path",attrs:{cx:"50",cy:"50",r:"20",fill:"none",stroke:"currentColor","stroke-width":this.thickness,"stroke-miterlimit":"10"}})])}});function Ke(e){if(e===window)return{top:0,left:0};var t=e.getBoundingClientRect();return{top:t.top,left:t.left}}function Ze(e){return e===window?window.innerHeight:e.getBoundingClientRect().height}function Je(e,t){var n=e.style;Object.keys(t).forEach((function(e){n[e]=t[e]}))}function Xe(e,t){return!0===e?t===document.documentElement||null===t?document.body:t:document.body}var et={offset:Ke,style:function(e,t){return window.getComputedStyle(e).getPropertyValue(t)},height:Ze,width:function(e){return e===window?window.innerWidth:e.getBoundingClientRect().width},css:Je,cssBatch:function(e,t){e.forEach((function(e){return Je(e,t)}))},ready:function(e){if("function"==typeof e)return"loading"!==document.readyState?e():void document.addEventListener("DOMContentLoaded",e,!1)}};function tt(e,t){void 0===t&&(t=250);var n,i=!1;return function(){return!1===i&&(i=!0,setTimeout((function(){i=!1}),t),n=e.apply(this,arguments)),n}}function nt(e,t,n,i){!0===n.modifiers.stop&&b(e);var r=n.modifiers.color,o=n.modifiers.center;o=!0===o||!0===i;var a=document.createElement("span"),s=document.createElement("span"),l=g(e),c=t.getBoundingClientRect(),u=c.left,d=c.top,h=c.width,f=c.height,p=Math.sqrt(h*h+f*f),m=p/2,v=(h-p)/2+"px",_=o?v:l.left-u-m+"px",y=(f-p)/2+"px",w=o?y:l.top-d-m+"px";s.className="q-ripple__inner",Je(s,{height:p+"px",width:p+"px",transform:"translate3d("+_+","+w+",0) scale3d(.2,.2,1)",opacity:0}),a.className="q-ripple"+(r?" text-"+r:""),a.setAttribute("dir","ltr"),a.appendChild(s),t.appendChild(a);var k=function(){a.remove(),clearTimeout(x)};n.abort.push(k);var x=setTimeout((function(){s.classList.add("q-ripple__inner--enter"),s.style.transform="translate3d("+v+","+y+",0) scale3d(1,1,1)",s.style.opacity=.2,x=setTimeout((function(){s.classList.remove("q-ripple__inner--enter"),s.classList.add("q-ripple__inner--leave"),s.style.opacity=0,x=setTimeout((function(){a.remove(),n.abort.splice(n.abort.indexOf(k),1)}),275)}),250)}),50)}function it(e,t){var n=t.modifiers,i=t.value,r=t.arg,o=Object.assign({},ae.config.ripple,n,i);e.modifiers={early:!0===o.early,stop:!0===o.stop,center:!0===o.center,color:o.color||r,keyCodes:[].concat(o.keyCodes||13)}}function rt(e){var t=e.__qripple;void 0!==t&&(t.abort.forEach((function(e){e()})),C(t,"main"),delete e._qripple)}var ot={name:"ripple",inserted:function(e,t){void 0!==e.__qripple&&(rt(e),e.__qripple_destroyed=!0);var n={enabled:!1!==t.value,modifiers:{},abort:[],start:function(t){!0===n.enabled&&!0!==t.qSkipRipple&&(!0!==d.is.ie||t.clientX>=0)&&(!0===n.modifiers.early?!0===["mousedown","touchstart"].includes(t.type):"click"===t.type)&&nt(t,e,n,!0===t.qKeyEvent)},keystart:tt((function(t){!0===n.enabled&&!0!==t.qSkipRipple&&!0===X(t,n.modifiers.keyCodes)&&t.type==="key"+(!0===n.modifiers.early?"down":"up")&&nt(t,e,n,!0)}),300)};it(n,t),e.__qripple=n,S(n,"main",[[e,"mousedown","start","passive"],[e,"touchstart","start","passive"],[e,"click","start","passive"],[e,"keydown","keystart","passive"],[e,"keyup","keystart","passive"]])},update:function(e,t){var n=e.__qripple;void 0!==n&&t.oldValue!==t.value&&(n.enabled=!1!==t.value,!0===n.enabled&&Object(t.value)===t.value&&it(n,t))},unbind:function(e){void 0===e.__qripple_destroyed?rt(e):delete e.__qripple_destroyed}},at={directives:{Ripple:ot},props:{ripple:{type:[Boolean,Object],default:!0}}},st={none:0,xs:4,sm:8,md:16,lg:24,xl:32},lt={mixins:[Pe,at,He,Me({xs:8,sm:10,md:14,lg:20,xl:24})],props:{type:String,to:[Object,String],replace:Boolean,append:Boolean,label:[Number,String],icon:String,iconRight:String,round:Boolean,outline:Boolean,flat:Boolean,unelevated:Boolean,rounded:Boolean,push:Boolean,glossy:Boolean,size:String,fab:Boolean,fabMini:Boolean,padding:String,color:String,textColor:String,noCaps:Boolean,noWrap:Boolean,dense:Boolean,tabindex:[Number,String],align:{default:"center"},stack:Boolean,stretch:Boolean,loading:{type:Boolean,default:null},disable:Boolean},computed:{style:function(){if(!1===this.fab&&!1===this.fabMini)return this.sizeStyle},isRounded:function(){return!0===this.rounded||!0===this.fab||!0===this.fabMini},isActionable:function(){return!0!==this.disable&&!0!==this.loading},computedTabIndex:function(){return!0===this.isActionable?this.tabindex||0:-1},hasRouterLink:function(){return!0!==this.disable&&void 0!==this.to&&null!==this.to&&""!==this.to},isLink:function(){return"a"===this.type||!0===this.hasRouterLink},design:function(){return!0===this.flat?"flat":!0===this.outline?"outline":!0===this.push?"push":!0===this.unelevated?"unelevated":"standard"},currentLocation:function(){if(!0===this.hasRouterLink)return!0===this.append?this.$router.resolve(this.to,this.$route,!0):this.$router.resolve(this.to)},attrs:function(){var e={tabindex:this.computedTabIndex};return"a"!==this.type&&(e.type=this.type||"button"),!0===this.hasRouterLink?(e.href=this.currentLocation.href,e.role="link"):e.role="a"===this.type?"link":"button",!0===this.loading&&void 0!==this.percentage&&(e.role="progressbar",e["aria-valuemin"]=0,e["aria-valuemax"]=100,e["aria-valuenow"]=this.percentage),!0===this.disable&&(e.disabled="",e["aria-disabled"]="true"),e},classes:function(){var e;return void 0!==this.color?e=!0===this.flat||!0===this.outline?"text-"+(this.textColor||this.color):"bg-"+this.color+" text-"+(this.textColor||"white"):this.textColor&&(e="text-"+this.textColor),"q-btn--"+this.design+" q-btn--"+(!0===this.round?"round":"rectangle"+(!0===this.isRounded?" q-btn--rounded":""))+(void 0!==e?" "+e:"")+(!0===this.isActionable?" q-btn--actionable q-focusable q-hoverable":!0===this.disable?" disabled":"")+(!0===this.fab?" q-btn--fab":!0===this.fabMini?" q-btn--fab-mini":"")+(!0===this.noCaps?" q-btn--no-uppercase":"")+(!0===this.noWrap?"":" q-btn--wrap")+(!0===this.dense?" q-btn--dense":"")+(!0===this.stretch?" no-border-radius self-stretch":"")+(!0===this.glossy?" glossy":"")},innerClasses:function(){return this.alignClass+(!0===this.stack?" column":" row")+(!0===this.noWrap?" no-wrap text-no-wrap":"")+(!0===this.loading?" q-btn__content--hidden":"")},wrapperStyle:function(){if(void 0!==this.padding)return{padding:this.padding.split(/\s+/).map((function(e){return e in st?st[e]+"px":e})).join(" "),minWidth:"0",minHeight:"0"}}}},ct=["left","right","up","down","horizontal","vertical"],ut={left:!0,right:!0,up:!0,down:!0,horizontal:!0,vertical:!0,all:!0};function dt(e){var t={};return ct.forEach((function(n){e[n]&&(t[n]=!0)})),0===Object.keys(t).length?ut:(!0===t.horizontal&&(t.left=t.right=!0),!0===t.vertical&&(t.up=t.down=!0),!0===t.left&&!0===t.right&&(t.horizontal=!0),!0===t.up&&!0===t.down&&(t.vertical=!0),!0===t.horizontal&&!0===t.vertical&&(t.all=!0),t)}var ht=!1===i&&!0!==a&&(!0===d.is.ios||window.navigator.vendor.toLowerCase().indexOf("apple")>-1)?function(){return document}:function(e){return e};function ft(e,t){return void 0===t.event&&void 0!==e.target&&!0!==e.target.draggable&&"function"==typeof t.handler&&"INPUT"!==e.target.nodeName.toUpperCase()&&(void 0===e.qClonedBy||-1===e.qClonedBy.indexOf(t.uid))}var pt=f.passiveCapture,mt=void 0,vt=void 0,gt=void 0,_t={role:"img","aria-hidden":"true"},bt=e.extend({name:"QBtn",mixins:[lt],props:{percentage:Number,darkPercentage:Boolean},computed:{hasLabel:function(){return void 0!==this.label&&null!==this.label&&""!==this.label},computedRipple:function(){return!1!==this.ripple&&Object.assign({},{keyCodes:!0===this.isLink?[13,32]:[13]},!0===this.ripple?{}:this.ripple)},percentageStyle:function(){var e=Math.max(0,Math.min(100,this.percentage));if(e>0)return{transition:"transform 0.6s",transform:"translateX("+(e-100)+"%)"}},onEvents:function(){if(!0===this.loading)return{mousedown:this.__onLoadingEvt,touchstart:this.__onLoadingEvt,click:this.__onLoadingEvt,keydown:this.__onLoadingEvt,keyup:this.__onLoadingEvt};if(!0===this.isActionable){var e=Object.assign({},this.qListeners,{click:this.click,keydown:this.__onKeydown,mousedown:this.__onMousedown});return!0===this.$q.platform.has.touch&&(e.touchstart=this.__onTouchstart),e}return{}},directives:function(){if(!0!==this.disable&&!1!==this.ripple)return[{name:"ripple",value:this.computedRipple,modifiers:{center:this.round}}]}},methods:{click:function(e){var t=this;if(void 0!==e){if(!0===e.defaultPrevented)return;var n=document.activeElement;if("submit"===this.type&&(!0===this.$q.platform.is.ie&&(e.clientX<0||e.clientY<0)||n!==document.body&&!1===this.$el.contains(n)&&!1===n.contains(this.$el))){this.$el.focus();var i=function(){document.removeEventListener("keydown",w,!0),document.removeEventListener("keyup",i,pt),void 0!==t.$el&&t.$el.removeEventListener("blur",i,pt)};document.addEventListener("keydown",w,!0),document.addEventListener("keyup",i,pt),this.$el.addEventListener("blur",i,pt)}if(!0===this.hasRouterLink){if(!0===e.ctrlKey||!0===e.shiftKey||!0===e.altKey||!0===e.metaKey)return;w(e)}}var r=function(){t.$router[!0===t.replace?"replace":"push"](t.currentLocation.route,void 0,m)};this.$emit("click",e,r),!0===this.hasRouterLink&&!1!==e.navigate&&r()},__onKeydown:function(e){!0===X(e,[13,32])&&(w(e),vt!==this.$el&&(void 0!==vt&&this.__cleanup(),this.$el.focus(),vt=this.$el,this.$el.classList.add("q-btn--active"),document.addEventListener("keyup",this.__onPressEnd,!0),this.$el.addEventListener("blur",this.__onPressEnd,pt))),this.$emit("keydown",e)},__onTouchstart:function(e){var t=this;if(mt!==this.$el){void 0!==mt&&this.__cleanup(),mt=this.$el;var n=this.touchTargetEl=ht(e.target);n.addEventListener("touchcancel",this.__onPressEnd,pt),n.addEventListener("touchend",this.__onPressEnd,pt)}this.avoidMouseRipple=!0,clearTimeout(this.mouseTimer),this.mouseTimer=setTimeout((function(){t.avoidMouseRipple=!1}),200),this.$emit("touchstart",e)},__onMousedown:function(e){gt!==this.$el&&(void 0!==gt&&this.__cleanup(),gt=this.$el,this.$el.classList.add("q-btn--active"),document.addEventListener("mouseup",this.__onPressEnd,pt)),e.qSkipRipple=!0===this.avoidMouseRipple,this.$emit("mousedown",e)},__onPressEnd:function(e){if(void 0===e||"blur"!==e.type||document.activeElement!==this.$el){if(void 0!==e&&"keyup"===e.type){if(vt===this.$el&&!0===X(e,[13,32])){var t=new MouseEvent("click",e);t.qKeyEvent=!0,!0===e.defaultPrevented&&y(t),!0===e.cancelBubble&&b(t),this.$el.dispatchEvent(t),w(e),e.qKeyEvent=!0}this.$emit("keyup",e)}this.__cleanup()}},__cleanup:function(e){var t=this.$refs.blurTarget;if(!0===e||mt!==this.$el&&gt!==this.$el||void 0===t||t===document.activeElement||(t.setAttribute("tabindex",-1),t.focus()),mt===this.$el){var n=this.touchTargetEl;n.removeEventListener("touchcancel",this.__onPressEnd,pt),n.removeEventListener("touchend",this.__onPressEnd,pt),mt=this.touchTargetEl=void 0}gt===this.$el&&(document.removeEventListener("mouseup",this.__onPressEnd,pt),gt=void 0),vt===this.$el&&(document.removeEventListener("keyup",this.__onPressEnd,!0),void 0!==this.$el&&this.$el.removeEventListener("blur",this.__onPressEnd,pt),vt=void 0),void 0!==this.$el&&this.$el.classList.remove("q-btn--active")},__onLoadingEvt:function(e){w(e),e.qSkipRipple=!0}},beforeDestroy:function(){this.__cleanup(!0)},render:function(e){var t=[];void 0!==this.icon&&t.push(e(De,{attrs:_t,props:{name:this.icon,left:!1===this.stack&&!0===this.hasLabel}})),!0===this.hasLabel&&t.push(e("span",{staticClass:"block"},[this.label])),t=qe(t,this,"default"),void 0!==this.iconRight&&!1===this.round&&t.push(e(De,{attrs:_t,props:{name:this.iconRight,right:!1===this.stack&&!0===this.hasLabel}}));var n=[e("span",{staticClass:"q-focus-helper",ref:"blurTarget"})];return!0===this.loading&&void 0!==this.percentage&&n.push(e("span",{staticClass:"q-btn__progress absolute-full overflow-hidden"},[e("span",{staticClass:"q-btn__progress-indicator fit block",class:!0===this.darkPercentage?"q-btn__progress--dark":"",style:this.percentageStyle})])),n.push(e("span",{staticClass:"q-btn__wrapper col row q-anchor--skip",style:this.wrapperStyle},[e("span",{staticClass:"q-btn__content text-center col items-center q-anchor--skip",class:this.innerClasses},t)])),null!==this.loading&&n.push(e("transition",{props:{name:"q-transition--fade"}},!0===this.loading?[e("span",{key:"loading",staticClass:"absolute-full flex flex-center"},void 0!==this.$scopedSlots.loading?this.$scopedSlots.loading():[e(Qe)])]:void 0)),e(!0===this.isLink?"a":"button",{staticClass:"q-btn q-btn-item non-selectable no-outline",class:this.classes,style:this.style,attrs:this.attrs,on:this.onEvents,directives:this.directives},n)}}),yt=e.extend({name:"QBtnGroup",mixin:[Pe],props:{unelevated:Boolean,outline:Boolean,flat:Boolean,rounded:Boolean,push:Boolean,stretch:Boolean,glossy:Boolean,spread:Boolean},computed:{classes:function(){var e=this;return["unelevated","outline","flat","rounded","push","stretch","glossy"].filter((function(t){return!0===e[t]})).map((function(e){return"q-btn-group--"+e})).join(" ")}},render:function(e){return e("div",{staticClass:"q-btn-group row no-wrap "+(!0===this.spread?"q-btn-group--spread":"inline"),class:this.classes,on:Object.assign({},this.qListeners)},Le(this,"default"))}});function wt(){if(void 0!==window.getSelection){var e=window.getSelection();void 0!==e.empty?e.empty():void 0!==e.removeAllRanges&&(e.removeAllRanges(),!0!==h.is.mobile&&e.addRange(document.createRange()))}else void 0!==document.selection&&document.selection.empty()}var kt={props:{target:{default:!0},noParentEvent:Boolean,contextMenu:Boolean},watch:{contextMenu:function(e){void 0!==this.anchorEl&&(this.__unconfigureAnchorEl(),this.__configureAnchorEl(e))},target:function(){void 0!==this.anchorEl&&this.__unconfigureAnchorEl(),this.__pickAnchorEl()},noParentEvent:function(e){void 0!==this.anchorEl&&(!0===e?this.__unconfigureAnchorEl():this.__configureAnchorEl())}},methods:{__showCondition:function(e){return void 0!==this.anchorEl&&(void 0===e||(void 0===e.touches||e.touches.length<=1))},__contextClick:function(e){var t=this;this.hide(e),this.$nextTick((function(){t.show(e)})),y(e)},__toggleKey:function(e){!0===X(e,13)&&this.toggle(e)},__mobileCleanup:function(e){this.anchorEl.classList.remove("non-selectable"),clearTimeout(this.touchTimer),!0===this.showing&&void 0!==e&&wt()},__mobilePrevent:y,__mobileTouch:function(e){var t=this;if(this.__mobileCleanup(e),!0===this.__showCondition(e)){this.hide(e),this.anchorEl.classList.add("non-selectable");var n=ht(e.target);S(this,"anchor",[[n,"touchmove","__mobileCleanup","passive"],[n,"touchend","__mobileCleanup","passive"],[n,"touchcancel","__mobileCleanup","passive"],[this.anchorEl,"contextmenu","__mobilePrevent","notPassive"]]),this.touchTimer=setTimeout((function(){t.show(e)}),300)}},__unconfigureAnchorEl:function(){C(this,"anchor")},__configureAnchorEl:function(e){(void 0===e&&(e=this.contextMenu),!0!==this.noParentEvent&&void 0!==this.anchorEl)&&S(this,"anchor",!0===e?!0===this.$q.platform.is.mobile?[[this.anchorEl,"touchstart","__mobileTouch","passive"]]:[[this.anchorEl,"click","hide","passive"],[this.anchorEl,"contextmenu","__contextClick","notPassive"]]:[[this.anchorEl,"click","toggle","passive"],[this.anchorEl,"keyup","__toggleKey","passive"]])},__setAnchorEl:function(e){for(this.anchorEl=e;this.anchorEl.classList.contains("q-anchor--skip");)this.anchorEl=this.anchorEl.parentNode;this.__configureAnchorEl()},__pickAnchorEl:function(){if(!1===this.target||""===this.target)this.anchorEl=void 0;else if(!0===this.target)this.__setAnchorEl(this.parentEl);else{var e=this.target;if("string"==typeof this.target)try{e=document.querySelector(this.target)}catch(t){e=void 0}null!=e?(this.anchorEl=!0===e._isVue&&void 0!==e.$el?e.$el:e,this.__configureAnchorEl()):(this.anchorEl=void 0,console.error('Anchor: target "'+this.target+'" not found',this))}},__changeScrollEvent:function(e,t){var n=(void 0!==t?"add":"remove")+"EventListener",i=void 0!==t?t:this.__scrollFn;e!==window&&e[n]("scroll",i,f.passive),window[n]("scroll",i,f.passive),this.__scrollFn=t}},created:function(){var e=this;"function"==typeof this.__configureScrollTarget&&"function"==typeof this.__unconfigureScrollTarget&&(this.noParentEventWatcher=this.$watch("noParentEvent",(function(){void 0!==e.__scrollTarget&&(e.__unconfigureScrollTarget(),e.__configureScrollTarget())})))},mounted:function(){this.parentEl=this.$el.parentNode,this.__pickAnchorEl(),!0===this.value&&void 0===this.anchorEl&&this.$emit("input",!1)},beforeDestroy:function(){clearTimeout(this.touchTimer),void 0!==this.noParentEventWatcher&&this.noParentEventWatcher(),void 0!==this.__anchorCleanup&&this.__anchorCleanup(),this.__unconfigureAnchorEl()}},xt={methods:{__nextTick:function(e){this.__tickFn=e},__prepareTick:function(){var e=this;if(void 0!==this.__tickFn){var t=this.__tickFn;this.$nextTick((function(){e.__tickFn===t&&(e.__tickFn(),e.__tickFn=void 0)}))}},__clearTick:function(){this.__tickFn=void 0},__setTimeout:function(e,t){clearTimeout(this.__timer),this.__timer=setTimeout(e,t)},__clearTimeout:function(){clearTimeout(this.__timer)}},beforeDestroy:function(){this.__tickFn=void 0,clearTimeout(this.__timer)}},St={mixins:[xt,Pe],props:{value:{type:Boolean,default:void 0}},data:function(){return{showing:!1}},watch:{value:function(e){this.__processModelChange(e)},$route:function(){!0===this.hideOnRouteChange&&!0===this.showing&&this.hide()}},methods:{toggle:function(e){this[!0===this.showing?"hide":"show"](e)},show:function(e){var t=this;!0===this.disable||void 0!==this.__showCondition&&!0!==this.__showCondition(e)||(void 0!==this.qListeners.input&&!1===i&&(this.$emit("input",!0),this.payload=e,this.$nextTick((function(){t.payload===e&&(t.payload=void 0)}))),void 0!==this.value&&void 0!==this.qListeners.input&&!0!==i||this.__processShow(e))},__processShow:function(e){!0!==this.showing&&(void 0!==this.__preparePortal&&this.__preparePortal(),this.showing=!0,this.$emit("before-show",e),void 0!==this.__show?(this.__clearTick(),this.__show(e),this.__prepareTick()):this.$emit("show",e))},hide:function(e){var t=this;!0!==this.disable&&(void 0!==this.qListeners.input&&!1===i&&(this.$emit("input",!1),this.payload=e,this.$nextTick((function(){t.payload===e&&(t.payload=void 0)}))),void 0!==this.value&&void 0!==this.qListeners.input&&!0!==i||this.__processHide(e))},__processHide:function(e){!1!==this.showing&&(this.showing=!1,this.$emit("before-hide",e),void 0!==this.__hide?(this.__clearTick(),this.__hide(e),this.__prepareTick()):this.$emit("hide",e))},__processModelChange:function(e){!0===this.disable&&!0===e?void 0!==this.qListeners.input&&this.$emit("input",!1):!0===e!==this.showing&&this["__process"+(!0===e?"Show":"Hide")](this.payload)}}};function Ct(e,t){do{if("QMenu"===e.$options.name){if(e.hide(t),!0===e.separateClosePopup)return e.$parent}else if(void 0!==e.__renderPortal)return void 0!==e.$parent&&"QPopupProxy"===e.$parent.$options.name?(e.hide(t),e.$parent):e;e=e.$parent}while(void 0!==e)}var Mt={inheritAttrs:!1,props:{contentClass:[Array,String,Object],contentStyle:[Array,String,Object]},methods:{__showPortal:function(){var e=this;if(void 0!==this.$q.fullscreen&&!0===this.$q.fullscreen.isCapable){var t=function(t){if(void 0!==e.__portal){var n=Xe(t,e.$q.fullscreen.activeEl);e.__portal.$el.parentElement!==n&&n.contains(e.$el)===(!1===e.__onGlobalDialog)&&n.appendChild(e.__portal.$el)}};this.unwatchFullscreen=this.$watch("$q.fullscreen.isActive",t);var n=this.$q.fullscreen.isActive;!1!==this.__onGlobalDialog&&!0!==n||t(n)}else void 0!==this.__portal&&!1===this.__onGlobalDialog&&document.body.appendChild(this.__portal.$el)},__hidePortal:function(){void 0!==this.__portal&&(void 0!==this.unwatchFullscreen&&(this.unwatchFullscreen(),this.unwatchFullscreen=void 0),!1===this.__onGlobalDialog&&(this.__portal.$destroy(),this.__portal.$el.remove()),this.__portal=void 0)},__preparePortal:function(){var t=this;void 0===this.__portal&&(this.__portal=!0===this.__onGlobalDialog?{$el:this.$el,$refs:this.$refs}:new e({name:"QPortal",parent:this,inheritAttrs:!1,render:function(e){return t.__renderPortal(e)},components:this.$options.components,directives:this.$options.directives}).$mount())}},render:function(e){if(!0===this.__onGlobalDialog)return this.__renderPortal(e);void 0!==this.__portal&&this.__portal.$forceUpdate()},beforeDestroy:function(){this.__hidePortal()}};!1===i&&(Mt.created=function(){this.__onGlobalDialog=function(e){for(;void 0!==e;){if("QGlobalDialog"===e.$options.name)return!0;if("QDialog"===e.$options.name)return!1;e=e.$parent}return!1}(this.$parent)});var Tt,At={props:{transitionShow:{type:String,default:"fade"},transitionHide:{type:String,default:"fade"}},data:function(){return{transitionState:this.showing}},watch:{showing:function(e){var t=this;this.transitionShow!==this.transitionHide&&this.$nextTick((function(){t.transitionState=e}))}},computed:{transition:function(){return"q-transition--"+(!0===this.transitionState?this.transitionHide:this.transitionShow)}}};var Pt=f.notPassiveCapture,Lt=f.passiveCapture,Ot={click:[],focus:[]};function qt(e,t){for(var n=e.length-1;n>=0;n--)if(void 0===e[n](t))return}function Et(e){clearTimeout(Tt),"focusin"===e.type&&!0===e.target.hasAttribute("tabindex")?Tt=setTimeout((function(){qt(Ot.focus,e)}),200):qt(Ot.click,e)}var Dt,zt={name:"click-outside",bind:function(e,t,n){var i=t.value,r=t.arg,o=n.componentInstance||n.context,a={trigger:i,toggleEl:r,handler:function(e){var t=e.target;if(!(void 0===t||8===t.nodeType||t===document.documentElement||!1!==t.classList.contains("no-pointer-events")||void 0!==a.toggleEl&&!1!==a.toggleEl.contains(t)||t!==document.body&&!1!==function(e,t){for(var n=e;void 0!==n;n=n.$parent)if(n===t)return!0;return!1}(function(e){for(var t=e;null!==t;t=t.parentNode){if(null===t.__vue__)return;if(void 0!==t.__vue__)return t.__vue__}}(t),o)))return e.qClickOutside=!0,a.trigger(e)}};e.__qclickoutside&&(e.__qclickoutside_old=e.__qclickoutside),e.__qclickoutside=a,0===Ot.click.length&&(document.addEventListener("mousedown",Et,Pt),document.addEventListener("touchstart",Et,Pt),document.addEventListener("focusin",Et,Lt)),Ot.click.push(a.handler),a.timerFocusin=setTimeout((function(){Ot.focus.push(a.handler)}),500)},update:function(e,t){var n=t.value,i=t.oldValue,r=t.arg,o=e.__qclickoutside;n!==i&&(o.trigger=n),r!==o.arg&&(o.toggleEl=r)},unbind:function(e){var t=e.__qclickoutside_old||e.__qclickoutside;if(void 0!==t){clearTimeout(t.timerFocusin);var n=Ot.click.findIndex((function(e){return e===t.handler})),i=Ot.focus.findIndex((function(e){return e===t.handler}));n>-1&&Ot.click.splice(n,1),i>-1&&Ot.focus.splice(i,1),0===Ot.click.length&&(clearTimeout(Tt),document.removeEventListener("mousedown",Et,Pt),document.removeEventListener("touchstart",Et,Pt),document.removeEventListener("focusin",Et,Lt)),delete e[e.__qclickoutside_old?"__qclickoutside_old":"__qclickoutside"]}}},Nt=!1===i?[null,document,document.body,document.scrollingElement,document.documentElement]:[];function jt(e,t){if("string"==typeof t)try{t=document.querySelector(t)}catch(e){t=void 0}return null==t?t=e.closest(".scroll,.scroll-y,.overflow-auto"):!0===t._isVue&&void 0!==t.$el&&(t=t.$el),Nt.includes(t)?window:t}function Rt(e){return(e===window?document.body:e).scrollHeight}function It(e){return e===window?window.pageYOffset||window.scrollY||document.body.scrollTop||0:e.scrollTop}function $t(e){return e===window?window.pageXOffset||window.scrollX||document.body.scrollLeft||0:e.scrollLeft}function Ft(e,t,n){void 0===n&&(n=0);var i=It(e);n<=0?i!==t&&Vt(e,t):requestAnimationFrame((function(){var r=i+(t-i)/Math.max(16,n)*16;Vt(e,r),r!==t&&Ft(e,t,n-16)}))}function Bt(e,t,n){void 0===n&&(n=0);var i=$t(e);n<=0?i!==t&&Ht(e,t):requestAnimationFrame((function(){var r=i+(t-i)/Math.max(16,n)*16;Ht(e,r),r!==t&&Bt(e,t,n-16)}))}function Vt(e,t){e!==window?e.scrollTop=t:window.scrollTo(window.pageXOffset||window.scrollX||document.body.scrollLeft||0,t)}function Ht(e,t){e!==window?e.scrollLeft=t:window.scrollTo(t,window.pageYOffset||window.scrollY||document.body.scrollTop||0)}function Wt(e,t,n){n?Ft(e,t,n):Vt(e,t)}function Ut(e,t,n){n?Bt(e,t,n):Ht(e,t)}function Yt(){if(void 0!==Dt)return Dt;var e=document.createElement("p"),t=document.createElement("div");Je(e,{width:"100%",height:"200px"}),Je(t,{position:"absolute",top:"0px",left:"0px",visibility:"hidden",width:"200px",height:"150px",overflow:"hidden"}),t.appendChild(e),document.body.appendChild(t);var n=e.offsetWidth;t.style.overflow="scroll";var i=e.offsetWidth;return n===i&&(i=t.clientWidth),t.remove(),Dt=n-i}function Gt(e,t){return void 0===t&&(t=!0),!(!e||e.nodeType!==Node.ELEMENT_NODE)&&(t?e.scrollHeight>e.clientHeight&&(e.classList.contains("scroll")||e.classList.contains("overflow-auto")||["auto","scroll"].includes(window.getComputedStyle(e)["overflow-y"])):e.scrollWidth>e.clientWidth&&(e.classList.contains("scroll")||e.classList.contains("overflow-auto")||["auto","scroll"].includes(window.getComputedStyle(e)["overflow-x"])))}var Qt,Kt,Zt={getScrollTarget:jt,getScrollHeight:Rt,getScrollWidth:function(e){return(e===window?document.body:e).scrollWidth},getScrollPosition:It,getHorizontalScrollPosition:$t,animScrollTo:Ft,animHorizontalScrollTo:Bt,setScrollPosition:Wt,setHorizontalScrollPosition:Ut,getScrollbarWidth:Yt,hasScrollbar:Gt},Jt=[],Xt=!1,en={__install:function(){this.__installed=!0,window.addEventListener("keydown",(function(e){Xt=27===e.keyCode})),window.addEventListener("blur",(function(){!0===Xt&&(Xt=!1)})),window.addEventListener("keyup",(function(e){!0===Xt&&(Xt=!1,0!==Jt.length&&!0===X(e,27)&&Jt[Jt.length-1].fn(e))}))},register:function(e,t){!0===e.$q.platform.is.desktop&&(!0!==this.__installed&&this.__install(),Jt.push({comp:e,fn:t}))},pop:function(e){if(!0===e.$q.platform.is.desktop){var t=Jt.findIndex((function(t){return t.comp===e}));t>-1&&Jt.splice(t,1)}}};function tn(e){var t=e.split(" ");return 2===t.length&&(["top","center","bottom"].includes(t[0])?!!["left","middle","right"].includes(t[1])||(console.error("Anchor/Self position must end with one of left/middle/right"),!1):(console.error("Anchor/Self position must start with one of top/center/bottom"),!1))}function nn(e){return!e||2===e.length&&("number"==typeof e[0]&&"number"==typeof e[1])}function rn(e){var t=e.split(" ");return{vertical:t[0],horizontal:t[1]}}function on(e){if(!0===d.is.ios&&void 0!==window.visualViewport){var t=document.body.style,n=window.visualViewport,i=n.offsetLeft,r=n.offsetTop;i!==Qt&&(t.setProperty("--q-pe-left",i+"px"),Qt=i),r!==Kt&&(t.setProperty("--q-pe-top",r+"px"),Kt=r)}var o,a=e.el,s=a.scrollLeft,l=a.scrollTop;if(void 0===e.absoluteOffset)o=function(e,t){var n=e.getBoundingClientRect(),i=n.top,r=n.left,o=n.right,a=n.bottom,s=n.width,l=n.height;return void 0!==t&&(i-=t[1],r-=t[0],a+=t[1],o+=t[0],s+=t[0],l+=t[1]),{top:i,left:r,right:o,bottom:a,width:s,height:l,middle:r+(o-r)/2,center:i+(a-i)/2}}(e.anchorEl,!0===e.cover?[0,0]:e.offset);else{var c=e.anchorEl.getBoundingClientRect(),u=c.top,h=c.left,f=u+e.absoluteOffset.top,p=h+e.absoluteOffset.left;o={top:f,left:p,width:1,height:1,right:p+1,center:f,middle:p,bottom:f+1}}var m={maxHeight:e.maxHeight,maxWidth:e.maxWidth,visibility:"visible"};!0!==e.fit&&!0!==e.cover||(m.minWidth=o.width+"px",!0===e.cover&&(m.minHeight=o.height+"px")),Object.assign(e.el.style,m);var v=function(e){return{top:0,center:e.offsetHeight/2,bottom:e.offsetHeight,left:0,middle:e.offsetWidth/2,right:e.offsetWidth}}(e.el),g={top:o[e.anchorOrigin.vertical]-v[e.selfOrigin.vertical],left:o[e.anchorOrigin.horizontal]-v[e.selfOrigin.horizontal]};!function(e,t,n,i,r){var o=n.bottom,a=n.right,s=Yt(),l=window.innerHeight-s,c=document.body.clientWidth;if(e.top<0||e.top+o>l)if("center"===r.vertical)e.top=t[i.vertical]>l/2?Math.max(0,l-o):0,e.maxHeight=Math.min(o,l);else if(t[i.vertical]>l/2){var u=Math.min(l,"center"===i.vertical?t.center:i.vertical===r.vertical?t.bottom:t.top);e.maxHeight=Math.min(o,u),e.top=Math.max(0,u-o)}else e.top=Math.max(0,"center"===i.vertical?t.center:i.vertical===r.vertical?t.top:t.bottom),e.maxHeight=Math.min(o,l-e.top);if(e.left<0||e.left+a>c)if(e.maxWidth=Math.min(a,c),"middle"===r.horizontal)e.left=t[i.horizontal]>c/2?Math.max(0,c-a):0;else if(t[i.horizontal]>c/2){var d=Math.min(c,"middle"===i.horizontal?t.middle:i.horizontal===r.horizontal?t.right:t.left);e.maxWidth=Math.min(a,d),e.left=Math.max(0,d-e.maxWidth)}else e.left=Math.max(0,"middle"===i.horizontal?t.middle:i.horizontal===r.horizontal?t.left:t.right),e.maxWidth=Math.min(a,c-e.left)}(g,o,v,e.anchorOrigin,e.selfOrigin),m={top:g.top+"px",left:g.left+"px"},void 0!==g.maxHeight&&(m.maxHeight=g.maxHeight+"px",o.height>g.maxHeight&&(m.minHeight=m.maxHeight)),void 0!==g.maxWidth&&(m.maxWidth=g.maxWidth+"px",o.width>g.maxWidth&&(m.minWidth=m.maxWidth)),Object.assign(e.el.style,m),e.el.scrollTop!==l&&(e.el.scrollTop=l),e.el.scrollLeft!==s&&(e.el.scrollLeft=s)}var an=e.extend({name:"QMenu",mixins:[_e,je,kt,St,Mt,At],directives:{ClickOutside:zt},props:{persistent:Boolean,autoClose:Boolean,separateClosePopup:Boolean,noRouteDismiss:Boolean,noRefocus:Boolean,noFocus:Boolean,fit:Boolean,cover:Boolean,square:Boolean,anchor:{type:String,validator:tn},self:{type:String,validator:tn},offset:{type:Array,validator:nn},scrollTarget:{default:void 0},touchPosition:Boolean,maxHeight:{type:String,default:null},maxWidth:{type:String,default:null}},computed:{horizSide:function(){return!0===this.$q.lang.rtl?"right":"left"},anchorOrigin:function(){return rn(this.anchor||(!0===this.cover?"center middle":"bottom "+this.horizSide))},selfOrigin:function(){return!0===this.cover?this.anchorOrigin:rn(this.self||"top "+this.horizSide)},menuClass:function(){return(!0===this.square?" q-menu--square":"")+(!0===this.isDark?" q-menu--dark q-dark":"")},hideOnRouteChange:function(){return!0!==this.persistent&&!0!==this.noRouteDismiss},onEvents:function(){var e=Object.assign({},this.qListeners,{input:b,"popup-show":b,"popup-hide":b});return!0===this.autoClose&&(e.click=this.__onAutoClose),e},attrs:function(){return Object.assign({},{tabindex:-1},this.qAttrs)}},methods:{focus:function(){var e=void 0!==this.__portal&&void 0!==this.__portal.$refs?this.__portal.$refs.inner:void 0;void 0!==e&&!0!==e.contains(document.activeElement)&&(e=e.querySelector("[autofocus], [data-autofocus]")||e).focus()},__show:function(e){var t=this;if(this.__refocusTarget=!1===this.noRefocus&&null!==document.activeElement?document.activeElement:void 0,en.register(this,(function(){!0!==t.persistent&&(t.$emit("escape-key"),t.hide())})),this.__showPortal(),this.__configureScrollTarget(),this.absoluteOffset=void 0,void 0!==e&&(this.touchPosition||this.contextMenu)){var n=g(e);if(void 0!==n.left){var i=this.anchorEl.getBoundingClientRect(),r=i.top,o=i.left;this.absoluteOffset={left:n.left-o,top:n.top-r}}}void 0===this.unwatch&&(this.unwatch=this.$watch((function(){return t.$q.screen.width+"|"+t.$q.screen.height+"|"+t.self+"|"+t.anchor}),this.updatePosition)),this.$el.dispatchEvent(x("popup-show",{bubbles:!0})),!0!==this.noFocus&&null!==document.activeElement&&document.activeElement.blur(),this.__nextTick((function(){t.updatePosition(),!0!==t.noFocus&&t.focus()})),this.__setTimeout((function(){!0===t.$q.platform.is.ios&&(t.__avoidAutoClose=t.autoClose,t.__portal.$el.click()),t.updatePosition(),t.$emit("show",e)}),300)},__hide:function(e){var t=this;this.__anchorCleanup(!0),void 0===this.__refocusTarget||null===this.__refocusTarget||void 0!==e&&!0===e.qClickOutside||this.__refocusTarget.focus(),this.$el.dispatchEvent(x("popup-hide",{bubbles:!0})),this.__setTimeout((function(){t.__hidePortal(),t.$emit("hide",e)}),300)},__anchorCleanup:function(e){this.absoluteOffset=void 0,void 0!==this.unwatch&&(this.unwatch(),this.unwatch=void 0),!0!==e&&!0!==this.showing||(en.pop(this),this.__unconfigureScrollTarget())},__unconfigureScrollTarget:function(){void 0!==this.__scrollTarget&&(this.__changeScrollEvent(this.__scrollTarget),this.__scrollTarget=void 0)},__configureScrollTarget:function(){void 0===this.anchorEl&&void 0===this.scrollTarget||(this.__scrollTarget=jt(this.anchorEl,this.scrollTarget),this.__changeScrollEvent(this.__scrollTarget,this.updatePosition))},__onAutoClose:function(e){!0!==this.__avoidAutoClose?(Ct(this,e),void 0!==this.qListeners.click&&this.$emit("click",e)):this.__avoidAutoClose=!1},updatePosition:function(){if(void 0!==this.anchorEl&&void 0!==this.__portal){var e=this.__portal.$el;8!==e.nodeType?on({el:e,offset:this.offset,anchorEl:this.anchorEl,anchorOrigin:this.anchorOrigin,selfOrigin:this.selfOrigin,absoluteOffset:this.absoluteOffset,fit:this.fit,cover:this.cover,maxHeight:this.maxHeight,maxWidth:this.maxWidth}):setTimeout(this.updatePosition,25)}},__onClickOutside:function(e){if(!0!==this.persistent&&!0===this.showing){var t=e.target.classList;return this.hide(e),("touchstart"===e.type||t.contains("q-dialog__backdrop"))&&w(e),!0}},__renderPortal:function(e){return e("transition",{props:{name:this.transition}},[!0===this.showing?e("div",{ref:"inner",staticClass:"q-menu q-position-engine scroll"+this.menuClass,class:this.contentClass,style:this.contentStyle,attrs:this.attrs,on:this.onEvents,directives:[{name:"click-outside",value:this.__onClickOutside,arg:this.anchorEl}]},Le(this,"default")):null])}},mounted:function(){this.__processModelChange(this.value)},beforeDestroy:function(){!0===this.showing&&void 0!==this.anchorEl&&this.anchorEl.dispatchEvent(x("popup-hide",{bubbles:!0}))}}),sn=e.extend({name:"QBtnDropdown",mixins:[lt],props:{value:Boolean,split:Boolean,dropdownIcon:String,contentClass:[Array,String,Object],contentStyle:[Array,String,Object],cover:Boolean,persistent:Boolean,noRouteDismiss:Boolean,autoClose:Boolean,menuAnchor:{type:String,default:"bottom right"},menuSelf:{type:String,default:"top right"},menuOffset:Array,disableMainBtn:Boolean,disableDropdown:Boolean,noIconAnimation:Boolean},data:function(){return{showing:this.value}},watch:{value:function(e){void 0!==this.$refs.menu&&this.$refs.menu[e?"show":"hide"]()}},render:function(e){var t=this,n=Le(this,"label",[]),i={"aria-expanded":!0===this.showing?"true":"false","aria-haspopup":"true"};(!0===this.disable||!1===this.split&&!0===this.disableMainBtn||!0===this.disableDropdown)&&(i["aria-disabled"]="true");var r=[e(De,{props:{name:this.dropdownIcon||this.$q.iconSet.arrow.dropdown},class:"q-btn-dropdown__arrow"+(!0===this.showing&&!1===this.noIconAnimation?" rotate-180":"")+(!1===this.split?" q-btn-dropdown__arrow-container":"")})];if(!0!==this.disableDropdown&&r.push(e(an,{ref:"menu",props:{cover:this.cover,fit:!0,persistent:this.persistent,noRouteDismiss:this.noRouteDismiss,autoClose:this.autoClose,anchor:this.menuAnchor,self:this.menuSelf,offset:this.menuOffset,contentClass:this.contentClass,contentStyle:this.contentStyle,separateClosePopup:!0},on:pe(this,"menu",{"before-show":function(e){t.showing=!0,t.$emit("before-show",e)},show:function(e){t.$emit("show",e),t.$emit("input",!0)},"before-hide":function(e){t.showing=!1,t.$emit("before-hide",e)},hide:function(e){t.$emit("hide",e),t.$emit("input",!1)}})},Le(this,"default"))),!1===this.split)return e(bt,{class:"q-btn-dropdown q-btn-dropdown--simple",props:Object.assign({},this.$props,{disable:!0===this.disable||!0===this.disableMainBtn,noWrap:!0,round:!1}),attrs:i,on:pe(this,"nonSpl",{click:function(e){t.$emit("click",e)}})},n.concat(r));var o=e(bt,{class:"q-btn-dropdown--current",props:Object.assign({},this.$props,{disable:!0===this.disable||!0===this.disableMainBtn,noWrap:!0,iconRight:this.iconRight,round:!1}),on:pe(this,"spl",{click:function(e){t.hide(),t.$emit("click",e)}})},n);return e(yt,{props:{outline:this.outline,flat:this.flat,rounded:this.rounded,push:this.push,unelevated:this.unelevated,glossy:this.glossy,stretch:this.stretch},staticClass:"q-btn-dropdown q-btn-dropdown--split no-wrap q-btn-item"},[o,e(bt,{staticClass:"q-btn-dropdown__arrow-container",attrs:i,props:{disable:!0===this.disable||!0===this.disableDropdown,outline:this.outline,flat:this.flat,rounded:this.rounded,push:this.push,size:this.size,color:this.color,textColor:this.textColor,dense:this.dense,ripple:this.ripple}},r)])},methods:{toggle:function(e){this.$refs.menu&&this.$refs.menu.toggle(e)},show:function(e){this.$refs.menu&&this.$refs.menu.show(e)},hide:function(e){this.$refs.menu&&this.$refs.menu.hide(e)}},mounted:function(){!0===this.value&&this.show()}}),ln={props:{name:String},computed:{formAttrs:function(){return{type:"hidden",name:this.name,value:this.value}}},methods:{__injectFormInput:function(e,t,n){e[t](this.$createElement("input",{staticClass:"hidden",class:n,attrs:this.formAttrs,domProps:this.formDomProps}))}}},cn={props:{name:String},computed:{nameProp:function(){return this.name||this.for}}},un=e.extend({name:"QBtnToggle",mixins:[Pe,at,ln],props:{value:{required:!0},options:{type:Array,required:!0,validator:function(e){return e.every((function(e){return("label"in e||"icon"in e||"slot"in e)&&"value"in e}))}},color:String,textColor:String,toggleColor:{type:String,default:"primary"},toggleTextColor:String,outline:Boolean,flat:Boolean,unelevated:Boolean,rounded:Boolean,push:Boolean,glossy:Boolean,size:String,padding:String,noCaps:Boolean,noWrap:Boolean,dense:Boolean,readonly:Boolean,disable:Boolean,stack:Boolean,stretch:Boolean,spread:Boolean,clearable:Boolean},computed:{hasActiveValue:function(){var e=this;return void 0!==this.options.find((function(t){return t.value===e.value}))},formAttrs:function(){return{type:"hidden",name:this.name,value:this.value}},btnOptions:function(){var e=this,t=function(t,n){return void 0===t[n]?e[n]:t[n]};return this.options.map((function(n,i){return{slot:n.slot,options:{key:i,class:n.class,style:n.style,on:Object.assign({},e.qListeners,{click:function(t){return e.__set(n.value,n,t)}}),attrs:n.attrs,props:Object.assign({},n,{slot:void 0,class:void 0,style:void 0,value:void 0,attrs:void 0,outline:e.outline,flat:e.flat,rounded:e.rounded,push:e.push,unelevated:e.unelevated,dense:e.dense,disable:!0===e.disable||!0===n.disable,color:n.value===e.value?t(n,"toggleColor"):t(n,"color"),textColor:n.value===e.value?t(n,"toggleTextColor"):t(n,"textColor"),noCaps:!0===t(n,"noCaps"),noWrap:!0===t(n,"noWrap"),size:t(n,"size"),padding:t(n,"padding"),ripple:t(n,"ripple"),stack:!0===t(n,"stack"),stretch:!0===t(n,"stretch")})}}}))}},methods:{__set:function(e,t,n){!0!==this.readonly&&(this.value===e?!0===this.clearable&&(this.$emit("input",null,null),this.$emit("clear")):this.$emit("input",e,t),this.$emit("click",n))}},render:function(e){var t=this,n=this.btnOptions.map((function(n){return e(bt,n.options,void 0!==n.slot?Le(t,n.slot):void 0)}));return void 0!==this.name&&!0!==this.disable&&!0===this.hasActiveValue&&this.__injectFormInput(n,"push"),e(yt,{staticClass:"q-btn-toggle",props:{outline:this.outline,flat:this.flat,rounded:this.rounded,push:this.push,stretch:this.stretch,unelevated:this.unelevated,glossy:this.glossy,spread:this.spread}},qe(n,this,"default"))}}),dn=e.extend({name:"QCard",mixins:[Pe,je,Ae],props:{square:Boolean,flat:Boolean,bordered:Boolean},computed:{classes:function(){return"q-card"+(!0===this.isDark?" q-card--dark q-dark":"")+(!0===this.bordered?" q-card--bordered":"")+(!0===this.square?" q-card--square no-border-radius":"")+(!0===this.flat?" q-card--flat no-shadow":"")}},render:function(e){return e(this.tag,{class:this.classes,on:Object.assign({},this.qListeners)},Le(this,"default"))}}),hn=e.extend({name:"QCardSection",mixins:[Pe,Ae],props:{horizontal:Boolean},computed:{classes:function(){return"q-card__section q-card__section--"+(!0===this.horizontal?"horiz row no-wrap":"vert")}},render:function(e){return e(this.tag,{class:this.classes,on:Object.assign({},this.qListeners)},Le(this,"default"))}}),fn=e.extend({name:"QCardActions",mixins:[Pe,He],props:{vertical:Boolean},computed:{classes:function(){return"q-card__actions--"+(!0===this.vertical?"vert column":"horiz row")+" "+this.alignClass}},render:function(e){return e("div",{staticClass:"q-card__actions",class:this.classes,on:Object.assign({},this.qListeners)},Le(this,"default"))}});function pn(e){var t=[.06,6,50];return"string"==typeof e&&e.length&&e.split(":").forEach((function(e,n){var i=parseFloat(e);i&&(t[n]=i)})),t}function mn(e){var t=e.__qtouchswipe;void 0!==t&&(C(t,"main"),C(t,"temp"),!0===d.is.firefox&&k(e,!1),void 0!==t.styleCleanup&&t.styleCleanup(),delete e.__qtouchswipe)}var vn={name:"touch-swipe",bind:function(e,t){var n=t.value,i=t.arg,r=t.modifiers;if(void 0!==e.__qtouchswipe&&(mn(e),e.__qtouchswipe_destroyed=!0),!0===r.mouse||!0===d.has.touch){var o=!0===r.mouseCapture?"Capture":"",a={handler:n,sensitivity:pn(i),modifiers:r,direction:dt(r),noop:m,mouseStart:function(e){ft(e,a)&&v(e)&&(S(a,"temp",[[document,"mousemove","move","notPassive"+o],[document,"mouseup","end","notPassiveCapture"]]),a.start(e,!0))},touchStart:function(e){if(ft(e,a)){var t=ht(e.target);S(a,"temp",[[t,"touchmove","move","notPassiveCapture"],[t,"touchcancel","end","notPassiveCapture"],[t,"touchend","end","notPassiveCapture"]]),a.start(e)}},start:function(t,n){!0===d.is.firefox&&k(e,!0);var i=g(t);a.event={x:i.left,y:i.top,time:Date.now(),mouse:!0===n,dir:!1}},move:function(e){if(void 0!==a.event)if(!1===a.event.dir){var t=Date.now()-a.event.time;if(0!==t){var n=g(e),i=n.left-a.event.x,r=Math.abs(i),o=n.top-a.event.y,s=Math.abs(o);if(!0!==a.event.mouse){if(r<a.sensitivity[1]&&s<a.sensitivity[1])return void a.end(e)}else if(r<a.sensitivity[2]&&s<a.sensitivity[2])return;var l=r/t,c=s/t;!0===a.direction.vertical&&r<s&&r<100&&c>a.sensitivity[0]&&(a.event.dir=o<0?"up":"down"),!0===a.direction.horizontal&&r>s&&s<100&&l>a.sensitivity[0]&&(a.event.dir=i<0?"left":"right"),!0===a.direction.up&&r<s&&o<0&&r<100&&c>a.sensitivity[0]&&(a.event.dir="up"),!0===a.direction.down&&r<s&&o>0&&r<100&&c>a.sensitivity[0]&&(a.event.dir="down"),!0===a.direction.left&&r>s&&i<0&&s<100&&l>a.sensitivity[0]&&(a.event.dir="left"),!0===a.direction.right&&r>s&&i>0&&s<100&&l>a.sensitivity[0]&&(a.event.dir="right"),!1!==a.event.dir?(w(e),!0===a.event.mouse&&(document.body.classList.add("no-pointer-events--children"),document.body.classList.add("non-selectable"),wt(),a.styleCleanup=function(e){a.styleCleanup=void 0,document.body.classList.remove("non-selectable");var t=function(){document.body.classList.remove("no-pointer-events--children")};!0===e?setTimeout(t,50):t()}),a.handler({evt:e,touch:!0!==a.event.mouse,mouse:a.event.mouse,direction:a.event.dir,duration:t,distance:{x:r,y:s}})):a.end(e)}}else w(e)},end:function(t){void 0!==a.event&&(C(a,"temp"),!0===d.is.firefox&&k(e,!1),void 0!==a.styleCleanup&&a.styleCleanup(!0),void 0!==t&&!1!==a.event.dir&&w(t),a.event=void 0)}};e.__qtouchswipe=a,!0===r.mouse&&S(a,"main",[[e,"mousedown","mouseStart","passive"+o]]),!0===d.has.touch&&S(a,"main",[[e,"touchstart","touchStart","passive"+(!0===r.capture?"Capture":"")],[e,"touchmove","noop","notPassiveCapture"]])}},update:function(e,t){var n=t.oldValue,i=t.value,r=e.__qtouchswipe;void 0!==r&&n!==i&&("function"!=typeof i&&r.end(),r.handler=i)},unbind:function(e){void 0===e.__qtouchswipe_destroyed?mn(e):delete e.__qtouchswipe_destroyed}},gn=e.extend({name:"QTabPanelWrapper",render:function(e){return e("div",{staticClass:"q-panel scroll",attrs:{role:"tabpanel"},on:pe(this,"stop",{input:b})},Le(this,"default"))}}),_n={mixins:[Pe],directives:{TouchSwipe:vn},props:{value:{required:!0},animated:Boolean,infinite:Boolean,swipeable:Boolean,vertical:Boolean,transitionPrev:String,transitionNext:String,keepAlive:Boolean},data:function(){return{panelIndex:null,panelTransition:null}},computed:{panelDirectives:function(){if(!0===this.swipeable)return[{name:"touch-swipe",value:this.__swipe,modifiers:{horizontal:!0!==this.vertical,vertical:this.vertical,mouse:!0}}]},contentKey:function(){return"string"==typeof this.value||"number"==typeof this.value?this.value:String(this.value)},transitionPrevComputed:function(){return this.transitionPrev||"slide-"+(!0===this.vertical?"down":"right")},transitionNextComputed:function(){return this.transitionNext||"slide-"+(!0===this.vertical?"up":"left")}},watch:{value:function(e,t){var n=this,i=!0===this.__isValidPanelName(e)?this.__getPanelIndex(e):-1;!0!==this.__forcedPanelTransition&&this.__updatePanelTransition(-1===i?0:i<this.__getPanelIndex(t)?-1:1),this.panelIndex!==i&&(this.panelIndex=i,this.$emit("before-transition",e,t),this.$nextTick((function(){n.$emit("transition",e,t)})))}},methods:{next:function(){this.__go(1)},previous:function(){this.__go(-1)},goTo:function(e){this.$emit("input",e)},__isValidPanelName:function(e){return null!=e&&""!==e},__getPanelIndex:function(e){return this.panels.findIndex((function(t){var n=t.componentOptions;return n&&n.propsData.name===e&&""!==n.propsData.disable&&!0!==n.propsData.disable}))},__getAllPanels:function(){var e=this;return this.panels.filter((function(t){return void 0!==t.componentOptions&&e.__isValidPanelName(t.componentOptions.propsData.name)}))},__getAvailablePanels:function(){return this.panels.filter((function(e){var t=e.componentOptions;return t&&void 0!==t.propsData.name&&""!==t.propsData.disable&&!0!==t.propsData.disable}))},__updatePanelTransition:function(e){var t=0!==e&&!0===this.animated&&-1!==this.panelIndex?"q-transition--"+(-1===e?this.transitionPrevComputed:this.transitionNextComputed):null;this.panelTransition!==t&&(this.panelTransition=t)},__go:function(e,t){var n=this;void 0===t&&(t=this.panelIndex);for(var i=t+e,r=this.panels;i>-1&&i<r.length;){var o=r[i].componentOptions;if(void 0!==o&&""!==o.propsData.disable&&!0!==o.propsData.disable)return this.__updatePanelTransition(e),this.__forcedPanelTransition=!0,this.$emit("input",r[i].componentOptions.propsData.name),void setTimeout((function(){n.__forcedPanelTransition=!1}));i+=e}!0===this.infinite&&r.length>0&&-1!==t&&t!==r.length&&this.__go(e,-1===e?r.length:-1)},__swipe:function(e){var t=!0===this.vertical?"up":"left";this.__go((!0===this.$q.lang.rtl?-1:1)*(e.direction===t?1:-1))},__updatePanelIndex:function(){var e=this.__getPanelIndex(this.value);return this.panelIndex!==e&&(this.panelIndex=e),!0},__getPanelContent:function(e){if(0!==this.panels.length){var t=this.__isValidPanelName(this.value)&&this.__updatePanelIndex()&&this.panels[this.panelIndex],n=!0===this.keepAlive?[e("keep-alive",[e(gn,{key:this.contentKey},[t])])]:[e("div",{staticClass:"q-panel scroll",key:this.contentKey,attrs:{role:"tabpanel"},on:pe(this,"stop",{input:b})},[t])];return!0===this.animated?[e("transition",{props:{name:this.panelTransition}},n)]:n}}},render:function(e){return this.panels=Le(this,"default",[]),this.__renderPanels(e)}},bn={mixins:[Pe],props:{name:{required:!0},disable:Boolean}},yn={props:{fullscreen:Boolean,noRouteFullscreenExit:Boolean},data:function(){return{inFullscreen:!1}},watch:{$route:function(){!0!==this.noRouteFullscreenExit&&this.exitFullscreen()},fullscreen:function(e){this.inFullscreen!==e&&this.toggleFullscreen()},inFullscreen:function(e){this.$emit("update:fullscreen",e),this.$emit("fullscreen",e)}},methods:{toggleFullscreen:function(){!0===this.inFullscreen?this.exitFullscreen():this.setFullscreen()},setFullscreen:function(){!0!==this.inFullscreen&&(this.inFullscreen=!0,this.container=this.$el.parentNode,this.container.replaceChild(this.fullscreenFillerNode,this.$el),document.body.appendChild(this.$el),document.body.classList.add("q-body--fullscreen-mixin"),this.__historyFullscreen={handler:this.exitFullscreen},z.add(this.__historyFullscreen))},exitFullscreen:function(){var e=this;!0===this.inFullscreen&&(void 0!==this.__historyFullscreen&&(z.remove(this.__historyFullscreen),this.__historyFullscreen=void 0),this.container.replaceChild(this.$el,this.fullscreenFillerNode),document.body.classList.remove("q-body--fullscreen-mixin"),this.inFullscreen=!1,void 0!==this.$el.scrollIntoView&&setTimeout((function(){e.$el.scrollIntoView()})))}},beforeMount:function(){this.fullscreenFillerNode=document.createElement("span")},mounted:function(){!0===this.fullscreen&&this.setFullscreen()},beforeDestroy:function(){this.exitFullscreen()}},wn="function"==typeof Map,kn="function"==typeof Set,xn="function"==typeof ArrayBuffer;function Sn(e,t){if(e===t)return!0;if(null!==e&&null!==t&&"object"==typeof e&&"object"==typeof t){if(e.constructor!==t.constructor)return!1;var n,i;if(e.constructor===Array){if((n=e.length)!==t.length)return!1;for(i=n;0!=i--;)if(!0!==Sn(e[i],t[i]))return!1;return!0}if(!0===wn&&e.constructor===Map){if(e.size!==t.size)return!1;for(i=e.entries().next();!0!==i.done;){if(!0!==t.has(i.value[0]))return!1;i=i.next()}for(i=e.entries().next();!0!==i.done;){if(!0!==Sn(i.value[1],t.get(i.value[0])))return!1;i=i.next()}return!0}if(!0===kn&&e.constructor===Set){if(e.size!==t.size)return!1;for(i=e.entries().next();!0!==i.done;){if(!0!==t.has(i.value[0]))return!1;i=i.next()}return!0}if(!0===xn&&null!=e.buffer&&e.buffer.constructor===ArrayBuffer){if((n=e.length)!==t.length)return!1;for(i=n;0!=i--;)if(e[i]!==t[i])return!1;return!0}if(e.constructor===RegExp)return e.source===t.source&&e.flags===t.flags;if(e.valueOf!==Object.prototype.valueOf)return e.valueOf()===t.valueOf();if(e.toString!==Object.prototype.toString)return e.toString()===t.toString();var r=Object.keys(e);if((n=r.length)!==Object.keys(t).length)return!1;for(i=n;0!=i--;){var o=r[i];if(!0!==Sn(e[o],t[o]))return!1}return!0}return e!=e&&t!=t}function Cn(e){return"[object Date]"===Object.prototype.toString.call(e)}function Mn(e){return"number"==typeof e&&isFinite(e)}var Tn=e.extend({name:"QCarousel",mixins:[je,_n,yn],props:{height:String,padding:Boolean,controlType:{type:String,validator:function(e){return["regular","flat","outline","push","unelevated"].includes(e)},default:"flat"},controlColor:String,controlTextColor:String,autoplay:[Number,Boolean],arrows:Boolean,prevIcon:String,nextIcon:String,navigation:Boolean,navigationPosition:{type:String,validator:function(e){return["top","right","bottom","left"].includes(e)}},navigationIcon:String,navigationActiveIcon:String,thumbnails:Boolean},computed:{style:function(){if(!0!==this.inFullscreen&&void 0!==this.height)return{height:this.height}},direction:function(){return!0===this.vertical?"vertical":"horizontal"},classes:function(){return"q-carousel q-panel-parent q-carousel--with"+(!0===this.padding?"":"out")+"-padding"+(!0===this.inFullscreen?" fullscreen":"")+(!0===this.isDark?" q-carousel--dark q-dark":"")+(!0===this.arrows?" q-carousel--arrows-"+this.direction:"")+(!0===this.navigation?" q-carousel--navigation-"+this.navigationPositionComputed:"")},arrowIcons:function(){var e=[this.prevIcon||this.$q.iconSet.carousel[!0===this.vertical?"up":"left"],this.nextIcon||this.$q.iconSet.carousel[!0===this.vertical?"down":"right"]];return!1===this.vertical&&!0===this.$q.lang.rtl?e.reverse():e},navIcon:function(){return this.navigationIcon||this.$q.iconSet.carousel.navigationIcon},navActiveIcon:function(){return this.navigationActiveIcon||this.navIcon},navigationPositionComputed:function(){return this.navigationPosition||(!0===this.vertical?"right":"bottom")},controlProps:function(){var e;return(e={color:this.controlColor,textColor:this.controlTextColor,round:!0})[this.controlType]=!0,e.dense=!0,e},transitionPrevComputed:function(){return this.transitionPrev||"fade"},transitionNextComputed:function(){return this.transitionNext||"fade"}},watch:{value:function(){this.autoplay&&(clearInterval(this.timer),this.__startTimer())},autoplay:function(e){e?this.__startTimer():clearInterval(this.timer)}},methods:{__startTimer:function(){this.timer=setTimeout(this.next,Mn(this.autoplay)?this.autoplay:5e3)},__getNavigationContainer:function(e,t,n){return e("div",{class:"q-carousel__control q-carousel__navigation no-wrap absolute flex q-carousel__navigation--"+t+" q-carousel__navigation--"+this.navigationPositionComputed+(void 0!==this.controlColor?" text-"+this.controlColor:"")},[e("div",{staticClass:"q-carousel__navigation-inner flex flex-center no-wrap"},this.__getAvailablePanels().map(n))])},__getContent:function(e){var t=this,n=[];if(!0===this.navigation){var i=void 0!==this.$scopedSlots["navigation-icon"]?this.$scopedSlots["navigation-icon"]:function(n){return e(bt,{key:"nav"+n.name,class:"q-carousel__navigation-icon q-carousel__navigation-icon--"+(!0===n.active?"":"in")+"active",props:n.btnProps,on:pe(t,"nav#"+n.name,{click:n.onClick})})},r=this.panels.length-1;n.push(this.__getNavigationContainer(e,"buttons",(function(e,n){var o=e.componentOptions.propsData.name,a=t.panelIndex===n;return i({index:n,maxIndex:r,name:o,active:a,btnProps:Object.assign({},{icon:!0===a?t.navActiveIcon:t.navIcon,size:"sm"},t.controlProps),onClick:function(){t.goTo(o)}})})))}else if(!0===this.thumbnails){var o=void 0!==this.controlColor?" text-"+this.controlColor:"";n.push(this.__getNavigationContainer(e,"thumbnails",(function(n){var i=n.componentOptions.propsData;return e("img",{class:"q-carousel__thumbnail q-carousel__thumbnail--"+(i.name===t.value?"":"in")+"active"+o,attrs:{src:i.imgSrc},key:"tmb#"+i.name,on:pe(t,"tmb#"+i.name,{click:function(){t.goTo(i.name)}})})})))}return!0===this.arrows&&this.panelIndex>=0&&((!0===this.infinite||this.panelIndex>0)&&n.push(e("div",{key:"prev",staticClass:"q-carousel__control q-carousel__arrow q-carousel__prev-arrow q-carousel__prev-arrow--"+this.direction+" absolute flex flex-center"},[e(bt,{props:Object.assign({},{icon:this.arrowIcons[0]},this.controlProps),on:pe(this,"prev",{click:this.previous})})])),(!0===this.infinite||this.panelIndex<this.panels.length-1)&&n.push(e("div",{key:"next",staticClass:"q-carousel__control q-carousel__arrow q-carousel__next-arrow q-carousel__next-arrow--"+this.direction+" absolute flex flex-center"},[e(bt,{props:Object.assign({},{icon:this.arrowIcons[1]},this.controlProps),on:pe(this,"next",{click:this.next})})]))),qe(n,this,"control")},__renderPanels:function(e){return e("div",{style:this.style,class:this.classes,on:Object.assign({},this.qListeners)},[e("div",{staticClass:"q-carousel__slides-container",directives:this.panelDirectives},this.__getPanelContent(e))].concat(this.__getContent(e)))}},mounted:function(){this.autoplay&&this.__startTimer()},beforeDestroy:function(){clearInterval(this.timer)}}),An=e.extend({name:"QCarouselSlide",mixins:[bn],props:{imgSrc:String},computed:{style:function(){if(this.imgSrc)return{backgroundImage:'url("'+this.imgSrc+'")'}}},render:function(e){return e("div",{staticClass:"q-carousel__slide",style:this.style,on:Object.assign({},this.qListeners)},Le(this,"default"))}}),Pn=e.extend({name:"QCarouselControl",mixins:[Pe],props:{position:{type:String,default:"bottom-right",validator:function(e){return["top-right","top-left","bottom-right","bottom-left","top","right","bottom","left"].includes(e)}},offset:{type:Array,default:function(){return[18,18]},validator:function(e){return 2===e.length}}},computed:{classes:function(){return"absolute-"+this.position},style:function(){return{margin:this.offset[1]+"px "+this.offset[0]+"px"}}},render:function(e){return e("div",{staticClass:"q-carousel__control absolute",style:this.style,class:this.classes,on:Object.assign({},this.qListeners)},Le(this,"default"))}}),Ln=e.extend({name:"QChatMessage",mixins:[Pe],props:{sent:Boolean,label:String,bgColor:String,textColor:String,name:String,avatar:String,text:Array,stamp:String,size:String,labelSanitize:Boolean,nameSanitize:Boolean,textSanitize:Boolean,stampSanitize:Boolean},computed:{textClass:function(){return"q-message-text-content q-message-text-content--"+this.op+(void 0!==this.textColor?" text-"+this.textColor:"")},messageClass:function(){return"q-message-text q-message-text--"+this.op+(void 0!==this.bgColor?" text-"+this.bgColor:"")},containerClass:function(){return"q-message-container row items-end no-wrap"+(!0===this.sent?" reverse":"")},sizeClass:function(){if(void 0!==this.size)return"col-"+this.size},op:function(){return!0===this.sent?"sent":"received"}},methods:{__getText:function(e){var t=this,n=!0===this.textSanitize?"textContent":"innerHTML",i=!0===this.stampSanitize?"textContent":"innerHTML";return this.text.map((function(r,o){var a,s;return e("div",{key:o,class:t.messageClass},[e("div",{class:t.textClass},[e("div",{domProps:(a={},a[n]=r,a)}),t.stamp?e("div",{staticClass:"q-message-stamp",domProps:(s={},s[i]=t.stamp,s)}):null])])}))},__getMessage:function(e){var t,n=Oe(this,"default",[]);return void 0!==this.stamp&&n.push(e("div",{staticClass:"q-message-stamp",domProps:(t={},t[!0===this.stampSanitize?"textContent":"innerHTML"]=this.stamp,t)})),e("div",{class:this.messageClass},[e("div",{staticClass:"q-message-text-content",class:this.textClass},n)])}},render:function(e){var t,n,i=[];void 0!==this.$scopedSlots.avatar?i.push(this.$scopedSlots.avatar()):void 0!==this.avatar&&i.push(e("img",{class:"q-message-avatar q-message-avatar--"+this.op,attrs:{src:this.avatar,"aria-hidden":"true"}}));var r=[];void 0!==this.name&&r.push(e("div",{class:"q-message-name q-message-name--"+this.op,domProps:(t={},t[!0===this.nameSanitize?"textContent":"innerHTML"]=this.name,t)})),void 0!==this.text&&r.push(this.__getText(e)),void 0!==this.$scopedSlots.default&&r.push(this.__getMessage(e)),i.push(e("div",{class:this.sizeClass},r));var o=[];return this.label&&o.push(e("div",{staticClass:"q-message-label text-center",domProps:(n={},n[!0===this.labelSanitize?"textContent":"innerHTML"]=this.label,n)})),o.push(e("div",{class:this.containerClass},i)),e("div",{class:"q-message q-message-"+this.op,on:Object.assign({},this.qListeners)},o)}}),On=Me({xs:30,sm:35,md:40,lg:50,xl:60}),qn={computed:{__refocusTargetEl:function(){if(!0!==this.disable)return this.$createElement("span",{ref:"refocusTarget",staticClass:"no-outline",attrs:{tabindex:-1}})}},methods:{__refocusTarget:function(e){void 0!==e&&0===e.type.indexOf("key")?document.activeElement!==this.$el&&!0===this.$el.contains(document.activeElement)&&this.$el.focus():void 0!==e&&!0!==this.$el.contains(e.target)||void 0===this.$refs.refocusTarget||this.$refs.refocusTarget.focus()}}},En={mixins:[je,On,ln,qn],props:{value:{required:!0,default:null},val:{},trueValue:{default:!0},falseValue:{default:!1},indeterminateValue:{default:null},toggleOrder:{type:String,validator:function(e){return"tf"===e||"ft"===e}},toggleIndeterminate:Boolean,label:String,leftLabel:Boolean,fontSize:String,color:String,keepColor:Boolean,dense:Boolean,disable:Boolean,tabindex:[String,Number]},computed:{isTrue:function(){return!0===this.modelIsArray?this.index>-1:this.value===this.trueValue},isFalse:function(){return!0===this.modelIsArray?-1===this.index:this.value===this.falseValue},isIndeterminate:function(){return!1===this.isTrue&&!1===this.isFalse},index:function(){if(!0===this.modelIsArray)return this.value.indexOf(this.val)},modelIsArray:function(){return void 0!==this.val&&Array.isArray(this.value)},computedTabindex:function(){return!0===this.disable?-1:this.tabindex||0},labelStyle:function(){if(void 0!==this.fontSize)return{fontSize:this.fontSize}},classes:function(){return"q-"+this.type+" cursor-pointer no-outline row inline no-wrap items-center"+(!0===this.disable?" disabled":"")+(!0===this.isDark?" q-"+this.type+"--dark":"")+(!0===this.dense?" q-"+this.type+"--dense":"")+(!0===this.leftLabel?" reverse":"")},innerClass:function(){var e=!0===this.isTrue?"truthy":!0===this.isFalse?"falsy":"indet",t=void 0===this.color||!0!==this.keepColor&&("toggle"===this.type?!0!==this.isTrue:!0===this.isFalse)?"":" text-"+this.color;return"q-"+this.type+"__inner--"+e+t},formAttrs:function(){var e={type:"checkbox"};return void 0!==this.name&&Object.assign(e,{checked:this.isTrue,name:this.name,value:!0===this.modelIsArray?this.val:this.trueValue}),e},attrs:function(){var e={tabindex:this.computedTabindex,role:"checkbox","aria-label":this.label,"aria-checked":!0===this.isIndeterminate?"mixed":!0===this.isTrue?"true":"false"};return!0===this.disable&&(e["aria-disabled"]="true"),e}},methods:{toggle:function(e){void 0!==e&&(w(e),this.__refocusTarget(e)),!0!==this.disable&&this.$emit("input",this.__getNextValue(),e)},__getNextValue:function(){if(!0===this.modelIsArray){if(!0===this.isTrue){var e=this.value.slice();return e.splice(this.index,1),e}return this.value.concat([this.val])}if(!0===this.isTrue){if("ft"!==this.toggleOrder||!1===this.toggleIndeterminate)return this.falseValue}else{if(!0!==this.isFalse)return"ft"!==this.toggleOrder?this.trueValue:this.falseValue;if("ft"===this.toggleOrder||!1===this.toggleIndeterminate)return this.trueValue}return this.indeterminateValue},__onKeydown:function(e){13!==e.keyCode&&32!==e.keyCode||w(e)},__onKeyup:function(e){13!==e.keyCode&&32!==e.keyCode||this.toggle(e)}},render:function(e){var t=this.__getInner(e);!0!==this.disable&&this.__injectFormInput(t,"unshift","q-"+this.type+"__native absolute q-ma-none q-pa-none invisible");var n=[e("div",{staticClass:"q-"+this.type+"__inner relative-position no-pointer-events",class:this.innerClass,style:this.sizeStyle},t)];void 0!==this.__refocusTargetEl&&n.push(this.__refocusTargetEl);var i=void 0!==this.label?qe([this.label],this,"default"):Le(this,"default");return void 0!==i&&n.push(e("div",{staticClass:"q-"+this.type+"__label q-anchor--skip"},i)),e("div",{class:this.classes,attrs:this.attrs,on:pe(this,"inpExt",{click:this.toggle,keydown:this.__onKeydown,keyup:this.__onKeyup})},n)}},Dn=e.extend({name:"QCheckbox",mixins:[En],methods:{__getInner:function(e){return[e("div",{staticClass:"q-checkbox__bg absolute"},[e("svg",{staticClass:"q-checkbox__svg fit absolute-full",attrs:{focusable:"false",viewBox:"0 0 24 24","aria-hidden":"true"}},[e("path",{staticClass:"q-checkbox__truthy",attrs:{fill:"none",d:"M1.73,12.91 8.1,19.28 22.79,4.59"}}),e("path",{staticClass:"q-checkbox__indet",attrs:{d:"M4,14H20V10H4"}})])])]}},created:function(){this.type="checkbox"}}),zn=e.extend({name:"QChip",mixins:[at,je,Me({xs:8,sm:10,md:14,lg:20,xl:24})],model:{event:"remove"},props:{dense:Boolean,icon:String,iconRight:String,iconRemove:String,label:[String,Number],color:String,textColor:String,value:{type:Boolean,default:!0},selected:{type:Boolean,default:null},square:Boolean,outline:Boolean,clickable:Boolean,removable:Boolean,tabindex:[String,Number],disable:Boolean},computed:{classes:function(){var e,t=!0===this.outline&&this.color||this.textColor;return(e={})["bg-"+this.color]=!1===this.outline&&void 0!==this.color,e["text-"+t+" q-chip--colored"]=t,e.disabled=this.disable,e["q-chip--dense"]=this.dense,e["q-chip--outline"]=this.outline,e["q-chip--selected"]=this.selected,e["q-chip--clickable cursor-pointer non-selectable q-hoverable"]=this.isClickable,e["q-chip--square"]=this.square,e["q-chip--dark q-dark"]=this.isDark,e},hasLeftIcon:function(){return!0===this.selected||void 0!==this.icon},isClickable:function(){return!1===this.disable&&(!0===this.clickable||null!==this.selected)},attrs:function(){return!0===this.disable?{tabindex:-1,"aria-disabled":"true"}:{tabindex:this.tabindex||0}}},methods:{__onKeyup:function(e){13===e.keyCode&&this.__onClick(e)},__onClick:function(e){this.disable||(this.$emit("update:selected",!this.selected),this.$emit("click",e))},__onRemove:function(e){void 0!==e.keyCode&&13!==e.keyCode||(w(e),!this.disable&&this.$emit("remove",!1))},__getContent:function(e){var t=[];!0===this.isClickable&&t.push(e("div",{staticClass:"q-focus-helper"})),!0===this.hasLeftIcon&&t.push(e(De,{staticClass:"q-chip__icon q-chip__icon--left",props:{name:!0===this.selected?this.$q.iconSet.chip.selected:this.icon}}));var n=void 0!==this.label?[e("div",{staticClass:"ellipsis"},[this.label])]:void 0;return t.push(e("div",{staticClass:"q-chip__content col row no-wrap items-center q-anchor--skip"},Ee(n,this,"default"))),this.iconRight&&t.push(e(De,{staticClass:"q-chip__icon q-chip__icon--right",props:{name:this.iconRight}})),!0===this.removable&&t.push(e(De,{staticClass:"q-chip__icon q-chip__icon--remove cursor-pointer",props:{name:this.iconRemove||this.$q.iconSet.chip.remove},attrs:this.attrs,on:pe(this,"non",{click:this.__onRemove,keyup:this.__onRemove})})),t}},render:function(e){if(!1!==this.value){var t={staticClass:"q-chip row inline no-wrap items-center",class:this.classes,style:this.sizeStyle};return!0===this.isClickable&&Object.assign(t,{attrs:this.attrs,on:pe(this,"click",{click:this.__onClick,keyup:this.__onKeyup}),directives:pe(this,"dir#"+this.ripple,[{name:"ripple",value:this.ripple}])}),e("div",t,this.__getContent(e))}}}),Nn=100*Math.PI,jn=Math.round(1e3*Nn)/1e3,Rn=e.extend({name:"QCircularProgress",mixins:[Pe,Te],props:{value:{type:Number,default:0},min:{type:Number,default:0},max:{type:Number,default:100},color:String,centerColor:String,trackColor:String,fontSize:String,thickness:{type:Number,default:.2,validator:function(e){return e>=0&&e<=1}},angle:{type:Number,default:0},indeterminate:Boolean,showValue:Boolean,reverse:Boolean,instantFeedback:Boolean},computed:{normalizedValue:function(){return ue(this.value,this.min,this.max)},svgStyle:function(){return{transform:"rotate3d(0, 0, 1, "+(this.angle-90)+"deg)"}},circleStyle:function(){if(!0!==this.instantFeedback&&!0!==this.indeterminate)return{transition:"stroke-dashoffset 0.6s ease 0s, stroke 0.6s ease"}},dir:function(){return(!0===this.$q.lang.rtl?-1:1)*(this.reverse?-1:1)},viewBox:function(){return 100/(1-this.thickness/2)},viewBoxAttr:function(){return this.viewBox/2+" "+this.viewBox/2+" "+this.viewBox+" "+this.viewBox},strokeDashOffset:function(){var e=1-(this.normalizedValue-this.min)/(this.max-this.min);return this.dir*e*Nn},strokeWidth:function(){return this.thickness/2*this.viewBox},attrs:function(){return{role:"progressbar","aria-valuemin":this.min,"aria-valuemax":this.max,"aria-valuenow":!0===this.indeterminate?void 0:this.normalizedValue}}},methods:{__getCircle:function(e,t){var n=t.thickness,i=t.offset,r=t.color;return e("circle",{staticClass:"q-circular-progress__"+t.cls,class:void 0!==r?"text-"+r:null,style:this.circleStyle,attrs:{fill:"transparent",stroke:"currentColor","stroke-width":n,"stroke-dasharray":jn,"stroke-dashoffset":i,cx:this.viewBox,cy:this.viewBox,r:50}})}},render:function(e){var t=[];void 0!==this.centerColor&&"transparent"!==this.centerColor&&t.push(e("circle",{staticClass:"q-circular-progress__center",class:"text-"+this.centerColor,attrs:{fill:"currentColor",r:50-this.strokeWidth/2,cx:this.viewBox,cy:this.viewBox}})),void 0!==this.trackColor&&"transparent"!==this.trackColor&&t.push(this.__getCircle(e,{cls:"track",thickness:this.strokeWidth,offset:0,color:this.trackColor})),t.push(this.__getCircle(e,{cls:"circle",thickness:this.strokeWidth,offset:this.strokeDashOffset,color:this.color}));var n=[e("svg",{staticClass:"q-circular-progress__svg",style:this.svgStyle,attrs:{focusable:"false",viewBox:this.viewBoxAttr,"aria-hidden":"true"}},t)];return!0===this.showValue&&n.push(e("div",{staticClass:"q-circular-progress__text absolute-full row flex-center content-center",style:{fontSize:this.fontSize}},void 0!==this.$scopedSlots.default?this.$scopedSlots.default():[e("div",[this.normalizedValue])])),e("div",{staticClass:"q-circular-progress",class:"q-circular-progress--"+(!0===this.indeterminate?"in":"")+"determinate",style:this.sizeStyle,on:Object.assign({},this.qListeners),attrs:this.attrs},Ee(n,this,"internal"))}}),In=/^#[0-9a-fA-F]{3}([0-9a-fA-F]{3})?$/,$n=/^#[0-9a-fA-F]{4}([0-9a-fA-F]{4})?$/,Fn=/^#([0-9a-fA-F]{3}|[0-9a-fA-F]{4}|[0-9a-fA-F]{6}|[0-9a-fA-F]{8})$/,Bn=/^rgb\(((0|[1-9][\d]?|1[\d]{0,2}|2[\d]?|2[0-4][\d]|25[0-5]),){2}(0|[1-9][\d]?|1[\d]{0,2}|2[\d]?|2[0-4][\d]|25[0-5])\)$/,Vn=/^rgba\(((0|[1-9][\d]?|1[\d]{0,2}|2[\d]?|2[0-4][\d]|25[0-5]),){2}(0|[1-9][\d]?|1[\d]{0,2}|2[\d]?|2[0-4][\d]|25[0-5]),(0|0\.[0-9]+[1-9]|0\.[1-9]+|1)\)$/,Hn={date:function(e){return/^-?[\d]+\/[0-1]\d\/[0-3]\d$/.test(e)},time:function(e){return/^([0-1]?\d|2[0-3]):[0-5]\d$/.test(e)},fulltime:function(e){return/^([0-1]?\d|2[0-3]):[0-5]\d:[0-5]\d$/.test(e)},timeOrFulltime:function(e){return/^([0-1]?\d|2[0-3]):[0-5]\d(:[0-5]\d)?$/.test(e)},hexColor:function(e){return In.test(e)},hexaColor:function(e){return $n.test(e)},hexOrHexaColor:function(e){return Fn.test(e)},rgbColor:function(e){return Bn.test(e)},rgbaColor:function(e){return Vn.test(e)},rgbOrRgbaColor:function(e){return Bn.test(e)||Vn.test(e)},hexOrRgbColor:function(e){return In.test(e)||Bn.test(e)},hexaOrRgbaColor:function(e){return $n.test(e)||Vn.test(e)},anyColor:function(e){return Fn.test(e)||Bn.test(e)||Vn.test(e)}},Wn={testPattern:Hn};function Un(e,t,n){var i,r=g(e),o=r.left-t.event.x,a=r.top-t.event.y,s=Math.abs(o),l=Math.abs(a),c=t.direction;!0===c.horizontal&&!0!==c.vertical?i=o<0?"left":"right":!0!==c.horizontal&&!0===c.vertical?i=a<0?"up":"down":!0===c.up&&a<0?(i="up",s>l&&(!0===c.left&&o<0?i="left":!0===c.right&&o>0&&(i="right"))):!0===c.down&&a>0?(i="down",s>l&&(!0===c.left&&o<0?i="left":!0===c.right&&o>0&&(i="right"))):!0===c.left&&o<0?(i="left",s<l&&(!0===c.up&&a<0?i="up":!0===c.down&&a>0&&(i="down"))):!0===c.right&&o>0&&(i="right",s<l&&(!0===c.up&&a<0?i="up":!0===c.down&&a>0&&(i="down")));var u=!1;if(void 0===i&&!1===n){if(!0===t.event.isFirst||void 0===t.event.lastDir)return{};u=!0,"left"===(i=t.event.lastDir)||"right"===i?(r.left-=o,s=0,o=0):(r.top-=a,l=0,a=0)}return{synthetic:u,payload:{evt:e,touch:!0!==t.event.mouse,mouse:!0===t.event.mouse,position:r,direction:i,isFirst:t.event.isFirst,isFinal:!0===n,duration:Date.now()-t.event.time,distance:{x:s,y:l},offset:{x:o,y:a},delta:{x:r.left-t.event.lastX,y:r.top-t.event.lastY}}}}function Yn(e){var t=e.__qtouchpan;void 0!==t&&(void 0!==t.event&&t.end(),C(t,"main"),C(t,"temp"),!0===d.is.firefox&&k(e,!1),void 0!==t.styleCleanup&&t.styleCleanup(),delete e.__qtouchpan)}var Gn=0,Qn={name:"touch-pan",bind:function(e,t){var n=t.value,i=t.modifiers;if(void 0!==e.__qtouchpan&&(Yn(e),e.__qtouchpan_destroyed=!0),!0===i.mouse||!0===d.has.touch){var r={uid:"qvtp_"+Gn++,handler:n,modifiers:i,direction:dt(i),noop:m,mouseStart:function(e){ft(e,r)&&v(e)&&(S(r,"temp",[[document,"mousemove","move","notPassiveCapture"],[document,"mouseup","end","passiveCapture"]]),r.start(e,!0))},touchStart:function(e){if(ft(e,r)){var t=ht(e.target);S(r,"temp",[[t,"touchmove","move","notPassiveCapture"],[t,"touchcancel","end","passiveCapture"],[t,"touchend","end","passiveCapture"]]),r.start(e)}},start:function(t,n){!0===d.is.firefox&&k(e,!0),r.lastEvt=t;var o=g(t);if(!0===n||!0===i.stop){if(!0!==r.direction.all&&(!0!==n||!0!==r.direction.mouseAllDir)){var a=t.type.indexOf("mouse")>-1?new MouseEvent(t.type,t):new TouchEvent(t.type,t);!0===t.defaultPrevented&&y(a),!0===t.cancelBubble&&b(a),a.qClonedBy=void 0===t.qClonedBy?[r.uid]:t.qClonedBy.concat(r.uid),a.qKeyEvent=t.qKeyEvent,a.qClickOutside=t.qClickOutside,r.initialEvent={target:t.target,event:a}}b(t)}r.event={x:o.left,y:o.top,time:Date.now(),mouse:!0===n,detected:!1,isFirst:!0,isFinal:!1,lastX:o.left,lastY:o.top}},move:function(e){if(void 0!==r.event){r.lastEvt=e;var t=!0===r.event.mouse,n=function(){o(e,t),!0!==i.preserveCursor&&(document.documentElement.style.cursor="grabbing"),!0===t&&document.body.classList.add("no-pointer-events--children"),document.body.classList.add("non-selectable"),wt(),r.styleCleanup=function(e){if(r.styleCleanup=void 0,!0!==i.preserveCursor&&(document.documentElement.style.cursor=""),document.body.classList.remove("non-selectable"),!0===t){var n=function(){document.body.classList.remove("no-pointer-events--children")};void 0!==e?setTimeout((function(){n(),e()}),50):n()}else void 0!==e&&e()}};if(!0!==r.event.detected){if(!0===r.direction.all||!0===t&&!0===r.modifiers.mouseAllDir)return n(),r.event.detected=!0,void r.move(e);var a=g(e),s=a.left-r.event.x,l=a.top-r.event.y,c=Math.abs(s),u=Math.abs(l);c!==u&&(!0===r.direction.horizontal&&c>u||!0===r.direction.vertical&&c<u||!0===r.direction.up&&c<u&&l<0||!0===r.direction.down&&c<u&&l>0||!0===r.direction.left&&c>u&&s<0||!0===r.direction.right&&c>u&&s>0?(r.event.detected=!0,r.move(e)):r.end(e,!0))}else{!0!==r.event.isFirst&&o(e,r.event.mouse);var d=Un(e,r,!1),h=d.payload,f=d.synthetic;void 0!==h&&(!1===r.handler(h)?r.end(e):(void 0===r.styleCleanup&&!0===r.event.isFirst&&n(),r.event.lastX=h.position.left,r.event.lastY=h.position.top,r.event.lastDir=!0===f?void 0:h.direction,r.event.isFirst=!1))}}},end:function(t,n){if(void 0!==r.event){if(C(r,"temp"),!0===d.is.firefox&&k(e,!1),!0===n)void 0!==r.styleCleanup&&r.styleCleanup(),!0!==r.event.detected&&void 0!==r.initialEvent&&r.initialEvent.target.dispatchEvent(r.initialEvent.event);else if(!0===r.event.detected){!0===r.event.isFirst&&r.handler(Un(void 0===t?r.lastEvt:t,r).payload);var i=Un(void 0===t?r.lastEvt:t,r,!0).payload,o=function(){r.handler(i)};void 0!==r.styleCleanup?r.styleCleanup(o):o()}r.event=void 0,r.initialEvent=void 0,r.lastEvt=void 0}}};e.__qtouchpan=r,!0===i.mouse&&S(r,"main",[[e,"mousedown","mouseStart","passive"+(!0===i.mouseCapture?"Capture":"")]]),!0===d.has.touch&&S(r,"main",[[e,"touchstart","touchStart","passive"+(!0===i.capture?"Capture":"")],[e,"touchmove","noop","notPassiveCapture"]])}function o(e,t){!0===i.mouse&&!0===t?w(e):(!0===i.stop&&b(e),!0===i.prevent&&y(e))}},update:function(e,t){var n=t.oldValue,i=t.value,r=e.__qtouchpan;void 0!==r&&n!==i&&("function"!=typeof i&&r.end(),r.handler=i)},unbind:function(e){void 0===e.__qtouchpan_destroyed?Yn(e):delete e.__qtouchpan_destroyed}},Kn=[34,37,40,33,39,38];function Zn(e,t,n,i){var r=g(e),o=ue(!0===i?(r.top-t.top)/t.height:(r.left-t.left)/t.width,0,1);return!0===n?1-o:o}function Jn(e,t,n,i,r){var o=t+e*(n-t);if(i>0){var a=(o-t)%i;o+=(Math.abs(a)>=i/2?(a<0?-1:1)*i:0)-a}return r>0&&(o=parseFloat(o.toFixed(r))),ue(o,t,n)}var Xn={mixins:[je,ln],directives:{TouchPan:Qn},props:{min:{type:Number,default:0},max:{type:Number,default:100},step:{type:Number,default:1,validator:function(e){return e>=0}},color:String,labelColor:String,labelTextColor:String,dense:Boolean,label:Boolean,labelAlways:Boolean,markers:Boolean,snap:Boolean,vertical:Boolean,reverse:Boolean,disable:Boolean,readonly:Boolean,tabindex:[String,Number],thumbPath:{type:String,default:"M 4, 10 a 6,6 0 1,0 12,0 a 6,6 0 1,0 -12,0"}},data:function(){return{active:!1,preventFocus:!1,focus:!1}},computed:{axis:function(){return!0===this.vertical?"--v":"--h"},classes:function(){return"q-slider q-slider"+this.axis+" q-slider--"+(!0===this.active?"":"in")+"active"+(!0===this.isReversed?" q-slider--reversed":"")+(void 0!==this.color?" text-"+this.color:"")+(!0===this.disable?" disabled":" q-slider--enabled"+(!0===this.editable?" q-slider--editable":""))+("both"===this.focus?" q-slider--focus":"")+(this.label||!0===this.labelAlways?" q-slider--label":"")+(!0===this.labelAlways?" q-slider--label-always":"")+(!0===this.isDark?" q-slider--dark":"")+(!0===this.dense?" q-slider--dense q-slider--dense"+this.axis:"")},editable:function(){return!0!==this.disable&&!0!==this.readonly},decimals:function(){return(String(this.step).trim("0").split(".")[1]||"").length},computedStep:function(){return 0===this.step?1:this.step},markerStyle:function(){return{backgroundSize:!0===this.vertical?"2px "+100*this.computedStep/(this.max-this.min)+"%":100*this.computedStep/(this.max-this.min)+"% 2px"}},computedTabindex:function(){return!0===this.editable?this.tabindex||0:-1},isReversed:function(){return!0===this.vertical?!0===this.reverse:this.reverse!==(!0===this.$q.lang.rtl)},positionProp:function(){return!0===this.vertical?!0===this.isReversed?"bottom":"top":!0===this.isReversed?"right":"left"},sizeProp:function(){return!0===this.vertical?"height":"width"},orientation:function(){return!0===this.vertical?"vertical":"horizontal"},attrs:function(){var e={role:"slider","aria-valuemin":this.min,"aria-valuemax":this.max,"aria-orientation":this.orientation,"data-step":this.step};return!0===this.disable?e["aria-disabled"]="true":!0===this.readonly&&(e["aria-readonly"]="true"),e},panDirectives:function(){var e;return!0===this.editable?[{name:"touch-pan",value:this.__pan,modifiers:(e={},e[this.orientation]=!0,e.prevent=!0,e.stop=!0,e.mouse=!0,e.mouseAllDir=!0,e)}]:null}},methods:{__getThumbSvg:function(e){return e("svg",{staticClass:"q-slider__thumb absolute",attrs:{focusable:"false",viewBox:"0 0 20 20",width:"20",height:"20","aria-hidden":"true"}},[e("path",{attrs:{d:this.thumbPath}})])},__getPinStyle:function(e,t){var n;if(!0===this.vertical)return{};var i=Math.ceil(20*Math.abs(.5-t))+"px";return{pin:{transformOrigin:(!0===this.$q.lang.rtl?i:!0===this.$q.platform.is.ie?"100%":"calc(100% - "+i+")")+" 50%"},pinTextContainer:(n={},n[!0===this.$q.lang.rtl?"left":"right"]=100*e+"%",n.transform="translateX("+Math.ceil(20*(!0===this.$q.lang.rtl?-1:1)*e)+"px)",n)}},__pan:function(e){e.isFinal?(void 0!==this.dragging&&(this.__updatePosition(e.evt),!0===e.touch&&this.__updateValue(!0),this.dragging=void 0),this.active=!1):e.isFirst?(this.dragging=this.__getDragging(e.evt),this.__updatePosition(e.evt),this.__updateValue(),this.active=!0):(this.__updatePosition(e.evt),this.__updateValue())},__blur:function(){this.focus=!1},__activate:function(e){this.__updatePosition(e,this.__getDragging(e)),this.__updateValue(),this.preventFocus=!0,this.active=!0,document.addEventListener("mouseup",this.__deactivate,!0)},__deactivate:function(){this.preventFocus=!1,void 0===this.dragging&&(this.active=!1),this.__updateValue(!0),this.__blur(),document.removeEventListener("mouseup",this.__deactivate,!0)},__mobileClick:function(e){this.__updatePosition(e,this.__getDragging(e)),this.__updateValue(!0)},__keyup:function(e){Kn.includes(e.keyCode)&&this.__updateValue(!0)}},beforeDestroy:function(){document.removeEventListener("mouseup",this.__deactivate,!0)}},ei=e.extend({name:"QSlider",mixins:[Xn],props:{value:{required:!0,default:null,validator:function(e){return"number"==typeof e||null===e}},labelValue:[String,Number]},data:function(){return{model:null===this.value?this.min:this.value,curRatio:0}},watch:{value:function(e){this.model=null===e?0:ue(e,this.min,this.max)},min:function(e){this.model=ue(this.model,e,this.max)},max:function(e){this.model=ue(this.model,this.min,e)}},computed:{ratio:function(){return!0===this.active?this.curRatio:this.modelRatio},modelRatio:function(){return(this.model-this.min)/(this.max-this.min)},trackStyle:function(){var e;return(e={})[this.positionProp]=0,e[this.sizeProp]=100*this.ratio+"%",e},thumbStyle:function(){var e;return(e={})[this.positionProp]=100*this.ratio+"%",e},thumbClass:function(){if(!1===this.preventFocus&&!0===this.focus)return"q-slider--focus"},pinClass:function(){if(void 0!==this.labelColor)return"text-"+this.labelColor},pinTextClass:function(){return"q-slider__pin-value-marker-text"+(void 0!==this.labelTextColor?" text-"+this.labelTextColor:"")},events:function(){if(!0===this.editable)return!0===this.$q.platform.is.mobile?{click:this.__mobileClick}:{mousedown:this.__activate,focus:this.__focus,blur:this.__blur,keydown:this.__keydown,keyup:this.__keyup}},computedLabel:function(){return void 0!==this.labelValue?this.labelValue:this.model},pinStyle:function(){var e=!0===this.reverse?-this.ratio:this.ratio-1;return this.__getPinStyle(e,this.ratio)}},methods:{__updateValue:function(e){this.model!==this.value&&this.$emit("input",this.model),!0===e&&this.$emit("change",this.model)},__getDragging:function(){return this.$el.getBoundingClientRect()},__updatePosition:function(e,t){void 0===t&&(t=this.dragging);var n=Zn(e,t,this.isReversed,this.vertical);this.model=Jn(n,this.min,this.max,this.step,this.decimals),this.curRatio=!0!==this.snap||0===this.step?n:(this.model-this.min)/(this.max-this.min)},__focus:function(){this.focus=!0},__keydown:function(e){if(Kn.includes(e.keyCode)){w(e);var t=([34,33].includes(e.keyCode)?10:1)*this.computedStep,n=[34,37,40].includes(e.keyCode)?-t:t;this.model=ue(parseFloat((this.model+n).toFixed(this.decimals)),this.min,this.max),this.__updateValue()}}},render:function(e){var t=[this.__getThumbSvg(e),e("div",{staticClass:"q-slider__focus-ring"})];!0!==this.label&&!0!==this.labelAlways||t.push(e("div",{staticClass:"q-slider__pin q-slider__pin"+this.axis+" absolute",style:this.pinStyle.pin,class:this.pinClass},[e("div",{staticClass:"q-slider__pin-text-container q-slider__pin-text-container"+this.axis,style:this.pinStyle.pinTextContainer},[e("span",{staticClass:"q-slider__pin-text",class:this.pinTextClass},[this.computedLabel])])]),e("div",{staticClass:"q-slider__arrow q-slider__arrow"+this.axis,class:this.pinClass})),void 0!==this.name&&!0!==this.disable&&this.__injectFormInput(t,"push");var n=[e("div",{staticClass:"q-slider__track q-slider__track"+this.axis+" absolute",style:this.trackStyle})];return!0===this.markers&&n.push(e("div",{staticClass:"q-slider__track-markers q-slider__track-markers"+this.axis+" absolute-full fit",style:this.markerStyle})),e("div",{staticClass:null===this.value?" q-slider--no-value":"",attrs:Object.assign({},this.attrs,{"aria-valuenow":this.value,tabindex:this.computedTabindex}),class:this.classes,on:this.events,directives:this.panDirectives},[e("div",{staticClass:"q-slider__track-container q-slider__track-container"+this.axis+" absolute"},n),e("div",{staticClass:"q-slider__thumb-container q-slider__thumb-container"+this.axis+" absolute non-selectable",class:this.thumbClass,style:this.thumbStyle},t)])}}),ti={data:function(){return{canRender:!o}},mounted:function(){!1===this.canRender&&(this.canRender=!0)}},ni=e.extend({name:"QResizeObserver",mixins:[ti],props:{debounce:{type:[String,Number],default:100}},data:function(){return!0===this.hasObserver?{}:{url:!0===this.$q.platform.is.ie?null:"about:blank"}},methods:{trigger:function(e){!0===e||0===this.debounce||"0"===this.debounce?this.__onResize():this.timer||(this.timer=setTimeout(this.__onResize,this.debounce))},__onResize:function(){if(this.timer=null,this.$el&&this.$el.parentNode){var e=this.$el.parentNode,t={width:e.offsetWidth,height:e.offsetHeight};t.width===this.size.width&&t.height===this.size.height||(this.size=t,this.$emit("resize",this.size))}},__cleanup:function(){void 0!==this.curDocView&&(void 0!==this.curDocView.removeEventListener&&this.curDocView.removeEventListener("resize",this.trigger,f.passive),this.curDocView=void 0)},__onObjLoad:function(){this.__cleanup(),this.$el.contentDocument&&(this.curDocView=this.$el.contentDocument.defaultView,this.curDocView.addEventListener("resize",this.trigger,f.passive)),this.__onResize()}},render:function(e){if(!1!==this.canRender&&!0!==this.hasObserver)return e("object",{style:this.style,attrs:{tabindex:-1,type:"text/html",data:this.url,"aria-hidden":"true"},on:pe(this,"load",{load:this.__onObjLoad})})},beforeCreate:function(){this.size={width:-1,height:-1},!0!==i&&(this.hasObserver="undefined"!=typeof ResizeObserver,!0!==this.hasObserver&&(this.style=(this.$q.platform.is.ie?"visibility:hidden;":"")+"display:block;position:absolute;top:0;left:0;right:0;bottom:0;height:100%;width:100%;overflow:hidden;pointer-events:none;z-index:-1;"))},mounted:function(){if(!0===this.hasObserver)return this.observer=new ResizeObserver(this.trigger),this.observer.observe(this.$el.parentNode),void this.__onResize();!0===this.$q.platform.is.ie?(this.url="about:blank",this.__onResize()):this.__onObjLoad()},beforeDestroy:function(){clearTimeout(this.timer),!0!==this.hasObserver?this.__cleanup():void 0!==this.observer&&this.$el.parentNode&&this.observer.unobserve(this.$el.parentNode)}});function ii(e,t,n){var i=!0===n?["left","right"]:["top","bottom"];return"absolute-"+(!0===t?i[0]:i[1])+(e?" text-"+e:"")}function ri(e,t){return e.priorityMatched===t.priorityMatched?t.priorityHref-e.priorityHref:t.priorityMatched-e.priorityMatched}function oi(e){return e.selected=!1,e}var ai=[function(e){return!0===e.selected&&!0===e.exact&&!0!==e.redirected},function(e){return!0===e.selected&&!0===e.exact},function(e){return!0===e.selected&&!0!==e.redirected},function(e){return!0===e.selected},function(e){return!0===e.exact&&!0!==e.redirected},function(e){return!0!==e.redirected},function(e){return!0===e.exact},function(e){return!0}],si=ai.length,li=e.extend({name:"QTabs",mixins:[xt,Pe],provide:function(){return{tabs:this.tabs,__recalculateScroll:this.__recalculateScroll,__activateTab:this.__activateTab,__activateRoute:this.__activateRoute}},props:{value:[Number,String],align:{type:String,default:"center",validator:function(e){return["left","center","right","justify"].includes(e)}},breakpoint:{type:[String,Number],default:600},vertical:Boolean,shrink:Boolean,stretch:Boolean,activeColor:String,activeBgColor:String,indicatorColor:String,leftIcon:String,rightIcon:String,outsideArrows:Boolean,mobileArrows:Boolean,switchIndicator:Boolean,narrowIndicator:Boolean,inlineLabel:Boolean,noCaps:Boolean,dense:Boolean,contentClass:String},data:function(){return{tabs:{current:this.value,activeColor:this.activeColor,activeBgColor:this.activeBgColor,indicatorClass:ii(this.indicatorColor,this.switchIndicator,this.vertical),narrowIndicator:this.narrowIndicator,inlineLabel:this.inlineLabel,noCaps:this.noCaps},scrollable:!1,leftArrow:!0,rightArrow:!1,justify:!1}},watch:{value:function(e){this.__activateTab(e,!0,!0)},activeColor:function(e){this.tabs.activeColor=e},activeBgColor:function(e){this.tabs.activeBgColor=e},vertical:function(e){this.tabs.indicatorClass=ii(this.indicatorColor,this.switchIndicator,e)},indicatorColor:function(e){this.tabs.indicatorClass=ii(e,this.switchIndicator,this.vertical)},switchIndicator:function(e){this.tabs.indicatorClass=ii(this.indicatorColor,e,this.vertical)},narrowIndicator:function(e){this.tabs.narrowIndicator=e},inlineLabel:function(e){this.tabs.inlineLabel=e},noCaps:function(e){this.tabs.noCaps=e},outsideArrows:function(){this.$nextTick(this.__recalculateScroll())},arrowsEnabled:function(e){this.__updateArrows=!0===e?this.__updateArrowsFn:m,this.$nextTick(this.__recalculateScroll())}},computed:{arrowsEnabled:function(){return!0===this.$q.platform.is.desktop||!0===this.mobileArrows},alignClass:function(){return"q-tabs__content--align-"+(!0===this.scrollable?"left":!0===this.justify?"justify":this.align)},classes:function(){return"q-tabs--"+(!0===this.scrollable?"":"not-")+"scrollable q-tabs--"+(!0===this.vertical?"vertical":"horizontal")+" q-tabs__arrows--"+(!0===this.arrowsEnabled&&!0===this.outsideArrows?"outside":"inside")+(!0===this.dense?" q-tabs--dense":"")+(!0===this.shrink?" col-shrink":"")+(!0===this.stretch?" self-stretch":"")},innerClass:function(){return this.alignClass+(void 0!==this.contentClass?" "+this.contentClass:"")},domProps:function(){return!0===this.vertical?{container:"height",content:"scrollHeight",posLeft:"top",posRight:"bottom"}:{container:"width",content:"scrollWidth",posLeft:"left",posRight:"right"}},onEvents:function(){return Object.assign({},{input:b},this.qListeners)}},methods:{__activateTab:function(e,t,n){this.tabs.current!==e&&(!0!==n&&this.$emit("input",e),!0!==t&&void 0!==this.qListeners.input||(this.__animate(this.tabs.current,e),this.tabs.current=e))},__activateRoute:function(e){var t=this;this.bufferRoute!==this.$route&&this.buffer.length>0&&(clearTimeout(this.bufferTimer),this.bufferTimer=void 0,this.buffer.length=0),this.bufferRoute=this.$route,void 0!==e&&(!0===e.remove?this.buffer=this.buffer.filter((function(t){return t.name!==e.name})):this.buffer.push(e)),void 0===this.bufferTimer&&(this.bufferTimer=setTimeout((function(){for(var e=[],n=0;n<si&&0===e.length;n++)e=t.buffer.filter(ai[n]);e.sort(ri),t.__activateTab(0===e.length?null:e[0].name,!0),t.buffer=t.buffer.map(oi),t.bufferTimer=void 0}),1))},__recalculateScroll:function(){var e=this;this.__nextTick((function(){!0!==e._isDestroyed&&e.__updateContainer({width:e.$el.offsetWidth,height:e.$el.offsetHeight})})),this.__prepareTick()},__updateContainer:function(e){var t=this,n=e[this.domProps.container],i=this.$refs.content[this.domProps.content],r=n>0&&i>n;this.scrollable!==r&&(this.scrollable=r),!0===r&&this.$nextTick((function(){return t.__updateArrows()}));var o=n<parseInt(this.breakpoint,10);this.justify!==o&&(this.justify=o)},__animate:function(e,t){var n=this,i=null!=e&&""!==e?this.$children.find((function(t){return t.name===e})):null,r=null!=t&&""!==t?this.$children.find((function(e){return e.name===t})):null;if(i&&r){var o=i.$el.getElementsByClassName("q-tab__indicator")[0],a=r.$el.getElementsByClassName("q-tab__indicator")[0];clearTimeout(this.animateTimer),o.style.transition="none",o.style.transform="none",a.style.transition="none",a.style.transform="none";var s=o.getBoundingClientRect(),l=a.getBoundingClientRect();a.style.transform=!0===this.vertical?"translate3d(0,"+(s.top-l.top)+"px,0) scale3d(1,"+(l.height?s.height/l.height:1)+",1)":"translate3d("+(s.left-l.left)+"px,0,0) scale3d("+(l.width?s.width/l.width:1)+",1,1)",this.$nextTick((function(){n.animateTimer=setTimeout((function(){a.style.transition="transform .25s cubic-bezier(.4, 0, .2, 1)",a.style.transform="none"}),70)}))}if(r&&!0===this.scrollable){var c=this.$refs.content.getBoundingClientRect(),u=c.left,d=c.width,h=c.top,f=c.height,p=r.$el.getBoundingClientRect(),m=!0===this.vertical?p.top-h:p.left-u;if(m<0)return this.$refs.content[!0===this.vertical?"scrollTop":"scrollLeft"]+=Math.floor(m),void this.__updateArrows();(m+=!0===this.vertical?p.height-f:p.width-d)>0&&(this.$refs.content[!0===this.vertical?"scrollTop":"scrollLeft"]+=Math.ceil(m),this.__updateArrows())}},__updateArrowsFn:function(){var e=this.$refs.content,t=e.getBoundingClientRect(),n=!0===this.vertical?e.scrollTop:e.scrollLeft;this.leftArrow=n>0,this.rightArrow=!0===this.vertical?Math.ceil(n+t.height)<e.scrollHeight:Math.ceil(n+t.width)<e.scrollWidth},__animScrollTo:function(e){var t=this;this.__stopAnimScroll(),this.__scrollTowards(e),this.scrollTimer=setInterval((function(){t.__scrollTowards(e)&&t.__stopAnimScroll()}),5)},__scrollToStart:function(){this.__animScrollTo(0)},__scrollToEnd:function(){this.__animScrollTo(9999)},__stopAnimScroll:function(){clearInterval(this.scrollTimer)},__scrollTowards:function(e){var t=this.$refs.content,n=!0===this.vertical?t.scrollTop:t.scrollLeft,i=!1,r=e<n?-1:1;return(n+=5*r)<0?(i=!0,n=0):(-1===r&&n<=e||1===r&&n>=e)&&(i=!0,n=e),t[!0===this.vertical?"scrollTop":"scrollLeft"]=n,this.__updateArrows(),i}},created:function(){this.buffer=[],this.__updateArrows=!0===this.arrowsEnabled?this.__updateArrowsFn:m},beforeDestroy:function(){clearTimeout(this.bufferTimer),clearTimeout(this.animateTimer)},render:function(e){var t=[e(ni,{on:pe(this,"resize",{resize:this.__updateContainer})}),e("div",{ref:"content",staticClass:"q-tabs__content row no-wrap items-center self-stretch hide-scrollbar",class:this.innerClass},Le(this,"default"))];return!0===this.arrowsEnabled&&t.push(e(De,{staticClass:"q-tabs__arrow q-tabs__arrow--left absolute q-tab__icon",class:!0===this.leftArrow?"":"q-tabs__arrow--faded",props:{name:this.leftIcon||(!0===this.vertical?this.$q.iconSet.tabs.up:this.$q.iconSet.tabs.left)},on:pe(this,"onL",{mousedown:this.__scrollToStart,touchstart:this.__scrollToStart,mouseup:this.__stopAnimScroll,mouseleave:this.__stopAnimScroll,touchend:this.__stopAnimScroll})}),e(De,{staticClass:"q-tabs__arrow q-tabs__arrow--right absolute q-tab__icon",class:!0===this.rightArrow?"":"q-tabs__arrow--faded",props:{name:this.rightIcon||(!0===this.vertical?this.$q.iconSet.tabs.down:this.$q.iconSet.tabs.right)},on:pe(this,"onR",{mousedown:this.__scrollToEnd,touchstart:this.__scrollToEnd,mouseup:this.__stopAnimScroll,mouseleave:this.__stopAnimScroll,touchend:this.__stopAnimScroll})})),e("div",{staticClass:"q-tabs row no-wrap items-center",class:this.classes,on:this.onEvents,attrs:{role:"tablist"}},t)}}),ci=0,ui=e.extend({name:"QTab",mixins:[at,Pe],inject:{tabs:{default:function(){console.error("QTab/QRouteTab components need to be child of QTabs")}},__activateTab:{},__recalculateScroll:{}},props:{icon:String,label:[Number,String],alert:[Boolean,String],alertIcon:String,name:{type:[Number,String],default:function(){return"t_"+ci++}},noCaps:Boolean,tabindex:[String,Number],disable:Boolean,contentClass:String},computed:{isActive:function(){return this.tabs.current===this.name},classes:function(){var e;return(e={})["q-tab--"+(this.isActive?"":"in")+"active"]=!0,e["text-"+this.tabs.activeColor]=this.isActive&&this.tabs.activeColor,e["bg-"+this.tabs.activeBgColor]=this.isActive&&this.tabs.activeBgColor,e["q-tab--full"]=this.icon&&this.label&&!this.tabs.inlineLabel,e["q-tab--no-caps"]=!0===this.noCaps||!0===this.tabs.noCaps,e["q-focusable q-hoverable cursor-pointer"]=!this.disable,e.disabled=this.disable,e},innerClass:function(){return(!0===this.tabs.inlineLabel?"row no-wrap q-tab__content--inline":"column")+(void 0!==this.contentClass?" "+this.contentClass:"")},computedTabIndex:function(){return!0===this.disable||!0===this.isActive?-1:this.tabindex||0},onEvents:function(){return Object.assign({},{input:b},this.qListeners,{click:this.__activate,keyup:this.__onKeyup})},attrs:function(){var e={tabindex:this.computedTabIndex,role:"tab","aria-selected":this.isActive};return!0===this.disable&&(e["aria-disabled"]="true"),e}},methods:{__activate:function(e,t){!0!==t&&void 0!==this.$refs.blurTarget&&this.$refs.blurTarget.focus(),!0!==this.disable&&(void 0!==this.qListeners.click&&this.$emit("click",e),this.__activateTab(this.name))},__onKeyup:function(e){!0===X(e,13)&&this.__activate(e,!0)},__getContent:function(e){var t=this.tabs.narrowIndicator,n=[],i=e("div",{staticClass:"q-tab__indicator",class:this.tabs.indicatorClass});void 0!==this.icon&&n.push(e(De,{staticClass:"q-tab__icon",props:{name:this.icon}})),void 0!==this.label&&n.push(e("div",{staticClass:"q-tab__label"},[this.label])),!1!==this.alert&&n.push(void 0!==this.alertIcon?e(De,{staticClass:"q-tab__alert-icon",props:{color:!0!==this.alert?this.alert:void 0,name:this.alertIcon}}):e("div",{staticClass:"q-tab__alert",class:!0!==this.alert?"text-"+this.alert:null})),!0===t&&n.push(i);var r=[e("div",{staticClass:"q-focus-helper",attrs:{tabindex:-1},ref:"blurTarget"}),e("div",{staticClass:"q-tab__content self-stretch flex-center relative-position q-anchor--skip non-selectable",class:this.innerClass},qe(n,this,"default"))];return!1===t&&r.push(i),r},__renderTab:function(e,t,n){var i={staticClass:"q-tab relative-position self-stretch flex flex-center text-center",class:this.classes,attrs:this.attrs,directives:!1!==this.ripple&&!0===this.disable?null:[{name:"ripple",value:this.ripple}]};return i["div"===t?"on":"nativeOn"]=this.onEvents,void 0!==n&&(i.props=n),e(t,i,this.__getContent(e))}},mounted:function(){this.__recalculateScroll()},beforeDestroy:function(){this.__recalculateScroll()},render:function(e){return this.__renderTab(e,"div")}}),di=e.extend({name:"QTabPanels",mixins:[je,_n],computed:{classes:function(){return"q-tab-panels q-panel-parent"+(!0===this.isDark?" q-tab-panels--dark q-dark":"")}},methods:{__renderPanels:function(e){return e("div",{class:this.classes,directives:this.panelDirectives,on:Object.assign({},this.qListeners)},this.__getPanelContent(e))}}}),hi=e.extend({name:"QTabPanel",mixins:[bn],render:function(e){return e("div",{staticClass:"q-tab-panel",on:Object.assign({},this.qListeners)},Le(this,"default"))}}),fi=["rgb(255,204,204)","rgb(255,230,204)","rgb(255,255,204)","rgb(204,255,204)","rgb(204,255,230)","rgb(204,255,255)","rgb(204,230,255)","rgb(204,204,255)","rgb(230,204,255)","rgb(255,204,255)","rgb(255,153,153)","rgb(255,204,153)","rgb(255,255,153)","rgb(153,255,153)","rgb(153,255,204)","rgb(153,255,255)","rgb(153,204,255)","rgb(153,153,255)","rgb(204,153,255)","rgb(255,153,255)","rgb(255,102,102)","rgb(255,179,102)","rgb(255,255,102)","rgb(102,255,102)","rgb(102,255,179)","rgb(102,255,255)","rgb(102,179,255)","rgb(102,102,255)","rgb(179,102,255)","rgb(255,102,255)","rgb(255,51,51)","rgb(255,153,51)","rgb(255,255,51)","rgb(51,255,51)","rgb(51,255,153)","rgb(51,255,255)","rgb(51,153,255)","rgb(51,51,255)","rgb(153,51,255)","rgb(255,51,255)","rgb(255,0,0)","rgb(255,128,0)","rgb(255,255,0)","rgb(0,255,0)","rgb(0,255,128)","rgb(0,255,255)","rgb(0,128,255)","rgb(0,0,255)","rgb(128,0,255)","rgb(255,0,255)","rgb(245,0,0)","rgb(245,123,0)","rgb(245,245,0)","rgb(0,245,0)","rgb(0,245,123)","rgb(0,245,245)","rgb(0,123,245)","rgb(0,0,245)","rgb(123,0,245)","rgb(245,0,245)","rgb(214,0,0)","rgb(214,108,0)","rgb(214,214,0)","rgb(0,214,0)","rgb(0,214,108)","rgb(0,214,214)","rgb(0,108,214)","rgb(0,0,214)","rgb(108,0,214)","rgb(214,0,214)","rgb(163,0,0)","rgb(163,82,0)","rgb(163,163,0)","rgb(0,163,0)","rgb(0,163,82)","rgb(0,163,163)","rgb(0,82,163)","rgb(0,0,163)","rgb(82,0,163)","rgb(163,0,163)","rgb(92,0,0)","rgb(92,46,0)","rgb(92,92,0)","rgb(0,92,0)","rgb(0,92,46)","rgb(0,92,92)","rgb(0,46,92)","rgb(0,0,92)","rgb(46,0,92)","rgb(92,0,92)","rgb(255,255,255)","rgb(205,205,205)","rgb(178,178,178)","rgb(153,153,153)","rgb(127,127,127)","rgb(102,102,102)","rgb(76,76,76)","rgb(51,51,51)","rgb(25,25,25)","rgb(0,0,0)"],pi=e.extend({name:"QColor",mixins:[Pe,je,ln],directives:{TouchPan:Qn},props:{value:String,defaultValue:String,defaultView:{type:String,default:"spectrum",validator:function(e){return["spectrum","tune","palette"].includes(e)}},formatModel:{type:String,default:"auto",validator:function(e){return["auto","hex","rgb","hexa","rgba"].includes(e)}},palette:Array,noHeader:Boolean,noFooter:Boolean,square:Boolean,flat:Boolean,bordered:Boolean,disable:Boolean,readonly:Boolean},data:function(){return{topView:"auto"===this.formatModel?void 0===this.value||null===this.value||""===this.value||this.value.startsWith("#")?"hex":"rgb":this.formatModel.startsWith("hex")?"hex":"rgb",view:this.defaultView,model:this.__parseModel(this.value||this.defaultValue)}},watch:{value:function(e){var t=this.__parseModel(e||this.defaultValue);t.hex!==this.model.hex&&(this.model=t)},defaultValue:function(e){if(!this.value&&e){var t=this.__parseModel(e);t.hex!==this.model.hex&&(this.model=t)}}},computed:{editable:function(){return!0!==this.disable&&!0!==this.readonly},forceHex:function(){return"auto"===this.formatModel?null:this.formatModel.indexOf("hex")>-1},forceAlpha:function(){return"auto"===this.formatModel?null:this.formatModel.indexOf("a")>-1},isHex:function(){return void 0===this.value||null===this.value||""===this.value||this.value.startsWith("#")},isOutputHex:function(){return null!==this.forceHex?this.forceHex:this.isHex},formAttrs:function(){return{type:"hidden",name:this.name,value:this.model[!0===this.isOutputHex?"hex":"rgb"]}},hasAlpha:function(){return null!==this.forceAlpha?this.forceAlpha:void 0!==this.model.a},currentBgColor:function(){return{backgroundColor:this.model.rgb||"#000"}},headerClass:function(){return"q-color-picker__header-content--"+(void 0!==this.model.a&&this.model.a<65||U(this.model)>.4?"light":"dark")},spectrumStyle:function(){return{background:"hsl("+this.model.h+",100%,50%)"}},spectrumPointerStyle:function(){var e;return(e={top:100-this.model.v+"%"})[!0===this.$q.lang.rtl?"right":"left"]=this.model.s+"%",e},inputsArray:function(){var e=["r","g","b"];return!0===this.hasAlpha&&e.push("a"),e},computedPalette:function(){return void 0!==this.palette&&this.palette.length>0?this.palette:fi},classes:function(){return"q-color-picker"+(!0===this.bordered?" q-color-picker--bordered":"")+(!0===this.square?" q-color-picker--square no-border-radius":"")+(!0===this.flat?" q-color-picker--flat no-shadow":"")+(!0===this.disable?" disabled":"")+(!0===this.isDark?" q-color-picker--dark q-dark":"")},attrs:function(){return!0===this.disable?{"aria-disabled":"true"}:!0===this.readonly?{"aria-readonly":"true"}:void 0}},created:function(){this.__spectrumChange=tt(this.__spectrumChange,20)},render:function(e){var t=[this.__getContent(e)];return void 0!==this.name&&!0!==this.disable&&this.__injectFormInput(t,"push"),!0!==this.noHeader&&t.unshift(this.__getHeader(e)),!0!==this.noFooter&&t.push(this.__getFooter(e)),e("div",{class:this.classes,attrs:this.attrs,on:Object.assign({},this.qListeners)},t)},methods:{__getHeader:function(e){var t=this;return e("div",{staticClass:"q-color-picker__header relative-position overflow-hidden"},[e("div",{staticClass:"q-color-picker__header-bg absolute-full"}),e("div",{staticClass:"q-color-picker__header-content absolute-full",class:this.headerClass,style:this.currentBgColor},[e(li,{props:{value:this.topView,dense:!0,align:"justify"},on:pe(this,"topVTab",{input:function(e){t.topView=e}})},[e(ui,{props:{label:"HEX"+(!0===this.hasAlpha?"A":""),name:"hex",ripple:!1}}),e(ui,{props:{label:"RGB"+(!0===this.hasAlpha?"A":""),name:"rgb",ripple:!1}})]),e("div",{staticClass:"q-color-picker__header-banner row flex-center no-wrap"},[e("input",{staticClass:"fit",domProps:{value:this.model[this.topView]},attrs:!0!==this.editable?{readonly:!0}:null,on:pe(this,"topIn",{input:function(e){t.__updateErrorIcon(!0===t.__onEditorChange(e))},change:b,blur:function(e){!0===t.__onEditorChange(e,!0)&&t.$forceUpdate(),t.__updateErrorIcon(!1)}})}),e(De,{ref:"errorIcon",staticClass:"q-color-picker__error-icon absolute no-pointer-events",props:{name:this.$q.iconSet.type.negative}})])])])},__getContent:function(e){return e(di,{props:{value:this.view,animated:!0}},[e(hi,{staticClass:"q-color-picker__spectrum-tab overflow-hidden",props:{name:"spectrum"}},this.__getSpectrumTab(e)),e(hi,{staticClass:"q-pa-md q-color-picker__tune-tab",props:{name:"tune"}},this.__getTuneTab(e)),e(hi,{staticClass:"q-color-picker__palette-tab",props:{name:"palette"}},this.__getPaletteTab(e))])},__getFooter:function(e){var t=this;return e("div",{staticClass:"q-color-picker__footer relative-position overflow-hidden"},[e(li,{staticClass:"absolute-full",props:{value:this.view,dense:!0,align:"justify"},on:pe(this,"ftIn",{input:function(e){t.view=e}})},[e(ui,{props:{icon:this.$q.iconSet.colorPicker.spectrum,name:"spectrum",ripple:!1}}),e(ui,{props:{icon:this.$q.iconSet.colorPicker.tune,name:"tune",ripple:!1}}),e(ui,{props:{icon:this.$q.iconSet.colorPicker.palette,name:"palette",ripple:!1}})])])},__getSpectrumTab:function(e){var t=this,n="M5 5 h10 v10 h-10 v-10 z";return[e("div",{ref:"spectrum",staticClass:"q-color-picker__spectrum non-selectable relative-position cursor-pointer",style:this.spectrumStyle,class:{readonly:!0!==this.editable},on:!0===this.editable?pe(this,"spectrT",{click:this.__spectrumClick,mousedown:this.__activate}):null,directives:!0===this.editable?pe(this,"spectrDir",[{name:"touch-pan",modifiers:{prevent:!0,stop:!0,mouse:!0},value:this.__spectrumPan}]):null},[e("div",{style:{paddingBottom:"100%"}}),e("div",{staticClass:"q-color-picker__spectrum-white absolute-full"}),e("div",{staticClass:"q-color-picker__spectrum-black absolute-full"}),e("div",{staticClass:"absolute",style:this.spectrumPointerStyle},[void 0!==this.model.hex?e("div",{staticClass:"q-color-picker__spectrum-circle"}):null])]),e("div",{staticClass:"q-color-picker__sliders"},[e("div",{staticClass:"q-color-picker__hue non-selectable"},[e(ei,{props:{value:this.model.h,min:0,max:360,fillHandleAlways:!0,readonly:!0!==this.editable,thumbPath:n},on:pe(this,"hueSlide",{input:this.__onHueChange,change:function(e){return t.__onHueChange(e,!0)}})})]),!0===this.hasAlpha?e("div",{staticClass:"q-color-picker__alpha non-selectable"},[e(ei,{props:{value:this.model.a,min:0,max:100,fillHandleAlways:!0,readonly:!0!==this.editable,thumbPath:n},on:pe(this,"alphaSlide",{input:function(e){return t.__onNumericChange(e,"a",100)},change:function(e){return t.__onNumericChange(e,"a",100,void 0,!0)}})})]):null])]},__getTuneTab:function(e){var t=this;return[e("div",{staticClass:"row items-center no-wrap"},[e("div",["R"]),e(ei,{props:{value:this.model.r,min:0,max:255,color:"red",dark:this.isDark,readonly:!0!==this.editable},on:pe(this,"rSlide",{input:function(e){return t.__onNumericChange(e,"r",255)},change:function(e){return t.__onNumericChange(e,"r",255,void 0,!0)}})}),e("input",{domProps:{value:this.model.r},attrs:{maxlength:3,readonly:!0!==this.editable},on:pe(this,"rIn",{input:function(e){return t.__onNumericChange(e.target.value,"r",255,e)},change:b,blur:function(e){return t.__onNumericChange(e.target.value,"r",255,e,!0)}})})]),e("div",{staticClass:"row items-center no-wrap"},[e("div",["G"]),e(ei,{props:{value:this.model.g,min:0,max:255,color:"green",dark:this.isDark,readonly:!0!==this.editable},on:pe(this,"gSlide",{input:function(e){return t.__onNumericChange(e,"g",255)},change:function(e){return t.__onNumericChange(e,"g",255,void 0,!0)}})}),e("input",{domProps:{value:this.model.g},attrs:{maxlength:3,readonly:!0!==this.editable},on:pe(this,"gIn",{input:function(e){return t.__onNumericChange(e.target.value,"g",255,e)},change:b,blur:function(e){return t.__onNumericChange(e.target.value,"g",255,e,!0)}})})]),e("div",{staticClass:"row items-center no-wrap"},[e("div",["B"]),e(ei,{props:{value:this.model.b,min:0,max:255,color:"blue",readonly:!0!==this.editable,dark:this.isDark},on:pe(this,"bSlide",{input:function(e){return t.__onNumericChange(e,"b",255)},change:function(e){return t.__onNumericChange(e,"b",255,void 0,!0)}})}),e("input",{domProps:{value:this.model.b},attrs:{maxlength:3,readonly:!0!==this.editable},on:pe(this,"bIn",{input:function(e){return t.__onNumericChange(e.target.value,"b",255,e)},change:b,blur:function(e){return t.__onNumericChange(e.target.value,"b",255,e,!0)}})})]),!0===this.hasAlpha?e("div",{staticClass:"row items-center no-wrap"},[e("div",["A"]),e(ei,{props:{value:this.model.a,color:"grey",readonly:!0!==this.editable,dark:this.isDark},on:pe(this,"aSlide",{input:function(e){return t.__onNumericChange(e,"a",100)},change:function(e){return t.__onNumericChange(e,"a",100,void 0,!0)}})}),e("input",{domProps:{value:this.model.a},attrs:{maxlength:3,readonly:!0!==this.editable},on:pe(this,"aIn",{input:function(e){return t.__onNumericChange(e.target.value,"a",100,e)},change:b,blur:function(e){return t.__onNumericChange(e.target.value,"a",100,e,!0)}})})]):null]},__getPaletteTab:function(e){var t=this;return[e("div",{staticClass:"row items-center q-color-picker__palette-rows",class:!0===this.editable?"q-color-picker__palette-rows--editable":""},this.computedPalette.map((function(n){return e("div",{staticClass:"q-color-picker__cube col-auto",style:{backgroundColor:n},on:!0===t.editable?pe(t,"palette#"+n,{click:function(){t.__onPalettePick(n)}}):null})})))]},__onSpectrumChange:function(e,t,n){var i=this.$refs.spectrum;if(void 0!==i){var r=i.clientWidth,o=i.clientHeight,a=i.getBoundingClientRect(),s=Math.min(r,Math.max(0,e-a.left));!0===this.$q.lang.rtl&&(s=r-s);var l=Math.min(o,Math.max(0,t-a.top)),c=Math.round(100*s/r),u=Math.round(100*Math.max(0,Math.min(1,-l/o+1))),d=V({h:this.model.h,s:c,v:u,a:!0===this.hasAlpha?this.model.a:void 0});this.model.s=c,this.model.v=u,this.__update(d,n)}},__onHueChange:function(e,t){var n=V({h:e=Math.round(e),s:this.model.s,v:this.model.v,a:!0===this.hasAlpha?this.model.a:void 0});this.model.h=e,this.__update(n,t)},__onNumericChange:function(e,t,n,i,r){if(void 0!==i&&b(i),/^[0-9]+$/.test(e)){var o=Math.floor(Number(e));if(o<0||o>n)!0===r&&this.$forceUpdate();else{var a={r:"r"===t?o:this.model.r,g:"g"===t?o:this.model.g,b:"b"===t?o:this.model.b,a:!0===this.hasAlpha?"a"===t?o:this.model.a:void 0};if("a"!==t){var s=H(a);this.model.h=s.h,this.model.s=s.s,this.model.v=s.v}if(this.__update(a,r),void 0!==i&&!0!==r&&void 0!==i.target.selectionEnd){var l=i.target.selectionEnd;this.$nextTick((function(){i.target.setSelectionRange(l,l)}))}}}else r&&this.$forceUpdate()},__onEditorChange:function(e,t){var n,i=e.target.value;if(b(e),"hex"===this.topView){if(i.length!==(!0===this.hasAlpha?9:7)||!/^#[0-9A-Fa-f]+$/.test(i))return!0;n=B(i)}else{var r;if(!i.endsWith(")"))return!0;if(!0!==this.hasAlpha&&i.startsWith("rgb(")){if(3!==(r=i.substring(4,i.length-1).split(",").map((function(e){return parseInt(e,10)}))).length||!/^rgb\([0-9]{1,3},[0-9]{1,3},[0-9]{1,3}\)$/.test(i))return!0}else{if(!0!==this.hasAlpha||!i.startsWith("rgba("))return!0;if(4!==(r=i.substring(5,i.length-1).split(",")).length||!/^rgba\([0-9]{1,3},[0-9]{1,3},[0-9]{1,3},(0|0\.[0-9]+[1-9]|0\.[1-9]+|1)\)$/.test(i))return!0;for(var o=0;o<3;o++){var a=parseInt(r[o],10);if(a<0||a>255)return!0;r[o]=a}var s=parseFloat(r[3]);if(s<0||s>1)return!0;r[3]=s}if(r[0]<0||r[0]>255||r[1]<0||r[1]>255||r[2]<0||r[2]>255||!0===this.hasAlpha&&(r[3]<0||r[3]>1))return!0;n={r:r[0],g:r[1],b:r[2],a:!0===this.hasAlpha?100*r[3]:void 0}}var l=H(n);if(this.model.h=l.h,this.model.s=l.s,this.model.v=l.v,this.__update(n,t),!0!==t){var c=e.target.selectionEnd;this.$nextTick((function(){e.target.setSelectionRange(c,c)}))}},__onPalettePick:function(e){var t=this.__parseModel(e),n={r:t.r,g:t.g,b:t.b,a:t.a};void 0===n.a&&(n.a=this.model.a),this.model.h=t.h,this.model.s=t.s,this.model.v=t.v,this.__update(n,!0)},__update:function(e,t){this.model.hex=$(e),this.model.rgb=F(e),this.model.r=e.r,this.model.g=e.g,this.model.b=e.b,this.model.a=e.a;var n=this.model[!0===this.isOutputHex?"hex":"rgb"];this.$emit("input",n),!0===t&&this.$emit("change",n)},__updateErrorIcon:function(e){void 0!==this.$refs.errorIcon&&(this.$refs.errorIcon.$el.style.opacity=e?1:0)},__parseModel:function(e){var t=void 0!==this.forceAlpha?this.forceAlpha:"auto"===this.formatModel?null:this.formatModel.indexOf("a")>-1;if("string"!=typeof e||0===e.length||!0!==Hn.anyColor(e.replace(/ /g,"")))return{h:0,s:0,v:0,r:0,g:0,b:0,a:!0===t?100:void 0,hex:void 0,rgb:void 0};var n=W(e);return!0===t&&void 0===n.a&&(n.a=100),n.hex=$(n),n.rgb=F(n),Object.assign(n,H(n))},__spectrumPan:function(e){e.isFinal?this.__onSpectrumChange(e.position.left,e.position.top,!0):this.__spectrumChange(e)},__spectrumChange:function(e){this.__onSpectrumChange(e.position.left,e.position.top)},__spectrumClick:function(e){this.__onSpectrumChange(e.pageX-window.pageXOffset,e.pageY-window.pageYOffset,!0)},__activate:function(e){this.__onSpectrumChange(e.pageX-window.pageXOffset,e.pageY-window.pageYOffset)}}}),mi=[-61,9,38,199,426,686,756,818,1111,1181,1210,1635,2060,2097,2192,2262,2324,2394,2456,3178];function vi(e,t,n){return"[object Date]"===Object.prototype.toString.call(e)&&(n=e.getDate(),t=e.getMonth()+1,e=e.getFullYear()),function(e){var t,n,i,r=ki(e).gy,o=r-621,a=yi(o,!1),s=wi(r,3,a.march);if((i=e-s)>=0){if(i<=185)return{jy:o,jm:n=1+xi(i,31),jd:t=Si(i,31)+1};i-=186}else o-=1,i+=179,1===a.leap&&(i+=1);return n=7+xi(i,30),t=Si(i,30)+1,{jy:o,jm:n,jd:t}}(wi(e,t,n))}function gi(e,t,n){return ki(function(e,t,n){var i=yi(e,!0);return wi(i.gy,3,i.march)+31*(t-1)-xi(t,7)*(t-7)+n-1}(e,t,n))}function _i(e){return 0===function(e){var t,n,i,r,o,a=mi.length,s=mi[0];if(e<s||e>=mi[a-1])throw new Error("Invalid Jalaali year "+e);for(o=1;o<a&&(n=(t=mi[o])-s,!(e<t));o+=1)s=t;r=e-s,n-r<6&&(r=r-n+33*xi(n+4,33));-1===(i=Si(Si(r+1,33)-1,4))&&(i=4);return i}(e)}function bi(e,t){return t<=6?31:t<=11||_i(e)?30:29}function yi(e,t){var n,i,r,o,a,s=mi.length,l=e+621,c=-14,u=mi[0];if(e<u||e>=mi[s-1])throw new Error("Invalid Jalaali year "+e);for(a=1;a<s&&(i=(n=mi[a])-u,!(e<n));a+=1)c=c+8*xi(i,33)+xi(Si(i,33),4),u=n;c=c+8*xi(o=e-u,33)+xi(Si(o,33)+3,4),4===Si(i,33)&&i-o==4&&(c+=1);var d=20+c-(xi(l,4)-xi(3*(xi(l,100)+1),4)-150);return t||(i-o<6&&(o=o-i+33*xi(i+4,33)),-1===(r=Si(Si(o+1,33)-1,4))&&(r=4)),{leap:r,gy:l,march:d}}function wi(e,t,n){var i=xi(1461*(e+xi(t-8,6)+100100),4)+xi(153*Si(t+9,12)+2,5)+n-34840408;return i=i-xi(3*xi(e+100100+xi(t-8,6),100),4)+752}function ki(e){var t=4*e+139361631;t=t+4*xi(3*xi(4*e+183187720,146097),4)-3908;var n=5*xi(Si(t,1461),4)+308,i=xi(Si(n,153),5)+1,r=Si(xi(n,153),12)+1;return{gy:xi(t,1461)-100100+xi(8-r,6),gm:r,gd:i}}function xi(e,t){return~~(e/t)}function Si(e,t){return e-~~(e/t)*t}var Ci=["gregorian","persian"],Mi={mixins:[je,ln,Pe],props:{value:{required:!0},mask:{type:String},locale:Object,calendar:{type:String,validator:function(e){return Ci.includes(e)},default:"gregorian"},landscape:Boolean,color:String,textColor:String,square:Boolean,flat:Boolean,bordered:Boolean,readonly:Boolean,disable:Boolean},computed:{computedMask:function(){return this.__getMask()},computedLocale:function(){return this.__getLocale()},editable:function(){return!0!==this.disable&&!0!==this.readonly},computedColor:function(){return this.color||"primary"},computedTextColor:function(){return this.textColor||"white"},computedTabindex:function(){return!0===this.editable?0:-1},headerClass:function(){var e=[];return void 0!==this.color&&e.push("bg-"+this.color),void 0!==this.textColor&&e.push("text-"+this.textColor),e.join(" ")}},methods:{__getLocale:function(){return this.locale||this.$q.lang.date},__getCurrentDate:function(){var e=new Date;if("persian"===this.calendar){var t=vi(e);return{year:t.jy,month:t.jm,day:t.jd}}return{year:e.getFullYear(),month:e.getMonth()+1,day:e.getDate(),hour:0,minute:0,second:0,millisecond:0}},__getCurrentTime:function(){var e=new Date;return{hour:e.getHours(),minute:e.getMinutes(),second:e.getSeconds(),millisecond:e.getMilliseconds()}}}},Ti=864e5,Ai=36e5,Pi=6e4,Li="YYYY-MM-DDTHH:mm:ss.SSSZ",Oi=/\[((?:[^\]\\]|\\]|\\)*)\]|d{1,4}|M{1,4}|m{1,2}|w{1,2}|Qo|Do|D{1,4}|YY(?:YY)?|H{1,2}|h{1,2}|s{1,2}|S{1,3}|Z{1,2}|a{1,2}|[AQExX]/g,qi=/(\[[^\]]*\])|d{1,4}|M{1,4}|m{1,2}|w{1,2}|Qo|Do|D{1,4}|YY(?:YY)?|H{1,2}|h{1,2}|s{1,2}|S{1,3}|Z{1,2}|a{1,2}|[AQExX]|([.*+:?^,\s${}()|\\]+)/g,Ei={};function Di(e,t,n,i,r){var o={year:null,month:null,day:null,hour:null,minute:null,second:null,millisecond:null,timezoneOffset:null,dateHash:null,timeHash:null};if(void 0!==r&&Object.assign(o,r),null==e||""===e||"string"!=typeof e)return o;void 0===t&&(t=Li);var a=void 0!==n?n:R.props.date,s=a.months,l=a.monthsShort,c=function(e,t){var n="("+t.days.join("|")+")",i=e+n;if(void 0!==Ei[i])return Ei[i];var r="("+t.daysShort.join("|")+")",o="("+t.months.join("|")+")",a="("+t.monthsShort.join("|")+")",s={},l=0,c=e.replace(qi,(function(e){switch(l++,e){case"YY":return s.YY=l,"(-?\\d{1,2})";case"YYYY":return s.YYYY=l,"(-?\\d{1,4})";case"M":return s.M=l,"(\\d{1,2})";case"MM":return s.M=l,"(\\d{2})";case"MMM":return s.MMM=l,a;case"MMMM":return s.MMMM=l,o;case"D":return s.D=l,"(\\d{1,2})";case"Do":return s.D=l++,"(\\d{1,2}(st|nd|rd|th))";case"DD":return s.D=l,"(\\d{2})";case"H":return s.H=l,"(\\d{1,2})";case"HH":return s.H=l,"(\\d{2})";case"h":return s.h=l,"(\\d{1,2})";case"hh":return s.h=l,"(\\d{2})";case"m":return s.m=l,"(\\d{1,2})";case"mm":return s.m=l,"(\\d{2})";case"s":return s.s=l,"(\\d{1,2})";case"ss":return s.s=l,"(\\d{2})";case"S":return s.S=l,"(\\d{1})";case"SS":return s.S=l,"(\\d{2})";case"SSS":return s.S=l,"(\\d{3})";case"A":return s.A=l,"(AM|PM)";case"a":return s.a=l,"(am|pm)";case"aa":return s.aa=l,"(a\\.m\\.|p\\.m\\.)";case"ddd":return r;case"dddd":return n;case"Q":case"d":case"E":return"(\\d{1})";case"Qo":return"(1st|2nd|3rd|4th)";case"DDD":case"DDDD":return"(\\d{1,3})";case"w":return"(\\d{1,2})";case"ww":return"(\\d{2})";case"Z":return s.Z=l,"(Z|[+-]\\d{2}:\\d{2})";case"ZZ":return s.ZZ=l,"(Z|[+-]\\d{2}\\d{2})";case"X":return s.X=l,"(-?\\d+)";case"x":return s.x=l,"(-?\\d{4,})";default:return l--,"["===e[0]&&(e=e.substring(1,e.length-1)),e.replace(/[.*+?^${}()|[\]\\]/g,"\\$&")}})),u={map:s,regex:new RegExp("^"+c)};return Ei[i]=u,u}(t,a),u=c.regex,d=c.map,h=e.match(u);if(null===h)return o;var f="";if(void 0!==d.X||void 0!==d.x){var p=parseInt(h[void 0!==d.X?d.X:d.x],10);if(!0===isNaN(p)||p<0)return o;var m=new Date(p*(void 0!==d.X?1e3:1));o.year=m.getFullYear(),o.month=m.getMonth()+1,o.day=m.getDate(),o.hour=m.getHours(),o.minute=m.getMinutes(),o.second=m.getSeconds(),o.millisecond=m.getMilliseconds()}else{if(void 0!==d.YYYY)o.year=parseInt(h[d.YYYY],10);else if(void 0!==d.YY){var v=parseInt(h[d.YY],10);o.year=v<0?v:2e3+v}if(void 0!==d.M){if(o.month=parseInt(h[d.M],10),o.month<1||o.month>12)return o}else void 0!==d.MMM?o.month=l.indexOf(h[d.MMM])+1:void 0!==d.MMMM&&(o.month=s.indexOf(h[d.MMMM])+1);if(void 0!==d.D){if(o.day=parseInt(h[d.D],10),null===o.year||null===o.month||o.day<1)return o;var g="persian"!==i?new Date(o.year,o.month,0).getDate():bi(o.year,o.month);if(o.day>g)return o}void 0!==d.H?o.hour=parseInt(h[d.H],10)%24:void 0!==d.h&&(o.hour=parseInt(h[d.h],10)%12,(d.A&&"PM"===h[d.A]||d.a&&"pm"===h[d.a]||d.aa&&"p.m."===h[d.aa])&&(o.hour+=12),o.hour=o.hour%24),void 0!==d.m&&(o.minute=parseInt(h[d.m],10)%60),void 0!==d.s&&(o.second=parseInt(h[d.s],10)%60),void 0!==d.S&&(o.millisecond=parseInt(h[d.S],10)*Math.pow(10,3-h[d.S].length)),void 0===d.Z&&void 0===d.ZZ||(f=void 0!==d.Z?h[d.Z].replace(":",""):h[d.ZZ],o.timezoneOffset=("+"===f[0]?-1:1)*(60*f.slice(1,3)+1*f.slice(3,5)))}return o.dateHash=o.year+"/"+he(o.month)+"/"+he(o.day),o.timeHash=he(o.hour)+":"+he(o.minute)+":"+he(o.second)+f,o}function zi(e,t){void 0===t&&(t="");var n=e>0?"-":"+",i=Math.abs(e),r=i%60;return n+he(Math.floor(i/60))+t+he(r)}function Ni(e,t){var n=new Date(e.getFullYear(),t,0,0,0,0,0).getDate();e.setMonth(t-1,Math.min(n,e.getDate()))}function ji(e,t,n){var i=new Date(e),r=n?1:-1;return Object.keys(t).forEach((function(e){if("month"!==e){var n="year"===e?"FullYear":ce("days"===e?"date":e);i["set"+n](i["get"+n]()+r*t[e])}else Ni(i,i.getMonth()+1+r*t.month)})),i}function Ri(e){var t=new Date(e.getFullYear(),e.getMonth(),e.getDate());t.setDate(t.getDate()-(t.getDay()+6)%7+3);var n=new Date(t.getFullYear(),0,4);n.setDate(n.getDate()-(n.getDay()+6)%7+3);var i=t.getTimezoneOffset()-n.getTimezoneOffset();t.setHours(t.getHours()-i);var r=(t-n)/(7*Ti);return 1+Math.floor(r)}function Ii(e,t){var n=new Date(e);return!0===t?function(e){return 1e4*e.getFullYear()+100*e.getMonth()+e.getDate()}(n):n.getTime()}function $i(e,t,n){var i=new Date(e),r="set"+(n?"UTC":"");return Object.keys(t).forEach((function(e){if("month"!==e){var n="year"===e?"FullYear":e.charAt(0).toUpperCase()+e.slice(1);i[""+r+n](t[e])}else Ni(i,t.month)})),i}function Fi(e,t){var n=new Date(e);switch(t){case"year":n.setMonth(0);case"month":n.setDate(1);case"day":n.setHours(0);case"hour":n.setMinutes(0);case"minute":n.setSeconds(0);case"second":n.setMilliseconds(0)}return n}function Bi(e,t,n){return(e.getTime()-e.getTimezoneOffset()*Pi-(t.getTime()-t.getTimezoneOffset()*Pi))/n}function Vi(e,t,n){void 0===n&&(n="days");var i=new Date(e),r=new Date(t);switch(n){case"years":return i.getFullYear()-r.getFullYear();case"months":return 12*(i.getFullYear()-r.getFullYear())+i.getMonth()-r.getMonth();case"days":return Bi(Fi(i,"day"),Fi(r,"day"),Ti);case"hours":return Bi(Fi(i,"hour"),Fi(r,"hour"),Ai);case"minutes":return Bi(Fi(i,"minute"),Fi(r,"minute"),Pi);case"seconds":return Bi(Fi(i,"second"),Fi(r,"second"),1e3)}}function Hi(e){return Vi(e,Fi(e,"year"),"days")+1}function Wi(e){return new Date(e.getFullYear(),e.getMonth()+1,0).getDate()}function Ui(e){if(e>=11&&e<=13)return e+"th";switch(e%10){case 1:return e+"st";case 2:return e+"nd";case 3:return e+"rd"}return e+"th"}var Yi={YY:function(e,t,n){var i=this.YYYY(e,t,n)%100;return i>0?he(i):"-"+he(Math.abs(i))},YYYY:function(e,t,n){return null!=n?n:e.getFullYear()},M:function(e){return e.getMonth()+1},MM:function(e){return he(e.getMonth()+1)},MMM:function(e,t){return t.monthsShort[e.getMonth()]},MMMM:function(e,t){return t.months[e.getMonth()]},Q:function(e){return Math.ceil((e.getMonth()+1)/3)},Qo:function(e){return Ui(this.Q(e))},D:function(e){return e.getDate()},Do:function(e){return Ui(e.getDate())},DD:function(e){return he(e.getDate())},DDD:function(e){return Hi(e)},DDDD:function(e){return he(Hi(e),3)},d:function(e){return e.getDay()},dd:function(e,t){return this.dddd(e,t).slice(0,2)},ddd:function(e,t){return t.daysShort[e.getDay()]},dddd:function(e,t){return t.days[e.getDay()]},E:function(e){return e.getDay()||7},w:function(e){return Ri(e)},ww:function(e){return he(Ri(e))},H:function(e){return e.getHours()},HH:function(e){return he(e.getHours())},h:function(e){var t=e.getHours();return 0===t?12:t>12?t%12:t},hh:function(e){return he(this.h(e))},m:function(e){return e.getMinutes()},mm:function(e){return he(e.getMinutes())},s:function(e){return e.getSeconds()},ss:function(e){return he(e.getSeconds())},S:function(e){return Math.floor(e.getMilliseconds()/100)},SS:function(e){return he(Math.floor(e.getMilliseconds()/10))},SSS:function(e){return he(e.getMilliseconds(),3)},A:function(e){return this.H(e)<12?"AM":"PM"},a:function(e){return this.H(e)<12?"am":"pm"},aa:function(e){return this.H(e)<12?"a.m.":"p.m."},Z:function(e,t,n,i){return zi(null==i?e.getTimezoneOffset():i,":")},ZZ:function(e,t,n,i){return zi(null==i?e.getTimezoneOffset():i)},X:function(e){return Math.floor(e.getTime()/1e3)},x:function(e){return e.getTime()}};function Gi(e,t,n,i,r){if((0===e||e)&&e!==1/0&&e!==-1/0){var o=new Date(e);if(!isNaN(o)){void 0===t&&(t=Li);var a=void 0!==n?n:R.props.date;return t.replace(Oi,(function(e,t){return e in Yi?Yi[e](o,a,i,r):void 0===t?e:t.split("\\]").join("]")}))}}}var Qi,Ki,Zi,Ji,Xi,er,tr={isValid:function(e){return"number"==typeof e||!1===isNaN(Date.parse(e))},extractDate:function(e,t,n){var i=Di(e,t,n),r=new Date(i.year,null===i.month?null:i.month-1,i.day,i.hour,i.minute,i.second,i.millisecond),o=r.getTimezoneOffset();return null===i.timezoneOffset||i.timezoneOffset===o?r:ji(r,{minutes:i.timezoneOffset-o},!0)},buildDate:function(e,t){return $i(new Date,e,t)},getDayOfWeek:function(e){var t=new Date(e).getDay();return 0===t?7:t},getWeekOfYear:Ri,isBetweenDates:function(e,t,n,i){void 0===i&&(i={});var r=Ii(t,i.onlyDate),o=Ii(n,i.onlyDate),a=Ii(e,i.onlyDate);return(a>r||!0===i.inclusiveFrom&&a===r)&&(a<o||!0===i.inclusiveTo&&a===o)},addToDate:function(e,t){return ji(e,t,!0)},subtractFromDate:function(e,t){return ji(e,t,!1)},adjustDate:$i,startOfDate:Fi,endOfDate:function(e,t){var n=new Date(e);switch(t){case"year":n.setMonth(11);case"month":n.setDate(Wi(n));case"day":n.setHours(23);case"hour":n.setMinutes(59);case"minute":n.setSeconds(59);case"second":n.setMilliseconds(59)}return n},getMaxDate:function(e){var t=new Date(e);return Array.prototype.slice.call(arguments,1).forEach((function(e){t=Math.max(t,new Date(e))})),t},getMinDate:function(e){var t=new Date(e);return Array.prototype.slice.call(arguments,1).forEach((function(e){t=Math.min(t,new Date(e))})),t},getDateDiff:Vi,getDayOfYear:Hi,inferDateFormat:function(e){return!0===Cn(e)?"date":"number"==typeof e?"number":"string"},getDateBetween:function(e,t,n){var i=new Date(e);if(t){var r=new Date(t);if(i<r)return r}if(n){var o=new Date(n);if(i>o)return o}return i},isSameDate:function(e,t,n){var i=new Date(e),r=new Date(t);if(void 0===n)return i.getTime()===r.getTime();switch(n){case"second":if(i.getSeconds()!==r.getSeconds())return!1;case"minute":if(i.getMinutes()!==r.getMinutes())return!1;case"hour":if(i.getHours()!==r.getHours())return!1;case"day":if(i.getDate()!==r.getDate())return!1;case"month":if(i.getMonth()!==r.getMonth())return!1;case"year":if(i.getFullYear()!==r.getFullYear())return!1;break;default:throw new Error("date isSameDate unknown unit "+n)}return!0},daysInMonth:Wi,formatDate:Gi,clone:function(e){return!0===Cn(e)?new Date(e.getTime()):e}},nr=20,ir=["Calendar","Years","Months"],rr=function(e){return ir.includes(e)},or=function(e){return/^-?[\d]+\/[0-1]\d$/.test(e)},ar=" — ",sr=e.extend({name:"QDate",mixins:[Mi],props:{multiple:Boolean,range:Boolean,title:String,subtitle:String,mask:{default:"YYYY/MM/DD"},defaultYearMonth:{type:String,validator:or},yearsInMonthView:Boolean,events:[Array,Function],eventColor:[String,Function],emitImmediately:Boolean,options:[Array,Function],navigationMinYearMonth:{type:String,validator:or},navigationMaxYearMonth:{type:String,validator:or},noUnset:Boolean,firstDayOfWeek:[String,Number],todayBtn:Boolean,minimal:Boolean,defaultView:{type:String,default:"Calendar",validator:rr}},data:function(){var e=this.__getMask(),t=this.__getLocale(),n=this.__getViewModel(e,t),i=n.year,r=!0===this.$q.lang.rtl?"right":"left";return{view:this.defaultView,monthDirection:r,yearDirection:r,startYear:i-i%nr-(i<0?nr:0),editRange:void 0,innerMask:e,innerLocale:t,viewModel:n}},watch:{value:function(e){if(this.lastEmitValue===e)this.lastEmitValue=0;else{var t=this.__getViewModel(this.innerMask,this.innerLocale),n=t.year,i=t.month;this.__updateViewModel(n,i)}},view:function(){void 0!==this.$refs.blurTarget&&this.$refs.blurTarget.focus()},"viewModel.year":function(e){this.$emit("navigation",{year:e,month:this.viewModel.month})},"viewModel.month":function(e){this.$emit("navigation",{year:this.viewModel.year,month:e})},computedMask:function(e){this.__updateValue(e,this.innerLocale,"mask"),this.innerMask=e},computedLocale:function(e){this.__updateValue(this.innerMask,e,"locale"),this.innerLocale=e}},computed:{classes:function(){var e=!0===this.landscape?"landscape":"portrait";return"q-date q-date--"+e+" q-date--"+e+"-"+(!0===this.minimal?"minimal":"standard")+(!0===this.isDark?" q-date--dark q-dark":"")+(!0===this.bordered?" q-date--bordered":"")+(!0===this.square?" q-date--square no-border-radius":"")+(!0===this.flat?" q-date--flat no-shadow":"")+(!0===this.disable?" disabled":!0===this.readonly?" q-date--readonly":"")},isImmediate:function(){return!0===this.emitImmediately&&void 0!==this.daysModel[0]&&null!==this.daysModel[0].dateHash},normalizedModel:function(){return!0===Array.isArray(this.value)?this.value:null!==this.value&&void 0!==this.value?[this.value]:[]},daysModel:function(){var e=this;return this.normalizedModel.filter((function(e){return"string"==typeof e})).map((function(t){return e.__decodeString(t,e.innerMask,e.innerLocale)})).filter((function(e){return null!==e.dateHash}))},rangeModel:function(){var e=this,t=function(t){return e.__decodeString(t,e.innerMask,e.innerLocale)};return this.normalizedModel.filter((function(e){return Object(e)===e&&void 0!==e.from&&void 0!==e.to})).map((function(e){return{from:t(e.from),to:t(e.to)}})).filter((function(e){return null!==e.from.dateHash&&null!==e.to.dateHash&&e.from.dateHash<e.to.dateHash}))},getNativeDateFn:function(){return"persian"!==this.calendar?function(e){return new Date(e.year,e.month-1,e.day)}:function(e){var t=gi(e.year,e.month,e.day);return new Date(t.gy,t.gm-1,t.gd)}},encodeObjectFn:function(){var e=this;return"persian"===this.calendar?this.__getDayHash:function(t,n,i){return Gi(new Date(t.year,t.month-1,t.day,t.hour,t.minute,t.second,t.millisecond),void 0===n?e.innerMask:n,void 0===i?e.innerLocale:i,t.year,t.timezoneOffset)}},daysInModel:function(){var e=this;return this.daysModel.length+this.rangeModel.reduce((function(t,n){return t+1+Vi(e.getNativeDateFn(n.to),e.getNativeDateFn(n.from))}),0)},headerTitle:function(){if(void 0!==this.title&&null!==this.title&&this.title.length>0)return this.title;if(void 0!==this.editRange){var e=this.editRange.init,t=this.getNativeDateFn(e);return this.innerLocale.daysShort[t.getDay()]+", "+this.innerLocale.monthsShort[e.month-1]+" "+e.day+ar+"?"}if(0===this.daysInModel)return ar;if(this.daysInModel>1)return this.daysInModel+" "+this.innerLocale.pluralDay;var n=this.daysModel[0],i=this.getNativeDateFn(n);return!0===isNaN(i.valueOf())?ar:void 0!==this.innerLocale.headerTitle?this.innerLocale.headerTitle(i,n):this.innerLocale.daysShort[i.getDay()]+", "+this.innerLocale.monthsShort[n.month-1]+" "+n.day},headerSubtitle:function(){if(void 0!==this.subtitle&&null!==this.subtitle&&this.subtitle.length>0)return this.subtitle;if(0===this.daysInModel)return ar;if(this.daysInModel>1){var e=this.minSelectedModel,t=this.maxSelectedModel,n=this.innerLocale.monthsShort;return n[e.month-1]+(e.year!==t.year?" "+e.year+ar+n[t.month-1]+" ":e.month!==t.month?ar+n[t.month-1]:"")+" "+t.year}return this.daysModel[0].year},minSelectedModel:function(){return this.daysModel.concat(this.rangeModel.map((function(e){return e.from}))).sort((function(e,t){return e.year-t.year||e.month-t.month}))[0]},maxSelectedModel:function(){return this.daysModel.concat(this.rangeModel.map((function(e){return e.to}))).sort((function(e,t){return t.year-e.year||t.month-e.month}))[0]},dateArrow:function(){var e=[this.$q.iconSet.datetime.arrowLeft,this.$q.iconSet.datetime.arrowRight];return!0===this.$q.lang.rtl?e.reverse():e},computedFirstDayOfWeek:function(){return void 0!==this.firstDayOfWeek?Number(this.firstDayOfWeek):this.innerLocale.firstDayOfWeek},daysOfWeek:function(){var e=this.innerLocale.daysShort,t=this.computedFirstDayOfWeek;return t>0?e.slice(t,7).concat(e.slice(0,t)):e},daysInMonth:function(){var e=this.viewModel;return"persian"!==this.calendar?new Date(e.year,e.month,0).getDate():bi(e.year,e.month)},today:function(){return this.__getCurrentDate()},evtColor:function(){var e=this;return"function"==typeof this.eventColor?this.eventColor:function(){return e.eventColor}},minNav:function(){if(void 0!==this.navigationMinYearMonth){var e=this.navigationMinYearMonth.split("/");return{year:parseInt(e[0],10),month:parseInt(e[1],10)}}},maxNav:function(){if(void 0!==this.navigationMaxYearMonth){var e=this.navigationMaxYearMonth.split("/");return{year:parseInt(e[0],10),month:parseInt(e[1],10)}}},navBoundaries:function(){var e={month:{prev:!0,next:!0},year:{prev:!0,next:!0}};return void 0!==this.minNav&&this.minNav.year>=this.viewModel.year&&(e.year.prev=!1,this.minNav.year===this.viewModel.year&&this.minNav.month>=this.viewModel.month&&(e.month.prev=!1)),void 0!==this.maxNav&&this.maxNav.year<=this.viewModel.year&&(e.year.next=!1,this.maxNav.year===this.viewModel.year&&this.maxNav.month<=this.viewModel.month&&(e.month.next=!1)),e},daysMap:function(){var e=this,t={};return this.daysModel.forEach((function(n){var i=e.__getMonthHash(n);void 0===t[i]&&(t[i]=[]),t[i].push(n.day)})),t},rangeMap:function(){var e=this,t={};return this.rangeModel.forEach((function(n){var i=e.__getMonthHash(n.from),r=e.__getMonthHash(n.to);if(void 0===t[i]&&(t[i]=[]),t[i].push({from:n.from.day,to:i===r?n.to.day:void 0,range:n}),i<r)for(var o,a=n.from,s=a.year,l=a.month,c=l<12?{year:s,month:l+1}:{year:s+1,month:1};(o=e.__getMonthHash(c))<=r;)void 0===t[o]&&(t[o]=[]),t[o].push({from:void 0,to:o===r?n.to.day:void 0,range:n}),c.month++,c.month>12&&(c.year++,c.month=1)})),t},rangeView:function(){if(void 0!==this.editRange){var e=this.editRange,t=e.init,n=e.initHash,i=e.final,r=n<=e.finalHash?[t,i]:[i,t],o=r[0],a=r[1],s=this.__getMonthHash(o),l=this.__getMonthHash(a);if(s===this.viewMonthHash||l===this.viewMonthHash){var c={};return s===this.viewMonthHash?(c.from=o.day,c.includeFrom=!0):c.from=1,l===this.viewMonthHash?(c.to=a.day,c.includeTo=!0):c.to=this.daysInMonth,c}}},viewMonthHash:function(){return this.__getMonthHash(this.viewModel)},selectionDaysMap:function(){var e=this,t={};if(void 0===this.options){for(var n=1;n<=this.daysInMonth;n++)t[n]=!0;return t}for(var i="function"==typeof this.options?this.options:function(t){return e.options.includes(t)},r=1;r<=this.daysInMonth;r++){var o=this.viewMonthHash+"/"+he(r);t[r]=i(o)}return t},eventDaysMap:function(){var e=this,t={};if(void 0===this.events)for(var n=1;n<=this.daysInMonth;n++)t[n]=!1;else for(var i="function"==typeof this.events?this.events:function(t){return e.events.includes(t)},r=1;r<=this.daysInMonth;r++){var o=this.viewMonthHash+"/"+he(r);t[r]=!0===i(o)&&this.evtColor(o)}return t},viewDays:function(){var e,t,n=this.viewModel,i=n.year,r=n.month;if("persian"!==this.calendar)e=new Date(i,r-1,1),t=new Date(i,r-1,0).getDate();else{var o=gi(i,r,1);e=new Date(o.gy,o.gm-1,o.gd);var a=r-1,s=i;0===a&&(a=12,s--),t=bi(s,a)}return{days:e.getDay()-this.computedFirstDayOfWeek-1,endDay:t}},days:function(){var e=this,t=[],n=this.viewDays,i=n.days,r=n.endDay,o=i<0?i+7:i;if(o<6)for(var a=r-o;a<=r;a++)t.push({i:a,fill:!0});for(var s=t.length,l=1;l<=this.daysInMonth;l++){var c={i:l,event:this.eventDaysMap[l],classes:[]};!0===this.selectionDaysMap[l]&&(c.in=!0,c.flat=!0),t.push(c)}if(void 0!==this.daysMap[this.viewMonthHash]&&this.daysMap[this.viewMonthHash].forEach((function(n){var i=s+n-1;Object.assign(t[i],{selected:!0,unelevated:!0,flat:!1,color:e.computedColor,textColor:e.computedTextColor})})),void 0!==this.rangeMap[this.viewMonthHash]&&this.rangeMap[this.viewMonthHash].forEach((function(n){if(void 0!==n.from){for(var i=s+n.from-1,r=s+(n.to||e.daysInMonth)-1,o=i;o<=r;o++)Object.assign(t[o],{range:n.range,unelevated:!0,color:e.computedColor,textColor:e.computedTextColor});Object.assign(t[i],{rangeFrom:!0,flat:!1}),void 0!==n.to&&Object.assign(t[r],{rangeTo:!0,flat:!1})}else if(void 0!==n.to){for(var a=s+n.to-1,l=s;l<=a;l++)Object.assign(t[l],{range:n.range,unelevated:!0,color:e.computedColor,textColor:e.computedTextColor});Object.assign(t[a],{flat:!1,rangeTo:!0})}else for(var c=s+e.daysInMonth-1,u=s;u<=c;u++)Object.assign(t[u],{range:n.range,unelevated:!0,color:e.computedColor,textColor:e.computedTextColor})})),void 0!==this.rangeView){for(var u=s+this.rangeView.from-1,d=s+this.rangeView.to-1,h=u;h<=d;h++)t[h].color=this.computedColor,t[h].editRange=!0;!0===this.rangeView.includeFrom&&(t[u].editRangeFrom=!0),!0===this.rangeView.includeTo&&(t[d].editRangeTo=!0)}this.viewModel.year===this.today.year&&this.viewModel.month===this.today.month&&(t[s+this.today.day-1].today=!0);var f=t.length%7;if(f>0)for(var p=7-f,m=1;m<=p;m++)t.push({i:m,fill:!0});return t.forEach((function(e){var t="q-date__calendar-item ";!0===e.fill?t+="q-date__calendar-item--fill":(t+="q-date__calendar-item--"+(!0===e.in?"in":"out"),void 0!==e.range&&(t+=" q-date__range"+(!0===e.rangeTo?"-to":!0===e.rangeFrom?"-from":"")),!0===e.editRange&&(t+=" q-date__edit-range"+(!0===e.editRangeFrom?"-from":"")+(!0===e.editRangeTo?"-to":"")),void 0===e.range&&!0!==e.editRange||(t+=" text-"+e.color)),e.classes=t})),t},attrs:function(){return!0===this.disable?{"aria-disabled":"true"}:!0===this.readonly?{"aria-readonly":"true"}:void 0}},methods:{setToday:function(){this.__toggleDate(this.today,this.__getMonthHash(this.today)),this.setCalendarTo(this.today.year,this.today.month)},setView:function(e){!0===rr(e)&&(this.view=e)},offsetCalendar:function(e,t){["month","year"].includes(e)&&this["__goTo"+("month"===e?"Month":"Year")](!0===t?-1:1)},setCalendarTo:function(e,t){this.view="Calendar",this.__updateViewModel(e,t)},setEditingRange:function(e,t){if(!1!==this.range&&e){var n=Object.assign(Object.assign({},this.viewModel),e),i=void 0!==t?Object.assign(Object.assign({},this.viewModel),t):n;this.editRange={init:n,initHash:this.__getDayHash(n),final:i,finalHash:this.__getDayHash(i)},this.setCalendarTo(n.year,n.month)}else this.editRange=void 0},__getMask:function(){return"persian"===this.calendar?"YYYY/MM/DD":this.mask},__decodeString:function(e,t,n){return Di(e,t,n,this.calendar,{hour:0,minute:0,second:0,millisecond:0})},__getViewModel:function(e,t){var n=!0===Array.isArray(this.value)?this.value:this.value?[this.value]:[];if(0===n.length)return this.__getDefaultViewModel();var i=this.__decodeString(void 0!==n[0].from?n[0].from:n[0],e,t);return null===i.dateHash?this.__getDefaultViewModel():i},__getDefaultViewModel:function(){var e,t;if(void 0!==this.defaultYearMonth){var n=this.defaultYearMonth.split("/");e=parseInt(n[0],10),t=parseInt(n[1],10)}else{var i=void 0!==this.today?this.today:this.__getCurrentDate();e=i.year,t=i.month}return{year:e,month:t,day:1,hour:0,minute:0,second:0,millisecond:0,dateHash:e+"/"+he(t)+"/01"}},__getHeader:function(e){var t=this;if(!0!==this.minimal)return e("div",{staticClass:"q-date__header",class:this.headerClass},[e("div",{staticClass:"relative-position"},[e("transition",{props:{name:"q-transition--fade"}},[e("div",{key:"h-yr-"+this.headerSubtitle,staticClass:"q-date__header-subtitle q-date__header-link",class:"Years"===this.view?"q-date__header-link--active":"cursor-pointer",attrs:{tabindex:this.computedTabindex},on:pe(this,"vY",{click:function(){t.view="Years"},keyup:function(e){13===e.keyCode&&(t.view="Years")}})},[this.headerSubtitle])])]),e("div",{staticClass:"q-date__header-title relative-position flex no-wrap"},[e("div",{staticClass:"relative-position col"},[e("transition",{props:{name:"q-transition--fade"}},[e("div",{key:"h-sub"+this.headerTitle,staticClass:"q-date__header-title-label q-date__header-link",class:"Calendar"===this.view?"q-date__header-link--active":"cursor-pointer",attrs:{tabindex:this.computedTabindex},on:pe(this,"vC",{click:function(){t.view="Calendar"},keyup:function(e){13===e.keyCode&&(t.view="Calendar")}})},[this.headerTitle])])]),!0===this.todayBtn?e(bt,{staticClass:"q-date__header-today self-start",props:{icon:this.$q.iconSet.datetime.today,flat:!0,size:"sm",round:!0,tabindex:this.computedTabindex},on:pe(this,"today",{click:this.setToday})}):null])])},__getNavigation:function(e,t){var n=this,i=t.label,r=t.view,o=t.key,a=t.dir,s=t.goTo,l=t.boundaries,c=t.cls;return[e("div",{staticClass:"row items-center q-date__arrow"},[e(bt,{props:{round:!0,dense:!0,size:"sm",flat:!0,icon:this.dateArrow[0],tabindex:this.computedTabindex,disable:!1===l.prev},on:pe(this,"go-#"+r,{click:function(){s(-1)}})})]),e("div",{staticClass:"relative-position overflow-hidden flex flex-center"+c},[e("transition",{props:{name:"q-transition--jump-"+a}},[e("div",{key:o},[e(bt,{props:{flat:!0,dense:!0,noCaps:!0,label:i,tabindex:this.computedTabindex},on:pe(this,"view#"+r,{click:function(){n.view=r}})})])])]),e("div",{staticClass:"row items-center q-date__arrow"},[e(bt,{props:{round:!0,dense:!0,size:"sm",flat:!0,icon:this.dateArrow[1],tabindex:this.computedTabindex,disable:!1===l.next},on:pe(this,"go+#"+r,{click:function(){s(1)}})})])]},__getCalendarView:function(e){var t=this;return[e("div",{key:"calendar-view",staticClass:"q-date__view q-date__calendar"},[e("div",{staticClass:"q-date__navigation row items-center no-wrap"},this.__getNavigation(e,{label:this.innerLocale.months[this.viewModel.month-1],view:"Months",key:this.viewModel.month,dir:this.monthDirection,goTo:this.__goToMonth,boundaries:this.navBoundaries.month,cls:" col"}).concat(this.__getNavigation(e,{label:this.viewModel.year,view:"Years",key:this.viewModel.year,dir:this.yearDirection,goTo:this.__goToYear,boundaries:this.navBoundaries.year,cls:""}))),e("div",{staticClass:"q-date__calendar-weekdays row items-center no-wrap"},this.daysOfWeek.map((function(t){return e("div",{staticClass:"q-date__calendar-item"},[e("div",[t])])}))),e("div",{staticClass:"q-date__calendar-days-container relative-position overflow-hidden"},[e("transition",{props:{name:"q-transition--slide-"+this.monthDirection}},[e("div",{key:this.viewMonthHash,staticClass:"q-date__calendar-days fit"},this.days.map((function(n){return e("div",{staticClass:n.classes},[!0===n.in?e(bt,{staticClass:!0===n.today?"q-date__today":null,props:{dense:!0,flat:n.flat,unelevated:n.unelevated,color:n.color,textColor:n.textColor,label:n.i,tabindex:t.computedTabindex},on:pe(t,"day#"+n.i,{click:function(){t.__onDayClick(n.i)},mouseover:function(){t.__onDayMouseover(n.i)}})},!1!==n.event?[e("div",{staticClass:"q-date__event bg-"+n.event})]:null):e("div",[n.i])])})))])])])]},__getMonthsView:function(e){var t=this,n=this.viewModel.year===this.today.year,i=function(e){return void 0!==t.minNav&&t.viewModel.year===t.minNav.year&&t.minNav.month>e||void 0!==t.maxNav&&t.viewModel.year===t.maxNav.year&&t.maxNav.month<e},r=this.innerLocale.monthsShort.map((function(r,o){var a=t.viewModel.month===o+1;return e("div",{staticClass:"q-date__months-item flex flex-center"},[e(bt,{staticClass:!0===n&&t.today.month===o+1?"q-date__today":null,props:{flat:!0!==a,label:r,unelevated:a,color:!0===a?t.computedColor:null,textColor:!0===a?t.computedTextColor:null,tabindex:t.computedTabindex,disable:i(o+1)},on:pe(t,"month#"+o,{click:function(){t.__setMonth(o+1)}})})])}));return!0===this.yearsInMonthView&&r.unshift(e("div",{staticClass:"row no-wrap full-width"},[this.__getNavigation(e,{label:this.viewModel.year,view:"Years",key:this.viewModel.year,dir:this.yearDirection,goTo:this.__goToYear,boundaries:this.navBoundaries.year,cls:" col"})])),e("div",{key:"months-view",staticClass:"q-date__view q-date__months flex flex-center"},r)},__getYearsView:function(e){for(var t=this,n=this.startYear,i=n+nr,r=[],o=function(e){return void 0!==t.minNav&&t.minNav.year>e||void 0!==t.maxNav&&t.maxNav.year<e},a=function(n){var i=t.viewModel.year===n;r.push(e("div",{staticClass:"q-date__years-item flex flex-center"},[e(bt,{key:"yr"+n,staticClass:t.today.year===n?"q-date__today":null,props:{flat:!i,label:n,dense:!0,unelevated:i,color:!0===i?t.computedColor:null,textColor:!0===i?t.computedTextColor:null,tabindex:t.computedTabindex,disable:o(n)},on:pe(t,"yr#"+n,{click:function(){t.__setYear(n)}})})]))},s=n;s<=i;s++)a(s);return e("div",{staticClass:"q-date__view q-date__years flex flex-center"},[e("div",{staticClass:"col-auto"},[e(bt,{props:{round:!0,dense:!0,flat:!0,icon:this.dateArrow[0],tabindex:this.computedTabindex,disable:o(n)},on:pe(this,"y-",{click:function(){t.startYear-=nr}})})]),e("div",{staticClass:"q-date__years-content col self-stretch row items-center"},r),e("div",{staticClass:"col-auto"},[e(bt,{props:{round:!0,dense:!0,flat:!0,icon:this.dateArrow[1],tabindex:this.computedTabindex,disable:o(i)},on:pe(this,"y+",{click:function(){t.startYear+=nr}})})])])},__goToMonth:function(e){var t=this.viewModel.year,n=Number(this.viewModel.month)+e;13===n?(n=1,t++):0===n&&(n=12,t--),this.__updateViewModel(t,n),!0===this.isImmediate&&this.__emitImmediately("month")},__goToYear:function(e){var t=Number(this.viewModel.year)+e;this.__updateViewModel(t,this.viewModel.month),!0===this.isImmediate&&this.__emitImmediately("year")},__setYear:function(e){this.__updateViewModel(e,this.viewModel.month),this.view="Years"===this.defaultView?"Months":"Calendar",!0===this.isImmediate&&this.__emitImmediately("year")},__setMonth:function(e){this.__updateViewModel(this.viewModel.year,e),this.view="Calendar",!0===this.isImmediate&&this.__emitImmediately("month")},__getMonthHash:function(e){return e.year+"/"+he(e.month)},__getDayHash:function(e){return e.year+"/"+he(e.month)+"/"+he(e.day)},__toggleDate:function(e,t){var n=this.daysMap[t];(void 0!==n&&!0===n.includes(e.day)?this.__removeFromModel:this.__addToModel)(e)},__getShortDate:function(e){return{year:e.year,month:e.month,day:e.day}},__onDayClick:function(e){var t=Object.assign({},this.viewModel,{day:e});if(!1!==this.range)if(void 0===this.editRange){var n=this.days.find((function(t){return!0!==t.fill&&t.i===e}));if(void 0!==n.range)return void this.__removeFromModel({target:t,from:n.range.from,to:n.range.to});if(!0===n.selected)return void this.__removeFromModel(t);var i=this.__getDayHash(t);this.editRange={init:t,initHash:i,final:t,finalHash:i},this.$emit("range-start",this.__getShortDate(t))}else{var r=this.editRange.initHash,o=this.__getDayHash(t),a=r<=o?{from:this.editRange.init,to:t}:{from:t,to:this.editRange.init};this.editRange=void 0,this.__addToModel(r===o?t:Object.assign({},{target:t},a)),this.$emit("range-end",{from:this.__getShortDate(a.from),to:this.__getShortDate(a.to)})}else this.__toggleDate(t,this.viewMonthHash)},__onDayMouseover:function(e){if(void 0!==this.editRange){var t=Object.assign({},this.viewModel,{day:e});Object.assign(this.editRange,{final:t,finalHash:this.__getDayHash(t)})}},__updateViewModel:function(e,t){var n=this;void 0!==this.minNav&&e<=this.minNav.year&&(e=this.minNav.year,t<this.minNav.month&&(t=this.minNav.month)),void 0!==this.maxNav&&e>=this.maxNav.year&&(e=this.maxNav.year,t>this.maxNav.month&&(t=this.maxNav.month));var i=e+"/"+he(t)+"/01";i!==this.viewModel.dateHash&&(this.monthDirection=this.viewModel.dateHash<i==(!0!==this.$q.lang.rtl)?"left":"right",e!==this.viewModel.year&&(this.yearDirection=this.monthDirection),this.$nextTick((function(){n.startYear=e-e%nr-(e<0?nr:0),Object.assign(n.viewModel,{year:e,month:t,day:1,dateHash:i})})))},__emitValue:function(e,t,n){var i=null!==e&&1===e.length&&!1===this.multiple?e[0]:e;this.lastEmitValue=i;var r=this.__getEmitParams(t,n),o=r.reason,a=r.details;this.$emit("input",i,o,a)},__emitImmediately:function(e){var t=this,n=this.daysModel[0];this.$nextTick((function(){n.year=t.viewModel.year,n.month=t.viewModel.month;var i="persian"!==t.calendar?new Date(n.year,n.month,0).getDate():bi(n.year,n.month);n.day=Math.min(Math.max(1,n.day),i);var r=t.__encodeEntry(n);t.lastEmitValue=r;var o=t.__getEmitParams("",n).details;t.$emit("input",r,e,o)}))},__getEmitParams:function(e,t){return void 0!==t.from?{reason:e+"-range",details:Object.assign({},this.__getShortDate(t.target),{from:this.__getShortDate(t.from),to:this.__getShortDate(t.to),changed:!0})}:{reason:e+"-day",details:Object.assign({},this.__getShortDate(t),{changed:!0})}},__encodeEntry:function(e,t,n){return void 0!==e.from?{from:this.encodeObjectFn(e.from,t,n),to:this.encodeObjectFn(e.to,t,n)}:this.encodeObjectFn(e,t,n)},__addToModel:function(e){var t,n=this;if(!0===this.multiple)if(void 0!==e.from){var i=this.__getDayHash(e.from),r=this.__getDayHash(e.to),o=this.daysModel.filter((function(e){return e.dateHash<i||e.dateHash>r})),a=this.rangeModel.filter((function(e){var t=e.from;return e.to.dateHash<i||t.dateHash>r}));t=o.concat(a).concat(e).map((function(e){return n.__encodeEntry(e)}))}else{var s=this.normalizedModel.slice();s.push(this.__encodeEntry(e)),t=s}else t=this.__encodeEntry(e);this.__emitValue(t,"add",e)},__removeFromModel:function(e){if(!0!==this.noUnset){var t=null;if(!0===this.multiple&&!0===Array.isArray(this.value)){var n=this.__encodeEntry(e);t=void 0!==e.from?this.value.filter((function(e){return void 0===e.from||e.from!==n.from&&e.to!==n.to})):this.value.filter((function(e){return e!==n})),0===t.length&&(t=null)}this.__emitValue(t,"remove",e)}},__updateValue:function(e,t,n){var i=this,r=this.daysModel.concat(this.rangeModel).map((function(n){return i.__encodeEntry(n,e,t)})).filter((function(e){return void 0!==e.from?null!==e.from.dateHash&&null!==e.to.dateHash:null!==e.dateHash}));this.$emit("input",(!0===this.multiple?r:r[0])||null,n)}},render:function(e){var t=[e("div",{staticClass:"q-date__content col relative-position"},[e("transition",{props:{name:"q-transition--fade"}},[this["__get"+this.view+"View"](e)])])],n=Le(this,"default");return void 0!==n&&t.push(e("div",{staticClass:"q-date__actions"},n)),void 0!==this.name&&!0!==this.disable&&this.__injectFormInput(t,"push"),e("div",{class:this.classes,attrs:this.attrs,on:Object.assign({},this.qListeners)},[this.__getHeader(e),e("div",{staticClass:"q-date__main col column",attrs:{tabindex:-1},ref:"blurTarget"},t)])}}),lr={methods:{__addHistory:function(){var e=this;this.__historyEntry={condition:function(){return!0===e.hideOnRouteChange},handler:this.hide},z.add(this.__historyEntry)},__removeHistory:function(){void 0!==this.__historyEntry&&(z.remove(this.__historyEntry),this.__historyEntry=void 0)}},beforeDestroy:function(){!0===this.showing&&this.__removeHistory()}},cr=0,ur=!1;function dr(e){(function(e){if(e.target===document.body||e.target.classList.contains("q-layout__backdrop"))return!0;for(var t=_(e),n=e.shiftKey&&!e.deltaX,i=!n&&Math.abs(e.deltaX)<=Math.abs(e.deltaY),r=n||i?e.deltaY:e.deltaX,o=0;o<t.length;o++){var a=t[o];if(Gt(a,i))return i?r<0&&0===a.scrollTop||r>0&&a.scrollTop+a.clientHeight===a.scrollHeight:r<0&&0===a.scrollLeft||r>0&&a.scrollLeft+a.clientWidth===a.scrollWidth}return!0})(e)&&w(e)}function hr(e){e.target===document&&(document.scrollingElement.scrollTop=document.scrollingElement.scrollTop)}function fr(e){!0!==ur&&(ur=!0,requestAnimationFrame((function(){ur=!1;var t=e.target.height,n=document.scrollingElement,i=n.clientHeight,r=n.scrollTop;void 0!==Zi&&t===window.innerHeight||(Zi=i-t,document.scrollingElement.scrollTop=r),r>Zi&&(document.scrollingElement.scrollTop-=Math.ceil((r-Zi)/8))})))}function pr(e){var t=document.body,n=void 0!==window.visualViewport;if("add"===e){var i=window.getComputedStyle(t).overflowY;Qi=$t(window),Ki=It(window),Ji=t.style.left,Xi=t.style.top,t.style.left="-"+Qi+"px",t.style.top="-"+Ki+"px","hidden"!==i&&("scroll"===i||t.scrollHeight>window.innerHeight)&&t.classList.add("q-body--force-scrollbar"),t.classList.add("q-body--prevent-scroll"),document.qScrollPrevented=!0,!0===d.is.ios&&(!0===n?(window.scrollTo(0,0),window.visualViewport.addEventListener("resize",fr,f.passiveCapture),window.visualViewport.addEventListener("scroll",fr,f.passiveCapture),window.scrollTo(0,0)):window.addEventListener("scroll",hr,f.passiveCapture))}!0===d.is.desktop&&!0===d.is.mac&&window[e+"EventListener"]("wheel",dr,f.notPassive),"remove"===e&&(!0===d.is.ios&&(!0===n?(window.visualViewport.removeEventListener("resize",fr,f.passiveCapture),window.visualViewport.removeEventListener("scroll",fr,f.passiveCapture)):window.removeEventListener("scroll",hr,f.passiveCapture)),t.classList.remove("q-body--prevent-scroll"),t.classList.remove("q-body--force-scrollbar"),document.qScrollPrevented=!1,t.style.left=Ji,t.style.top=Xi,window.scrollTo(Qi,Ki),Zi=void 0)}function mr(e){var t="add";if(!0===e){if(cr++,void 0!==er)return clearTimeout(er),void(er=void 0);if(cr>1)return}else{if(0===cr)return;if(--cr>0)return;if(t="remove",!0===d.is.ios&&!0===d.is.nativeMobile)return clearTimeout(er),void(er=setTimeout((function(){pr(t),er=void 0}),100))}pr(t)}for(var vr,gr={methods:{__preventScroll:function(e){e===this.preventedScroll||void 0===this.preventedScroll&&!0!==e||(this.preventedScroll=e,mr(e))}}},_r=0,br={standard:"fixed-full flex-center",top:"fixed-top justify-center",bottom:"fixed-bottom justify-center",right:"fixed-right items-center",left:"fixed-left items-center"},yr={standard:["scale","scale"],top:["slide-down","slide-up"],bottom:["slide-up","slide-down"],right:["slide-left","slide-right"],left:["slide-right","slide-left"]},wr=e.extend({name:"QDialog",mixins:[_e,lr,St,Mt,gr],props:{persistent:Boolean,autoClose:Boolean,noEscDismiss:Boolean,noBackdropDismiss:Boolean,noRouteDismiss:Boolean,noRefocus:Boolean,noFocus:Boolean,seamless:Boolean,maximized:Boolean,fullWidth:Boolean,fullHeight:Boolean,square:Boolean,position:{type:String,default:"standard",validator:function(e){return"standard"===e||["top","bottom","left","right"].includes(e)}},transitionShow:String,transitionHide:String},data:function(){return{transitionState:this.showing}},watch:{showing:function(e){var t=this;this.transitionShowComputed!==this.transitionHideComputed&&this.$nextTick((function(){t.transitionState=e}))},maximized:function(e){!0===this.showing&&this.__updateMaximized(e)},useBackdrop:function(e){this.__preventScroll(e),this.__preventFocusout(e)}},computed:{classes:function(){return"q-dialog__inner--"+(!0===this.maximized?"maximized":"minimized")+" q-dialog__inner--"+this.position+" "+br[this.position]+(!0===this.fullWidth?" q-dialog__inner--fullwidth":"")+(!0===this.fullHeight?" q-dialog__inner--fullheight":"")+(!0===this.square?" q-dialog__inner--square":"")},transitionShowComputed:function(){return"q-transition--"+(void 0===this.transitionShow?yr[this.position][0]:this.transitionShow)},transitionHideComputed:function(){return"q-transition--"+(void 0===this.transitionHide?yr[this.position][1]:this.transitionHide)},transition:function(){return!0===this.transitionState?this.transitionHideComputed:this.transitionShowComputed},useBackdrop:function(){return!0===this.showing&&!0!==this.seamless},hideOnRouteChange:function(){return!0!==this.persistent&&!0!==this.noRouteDismiss&&!0!==this.seamless},onEvents:function(){var e=Object.assign({},this.qListeners,{input:b,"popup-show":b,"popup-hide":b});return!0===this.autoClose&&(e.click=this.__onAutoClose),e}},methods:{focus:function(){var e=this.__getInnerNode();void 0!==e&&!0!==e.contains(document.activeElement)&&(e=e.querySelector("[autofocus], [data-autofocus]")||e).focus()},shake:function(){this.focus(),this.$emit("shake");var e=this.__getInnerNode();void 0!==e&&(e.classList.remove("q-animate--scale"),e.classList.add("q-animate--scale"),clearTimeout(this.shakeTimeout),this.shakeTimeout=setTimeout((function(){e.classList.remove("q-animate--scale")}),170))},__getInnerNode:function(){return void 0!==this.__portal&&void 0!==this.__portal.$refs?this.__portal.$refs.inner:void 0},__show:function(e){var t=this;this.__addHistory(),this.__refocusTarget=!1===this.noRefocus&&null!==document.activeElement?document.activeElement:void 0,this.$el.dispatchEvent(x("popup-show",{bubbles:!0})),this.__updateMaximized(this.maximized),en.register(this,(function(){!0!==t.seamless&&(!0===t.persistent||!0===t.noEscDismiss?!0!==t.maximized&&t.shake():(t.$emit("escape-key"),t.hide()))})),this.__showPortal(),!0!==this.noFocus&&(null!==document.activeElement&&document.activeElement.blur(),this.__nextTick(this.focus)),this.__setTimeout((function(){if(!0===t.$q.platform.is.ios){if(!0!==t.seamless&&document.activeElement){var n=document.activeElement.getBoundingClientRect(),i=n.top,r=n.bottom,o=window.innerHeight,a=void 0!==window.visualViewport?window.visualViewport.height:o;if(i>0&&r>a/2){var s=Math.min(document.scrollingElement.scrollHeight-a,r>=o?1/0:Math.ceil(document.scrollingElement.scrollTop+r-a/2)),l=function(){requestAnimationFrame((function(){document.scrollingElement.scrollTop+=Math.ceil((s-document.scrollingElement.scrollTop)/8),document.scrollingElement.scrollTop!==s&&l()}))};l()}document.activeElement.scrollIntoView()}t.__portal.$el.click()}t.$emit("show",e)}),300)},__hide:function(e){var t=this;this.__removeHistory(),this.__cleanup(!0),void 0!==this.__refocusTarget&&null!==this.__refocusTarget&&this.__refocusTarget.focus(),this.$el.dispatchEvent(x("popup-hide",{bubbles:!0})),this.__setTimeout((function(){t.__hidePortal(),t.$emit("hide",e)}),300)},__cleanup:function(e){clearTimeout(this.shakeTimeout),!0!==e&&!0!==this.showing||(en.pop(this),this.__updateMaximized(!1),!0!==this.seamless&&(this.__preventScroll(!1),this.__preventFocusout(!1)))},__updateMaximized:function(e){!0===e?!0!==this.isMaximized&&(_r<1&&document.body.classList.add("q-body--dialog"),_r++,this.isMaximized=!0):!0===this.isMaximized&&(_r<2&&document.body.classList.remove("q-body--dialog"),_r--,this.isMaximized=!1)},__preventFocusout:function(e){if(!0===this.$q.platform.is.desktop){var t=(!0===e?"add":"remove")+"EventListener";document.body[t]("focusin",this.__onFocusChange)}},__onAutoClose:function(e){this.hide(e),void 0!==this.qListeners.click&&this.$emit("click",e)},__onBackdropClick:function(e){!0!==this.persistent&&!0!==this.noBackdropDismiss?this.hide(e):this.shake()},__onFocusChange:function(e){!0===this.showing&&void 0!==this.__portal&&!0!==function(e,t){if(void 0===e||!0===e.contains(t))return!0;for(var n=e.nextElementSibling;null!==n;n=n.nextElementSibling)if(n.contains(t))return!0;return!1}(this.__portal.$el,e.target)&&this.focus()},__renderPortal:function(e){return e("div",{staticClass:"q-dialog fullscreen no-pointer-events",class:this.contentClass,style:this.contentStyle,attrs:this.qAttrs},[e("transition",{props:{name:"q-transition--fade"}},!0===this.useBackdrop?[e("div",{staticClass:"q-dialog__backdrop fixed-full",attrs:ge,on:pe(this,"bkdrop",{click:this.__onBackdropClick})})]:null),e("transition",{props:{name:this.transition}},[!0===this.showing?e("div",{ref:"inner",staticClass:"q-dialog__inner flex no-pointer-events",class:this.classes,attrs:{tabindex:-1},on:this.onEvents},Le(this,"default")):null])])}},mounted:function(){this.__processModelChange(this.value)},beforeDestroy:function(){this.__cleanup()}}),kr=["mouseover","mouseout","mouseenter","mouseleave"],xr=e.extend({name:"QDrawer",inject:{layout:{default:function(){console.error("QDrawer needs to be child of QLayout")}}},mixins:[je,lr,St,gr],directives:{TouchPan:Qn},props:{side:{type:String,default:"left",validator:function(e){return["left","right"].includes(e)}},width:{type:Number,default:300},mini:Boolean,miniToOverlay:Boolean,miniWidth:{type:Number,default:57},breakpoint:{type:Number,default:1023},showIfAbove:Boolean,behavior:{type:String,validator:function(e){return["default","desktop","mobile"].includes(e)},default:"default"},bordered:Boolean,elevated:Boolean,contentStyle:[String,Object,Array],contentClass:[String,Object,Array],overlay:Boolean,persistent:Boolean,noSwipeOpen:Boolean,noSwipeClose:Boolean,noSwipeBackdrop:Boolean},data:function(){var e="mobile"===this.behavior||"desktop"!==this.behavior&&this.layout.totalWidth<=this.breakpoint;return{belowBreakpoint:e,showing:!0===this.showIfAbove&&!1===e||!0===this.value}},watch:{belowBreakpoint:function(e){!0===e?(this.lastDesktopState=this.showing,!0===this.showing&&this.hide(!1)):!1===this.overlay&&"mobile"!==this.behavior&&!1!==this.lastDesktopState&&(!0===this.showing?(this.__applyPosition(0),this.__applyBackdrop(0),this.__cleanup()):this.show(!1))},"layout.totalWidth":function(e){this.__updateLocal("belowBreakpoint","mobile"===this.behavior||"desktop"!==this.behavior&&e<=this.breakpoint)},side:function(e,t){this.layout.instances[t]===this&&(this.layout.instances[t]=void 0,this.layout[t].space=!1,this.layout[t].offset=0),this.layout.instances[e]=this,this.layout[e].size=this.size,this.layout[e].space=this.onLayout,this.layout[e].offset=this.offset},behavior:function(e){this.__updateLocal("belowBreakpoint","mobile"===e||"desktop"!==e&&this.layout.totalWidth<=this.breakpoint)},breakpoint:function(e){this.__updateLocal("belowBreakpoint","mobile"===this.behavior||"desktop"!==this.behavior&&this.layout.totalWidth<=e)},"layout.container":function(e){!0===this.showing&&this.__preventScroll(!0!==e)},"layout.scrollbarWidth":function(){this.__applyPosition(!0===this.showing?0:void 0)},offset:function(e){this.__update("offset",e)},onLayout:function(e){this.$emit("on-layout",e),this.__update("space",e)},rightSide:function(){this.__applyPosition()},size:function(e){this.__applyPosition(),this.__updateSizeOnLayout(this.miniToOverlay,e)},miniToOverlay:function(e){this.__updateSizeOnLayout(e,this.size)},"$q.lang.rtl":function(){this.__applyPosition()},mini:function(){!0===this.value&&(this.__animateMini(),this.layout.__animate())},isMini:function(e){this.$emit("mini-state",e)}},computed:{rightSide:function(){return"right"===this.side},otherSide:function(){return!0===this.rightSide?"left":"right"},offset:function(){return!0===this.showing&&!1===this.belowBreakpoint&&!1===this.overlay?!0===this.miniToOverlay?this.miniWidth:this.size:0},size:function(){return!0===this.isMini?this.miniWidth:this.width},fixed:function(){return!0===this.overlay||!0===this.miniToOverlay||this.layout.view.indexOf(this.rightSide?"R":"L")>-1||this.$q.platform.is.ios&&!0===this.layout.container},onLayout:function(){return!0===this.showing&&!1===this.belowBreakpoint&&!1===this.overlay},onScreenOverlay:function(){return!0===this.showing&&!1===this.belowBreakpoint&&!0===this.overlay},backdropClass:function(){return!1===this.showing?"hidden":null},headerSlot:function(){return!0===this.rightSide?"r"===this.layout.rows.top[2]:"l"===this.layout.rows.top[0]},footerSlot:function(){return!0===this.rightSide?"r"===this.layout.rows.bottom[2]:"l"===this.layout.rows.bottom[0]},aboveStyle:function(){var e={};return!0===this.layout.header.space&&!1===this.headerSlot&&(!0===this.fixed?e.top=this.layout.header.offset+"px":!0===this.layout.header.space&&(e.top=this.layout.header.size+"px")),!0===this.layout.footer.space&&!1===this.footerSlot&&(!0===this.fixed?e.bottom=this.layout.footer.offset+"px":!0===this.layout.footer.space&&(e.bottom=this.layout.footer.size+"px")),e},style:function(){var e={width:this.size+"px"};return!0===this.belowBreakpoint?e:Object.assign(e,this.aboveStyle)},classes:function(){return"q-drawer--"+this.side+(!0===this.bordered?" q-drawer--bordered":"")+(!0===this.isDark?" q-drawer--dark q-dark":"")+(!0!==this.showing?" q-layout--prevent-focus":"")+(!0===this.belowBreakpoint?" fixed q-drawer--on-top q-drawer--mobile q-drawer--top-padding":" q-drawer--"+(!0===this.isMini?"mini":"standard")+(!0===this.fixed||!0!==this.onLayout?" fixed":"")+(!0===this.overlay||!0===this.miniToOverlay?" q-drawer--on-top":"")+(!0===this.headerSlot?" q-drawer--top-padding":""))},stateDirection:function(){return(!0===this.$q.lang.rtl?-1:1)*(!0===this.rightSide?1:-1)},isMini:function(){return!0===this.mini&&!0!==this.belowBreakpoint},onNativeEvents:function(){var e=this;if(!0!==this.belowBreakpoint){var t={"!click":function(t){e.$emit("click",t)}};return kr.forEach((function(n){t[n]=function(t){void 0!==e.qListeners[n]&&e.$emit(n,t)}})),t}},hideOnRouteChange:function(){return!0!==this.persistent&&(!0===this.belowBreakpoint||!0===this.onScreenOverlay)},openDirective:function(){var e,t=!0===this.$q.lang.rtl?this.side:this.otherSide;return[{name:"touch-pan",value:this.__openByTouch,modifiers:(e={},e[t]=!0,e.mouse=!0,e)}]},contentCloseDirective:function(){var e;if(!0!==this.noSwipeClose){var t=!0===this.$q.lang.rtl?this.otherSide:this.side;return[{name:"touch-pan",value:this.__closeByTouch,modifiers:(e={},e[t]=!0,e.mouse=!0,e)}]}},backdropCloseDirective:function(){var e;if(!0!==this.noSwipeBackdrop){var t=!0===this.$q.lang.rtl?this.otherSide:this.side;return[{name:"touch-pan",value:this.__closeByTouch,modifiers:(e={},e[t]=!0,e.mouse=!0,e.mouseAllDir=!0,e)}]}}},methods:{__applyPosition:function(e){var t=this;void 0===e?this.$nextTick((function(){e=!0===t.showing?0:t.size,t.__applyPosition(t.stateDirection*e)})):void 0!==this.$refs.content&&(!0!==this.layout.container||!0!==this.rightSide||!0!==this.belowBreakpoint&&Math.abs(e)!==this.size||(e+=this.stateDirection*this.layout.scrollbarWidth),this.__lastPosition!==e&&(this.$refs.content.style.transform="translateX("+e+"px)",this.__lastPosition=e))},__applyBackdrop:function(e,t){var n=this;void 0!==this.$refs.backdrop?this.$refs.backdrop.style.backgroundColor=this.lastBackdropBg="rgba(0,0,0,"+.4*e+")":!0!==t&&this.$nextTick((function(){n.__applyBackdrop(e,!0)}))},__setBackdropVisible:function(e){void 0!==this.$refs.backdrop&&this.$refs.backdrop.classList[!0===e?"remove":"add"]("hidden")},__setScrollable:function(e){var t=!0===e?"remove":!0!==this.layout.container?"add":"";""!==t&&document.body.classList[t]("q-body--drawer-toggle")},__animateMini:function(){var e=this;void 0!==this.timerMini?clearTimeout(this.timerMini):void 0!==this.$el&&this.$el.classList.add("q-drawer--mini-animate"),this.timerMini=setTimeout((function(){void 0!==e.$el&&e.$el.classList.remove("q-drawer--mini-animate"),e.timerMini=void 0}),150)},__openByTouch:function(e){if(!1===this.showing){var t=this.size,n=ue(e.distance.x,0,t);if(!0===e.isFinal){var i=this.$refs.content,r=n>=Math.min(75,t);return i.classList.remove("no-transition"),void(!0===r?this.show():(this.layout.__animate(),this.__applyBackdrop(0),this.__applyPosition(this.stateDirection*t),i.classList.remove("q-drawer--delimiter"),i.classList.add("q-layout--prevent-focus"),this.__setBackdropVisible(!1)))}if(this.__applyPosition((!0===this.$q.lang.rtl?!0!==this.rightSide:this.rightSide)?Math.max(t-n,0):Math.min(0,n-t)),this.__applyBackdrop(ue(n/t,0,1)),!0===e.isFirst){var o=this.$refs.content;o.classList.add("no-transition"),o.classList.add("q-drawer--delimiter"),o.classList.remove("q-layout--prevent-focus"),this.__setBackdropVisible(!0)}}},__closeByTouch:function(e){if(!0===this.showing){var t=this.size,n=e.direction===this.side,i=(!0===this.$q.lang.rtl?!0!==n:n)?ue(e.distance.x,0,t):0;if(!0===e.isFinal){var r=Math.abs(i)<Math.min(75,t);return this.$refs.content.classList.remove("no-transition"),void(!0===r?(this.layout.__animate(),this.__applyBackdrop(1),this.__applyPosition(0)):this.hide())}this.__applyPosition(this.stateDirection*i),this.__applyBackdrop(ue(1-i/t,0,1)),!0===e.isFirst&&this.$refs.content.classList.add("no-transition")}},__show:function(e,t){var n=this;if(this.__addHistory(),this.__setBackdropVisible(!0),!1!==e&&this.layout.__animate(),this.__applyPosition(0),!0===this.belowBreakpoint){var i=this.layout.instances[this.otherSide];void 0!==i&&!0===i.belowBreakpoint&&i.hide(!1),this.__applyBackdrop(1),!0!==this.layout.container&&this.__preventScroll(!0)}else this.__applyBackdrop(0),!1!==e&&this.__setScrollable(!1);this.__setTimeout((function(){!1!==e&&n.__setScrollable(!0),!0!==t&&n.$emit("show",e)}),150)},__hide:function(e,t){var n=this;this.__removeHistory(),!1!==e&&this.layout.__animate(),this.__applyBackdrop(0),this.__applyPosition(this.stateDirection*this.size),this.__setBackdropVisible(!1),this.__cleanup(),!0!==t&&this.__setTimeout((function(){n.$emit("hide",e)}),150)},__cleanup:function(){this.__preventScroll(!1),this.__setScrollable(!0)},__update:function(e,t){this.layout[this.side][e]!==t&&(this.layout[this.side][e]=t)},__updateLocal:function(e,t){this[e]!==t&&(this[e]=t)},__updateSizeOnLayout:function(e,t){this.__update("size",!0===e?this.miniWidth:t)}},created:function(){this.layout.instances[this.side]=this,this.__updateSizeOnLayout(this.miniToOverlay,this.size),this.__update("space",this.onLayout),this.__update("offset",this.offset),!0===this.showIfAbove&&!0!==this.value&&!0===this.showing&&void 0!==this.qListeners.input&&this.$emit("input",!0)},mounted:function(){var e=this;this.$emit("on-layout",this.onLayout),this.$emit("mini-state",this.isMini),this.lastDesktopState=!0===this.showIfAbove;var t=function(){var t=!0===e.showing?"show":"hide";e["__"+t](!1,!0)};0===this.layout.totalWidth?this.watcher=this.$watch("layout.totalWidth",(function(){e.watcher(),e.watcher=void 0,!1===e.showing&&!0===e.showIfAbove&&!1===e.belowBreakpoint?e.show(!1):t()})):this.$nextTick(t)},beforeDestroy:function(){void 0!==this.watcher&&this.watcher(),clearTimeout(this.timerMini),!0===this.showing&&this.__cleanup(),this.layout.instances[this.side]===this&&(this.layout.instances[this.side]=void 0,this.__update("size",0),this.__update("offset",0),this.__update("space",!1))},render:function(e){var t=[];!0===this.belowBreakpoint&&(!0!==this.noSwipeOpen&&t.push(e("div",{staticClass:"q-drawer__opener fixed-"+this.side,attrs:ge,directives:this.openDirective})),t.push(e("div",{ref:"backdrop",staticClass:"fullscreen q-drawer__backdrop",class:this.backdropClass,attrs:ge,style:void 0!==this.lastBackdropBg?{backgroundColor:this.lastBackdropBg}:null,on:pe(this,"bkdrop",{click:this.hide}),directives:!1===this.showing?void 0:this.backdropCloseDirective})));var n=[e("div",{staticClass:"q-drawer__content fit "+(!0===this.layout.container?"overflow-auto":"scroll"),class:this.contentClass,style:this.contentStyle},!0===this.isMini&&void 0!==this.$scopedSlots.mini?this.$scopedSlots.mini():Le(this,"default"))];return!0===this.elevated&&!0===this.showing&&n.push(e("div",{staticClass:"q-layout__shadow absolute-full overflow-hidden no-pointer-events"})),t.push(e("aside",{ref:"content",staticClass:"q-drawer",class:this.classes,style:this.style,on:this.onNativeEvents,directives:!0===this.belowBreakpoint?this.contentCloseDirective:void 0},n)),e("div",{staticClass:"q-drawer-container"},t)}}),Sr=[!0,!1,"ondemand"],Cr={props:{value:{},error:{type:Boolean,default:null},errorMessage:String,noErrorIcon:Boolean,rules:Array,reactiveRules:Boolean,lazyRules:{type:[Boolean,String],validator:function(e){return Sr.includes(e)}}},data:function(){return{isDirty:null,innerError:!1,innerErrorMessage:void 0}},watch:{value:function(){this.__validateIfNeeded()},reactiveRules:{handler:function(e){var t=this;!0===e?void 0===this.unwatchRules&&(this.unwatchRules=this.$watch("rules",(function(){t.__validateIfNeeded(!0)}))):void 0!==this.unwatchRules&&(this.unwatchRules(),this.unwatchRules=void 0)},immediate:!0},focused:function(e){"ondemand"!==this.lazyRules&&(!0===e?null===this.isDirty&&(this.isDirty=!1):!1===this.isDirty&&!0===this.hasRules&&(this.isDirty=!0,this.validate()))}},computed:{hasRules:function(){return void 0!==this.rules&&null!==this.rules&&this.rules.length>0},hasError:function(){return!0===this.error||!0===this.innerError},computedErrorMessage:function(){return"string"==typeof this.errorMessage&&this.errorMessage.length>0?this.errorMessage:this.innerErrorMessage}},mounted:function(){this.validateIndex=0},beforeDestroy:function(){void 0!==this.unwatchRules&&this.unwatchRules()},methods:{resetValidation:function(){this.validateIndex++,this.innerLoading=!1,this.isDirty=null,this.innerError=!1,this.innerErrorMessage=void 0},validate:function(e){var t=this;if(void 0===e&&(e=this.value),!0!==this.hasRules)return!0;this.validateIndex++,!0!==this.innerLoading&&!0!==this.lazyRules&&(this.isDirty=!0);for(var n=function(e,n){t.innerError!==e&&(t.innerError=e);var i=n||void 0;t.innerErrorMessage!==i&&(t.innerErrorMessage=i),!1!==t.innerLoading&&(t.innerLoading=!1)},i=[],r=0;r<this.rules.length;r++){var o=this.rules[r],a=void 0;if("function"==typeof o?a=o(e):"string"==typeof o&&void 0!==Hn[o]&&(a=Hn[o](e)),!1===a||"string"==typeof a)return n(!0,a),!1;!0!==a&&void 0!==a&&i.push(a)}if(0===i.length)return n(!1),!0;!0!==this.innerLoading&&(this.innerLoading=!0);var s=this.validateIndex;return Promise.all(i).then((function(e){if(s!==t.validateIndex)return!0;if(void 0===e||!1===Array.isArray(e)||0===e.length)return n(!1),!0;var i=e.find((function(e){return!1===e||"string"==typeof e}));return n(void 0!==i,i),void 0===i}),(function(e){return s!==t.validateIndex||(console.error(e),n(!0),!1)}))},__validateIfNeeded:function(e){!0===this.hasRules&&"ondemand"!==this.lazyRules&&(!0===this.isDirty||!0!==this.lazyRules&&!0!==e)&&this.validate()}}},Mr=0,Tr=new Array(256),Ar=0;Ar<256;Ar++)Tr[Ar]=(Ar+256).toString(16).substr(1);var Pr=function(){var e="undefined"!=typeof crypto?crypto:"undefined"!=typeof window?window.msCrypto:void 0;if(void 0!==e){if(void 0!==e.randomBytes)return e.randomBytes;if(void 0!==e.getRandomValues)return function(t){var n=new Uint8Array(t);return e.getRandomValues(n),n}}return function(e){for(var t=[],n=e;n>0;n--)t.push(Math.floor(256*Math.random()));return t}}(),Lr=4096;function Or(){(void 0===vr||Mr+16>Lr)&&(Mr=0,vr=Pr(Lr));var e=Array.prototype.slice.call(vr,Mr,Mr+=16);return e[6]=15&e[6]|64,e[8]=63&e[8]|128,Tr[e[0]]+Tr[e[1]]+Tr[e[2]]+Tr[e[3]]+"-"+Tr[e[4]]+Tr[e[5]]+"-"+Tr[e[6]]+Tr[e[7]]+"-"+Tr[e[8]]+Tr[e[9]]+"-"+Tr[e[10]]+Tr[e[11]]+Tr[e[12]]+Tr[e[13]]+Tr[e[14]]+Tr[e[15]]}function qr(e){return void 0===e?"f_"+Or():e}var Er=e.extend({name:"QField",mixins:[je,Cr,_e],inheritAttrs:!1,props:{label:String,stackLabel:Boolean,hint:String,hideHint:Boolean,prefix:String,suffix:String,labelColor:String,color:String,bgColor:String,filled:Boolean,outlined:Boolean,borderless:Boolean,standout:[Boolean,String],square:Boolean,loading:Boolean,labelSlot:Boolean,bottomSlots:Boolean,hideBottomSpace:Boolean,rounded:Boolean,dense:Boolean,itemAligned:Boolean,counter:Boolean,clearable:Boolean,clearIcon:String,disable:Boolean,readonly:Boolean,autofocus:Boolean,for:String,maxlength:[Number,String],maxValues:[Number,String]},data:function(){return{focused:!1,targetUid:qr(this.for),innerLoading:!1}},watch:{for:function(e){this.targetUid=qr(e)}},computed:{editable:function(){return!0!==this.disable&&!0!==this.readonly},hasValue:function(){var e=void 0===this.__getControl?this.value:this.innerValue;return null!=e&&(""+e).length>0},computedCounter:function(){if(!1!==this.counter){var e="string"==typeof this.value||"number"==typeof this.value?(""+this.value).length:!0===Array.isArray(this.value)?this.value.length:0,t=void 0!==this.maxlength?this.maxlength:this.maxValues;return e+(void 0!==t?" / "+t:"")}},floatingLabel:function(){return!0===this.stackLabel||!0===this.focused||(void 0!==this.inputValue&&!0===this.hideSelected?this.inputValue.length>0:!0===this.hasValue)||void 0!==this.displayValue&&null!==this.displayValue&&(""+this.displayValue).length>0},shouldRenderBottom:function(){return!0===this.bottomSlots||void 0!==this.hint||!0===this.hasRules||!0===this.counter||null!==this.error},classes:function(){var e;return(e={})[this.fieldClass]=void 0!==this.fieldClass,e["q-field--"+this.styleType]=!0,e["q-field--rounded"]=this.rounded,e["q-field--square"]=this.square,e["q-field--focused"]=!0===this.focused||!0===this.hasError,e["q-field--float"]=this.floatingLabel,e["q-field--labeled"]=this.hasLabel,e["q-field--dense"]=this.dense,e["q-field--item-aligned q-item-type"]=this.itemAligned,e["q-field--dark"]=this.isDark,e["q-field--auto-height"]=void 0===this.__getControl,e["q-field--with-bottom"]=!0!==this.hideBottomSpace&&!0===this.shouldRenderBottom,e["q-field--error"]=this.hasError,e["q-field--readonly"]=!0===this.readonly&&!0!==this.disable,e["q-field--disabled"]=this.disable,e},styleType:function(){return!0===this.filled?"filled":!0===this.outlined?"outlined":!0===this.borderless?"borderless":this.standout?"standout":"standard"},contentClass:function(){var e=[];if(!0===this.hasError)e.push("text-negative");else{if("string"==typeof this.standout&&this.standout.length>0&&!0===this.focused)return this.standout;void 0!==this.color&&e.push("text-"+this.color)}return void 0!==this.bgColor&&e.push("bg-"+this.bgColor),e},hasLabel:function(){return!0===this.labelSlot||void 0!==this.label},labelClass:function(){if(void 0!==this.labelColor&&!0!==this.hasError)return"text-"+this.labelColor},controlSlotScope:function(){return{id:this.targetUid,field:this.$el,editable:this.editable,focused:this.focused,floatingLabel:this.floatingLabel,value:this.value,emitValue:this.__emitValue}},attrs:function(){var e={for:this.targetUid};return!0===this.disable?e["aria-disabled"]="true":!0===this.readonly&&(e["aria-readonly"]="true"),e}},methods:{focus:function(){void 0===this.showPopup||!0!==this.hasDialog?this.__focus():this.showPopup()},blur:function(){var e=document.activeElement;null!==e&&this.$el.contains(e)&&e.blur()},__focus:function(){var e=document.activeElement,t=this.$refs.target;void 0===t||null!==e&&e.id===this.targetUid||(!0===t.hasAttribute("tabindex")||(t=t.querySelector("[tabindex]")),null!==t&&t!==e&&t.focus())},__getContent:function(e){var t=[];return void 0!==this.$scopedSlots.prepend&&t.push(e("div",{staticClass:"q-field__prepend q-field__marginal row no-wrap items-center",key:"prepend",on:this.slotsEvents},this.$scopedSlots.prepend())),t.push(e("div",{staticClass:"q-field__control-container col relative-position row no-wrap q-anchor--skip"},this.__getControlContainer(e))),void 0!==this.$scopedSlots.append&&t.push(e("div",{staticClass:"q-field__append q-field__marginal row no-wrap items-center",key:"append",on:this.slotsEvents},this.$scopedSlots.append())),!0===this.hasError&&!1===this.noErrorIcon&&t.push(this.__getInnerAppendNode(e,"error",[e(De,{props:{name:this.$q.iconSet.field.error,color:"negative"}})])),!0===this.loading||!0===this.innerLoading?t.push(this.__getInnerAppendNode(e,"inner-loading-append",void 0!==this.$scopedSlots.loading?this.$scopedSlots.loading():[e(Qe,{props:{color:this.color}})])):!0===this.clearable&&!0===this.hasValue&&!0===this.editable&&t.push(this.__getInnerAppendNode(e,"inner-clearable-append",[e(De,{staticClass:"q-field__focusable-action",props:{tag:"button",name:this.clearIcon||this.$q.iconSet.field.clear},attrs:{tabindex:0,type:"button"},on:this.clearableEvents})])),void 0!==this.__getInnerAppend&&t.push(this.__getInnerAppendNode(e,"inner-append",this.__getInnerAppend(e))),void 0!==this.__getControlChild&&t.push(this.__getControlChild(e)),t},__getControlContainer:function(e){var t=[];return void 0!==this.prefix&&null!==this.prefix&&t.push(e("div",{staticClass:"q-field__prefix no-pointer-events row items-center"},[this.prefix])),!0===this.hasShadow&&void 0!==this.__getShadowControl&&t.push(this.__getShadowControl(e)),void 0!==this.__getControl?t.push(this.__getControl(e)):void 0!==this.$scopedSlots.rawControl?t.push(this.$scopedSlots.rawControl()):void 0!==this.$scopedSlots.control&&t.push(e("div",{ref:"target",staticClass:"q-field__native row",attrs:Object.assign({},this.qAttrs,{"data-autofocus":this.autofocus})},this.$scopedSlots.control(this.controlSlotScope))),!0===this.hasLabel&&t.push(e("div",{staticClass:"q-field__label no-pointer-events absolute ellipsis",class:this.labelClass},[Le(this,"label",this.label)])),void 0!==this.suffix&&null!==this.suffix&&t.push(e("div",{staticClass:"q-field__suffix no-pointer-events row items-center"},[this.suffix])),t.concat(void 0!==this.__getDefaultSlot?this.__getDefaultSlot(e):Le(this,"default"))},__getBottom:function(e){var t,n;!0===this.hasError?void 0!==this.computedErrorMessage?(t=[e("div",[this.computedErrorMessage])],n=this.computedErrorMessage):(t=Le(this,"error"),n="q--slot-error"):!0===this.hideHint&&!0!==this.focused||(void 0!==this.hint?(t=[e("div",[this.hint])],n=this.hint):(t=Le(this,"hint"),n="q--slot-hint"));var i=!0===this.counter||void 0!==this.$scopedSlots.counter;if(!0!==this.hideBottomSpace||!1!==i||void 0!==t){var r=e("div",{key:n,staticClass:"q-field__messages col"},t);return e("div",{staticClass:"q-field__bottom row items-start q-field__bottom--"+(!0!==this.hideBottomSpace?"animated":"stale")},[!0===this.hideBottomSpace?r:e("transition",{props:{name:"q-transition--field-message"}},[r]),!0===i?e("div",{staticClass:"q-field__counter"},void 0!==this.$scopedSlots.counter?this.$scopedSlots.counter():[this.computedCounter]):null])}},__getInnerAppendNode:function(e,t,n){return null===n?null:e("div",{staticClass:"q-field__append q-field__marginal row no-wrap items-center q-anchor--skip",key:t},n)},__onControlPopupShow:function(e){void 0!==e&&b(e),this.$emit("popup-show",e),this.hasPopupOpen=!0,this.__onControlFocusin(e)},__onControlPopupHide:function(e){void 0!==e&&b(e),this.$emit("popup-hide",e),this.hasPopupOpen=!1,this.__onControlFocusout(e)},__onControlFocusin:function(e){!0===this.editable&&!1===this.focused&&(this.focused=!0,this.$emit("focus",e))},__onControlFocusout:function(e,t){var n=this;clearTimeout(this.focusoutTimer),this.focusoutTimer=setTimeout((function(){(!0!==document.hasFocus()||!0!==n.hasPopupOpen&&void 0!==n.$refs&&void 0!==n.$refs.control&&!1===n.$refs.control.contains(document.activeElement))&&(!0===n.focused&&(n.focused=!1,n.$emit("blur",e)),void 0!==t&&t())}))},__clearValue:function(e){w(e),(this.$refs.target||this.$el).focus(),"file"===this.type&&(this.$refs.input.value=null),this.$emit("input",null),this.$emit("clear",this.value)},__emitValue:function(e){this.$emit("input",e)}},render:function(e){return void 0!==this.__onPreRender&&this.__onPreRender(),void 0!==this.__onPostRender&&this.$nextTick(this.__onPostRender),e("label",{staticClass:"q-field q-validation-component row no-wrap items-start",class:this.classes,attrs:this.attrs},[void 0!==this.$scopedSlots.before?e("div",{staticClass:"q-field__before q-field__marginal row no-wrap items-center",on:this.slotsEvents},this.$scopedSlots.before()):null,e("div",{staticClass:"q-field__inner relative-position col self-stretch column justify-center"},[e("div",{ref:"control",staticClass:"q-field__control relative-position row no-wrap",class:this.contentClass,attrs:{tabindex:-1},on:this.controlEvents},this.__getContent(e)),!0===this.shouldRenderBottom?this.__getBottom(e):null]),void 0!==this.$scopedSlots.after?e("div",{staticClass:"q-field__after q-field__marginal row no-wrap items-center",on:this.slotsEvents},this.$scopedSlots.after()):null])},created:function(){void 0!==this.__onPreRender&&this.__onPreRender(),this.slotsEvents={click:y},this.clearableEvents={click:this.__clearValue},this.controlEvents=void 0!==this.__getControlEvents?this.__getControlEvents():{focusin:this.__onControlFocusin,focusout:this.__onControlFocusout,"popup-show":this.__onControlPopupShow,"popup-hide":this.__onControlPopupHide}},mounted:function(){!0===r&&void 0===this.for&&(this.targetUid=qr()),!0===this.autofocus&&this.focus()},beforeDestroy:function(){clearTimeout(this.focusoutTimer)}});function Dr(e,t,n,i){var r=[];return e.forEach((function(e){!0===i(e)?r.push(e):t.push({failedPropValidation:n,file:e})})),r}var zr={props:{multiple:Boolean,accept:String,capture:String,maxFileSize:[Number,String],maxTotalSize:[Number,String],maxFiles:[Number,String],filter:Function},computed:{extensions:function(){if(void 0!==this.accept)return this.accept.split(",").map((function(e){return"*"===(e=e.trim())?"*/":(e.endsWith("/*")&&(e=e.slice(0,e.length-1)),e.toUpperCase())}))},maxFilesNumber:function(){return parseInt(this.maxFiles,10)},maxTotalSizeNumber:function(){return parseInt(this.maxTotalSize,10)}},methods:{pickFiles:function(e){if(this.editable){var t=this.__getFileInput();t&&t.click(e)}},addFiles:function(e){this.editable&&e&&this.__addFiles(null,e)},__processFiles:function(e,t,n,i){var r=this,o=Array.from(t||e.target.files),a=[],s=function(){a.length>0&&r.$emit("rejected",a)};if(void 0!==this.accept&&-1===this.extensions.indexOf("*/")&&0===(o=Dr(o,a,"accept",(function(e){return r.extensions.some((function(t){return e.type.toUpperCase().startsWith(t)||e.name.toUpperCase().endsWith(t)}))}))).length)return s();if(void 0!==this.maxFileSize){var l=parseInt(this.maxFileSize,10);if(0===(o=Dr(o,a,"max-file-size",(function(e){return e.size<=l}))).length)return s()}if(!0!==this.multiple&&(o=[o[0]]),void 0!==this.maxTotalSize){var c=!0===i?n.reduce((function(e,t){return e+t.size}),0):0;if(0===(o=Dr(o,a,"max-total-size",(function(e){return(c+=e.size)<=r.maxTotalSizeNumber}))).length)return s()}if("function"==typeof this.filter){var u=this.filter(o);o=Dr(o,a,"filter",(function(e){return u.includes(e)}))}if(void 0!==this.maxFiles){var d=!0===i?n.length:0;if(0===(o=Dr(o,a,"max-files",(function(){return++d<=r.maxFilesNumber}))).length)return s()}return s(),o.length>0?o:void 0},__onDragOver:function(e){w(e),this.dnd=!0},__onDragLeave:function(e){w(e),this.dnd=!1},__onDrop:function(e){w(e);var t=e.dataTransfer.files;t.length>0&&this.__addFiles(null,t),this.dnd=!1},__getDnd:function(e,t){if(!0===this.dnd)return e("div",{staticClass:"q-"+t+"__dnd absolute-full",on:pe(this,"dnd",{dragenter:w,dragover:w,dragleave:this.__onDragLeave,drop:this.__onDrop})})}}},Nr={computed:{formDomProps:function(){if("file"===this.type)try{var e="DataTransfer"in window?new DataTransfer:"ClipboardEvent"in window?new ClipboardEvent("").clipboardData:void 0;return Object(this.value)===this.value&&("length"in this.value?Array.from(this.value):[this.value]).forEach((function(t){e.items.add(t)})),{files:e.files}}catch(e){return{files:void 0}}}}},jr={date:"####/##/##",datetime:"####/##/## ##:##",time:"##:##",fulltime:"##:##:##",phone:"(###) ### - ####",card:"#### #### #### ####"},Rr={"#":{pattern:"[\\d]",negate:"[^\\d]"},S:{pattern:"[a-zA-Z]",negate:"[^a-zA-Z]"},N:{pattern:"[0-9a-zA-Z]",negate:"[^0-9a-zA-Z]"},A:{pattern:"[a-zA-Z]",negate:"[^a-zA-Z]",transform:function(e){return e.toLocaleUpperCase()}},a:{pattern:"[a-zA-Z]",negate:"[^a-zA-Z]",transform:function(e){return e.toLocaleLowerCase()}},X:{pattern:"[0-9a-zA-Z]",negate:"[^0-9a-zA-Z]",transform:function(e){return e.toLocaleUpperCase()}},x:{pattern:"[0-9a-zA-Z]",negate:"[^0-9a-zA-Z]",transform:function(e){return e.toLocaleLowerCase()}}},Ir=Object.keys(Rr);Ir.forEach((function(e){Rr[e].regex=new RegExp(Rr[e].pattern)}));var $r=new RegExp("\\\\([^.*+?^${}()|([\\]])|([.*+?^${}()|[\\]])|(["+Ir.join("")+"])|(.)","g"),Fr=/[.*+?^${}()|[\]\\]/g,Br=String.fromCharCode(1),Vr={props:{mask:String,reverseFillMask:Boolean,fillMask:[Boolean,String],unmaskedValue:Boolean},watch:{type:function(){this.__updateMaskInternals()},mask:function(e){if(void 0!==e)this.__updateMaskValue(this.innerValue,!0);else{var t=this.__unmask(this.innerValue);this.__updateMaskInternals(),this.value!==t&&this.$emit("input",t)}},fillMask:function(){!0===this.hasMask&&this.__updateMaskValue(this.innerValue,!0)},reverseFillMask:function(){!0===this.hasMask&&this.__updateMaskValue(this.innerValue,!0)},unmaskedValue:function(){!0===this.hasMask&&this.__updateMaskValue(this.innerValue)}},methods:{__getInitialMaskedValue:function(){if(this.__updateMaskInternals(),!0===this.hasMask){var e=this.__mask(this.__unmask(this.value));return!1!==this.fillMask?this.__fillWithMask(e):e}return this.value},__getPaddedMaskMarked:function(e){if(e<this.maskMarked.length)return this.maskMarked.slice(-e);var t=this.maskMarked,n="",i=t.indexOf(Br);if(i>-1){for(var r=e-t.length;r>0;r--)n+=Br;t=t.slice(0,i)+n+t.slice(i)}return t},__updateMaskInternals:function(){var e=this;if(this.hasMask=void 0!==this.mask&&this.mask.length>0&&["text","search","url","tel","password"].includes(this.type),!1===this.hasMask)return this.computedUnmask=void 0,this.maskMarked="",void(this.maskReplaced="");var t=void 0===jr[this.mask]?this.mask:jr[this.mask],n="string"==typeof this.fillMask&&this.fillMask.length>0?this.fillMask.slice(0,1):"_",i=n.replace(Fr,"\\$&"),r=[],o=[],a=[],s=!0===this.reverseFillMask,l="",c="";t.replace($r,(function(e,t,n,i,u){if(void 0!==i){var d=Rr[i];a.push(d),c=d.negate,!0===s&&(o.push("(?:"+c+"+)?("+d.pattern+"+)?(?:"+c+"+)?("+d.pattern+"+)?"),s=!1),o.push("(?:"+c+"+)?("+d.pattern+")?")}else if(void 0!==n)l="\\"+("\\"===n?"":n),a.push(n),r.push("([^"+l+"]+)?"+l+"?");else{var h=void 0!==t?t:u;l="\\"===h?"\\\\\\\\":h.replace(Fr,"\\\\$&"),a.push(h),r.push("([^"+l+"]+)?"+l+"?")}}));var u=new RegExp("^"+r.join("")+"("+(""===l?".":"[^"+l+"]")+"+)?$"),d=o.length-1,h=o.map((function(t,n){return 0===n&&!0===e.reverseFillMask?new RegExp("^"+i+"*"+t):n===d?new RegExp("^"+t+"("+(""===c?".":c)+"+)?"+(!0===e.reverseFillMask?"$":i+"*")):new RegExp("^"+t)}));this.computedMask=a,this.computedUnmask=function(e){var t=u.exec(e);null!==t&&(e=t.slice(1).join(""));for(var n=[],i=h.length,r=0,o=e;r<i;r++){var a=h[r].exec(o);if(null===a)break;o=o.slice(a.shift().length),n.push.apply(n,a)}return n.length>0?n.join(""):e},this.maskMarked=a.map((function(e){return"string"==typeof e?e:Br})).join(""),this.maskReplaced=this.maskMarked.split(Br).join(n)},__updateMaskValue:function(e,t,n){var i=this,r=this.$refs.input,o=r.selectionEnd,a=r.value.length-o,s=this.__unmask(e);!0===t&&this.__updateMaskInternals();var l=this.__mask(s),c=!1!==this.fillMask?this.__fillWithMask(l):l,u=this.innerValue!==c;r.value!==c&&(r.value=c),!0===u&&(this.innerValue=c),document.activeElement===r&&this.$nextTick((function(){if(c!==i.maskReplaced)if("insertFromPaste"!==n||!0===i.reverseFillMask)if(["deleteContentBackward","deleteContentForward"].indexOf(n)>-1){var e=!0===i.reverseFillMask?Math.max(0,c.length-(c===i.maskReplaced?0:Math.min(l.length,a)+1))+1:o;r.setSelectionRange(e,e,"forward")}else if(!0===i.reverseFillMask)if(!0===u){var t=Math.max(0,c.length-(c===i.maskReplaced?0:Math.min(l.length,a+1)));i.__moveCursorRightReverse(r,t,t)}else{var s=c.length-a;r.setSelectionRange(s,s,"backward")}else if(!0===u){var d=Math.max(0,i.maskMarked.indexOf(Br),Math.min(l.length,o)-1);i.__moveCursorRight(r,d,d)}else{var h=o-1;i.__moveCursorRight(r,h,h)}else{var f=o-1;i.__moveCursorRight(r,f,f)}else{var p=!0===i.reverseFillMask?i.maskReplaced.length:0;r.setSelectionRange(p,p,"forward")}}));var d=!0===this.unmaskedValue?this.__unmask(c):c;this.value!==d&&this.__emitValue(d,!0)},__moveCursorForPaste:function(e,t,n){var i=this.__mask(this.__unmask(e.value));t=Math.max(0,this.maskMarked.indexOf(Br),Math.min(i.length,t)),e.setSelectionRange(t,n,"forward")},__moveCursorLeft:function(e,t,n,i){for(var r=-1===this.maskMarked.slice(t-1).indexOf(Br),o=Math.max(0,t-1);o>=0;o--)if(this.maskMarked[o]===Br){t=o,!0===r&&t++;break}if(o<0&&void 0!==this.maskMarked[t]&&this.maskMarked[t]!==Br)return this.__moveCursorRight(e,0,0);t>=0&&e.setSelectionRange(t,!0===i?n:t,"backward")},__moveCursorRight:function(e,t,n,i){for(var r=e.value.length,o=Math.min(r,n+1);o<=r;o++){if(this.maskMarked[o]===Br){n=o;break}this.maskMarked[o-1]===Br&&(n=o)}if(o>r&&void 0!==this.maskMarked[n-1]&&this.maskMarked[n-1]!==Br)return this.__moveCursorLeft(e,r,r);e.setSelectionRange(i?t:n,n,"forward")},__moveCursorLeftReverse:function(e,t,n,i){for(var r=this.__getPaddedMaskMarked(e.value.length),o=Math.max(0,t-1);o>=0;o--){if(r[o-1]===Br){t=o;break}if(r[o]===Br&&(t=o,0===o))break}if(o<0&&void 0!==r[t]&&r[t]!==Br)return this.__moveCursorRightReverse(e,0,0);t>=0&&e.setSelectionRange(t,!0===i?n:t,"backward")},__moveCursorRightReverse:function(e,t,n,i){for(var r=e.value.length,o=this.__getPaddedMaskMarked(r),a=-1===o.slice(0,n+1).indexOf(Br),s=Math.min(r,n+1);s<=r;s++)if(o[s-1]===Br){(n=s)>0&&!0===a&&n--;break}if(s>r&&void 0!==o[n-1]&&o[n-1]!==Br)return this.__moveCursorLeftReverse(e,r,r);e.setSelectionRange(!0===i?t:n,n,"forward")},__onMaskedKeydown:function(e){if(!0!==J(e)){var t=this.$refs.input,n=t.selectionStart,i=t.selectionEnd;if(37===e.keyCode||39===e.keyCode){var r=this["__moveCursor"+(39===e.keyCode?"Right":"Left")+(!0===this.reverseFillMask?"Reverse":"")];e.preventDefault(),r(t,n,i,e.shiftKey)}else 8===e.keyCode&&!0!==this.reverseFillMask&&n===i?this.__moveCursorLeft(t,n,i,!0):46===e.keyCode&&!0===this.reverseFillMask&&n===i&&this.__moveCursorRightReverse(t,n,i,!0);this.$emit("keydown",e)}},__mask:function(e){if(null==e||""===e)return"";if(!0===this.reverseFillMask)return this.__maskReverse(e);for(var t=this.computedMask,n=0,i="",r=0;r<t.length;r++){var o=e[n],a=t[r];if("string"==typeof a)i+=a,o===a&&n++;else{if(void 0===o||!a.regex.test(o))return i;i+=void 0!==a.transform?a.transform(o):o,n++}}return i},__maskReverse:function(e){for(var t=this.computedMask,n=this.maskMarked.indexOf(Br),i=e.length-1,r="",o=t.length-1;o>=0;o--){var a=t[o],s=e[i];if("string"==typeof a)r=a+r,s===a&&i--;else{if(void 0===s||!a.regex.test(s))return r;do{r=(void 0!==a.transform?a.transform(s):s)+r,s=e[--i]}while(n===o&&void 0!==s&&a.regex.test(s))}}return r},__unmask:function(e){return"string"!=typeof e||void 0===this.computedUnmask?"number"==typeof e?this.computedUnmask(""+e):e:this.computedUnmask(e)},__fillWithMask:function(e){return this.maskReplaced.length-e.length<=0?e:!0===this.reverseFillMask&&e.length>0?this.maskReplaced.slice(0,-e.length)+e:e+this.maskReplaced.slice(e.length)}}},Hr=/[\u3000-\u303f\u3040-\u309f\u30a0-\u30ff\uff00-\uff9f\u4e00-\u9faf\u3400-\u4dbf]/,Wr=/(?:[\u3300-\u4DBF\u4E00-\u9FFF\uF900-\uFAFF\uFE30-\uFE4F]|[\uD840-\uD868\uD86A-\uD872][\uDC00-\uDFFF]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD873[\uDC00-\uDEAF]|\uD87E[\uDC00-\uDE1F])/,Ur=/[\u3131-\u314e\u314f-\u3163\uac00-\ud7a3]/,Yr={methods:{__onComposition:function(e){if("compositionend"===e.type||"change"===e.type){if(!0!==e.target.composing)return;e.target.composing=!1,this.__onInput(e)}else"compositionupdate"===e.type?"string"==typeof e.data&&!1===Hr.test(e.data)&&!1===Wr.test(e.data)&&!1===Ur.test(e.data)&&(e.target.composing=!1):e.target.composing=!0}}},Gr=e.extend({name:"QInput",mixins:[Er,Vr,Yr,cn,Nr,Pe],props:{value:{required:!1},shadowText:String,type:{type:String,default:"text"},debounce:[String,Number],autogrow:Boolean,inputClass:[Array,String,Object],inputStyle:[Array,String,Object]},watch:{value:function(e){if(!0===this.hasMask){if(!0===this.stopValueWatcher)return void(this.stopValueWatcher=!1);this.__updateMaskValue(e)}else this.innerValue!==e&&(this.innerValue=e,"number"===this.type&&!0===this.hasOwnProperty("tempValue")&&(!0===this.typedNumber?this.typedNumber=!1:delete this.tempValue));!0===this.autogrow&&this.$nextTick(this.__adjustHeight)},autogrow:function(e){if(!0===e)this.$nextTick(this.__adjustHeight);else if(this.qAttrs.rows>0&&void 0!==this.$refs.input){this.$refs.input.style.height="auto"}},dense:function(){!0===this.autogrow&&this.$nextTick(this.__adjustHeight)}},data:function(){return{innerValue:this.__getInitialMaskedValue()}},computed:{isTextarea:function(){return"textarea"===this.type||!0===this.autogrow},fieldClass:function(){return"q-"+(!0===this.isTextarea?"textarea":"input")+(!0===this.autogrow?" q-textarea--autogrow":"")},hasShadow:function(){return"file"!==this.type&&"string"==typeof this.shadowText&&this.shadowText.length>0},onEvents:function(){var e=Object.assign({},this.qListeners,{input:this.__onInput,paste:this.__onPaste,change:this.__onChange,blur:this.__onFinishEditing,focus:b});return e.compositionstart=e.compositionupdate=e.compositionend=this.__onComposition,!0===this.hasMask&&(e.keydown=this.__onMaskedKeydown),!0===this.autogrow&&(e.animationend=this.__adjustHeight),e},inputAttrs:function(){var e=Object.assign({},{tabindex:0,"data-autofocus":this.autofocus,rows:"textarea"===this.type?6:void 0,"aria-label":this.label,name:this.nameProp},this.qAttrs,{id:this.targetUid,type:this.type,maxlength:this.maxlength,disabled:!0===this.disable,readonly:!0===this.readonly});return!0===this.autogrow&&(e.rows=1),e}},methods:{focus:function(){var e=document.activeElement;void 0===this.$refs.input||this.$refs.input===e||null!==e&&e.id===this.targetUid||this.$refs.input.focus()},select:function(){void 0!==this.$refs.input&&this.$refs.input.select()},__onPaste:function(e){if(!0===this.hasMask&&!0!==this.reverseFillMask){var t=e.target;this.__moveCursorForPaste(t,t.selectionStart,t.selectionEnd)}this.$emit("paste",e)},__onInput:function(e){if(!e||!e.target||!0!==e.target.composing)if("file"!==this.type){var t=e.target.value;!0===this.hasMask?this.__updateMaskValue(t,!1,e.inputType):this.__emitValue(t),!0===this.autogrow&&this.__adjustHeight()}else this.$emit("input",e.target.files)},__emitValue:function(e,t){var n=this;this.emitValueFn=function(){"number"!==n.type&&!0===n.hasOwnProperty("tempValue")&&delete n.tempValue,n.value!==e&&(!0===t&&(n.stopValueWatcher=!0),n.$emit("input",e)),n.emitValueFn=void 0},"number"===this.type&&(this.typedNumber=!0,this.tempValue=e),void 0!==this.debounce?(clearTimeout(this.emitTimer),this.tempValue=e,this.emitTimer=setTimeout(this.emitValueFn,this.debounce)):this.emitValueFn()},__adjustHeight:function(){var e=this.$refs.input;if(void 0!==e){var t=e.parentNode.style;t.marginBottom=e.scrollHeight-1+"px",e.style.height="1px",e.style.height=e.scrollHeight+"px",t.marginBottom=""}},__onChange:function(e){this.__onComposition(e),clearTimeout(this.emitTimer),void 0!==this.emitValueFn&&this.emitValueFn(),this.$emit("change",e)},__onFinishEditing:function(e){var t=this;void 0!==e&&b(e),clearTimeout(this.emitTimer),void 0!==this.emitValueFn&&this.emitValueFn(),this.typedNumber=!1,this.stopValueWatcher=!1,delete this.tempValue,"file"!==this.type&&this.$nextTick((function(){void 0!==t.$refs.input&&(t.$refs.input.value=void 0!==t.innerValue?t.innerValue:"")}))},__getCurValue:function(){return!0===this.hasOwnProperty("tempValue")?this.tempValue:void 0!==this.innerValue?this.innerValue:""},__getShadowControl:function(e){return e("div",{staticClass:"q-field__native q-field__shadow absolute-full no-pointer-events"},[e("span",{staticClass:"invisible"},this.__getCurValue()),e("span",this.shadowText)])},__getControl:function(e){return e(!0===this.isTextarea?"textarea":"input",{ref:"input",staticClass:"q-field__native q-placeholder",style:this.inputStyle,class:this.inputClass,attrs:this.inputAttrs,on:this.onEvents,domProps:"file"!==this.type?{value:this.__getCurValue()}:this.formDomProps})}},mounted:function(){!0===this.autogrow&&this.__adjustHeight()},beforeDestroy:function(){this.__onFinishEditing()}}),Qr=e.extend({name:"QTooltip",mixins:[kt,St,Mt,At],props:{maxHeight:{type:String,default:null},maxWidth:{type:String,default:null},transitionShow:{default:"jump-down"},transitionHide:{default:"jump-up"},anchor:{type:String,default:"bottom middle",validator:tn},self:{type:String,default:"top middle",validator:tn},offset:{type:Array,default:function(){return[14,14]},validator:nn},scrollTarget:{default:void 0},delay:{type:Number,default:0},hideDelay:{type:Number,default:0}},computed:{anchorOrigin:function(){return rn(this.anchor)},selfOrigin:function(){return rn(this.self)},hideOnRouteChange:function(){return!0!==this.persistent}},methods:{__show:function(e){var t=this;this.__showPortal(),this.__nextTick((function(){t.observer=new MutationObserver((function(){return t.updatePosition()})),t.observer.observe(t.__portal.$el,{attributes:!1,childList:!0,characterData:!0,subtree:!0}),t.updatePosition(),t.__configureScrollTarget()})),this.__setTimeout((function(){t.$emit("show",e)}),300)},__hide:function(e){var t=this;this.__anchorCleanup(),this.__setTimeout((function(){t.__hidePortal(),t.$emit("hide",e)}),300)},__anchorCleanup:function(){void 0!==this.observer&&(this.observer.disconnect(),this.observer=void 0),this.__unconfigureScrollTarget(),C(this,"tooltipTemp")},updatePosition:function(){if(void 0!==this.anchorEl&&void 0!==this.__portal){var e=this.__portal.$el;8!==e.nodeType?on({el:e,offset:this.offset,anchorEl:this.anchorEl,anchorOrigin:this.anchorOrigin,selfOrigin:this.selfOrigin,maxHeight:this.maxHeight,maxWidth:this.maxWidth}):setTimeout(this.updatePosition,25)}},__delayShow:function(e){var t=this;if(!0===this.$q.platform.is.mobile){wt(),document.body.classList.add("non-selectable");var n=ht(this.anchorEl);S(this,"tooltipTemp",["touchmove","touchcancel","touchend","click"].map((function(e){return[n,e,"__delayHide","passiveCapture"]})))}this.__setTimeout((function(){t.show(e)}),this.delay)},__delayHide:function(e){var t=this;this.__clearTimeout(),!0===this.$q.platform.is.mobile&&(C(this,"tooltipTemp"),wt(),setTimeout((function(){document.body.classList.remove("non-selectable")}),10)),this.__setTimeout((function(){t.hide(e)}),this.hideDelay)},__configureAnchorEl:function(){!0!==this.noParentEvent&&void 0!==this.anchorEl&&S(this,"anchor",!0===this.$q.platform.is.mobile?[[this.anchorEl,"touchstart","__delayShow","passive"]]:[[this.anchorEl,"mouseenter","__delayShow","passive"],[this.anchorEl,"mouseleave","__delayHide","passive"]])},__unconfigureScrollTarget:function(){void 0!==this.__scrollTarget&&(this.__changeScrollEvent(this.__scrollTarget),this.__scrollTarget=void 0)},__configureScrollTarget:function(){if(void 0!==this.anchorEl||void 0!==this.scrollTarget){this.__scrollTarget=jt(this.anchorEl,this.scrollTarget);var e=!0===this.noParentEvent?this.updatePosition:this.hide;this.__changeScrollEvent(this.__scrollTarget,e)}},__renderPortal:function(e){return e("transition",{props:{name:this.transition}},[!0===this.showing?e("div",{staticClass:"q-tooltip q-tooltip--style q-position-engine no-pointer-events",class:this.contentClass,style:this.contentStyle,attrs:{role:"complementary"}},Le(this,"default")):null])}},mounted:function(){this.__processModelChange(this.value)}}),Kr=e.extend({name:"QList",mixins:[Pe,je],props:{bordered:Boolean,dense:Boolean,separator:Boolean,padding:Boolean},computed:{classes:function(){return"q-list"+(!0===this.bordered?" q-list--bordered":"")+(!0===this.dense?" q-list--dense":"")+(!0===this.separator?" q-list--separator":"")+(!0===this.isDark?" q-list--dark":"")+(!0===this.padding?" q-list--padding":"")}},render:function(e){return e("div",{class:this.classes,on:Object.assign({},this.qListeners)},Le(this,"default"))}}),Zr=e.extend({name:"QItem",mixins:[je,Ue,Ae,Pe],props:{active:Boolean,clickable:Boolean,dense:Boolean,insetLevel:Number,tabindex:[String,Number],focused:Boolean,manualFocus:Boolean},computed:{isActionable:function(){return!0===this.clickable||!0===this.hasRouterLink||"a"===this.tag||"label"===this.tag},isClickable:function(){return!0!==this.disable&&!0===this.isActionable},classes:function(){var e;return(e={"q-item--clickable q-link cursor-pointer":this.isClickable,"q-focusable q-hoverable":!0===this.isClickable&&!1===this.manualFocus,"q-manual-focusable":!0===this.isClickable&&!0===this.manualFocus,"q-manual-focusable--focused":!0===this.isClickable&&!0===this.focused,"q-item--dense":this.dense,"q-item--dark":this.isDark,"q-item--active":this.active})[this.activeClass]=!0===this.active&&!0!==this.hasRouterLink&&void 0!==this.activeClass,e.disabled=this.disable,e},style:function(){var e;if(void 0!==this.insetLevel)return(e={})["padding"+(!0===this.$q.lang.rtl?"Right":"Left")]=16+56*this.insetLevel+"px",e},onEvents:function(){return Object.assign({},this.qListeners,{click:this.__onClick,keyup:this.__onKeyup})}},methods:{__getContent:function(e){var t=Oe(this,"default",[]);return!0===this.isClickable&&t.unshift(e("div",{staticClass:"q-focus-helper",attrs:{tabindex:-1},ref:"blurTarget"})),t},__onClick:function(e){!0===this.isClickable&&(void 0!==this.$refs.blurTarget&&(!0!==e.qKeyEvent&&document.activeElement===this.$el?this.$refs.blurTarget.focus():document.activeElement===this.$refs.blurTarget&&this.$el.focus()),this.$emit("click",e))},__onKeyup:function(e){if(!0===this.isClickable&&!0===X(e,13)){w(e),e.qKeyEvent=!0;var t=new MouseEvent("click",e);t.qKeyEvent=!0,this.$el.dispatchEvent(t)}this.$emit("keyup",e)}},render:function(e){var t={staticClass:"q-item q-item-type row no-wrap",class:this.classes,style:this.style};return t[!0===this.hasRouterLink?"nativeOn":"on"]=this.onEvents,!0===this.isClickable?t.attrs={tabindex:this.tabindex||"0"}:!0===this.isActionable&&(t.attrs={"aria-disabled":"true"}),!0===this.hasRouterLink?(t.tag="a",t.props=this.routerLinkProps,e("router-link",t,this.__getContent(e))):e(this.tag,t,this.__getContent(e))}}),Jr=e.extend({name:"QItemSection",mixins:[Pe],props:{avatar:Boolean,thumbnail:Boolean,side:Boolean,top:Boolean,noWrap:Boolean},computed:{classes:function(){var e,t=this.avatar||this.side||this.thumbnail;return(e={"q-item__section--top":this.top,"q-item__section--avatar":this.avatar,"q-item__section--thumbnail":this.thumbnail,"q-item__section--side":t,"q-item__section--nowrap":this.noWrap,"q-item__section--main":!t})["justify-"+(this.top?"start":"center")]=!0,e}},render:function(e){return e("div",{staticClass:"q-item__section column",class:this.classes,on:Object.assign({},this.qListeners)},Le(this,"default"))}});function Xr(e,t,n){t.handler?t.handler(e,n,n.caret):n.runCmd(t.cmd,t.param)}function eo(e,t){return e("div",{staticClass:"q-editor__toolbar-group"},t)}function to(e,t,n,i,r){void 0===r&&(r=!1);var o=r||"toggle"===n.type&&(n.toggled?n.toggled(t):n.cmd&&t.caret.is(n.cmd,n.param)),a=[],s={click:function(e){i&&i(),Xr(e,n,t)}};if(n.tip&&t.$q.platform.is.desktop){var l=n.key?e("div",[e("small","(CTRL + "+String.fromCharCode(n.key)+")")]):null;a.push(e(Qr,{props:{delay:1e3}},[e("div",{domProps:{innerHTML:n.tip}}),l]))}return e(bt,{props:Object.assign({},t.buttonProps,{icon:n.icon,color:o?n.toggleColor||t.toolbarToggleColor:n.color||t.toolbarColor,textColor:o&&!t.toolbarPush?null:n.textColor||t.toolbarTextColor,label:n.label,disable:!!n.disable&&("function"!=typeof n.disable||n.disable(t)),size:"sm"}),on:s},a)}function no(e,t){if(t.caret)return t.buttons.filter((function(e){return!t.isViewingSource||e.find((function(e){return"viewsource"===e.cmd}))})).map((function(n){return eo(e,n.map((function(n){return(!t.isViewingSource||"viewsource"===n.cmd)&&("slot"===n.type?Le(t,n.slot):"dropdown"===n.type?function(e,t,n){var i,r,o="only-icons"===n.list,a=n.label,s=n.icon;function l(){h.componentInstance.hide()}if(o)r=n.options.map((function(n){var i=void 0===n.type&&t.caret.is(n.cmd,n.param);return i&&(a=n.tip,s=n.icon),to(e,t,n,l,i)})),i=t.toolbarBackgroundClass,r=[eo(e,r)];else{var c=void 0!==t.toolbarToggleColor?"text-"+t.toolbarToggleColor:null,u=void 0!==t.toolbarTextColor?"text-"+t.toolbarTextColor:null;r=n.options.map((function(n){var i=!!n.disable&&n.disable(t),r=void 0===n.type&&t.caret.is(n.cmd,n.param);r&&(a=n.tip,s=n.icon);var o=n.htmlTip;return e(Zr,{props:{active:r,activeClass:c,clickable:!0,disable:i,dense:!0},on:{click:function(e){l(),t.$refs.content&&t.$refs.content.focus(),t.caret.restore(),Xr(e,n,t)}}},["no-icons"===n.list?null:e(Jr,{class:r?c:u,props:{side:!0}},[e(De,{props:{name:n.icon}})]),e(Jr,[o?e("div",{domProps:{innerHTML:n.htmlTip}}):n.tip?e("div",[n.tip]):null])])})),i=[t.toolbarBackgroundClass,u],r=[e(Kr,[r])]}var d=n.highlight&&a!==n.label,h=e(sn,{props:Object.assign({},t.buttonProps,{noCaps:!0,noWrap:!0,color:d?t.toolbarToggleColor:t.toolbarColor,textColor:d&&!t.toolbarPush?null:t.toolbarTextColor,label:n.fixedLabel?n.label:a,icon:n.fixedIcon?n.icon:s,contentClass:i})},r);return h}(e,t,n):to(e,t,n))})))}))}function io(e,t){if(t&&e===t)return null;var n=e.nodeName.toLowerCase();if(!0===["div","li","ul","ol","blockquote"].includes(n))return e;var i=(window.getComputedStyle?window.getComputedStyle(e):e.currentStyle).display;return"block"===i||"table"===i?e:io(e.parentNode)}function ro(e,t){return!(!e||e===document.body)&&(t===document?document.body:t).contains(e.parentNode)}function oo(e,t,n){if(n||((n=document.createRange()).selectNode(e),n.setStart(e,0)),0===t.count)n.setEnd(e,t.count);else if(t.count>0)if(e.nodeType===Node.TEXT_NODE)e.textContent.length<t.count?t.count-=e.textContent.length:(n.setEnd(e,t.count),t.count=0);else for(var i=0;0!==t.count&&i<e.childNodes.length;i++)n=oo(e.childNodes[i],t,n);return n}var ao=/^https?:\/\//,so=function(e,t){this.el=e,this.vm=t,this._range=null},lo={selection:{configurable:!0},hasSelection:{configurable:!0},range:{configurable:!0},parent:{configurable:!0},blockParent:{configurable:!0}};lo.selection.get=function(){if(this.el){var e=document.getSelection();if(ro(e.anchorNode,this.el)&&ro(e.focusNode,this.el))return e}return null},lo.hasSelection.get=function(){return null!==this.selection&&this.selection.toString().length>0},lo.range.get=function(){var e=this.selection;return null!==e&&e.rangeCount?e.getRangeAt(0):this._range},lo.parent.get=function(){var e=this.range;if(null!==e){var t=e.startContainer;return t.nodeType===document.ELEMENT_NODE?t:t.parentNode}return null},lo.blockParent.get=function(){var e=this.parent;return null!==e?io(e,this.el):null},so.prototype.save=function(e){void 0===e&&(e=this.range),null!==e&&(this._range=e)},so.prototype.restore=function(e){void 0===e&&(e=this._range);var t=document.createRange(),n=document.getSelection();null!==e?(t.setStart(e.startContainer,e.startOffset),t.setEnd(e.endContainer,e.endOffset),n.removeAllRanges(),n.addRange(t)):(n.selectAllChildren(this.el),n.collapseToEnd())},so.prototype.savePosition=function(){var e,t=-1,n=document.getSelection(),i=this.el.parentNode;if(n.focusNode&&ro(n.focusNode,i))for(e=n.focusNode,t=n.focusOffset;e&&e!==i;)e!==this.el&&e.previousSibling?t+=(e=e.previousSibling).textContent.length:e=e.parentNode;this.savedPos=t},so.prototype.restorePosition=function(){if(this.savedPos>=0){var e=window.getSelection(),t=oo(this.el,{count:this.savedPos});t&&(t.collapse(!1),e.removeAllRanges(),e.addRange(t))}},so.prototype.hasParent=function(e,t){var n=t?this.parent:this.blockParent;return null!==n&&n.nodeName.toLowerCase()===e.toLowerCase()},so.prototype.hasParents=function(e,t,n){return void 0===n&&(n=this.parent),null!==n&&(null!==n&&!0===e.includes(n.nodeName.toLowerCase())||!0===t&&this.hasParents(e,t,n.parentNode))},so.prototype.is=function(e,t){switch(e){case"formatBlock":return"DIV"===t&&this.parent===this.el||this.hasParent(t,"PRE"===t);case"link":return this.hasParent("A",!0);case"fontSize":return document.queryCommandValue(e)===t;case"fontName":var n=document.queryCommandValue(e);return n==='"'+t+'"'||n===t;case"fullscreen":return this.vm.inFullscreen;case"viewsource":return this.vm.isViewingSource;case void 0:return!1;default:var i=document.queryCommandState(e);return void 0!==t?i===t:i}},so.prototype.getParentAttribute=function(e){return null!==this.parent?this.parent.getAttribute(e):null},so.prototype.can=function(e){return"outdent"===e?this.hasParents(["blockquote","li"],!0):"indent"===e?this.hasParents(["li"],!0):"link"===e?null!==this.selection||this.is("link"):void 0},so.prototype.apply=function(e,t,n){if(void 0===n&&(n=m),"formatBlock"===e)["BLOCKQUOTE","H1","H2","H3","H4","H5","H6"].includes(t)&&this.is(e,t)&&(e="outdent",t=null),"PRE"===t&&this.is(e,"PRE")&&(t="P");else{if("print"===e){n();var i=window.open();return i.document.write("\n        <!doctype html>\n        <html>\n          <head>\n            <title>Print - "+document.title+"</title>\n          </head>\n          <body>\n            <div>"+this.el.innerHTML+"</div>\n          </body>\n        </html>\n      "),i.print(),void i.close()}if("link"===e){var r=this.getParentAttribute("href");if(null===r){var o=this.selectWord(this.selection),a=o?o.toString():"";if(!a.length)return;this.vm.editLinkUrl=ao.test(a)?a:"https://",document.execCommand("createLink",!1,this.vm.editLinkUrl),this.save(o.getRangeAt(0))}else this.vm.editLinkUrl=r,this.range.selectNodeContents(this.parent),this.save();return}if("fullscreen"===e)return this.vm.toggleFullscreen(),void n();if("viewsource"===e)return this.vm.isViewingSource=!1===this.vm.isViewingSource,this.vm.__setContent(this.vm.value),void n()}document.execCommand(e,!1,t),n()},so.prototype.selectWord=function(e){if(null===e||!0!==e.isCollapsed||void 0===e.modify)return e;var t=document.createRange();t.setStart(e.anchorNode,e.anchorOffset),t.setEnd(e.focusNode,e.focusOffset);var n=t.collapsed?["backward","forward"]:["forward","backward"];t.detach();var i=e.focusNode,r=e.focusOffset;return e.collapse(e.anchorNode,e.anchorOffset),e.modify("move",n[0],"character"),e.modify("move",n[1],"word"),e.extend(i,r),e.modify("extend",n[1],"character"),e.modify("extend",n[0],"word"),e},Object.defineProperties(so.prototype,lo);var co=Object.prototype.toString,uo=Object.prototype.hasOwnProperty,ho={};function fo(e){return null===e?String(e):ho[co.call(e)]||"object"}function po(e){if(!e||"object"!==fo(e))return!1;if(e.constructor&&!uo.call(e,"constructor")&&!uo.call(e.constructor.prototype,"isPrototypeOf"))return!1;var t;for(t in e);return void 0===t||uo.call(e,t)}function mo(){var e,t,n,i,r,o,a=arguments,s=arguments[0]||{},l=1,c=!1,u=arguments.length;for("boolean"==typeof s&&(c=s,s=arguments[1]||{},l=2),Object(s)!==s&&"function"!==fo(s)&&(s={}),u===l&&(s=this,l--);l<u;l++)if(null!==(e=a[l]))for(t in e)n=s[t],s!==(i=e[t])&&(c&&i&&(po(i)||(r="array"===fo(i)))?(r?(r=!1,o=n&&"array"===fo(n)?n:[]):o=n&&po(n)?n:{},s[t]=mo(c,o,i)):void 0!==i&&(s[t]=i));return s}"Boolean Number String Function Array Date RegExp Object".split(" ").forEach((function(e){ho["[object "+e+"]"]=e.toLowerCase()}));var vo=e.extend({name:"QEditor",mixins:[Pe,yn,je],props:{value:{type:String,required:!0},readonly:Boolean,disable:Boolean,minHeight:{type:String,default:"10rem"},maxHeight:String,height:String,definitions:Object,fonts:Object,placeholder:String,toolbar:{type:Array,validator:function(e){return 0===e.length||e.every((function(e){return e.length}))},default:function(){return[["left","center","right","justify"],["bold","italic","underline","strike"],["undo","redo"]]}},toolbarColor:String,toolbarBg:String,toolbarTextColor:String,toolbarToggleColor:{type:String,default:"primary"},toolbarOutline:Boolean,toolbarPush:Boolean,toolbarRounded:Boolean,contentStyle:Object,contentClass:[Object,Array,String],square:Boolean,flat:Boolean,dense:Boolean},computed:{editable:function(){return!this.readonly&&!this.disable},hasToolbar:function(){return this.toolbar&&this.toolbar.length>0},toolbarBackgroundClass:function(){if(this.toolbarBg)return"bg-"+this.toolbarBg},buttonProps:function(){return{type:"a",flat:!0!==this.toolbarOutline&&!0!==this.toolbarPush,noWrap:!0,outline:this.toolbarOutline,push:this.toolbarPush,rounded:this.toolbarRounded,dense:!0,color:this.toolbarColor,disable:!this.editable,size:"sm"}},buttonDef:function(){var e=this.$q.lang.editor,t=this.$q.iconSet.editor;return{bold:{cmd:"bold",icon:t.bold,tip:e.bold,key:66},italic:{cmd:"italic",icon:t.italic,tip:e.italic,key:73},strike:{cmd:"strikeThrough",icon:t.strikethrough,tip:e.strikethrough,key:83},underline:{cmd:"underline",icon:t.underline,tip:e.underline,key:85},unordered:{cmd:"insertUnorderedList",icon:t.unorderedList,tip:e.unorderedList},ordered:{cmd:"insertOrderedList",icon:t.orderedList,tip:e.orderedList},subscript:{cmd:"subscript",icon:t.subscript,tip:e.subscript,htmlTip:"x<subscript>2</subscript>"},superscript:{cmd:"superscript",icon:t.superscript,tip:e.superscript,htmlTip:"x<superscript>2</superscript>"},link:{cmd:"link",disable:function(e){return e.caret&&!e.caret.can("link")},icon:t.hyperlink,tip:e.hyperlink,key:76},fullscreen:{cmd:"fullscreen",icon:t.toggleFullscreen,tip:e.toggleFullscreen,key:70},viewsource:{cmd:"viewsource",icon:t.viewSource,tip:e.viewSource},quote:{cmd:"formatBlock",param:"BLOCKQUOTE",icon:t.quote,tip:e.quote,key:81},left:{cmd:"justifyLeft",icon:t.left,tip:e.left},center:{cmd:"justifyCenter",icon:t.center,tip:e.center},right:{cmd:"justifyRight",icon:t.right,tip:e.right},justify:{cmd:"justifyFull",icon:t.justify,tip:e.justify},print:{type:"no-state",cmd:"print",icon:t.print,tip:e.print,key:80},outdent:{type:"no-state",disable:function(e){return e.caret&&!e.caret.can("outdent")},cmd:"outdent",icon:t.outdent,tip:e.outdent},indent:{type:"no-state",disable:function(e){return e.caret&&!e.caret.can("indent")},cmd:"indent",icon:t.indent,tip:e.indent},removeFormat:{type:"no-state",cmd:"removeFormat",icon:t.removeFormat,tip:e.removeFormat},hr:{type:"no-state",cmd:"insertHorizontalRule",icon:t.hr,tip:e.hr},undo:{type:"no-state",cmd:"undo",icon:t.undo,tip:e.undo,key:90},redo:{type:"no-state",cmd:"redo",icon:t.redo,tip:e.redo,key:89},h1:{cmd:"formatBlock",param:"H1",icon:t.heading1||t.heading,tip:e.heading1,htmlTip:'<h1 class="q-ma-none">'+e.heading1+"</h1>"},h2:{cmd:"formatBlock",param:"H2",icon:t.heading2||t.heading,tip:e.heading2,htmlTip:'<h2 class="q-ma-none">'+e.heading2+"</h2>"},h3:{cmd:"formatBlock",param:"H3",icon:t.heading3||t.heading,tip:e.heading3,htmlTip:'<h3 class="q-ma-none">'+e.heading3+"</h3>"},h4:{cmd:"formatBlock",param:"H4",icon:t.heading4||t.heading,tip:e.heading4,htmlTip:'<h4 class="q-ma-none">'+e.heading4+"</h4>"},h5:{cmd:"formatBlock",param:"H5",icon:t.heading5||t.heading,tip:e.heading5,htmlTip:'<h5 class="q-ma-none">'+e.heading5+"</h5>"},h6:{cmd:"formatBlock",param:"H6",icon:t.heading6||t.heading,tip:e.heading6,htmlTip:'<h6 class="q-ma-none">'+e.heading6+"</h6>"},p:{cmd:"formatBlock",param:"DIV",icon:t.heading,tip:e.paragraph},code:{cmd:"formatBlock",param:"PRE",icon:t.code,htmlTip:"<code>"+e.code+"</code>"},"size-1":{cmd:"fontSize",param:"1",icon:t.size1||t.size,tip:e.size1,htmlTip:'<font size="1">'+e.size1+"</font>"},"size-2":{cmd:"fontSize",param:"2",icon:t.size2||t.size,tip:e.size2,htmlTip:'<font size="2">'+e.size2+"</font>"},"size-3":{cmd:"fontSize",param:"3",icon:t.size3||t.size,tip:e.size3,htmlTip:'<font size="3">'+e.size3+"</font>"},"size-4":{cmd:"fontSize",param:"4",icon:t.size4||t.size,tip:e.size4,htmlTip:'<font size="4">'+e.size4+"</font>"},"size-5":{cmd:"fontSize",param:"5",icon:t.size5||t.size,tip:e.size5,htmlTip:'<font size="5">'+e.size5+"</font>"},"size-6":{cmd:"fontSize",param:"6",icon:t.size6||t.size,tip:e.size6,htmlTip:'<font size="6">'+e.size6+"</font>"},"size-7":{cmd:"fontSize",param:"7",icon:t.size7||t.size,tip:e.size7,htmlTip:'<font size="7">'+e.size7+"</font>"}}},buttons:function(){var e=this,t=this.definitions||{},n=this.definitions||this.fonts?mo(!0,{},this.buttonDef,t,function(e,t,n,i){void 0===i&&(i={});var r=Object.keys(i);if(0===r.length)return{};var o={default_font:{cmd:"fontName",param:e,icon:n,tip:t}};return r.forEach((function(e){var t=i[e];o[e]={cmd:"fontName",param:t,icon:n,tip:t,htmlTip:'<font face="'+t+'">'+t+"</font>"}})),o}(this.defaultFont,this.$q.lang.editor.defaultFont,this.$q.iconSet.editor.font,this.fonts)):this.buttonDef;return this.toolbar.map((function(i){return i.map((function(i){if(i.options)return{type:"dropdown",icon:i.icon,label:i.label,size:"sm",dense:!0,fixedLabel:i.fixedLabel,fixedIcon:i.fixedIcon,highlight:i.highlight,list:i.list,options:i.options.map((function(e){return n[e]}))};var r=n[i];return r?"no-state"===r.type||t[i]&&(void 0===r.cmd||e.buttonDef[r.cmd]&&"no-state"===e.buttonDef[r.cmd].type)?r:Object.assign({type:"toggle"},r):{type:"slot",slot:i}}))}))},keys:function(){var e={},t=function(t){t.key&&(e[t.key]={cmd:t.cmd,param:t.param})};return this.buttons.forEach((function(e){e.forEach((function(e){e.options?e.options.forEach(t):t(e)}))})),e},innerStyle:function(){return this.inFullscreen?this.contentStyle:[{minHeight:this.minHeight,height:this.height,maxHeight:this.maxHeight},this.contentStyle]},classes:function(){return"q-editor q-editor--"+(!0===this.isViewingSource?"source":"default")+(!0===this.disable?" disabled":"")+(!0===this.inFullscreen?" fullscreen column":"")+(!0===this.square?" q-editor--square no-border-radius":"")+(!0===this.flat?" q-editor--flat":"")+(!0===this.dense?" q-editor--dense":"")+(!0===this.isDark?" q-editor--dark q-dark":"")},innerClass:function(){return[this.contentClass,{col:this.inFullscreen,"overflow-auto":this.inFullscreen||this.maxHeight}]},attrs:function(){return!0===this.disable?{"aria-disabled":"true"}:!0===this.readonly?{"aria-readonly":"true"}:void 0}},data:function(){return{lastEmit:this.value,editLinkUrl:null,isViewingSource:!1}},watch:{value:function(e){this.lastEmit!==e&&this.__setContent(e,!0)}},methods:{__onInput:function(){if(void 0!==this.$refs.content){var e=!0===this.isViewingSource?this.$refs.content.innerText:this.$refs.content.innerHTML;e!==this.value&&(this.lastEmit=e,this.$emit("input",e))}},__onKeydown:function(e){if(this.$emit("keydown",e),!0!==e.ctrlKey||!0===J(e))return this.refreshToolbar(),void(this.$q.platform.is.ie&&this.$nextTick(this.__onInput));var t=e.keyCode,n=this.keys[t];if(void 0!==n){var i=n.cmd,r=n.param;w(e),this.runCmd(i,r,!1)}},__onClick:function(e){this.refreshToolbar(),this.$emit("click",e)},__onBlur:function(e){if(void 0!==this.$refs.content){var t=this.$refs.content,n=t.scrollTop,i=t.scrollHeight;this.__offsetBottom=i-n}!0!==this.$q.platform.is.ie&&this.caret.save(),this.$emit("blur",e)},__onFocus:function(e){var t=this;this.$nextTick((function(){void 0!==t.$refs.content&&void 0!==t.__offsetBottom&&(t.$refs.content.scrollTop=t.$refs.content.scrollHeight-t.__offsetBottom)})),this.$emit("focus",e)},__onMouseup:function(e){this.caret.save(),void 0!==this.qListeners.mouseup&&this.$emit("mouseup",e)},__onKeyup:function(e){this.caret.save(),void 0!==this.qListeners.keyup&&this.$emit("keyup",e)},__onTouchend:function(e){this.caret.save(),void 0!==this.qListeners.touchend&&this.$emit("touchend",e)},runCmd:function(e,t,n){var i=this;void 0===n&&(n=!0),this.focus(),this.caret.restore(),this.caret.apply(e,t,(function(){i.focus(),i.caret.save(),!0!==i.$q.platform.is.ie&&!0!==i.$q.platform.is.edge||i.$nextTick(i.__onInput),n&&i.refreshToolbar()}))},refreshToolbar:function(){var e=this;setTimeout((function(){e.editLinkUrl=null,e.$forceUpdate()}),1)},focus:function(){void 0!==this.$refs.content&&this.$refs.content.focus()},getContentEl:function(){return this.$refs.content},__setContent:function(e,t){if(void 0!==this.$refs.content){!0===t&&this.caret.savePosition();var n="inner"+(!0===this.isViewingSource?"Text":"HTML");this.$refs.content[n]=e,!0===t&&(this.caret.restorePosition(),this.refreshToolbar())}}},created:function(){!1===i&&(document.execCommand("defaultParagraphSeparator",!1,"div"),this.defaultFont=window.getComputedStyle(document.body).fontFamily)},mounted:function(){this.caret=new so(this.$refs.content,this),this.__setContent(this.value),this.refreshToolbar()},render:function(e){var t;if(this.hasToolbar){var n=[e("div",{key:"qedt_top",staticClass:"q-editor__toolbar row no-wrap scroll-x",class:this.toolbarBackgroundClass},no(e,this))];null!==this.editLinkUrl&&n.push(e("div",{key:"qedt_btm",staticClass:"q-editor__toolbar row no-wrap items-center scroll-x",class:this.toolbarBackgroundClass},function(e,t,n){if(t.caret){var i=t.toolbarColor||t.toolbarTextColor,r=t.editLinkUrl,o=function(){t.caret.restore(),r!==t.editLinkUrl&&document.execCommand("createLink",!1,""===r?" ":r),t.editLinkUrl=null,!0===n&&t.$nextTick(t.__onInput)};return[e("div",{staticClass:"q-mx-xs",class:"text-"+i},[t.$q.lang.editor.url+": "]),e(Gr,{key:"qedt_btm_input",staticClass:"q-ma-none q-pa-none col q-editor-input",props:{value:r,color:i,autofocus:!0,borderless:!0,dense:!0},on:{input:function(e){r=e},keydown:function(e){if(!0!==J(e))switch(e.keyCode){case 13:return y(e),o();case 27:y(e),t.caret.restore(),t.editLinkUrl&&"https://"!==t.editLinkUrl||document.execCommand("unlink"),t.editLinkUrl=null}}}}),eo(e,[e(bt,{key:"qedt_btm_rem",attrs:{tabindex:-1},props:Object.assign({},t.buttonProps,{label:t.$q.lang.label.remove,noCaps:!0}),on:{click:function(){t.caret.restore(),document.execCommand("unlink"),t.editLinkUrl=null,!0===n&&t.$nextTick(t.__onInput)}}}),e(bt,{key:"qedt_btm_upd",props:Object.assign({},t.buttonProps,{label:t.$q.lang.label.update,noCaps:!0}),on:{click:o}})])]}}(e,this,this.$q.platform.is.ie))),t=e("div",{key:"toolbar_ctainer",staticClass:"q-editor__toolbars-container"},n)}var r=Object.assign({},this.qListeners,{input:this.__onInput,keydown:this.__onKeydown,click:this.__onClick,blur:this.__onBlur,focus:this.__onFocus,mouseup:this.__onMouseup,keyup:this.__onKeyup,touchend:this.__onTouchend});return e("div",{style:{height:!0===this.inFullscreen?"100vh":null},class:this.classes,attrs:this.attrs},[t,e("div",{ref:"content",staticClass:"q-editor__content",style:this.innerStyle,class:this.innerClass,attrs:{contenteditable:this.editable,placeholder:this.placeholder},domProps:i?{innerHTML:this.value}:void 0,on:r})])}}),go=e.extend({name:"QItemLabel",mixins:[Pe],props:{overline:Boolean,caption:Boolean,header:Boolean,lines:[Number,String]},computed:{classes:function(){return{"q-item__label--overline text-overline":this.overline,"q-item__label--caption text-caption":this.caption,"q-item__label--header":this.header,ellipsis:1===parseInt(this.lines,10)}},style:function(){if(void 0!==this.lines&&parseInt(this.lines,10)>1)return{overflow:"hidden",display:"-webkit-box","-webkit-box-orient":"vertical","-webkit-line-clamp":this.lines}}},render:function(e){return e("div",{staticClass:"q-item__label",style:this.style,class:this.classes,on:Object.assign({},this.qListeners)},Le(this,"default"))}}),_o=e.extend({name:"QSlideTransition",props:{appear:Boolean,duration:{type:Number,default:300}},methods:{__begin:function(e,t,n){e.style.overflowY="hidden",void 0!==t&&(e.style.height=t+"px"),e.style.transition="height "+this.duration+"ms cubic-bezier(.25, .8, .50, 1)",this.animating=!0,this.done=n},__end:function(e,t){e.style.overflowY=null,e.style.height=null,e.style.transition=null,this.__cleanup(),t!==this.lastEvent&&this.$emit(t)},__cleanup:function(){this.done&&this.done(),this.done=null,this.animating=!1,clearTimeout(this.timer),clearTimeout(this.timerFallback),void 0!==this.el&&this.el.removeEventListener("transitionend",this.animListener),this.animListener=null}},beforeDestroy:function(){this.animating&&this.__cleanup()},render:function(e){var t=this;return e("transition",{props:{css:!1,appear:this.appear},on:pe(this,"tr",{enter:function(e,n){var i=0;t.el=e,!0===t.animating?(t.__cleanup(),i=e.offsetHeight===e.scrollHeight?0:void 0):t.lastEvent="hide",t.__begin(e,i,n),t.timer=setTimeout((function(){e.style.height=e.scrollHeight+"px",t.animListener=function(n){Object(n)===n&&n.target!==e||t.__end(e,"show")},e.addEventListener("transitionend",t.animListener),t.timerFallback=setTimeout(t.animListener,1.1*t.duration)}),100)},leave:function(e,n){var i;t.el=e,!0===t.animating?t.__cleanup():(t.lastEvent="show",i=e.scrollHeight),t.__begin(e,i,n),t.timer=setTimeout((function(){e.style.height=0,t.animListener=function(n){Object(n)===n&&n.target!==e||t.__end(e,"hide")},e.addEventListener("transitionend",t.animListener),t.timerFallback=setTimeout(t.animListener,1.1*t.duration)}),100)}})},Le(this,"default"))}}),bo={true:"inset",item:"item-inset","item-thumbnail":"item-thumbnail-inset"},yo={xs:2,sm:4,md:8,lg:16,xl:24},wo=e.extend({name:"QSeparator",mixins:[je,Pe],props:{spaced:[Boolean,String],inset:[Boolean,String],vertical:Boolean,color:String,size:String},computed:{orientation:function(){return!0===this.vertical?"vertical":"horizontal"},classPrefix:function(){return" q-separator--"+this.orientation},insetClass:function(){return!1!==this.inset?this.classPrefix+"-"+bo[this.inset]:""},classes:function(){return"q-separator"+this.classPrefix+this.insetClass+(void 0!==this.color?" bg-"+this.color:"")+(!0===this.isDark?" q-separator--dark":"")},style:function(){var e={};if(void 0!==this.size&&(e[!0===this.vertical?"width":"height"]=this.size),!1!==this.spaced){var t=!0===this.spaced?yo.md+"px":this.spaced in yo?yo[this.spaced]+"px":this.spaced,n=!0===this.vertical?["Left","Right"]:["Top","Bottom"];e["margin"+n[0]]=e["margin"+n[1]]=t}return e},attrs:function(){return{role:"separator","aria-orientation":this.orientation}}},render:function(e){return e("hr",{staticClass:"q-separator",class:this.classes,style:this.style,attrs:this.attrs,on:Object.assign({},this.qListeners)})}}),ko="q:expansion-item:close",xo=e.extend({name:"QExpansionItem",mixins:[je,Ue,St],props:{icon:String,label:String,labelLines:[Number,String],caption:String,captionLines:[Number,String],dense:Boolean,expandIcon:String,expandedIcon:String,expandIconClass:[Array,String,Object],duration:Number,headerInsetLevel:Number,contentInsetLevel:Number,expandSeparator:Boolean,defaultOpened:Boolean,expandIconToggle:Boolean,switchToggleSide:Boolean,denseToggle:Boolean,group:String,popup:Boolean,headerStyle:[Array,String,Object],headerClass:[Array,String,Object]},data:function(){return{showing:void 0!==this.value?this.value:this.defaultOpened}},watch:{showing:function(e){!0===e&&void 0!==this.group&&this.$root.$emit(ko,this)},group:function(e,t){void 0!==e&&void 0===t?this.$root.$on(ko,this.__eventHandler):void 0===e&&void 0!==t&&this.$root.$off(ko,this.__eventHandler)}},computed:{classes:function(){return"q-expansion-item--"+(!0===this.showing?"expanded":"collapsed")+" q-expansion-item--"+(!0===this.popup?"popup":"standard")},contentStyle:function(){var e;if(void 0!==this.contentInsetLevel)return(e={})["padding"+(!0===this.$q.lang.rtl?"Right":"Left")]=56*this.contentInsetLevel+"px",e},isClickable:function(){return!0===this.hasRouterLink||!0!==this.expandIconToggle},expansionIcon:function(){return void 0!==this.expandedIcon&&!0===this.showing?this.expandedIcon:this.expandIcon||this.$q.iconSet.expansionItem[!0===this.denseToggle?"denseIcon":"icon"]},activeToggleIcon:function(){return!0!==this.disable&&(!0===this.hasRouterLink||!0===this.expandIconToggle)}},methods:{__onHeaderClick:function(e){!0!==this.hasRouterLink&&this.toggle(e),this.$emit("click",e)},__toggleIconKeyboard:function(e){13===e.keyCode&&this.__toggleIcon(e,!0)},__toggleIcon:function(e,t){!0!==t&&void 0!==this.$refs.blurTarget&&this.$refs.blurTarget.focus(),this.toggle(e),w(e)},__eventHandler:function(e){this!==e&&this.group===e.group&&this.hide()},__getToggleIcon:function(e){var t={staticClass:"q-focusable relative-position cursor-pointer"+(!0===this.denseToggle&&!0===this.switchToggleSide?" items-end":""),class:this.expandIconClass,props:{side:!0!==this.switchToggleSide,avatar:this.switchToggleSide}},n=[e(De,{staticClass:"q-expansion-item__toggle-icon",class:void 0===this.expandedIcon&&!0===this.showing?"q-expansion-item__toggle-icon--rotated":void 0,props:{name:this.expansionIcon}})];return!0===this.activeToggleIcon&&(Object.assign(t,{attrs:{tabindex:0},on:pe(this,"inpExt",{click:this.__toggleIcon,keyup:this.__toggleIconKeyboard})}),n.unshift(e("div",{ref:"blurTarget",staticClass:"q-expansion-item__toggle-focus q-icon q-focus-helper q-focus-helper--rounded",attrs:{tabindex:-1}}))),e(Jr,t,n)},__getHeader:function(e){var t;void 0!==this.$scopedSlots.header?t=this.$scopedSlots.header().slice():(t=[e(Jr,[e(go,{props:{lines:this.labelLines}},[this.label||""]),this.caption?e(go,{props:{lines:this.captionLines,caption:!0}},[this.caption]):null])],this.icon&&t[!0===this.switchToggleSide?"push":"unshift"](e(Jr,{props:{side:!0===this.switchToggleSide,avatar:!0!==this.switchToggleSide}},[e(De,{props:{name:this.icon}})]))),!0!==this.disable&&t[!0===this.switchToggleSide?"unshift":"push"](this.__getToggleIcon(e));var n={ref:"item",style:this.headerStyle,class:this.headerClass,props:{dark:this.isDark,disable:this.disable,dense:this.dense,insetLevel:this.headerInsetLevel}};if(!0===this.isClickable){var i=!0===this.hasRouterLink?"nativeOn":"on";n.props.clickable=!0,n[i]=Object.assign({},this.qListeners,{click:this.__onHeaderClick}),!0===this.hasRouterLink&&Object.assign(n.props,this.routerLinkProps)}return e(Zr,n,t)},__getContent:function(e){var t=this,n=[this.__getHeader(e),e(_o,{props:{duration:this.duration},on:pe(this,"slide",{show:function(){t.$emit("after-show")},hide:function(){t.$emit("after-hide")}})},[e("div",{staticClass:"q-expansion-item__content relative-position",style:this.contentStyle,directives:[{name:"show",value:this.showing}]},Le(this,"default"))])];return this.expandSeparator&&n.push(e(wo,{staticClass:"q-expansion-item__border q-expansion-item__border--top absolute-top",props:{dark:this.isDark}}),e(wo,{staticClass:"q-expansion-item__border q-expansion-item__border--bottom absolute-bottom",props:{dark:this.isDark}})),n}},render:function(e){return e("div",{staticClass:"q-expansion-item q-item-type",class:this.classes},[e("div",{staticClass:"q-expansion-item__container relative-position"},this.__getContent(e))])},created:function(){void 0!==this.group&&this.$root.$on(ko,this.__eventHandler)},beforeDestroy:function(){void 0!==this.group&&this.$root.$off(ko,this.__eventHandler)}}),So=["top","right","bottom","left"],Co={mixins:[Pe],props:{type:{type:String,default:"a"},outline:Boolean,push:Boolean,flat:Boolean,unelevated:Boolean,color:String,textColor:String,glossy:Boolean,square:Boolean,padding:String,label:{type:[String,Number],default:""},labelPosition:{type:String,default:"right",validator:function(e){return So.includes(e)}},externalLabel:Boolean,hideLabel:{type:Boolean},labelClass:[Array,String,Object],labelStyle:[Array,String,Object],disable:Boolean,tabindex:[Number,String]},computed:{formClass:function(){return"q-fab--form-"+(!0===this.square?"square":"rounded")},stacked:function(){return!1===this.externalLabel&&["top","bottom"].includes(this.labelPosition)},labelProps:function(){if(!0===this.externalLabel){var e=null===this.hideLabel?!1===this.showing:this.hideLabel;return{action:"push",data:{staticClass:"q-fab__label q-tooltip--style q-fab__label--external q-fab__label--external-"+this.labelPosition+(!0===e?" q-fab__label--external-hidden":""),style:this.labelStyle,class:this.labelClass}}}return{action:["left","top"].includes(this.labelPosition)?"unshift":"push",data:{staticClass:"q-fab__label q-fab__label--internal q-fab__label--internal-"+this.labelPosition+(!0===this.hideLabel?" q-fab__label--internal-hidden":""),style:this.labelStyle,class:this.labelClass}}}}},Mo=["up","right","down","left"],To=["left","center","right"],Ao=e.extend({name:"QFab",inheritAttrs:!1,mixins:[Co,_e,St],provide:function(){return{__qFab:this}},props:{icon:String,activeIcon:String,hideIcon:Boolean,hideLabel:{default:null},direction:{type:String,default:"right",validator:function(e){return Mo.includes(e)}},persistent:Boolean,verticalActionsAlign:{type:String,default:"center",validator:function(e){return To.includes(e)}}},data:function(){return{showing:!0===this.value}},computed:{hideOnRouteChange:function(){return!0!==this.persistent},classes:function(){return"q-fab--align-"+this.verticalActionsAlign+" "+this.formClass+(!0===this.showing?" q-fab--opened":"")},attrs:function(){return Object.assign({},{"aria-expanded":!0===this.showing?"true":"false","aria-haspopup":"true"},this.qAttrs)}},methods:{__onChildClick:function(e){this.hide(e),this.$refs.trigger&&this.$refs.trigger.$el&&this.$refs.trigger.$el.focus()}},render:function(e){var t=[];return!0!==this.hideIcon&&t.push(e("div",{staticClass:"q-fab__icon-holder"},[e(De,{staticClass:"q-fab__icon absolute-full",props:{name:this.icon||this.$q.iconSet.fab.icon}}),e(De,{staticClass:"q-fab__active-icon absolute-full",props:{name:this.activeIcon||this.$q.iconSet.fab.activeIcon}})])),""!==this.label&&t[this.labelProps.action](e("div",this.labelProps.data,[this.label])),e("div",{staticClass:"q-fab z-fab row inline justify-center",class:this.classes,on:Object.assign({},this.qListeners)},[e(bt,{ref:"trigger",class:this.formClass,props:Object.assign({},this.$props,{noWrap:!0,stack:this.stacked,align:void 0,icon:void 0,label:void 0,noCaps:!0,fab:!0}),attrs:this.attrs,on:pe(this,"tog",{click:this.toggle})},qe(t,this,"tooltip")),e("div",{staticClass:"q-fab__actions flex no-wrap inline",class:"q-fab__actions--"+this.direction},Le(this,"default"))])}}),Po={start:"self-end",center:"self-center",end:"self-start"},Lo=Object.keys(Po),Oo=e.extend({name:"QFabAction",mixins:[Co],props:{icon:{type:String,default:""},anchor:{type:String,validator:function(e){return Lo.includes(e)}},to:[String,Object],replace:Boolean},inject:{__qFab:{default:function(){console.error("QFabAction needs to be child of QFab")}}},computed:{classes:function(){var e=Po[this.anchor];return this.formClass+(void 0!==e?" "+e:"")},onEvents:function(){return Object.assign({},this.qListeners,{click:this.click})},isDisabled:function(){return!0!==this.__qFab.showing||!0===this.disable}},methods:{click:function(e){this.__qFab.__onChildClick(e),this.$emit("click",e)}},render:function(e){var t=[];return""!==this.icon&&t.push(e(De,{props:{name:this.icon}})),""!==this.label&&t[this.labelProps.action](e("div",this.labelProps.data,[this.label])),e(bt,{class:this.classes,props:Object.assign({},this.$props,{noWrap:!0,stack:this.stacked,icon:void 0,label:void 0,noCaps:!0,fabMini:!0,disable:this.isDisabled}),on:this.onEvents},qe(t,this,"default"))}}),qo=e.extend({name:"QFile",mixins:[Er,zr,cn,Nr],props:{value:!0===i?{}:[File,FileList,Array],append:Boolean,useChips:Boolean,displayValue:[String,Number],tabindex:{type:[String,Number],default:0},counterLabel:Function,inputClass:[Array,String,Object],inputStyle:[Array,String,Object]},data:function(){return{dnd:!1}},computed:{innerValue:function(){return Object(this.value)===this.value?"length"in this.value?Array.from(this.value):[this.value]:[]},selectedString:function(){return this.innerValue.map((function(e){return e.name})).join(", ")},totalSize:function(){return le(this.innerValue.reduce((function(e,t){return e+t.size}),0))},counterProps:function(){return{totalSize:this.totalSize,filesNumber:this.innerValue.length,maxFiles:this.maxFiles}},computedCounter:function(){if(void 0!==this.counterLabel)return this.counterLabel(this.counterProps);var e=this.maxFiles;return this.innerValue.length+(void 0!==e?" / "+e:"")+" ("+this.totalSize+")"},inputAttrs:function(){return Object.assign({},{tabindex:-1,type:"file",title:"",accept:this.accept,capture:this.capture,name:this.nameProp},this.qAttrs,{id:this.targetUid,disabled:!0!==this.editable})},isAppending:function(){return!0===this.multiple&&!0===this.append}},methods:{removeAtIndex:function(e){var t=this.innerValue.slice();t.splice(e,1),this.__emitValue(t)},removeFile:function(e){var t=this.innerValue.findIndex(e);t>-1&&this.removeAtIndex(t)},__emitValue:function(e){this.$emit("input",!0===this.multiple?e:e[0])},__onKeyup:function(e){13===e.keyCode&&this.pickFiles(e)},__getFileInput:function(){return this.$refs.input},__addFiles:function(e,t){var n=this.__processFiles(e,t,this.innerValue,this.isAppending);void 0!==n&&this.__emitValue(!0===this.isAppending?this.innerValue.concat(n):n)},__getControl:function(e){var t={ref:"target",staticClass:"q-field__native row items-center cursor-pointer",attrs:{tabindex:this.tabindex}};return!0===this.editable&&(t.on=pe(this,"native",{dragover:this.__onDragOver,keyup:this.__onKeyup})),e("div",t,[this.__getInput(e)].concat(this.__getSelection(e)))},__getControlChild:function(e){return this.__getDnd(e,"file")},__getSelection:function(e){var t=this;return void 0!==this.$scopedSlots.file?this.innerValue.map((function(e,n){return t.$scopedSlots.file({index:n,file:e,ref:t})})):void 0!==this.$scopedSlots.selected?this.$scopedSlots.selected({files:this.innerValue,ref:this}):!0===this.useChips?this.innerValue.map((function(n,i){return e(zn,{key:"file-"+i,props:{removable:t.editable,dense:!0,textColor:t.color,tabindex:t.tabindex},on:pe(t,"rem#"+i,{remove:function(){t.removeAtIndex(i)}})},[e("span",{staticClass:"ellipsis",domProps:{textContent:n.name}})])})):[e("div",{style:this.inputStyle,class:this.inputClass,domProps:{textContent:void 0!==this.displayValue?this.displayValue:this.selectedString}})]},__getInput:function(e){var t={ref:"input",staticClass:"q-field__input fit absolute-full cursor-pointer",attrs:this.inputAttrs,domProps:this.formDomProps,on:pe(this,"input",{change:this.__addFiles})};return!0===this.multiple&&(t.attrs.multiple=!0),e("input",t)}},created:function(){this.fieldClass="q-file q-field--auto-height",this.type="file"}}),Eo=e.extend({name:"QFooter",mixins:[Pe],inject:{layout:{default:function(){console.error("QFooter needs to be child of QLayout")}}},props:{value:{type:Boolean,default:!0},reveal:Boolean,bordered:Boolean,elevated:Boolean,heightHint:{type:[String,Number],default:50}},data:function(){return{size:parseInt(this.heightHint,10),revealed:!0,windowHeight:o||this.layout.container?0:window.innerHeight}},watch:{value:function(e){this.__update("space",e),this.__updateLocal("revealed",!0),this.layout.__animate()},offset:function(e){this.__update("offset",e)},reveal:function(e){!1===e&&this.__updateLocal("revealed",this.value)},revealed:function(e){this.layout.__animate(),this.$emit("reveal",e)},"layout.scroll":function(){this.__updateRevealed()},"layout.height":function(){this.__updateRevealed()},size:function(){this.__updateRevealed()},"$q.screen.height":function(e){!0!==this.layout.container&&this.__updateLocal("windowHeight",e)}},computed:{fixed:function(){return!0===this.reveal||this.layout.view.indexOf("F")>-1||!0===this.layout.container},containerHeight:function(){return!0===this.layout.container?this.layout.containerHeight:this.windowHeight},offset:function(){if(!0!==this.value)return 0;if(!0===this.fixed)return!0===this.revealed?this.size:0;var e=this.layout.scroll.position+this.containerHeight+this.size-this.layout.height;return e>0?e:0},hidden:function(){return!0!==this.value||!0===this.fixed&&!0!==this.revealed},revealOnFocus:function(){return!0===this.value&&!0===this.hidden&&!0===this.reveal},classes:function(){return(!0===this.fixed?"fixed":"absolute")+"-bottom"+(!0===this.bordered?" q-footer--bordered":"")+(!0===this.hidden?" q-footer--hidden":"")+(!0!==this.value?" q-layout--prevent-focus":"")+(!0!==this.value&&!0!==this.fixed?" hidden":"")},style:function(){var e=this.layout.rows.bottom,t={};return"l"===e[0]&&!0===this.layout.left.space&&(t[!0===this.$q.lang.rtl?"right":"left"]=this.layout.left.size+"px"),"r"===e[2]&&!0===this.layout.right.space&&(t[!0===this.$q.lang.rtl?"left":"right"]=this.layout.right.size+"px"),t},onEvents:function(){return Object.assign({},this.qListeners,{focusin:this.__onFocusin,input:b})}},render:function(e){var t=qe([e(ni,{props:{debounce:0},on:pe(this,"resize",{resize:this.__onResize})})],this,"default");return!0===this.elevated&&t.push(e("div",{staticClass:"q-layout__shadow absolute-full overflow-hidden no-pointer-events"})),e("footer",{staticClass:"q-footer q-layout__section--marginal",class:this.classes,style:this.style,on:this.onEvents},t)},created:function(){this.layout.instances.footer=this,!0===this.value&&this.__update("size",this.size),this.__update("space",this.value),this.__update("offset",this.offset)},beforeDestroy:function(){this.layout.instances.footer===this&&(this.layout.instances.footer=void 0,this.__update("size",0),this.__update("offset",0),this.__update("space",!1))},methods:{__onResize:function(e){var t=e.height;this.__updateLocal("size",t),this.__update("size",t)},__update:function(e,t){this.layout.footer[e]!==t&&(this.layout.footer[e]=t)},__updateLocal:function(e,t){this[e]!==t&&(this[e]=t)},__updateRevealed:function(){if(!0===this.reveal){var e=this.layout.scroll,t=e.direction,n=e.position,i=e.inflexionPosition;this.__updateLocal("revealed","up"===t||n-i<100||this.layout.height-this.containerHeight-n-this.size<300)}},__onFocusin:function(e){!0===this.revealOnFocus&&this.__updateLocal("revealed",!0),this.$emit("focusin",e)}}}),Do=e.extend({name:"QForm",mixins:[Pe],props:{autofocus:Boolean,noErrorFocus:Boolean,noResetFocus:Boolean,greedy:Boolean},computed:{onEvents:function(){return Object.assign({},this.qListeners,{submit:this.submit,reset:this.reset})}},mounted:function(){this.validateIndex=0,!0===this.autofocus&&this.focus()},methods:{validate:function(e){var t=this,n=[],i="boolean"==typeof e?e:!0!==this.noErrorFocus;this.validateIndex++;for(var r=this.getValidationComponents(),o=function(e,n){t.$emit("validation-"+(!0===e?"success":"error"),n)},a=function(e){var a=r[e],s=a.validate();if("function"==typeof s.then)n.push(s.then((function(e){return{valid:e,comp:a}}),(function(e){return{valid:!1,comp:a,error:e}})));else if(!0!==s){if(!1===t.greedy)return o(!1,a),!0===i&&"function"==typeof a.focus&&a.focus(),{v:Promise.resolve(!1)};n.push({valid:!1,comp:a})}},s=0;s<r.length;s++){var l=a(s);if(l)return l.v}if(0===n.length)return o(!0),Promise.resolve(!0);var c=this.validateIndex;return Promise.all(n).then((function(e){if(c===t.validateIndex){var n=e.filter((function(e){return!0!==e.valid}));if(0===n.length)return o(!0),!0;var r=n[0],a=r.valid,s=r.comp;return o(!1,s),!0===i&&!0!==a&&"function"==typeof s.focus&&s.focus(),!1}}))},resetValidation:function(){this.validateIndex++,this.getValidationComponents().forEach((function(e){e.resetValidation()}))},submit:function(e){var t=this;void 0!==e&&w(e),this.validate().then((function(n){!0===n&&(void 0!==t.qListeners.submit?t.$emit("submit",e):void 0!==e&&void 0!==e.target&&"function"==typeof e.target.submit&&e.target.submit())}))},reset:function(e){var t=this;void 0!==e&&w(e),this.$emit("reset"),this.$nextTick((function(){t.resetValidation(),!0===t.autofocus&&!0!==t.noResetFocus&&t.focus()}))},focus:function(){var e=this.$el.querySelector("[autofocus], [data-autofocus]")||Array.prototype.find.call(this.$el.querySelectorAll("[tabindex]"),(function(e){return e.tabIndex>-1}));null!=e&&e.focus()},getValidationComponents:function(){return Array.prototype.map.call(this.$el.getElementsByClassName("q-validation-component"),(function(e){return e.__vue__})).filter((function(e){return void 0!==e&&"function"==typeof e.validate}))}},render:function(e){return e("form",{staticClass:"q-form",on:this.onEvents},Le(this,"default"))}}),zo=e.extend({name:"QHeader",mixins:[Pe],inject:{layout:{default:function(){console.error("QHeader needs to be child of QLayout")}}},props:{value:{type:Boolean,default:!0},reveal:Boolean,revealOffset:{type:Number,default:250},bordered:Boolean,elevated:Boolean,heightHint:{type:[String,Number],default:50}},data:function(){return{size:parseInt(this.heightHint,10),revealed:!0}},watch:{value:function(e){this.__update("space",e),this.__updateLocal("revealed",!0),this.layout.__animate()},offset:function(e){this.__update("offset",e)},reveal:function(e){!1===e&&this.__updateLocal("revealed",this.value)},revealed:function(e){this.layout.__animate(),this.$emit("reveal",e)},"layout.scroll":function(e){!0===this.reveal&&this.__updateLocal("revealed","up"===e.direction||e.position<=this.revealOffset||e.position-e.inflexionPosition<100)}},computed:{fixed:function(){return!0===this.reveal||this.layout.view.indexOf("H")>-1||!0===this.layout.container},offset:function(){if(!0!==this.value)return 0;if(!0===this.fixed)return!0===this.revealed?this.size:0;var e=this.size-this.layout.scroll.position;return e>0?e:0},hidden:function(){return!0!==this.value||!0===this.fixed&&!0!==this.revealed},revealOnFocus:function(){return!0===this.value&&!0===this.hidden&&!0===this.reveal},classes:function(){return(!0===this.fixed?"fixed":"absolute")+"-top"+(!0===this.bordered?" q-header--bordered":"")+(!0===this.hidden?" q-header--hidden":"")+(!0!==this.value?" q-layout--prevent-focus":"")},style:function(){var e=this.layout.rows.top,t={};return"l"===e[0]&&!0===this.layout.left.space&&(t[!0===this.$q.lang.rtl?"right":"left"]=this.layout.left.size+"px"),"r"===e[2]&&!0===this.layout.right.space&&(t[!0===this.$q.lang.rtl?"left":"right"]=this.layout.right.size+"px"),t},onEvents:function(){return Object.assign({},this.qListeners,{focusin:this.__onFocusin,input:b})}},render:function(e){var t=Oe(this,"default",[]);return!0===this.elevated&&t.push(e("div",{staticClass:"q-layout__shadow absolute-full overflow-hidden no-pointer-events"})),t.push(e(ni,{props:{debounce:0},on:pe(this,"resize",{resize:this.__onResize})})),e("header",{staticClass:"q-header q-layout__section--marginal",class:this.classes,style:this.style,on:this.onEvents},t)},created:function(){this.layout.instances.header=this,!0===this.value&&this.__update("size",this.size),this.__update("space",this.value),this.__update("offset",this.offset)},beforeDestroy:function(){this.layout.instances.header===this&&(this.layout.instances.header=void 0,this.__update("size",0),this.__update("offset",0),this.__update("space",!1))},methods:{__onResize:function(e){var t=e.height;this.__updateLocal("size",t),this.__update("size",t)},__update:function(e,t){this.layout.header[e]!==t&&(this.layout.header[e]=t)},__updateLocal:function(e,t){this[e]!==t&&(this[e]=t)},__onFocusin:function(e){!0===this.revealOnFocus&&this.__updateLocal("revealed",!0),this.$emit("focusin",e)}}}),No={props:{ratio:[String,Number]},computed:{ratioStyle:function(){var e=this.ratio||this.naturalRatio;if(void 0!==e)return{paddingBottom:100/e+"%"}}}},jo=e.extend({name:"QImg",mixins:[Pe,No],props:{src:String,srcset:String,sizes:String,alt:String,width:String,height:String,placeholderSrc:String,basic:Boolean,contain:Boolean,position:{type:String,default:"50% 50%"},transition:{type:String,default:"fade"},imgClass:[Array,String,Object],imgStyle:Object,nativeContextMenu:Boolean,noDefaultSpinner:Boolean,spinnerColor:String,spinnerSize:String},data:function(){return{currentSrc:"",image:null,isLoading:!!this.src,hasError:!1,naturalRatio:void 0}},watch:{src:function(){this.__load()},srcset:function(e){this.__updateWatcher(e)}},computed:{url:function(){return this.currentSrc||this.placeholderSrc||void 0},attrs:function(){var e={role:"img"};return void 0!==this.alt&&(e["aria-label"]=this.alt),e},imgContainerStyle:function(){return Object.assign({backgroundSize:!0===this.contain?"contain":"cover",backgroundPosition:this.position},this.imgStyle,{backgroundImage:'url("'+this.url+'")'})},style:function(){return{width:this.width,height:this.height}},classes:function(){return"q-img overflow-hidden"+(!0===this.nativeContextMenu?" q-img--menu":"")}},methods:{__onLoad:function(e){this.isLoading=!1,this.hasError=!1,this.__computeRatio(e),this.__updateSrc(),this.__updateWatcher(this.srcset),this.$emit("load",this.currentSrc)},__onError:function(e){clearTimeout(this.ratioTimer),this.isLoading=!1,this.hasError=!0,this.currentSrc="",this.$emit("error",e)},__updateSrc:function(){if(void 0!==this.image&&!1===this.isLoading){var e=this.image.currentSrc||this.image.src;this.currentSrc!==e&&(this.currentSrc=e)}},__updateWatcher:function(e){e?void 0===this.unwatch&&(this.unwatch=this.$watch("$q.screen.width",this.__updateSrc)):void 0!==this.unwatch&&(this.unwatch(),this.unwatch=void 0)},__load:function(){var e=this;if(clearTimeout(this.ratioTimer),this.hasError=!1,!this.src)return this.isLoading=!1,this.image=void 0,void(this.currentSrc="");this.isLoading=!0;var t=new Image;this.image=t,t.onerror=function(n){e.image===t&&!0!==e.destroyed&&e.__onError(n)},t.onload=function(){!0!==e.destroyed&&e.image===t&&(void 0!==t.decode?t.decode().catch((function(n){e.image===t&&!0!==e.destroyed&&e.__onError(n)})).then((function(){e.image===t&&!0!==e.destroyed&&e.__onLoad(t)})):e.__onLoad(t))},t.src=this.src,this.srcset&&(t.srcset=this.srcset),void 0!==this.sizes?t.sizes=this.sizes:Object.assign(t,{height:this.height,width:this.width})},__computeRatio:function(e){var t=this,n=e.naturalHeight,i=e.naturalWidth;n||i?this.naturalRatio=0===n?1:i/n:this.ratioTimer=setTimeout((function(){t.image===e&&!0!==t.destroyed&&t.__computeRatio(e)}),100)},__getImage:function(e){var t=!0===this.nativeContextMenu?[e("img",{staticClass:"absolute-full fit",attrs:{src:this.url,"aria-hidden":"true"}})]:void 0,n=void 0!==this.url?e("div",{key:this.url,staticClass:"q-img__image absolute-full",class:this.imgClass,style:this.imgContainerStyle},t):null;return!0===this.basic?n:e("transition",{props:{name:"q-transition--"+this.transition}},[n])},__getContent:function(e){var t=Le(this,!0===this.hasError?"error":"default");if(!0===this.basic)return e("div",{key:"content",staticClass:"q-img__content absolute-full"},t);var n=!0===this.isLoading?e("div",{key:"placeholder",staticClass:"q-img__loading absolute-full flex flex-center"},void 0!==this.$scopedSlots.loading?this.$scopedSlots.loading():!1===this.noDefaultSpinner?[e(Qe,{props:{color:this.spinnerColor,size:this.spinnerSize}})]:void 0):e("div",{key:"content",staticClass:"q-img__content absolute-full"},t);return e("transition",{props:{name:"q-transition--fade"}},[n])}},render:function(e){return e("div",{class:this.classes,style:this.style,attrs:this.attrs,on:Object.assign({},this.qListeners)},[e("div",{style:this.ratioStyle}),this.__getImage(e),this.__getContent(e)])},beforeMount:function(){if(void 0!==this.placeholderSrc&&void 0===this.ratio){var e=new Image;e.src=this.placeholderSrc,this.__computeRatio(e)}!0===this.isLoading&&this.__load()},beforeDestroy:function(){this.destroyed=!0,clearTimeout(this.ratioTimer),void 0!==this.unwatch&&this.unwatch()}}),Ro=e.extend({name:"QInfiniteScroll",mixins:[Pe],props:{offset:{type:Number,default:500},debounce:{type:[String,Number],default:100},scrollTarget:{default:void 0},initialIndex:Number,disable:Boolean,reverse:Boolean},data:function(){return{index:this.initialIndex||0,fetching:!1,working:!0}},watch:{disable:function(e){!0===e?this.stop():this.resume()},scrollTarget:function(){this.updateScrollTarget()},debounce:function(e){this.__setDebounce(e)}},methods:{poll:function(){if(!0!==this.disable&&!0!==this.fetching&&!1!==this.working){var e=Rt(this.__scrollTarget),t=It(this.__scrollTarget),n=Ze(this.__scrollTarget);!1===this.reverse?t+n+this.offset>=e&&this.trigger():t<this.offset&&this.trigger()}},trigger:function(){var e=this;if(!0!==this.disable&&!0!==this.fetching&&!1!==this.working){this.index++,this.fetching=!0;var t=Rt(this.__scrollTarget);this.$emit("load",this.index,(function(n){!0===e.working&&(e.fetching=!1,e.$nextTick((function(){if(!0===e.reverse){var i=Rt(e.__scrollTarget),r=It(e.__scrollTarget),o=i-t;Wt(e.__scrollTarget,r+o)}!0===n?e.stop():e.$el.closest("body")&&e.poll()})))}))}},reset:function(){this.index=0},resume:function(){!1===this.working&&(this.working=!0,this.__scrollTarget.addEventListener("scroll",this.poll,f.passive)),this.immediatePoll()},stop:function(){!0===this.working&&(this.working=!1,this.fetching=!1,this.__scrollTarget.removeEventListener("scroll",this.poll,f.passive))},updateScrollTarget:function(){this.__scrollTarget&&!0===this.working&&this.__scrollTarget.removeEventListener("scroll",this.poll,f.passive),this.__scrollTarget=jt(this.$el,this.scrollTarget),!0===this.working&&this.__scrollTarget.addEventListener("scroll",this.poll,f.passive)},setIndex:function(e){this.index=e},__setDebounce:function(e){e=parseInt(e,10),this.poll=e<=0?this.immediatePoll:T(this.immediatePoll,!0===isNaN(e)?100:e)}},mounted:function(){if(this.immediatePoll=this.poll,this.__setDebounce(this.debounce),this.updateScrollTarget(),this.immediatePoll(),!0===this.reverse){var e=Rt(this.__scrollTarget),t=Ze(this.__scrollTarget);Wt(this.__scrollTarget,e-t)}},beforeDestroy:function(){!0===this.working&&this.__scrollTarget.removeEventListener("scroll",this.poll,f.passive)},render:function(e){var t=Oe(this,"default",[]);return!0!==this.disable&&!0===this.working&&t[!1===this.reverse?"push":"unshift"](e("div",{staticClass:"q-infinite-scroll__loading",class:!0===this.fetching?"":"invisible"},Le(this,"loading"))),e("div",{staticClass:"q-infinite-scroll",on:Object.assign({},this.qListeners)},t)}}),Io=e.extend({name:"QInnerLoading",mixins:[Pe,je,At],props:{showing:Boolean,color:String,size:{type:[String,Number],default:42}},render:function(e){var t=!0===this.showing?[e("div",{staticClass:"q-inner-loading absolute-full column flex-center",class:!0===this.isDark?"q-inner-loading--dark":null,on:Object.assign({},this.qListeners)},void 0!==this.$scopedSlots.default?this.$scopedSlots.default():[e(Qe,{props:{size:this.size,color:this.color}})])]:void 0;return e("transition",{props:{name:this.transition,appear:!0}},t)}}),$o={threshold:0,root:null,rootMargin:"0px"};function Fo(e,t,n){var i,r,o;"function"==typeof n?(i=n,r=$o,o=void 0===t.cfg):(i=n.handler,r=Object.assign({},$o,n.cfg),o=void 0===t.cfg||!1===Sn(t.cfg,r)),t.handler!==i&&(t.handler=i),!0===o&&(t.cfg=r,void 0!==t.observer&&t.observer.unobserve(e),t.observer=new IntersectionObserver((function(n){var i=n[0];if("function"==typeof t.handler){if(null===i.rootBounds&&(void 0!==e.__vue__?!0!==e.__vue__._inactive:!0===document.body.contains(e)))return t.observer.unobserve(e),void t.observer.observe(e);(!1===t.handler(i,t.observer)||!0===t.once&&!0===i.isIntersecting)&&Bo(e)}}),r),t.observer.observe(e))}function Bo(e){var t=e.__qvisible;void 0!==t&&(void 0!==t.observer&&t.observer.unobserve(e),delete e.__qvisible)}var Vo={name:"intersection",inserted:function(e,t){var n=t.modifiers,i=t.value;void 0!==e.__qvisible&&(Bo(e),e.__qvisible_destroyed=!0);var r={once:!0===n.once};Fo(e,r,i),e.__qvisible=r},update:function(e,t){var n=e.__qvisible;void 0!==n&&Fo(e,n,t.value)},unbind:function(e){void 0===e.__qvisible_destroyed?Bo(e):delete e.__qvisible_destroyed}},Ho=e.extend({name:"QIntersection",mixins:[Ae,Pe],directives:{Intersection:Vo},props:{once:Boolean,transition:String,ssrPrerender:Boolean,margin:String,threshold:[Number,Array],disable:Boolean},data:function(){return{showing:!0===o&&this.ssrPrerender}},computed:{value:function(){return void 0!==this.margin||void 0!==this.threshold?{handler:this.__trigger,cfg:{rootMargin:this.margin,threshold:this.threshold}}:this.__trigger},directives:function(){if(!0!==this.disable&&(!0!==o||!0!==this.once||!0!==this.ssrPrerender))return[{name:"intersection",value:this.value,modifiers:{once:this.once}}]}},methods:{__trigger:function(e){this.showing!==e.isIntersecting&&(this.showing=e.isIntersecting,void 0!==this.qListeners.visibility&&this.$emit("visibility",this.showing))}},render:function(e){var t=!0===this.showing?[e("div",{key:"content"},Le(this,"default"))]:void 0;return e(this.tag,{staticClass:"q-intersection",on:Object.assign({},this.qListeners),directives:this.directives},this.transition?[e("transition",{props:{name:"q-transition--"+this.transition}},t)]:t)}}),Wo=[34,37,40,33,39,38],Uo=e.extend({name:"QKnob",mixins:[{props:Rn.options.props},ln],directives:{TouchPan:Qn},props:{step:{type:Number,default:1,validator:function(e){return e>=0}},tabindex:{type:[Number,String],default:0},disable:Boolean,readonly:Boolean},data:function(){return{model:this.value,dragging:!1}},watch:{value:function(e){if(e<this.min)this.model=this.min;else{if(!(e>this.max))return void(e!==this.model&&(this.model=e));this.model=this.max}this.model!==this.value&&(this.$emit("input",this.model),this.$emit("change",this.model))}},computed:{classes:function(){return"q-knob non-selectable"+(!0===this.editable?" q-knob--editable":!0===this.disable?" disabled":"")},editable:function(){return!1===this.disable&&!1===this.readonly},decimals:function(){return(String(this.step).trim("0").split(".")[1]||"").length},computedStep:function(){return 0===this.step?1:this.step},computedInstantFeedback:function(){return!0===this.instantFeedback||!0===this.dragging},onEvents:function(){return!0===this.$q.platform.is.mobile?{click:this.__click}:{mousedown:this.__activate,click:this.__click,keydown:this.__keydown,keyup:this.__keyup}},attrs:function(){var e={role:"slider","aria-valuemin":this.min,"aria-valuemax":this.max,"aria-valuenow":this.value};return!0===this.editable?e.tabindex=this.tabindex:e["aria-"+(!0===this.disable?"disabled":"readonly")]="",e}},methods:{__updateCenterPosition:function(){var e=this.$el.getBoundingClientRect(),t=e.top,n=e.left,i=e.width,r=e.height;this.centerPosition={top:t+r/2,left:n+i/2}},__pan:function(e){e.isFinal?(this.__updatePosition(e.evt,!0),this.dragging=!1):e.isFirst?(this.__updateCenterPosition(),this.dragging=!0,this.__updatePosition(e.evt)):this.__updatePosition(e.evt)},__click:function(e){this.__updateCenterPosition(),this.__updatePosition(e,!0)},__keydown:function(e){if(Wo.includes(e.keyCode)){w(e);var t=([34,33].includes(e.keyCode)?10:1)*this.computedStep,n=[34,37,40].includes(e.keyCode)?-t:t;this.model=ue(parseFloat((this.model+n).toFixed(this.decimals)),this.min,this.max),this.__updateValue()}},__keyup:function(e){Wo.includes(e.keyCode)&&this.__updateValue(!0)},__activate:function(e){this.__updateCenterPosition(),this.__updatePosition(e)},__updatePosition:function(e,t){var n=this.centerPosition,i=g(e),r=Math.abs(i.top-n.top),o=Math.sqrt(Math.pow(r,2)+Math.pow(Math.abs(i.left-n.left),2)),a=Math.asin(r/o)*(180/Math.PI);a=i.top<n.top?n.left<i.left?90-a:270+a:n.left<i.left?a+90:270-a,this.angle&&(a=de(a-this.angle,0,360)),!0===this.$q.lang.rtl&&(a=360-a);var s=this.min+a/360*(this.max-this.min);if(0!==this.step){var l=this.computedStep,c=s%l;s=s-c+(Math.abs(c)>=l/2?(c<0?-1:1)*l:0),s=parseFloat(s.toFixed(this.decimals))}s=ue(s,this.min,this.max),this.$emit("drag-value",s),this.model!==s&&(this.model=s),this.__updateValue(t)},__updateValue:function(e){this.value!==this.model&&this.$emit("input",this.model),!0===e&&this.$emit("change",this.model)},__getNameInput:function(){return this.$createElement("input",{attrs:this.formAttrs})}},render:function(e){var t={class:this.classes,attrs:this.attrs,props:Object.assign({},this.$props,{value:this.model,instantFeedback:this.computedInstantFeedback})};return!0===this.editable&&(t.on=this.onEvents,t.directives=pe(this,"dir",[{name:"touch-pan",value:this.__pan,modifiers:{prevent:!0,stop:!0,mouse:!0}}]),void 0!==this.name&&(t.scopedSlots={internal:this.__getNameInput})),e(Rn,t,Le(this,"default"))}}),Yo=f.passive,Go=e.extend({name:"QScrollObserver",props:{debounce:[String,Number],horizontal:Boolean,scrollTarget:{default:void 0}},render:m,data:function(){return{pos:0,dir:!0===this.horizontal?"right":"down",dirChanged:!1,dirChangePos:0}},watch:{scrollTarget:function(){this.__unconfigureScrollTarget(),this.__configureScrollTarget()}},methods:{getPosition:function(){return{position:this.pos,direction:this.dir,directionChanged:this.dirChanged,inflexionPosition:this.dirChangePos}},trigger:function(e){!0===e||0===this.debounce||"0"===this.debounce?this.__emit():this.timer||(this.timer=this.debounce?setTimeout(this.__emit,this.debounce):requestAnimationFrame(this.__emit))},__emit:function(){var e=!0===this.horizontal?$t:It,t=Math.max(0,e(this.__scrollTarget)),n=t-this.pos,i=!0===this.horizontal?n<0?"left":"right":n<0?"up":"down";this.dirChanged=this.dir!==i,this.dirChanged&&(this.dir=i,this.dirChangePos=this.pos),this.timer=null,this.pos=t,this.$emit("scroll",this.getPosition())},__configureScrollTarget:function(){this.__scrollTarget=jt(this.$el.parentNode,this.scrollTarget),this.__scrollTarget.addEventListener("scroll",this.trigger,Yo),this.trigger(!0)},__unconfigureScrollTarget:function(){void 0!==this.__scrollTarget&&(this.__scrollTarget.removeEventListener("scroll",this.trigger,Yo),this.__scrollTarget=void 0)}},mounted:function(){this.__configureScrollTarget()},beforeDestroy:function(){clearTimeout(this.timer),cancelAnimationFrame(this.timer),this.__unconfigureScrollTarget()}}),Qo=e.extend({name:"QLayout",mixins:[Pe],provide:function(){return{layout:this}},props:{container:Boolean,view:{type:String,default:"hhh lpr fff",validator:function(e){return/^(h|l)h(h|r) lpr (f|l)f(f|r)$/.test(e.toLowerCase())}}},data:function(){return{height:this.$q.screen.height,width:!0===this.container?0:this.$q.screen.width,containerHeight:0,scrollbarWidth:!0===o?0:Yt(),header:{size:0,offset:0,space:!1},right:{size:300,offset:0,space:!1},footer:{size:0,offset:0,space:!1},left:{size:300,offset:0,space:!1},scroll:{position:0,direction:"down"}}},computed:{rows:function(){var e=this.view.toLowerCase().split(" ");return{top:e[0].split(""),middle:e[1].split(""),bottom:e[2].split("")}},style:function(){return!0===this.container?null:{minHeight:this.$q.screen.height+"px"}},targetStyle:function(){var e;if(0!==this.scrollbarWidth)return(e={})[!0===this.$q.lang.rtl?"left":"right"]=this.scrollbarWidth+"px",e},targetChildStyle:function(){var e;if(0!==this.scrollbarWidth)return(e={})[!0===this.$q.lang.rtl?"right":"left"]=0,e[!0===this.$q.lang.rtl?"left":"right"]="-"+this.scrollbarWidth+"px",e.width="calc(100% + "+this.scrollbarWidth+"px)",e},totalWidth:function(){return this.width+this.scrollbarWidth},classes:function(){return"q-layout q-layout--"+(!0===this.container?"containerized":"standard")}},created:function(){this.instances={}},render:function(e){var t=e("div",{class:this.classes,style:this.style,on:Object.assign({},this.qListeners)},qe([e(Go,{on:pe(this,"scroll",{scroll:this.__onPageScroll})}),e(ni,{on:pe(this,"resizeOut",{resize:this.__onPageResize})})],this,"default"));return!0===this.container?e("div",{staticClass:"q-layout-container overflow-hidden"},[e(ni,{on:pe(this,"resizeIn",{resize:this.__onContainerResize})}),e("div",{staticClass:"absolute-full",style:this.targetStyle},[e("div",{staticClass:"scroll",style:this.targetChildStyle},[t])])]):t},methods:{__animate:function(){var e=this;void 0!==this.timer?clearTimeout(this.timer):document.body.classList.add("q-body--layout-animate"),this.timer=setTimeout((function(){document.body.classList.remove("q-body--layout-animate"),e.timer=void 0}),150)},__onPageScroll:function(e){!0!==this.container&&!0===document.qScrollPrevented||(this.scroll=e),void 0!==this.qListeners.scroll&&this.$emit("scroll",e)},__onPageResize:function(e){var t=e.height,n=e.width,i=!1;this.height!==t&&(i=!0,this.height=t,void 0!==this.qListeners["scroll-height"]&&this.$emit("scroll-height",t),this.__updateScrollbarWidth()),this.width!==n&&(i=!0,this.width=n),!0===i&&void 0!==this.qListeners.resize&&this.$emit("resize",{height:t,width:n})},__onContainerResize:function(e){var t=e.height;this.containerHeight!==t&&(this.containerHeight=t,this.__updateScrollbarWidth())},__updateScrollbarWidth:function(){if(!0===this.container){var e=this.height>this.containerHeight?Yt():0;this.scrollbarWidth!==e&&(this.scrollbarWidth=e)}}}}),Ko=e.extend({name:"QMarkupTable",mixins:[je,Pe],props:{dense:Boolean,flat:Boolean,bordered:Boolean,square:Boolean,separator:{type:String,default:"horizontal",validator:function(e){return["horizontal","vertical","cell","none"].includes(e)}},wrapCells:Boolean},computed:{classes:function(){return"q-table--"+this.separator+"-separator"+(!0===this.isDark?" q-table--dark q-table__card--dark q-dark":"")+(!0===this.dense?" q-table--dense":"")+(!0===this.flat?" q-table--flat":"")+(!0===this.bordered?" q-table--bordered":"")+(!0===this.square?" q-table--square":"")+(!1===this.wrapCells?" q-table--no-wrap":"")}},render:function(e){return e("div",{staticClass:"q-markup-table q-table__container q-table__card",class:this.classes,on:Object.assign({},this.qListeners)},[e("table",{staticClass:"q-table"},Le(this,"default"))])}}),Zo=e.extend({name:"QNoSsr",mixins:[ti,Ae,Pe],props:{placeholder:String},render:function(e){var t={on:Object.assign({},this.qListeners)};if(!0===this.canRender){var n=Le(this,"default");return void 0===n?n:n.length>1?e(this.tag,t,n):n[0]}t.staticClass="q-no-ssr-placeholder";var i=Le(this,"placeholder");return void 0!==i?i.length>1?e(this.tag,t,i):i[0]:void 0!==this.placeholder?e(this.tag,t,[this.placeholder]):void 0}}),Jo=e.extend({name:"QRadio",mixins:[je,On,ln,qn],props:{value:{required:!0},val:{required:!0},label:String,leftLabel:Boolean,color:String,keepColor:Boolean,dense:Boolean,disable:Boolean,tabindex:[String,Number]},computed:{isTrue:function(){return this.value===this.val},classes:function(){return"q-radio cursor-pointer no-outline row inline no-wrap items-center"+(!0===this.disable?" disabled":"")+(!0===this.isDark?" q-radio--dark":"")+(!0===this.dense?" q-radio--dense":"")+(!0===this.leftLabel?" reverse":"")},innerClass:function(){var e=void 0===this.color||!0!==this.keepColor&&!0!==this.isTrue?"":" text-"+this.color;return"q-radio__inner--"+(!0===this.isTrue?"truthy":"falsy")+e},computedTabindex:function(){return!0===this.disable?-1:this.tabindex||0},formAttrs:function(){var e={type:"radio"};return void 0!==this.name&&Object.assign(e,{name:this.name,value:this.val}),e},formDomProps:function(){if(void 0!==this.name&&!0===this.isTrue)return{checked:!0}},attrs:function(){var e={tabindex:this.computedTabindex,role:"radio","aria-label":this.label,"aria-checked":!0===this.isTrue?"true":"false"};return!0===this.disable&&(e["aria-disabled"]="true"),e}},methods:{set:function(e){void 0!==e&&(w(e),this.__refocusTarget(e)),!0!==this.disable&&!0!==this.isTrue&&this.$emit("input",this.val,e)}},render:function(e){var t=this,n=[e("svg",{staticClass:"q-radio__bg absolute",attrs:{focusable:"false",viewBox:"0 0 24 24","aria-hidden":"true"}},[e("path",{attrs:{d:"M12,22a10,10 0 0 1 -10,-10a10,10 0 0 1 10,-10a10,10 0 0 1 10,10a10,10 0 0 1 -10,10m0,-22a12,12 0 0 0 -12,12a12,12 0 0 0 12,12a12,12 0 0 0 12,-12a12,12 0 0 0 -12,-12"}}),e("path",{staticClass:"q-radio__check",attrs:{d:"M12,6a6,6 0 0 0 -6,6a6,6 0 0 0 6,6a6,6 0 0 0 6,-6a6,6 0 0 0 -6,-6"}})])];!0!==this.disable&&this.__injectFormInput(n,"unshift","q-radio__native q-ma-none q-pa-none invisible");var i=[e("div",{staticClass:"q-radio__inner relative-position no-pointer-events",class:this.innerClass,style:this.sizeStyle},n)];void 0!==this.__refocusTargetEl&&i.push(this.__refocusTargetEl);var r=void 0!==this.label?qe([this.label],this,"default"):Le(this,"default");return void 0!==r&&i.push(e("div",{staticClass:"q-radio__label q-anchor--skip"},r)),e("div",{class:this.classes,attrs:this.attrs,on:pe(this,"inpExt",{click:this.set,keydown:function(e){13!==e.keyCode&&32!==e.keyCode||w(e)},keyup:function(e){13!==e.keyCode&&32!==e.keyCode||t.set(e)}})},i)}}),Xo=e.extend({name:"QToggle",mixins:[En],props:{icon:String,checkedIcon:String,uncheckedIcon:String,indeterminateIcon:String,iconColor:String},computed:{computedIcon:function(){return(!0===this.isTrue?this.checkedIcon:!0===this.isIndeterminate?this.indeterminateIcon:this.uncheckedIcon)||this.icon},computedIconColor:function(){if(!0===this.isTrue)return this.iconColor}},methods:{__getInner:function(e){return[e("div",{staticClass:"q-toggle__track"}),e("div",{staticClass:"q-toggle__thumb absolute flex flex-center no-wrap"},void 0!==this.computedIcon?[e(De,{props:{name:this.computedIcon,color:this.computedIconColor}})]:void 0)]}},created:function(){this.type="toggle"}}),ea={radio:Jo,checkbox:Dn,toggle:Xo},ta=Object.keys(ea),na=e.extend({name:"QOptionGroup",mixins:[je,Pe],props:{value:{required:!0},options:{type:Array,validator:function(e){return e.every((function(e){return"value"in e&&"label"in e}))}},name:String,type:{default:"radio",validator:function(e){return ta.includes(e)}},color:String,keepColor:Boolean,dense:Boolean,size:String,leftLabel:Boolean,inline:Boolean,disable:Boolean},computed:{component:function(){return ea[this.type]},model:function(){return Array.isArray(this.value)?this.value.slice():this.value},classes:function(){return"q-option-group q-gutter-x-sm"+(!0===this.inline?" q-option-group--inline":"")},attrs:function(){if("radio"===this.type){var e={role:"radiogroup"};return!0===this.disable&&(e["aria-disabled"]="true"),e}}},methods:{__update:function(e){this.$emit("input",e)}},created:function(){var e=Array.isArray(this.value);"radio"===this.type?e&&console.error("q-option-group: model should not be array"):!1===e&&console.error("q-option-group: model should be array in your case")},render:function(e){var t=this;return e("div",{class:this.classes,attrs:this.attrs,on:Object.assign({},this.qListeners)},this.options.map((function(n){return e("div",[e(t.component,{props:{value:t.value,val:n.value,name:t.name||n.name,disable:t.disable||n.disable,label:n.label,leftLabel:t.leftLabel||n.leftLabel,color:n.color||t.color,checkedIcon:n.checkedIcon,uncheckedIcon:n.uncheckedIcon,dark:n.dark||t.isDark,size:n.size||t.size,dense:t.dense,keepColor:n.keepColor||t.keepColor},on:pe(t,"inp",{input:t.__update})})])})))}}),ia=e.extend({name:"QPage",mixins:[Pe],inject:{pageContainer:{default:function(){console.error("QPage needs to be child of QPageContainer")}},layout:{}},props:{padding:Boolean,styleFn:Function},computed:{style:function(){var e=(!0===this.layout.header.space?this.layout.header.size:0)+(!0===this.layout.footer.space?this.layout.footer.size:0);if("function"==typeof this.styleFn){var t=!0===this.layout.container?this.layout.containerHeight:this.$q.screen.height;return this.styleFn(e,t)}return{minHeight:!0===this.layout.container?this.layout.containerHeight-e+"px":0===this.$q.screen.height?"calc(100vh - "+e+"px)":this.$q.screen.height-e+"px"}},classes:function(){if(!0===this.padding)return"q-layout-padding"}},render:function(e){return e("main",{staticClass:"q-page",style:this.style,class:this.classes,on:Object.assign({},this.qListeners)},Le(this,"default"))}}),ra=e.extend({name:"QPageContainer",mixins:[Pe],inject:{layout:{default:function(){console.error("QPageContainer needs to be child of QLayout")}}},provide:{pageContainer:!0},computed:{style:function(){var e={};return!0===this.layout.header.space&&(e.paddingTop=this.layout.header.size+"px"),!0===this.layout.right.space&&(e["padding"+(!0===this.$q.lang.rtl?"Left":"Right")]=this.layout.right.size+"px"),!0===this.layout.footer.space&&(e.paddingBottom=this.layout.footer.size+"px"),!0===this.layout.left.space&&(e["padding"+(!0===this.$q.lang.rtl?"Right":"Left")]=this.layout.left.size+"px"),e}},render:function(e){return e("div",{staticClass:"q-page-container",style:this.style,on:Object.assign({},this.qListeners)},Le(this,"default"))}}),oa=e.extend({name:"QPageSticky",mixins:[Pe],inject:{layout:{default:function(){console.error("QPageSticky needs to be child of QLayout")}}},props:{position:{type:String,default:"bottom-right",validator:function(e){return["top-right","top-left","bottom-right","bottom-left","top","right","bottom","left"].includes(e)}},offset:{type:Array,validator:function(e){return 2===e.length}},expand:Boolean},computed:{attach:function(){var e=this.position;return{top:e.indexOf("top")>-1,right:e.indexOf("right")>-1,bottom:e.indexOf("bottom")>-1,left:e.indexOf("left")>-1,vertical:"top"===e||"bottom"===e,horizontal:"left"===e||"right"===e}},top:function(){return this.layout.header.offset},right:function(){return this.layout.right.offset},bottom:function(){return this.layout.footer.offset},left:function(){return this.layout.left.offset},style:function(){var e=0,t=0,n=this.attach,i=!0===this.$q.lang.rtl?-1:1;!0===n.top&&0!==this.top?t=this.top+"px":!0===n.bottom&&0!==this.bottom&&(t=-this.bottom+"px"),!0===n.left&&0!==this.left?e=i*this.left+"px":!0===n.right&&0!==this.right&&(e=-i*this.right+"px");var r={transform:"translate("+e+", "+t+")"};return this.offset&&(r.margin=this.offset[1]+"px "+this.offset[0]+"px"),!0===n.vertical?(0!==this.left&&(r[!0===this.$q.lang.rtl?"right":"left"]=this.left+"px"),0!==this.right&&(r[!0===this.$q.lang.rtl?"left":"right"]=this.right+"px")):!0===n.horizontal&&(0!==this.top&&(r.top=this.top+"px"),0!==this.bottom&&(r.bottom=this.bottom+"px")),r},classes:function(){return"fixed-"+this.position+" q-page-sticky--"+(!0===this.expand?"expand":"shrink")}},render:function(e){var t=Le(this,"default");return e("div",{staticClass:"q-page-sticky row flex-center",class:this.classes,style:this.style,on:Object.assign({},this.qListeners)},!0===this.expand?t:[e("div",t)])}}),aa=e.extend({name:"QPageScroller",mixins:[oa],props:{scrollOffset:{type:Number,default:1e3},reverse:Boolean,duration:{type:Number,default:300},offset:{default:function(){return[18,18]}}},inject:{layout:{default:function(){console.error("QPageScroller needs to be used within a QLayout")}}},data:function(){return{showing:this.__isVisible()}},computed:{height:function(){return!0===this.layout.container?this.layout.containerHeight:this.layout.height},onEvents:function(){return Object.assign({},this.qListeners,{click:this.__onClick})}},watch:{"layout.scroll.position":function(){this.__updateVisibility()},reverse:{handler:function(e){!0===e?void 0===this.heightWatcher&&(this.heightWatcher=this.$watch("height",this.__updateVisibility)):void 0!==this.heightWatcher&&this.__cleanup()},immediate:!0}},methods:{__isVisible:function(){return!0===this.reverse?this.height-this.layout.scroll.position>this.scrollOffset:this.layout.scroll.position>this.scrollOffset},__onClick:function(e){Wt(!0===this.layout.container?jt(this.$el):jt(this.layout.$el),!0===this.reverse?this.layout.height:0,this.duration),this.$emit("click",e)},__updateVisibility:function(){var e=this.__isVisible();this.showing!==e&&(this.showing=e)},__cleanup:function(){this.heightWatcher(),this.heightWatcher=void 0}},render:function(e){return e("transition",{props:{name:"q-transition--fade"}},!0===this.showing?[e("div",{staticClass:"q-page-scroller",on:this.onEvents},[oa.options.render.call(this,e)])]:null)},beforeDestroy:function(){void 0!==this.heightWatcher&&this.__cleanup()}}),sa=e.extend({name:"QPagination",mixins:[je,Pe],props:{value:{type:Number,required:!0},min:{type:Number,default:1},max:{type:Number,required:!0},color:{type:String,default:"primary"},textColor:String,inputStyle:[Array,String,Object],inputClass:[Array,String,Object],size:String,disable:Boolean,input:Boolean,iconPrev:String,iconNext:String,iconFirst:String,iconLast:String,toFn:Function,boundaryLinks:{type:Boolean,default:null},boundaryNumbers:{type:Boolean,default:null},directionLinks:{type:Boolean,default:null},ellipses:{type:Boolean,default:null},maxPages:{type:Number,default:0,validator:function(e){return e>=0}},ripple:{type:[Boolean,Object],default:null}},data:function(){return{newPage:null}},watch:{min:function(){this.model=this.value},max:function(){this.model=this.value}},computed:{model:{get:function(){return this.value},set:function(e){if(e=parseInt(e,10),!this.disable&&!isNaN(e)&&0!==e){var t=ue(e,this.min,this.max);this.$emit("input",t)}}},inputPlaceholder:function(){return this.model+" / "+this.max},__boundaryLinks:function(){return this.__getBool(this.boundaryLinks,this.input)},__boundaryNumbers:function(){return this.__getBool(this.boundaryNumbers,!this.input)},__directionLinks:function(){return this.__getBool(this.directionLinks,this.input)},__ellipses:function(){return this.__getBool(this.ellipses,!this.input)},icons:function(){var e=[this.iconFirst||this.$q.iconSet.pagination.first,this.iconPrev||this.$q.iconSet.pagination.prev,this.iconNext||this.$q.iconSet.pagination.next,this.iconLast||this.$q.iconSet.pagination.last];return!0===this.$q.lang.rtl?e.reverse():e},attrs:function(){if(!0===this.disable)return{"aria-disabled":"true"}},btnProps:function(){return{color:this.color,flat:!0,size:this.size,ripple:null===this.ripple||this.ripple}}},methods:{set:function(e){this.model=e},setByOffset:function(e){this.model=this.model+e},__update:function(){this.model=this.newPage,this.newPage=null},__getBool:function(e,t){return[!0,!1].includes(e)?e:t},__getBtn:function(e,t,n,i){var r=this;return t.props=Object.assign({},this.btnProps,n),void 0!==i&&(void 0!==this.toFn?t.props.to=this.toFn(i):t.on={click:function(){return r.set(i)}}),e(bt,t)}},render:function(e){var t=this,n=[],i=[],r=[];if(this.__boundaryLinks&&(n.push(this.__getBtn(e,{key:"bls"},{disable:this.disable||this.value<=this.min,icon:this.icons[0]},this.min)),i.unshift(this.__getBtn(e,{key:"ble"},{disable:this.disable||this.value>=this.max,icon:this.icons[3]},this.max))),this.__directionLinks&&(n.push(this.__getBtn(e,{key:"bdp"},{disable:this.disable||this.value<=this.min,icon:this.icons[1]},this.value-1)),i.unshift(this.__getBtn(e,{key:"bdn"},{disable:this.disable||this.value>=this.max,icon:this.icons[2]},this.value+1))),!0===this.input)r.push(e(Gr,{staticClass:"inline",style:{width:this.inputPlaceholder.length/1.5+"em"},props:{type:"number",dense:!0,value:this.newPage,disable:this.disable,dark:this.isDark,borderless:!0,inputClass:this.inputClass,inputStyle:this.inputStyle},attrs:{placeholder:this.inputPlaceholder,min:this.min,max:this.max},on:pe(this,"inp",{input:function(e){t.newPage=e},keyup:function(e){!0===X(e,13)&&t.__update()},blur:this.__update})}));else{var o=Math.max(this.maxPages,1+(this.__ellipses?2:0)+(this.__boundaryNumbers?2:0)),a=this.min,s=this.max,l=!1,c=!1,u=!1,d=!1;this.maxPages&&o<this.max-this.min+1&&(o=1+2*Math.floor(o/2),a=Math.max(this.min,Math.min(this.max-o+1,this.value-Math.floor(o/2))),s=Math.min(this.max,a+o-1),this.__boundaryNumbers&&(u=!0,a+=1),this.__ellipses&&a>this.min+(this.__boundaryNumbers?1:0)&&(l=!0,a+=1),this.__boundaryNumbers&&(d=!0,s-=1),this.__ellipses&&s<this.max-(this.__boundaryNumbers?1:0)&&(c=!0,s-=1));var h={minWidth:Math.max(2,String(this.max).length)+"em"};if(u){var f=this.min===this.value;n.push(this.__getBtn(e,{key:"bns",style:h},{disable:this.disable,flat:!f,textColor:f?this.textColor:null,label:this.min},this.min))}if(d){var p=this.max===this.value;i.unshift(this.__getBtn(e,{key:"bne",style:h},{disable:this.disable,flat:!p,textColor:p?this.textColor:null,label:this.max},this.max))}l&&n.push(this.__getBtn(e,{key:"bes",style:h},{disable:this.disable,label:"…",ripple:!1},a-1)),c&&i.unshift(this.__getBtn(e,{key:"bee",style:h},{disable:this.disable,label:"…",ripple:!1},s+1));for(var m=a;m<=s;m++){var v=m===this.value;r.push(this.__getBtn(e,{key:"bpg"+m,style:h},{disable:this.disable,flat:!v,textColor:v?this.textColor:null,label:m},m))}}return e("div",{staticClass:"q-pagination row no-wrap items-center",class:{disabled:this.disable},attrs:this.attrs,on:Object.assign({},this.qListeners)},[n,e("div",{staticClass:"row justify-center",on:!0===this.input?pe(this,"stop",{input:b}):null},[r]),i])}});function la(e){var t,n,i=!1;function r(){var r=this;n=arguments,!0!==i&&(i=!0,t=requestAnimationFrame((function(){e.apply(r,n),n=void 0,i=!1})))}return r.cancel=function(){window.cancelAnimationFrame(t),i=!1},r}var ca=f.passive,ua=e.extend({name:"QParallax",mixins:[Pe],props:{src:String,height:{type:Number,default:500},speed:{type:Number,default:1,validator:function(e){return e>=0&&e<=1}},scrollTarget:{default:void 0}},data:function(){return{scrolling:!1,percentScrolled:0}},watch:{height:function(){!0===this.working&&this.__updatePos()},scrollTarget:function(){!0===this.working&&(this.__stop(),this.__start())}},methods:{__update:function(e){this.percentScrolled=e,void 0!==this.qListeners.scroll&&this.$emit("scroll",e)},__updatePos:function(){var e,t,n;this.__scrollTarget===window?(e=0,n=t=window.innerHeight):n=(e=Ke(this.__scrollTarget).top)+(t=Ze(this.__scrollTarget));var i=Ke(this.$el).top,r=i+this.height;if(void 0!==this.observer||r>e&&i<n){var o=(n-i)/(this.height+t);this.__setPos((this.mediaHeight-this.height)*o*this.speed),this.__update(o)}},__setPos:function(e){this.media.style.transform="translate3D(-50%,"+Math.round(e)+"px, 0)"},__onResize:function(){this.mediaHeight=this.media.naturalHeight||this.media.videoHeight||Ze(this.media),!0===this.working&&this.__updatePos()},__start:function(){this.working=!0,this.__scrollTarget=jt(this.$el,this.scrollTarget),this.__scrollTarget.addEventListener("scroll",this.__updatePos,ca),window.addEventListener("resize",this.__resizeHandler,ca),this.__updatePos()},__stop:function(){!0===this.working&&(this.working=!1,this.__scrollTarget.removeEventListener("scroll",this.__updatePos,ca),window.removeEventListener("resize",this.__resizeHandler,ca),this.__scrollTarget=void 0)}},render:function(e){return e("div",{staticClass:"q-parallax",style:{height:this.height+"px"},on:Object.assign({},this.qListeners)},[e("div",{ref:"mediaParent",staticClass:"q-parallax__media absolute-full"},void 0!==this.$scopedSlots.media?this.$scopedSlots.media():[e("img",{ref:"media",attrs:{src:this.src}})]),e("div",{staticClass:"q-parallax__content absolute-full column flex-center"},void 0!==this.$scopedSlots.content?this.$scopedSlots.content({percentScrolled:this.percentScrolled}):Le(this,"default"))])},mounted:function(){var e=this;this.__setPos=la(this.__setPos),this.__update=la(this.__update),this.__resizeHandler=la(this.__onResize),this.media=void 0!==this.$scopedSlots.media?this.$refs.mediaParent.children[0]:this.$refs.media,this.media.onload=this.media.onloadstart=this.media.loadedmetadata=this.__onResize,this.__onResize(),this.media.style.display="initial",void 0!==window.IntersectionObserver?(this.observer=new IntersectionObserver((function(t){e[!0===t[0].isIntersecting?"__start":"__stop"]()})),this.observer.observe(this.$el)):this.__start()},beforeDestroy:function(){this.__stop(),void 0!==this.observer&&this.observer.disconnect(),this.media.onload=this.media.onloadstart=this.media.loadedmetadata=null}});function da(e){var t=JSON.stringify(e);if(t)return JSON.parse(t)}var ha=e.extend({name:"QPopupEdit",mixins:[_e],props:{value:{required:!0},title:String,buttons:Boolean,labelSet:String,labelCancel:String,color:{type:String,default:"primary"},validate:{type:Function,default:function(){return!0}},autoSave:Boolean,cover:{type:Boolean,default:!0},contentClass:String,disable:Boolean},data:function(){return{initialValue:""}},computed:{classes:function(){return"q-popup-edit"+(void 0!==this.contentClass?" "+this.contentClass:"")},defaultSlotScope:function(){return{initialValue:this.initialValue,value:this.value,emitValue:this.__emitValue,validate:this.validate,set:this.set,cancel:this.cancel}},menuProps:function(){return Object.assign({},this.qAttrs,{cover:this.cover,contentClass:this.classes})}},methods:{set:function(){if(!0===this.__hasChanged()){if(!1===this.validate(this.value))return;this.$emit("save",this.value,this.initialValue)}this.__close()},cancel:function(){!0===this.__hasChanged()&&(this.$emit("input",this.initialValue),this.$emit("cancel",this.value,this.initialValue)),this.__close()},show:function(e){void 0!==this.$refs.menu&&this.$refs.menu.show(e)},hide:function(e){void 0!==this.$refs.menu&&this.$refs.menu.hide(e)},__hasChanged:function(){return!1===Sn(this.value,this.initialValue)},__emitValue:function(e){!0!==this.disable&&this.$emit("input",e)},__close:function(){this.validated=!0,!0===this.$refs.menu.showing&&this.$refs.menu.hide()},__reposition:function(){var e=this;this.$nextTick((function(){e.$refs.menu.updatePosition()}))},__getContent:function(e){var t=Le(this,"title",this.title),n=void 0===this.$scopedSlots.default?[]:this.$scopedSlots.default(this.defaultSlotScope).slice();return t&&n.unshift(e("div",{staticClass:"q-dialog__title q-mt-sm q-mb-sm"},[t])),!0===this.buttons&&n.push(e("div",{staticClass:"q-popup-edit__buttons row justify-center no-wrap"},[e(bt,{props:{flat:!0,color:this.color,label:this.labelCancel||this.$q.lang.label.cancel},on:pe(this,"cancel",{click:this.cancel})}),e(bt,{props:{flat:!0,color:this.color,label:this.labelSet||this.$q.lang.label.set},on:pe(this,"ok",{click:this.set})})])),n}},render:function(e){var t=this;if(!0!==this.disable)return e(an,{ref:"menu",props:this.menuProps,on:pe(this,"menu",{"before-show":function(){t.validated=!1,t.initialValue=da(t.value),t.watcher=t.$watch("value",t.__reposition),t.$emit("before-show")},show:function(){t.$emit("show")},"escape-key":this.cancel,"before-hide":function(){t.watcher(),!1===t.validated&&!0===t.__hasChanged()&&(!0===t.autoSave&&!0===t.validate(t.value)?t.$emit("save",t.value,t.initialValue):(t.$emit("cancel",t.value,t.initialValue),t.$emit("input",t.initialValue))),t.$emit("before-hide")},hide:function(){t.$emit("hide")},keyup:function(e){!0===X(e,13)&&t.set()}})},this.__getContent(e))}}),fa=e.extend({name:"QPopupProxy",mixins:[_e,Pe,kt],props:{breakpoint:{type:[String,Number],default:450}},data:function(){var e=parseInt(this.breakpoint,10);return{type:this.$q.screen.width<e||this.$q.screen.height<e?"dialog":"menu"}},computed:{parsedBreakpoint:function(){return parseInt(this.breakpoint,10)},onEvents:function(){return Object.assign({},this.qListeners,{hide:this.__onHide})}},watch:{"$q.screen.width":function(e){!0!==this.$refs.popup.showing&&this.__updateType(e,this.$q.screen.height,this.parsedBreakpoint)},"$q.screen.height":function(e){!0!==this.$refs.popup.showing&&this.__updateType(this.$q.screen.width,e,this.parsedBreakpoint)},breakpoint:function(e){!0!==this.$refs.popup.showing&&this.__updateType(this.$q.screen.width,this.$q.screen.height,parseInt(e,10))}},methods:{toggle:function(e){this.$refs.popup.toggle(e)},show:function(e){this.$refs.popup.show(e)},hide:function(e){this.$refs.popup.hide(e)},__onHide:function(e){this.__updateType(this.$q.screen.width,this.$q.screen.height,this.parsedBreakpoint),this.$emit("hide",e)},__updateType:function(e,t,n){var i=e<n||t<n?"dialog":"menu";this.type!==i&&(this.type=i)}},render:function(e){var t,n=Le(this,"default"),i="menu"===this.type&&void 0!==n&&void 0!==n[0]&&void 0!==n[0].componentOptions&&void 0!==n[0].componentOptions.Ctor&&void 0!==n[0].componentOptions.Ctor.sealedOptions&&["QDate","QTime","QCarousel","QColor"].includes(n[0].componentOptions.Ctor.sealedOptions.name)?{cover:!0,maxHeight:"99vh"}:{},r={ref:"popup",props:Object.assign({},i,this.qAttrs),on:this.onEvents};return"dialog"===this.type?t=wr:(t=an,r.props.target=this.target,r.props.contextMenu=this.contextMenu,r.props.noParentEvent=!0,r.props.separateClosePopup=!0),e(t,r,n)}});function pa(e,t){return!0===t?{transform:"translateX(100%) scale3d("+-e+",1,1)"}:{transform:"scale3d("+e+",1,1)"}}var ma=e.extend({name:"QLinearProgress",mixins:[Pe,je,Me({xs:2,sm:4,md:6,lg:10,xl:14})],props:{value:{type:Number,default:0},buffer:Number,color:String,trackColor:String,reverse:Boolean,stripe:Boolean,indeterminate:Boolean,query:Boolean,rounded:Boolean,instantFeedback:Boolean},computed:{motion:function(){return!0===this.indeterminate||!0===this.query},classes:function(){return"q-linear-progress"+(void 0!==this.color?" text-"+this.color:"")+(!0===this.reverse||!0===this.query?" q-linear-progress--reverse":"")+(!0===this.rounded?" rounded-borders":"")},trackStyle:function(){return pa(void 0!==this.buffer?this.buffer:1,this.reverse)},trackClass:function(){return"q-linear-progress__track--with"+(!0===this.instantFeedback?"out":"")+"-transition q-linear-progress__track--"+(!0===this.isDark?"dark":"light")+(void 0!==this.trackColor?" bg-"+this.trackColor:"")},modelStyle:function(){return pa(!0===this.motion?1:this.value,this.reverse)},modelClasses:function(){return"q-linear-progress__model--with"+(!0===this.instantFeedback?"out":"")+"-transition q-linear-progress__model--"+(!0===this.motion?"in":"")+"determinate"},stripeStyle:function(){return{width:100*this.value+"%"}},attrs:function(){return{role:"progressbar","aria-valuemin":0,"aria-valuemax":1,"aria-valuenow":!0===this.indeterminate?void 0:this.value}}},render:function(e){var t=[e("div",{staticClass:"q-linear-progress__track absolute-full",style:this.trackStyle,class:this.trackClass}),e("div",{staticClass:"q-linear-progress__model absolute-full",style:this.modelStyle,class:this.modelClasses})];return!0===this.stripe&&!1===this.motion&&t.push(e("div",{staticClass:"q-linear-progress__stripe absolute-full",style:this.stripeStyle})),e("div",{style:this.sizeStyle,class:this.classes,attrs:this.attrs,on:Object.assign({},this.qListeners)},qe(t,this,"default"))}}),va=40,ga=e.extend({name:"QPullToRefresh",mixins:[Pe],directives:{TouchPan:Qn},props:{color:String,bgColor:String,icon:String,noMouse:Boolean,disable:Boolean,scrollTarget:{default:void 0}},data:function(){return{state:"pull",pullRatio:0,pulling:!1,pullPosition:-40,animating:!1,positionCSS:{}}},computed:{style:function(){return{opacity:this.pullRatio,transform:"translateY("+this.pullPosition+"px) rotate("+360*this.pullRatio+"deg)"}},classes:function(){return"q-pull-to-refresh__puller row flex-center"+(!0===this.animating?" q-pull-to-refresh__puller--animating":"")+(void 0!==this.bgColor?" bg-"+this.bgColor:"")},directives:function(){if(!0!==this.disable){var e={down:!0,mightPrevent:!0};return!0!==this.noMouse&&(e.mouse=!0),[{name:"touch-pan",modifiers:e,value:this.__pull}]}},contentClass:function(){return"q-pull-to-refresh__content"+(!0===this.pulling?" no-pointer-events":"")}},watch:{scrollTarget:function(){this.updateScrollTarget()}},methods:{trigger:function(){var e=this;this.$emit("refresh",(function(){e.__animateTo({pos:-40,ratio:0},(function(){e.state="pull"}))}))},updateScrollTarget:function(){this.__scrollTarget=jt(this.$el,this.scrollTarget)},__pull:function(e){if(!0!==e.isFinal){if(!0===this.animating||"refreshing"===this.state)return!1;if(!0===e.isFirst){if(0!==It(this.__scrollTarget))return!0===this.pulling&&(this.pulling=!1,this.state="pull",this.__animateTo({pos:-40,ratio:0})),!1;this.pulling=!0;var t=this.$el.getBoundingClientRect(),n=t.top,i=t.left;this.positionCSS={top:n+"px",left:i+"px",width:window.getComputedStyle(this.$el).getPropertyValue("width")}}y(e.evt);var r=Math.min(140,Math.max(0,e.distance.y));this.pullPosition=r-va,this.pullRatio=ue(r/60,0,1);var o=this.pullPosition>20?"pulled":"pull";this.state!==o&&(this.state=o)}else!0===this.pulling&&(this.pulling=!1,"pulled"===this.state?(this.state="refreshing",this.__animateTo({pos:20}),this.trigger()):"pull"===this.state&&this.__animateTo({pos:-40,ratio:0}))},__animateTo:function(e,t){var n=this,i=e.pos,r=e.ratio;this.animating=!0,this.pullPosition=i,void 0!==r&&(this.pullRatio=r),clearTimeout(this.timer),this.timer=setTimeout((function(){n.animating=!1,t&&t()}),300)}},mounted:function(){this.updateScrollTarget()},beforeDestroy:function(){clearTimeout(this.timer)},render:function(e){return e("div",{staticClass:"q-pull-to-refresh",on:Object.assign({},this.qListeners),directives:this.directives},[e("div",{class:this.contentClass},Le(this,"default")),e("div",{staticClass:"q-pull-to-refresh__puller-container fixed row flex-center no-pointer-events z-top",style:this.positionCSS},[e("div",{style:this.style,class:this.classes},["refreshing"!==this.state?e(De,{props:{name:this.icon||this.$q.iconSet.pullToRefresh.icon,color:this.color,size:"32px"}}):e(Qe,{props:{size:"24px",color:this.color}})])])])}}),_a=0,ba=1,ya=2,wa=e.extend({name:"QRange",mixins:[Xn],props:{value:{type:Object,default:function(){return{min:null,max:null}},validator:function(e){return"min"in e&&"max"in e}},name:String,dragRange:Boolean,dragOnlyRange:Boolean,leftLabelColor:String,leftLabelTextColor:String,rightLabelColor:String,rightLabelTextColor:String,leftLabelValue:[String,Number],rightLabelValue:[String,Number]},data:function(){return{model:{min:null===this.value.min?this.min:this.value.min,max:null===this.value.max?this.max:this.value.max},curMinRatio:0,curMaxRatio:0}},watch:{"value.min":function(e){this.model.min=null===e?this.min:e},"value.max":function(e){this.model.max=null===e?this.max:e},min:function(e){this.model.min<e&&(this.model.min=e),this.model.max<e&&(this.model.max=e)},max:function(e){this.model.min>e&&(this.model.min=e),this.model.max>e&&(this.model.max=e)}},computed:{ratioMin:function(){return!0===this.active?this.curMinRatio:this.modelMinRatio},ratioMax:function(){return!0===this.active?this.curMaxRatio:this.modelMaxRatio},modelMinRatio:function(){return(this.model.min-this.min)/(this.max-this.min)},modelMaxRatio:function(){return(this.model.max-this.min)/(this.max-this.min)},trackStyle:function(){var e;return(e={})[this.positionProp]=100*this.ratioMin+"%",e[this.sizeProp]=100*(this.ratioMax-this.ratioMin)+"%",e},minThumbStyle:function(){var e;return(e={})[this.positionProp]=100*this.ratioMin+"%",e["z-index"]="min"===this.__nextFocus?2:void 0,e},maxThumbStyle:function(){var e;return(e={})[this.positionProp]=100*this.ratioMax+"%",e},minThumbClass:function(){if(!1===this.preventFocus&&"min"===this.focus)return"q-slider--focus"},maxThumbClass:function(){if(!1===this.preventFocus&&"max"===this.focus)return"q-slider--focus"},events:function(){var e=this;if(!0===this.editable){if(!0===this.$q.platform.is.mobile)return{click:this.__mobileClick};var t={mousedown:this.__activate};return!0===this.dragOnlyRange&&Object.assign(t,{focus:function(){e.__focus("both")},blur:this.__blur,keydown:this.__keydown,keyup:this.__keyup}),t}},minEvents:function(){var e=this;if(!0===this.editable&&!0!==this.$q.platform.is.mobile&&!0!==this.dragOnlyRange)return{focus:function(){e.__focus("min")},blur:this.__blur,keydown:this.__keydown,keyup:this.__keyup}},maxEvents:function(){var e=this;if(!0===this.editable&&!0!==this.$q.platform.is.mobile&&!0!==this.dragOnlyRange)return{focus:function(){e.__focus("max")},blur:this.__blur,keydown:this.__keydown,keyup:this.__keyup}},minPinClass:function(){var e=this.leftLabelColor||this.labelColor;if(e)return"text-"+e},minPinTextClass:function(){var e=this.leftLabelTextColor||this.labelTextColor;if(e)return"text-"+e},maxPinClass:function(){var e=this.rightLabelColor||this.labelColor;if(e)return"text-"+e},maxPinTextClass:function(){var e=this.rightLabelTextColor||this.labelTextColor;if(e)return"text-"+e},minLabel:function(){return void 0!==this.leftLabelValue?this.leftLabelValue:this.model.min},maxLabel:function(){return void 0!==this.rightLabelValue?this.rightLabelValue:this.model.max},minPinStyle:function(){var e=!0===this.reverse?-this.ratioMin:this.ratioMin-1;return this.__getPinStyle(e,this.ratioMin)},maxPinStyle:function(){var e=!0===this.reverse?-this.ratioMax:this.ratioMax-1;return this.__getPinStyle(e,this.ratioMax)},formAttrs:function(){return{type:"hidden",name:this.name,value:this.value.min+"|"+this.value.max}}},methods:{__updateValue:function(e){this.model.min===this.value.min&&this.model.max===this.value.max||this.$emit("input",this.model),!0===e&&this.$emit("change",this.model)},__getDragging:function(e){var t,n=this.$el.getBoundingClientRect(),i=n.left,r=n.top,o=n.width,a=n.height,s=!0===this.dragOnlyRange?0:!0===this.vertical?this.$refs.minThumb.offsetHeight/(2*a):this.$refs.minThumb.offsetWidth/(2*o),l=this.max-this.min,c={left:i,top:r,width:o,height:a,valueMin:this.model.min,valueMax:this.model.max,ratioMin:(this.model.min-this.min)/l,ratioMax:(this.model.max-this.min)/l},u=Zn(e,c,this.isReversed,this.vertical);return!0!==this.dragOnlyRange&&u<c.ratioMin+s?t=_a:!0===this.dragOnlyRange||u<c.ratioMax-s?!0===this.dragRange||!0===this.dragOnlyRange?(t=ba,Object.assign(c,{offsetRatio:u,offsetModel:Jn(u,this.min,this.max,this.step,this.decimals),rangeValue:c.valueMax-c.valueMin,rangeRatio:c.ratioMax-c.ratioMin})):t=c.ratioMax-u<u-c.ratioMin?ya:_a:t=ya,c.type=t,this.__nextFocus=void 0,c},__updatePosition:function(e,t){void 0===t&&(t=this.dragging);var n,i=Zn(e,t,this.isReversed,this.vertical),r=Jn(i,this.min,this.max,this.step,this.decimals);switch(t.type){case _a:i<=t.ratioMax?(n={minR:i,maxR:t.ratioMax,min:r,max:t.valueMax},this.__nextFocus="min"):(n={minR:t.ratioMax,maxR:i,min:t.valueMax,max:r},this.__nextFocus="max");break;case ya:i>=t.ratioMin?(n={minR:t.ratioMin,maxR:i,min:t.valueMin,max:r},this.__nextFocus="max"):(n={minR:i,maxR:t.ratioMin,min:r,max:t.valueMin},this.__nextFocus="min");break;case ba:var o=i-t.offsetRatio,a=ue(t.ratioMin+o,0,1-t.rangeRatio),s=r-t.offsetModel,l=ue(t.valueMin+s,this.min,this.max-t.rangeValue);n={minR:a,maxR:a+t.rangeRatio,min:parseFloat(l.toFixed(this.decimals)),max:parseFloat((l+t.rangeValue).toFixed(this.decimals))}}if(this.model={min:n.min,max:n.max},null!==this.model.min&&null!==this.model.max||(this.model.min=n.min||this.min,this.model.max=n.max||this.max),!0!==this.snap||0===this.step)this.curMinRatio=n.minR,this.curMaxRatio=n.maxR;else{var c=this.max-this.min;this.curMinRatio=(this.model.min-this.min)/c,this.curMaxRatio=(this.model.max-this.min)/c}},__focus:function(e){this.focus=e},__keydown:function(e){var t;if(Kn.includes(e.keyCode)){w(e);var n=([34,33].includes(e.keyCode)?10:1)*this.computedStep,i=[34,37,40].includes(e.keyCode)?-n:n;if(this.dragOnlyRange){var r=this.dragOnlyRange?this.model.max-this.model.min:0,o=ue(parseFloat((this.model.min+i).toFixed(this.decimals)),this.min,this.max-r);this.model={min:o,max:parseFloat((o+r).toFixed(this.decimals))}}else{if(!1===this.focus)return;var a=this.focus;this.model=Object.assign({},this.model,((t={})[a]=ue(parseFloat((this.model[a]+i).toFixed(this.decimals)),"min"===a?this.min:this.model.min,"max"===a?this.max:this.model.max),t))}this.__updateValue()}},__getThumb:function(e,t){var n=[this.__getThumbSvg(e),e("div",{staticClass:"q-slider__focus-ring"})];return!0!==this.label&&!0!==this.labelAlways||n.push(e("div",{staticClass:"q-slider__pin q-slider__pin"+this.axis+" absolute",style:this[t+"PinStyle"].pin,class:this[t+"PinClass"]},[e("div",{staticClass:"q-slider__pin-text-container q-slider__pin-text-container"+this.axis,style:this[t+"PinStyle"].pinTextContainer},[e("span",{staticClass:"q-slider__pin-text",class:this[t+"PinTextClass"]},[this[t+"Label"]])])]),e("div",{staticClass:"q-slider__arrow q-slider__arrow"+this.axis,class:this[t+"PinClass"]})),e("div",{ref:t+"Thumb",staticClass:"q-slider__thumb-container q-slider__thumb-container"+this.axis+" absolute non-selectable",style:this[t+"ThumbStyle"],class:this[t+"ThumbClass"],on:this[t+"Events"],attrs:{tabindex:!0!==this.dragOnlyRange?this.computedTabindex:null}},n)}},render:function(e){var t=[e("div",{staticClass:"q-slider__track q-slider__track"+this.axis+" absolute",style:this.trackStyle})];!0===this.markers&&t.push(e("div",{staticClass:"q-slider__track-markers q-slider__track-markers"+this.axis+" absolute-full fit",style:this.markerStyle}));var n=[e("div",{staticClass:"q-slider__track-container q-slider__track-container"+this.axis+" absolute"},t),this.__getThumb(e,"min"),this.__getThumb(e,"max")];return void 0!==this.name&&!0!==this.disable&&this.__injectFormInput(n,"push"),e("div",{staticClass:null===this.value.min||null===this.value.max?"q-slider--no-value":void 0,attrs:Object.assign({},this.attrs,{"aria-valuenow":this.value.min+"|"+this.value.max,tabindex:!0===this.dragOnlyRange&&!0!==this.$q.platform.is.mobile?this.computedTabindex:null}),class:this.classes,on:this.events,directives:this.panDirectives},n)}}),ka=e.extend({name:"QRating",mixins:[Te,ln,Pe],props:{value:{type:Number,required:!0},max:{type:[String,Number],default:5},icon:[String,Array],iconHalf:[String,Array],iconSelected:[String,Array],color:[String,Array],colorHalf:[String,Array],colorSelected:[String,Array],noReset:Boolean,noDimming:Boolean,readonly:Boolean,disable:Boolean},data:function(){return{mouseModel:0}},computed:{editable:function(){return!0!==this.readonly&&!0!==this.disable},classes:function(){return"q-rating--"+(!0===this.editable?"":"non-")+"editable"+(!0===this.noDimming?" q-rating--no-dimming":"")+(!0===this.disable?" disabled":"")+(void 0!==this.color&&!1===Array.isArray(this.color)?" text-"+this.color:"")},iconData:function(){var e=!0===Array.isArray(this.icon)?this.icon.length:0,t=!0===Array.isArray(this.iconSelected)?this.iconSelected.length:0,n=!0===Array.isArray(this.iconHalf)?this.iconHalf.length:0,i=!0===Array.isArray(this.color)?this.color.length:0,r=!0===Array.isArray(this.colorSelected)?this.colorSelected.length:0,o=!0===Array.isArray(this.colorHalf)?this.colorHalf.length:0;return{iconLen:e,icon:e>0?this.icon[e-1]:this.icon,selIconLen:t,selIcon:t>0?this.iconSelected[t-1]:this.iconSelected,halfIconLen:n,halfIcon:n>0?this.iconHalf[t-1]:this.iconHalf,colorLen:i,color:i>0?this.color[i-1]:this.color,selColorLen:r,selColor:r>0?this.colorSelected[r-1]:this.colorSelected,halfColorLen:o,halfColor:o>0?this.colorHalf[o-1]:this.colorHalf}},attrs:function(){return!0===this.disable?{"aria-disabled":"true"}:!0===this.readonly?{"aria-readonly":"true"}:void 0}},methods:{__set:function(e){if(!0===this.editable){var t=ue(parseInt(e,10),1,parseInt(this.max,10)),n=!0!==this.noReset&&this.value===t?0:t;n!==this.value&&this.$emit("input",n),this.mouseModel=0}},__setHoverValue:function(e){!0===this.editable&&(this.mouseModel=e)},__keyup:function(e,t){switch(e.keyCode){case 13:case 32:return this.__set(t),w(e);case 37:case 40:return this.$refs["rt"+(t-1)]&&this.$refs["rt"+(t-1)].focus(),w(e);case 39:case 38:return this.$refs["rt"+(t+1)]&&this.$refs["rt"+(t+1)].focus(),w(e)}}},render:function(e){for(var t,n=this,i=[],r=!0===this.editable?0:null,o=this.iconData,a=Math.ceil(this.value),s=void 0===this.iconHalf||a===this.value?-1:a,l=function(l){var c=0===n.mouseModel&&n.value>=l||n.mouseModel>0&&n.mouseModel>=l,u=s===l&&n.mouseModel<l,d=n.mouseModel>0&&(!0===u?a:n.value)>=l&&n.mouseModel<l,h=!0===u?l<=o.halfIconLen?n.iconHalf[l-1]:o.halfIcon:void 0===o.selIcon||!0!==c&&!0!==d?l<=o.iconLen?n.icon[l-1]:o.icon:l<=o.selIconLen?n.iconSelected[l-1]:o.selIcon,f=!0===u?l<=o.halfColorLen?n.colorHalf[l-1]:o.halfColor:void 0!==o.selColor&&!0===c?l<=o.selColorLen?n.colorSelected[l-1]:o.selColor:l<=o.colorLen?n.color[l-1]:o.color;i.push(e(De,{key:l,ref:"rt"+l,staticClass:"q-rating__icon",class:(t={"q-rating__icon--active":!0===c||!0===u,"q-rating__icon--exselected":d,"q-rating__icon--hovered":n.mouseModel===l},t["text-"+f]=void 0!==f,t),props:{name:h||n.$q.iconSet.rating.icon},attrs:{tabindex:r},on:pe(n,"i#"+l,{click:function(){n.__set(l)},mouseover:function(){n.__setHoverValue(l)},mouseout:function(){n.mouseModel=0},focus:function(){n.__setHoverValue(l)},blur:function(){n.mouseModel=0},keyup:function(e){n.__keyup(e,l)}})},Le(n,"tip-"+l)))},c=1;c<=n.max;c++)l(c);return void 0!==this.name&&!0!==this.disable&&this.__injectFormInput(i,"push"),e("div",{staticClass:"q-rating row inline items-center",class:this.classes,style:this.sizeStyle,attrs:this.attrs,on:Object.assign({},this.qListeners)},i)}}),xa=e.extend({name:"QResponsive",mixins:[No,Pe],render:function(e){return e("div",{staticClass:"q-responsive",on:Object.assign({},this.qListeners)},[e("div",{staticClass:"q-responsive__filler overflow-hidden"},[e("div",{style:this.ratioStyle})]),e("div",{staticClass:"q-responsive__content absolute-full fit"},Le(this,"default"))])}}),Sa=e.extend({name:"QScrollArea",mixins:[je],directives:{TouchPan:Qn},props:{barStyle:[Array,String,Object],thumbStyle:Object,contentStyle:[Array,String,Object],contentActiveStyle:[Array,String,Object],delay:{type:[String,Number],default:1e3},visible:{type:Boolean,default:null},horizontal:Boolean},data:function(){return{tempShowing:!1,panning:!1,hover:!1,containerWidth:0,containerHeight:0,scrollPosition:0,scrollSize:0}},computed:{classes:function(){return"q-scrollarea"+(!0===this.isDark?" q-scrollarea--dark":"")},thumbHidden:function(){return!0!==(null===this.visible?this.hover:this.visible)&&!1===this.tempShowing&&!1===this.panning||this.scrollSize<=this.containerSize},thumbSize:function(){return Math.round(ue(this.containerSize*this.containerSize/this.scrollSize,50,this.containerSize))},style:function(){var e=this.scrollPercentage*(this.containerSize-this.thumbSize);return Object.assign({},this.thumbStyle,!0===this.horizontal?{left:e+"px",width:this.thumbSize+"px"}:{top:e+"px",height:this.thumbSize+"px"})},mainStyle:function(){return!0===this.thumbHidden?this.contentStyle:this.contentActiveStyle},scrollPercentage:function(){var e=ue(this.scrollPosition/(this.scrollSize-this.containerSize),0,1);return Math.round(1e4*e)/1e4},containerSize:function(){return this["container"+this.dirProps.suffix]},dirProps:function(){return!0===this.horizontal?{prefix:"horizontal",suffix:"Width",scroll:"scrollLeft",classSuffix:"h absolute-bottom",dir:"right",dist:"x"}:{prefix:"vertical",suffix:"Height",scroll:"scrollTop",classSuffix:"v absolute-right",dir:"down",dist:"y"}},thumbClass:function(){return"q-scrollarea__thumb--"+this.dirProps.classSuffix+(!0===this.thumbHidden?" q-scrollarea__thumb--invisible":"")},barClass:function(){return"q-scrollarea__bar--"+this.dirProps.classSuffix+(!0===this.thumbHidden?" q-scrollarea__bar--invisible":"")},thumbDirectives:function(){var e;return[{name:"touch-pan",modifiers:(e={},e[!0===this.horizontal?"horizontal":"vertical"]=!0,e.prevent=!0,e.mouse=!0,e.mouseAllDir=!0,e),value:this.__panThumb}]}},methods:{getScrollTarget:function(){return this.$refs.target},getScrollPosition:function(){return this.scrollPosition},setScrollPosition:function(e,t){(!0===this.horizontal?Ut:Wt)(this.$refs.target,e,t)},setScrollPercentage:function(e,t){this.setScrollPosition(e*(this.scrollSize-this.containerSize),t)},__updateContainer:function(e){var t=e.height,n=e.width,i=!1;this.containerWidth!==n&&(this.containerWidth=n,i=!0),this.containerHeight!==t&&(this.containerHeight=t,i=!0),!0===i&&this.__startTimer()},__updateScroll:function(e){this.scrollPosition!==e.position&&(this.scrollPosition=e.position,this.__startTimer())},__updateScrollSize:function(e){var t=e.height,n=e.width;!0===this.horizontal?this.scrollSize!==n&&(this.scrollSize=n,this.__startTimer()):this.scrollSize!==t&&(this.scrollSize=t,this.__startTimer())},__panThumb:function(e){if(!0===e.isFirst){if(!0===this.thumbHidden)return;this.refPos=this.scrollPosition,this.panning=!0}else if(!0!==this.panning)return;!0===e.isFinal&&(this.panning=!1);var t=(this.scrollSize-this.containerSize)/(this.containerSize-this.thumbSize),n=e.distance[this.dirProps.dist],i=this.refPos+(e.direction===this.dirProps.dir?1:-1)*n*t;this.__setScroll(i)},__mouseDown:function(e){if(!0!==this.thumbHidden){var t=e["offset"+(!0===this.horizontal?"X":"Y")]-this.thumbSize/2;this.__setScroll(t/this.containerSize*this.scrollSize),void 0!==this.$refs.thumb&&this.$refs.thumb.dispatchEvent(new MouseEvent(e.type,e))}},__startTimer:function(){var e=this;!0===this.tempShowing?clearTimeout(this.timer):this.tempShowing=!0,this.timer=setTimeout((function(){e.tempShowing=!1}),this.delay),this.__emitScroll()},__setScroll:function(e){this.$refs.target[this.dirProps.scroll]=e}},render:function(e){var t=this;return e("div",{class:this.classes,on:pe(this,"desk",{mouseenter:function(){t.hover=!0},mouseleave:function(){t.hover=!1}})},[e("div",{ref:"target",staticClass:"scroll relative-position fit hide-scrollbar"},[e("div",{staticClass:"absolute",style:this.mainStyle,class:"full-"+(!0===this.horizontal?"height":"width")},qe([e(ni,{on:pe(this,"resizeIn",{resize:this.__updateScrollSize})})],this,"default")),e(Go,{props:{horizontal:this.horizontal},on:pe(this,"scroll",{scroll:this.__updateScroll})})]),e(ni,{on:pe(this,"resizeOut",{resize:this.__updateContainer})}),e("div",{staticClass:"q-scrollarea__bar",style:this.barStyle,class:this.barClass,attrs:ge,on:pe(this,"bar",{mousedown:this.__mouseDown})}),e("div",{ref:"thumb",staticClass:"q-scrollarea__thumb",style:this.style,class:this.thumbClass,attrs:ge,directives:this.thumbDirectives})])},created:function(){var e=this;this.__emitScroll=T((function(){if(void 0!==e.$listeners.scroll){var t={ref:e},n=e.dirProps.prefix;t[n+"Position"]=e.scrollPosition,t[n+"Percentage"]=e.scrollPercentage,t[n+"Size"]=e.scrollSize,t[n+"ContainerSize"]=e.containerSize,e.$emit("scroll",t)}}),0)}}),Ca=1e3,Ma=["start","center","end","start-force","center-force","end-force"],Ta=Array.prototype.slice,Aa=void 0;function Pa(e,t){return e+t}function La(e,t,n,i,r,o,a,s){var l=e===window?document.scrollingElement||document.documentElement:e,c=!0===r?"offsetWidth":"offsetHeight",u={scrollStart:0,scrollViewSize:-a-s,scrollMaxSize:0,offsetStart:-a,offsetEnd:-s};if(!0===r?(e===window?(u.scrollStart=window.pageXOffset||window.scrollX||document.body.scrollLeft||0,u.scrollViewSize+=window.innerWidth):(u.scrollStart=l.scrollLeft,u.scrollViewSize+=l.clientWidth),u.scrollMaxSize=l.scrollWidth,!0===o&&(u.scrollStart=(!0===Aa?u.scrollMaxSize-u.scrollViewSize:0)-u.scrollStart)):(e===window?(u.scrollStart=window.pageYOffset||window.scrollY||document.body.scrollTop||0,u.scrollViewSize+=window.innerHeight):(u.scrollStart=l.scrollTop,u.scrollViewSize+=l.clientHeight),u.scrollMaxSize=l.scrollHeight),void 0!==n)for(var d=n.previousElementSibling;null!==d;d=d.previousElementSibling)!1===d.classList.contains("q-virtual-scroll--skip")&&(u.offsetStart+=d[c]);if(void 0!==i)for(var h=i.nextElementSibling;null!==h;h=h.nextElementSibling)!1===h.classList.contains("q-virtual-scroll--skip")&&(u.offsetEnd+=h[c]);if(t!==e){var f=l.getBoundingClientRect(),p=t.getBoundingClientRect();!0===r?(u.offsetStart+=p.left-f.left,u.offsetEnd-=p.width):(u.offsetStart+=p.top-f.top,u.offsetEnd-=p.height),e!==window&&(u.offsetStart+=u.scrollStart),u.offsetEnd+=u.scrollMaxSize-u.offsetStart}return u}function Oa(e,t,n,i){if(n>=i)return 0;var r=t.length,o=Math.floor(n/Ca),a=Math.floor((i-1)/Ca)+1,s=e.slice(o,a).reduce(Pa,0);return n%Ca!=0&&(s-=t.slice(o*Ca,n).reduce(Pa,0)),i%Ca!=0&&i!==r&&(s-=t.slice(i,a*Ca).reduce(Pa,0)),s}var qa={virtualScrollSliceSize:{type:Number,default:null},virtualScrollItemSize:{type:Number,default:24},virtualScrollStickySizeStart:{type:Number,default:0},virtualScrollStickySizeEnd:{type:Number,default:0},tableColspan:[Number,String]},Ea=Object.keys(qa),Da={props:Object.assign({},{virtualScrollHorizontal:Boolean},qa),data:function(){return{virtualScrollSliceRange:{from:0,to:0}}},watch:{virtualScrollHorizontal:function(){this.__setVirtualScrollSize()},needsReset:function(){this.reset()}},computed:{needsReset:function(){var e=this;return["virtualScrollItemSize","virtualScrollHorizontal"].map((function(t){return e[t]})).join(";")},colspanAttr:function(){return void 0!==this.tableColspan?{colspan:this.tableColspan}:{colspan:100}}},methods:{reset:function(){this.__resetVirtualScroll(this.prevToIndex,!0)},refresh:function(e){this.__resetVirtualScroll(void 0===e?this.prevToIndex:e)},scrollTo:function(e,t){var n=this.__getVirtualScrollTarget();if(null!=n&&8!==n.nodeType){var i=La(n,this.__getVirtualScrollEl(),this.$refs.before,this.$refs.after,this.virtualScrollHorizontal,this.$q.lang.rtl,this.virtualScrollStickySizeStart,this.virtualScrollStickySizeEnd);this.__scrollViewSize!==i.scrollViewSize&&this.__setVirtualScrollSize(i.scrollViewSize),this.__setVirtualScrollSliceRange(n,i,Math.min(this.virtualScrollLength-1,Math.max(0,parseInt(e,10)||0)),0,Ma.indexOf(t)>-1?t:this.prevToIndex>-1&&e>this.prevToIndex?"end":"start")}},__onVirtualScrollEvt:function(){var e=this.__getVirtualScrollTarget();if(null!=e&&8!==e.nodeType){var t=La(e,this.__getVirtualScrollEl(),this.$refs.before,this.$refs.after,this.virtualScrollHorizontal,this.$q.lang.rtl,this.virtualScrollStickySizeStart,this.virtualScrollStickySizeEnd),n=this.virtualScrollLength-1,i=t.scrollMaxSize-t.offsetStart-t.offsetEnd-this.virtualScrollPaddingAfter;if(this.prevScrollStart!==t.scrollStart)if(this.prevScrollStart=void 0,t.scrollMaxSize<=0)this.__setVirtualScrollSliceRange(e,t,0,0);else{this.__scrollViewSize!==t.scrollViewSize&&this.__setVirtualScrollSize(t.scrollViewSize),this.__updateVirtualScrollSizes(this.virtualScrollSliceRange.from);var r=t.scrollMaxSize-Math.max(t.scrollViewSize,t.offsetEnd)-this.virtualScrollSizes[n];if(r>0&&t.scrollStart>=r)this.__setVirtualScrollSliceRange(e,t,n,t.scrollMaxSize-t.offsetEnd-this.virtualScrollSizesAgg.reduce(Pa,0));else{var o=0,a=t.scrollStart-t.offsetStart,s=a;if(a<=i&&a+t.scrollViewSize>=this.virtualScrollPaddingBefore)a-=this.virtualScrollPaddingBefore,o=this.virtualScrollSliceRange.from,s=a;else for(var l=0;a>=this.virtualScrollSizesAgg[l]&&o<n;l++)a-=this.virtualScrollSizesAgg[l],o+=Ca;for(;a>0&&o<n;)(a-=this.virtualScrollSizes[o])>-t.scrollViewSize?(o++,s=a):s=this.virtualScrollSizes[o]+a;this.__setVirtualScrollSliceRange(e,t,o,s)}}}},__setVirtualScrollSliceRange:function(e,t,n,i,r){var o=this,a="string"==typeof r&&r.indexOf("-force")>-1,s=!0===a?r.replace("-force",""):r,l=Math.max(0,Math.ceil(n-this.virtualScrollSliceSizeComputed/(void 0===s||"center"===s?2:"start"===s?3:1.5))),c=l+this.virtualScrollSliceSizeComputed;c>this.virtualScrollLength&&(c=this.virtualScrollLength,l=Math.max(0,c-this.virtualScrollSliceSizeComputed));var u=l!==this.virtualScrollSliceRange.from||c!==this.virtualScrollSliceRange.to;if(!1!==u||void 0!==s){var d=!0===u&&"function"==typeof e.contains&&e.contains(document.activeElement),h=void 0!==s?this.virtualScrollSizes.slice(l,n).reduce(Pa,0):0;!0===u&&(this.virtualScrollSliceRange={from:l,to:c},this.virtualScrollPaddingBefore=Oa(this.virtualScrollSizesAgg,this.virtualScrollSizes,0,l),this.virtualScrollPaddingAfter=Oa(this.virtualScrollSizesAgg,this.virtualScrollSizes,c,this.virtualScrollLength)),this.__activeScrollStart=t.scrollStart,requestAnimationFrame((function(){if(!0===d&&!0!==e.contains(document.activeElement)&&e.focus(),o.__activeScrollStart===t.scrollStart){!0===u&&o.__updateVirtualScrollSizes(l);var r=o.virtualScrollSizes.slice(l,n).reduce(Pa,0),c=r+t.offsetStart+o.virtualScrollPaddingBefore,f=c+o.virtualScrollSizes[n],p=!0===o.$q.lang.rtl,m=c+i;if(void 0!==s){var v=r-h,g=t.scrollStart+v;m=!0!==a&&g<c&&f<g+t.scrollViewSize?g:"end"===s?f-t.scrollViewSize:c-("start"===s?0:Math.round((t.scrollViewSize-o.virtualScrollSizes[n])/2))}o.prevScrollStart=m,function(e,t,n,i){e===window?!0===n?(!0===i&&(t=(!0===Aa?document.body.scrollWidth-window.innerWidth:0)-t),window.scrollTo(t,window.pageYOffset||window.scrollY||document.body.scrollTop||0)):window.scrollTo(window.pageXOffset||window.scrollX||document.body.scrollLeft||0,t):!0===n?(!0===i&&(t=(!0===Aa?e.scrollWidth-e.offsetWidth:0)-t),e.scrollLeft=t):e.scrollTop=t}(e,m,o.virtualScrollHorizontal,p),o.__emitScroll(n)}}))}else this.__emitScroll(n)},__updateVirtualScrollSizes:function(e){var t=this.$refs.content;if(void 0!==t)for(var n,i,r=Ta.call(t.children).filter((function(e){return!1===e.classList.contains("q-virtual-scroll--skip")})),o=r.length,a=!0===this.virtualScrollHorizontal?function(e){return e.getBoundingClientRect().width}:function(e){return e.offsetHeight},s=e,l=0;l<o;){for(n=a(r[l]),l++;l<o&&!0===r[l].classList.contains("q-virtual-scroll--with-prev");)n+=a(r[l]),l++;0!==(i=n-this.virtualScrollSizes[s])&&(this.virtualScrollSizes[s]+=i,this.virtualScrollSizesAgg[Math.floor(s/Ca)]+=i),s++}},__resetVirtualScroll:function(e,t){var n=this,i=this.virtualScrollItemSize;!0!==t&&!1!==Array.isArray(this.virtualScrollSizes)||(this.virtualScrollSizes=[]);var r=this.virtualScrollSizes.length;this.virtualScrollSizes.length=this.virtualScrollLength;for(var o=this.virtualScrollLength-1;o>=r;o--)this.virtualScrollSizes[o]=i;var a=Math.floor((this.virtualScrollLength-1)/Ca);this.virtualScrollSizesAgg=[];for(var s=0;s<=a;s++){for(var l=0,c=Math.min((s+1)*Ca,this.virtualScrollLength),u=s*Ca;u<c;u++)l+=this.virtualScrollSizes[u];this.virtualScrollSizesAgg.push(l)}this.prevToIndex=-1,this.prevScrollStart=void 0,e>=0?(this.__updateVirtualScrollSizes(this.virtualScrollSliceRange.from),this.$nextTick((function(){n.scrollTo(e)}))):(this.virtualScrollPaddingBefore=Oa(this.virtualScrollSizesAgg,this.virtualScrollSizes,0,this.virtualScrollSliceRange.from),this.virtualScrollPaddingAfter=Oa(this.virtualScrollSizesAgg,this.virtualScrollSizes,this.virtualScrollSliceRange.to,this.virtualScrollLength),this.__onVirtualScrollEvt())},__setVirtualScrollSize:function(e){if(this.virtualScrollSliceSize>0)this.virtualScrollSliceSizeComputed=this.virtualScrollSliceSize;else{if(void 0===e&&"undefined"!=typeof window){var t=this.__getVirtualScrollTarget();null!=t&&8!==t.nodeType&&(e=La(t,this.__getVirtualScrollEl(),this.$refs.before,this.$refs.after,this.virtualScrollHorizontal,this.$q.lang.rtl,this.virtualScrollStickySizeStart,this.virtualScrollStickySizeEnd).scrollViewSize)}this.__scrollViewSize=e,this.virtualScrollSliceSizeComputed=void 0===e||e<=0?30:Math.ceil(e/this.virtualScrollItemSize*3)}},__padVirtualScroll:function(e,t,n){var i,r,o,a,s=!0===this.virtualScrollHorizontal?"width":"height";return["tbody"===t?e(t,{staticClass:"q-virtual-scroll__padding",key:"before",ref:"before"},[e("tr",[e("td",{style:(i={},i[s]=this.virtualScrollPaddingBefore+"px",i),attrs:this.colspanAttr})])]):e(t,{staticClass:"q-virtual-scroll__padding",key:"before",ref:"before",style:(r={},r[s]=this.virtualScrollPaddingBefore+"px",r)}),e(t,{staticClass:"q-virtual-scroll__content",key:"content",ref:"content"},n),"tbody"===t?e(t,{staticClass:"q-virtual-scroll__padding",key:"after",ref:"after"},[e("tr",[e("td",{style:(o={},o[s]=this.virtualScrollPaddingAfter+"px",o),attrs:this.colspanAttr})])]):e(t,{staticClass:"q-virtual-scroll__padding",key:"after",ref:"after",style:(a={},a[s]=this.virtualScrollPaddingAfter+"px",a)})]},__emitScroll:function(e){this.prevToIndex!==e&&(void 0!==this.qListeners["virtual-scroll"]&&this.$emit("virtual-scroll",{index:e,from:this.virtualScrollSliceRange.from,to:this.virtualScrollSliceRange.to-1,direction:e<this.prevToIndex?"decrease":"increase",ref:this}),this.prevToIndex=e)}},created:function(){this.__setVirtualScrollSize()},beforeMount:function(){var e,t;void 0===Aa&&(e=document.createElement("div"),t=document.createElement("div"),e.setAttribute("dir","rtl"),e.style.width="1px",e.style.height="1px",e.style.overflow="auto",t.style.width="1000px",t.style.height="1px",document.body.appendChild(e),e.appendChild(t),e.scrollLeft=-1e3,Aa=e.scrollLeft>=0,e.remove()),this.__onVirtualScrollEvt=T(this.__onVirtualScrollEvt,!0===this.$q.platform.is.ios?120:70),this.__setVirtualScrollSize()}},za=function(e){return["add","add-unique","toggle"].includes(e)},Na=e.extend({name:"QSelect",mixins:[Er,Da,Yr,cn,Pe],props:{value:{required:!0},multiple:Boolean,displayValue:[String,Number],displayValueSanitize:Boolean,dropdownIcon:String,options:{type:Array,default:function(){return[]}},optionValue:[Function,String],optionLabel:[Function,String],optionDisable:[Function,String],hideSelected:Boolean,hideDropdownIcon:Boolean,fillInput:Boolean,maxValues:[Number,String],optionsDense:Boolean,optionsDark:{type:Boolean,default:null},optionsSelectedClass:String,optionsSanitize:Boolean,optionsCover:Boolean,menuShrink:Boolean,menuAnchor:String,menuSelf:String,menuOffset:Array,popupContentClass:String,popupContentStyle:[String,Array,Object],useInput:Boolean,useChips:Boolean,newValueMode:{type:String,validator:za},mapOptions:Boolean,emitValue:Boolean,inputDebounce:{type:[Number,String],default:500},inputClass:[Array,String,Object],inputStyle:[Array,String,Object],tabindex:{type:[String,Number],default:0},transitionShow:String,transitionHide:String,behavior:{type:String,validator:function(e){return["default","menu","dialog"].includes(e)},default:"default"}},data:function(){return{menu:!1,dialog:!1,optionIndex:-1,inputValue:"",dialogFieldFocused:!1}},watch:{innerValue:{handler:function(e){this.innerValueCache=e,!0===this.useInput&&!0===this.fillInput&&!0!==this.multiple&&!0!==this.innerLoading&&(!0!==this.dialog&&!0!==this.menu||!0!==this.hasValue)&&(!0!==this.userInputValue&&this.__resetInputValue(),!0!==this.dialog&&!0!==this.menu||this.filter(""))},immediate:!0},fillInput:function(){this.__resetInputValue()},menu:function(e){this.__updateMenu(e)}},computed:{isOptionsDark:function(){return null===this.optionsDark?this.isDark:this.optionsDark},virtualScrollLength:function(){return Array.isArray(this.options)?this.options.length:0},fieldClass:function(){return"q-select q-field--auto-height q-select--with"+(!0!==this.useInput?"out":"")+"-input q-select--with"+(!0!==this.useChips?"out":"")+"-chips q-select--"+(!0===this.multiple?"multiple":"single")},computedInputClass:function(){return!0===this.hideSelected||0===this.innerValue.length?this.inputClass:void 0===this.inputClass?"q-field__input--padding":[this.inputClass,"q-field__input--padding"]},menuContentClass:function(){return(!0===this.virtualScrollHorizontal?"q-virtual-scroll--horizontal":"")+(this.popupContentClass?" "+this.popupContentClass:"")},innerValue:function(){var e=this,t=!0===this.mapOptions&&!0!==this.multiple,n=void 0===this.value||null===this.value&&!0!==t?[]:!0===this.multiple&&Array.isArray(this.value)?this.value:[this.value];if(!0===this.mapOptions&&!0===Array.isArray(this.options)){var i=!0===this.mapOptions&&void 0!==this.innerValueCache?this.innerValueCache:[],r=n.map((function(t){return e.__getOption(t,i)}));return null===this.value&&!0===t?r.filter((function(e){return null!==e})):r}return n},noOptions:function(){return 0===this.virtualScrollLength},selectedString:function(){var e=this;return this.innerValue.map((function(t){return e.getOptionLabel(t)})).join(", ")},sanitizeFn:function(){return!0===this.optionsSanitize?function(){return!0}:function(e){return null!=e&&!0===e.sanitize}},displayAsText:function(){return!0===this.displayValueSanitize||void 0===this.displayValue&&(!0===this.optionsSanitize||this.innerValue.some(this.sanitizeFn))},computedTabindex:function(){return!0===this.focused?this.tabindex:-1},selectedScope:function(){var e=this;return this.innerValue.map((function(t,n){return{index:n,opt:t,sanitize:e.sanitizeFn(t),selected:!0,removeAtIndex:e.__removeAtIndexAndFocus,toggleOption:e.toggleOption,tabindex:e.computedTabindex}}))},optionScope:function(){var e=this;if(0===this.virtualScrollLength)return[];var t=this.virtualScrollSliceRange,n=t.from,i=t.to;return this.options.slice(n,i).map((function(t,i){var r=!0===e.isOptionDisabled(t),o=n+i,a={clickable:!0,active:!1,activeClass:e.computedOptionsSelectedClass,manualFocus:!0,focused:!1,disable:r,tabindex:-1,dense:e.optionsDense,dark:e.isOptionsDark};!0!==r&&(!0===e.isOptionSelected(t)&&(a.active=!0),e.optionIndex===o&&(a.focused=!0));var s={click:function(){e.toggleOption(t)}};return!0===e.$q.platform.is.desktop&&(s.mousemove=function(){e.setOptionIndex(o)}),{index:o,opt:t,sanitize:e.sanitizeFn(t),selected:a.active,focused:a.focused,toggleOption:e.toggleOption,setOptionIndex:e.setOptionIndex,itemProps:a,itemEvents:s}}))},dropdownArrowIcon:function(){return void 0!==this.dropdownIcon?this.dropdownIcon:this.$q.iconSet.arrow.dropdown},squaredMenu:function(){return!1===this.optionsCover&&!0!==this.outlined&&!0!==this.standout&&!0!==this.borderless&&!0!==this.rounded},computedOptionsSelectedClass:function(){return void 0!==this.optionsSelectedClass?this.optionsSelectedClass:void 0!==this.color?"text-"+this.color:""},innerOptionsValue:function(){var e=this;return this.innerValue.map((function(t){return e.getOptionValue(t)}))},getOptionValue:function(){return this.__getPropValueFn("optionValue","value")},getOptionLabel:function(){return this.__getPropValueFn("optionLabel","label")},isOptionDisabled:function(){return this.__getPropValueFn("optionDisable","disable")},inputControlEvents:function(){var e=this,t={input:this.__onInput,change:this.__onChange,keydown:this.__onTargetKeydown,keyup:this.__onTargetKeyup,keypress:this.__onTargetKeypress,focus:this.__selectInputText,click:function(t){!0===e.hasDialog&&b(t)}};return t.compositionstart=t.compositionupdate=t.compositionend=this.__onComposition,t}},methods:{getEmittingOptionValue:function(e){return!0===this.emitValue?this.getOptionValue(e):e},removeAtIndex:function(e){if(e>-1&&e<this.innerValue.length)if(!0===this.multiple){var t=this.value.slice();this.$emit("remove",{index:e,value:t.splice(e,1)[0]}),this.$emit("input",t)}else this.$emit("input",null)},__removeAtIndexAndFocus:function(e){this.removeAtIndex(e),this.__focus()},add:function(e,t){var n=this.getEmittingOptionValue(e);if(!0!==this.multiple)return!0===this.fillInput&&this.updateInputValue(this.getOptionLabel(e),!0,!0),void this.$emit("input",n);if(0===this.innerValue.length)return this.$emit("add",{index:0,value:n}),void this.$emit("input",!0===this.multiple?[n]:n);if(!(!0===t&&!0===this.isOptionSelected(e)||void 0!==this.maxValues&&this.value.length>=this.maxValues)){var i=this.value.slice();this.$emit("add",{index:i.length,value:n}),i.push(n),this.$emit("input",i)}},toggleOption:function(e,t){if(!0===this.editable&&void 0!==e&&!0!==this.isOptionDisabled(e)){var n=this.getOptionValue(e);if(!0!==this.multiple)return!0!==t&&(this.updateInputValue(!0===this.fillInput?this.getOptionLabel(e):"",!0,!0),this.hidePopup()),void 0!==this.$refs.target&&this.$refs.target.focus(),void(!0!==Sn(this.getOptionValue(this.innerValue[0]),n)&&this.$emit("input",!0===this.emitValue?n:e));if((!0!==this.hasDialog||!0===this.dialogFieldFocused)&&this.__focus(),this.__selectInputText(),0===this.innerValue.length){var i=!0===this.emitValue?n:e;return this.$emit("add",{index:0,value:i}),void this.$emit("input",!0===this.multiple?[i]:i)}var r=this.value.slice(),o=this.innerOptionsValue.findIndex((function(e){return Sn(e,n)}));if(o>-1)this.$emit("remove",{index:o,value:r.splice(o,1)[0]});else{if(void 0!==this.maxValues&&r.length>=this.maxValues)return;var a=!0===this.emitValue?n:e;this.$emit("add",{index:r.length,value:a}),r.push(a)}this.$emit("input",r)}},setOptionIndex:function(e){if(!0===this.$q.platform.is.desktop){var t=e>-1&&e<this.virtualScrollLength?e:-1;this.optionIndex!==t&&(this.optionIndex=t)}},moveOptionSelection:function(e,t){if(void 0===e&&(e=1),!0===this.menu){var n=this.optionIndex;do{n=de(n+e,-1,this.virtualScrollLength-1)}while(-1!==n&&n!==this.optionIndex&&!0===this.isOptionDisabled(this.options[n]));this.optionIndex!==n&&(this.setOptionIndex(n),this.scrollTo(n),!0!==t&&!0===this.useInput&&!0===this.fillInput&&this.__setInputValue(n>=0?this.getOptionLabel(this.options[n]):this.defaultInputValue))}},__getOption:function(e,t){var n=this,i=function(t){return Sn(n.getOptionValue(t),e)};return this.options.find(i)||t.find(i)||e},__getPropValueFn:function(e,t){var n=void 0!==this[e]?this[e]:t;return"function"==typeof n?n:function(e){return Object(e)===e&&n in e?e[n]:e}},isOptionSelected:function(e){var t=this.getOptionValue(e);return void 0!==this.innerOptionsValue.find((function(e){return Sn(e,t)}))},__selectInputText:function(){!0===this.useInput&&void 0!==this.$refs.target&&this.$refs.target.select()},__onTargetKeyup:function(e){!0===X(e,27)&&!0===this.menu&&(b(e),this.hidePopup(),this.__resetInputValue()),this.$emit("keyup",e)},__onTargetAutocomplete:function(e){var t=this,n=e.target.value;if(e.target.value="",void 0===e.keyCode){if("string"==typeof n&&n.length>0){var i=n.toLocaleLowerCase(),r=function(e){return t.getOptionValue(e).toLocaleLowerCase()===i},o=this.options.find(r);null!==o?-1===this.innerValue.indexOf(o)&&this.toggleOption(o):(r=function(e){return t.getOptionLabel(e).toLocaleLowerCase()===i},null!==(o=this.options.find(r))&&-1===this.innerValue.indexOf(o)&&this.toggleOption(o))}}else this.__onTargetKeyup(e)},__onTargetKeypress:function(e){this.$emit("keypress",e)},__onTargetKeydown:function(e){var t=this;if(this.$emit("keydown",e),!0!==J(e)){var n=this.inputValue.length>0&&(void 0!==this.newValueMode||void 0!==this.qListeners["new-value"]),i=!0!==e.shiftKey&&!0!==this.multiple&&(this.optionIndex>-1||!0===n);if(27!==e.keyCode)if(9!==e.keyCode||!1!==i){if(void 0!==e.target&&e.target.id===this.targetUid){if(40===e.keyCode&&!0!==this.innerLoading&&!1===this.menu)return w(e),void this.showPopup();if(8===e.keyCode&&!0===this.multiple&&!0!==this.hideSelected&&0===this.inputValue.length&&Array.isArray(this.value))this.removeAtIndex(this.value.length-1);else{38!==e.keyCode&&40!==e.keyCode||(w(e),this.moveOptionSelection(38===e.keyCode?-1:1,this.multiple));var r=this.virtualScrollLength;if((void 0===this.searchBuffer||this.searchBufferExp<Date.now())&&(this.searchBuffer=""),r>0&&!0!==this.useInput&&1===e.key.length&&e.altKey===e.ctrlKey&&(32!==e.keyCode||this.searchBuffer.length>0)){!0!==this.menu&&this.showPopup(e);var o=e.key.toLocaleLowerCase(),a=1===this.searchBuffer.length&&this.searchBuffer[0]===o;this.searchBufferExp=Date.now()+1500,!1===a&&(w(e),this.searchBuffer+=o);var s=new RegExp("^"+this.searchBuffer.split("").map((function(e){return".*+?^${}()|[]\\".indexOf(e)>-1?"\\"+e:e})).join(".*"),"i"),l=this.optionIndex;if(!0===a||l<0||!0!==s.test(this.getOptionLabel(this.options[l])))do{l=de(l+1,-1,r-1)}while(l!==this.optionIndex&&(!0===this.isOptionDisabled(this.options[l])||!0!==s.test(this.getOptionLabel(this.options[l]))));this.optionIndex!==l&&this.$nextTick((function(){t.setOptionIndex(l),t.scrollTo(l),l>=0&&!0===t.useInput&&!0===t.fillInput&&t.__setInputValue(t.getOptionLabel(t.options[l]))}))}else if(13===e.keyCode||32===e.keyCode&&!0!==this.useInput&&""===this.searchBuffer||9===e.keyCode&&!1!==i)if(9!==e.keyCode&&w(e),this.optionIndex>-1&&this.optionIndex<r)this.toggleOption(this.options[this.optionIndex]);else{if(!0===n){var c=function(e,n){if(n){if(!0!==za(n))return}else n=t.newValueMode;null!=e&&(t.updateInputValue("",!0!==t.multiple,!0),t["toggle"===n?"toggleOption":"add"](e,"add-unique"===n),!0!==t.multiple&&(void 0!==t.$refs.target&&t.$refs.target.focus(),t.hidePopup()))};if(void 0!==this.qListeners["new-value"]?this.$emit("new-value",this.inputValue,c):c(this.inputValue),!0!==this.multiple)return}!0===this.menu?this.__closeMenu():!0!==this.innerLoading&&this.showPopup()}}}}else this.__closeMenu();else y(e)}},__getVirtualScrollEl:function(){return!0===this.hasDialog?this.$refs.menuContent:void 0!==this.$refs.menu&&void 0!==this.$refs.menu.__portal?this.$refs.menu.__portal.$el:void 0},__getVirtualScrollTarget:function(){return this.__getVirtualScrollEl()},__getSelection:function(e,t){var n,i=this;return!0===this.hideSelected?!0===t||!0!==this.dialog||!0!==this.hasDialog?[]:[e("span",{domProps:{textContent:this.inputValue}})]:void 0!==this.$scopedSlots["selected-item"]?this.selectedScope.map((function(e){return i.$scopedSlots["selected-item"](e)})).slice():void 0!==this.$scopedSlots.selected?this.$scopedSlots.selected().slice():!0===this.useChips?this.selectedScope.map((function(t,n){var r;return e(zn,{key:"option-"+n,props:{removable:!0===i.editable&&!0!==i.isOptionDisabled(t.opt),dense:!0,textColor:i.color,tabindex:i.computedTabindex},on:pe(i,"rem#"+n,{remove:function(){t.removeAtIndex(n)}})},[e("span",{staticClass:"ellipsis",domProps:(r={},r[!0===t.sanitize?"textContent":"innerHTML"]=i.getOptionLabel(t.opt),r)})])})):[e("span",{domProps:(n={},n[this.displayAsText?"textContent":"innerHTML"]=void 0!==this.displayValue?this.displayValue:this.selectedString,n)})]},__getControl:function(e,t){var n=this.__getSelection(e,t),i=!0===t||!0!==this.dialog||!0!==this.hasDialog;if(!0===i&&!0===this.useInput?n.push(this.__getInput(e,t)):!0===this.editable&&(!0===i&&n.push(e("div",{ref:"target",key:"d_t",staticClass:"no-outline",attrs:{id:this.targetUid,tabindex:this.tabindex},on:pe(this,"f-tget",{keydown:this.__onTargetKeydown,keyup:this.__onTargetKeyup,keypress:this.__onTargetKeypress})})),void 0!==this.qAttrs.autocomplete&&n.push(e("input",{staticClass:"q-select__autocomplete-input no-outline",attrs:{autocomplete:this.qAttrs.autocomplete},on:pe(this,"autoinp",{keyup:this.__onTargetAutocomplete})}))),void 0!==this.nameProp&&!0!==this.disable&&this.innerOptionsValue.length>0){var r=this.innerOptionsValue.map((function(t){return e("option",{attrs:{value:t,selected:!0}})}));n.push(e("select",{staticClass:"hidden",attrs:{name:this.nameProp,multiple:this.multiple}},r))}return e("div",{staticClass:"q-field__native row items-center",attrs:this.qAttrs},n)},__getOptions:function(e){var t=this;if(!0===this.menu){var n=void 0!==this.$scopedSlots.option?this.$scopedSlots.option:function(n){var i;return e(Zr,{key:n.index,props:n.itemProps,on:n.itemEvents},[e(Jr,[e(go,{domProps:(i={},i[!0===n.sanitize?"textContent":"innerHTML"]=t.getOptionLabel(n.opt),i)})])])},i=this.__padVirtualScroll(e,"div",this.optionScope.map(n));return void 0!==this.$scopedSlots["before-options"]&&(i=this.$scopedSlots["before-options"]().concat(i)),qe(i,this,"after-options")}},__getInnerAppend:function(e){return!0!==this.loading&&!0!==this.innerLoading&&!0!==this.hideDropdownIcon?[e(De,{staticClass:"q-select__dropdown-icon",props:{name:this.dropdownArrowIcon}})]:null},__getInput:function(e,t){var n={ref:"target",key:"i_t",staticClass:"q-field__input q-placeholder col",style:this.inputStyle,class:this.computedInputClass,domProps:{value:void 0!==this.inputValue?this.inputValue:""},attrs:Object.assign({},{type:"search"},this.qAttrs,{id:this.targetUid,maxlength:this.maxlength,tabindex:this.tabindex,"data-autofocus":!0!==t&&this.autofocus,disabled:!0===this.disable,readonly:!0===this.readonly}),on:this.inputControlEvents};return!0!==t&&!0===this.hasDialog&&(n.staticClass+=" no-pointer-events",n.attrs.readonly=!0),e("input",n)},__onChange:function(e){this.__onComposition(e)},__onInput:function(e){var t=this;clearTimeout(this.inputTimer),e&&e.target&&!0===e.target.composing||(this.__setInputValue(e.target.value||""),this.userInputValue=!0,this.defaultInputValue=this.inputValue,!0===this.focused||!0===this.hasDialog&&!0!==this.dialogFieldFocused||this.__focus(),void 0!==this.qListeners.filter&&(this.inputTimer=setTimeout((function(){t.filter(t.inputValue)}),this.inputDebounce)))},__setInputValue:function(e){this.inputValue!==e&&(this.inputValue=e,this.$emit("input-value",e))},updateInputValue:function(e,t,n){this.userInputValue=!0!==n,!0===this.useInput&&(this.__setInputValue(e),!0!==t&&!0===n||(this.defaultInputValue=e),!0!==t&&this.filter(e))},filter:function(e){var t=this;if(void 0!==this.qListeners.filter&&!0===this.focused){!0===this.innerLoading?this.$emit("filter-abort"):this.innerLoading=!0,""!==e&&!0!==this.multiple&&this.innerValue.length>0&&!0!==this.userInputValue&&e===this.getOptionLabel(this.innerValue[0])&&(e="");var n=setTimeout((function(){!0===t.menu&&(t.menu=!1)}),10);clearTimeout(this.filterId),this.filterId=n,this.$emit("filter",e,(function(e,i){!0===t.focused&&t.filterId===n&&(clearTimeout(t.filterId),"function"==typeof e&&e(),t.$nextTick((function(){t.innerLoading=!1,!0===t.editable&&(!0===t.menu?t.__updateMenu(!0):t.menu=!0),"function"==typeof i&&t.$nextTick((function(){i(t)}))})))}),(function(){!0===t.focused&&t.filterId===n&&(clearTimeout(t.filterId),t.innerLoading=!1),!0===t.menu&&(t.menu=!1)}))}},__getControlEvents:function(){var e=this,t=function(t){e.__onControlFocusout(t,(function(){e.__resetInputValue(),e.__closeMenu()}))};return{focusin:this.__onControlFocusin,focusout:t,"popup-show":this.__onControlPopupShow,"popup-hide":function(n){void 0!==n&&b(n),e.$emit("popup-hide",n),e.hasPopupOpen=!1,t(n)},click:function(t){if(!0!==e.hasDialog){if(!0===e.useInput&&!0!==t.target.classList.contains("q-field__input")||!0!==e.useInput&&!0===t.target.classList.contains("no-outline"))return;if(!0===e.menu)return e.__closeMenu(),void(void 0!==e.$refs.target&&e.$refs.target.focus())}e.showPopup(t)}}},__getControlChild:function(e){if(!1!==this.editable&&(!0===this.dialog||!0!==this.noOptions||void 0!==this.$scopedSlots["no-option"]))return this["__get"+(!0===this.hasDialog?"Dialog":"Menu")](e)},__getMenu:function(e){var t=!0===this.noOptions?void 0!==this.$scopedSlots["no-option"]?this.$scopedSlots["no-option"]({inputValue:this.inputValue}):null:this.__getOptions(e);return e(an,{ref:"menu",props:{value:this.menu,fit:!0!==this.menuShrink,cover:!0===this.optionsCover&&!0!==this.noOptions&&!0!==this.useInput,anchor:this.menuAnchor,self:this.menuSelf,offset:this.menuOffset,contentClass:this.menuContentClass,contentStyle:this.popupContentStyle,dark:this.isOptionsDark,noParentEvent:!0,noRefocus:!0,noFocus:!0,square:this.squaredMenu,transitionShow:this.transitionShow,transitionHide:this.transitionHide,separateClosePopup:!0},on:pe(this,"menu",{"&scroll":this.__onVirtualScrollEvt,"before-hide":this.__closeMenu})},t)},__onDialogFieldFocus:function(e){b(e),void 0!==this.$refs.target&&this.$refs.target.focus(),this.dialogFieldFocused=!0,window.scrollTo(window.pageXOffset||window.scrollX||document.body.scrollLeft||0,0)},__onDialogFieldBlur:function(e){var t=this;b(e),this.$nextTick((function(){t.dialogFieldFocused=!1}))},__getDialog:function(e){var t=this,n=[e(Er,{staticClass:"col-auto "+this.fieldClass,props:Object.assign({},this.$props,{for:this.targetUid,dark:this.isOptionsDark,square:!0,loading:this.innerLoading,filled:!0,stackLabel:this.inputValue.length>0}),on:Object.assign({},this.qListeners,{focus:this.__onDialogFieldFocus,blur:this.__onDialogFieldBlur}),scopedSlots:Object.assign({},this.$scopedSlots,{rawControl:function(){return t.__getControl(e,!0)},before:void 0,after:void 0})})];return!0===this.menu&&n.push(e("div",{ref:"menuContent",staticClass:"scroll",class:this.menuContentClass,style:this.popupContentStyle,on:pe(this,"virtMenu",{click:y,"&scroll":this.__onVirtualScrollEvt})},!0===this.noOptions?void 0!==this.$scopedSlots["no-option"]?this.$scopedSlots["no-option"]({inputValue:this.inputValue}):null:this.__getOptions(e))),e(wr,{ref:"dialog",props:{value:this.dialog,dark:this.isOptionsDark,position:!0===this.useInput?"top":void 0,transitionShow:this.transitionShowComputed,transitionHide:this.transitionHide},on:pe(this,"dialog",{"before-hide":this.__onDialogBeforeHide,hide:this.__onDialogHide,show:this.__onDialogShow})},[e("div",{staticClass:"q-select__dialog"+(!0===this.isOptionsDark?" q-select__dialog--dark q-dark":"")+(!0===this.dialogFieldFocused?" q-select__dialog--focused":"")},n)])},__onDialogBeforeHide:function(){this.$refs.dialog.__refocusTarget=this.$el.querySelector(".q-field__native > [tabindex]:last-child"),this.focused=!1},__onDialogHide:function(e){this.hidePopup(),!1===this.focused&&this.$emit("blur",e),this.__resetInputValue()},__onDialogShow:function(){var e=document.activeElement;null!==e&&e.id===this.targetUid||this.$refs.target===e||void 0===this.$refs.target||this.$refs.target.focus()},__closeMenu:function(){!0!==this.dialog&&(this.optionIndex=-1,!0===this.menu&&(this.menu=!1),!1===this.focused&&(clearTimeout(this.filterId),this.filterId=void 0,!0===this.innerLoading&&(this.$emit("filter-abort"),this.innerLoading=!1)))},showPopup:function(e){var t=this;!0===this.editable&&(!0===this.hasDialog?(this.__onControlFocusin(e),this.dialog=!0,this.$nextTick((function(){t.__focus()}))):this.__focus(),void 0!==this.qListeners.filter?this.filter(this.inputValue):!0===this.noOptions&&void 0===this.$scopedSlots["no-option"]||(this.menu=!0))},hidePopup:function(){this.dialog=!1,this.__closeMenu()},__resetInputValue:function(){!0===this.useInput&&this.updateInputValue(!0!==this.multiple&&!0===this.fillInput&&this.innerValue.length>0&&this.getOptionLabel(this.innerValue[0])||"",!0,!0)},__updateMenu:function(e){var t=this,n=-1;if(!0===e){if(this.innerValue.length>0){var i=this.getOptionValue(this.innerValue[0]);n=this.options.findIndex((function(e){return Sn(t.getOptionValue(e),i)}))}this.__resetVirtualScroll(n)}this.setOptionIndex(n)},__onPreRender:function(){this.hasDialog=(!0===this.$q.platform.is.mobile||"dialog"===this.behavior)&&("menu"!==this.behavior&&(!0!==this.useInput||(void 0!==this.$scopedSlots["no-option"]||void 0!==this.qListeners.filter||!1===this.noOptions))),this.transitionShowComputed=!0===this.hasDialog&&!0===this.useInput&&!0===this.$q.platform.is.ios?"fade":this.transitionShow},__onPostRender:function(){!1===this.dialog&&void 0!==this.$refs.menu&&this.$refs.menu.updatePosition()},updateMenuPosition:function(){this.__onPostRender()}},beforeDestroy:function(){clearTimeout(this.inputTimer)}}),ja=["text","rect","circle","QBtn","QBadge","QChip","QToolbar","QCheckbox","QRadio","QToggle","QSlider","QRange","QInput","QAvatar"],Ra=["wave","pulse","pulse-x","pulse-y","fade","blink","none"],Ia=e.extend({name:"QSkeleton",mixins:[je,Ae,Pe],props:{type:{type:String,validator:function(e){return ja.includes(e)},default:"rect"},animation:{type:String,validator:function(e){return Ra.includes(e)},default:"wave"},square:Boolean,bordered:Boolean,size:String,width:String,height:String},computed:{style:function(){return void 0!==this.size?{width:this.size,height:this.size}:{width:this.width,height:this.height}},classes:function(){return"q-skeleton--"+(!0===this.isDark?"dark":"light")+" q-skeleton--type-"+this.type+("none"!==this.animation?" q-skeleton--anim q-skeleton--anim-"+this.animation:"")+(!0===this.square?" q-skeleton--square":"")+(!0===this.bordered?" q-skeleton--bordered":"")}},render:function(e){return e(this.tag,{staticClass:"q-skeleton",class:this.classes,style:this.style,on:Object.assign({},this.qListeners)},Le(this,"default"))}}),$a=[["left","center","start","width"],["right","center","end","width"],["top","start","center","height"],["bottom","end","center","height"]],Fa=e.extend({name:"QSlideItem",mixins:[je,Pe],props:{leftColor:String,rightColor:String,topColor:String,bottomColor:String},directives:{TouchPan:Qn},computed:{langDir:function(){return!0===this.$q.lang.rtl?{left:"right",right:"left"}:{left:"left",right:"right"}}},methods:{reset:function(){this.$refs.content.style.transform="translate(0,0)"},__pan:function(e){var t,n,i,r=this,o=this.$refs.content;if(e.isFirst)this.__dir=null,this.__size={left:0,right:0,top:0,bottom:0},this.__scale=0,o.classList.add("no-transition"),$a.forEach((function(e){if(void 0!==r.$scopedSlots[e[0]]){var t=r.$refs[e[0]+"Content"];t.style.transform="scale(1)",r.__size[e[0]]=t.getBoundingClientRect()[e[3]]}})),this.__axis="up"===e.direction||"down"===e.direction?"Y":"X";else{if(e.isFinal)return o.classList.remove("no-transition"),void(1===this.__scale?(o.style.transform="translate"+this.__axis+"("+100*this.__dir+"%)",this.timer=setTimeout((function(){r.$emit(r.__showing,{reset:r.reset}),r.$emit("action",{side:r.__showing,reset:r.reset})}),230)):o.style.transform="translate(0,0)");e.direction="X"===this.__axis?e.offset.x<0?"left":"right":e.offset.y<0?"up":"down"}void 0===this.$scopedSlots.left&&e.direction===this.langDir.right||void 0===this.$scopedSlots.right&&e.direction===this.langDir.left||void 0===this.$scopedSlots.top&&"down"===e.direction||void 0===this.$scopedSlots.bottom&&"up"===e.direction?o.style.transform="translate(0,0)":("X"===this.__axis?(n="left"===e.direction?-1:1,t=1===n?this.langDir.left:this.langDir.right,i=e.distance.x):(n="up"===e.direction?-2:2,t=2===n?"top":"bottom",i=e.distance.y),null!==this.__dir&&Math.abs(n)!==Math.abs(this.__dir)||(this.__dir!==n&&(["left","right","top","bottom"].forEach((function(e){void 0!==r.$refs[e]&&(r.$refs[e].style.visibility=t===e?"visible":"hidden")})),this.__showing=t,this.__dir=n),this.__scale=Math.max(0,Math.min(1,(i-40)/this.__size[t])),o.style.transform="translate"+this.__axis+"("+i*n/Math.abs(n)+"px)",this.$refs[t+"Content"].style.transform="scale("+this.__scale+")"))}},render:function(e){var t=this,n=[],i={left:void 0!==this.$scopedSlots[this.langDir.right],right:void 0!==this.$scopedSlots[this.langDir.left],up:void 0!==this.$scopedSlots.bottom,down:void 0!==this.$scopedSlots.top},r=Object.keys(i).filter((function(e){return!0===i[e]}));return $a.forEach((function(i){var r=i[0];void 0!==t.$scopedSlots[r]&&n.push(e("div",{ref:r,class:"q-slide-item__"+r+" absolute-full row no-wrap items-"+i[1]+" justify-"+i[2]+(void 0!==t[r+"Color"]?" bg-"+t[r+"Color"]:"")},[e("div",{ref:r+"Content"},t.$scopedSlots[r]())]))})),n.push(e("div",{ref:"content",key:"content",staticClass:"q-slide-item__content",directives:r.length>0?me(this,"dir#"+r.join(""),(function(){var e={prevent:!0,stop:!0,mouse:!0};return r.forEach((function(t){e[t]=!0})),[{name:"touch-pan",value:t.__pan,modifiers:e}]})):null},Le(this,"default"))),e("div",{staticClass:"q-slide-item q-item-type overflow-hidden",class:!0===this.isDark?"q-slide-item--dark q-dark":"",on:Object.assign({},this.qListeners)},n)},beforeDestroy:function(){clearTimeout(this.timer)}}),Ba=e.extend({name:"QSpace",mixins:[Pe],render:function(e){return e("div",{staticClass:"q-space",on:Object.assign({},this.qListeners)})}}),Va=e.extend({name:"QSpinnerAudio",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",fill:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 55 80",xmlns:"http://www.w3.org/2000/svg"}},[e("g",{attrs:{transform:"matrix(1 0 0 -1 0 80)"}},[e("rect",{attrs:{width:"10",height:"20",rx:"3"}},[e("animate",{attrs:{attributeName:"height",begin:"0s",dur:"4.3s",values:"20;45;57;80;64;32;66;45;64;23;66;13;64;56;34;34;2;23;76;79;20",calcMode:"linear",repeatCount:"indefinite"}})]),e("rect",{attrs:{x:"15",width:"10",height:"80",rx:"3"}},[e("animate",{attrs:{attributeName:"height",begin:"0s",dur:"2s",values:"80;55;33;5;75;23;73;33;12;14;60;80",calcMode:"linear",repeatCount:"indefinite"}})]),e("rect",{attrs:{x:"30",width:"10",height:"50",rx:"3"}},[e("animate",{attrs:{attributeName:"height",begin:"0s",dur:"1.4s",values:"50;34;78;23;56;23;34;76;80;54;21;50",calcMode:"linear",repeatCount:"indefinite"}})]),e("rect",{attrs:{x:"45",width:"10",height:"30",rx:"3"}},[e("animate",{attrs:{attributeName:"height",begin:"0s",dur:"2s",values:"30;45;13;80;56;72;45;76;34;23;67;30",calcMode:"linear",repeatCount:"indefinite"}})])])])}}),Ha=e.extend({name:"QSpinnerBall",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",stroke:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 57 57",xmlns:"http://www.w3.org/2000/svg"}},[e("g",{attrs:{transform:"translate(1 1)","stroke-width":"2",fill:"none","fill-rule":"evenodd"}},[e("circle",{attrs:{cx:"5",cy:"50",r:"5"}},[e("animate",{attrs:{attributeName:"cy",begin:"0s",dur:"2.2s",values:"50;5;50;50",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"cx",begin:"0s",dur:"2.2s",values:"5;27;49;5",calcMode:"linear",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"27",cy:"5",r:"5"}},[e("animate",{attrs:{attributeName:"cy",begin:"0s",dur:"2.2s",from:"5",to:"5",values:"5;50;50;5",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"cx",begin:"0s",dur:"2.2s",from:"27",to:"27",values:"27;49;5;27",calcMode:"linear",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"49",cy:"50",r:"5"}},[e("animate",{attrs:{attributeName:"cy",begin:"0s",dur:"2.2s",values:"50;50;5;50",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"cx",from:"49",to:"49",begin:"0s",dur:"2.2s",values:"49;5;27;49",calcMode:"linear",repeatCount:"indefinite"}})])])])}}),Wa=e.extend({name:"QSpinnerBars",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",fill:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 135 140",xmlns:"http://www.w3.org/2000/svg"}},[e("rect",{attrs:{y:"10",width:"15",height:"120",rx:"6"}},[e("animate",{attrs:{attributeName:"height",begin:"0.5s",dur:"1s",values:"120;110;100;90;80;70;60;50;40;140;120",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"y",begin:"0.5s",dur:"1s",values:"10;15;20;25;30;35;40;45;50;0;10",calcMode:"linear",repeatCount:"indefinite"}})]),e("rect",{attrs:{x:"30",y:"10",width:"15",height:"120",rx:"6"}},[e("animate",{attrs:{attributeName:"height",begin:"0.25s",dur:"1s",values:"120;110;100;90;80;70;60;50;40;140;120",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"y",begin:"0.25s",dur:"1s",values:"10;15;20;25;30;35;40;45;50;0;10",calcMode:"linear",repeatCount:"indefinite"}})]),e("rect",{attrs:{x:"60",width:"15",height:"140",rx:"6"}},[e("animate",{attrs:{attributeName:"height",begin:"0s",dur:"1s",values:"120;110;100;90;80;70;60;50;40;140;120",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"y",begin:"0s",dur:"1s",values:"10;15;20;25;30;35;40;45;50;0;10",calcMode:"linear",repeatCount:"indefinite"}})]),e("rect",{attrs:{x:"90",y:"10",width:"15",height:"120",rx:"6"}},[e("animate",{attrs:{attributeName:"height",begin:"0.25s",dur:"1s",values:"120;110;100;90;80;70;60;50;40;140;120",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"y",begin:"0.25s",dur:"1s",values:"10;15;20;25;30;35;40;45;50;0;10",calcMode:"linear",repeatCount:"indefinite"}})]),e("rect",{attrs:{x:"120",y:"10",width:"15",height:"120",rx:"6"}},[e("animate",{attrs:{attributeName:"height",begin:"0.5s",dur:"1s",values:"120;110;100;90;80;70;60;50;40;140;120",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"y",begin:"0.5s",dur:"1s",values:"10;15;20;25;30;35;40;45;50;0;10",calcMode:"linear",repeatCount:"indefinite"}})])])}}),Ua=e.extend({name:"QSpinnerComment",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,xmlns:"http://www.w3.org/2000/svg",viewBox:"0 0 100 100",preserveAspectRatio:"xMidYMid"}},[e("rect",{attrs:{x:"0",y:"0",width:"100",height:"100",fill:"none"}}),e("path",{attrs:{d:"M78,19H22c-6.6,0-12,5.4-12,12v31c0,6.6,5.4,12,12,12h37.2c0.4,3,1.8,5.6,3.7,7.6c2.4,2.5,5.1,4.1,9.1,4 c-1.4-2.1-2-7.2-2-10.3c0-0.4,0-0.8,0-1.3h8c6.6,0,12-5.4,12-12V31C90,24.4,84.6,19,78,19z",fill:"currentColor"}}),e("circle",{attrs:{cx:"30",cy:"47",r:"5",fill:"#fff"}},[e("animate",{attrs:{attributeName:"opacity",from:"0",to:"1",values:"0;1;1",keyTimes:"0;0.2;1",dur:"1s",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"50",cy:"47",r:"5",fill:"#fff"}},[e("animate",{attrs:{attributeName:"opacity",from:"0",to:"1",values:"0;0;1;1",keyTimes:"0;0.2;0.4;1",dur:"1s",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"70",cy:"47",r:"5",fill:"#fff"}},[e("animate",{attrs:{attributeName:"opacity",from:"0",to:"1",values:"0;0;1;1",keyTimes:"0;0.4;0.6;1",dur:"1s",repeatCount:"indefinite"}})])])}}),Ya=e.extend({name:"QSpinnerCube",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,xmlns:"http://www.w3.org/2000/svg",viewBox:"0 0 100 100",preserveAspectRatio:"xMidYMid"}},[e("rect",{attrs:{x:"0",y:"0",width:"100",height:"100",fill:"none"}}),e("g",{attrs:{transform:"translate(25 25)"}},[e("rect",{attrs:{x:"-20",y:"-20",width:"40",height:"40",fill:"currentColor",opacity:"0.9"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"scale",from:"1.5",to:"1",repeatCount:"indefinite",begin:"0s",dur:"1s",calcMode:"spline",keySplines:"0.2 0.8 0.2 0.8",keyTimes:"0;1"}})])]),e("g",{attrs:{transform:"translate(75 25)"}},[e("rect",{attrs:{x:"-20",y:"-20",width:"40",height:"40",fill:"currentColor",opacity:"0.8"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"scale",from:"1.5",to:"1",repeatCount:"indefinite",begin:"0.1s",dur:"1s",calcMode:"spline",keySplines:"0.2 0.8 0.2 0.8",keyTimes:"0;1"}})])]),e("g",{attrs:{transform:"translate(25 75)"}},[e("rect",{staticClass:"cube",attrs:{x:"-20",y:"-20",width:"40",height:"40",fill:"currentColor",opacity:"0.7"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"scale",from:"1.5",to:"1",repeatCount:"indefinite",begin:"0.3s",dur:"1s",calcMode:"spline",keySplines:"0.2 0.8 0.2 0.8",keyTimes:"0;1"}})])]),e("g",{attrs:{transform:"translate(75 75)"}},[e("rect",{staticClass:"cube",attrs:{x:"-20",y:"-20",width:"40",height:"40",fill:"currentColor",opacity:"0.6"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"scale",from:"1.5",to:"1",repeatCount:"indefinite",begin:"0.2s",dur:"1s",calcMode:"spline",keySplines:"0.2 0.8 0.2 0.8",keyTimes:"0;1"}})])])])}}),Ga=e.extend({name:"QSpinnerDots",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",fill:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 120 30",xmlns:"http://www.w3.org/2000/svg"}},[e("circle",{attrs:{cx:"15",cy:"15",r:"15"}},[e("animate",{attrs:{attributeName:"r",from:"15",to:"15",begin:"0s",dur:"0.8s",values:"15;9;15",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"fill-opacity",from:"1",to:"1",begin:"0s",dur:"0.8s",values:"1;.5;1",calcMode:"linear",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"60",cy:"15",r:"9","fill-opacity":".3"}},[e("animate",{attrs:{attributeName:"r",from:"9",to:"9",begin:"0s",dur:"0.8s",values:"9;15;9",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"fill-opacity",from:".5",to:".5",begin:"0s",dur:"0.8s",values:".5;1;.5",calcMode:"linear",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"105",cy:"15",r:"15"}},[e("animate",{attrs:{attributeName:"r",from:"15",to:"15",begin:"0s",dur:"0.8s",values:"15;9;15",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"fill-opacity",from:"1",to:"1",begin:"0s",dur:"0.8s",values:"1;.5;1",calcMode:"linear",repeatCount:"indefinite"}})])])}}),Qa=e.extend({name:"QSpinnerFacebook",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"0 0 100 100",xmlns:"http://www.w3.org/2000/svg",preserveAspectRatio:"xMidYMid"}},[e("g",{attrs:{transform:"translate(20 50)"}},[e("rect",{attrs:{x:"-10",y:"-30",width:"20",height:"60",fill:"currentColor",opacity:"0.6"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"scale",from:"2",to:"1",begin:"0s",repeatCount:"indefinite",dur:"1s",calcMode:"spline",keySplines:"0.1 0.9 0.4 1",keyTimes:"0;1",values:"2;1"}})])]),e("g",{attrs:{transform:"translate(50 50)"}},[e("rect",{attrs:{x:"-10",y:"-30",width:"20",height:"60",fill:"currentColor",opacity:"0.8"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"scale",from:"2",to:"1",begin:"0.1s",repeatCount:"indefinite",dur:"1s",calcMode:"spline",keySplines:"0.1 0.9 0.4 1",keyTimes:"0;1",values:"2;1"}})])]),e("g",{attrs:{transform:"translate(80 50)"}},[e("rect",{attrs:{x:"-10",y:"-30",width:"20",height:"60",fill:"currentColor",opacity:"0.9"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"scale",from:"2",to:"1",begin:"0.2s",repeatCount:"indefinite",dur:"1s",calcMode:"spline",keySplines:"0.1 0.9 0.4 1",keyTimes:"0;1",values:"2;1"}})])])])}}),Ka=e.extend({name:"QSpinnerGears",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"0 0 100 100",preserveAspectRatio:"xMidYMid",xmlns:"http://www.w3.org/2000/svg"}},[e("g",{attrs:{transform:"translate(-20,-20)"}},[e("path",{attrs:{d:"M79.9,52.6C80,51.8,80,50.9,80,50s0-1.8-0.1-2.6l-5.1-0.4c-0.3-2.4-0.9-4.6-1.8-6.7l4.2-2.9c-0.7-1.6-1.6-3.1-2.6-4.5 L70,35c-1.4-1.9-3.1-3.5-4.9-4.9l2.2-4.6c-1.4-1-2.9-1.9-4.5-2.6L59.8,27c-2.1-0.9-4.4-1.5-6.7-1.8l-0.4-5.1C51.8,20,50.9,20,50,20 s-1.8,0-2.6,0.1l-0.4,5.1c-2.4,0.3-4.6,0.9-6.7,1.8l-2.9-4.1c-1.6,0.7-3.1,1.6-4.5,2.6l2.1,4.6c-1.9,1.4-3.5,3.1-5,4.9l-4.5-2.1 c-1,1.4-1.9,2.9-2.6,4.5l4.1,2.9c-0.9,2.1-1.5,4.4-1.8,6.8l-5,0.4C20,48.2,20,49.1,20,50s0,1.8,0.1,2.6l5,0.4 c0.3,2.4,0.9,4.7,1.8,6.8l-4.1,2.9c0.7,1.6,1.6,3.1,2.6,4.5l4.5-2.1c1.4,1.9,3.1,3.5,5,4.9l-2.1,4.6c1.4,1,2.9,1.9,4.5,2.6l2.9-4.1 c2.1,0.9,4.4,1.5,6.7,1.8l0.4,5.1C48.2,80,49.1,80,50,80s1.8,0,2.6-0.1l0.4-5.1c2.3-0.3,4.6-0.9,6.7-1.8l2.9,4.2 c1.6-0.7,3.1-1.6,4.5-2.6L65,69.9c1.9-1.4,3.5-3,4.9-4.9l4.6,2.2c1-1.4,1.9-2.9,2.6-4.5L73,59.8c0.9-2.1,1.5-4.4,1.8-6.7L79.9,52.6 z M50,65c-8.3,0-15-6.7-15-15c0-8.3,6.7-15,15-15s15,6.7,15,15C65,58.3,58.3,65,50,65z",fill:"currentColor"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"90 50 50",to:"0 50 50",dur:"1s",repeatCount:"indefinite"}})])]),e("g",{attrs:{transform:"translate(20,20) rotate(15 50 50)"}},[e("path",{attrs:{d:"M79.9,52.6C80,51.8,80,50.9,80,50s0-1.8-0.1-2.6l-5.1-0.4c-0.3-2.4-0.9-4.6-1.8-6.7l4.2-2.9c-0.7-1.6-1.6-3.1-2.6-4.5 L70,35c-1.4-1.9-3.1-3.5-4.9-4.9l2.2-4.6c-1.4-1-2.9-1.9-4.5-2.6L59.8,27c-2.1-0.9-4.4-1.5-6.7-1.8l-0.4-5.1C51.8,20,50.9,20,50,20 s-1.8,0-2.6,0.1l-0.4,5.1c-2.4,0.3-4.6,0.9-6.7,1.8l-2.9-4.1c-1.6,0.7-3.1,1.6-4.5,2.6l2.1,4.6c-1.9,1.4-3.5,3.1-5,4.9l-4.5-2.1 c-1,1.4-1.9,2.9-2.6,4.5l4.1,2.9c-0.9,2.1-1.5,4.4-1.8,6.8l-5,0.4C20,48.2,20,49.1,20,50s0,1.8,0.1,2.6l5,0.4 c0.3,2.4,0.9,4.7,1.8,6.8l-4.1,2.9c0.7,1.6,1.6,3.1,2.6,4.5l4.5-2.1c1.4,1.9,3.1,3.5,5,4.9l-2.1,4.6c1.4,1,2.9,1.9,4.5,2.6l2.9-4.1 c2.1,0.9,4.4,1.5,6.7,1.8l0.4,5.1C48.2,80,49.1,80,50,80s1.8,0,2.6-0.1l0.4-5.1c2.3-0.3,4.6-0.9,6.7-1.8l2.9,4.2 c1.6-0.7,3.1-1.6,4.5-2.6L65,69.9c1.9-1.4,3.5-3,4.9-4.9l4.6,2.2c1-1.4,1.9-2.9,2.6-4.5L73,59.8c0.9-2.1,1.5-4.4,1.8-6.7L79.9,52.6 z M50,65c-8.3,0-15-6.7-15-15c0-8.3,6.7-15,15-15s15,6.7,15,15C65,58.3,58.3,65,50,65z",fill:"currentColor"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 50 50",to:"90 50 50",dur:"1s",repeatCount:"indefinite"}})])])])}}),Za=e.extend({name:"QSpinnerGrid",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",fill:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 105 105",xmlns:"http://www.w3.org/2000/svg"}},[e("circle",{attrs:{cx:"12.5",cy:"12.5",r:"12.5"}},[e("animate",{attrs:{attributeName:"fill-opacity",begin:"0s",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"12.5",cy:"52.5",r:"12.5","fill-opacity":".5"}},[e("animate",{attrs:{attributeName:"fill-opacity",begin:"100ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"52.5",cy:"12.5",r:"12.5"}},[e("animate",{attrs:{attributeName:"fill-opacity",begin:"300ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"52.5",cy:"52.5",r:"12.5"}},[e("animate",{attrs:{attributeName:"fill-opacity",begin:"600ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"92.5",cy:"12.5",r:"12.5"}},[e("animate",{attrs:{attributeName:"fill-opacity",begin:"800ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"92.5",cy:"52.5",r:"12.5"}},[e("animate",{attrs:{attributeName:"fill-opacity",begin:"400ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"12.5",cy:"92.5",r:"12.5"}},[e("animate",{attrs:{attributeName:"fill-opacity",begin:"700ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"52.5",cy:"92.5",r:"12.5"}},[e("animate",{attrs:{attributeName:"fill-opacity",begin:"500ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"92.5",cy:"92.5",r:"12.5"}},[e("animate",{attrs:{attributeName:"fill-opacity",begin:"200ms",dur:"1s",values:"1;.2;1",calcMode:"linear",repeatCount:"indefinite"}})])])}}),Ja=e.extend({name:"QSpinnerHearts",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",fill:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 140 64",xmlns:"http://www.w3.org/2000/svg"}},[e("path",{attrs:{d:"M30.262 57.02L7.195 40.723c-5.84-3.976-7.56-12.06-3.842-18.063 3.715-6 11.467-7.65 17.306-3.68l4.52 3.76 2.6-5.274c3.716-6.002 11.47-7.65 17.304-3.68 5.84 3.97 7.56 12.054 3.842 18.062L34.49 56.118c-.897 1.512-2.793 1.915-4.228.9z","fill-opacity":".5"}},[e("animate",{attrs:{attributeName:"fill-opacity",begin:"0s",dur:"1.4s",values:"0.5;1;0.5",calcMode:"linear",repeatCount:"indefinite"}})]),e("path",{attrs:{d:"M105.512 56.12l-14.44-24.272c-3.716-6.008-1.996-14.093 3.843-18.062 5.835-3.97 13.588-2.322 17.306 3.68l2.6 5.274 4.52-3.76c5.84-3.97 13.593-2.32 17.308 3.68 3.718 6.003 1.998 14.088-3.842 18.064L109.74 57.02c-1.434 1.014-3.33.61-4.228-.9z","fill-opacity":".5"}},[e("animate",{attrs:{attributeName:"fill-opacity",begin:"0.7s",dur:"1.4s",values:"0.5;1;0.5",calcMode:"linear",repeatCount:"indefinite"}})]),e("path",{attrs:{d:"M67.408 57.834l-23.01-24.98c-5.864-6.15-5.864-16.108 0-22.248 5.86-6.14 15.37-6.14 21.234 0L70 16.168l4.368-5.562c5.863-6.14 15.375-6.14 21.235 0 5.863 6.14 5.863 16.098 0 22.247l-23.007 24.98c-1.43 1.556-3.757 1.556-5.188 0z"}})])}}),Xa=e.extend({name:"QSpinnerHourglass",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"0 0 100 100",preserveAspectRatio:"xMidYMid",xmlns:"http://www.w3.org/2000/svg"}},[e("g",[e("path",{staticClass:"glass",attrs:{fill:"none",stroke:"currentColor","stroke-width":"5","stroke-miterlimit":"10",d:"M58.4,51.7c-0.9-0.9-1.4-2-1.4-2.3s0.5-0.4,1.4-1.4 C70.8,43.8,79.8,30.5,80,15.5H70H30H20c0.2,15,9.2,28.1,21.6,32.3c0.9,0.9,1.4,1.2,1.4,1.5s-0.5,1.6-1.4,2.5 C29.2,56.1,20.2,69.5,20,85.5h10h40h10C79.8,69.5,70.8,55.9,58.4,51.7z"}}),e("clipPath",{attrs:{id:"uil-hourglass-clip1"}},[e("rect",{staticClass:"clip",attrs:{x:"15",y:"20",width:"70",height:"25"}},[e("animate",{attrs:{attributeName:"height",from:"25",to:"0",dur:"1s",repeatCount:"indefinite",values:"25;0;0",keyTimes:"0;0.5;1"}}),e("animate",{attrs:{attributeName:"y",from:"20",to:"45",dur:"1s",repeatCount:"indefinite",values:"20;45;45",keyTimes:"0;0.5;1"}})])]),e("clipPath",{attrs:{id:"uil-hourglass-clip2"}},[e("rect",{staticClass:"clip",attrs:{x:"15",y:"55",width:"70",height:"25"}},[e("animate",{attrs:{attributeName:"height",from:"0",to:"25",dur:"1s",repeatCount:"indefinite",values:"0;25;25",keyTimes:"0;0.5;1"}}),e("animate",{attrs:{attributeName:"y",from:"80",to:"55",dur:"1s",repeatCount:"indefinite",values:"80;55;55",keyTimes:"0;0.5;1"}})])]),e("path",{staticClass:"sand",attrs:{d:"M29,23c3.1,11.4,11.3,19.5,21,19.5S67.9,34.4,71,23H29z","clip-path":"url(#uil-hourglass-clip1)",fill:"currentColor"}}),e("path",{staticClass:"sand",attrs:{d:"M71.6,78c-3-11.6-11.5-20-21.5-20s-18.5,8.4-21.5,20H71.6z","clip-path":"url(#uil-hourglass-clip2)",fill:"currentColor"}}),e("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 50 50",to:"180 50 50",repeatCount:"indefinite",dur:"1s",values:"0 50 50;0 50 50;180 50 50",keyTimes:"0;0.7;1"}})])])}}),es=e.extend({name:"QSpinnerInfinity",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"0 0 100 100",preserveAspectRatio:"xMidYMid"}},[e("path",{attrs:{d:"M24.3,30C11.4,30,5,43.3,5,50s6.4,20,19.3,20c19.3,0,32.1-40,51.4-40C88.6,30,95,43.3,95,50s-6.4,20-19.3,20C56.4,70,43.6,30,24.3,30z",fill:"none",stroke:"currentColor","stroke-width":"8","stroke-dasharray":"10.691205342610678 10.691205342610678","stroke-dashoffset":"0"}},[e("animate",{attrs:{attributeName:"stroke-dashoffset",from:"0",to:"21.382410685221355",begin:"0",dur:"2s",repeatCount:"indefinite",fill:"freeze"}})])])}}),ts=e.extend({name:"QSpinnerIos",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,stroke:"currentColor",fill:"currentColor",viewBox:"0 0 64 64"}},[e("g",{attrs:{"stroke-width":"4","stroke-linecap":"round"}},[e("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(180)"}},[e("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:"1;.85;.7;.65;.55;.45;.35;.25;.15;.1;0;1",repeatCount:"indefinite"}})]),e("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(210)"}},[e("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:"0;1;.85;.7;.65;.55;.45;.35;.25;.15;.1;0",repeatCount:"indefinite"}})]),e("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(240)"}},[e("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".1;0;1;.85;.7;.65;.55;.45;.35;.25;.15;.1",repeatCount:"indefinite"}})]),e("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(270)"}},[e("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".15;.1;0;1;.85;.7;.65;.55;.45;.35;.25;.15",repeatCount:"indefinite"}})]),e("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(300)"}},[e("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".25;.15;.1;0;1;.85;.7;.65;.55;.45;.35;.25",repeatCount:"indefinite"}})]),e("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(330)"}},[e("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".35;.25;.15;.1;0;1;.85;.7;.65;.55;.45;.35",repeatCount:"indefinite"}})]),e("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(0)"}},[e("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".45;.35;.25;.15;.1;0;1;.85;.7;.65;.55;.45",repeatCount:"indefinite"}})]),e("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(30)"}},[e("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".55;.45;.35;.25;.15;.1;0;1;.85;.7;.65;.55",repeatCount:"indefinite"}})]),e("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(60)"}},[e("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".65;.55;.45;.35;.25;.15;.1;0;1;.85;.7;.65",repeatCount:"indefinite"}})]),e("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(90)"}},[e("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".7;.65;.55;.45;.35;.25;.15;.1;0;1;.85;.7",repeatCount:"indefinite"}})]),e("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(120)"}},[e("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:".85;.7;.65;.55;.45;.35;.25;.15;.1;0;1;.85",repeatCount:"indefinite"}})]),e("line",{attrs:{y1:"17",y2:"29",transform:"translate(32,32) rotate(150)"}},[e("animate",{attrs:{attributeName:"stroke-opacity",dur:"750ms",values:"1;.85;.7;.65;.55;.45;.35;.25;.15;.1;0;1",repeatCount:"indefinite"}})])])])}}),ns=e.extend({name:"QSpinnerOval",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",stroke:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 38 38",xmlns:"http://www.w3.org/2000/svg"}},[e("g",{attrs:{transform:"translate(1 1)","stroke-width":"2",fill:"none","fill-rule":"evenodd"}},[e("circle",{attrs:{"stroke-opacity":".5",cx:"18",cy:"18",r:"18"}}),e("path",{attrs:{d:"M36 18c0-9.94-8.06-18-18-18"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 18 18",to:"360 18 18",dur:"1s",repeatCount:"indefinite"}})])])])}}),is=e.extend({name:"QSpinnerPie",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"0 0 100 100",preserveAspectRatio:"xMidYMid",xmlns:"http://www.w3.org/2000/svg"}},[e("path",{attrs:{d:"M0 50A50 50 0 0 1 50 0L50 50L0 50",fill:"currentColor",opacity:"0.5"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 50 50",to:"360 50 50",dur:"0.8s",repeatCount:"indefinite"}})]),e("path",{attrs:{d:"M50 0A50 50 0 0 1 100 50L50 50L50 0",fill:"currentColor",opacity:"0.5"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 50 50",to:"360 50 50",dur:"1.6s",repeatCount:"indefinite"}})]),e("path",{attrs:{d:"M100 50A50 50 0 0 1 50 100L50 50L100 50",fill:"currentColor",opacity:"0.5"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 50 50",to:"360 50 50",dur:"2.4s",repeatCount:"indefinite"}})]),e("path",{attrs:{d:"M50 100A50 50 0 0 1 0 50L50 50L50 100",fill:"currentColor",opacity:"0.5"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 50 50",to:"360 50 50",dur:"3.2s",repeatCount:"indefinite"}})])])}}),rs=e.extend({name:"QSpinnerPuff",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",stroke:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 44 44",xmlns:"http://www.w3.org/2000/svg"}},[e("g",{attrs:{fill:"none","fill-rule":"evenodd","stroke-width":"2"}},[e("circle",{attrs:{cx:"22",cy:"22",r:"1"}},[e("animate",{attrs:{attributeName:"r",begin:"0s",dur:"1.8s",values:"1; 20",calcMode:"spline",keyTimes:"0; 1",keySplines:"0.165, 0.84, 0.44, 1",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"stroke-opacity",begin:"0s",dur:"1.8s",values:"1; 0",calcMode:"spline",keyTimes:"0; 1",keySplines:"0.3, 0.61, 0.355, 1",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"22",cy:"22",r:"1"}},[e("animate",{attrs:{attributeName:"r",begin:"-0.9s",dur:"1.8s",values:"1; 20",calcMode:"spline",keyTimes:"0; 1",keySplines:"0.165, 0.84, 0.44, 1",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"stroke-opacity",begin:"-0.9s",dur:"1.8s",values:"1; 0",calcMode:"spline",keyTimes:"0; 1",keySplines:"0.3, 0.61, 0.355, 1",repeatCount:"indefinite"}})])])])}}),os=e.extend({name:"QSpinnerRadio",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"0 0 100 100",preserveAspectRatio:"xMidYMid",xmlns:"http://www.w3.org/2000/svg"}},[e("g",{attrs:{transform:"scale(0.55)"}},[e("circle",{attrs:{cx:"30",cy:"150",r:"30",fill:"currentColor"}},[e("animate",{attrs:{attributeName:"opacity",from:"0",to:"1",dur:"1s",begin:"0",repeatCount:"indefinite",keyTimes:"0;0.5;1",values:"0;1;1"}})]),e("path",{attrs:{d:"M90,150h30c0-49.7-40.3-90-90-90v30C63.1,90,90,116.9,90,150z",fill:"currentColor"}},[e("animate",{attrs:{attributeName:"opacity",from:"0",to:"1",dur:"1s",begin:"0.1",repeatCount:"indefinite",keyTimes:"0;0.5;1",values:"0;1;1"}})]),e("path",{attrs:{d:"M150,150h30C180,67.2,112.8,0,30,0v30C96.3,30,150,83.7,150,150z",fill:"currentColor"}},[e("animate",{attrs:{attributeName:"opacity",from:"0",to:"1",dur:"1s",begin:"0.2",repeatCount:"indefinite",keyTimes:"0;0.5;1",values:"0;1;1"}})])])])}}),as=e.extend({name:"QSpinnerRings",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",stroke:"currentColor",width:this.cSize,height:this.cSize,viewBox:"0 0 45 45",xmlns:"http://www.w3.org/2000/svg"}},[e("g",{attrs:{fill:"none","fill-rule":"evenodd",transform:"translate(1 1)","stroke-width":"2"}},[e("circle",{attrs:{cx:"22",cy:"22",r:"6"}},[e("animate",{attrs:{attributeName:"r",begin:"1.5s",dur:"3s",values:"6;22",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"stroke-opacity",begin:"1.5s",dur:"3s",values:"1;0",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"stroke-width",begin:"1.5s",dur:"3s",values:"2;0",calcMode:"linear",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"22",cy:"22",r:"6"}},[e("animate",{attrs:{attributeName:"r",begin:"3s",dur:"3s",values:"6;22",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"stroke-opacity",begin:"3s",dur:"3s",values:"1;0",calcMode:"linear",repeatCount:"indefinite"}}),e("animate",{attrs:{attributeName:"stroke-width",begin:"3s",dur:"3s",values:"2;0",calcMode:"linear",repeatCount:"indefinite"}})]),e("circle",{attrs:{cx:"22",cy:"22",r:"8"}},[e("animate",{attrs:{attributeName:"r",begin:"0s",dur:"1.5s",values:"6;1;2;3;4;5;6",calcMode:"linear",repeatCount:"indefinite"}})])])])}}),ss=e.extend({name:"QSpinnerTail",mixins:[Ge],render:function(e){return e("svg",{staticClass:"q-spinner",class:this.classes,on:Object.assign({},this.qListeners),attrs:{focusable:"false",width:this.cSize,height:this.cSize,viewBox:"0 0 38 38",xmlns:"http://www.w3.org/2000/svg"}},[e("defs",[e("linearGradient",{attrs:{x1:"8.042%",y1:"0%",x2:"65.682%",y2:"23.865%",id:"a"}},[e("stop",{attrs:{"stop-color":"currentColor","stop-opacity":"0",offset:"0%"}}),e("stop",{attrs:{"stop-color":"currentColor","stop-opacity":".631",offset:"63.146%"}}),e("stop",{attrs:{"stop-color":"currentColor",offset:"100%"}})])]),e("g",{attrs:{transform:"translate(1 1)",fill:"none","fill-rule":"evenodd"}},[e("path",{attrs:{d:"M36 18c0-9.94-8.06-18-18-18",stroke:"url(#a)","stroke-width":"2"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 18 18",to:"360 18 18",dur:"0.9s",repeatCount:"indefinite"}})]),e("circle",{attrs:{fill:"currentColor",cx:"36",cy:"18",r:"1"}},[e("animateTransform",{attrs:{attributeName:"transform",type:"rotate",from:"0 18 18",to:"360 18 18",dur:"0.9s",repeatCount:"indefinite"}})])])])}}),ls=e.extend({name:"QSplitter",mixins:[je,Pe],directives:{TouchPan:Qn},props:{value:{type:Number,required:!0},reverse:Boolean,unit:{type:String,default:"%",validator:function(e){return["%","px"].includes(e)}},limits:{type:Array,validator:function(e){return 2===e.length&&("number"==typeof e[0]&&"number"==typeof e[1]&&(e[0]>=0&&e[0]<=e[1]))}},emitImmediately:Boolean,horizontal:Boolean,disable:Boolean,beforeClass:[Array,String,Object],afterClass:[Array,String,Object],separatorClass:[Array,String,Object],separatorStyle:[Array,String,Object]},watch:{value:{immediate:!0,handler:function(e){this.__normalize(e,this.computedLimits)}},limits:{deep:!0,handler:function(){var e=this;this.$nextTick((function(){e.__normalize(e.value,e.computedLimits)}))}}},computed:{classes:function(){return(!0===this.horizontal?"column":"row")+" q-splitter--"+(!0===this.horizontal?"horizontal":"vertical")+" q-splitter--"+(!0===this.disable?"disabled":"workable")+(!0===this.isDark?" q-splitter--dark":"")},prop:function(){return!0===this.horizontal?"height":"width"},side:function(){return!0!==this.reverse?"before":"after"},computedLimits:function(){return void 0!==this.limits?this.limits:"%"===this.unit?[10,90]:[50,1/0]},styles:function(){var e,t;return(t={})[this.side]=((e={})[this.prop]=this.__getCSSValue(this.value),e),t},separatorDirectives:function(){var e;if(!0!==this.disable)return[{name:"touch-pan",value:this.__pan,modifiers:(e={},e[!0===this.horizontal?"vertical":"horizontal"]=!0,e.prevent=!0,e.stop=!0,e.mouse=!0,e.mouseAllDir=!0,e)}]}},methods:{__pan:function(e){if(!0===e.isFirst){var t=this.$el.getBoundingClientRect()[this.prop];return this.__dir=!0===this.horizontal?"up":"left",this.__maxValue="%"===this.unit?100:t,this.__value=Math.min(this.__maxValue,this.computedLimits[1],Math.max(this.computedLimits[0],this.value)),this.__multiplier=(!0!==this.reverse?1:-1)*(!0===this.horizontal?1:!0===this.$q.lang.rtl?-1:1)*("%"===this.unit?0===t?0:100/t:1),void this.$el.classList.add("q-splitter--active")}if(!0===e.isFinal)return this.__normalized!==this.value&&this.$emit("input",this.__normalized),void this.$el.classList.remove("q-splitter--active");var n=this.__value+this.__multiplier*(e.direction===this.__dir?-1:1)*e.distance[!0===this.horizontal?"y":"x"];this.__normalized=Math.min(this.__maxValue,this.computedLimits[1],Math.max(this.computedLimits[0],n)),this.$refs[this.side].style[this.prop]=this.__getCSSValue(this.__normalized),!0===this.emitImmediately&&this.value!==this.__normalized&&this.$emit("input",this.__normalized)},__normalize:function(e,t){e<t[0]?this.$emit("input",t[0]):e>t[1]&&this.$emit("input",t[1])},__getCSSValue:function(e){return("%"===this.unit?e:Math.round(e))+this.unit}},render:function(e){var t=!0===this.disable?{"aria-disabled":"true"}:void 0,n=[e("div",{ref:"before",staticClass:"q-splitter__panel q-splitter__before"+(!0===this.reverse?" col":""),style:this.styles.before,class:this.beforeClass,on:pe(this,"stop",{input:b})},Le(this,"before")),e("div",{staticClass:"q-splitter__separator",style:this.separatorStyle,class:this.separatorClass,attrs:t},[e("div",{staticClass:"absolute-full q-splitter__separator-area",directives:this.separatorDirectives},Le(this,"separator"))]),e("div",{ref:"after",staticClass:"q-splitter__panel q-splitter__after"+(!0===this.reverse?"":" col"),style:this.styles.after,class:this.afterClass,on:pe(this,"stop",{input:b})},Le(this,"after"))];return e("div",{staticClass:"q-splitter no-wrap",class:this.classes,on:Object.assign({},this.qListeners)},qe(n,this,"default"))}}),cs=e.extend({name:"StepHeader",mixins:[_e],directives:{Ripple:ot},props:{stepper:{},step:{}},computed:{isActive:function(){return this.stepper.value===this.step.name},isDisable:function(){var e=this.step.disable;return!0===e||""===e},isError:function(){var e=this.step.error;return!0===e||""===e},isDone:function(){var e=this.step.done;return!1===this.isDisable&&(!0===e||""===e)},headerNav:function(){var e=this.step.headerNav,t=!0===e||""===e||void 0===e;return!1===this.isDisable&&this.stepper.headerNav&&t},hasPrefix:function(){return this.step.prefix&&!1===this.isActive&&!1===this.isError&&!1===this.isDone},icon:function(){return!0===this.isActive?this.step.activeIcon||this.stepper.activeIcon||this.$q.iconSet.stepper.active:!0===this.isError?this.step.errorIcon||this.stepper.errorIcon||this.$q.iconSet.stepper.error:!1===this.isDisable&&!0===this.isDone?this.step.doneIcon||this.stepper.doneIcon||this.$q.iconSet.stepper.done:this.step.icon||this.stepper.inactiveIcon},color:function(){var e=!0===this.isError?this.step.errorColor||this.stepper.errorColor:void 0;if(!0===this.isActive){var t=this.step.activeColor||this.stepper.activeColor||this.step.color;return void 0!==t?t:e}return void 0!==e?e:!1===this.isDisable&&!0===this.isDone?this.step.doneColor||this.stepper.doneColor||this.step.color||this.stepper.inactiveColor:this.step.color||this.stepper.inactiveColor},classes:function(){return"q-stepper__tab col-grow flex items-center no-wrap relative-position"+(void 0!==this.color?" text-"+this.color:"")+(!0===this.isError?" q-stepper__tab--error":"")+(!0===this.isActive?" q-stepper__tab--active":"")+(!0===this.isDone?" q-stepper__tab--done":"")+(!0===this.headerNav?" q-stepper__tab--navigation q-focusable q-hoverable":"")+(!0===this.isDisable?" q-stepper__tab--disabled":"")}},methods:{activate:function(){void 0!==this.$refs.blurTarget&&this.$refs.blurTarget.focus(),!1===this.isActive&&this.stepper.goTo(this.step.name)},keyup:function(e){13===e.keyCode&&!1===this.isActive&&this.stepper.goTo(this.step.name)}},render:function(e){var t={class:this.classes};!0===this.stepper.headerNav&&(t.directives=[{name:"ripple",value:this.headerNav}]),!0===this.headerNav&&Object.assign(t,{on:pe(this,"headnavon",{click:this.activate,keyup:this.keyup}),attrs:!0===this.isDisable?{tabindex:-1,"aria-disabled":"true"}:{tabindex:this.qAttrs.tabindex||0}});var n=[e("div",{staticClass:"q-focus-helper",attrs:{tabindex:-1},ref:"blurTarget"}),e("div",{staticClass:"q-stepper__dot row flex-center q-stepper__line relative-position"},[e("span",{staticClass:"row flex-center"},[!0===this.hasPrefix?this.step.prefix:e(De,{props:{name:this.icon}})])])];if(void 0!==this.step.title&&null!==this.step.title){var i=[e("div",{staticClass:"q-stepper__title"},[this.step.title])];void 0!==this.step.caption&&null!==this.step.caption&&i.push(e("div",{staticClass:"q-stepper__caption"},[this.step.caption])),n.push(e("div",{staticClass:"q-stepper__label q-stepper__line relative-position"},i))}return e("div",t,n)}}),us=e.extend({name:"QStepWrapper",render:function(e){return e("div",{staticClass:"q-stepper__step-content"},[e("div",{staticClass:"q-stepper__step-inner"},Le(this,"default"))])}}),ds=e.extend({name:"QStep",inject:{stepper:{default:function(){console.error("QStep needs to be child of QStepper")}}},mixins:[bn],props:{icon:String,color:String,title:{type:String,required:!0},caption:String,prefix:[String,Number],doneIcon:String,doneColor:String,activeIcon:String,activeColor:String,errorIcon:String,errorColor:String,headerNav:{type:Boolean,default:!0},done:Boolean,error:Boolean},computed:{isActive:function(){return this.stepper.value===this.name}},watch:{isActive:function(e){var t=this;!0===e&&!0===this.stepper.vertical&&this.$nextTick((function(){void 0!==t.$el&&(t.$el.scrollTop=0)}))}},render:function(e){var t=this.stepper.vertical,n=!0===t&&!0===this.stepper.keepAlive?e("keep-alive",!0===this.isActive?[e(us,{key:this.name},Le(this,"default"))]:void 0):!0!==t||!0===this.isActive?us.options.render.call(this,e):void 0;return e("div",{staticClass:"q-stepper__step",on:Object.assign({},this.qListeners)},!0===t?[e(cs,{props:{stepper:this.stepper,step:this}}),!0===this.stepper.animated?e(_o,[n]):n]:[n])}}),hs=e.extend({name:"QStepper",provide:function(){return{stepper:this}},mixins:[je,_n],props:{flat:Boolean,bordered:Boolean,alternativeLabels:Boolean,headerNav:Boolean,contracted:Boolean,headerClass:String,inactiveColor:String,inactiveIcon:String,doneIcon:String,doneColor:String,activeIcon:String,activeColor:String,errorIcon:String,errorColor:String},computed:{classes:function(){return"q-stepper q-stepper--"+(!0===this.vertical?"vertical":"horizontal")+(!0===this.flat||!0===this.isDark?" q-stepper--flat no-shadow":"")+(!0===this.bordered||!0===this.isDark&&!1===this.flat?" q-stepper--bordered":"")+(!0===this.contracted?" q-stepper--contracted":"")+(!0===this.isDark?" q-stepper--dark q-dark":"")},headerClasses:function(){return"q-stepper__header row items-stretch justify-between q-stepper__header--"+(!0===this.alternativeLabels?"alternative":"standard")+"-labels"+(!1===this.flat||!0===this.bordered?" q-stepper__header--border":"")+(void 0!==this.headerClass?" "+this.headerClass:"")}},methods:{__getContent:function(e){var t=this,n=Le(this,"message",[]);if(!0===this.vertical){this.__isValidPanelName(this.value)&&this.__updatePanelIndex();var i=e("div",{staticClass:"q-stepper__content",on:pe(this,"stop",{input:b})},Le(this,"default"));return void 0===n?[i]:n.concat(i)}return[e("div",{class:this.headerClasses},this.__getAllPanels().map((function(n){var i=n.componentOptions.propsData;return e(cs,{key:i.name,props:{stepper:t,step:i}})})))].concat(n,e("div",{staticClass:"q-stepper__content q-panel-parent",directives:this.panelDirectives},this.__getPanelContent(e)))},__renderPanels:function(e){return e("div",{class:this.classes,on:Object.assign({},this.qListeners)},qe(this.__getContent(e),this,"navigation"))}}}),fs=e.extend({name:"QStepperNavigation",mixins:[Pe],render:function(e){return e("div",{staticClass:"q-stepper__nav",on:Object.assign({},this.qListeners)},Le(this,"default"))}}),ps=e.extend({name:"QTh",mixins:[Pe],props:{props:Object,autoWidth:Boolean},render:function(e){var t,n,i=this,r=Object.assign({},this.qListeners);if(void 0===this.props)return e("th",{on:r,class:!0===this.autoWidth?"q-table--col-auto-width":null},Le(this,"default"));var o=this.$vnode.key;if(o){if(void 0===(t=this.props.colsMap[o]))return}else t=this.props.col;if(!0===t.sortable){var a="right"===t.align?"unshift":"push";(n=Oe(this,"default",[]))[a](e(De,{props:{name:this.$q.iconSet.table.arrowUp},staticClass:t.__iconClass}))}else n=Le(this,"default");var s=!0===t.sortable?{click:function(e){i.props.sort(t),i.$emit("click",e)}}:{};return e("th",{on:Object.assign({},r,s),style:t.headerStyle,class:t.__thClass+(!0===this.autoWidth?" q-table--col-auto-width":"")},n)}}),ms={methods:{getTableHeader:function(e){var t=this.getTableHeaderRow(e);return!0===this.loading&&void 0===this.$scopedSlots.loading&&t.push(e("tr",{staticClass:"q-table__progress"},[e("th",{staticClass:"relative-position",attrs:{colspan:this.computedColspan}},this.__getProgress(e))])),e("thead",t)},getTableHeaderRow:function(e){var t=this,n=this.$scopedSlots.header,i=this.$scopedSlots["header-cell"];if(void 0!==n)return n(this.addTableHeaderRowMeta({header:!0,cols:this.computedCols,sort:this.sort,colsMap:this.computedColsMap})).slice();var r=this.computedCols.map((function(n){var r=t.$scopedSlots["header-cell-"+n.name],o=void 0!==r?r:i,a={col:n,cols:t.computedCols,sort:t.sort,colsMap:t.computedColsMap};return void 0!==o?o(a):e(ps,{key:n.name,props:{props:a},style:n.headerStyle,class:n.headerClasses},n.label)}));return!0===this.singleSelection&&!0!==this.grid?r.unshift(e("th",{staticClass:"q-table--col-auto-width"},[" "])):!0===this.multipleSelection&&r.unshift(e("th",{staticClass:"q-table--col-auto-width"},[e(Dn,{props:{color:this.color,value:!0===this.someRowsSelected?null:this.allRowsSelected,dark:this.isDark,dense:this.dense},on:pe(this,"inp",{input:function(e){!0===t.someRowsSelected&&(e=!1),t.__updateSelection(t.computedRows.map(t.getRowKey),t.computedRows,e)}})})])),[e("tr",{style:this.tableHeaderStyle,class:this.tableHeaderClass},r)]},addTableHeaderRowMeta:function(e){var t=this;return!0===this.multipleSelection&&(Object.defineProperty(e,"selected",{get:function(){return!0===t.someRowsSelected?"some":t.allRowsSelected},set:function(e){!0===t.someRowsSelected&&(e=!1),t.__updateSelection(t.computedRows.map(t.getRowKey),t.computedRows,e)},configurable:!0,enumerable:!0}),e.partialSelected=this.someRowsSelected,e.multipleSelect=!0),e}}},vs={methods:{getTableRowBody:function(e,t,n){var i=this.getRowKey(e),r=this.isRowSelected(i);return t(this.addBodyRowMeta({key:i,row:e,pageIndex:n,cols:this.computedCols,colsMap:this.computedColsMap,__trClass:r?"selected":""}))},getTableRow:function(e,t,n){var i=this,r=this.$scopedSlots["body-cell"],o=this.getRowKey(t),a=this.isRowSelected(o),s=this.computedCols.map((function(o){var a=i.$scopedSlots["body-cell-"+o.name],s=void 0!==a?a:r;return void 0!==s?s(i.addBodyCellMetaData({row:t,pageIndex:n,col:o})):e("td",{class:o.__tdClass,style:o.style},i.getCellValue(o,t))}));!0===this.hasSelectionMode&&s.unshift(e("td",{staticClass:"q-table--col-auto-width"},[e(Dn,{props:{value:a,color:this.color,dark:this.isDark,dense:this.dense},on:{input:function(e,n){i.__updateSelection([o],[t],e,n)}}})]));var l={key:o,class:{selected:a},on:{}};return void 0!==this.qListeners["row-click"]&&(l.class["cursor-pointer"]=!0,l.on.click=function(e){i.$emit("row-click",e,t,n)}),void 0!==this.qListeners["row-dblclick"]&&(l.class["cursor-pointer"]=!0,l.on.dblclick=function(e){i.$emit("row-dblclick",e,t,n)}),e("tr",l,s)},getTableBody:function(e){var t=this,n=this.$scopedSlots.body,i=this.$scopedSlots["top-row"],r=this.$scopedSlots["bottom-row"],o=void 0!==n?function(e,i){return t.getTableRowBody(e,n,i)}:function(n,i){return t.getTableRow(e,n,i)},a=this.computedRows.map(o);return void 0!==i&&(a=i({cols:this.computedCols}).concat(a)),void 0!==r&&(a=a.concat(r({cols:this.computedCols}))),e("tbody",a)},getTableRowVirtual:function(e){var t=this,n=this.$scopedSlots.body;return void 0!==n?function(e){return t.getTableRowBody(e.item,n,e.index)}:function(n){return t.getTableRow(e,n.item,n.index)}},addBodyRowMeta:function(e){var t=this;return e.rowIndex=this.firstRowIndex+e.pageIndex,!0===this.hasSelectionMode&&Object.defineProperty(e,"selected",{get:function(){return t.isRowSelected(e.key)},set:function(n){t.__updateSelection([e.key],[e.row],n)},configurable:!0,enumerable:!0}),Object.defineProperty(e,"expand",{get:function(){return t.isRowExpanded(e.key)},set:function(n){t.__updateExpanded(e.key,n)},configurable:!0,enumerable:!0}),e.cols=e.cols.map((function(n){var i=Object.assign({},n);return Object.defineProperty(i,"value",{get:function(){return t.getCellValue(n,e.row)},configurable:!0,enumerable:!0}),i})),e},addBodyCellMetaData:function(e){var t=this;return e.rowIndex=this.firstRowIndex+e.pageIndex,Object.defineProperty(e,"value",{get:function(){return t.getCellValue(e.col,e.row)},configurable:!0,enumerable:!0}),e},getCellValue:function(e,t){var n="function"==typeof e.field?e.field(t):t[e.field];return void 0!==e.format?e.format(n,t):n}}},gs="q-table__bottom row items-center",_s={props:{hideBottom:Boolean,hideSelectedBanner:Boolean,hideNoData:Boolean,hidePagination:Boolean},computed:{navIcon:function(){var e=[this.iconFirstPage||this.$q.iconSet.table.firstPage,this.iconPrevPage||this.$q.iconSet.table.prevPage,this.iconNextPage||this.$q.iconSet.table.nextPage,this.iconLastPage||this.$q.iconSet.table.lastPage];return!0===this.$q.lang.rtl?e.reverse():e}},methods:{getBottom:function(e){if(!0!==this.hideBottom){if(!0===this.nothingToDisplay){if(!0===this.hideNoData)return;var t=!0===this.loading?this.loadingLabel||this.$q.lang.table.loading:this.filter?this.noResultsLabel||this.$q.lang.table.noResults:this.noDataLabel||this.$q.lang.table.noData,n=this.$scopedSlots["no-data"],i=void 0!==n?[n({message:t,icon:this.$q.iconSet.table.warning,filter:this.filter})]:[e(De,{staticClass:"q-table__bottom-nodata-icon",props:{name:this.$q.iconSet.table.warning}}),t];return e("div",{staticClass:gs+" q-table__bottom--nodata"},i)}var r=this.$scopedSlots.bottom;if(void 0!==r)return e("div",{staticClass:gs},[r(this.marginalsProps)]);var o=!0!==this.hideSelectedBanner&&!0===this.hasSelectionMode&&this.rowsSelectedNumber>0?[e("div",{staticClass:"q-table__control"},[e("div",[(this.selectedRowsLabel||this.$q.lang.table.selectedRecords)(this.rowsSelectedNumber)])])]:[];return!0!==this.hidePagination?e("div",{staticClass:gs+" justify-end"},this.getPaginationRow(e,o)):o.length>0?e("div",{staticClass:gs},o):void 0}},getPaginationRow:function(e,t){var n,i=this,r=this.computedPagination.rowsPerPage,o=this.paginationLabel||this.$q.lang.table.pagination,a=this.$scopedSlots.pagination,s=this.rowsPerPageOptions.length>1;if(t.push(e("div",{staticClass:"q-table__separator col"})),!0===s&&t.push(e("div",{staticClass:"q-table__control"},[e("span",{staticClass:"q-table__bottom-item"},[this.rowsPerPageLabel||this.$q.lang.table.recordsPerPage]),e(Na,{staticClass:"q-table__select inline q-table__bottom-item",props:{color:this.color,value:r,options:this.computedRowsPerPageOptions,displayValue:0===r?this.$q.lang.table.allRows:r,dark:this.isDark,borderless:!0,dense:!0,optionsDense:!0,optionsCover:!0},on:pe(this,"pgSize",{input:function(e){i.setPagination({page:1,rowsPerPage:e.value})}})})])),void 0!==a)n=a(this.marginalsProps);else if(n=[e("span",0!==r?{staticClass:"q-table__bottom-item"}:{},[r?o(this.firstRowIndex+1,Math.min(this.lastRowIndex,this.computedRowsNumber),this.computedRowsNumber):o(1,this.filteredSortedRowsNumber,this.computedRowsNumber)])],0!==r&&this.pagesNumber>1){var l={color:this.color,round:!0,dense:!0,flat:!0};!0===this.dense&&(l.size="sm"),this.pagesNumber>2&&n.push(e(bt,{key:"pgFirst",props:Object.assign({},l,{icon:this.navIcon[0],disable:this.isFirstPage}),on:pe(this,"pgFirst",{click:this.firstPage})})),n.push(e(bt,{key:"pgPrev",props:Object.assign({},l,{icon:this.navIcon[1],disable:this.isFirstPage}),on:pe(this,"pgPrev",{click:this.prevPage})}),e(bt,{key:"pgNext",props:Object.assign({},l,{icon:this.navIcon[2],disable:this.isLastPage}),on:pe(this,"pgNext",{click:this.nextPage})})),this.pagesNumber>2&&n.push(e(bt,{key:"pgLast",props:Object.assign({},l,{icon:this.navIcon[3],disable:this.isLastPage}),on:pe(this,"pgLast",{click:this.lastPage})}))}return t.push(e("div",{staticClass:"q-table__control"},n)),t}}},bs={methods:{getGridBody:function(e){var t=this,n=void 0!==this.$scopedSlots.item?this.$scopedSlots.item:function(n){var i=n.cols.map((function(t){return e("div",{staticClass:"q-table__grid-item-row"},[e("div",{staticClass:"q-table__grid-item-title"},[t.label]),e("div",{staticClass:"q-table__grid-item-value"},[t.value])])}));!0===t.hasSelectionMode&&i.unshift(e("div",{staticClass:"q-table__grid-item-row"},[e(Dn,{props:{value:n.selected,color:t.color,dark:t.isDark,dense:!0},on:{input:function(e,i){t.__updateSelection([n.key],[n.row],e,i)}}})]),e(wo,{props:{dark:t.isDark}}));var r={staticClass:"q-table__grid-item-card"+t.cardDefaultClass,class:t.cardClass,style:t.cardStyle,on:{}};return void 0===t.qListeners["row-click"]&&void 0===t.qListeners["row-dblclick"]||(r.staticClass+=" cursor-pointer"),void 0!==t.qListeners["row-click"]&&(r.on.click=function(e){t.$emit("row-click",e,n.row,n.pageIndex)}),void 0!==t.qListeners["row-dblclick"]&&(r.on.dblclick=function(e){t.$emit("row-dblclick",e,n.row,n.pageIndex)}),e("div",{staticClass:"q-table__grid-item col-xs-12 col-sm-6 col-md-4 col-lg-3",class:!0===n.selected?"q-table__grid-item--selected":""},[e("div",r,i)])};return e("div",{staticClass:"q-table__grid-content row",class:this.cardContainerClass,style:this.cardContainerStyle},this.computedRows.map((function(e,i){var r=t.getRowKey(e),o=t.isRowSelected(r);return n(t.addBodyRowMeta({key:r,row:e,pageIndex:i,cols:t.computedCols,colsMap:t.computedColsMap,__trClass:o?"selected":""}))})))},getGridHeader:function(e){var t=!0===this.gridHeader?[e("table",{staticClass:"q-table"},[this.getTableHeader(e)])]:!0===this.loading&&void 0===this.$scopedSlots.loading?this.__getProgress(e):void 0;return e("div",{staticClass:"q-table__middle"},t)}}};function ys(e,t,n){return e("div",Object.assign({},t,{staticClass:"q-table__middle"+(void 0!==t.staticClass?" "+t.staticClass:"")}),[e("table",{staticClass:"q-table"},n)])}var ws={list:Kr,table:Ko},ks=e.extend({name:"QVirtualScroll",mixins:[_e,Pe,Da],props:{type:{type:String,default:"list",validator:function(e){return["list","table","__qtable"].includes(e)}},items:{type:Array,default:function(){return[]}},itemsFn:Function,itemsSize:Number,scrollTarget:{default:void 0}},computed:{virtualScrollLength:function(){return this.itemsSize>=0&&void 0!==this.itemsFn?parseInt(this.itemsSize,10):Array.isArray(this.items)?this.items.length:0},virtualScrollScope:function(){var e=this;if(0===this.virtualScrollLength)return[];var t=function(t,n){return{index:e.virtualScrollSliceRange.from+n,item:t}};return void 0===this.itemsFn?this.items.slice(this.virtualScrollSliceRange.from,this.virtualScrollSliceRange.to).map(t):this.itemsFn(this.virtualScrollSliceRange.from,this.virtualScrollSliceRange.to-this.virtualScrollSliceRange.from).map(t)},classes:function(){return"q-virtual-scroll q-virtual-scroll"+(!0===this.virtualScrollHorizontal?"--horizontal":"--vertical")+(void 0!==this.scrollTarget?"":" scroll")},attrs:function(){return void 0!==this.scrollTarget?void 0:{tabindex:0}}},watch:{virtualScrollLength:function(){this.__resetVirtualScroll()},scrollTarget:function(){this.__unconfigureScrollTarget(),this.__configureScrollTarget()}},methods:{__getVirtualScrollEl:function(){return this.$el},__getVirtualScrollTarget:function(){return this.__scrollTarget},__configureScrollTarget:function(){this.__scrollTarget=jt(this.$el,this.scrollTarget),this.__scrollTarget.addEventListener("scroll",this.__onVirtualScrollEvt,f.passive)},__unconfigureScrollTarget:function(){void 0!==this.__scrollTarget&&(this.__scrollTarget.removeEventListener("scroll",this.__onVirtualScrollEvt,f.passive),this.__scrollTarget=void 0)}},beforeMount:function(){this.__resetVirtualScroll()},mounted:function(){this.__configureScrollTarget()},beforeDestroy:function(){this.__unconfigureScrollTarget()},render:function(e){if(void 0!==this.$scopedSlots.default){var t=this.__padVirtualScroll(e,"list"===this.type?"div":"tbody",this.virtualScrollScope.map(this.$scopedSlots.default));return void 0!==this.$scopedSlots.before&&(t=this.$scopedSlots.before().concat(t)),t=qe(t,this,"after"),"__qtable"===this.type?ys(e,{staticClass:this.classes},t):e(ws[this.type],{class:this.classes,attrs:this.attrs,props:this.qAttrs,on:Object.assign({},this.qListeners)},t)}console.error("QVirtualScroll: default scoped slot is required for rendering",this)}});var xs={props:{sortMethod:{type:Function,default:function(e,t,n){var i=this.colList.find((function(e){return e.name===t}));if(void 0===i||void 0===i.field)return e;var r=!0===n?-1:1,o="function"==typeof i.field?function(e){return i.field(e)}:function(e){return e[i.field]};return e.sort((function(e,t){var n,a=o(e),s=o(t);return null==a?-1*r:null==s?1*r:void 0!==i.sort?i.sort(a,s,e,t)*r:!0===Mn(a)&&!0===Mn(s)?(a-s)*r:!0===Cn(a)&&!0===Cn(s)?function(e,t){return new Date(e)-new Date(t)}(a,s)*r:"boolean"==typeof a&&"boolean"==typeof s?(a-s)*r:(n=[a,s].map((function(e){return(e+"").toLocaleString().toLowerCase()})),(a=n[0])<(s=n[1])?-1*r:a===s?0:r)}))}}},computed:{columnToSort:function(){var e=this.computedPagination.sortBy;if(e)return this.colList.find((function(t){return t.name===e}))||null}},methods:{sort:function(e){e===Object(e)&&(e=e.name);var t=this.computedPagination,n=t.sortBy,i=t.descending;n!==e?(n=e,i=!1):!0===this.binaryStateSort?i=!i:!0===i?n=null:i=!0,this.setPagination({sortBy:n,descending:i,page:1})}}},Ss={props:{filter:[String,Object],filterMethod:{type:Function,default:function(e,t,n,i){void 0===n&&(n=this.computedCols),void 0===i&&(i=this.getCellValue);var r=t?t.toLowerCase():"";return e.filter((function(e){return n.some((function(t){var n=i(t,e)+"";return-1!==("undefined"===n||"null"===n?"":n.toLowerCase()).indexOf(r)}))}))}}},watch:{filter:{handler:function(){var e=this;this.$nextTick((function(){e.setPagination({page:1},!0)}))},deep:!0}}};function Cs(e){return e.page<1&&(e.page=1),void 0!==e.rowsPerPage&&e.rowsPerPage<1&&(e.rowsPerPage=0),e}var Ms={props:{pagination:Object,rowsPerPageOptions:{type:Array,default:function(){return[5,7,10,15,20,25,50,0]}}},computed:{computedPagination:function(){return Cs(void 0!==this.qListeners["update:pagination"]?Object.assign({},this.innerPagination,this.pagination):this.innerPagination)},firstRowIndex:function(){var e=this.computedPagination;return(e.page-1)*e.rowsPerPage},lastRowIndex:function(){var e=this.computedPagination;return e.page*e.rowsPerPage},isFirstPage:function(){return 1===this.computedPagination.page},pagesNumber:function(){return 0===this.computedPagination.rowsPerPage?1:Math.max(1,Math.ceil(this.computedRowsNumber/this.computedPagination.rowsPerPage))},isLastPage:function(){return 0===this.lastRowIndex||this.computedPagination.page>=this.pagesNumber},computedRowsPerPageOptions:function(){var e=this;return(this.rowsPerPageOptions.includes(this.innerPagination.rowsPerPage)?this.rowsPerPageOptions:[this.innerPagination.rowsPerPage].concat(this.rowsPerPageOptions)).map((function(t){return{label:0===t?e.$q.lang.table.allRows:""+t,value:t}}))}},watch:{pagesNumber:function(e,t){if(e!==t){var n=this.computedPagination.page;e&&!n?this.setPagination({page:1}):e<n&&this.setPagination({page:e})}}},methods:{__sendServerRequest:function(e){this.requestServerInteraction({pagination:e,filter:this.filter})},setPagination:function(e,t){var n=Cs(Object.assign({},this.computedPagination,e));!function(e,t){for(var n in t)if(t[n]!==e[n])return!1;return!0}(this.computedPagination,n)?!0!==this.isServerSide?void 0!==this.pagination&&void 0!==this.qListeners["update:pagination"]?this.$emit("update:pagination",n):this.innerPagination=n:this.__sendServerRequest(n):!0===this.isServerSide&&!0===t&&this.__sendServerRequest(n)},firstPage:function(){this.setPagination({page:1})},prevPage:function(){var e=this.computedPagination.page;e>1&&this.setPagination({page:e-1})},nextPage:function(){var e=this.computedPagination,t=e.page,n=e.rowsPerPage;this.lastRowIndex>0&&t*n<this.computedRowsNumber&&this.setPagination({page:t+1})},lastPage:function(){this.setPagination({page:this.pagesNumber})}},created:function(){void 0!==this.qListeners["update:pagination"]&&this.$emit("update:pagination",Object.assign({},this.computedPagination))}},Ts={props:{selection:{type:String,default:"none",validator:function(e){return["single","multiple","none"].includes(e)}},selected:{type:Array,default:function(){return[]}}},computed:{selectedKeys:function(){var e={};return this.selected.map(this.getRowKey).forEach((function(t){e[t]=!0})),e},hasSelectionMode:function(){return"none"!==this.selection},singleSelection:function(){return"single"===this.selection},multipleSelection:function(){return"multiple"===this.selection},allRowsSelected:function(){var e=this;return this.computedRows.length>0&&this.computedRows.every((function(t){return!0===e.selectedKeys[e.getRowKey(t)]}))},someRowsSelected:function(){var e=this;return!0!==this.allRowsSelected&&this.computedRows.some((function(t){return!0===e.selectedKeys[e.getRowKey(t)]}))},rowsSelectedNumber:function(){return this.selected.length}},methods:{isRowSelected:function(e){return!0===this.selectedKeys[e]},clearSelection:function(){this.$emit("update:selected",[])},__updateSelection:function(e,t,n,i){var r=this;this.$emit("selection",{rows:t,added:n,keys:e,evt:i});var o=!0===this.singleSelection?!0===n?t:[]:!0===n?this.selected.concat(t):this.selected.filter((function(t){return!1===e.includes(r.getRowKey(t))}));this.$emit("update:selected",o)}}};function As(e){return Array.isArray(e)?e.slice():[]}var Ps={props:{expanded:Array},data:function(){return{innerExpanded:As(this.expanded)}},watch:{expanded:function(e){this.innerExpanded=As(e)}},methods:{isRowExpanded:function(e){return this.innerExpanded.includes(e)},setExpanded:function(e){void 0!==this.expanded?this.$emit("update:expanded",e):this.innerExpanded=e},__updateExpanded:function(e,t){var n=this.innerExpanded.slice(),i=n.indexOf(e);!0===t?-1===i&&(n.push(e),this.setExpanded(n)):-1!==i&&(n.splice(i,1),this.setExpanded(n))}}},Ls={props:{visibleColumns:Array},computed:{colList:function(){if(void 0!==this.columns)return this.columns;var e=this.data[0];return void 0!==e?Object.keys(e).map((function(t){return{name:t,label:t.toUpperCase(),field:t,align:Mn(e[t])?"right":"left",sortable:!0}})):[]},computedCols:function(){var e=this,t=this.computedPagination,n=t.sortBy,i=t.descending;return(void 0!==this.visibleColumns?this.colList.filter((function(t){return!0===t.required||!0===e.visibleColumns.includes(t.name)})):this.colList).map((function(e){var t=e.align||"right";return Object.assign({},e,{align:t,__iconClass:"q-table__sort-icon q-table__sort-icon--"+t,__thClass:"text-"+t+(void 0!==e.headerClasses?" "+e.headerClasses:"")+(!0===e.sortable?" sortable":"")+(e.name===n?" sorted "+(!0===i?"sort-desc":""):""),__tdClass:"text-"+t+(void 0!==e.classes?" "+e.classes:"")})}))},computedColsMap:function(){var e={};return this.computedCols.forEach((function(t){e[t.name]=t})),e},computedColspan:function(){return void 0!==this.tableColspan?this.tableColspan:this.computedCols.length+(!0===this.hasSelectionMode?1:0)}}},Os={};Ea.forEach((function(e){Os[e]={}}));var qs=e.extend({name:"QTable",mixins:[je,Pe,yn,{computed:{marginalsProps:function(){return{pagination:this.computedPagination,pagesNumber:this.pagesNumber,isFirstPage:this.isFirstPage,isLastPage:this.isLastPage,firstPage:this.firstPage,prevPage:this.prevPage,nextPage:this.nextPage,lastPage:this.lastPage,inFullscreen:this.inFullscreen,toggleFullscreen:this.toggleFullscreen}}},methods:{getTop:function(e){var t,n=this.$scopedSlots.top,i=this.$scopedSlots["top-left"],r=this.$scopedSlots["top-right"],o=this.$scopedSlots["top-selection"],a=!0===this.hasSelectionMode&&void 0!==o&&this.rowsSelectedNumber>0,s="q-table__top relative-position row items-center";return void 0!==n?e("div",{staticClass:s},[n(this.marginalsProps)]):(!0===a?t=o(this.marginalsProps).slice():(t=[],void 0!==i?t.push(e("div",{staticClass:"q-table-control"},[i(this.marginalsProps)])):this.title&&t.push(e("div",{staticClass:"q-table__control"},[e("div",{staticClass:"q-table__title",class:this.titleClass},this.title)]))),void 0!==r&&(t.push(e("div",{staticClass:"q-table__separator col"})),t.push(e("div",{staticClass:"q-table__control"},[r(this.marginalsProps)]))),0!==t.length?e("div",{staticClass:s},t):void 0)}}},ms,vs,_s,bs,xs,Ss,Ms,Ts,Ps,Ls],props:Object.assign({},{data:{type:Array,default:function(){return[]}},rowKey:{type:[String,Function],default:"id"},columns:Array,loading:Boolean,binaryStateSort:Boolean,iconFirstPage:String,iconPrevPage:String,iconNextPage:String,iconLastPage:String,title:String,hideHeader:Boolean,grid:Boolean,gridHeader:Boolean,dense:Boolean,flat:Boolean,bordered:Boolean,square:Boolean,separator:{type:String,default:"horizontal",validator:function(e){return["horizontal","vertical","cell","none"].includes(e)}},wrapCells:Boolean,virtualScroll:Boolean},Os,{noDataLabel:String,noResultsLabel:String,loadingLabel:String,selectedRowsLabel:Function,rowsPerPageLabel:String,paginationLabel:Function,color:{type:String,default:"grey-8"},titleClass:[String,Array,Object],tableStyle:[String,Array,Object],tableClass:[String,Array,Object],tableHeaderStyle:[String,Array,Object],tableHeaderClass:[String,Array,Object],cardContainerClass:[String,Array,Object],cardContainerStyle:[String,Array,Object],cardStyle:[String,Array,Object],cardClass:[String,Array,Object]}),data:function(){return{innerPagination:Object.assign({sortBy:null,descending:!1,page:1,rowsPerPage:this.rowsPerPageOptions.length>0?this.rowsPerPageOptions[0]:5},this.pagination)}},watch:{needsReset:function(){!0===this.hasVirtScroll&&void 0!==this.$refs.virtScroll&&this.$refs.virtScroll.reset()}},computed:{getRowKey:function(){var e=this;return"function"==typeof this.rowKey?this.rowKey:function(t){return t[e.rowKey]}},hasVirtScroll:function(){return!0!==this.grid&&!0===this.virtualScroll},needsReset:function(){var e=this;return["tableStyle","tableClass","tableHeaderStyle","tableHeaderClass","containerClass"].map((function(t){return e[t]})).join(";")},filteredSortedRows:function(){var e=this.data;if(!0===this.isServerSide||0===e.length)return e;var t=this.computedPagination,n=t.sortBy,i=t.descending;return this.filter&&(e=this.filterMethod(e,this.filter,this.computedCols,this.getCellValue)),void 0!==this.columnToSort&&(e=this.sortMethod(this.data===e?e.slice():e,n,i)),e},filteredSortedRowsNumber:function(){return this.filteredSortedRows.length},computedRows:function(){var e=this.filteredSortedRows;return!0===this.isServerSide||0!==this.computedPagination.rowsPerPage&&(0===this.firstRowIndex&&this.data!==e?e.length>this.lastRowIndex&&(e.length=this.lastRowIndex):e=e.slice(this.firstRowIndex,this.lastRowIndex)),e},computedRowsNumber:function(){return!0===this.isServerSide?this.computedPagination.rowsNumber||0:this.filteredSortedRowsNumber},nothingToDisplay:function(){return 0===this.computedRows.length},isServerSide:function(){return void 0!==this.computedPagination.rowsNumber},cardDefaultClass:function(){return" q-table__card"+(!0===this.isDark?" q-table__card--dark q-dark":"")+(!0===this.square?" q-table--square":"")+(!0===this.flat?" q-table--flat":"")+(!0===this.bordered?" q-table--bordered":"")},containerClass:function(){return"q-table__container q-table--"+this.separator+"-separator column no-wrap"+(!0===this.loading?" q-table--loading":"")+(!0===this.grid?" q-table--grid":this.cardDefaultClass)+(!0===this.isDark?" q-table--dark":"")+(!0===this.dense?" q-table--dense":"")+(!1===this.wrapCells?" q-table--no-wrap":"")+(!0===this.inFullscreen?" fullscreen scroll":"")},virtProps:function(){var e=this,t={};return Ea.forEach((function(n){t[n]=e[n]})),void 0===t.virtualScrollItemSize&&(t.virtualScrollItemSize=!0===this.dense?28:48),t}},render:function(e){var t=[this.getTop(e)],n={staticClass:this.containerClass};return!0===this.grid?t.push(this.getGridHeader(e)):Object.assign(n,{class:this.cardClass,style:this.cardStyle}),t.push(this.getBody(e),this.getBottom(e)),!0===this.loading&&void 0!==this.$scopedSlots.loading&&t.push(this.$scopedSlots.loading()),e("div",n,t)},methods:{requestServerInteraction:function(e){var t=this;void 0===e&&(e={}),this.$nextTick((function(){t.$emit("request",{pagination:e.pagination||t.computedPagination,filter:e.filter||t.filter,getCellValue:t.getCellValue})}))},resetVirtualScroll:function(){!0===this.hasVirtScroll&&this.$refs.virtScroll.reset()},getBody:function(e){if(!0===this.grid)return this.getGridBody(e);var t=!0!==this.hideHeader?this.getTableHeader(e):null;return!0===this.hasVirtScroll?e(ks,{ref:"virtScroll",props:Object.assign({},this.virtProps,{items:this.computedRows,type:"__qtable",tableColspan:this.computedColspan}),on:pe(this,"vs",{"virtual-scroll":this.__onVScroll}),class:this.tableClass,style:this.tableStyle,scopedSlots:{before:null===t?void 0:function(){return t},default:this.getTableRowVirtual(e)}}):ys(e,{staticClass:"scroll",class:this.tableClass,style:this.tableStyle},[t,this.getTableBody(e)])},scrollTo:function(e){if(void 0===this.$refs.virtScroll){e=parseInt(e,10);var t=this.$el.querySelector("tbody tr:nth-of-type("+(e+1)+")");if(null!==t){var n=this.$el.querySelector(".q-table__middle.scroll"),i=t.offsetTop,r=i<n.scrollTop?"decrease":"increase";n.scrollTop=i,this.$emit("virtual-scroll",{index:e,from:0,to:this.pagination.rowsPerPage-1,direction:r})}}else this.$refs.virtScroll.scrollTo(e)},__onVScroll:function(e){this.$emit("virtual-scroll",e)},__getProgress:function(e){return[e(ma,{staticClass:"q-table__linear-progress",props:{color:this.color,dark:this.isDark,indeterminate:!0,trackColor:"transparent"}})]}}}),Es=e.extend({name:"QTr",mixins:[Pe],props:{props:Object,noHover:Boolean},computed:{classes:function(){return"q-tr"+(void 0===this.props||!0===this.props.header?"":" "+this.props.__trClass)+(!0===this.noHover?" q-tr--no-hover":"")}},render:function(e){return e("tr",{on:Object.assign({},this.qListeners),class:this.classes},Le(this,"default"))}}),Ds=e.extend({name:"QTd",mixins:[Pe],props:{props:Object,autoWidth:Boolean,noHover:Boolean},computed:{classes:function(){return"q-td"+(!0===this.autoWidth?" q-table--col-auto-width":"")+(!0===this.noHover?" q-td--no-hover":"")}},render:function(e){var t=this.qListeners;if(void 0===this.props)return e("td",{on:t,class:this.classes},Le(this,"default"));var n=this.$vnode.key,i=void 0!==this.props.colsMap&&n?this.props.colsMap[n]:this.props.col;return void 0!==i?e("td",{on:t,style:i.style,class:this.classes+" "+i.__tdClass},Le(this,"default")):void 0}}),zs=/\/?$/;function Ns(e,t){return!!t&&(e.path&&t.path?e.path.replace(zs,"")===t.path.replace(zs,"")&&e.hash===t.hash&&Sn(e.query,t.query):!(!e.name||!t.name)&&(e.name===t.name&&e.hash===t.hash&&Sn(e.query,t.query)&&Sn(e.params,t.params)))}function js(e,t){return 0===e.path.replace(zs,"/").indexOf(t.path.replace(zs,"/"))&&(!t.hash||e.hash===t.hash)&&function(e,t){for(var n in t)if(!(n in e))return!1;return!0}(e.query,t.query)}var Rs=e.extend({name:"QRouteTab",mixins:[ui,Ue],props:{to:{required:!0}},inject:{__activateRoute:{},__recalculateScroll:{}},watch:{$route:function(){this.__checkActivation()}},computed:{onEvents:function(){return Object.assign({},{input:b},this.qListeners,{"!click":this.__activate,keyup:this.__onKeyup})}},methods:{__activate:function(e,t){var n=this;if(!0!==this.disable)if(void 0===e||!0!==e.ctrlKey&&!0!==e.shiftKey&&!0!==e.altKey&&!0!==e.metaKey){void 0!==e&&w(e);var i=function(e,t,i){void 0===e&&(e=n.to),void 0===t&&(t=n.append),void 0===i&&(i=n.replace);var r=n.$router.resolve(e,n.$route,t).route,o=e===n.to&&t===n.append&&i===n.replace?n.__checkActivation:m;n.$router[!0===i?"replace":"push"](r,(function(){o(!0)}),(function(e){e&&"NavigationDuplicated"===e.name&&o(!0)}))};void 0!==this.qListeners.click&&this.$emit("click",e,i),!1!==e.navigate&&i()}else this.__checkActivation(!0);!0===t?this.$el.focus(e):void 0!==this.$refs.blurTarget&&this.$refs.blurTarget.focus(e)},__checkActivation:function(e){void 0===e&&(e=!1);var t=this.$route,n=this.$router.resolve(this.to,t,this.append),i=n.href,r=n.location,o=n.route,a=void 0!==o.redirectedFrom,s=Ns(t,o),l=!0===this.exact?Ns:js,c={name:this.name,selected:e,exact:this.exact,priorityMatched:o.matched.length,priorityHref:i.length};(!0===s||!0!==this.exact&&!0===js(t,o))&&this.__activateRoute(Object.assign({},c,{redirected:a,exact:!0===this.exact||!0===s})),!0===a&&!0===l(t,Object.assign({},{path:o.redirectedFrom},r))&&this.__activateRoute(c),!0===this.isActive&&this.__activateRoute()}},mounted:function(){this.__recalculateScroll(),void 0!==this.$router&&this.__checkActivation()},beforeDestroy:function(){this.__recalculateScroll(),this.__activateRoute({remove:!0,name:this.name})},render:function(e){return this.__renderTab(e,"router-link",this.routerLinkProps)}}),Is=e.extend({name:"QTime",mixins:[Mi],directives:{TouchPan:Qn},props:{mask:{default:null},format24h:{type:Boolean,default:null},defaultDate:{type:String,validator:function(e){return/^-?[\d]+\/[0-1]\d\/[0-3]\d$/.test(e)}},options:Function,hourOptions:Array,minuteOptions:Array,secondOptions:Array,withSeconds:Boolean,nowBtn:Boolean},data:function(){var e=Di(this.value,this.__getMask(),this.__getLocale(),this.calendar,this.__getDefaultDateModel()),t="Hour";return null!==e.hour&&(null===e.minute?t="Minute":!0===this.withSeconds&&null===e.second&&(t="Second")),{view:t,isAM:null===e.hour||e.hour<12,innerModel:e}},watch:{value:function(e){var t=Di(e,this.computedMask,this.computedLocale,this.calendar,this.defaultDateModel);t.dateHash===this.innerModel.dateHash&&t.timeHash===this.innerModel.timeHash||(this.innerModel=t,null===t.hour?this.view="Hour":this.isAM=t.hour<12)},computedMask:function(){var e=this;this.$nextTick((function(){e.__updateValue()}))},computedLocale:function(){var e=this;this.$nextTick((function(){e.__updateValue()}))}},computed:{classes:function(){return"q-time q-time--"+(!0===this.landscape?"landscape":"portrait")+(!0===this.isDark?" q-time--dark q-dark":"")+(!0===this.disable?" disabled":!0===this.readonly?" q-time--readonly":"")+(!0===this.bordered?" q-time--bordered":"")+(!0===this.square?" q-time--square no-border-radius":"")+(!0===this.flat?" q-time--flat no-shadow":"")},stringModel:function(){var e=this.innerModel;return{hour:null===e.hour?"--":!0===this.computedFormat24h?he(e.hour):String(!0===this.isAM?0===e.hour?12:e.hour:e.hour>12?e.hour-12:e.hour),minute:null===e.minute?"--":he(e.minute),second:null===e.second?"--":he(e.second)}},defaultDateModel:function(){return this.__getDefaultDateModel()},computedFormat24h:function(){return null!==this.format24h?this.format24h:this.$q.lang.date.format24h},pointerStyle:function(){var e="Hour"===this.view,t=!0===e?12:60,n=this.innerModel[this.view.toLowerCase()],i="rotate("+(Math.round(n*(360/t))-180)+"deg) translateX(-50%)";return!0===e&&!0===this.computedFormat24h&&this.innerModel.hour>=12&&(i+=" scale(.7)"),{transform:i}},minLink:function(){return null!==this.innerModel.hour},secLink:function(){return!0===this.minLink&&null!==this.innerModel.minute},hourInSelection:function(){var e=this;return void 0!==this.hourOptions?function(t){return e.hourOptions.includes(t)}:void 0!==this.options?function(t){return e.options(t,null,null)}:void 0},minuteInSelection:function(){var e=this;return void 0!==this.minuteOptions?function(t){return e.minuteOptions.includes(t)}:void 0!==this.options?function(t){return e.options(e.innerModel.hour,t,null)}:void 0},secondInSelection:function(){var e=this;return void 0!==this.secondOptions?function(t){return e.secondOptions.includes(t)}:void 0!==this.options?function(t){return e.options(e.innerModel.hour,e.innerModel.minute,t)}:void 0},hourSnappingGrid:function(){return this.__getSnapGrid(this.hourInSelection,24)},minuteSnappingGrid:function(){return this.__getSnapGrid(this.minuteInSelection,60)},secondSnappingGrid:function(){return this.__getSnapGrid(this.secondInSelection,60)},positions:function(){var e,t,n,i=0,r=1;"Hour"===this.view?(n=this.hourInSelection,!0===this.computedFormat24h?(e=0,t=23):(e=0,t=11,!1===this.isAM&&(i=12))):(e=0,t=55,r=5,n="Minute"===this.view?this.minuteInSelection:this.secondInSelection);for(var o=[],a=e,s=e;a<=t;a+=r,s++){var l=a+i,c=void 0!==n&&!1===n(l),u="Hour"===this.view&&0===a?!0===this.format24h?"00":"12":a;o.push({val:l,index:s,disable:c,label:u})}return o}},methods:{setNow:function(){this.__updateValue(Object.assign({},this.__getCurrentDate(),this.__getCurrentTime())),this.view="Hour"},__getSnapGrid:function(e,t){if(void 0!==e){var n=[].concat(Array(t).keys()).map(e),i=t-1-n.lastIndexOf(!0);if(-1!==i){for(var r=0;r<t;r++)if(!0===n[r]){if(i){if(i>1){for(var o=Math.floor(i/2),a=(r-i-1+t)%t,s=(r-i+t)%t,l=0,c=s;l<o;c=(s+ ++l+t)%t)n[c]=a;for(var u=r,d=(r-o+t)%t,h=0,f=d;h<o;f=(d+ ++h+t)%t)n[f]=u}else{var p=(r-1+t)%t;n[p]=p}i=0}n[r]=r}else!1===n[r]&&i++;return n}}},__getMask:function(){return"persian"!==this.calendar&&null!==this.mask?this.mask:"HH:mm"+(!0===this.withSeconds?":ss":"")},__getDefaultDateModel:function(){if("string"!=typeof this.defaultDate){var e=this.__getCurrentDate();return e.dateHash=e.year+"/"+he(e.month)+"/"+he(e.day),e}return Di(this.defaultDate,"YYYY/MM/DD",void 0,this.calendar)},__click:function(e){!0!==this._isBeingDestroyed&&!0!==this._isDestroyed&&(!0!==this.$q.platform.is.desktop&&this.__updateClock(e,this.__getClockRect()),this.__goToNextView())},__activate:function(e){!0!==this._isBeingDestroyed&&!0!==this._isDestroyed&&this.__updateClock(e,this.__getClockRect())},__getClockRect:function(){var e=this.$refs.clock.getBoundingClientRect(),t=e.top,n=e.left,i=e.width/2;return{top:t+i,left:n+i,dist:.7*i}},__goToNextView:function(){"Hour"===this.view?this.view="Minute":this.withSeconds&&"Minute"===this.view&&(this.view="Second")},__drag:function(e){if(!0!==this._isBeingDestroyed&&!0!==this._isDestroyed){if(!0===e.isFirst)return this.draggingClockRect=this.__getClockRect(),void(this.dragCache=this.__updateClock(e.evt,this.draggingClockRect));this.dragCache=this.__updateClock(e.evt,this.draggingClockRect,this.dragCache),!0===e.isFinal&&(this.draggingClockRect=!1,this.dragCache=null,this.__goToNextView())}},__updateClock:function(e,t,n){var i,r=g(e),o=Math.abs(r.top-t.top),a=Math.sqrt(Math.pow(Math.abs(r.top-t.top),2)+Math.pow(Math.abs(r.left-t.left),2)),s=Math.asin(o/a)*(180/Math.PI);if(s=r.top<t.top?t.left<r.left?90-s:270+s:t.left<r.left?s+90:270-s,"Hour"===this.view?(i=Math.round(s/30),!0===this.computedFormat24h?(a<t.dist?i<12&&(i+=12):12===i&&(i=0),this.isAM=i<12):!0===this.isAM&&12===i?i=0:!1===this.isAM&&12!==i&&(i+=12),void 0!==this.hourSnappingGrid&&(i=this.hourSnappingGrid[i])):(i=Math.round(s/6)%60,"Minute"===this.view&&void 0!==this.minuteSnappingGrid?i=this.minuteSnappingGrid[i]:"Second"===this.view&&void 0!==this.secondSnappingGrid&&(i=this.secondSnappingGrid[i])),n===i)return i;var l=this[this.view.toLowerCase()+"InSelection"];return void 0===l||!0===l(i)?(this["__set"+this.view](i),i):void 0},__onKeyupHour:function(e){if(13===e.keyCode)this.view="Hour";else{var t=!0===this.computedFormat24h?24:12,n=!0!==this.computedFormat24h&&!1===this.isAM?12:0;37===e.keyCode?this.__setHour(n+(24+this.innerModel.hour-1)%t):39===e.keyCode&&this.__setHour(n+(24+this.innerModel.hour+1)%t)}},__onKeyupMinute:function(e){13===e.keyCode?this.view="Minute":37===e.keyCode?this.__setMinute((60+this.innerModel.minute-1)%60):39===e.keyCode&&this.__setMinute((60+this.innerModel.minute+1)%60)},__onKeyupSecond:function(e){13===e.keyCode?this.view="Second":37===e.keyCode?this.__setSecond((60+this.innerModel.second-1)%60):39===e.keyCode&&this.__setSecond((60+this.innerModel.second+1)%60)},__getHeader:function(e){var t=this,n=[e("div",{staticClass:"q-time__link",class:"Hour"===this.view?"q-time__link--active":"cursor-pointer",attrs:{tabindex:this.computedTabindex},on:pe(this,"vH",{click:function(){t.view="Hour"},keyup:this.__onKeyupHour})},[this.stringModel.hour]),e("div",[":"]),e("div",!0===this.minLink?{staticClass:"q-time__link",class:"Minute"===this.view?"q-time__link--active":"cursor-pointer",attrs:{tabindex:this.computedTabindex},on:pe(this,"vM",{click:function(){t.view="Minute"},keyup:this.__onKeyupMinute})}:{staticClass:"q-time__link"},[this.stringModel.minute])];return!0===this.withSeconds&&n.push(e("div",[":"]),e("div",!0===this.secLink?{staticClass:"q-time__link",class:"Second"===this.view?"q-time__link--active":"cursor-pointer",attrs:{tabindex:this.computedTabindex},on:pe(this,"vS",{click:function(){t.view="Second"},keyup:this.__onKeyupSecond})}:{staticClass:"q-time__link"},[this.stringModel.second])),e("div",{staticClass:"q-time__header flex flex-center no-wrap",class:this.headerClass},[e("div",{staticClass:"q-time__header-label row items-center no-wrap",attrs:{dir:"ltr"}},n),!1===this.computedFormat24h?e("div",{staticClass:"q-time__header-ampm column items-between no-wrap"},[e("div",{staticClass:"q-time__link",class:!0===this.isAM?"q-time__link--active":"cursor-pointer",attrs:{tabindex:this.computedTabindex},on:pe(this,"AM",{click:this.__setAm,keyup:function(e){13===e.keyCode&&t.__setAm()}})},["AM"]),e("div",{staticClass:"q-time__link",class:!0!==this.isAM?"q-time__link--active":"cursor-pointer",attrs:{tabindex:this.computedTabindex},on:pe(this,"PM",{click:this.__setPm,keyup:function(e){13===e.keyCode&&t.__setPm()}})},["PM"])]):null])},__getClock:function(e){var t=this,n=this.view.toLowerCase(),i=this.innerModel[n];return e("div",{staticClass:"q-time__content col relative-position"},[e("transition",{props:{name:"q-transition--scale"}},[e("div",{key:"clock"+this.view,staticClass:"q-time__container-parent absolute-full"},[e("div",{ref:"clock",staticClass:"q-time__container-child fit overflow-hidden"},[e("div",{staticClass:"q-time__clock cursor-pointer non-selectable",on:pe(this,"click",{click:this.__click,mousedown:this.__activate}),directives:pe(this,"touch",[{name:"touch-pan",value:this.__drag,modifiers:{stop:!0,prevent:!0,mouse:!0}}])},[e("div",{staticClass:"q-time__clock-circle fit"},[e("div",{staticClass:"q-time__clock-pointer",style:this.pointerStyle,class:null===this.innerModel[n]?"hidden":void 0!==this.color?"text-"+this.color:""}),this.positions.map((function(n){return e("div",{staticClass:"q-time__clock-position row flex-center q-time__clock-pos-"+n.index,class:n.val===i?t.headerClass.concat(" q-time__clock-position--active"):!0===n.disable?"q-time__clock-position--disable":null},[e("span",[n.label])])}))])])])])]),!0===this.nowBtn?e(bt,{staticClass:"q-time__now-button absolute",props:{icon:this.$q.iconSet.datetime.now,unelevated:!0,size:"sm",round:!0,color:this.color,textColor:this.textColor,tabindex:this.computedTabindex},on:pe(this,"now",{click:this.setNow})}):null])},__setHour:function(e){this.innerModel.hour!==e&&(this.innerModel.hour=e,this.innerModel.minute=null,this.innerModel.second=null)},__setMinute:function(e){this.innerModel.minute!==e&&(this.innerModel.minute=e,this.innerModel.second=null,!0!==this.withSeconds&&this.__updateValue({minute:e}))},__setSecond:function(e){this.innerModel.second!==e&&this.__updateValue({second:e})},__setAm:function(){this.isAM||(this.isAM=!0,null!==this.innerModel.hour&&(this.innerModel.hour-=12,this.__verifyAndUpdate()))},__setPm:function(){this.isAM&&(this.isAM=!1,null!==this.innerModel.hour&&(this.innerModel.hour+=12,this.__verifyAndUpdate()))},__verifyAndUpdate:function(){return void 0!==this.hourInSelection&&!0!==this.hourInSelection(this.innerModel.hour)?(this.innerModel=Di(),this.isAM=!0,void(this.view="Hour")):void 0!==this.minuteInSelection&&!0!==this.minuteInSelection(this.innerModel.minute)?(this.innerModel.minute=null,this.innerModel.second=null,void(this.view="Minute")):!0===this.withSeconds&&void 0!==this.secondInSelection&&!0!==this.secondInSelection(this.innerModel.second)?(this.innerModel.second=null,void(this.view="Second")):void(null===this.innerModel.hour||null===this.innerModel.minute||!0===this.withSeconds&&null===this.innerModel.second||this.__updateValue())},__updateValue:function(e){var t=Object.assign(Object.assign({},this.innerModel),e),n="persian"===this.calendar?he(t.hour)+":"+he(t.minute)+(!0===this.withSeconds?":"+he(t.second):""):Gi(new Date(t.year,null===t.month?null:t.month-1,t.day,t.hour,t.minute,t.second,t.millisecond),this.computedMask,this.computedLocale,t.year,t.timezoneOffset);t.changed=n!==this.value,this.$emit("input",n,t)}},render:function(e){var t=[this.__getClock(e)],n=Le(this,"default");return void 0!==n&&t.push(e("div",{staticClass:"q-time__actions"},n)),void 0!==this.name&&!0!==this.disable&&this.__injectFormInput(t,"push"),e("div",{class:this.classes,on:Object.assign({},this.qListeners),attrs:{tabindex:-1}},[this.__getHeader(e),e("div",{staticClass:"q-time__main col overflow-auto"},t)])}}),$s=e.extend({name:"QTimeline",mixins:[je,Pe],provide:function(){return{__timeline:this}},props:{color:{type:String,default:"primary"},side:{type:String,default:"right",validator:function(e){return["left","right"].includes(e)}},layout:{type:String,default:"dense",validator:function(e){return["dense","comfortable","loose"].includes(e)}}},computed:{classes:function(){return"q-timeline--"+this.layout+" q-timeline--"+this.layout+"--"+this.side+(!0===this.isDark?" q-timeline--dark":"")}},render:function(e){return e("ul",{staticClass:"q-timeline",class:this.classes,on:Object.assign({},this.qListeners)},Le(this,"default"))}}),Fs=e.extend({name:"QTimelineEntry",inject:{__timeline:{default:function(){console.error("QTimelineEntry needs to be child of QTimeline")}}},mixins:[Pe],props:{heading:Boolean,tag:{type:String,default:"h3"},side:{type:String,default:"right",validator:function(e){return["left","right"].includes(e)}},icon:String,avatar:String,color:String,title:String,subtitle:String,body:String},computed:{colorClass:function(){return"text-"+(this.color||this.__timeline.color)},classes:function(){return"q-timeline__entry--"+this.side+(void 0!==this.icon||void 0!==this.avatar?" q-timeline__entry--icon":"")},reverse:function(){return"comfortable"===this.__timeline.layout&&"left"===this.__timeline.side}},render:function(e){var t,n=Oe(this,"default",[]);if(void 0!==this.body&&n.unshift(this.body),!0===this.heading){var i=[e("div"),e("div"),e(this.tag,{staticClass:"q-timeline__heading-title"},n)];return e("div",{staticClass:"q-timeline__heading",on:Object.assign({},this.qListeners)},!0===this.reverse?i.reverse():i)}void 0!==this.icon?t=[e(De,{staticClass:"row items-center justify-center",props:{name:this.icon}})]:void 0!==this.avatar&&(t=[e("img",{staticClass:"q-timeline__dot-img",domProps:{src:this.avatar}})]);var r=[e("div",{staticClass:"q-timeline__subtitle"},[e("span",Le(this,"subtitle",[this.subtitle]))]),e("div",{staticClass:"q-timeline__dot",class:this.colorClass},t),e("div",{staticClass:"q-timeline__content"},[e("h6",{staticClass:"q-timeline__title"},Le(this,"title",[this.title]))].concat(n))];return e("li",{staticClass:"q-timeline__entry",class:this.classes,on:Object.assign({},this.qListeners)},!0===this.reverse?r.reverse():r)}}),Bs=e.extend({name:"QToolbar",mixins:[Pe],props:{inset:Boolean},render:function(e){return e("div",{staticClass:"q-toolbar row no-wrap items-center",class:this.inset?"q-toolbar--inset":null,on:Object.assign({},this.qListeners)},Le(this,"default"))}}),Vs=e.extend({name:"QToolbarTitle",mixins:[Pe],props:{shrink:Boolean},computed:{classes:function(){return"q-toolbar__title ellipsis"+(!0===this.shrink?" col-shrink":"")}},render:function(e){return e("div",{class:this.classes,on:Object.assign({},this.qListeners)},Le(this,"default"))}}),Hs=e.extend({name:"QTree",mixins:[je],props:{nodes:{type:Array,required:!0},nodeKey:{type:String,required:!0},labelKey:{type:String,default:"label"},childrenKey:{type:String,default:"children"},color:String,controlColor:String,textColor:String,selectedColor:String,icon:String,tickStrategy:{type:String,default:"none",validator:function(e){return["none","strict","leaf","leaf-filtered"].includes(e)}},ticked:Array,expanded:Array,selected:{},defaultExpandAll:Boolean,accordion:Boolean,filter:String,filterMethod:{type:Function,default:function(e,t){var n=t.toLowerCase();return e[this.labelKey]&&e[this.labelKey].toLowerCase().indexOf(n)>-1}},duration:Number,noConnectors:Boolean,noNodesLabel:String,noResultsLabel:String},computed:{classes:function(){return"q-tree"+(!0===this.noConnectors?" q-tree--no-connectors":"")+(!0===this.isDark?" q-tree--dark":"")+(void 0!==this.color?" text-"+this.color:"")},hasSelection:function(){return void 0!==this.selected},computedIcon:function(){return this.icon||this.$q.iconSet.tree.icon},computedControlColor:function(){return this.controlColor||this.color},textColorClass:function(){if(void 0!==this.textColor)return"text-"+this.textColor},selectedColorClass:function(){var e=this.selectedColor||this.color;if(e)return"text-"+e},meta:function(){var e=this,t={},n=function(i,r){var o=i.tickStrategy||(r?r.tickStrategy:e.tickStrategy),a=i[e.nodeKey],s=i[e.childrenKey]&&i[e.childrenKey].length>0,l=!0!==s,c=!0!==i.disabled&&!0===e.hasSelection&&!1!==i.selectable,u=!0!==i.disabled&&!1!==i.expandable,d="none"!==o,h="strict"===o,f="leaf-filtered"===o,p="leaf"===o||"leaf-filtered"===o,m=!0!==i.disabled&&!1!==i.tickable;!0===p&&!0===m&&r&&!0!==r.tickable&&(m=!1);var v=i.lazy;v&&e.lazy[a]&&(v=e.lazy[a]);var g={key:a,parent:r,isParent:s,isLeaf:l,lazy:v,disabled:i.disabled,link:!0!==i.disabled&&(!0===c||!0===u&&(!0===s||!0===v)),children:[],matchesFilter:!e.filter||e.filterMethod(i,e.filter),selected:a===e.selected&&!0===c,selectable:c,expanded:!0===s&&e.innerExpanded.includes(a),expandable:u,noTick:!0===i.noTick||!0!==h&&v&&"loaded"!==v,tickable:m,tickStrategy:o,hasTicking:d,strictTicking:h,leafFilteredTicking:f,leafTicking:p,ticked:(!0===h||!0===l)&&e.innerTicked.includes(a)};if(t[a]=g,!0===s&&(g.children=i[e.childrenKey].map((function(e){return n(e,g)})),e.filter&&(!0!==g.matchesFilter?g.matchesFilter=g.children.some((function(e){return e.matchesFilter})):!0!==g.noTick&&!0!==g.disabled&&!0===g.tickable&&!0===f&&!0===g.children.every((function(e){return!0!==e.matchesFilter||!0===e.noTick||!0!==e.tickable}))&&(g.tickable=!1)),!0===g.matchesFilter&&(!0!==g.noTick&&!0!==h&&!0===g.children.every((function(e){return e.noTick}))&&(g.noTick=!0),p))){if(g.ticked=!1,g.indeterminate=g.children.some((function(e){return!0===e.indeterminate})),g.tickable=!0===g.tickable&&g.children.some((function(e){return e.tickable})),!0!==g.indeterminate){var _=g.children.reduce((function(e,t){return!0===t.ticked?e+1:e}),0);_===g.children.length?g.ticked=!0:_>0&&(g.indeterminate=!0)}!0===g.indeterminate&&(g.indeterminateNextState=g.children.every((function(e){return!0!==e.tickable||!0!==e.ticked})))}return g};return this.nodes.forEach((function(e){return n(e,null)})),t}},data:function(){return{lazy:{},innerTicked:this.ticked||[],innerExpanded:this.expanded||[]}},watch:{ticked:function(e){this.innerTicked=e},expanded:function(e){this.innerExpanded=e}},methods:{getNodeByKey:function(e){var t=this,n=[].reduce,i=function(r,o){return r||!o?r:!0===Array.isArray(o)?n.call(Object(o),i,r):o[t.nodeKey]===e?o:o[t.childrenKey]?i(null,o[t.childrenKey]):void 0};return i(null,this.nodes)},getTickedNodes:function(){var e=this;return this.innerTicked.map((function(t){return e.getNodeByKey(t)}))},getExpandedNodes:function(){var e=this;return this.innerExpanded.map((function(t){return e.getNodeByKey(t)}))},isExpanded:function(e){return!(!e||!this.meta[e])&&this.meta[e].expanded},collapseAll:function(){void 0!==this.expanded?this.$emit("update:expanded",[]):this.innerExpanded=[]},expandAll:function(){var e=this,t=this.innerExpanded,n=function(i){i[e.childrenKey]&&i[e.childrenKey].length>0&&!1!==i.expandable&&!0!==i.disabled&&(t.push(i[e.nodeKey]),i[e.childrenKey].forEach(n))};this.nodes.forEach(n),void 0!==this.expanded?this.$emit("update:expanded",t):this.innerExpanded=t},setExpanded:function(e,t,n,i){var r=this;if(void 0===n&&(n=this.getNodeByKey(e)),void 0===i&&(i=this.meta[e]),i.lazy&&"loaded"!==i.lazy){if("loading"===i.lazy)return;this.$set(this.lazy,e,"loading"),this.$emit("lazy-load",{node:n,key:e,done:function(t){r.lazy[e]="loaded",t&&r.$set(n,r.childrenKey,t),r.$nextTick((function(){var t=r.meta[e];t&&!0===t.isParent&&r.__setExpanded(e,!0)}))},fail:function(){r.$delete(r.lazy,e)}})}else!0===i.isParent&&!0===i.expandable&&this.__setExpanded(e,t)},__setExpanded:function(e,t){var n=this,i=this.innerExpanded,r=void 0!==this.expanded;if(!0===r&&(i=i.slice()),t){if(this.accordion&&this.meta[e]){var o=[];this.meta[e].parent?this.meta[e].parent.children.forEach((function(t){t.key!==e&&!0===t.expandable&&o.push(t.key)})):this.nodes.forEach((function(t){var i=t[n.nodeKey];i!==e&&o.push(i)})),o.length>0&&(i=i.filter((function(e){return!1===o.includes(e)})))}i=i.concat([e]).filter((function(e,t,n){return n.indexOf(e)===t}))}else i=i.filter((function(t){return t!==e}));!0===r?this.$emit("update:expanded",i):this.innerExpanded=i},isTicked:function(e){return!(!e||!this.meta[e])&&this.meta[e].ticked},setTicked:function(e,t){var n=this.innerTicked,i=void 0!==this.ticked;!0===i&&(n=n.slice()),n=t?n.concat(e).filter((function(e,t,n){return n.indexOf(e)===t})):n.filter((function(t){return!1===e.includes(t)})),!0===i&&this.$emit("update:ticked",n)},__getSlotScope:function(e,t,n){var i=this,r={tree:this,node:e,key:n,color:this.color,dark:this.isDark};return Object.defineProperty(r,"expanded",{get:function(){return t.expanded},set:function(e){e!==t.expanded&&i.setExpanded(n,e)},configurable:!0,enumerable:!0}),Object.defineProperty(r,"ticked",{get:function(){return t.ticked},set:function(e){e!==t.ticked&&i.setTicked([n],e)},configurable:!0,enumerable:!0}),r},__getChildren:function(e,t){var n=this;return(this.filter?t.filter((function(e){return n.meta[e[n.nodeKey]].matchesFilter})):t).map((function(t){return n.__getNode(e,t)}))},__getNodeMedia:function(e,t){if(void 0!==t.icon)return e(De,{staticClass:"q-tree__icon q-mr-sm",props:{name:t.icon,color:t.iconColor}});var n=t.img||t.avatar;return n?e("img",{staticClass:"q-tree__"+(t.img?"img":"avatar")+" q-mr-sm",attrs:{src:n}}):void 0},__getNode:function(e,t){var n=this,i=t[this.nodeKey],r=this.meta[i],o=t.header&&this.$scopedSlots["header-"+t.header]||this.$scopedSlots["default-header"],a=!0===r.isParent?this.__getChildren(e,t[this.childrenKey]):[],s=a.length>0||r.lazy&&"loaded"!==r.lazy,l=t.body&&this.$scopedSlots["body-"+t.body]||this.$scopedSlots["default-body"],c=void 0!==o||void 0!==l?this.__getSlotScope(t,r,i):null;return void 0!==l&&(l=e("div",{staticClass:"q-tree__node-body relative-position"},[e("div",{class:this.textColorClass},[l(c)])])),e("div",{key:i,staticClass:"q-tree__node relative-position",class:{"q-tree__node--parent":s,"q-tree__node--child":!s}},[e("div",{staticClass:"q-tree__node-header relative-position row no-wrap items-center",class:{"q-tree__node--link q-hoverable q-focusable":r.link,"q-tree__node--selected":r.selected,"q-tree__node--disabled":r.disabled},attrs:{tabindex:r.link?0:-1},on:{click:function(e){n.__onClick(t,r,e)},keypress:function(e){!0!==J(e)&&(13===e.keyCode?n.__onClick(t,r,e,!0):32===e.keyCode&&n.__onExpandClick(t,r,e,!0))}}},[e("div",{staticClass:"q-focus-helper",attrs:{tabindex:-1},ref:"blurTarget_"+r.key}),"loading"===r.lazy?e(Qe,{staticClass:"q-tree__spinner q-mr-xs",props:{color:this.computedControlColor}}):!0===s?e(De,{staticClass:"q-tree__arrow q-mr-xs",class:{"q-tree__arrow--rotate":r.expanded},props:{name:this.computedIcon},on:{click:function(e){n.__onExpandClick(t,r,e)}}}):null,!0===r.hasTicking&&!0!==r.noTick?e(Dn,{staticClass:"q-mr-xs",props:{value:!0===r.indeterminate?null:r.ticked,color:this.computedControlColor,dark:this.isDark,dense:!0,keepColor:!0,disable:!0!==r.tickable},on:{keydown:w,input:function(e){n.__onTickedClick(r,e)}}}):null,e("div",{staticClass:"q-tree__node-header-content col row no-wrap items-center",class:r.selected?this.selectedColorClass:this.textColorClass},[o?o(c):[this.__getNodeMedia(e,t),e("div",t[this.labelKey])]])]),!0===s?e(_o,{props:{duration:this.duration},on:pe(this,"slide",{show:function(){n.$emit("after-show")},hide:function(){n.$emit("after-hide")}})},[e("div",{staticClass:"q-tree__node-collapsible",class:this.textColorClass,directives:[{name:"show",value:r.expanded}]},[l,e("div",{staticClass:"q-tree__children",class:{"q-tree__node--disabled":r.disabled}},a)])]):l])},__blur:function(e){var t=this.$refs["blurTarget_"+e];void 0!==t&&t.focus()},__onClick:function(e,t,n,i){!0!==i&&this.__blur(t.key),this.hasSelection?t.selectable&&this.$emit("update:selected",t.key!==this.selected?t.key:null):this.__onExpandClick(e,t,n,i),"function"==typeof e.handler&&e.handler(e)},__onExpandClick:function(e,t,n,i){void 0!==n&&w(n),!0!==i&&this.__blur(t.key),this.setExpanded(t.key,!t.expanded,e,t)},__onTickedClick:function(e,t){if(!0===e.indeterminate&&(t=e.indeterminateNextState),e.strictTicking)this.setTicked([e.key],t);else if(e.leafTicking){var n=[],i=function(e){e.isParent?(!0!==t&&!0!==e.noTick&&!0===e.tickable&&n.push(e.key),!0===e.leafTicking&&e.children.forEach(i)):!0===e.noTick||!0!==e.tickable||!0===e.leafFilteredTicking&&!0!==e.matchesFilter||n.push(e.key)};i(e),this.setTicked(n,t)}}},render:function(e){var t=this.__getChildren(e,this.nodes);return e("div",{class:this.classes},0===t.length?this.filter?this.noResultsLabel||this.$q.lang.tree.noResults:this.noNodesLabel||this.$q.lang.tree.noNodes:t)},created:function(){!0===this.defaultExpandAll&&this.expandAll()}}),Ws=e.extend({name:"QUploaderBase",mixins:[je,zr],props:{label:String,color:String,textColor:String,square:Boolean,flat:Boolean,bordered:Boolean,noThumbnails:Boolean,autoUpload:Boolean,hideUploadBtn:Boolean,disable:Boolean,readonly:Boolean},provide:function(){return{__qUploaderGetInput:this.__getInputControl}},data:function(){return{files:[],queuedFiles:[],uploadedFiles:[],dnd:!1,expanded:!1,uploadSize:0,uploadedSize:0}},watch:{isUploading:function(e,t){!1===t&&!0===e?this.$emit("start"):!0===t&&!1===e&&this.$emit("finish")}},computed:{canUpload:function(){return!0===this.editable&&!0!==this.isBusy&&!0!==this.isUploading&&this.queuedFiles.length>0},canAddFiles:function(){return!0===this.editable&&!0!==this.isUploading&&(!0===this.multiple||0===this.queuedFiles.length)&&(void 0===this.maxFiles||this.files.length<this.maxFilesNumber)&&(void 0===this.maxTotalSize||this.uploadSize<this.maxTotalSizeNumber)},uploadProgress:function(){return 0===this.uploadSize?0:this.uploadedSize/this.uploadSize},uploadProgressLabel:function(){return this.__getProgressLabel(this.uploadProgress)},uploadedSizeLabel:function(){return le(this.uploadedSize)},uploadSizeLabel:function(){return le(this.uploadSize)},colorClass:function(){var e=[];return void 0!==this.color&&e.push("bg-"+this.color),void 0!==this.textColor&&e.push("text-"+this.textColor),e.join(" ")},editable:function(){return!0!==this.disable&&!0!==this.readonly}},methods:{reset:function(){this.disable||(this.abort(),this.uploadedSize=0,this.uploadSize=0,this.__revokeImgURLs(),this.files=[],this.queuedFiles=[],this.uploadedFiles=[])},removeUploadedFiles:function(){this.disable||(this.files=this.files.filter((function(e){return"uploaded"!==e.__status||(void 0!==e._img&&window.URL.revokeObjectURL(e._img.src),!1)})),this.uploadedFiles=[])},removeQueuedFiles:function(){var e=this;if(!this.disable){var t=[],n=this.files.filter((function(n){return"idle"!==n.__status&&"failed"!==n.__status||(e.uploadSize-=n.size,t.push(n),void 0!==n._img&&window.URL.revokeObjectURL(n._img.src),!1)}));t.length>0&&(this.files=n,this.queuedFiles=[],this.$emit("removed",t))}},removeFile:function(e){this.disable||("uploaded"===e.__status?this.uploadedFiles=this.uploadedFiles.filter((function(t){return t.name!==e.name})):"uploading"===e.__status?e.__abort():this.uploadSize-=e.size,this.files=this.files.filter((function(t){return t.name!==e.name||(void 0!==t._img&&window.URL.revokeObjectURL(t._img.src),!1)})),this.queuedFiles=this.queuedFiles.filter((function(t){return t.name!==e.name})),this.$emit("removed",[e]))},__revokeImgURLs:function(){this.files.forEach((function(e){void 0!==e._img&&window.URL.revokeObjectURL(e._img.src)}))},__getFileInput:function(){return this.$refs.input||this.$el.getElementsByClassName("q-uploader__input")[0]},__getProgressLabel:function(e){return(100*e).toFixed(2)+"%"},__updateFile:function(e,t,n){if(e.__status=t,"idle"===t)return e.__uploaded=0,e.__progress=0,e.__sizeLabel=le(e.size),void(e.__progressLabel="0.00%");"failed"!==t?(e.__uploaded="uploaded"===t?e.size:n,e.__progress="uploaded"===t?1:Math.min(.9999,e.__uploaded/e.size),e.__progressLabel=this.__getProgressLabel(e.__progress),this.$forceUpdate()):this.$forceUpdate()},__addFiles:function(e,t){var n=this,i=this.__processFiles(e,t,this.files,!0);if(void 0!==i){var r=i.filter((function(e){return-1===n.files.findIndex((function(t){return e.name===t.name}))}));this.__getFileInput().value="",void 0!==r&&(r.forEach((function(e){if(n.__updateFile(e,"idle"),n.uploadSize+=e.size,!0!==n.noThumbnails&&e.type.toUpperCase().startsWith("IMAGE")){var t=new Image;t.src=window.URL.createObjectURL(e),e.__img=t}})),this.files=this.files.concat(r),this.queuedFiles=this.queuedFiles.concat(r),this.$emit("added",r),!0===this.autoUpload&&this.upload())}},__getBtn:function(e,t,n,i){if(!0===t)return e(bt,{props:{type:"a",icon:this.$q.iconSet.uploader[n],flat:!0,dense:!0},on:"add"===n?null:{click:i}},"add"===n?this.__getInputControl(e):null)},__getInputControl:function(e){return[e("input",{ref:"input",staticClass:"q-uploader__input overflow-hidden absolute-full",attrs:Object.assign({},{tabindex:-1,type:"file",title:"",accept:this.accept,capture:this.capture},!0===this.multiple?{multiple:!0}:{}),on:pe(this,"input",{mousedown:b,change:this.__addFiles})})]},__getHeader:function(e){return void 0!==this.$scopedSlots.header?this.$scopedSlots.header(this):[e("div",{staticClass:"q-uploader__header-content flex flex-center no-wrap q-gutter-xs"},[this.__getBtn(e,this.queuedFiles.length>0,"removeQueue",this.removeQueuedFiles),this.__getBtn(e,this.uploadedFiles.length>0,"removeUploaded",this.removeUploadedFiles),!0===this.isUploading?e(Qe,{staticClass:"q-uploader__spinner"}):null,e("div",{staticClass:"col column justify-center"},[void 0!==this.label?e("div",{staticClass:"q-uploader__title"},[this.label]):null,e("div",{staticClass:"q-uploader__subtitle"},[this.uploadSizeLabel+" / "+this.uploadProgressLabel])]),this.__getBtn(e,this.canAddFiles,"add",this.pickFiles),this.__getBtn(e,!1===this.hideUploadBtn&&!0===this.canUpload,"upload",this.upload),this.__getBtn(e,this.isUploading,"clear",this.abort)])]},__getList:function(e){var t=this;return void 0!==this.$scopedSlots.list?this.$scopedSlots.list(this):this.files.map((function(n){return e("div",{key:n.name,staticClass:"q-uploader__file relative-position",class:{"q-uploader__file--img":!0!==t.noThumbnails&&void 0!==n.__img,"q-uploader__file--failed":"failed"===n.__status,"q-uploader__file--uploaded":"uploaded"===n.__status},style:!0!==t.noThumbnails&&void 0!==n.__img?{backgroundImage:'url("'+n.__img.src+'")'}:null},[e("div",{staticClass:"q-uploader__file-header row flex-center no-wrap"},["failed"===n.__status?e(De,{staticClass:"q-uploader__file-status",props:{name:t.$q.iconSet.type.negative,color:"negative"}}):null,e("div",{staticClass:"q-uploader__file-header-content col"},[e("div",{staticClass:"q-uploader__title"},[n.name]),e("div",{staticClass:"q-uploader__subtitle row items-center no-wrap"},[n.__sizeLabel+" / "+n.__progressLabel])]),"uploading"===n.__status?e(Rn,{props:{value:n.__progress,min:0,max:1,indeterminate:0===n.__progress}}):e(bt,{props:{round:!0,dense:!0,flat:!0,icon:t.$q.iconSet.uploader["uploaded"===n.__status?"done":"clear"]},on:{click:function(){t.removeFile(n)}}})])])}))}},beforeDestroy:function(){!0===this.isUploading&&this.abort(),this.files.length>0&&this.__revokeImgURLs()},render:function(e){var t=[e("div",{staticClass:"q-uploader__header",class:this.colorClass},this.__getHeader(e)),e("div",{staticClass:"q-uploader__list scroll"},this.__getList(e)),this.__getDnd(e,"uploader")];return!0===this.isBusy&&t.push(e("div",{staticClass:"q-uploader__overlay absolute-full flex flex-center"},[e(Qe)])),e("div",{staticClass:"q-uploader column no-wrap",class:{"q-uploader--dark q-dark":this.isDark,"q-uploader--bordered":this.bordered,"q-uploader--square no-border-radius":this.square,"q-uploader--flat no-shadow":this.flat,"disabled q-uploader--disable":this.disable},on:!0===this.canAddFiles?pe(this,"drag",{dragover:this.__onDragOver}):null},t)}});function Us(e){return"function"==typeof e?e:function(){return e}}var Ys={props:{url:[Function,String],method:{type:[Function,String],default:"POST"},fieldName:{type:[Function,String],default:function(e){return e.name}},headers:[Function,Array],formFields:[Function,Array],withCredentials:[Function,Boolean],sendRaw:[Function,Boolean],batch:[Function,Boolean],factory:Function},data:function(){return{xhrs:[],promises:[],workingThreads:0}},computed:{xhrProps:function(){return{url:Us(this.url),method:Us(this.method),headers:Us(this.headers),formFields:Us(this.formFields),fieldName:Us(this.fieldName),withCredentials:Us(this.withCredentials),sendRaw:Us(this.sendRaw),batch:Us(this.batch)}},isUploading:function(){return this.workingThreads>0},isBusy:function(){return this.promises.length>0}},methods:{abort:function(){this.xhrs.forEach((function(e){e.abort()})),this.promises.length>0&&(this.abortPromises=!0)},upload:function(){var e=this;if(!1!==this.canUpload){var t=this.queuedFiles.slice(0);this.queuedFiles=[],this.xhrProps.batch(t)?this.__runFactory(t):t.forEach((function(t){e.__runFactory([t])}))}},__runFactory:function(e){var t=this;if(this.workingThreads++,"function"==typeof this.factory){var n=this.factory(e);if(n)if("function"==typeof n.catch&&"function"==typeof n.then){this.promises.push(n);var i=function(i){!0!==t._isBeingDestroyed&&!0!==t._isDestroyed&&(t.promises=t.promises.filter((function(e){return e!==n})),0===t.promises.length&&(t.abortPromises=!1),t.queuedFiles=t.queuedFiles.concat(e),e.forEach((function(e){t.__updateFile(e,"failed")})),t.$emit("factory-failed",i,e),t.workingThreads--)};n.then((function(r){!0===t.abortPromises?i(new Error("Aborted")):!0!==t._isBeingDestroyed&&!0!==t._isDestroyed&&(t.promises=t.promises.filter((function(e){return e!==n})),t.__uploadFiles(e,r))})).catch(i)}else this.__uploadFiles(e,n||{});else this.$emit("factory-failed",new Error("QUploader: factory() does not return properly"),e),this.workingThreads--}else this.__uploadFiles(e,{})},__uploadFiles:function(e,t){var n=this,i=new FormData,r=new XMLHttpRequest,o=function(e,i){return void 0!==t[e]?Us(t[e])(i):n.xhrProps[e](i)},a=o("url",e);if(!a)return console.error("q-uploader: invalid or no URL specified"),void this.workingThreads--;var s=o("formFields",e);void 0!==s&&s.forEach((function(e){i.append(e.name,e.value)}));var l,c=0,u=0,d=0,h=0;r.upload.addEventListener("progress",(function(t){if(!0!==l){var i=Math.min(h,t.loaded);n.uploadedSize+=i-d;for(var r=(d=i)-u,o=c;r>0&&o<e.length;o++){var a=e[o];if(!(r>a.size))return void n.__updateFile(a,"uploading",r);r-=a.size,c++,u+=a.size,n.__updateFile(a,"uploading",a.size)}}}),!1),r.onreadystatechange=function(){r.readyState<4||(r.status&&r.status<400?(n.uploadedFiles=n.uploadedFiles.concat(e),e.forEach((function(e){n.__updateFile(e,"uploaded")})),n.$emit("uploaded",{files:e,xhr:r})):(l=!0,n.uploadedSize-=d,n.queuedFiles=n.queuedFiles.concat(e),e.forEach((function(e){n.__updateFile(e,"failed")})),n.$emit("failed",{files:e,xhr:r})),n.workingThreads--,n.xhrs=n.xhrs.filter((function(e){return e!==r})))},r.open(o("method",e),a),!0===o("withCredentials",e)&&(r.withCredentials=!0);var f=o("headers",e);void 0!==f&&f.forEach((function(e){r.setRequestHeader(e.name,e.value)}));var p=o("sendRaw",e);e.forEach((function(e){n.__updateFile(e,"uploading",0),!0!==p&&i.append(o("fieldName",e),e,e.name),e.xhr=r,e.__abort=function(){r.abort()},h+=e.size})),this.$emit("uploading",{files:e,xhr:r}),this.xhrs.push(r),!0===p?r.send(new Blob(e)):r.send(i)}}},Gs=e.extend({name:"QUploader",mixins:[Ws,Ys]}),Qs=e.extend({name:"QUploaderAddTrigger",inject:{__qUploaderGetInput:{default:function(){console.error("QUploaderAddTrigger needs to be child of QUploader")}}},render:function(e){return this.__qUploaderGetInput(e)}}),Ks=e.extend({name:"QVideo",mixins:[No,Pe],props:{src:{type:String,required:!0}},computed:{iframeData:function(){return{attrs:{src:this.src,frameborder:"0",allowfullscreen:!0}}},classes:function(){return"q-video"+(void 0!==this.ratio?" q-video--responsive":"")}},render:function(e){return e("div",{class:this.classes,style:this.ratioStyle,on:Object.assign({},this.qListeners)},[e("iframe",this.iframeData)])}}),Zs=Object.freeze({__proto__:null,QAjaxBar:Se,QAvatar:ze,QBadge:Ne,QBanner:Ie,QBar:Fe,QBreadcrumbs:We,QBreadcrumbsEl:Ye,QBtn:bt,QBtnDropdown:sn,QBtnGroup:yt,QBtnToggle:un,QCard:dn,QCardSection:hn,QCardActions:fn,QCarousel:Tn,QCarouselSlide:An,QCarouselControl:Pn,QChatMessage:Ln,QCheckbox:Dn,QChip:zn,QCircularProgress:Rn,QColor:pi,QDate:sr,QDialog:wr,QDrawer:xr,QEditor:vo,QExpansionItem:xo,QFab:Ao,QFabAction:Oo,QField:Er,QFile:qo,QFooter:Eo,QForm:Do,QHeader:zo,QIcon:De,QImg:jo,QInfiniteScroll:Ro,QInnerLoading:Io,QInput:Gr,QIntersection:Ho,QList:Kr,QItem:Zr,QItemSection:Jr,QItemLabel:go,QKnob:Uo,QLayout:Qo,QMarkupTable:Ko,QMenu:an,QNoSsr:Zo,QOptionGroup:na,QPage:ia,QPageContainer:ra,QPageScroller:aa,QPageSticky:oa,QPagination:sa,QParallax:ua,QPopupEdit:ha,QPopupProxy:fa,QLinearProgress:ma,QPullToRefresh:ga,QRadio:Jo,QRange:wa,QRating:ka,QResizeObserver:ni,QResponsive:xa,QScrollArea:Sa,QScrollObserver:Go,QSelect:Na,QSeparator:wo,QSkeleton:Ia,QSlideItem:Fa,QSlideTransition:_o,QSlider:ei,QSpace:Ba,QSpinner:Qe,QSpinnerAudio:Va,QSpinnerBall:Ha,QSpinnerBars:Wa,QSpinnerComment:Ua,QSpinnerCube:Ya,QSpinnerDots:Ga,QSpinnerFacebook:Qa,QSpinnerGears:Ka,QSpinnerGrid:Za,QSpinnerHearts:Ja,QSpinnerHourglass:Xa,QSpinnerInfinity:es,QSpinnerIos:ts,QSpinnerOval:ns,QSpinnerPie:is,QSpinnerPuff:rs,QSpinnerRadio:os,QSpinnerRings:as,QSpinnerTail:ss,QSplitter:ls,QStep:ds,QStepper:hs,QStepperNavigation:fs,QTabPanels:di,QTabPanel:hi,QTable:qs,QTh:ps,QTr:Es,QTd:Ds,QTabs:li,QTab:ui,QRouteTab:Rs,QTime:Is,QTimeline:$s,QTimelineEntry:Fs,QToggle:Xo,QToolbar:Bs,QToolbarTitle:Vs,QTooltip:Qr,QTree:Hs,QUploader:Gs,QUploaderBase:Ws,QUploaderAddTrigger:Qs,QVideo:Ks,QVirtualScroll:ks});function Js(e){if(!1===e)return 0;if(!0===e||void 0===e)return 1;var t=parseInt(e,10);return isNaN(t)?0:t}function Xs(e){var t=e.__qclosepopup;void 0!==t&&(e.removeEventListener("click",t.handler),e.removeEventListener("keyup",t.handlerKey),delete e.__qclosepopup)}var el={name:"close-popup",bind:function(e,t,n){var i=t.value;void 0!==e.__qclosepopup&&(Xs(e),e.__qclosepopup_destroyed=!0);var r={depth:Js(i),handler:function(e){0!==r.depth&&setTimeout((function(){!function(e,t,n){for(;0!==n&&void 0!==e;){if(void 0!==e.__renderPortal){if(n--,"QMenu"===e.$options.name){e=Ct(e,t);continue}e.hide(t)}e=e.$parent}}(n.componentInstance||n.context,e,r.depth)}))},handlerKey:function(e){!0===X(e,13)&&r.handler(e)}};e.__qclosepopup=r,e.addEventListener("click",r.handler),e.addEventListener("keyup",r.handlerKey)},update:function(e,t){var n=t.value,i=t.oldValue;void 0!==e.__qclosepopup&&n!==i&&(e.__qclosepopup.depth=Js(n))},unbind:function(e){void 0===e.__qclosepopup_destroyed?Xs(e):delete e.__qclosepopup_destroyed}};function tl(e){var t=e.__qgoback;void 0!==t&&(e.removeEventListener("click",t.goBack),e.removeEventListener("keyup",t.goBackKey),delete e.__qgoback)}var nl={name:"go-back",bind:function(e,t,n){var i=t.value,r=t.modifiers;void 0!==e.__qgoback&&(tl(e),e.__qgoback_destroyed=!0);var o={value:i,position:window.history.length-1,single:r.single,goBack:function(){var e=n.context.$router;!0===o.single?e.go(-1):!0===d.is.nativeMobile?e.go(o.position-window.history.length):e.replace(o.value)},goBackKey:function(e){!0===X(e,13)&&o.goBack()}};e.__qgoback=o,e.addEventListener("click",o.goBack),e.addEventListener("keyup",o.goBackKey)},update:function(e,t){var n=t.value,i=t.oldValue,r=e.__qgoback;void 0!==r&&n!==i&&(r.value=n)},unbind:function(e){void 0===e.__qgoback_destroyed?tl(e):delete e.__qgoback_destroyed}},il=0,rl=void 0;function ol(e,t){void 0===rl&&((rl=document.createElement("div")).style.cssText="position: absolute; left: 0; top: 0",document.body.appendChild(rl));var n=e.getBoundingClientRect(),i=rl.getBoundingClientRect(),r=window.getComputedStyle(e),o=r.marginLeft,a=r.marginRight,s=r.marginTop,l=r.marginBottom,c=parseInt(o,10)+parseInt(a,10),u=parseInt(s,10)+parseInt(l,10);return{left:n.left-i.left,top:n.top-i.top,width:n.right-n.left,height:n.bottom-n.top,widthM:n.right-n.left+(!0===t?0:c),heightM:n.bottom-n.top+(!0===t?0:u),marginH:!0===t?c:0,marginV:!0===t?u:0}}function al(e){return{width:e.scrollWidth,height:e.scrollHeight}}var sl=["Top","Right","Bottom","Left"],ll=["borderTopLeftRadius","borderTopRightRadius","borderBottomRightRadius","borderBottomLeftRadius"];function cl(e,t){for(var n=window.getComputedStyle(e),i={},r=0;r<t.length;r++){var o=t[r];if(""===n[o])if("cssText"===o){for(var a=n.length,s="",l=0;l<a;l++)s+=n[l]+": "+n[n[l]]+"; ";i[o]=s}else if(["borderWidth","borderStyle","borderColor"].indexOf(o)>-1){for(var c=o.replace("border",""),u="",d=0;d<sl.length;d++){u+=n["border"+sl[d]+c]+" "}i[o]=u}else if("borderRadius"===o){for(var h="",f="",p=0;p<ll.length;p++){var m=n[ll[p]].split(" ");h+=m[0]+" ",f+=(void 0===m[1]?m[0]:m[1])+" "}i[o]=h+"/ "+f}else i[o]=n[o];else i[o]=n[o]}return i}function ul(e){var t=typeof e;return"function"===t?e():"string"===t?document.querySelector(e):e}function dl(e){return e&&e.ownerDocument===document&&null!==e.parentNode}function hl(e){var t=function(){return!1},n=!1,i=!0,r=function(e){return{from:e.from,to:void 0!==e.to?e.to:e.from}}(e),o=function(e){return"number"==typeof e?e={duration:e}:"function"==typeof e&&(e={onEnd:e}),Object.assign({},e,{waitFor:void 0===e.waitFor?0:e.waitFor,duration:!0===isNaN(e.duration)?300:parseInt(e.duration,10),easing:"string"==typeof e.easing&&e.easing.length>0?e.easing:"ease-in-out",delay:!0===isNaN(e.delay)?0:parseInt(e.delay,10),fill:"string"==typeof e.fill&&e.fill.length>0?e.fill:"none",resize:!0===e.resize,useCSS:!0===e.useCSS,hideFromClone:!0===e.hideFromClone,keepToClone:!0===e.keepToClone,tween:!0===e.tween,tweenFromOpacity:!0===isNaN(e.tweenFromOpacity)?.6:parseFloat(e.tweenFromOpacity),tweenToOpacity:!0===isNaN(e.tweenToOpacity)?.5:parseFloat(e.tweenToOpacity)})}(e),a=ul(r.from);if(!0!==dl(a))return t;"function"==typeof a.qMorphCancel&&a.qMorphCancel();var s=void 0,l=void 0,c=void 0,u=void 0,d=a.parentNode,h=a.nextElementSibling,f=ol(a,o.resize),p=al(d),m=p.width,v=p.height,g=cl(a,["borderWidth","borderStyle","borderColor","borderRadius","backgroundColor","transform","position","cssText"]),_=g.borderWidth,b=g.borderStyle,y=g.borderColor,w=g.borderRadius,k=g.backgroundColor,x=g.transform,S=g.position,C=g.cssText,M=a.classList.toString(),T=a.style.cssText,A=a.cloneNode(!0),P=!0===o.tween?a.cloneNode(!0):void 0;void 0!==P&&(P.className=P.classList.toString().split(" ").filter((function(e){return!1===/^bg-/.test(e)})).join(" ")),!0===o.hideFromClone&&A.classList.add("q-morph--internal"),A.setAttribute("aria-hidden","true"),A.style.transition="none",A.style.animation="none",A.style.pointerEvents="none",d.insertBefore(A,h),a.qMorphCancel=function(){n=!0,A.remove(),void 0!==P&&P.remove(),!0===o.hideFromClone&&A.classList.remove("q-morph--internal"),a.qMorphCancel=void 0};return"function"==typeof e.onToggle&&e.onToggle(),requestAnimationFrame((function(){var e=ul(r.to);if(!0!==n&&!0===dl(e)){a!==e&&"function"==typeof e.qMorphCancel&&e.qMorphCancel(),!0!==o.keepToClone&&e.classList.add("q-morph--internal"),A.classList.add("q-morph--internal");var h=al(d),p=h.width,g=h.height,L=al(e.parentNode),O=L.width,q=L.height;!0!==o.hideFromClone&&A.classList.remove("q-morph--internal"),e.qMorphCancel=function(){n=!0,A.remove(),void 0!==P&&P.remove(),!0===o.hideFromClone&&A.classList.remove("q-morph--internal"),!0!==o.keepToClone&&e.classList.remove("q-morph--internal"),a.qMorphCancel=void 0,e.qMorphCancel=void 0};var E=function(){if(!0!==n){!0!==o.hideFromClone&&(A.classList.add("q-morph--internal"),A.innerHTML="",A.style.left=0,A.style.right="unset",A.style.top=0,A.style.bottom="unset",A.style.transform="none"),!0!==o.keepToClone&&e.classList.remove("q-morph--internal");var r=e.parentNode,h=al(r),L=h.width,E=h.height,D=e.cloneNode(o.keepToClone);D.setAttribute("aria-hidden","true"),!0!==o.keepToClone&&(D.style.left=0,D.style.right="unset",D.style.top=0,D.style.bottom="unset",D.style.transform="none",D.style.pointerEvents="none"),D.classList.add("q-morph--internal");var z=e===a&&d===r?A:e.nextElementSibling;r.insertBefore(D,z);var N=cl(e,["borderWidth","borderStyle","borderColor","borderRadius","backgroundColor","transform","position","cssText"]),j=N.borderWidth,R=N.borderStyle,I=N.borderColor,$=N.borderRadius,F=N.backgroundColor,B=N.transform,V=N.position,H=N.cssText,W=e.classList.toString(),U=e.style.cssText;e.style.cssText=H,e.style.transform="none",e.style.animation="none",e.style.transition="none",e.className=W.split(" ").filter((function(e){return!1===/^bg-/.test(e)})).join(" ");for(var Y=ol(e,o.resize),G=f.left-Y.left,Q=f.top-Y.top,K=f.width/(Y.width>0?Y.width:10),Z=f.height/(Y.height>0?Y.height:100),J=m-p,X=v-g,ee=L-O,te=E-q,ne=Math.max(f.widthM,J),ie=Math.max(f.heightM,X),re=Math.max(Y.widthM,ee),oe=Math.max(Y.heightM,te),ae=a===e&&!1===["absolute","fixed"].includes(V)&&!1===["absolute","fixed"].includes(S),se="fixed"===V,le=r;!0!==se&&le!==document;)se="fixed"===window.getComputedStyle(le).position,le=le.parentNode;if(!0!==o.hideFromClone&&(A.style.display="block",A.style.flex="0 0 auto",A.style.opacity=0,A.style.minWidth="unset",A.style.maxWidth="unset",A.style.minHeight="unset",A.style.maxHeight="unset",A.classList.remove("q-morph--internal")),!0!==o.keepToClone&&(D.style.display="block",D.style.flex="0 0 auto",D.style.opacity=0,D.style.minWidth="unset",D.style.maxWidth="unset",D.style.minHeight="unset",D.style.maxHeight="unset"),D.classList.remove("q-morph--internal"),"string"==typeof o.classes&&(e.className+=" "+o.classes),"string"==typeof o.style)e.style.cssText+=" "+o.style;else if(o.style===Object(o.style))for(var ce in o.style)e.style[ce]=o.style[ce];var ue=!0===se?document.documentElement:{scrollLeft:0,scrollTop:0};e.style.position=!0===se?"fixed":"absolute",e.style.left=Y.left-ue.scrollLeft+"px",e.style.right="unset",e.style.top=Y.top-ue.scrollTop+"px",e.style.margin=0,!0===o.resize&&(e.style.minWidth="unset",e.style.maxWidth="unset",e.style.minHeight="unset",e.style.maxHeight="unset",e.style.overflow="hidden",e.style.overflowX="hidden",e.style.overflowY="hidden"),document.body.appendChild(e),void 0!==P&&(P.style.cssText=C,P.style.transform="none",P.style.animation="none",P.style.transition="none",P.style.position=e.style.position,P.style.left=f.left-ue.scrollLeft+"px",P.style.right="unset",P.style.top=f.top-ue.scrollTop+"px",P.style.margin=0,P.style.pointerEvents="none",!0===o.resize&&(P.style.minWidth="unset",P.style.maxWidth="unset",P.style.minHeight="unset",P.style.maxHeight="unset",P.style.overflow="hidden",P.style.overflowX="hidden",P.style.overflowY="hidden"),document.body.appendChild(P));var de=function(n){a===e&&!0!==i?(e.style.cssText=T,e.className=M):(e.style.cssText=U,e.className=W),D.parentNode===r&&r.insertBefore(e,D),A.remove(),D.remove(),void 0!==P&&P.remove(),t=function(){return!1},a.qMorphCancel=void 0,e.qMorphCancel=void 0,"function"==typeof o.onEnd&&o.onEnd(!0===i?"to":"from",!0===n)};if(!0!==o.useCSS&&"function"==typeof e.animate){var he=!0===o.resize?{transform:"translate("+G+"px, "+Q+"px)",width:ne+"px",height:ie+"px"}:{transform:"translate("+G+"px, "+Q+"px) scale("+K+", "+Z+")"},fe=!0===o.resize?{width:re+"px",height:oe+"px"}:{},pe=!0===o.resize?{width:ne+"px",height:ie+"px"}:{},me=!0===o.resize?{transform:"translate("+-1*G+"px, "+-1*Q+"px)",width:re+"px",height:oe+"px"}:{transform:"translate("+-1*G+"px, "+-1*Q+"px) scale("+1/K+", "+1/Z+")"},ve=void 0!==P?{opacity:o.tweenToOpacity}:{backgroundColor:k},ge=void 0!==P?{opacity:1}:{backgroundColor:F};u=e.animate([Object.assign({},{margin:0,borderWidth:_,borderStyle:b,borderColor:y,borderRadius:w,transformOrigin:"0 0"},he,ve),Object.assign({},{margin:0,borderWidth:j,borderStyle:R,borderColor:I,borderRadius:$,transformOrigin:"0 0",transform:B},fe,ge)],{duration:o.duration,easing:o.easing,fill:o.fill,delay:o.delay}),l=void 0===P?void 0:P.animate([Object.assign({},{opacity:o.tweenFromOpacity,margin:0,borderWidth:_,borderStyle:b,borderColor:y,borderRadius:w,transformOrigin:"0 0",transform:x},pe),Object.assign({},{opacity:0,margin:0,borderWidth:j,borderStyle:R,borderColor:I,borderRadius:$,transformOrigin:"0 0"},me)],{duration:o.duration,easing:o.easing,fill:o.fill,delay:o.delay}),s=!0===o.hideFromClone||!0===ae?void 0:A.animate([{margin:(X<0?X/2:0)+"px "+(J<0?J/2:0)+"px",width:ne+f.marginH+"px",height:ie+f.marginV+"px"},{margin:0,width:0,height:0}],{duration:o.duration,easing:o.easing,fill:o.fill,delay:o.delay}),c=!0===o.keepToClone?void 0:D.animate([!0===ae?{margin:(X<0?X/2:0)+"px "+(J<0?J/2:0)+"px",width:ne+f.marginH+"px",height:ie+f.marginV+"px"}:{margin:0,width:0,height:0},{margin:(te<0?te/2:0)+"px "+(ee<0?ee/2:0)+"px",width:re+Y.marginH+"px",height:oe+Y.marginV+"px"}],{duration:o.duration,easing:o.easing,fill:o.fill,delay:o.delay});var _e=function(e){void 0!==s&&s.cancel(),void 0!==l&&l.cancel(),void 0!==c&&c.cancel(),u.cancel(),u.removeEventListener("finish",_e),u.removeEventListener("cancel",_e),de(e),s=void 0,l=void 0,c=void 0,u=void 0};a.qMorphCancel=function(){a.qMorphCancel=void 0,n=!0,_e()},e.qMorphCancel=function(){e.qMorphCancel=void 0,n=!0,_e()},u.addEventListener("finish",_e),u.addEventListener("cancel",_e),t=function(e){return!0!==n&&void 0!==u&&(!0===e?(_e(!0),!0):(i=!0!==i,void 0!==s&&s.reverse(),void 0!==l&&l.reverse(),void 0!==c&&c.reverse(),u.reverse(),!0))}}else{var be="q-morph-anim-"+ ++il,ye=document.createElement("style"),we=!0===o.resize?"\n            transform: translate("+G+"px, "+Q+"px);\n            width: "+ne+"px;\n            height: "+ie+"px;\n          ":"transform: translate("+G+"px, "+Q+"px) scale("+K+", "+Z+");",ke=!0===o.resize?"\n            width: "+re+"px;\n            height: "+oe+"px;\n          ":"",xe=!0===o.resize?"\n            width: "+ne+"px;\n            height: "+ie+"px;\n          ":"",Se=!0===o.resize?"\n            transform: translate("+-1*G+"px, "+-1*Q+"px);\n            width: "+re+"px;\n            height: "+oe+"px;\n          ":"transform: translate("+-1*G+"px, "+-1*Q+"px) scale("+1/K+", "+1/Z+");",Ce=void 0!==P?"opacity: "+o.tweenToOpacity+";":"background-color: "+k+";",Me=void 0!==P?"opacity: 1;":"background-color: "+F+";",Te=void 0===P?"":"\n            @keyframes "+be+"-from-tween {\n              0% {\n                opacity: "+o.tweenFromOpacity+";\n                margin: 0;\n                border-width: "+_+";\n                border-style: "+b+";\n                border-color: "+y+";\n                border-radius: "+w+";\n                transform-origin: 0 0;\n                transform: "+x+";\n                "+xe+"\n              }\n\n              100% {\n                opacity: 0;\n                margin: 0;\n                border-width: "+j+";\n                border-style: "+R+";\n                border-color: "+I+";\n                border-radius: "+$+";\n                transform-origin: 0 0;\n                "+Se+"\n              }\n            }\n          ",Ae=!0===o.hideFromClone||!0===ae?"":"\n            @keyframes "+be+"-from {\n              0% {\n                margin: "+(X<0?X/2:0)+"px "+(J<0?J/2:0)+"px;\n                width: "+(ne+f.marginH)+"px;\n                height: "+(ie+f.marginV)+"px;\n              }\n\n              100% {\n                margin: 0;\n                width: 0;\n                height: 0;\n              }\n            }\n          ",Pe=!0===ae?"\n            margin: "+(X<0?X/2:0)+"px "+(J<0?J/2:0)+"px;\n            width: "+(ne+f.marginH)+"px;\n            height: "+(ie+f.marginV)+"px;\n          ":"\n            margin: 0;\n            width: 0;\n            height: 0;\n          ",Le=!0===o.keepToClone?"":"\n            @keyframes "+be+"-to {\n              0% {\n                "+Pe+"\n              }\n\n              100% {\n                margin: "+(te<0?te/2:0)+"px "+(ee<0?ee/2:0)+"px;\n                width: "+(re+Y.marginH)+"px;\n                height: "+(oe+Y.marginV)+"px;\n              }\n            }\n          ";ye.innerHTML="\n          @keyframes "+be+" {\n            0% {\n              margin: 0;\n              border-width: "+_+";\n              border-style: "+b+";\n              border-color: "+y+";\n              border-radius: "+w+";\n              background-color: "+k+";\n              transform-origin: 0 0;\n              "+we+"\n              "+Ce+"\n            }\n\n            100% {\n              margin: 0;\n              border-width: "+j+";\n              border-style: "+R+";\n              border-color: "+I+";\n              border-radius: "+$+";\n              background-color: "+F+";\n              transform-origin: 0 0;\n              transform: "+B+";\n              "+ke+"\n              "+Me+"\n            }\n          }\n\n          "+Ae+"\n\n          "+Te+"\n\n          "+Le+"\n        ",document.head.appendChild(ye);var Oe="normal";A.style.animation=o.duration+"ms "+o.easing+" "+o.delay+"ms "+Oe+" "+o.fill+" "+be+"-from",void 0!==P&&(P.style.animation=o.duration+"ms "+o.easing+" "+o.delay+"ms "+Oe+" "+o.fill+" "+be+"-from-tween"),D.style.animation=o.duration+"ms "+o.easing+" "+o.delay+"ms "+Oe+" "+o.fill+" "+be+"-to",e.style.animation=o.duration+"ms "+o.easing+" "+o.delay+"ms "+Oe+" "+o.fill+" "+be;var qe=function(t){t===Object(t)&&t.animationName!==be||(e.removeEventListener("animationend",qe),e.removeEventListener("animationcancel",qe),de(),ye.remove())};a.qMorphCancel=function(){a.qMorphCancel=void 0,n=!0,qe()},e.qMorphCancel=function(){e.qMorphCancel=void 0,n=!0,qe()},e.addEventListener("animationend",qe),e.addEventListener("animationcancel",qe),t=function(t){return!!(!0!==n&&e&&A&&D)&&(!0===t?(qe(),!0):(i=!0!==i,Oe="normal"===Oe?"reverse":"normal",A.style.animationDirection=Oe,P.style.animationDirection=Oe,D.style.animationDirection=Oe,e.style.animationDirection=Oe,!0))}}}else"function"==typeof e.qMorphCancel&&e.qMorphCancel()};if(o.waitFor>0||"transitionend"===o.waitFor||o.waitFor===Object(o.waitFor)&&"function"==typeof o.waitFor.then){var D=o.waitFor>0?new Promise((function(e){return setTimeout(e,o.waitFor)})):"transitionend"===o.waitFor?new Promise((function(t){var n=setTimeout((function(){i()}),400),i=function(r){clearTimeout(n),e&&(e.removeEventListener("transitionend",i),e.removeEventListener("transitioncancel",i)),t()};e.addEventListener("transitionend",i),e.addEventListener("transitioncancel",i)})):o.waitFor;D.then(E).catch((function(){"function"==typeof e.qMorphCancel&&e.qMorphCancel()}))}else E()}else"function"==typeof a.qMorphCancel&&a.qMorphCancel()})),function(e){return t(e)}}var fl={},pl=["duration","delay","easing","fill","classes","style","duration","resize","useCSS","hideFromClone","keepToClone","tween","tweenFromOpacity","tweenToOpacity","waitFor","onEnd"],ml=["resize","useCSS","hideFromClone","keepToClone","tween"];function vl(e,t){e.clsAction!==t&&(e.clsAction=t,e.el.classList[t]("q-morph--invisible"))}function gl(e){if(!(!0===e.animating||e.queue.length<2)){var t=e.queue,n=t[0],i=t[1];e.animating=!0,n.animating=!0,i.animating=!0,vl(n,"remove"),vl(i,"remove");var r=hl(Object.assign({},{from:n.el,to:i.el,onToggle:function(){vl(n,"add"),vl(i,"remove")}},i.opts,{onEnd:function(t,r){void 0!==i.opts.onEnd&&i.opts.onEnd(t,r),!0!==r&&(n.animating=!1,i.animating=!1,e.animating=!1,e.cancel=void 0,e.queue.shift(),gl(e))}}));e.cancel=function(){r(!0),e.cancel=void 0}}}function _l(e,t){var n=t.opts;ml.forEach((function(t){n[t]=!0===e[t]}))}function bl(e,t){if(t.name!==e)!1===t.animating&&vl(t,"add");else{var n=fl[t.group];void 0===n?(fl[t.group]={name:t.group,model:e,queue:[t],animating:!1},vl(t,"remove")):n.model!==e&&(n.model=e,n.queue.push(t),!1===n.animating&&2===n.queue.length&&gl(n))}}function yl(e,t){var n;Object(t)===t?(n=""+t.model,function(e,t){void 0!==e.group&&(t.group=e.group),void 0!==e.name&&(t.name=e.name);var n=t.opts;pl.forEach((function(t){void 0!==e[t]&&(n[t]=e[t])}))}(t,e),_l(t,e)):n=""+t,n!==e.model?(e.model=n,bl(n,e)):!1===e.animating&&void 0!==e.clsAction&&e.el.classList[e.clsAction]("q-morph--invisible")}function wl(e){var t=e.__qmorph;if(void 0!==t){var n=fl[t.group];if(void 0!==n)-1!==n.queue.indexOf(t)&&(n.queue=n.queue.filter((function(e){return e!==t})),0===n.queue.length&&(void 0!==n.cancel&&n.cancel(),delete fl[t.group]));"add"===t.clsAction&&e.classList.remove("q-morph--invisible"),delete e.__qmorph}}var kl={name:"morph",inserted:function(e,t){void 0!==e.__qmorph&&(wl(e),e.__qmorph_destroyed=!0);var n={el:e,animating:!1,opts:{}};_l(t.modifiers,n),function(e,t){var n="string"==typeof e&&e.length>0?e.split(":"):[];t.name=n[0],t.group=n[1],Object.assign(t.opts,{duration:!0===isNaN(n[2])?300:parseFloat(n[2]),waitFor:n[3]})}(t.arg,n),yl(n,t.value),e.__qmorph=n},update:function(e,t){var n=e.__qmorph;void 0!==n&&yl(n,t.value)},unbind:function(e){void 0===e.__qmorph_destroyed?wl(e):delete e.__qmorph_destroyed}};var xl={childList:!0,subtree:!0,attributes:!0,characterData:!0,attributeOldValue:!0,characterDataOldValue:!0};function Sl(e,t,n){t.handler=n,void 0!==t.observer&&t.observer.disconnect(),t.observer=new MutationObserver((function(n){"function"==typeof t.handler&&(!1!==t.handler(n)&&!0!==t.once||Cl(e))})),t.observer.observe(e,t.opts)}function Cl(e){var t=e.__qmutation;void 0!==t&&(void 0!==t.observer&&t.observer.disconnect(),delete e.__qmutation)}var Ml={name:"mutation",inserted:function(e,t){var n=t.modifiers,i=n.once,r=function(e,t){var n={};for(var i in e)Object.prototype.hasOwnProperty.call(e,i)&&-1===t.indexOf(i)&&(n[i]=e[i]);return n}(n,["once"]),o=t.value;void 0!==e.__qmutation&&(Cl(e),e.__qmutation_destroyed=!0);var a={once:i,opts:0===Object.keys(r).length?xl:r};Sl(e,a,o),e.__qmutation=a},update:function(e,t){var n=t.oldValue,i=t.value,r=e.__qmutation;void 0!==r&&n!==i&&Sl(e,r,i)},unbind:function(e){void 0===e.__qmutation_destroyed?Cl(e):delete e.__qmutation_destroyed}};function Tl(e,t){var n=t.value,i=t.oldValue;"function"==typeof n?(e.handler=n,"function"!=typeof i&&(e.scrollTarget.addEventListener("scroll",e.scroll,f.passive),e.scroll())):e.scrollTarget.removeEventListener("scroll",e.scroll)}function Al(e){var t=e.__qscrollfire;void 0!==t&&(t.scrollTarget.removeEventListener("scroll",t.scroll,f.passive),delete e.__qscrollfire)}var Pl={name:"scroll-fire",inserted:function(e,t){void 0!==e.__qscrollfire&&(Al(e),e.__qscrollfire_destroyed=!0);var n={scrollTarget:jt(e),scroll:T((function(){var t,i;n.scrollTarget===window?(i=e.getBoundingClientRect().bottom,t=window.innerHeight):(i=Ke(e).top+Ze(e),t=Ke(n.scrollTarget).top+Ze(n.scrollTarget)),i>0&&i<t&&(n.scrollTarget.removeEventListener("scroll",n.scroll,f.passive),n.handler(e))}),25)};Tl(n,t),e.__qscrollfire=n},update:function(e,t){void 0!==e.__qscrollfire&&t.value!==t.oldValue&&Tl(e.__qscrollfire,t)},unbind:function(e){void 0===e.__qscrollfire_destroyed?Al(e):delete e.__qscrollfire_destroyed}};function Ll(e,t){var n=t.value,i=t.oldValue;"function"==typeof n?(e.handler=n,"function"!=typeof i&&e.scrollTarget.addEventListener("scroll",e.scroll,f.passive)):e.scrollTarget.removeEventListener("scroll",e.scroll,f.passive)}function Ol(e){var t=e.__qscroll;void 0!==t&&(t.scrollTarget.removeEventListener("scroll",t.scroll,f.passive),delete e.__qscroll)}var ql={name:"scroll",inserted:function(e,t){void 0!==e.__qscroll&&(Ol(e),e.__qscroll_destroyed=!0);var n={scrollTarget:jt(e),scroll:function(){n.handler(It(n.scrollTarget),$t(n.scrollTarget))}};Ll(n,t),e.__qscroll=n},update:function(e,t){void 0!==e.__qscroll&&t.oldValue!==t.value&&Ll(e.__qscroll,t)},unbind:function(e){void 0===e.__qscroll_destroyed?Ol(e):delete e.__qscroll_destroyed}};function El(e){var t=e.__qtouchhold;void 0!==t&&(C(t,"main"),C(t,"temp"),clearTimeout(t.timer),void 0!==t.styleCleanup&&t.styleCleanup(),delete e.__qtouchhold)}var Dl={name:"touch-hold",bind:function(e,t){var n;void 0!==e.__qtouchhold&&(El(e),e.__qtouchhold_destroyed=!0);var i=t.modifiers;if(!0===i.mouse||!0===d.has.touch){var r={handler:t.value,noop:m,mouseStart:function(e){"function"==typeof r.handler&&!0===v(e)&&(S(r,"temp",[[document,"mousemove","move","passiveCapture"],[document,"click","end","notPassiveCapture"]]),r.start(e,!0))},touchStart:function(e){if(void 0!==e.target&&"function"==typeof r.handler){var t=ht(e.target);S(r,"temp",[[t,"touchmove","move","passiveCapture"],[t,"touchcancel","end","notPassiveCapture"],[t,"touchend","end","notPassiveCapture"]]),r.start(e)}},start:function(e,t){r.origin=g(e);var n=Date.now();!0===d.is.mobile&&(document.body.classList.add("non-selectable"),wt(),r.styleCleanup=function(e){r.styleCleanup=void 0;var t=function(){document.body.classList.remove("non-selectable")};!0===e?(wt(),setTimeout(t,10)):t()}),r.triggered=!1,r.sensitivity=!0===t?r.mouseSensitivity:r.touchSensitivity,r.timer=setTimeout((function(){wt(),r.triggered=!0,r.handler({evt:e,touch:!0!==t,mouse:!0===t,position:r.origin,duration:Date.now()-n})}),r.duration)},move:function(e){var t=g(e),n=t.top,i=t.left;(Math.abs(i-r.origin.left)>=r.sensitivity||Math.abs(n-r.origin.top)>=r.sensitivity)&&clearTimeout(r.timer)},end:function(e){C(r,"temp"),void 0!==r.styleCleanup&&r.styleCleanup(r.triggered),!0===r.triggered?void 0!==e&&w(e):clearTimeout(r.timer)}},o=[600,5,7];"string"==typeof t.arg&&t.arg.length>0&&t.arg.split(":").forEach((function(e,t){var n=parseInt(e,10);n&&(o[t]=n)})),n=o,r.duration=n[0],r.touchSensitivity=n[1],r.mouseSensitivity=n[2],e.__qtouchhold=r,!0===i.mouse&&S(r,"main",[[e,"mousedown","mouseStart","passive"+(!0===i.mouseCapture?"Capture":"")]]),!0===d.has.touch&&S(r,"main",[[e,"touchstart","touchStart","passive"+(!0===i.capture?"Capture":"")],[e,"touchend","noop","notPassiveCapture"]])}},update:function(e,t){var n=e.__qtouchhold;void 0!==n&&t.oldValue!==t.value&&("function"!=typeof t.value&&n.end(),n.handler=t.value)},unbind:function(e){void 0===e.__qtouchhold_destroyed?El(e):delete e.__qtouchhold_destroyed}},zl={esc:27,tab:9,enter:13,space:32,up:38,left:37,right:39,down:40,delete:[8,46]},Nl=new RegExp("^([\\d+]+|"+Object.keys(zl).join("|")+")$","i");function jl(e){var t=e.__qtouchrepeat;void 0!==t&&(clearTimeout(t.timer),C(t,"main"),C(t,"temp"),void 0!==t.styleCleanup&&t.styleCleanup(),delete e.__qtouchrepeat)}var Rl,Il={name:"touch-repeat",bind:function(e,t){var n=t.modifiers,i=t.value,r=t.arg;void 0!==e.__qtouchrepeat&&(jl(e),e.__qtouchrepeat_destroyed=!0);var o=Object.keys(n).reduce((function(e,t){if(!0===Nl.test(t)){var n=isNaN(parseInt(t,10))?zl[t.toLowerCase()]:parseInt(t,10);n>=0&&e.push(n)}return e}),[]);if(!0===n.mouse||!0===d.has.touch||0!==o.length){var a="string"==typeof r&&r.length>0?r.split(":").map((function(e){return parseInt(e,10)})):[0,600,300],s=a.length-1,l={keyboard:o,handler:i,noop:m,mouseStart:function(e){void 0===l.event&&"function"==typeof l.handler&&!0===v(e)&&(S(l,"temp",[[document,"mousemove","move","passiveCapture"],[document,"click","end","notPassiveCapture"]]),l.start(e,!0))},keyboardStart:function(t){if("function"==typeof l.handler&&!0===X(t,o)){if((0===a[0]||void 0!==l.event)&&(w(t),e.focus(),void 0!==l.event))return;S(l,"temp",[[document,"keyup","end","notPassiveCapture"],[document,"click","end","notPassiveCapture"]]),l.start(t,!1,!0)}},touchStart:function(e){if(void 0!==e.target&&"function"==typeof l.handler){var t=ht(e.target);S(l,"temp",[[t,"touchmove","move","passiveCapture"],[t,"touchcancel","end","notPassiveCapture"],[t,"touchend","end","notPassiveCapture"]]),l.start(e)}},start:function(e,t,n){function i(e){l.styleCleanup=void 0,document.documentElement.style.cursor="";var t=function(){document.body.classList.remove("non-selectable")};!0===e?(wt(),setTimeout(t,10)):t()}!0!==n&&(l.origin=g(e)),!0===d.is.mobile&&(document.body.classList.add("non-selectable"),wt(),l.styleCleanup=i),l.event={touch:!0!==t&&!0!==n,mouse:!0===t,keyboard:!0===n,startTime:Date.now(),repeatCount:0};var r=function(){if(void 0!==l.event){0===l.event.repeatCount&&(l.event.evt=e,!0===n?l.event.keyCode=e.keyCode:l.event.position=g(e),!0!==d.is.mobile&&(document.documentElement.style.cursor="pointer",document.body.classList.add("non-selectable"),wt(),l.styleCleanup=i)),l.event.duration=Date.now()-l.event.startTime,l.event.repeatCount+=1,l.handler(l.event);var t=s<l.event.repeatCount?s:l.event.repeatCount;l.timer=setTimeout(r,a[t])}};0===a[0]?r():l.timer=setTimeout(r,a[0])},move:function(e){void 0!==l.event&&!0===function(e,t){var n=g(e),i=n.top,r=n.left;return Math.abs(r-t.left)>=7||Math.abs(i-t.top)>=7}(e,l.origin)&&clearTimeout(l.timer)},end:function(e){void 0!==l.event&&(void 0!==l.styleCleanup&&l.styleCleanup(!0),void 0!==e&&l.event.repeatCount>0&&w(e),C(l,"temp"),clearTimeout(l.timer),l.event=void 0)}};e.__qtouchrepeat=l,!0===n.mouse&&S(l,"main",[[e,"mousedown","mouseStart","passive"+(!0===n.mouseCapture?"Capture":"")]]),!0===d.has.touch&&S(l,"main",[[e,"touchstart","touchStart","passive"+(!0===n.capture?"Capture":"")],[e,"touchend","noop","notPassiveCapture"]]),o.length>0&&S(l,"main",[[e,"keydown","keyboardStart","notPassive"+(!0===n.keyCapture?"Capture":"")]])}},update:function(e,t){var n=t.oldValue,i=t.value,r=e.__qtouchrepeat;void 0!==r&&n!==i&&("function"!=typeof i&&r.end(),r.handler=i)},unbind:function(e){void 0===e.__qtouchrepeat_destroyed?jl(e):delete e.__qtouchrepeat_destroyed}},$l=Object.freeze({__proto__:null,ClosePopup:el,GoBack:nl,Intersection:Vo,Morph:kl,Mutation:Ml,Ripple:ot,ScrollFire:Pl,Scroll:ql,TouchHold:Dl,TouchPan:Qn,TouchRepeat:Il,TouchSwipe:vn});function Fl(e){void 0===Rl&&(Rl=h.is.winphone?"msapplication-navbutton-color":h.is.safari?"apple-mobile-web-app-status-bar-style":"theme-color");var t=function(e){var t=document.getElementsByTagName("META");for(var n in t)if(t[n].name===e)return t[n]}(Rl),n=void 0===t;n&&(t=document.createElement("meta")).setAttribute("name",Rl),t.setAttribute("content",e),n&&document.head.appendChild(t)}var Bl={install:function(e){var t=e.$q,n=e.cfg;this.set=!1!==i||!0!==h.is.mobile||!0!==h.is.nativeMobile&&!0!==h.is.winphone&&!0!==h.is.safari&&!0!==h.is.webkit&&!0!==h.is.vivaldi?m:function(e){var t=e||G("primary");!0===h.is.nativeMobile&&window.StatusBar?window.StatusBar.backgroundColorByHexString(t):Fl(t)},t.addressbarColor=this,n.addressbarColor&&this.set(n.addressbarColor)}},Vl={};function Hl(e,t){try{var n=e[t]();return void 0===n?Promise.resolve():n}catch(e){return Promise.reject(e)}}var Wl={isCapable:!1,isActive:!1,activeEl:null,request:function(e){var t=this;if(!0===this.isCapable&&!1===this.isActive){var n=e||document.documentElement;return Hl(n,Vl.request).then((function(){t.activeEl=n}))}return this.__getErr()},exit:function(){var e=this;return!0===this.isCapable&&!0===this.isActive?Hl(document,Vl.exit).then((function(){e.activeEl=null})):this.__getErr()},toggle:function(e){return!0===this.isActive?this.exit():this.request(e)},install:function(t){var n=this;t.$q.fullscreen=this,!0!==i&&(Vl.request=["requestFullscreen","msRequestFullscreen","mozRequestFullScreen","webkitRequestFullscreen"].find((function(e){return void 0!==document.documentElement[e]})),this.isCapable=void 0!==Vl.request,!1!==this.isCapable?(this.__getErr=function(){return Promise.resolve()},Vl.exit=["exitFullscreen","msExitFullscreen","mozCancelFullScreen","webkitExitFullscreen"].find((function(e){return document[e]})),this.isActive=!!(document.fullscreenElement||document.mozFullScreenElement||document.webkitFullscreenElement||document.msFullscreenElement),["onfullscreenchange","onmsfullscreenchange","onwebkitfullscreenchange"].forEach((function(e){document[e]=function(){n.isActive=!1===n.isActive}})),e.util.defineReactive(this,"isActive",this.isActive),e.util.defineReactive(this,"activeEl",this.activeEl)):this.__getErr=function(){return Promise.reject("Not capable")})}},Ul={appVisible:!1,install:function(t){var n=this,r=t.$q;if(!0!==i){var o,a;void 0!==document.hidden?(o="hidden",a="visibilitychange"):void 0!==document.msHidden?(o="msHidden",a="msvisibilitychange"):void 0!==document.webkitHidden&&(o="webkitHidden",a="webkitvisibilitychange");var s=function(){n.appVisible=r.appVisible=!document[o]};s(),a&&void 0!==document[o]&&(e.util.defineReactive(r,"appVisible",this.appVisible),document.addEventListener(a,s,!1))}else this.appVisible=r.appVisible=!0}},Yl=e.extend({name:"BottomSheetPlugin",mixins:[je,_e],inheritAttrs:!1,props:{title:String,message:String,actions:Array,grid:Boolean,cardClass:[String,Array,Object],cardStyle:[String,Array,Object]},computed:{dialogProps:function(){return Object.assign({},this.qAttrs,{position:"bottom"})}},methods:{show:function(){this.$refs.dialog.show()},hide:function(){this.$refs.dialog.hide()},onOk:function(e){this.$emit("ok",e),this.hide()},__getGrid:function(e){var t=this;return this.actions.map((function(n){var i=n.avatar||n.img;return void 0===n.label?e(wo,{staticClass:"col-all",props:{dark:t.isDark}}):e("div",{staticClass:"q-bottom-sheet__item q-hoverable q-focusable cursor-pointer relative-position",class:n.classes,attrs:{tabindex:0},on:{click:function(){return t.onOk(n)},keyup:function(e){13===e.keyCode&&t.onOk(n)}}},[e("div",{staticClass:"q-focus-helper"}),n.icon?e(De,{props:{name:n.icon,color:n.color}}):i?e("img",{attrs:{src:i},staticClass:n.avatar?"q-bottom-sheet__avatar":null}):e("div",{staticClass:"q-bottom-sheet__empty-icon"}),e("div",[n.label])])}))},__getList:function(e){var t=this;return this.actions.map((function(n){var i=n.avatar||n.img;return void 0===n.label?e(wo,{props:{spaced:!0,dark:t.isDark}}):e(Zr,{staticClass:"q-bottom-sheet__item",class:n.classes,props:{tabindex:0,clickable:!0,dark:t.isDark},on:{click:function(){return t.onOk(n)},keyup:function(e){13===e.keyCode&&t.onOk(n)}}},[e(Jr,{props:{avatar:!0}},[n.icon?e(De,{props:{name:n.icon,color:n.color}}):i?e("img",{attrs:{src:i},staticClass:n.avatar?"q-bottom-sheet__avatar":null}):null]),e(Jr,[n.label])])}))}},render:function(e){var t=this,n=[];return this.title&&n.push(e(hn,{staticClass:"q-dialog__title"},[this.title])),this.message&&n.push(e(hn,{staticClass:"q-dialog__message"},[this.message])),n.push(!0===this.grid?e("div",{staticClass:"row items-stretch justify-start"},this.__getGrid(e)):e("div",this.__getList(e))),e(wr,{ref:"dialog",props:this.dialogProps,on:pe(this,"hide",{hide:function(){t.$emit("hide")}})},[e(dn,{staticClass:"q-bottom-sheet q-bottom-sheet--"+(!0===this.grid?"grid":"list")+(!0===this.isDark?" q-bottom-sheet--dark q-dark":""),style:this.cardStyle,class:this.cardClass},n)])}});var Gl={onOk:function(){return Gl},okCancel:function(){return Gl},hide:function(){return Gl}};function Ql(t){return function(n){n.className;var r=n.class,o=n.style,a=n.component,s=n.root,l=n.parent,c=function(e,t){var n={};for(var i in e)Object.prototype.hasOwnProperty.call(e,i)&&-1===t.indexOf(i)&&(n[i]=e[i]);return n}(n,["className","class","style","component","root","parent"]);if(!0===i)return Gl;void 0!==r&&(c.cardClass=r),void 0!==o&&(c.cardStyle=o);var u=[],d=[],h={onOk:function(e){return u.push(e),h},onCancel:function(e){return d.push(e),h},onDismiss:function(e){return u.push(e),d.push(e),h},hide:function(){return _.$refs.dialog.hide(),h}},f=document.createElement("div");document.body.appendChild(f);var p=!1,m={ok:function(e){p=!0,u.forEach((function(t){t(e)}))},hide:function(){_.$destroy(),_.$el.remove(),_=null,!0!==p&&d.forEach((function(e){e()}))}};e.observable(c);var v=void 0!==a?a:t,g=void 0===a?c:void 0,_=new e({name:"QGlobalDialog",el:f,parent:void 0===l?s:l,render:function(e){return e(v,{ref:"dialog",props:c,attrs:g,on:m})},mounted:function(){this.$refs.dialog.show()}});return h}}var Kl={install:function(e){var t=e.$q;this.create=t.bottomSheet=Ql(Yl)}};function Zl(e){return encodeURIComponent(e)}function Jl(e){return decodeURIComponent(e)}function Xl(e){if(""===e)return e;0===e.indexOf('"')&&(e=e.slice(1,-1).replace(/\\"/g,'"').replace(/\\\\/g,"\\")),e=Jl(e.replace(/\+/g," "));try{e=JSON.parse(e)}catch(e){}return e}function ec(e){var t=new Date;return t.setMilliseconds(t.getMilliseconds()+e),t.toUTCString()}function tc(e,t,n,i){var r,o,a,s,l,c,u,d;void 0===n&&(n={}),void 0!==n.expires&&("[object Date]"===Object.prototype.toString.call(n.expires)?r=n.expires.toUTCString():"string"==typeof n.expires?(a=n.expires,s=0,l=a.match(/(\d+)d/),c=a.match(/(\d+)h/),u=a.match(/(\d+)m/),d=a.match(/(\d+)s/),l&&(s+=864e5*l[1]),c&&(s+=36e5*c[1]),u&&(s+=6e4*u[1]),d&&(s+=1e3*d[1]),r=0===s?a:ec(s)):(o=parseFloat(n.expires),r=!1===isNaN(o)?ec(864e5*o):n.expires));var h,f=Zl(e)+"="+Zl((h=t)===Object(h)?JSON.stringify(h):""+h),p=[f,void 0!==r?"; Expires="+r:"",n.path?"; Path="+n.path:"",n.domain?"; Domain="+n.domain:"",n.sameSite?"; SameSite="+n.sameSite:"",n.httpOnly?"; HttpOnly":"",n.secure?"; Secure":"",n.other?"; "+n.other:""].join("");if(i){i.req.qCookies?i.req.qCookies.push(p):i.req.qCookies=[p],i.res.setHeader("Set-Cookie",i.req.qCookies);var m=i.req.headers.cookie||"";if(void 0!==r&&o<0){var v=nc(e,i);void 0!==v&&(m=m.replace(e+"="+v+"; ","").replace("; "+e+"="+v,"").replace(e+"="+v,""))}else m=m?f+"; "+m:p;i.req.headers.cookie=m}else document.cookie=p}function nc(e,t){for(var n,i,r,o=t?t.req.headers:document,a=o.cookie?o.cookie.split("; "):[],s=a.length,l=e?null:{},c=0;c<s;c++)if(i=Jl((n=a[c].split("=")).shift()),r=n.join("="),e){if(e===i){l=Xl(r);break}}else l[i]=r;return l}function ic(e){return{get:function(t){return nc(t,e)},set:function(t,n,i){return tc(t,n,i,e)},has:function(t){return function(e,t){return null!==nc(e,t)}(t,e)},remove:function(t,n){return function(e,t,n){tc(e,"",Object.assign({},{expires:-1},t),n)}(t,n,e)},getAll:function(){return nc(null,e)}}}var rc,oc,ac,sc,lc={parseSSR:function(e){return void 0!==e?ic(e):this},install:function(e){var t=e.$q,n=e.queues;!0===i?n.server.push((function(e,t){e.cookies=ic(t.ssr)})):(Object.assign(this,ic()),t.cookies=this)}},cc=e.extend({name:"DialogPlugin",mixins:[je,_e],inheritAttrs:!1,props:{title:String,message:String,prompt:Object,options:Object,html:Boolean,ok:{type:[String,Object,Boolean],default:!0},cancel:[String,Object,Boolean],focus:{type:String,default:"ok",validator:function(e){return["ok","cancel","none"].includes(e)}},stackButtons:Boolean,color:String,cardClass:[String,Array,Object],cardStyle:[String,Array,Object]},computed:{hasForm:function(){return void 0!==this.prompt||void 0!==this.options},okLabel:function(){return Object(this.ok)===this.ok||!0===this.ok?this.$q.lang.label.ok:this.ok},cancelLabel:function(){return Object(this.cancel)===this.cancel||!0===this.cancel?this.$q.lang.label.cancel:this.cancel},vmColor:function(){return this.color||(!0===this.isDark?"amber":"primary")},okDisabled:function(){return void 0!==this.prompt?void 0!==this.prompt.isValid&&!0!==this.prompt.isValid(this.prompt.model):void 0!==this.options?void 0!==this.options.isValid&&!0!==this.options.isValid(this.options.model):void 0},okProps:function(){return Object.assign({},{color:this.vmColor,label:this.okLabel,ripple:!1},Object(this.ok)===this.ok?this.ok:{flat:!0},{disable:this.okDisabled})},cancelProps:function(){return Object.assign({},{color:this.vmColor,label:this.cancelLabel,ripple:!1},Object(this.cancel)===this.cancel?this.cancel:{flat:!0})}},methods:{show:function(){this.$refs.dialog.show()},hide:function(){this.$refs.dialog.hide()},getPrompt:function(e){var t=this;return[e(Gr,{props:{value:this.prompt.model,type:this.prompt.type,label:this.prompt.label,stackLabel:this.prompt.stackLabel,outlined:this.prompt.outlined,filled:this.prompt.filled,standout:this.prompt.standout,rounded:this.prompt.rounded,square:this.prompt.square,counter:this.prompt.counter,maxlength:this.prompt.maxlength,prefix:this.prompt.prefix,suffix:this.prompt.suffix,color:this.vmColor,dense:!0,autofocus:!0,dark:this.isDark},attrs:this.prompt.attrs,on:pe(this,"prompt",{input:function(e){t.prompt.model=e},keyup:function(e){!0!==t.okDisabled&&"textarea"!==t.prompt.type&&!0===X(e,13)&&t.onOk()}})})]},getOptions:function(e){var t=this;return[e(na,{props:{value:this.options.model,type:this.options.type,color:this.vmColor,inline:this.options.inline,options:this.options.items,dark:this.isDark},on:pe(this,"opts",{input:function(e){t.options.model=e}})})]},getButtons:function(e){var t=[];if(this.cancel&&t.push(e(bt,{props:this.cancelProps,attrs:{"data-autofocus":"cancel"===this.focus&&!0!==this.hasForm},on:pe(this,"cancel",{click:this.onCancel})})),this.ok&&t.push(e(bt,{props:this.okProps,attrs:{"data-autofocus":"ok"===this.focus&&!0!==this.hasForm},on:pe(this,"ok",{click:this.onOk})})),t.length>0)return e(fn,{staticClass:!0===this.stackButtons?"items-end":null,props:{vertical:this.stackButtons,align:"right"}},t)},onOk:function(){this.$emit("ok",da(this.getData())),this.hide()},onCancel:function(){this.hide()},getData:function(){return void 0!==this.prompt?this.prompt.model:void 0!==this.options?this.options.model:void 0},getSection:function(e,t,n){return!0===this.html?e(hn,{staticClass:t,domProps:{innerHTML:n}}):e(hn,{staticClass:t},[n])}},render:function(e){var t=this,n=[];return this.title&&n.push(this.getSection(e,"q-dialog__title",this.title)),this.message&&n.push(this.getSection(e,"q-dialog__message",this.message)),void 0!==this.prompt?n.push(e(hn,{staticClass:"scroll q-dialog-plugin__form"},this.getPrompt(e))):void 0!==this.options&&n.push(e(wo,{props:{dark:this.isDark}}),e(hn,{staticClass:"scroll q-dialog-plugin__form"},this.getOptions(e)),e(wo,{props:{dark:this.isDark}})),(this.ok||this.cancel)&&n.push(this.getButtons(e)),e(wr,{ref:"dialog",props:Object.assign({},this.qAttrs,{value:this.value}),on:pe(this,"hide",{hide:function(){t.$emit("hide")}})},[e(dn,{staticClass:"q-dialog-plugin"+(!0===this.isDark?" q-dialog-plugin--dark q-dark":""),style:this.cardStyle,class:this.cardClass,props:{dark:this.isDark}},n)])}}),uc={install:function(e){var t=e.$q;this.create=t.dialog=Ql(cc)}},dc={isActive:!1,start:m,stop:m,increment:m,setDefaults:m,install:function(t){var n=this,r=t.$q,o=t.cfg;if(!0!==i){var a=void 0!==o.loadingBar?Object.assign({},o.loadingBar):{},s=r.loadingBar=new e({name:"LoadingBar",render:function(e){return e(Se,{ref:"bar",props:a})}}).$mount().$refs.bar;Object.assign(this,{start:function(e){s.start(e),n.isActive=s.isActive=s.calls>0},stop:function(){s.stop(),n.isActive=s.isActive=s.calls>0},increment:s.increment,setDefaults:function(e){e===Object(e)&&Object.assign(a,e),s.$parent.$forceUpdate()}}),e.util.defineReactive(this,"isActive",this.isActive),e.util.defineReactive(s,"isActive",this.isActive),s.setDefaults=this.setDefaults,document.body.appendChild(s.$parent.$el)}else r.loadingBar=this}},hc=0,fc={},pc={delay:0,message:!1,spinnerSize:80,spinnerColor:"white",messageColor:"white",backgroundColor:"black",spinner:Qe,customClass:""},mc=Object.assign({},pc),vc={isActive:!1,show:function(t){var n=this;!0!==i&&((fc=t===Object(t)&&!0===t.ignoreDefaults?Object.assign({},pc,t):Object.assign({},mc,t)).customClass+=" text-"+fc.backgroundColor,fc.uid="l_"+hc++,this.isActive=!0,void 0===rc?(clearTimeout(oc),oc=setTimeout((function(){oc=void 0;var t=document.createElement("div");document.body.appendChild(t),rc=new e({name:"QLoading",el:t,mounted:function(){mr(!0)},render:function(e){var t;return e("transition",{props:{name:"q-transition--fade",appear:!0},on:pe(n,"tr",{"after-leave":function(){!0!==n.isActive&&void 0!==rc&&(mr(!1),rc.$destroy(),rc.$el.remove(),rc=void 0)}})},[!0===n.isActive?e("div",{staticClass:"q-loading fullscreen column flex-center z-max",key:fc.uid,class:fc.customClass.trim()},[e(fc.spinner,{props:{color:fc.spinnerColor,size:fc.spinnerSize}}),fc.message&&e("div",{class:"text-"+fc.messageColor,domProps:(t={},t[!0===fc.sanitize?"textContent":"innerHTML"]=fc.message,t)})||void 0]):null])}})}),fc.delay)):rc.$forceUpdate())},hide:function(){!0===this.isActive&&(void 0!==oc&&(clearTimeout(oc),oc=void 0),this.isActive=!1)},setDefaults:function(e){e===Object(e)&&Object.assign(mc,e)},install:function(e){var t=e.$q,n=e.cfg.loading;this.setDefaults(n),t.loading=this}};function gc(e){e.title&&(e.title=e.titleTemplate?e.titleTemplate(e.title):e.title,delete e.titleTemplate),[["meta","content"],["link","href"]].forEach((function(t){var n=e[t[0]],i=t[1];for(var r in n){var o=n[r];o.template&&(1===Object.keys(o).length?delete n[r]:(o[i]=o.template(o[i]||""),delete o.template))}}))}function _c(e,t){if(Object.keys(e).length!==Object.keys(t).length)return!0;for(var n in e)if(e[n]!==t[n])return!0}function bc(e){return!1===["class","style"].includes(e)}function yc(e){return!1===["lang","dir"].includes(e)}function wc(e,t){!0!==e._inactive&&(!0===Mc(e)&&(mo(!0,t,e.__qMeta),!0===e.$options.meta.stopPropagation)||e.$children.forEach((function(e){wc(e,t)})))}function kc(){!0===sc&&(sc=!1,this.$root.__currentMeta=window.__Q_META__);var e={title:"",titleTemplate:null,meta:{},link:{},script:{},htmlAttr:{},bodyAttr:{}};wc(this.$root,e),gc(e),function(e){var t=e.add,n=e.remove;t.title&&(document.title=t.title),Object.keys(n).length>0&&(["meta","link","script"].forEach((function(e){n[e].forEach((function(t){document.head.querySelector(e+'[data-qmeta="'+t+'"]').remove()}))})),n.htmlAttr.filter(yc).forEach((function(e){document.documentElement.removeAttribute(e)})),n.bodyAttr.filter(bc).forEach((function(e){document.body.removeAttribute(e)}))),["meta","link","script"].forEach((function(e){var n=t[e];for(var i in n){var r=document.createElement(e);for(var o in n[i])"innerHTML"!==o&&r.setAttribute(o,n[i][o]);r.setAttribute("data-qmeta",i),"script"===e&&(r.innerHTML=n[i].innerHTML||""),document.head.appendChild(r)}})),Object.keys(t.htmlAttr).filter(yc).forEach((function(e){document.documentElement.setAttribute(e,t.htmlAttr[e]||"")})),Object.keys(t.bodyAttr).filter(bc).forEach((function(e){document.body.setAttribute(e,t.bodyAttr[e]||"")}))}(function(e,t){var n={},i={};return void 0===e?{add:t,remove:i}:(e.title!==t.title&&(n.title=t.title),["meta","link","script","htmlAttr","bodyAttr"].forEach((function(r){var o=e[r],a=t[r];if(i[r]=[],null!=o){for(var s in n[r]={},o)!1===a.hasOwnProperty(s)&&i[r].push(s);for(var l in a)!1===o.hasOwnProperty(l)?n[r][l]=a[l]:!0===_c(o[l],a[l])&&(i[r].push(l),n[r][l]=a[l])}else n[r]=a})),{add:n,remove:i})}(this.$root.__currentMeta,e)),this.$root.__currentMeta=e}function xc(e){return function(t){var n=e[t];return t+(void 0!==n?'="'+n+'"':"")}}function Sc(e){var t="";return e.title&&(t+="<title>"+e.title+"</title>"),["meta","link","script"].forEach((function(n){var i=e[n];for(var r in i){var o=Object.keys(i[r]).filter((function(e){return"innerHTML"!==e})).map(xc(i[r]));t+="<"+n+" "+o.join(" ")+' data-qmeta="'+r+'">',"script"===n&&(t+=(i[r].innerHTML||"")+"<\/script>")}})),t}function Cc(){"function"==typeof this.$options.meta?(void 0===this.$options.computed&&(this.$options.computed={}),this.$options.computed.__qMeta=this.$options.meta):!0===Mc(this)&&(this.__qMeta=this.$options.meta)}function Mc(e){return void 0!==e.$options.meta&&null!==e.$options.meta}function Tc(){!0===Mc(this)&&this.__qMetaUpdate()}!1===i&&e.util.defineReactive(vc,"isActive",vc.isActive);var Ac={install:function(t){var n=t.queues;!0===i?(e.prototype.$getMetaHTML=function(e){return function(t,n){return function(e,t,n){var i={title:"",titleTemplate:null,meta:{},link:{},htmlAttr:{},bodyAttr:{},noscript:{}};wc(e,i),gc(i);var r=void 0!==n&&void 0!==n.nonce?' nonce="'+n.nonce+'"':"",o={"%%Q_HTML_ATTRS%%":Object.keys(i.htmlAttr).filter(yc).map(xc(i.htmlAttr)).join(" "),"%%Q_HEAD_TAGS%%":Sc(i),"%%Q_BODY_ATTRS%%":Object.keys(i.bodyAttr).filter(bc).map(xc(i.bodyAttr)).join(" "),"%%Q_BODY_TAGS%%":Object.keys(i.noscript).map((function(e){return'<noscript data-qmeta="'+e+'">'+i.noscript[e]+"</noscript>"})).join("")+"<script"+r+">window.__Q_META__="+(delete i.noscript&&JSON.stringify(i))+"<\/script>"};return Object.keys(o).forEach((function(e){t=t.replace(e,o[e])})),t}(e,t,n)}},e.mixin({beforeCreate:Cc}),n.server.push((function(e,t){t.ssr.Q_HTML_ATTRS+=" %%Q_HTML_ATTRS%%",Object.assign(t.ssr,{Q_HEAD_TAGS:"%%Q_HEAD_TAGS%%",Q_BODY_ATTRS:"%%Q_BODY_ATTRS%%",Q_BODY_TAGS:"%%Q_BODY_TAGS%%"})}))):(sc=r,e.mixin({beforeCreate:Cc,created:function(){!0===Mc(this)&&(this.__qMetaUnwatch=this.$watch("__qMeta",this.__qMetaUpdate))},activated:Tc,deactivated:Tc,beforeMount:Tc,destroyed:function(){!0===Mc(this)&&(this.__qMetaUnwatch(),this.__qMetaUpdate())},methods:{__qMetaUpdate:function(){clearTimeout(ac),ac=setTimeout(kc.bind(this),50)}}}))}};var Pc=0,Lc={},Oc=["top-left","top-right","bottom-left","bottom-right","top","bottom","left","right","center"],qc=["top-left","top-right","bottom-left","bottom-right"],Ec={positive:{icon:function(){return this.$q.iconSet.type.positive},color:"positive"},negative:{icon:function(){return this.$q.iconSet.type.negative},color:"negative"},warning:{icon:function(){return this.$q.iconSet.type.warning},color:"warning",textColor:"dark"},info:{icon:function(){return this.$q.iconSet.type.info},color:"info"}},Dc={},zc={},Nc={name:"QNotifications",created:function(){var e=this;this.notifs={},Oc.forEach((function(t){e.notifs[t]=[];var n=!0===["left","center","right"].includes(t)?"center":t.indexOf("top")>-1?"top":"bottom",i=t.indexOf("left")>-1?"start":t.indexOf("right")>-1?"end":"center",r=["left","right"].includes(t)?"items-"+("left"===t?"start":"end")+" justify-center":"center"===t?"flex-center":"items-"+i;zc[t]="q-notifications__list q-notifications__list--"+n+" fixed column no-wrap "+r}))},methods:{add:function(e){var t=this;if(!e)return console.error("Notify: parameter required"),!1;var n={textColor:"white"};if("string"!=typeof e&&!0===e.ignoreDefaults||Object.assign(n,Lc),Object(e)===e?(Object.assign(n,Ec[e.type],e),"function"==typeof n.icon&&(n.icon=n.icon.call(this))):n.message=e,n.meta={hasMedia:Boolean(n.icon||n.avatar)},n.position){if(!1===Oc.includes(n.position))return console.error("Notify: wrong position: "+n.position),!1}else n.position="bottom";if(void 0===n.timeout)n.timeout=5e3;else{var i=parseInt(n.timeout,10);if(isNaN(i)||i<0)return console.error("Notify: wrong timeout: "+n.timeout),!1;n.timeout=i}0===n.timeout?n.progress=!1:!0===n.progress&&(n.meta.progressStyle={animationDuration:n.timeout+1e3+"ms"});var r=(!0===Array.isArray(e.actions)?e.actions:[]).concat(!0!==e.ignoreDefaults&&!0===Array.isArray(Lc.actions)?Lc.actions:[]).concat(void 0!==Ec[e.type]&&!0===Array.isArray(Ec[e.type].actions)?Ec[e.type].actions:[]);n.closeBtn&&r.push({label:"string"==typeof n.closeBtn?n.closeBtn:this.$q.lang.label.close}),n.actions=r.map((function(e){var t=e.handler,i=e.noDismiss,r=e.attrs,o=function(e,t){var n={};for(var i in e)Object.prototype.hasOwnProperty.call(e,i)&&-1===t.indexOf(i)&&(n[i]=e[i]);return n}(e,["handler","noDismiss","attrs"]);return{props:Object.assign({},{flat:!0},o),attrs:r,on:{click:"function"==typeof t?function(){t(),!0!==i&&n.meta.close()}:function(){n.meta.close()}}}})),void 0===n.multiLine&&(n.multiLine=n.actions.length>1),Object.assign(n.meta,{staticClass:"q-notification row items-stretch q-notification--"+(!0===n.multiLine?"multi-line":"standard")+(void 0!==n.color?" bg-"+n.color:"")+(void 0!==n.textColor?" text-"+n.textColor:"")+(void 0!==n.classes?" "+n.classes:""),wrapperClass:"q-notification__wrapper col relative-position border-radius-inherit "+(!0===n.multiLine?"column no-wrap justify-center":"row items-center"),contentClass:"q-notification__content row items-center"+(!0===n.multiLine?"":" col"),attrs:Object.assign({},{role:"alert"},n.attrs)}),!1===n.group?n.group=void 0:(void 0!==n.group&&!0!==n.group||(n.group=[n.message,n.caption,n.multiline].concat(n.actions.map((function(e){return e.props.label+"*"+e.props.icon}))).join("|")),n.group+="|"+n.position),0===n.actions.length?n.actions=void 0:n.meta.actionsClass="q-notification__actions row items-center "+(!0===n.multiLine?"justify-end":"col-auto")+(!0===n.meta.hasMedia?" q-notification__actions--with-media":"");var o=Dc[n.group];if(void 0===o){if(n.meta.uid=Pc++,n.meta.badge=1,-1!==["left","right","center"].indexOf(n.position))this.notifs[n.position].splice(Math.floor(this.notifs[n.position].length/2),0,n);else{var a=n.position.indexOf("top")>-1?"unshift":"push";this.notifs[n.position][a](n)}void 0!==n.group&&(Dc[n.group]=n)}else{void 0!==o.meta.timer&&clearTimeout(o.meta.timer);var s=Dc[n.group];if(void 0!==n.badgePosition){if(!1===qc.includes(n.badgePosition))return console.error("Notify - wrong badgePosition specified: "+n.badgePosition),!1}else n.badgePosition="top-"+(n.position.indexOf("left")>-1?"right":"left");n.meta.uid=s.meta.uid,n.meta.badge=s.meta.badge+1,n.meta.badgeStaticClass="q-notification__badge q-notification__badge--"+n.badgePosition+(void 0!==n.badgeColor?" bg-"+n.badgeColor:"")+(void 0!==n.badgeTextColor?" text-"+n.badgeTextColor:"");var l=this.notifs[n.position].indexOf(s);this.notifs[n.position][l]=Dc[n.group]=n}return n.meta.close=function(){t.remove(n)},this.$forceUpdate(),n.timeout>0&&(n.meta.timer=setTimeout((function(){n.meta.close()}),n.timeout+1e3)),n.meta.close},remove:function(e){clearTimeout(e.meta.timer);var t=this.notifs[e.position].indexOf(e);if(-1!==t){void 0!==e.group&&delete Dc[e.group];var n=this.$refs["notif_"+e.meta.uid];if(n){var i=getComputedStyle(n),r=i.width,o=i.height;n.style.left=n.offsetLeft+"px",n.style.width=r,n.style.height=o}this.notifs[e.position].splice(t,1),this.$forceUpdate(),"function"==typeof e.onDismiss&&e.onDismiss()}}},render:function(e){var t=this;return e("div",{staticClass:"q-notifications"},Oc.map((function(n){return e("transition-group",{key:n,staticClass:zc[n],tag:"div",props:{name:"q-notification--"+n,mode:"out-in"}},t.notifs[n].map((function(t){var n,i=t.meta,r={staticClass:"q-notification__message col"};if(!0===t.html)r.domProps={innerHTML:t.caption?"<div>"+t.message+'</div><div class="q-notification__caption">'+t.caption+"</div>":t.message};else{var o=[t.message];n=t.caption?[e("div",o),e("div",{staticClass:"q-notification__caption"},[t.caption])]:o}var a=[];!0===i.hasMedia&&(t.icon?a.push(e(De,{staticClass:"q-notification__icon",attrs:{role:"img"},props:{name:t.icon}})):t.avatar&&a.push(e(ze,{staticClass:"q-notification__avatar col-auto"},[e("img",{attrs:{src:t.avatar,"aria-hidden":"true"}})]))),a.push(e("div",r,n));var s=[e("div",{staticClass:i.contentClass},a)];return!0===t.progress&&s.push(e("div",{key:i.uid+"|p|"+i.badge,staticClass:"q-notification__progress",style:i.progressStyle,class:t.progressClass})),void 0!==t.actions&&s.push(e("div",{staticClass:i.actionsClass},t.actions.map((function(t){return e(bt,{props:t.props,attrs:t.attrs,on:t.on})})))),i.badge>1&&s.push(e("div",{key:i.uid+"|"+i.badge,staticClass:i.badgeStaticClass,style:t.badgeStyle,class:t.badgeClass},[i.badge])),e("div",{ref:"notif_"+i.uid,key:i.uid,staticClass:i.staticClass,attrs:i.attrs},[e("div",{staticClass:i.wrapperClass},s)])})))})))},mounted:function(){var e=this;if(void 0!==this.$q.fullscreen&&!0===this.$q.fullscreen.isCapable){var t=function(t){var n=Xe(t,e.$q.fullscreen.activeEl);e.$el.parentElement!==n&&n.appendChild(e.$el)};this.unwatchFullscreen=this.$watch("$q.fullscreen.isActive",t),!0===this.$q.fullscreen.isActive&&t(!0)}},beforeDestroy:function(){void 0!==this.unwatchFullscreen&&this.unwatchFullscreen()}},jc={create:function(e){return!0===i?m:this.__vm.add(e)},setDefaults:function(e){e===Object(e)&&Object.assign(Lc,e)},registerType:function(e,t){!0!==i&&t===Object(t)&&(Ec[e]=t)},install:function(t){var n=t.cfg,r=t.$q;if(!0===i)return r.notify=m,void(r.notify.setDefaults=m);this.setDefaults(n.notify),r.notify=this.create.bind(this),r.notify.setDefaults=this.setDefaults,r.notify.registerType=this.registerType;var o=document.createElement("div");document.body.appendChild(o),this.__vm=new e(Nc),this.__vm.$mount(o)}};function Rc(){return{has:m,getLength:m,getItem:m,getIndex:m,getAll:m,set:m,remove:m,clear:m,isEmpty:m}}function Ic(e){var t=window[e+"Storage"],n=function(e){var n=t.getItem(e);return n?function(e){if(e.length<9)return e;var t=e.substr(0,8),n=e.substring(9);switch(t){case"__q_date":return new Date(n);case"__q_expr":return new RegExp(n);case"__q_numb":return Number(n);case"__q_bool":return Boolean("1"===n);case"__q_strn":return""+n;case"__q_objt":return JSON.parse(n);default:return e}}(n):null};return{has:function(e){return null!==t.getItem(e)},getLength:function(){return t.length},getItem:n,getIndex:function(e){return e<t.length?n(t.key(e)):null},getKey:function(e){return e<t.length?t.key(e):null},getAll:function(){for(var e,i={},r=t.length,o=0;o<r;o++)i[e=t.key(o)]=n(e);return i},getAllKeys:function(){for(var e=[],n=t.length,i=0;i<n;i++)e.push(t.key(i));return e},set:function(e,n){t.setItem(e,function(e){return"[object Date]"===Object.prototype.toString.call(e)?"__q_date|"+e.toUTCString():"[object RegExp]"===Object.prototype.toString.call(e)?"__q_expr|"+e.source:"number"==typeof e?"__q_numb|"+e:"boolean"==typeof e?"__q_bool|"+(e?"1":"0"):"string"==typeof e?"__q_strn|"+e:"function"==typeof e?"__q_strn|"+e.toString():e===Object(e)?"__q_objt|"+JSON.stringify(e):e}(n))},remove:function(e){t.removeItem(e)},clear:function(){t.clear()},isEmpty:function(){return 0===t.length}}}var $c={install:function(e){var t=e.$q,n=!0===i||!1===d.has.webStorage?Rc():Ic("local");t.localStorage=n,Object.assign(this,n)}},Fc={install:function(e){var t=e.$q,n=!0===i||!1===d.has.webStorage?Rc():Ic("session");t.sessionStorage=n,Object.assign(this,n)}},Bc=Object.freeze({__proto__:null,AddressbarColor:Bl,AppFullscreen:Wl,AppVisibility:Ul,BottomSheet:Kl,Cookies:lc,Dark:O,Dialog:uc,LoadingBar:dc,Loading:vc,Meta:Ac,Notify:jc,Platform:h,Screen:L,LocalStorage:$c,SessionStorage:Fc});function Vc(e){setTimeout((function(){window.URL.revokeObjectURL(e.href)}),1e4),e.remove()}function Hc(t,n,i){var r=window.open;if(!0===h.is.cordova){if(void 0!==cordova&&void 0!==cordova.InAppBrowser&&void 0!==cordova.InAppBrowser.open)r=cordova.InAppBrowser.open;else if(void 0!==navigator&&void 0!==navigator.app)return navigator.app.loadUrl(t,{openExternal:!0})}else if(void 0!==e.prototype.$q.electron)return e.prototype.$q.electron.shell.openExternal(t);var o,a,s,l=r(t,"_blank",(o=i,a=Object.assign({noopener:!0},o),s=[],Object.keys(a).forEach((function(e){!0===a[e]&&s.push(e)})),s.join(",")));if(l)return h.is.desktop&&l.focus(),l;n&&n()}var Wc=Object.freeze({__proto__:null,clone:da,colors:Q,copyToClipboard:function(e){return void 0!==navigator.clipboard?navigator.clipboard.writeText(e):new Promise((function(t,n){var i=function(e){var t=document.createElement("textarea");t.value=e,t.contentEditable=!0,t.style.position="fixed",document.body.appendChild(t),t.focus(),t.select();var n=document.execCommand("copy");return t.remove(),n}(e);i?t(!0):n(i)}))},date:tr,debounce:T,dom:et,event:M,exportFile:function(e,t,n){var i=new Blob([t],{type:n||"text/plain"});if(window.navigator.msSaveOrOpenBlob)return window.navigator.msSaveOrOpenBlob(i,e);var r=document.createElement("a");r.download=e,r.href=window.URL.createObjectURL(i),r.classList.add("hidden"),r.style.position="fixed",document.body.appendChild(r);try{return r.click(),Vc(r),!0}catch(e){return Vc(r),e}},extend:mo,format:fe,frameDebounce:la,noop:m,openURL:function(e,t,n){if(!0!==h.is.ios||void 0===window.SafariViewController)return Hc(e,t,n);window.SafariViewController.isAvailable((function(i){i?window.SafariViewController.show({url:e},m,t):Hc(e,t,n)}))},morph:hl,patterns:Wn,scroll:Zt,throttle:tt,uid:Or});return e.use({install:function(e,t){if(void 0===t&&(t={}),!0!==this.__qInstalled){this.__qInstalled=!0;var n=ae.config=Object.freeze(t.config||{});if(h.install(ae,oe),te(oe,n),O.install(ae,oe,n),L.install(ae,oe,n),z.install(n),R.install(ae,oe,t.lang),ie.install(ae,oe,t.iconSet),!0===i?e.mixin({beforeCreate:function(){this.$q=this.$root.$options.$q}}):e.prototype.$q=ae,t.components&&Object.keys(t.components).forEach((function(n){var i=t.components[n];"function"==typeof i&&e.component(i.options.name,i)})),t.directives&&Object.keys(t.directives).forEach((function(n){var i=t.directives[n];void 0!==i.name&&void 0!==i.unbind&&e.directive(i.name,i)})),t.plugins){var r={$q:ae,queues:oe,cfg:n};Object.keys(t.plugins).forEach((function(e){var n=t.plugins[e];"function"==typeof n.install&&!1===re.includes(n)&&n.install(r)}))}}}},{components:Zs,directives:$l,plugins:Bc,config:window.quasarConfig||{}}),Object.assign({},{version:n,lang:R,iconSet:ie,components:Zs,directives:$l,plugins:Bc,utils:Wc},Zs,$l,Bc,Wc)})),
/*!
 * Chart.js v2.9.4
 * https://www.chartjs.org
 * (c) 2020 Chart.js Contributors
 * Released under the MIT License
 */
function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e=e||self).Chart=t()}(this,(function(){"use strict";"undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self&&self;function e(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}function t(e,t){return e(t={exports:{}},t.exports),t.exports}var n={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]},i=t((function(e){var t={};for(var i in n)n.hasOwnProperty(i)&&(t[n[i]]=i);var r=e.exports={rgb:{channels:3,labels:"rgb"},hsl:{channels:3,labels:"hsl"},hsv:{channels:3,labels:"hsv"},hwb:{channels:3,labels:"hwb"},cmyk:{channels:4,labels:"cmyk"},xyz:{channels:3,labels:"xyz"},lab:{channels:3,labels:"lab"},lch:{channels:3,labels:"lch"},hex:{channels:1,labels:["hex"]},keyword:{channels:1,labels:["keyword"]},ansi16:{channels:1,labels:["ansi16"]},ansi256:{channels:1,labels:["ansi256"]},hcg:{channels:3,labels:["h","c","g"]},apple:{channels:3,labels:["r16","g16","b16"]},gray:{channels:1,labels:["gray"]}};for(var o in r)if(r.hasOwnProperty(o)){if(!("channels"in r[o]))throw new Error("missing channels property: "+o);if(!("labels"in r[o]))throw new Error("missing channel labels property: "+o);if(r[o].labels.length!==r[o].channels)throw new Error("channel and label counts mismatch: "+o);var a=r[o].channels,s=r[o].labels;delete r[o].channels,delete r[o].labels,Object.defineProperty(r[o],"channels",{value:a}),Object.defineProperty(r[o],"labels",{value:s})}r.rgb.hsl=function(e){var t,n,i=e[0]/255,r=e[1]/255,o=e[2]/255,a=Math.min(i,r,o),s=Math.max(i,r,o),l=s-a;return s===a?t=0:i===s?t=(r-o)/l:r===s?t=2+(o-i)/l:o===s&&(t=4+(i-r)/l),(t=Math.min(60*t,360))<0&&(t+=360),n=(a+s)/2,[t,100*(s===a?0:n<=.5?l/(s+a):l/(2-s-a)),100*n]},r.rgb.hsv=function(e){var t,n,i,r,o,a=e[0]/255,s=e[1]/255,l=e[2]/255,c=Math.max(a,s,l),u=c-Math.min(a,s,l),d=function(e){return(c-e)/6/u+.5};return 0===u?r=o=0:(o=u/c,t=d(a),n=d(s),i=d(l),a===c?r=i-n:s===c?r=1/3+t-i:l===c&&(r=2/3+n-t),r<0?r+=1:r>1&&(r-=1)),[360*r,100*o,100*c]},r.rgb.hwb=function(e){var t=e[0],n=e[1],i=e[2];return[r.rgb.hsl(e)[0],100*(1/255*Math.min(t,Math.min(n,i))),100*(i=1-1/255*Math.max(t,Math.max(n,i)))]},r.rgb.cmyk=function(e){var t,n=e[0]/255,i=e[1]/255,r=e[2]/255;return[100*((1-n-(t=Math.min(1-n,1-i,1-r)))/(1-t)||0),100*((1-i-t)/(1-t)||0),100*((1-r-t)/(1-t)||0),100*t]},r.rgb.keyword=function(e){var i=t[e];if(i)return i;var r,o,a,s=1/0;for(var l in n)if(n.hasOwnProperty(l)){var c=n[l],u=(o=e,a=c,Math.pow(o[0]-a[0],2)+Math.pow(o[1]-a[1],2)+Math.pow(o[2]-a[2],2));u<s&&(s=u,r=l)}return r},r.keyword.rgb=function(e){return n[e]},r.rgb.xyz=function(e){var t=e[0]/255,n=e[1]/255,i=e[2]/255;return[100*(.4124*(t=t>.04045?Math.pow((t+.055)/1.055,2.4):t/12.92)+.3576*(n=n>.04045?Math.pow((n+.055)/1.055,2.4):n/12.92)+.1805*(i=i>.04045?Math.pow((i+.055)/1.055,2.4):i/12.92)),100*(.2126*t+.7152*n+.0722*i),100*(.0193*t+.1192*n+.9505*i)]},r.rgb.lab=function(e){var t=r.rgb.xyz(e),n=t[0],i=t[1],o=t[2];return i/=100,o/=108.883,n=(n/=95.047)>.008856?Math.pow(n,1/3):7.787*n+16/116,[116*(i=i>.008856?Math.pow(i,1/3):7.787*i+16/116)-16,500*(n-i),200*(i-(o=o>.008856?Math.pow(o,1/3):7.787*o+16/116))]},r.hsl.rgb=function(e){var t,n,i,r,o,a=e[0]/360,s=e[1]/100,l=e[2]/100;if(0===s)return[o=255*l,o,o];t=2*l-(n=l<.5?l*(1+s):l+s-l*s),r=[0,0,0];for(var c=0;c<3;c++)(i=a+1/3*-(c-1))<0&&i++,i>1&&i--,o=6*i<1?t+6*(n-t)*i:2*i<1?n:3*i<2?t+(n-t)*(2/3-i)*6:t,r[c]=255*o;return r},r.hsl.hsv=function(e){var t=e[0],n=e[1]/100,i=e[2]/100,r=n,o=Math.max(i,.01);return n*=(i*=2)<=1?i:2-i,r*=o<=1?o:2-o,[t,100*(0===i?2*r/(o+r):2*n/(i+n)),100*((i+n)/2)]},r.hsv.rgb=function(e){var t=e[0]/60,n=e[1]/100,i=e[2]/100,r=Math.floor(t)%6,o=t-Math.floor(t),a=255*i*(1-n),s=255*i*(1-n*o),l=255*i*(1-n*(1-o));switch(i*=255,r){case 0:return[i,l,a];case 1:return[s,i,a];case 2:return[a,i,l];case 3:return[a,s,i];case 4:return[l,a,i];case 5:return[i,a,s]}},r.hsv.hsl=function(e){var t,n,i,r=e[0],o=e[1]/100,a=e[2]/100,s=Math.max(a,.01);return i=(2-o)*a,n=o*s,[r,100*(n=(n/=(t=(2-o)*s)<=1?t:2-t)||0),100*(i/=2)]},r.hwb.rgb=function(e){var t,n,i,r,o,a,s,l=e[0]/360,c=e[1]/100,u=e[2]/100,d=c+u;switch(d>1&&(c/=d,u/=d),i=6*l-(t=Math.floor(6*l)),0!=(1&t)&&(i=1-i),r=c+i*((n=1-u)-c),t){default:case 6:case 0:o=n,a=r,s=c;break;case 1:o=r,a=n,s=c;break;case 2:o=c,a=n,s=r;break;case 3:o=c,a=r,s=n;break;case 4:o=r,a=c,s=n;break;case 5:o=n,a=c,s=r}return[255*o,255*a,255*s]},r.cmyk.rgb=function(e){var t=e[0]/100,n=e[1]/100,i=e[2]/100,r=e[3]/100;return[255*(1-Math.min(1,t*(1-r)+r)),255*(1-Math.min(1,n*(1-r)+r)),255*(1-Math.min(1,i*(1-r)+r))]},r.xyz.rgb=function(e){var t,n,i,r=e[0]/100,o=e[1]/100,a=e[2]/100;return n=-.9689*r+1.8758*o+.0415*a,i=.0557*r+-.204*o+1.057*a,t=(t=3.2406*r+-1.5372*o+-.4986*a)>.0031308?1.055*Math.pow(t,1/2.4)-.055:12.92*t,n=n>.0031308?1.055*Math.pow(n,1/2.4)-.055:12.92*n,i=i>.0031308?1.055*Math.pow(i,1/2.4)-.055:12.92*i,[255*(t=Math.min(Math.max(0,t),1)),255*(n=Math.min(Math.max(0,n),1)),255*(i=Math.min(Math.max(0,i),1))]},r.xyz.lab=function(e){var t=e[0],n=e[1],i=e[2];return n/=100,i/=108.883,t=(t/=95.047)>.008856?Math.pow(t,1/3):7.787*t+16/116,[116*(n=n>.008856?Math.pow(n,1/3):7.787*n+16/116)-16,500*(t-n),200*(n-(i=i>.008856?Math.pow(i,1/3):7.787*i+16/116))]},r.lab.xyz=function(e){var t,n,i,r=e[0];t=e[1]/500+(n=(r+16)/116),i=n-e[2]/200;var o=Math.pow(n,3),a=Math.pow(t,3),s=Math.pow(i,3);return n=o>.008856?o:(n-16/116)/7.787,t=a>.008856?a:(t-16/116)/7.787,i=s>.008856?s:(i-16/116)/7.787,[t*=95.047,n*=100,i*=108.883]},r.lab.lch=function(e){var t,n=e[0],i=e[1],r=e[2];return(t=360*Math.atan2(r,i)/2/Math.PI)<0&&(t+=360),[n,Math.sqrt(i*i+r*r),t]},r.lch.lab=function(e){var t,n=e[0],i=e[1];return t=e[2]/360*2*Math.PI,[n,i*Math.cos(t),i*Math.sin(t)]},r.rgb.ansi16=function(e){var t=e[0],n=e[1],i=e[2],o=1 in arguments?arguments[1]:r.rgb.hsv(e)[2];if(0===(o=Math.round(o/50)))return 30;var a=30+(Math.round(i/255)<<2|Math.round(n/255)<<1|Math.round(t/255));return 2===o&&(a+=60),a},r.hsv.ansi16=function(e){return r.rgb.ansi16(r.hsv.rgb(e),e[2])},r.rgb.ansi256=function(e){var t=e[0],n=e[1],i=e[2];return t===n&&n===i?t<8?16:t>248?231:Math.round((t-8)/247*24)+232:16+36*Math.round(t/255*5)+6*Math.round(n/255*5)+Math.round(i/255*5)},r.ansi16.rgb=function(e){var t=e%10;if(0===t||7===t)return e>50&&(t+=3.5),[t=t/10.5*255,t,t];var n=.5*(1+~~(e>50));return[(1&t)*n*255,(t>>1&1)*n*255,(t>>2&1)*n*255]},r.ansi256.rgb=function(e){if(e>=232){var t=10*(e-232)+8;return[t,t,t]}var n;return e-=16,[Math.floor(e/36)/5*255,Math.floor((n=e%36)/6)/5*255,n%6/5*255]},r.rgb.hex=function(e){var t=(((255&Math.round(e[0]))<<16)+((255&Math.round(e[1]))<<8)+(255&Math.round(e[2]))).toString(16).toUpperCase();return"000000".substring(t.length)+t},r.hex.rgb=function(e){var t=e.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);if(!t)return[0,0,0];var n=t[0];3===t[0].length&&(n=n.split("").map((function(e){return e+e})).join(""));var i=parseInt(n,16);return[i>>16&255,i>>8&255,255&i]},r.rgb.hcg=function(e){var t,n=e[0]/255,i=e[1]/255,r=e[2]/255,o=Math.max(Math.max(n,i),r),a=Math.min(Math.min(n,i),r),s=o-a;return t=s<=0?0:o===n?(i-r)/s%6:o===i?2+(r-n)/s:4+(n-i)/s+4,t/=6,[360*(t%=1),100*s,100*(s<1?a/(1-s):0)]},r.hsl.hcg=function(e){var t=e[1]/100,n=e[2]/100,i=1,r=0;return(i=n<.5?2*t*n:2*t*(1-n))<1&&(r=(n-.5*i)/(1-i)),[e[0],100*i,100*r]},r.hsv.hcg=function(e){var t=e[1]/100,n=e[2]/100,i=t*n,r=0;return i<1&&(r=(n-i)/(1-i)),[e[0],100*i,100*r]},r.hcg.rgb=function(e){var t=e[0]/360,n=e[1]/100,i=e[2]/100;if(0===n)return[255*i,255*i,255*i];var r,o=[0,0,0],a=t%1*6,s=a%1,l=1-s;switch(Math.floor(a)){case 0:o[0]=1,o[1]=s,o[2]=0;break;case 1:o[0]=l,o[1]=1,o[2]=0;break;case 2:o[0]=0,o[1]=1,o[2]=s;break;case 3:o[0]=0,o[1]=l,o[2]=1;break;case 4:o[0]=s,o[1]=0,o[2]=1;break;default:o[0]=1,o[1]=0,o[2]=l}return r=(1-n)*i,[255*(n*o[0]+r),255*(n*o[1]+r),255*(n*o[2]+r)]},r.hcg.hsv=function(e){var t=e[1]/100,n=t+e[2]/100*(1-t),i=0;return n>0&&(i=t/n),[e[0],100*i,100*n]},r.hcg.hsl=function(e){var t=e[1]/100,n=e[2]/100*(1-t)+.5*t,i=0;return n>0&&n<.5?i=t/(2*n):n>=.5&&n<1&&(i=t/(2*(1-n))),[e[0],100*i,100*n]},r.hcg.hwb=function(e){var t=e[1]/100,n=t+e[2]/100*(1-t);return[e[0],100*(n-t),100*(1-n)]},r.hwb.hcg=function(e){var t=e[1]/100,n=1-e[2]/100,i=n-t,r=0;return i<1&&(r=(n-i)/(1-i)),[e[0],100*i,100*r]},r.apple.rgb=function(e){return[e[0]/65535*255,e[1]/65535*255,e[2]/65535*255]},r.rgb.apple=function(e){return[e[0]/255*65535,e[1]/255*65535,e[2]/255*65535]},r.gray.rgb=function(e){return[e[0]/100*255,e[0]/100*255,e[0]/100*255]},r.gray.hsl=r.gray.hsv=function(e){return[0,0,e[0]]},r.gray.hwb=function(e){return[0,100,e[0]]},r.gray.cmyk=function(e){return[0,0,0,e[0]]},r.gray.lab=function(e){return[e[0],0,0]},r.gray.hex=function(e){var t=255&Math.round(e[0]/100*255),n=((t<<16)+(t<<8)+t).toString(16).toUpperCase();return"000000".substring(n.length)+n},r.rgb.gray=function(e){return[(e[0]+e[1]+e[2])/3/255*100]}}));i.rgb,i.hsl,i.hsv,i.hwb,i.cmyk,i.xyz,i.lab,i.lch,i.hex,i.keyword,i.ansi16,i.ansi256,i.hcg,i.apple,i.gray;function r(e){var t=function(){for(var e={},t=Object.keys(i),n=t.length,r=0;r<n;r++)e[t[r]]={distance:-1,parent:null};return e}(),n=[e];for(t[e].distance=0;n.length;)for(var r=n.pop(),o=Object.keys(i[r]),a=o.length,s=0;s<a;s++){var l=o[s],c=t[l];-1===c.distance&&(c.distance=t[r].distance+1,c.parent=r,n.unshift(l))}return t}function o(e,t){return function(n){return t(e(n))}}function a(e,t){for(var n=[t[e].parent,e],r=i[t[e].parent][e],a=t[e].parent;t[a].parent;)n.unshift(t[a].parent),r=o(i[t[a].parent][a],r),a=t[a].parent;return r.conversion=n,r}var s={};Object.keys(i).forEach((function(e){s[e]={},Object.defineProperty(s[e],"channels",{value:i[e].channels}),Object.defineProperty(s[e],"labels",{value:i[e].labels});var t=function(e){for(var t=r(e),n={},i=Object.keys(t),o=i.length,s=0;s<o;s++){var l=i[s];null!==t[l].parent&&(n[l]=a(l,t))}return n}(e);Object.keys(t).forEach((function(n){var i=t[n];s[e][n]=function(e){var t=function(t){if(null==t)return t;arguments.length>1&&(t=Array.prototype.slice.call(arguments));var n=e(t);if("object"==typeof n)for(var i=n.length,r=0;r<i;r++)n[r]=Math.round(n[r]);return n};return"conversion"in e&&(t.conversion=e.conversion),t}(i),s[e][n].raw=function(e){var t=function(t){return null==t?t:(arguments.length>1&&(t=Array.prototype.slice.call(arguments)),e(t))};return"conversion"in e&&(t.conversion=e.conversion),t}(i)}))}));var l=s,c={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]},u={getRgba:d,getHsla:h,getRgb:function(e){var t=d(e);return t&&t.slice(0,3)},getHsl:function(e){var t=h(e);return t&&t.slice(0,3)},getHwb:f,getAlpha:function(e){var t=d(e);if(t)return t[3];if(t=h(e))return t[3];if(t=f(e))return t[3]},hexString:function(e,t){t=void 0!==t&&3===e.length?t:e[3];return"#"+_(e[0])+_(e[1])+_(e[2])+(t>=0&&t<1?_(Math.round(255*t)):"")},rgbString:function(e,t){if(t<1||e[3]&&e[3]<1)return p(e,t);return"rgb("+e[0]+", "+e[1]+", "+e[2]+")"},rgbaString:p,percentString:function(e,t){if(t<1||e[3]&&e[3]<1)return m(e,t);var n=Math.round(e[0]/255*100),i=Math.round(e[1]/255*100),r=Math.round(e[2]/255*100);return"rgb("+n+"%, "+i+"%, "+r+"%)"},percentaString:m,hslString:function(e,t){if(t<1||e[3]&&e[3]<1)return v(e,t);return"hsl("+e[0]+", "+e[1]+"%, "+e[2]+"%)"},hslaString:v,hwbString:function(e,t){void 0===t&&(t=void 0!==e[3]?e[3]:1);return"hwb("+e[0]+", "+e[1]+"%, "+e[2]+"%"+(void 0!==t&&1!==t?", "+t:"")+")"},keyword:function(e){return b[e.slice(0,3)]}};function d(e){if(e){var t=[0,0,0],n=1,i=e.match(/^#([a-fA-F0-9]{3,4})$/i),r="";if(i){r=(i=i[1])[3];for(var o=0;o<t.length;o++)t[o]=parseInt(i[o]+i[o],16);r&&(n=Math.round(parseInt(r+r,16)/255*100)/100)}else if(i=e.match(/^#([a-fA-F0-9]{6}([a-fA-F0-9]{2})?)$/i)){r=i[2],i=i[1];for(o=0;o<t.length;o++)t[o]=parseInt(i.slice(2*o,2*o+2),16);r&&(n=Math.round(parseInt(r,16)/255*100)/100)}else if(i=e.match(/^rgba?\(\s*([+-]?\d+)\s*,\s*([+-]?\d+)\s*,\s*([+-]?\d+)\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)$/i)){for(o=0;o<t.length;o++)t[o]=parseInt(i[o+1]);n=parseFloat(i[4])}else if(i=e.match(/^rgba?\(\s*([+-]?[\d\.]+)\%\s*,\s*([+-]?[\d\.]+)\%\s*,\s*([+-]?[\d\.]+)\%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)$/i)){for(o=0;o<t.length;o++)t[o]=Math.round(2.55*parseFloat(i[o+1]));n=parseFloat(i[4])}else if(i=e.match(/(\w+)/)){if("transparent"==i[1])return[0,0,0,0];if(!(t=c[i[1]]))return}for(o=0;o<t.length;o++)t[o]=g(t[o],0,255);return n=n||0==n?g(n,0,1):1,t[3]=n,t}}function h(e){if(e){var t=e.match(/^hsla?\(\s*([+-]?\d+)(?:deg)?\s*,\s*([+-]?[\d\.]+)%\s*,\s*([+-]?[\d\.]+)%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)/);if(t){var n=parseFloat(t[4]);return[g(parseInt(t[1]),0,360),g(parseFloat(t[2]),0,100),g(parseFloat(t[3]),0,100),g(isNaN(n)?1:n,0,1)]}}}function f(e){if(e){var t=e.match(/^hwb\(\s*([+-]?\d+)(?:deg)?\s*,\s*([+-]?[\d\.]+)%\s*,\s*([+-]?[\d\.]+)%\s*(?:,\s*([+-]?[\d\.]+)\s*)?\)/);if(t){var n=parseFloat(t[4]);return[g(parseInt(t[1]),0,360),g(parseFloat(t[2]),0,100),g(parseFloat(t[3]),0,100),g(isNaN(n)?1:n,0,1)]}}}function p(e,t){return void 0===t&&(t=void 0!==e[3]?e[3]:1),"rgba("+e[0]+", "+e[1]+", "+e[2]+", "+t+")"}function m(e,t){return"rgba("+Math.round(e[0]/255*100)+"%, "+Math.round(e[1]/255*100)+"%, "+Math.round(e[2]/255*100)+"%, "+(t||e[3]||1)+")"}function v(e,t){return void 0===t&&(t=void 0!==e[3]?e[3]:1),"hsla("+e[0]+", "+e[1]+"%, "+e[2]+"%, "+t+")"}function g(e,t,n){return Math.min(Math.max(t,e),n)}function _(e){var t=e.toString(16).toUpperCase();return t.length<2?"0"+t:t}var b={};for(var y in c)b[c[y]]=y;var w=function(e){return e instanceof w?e:this instanceof w?(this.valid=!1,this.values={rgb:[0,0,0],hsl:[0,0,0],hsv:[0,0,0],hwb:[0,0,0],cmyk:[0,0,0,0],alpha:1},void("string"==typeof e?(t=u.getRgba(e))?this.setValues("rgb",t):(t=u.getHsla(e))?this.setValues("hsl",t):(t=u.getHwb(e))&&this.setValues("hwb",t):"object"==typeof e&&(void 0!==(t=e).r||void 0!==t.red?this.setValues("rgb",t):void 0!==t.l||void 0!==t.lightness?this.setValues("hsl",t):void 0!==t.v||void 0!==t.value?this.setValues("hsv",t):void 0!==t.w||void 0!==t.whiteness?this.setValues("hwb",t):void 0===t.c&&void 0===t.cyan||this.setValues("cmyk",t)))):new w(e);var t};w.prototype={isValid:function(){return this.valid},rgb:function(){return this.setSpace("rgb",arguments)},hsl:function(){return this.setSpace("hsl",arguments)},hsv:function(){return this.setSpace("hsv",arguments)},hwb:function(){return this.setSpace("hwb",arguments)},cmyk:function(){return this.setSpace("cmyk",arguments)},rgbArray:function(){return this.values.rgb},hslArray:function(){return this.values.hsl},hsvArray:function(){return this.values.hsv},hwbArray:function(){var e=this.values;return 1!==e.alpha?e.hwb.concat([e.alpha]):e.hwb},cmykArray:function(){return this.values.cmyk},rgbaArray:function(){var e=this.values;return e.rgb.concat([e.alpha])},hslaArray:function(){var e=this.values;return e.hsl.concat([e.alpha])},alpha:function(e){return void 0===e?this.values.alpha:(this.setValues("alpha",e),this)},red:function(e){return this.setChannel("rgb",0,e)},green:function(e){return this.setChannel("rgb",1,e)},blue:function(e){return this.setChannel("rgb",2,e)},hue:function(e){return e&&(e=(e%=360)<0?360+e:e),this.setChannel("hsl",0,e)},saturation:function(e){return this.setChannel("hsl",1,e)},lightness:function(e){return this.setChannel("hsl",2,e)},saturationv:function(e){return this.setChannel("hsv",1,e)},whiteness:function(e){return this.setChannel("hwb",1,e)},blackness:function(e){return this.setChannel("hwb",2,e)},value:function(e){return this.setChannel("hsv",2,e)},cyan:function(e){return this.setChannel("cmyk",0,e)},magenta:function(e){return this.setChannel("cmyk",1,e)},yellow:function(e){return this.setChannel("cmyk",2,e)},black:function(e){return this.setChannel("cmyk",3,e)},hexString:function(){return u.hexString(this.values.rgb)},rgbString:function(){return u.rgbString(this.values.rgb,this.values.alpha)},rgbaString:function(){return u.rgbaString(this.values.rgb,this.values.alpha)},percentString:function(){return u.percentString(this.values.rgb,this.values.alpha)},hslString:function(){return u.hslString(this.values.hsl,this.values.alpha)},hslaString:function(){return u.hslaString(this.values.hsl,this.values.alpha)},hwbString:function(){return u.hwbString(this.values.hwb,this.values.alpha)},keyword:function(){return u.keyword(this.values.rgb,this.values.alpha)},rgbNumber:function(){var e=this.values.rgb;return e[0]<<16|e[1]<<8|e[2]},luminosity:function(){for(var e=this.values.rgb,t=[],n=0;n<e.length;n++){var i=e[n]/255;t[n]=i<=.03928?i/12.92:Math.pow((i+.055)/1.055,2.4)}return.2126*t[0]+.7152*t[1]+.0722*t[2]},contrast:function(e){var t=this.luminosity(),n=e.luminosity();return t>n?(t+.05)/(n+.05):(n+.05)/(t+.05)},level:function(e){var t=this.contrast(e);return t>=7.1?"AAA":t>=4.5?"AA":""},dark:function(){var e=this.values.rgb;return(299*e[0]+587*e[1]+114*e[2])/1e3<128},light:function(){return!this.dark()},negate:function(){for(var e=[],t=0;t<3;t++)e[t]=255-this.values.rgb[t];return this.setValues("rgb",e),this},lighten:function(e){var t=this.values.hsl;return t[2]+=t[2]*e,this.setValues("hsl",t),this},darken:function(e){var t=this.values.hsl;return t[2]-=t[2]*e,this.setValues("hsl",t),this},saturate:function(e){var t=this.values.hsl;return t[1]+=t[1]*e,this.setValues("hsl",t),this},desaturate:function(e){var t=this.values.hsl;return t[1]-=t[1]*e,this.setValues("hsl",t),this},whiten:function(e){var t=this.values.hwb;return t[1]+=t[1]*e,this.setValues("hwb",t),this},blacken:function(e){var t=this.values.hwb;return t[2]+=t[2]*e,this.setValues("hwb",t),this},greyscale:function(){var e=this.values.rgb,t=.3*e[0]+.59*e[1]+.11*e[2];return this.setValues("rgb",[t,t,t]),this},clearer:function(e){var t=this.values.alpha;return this.setValues("alpha",t-t*e),this},opaquer:function(e){var t=this.values.alpha;return this.setValues("alpha",t+t*e),this},rotate:function(e){var t=this.values.hsl,n=(t[0]+e)%360;return t[0]=n<0?360+n:n,this.setValues("hsl",t),this},mix:function(e,t){var n=this,i=e,r=void 0===t?.5:t,o=2*r-1,a=n.alpha()-i.alpha(),s=((o*a==-1?o:(o+a)/(1+o*a))+1)/2,l=1-s;return this.rgb(s*n.red()+l*i.red(),s*n.green()+l*i.green(),s*n.blue()+l*i.blue()).alpha(n.alpha()*r+i.alpha()*(1-r))},toJSON:function(){return this.rgb()},clone:function(){var e,t,n=new w,i=this.values,r=n.values;for(var o in i)i.hasOwnProperty(o)&&(e=i[o],"[object Array]"===(t={}.toString.call(e))?r[o]=e.slice(0):"[object Number]"===t?r[o]=e:console.error("unexpected color value:",e));return n}},w.prototype.spaces={rgb:["red","green","blue"],hsl:["hue","saturation","lightness"],hsv:["hue","saturation","value"],hwb:["hue","whiteness","blackness"],cmyk:["cyan","magenta","yellow","black"]},w.prototype.maxes={rgb:[255,255,255],hsl:[360,100,100],hsv:[360,100,100],hwb:[360,100,100],cmyk:[100,100,100,100]},w.prototype.getValues=function(e){for(var t=this.values,n={},i=0;i<e.length;i++)n[e.charAt(i)]=t[e][i];return 1!==t.alpha&&(n.a=t.alpha),n},w.prototype.setValues=function(e,t){var n,i,r=this.values,o=this.spaces,a=this.maxes,s=1;if(this.valid=!0,"alpha"===e)s=t;else if(t.length)r[e]=t.slice(0,e.length),s=t[e.length];else if(void 0!==t[e.charAt(0)]){for(n=0;n<e.length;n++)r[e][n]=t[e.charAt(n)];s=t.a}else if(void 0!==t[o[e][0]]){var c=o[e];for(n=0;n<e.length;n++)r[e][n]=t[c[n]];s=t.alpha}if(r.alpha=Math.max(0,Math.min(1,void 0===s?r.alpha:s)),"alpha"===e)return!1;for(n=0;n<e.length;n++)i=Math.max(0,Math.min(a[e][n],r[e][n])),r[e][n]=Math.round(i);for(var u in o)u!==e&&(r[u]=l[e][u](r[e]));return!0},w.prototype.setSpace=function(e,t){var n=t[0];return void 0===n?this.getValues(e):("number"==typeof n&&(n=Array.prototype.slice.call(t)),this.setValues(e,n),this)},w.prototype.setChannel=function(e,t,n){var i=this.values[e];return void 0===n?i[t]:(n===i[t]||(i[t]=n,this.setValues(e,i)),this)},"undefined"!=typeof window&&(window.Color=w);var k=w;function x(e){return-1===["__proto__","prototype","constructor"].indexOf(e)}var S={noop:function(){},uid:function(){var e=0;return function(){return e++}}(),isNullOrUndef:function(e){return null==e},isArray:function(e){if(Array.isArray&&Array.isArray(e))return!0;var t=Object.prototype.toString.call(e);return"[object"===t.substr(0,7)&&"Array]"===t.substr(-6)},isObject:function(e){return null!==e&&"[object Object]"===Object.prototype.toString.call(e)},isFinite:function(e){return("number"==typeof e||e instanceof Number)&&isFinite(e)},valueOrDefault:function(e,t){return void 0===e?t:e},valueAtIndexOrDefault:function(e,t,n){return S.valueOrDefault(S.isArray(e)?e[t]:e,n)},callback:function(e,t,n){if(e&&"function"==typeof e.call)return e.apply(n,t)},each:function(e,t,n,i){var r,o,a;if(S.isArray(e))if(o=e.length,i)for(r=o-1;r>=0;r--)t.call(n,e[r],r);else for(r=0;r<o;r++)t.call(n,e[r],r);else if(S.isObject(e))for(o=(a=Object.keys(e)).length,r=0;r<o;r++)t.call(n,e[a[r]],a[r])},arrayEquals:function(e,t){var n,i,r,o;if(!e||!t||e.length!==t.length)return!1;for(n=0,i=e.length;n<i;++n)if(r=e[n],o=t[n],r instanceof Array&&o instanceof Array){if(!S.arrayEquals(r,o))return!1}else if(r!==o)return!1;return!0},clone:function(e){if(S.isArray(e))return e.map(S.clone);if(S.isObject(e)){for(var t=Object.create(e),n=Object.keys(e),i=n.length,r=0;r<i;++r)t[n[r]]=S.clone(e[n[r]]);return t}return e},_merger:function(e,t,n,i){if(x(e)){var r=t[e],o=n[e];S.isObject(r)&&S.isObject(o)?S.merge(r,o,i):t[e]=S.clone(o)}},_mergerIf:function(e,t,n){if(x(e)){var i=t[e],r=n[e];S.isObject(i)&&S.isObject(r)?S.mergeIf(i,r):t.hasOwnProperty(e)||(t[e]=S.clone(r))}},merge:function(e,t,n){var i,r,o,a,s,l=S.isArray(t)?t:[t],c=l.length;if(!S.isObject(e))return e;for(i=(n=n||{}).merger||S._merger,r=0;r<c;++r)if(t=l[r],S.isObject(t))for(s=0,a=(o=Object.keys(t)).length;s<a;++s)i(o[s],e,t,n);return e},mergeIf:function(e,t){return S.merge(e,t,{merger:S._mergerIf})},extend:Object.assign||function(e){return S.merge(e,[].slice.call(arguments,1),{merger:function(e,t,n){t[e]=n[e]}})},inherits:function(e){var t=this,n=e&&e.hasOwnProperty("constructor")?e.constructor:function(){return t.apply(this,arguments)},i=function(){this.constructor=n};return i.prototype=t.prototype,n.prototype=new i,n.extend=S.inherits,e&&S.extend(n.prototype,e),n.__super__=t.prototype,n},_deprecated:function(e,t,n,i){void 0!==t&&console.warn(e+': "'+n+'" is deprecated. Please use "'+i+'" instead')}},C=S;S.callCallback=S.callback,S.indexOf=function(e,t,n){return Array.prototype.indexOf.call(e,t,n)},S.getValueOrDefault=S.valueOrDefault,S.getValueAtIndexOrDefault=S.valueAtIndexOrDefault;var M={linear:function(e){return e},easeInQuad:function(e){return e*e},easeOutQuad:function(e){return-e*(e-2)},easeInOutQuad:function(e){return(e/=.5)<1?.5*e*e:-.5*(--e*(e-2)-1)},easeInCubic:function(e){return e*e*e},easeOutCubic:function(e){return(e-=1)*e*e+1},easeInOutCubic:function(e){return(e/=.5)<1?.5*e*e*e:.5*((e-=2)*e*e+2)},easeInQuart:function(e){return e*e*e*e},easeOutQuart:function(e){return-((e-=1)*e*e*e-1)},easeInOutQuart:function(e){return(e/=.5)<1?.5*e*e*e*e:-.5*((e-=2)*e*e*e-2)},easeInQuint:function(e){return e*e*e*e*e},easeOutQuint:function(e){return(e-=1)*e*e*e*e+1},easeInOutQuint:function(e){return(e/=.5)<1?.5*e*e*e*e*e:.5*((e-=2)*e*e*e*e+2)},easeInSine:function(e){return 1-Math.cos(e*(Math.PI/2))},easeOutSine:function(e){return Math.sin(e*(Math.PI/2))},easeInOutSine:function(e){return-.5*(Math.cos(Math.PI*e)-1)},easeInExpo:function(e){return 0===e?0:Math.pow(2,10*(e-1))},easeOutExpo:function(e){return 1===e?1:1-Math.pow(2,-10*e)},easeInOutExpo:function(e){return 0===e?0:1===e?1:(e/=.5)<1?.5*Math.pow(2,10*(e-1)):.5*(2-Math.pow(2,-10*--e))},easeInCirc:function(e){return e>=1?e:-(Math.sqrt(1-e*e)-1)},easeOutCirc:function(e){return Math.sqrt(1-(e-=1)*e)},easeInOutCirc:function(e){return(e/=.5)<1?-.5*(Math.sqrt(1-e*e)-1):.5*(Math.sqrt(1-(e-=2)*e)+1)},easeInElastic:function(e){var t=1.70158,n=0,i=1;return 0===e?0:1===e?1:(n||(n=.3),i<1?(i=1,t=n/4):t=n/(2*Math.PI)*Math.asin(1/i),-i*Math.pow(2,10*(e-=1))*Math.sin((e-t)*(2*Math.PI)/n))},easeOutElastic:function(e){var t=1.70158,n=0,i=1;return 0===e?0:1===e?1:(n||(n=.3),i<1?(i=1,t=n/4):t=n/(2*Math.PI)*Math.asin(1/i),i*Math.pow(2,-10*e)*Math.sin((e-t)*(2*Math.PI)/n)+1)},easeInOutElastic:function(e){var t=1.70158,n=0,i=1;return 0===e?0:2==(e/=.5)?1:(n||(n=.45),i<1?(i=1,t=n/4):t=n/(2*Math.PI)*Math.asin(1/i),e<1?i*Math.pow(2,10*(e-=1))*Math.sin((e-t)*(2*Math.PI)/n)*-.5:i*Math.pow(2,-10*(e-=1))*Math.sin((e-t)*(2*Math.PI)/n)*.5+1)},easeInBack:function(e){var t=1.70158;return e*e*((t+1)*e-t)},easeOutBack:function(e){var t=1.70158;return(e-=1)*e*((t+1)*e+t)+1},easeInOutBack:function(e){var t=1.70158;return(e/=.5)<1?e*e*((1+(t*=1.525))*e-t)*.5:.5*((e-=2)*e*((1+(t*=1.525))*e+t)+2)},easeInBounce:function(e){return 1-M.easeOutBounce(1-e)},easeOutBounce:function(e){return e<1/2.75?7.5625*e*e:e<2/2.75?7.5625*(e-=1.5/2.75)*e+.75:e<2.5/2.75?7.5625*(e-=2.25/2.75)*e+.9375:7.5625*(e-=2.625/2.75)*e+.984375},easeInOutBounce:function(e){return e<.5?.5*M.easeInBounce(2*e):.5*M.easeOutBounce(2*e-1)+.5}},T={effects:M};C.easingEffects=M;var A=Math.PI,P=A/180,L=2*A,O=A/2,q=A/4,E=2*A/3,D={clear:function(e){e.ctx.clearRect(0,0,e.width,e.height)},roundedRect:function(e,t,n,i,r,o){if(o){var a=Math.min(o,r/2,i/2),s=t+a,l=n+a,c=t+i-a,u=n+r-a;e.moveTo(t,l),s<c&&l<u?(e.arc(s,l,a,-A,-O),e.arc(c,l,a,-O,0),e.arc(c,u,a,0,O),e.arc(s,u,a,O,A)):s<c?(e.moveTo(s,n),e.arc(c,l,a,-O,O),e.arc(s,l,a,O,A+O)):l<u?(e.arc(s,l,a,-A,0),e.arc(s,u,a,0,A)):e.arc(s,l,a,-A,A),e.closePath(),e.moveTo(t,n)}else e.rect(t,n,i,r)},drawPoint:function(e,t,n,i,r,o){var a,s,l,c,u,d=(o||0)*P;if(t&&"object"==typeof t&&("[object HTMLImageElement]"===(a=t.toString())||"[object HTMLCanvasElement]"===a))return e.save(),e.translate(i,r),e.rotate(d),e.drawImage(t,-t.width/2,-t.height/2,t.width,t.height),void e.restore();if(!(isNaN(n)||n<=0)){switch(e.beginPath(),t){default:e.arc(i,r,n,0,L),e.closePath();break;case"triangle":e.moveTo(i+Math.sin(d)*n,r-Math.cos(d)*n),d+=E,e.lineTo(i+Math.sin(d)*n,r-Math.cos(d)*n),d+=E,e.lineTo(i+Math.sin(d)*n,r-Math.cos(d)*n),e.closePath();break;case"rectRounded":c=n-(u=.516*n),s=Math.cos(d+q)*c,l=Math.sin(d+q)*c,e.arc(i-s,r-l,u,d-A,d-O),e.arc(i+l,r-s,u,d-O,d),e.arc(i+s,r+l,u,d,d+O),e.arc(i-l,r+s,u,d+O,d+A),e.closePath();break;case"rect":if(!o){c=Math.SQRT1_2*n,e.rect(i-c,r-c,2*c,2*c);break}d+=q;case"rectRot":s=Math.cos(d)*n,l=Math.sin(d)*n,e.moveTo(i-s,r-l),e.lineTo(i+l,r-s),e.lineTo(i+s,r+l),e.lineTo(i-l,r+s),e.closePath();break;case"crossRot":d+=q;case"cross":s=Math.cos(d)*n,l=Math.sin(d)*n,e.moveTo(i-s,r-l),e.lineTo(i+s,r+l),e.moveTo(i+l,r-s),e.lineTo(i-l,r+s);break;case"star":s=Math.cos(d)*n,l=Math.sin(d)*n,e.moveTo(i-s,r-l),e.lineTo(i+s,r+l),e.moveTo(i+l,r-s),e.lineTo(i-l,r+s),d+=q,s=Math.cos(d)*n,l=Math.sin(d)*n,e.moveTo(i-s,r-l),e.lineTo(i+s,r+l),e.moveTo(i+l,r-s),e.lineTo(i-l,r+s);break;case"line":s=Math.cos(d)*n,l=Math.sin(d)*n,e.moveTo(i-s,r-l),e.lineTo(i+s,r+l);break;case"dash":e.moveTo(i,r),e.lineTo(i+Math.cos(d)*n,r+Math.sin(d)*n)}e.fill(),e.stroke()}},_isPointInArea:function(e,t){var n=1e-6;return e.x>t.left-n&&e.x<t.right+n&&e.y>t.top-n&&e.y<t.bottom+n},clipArea:function(e,t){e.save(),e.beginPath(),e.rect(t.left,t.top,t.right-t.left,t.bottom-t.top),e.clip()},unclipArea:function(e){e.restore()},lineTo:function(e,t,n,i){var r=n.steppedLine;if(r){if("middle"===r){var o=(t.x+n.x)/2;e.lineTo(o,i?n.y:t.y),e.lineTo(o,i?t.y:n.y)}else"after"===r&&!i||"after"!==r&&i?e.lineTo(t.x,n.y):e.lineTo(n.x,t.y);e.lineTo(n.x,n.y)}else n.tension?e.bezierCurveTo(i?t.controlPointPreviousX:t.controlPointNextX,i?t.controlPointPreviousY:t.controlPointNextY,i?n.controlPointNextX:n.controlPointPreviousX,i?n.controlPointNextY:n.controlPointPreviousY,n.x,n.y):e.lineTo(n.x,n.y)}},z=D;C.clear=D.clear,C.drawRoundedRectangle=function(e){e.beginPath(),D.roundedRect.apply(D,arguments)};var N={_set:function(e,t){return C.merge(this[e]||(this[e]={}),t)}};N._set("global",{defaultColor:"rgba(0,0,0,0.1)",defaultFontColor:"#666",defaultFontFamily:"'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",defaultFontSize:12,defaultFontStyle:"normal",defaultLineHeight:1.2,showLines:!0});var j=N,R=C.valueOrDefault;var I={toLineHeight:function(e,t){var n=(""+e).match(/^(normal|(\d+(?:\.\d+)?)(px|em|%)?)$/);if(!n||"normal"===n[1])return 1.2*t;switch(e=+n[2],n[3]){case"px":return e;case"%":e/=100}return t*e},toPadding:function(e){var t,n,i,r;return C.isObject(e)?(t=+e.top||0,n=+e.right||0,i=+e.bottom||0,r=+e.left||0):t=n=i=r=+e||0,{top:t,right:n,bottom:i,left:r,height:t+i,width:r+n}},_parseFont:function(e){var t=j.global,n=R(e.fontSize,t.defaultFontSize),i={family:R(e.fontFamily,t.defaultFontFamily),lineHeight:C.options.toLineHeight(R(e.lineHeight,t.defaultLineHeight),n),size:n,style:R(e.fontStyle,t.defaultFontStyle),weight:null,string:""};return i.string=function(e){return!e||C.isNullOrUndef(e.size)||C.isNullOrUndef(e.family)?null:(e.style?e.style+" ":"")+(e.weight?e.weight+" ":"")+e.size+"px "+e.family}(i),i},resolve:function(e,t,n,i){var r,o,a,s=!0;for(r=0,o=e.length;r<o;++r)if(void 0!==(a=e[r])&&(void 0!==t&&"function"==typeof a&&(a=a(t),s=!1),void 0!==n&&C.isArray(a)&&(a=a[n],s=!1),void 0!==a))return i&&!s&&(i.cacheable=!1),a}},$={_factorize:function(e){var t,n=[],i=Math.sqrt(e);for(t=1;t<i;t++)e%t==0&&(n.push(t),n.push(e/t));return i===(0|i)&&n.push(i),n.sort((function(e,t){return e-t})).pop(),n},log10:Math.log10||function(e){var t=Math.log(e)*Math.LOG10E,n=Math.round(t);return e===Math.pow(10,n)?n:t}},F=$;C.log10=$.log10;var B={getRtlAdapter:function(e,t,n){return e?function(e,t){return{x:function(n){return e+e+t-n},setWidth:function(e){t=e},textAlign:function(e){return"center"===e?e:"right"===e?"left":"right"},xPlus:function(e,t){return e-t},leftForLtr:function(e,t){return e-t}}}(t,n):{x:function(e){return e},setWidth:function(e){},textAlign:function(e){return e},xPlus:function(e,t){return e+t},leftForLtr:function(e,t){return e}}},overrideTextDirection:function(e,t){var n,i;"ltr"!==t&&"rtl"!==t||(i=[(n=e.canvas.style).getPropertyValue("direction"),n.getPropertyPriority("direction")],n.setProperty("direction",t,"important"),e.prevTextDirection=i)},restoreTextDirection:function(e){var t=e.prevTextDirection;void 0!==t&&(delete e.prevTextDirection,e.canvas.style.setProperty("direction",t[0],t[1]))}},V=C,H=T,W=z,U=I,Y=F,G=B;V.easing=H,V.canvas=W,V.options=U,V.math=Y,V.rtl=G;var Q=function(e){V.extend(this,e),this.initialize.apply(this,arguments)};V.extend(Q.prototype,{_type:void 0,initialize:function(){this.hidden=!1},pivot:function(){var e=this;return e._view||(e._view=V.extend({},e._model)),e._start={},e},transition:function(e){var t=this,n=t._model,i=t._start,r=t._view;return n&&1!==e?(r||(r=t._view={}),i||(i=t._start={}),function(e,t,n,i){var r,o,a,s,l,c,u,d,h,f=Object.keys(n);for(r=0,o=f.length;r<o;++r)if(c=n[a=f[r]],t.hasOwnProperty(a)||(t[a]=c),(s=t[a])!==c&&"_"!==a[0]){if(e.hasOwnProperty(a)||(e[a]=s),(u=typeof c)==typeof(l=e[a]))if("string"===u){if((d=k(l)).valid&&(h=k(c)).valid){t[a]=h.mix(d,i).rgbString();continue}}else if(V.isFinite(l)&&V.isFinite(c)){t[a]=l+(c-l)*i;continue}t[a]=c}}(i,r,n,e),t):(t._view=V.extend({},n),t._start=null,t)},tooltipPosition:function(){return{x:this._model.x,y:this._model.y}},hasValue:function(){return V.isNumber(this._model.x)&&V.isNumber(this._model.y)}}),Q.extend=V.inherits;var K=Q,Z=K.extend({chart:null,currentStep:0,numSteps:60,easing:"",render:null,onAnimationProgress:null,onAnimationComplete:null}),J=Z;Object.defineProperty(Z.prototype,"animationObject",{get:function(){return this}}),Object.defineProperty(Z.prototype,"chartInstance",{get:function(){return this.chart},set:function(e){this.chart=e}}),j._set("global",{animation:{duration:1e3,easing:"easeOutQuart",onProgress:V.noop,onComplete:V.noop}});var X={animations:[],request:null,addAnimation:function(e,t,n,i){var r,o,a=this.animations;for(t.chart=e,t.startTime=Date.now(),t.duration=n,i||(e.animating=!0),r=0,o=a.length;r<o;++r)if(a[r].chart===e)return void(a[r]=t);a.push(t),1===a.length&&this.requestAnimationFrame()},cancelAnimation:function(e){var t=V.findIndex(this.animations,(function(t){return t.chart===e}));-1!==t&&(this.animations.splice(t,1),e.animating=!1)},requestAnimationFrame:function(){var e=this;null===e.request&&(e.request=V.requestAnimFrame.call(window,(function(){e.request=null,e.startDigest()})))},startDigest:function(){var e=this;e.advance(),e.animations.length>0&&e.requestAnimationFrame()},advance:function(){for(var e,t,n,i,r=this.animations,o=0;o<r.length;)t=(e=r[o]).chart,n=e.numSteps,i=Math.floor((Date.now()-e.startTime)/e.duration*n)+1,e.currentStep=Math.min(i,n),V.callback(e.render,[t,e],t),V.callback(e.onAnimationProgress,[e],t),e.currentStep>=n?(V.callback(e.onAnimationComplete,[e],t),t.animating=!1,r.splice(o,1)):++o}},ee=V.options.resolve,te=["push","pop","shift","splice","unshift"];function ne(e,t){var n=e._chartjs;if(n){var i=n.listeners,r=i.indexOf(t);-1!==r&&i.splice(r,1),i.length>0||(te.forEach((function(t){delete e[t]})),delete e._chartjs)}}var ie=function(e,t){this.initialize(e,t)};V.extend(ie.prototype,{datasetElementType:null,dataElementType:null,_datasetElementOptions:["backgroundColor","borderCapStyle","borderColor","borderDash","borderDashOffset","borderJoinStyle","borderWidth"],_dataElementOptions:["backgroundColor","borderColor","borderWidth","pointStyle"],initialize:function(e,t){var n=this;n.chart=e,n.index=t,n.linkScales(),n.addElements(),n._type=n.getMeta().type},updateIndex:function(e){this.index=e},linkScales:function(){var e=this,t=e.getMeta(),n=e.chart,i=n.scales,r=e.getDataset(),o=n.options.scales;null!==t.xAxisID&&t.xAxisID in i&&!r.xAxisID||(t.xAxisID=r.xAxisID||o.xAxes[0].id),null!==t.yAxisID&&t.yAxisID in i&&!r.yAxisID||(t.yAxisID=r.yAxisID||o.yAxes[0].id)},getDataset:function(){return this.chart.data.datasets[this.index]},getMeta:function(){return this.chart.getDatasetMeta(this.index)},getScaleForId:function(e){return this.chart.scales[e]},_getValueScaleId:function(){return this.getMeta().yAxisID},_getIndexScaleId:function(){return this.getMeta().xAxisID},_getValueScale:function(){return this.getScaleForId(this._getValueScaleId())},_getIndexScale:function(){return this.getScaleForId(this._getIndexScaleId())},reset:function(){this._update(!0)},destroy:function(){this._data&&ne(this._data,this)},createMetaDataset:function(){var e=this,t=e.datasetElementType;return t&&new t({_chart:e.chart,_datasetIndex:e.index})},createMetaData:function(e){var t=this,n=t.dataElementType;return n&&new n({_chart:t.chart,_datasetIndex:t.index,_index:e})},addElements:function(){var e,t,n=this,i=n.getMeta(),r=n.getDataset().data||[],o=i.data;for(e=0,t=r.length;e<t;++e)o[e]=o[e]||n.createMetaData(e);i.dataset=i.dataset||n.createMetaDataset()},addElementAndReset:function(e){var t=this.createMetaData(e);this.getMeta().data.splice(e,0,t),this.updateElement(t,e,!0)},buildOrUpdateElements:function(){var e,t,n=this,i=n.getDataset(),r=i.data||(i.data=[]);n._data!==r&&(n._data&&ne(n._data,n),r&&Object.isExtensible(r)&&(t=n,(e=r)._chartjs?e._chartjs.listeners.push(t):(Object.defineProperty(e,"_chartjs",{configurable:!0,enumerable:!1,value:{listeners:[t]}}),te.forEach((function(t){var n="onData"+t.charAt(0).toUpperCase()+t.slice(1),i=e[t];Object.defineProperty(e,t,{configurable:!0,enumerable:!1,value:function(){var t=Array.prototype.slice.call(arguments),r=i.apply(this,t);return V.each(e._chartjs.listeners,(function(e){"function"==typeof e[n]&&e[n].apply(e,t)})),r}})})))),n._data=r),n.resyncElements()},_configure:function(){var e=this;e._config=V.merge(Object.create(null),[e.chart.options.datasets[e._type],e.getDataset()],{merger:function(e,t,n){"_meta"!==e&&"data"!==e&&V._merger(e,t,n)}})},_update:function(e){var t=this;t._configure(),t._cachedDataOpts=null,t.update(e)},update:V.noop,transition:function(e){for(var t=this.getMeta(),n=t.data||[],i=n.length,r=0;r<i;++r)n[r].transition(e);t.dataset&&t.dataset.transition(e)},draw:function(){var e=this.getMeta(),t=e.data||[],n=t.length,i=0;for(e.dataset&&e.dataset.draw();i<n;++i)t[i].draw()},getStyle:function(e){var t,n=this,i=n.getMeta(),r=i.dataset;return n._configure(),r&&void 0===e?t=n._resolveDatasetElementOptions(r||{}):(e=e||0,t=n._resolveDataElementOptions(i.data[e]||{},e)),!1!==t.fill&&null!==t.fill||(t.backgroundColor=t.borderColor),t},_resolveDatasetElementOptions:function(e,t){var n,i,r,o,a=this,s=a.chart,l=a._config,c=e.custom||{},u=s.options.elements[a.datasetElementType.prototype._type]||{},d=a._datasetElementOptions,h={},f={chart:s,dataset:a.getDataset(),datasetIndex:a.index,hover:t};for(n=0,i=d.length;n<i;++n)r=d[n],o=t?"hover"+r.charAt(0).toUpperCase()+r.slice(1):r,h[r]=ee([c[o],l[o],u[o]],f);return h},_resolveDataElementOptions:function(e,t){var n=this,i=e&&e.custom,r=n._cachedDataOpts;if(r&&!i)return r;var o,a,s,l,c=n.chart,u=n._config,d=c.options.elements[n.dataElementType.prototype._type]||{},h=n._dataElementOptions,f={},p={chart:c,dataIndex:t,dataset:n.getDataset(),datasetIndex:n.index},m={cacheable:!i};if(i=i||{},V.isArray(h))for(a=0,s=h.length;a<s;++a)f[l=h[a]]=ee([i[l],u[l],d[l]],p,t,m);else for(a=0,s=(o=Object.keys(h)).length;a<s;++a)f[l=o[a]]=ee([i[l],u[h[l]],u[l],d[l]],p,t,m);return m.cacheable&&(n._cachedDataOpts=Object.freeze(f)),f},removeHoverStyle:function(e){V.merge(e._model,e.$previousStyle||{}),delete e.$previousStyle},setHoverStyle:function(e){var t=this.chart.data.datasets[e._datasetIndex],n=e._index,i=e.custom||{},r=e._model,o=V.getHoverColor;e.$previousStyle={backgroundColor:r.backgroundColor,borderColor:r.borderColor,borderWidth:r.borderWidth},r.backgroundColor=ee([i.hoverBackgroundColor,t.hoverBackgroundColor,o(r.backgroundColor)],void 0,n),r.borderColor=ee([i.hoverBorderColor,t.hoverBorderColor,o(r.borderColor)],void 0,n),r.borderWidth=ee([i.hoverBorderWidth,t.hoverBorderWidth,r.borderWidth],void 0,n)},_removeDatasetHoverStyle:function(){var e=this.getMeta().dataset;e&&this.removeHoverStyle(e)},_setDatasetHoverStyle:function(){var e,t,n,i,r,o,a=this.getMeta().dataset,s={};if(a){for(o=a._model,r=this._resolveDatasetElementOptions(a,!0),e=0,t=(i=Object.keys(r)).length;e<t;++e)s[n=i[e]]=o[n],o[n]=r[n];a.$previousStyle=s}},resyncElements:function(){var e=this,t=e.getMeta(),n=e.getDataset().data,i=t.data.length,r=n.length;r<i?t.data.splice(r,i-r):r>i&&e.insertElements(i,r-i)},insertElements:function(e,t){for(var n=0;n<t;++n)this.addElementAndReset(e+n)},onDataPush:function(){var e=arguments.length;this.insertElements(this.getDataset().data.length-e,e)},onDataPop:function(){this.getMeta().data.pop()},onDataShift:function(){this.getMeta().data.shift()},onDataSplice:function(e,t){this.getMeta().data.splice(e,t),this.insertElements(e,arguments.length-2)},onDataUnshift:function(){this.insertElements(0,arguments.length)}}),ie.extend=V.inherits;var re=ie,oe=2*Math.PI;function ae(e,t){var n=t.startAngle,i=t.endAngle,r=t.pixelMargin,o=r/t.outerRadius,a=t.x,s=t.y;e.beginPath(),e.arc(a,s,t.outerRadius,n-o,i+o),t.innerRadius>r?(o=r/t.innerRadius,e.arc(a,s,t.innerRadius-r,i+o,n-o,!0)):e.arc(a,s,r,i+Math.PI/2,n-Math.PI/2),e.closePath(),e.clip()}function se(e,t,n){var i="inner"===t.borderAlign;i?(e.lineWidth=2*t.borderWidth,e.lineJoin="round"):(e.lineWidth=t.borderWidth,e.lineJoin="bevel"),n.fullCircles&&function(e,t,n,i){var r,o=n.endAngle;for(i&&(n.endAngle=n.startAngle+oe,ae(e,n),n.endAngle=o,n.endAngle===n.startAngle&&n.fullCircles&&(n.endAngle+=oe,n.fullCircles--)),e.beginPath(),e.arc(n.x,n.y,n.innerRadius,n.startAngle+oe,n.startAngle,!0),r=0;r<n.fullCircles;++r)e.stroke();for(e.beginPath(),e.arc(n.x,n.y,t.outerRadius,n.startAngle,n.startAngle+oe),r=0;r<n.fullCircles;++r)e.stroke()}(e,t,n,i),i&&ae(e,n),e.beginPath(),e.arc(n.x,n.y,t.outerRadius,n.startAngle,n.endAngle),e.arc(n.x,n.y,n.innerRadius,n.endAngle,n.startAngle,!0),e.closePath(),e.stroke()}j._set("global",{elements:{arc:{backgroundColor:j.global.defaultColor,borderColor:"#fff",borderWidth:2,borderAlign:"center"}}});var le=K.extend({_type:"arc",inLabelRange:function(e){var t=this._view;return!!t&&Math.pow(e-t.x,2)<Math.pow(t.radius+t.hoverRadius,2)},inRange:function(e,t){var n=this._view;if(n){for(var i=V.getAngleFromPoint(n,{x:e,y:t}),r=i.angle,o=i.distance,a=n.startAngle,s=n.endAngle;s<a;)s+=oe;for(;r>s;)r-=oe;for(;r<a;)r+=oe;var l=r>=a&&r<=s,c=o>=n.innerRadius&&o<=n.outerRadius;return l&&c}return!1},getCenterPoint:function(){var e=this._view,t=(e.startAngle+e.endAngle)/2,n=(e.innerRadius+e.outerRadius)/2;return{x:e.x+Math.cos(t)*n,y:e.y+Math.sin(t)*n}},getArea:function(){var e=this._view;return Math.PI*((e.endAngle-e.startAngle)/(2*Math.PI))*(Math.pow(e.outerRadius,2)-Math.pow(e.innerRadius,2))},tooltipPosition:function(){var e=this._view,t=e.startAngle+(e.endAngle-e.startAngle)/2,n=(e.outerRadius-e.innerRadius)/2+e.innerRadius;return{x:e.x+Math.cos(t)*n,y:e.y+Math.sin(t)*n}},draw:function(){var e,t=this._chart.ctx,n=this._view,i="inner"===n.borderAlign?.33:0,r={x:n.x,y:n.y,innerRadius:n.innerRadius,outerRadius:Math.max(n.outerRadius-i,0),pixelMargin:i,startAngle:n.startAngle,endAngle:n.endAngle,fullCircles:Math.floor(n.circumference/oe)};if(t.save(),t.fillStyle=n.backgroundColor,t.strokeStyle=n.borderColor,r.fullCircles){for(r.endAngle=r.startAngle+oe,t.beginPath(),t.arc(r.x,r.y,r.outerRadius,r.startAngle,r.endAngle),t.arc(r.x,r.y,r.innerRadius,r.endAngle,r.startAngle,!0),t.closePath(),e=0;e<r.fullCircles;++e)t.fill();r.endAngle=r.startAngle+n.circumference%oe}t.beginPath(),t.arc(r.x,r.y,r.outerRadius,r.startAngle,r.endAngle),t.arc(r.x,r.y,r.innerRadius,r.endAngle,r.startAngle,!0),t.closePath(),t.fill(),n.borderWidth&&se(t,n,r),t.restore()}}),ce=V.valueOrDefault,ue=j.global.defaultColor;j._set("global",{elements:{line:{tension:.4,backgroundColor:ue,borderWidth:3,borderColor:ue,borderCapStyle:"butt",borderDash:[],borderDashOffset:0,borderJoinStyle:"miter",capBezierPoints:!0,fill:!0}}});var de=K.extend({_type:"line",draw:function(){var e,t,n,i=this,r=i._view,o=i._chart.ctx,a=r.spanGaps,s=i._children.slice(),l=j.global,c=l.elements.line,u=-1,d=i._loop;if(s.length){if(i._loop){for(e=0;e<s.length;++e)if(t=V.previousItem(s,e),!s[e]._view.skip&&t._view.skip){s=s.slice(e).concat(s.slice(0,e)),d=a;break}d&&s.push(s[0])}for(o.save(),o.lineCap=r.borderCapStyle||c.borderCapStyle,o.setLineDash&&o.setLineDash(r.borderDash||c.borderDash),o.lineDashOffset=ce(r.borderDashOffset,c.borderDashOffset),o.lineJoin=r.borderJoinStyle||c.borderJoinStyle,o.lineWidth=ce(r.borderWidth,c.borderWidth),o.strokeStyle=r.borderColor||l.defaultColor,o.beginPath(),(n=s[0]._view).skip||(o.moveTo(n.x,n.y),u=0),e=1;e<s.length;++e)n=s[e]._view,t=-1===u?V.previousItem(s,e):s[u],n.skip||(u!==e-1&&!a||-1===u?o.moveTo(n.x,n.y):V.canvas.lineTo(o,t._view,n),u=e);d&&o.closePath(),o.stroke(),o.restore()}}}),he=V.valueOrDefault,fe=j.global.defaultColor;function pe(e){var t=this._view;return!!t&&Math.abs(e-t.x)<t.radius+t.hitRadius}j._set("global",{elements:{point:{radius:3,pointStyle:"circle",backgroundColor:fe,borderColor:fe,borderWidth:1,hitRadius:1,hoverRadius:4,hoverBorderWidth:1}}});var me=K.extend({_type:"point",inRange:function(e,t){var n=this._view;return!!n&&Math.pow(e-n.x,2)+Math.pow(t-n.y,2)<Math.pow(n.hitRadius+n.radius,2)},inLabelRange:pe,inXRange:pe,inYRange:function(e){var t=this._view;return!!t&&Math.abs(e-t.y)<t.radius+t.hitRadius},getCenterPoint:function(){var e=this._view;return{x:e.x,y:e.y}},getArea:function(){return Math.PI*Math.pow(this._view.radius,2)},tooltipPosition:function(){var e=this._view;return{x:e.x,y:e.y,padding:e.radius+e.borderWidth}},draw:function(e){var t=this._view,n=this._chart.ctx,i=t.pointStyle,r=t.rotation,o=t.radius,a=t.x,s=t.y,l=j.global,c=l.defaultColor;t.skip||(void 0===e||V.canvas._isPointInArea(t,e))&&(n.strokeStyle=t.borderColor||c,n.lineWidth=he(t.borderWidth,l.elements.point.borderWidth),n.fillStyle=t.backgroundColor||c,V.canvas.drawPoint(n,i,o,a,s,r))}}),ve=j.global.defaultColor;function ge(e){return e&&void 0!==e.width}function _e(e){var t,n,i,r,o;return ge(e)?(o=e.width/2,t=e.x-o,n=e.x+o,i=Math.min(e.y,e.base),r=Math.max(e.y,e.base)):(o=e.height/2,t=Math.min(e.x,e.base),n=Math.max(e.x,e.base),i=e.y-o,r=e.y+o),{left:t,top:i,right:n,bottom:r}}function be(e,t,n){return e===t?n:e===n?t:e}function ye(e,t,n){var i,r,o,a,s=e.borderWidth,l=function(e){var t=e.borderSkipped,n={};return t?(e.horizontal?e.base>e.x&&(t=be(t,"left","right")):e.base<e.y&&(t=be(t,"bottom","top")),n[t]=!0,n):n}(e);return V.isObject(s)?(i=+s.top||0,r=+s.right||0,o=+s.bottom||0,a=+s.left||0):i=r=o=a=+s||0,{t:l.top||i<0?0:i>n?n:i,r:l.right||r<0?0:r>t?t:r,b:l.bottom||o<0?0:o>n?n:o,l:l.left||a<0?0:a>t?t:a}}function we(e,t,n){var i=null===t,r=null===n,o=!(!e||i&&r)&&_e(e);return o&&(i||t>=o.left&&t<=o.right)&&(r||n>=o.top&&n<=o.bottom)}j._set("global",{elements:{rectangle:{backgroundColor:ve,borderColor:ve,borderSkipped:"bottom",borderWidth:0}}});var ke=K.extend({_type:"rectangle",draw:function(){var e=this._chart.ctx,t=this._view,n=function(e){var t=_e(e),n=t.right-t.left,i=t.bottom-t.top,r=ye(e,n/2,i/2);return{outer:{x:t.left,y:t.top,w:n,h:i},inner:{x:t.left+r.l,y:t.top+r.t,w:n-r.l-r.r,h:i-r.t-r.b}}}(t),i=n.outer,r=n.inner;e.fillStyle=t.backgroundColor,e.fillRect(i.x,i.y,i.w,i.h),i.w===r.w&&i.h===r.h||(e.save(),e.beginPath(),e.rect(i.x,i.y,i.w,i.h),e.clip(),e.fillStyle=t.borderColor,e.rect(r.x,r.y,r.w,r.h),e.fill("evenodd"),e.restore())},height:function(){var e=this._view;return e.base-e.y},inRange:function(e,t){return we(this._view,e,t)},inLabelRange:function(e,t){var n=this._view;return ge(n)?we(n,e,null):we(n,null,t)},inXRange:function(e){return we(this._view,e,null)},inYRange:function(e){return we(this._view,null,e)},getCenterPoint:function(){var e,t,n=this._view;return ge(n)?(e=n.x,t=(n.y+n.base)/2):(e=(n.x+n.base)/2,t=n.y),{x:e,y:t}},getArea:function(){var e=this._view;return ge(e)?e.width*Math.abs(e.y-e.base):e.height*Math.abs(e.x-e.base)},tooltipPosition:function(){var e=this._view;return{x:e.x,y:e.y}}}),xe={},Se=le,Ce=de,Me=me,Te=ke;xe.Arc=Se,xe.Line=Ce,xe.Point=Me,xe.Rectangle=Te;var Ae=V._deprecated,Pe=V.valueOrDefault;function Le(e,t,n){var i,r,o=n.barThickness,a=t.stackCount,s=t.pixels[e],l=V.isNullOrUndef(o)?function(e,t){var n,i,r,o,a=e._length;for(r=1,o=t.length;r<o;++r)a=Math.min(a,Math.abs(t[r]-t[r-1]));for(r=0,o=e.getTicks().length;r<o;++r)i=e.getPixelForTick(r),a=r>0?Math.min(a,Math.abs(i-n)):a,n=i;return a}(t.scale,t.pixels):-1;return V.isNullOrUndef(o)?(i=l*n.categoryPercentage,r=n.barPercentage):(i=o*a,r=1),{chunk:i/a,ratio:r,start:s-i/2}}j._set("bar",{hover:{mode:"label"},scales:{xAxes:[{type:"category",offset:!0,gridLines:{offsetGridLines:!0}}],yAxes:[{type:"linear"}]}}),j._set("global",{datasets:{bar:{categoryPercentage:.8,barPercentage:.9}}});var Oe=re.extend({dataElementType:xe.Rectangle,_dataElementOptions:["backgroundColor","borderColor","borderSkipped","borderWidth","barPercentage","barThickness","categoryPercentage","maxBarThickness","minBarLength"],initialize:function(){var e,t,n=this;re.prototype.initialize.apply(n,arguments),(e=n.getMeta()).stack=n.getDataset().stack,e.bar=!0,t=n._getIndexScale().options,Ae("bar chart",t.barPercentage,"scales.[x/y]Axes.barPercentage","dataset.barPercentage"),Ae("bar chart",t.barThickness,"scales.[x/y]Axes.barThickness","dataset.barThickness"),Ae("bar chart",t.categoryPercentage,"scales.[x/y]Axes.categoryPercentage","dataset.categoryPercentage"),Ae("bar chart",n._getValueScale().options.minBarLength,"scales.[x/y]Axes.minBarLength","dataset.minBarLength"),Ae("bar chart",t.maxBarThickness,"scales.[x/y]Axes.maxBarThickness","dataset.maxBarThickness")},update:function(e){var t,n,i=this,r=i.getMeta().data;for(i._ruler=i.getRuler(),t=0,n=r.length;t<n;++t)i.updateElement(r[t],t,e)},updateElement:function(e,t,n){var i=this,r=i.getMeta(),o=i.getDataset(),a=i._resolveDataElementOptions(e,t);e._xScale=i.getScaleForId(r.xAxisID),e._yScale=i.getScaleForId(r.yAxisID),e._datasetIndex=i.index,e._index=t,e._model={backgroundColor:a.backgroundColor,borderColor:a.borderColor,borderSkipped:a.borderSkipped,borderWidth:a.borderWidth,datasetLabel:o.label,label:i.chart.data.labels[t]},V.isArray(o.data[t])&&(e._model.borderSkipped=null),i._updateElementGeometry(e,t,n,a),e.pivot()},_updateElementGeometry:function(e,t,n,i){var r=this,o=e._model,a=r._getValueScale(),s=a.getBasePixel(),l=a.isHorizontal(),c=r._ruler||r.getRuler(),u=r.calculateBarValuePixels(r.index,t,i),d=r.calculateBarIndexPixels(r.index,t,c,i);o.horizontal=l,o.base=n?s:u.base,o.x=l?n?s:u.head:d.center,o.y=l?d.center:n?s:u.head,o.height=l?d.size:void 0,o.width=l?void 0:d.size},_getStacks:function(e){var t,n,i=this._getIndexScale(),r=i._getMatchingVisibleMetas(this._type),o=i.options.stacked,a=r.length,s=[];for(t=0;t<a&&(n=r[t],(!1===o||-1===s.indexOf(n.stack)||void 0===o&&void 0===n.stack)&&s.push(n.stack),n.index!==e);++t);return s},getStackCount:function(){return this._getStacks().length},getStackIndex:function(e,t){var n=this._getStacks(e),i=void 0!==t?n.indexOf(t):-1;return-1===i?n.length-1:i},getRuler:function(){var e,t,n=this,i=n._getIndexScale(),r=[];for(e=0,t=n.getMeta().data.length;e<t;++e)r.push(i.getPixelForValue(null,e,n.index));return{pixels:r,start:i._startPixel,end:i._endPixel,stackCount:n.getStackCount(),scale:i}},calculateBarValuePixels:function(e,t,n){var i,r,o,a,s,l,c,u=this,d=u.chart,h=u._getValueScale(),f=h.isHorizontal(),p=d.data.datasets,m=h._getMatchingVisibleMetas(u._type),v=h._parseValue(p[e].data[t]),g=n.minBarLength,_=h.options.stacked,b=u.getMeta().stack,y=void 0===v.start?0:v.max>=0&&v.min>=0?v.min:v.max,w=void 0===v.start?v.end:v.max>=0&&v.min>=0?v.max-v.min:v.min-v.max,k=m.length;if(_||void 0===_&&void 0!==b)for(i=0;i<k&&(r=m[i]).index!==e;++i)r.stack===b&&(o=void 0===(c=h._parseValue(p[r.index].data[t])).start?c.end:c.min>=0&&c.max>=0?c.max:c.min,(v.min<0&&o<0||v.max>=0&&o>0)&&(y+=o));return a=h.getPixelForValue(y),l=(s=h.getPixelForValue(y+w))-a,void 0!==g&&Math.abs(l)<g&&(l=g,s=w>=0&&!f||w<0&&f?a-g:a+g),{size:l,base:a,head:s,center:s+l/2}},calculateBarIndexPixels:function(e,t,n,i){var r="flex"===i.barThickness?function(e,t,n){var i,r=t.pixels,o=r[e],a=e>0?r[e-1]:null,s=e<r.length-1?r[e+1]:null,l=n.categoryPercentage;return null===a&&(a=o-(null===s?t.end-t.start:s-o)),null===s&&(s=o+o-a),i=o-(o-Math.min(a,s))/2*l,{chunk:Math.abs(s-a)/2*l/t.stackCount,ratio:n.barPercentage,start:i}}(t,n,i):Le(t,n,i),o=this.getStackIndex(e,this.getMeta().stack),a=r.start+r.chunk*o+r.chunk/2,s=Math.min(Pe(i.maxBarThickness,1/0),r.chunk*r.ratio);return{base:a-s/2,head:a+s/2,center:a,size:s}},draw:function(){var e=this,t=e.chart,n=e._getValueScale(),i=e.getMeta().data,r=e.getDataset(),o=i.length,a=0;for(V.canvas.clipArea(t.ctx,t.chartArea);a<o;++a){var s=n._parseValue(r.data[a]);isNaN(s.min)||isNaN(s.max)||i[a].draw()}V.canvas.unclipArea(t.ctx)},_resolveDataElementOptions:function(){var e=this,t=V.extend({},re.prototype._resolveDataElementOptions.apply(e,arguments)),n=e._getIndexScale().options,i=e._getValueScale().options;return t.barPercentage=Pe(n.barPercentage,t.barPercentage),t.barThickness=Pe(n.barThickness,t.barThickness),t.categoryPercentage=Pe(n.categoryPercentage,t.categoryPercentage),t.maxBarThickness=Pe(n.maxBarThickness,t.maxBarThickness),t.minBarLength=Pe(i.minBarLength,t.minBarLength),t}}),qe=V.valueOrDefault,Ee=V.options.resolve;j._set("bubble",{hover:{mode:"single"},scales:{xAxes:[{type:"linear",position:"bottom",id:"x-axis-0"}],yAxes:[{type:"linear",position:"left",id:"y-axis-0"}]},tooltips:{callbacks:{title:function(){return""},label:function(e,t){var n=t.datasets[e.datasetIndex].label||"",i=t.datasets[e.datasetIndex].data[e.index];return n+": ("+e.xLabel+", "+e.yLabel+", "+i.r+")"}}}});var De=re.extend({dataElementType:xe.Point,_dataElementOptions:["backgroundColor","borderColor","borderWidth","hoverBackgroundColor","hoverBorderColor","hoverBorderWidth","hoverRadius","hitRadius","pointStyle","rotation"],update:function(e){var t=this,n=t.getMeta().data;V.each(n,(function(n,i){t.updateElement(n,i,e)}))},updateElement:function(e,t,n){var i=this,r=i.getMeta(),o=e.custom||{},a=i.getScaleForId(r.xAxisID),s=i.getScaleForId(r.yAxisID),l=i._resolveDataElementOptions(e,t),c=i.getDataset().data[t],u=i.index,d=n?a.getPixelForDecimal(.5):a.getPixelForValue("object"==typeof c?c:NaN,t,u),h=n?s.getBasePixel():s.getPixelForValue(c,t,u);e._xScale=a,e._yScale=s,e._options=l,e._datasetIndex=u,e._index=t,e._model={backgroundColor:l.backgroundColor,borderColor:l.borderColor,borderWidth:l.borderWidth,hitRadius:l.hitRadius,pointStyle:l.pointStyle,rotation:l.rotation,radius:n?0:l.radius,skip:o.skip||isNaN(d)||isNaN(h),x:d,y:h},e.pivot()},setHoverStyle:function(e){var t=e._model,n=e._options,i=V.getHoverColor;e.$previousStyle={backgroundColor:t.backgroundColor,borderColor:t.borderColor,borderWidth:t.borderWidth,radius:t.radius},t.backgroundColor=qe(n.hoverBackgroundColor,i(n.backgroundColor)),t.borderColor=qe(n.hoverBorderColor,i(n.borderColor)),t.borderWidth=qe(n.hoverBorderWidth,n.borderWidth),t.radius=n.radius+n.hoverRadius},_resolveDataElementOptions:function(e,t){var n=this,i=n.chart,r=n.getDataset(),o=e.custom||{},a=r.data[t]||{},s=re.prototype._resolveDataElementOptions.apply(n,arguments),l={chart:i,dataIndex:t,dataset:r,datasetIndex:n.index};return n._cachedDataOpts===s&&(s=V.extend({},s)),s.radius=Ee([o.radius,a.r,n._config.radius,i.options.elements.point.radius],l,t),s}}),ze=V.valueOrDefault,Ne=Math.PI,je=2*Ne,Re=Ne/2;j._set("doughnut",{animation:{animateRotate:!0,animateScale:!1},hover:{mode:"single"},legendCallback:function(e){var t,n,i,r=document.createElement("ul"),o=e.data,a=o.datasets,s=o.labels;if(r.setAttribute("class",e.id+"-legend"),a.length)for(t=0,n=a[0].data.length;t<n;++t)(i=r.appendChild(document.createElement("li"))).appendChild(document.createElement("span")).style.backgroundColor=a[0].backgroundColor[t],s[t]&&i.appendChild(document.createTextNode(s[t]));return r.outerHTML},legend:{labels:{generateLabels:function(e){var t=e.data;return t.labels.length&&t.datasets.length?t.labels.map((function(n,i){var r=e.getDatasetMeta(0),o=r.controller.getStyle(i);return{text:n,fillStyle:o.backgroundColor,strokeStyle:o.borderColor,lineWidth:o.borderWidth,hidden:isNaN(t.datasets[0].data[i])||r.data[i].hidden,index:i}})):[]}},onClick:function(e,t){var n,i,r,o=t.index,a=this.chart;for(n=0,i=(a.data.datasets||[]).length;n<i;++n)(r=a.getDatasetMeta(n)).data[o]&&(r.data[o].hidden=!r.data[o].hidden);a.update()}},cutoutPercentage:50,rotation:-Re,circumference:je,tooltips:{callbacks:{title:function(){return""},label:function(e,t){var n=t.labels[e.index],i=": "+t.datasets[e.datasetIndex].data[e.index];return V.isArray(n)?(n=n.slice())[0]+=i:n+=i,n}}}});var Ie=re.extend({dataElementType:xe.Arc,linkScales:V.noop,_dataElementOptions:["backgroundColor","borderColor","borderWidth","borderAlign","hoverBackgroundColor","hoverBorderColor","hoverBorderWidth"],getRingIndex:function(e){for(var t=0,n=0;n<e;++n)this.chart.isDatasetVisible(n)&&++t;return t},update:function(e){var t,n,i,r,o=this,a=o.chart,s=a.chartArea,l=a.options,c=1,u=1,d=0,h=0,f=o.getMeta(),p=f.data,m=l.cutoutPercentage/100||0,v=l.circumference,g=o._getRingWeight(o.index);if(v<je){var _=l.rotation%je,b=(_+=_>=Ne?-je:_<-Ne?je:0)+v,y=Math.cos(_),w=Math.sin(_),k=Math.cos(b),x=Math.sin(b),S=_<=0&&b>=0||b>=je,C=_<=Re&&b>=Re||b>=je+Re,M=_<=-Re&&b>=-Re||b>=Ne+Re,T=_===-Ne||b>=Ne?-1:Math.min(y,y*m,k,k*m),A=M?-1:Math.min(w,w*m,x,x*m),P=S?1:Math.max(y,y*m,k,k*m),L=C?1:Math.max(w,w*m,x,x*m);c=(P-T)/2,u=(L-A)/2,d=-(P+T)/2,h=-(L+A)/2}for(i=0,r=p.length;i<r;++i)p[i]._options=o._resolveDataElementOptions(p[i],i);for(a.borderWidth=o.getMaxBorderWidth(),t=(s.right-s.left-a.borderWidth)/c,n=(s.bottom-s.top-a.borderWidth)/u,a.outerRadius=Math.max(Math.min(t,n)/2,0),a.innerRadius=Math.max(a.outerRadius*m,0),a.radiusLength=(a.outerRadius-a.innerRadius)/(o._getVisibleDatasetWeightTotal()||1),a.offsetX=d*a.outerRadius,a.offsetY=h*a.outerRadius,f.total=o.calculateTotal(),o.outerRadius=a.outerRadius-a.radiusLength*o._getRingWeightOffset(o.index),o.innerRadius=Math.max(o.outerRadius-a.radiusLength*g,0),i=0,r=p.length;i<r;++i)o.updateElement(p[i],i,e)},updateElement:function(e,t,n){var i=this,r=i.chart,o=r.chartArea,a=r.options,s=a.animation,l=(o.left+o.right)/2,c=(o.top+o.bottom)/2,u=a.rotation,d=a.rotation,h=i.getDataset(),f=n&&s.animateRotate||e.hidden?0:i.calculateCircumference(h.data[t])*(a.circumference/je),p=n&&s.animateScale?0:i.innerRadius,m=n&&s.animateScale?0:i.outerRadius,v=e._options||{};V.extend(e,{_datasetIndex:i.index,_index:t,_model:{backgroundColor:v.backgroundColor,borderColor:v.borderColor,borderWidth:v.borderWidth,borderAlign:v.borderAlign,x:l+r.offsetX,y:c+r.offsetY,startAngle:u,endAngle:d,circumference:f,outerRadius:m,innerRadius:p,label:V.valueAtIndexOrDefault(h.label,t,r.data.labels[t])}});var g=e._model;n&&s.animateRotate||(g.startAngle=0===t?a.rotation:i.getMeta().data[t-1]._model.endAngle,g.endAngle=g.startAngle+g.circumference),e.pivot()},calculateTotal:function(){var e,t=this.getDataset(),n=this.getMeta(),i=0;return V.each(n.data,(function(n,r){e=t.data[r],isNaN(e)||n.hidden||(i+=Math.abs(e))})),i},calculateCircumference:function(e){var t=this.getMeta().total;return t>0&&!isNaN(e)?je*(Math.abs(e)/t):0},getMaxBorderWidth:function(e){var t,n,i,r,o,a,s,l,c=0,u=this.chart;if(!e)for(t=0,n=u.data.datasets.length;t<n;++t)if(u.isDatasetVisible(t)){e=(i=u.getDatasetMeta(t)).data,t!==this.index&&(o=i.controller);break}if(!e)return 0;for(t=0,n=e.length;t<n;++t)r=e[t],o?(o._configure(),a=o._resolveDataElementOptions(r,t)):a=r._options,"inner"!==a.borderAlign&&(s=a.borderWidth,c=(l=a.hoverBorderWidth)>(c=s>c?s:c)?l:c);return c},setHoverStyle:function(e){var t=e._model,n=e._options,i=V.getHoverColor;e.$previousStyle={backgroundColor:t.backgroundColor,borderColor:t.borderColor,borderWidth:t.borderWidth},t.backgroundColor=ze(n.hoverBackgroundColor,i(n.backgroundColor)),t.borderColor=ze(n.hoverBorderColor,i(n.borderColor)),t.borderWidth=ze(n.hoverBorderWidth,n.borderWidth)},_getRingWeightOffset:function(e){for(var t=0,n=0;n<e;++n)this.chart.isDatasetVisible(n)&&(t+=this._getRingWeight(n));return t},_getRingWeight:function(e){return Math.max(ze(this.chart.data.datasets[e].weight,1),0)},_getVisibleDatasetWeightTotal:function(){return this._getRingWeightOffset(this.chart.data.datasets.length)}});j._set("horizontalBar",{hover:{mode:"index",axis:"y"},scales:{xAxes:[{type:"linear",position:"bottom"}],yAxes:[{type:"category",position:"left",offset:!0,gridLines:{offsetGridLines:!0}}]},elements:{rectangle:{borderSkipped:"left"}},tooltips:{mode:"index",axis:"y"}}),j._set("global",{datasets:{horizontalBar:{categoryPercentage:.8,barPercentage:.9}}});var $e=Oe.extend({_getValueScaleId:function(){return this.getMeta().xAxisID},_getIndexScaleId:function(){return this.getMeta().yAxisID}}),Fe=V.valueOrDefault,Be=V.options.resolve,Ve=V.canvas._isPointInArea;function He(e,t){var n=e&&e.options.ticks||{},i=n.reverse,r=void 0===n.min?t:0,o=void 0===n.max?t:0;return{start:i?o:r,end:i?r:o}}j._set("line",{showLines:!0,spanGaps:!1,hover:{mode:"label"},scales:{xAxes:[{type:"category",id:"x-axis-0"}],yAxes:[{type:"linear",id:"y-axis-0"}]}});var We=re.extend({datasetElementType:xe.Line,dataElementType:xe.Point,_datasetElementOptions:["backgroundColor","borderCapStyle","borderColor","borderDash","borderDashOffset","borderJoinStyle","borderWidth","cubicInterpolationMode","fill"],_dataElementOptions:{backgroundColor:"pointBackgroundColor",borderColor:"pointBorderColor",borderWidth:"pointBorderWidth",hitRadius:"pointHitRadius",hoverBackgroundColor:"pointHoverBackgroundColor",hoverBorderColor:"pointHoverBorderColor",hoverBorderWidth:"pointHoverBorderWidth",hoverRadius:"pointHoverRadius",pointStyle:"pointStyle",radius:"pointRadius",rotation:"pointRotation"},update:function(e){var t,n,i=this,r=i.getMeta(),o=r.dataset,a=r.data||[],s=i.chart.options,l=i._config,c=i._showLine=Fe(l.showLine,s.showLines);for(i._xScale=i.getScaleForId(r.xAxisID),i._yScale=i.getScaleForId(r.yAxisID),c&&(void 0!==l.tension&&void 0===l.lineTension&&(l.lineTension=l.tension),o._scale=i._yScale,o._datasetIndex=i.index,o._children=a,o._model=i._resolveDatasetElementOptions(o),o.pivot()),t=0,n=a.length;t<n;++t)i.updateElement(a[t],t,e);for(c&&0!==o._model.tension&&i.updateBezierControlPoints(),t=0,n=a.length;t<n;++t)a[t].pivot()},updateElement:function(e,t,n){var i,r,o=this,a=o.getMeta(),s=e.custom||{},l=o.getDataset(),c=o.index,u=l.data[t],d=o._xScale,h=o._yScale,f=a.dataset._model,p=o._resolveDataElementOptions(e,t);i=d.getPixelForValue("object"==typeof u?u:NaN,t,c),r=n?h.getBasePixel():o.calculatePointY(u,t,c),e._xScale=d,e._yScale=h,e._options=p,e._datasetIndex=c,e._index=t,e._model={x:i,y:r,skip:s.skip||isNaN(i)||isNaN(r),radius:p.radius,pointStyle:p.pointStyle,rotation:p.rotation,backgroundColor:p.backgroundColor,borderColor:p.borderColor,borderWidth:p.borderWidth,tension:Fe(s.tension,f?f.tension:0),steppedLine:!!f&&f.steppedLine,hitRadius:p.hitRadius}},_resolveDatasetElementOptions:function(e){var t,n,i,r,o,a,s,l,c,u,d,h=this,f=h._config,p=e.custom||{},m=h.chart.options,v=m.elements.line,g=re.prototype._resolveDatasetElementOptions.apply(h,arguments);return g.spanGaps=Fe(f.spanGaps,m.spanGaps),g.tension=Fe(f.lineTension,v.tension),g.steppedLine=Be([p.steppedLine,f.steppedLine,v.stepped]),g.clip=(t=Fe(f.clip,(a=h._xScale,s=h._yScale,l=g.borderWidth,u=He(a,c=l/2),{top:(d=He(s,c)).end,right:u.end,bottom:d.start,left:u.start})),V.isObject(t)?(n=t.top,i=t.right,r=t.bottom,o=t.left):n=i=r=o=t,{top:n,right:i,bottom:r,left:o}),g},calculatePointY:function(e,t,n){var i,r,o,a,s,l,c,u=this.chart,d=this._yScale,h=0,f=0;if(d.options.stacked){for(s=+d.getRightValue(e),c=(l=u._getSortedVisibleDatasetMetas()).length,i=0;i<c&&(o=l[i]).index!==n;++i)r=u.data.datasets[o.index],"line"===o.type&&o.yAxisID===d.id&&((a=+d.getRightValue(r.data[t]))<0?f+=a||0:h+=a||0);return s<0?d.getPixelForValue(f+s):d.getPixelForValue(h+s)}return d.getPixelForValue(e)},updateBezierControlPoints:function(){var e,t,n,i,r=this.chart,o=this.getMeta(),a=o.dataset._model,s=r.chartArea,l=o.data||[];function c(e,t,n){return Math.max(Math.min(e,n),t)}if(a.spanGaps&&(l=l.filter((function(e){return!e._model.skip}))),"monotone"===a.cubicInterpolationMode)V.splineCurveMonotone(l);else for(e=0,t=l.length;e<t;++e)n=l[e]._model,i=V.splineCurve(V.previousItem(l,e)._model,n,V.nextItem(l,e)._model,a.tension),n.controlPointPreviousX=i.previous.x,n.controlPointPreviousY=i.previous.y,n.controlPointNextX=i.next.x,n.controlPointNextY=i.next.y;if(r.options.elements.line.capBezierPoints)for(e=0,t=l.length;e<t;++e)n=l[e]._model,Ve(n,s)&&(e>0&&Ve(l[e-1]._model,s)&&(n.controlPointPreviousX=c(n.controlPointPreviousX,s.left,s.right),n.controlPointPreviousY=c(n.controlPointPreviousY,s.top,s.bottom)),e<l.length-1&&Ve(l[e+1]._model,s)&&(n.controlPointNextX=c(n.controlPointNextX,s.left,s.right),n.controlPointNextY=c(n.controlPointNextY,s.top,s.bottom)))},draw:function(){var e,t=this,n=t.chart,i=t.getMeta(),r=i.data||[],o=n.chartArea,a=n.canvas,s=0,l=r.length;for(t._showLine&&(e=i.dataset._model.clip,V.canvas.clipArea(n.ctx,{left:!1===e.left?0:o.left-e.left,right:!1===e.right?a.width:o.right+e.right,top:!1===e.top?0:o.top-e.top,bottom:!1===e.bottom?a.height:o.bottom+e.bottom}),i.dataset.draw(),V.canvas.unclipArea(n.ctx));s<l;++s)r[s].draw(o)},setHoverStyle:function(e){var t=e._model,n=e._options,i=V.getHoverColor;e.$previousStyle={backgroundColor:t.backgroundColor,borderColor:t.borderColor,borderWidth:t.borderWidth,radius:t.radius},t.backgroundColor=Fe(n.hoverBackgroundColor,i(n.backgroundColor)),t.borderColor=Fe(n.hoverBorderColor,i(n.borderColor)),t.borderWidth=Fe(n.hoverBorderWidth,n.borderWidth),t.radius=Fe(n.hoverRadius,n.radius)}}),Ue=V.options.resolve;j._set("polarArea",{scale:{type:"radialLinear",angleLines:{display:!1},gridLines:{circular:!0},pointLabels:{display:!1},ticks:{beginAtZero:!0}},animation:{animateRotate:!0,animateScale:!0},startAngle:-.5*Math.PI,legendCallback:function(e){var t,n,i,r=document.createElement("ul"),o=e.data,a=o.datasets,s=o.labels;if(r.setAttribute("class",e.id+"-legend"),a.length)for(t=0,n=a[0].data.length;t<n;++t)(i=r.appendChild(document.createElement("li"))).appendChild(document.createElement("span")).style.backgroundColor=a[0].backgroundColor[t],s[t]&&i.appendChild(document.createTextNode(s[t]));return r.outerHTML},legend:{labels:{generateLabels:function(e){var t=e.data;return t.labels.length&&t.datasets.length?t.labels.map((function(n,i){var r=e.getDatasetMeta(0),o=r.controller.getStyle(i);return{text:n,fillStyle:o.backgroundColor,strokeStyle:o.borderColor,lineWidth:o.borderWidth,hidden:isNaN(t.datasets[0].data[i])||r.data[i].hidden,index:i}})):[]}},onClick:function(e,t){var n,i,r,o=t.index,a=this.chart;for(n=0,i=(a.data.datasets||[]).length;n<i;++n)(r=a.getDatasetMeta(n)).data[o].hidden=!r.data[o].hidden;a.update()}},tooltips:{callbacks:{title:function(){return""},label:function(e,t){return t.labels[e.index]+": "+e.yLabel}}}});var Ye=re.extend({dataElementType:xe.Arc,linkScales:V.noop,_dataElementOptions:["backgroundColor","borderColor","borderWidth","borderAlign","hoverBackgroundColor","hoverBorderColor","hoverBorderWidth"],_getIndexScaleId:function(){return this.chart.scale.id},_getValueScaleId:function(){return this.chart.scale.id},update:function(e){var t,n,i,r=this,o=r.getDataset(),a=r.getMeta(),s=r.chart.options.startAngle||0,l=r._starts=[],c=r._angles=[],u=a.data;for(r._updateRadius(),a.count=r.countVisibleElements(),t=0,n=o.data.length;t<n;t++)l[t]=s,i=r._computeAngle(t),c[t]=i,s+=i;for(t=0,n=u.length;t<n;++t)u[t]._options=r._resolveDataElementOptions(u[t],t),r.updateElement(u[t],t,e)},_updateRadius:function(){var e=this,t=e.chart,n=t.chartArea,i=t.options,r=Math.min(n.right-n.left,n.bottom-n.top);t.outerRadius=Math.max(r/2,0),t.innerRadius=Math.max(i.cutoutPercentage?t.outerRadius/100*i.cutoutPercentage:1,0),t.radiusLength=(t.outerRadius-t.innerRadius)/t.getVisibleDatasetCount(),e.outerRadius=t.outerRadius-t.radiusLength*e.index,e.innerRadius=e.outerRadius-t.radiusLength},updateElement:function(e,t,n){var i=this,r=i.chart,o=i.getDataset(),a=r.options,s=a.animation,l=r.scale,c=r.data.labels,u=l.xCenter,d=l.yCenter,h=a.startAngle,f=e.hidden?0:l.getDistanceFromCenterForValue(o.data[t]),p=i._starts[t],m=p+(e.hidden?0:i._angles[t]),v=s.animateScale?0:l.getDistanceFromCenterForValue(o.data[t]),g=e._options||{};V.extend(e,{_datasetIndex:i.index,_index:t,_scale:l,_model:{backgroundColor:g.backgroundColor,borderColor:g.borderColor,borderWidth:g.borderWidth,borderAlign:g.borderAlign,x:u,y:d,innerRadius:0,outerRadius:n?v:f,startAngle:n&&s.animateRotate?h:p,endAngle:n&&s.animateRotate?h:m,label:V.valueAtIndexOrDefault(c,t,c[t])}}),e.pivot()},countVisibleElements:function(){var e=this.getDataset(),t=this.getMeta(),n=0;return V.each(t.data,(function(t,i){isNaN(e.data[i])||t.hidden||n++})),n},setHoverStyle:function(e){var t=e._model,n=e._options,i=V.getHoverColor,r=V.valueOrDefault;e.$previousStyle={backgroundColor:t.backgroundColor,borderColor:t.borderColor,borderWidth:t.borderWidth},t.backgroundColor=r(n.hoverBackgroundColor,i(n.backgroundColor)),t.borderColor=r(n.hoverBorderColor,i(n.borderColor)),t.borderWidth=r(n.hoverBorderWidth,n.borderWidth)},_computeAngle:function(e){var t=this,n=this.getMeta().count,i=t.getDataset(),r=t.getMeta();if(isNaN(i.data[e])||r.data[e].hidden)return 0;var o={chart:t.chart,dataIndex:e,dataset:i,datasetIndex:t.index};return Ue([t.chart.options.elements.arc.angle,2*Math.PI/n],o,e)}});j._set("pie",V.clone(j.doughnut)),j._set("pie",{cutoutPercentage:0});var Ge=Ie,Qe=V.valueOrDefault;j._set("radar",{spanGaps:!1,scale:{type:"radialLinear"},elements:{line:{fill:"start",tension:0}}});var Ke=re.extend({datasetElementType:xe.Line,dataElementType:xe.Point,linkScales:V.noop,_datasetElementOptions:["backgroundColor","borderWidth","borderColor","borderCapStyle","borderDash","borderDashOffset","borderJoinStyle","fill"],_dataElementOptions:{backgroundColor:"pointBackgroundColor",borderColor:"pointBorderColor",borderWidth:"pointBorderWidth",hitRadius:"pointHitRadius",hoverBackgroundColor:"pointHoverBackgroundColor",hoverBorderColor:"pointHoverBorderColor",hoverBorderWidth:"pointHoverBorderWidth",hoverRadius:"pointHoverRadius",pointStyle:"pointStyle",radius:"pointRadius",rotation:"pointRotation"},_getIndexScaleId:function(){return this.chart.scale.id},_getValueScaleId:function(){return this.chart.scale.id},update:function(e){var t,n,i=this,r=i.getMeta(),o=r.dataset,a=r.data||[],s=i.chart.scale,l=i._config;for(void 0!==l.tension&&void 0===l.lineTension&&(l.lineTension=l.tension),o._scale=s,o._datasetIndex=i.index,o._children=a,o._loop=!0,o._model=i._resolveDatasetElementOptions(o),o.pivot(),t=0,n=a.length;t<n;++t)i.updateElement(a[t],t,e);for(i.updateBezierControlPoints(),t=0,n=a.length;t<n;++t)a[t].pivot()},updateElement:function(e,t,n){var i=this,r=e.custom||{},o=i.getDataset(),a=i.chart.scale,s=a.getPointPositionForValue(t,o.data[t]),l=i._resolveDataElementOptions(e,t),c=i.getMeta().dataset._model,u=n?a.xCenter:s.x,d=n?a.yCenter:s.y;e._scale=a,e._options=l,e._datasetIndex=i.index,e._index=t,e._model={x:u,y:d,skip:r.skip||isNaN(u)||isNaN(d),radius:l.radius,pointStyle:l.pointStyle,rotation:l.rotation,backgroundColor:l.backgroundColor,borderColor:l.borderColor,borderWidth:l.borderWidth,tension:Qe(r.tension,c?c.tension:0),hitRadius:l.hitRadius}},_resolveDatasetElementOptions:function(){var e=this,t=e._config,n=e.chart.options,i=re.prototype._resolveDatasetElementOptions.apply(e,arguments);return i.spanGaps=Qe(t.spanGaps,n.spanGaps),i.tension=Qe(t.lineTension,n.elements.line.tension),i},updateBezierControlPoints:function(){var e,t,n,i,r=this.getMeta(),o=this.chart.chartArea,a=r.data||[];function s(e,t,n){return Math.max(Math.min(e,n),t)}for(r.dataset._model.spanGaps&&(a=a.filter((function(e){return!e._model.skip}))),e=0,t=a.length;e<t;++e)n=a[e]._model,i=V.splineCurve(V.previousItem(a,e,!0)._model,n,V.nextItem(a,e,!0)._model,n.tension),n.controlPointPreviousX=s(i.previous.x,o.left,o.right),n.controlPointPreviousY=s(i.previous.y,o.top,o.bottom),n.controlPointNextX=s(i.next.x,o.left,o.right),n.controlPointNextY=s(i.next.y,o.top,o.bottom)},setHoverStyle:function(e){var t=e._model,n=e._options,i=V.getHoverColor;e.$previousStyle={backgroundColor:t.backgroundColor,borderColor:t.borderColor,borderWidth:t.borderWidth,radius:t.radius},t.backgroundColor=Qe(n.hoverBackgroundColor,i(n.backgroundColor)),t.borderColor=Qe(n.hoverBorderColor,i(n.borderColor)),t.borderWidth=Qe(n.hoverBorderWidth,n.borderWidth),t.radius=Qe(n.hoverRadius,n.radius)}});j._set("scatter",{hover:{mode:"single"},scales:{xAxes:[{id:"x-axis-1",type:"linear",position:"bottom"}],yAxes:[{id:"y-axis-1",type:"linear",position:"left"}]},tooltips:{callbacks:{title:function(){return""},label:function(e){return"("+e.xLabel+", "+e.yLabel+")"}}}}),j._set("global",{datasets:{scatter:{showLine:!1}}});var Ze={bar:Oe,bubble:De,doughnut:Ie,horizontalBar:$e,line:We,polarArea:Ye,pie:Ge,radar:Ke,scatter:We};function Je(e,t){return e.native?{x:e.x,y:e.y}:V.getRelativePosition(e,t)}function Xe(e,t){var n,i,r,o,a,s,l=e._getSortedVisibleDatasetMetas();for(i=0,o=l.length;i<o;++i)for(r=0,a=(n=l[i].data).length;r<a;++r)(s=n[r])._view.skip||t(s)}function et(e,t){var n=[];return Xe(e,(function(e){e.inRange(t.x,t.y)&&n.push(e)})),n}function tt(e,t,n,i){var r=Number.POSITIVE_INFINITY,o=[];return Xe(e,(function(e){if(!n||e.inRange(t.x,t.y)){var a=e.getCenterPoint(),s=i(t,a);s<r?(o=[e],r=s):s===r&&o.push(e)}})),o}function nt(e){var t=-1!==e.indexOf("x"),n=-1!==e.indexOf("y");return function(e,i){var r=t?Math.abs(e.x-i.x):0,o=n?Math.abs(e.y-i.y):0;return Math.sqrt(Math.pow(r,2)+Math.pow(o,2))}}function it(e,t,n){var i=Je(t,e);n.axis=n.axis||"x";var r=nt(n.axis),o=n.intersect?et(e,i):tt(e,i,!1,r),a=[];return o.length?(e._getSortedVisibleDatasetMetas().forEach((function(e){var t=e.data[o[0]._index];t&&!t._view.skip&&a.push(t)})),a):[]}var rt={modes:{single:function(e,t){var n=Je(t,e),i=[];return Xe(e,(function(e){if(e.inRange(n.x,n.y))return i.push(e),i})),i.slice(0,1)},label:it,index:it,dataset:function(e,t,n){var i=Je(t,e);n.axis=n.axis||"xy";var r=nt(n.axis),o=n.intersect?et(e,i):tt(e,i,!1,r);return o.length>0&&(o=e.getDatasetMeta(o[0]._datasetIndex).data),o},"x-axis":function(e,t){return it(e,t,{intersect:!1})},point:function(e,t){return et(e,Je(t,e))},nearest:function(e,t,n){var i=Je(t,e);n.axis=n.axis||"xy";var r=nt(n.axis);return tt(e,i,n.intersect,r)},x:function(e,t,n){var i=Je(t,e),r=[],o=!1;return Xe(e,(function(e){e.inXRange(i.x)&&r.push(e),e.inRange(i.x,i.y)&&(o=!0)})),n.intersect&&!o&&(r=[]),r},y:function(e,t,n){var i=Je(t,e),r=[],o=!1;return Xe(e,(function(e){e.inYRange(i.y)&&r.push(e),e.inRange(i.x,i.y)&&(o=!0)})),n.intersect&&!o&&(r=[]),r}}},ot=V.extend;function at(e,t){return V.where(e,(function(e){return e.pos===t}))}function st(e,t){return e.sort((function(e,n){var i=t?n:e,r=t?e:n;return i.weight===r.weight?i.index-r.index:i.weight-r.weight}))}function lt(e,t,n,i){return Math.max(e[n],t[n])+Math.max(e[i],t[i])}function ct(e,t,n){var i,r,o=n.box,a=e.maxPadding;if(n.size&&(e[n.pos]-=n.size),n.size=n.horizontal?o.height:o.width,e[n.pos]+=n.size,o.getPadding){var s=o.getPadding();a.top=Math.max(a.top,s.top),a.left=Math.max(a.left,s.left),a.bottom=Math.max(a.bottom,s.bottom),a.right=Math.max(a.right,s.right)}if(i=t.outerWidth-lt(a,e,"left","right"),r=t.outerHeight-lt(a,e,"top","bottom"),i!==e.w||r!==e.h){e.w=i,e.h=r;var l=n.horizontal?[i,e.w]:[r,e.h];return!(l[0]===l[1]||isNaN(l[0])&&isNaN(l[1]))}}function ut(e,t){var n=t.maxPadding;function i(e){var i={left:0,top:0,right:0,bottom:0};return e.forEach((function(e){i[e]=Math.max(t[e],n[e])})),i}return i(e?["left","right"]:["top","bottom"])}function dt(e,t,n){var i,r,o,a,s,l,c=[];for(i=0,r=e.length;i<r;++i)(a=(o=e[i]).box).update(o.width||t.w,o.height||t.h,ut(o.horizontal,t)),ct(t,n,o)&&(l=!0,c.length&&(s=!0)),a.fullWidth||c.push(o);return s&&dt(c,t,n)||l}function ht(e,t,n){var i,r,o,a,s=n.padding,l=t.x,c=t.y;for(i=0,r=e.length;i<r;++i)a=(o=e[i]).box,o.horizontal?(a.left=a.fullWidth?s.left:t.left,a.right=a.fullWidth?n.outerWidth-s.right:t.left+t.w,a.top=c,a.bottom=c+a.height,a.width=a.right-a.left,c=a.bottom):(a.left=l,a.right=l+a.width,a.top=t.top,a.bottom=t.top+t.h,a.height=a.bottom-a.top,l=a.right);t.x=l,t.y=c}j._set("global",{layout:{padding:{top:0,right:0,bottom:0,left:0}}});var ft,pt={defaults:{},addBox:function(e,t){e.boxes||(e.boxes=[]),t.fullWidth=t.fullWidth||!1,t.position=t.position||"top",t.weight=t.weight||0,t._layers=t._layers||function(){return[{z:0,draw:function(){t.draw.apply(t,arguments)}}]},e.boxes.push(t)},removeBox:function(e,t){var n=e.boxes?e.boxes.indexOf(t):-1;-1!==n&&e.boxes.splice(n,1)},configure:function(e,t,n){for(var i,r=["fullWidth","position","weight"],o=r.length,a=0;a<o;++a)i=r[a],n.hasOwnProperty(i)&&(t[i]=n[i])},update:function(e,t,n){if(e){var i=e.options.layout||{},r=V.options.toPadding(i.padding),o=t-r.width,a=n-r.height,s=function(e){var t=function(e){var t,n,i,r=[];for(t=0,n=(e||[]).length;t<n;++t)i=e[t],r.push({index:t,box:i,pos:i.position,horizontal:i.isHorizontal(),weight:i.weight});return r}(e),n=st(at(t,"left"),!0),i=st(at(t,"right")),r=st(at(t,"top"),!0),o=st(at(t,"bottom"));return{leftAndTop:n.concat(r),rightAndBottom:i.concat(o),chartArea:at(t,"chartArea"),vertical:n.concat(i),horizontal:r.concat(o)}}(e.boxes),l=s.vertical,c=s.horizontal,u=Object.freeze({outerWidth:t,outerHeight:n,padding:r,availableWidth:o,vBoxMaxWidth:o/2/l.length,hBoxMaxHeight:a/2}),d=ot({maxPadding:ot({},r),w:o,h:a,x:r.left,y:r.top},r);!function(e,t){var n,i,r;for(n=0,i=e.length;n<i;++n)(r=e[n]).width=r.horizontal?r.box.fullWidth&&t.availableWidth:t.vBoxMaxWidth,r.height=r.horizontal&&t.hBoxMaxHeight}(l.concat(c),u),dt(l,d,u),dt(c,d,u)&&dt(l,d,u),function(e){var t=e.maxPadding;function n(n){var i=Math.max(t[n]-e[n],0);return e[n]+=i,i}e.y+=n("top"),e.x+=n("left"),n("right"),n("bottom")}(d),ht(s.leftAndTop,d,u),d.x+=d.w,d.y+=d.h,ht(s.rightAndBottom,d,u),e.chartArea={left:d.left,top:d.top,right:d.left+d.w,bottom:d.top+d.h},V.each(s.chartArea,(function(t){var n=t.box;ot(n,e.chartArea),n.update(d.w,d.h)}))}}},mt=(ft=Object.freeze({__proto__:null,default:"/*\r\n * DOM element rendering detection\r\n * https://davidwalsh.name/detect-node-insertion\r\n */\r\n@keyframes chartjs-render-animation {\r\n\tfrom { opacity: 0.99; }\r\n\tto { opacity: 1; }\r\n}\r\n\r\n.chartjs-render-monitor {\r\n\tanimation: chartjs-render-animation 0.001s;\r\n}\r\n\r\n/*\r\n * DOM element resizing detection\r\n * https://github.com/marcj/css-element-queries\r\n */\r\n.chartjs-size-monitor,\r\n.chartjs-size-monitor-expand,\r\n.chartjs-size-monitor-shrink {\r\n\tposition: absolute;\r\n\tdirection: ltr;\r\n\tleft: 0;\r\n\ttop: 0;\r\n\tright: 0;\r\n\tbottom: 0;\r\n\toverflow: hidden;\r\n\tpointer-events: none;\r\n\tvisibility: hidden;\r\n\tz-index: -1;\r\n}\r\n\r\n.chartjs-size-monitor-expand > div {\r\n\tposition: absolute;\r\n\twidth: 1000000px;\r\n\theight: 1000000px;\r\n\tleft: 0;\r\n\ttop: 0;\r\n}\r\n\r\n.chartjs-size-monitor-shrink > div {\r\n\tposition: absolute;\r\n\twidth: 200%;\r\n\theight: 200%;\r\n\tleft: 0;\r\n\ttop: 0;\r\n}\r\n"}))&&ft.default||ft,vt="$chartjs",gt="chartjs-",_t=gt+"size-monitor",bt=gt+"render-monitor",yt=gt+"render-animation",wt=["animationstart","webkitAnimationStart"],kt={touchstart:"mousedown",touchmove:"mousemove",touchend:"mouseup",pointerenter:"mouseenter",pointerdown:"mousedown",pointermove:"mousemove",pointerup:"mouseup",pointerleave:"mouseout",pointerout:"mouseout"};function xt(e,t){var n=V.getStyle(e,t),i=n&&n.match(/^(\d+)(\.\d+)?px$/);return i?Number(i[1]):void 0}var St=function(){var e=!1;try{var t=Object.defineProperty({},"passive",{get:function(){e=!0}});window.addEventListener("e",null,t)}catch(e){}return e}(),Ct=!!St&&{passive:!0};function Mt(e,t,n){e.addEventListener(t,n,Ct)}function Tt(e,t,n){e.removeEventListener(t,n,Ct)}function At(e,t,n,i,r){return{type:e,chart:t,native:r||null,x:void 0!==n?n:null,y:void 0!==i?i:null}}function Pt(e){var t=document.createElement("div");return t.className=e||"",t}function Lt(e,t,n){var i,r,o,a,s=e[vt]||(e[vt]={}),l=s.resizer=function(e){var t=1e6,n=Pt(_t),i=Pt(_t+"-expand"),r=Pt(_t+"-shrink");i.appendChild(Pt()),r.appendChild(Pt()),n.appendChild(i),n.appendChild(r),n._reset=function(){i.scrollLeft=t,i.scrollTop=t,r.scrollLeft=t,r.scrollTop=t};var o=function(){n._reset(),e()};return Mt(i,"scroll",o.bind(i,"expand")),Mt(r,"scroll",o.bind(r,"shrink")),n}((i=function(){if(s.resizer){var i=n.options.maintainAspectRatio&&e.parentNode,r=i?i.clientWidth:0;t(At("resize",n)),i&&i.clientWidth<r&&n.canvas&&t(At("resize",n))}},o=!1,a=[],function(){a=Array.prototype.slice.call(arguments),r=r||this,o||(o=!0,V.requestAnimFrame.call(window,(function(){o=!1,i.apply(r,a)})))}));!function(e,t){var n=e[vt]||(e[vt]={}),i=n.renderProxy=function(e){e.animationName===yt&&t()};V.each(wt,(function(t){Mt(e,t,i)})),n.reflow=!!e.offsetParent,e.classList.add(bt)}(e,(function(){if(s.resizer){var t=e.parentNode;t&&t!==l.parentNode&&t.insertBefore(l,t.firstChild),l._reset()}}))}function Ot(e){var t=e[vt]||{},n=t.resizer;delete t.resizer,function(e){var t=e[vt]||{},n=t.renderProxy;n&&(V.each(wt,(function(t){Tt(e,t,n)})),delete t.renderProxy),e.classList.remove(bt)}(e),n&&n.parentNode&&n.parentNode.removeChild(n)}var qt={disableCSSInjection:!1,_enabled:"undefined"!=typeof window&&"undefined"!=typeof document,_ensureLoaded:function(e){if(!this.disableCSSInjection){var t=e.getRootNode?e.getRootNode():document;!function(e,t){var n=e[vt]||(e[vt]={});if(!n.containsStyles){n.containsStyles=!0,t="/* Chart.js */\n"+t;var i=document.createElement("style");i.setAttribute("type","text/css"),i.appendChild(document.createTextNode(t)),e.appendChild(i)}}(t.host?t:document.head,mt)}},acquireContext:function(e,t){"string"==typeof e?e=document.getElementById(e):e.length&&(e=e[0]),e&&e.canvas&&(e=e.canvas);var n=e&&e.getContext&&e.getContext("2d");return n&&n.canvas===e?(this._ensureLoaded(e),function(e,t){var n=e.style,i=e.getAttribute("height"),r=e.getAttribute("width");if(e[vt]={initial:{height:i,width:r,style:{display:n.display,height:n.height,width:n.width}}},n.display=n.display||"block",null===r||""===r){var o=xt(e,"width");void 0!==o&&(e.width=o)}if(null===i||""===i)if(""===e.style.height)e.height=e.width/(t.options.aspectRatio||2);else{var a=xt(e,"height");void 0!==o&&(e.height=a)}}(e,t),n):null},releaseContext:function(e){var t=e.canvas;if(t[vt]){var n=t[vt].initial;["height","width"].forEach((function(e){var i=n[e];V.isNullOrUndef(i)?t.removeAttribute(e):t.setAttribute(e,i)})),V.each(n.style||{},(function(e,n){t.style[n]=e})),t.width=t.width,delete t[vt]}},addEventListener:function(e,t,n){var i=e.canvas;if("resize"!==t){var r=n[vt]||(n[vt]={}),o=(r.proxies||(r.proxies={}))[e.id+"_"+t]=function(t){n(function(e,t){var n=kt[e.type]||e.type,i=V.getRelativePosition(e,t);return At(n,t,i.x,i.y,e)}(t,e))};Mt(i,t,o)}else Lt(i,n,e)},removeEventListener:function(e,t,n){var i=e.canvas;if("resize"!==t){var r=((n[vt]||{}).proxies||{})[e.id+"_"+t];r&&Tt(i,t,r)}else Ot(i)}};V.addEvent=Mt,V.removeEvent=Tt;var Et=qt._enabled?qt:{acquireContext:function(e){return e&&e.canvas&&(e=e.canvas),e&&e.getContext("2d")||null}},Dt=V.extend({initialize:function(){},acquireContext:function(){},releaseContext:function(){},addEventListener:function(){},removeEventListener:function(){}},Et);j._set("global",{plugins:{}});var zt={_plugins:[],_cacheId:0,register:function(e){var t=this._plugins;[].concat(e).forEach((function(e){-1===t.indexOf(e)&&t.push(e)})),this._cacheId++},unregister:function(e){var t=this._plugins;[].concat(e).forEach((function(e){var n=t.indexOf(e);-1!==n&&t.splice(n,1)})),this._cacheId++},clear:function(){this._plugins=[],this._cacheId++},count:function(){return this._plugins.length},getAll:function(){return this._plugins},notify:function(e,t,n){var i,r,o,a,s,l=this.descriptors(e),c=l.length;for(i=0;i<c;++i)if("function"==typeof(s=(o=(r=l[i]).plugin)[t])&&((a=[e].concat(n||[])).push(r.options),!1===s.apply(o,a)))return!1;return!0},descriptors:function(e){var t=e.$plugins||(e.$plugins={});if(t.id===this._cacheId)return t.descriptors;var n=[],i=[],r=e&&e.config||{},o=r.options&&r.options.plugins||{};return this._plugins.concat(r.plugins||[]).forEach((function(e){if(-1===n.indexOf(e)){var t=e.id,r=o[t];!1!==r&&(!0===r&&(r=V.clone(j.global.plugins[t])),n.push(e),i.push({plugin:e,options:r||{}}))}})),t.descriptors=i,t.id=this._cacheId,i},_invalidate:function(e){delete e.$plugins}},Nt={constructors:{},defaults:{},registerScaleType:function(e,t,n){this.constructors[e]=t,this.defaults[e]=V.clone(n)},getScaleConstructor:function(e){return this.constructors.hasOwnProperty(e)?this.constructors[e]:void 0},getScaleDefaults:function(e){return this.defaults.hasOwnProperty(e)?V.merge(Object.create(null),[j.scale,this.defaults[e]]):{}},updateScaleDefaults:function(e,t){var n=this;n.defaults.hasOwnProperty(e)&&(n.defaults[e]=V.extend(n.defaults[e],t))},addScalesToLayout:function(e){V.each(e.scales,(function(t){t.fullWidth=t.options.fullWidth,t.position=t.options.position,t.weight=t.options.weight,pt.addBox(e,t)}))}},jt=V.valueOrDefault,Rt=V.rtl.getRtlAdapter;j._set("global",{tooltips:{enabled:!0,custom:null,mode:"nearest",position:"average",intersect:!0,backgroundColor:"rgba(0,0,0,0.8)",titleFontStyle:"bold",titleSpacing:2,titleMarginBottom:6,titleFontColor:"#fff",titleAlign:"left",bodySpacing:2,bodyFontColor:"#fff",bodyAlign:"left",footerFontStyle:"bold",footerSpacing:2,footerMarginTop:6,footerFontColor:"#fff",footerAlign:"left",yPadding:6,xPadding:6,caretPadding:2,caretSize:5,cornerRadius:6,multiKeyBackground:"#fff",displayColors:!0,borderColor:"rgba(0,0,0,0)",borderWidth:0,callbacks:{beforeTitle:V.noop,title:function(e,t){var n="",i=t.labels,r=i?i.length:0;if(e.length>0){var o=e[0];o.label?n=o.label:o.xLabel?n=o.xLabel:r>0&&o.index<r&&(n=i[o.index])}return n},afterTitle:V.noop,beforeBody:V.noop,beforeLabel:V.noop,label:function(e,t){var n=t.datasets[e.datasetIndex].label||"";return n&&(n+=": "),V.isNullOrUndef(e.value)?n+=e.yLabel:n+=e.value,n},labelColor:function(e,t){var n=t.getDatasetMeta(e.datasetIndex).data[e.index]._view;return{borderColor:n.borderColor,backgroundColor:n.backgroundColor}},labelTextColor:function(){return this._options.bodyFontColor},afterLabel:V.noop,afterBody:V.noop,beforeFooter:V.noop,footer:V.noop,afterFooter:V.noop}}});var It={average:function(e){if(!e.length)return!1;var t,n,i=0,r=0,o=0;for(t=0,n=e.length;t<n;++t){var a=e[t];if(a&&a.hasValue()){var s=a.tooltipPosition();i+=s.x,r+=s.y,++o}}return{x:i/o,y:r/o}},nearest:function(e,t){var n,i,r,o=t.x,a=t.y,s=Number.POSITIVE_INFINITY;for(n=0,i=e.length;n<i;++n){var l=e[n];if(l&&l.hasValue()){var c=l.getCenterPoint(),u=V.distanceBetweenPoints(t,c);u<s&&(s=u,r=l)}}if(r){var d=r.tooltipPosition();o=d.x,a=d.y}return{x:o,y:a}}};function $t(e,t){return t&&(V.isArray(t)?Array.prototype.push.apply(e,t):e.push(t)),e}function Ft(e){return("string"==typeof e||e instanceof String)&&e.indexOf("\n")>-1?e.split("\n"):e}function Bt(e){var t=j.global;return{xPadding:e.xPadding,yPadding:e.yPadding,xAlign:e.xAlign,yAlign:e.yAlign,rtl:e.rtl,textDirection:e.textDirection,bodyFontColor:e.bodyFontColor,_bodyFontFamily:jt(e.bodyFontFamily,t.defaultFontFamily),_bodyFontStyle:jt(e.bodyFontStyle,t.defaultFontStyle),_bodyAlign:e.bodyAlign,bodyFontSize:jt(e.bodyFontSize,t.defaultFontSize),bodySpacing:e.bodySpacing,titleFontColor:e.titleFontColor,_titleFontFamily:jt(e.titleFontFamily,t.defaultFontFamily),_titleFontStyle:jt(e.titleFontStyle,t.defaultFontStyle),titleFontSize:jt(e.titleFontSize,t.defaultFontSize),_titleAlign:e.titleAlign,titleSpacing:e.titleSpacing,titleMarginBottom:e.titleMarginBottom,footerFontColor:e.footerFontColor,_footerFontFamily:jt(e.footerFontFamily,t.defaultFontFamily),_footerFontStyle:jt(e.footerFontStyle,t.defaultFontStyle),footerFontSize:jt(e.footerFontSize,t.defaultFontSize),_footerAlign:e.footerAlign,footerSpacing:e.footerSpacing,footerMarginTop:e.footerMarginTop,caretSize:e.caretSize,cornerRadius:e.cornerRadius,backgroundColor:e.backgroundColor,opacity:0,legendColorBackground:e.multiKeyBackground,displayColors:e.displayColors,borderColor:e.borderColor,borderWidth:e.borderWidth}}function Vt(e,t){return"center"===t?e.x+e.width/2:"right"===t?e.x+e.width-e.xPadding:e.x+e.xPadding}function Ht(e){return $t([],Ft(e))}var Wt=K.extend({initialize:function(){this._model=Bt(this._options),this._lastActive=[]},getTitle:function(){var e=this,t=e._options.callbacks,n=t.beforeTitle.apply(e,arguments),i=t.title.apply(e,arguments),r=t.afterTitle.apply(e,arguments),o=[];return o=$t(o,Ft(n)),o=$t(o,Ft(i)),o=$t(o,Ft(r))},getBeforeBody:function(){return Ht(this._options.callbacks.beforeBody.apply(this,arguments))},getBody:function(e,t){var n=this,i=n._options.callbacks,r=[];return V.each(e,(function(e){var o={before:[],lines:[],after:[]};$t(o.before,Ft(i.beforeLabel.call(n,e,t))),$t(o.lines,i.label.call(n,e,t)),$t(o.after,Ft(i.afterLabel.call(n,e,t))),r.push(o)})),r},getAfterBody:function(){return Ht(this._options.callbacks.afterBody.apply(this,arguments))},getFooter:function(){var e=this,t=e._options.callbacks,n=t.beforeFooter.apply(e,arguments),i=t.footer.apply(e,arguments),r=t.afterFooter.apply(e,arguments),o=[];return o=$t(o,Ft(n)),o=$t(o,Ft(i)),o=$t(o,Ft(r))},update:function(e){var t,n,i,r,o,a,s,l,c,u,d=this,h=d._options,f=d._model,p=d._model=Bt(h),m=d._active,v=d._data,g={xAlign:f.xAlign,yAlign:f.yAlign},_={x:f.x,y:f.y},b={width:f.width,height:f.height},y={x:f.caretX,y:f.caretY};if(m.length){p.opacity=1;var w=[],k=[];y=It[h.position].call(d,m,d._eventPosition);var x=[];for(t=0,n=m.length;t<n;++t)x.push((i=m[t],r=void 0,o=void 0,a=void 0,s=void 0,l=void 0,c=void 0,u=void 0,r=i._xScale,o=i._yScale||i._scale,a=i._index,s=i._datasetIndex,l=i._chart.getDatasetMeta(s).controller,c=l._getIndexScale(),u=l._getValueScale(),{xLabel:r?r.getLabelForIndex(a,s):"",yLabel:o?o.getLabelForIndex(a,s):"",label:c?""+c.getLabelForIndex(a,s):"",value:u?""+u.getLabelForIndex(a,s):"",index:a,datasetIndex:s,x:i._model.x,y:i._model.y}));h.filter&&(x=x.filter((function(e){return h.filter(e,v)}))),h.itemSort&&(x=x.sort((function(e,t){return h.itemSort(e,t,v)}))),V.each(x,(function(e){w.push(h.callbacks.labelColor.call(d,e,d._chart)),k.push(h.callbacks.labelTextColor.call(d,e,d._chart))})),p.title=d.getTitle(x,v),p.beforeBody=d.getBeforeBody(x,v),p.body=d.getBody(x,v),p.afterBody=d.getAfterBody(x,v),p.footer=d.getFooter(x,v),p.x=y.x,p.y=y.y,p.caretPadding=h.caretPadding,p.labelColors=w,p.labelTextColors=k,p.dataPoints=x,b=function(e,t){var n=e._chart.ctx,i=2*t.yPadding,r=0,o=t.body,a=o.reduce((function(e,t){return e+t.before.length+t.lines.length+t.after.length}),0);a+=t.beforeBody.length+t.afterBody.length;var s=t.title.length,l=t.footer.length,c=t.titleFontSize,u=t.bodyFontSize,d=t.footerFontSize;i+=s*c,i+=s?(s-1)*t.titleSpacing:0,i+=s?t.titleMarginBottom:0,i+=a*u,i+=a?(a-1)*t.bodySpacing:0,i+=l?t.footerMarginTop:0,i+=l*d,i+=l?(l-1)*t.footerSpacing:0;var h=0,f=function(e){r=Math.max(r,n.measureText(e).width+h)};return n.font=V.fontString(c,t._titleFontStyle,t._titleFontFamily),V.each(t.title,f),n.font=V.fontString(u,t._bodyFontStyle,t._bodyFontFamily),V.each(t.beforeBody.concat(t.afterBody),f),h=t.displayColors?u+2:0,V.each(o,(function(e){V.each(e.before,f),V.each(e.lines,f),V.each(e.after,f)})),h=0,n.font=V.fontString(d,t._footerFontStyle,t._footerFontFamily),V.each(t.footer,f),{width:r+=2*t.xPadding,height:i}}(this,p),g=function(e,t){var n,i,r,o,a,s=e._model,l=e._chart,c=e._chart.chartArea,u="center",d="center";s.y<t.height?d="top":s.y>l.height-t.height&&(d="bottom");var h=(c.left+c.right)/2,f=(c.top+c.bottom)/2;"center"===d?(n=function(e){return e<=h},i=function(e){return e>h}):(n=function(e){return e<=t.width/2},i=function(e){return e>=l.width-t.width/2}),r=function(e){return e+t.width+s.caretSize+s.caretPadding>l.width},o=function(e){return e-t.width-s.caretSize-s.caretPadding<0},a=function(e){return e<=f?"top":"bottom"},n(s.x)?(u="left",r(s.x)&&(u="center",d=a(s.y))):i(s.x)&&(u="right",o(s.x)&&(u="center",d=a(s.y)));var p=e._options;return{xAlign:p.xAlign?p.xAlign:u,yAlign:p.yAlign?p.yAlign:d}}(this,b),_=function(e,t,n,i){var r=e.x,o=e.y,a=e.caretSize,s=e.caretPadding,l=e.cornerRadius,c=n.xAlign,u=n.yAlign,d=a+s,h=l+s;return"right"===c?r-=t.width:"center"===c&&((r-=t.width/2)+t.width>i.width&&(r=i.width-t.width),r<0&&(r=0)),"top"===u?o+=d:o-="bottom"===u?t.height+d:t.height/2,"center"===u?"left"===c?r+=d:"right"===c&&(r-=d):"left"===c?r-=h:"right"===c&&(r+=h),{x:r,y:o}}(p,b,g,d._chart)}else p.opacity=0;return p.xAlign=g.xAlign,p.yAlign=g.yAlign,p.x=_.x,p.y=_.y,p.width=b.width,p.height=b.height,p.caretX=y.x,p.caretY=y.y,d._model=p,e&&h.custom&&h.custom.call(d,p),d},drawCaret:function(e,t){var n=this._chart.ctx,i=this._view,r=this.getCaretPosition(e,t,i);n.lineTo(r.x1,r.y1),n.lineTo(r.x2,r.y2),n.lineTo(r.x3,r.y3)},getCaretPosition:function(e,t,n){var i,r,o,a,s,l,c=n.caretSize,u=n.cornerRadius,d=n.xAlign,h=n.yAlign,f=e.x,p=e.y,m=t.width,v=t.height;if("center"===h)s=p+v/2,"left"===d?(r=(i=f)-c,o=i,a=s+c,l=s-c):(r=(i=f+m)+c,o=i,a=s-c,l=s+c);else if("left"===d?(i=(r=f+u+c)-c,o=r+c):"right"===d?(i=(r=f+m-u-c)-c,o=r+c):(i=(r=n.caretX)-c,o=r+c),"top"===h)s=(a=p)-c,l=a;else{s=(a=p+v)+c,l=a;var g=o;o=i,i=g}return{x1:i,x2:r,x3:o,y1:a,y2:s,y3:l}},drawTitle:function(e,t,n){var i,r,o,a=t.title,s=a.length;if(s){var l=Rt(t.rtl,t.x,t.width);for(e.x=Vt(t,t._titleAlign),n.textAlign=l.textAlign(t._titleAlign),n.textBaseline="middle",i=t.titleFontSize,r=t.titleSpacing,n.fillStyle=t.titleFontColor,n.font=V.fontString(i,t._titleFontStyle,t._titleFontFamily),o=0;o<s;++o)n.fillText(a[o],l.x(e.x),e.y+i/2),e.y+=i+r,o+1===s&&(e.y+=t.titleMarginBottom-r)}},drawBody:function(e,t,n){var i,r,o,a,s,l,c,u,d=t.bodyFontSize,h=t.bodySpacing,f=t._bodyAlign,p=t.body,m=t.displayColors,v=0,g=m?Vt(t,"left"):0,_=Rt(t.rtl,t.x,t.width),b=function(t){n.fillText(t,_.x(e.x+v),e.y+d/2),e.y+=d+h},y=_.textAlign(f);for(n.textAlign=f,n.textBaseline="middle",n.font=V.fontString(d,t._bodyFontStyle,t._bodyFontFamily),e.x=Vt(t,y),n.fillStyle=t.bodyFontColor,V.each(t.beforeBody,b),v=m&&"right"!==y?"center"===f?d/2+1:d+2:0,s=0,c=p.length;s<c;++s){for(i=p[s],r=t.labelTextColors[s],o=t.labelColors[s],n.fillStyle=r,V.each(i.before,b),l=0,u=(a=i.lines).length;l<u;++l){if(m){var w=_.x(g);n.fillStyle=t.legendColorBackground,n.fillRect(_.leftForLtr(w,d),e.y,d,d),n.lineWidth=1,n.strokeStyle=o.borderColor,n.strokeRect(_.leftForLtr(w,d),e.y,d,d),n.fillStyle=o.backgroundColor,n.fillRect(_.leftForLtr(_.xPlus(w,1),d-2),e.y+1,d-2,d-2),n.fillStyle=r}b(a[l])}V.each(i.after,b)}v=0,V.each(t.afterBody,b),e.y-=h},drawFooter:function(e,t,n){var i,r,o=t.footer,a=o.length;if(a){var s=Rt(t.rtl,t.x,t.width);for(e.x=Vt(t,t._footerAlign),e.y+=t.footerMarginTop,n.textAlign=s.textAlign(t._footerAlign),n.textBaseline="middle",i=t.footerFontSize,n.fillStyle=t.footerFontColor,n.font=V.fontString(i,t._footerFontStyle,t._footerFontFamily),r=0;r<a;++r)n.fillText(o[r],s.x(e.x),e.y+i/2),e.y+=i+t.footerSpacing}},drawBackground:function(e,t,n,i){n.fillStyle=t.backgroundColor,n.strokeStyle=t.borderColor,n.lineWidth=t.borderWidth;var r=t.xAlign,o=t.yAlign,a=e.x,s=e.y,l=i.width,c=i.height,u=t.cornerRadius;n.beginPath(),n.moveTo(a+u,s),"top"===o&&this.drawCaret(e,i),n.lineTo(a+l-u,s),n.quadraticCurveTo(a+l,s,a+l,s+u),"center"===o&&"right"===r&&this.drawCaret(e,i),n.lineTo(a+l,s+c-u),n.quadraticCurveTo(a+l,s+c,a+l-u,s+c),"bottom"===o&&this.drawCaret(e,i),n.lineTo(a+u,s+c),n.quadraticCurveTo(a,s+c,a,s+c-u),"center"===o&&"left"===r&&this.drawCaret(e,i),n.lineTo(a,s+u),n.quadraticCurveTo(a,s,a+u,s),n.closePath(),n.fill(),t.borderWidth>0&&n.stroke()},draw:function(){var e=this._chart.ctx,t=this._view;if(0!==t.opacity){var n={width:t.width,height:t.height},i={x:t.x,y:t.y},r=Math.abs(t.opacity<.001)?0:t.opacity,o=t.title.length||t.beforeBody.length||t.body.length||t.afterBody.length||t.footer.length;this._options.enabled&&o&&(e.save(),e.globalAlpha=r,this.drawBackground(i,t,e,n),i.y+=t.yPadding,V.rtl.overrideTextDirection(e,t.textDirection),this.drawTitle(i,t,e),this.drawBody(i,t,e),this.drawFooter(i,t,e),V.rtl.restoreTextDirection(e,t.textDirection),e.restore())}},handleEvent:function(e){var t,n=this,i=n._options;return n._lastActive=n._lastActive||[],"mouseout"===e.type?n._active=[]:(n._active=n._chart.getElementsAtEventForMode(e,i.mode,i),i.reverse&&n._active.reverse()),(t=!V.arrayEquals(n._active,n._lastActive))&&(n._lastActive=n._active,(i.enabled||i.custom)&&(n._eventPosition={x:e.x,y:e.y},n.update(!0),n.pivot())),t}}),Ut=It,Yt=Wt;Yt.positioners=Ut;var Gt=V.valueOrDefault;function Qt(){return V.merge(Object.create(null),[].slice.call(arguments),{merger:function(e,t,n,i){if("xAxes"===e||"yAxes"===e){var r,o,a,s=n[e].length;for(t[e]||(t[e]=[]),r=0;r<s;++r)a=n[e][r],o=Gt(a.type,"xAxes"===e?"category":"linear"),r>=t[e].length&&t[e].push({}),!t[e][r].type||a.type&&a.type!==t[e][r].type?V.merge(t[e][r],[Nt.getScaleDefaults(o),a]):V.merge(t[e][r],a)}else V._merger(e,t,n,i)}})}function Kt(){return V.merge(Object.create(null),[].slice.call(arguments),{merger:function(e,t,n,i){var r=t[e]||Object.create(null),o=n[e];"scales"===e?t[e]=Qt(r,o):"scale"===e?t[e]=V.merge(r,[Nt.getScaleDefaults(o.type),o]):V._merger(e,t,n,i)}})}function Zt(e,t,n){var i,r=function(e){return e.id===i};do{i=t+n++}while(V.findIndex(e,r)>=0);return i}function Jt(e){return"top"===e||"bottom"===e}function Xt(e,t){return function(n,i){return n[e]===i[e]?n[t]-i[t]:n[e]-i[e]}}j._set("global",{elements:{},events:["mousemove","mouseout","click","touchstart","touchmove"],hover:{onHover:null,mode:"nearest",intersect:!0,animationDuration:400},onClick:null,maintainAspectRatio:!0,responsive:!0,responsiveAnimationDuration:0});var en=function(e,t){return this.construct(e,t),this};V.extend(en.prototype,{construct:function(e,t){var n=this;t=function(e){var t=(e=e||Object.create(null)).data=e.data||{};return t.datasets=t.datasets||[],t.labels=t.labels||[],e.options=Kt(j.global,j[e.type],e.options||{}),e}(t);var i=Dt.acquireContext(e,t),r=i&&i.canvas,o=r&&r.height,a=r&&r.width;n.id=V.uid(),n.ctx=i,n.canvas=r,n.config=t,n.width=a,n.height=o,n.aspectRatio=o?a/o:null,n.options=t.options,n._bufferedRender=!1,n._layers=[],n.chart=n,n.controller=n,en.instances[n.id]=n,Object.defineProperty(n,"data",{get:function(){return n.config.data},set:function(e){n.config.data=e}}),i&&r?(n.initialize(),n.update()):console.error("Failed to create chart: can't acquire context from the given item")},initialize:function(){var e=this;return zt.notify(e,"beforeInit"),V.retinaScale(e,e.options.devicePixelRatio),e.bindEvents(),e.options.responsive&&e.resize(!0),e.initToolTip(),zt.notify(e,"afterInit"),e},clear:function(){return V.canvas.clear(this),this},stop:function(){return X.cancelAnimation(this),this},resize:function(e){var t=this,n=t.options,i=t.canvas,r=n.maintainAspectRatio&&t.aspectRatio||null,o=Math.max(0,Math.floor(V.getMaximumWidth(i))),a=Math.max(0,Math.floor(r?o/r:V.getMaximumHeight(i)));if((t.width!==o||t.height!==a)&&(i.width=t.width=o,i.height=t.height=a,i.style.width=o+"px",i.style.height=a+"px",V.retinaScale(t,n.devicePixelRatio),!e)){var s={width:o,height:a};zt.notify(t,"resize",[s]),n.onResize&&n.onResize(t,s),t.stop(),t.update({duration:n.responsiveAnimationDuration})}},ensureScalesHaveIDs:function(){var e=this.options,t=e.scales||{},n=e.scale;V.each(t.xAxes,(function(e,n){e.id||(e.id=Zt(t.xAxes,"x-axis-",n))})),V.each(t.yAxes,(function(e,n){e.id||(e.id=Zt(t.yAxes,"y-axis-",n))})),n&&(n.id=n.id||"scale")},buildOrUpdateScales:function(){var e=this,t=e.options,n=e.scales||{},i=[],r=Object.keys(n).reduce((function(e,t){return e[t]=!1,e}),{});t.scales&&(i=i.concat((t.scales.xAxes||[]).map((function(e){return{options:e,dtype:"category",dposition:"bottom"}})),(t.scales.yAxes||[]).map((function(e){return{options:e,dtype:"linear",dposition:"left"}})))),t.scale&&i.push({options:t.scale,dtype:"radialLinear",isDefault:!0,dposition:"chartArea"}),V.each(i,(function(t){var i=t.options,o=i.id,a=Gt(i.type,t.dtype);Jt(i.position)!==Jt(t.dposition)&&(i.position=t.dposition),r[o]=!0;var s=null;if(o in n&&n[o].type===a)(s=n[o]).options=i,s.ctx=e.ctx,s.chart=e;else{var l=Nt.getScaleConstructor(a);if(!l)return;s=new l({id:o,type:a,options:i,ctx:e.ctx,chart:e}),n[s.id]=s}s.mergeTicksOptions(),t.isDefault&&(e.scale=s)})),V.each(r,(function(e,t){e||delete n[t]})),e.scales=n,Nt.addScalesToLayout(this)},buildOrUpdateControllers:function(){var e,t,n=this,i=[],r=n.data.datasets;for(e=0,t=r.length;e<t;e++){var o=r[e],a=n.getDatasetMeta(e),s=o.type||n.config.type;if(a.type&&a.type!==s&&(n.destroyDatasetMeta(e),a=n.getDatasetMeta(e)),a.type=s,a.order=o.order||0,a.index=e,a.controller)a.controller.updateIndex(e),a.controller.linkScales();else{var l=Ze[a.type];if(void 0===l)throw new Error('"'+a.type+'" is not a chart type.');a.controller=new l(n,e),i.push(a.controller)}}return i},resetElements:function(){var e=this;V.each(e.data.datasets,(function(t,n){e.getDatasetMeta(n).controller.reset()}),e)},reset:function(){this.resetElements(),this.tooltip.initialize()},update:function(e){var t,n,i,r,o=this;if(e&&"object"==typeof e||(e={duration:e,lazy:arguments[1]}),r=(i=o).options,V.each(i.scales,(function(e){pt.removeBox(i,e)})),r=Kt(j.global,j[i.config.type],r),i.options=i.config.options=r,i.ensureScalesHaveIDs(),i.buildOrUpdateScales(),i.tooltip._options=r.tooltips,i.tooltip.initialize(),zt._invalidate(o),!1!==zt.notify(o,"beforeUpdate")){o.tooltip._data=o.data;var a=o.buildOrUpdateControllers();for(t=0,n=o.data.datasets.length;t<n;t++)o.getDatasetMeta(t).controller.buildOrUpdateElements();o.updateLayout(),o.options.animation&&o.options.animation.duration&&V.each(a,(function(e){e.reset()})),o.updateDatasets(),o.tooltip.initialize(),o.lastActive=[],zt.notify(o,"afterUpdate"),o._layers.sort(Xt("z","_idx")),o._bufferedRender?o._bufferedRequest={duration:e.duration,easing:e.easing,lazy:e.lazy}:o.render(e)}},updateLayout:function(){var e=this;!1!==zt.notify(e,"beforeLayout")&&(pt.update(this,this.width,this.height),e._layers=[],V.each(e.boxes,(function(t){t._configure&&t._configure(),e._layers.push.apply(e._layers,t._layers())}),e),e._layers.forEach((function(e,t){e._idx=t})),zt.notify(e,"afterScaleUpdate"),zt.notify(e,"afterLayout"))},updateDatasets:function(){var e=this;if(!1!==zt.notify(e,"beforeDatasetsUpdate")){for(var t=0,n=e.data.datasets.length;t<n;++t)e.updateDataset(t);zt.notify(e,"afterDatasetsUpdate")}},updateDataset:function(e){var t=this,n=t.getDatasetMeta(e),i={meta:n,index:e};!1!==zt.notify(t,"beforeDatasetUpdate",[i])&&(n.controller._update(),zt.notify(t,"afterDatasetUpdate",[i]))},render:function(e){var t=this;e&&"object"==typeof e||(e={duration:e,lazy:arguments[1]});var n=t.options.animation,i=Gt(e.duration,n&&n.duration),r=e.lazy;if(!1!==zt.notify(t,"beforeRender")){var o=function(e){zt.notify(t,"afterRender"),V.callback(n&&n.onComplete,[e],t)};if(n&&i){var a=new J({numSteps:i/16.66,easing:e.easing||n.easing,render:function(e,t){var n=V.easing.effects[t.easing],i=t.currentStep,r=i/t.numSteps;e.draw(n(r),r,i)},onAnimationProgress:n.onProgress,onAnimationComplete:o});X.addAnimation(t,a,i,r)}else t.draw(),o(new J({numSteps:0,chart:t}));return t}},draw:function(e){var t,n,i=this;if(i.clear(),V.isNullOrUndef(e)&&(e=1),i.transition(e),!(i.width<=0||i.height<=0)&&!1!==zt.notify(i,"beforeDraw",[e])){for(n=i._layers,t=0;t<n.length&&n[t].z<=0;++t)n[t].draw(i.chartArea);for(i.drawDatasets(e);t<n.length;++t)n[t].draw(i.chartArea);i._drawTooltip(e),zt.notify(i,"afterDraw",[e])}},transition:function(e){for(var t=this,n=0,i=(t.data.datasets||[]).length;n<i;++n)t.isDatasetVisible(n)&&t.getDatasetMeta(n).controller.transition(e);t.tooltip.transition(e)},_getSortedDatasetMetas:function(e){var t,n,i=this,r=[];for(t=0,n=(i.data.datasets||[]).length;t<n;++t)e&&!i.isDatasetVisible(t)||r.push(i.getDatasetMeta(t));return r.sort(Xt("order","index")),r},_getSortedVisibleDatasetMetas:function(){return this._getSortedDatasetMetas(!0)},drawDatasets:function(e){var t,n,i=this;if(!1!==zt.notify(i,"beforeDatasetsDraw",[e])){for(n=(t=i._getSortedVisibleDatasetMetas()).length-1;n>=0;--n)i.drawDataset(t[n],e);zt.notify(i,"afterDatasetsDraw",[e])}},drawDataset:function(e,t){var n={meta:e,index:e.index,easingValue:t};!1!==zt.notify(this,"beforeDatasetDraw",[n])&&(e.controller.draw(t),zt.notify(this,"afterDatasetDraw",[n]))},_drawTooltip:function(e){var t=this,n=t.tooltip,i={tooltip:n,easingValue:e};!1!==zt.notify(t,"beforeTooltipDraw",[i])&&(n.draw(),zt.notify(t,"afterTooltipDraw",[i]))},getElementAtEvent:function(e){return rt.modes.single(this,e)},getElementsAtEvent:function(e){return rt.modes.label(this,e,{intersect:!0})},getElementsAtXAxis:function(e){return rt.modes["x-axis"](this,e,{intersect:!0})},getElementsAtEventForMode:function(e,t,n){var i=rt.modes[t];return"function"==typeof i?i(this,e,n):[]},getDatasetAtEvent:function(e){return rt.modes.dataset(this,e,{intersect:!0})},getDatasetMeta:function(e){var t=this,n=t.data.datasets[e];n._meta||(n._meta={});var i=n._meta[t.id];return i||(i=n._meta[t.id]={type:null,data:[],dataset:null,controller:null,hidden:null,xAxisID:null,yAxisID:null,order:n.order||0,index:e}),i},getVisibleDatasetCount:function(){for(var e=0,t=0,n=this.data.datasets.length;t<n;++t)this.isDatasetVisible(t)&&e++;return e},isDatasetVisible:function(e){var t=this.getDatasetMeta(e);return"boolean"==typeof t.hidden?!t.hidden:!this.data.datasets[e].hidden},generateLegend:function(){return this.options.legendCallback(this)},destroyDatasetMeta:function(e){var t=this.id,n=this.data.datasets[e],i=n._meta&&n._meta[t];i&&(i.controller.destroy(),delete n._meta[t])},destroy:function(){var e,t,n=this,i=n.canvas;for(n.stop(),e=0,t=n.data.datasets.length;e<t;++e)n.destroyDatasetMeta(e);i&&(n.unbindEvents(),V.canvas.clear(n),Dt.releaseContext(n.ctx),n.canvas=null,n.ctx=null),zt.notify(n,"destroy"),delete en.instances[n.id]},toBase64Image:function(){return this.canvas.toDataURL.apply(this.canvas,arguments)},initToolTip:function(){var e=this;e.tooltip=new Yt({_chart:e,_chartInstance:e,_data:e.data,_options:e.options.tooltips},e)},bindEvents:function(){var e=this,t=e._listeners={},n=function(){e.eventHandler.apply(e,arguments)};V.each(e.options.events,(function(i){Dt.addEventListener(e,i,n),t[i]=n})),e.options.responsive&&(n=function(){e.resize()},Dt.addEventListener(e,"resize",n),t.resize=n)},unbindEvents:function(){var e=this,t=e._listeners;t&&(delete e._listeners,V.each(t,(function(t,n){Dt.removeEventListener(e,n,t)})))},updateHoverStyle:function(e,t,n){var i,r,o,a=n?"set":"remove";for(r=0,o=e.length;r<o;++r)(i=e[r])&&this.getDatasetMeta(i._datasetIndex).controller[a+"HoverStyle"](i);"dataset"===t&&this.getDatasetMeta(e[0]._datasetIndex).controller["_"+a+"DatasetHoverStyle"]()},eventHandler:function(e){var t=this,n=t.tooltip;if(!1!==zt.notify(t,"beforeEvent",[e])){t._bufferedRender=!0,t._bufferedRequest=null;var i=t.handleEvent(e);n&&(i=n._start?n.handleEvent(e):i|n.handleEvent(e)),zt.notify(t,"afterEvent",[e]);var r=t._bufferedRequest;return r?t.render(r):i&&!t.animating&&(t.stop(),t.render({duration:t.options.hover.animationDuration,lazy:!0})),t._bufferedRender=!1,t._bufferedRequest=null,t}},handleEvent:function(e){var t,n=this,i=n.options||{},r=i.hover;return n.lastActive=n.lastActive||[],"mouseout"===e.type?n.active=[]:n.active=n.getElementsAtEventForMode(e,r.mode,r),V.callback(i.onHover||i.hover.onHover,[e.native,n.active],n),"mouseup"!==e.type&&"click"!==e.type||i.onClick&&i.onClick.call(n,e.native,n.active),n.lastActive.length&&n.updateHoverStyle(n.lastActive,r.mode,!1),n.active.length&&r.mode&&n.updateHoverStyle(n.active,r.mode,!0),t=!V.arrayEquals(n.active,n.lastActive),n.lastActive=n.active,t}}),en.instances={};var tn=en;en.Controller=en,en.types={},V.configMerge=Kt,V.scaleMerge=Qt;function nn(){throw new Error("This method is not implemented: either no adapter can be found or an incomplete integration was provided.")}function rn(e){this.options=e||{}}V.extend(rn.prototype,{formats:nn,parse:nn,format:nn,add:nn,diff:nn,startOf:nn,endOf:nn,_create:function(e){return e}}),rn.override=function(e){V.extend(rn.prototype,e)};var on={_date:rn},an={formatters:{values:function(e){return V.isArray(e)?e:""+e},linear:function(e,t,n){var i=n.length>3?n[2]-n[1]:n[1]-n[0];Math.abs(i)>1&&e!==Math.floor(e)&&(i=e-Math.floor(e));var r=V.log10(Math.abs(i)),o="";if(0!==e)if(Math.max(Math.abs(n[0]),Math.abs(n[n.length-1]))<1e-4){var a=V.log10(Math.abs(e)),s=Math.floor(a)-Math.floor(r);s=Math.max(Math.min(s,20),0),o=e.toExponential(s)}else{var l=-1*Math.floor(r);l=Math.max(Math.min(l,20),0),o=e.toFixed(l)}else o="0";return o},logarithmic:function(e,t,n){var i=e/Math.pow(10,Math.floor(V.log10(e)));return 0===e?"0":1===i||2===i||5===i||0===t||t===n.length-1?e.toExponential():""}}},sn=V.isArray,ln=V.isNullOrUndef,cn=V.valueOrDefault,un=V.valueAtIndexOrDefault;function dn(e,t,n){var i,r=e.getTicks().length,o=Math.min(t,r-1),a=e.getPixelForTick(o),s=e._startPixel,l=e._endPixel,c=1e-6;if(!(n&&(i=1===r?Math.max(a-s,l-a):0===t?(e.getPixelForTick(1)-a)/2:(a-e.getPixelForTick(o-1))/2,(a+=o<t?i:-i)<s-c||a>l+c)))return a}function hn(e,t,n,i){var r,o,a,s,l,c,u,d,h,f,p,m,v,g=n.length,_=[],b=[],y=[],w=0,k=0;for(r=0;r<g;++r){if(s=n[r].label,l=n[r].major?t.major:t.minor,e.font=c=l.string,u=i[c]=i[c]||{data:{},gc:[]},d=l.lineHeight,h=f=0,ln(s)||sn(s)){if(sn(s))for(o=0,a=s.length;o<a;++o)p=s[o],ln(p)||sn(p)||(h=V.measureText(e,u.data,u.gc,h,p),f+=d)}else h=V.measureText(e,u.data,u.gc,h,s),f=d;_.push(h),b.push(f),y.push(d/2),w=Math.max(h,w),k=Math.max(f,k)}function x(e){return{width:_[e]||0,height:b[e]||0,offset:y[e]||0}}return function(e,t){V.each(e,(function(e){var n,i=e.gc,r=i.length/2;if(r>t){for(n=0;n<r;++n)delete e.data[i[n]];i.splice(0,r)}}))}(i,g),m=_.indexOf(w),v=b.indexOf(k),{first:x(0),last:x(g-1),widest:x(m),highest:x(v)}}function fn(e){return e.drawTicks?e.tickMarkLength:0}function pn(e){var t,n;return e.display?(t=V.options._parseFont(e),n=V.options.toPadding(e.padding),t.lineHeight+n.height):0}function mn(e,t){return V.extend(V.options._parseFont({fontFamily:cn(t.fontFamily,e.fontFamily),fontSize:cn(t.fontSize,e.fontSize),fontStyle:cn(t.fontStyle,e.fontStyle),lineHeight:cn(t.lineHeight,e.lineHeight)}),{color:V.options.resolve([t.fontColor,e.fontColor,j.global.defaultFontColor])})}function vn(e){var t=mn(e,e.minor);return{minor:t,major:e.major.enabled?mn(e,e.major):t}}function gn(e){var t,n,i,r=[];for(n=0,i=e.length;n<i;++n)void 0!==(t=e[n])._index&&r.push(t);return r}function _n(e,t,n,i){var r,o,a,s,l=cn(n,0),c=Math.min(cn(i,e.length),e.length),u=0;for(t=Math.ceil(t),i&&(t=(r=i-n)/Math.floor(r/t)),s=l;s<0;)u++,s=Math.round(l+u*t);for(o=Math.max(l,0);o<c;o++)a=e[o],o===s?(a._index=o,u++,s=Math.round(l+u*t)):delete a.label}j._set("scale",{display:!0,position:"left",offset:!1,gridLines:{display:!0,color:"rgba(0,0,0,0.1)",lineWidth:1,drawBorder:!0,drawOnChartArea:!0,drawTicks:!0,tickMarkLength:10,zeroLineWidth:1,zeroLineColor:"rgba(0,0,0,0.25)",zeroLineBorderDash:[],zeroLineBorderDashOffset:0,offsetGridLines:!1,borderDash:[],borderDashOffset:0},scaleLabel:{display:!1,labelString:"",padding:{top:4,bottom:4}},ticks:{beginAtZero:!1,minRotation:0,maxRotation:50,mirror:!1,padding:0,reverse:!1,display:!0,autoSkip:!0,autoSkipPadding:0,labelOffset:0,callback:an.formatters.values,minor:{},major:{}}});var bn=K.extend({zeroLineIndex:0,getPadding:function(){var e=this;return{left:e.paddingLeft||0,top:e.paddingTop||0,right:e.paddingRight||0,bottom:e.paddingBottom||0}},getTicks:function(){return this._ticks},_getLabels:function(){var e=this.chart.data;return this.options.labels||(this.isHorizontal()?e.xLabels:e.yLabels)||e.labels||[]},mergeTicksOptions:function(){},beforeUpdate:function(){V.callback(this.options.beforeUpdate,[this])},update:function(e,t,n){var i,r,o,a,s,l=this,c=l.options.ticks,u=c.sampleSize;if(l.beforeUpdate(),l.maxWidth=e,l.maxHeight=t,l.margins=V.extend({left:0,right:0,top:0,bottom:0},n),l._ticks=null,l.ticks=null,l._labelSizes=null,l._maxLabelLines=0,l.longestLabelWidth=0,l.longestTextCache=l.longestTextCache||{},l._gridLineItems=null,l._labelItems=null,l.beforeSetDimensions(),l.setDimensions(),l.afterSetDimensions(),l.beforeDataLimits(),l.determineDataLimits(),l.afterDataLimits(),l.beforeBuildTicks(),a=l.buildTicks()||[],(!(a=l.afterBuildTicks(a)||a)||!a.length)&&l.ticks)for(a=[],i=0,r=l.ticks.length;i<r;++i)a.push({value:l.ticks[i],major:!1});return l._ticks=a,s=u<a.length,o=l._convertTicksToLabels(s?function(e,t){for(var n=[],i=e.length/t,r=0,o=e.length;r<o;r+=i)n.push(e[Math.floor(r)]);return n}(a,u):a),l._configure(),l.beforeCalculateTickRotation(),l.calculateTickRotation(),l.afterCalculateTickRotation(),l.beforeFit(),l.fit(),l.afterFit(),l._ticksToDraw=c.display&&(c.autoSkip||"auto"===c.source)?l._autoSkip(a):a,s&&(o=l._convertTicksToLabels(l._ticksToDraw)),l.ticks=o,l.afterUpdate(),l.minSize},_configure:function(){var e,t,n=this,i=n.options.ticks.reverse;n.isHorizontal()?(e=n.left,t=n.right):(e=n.top,t=n.bottom,i=!i),n._startPixel=e,n._endPixel=t,n._reversePixels=i,n._length=t-e},afterUpdate:function(){V.callback(this.options.afterUpdate,[this])},beforeSetDimensions:function(){V.callback(this.options.beforeSetDimensions,[this])},setDimensions:function(){var e=this;e.isHorizontal()?(e.width=e.maxWidth,e.left=0,e.right=e.width):(e.height=e.maxHeight,e.top=0,e.bottom=e.height),e.paddingLeft=0,e.paddingTop=0,e.paddingRight=0,e.paddingBottom=0},afterSetDimensions:function(){V.callback(this.options.afterSetDimensions,[this])},beforeDataLimits:function(){V.callback(this.options.beforeDataLimits,[this])},determineDataLimits:V.noop,afterDataLimits:function(){V.callback(this.options.afterDataLimits,[this])},beforeBuildTicks:function(){V.callback(this.options.beforeBuildTicks,[this])},buildTicks:V.noop,afterBuildTicks:function(e){var t=this;return sn(e)&&e.length?V.callback(t.options.afterBuildTicks,[t,e]):(t.ticks=V.callback(t.options.afterBuildTicks,[t,t.ticks])||t.ticks,e)},beforeTickToLabelConversion:function(){V.callback(this.options.beforeTickToLabelConversion,[this])},convertTicksToLabels:function(){var e=this,t=e.options.ticks;e.ticks=e.ticks.map(t.userCallback||t.callback,this)},afterTickToLabelConversion:function(){V.callback(this.options.afterTickToLabelConversion,[this])},beforeCalculateTickRotation:function(){V.callback(this.options.beforeCalculateTickRotation,[this])},calculateTickRotation:function(){var e,t,n,i,r,o,a,s=this,l=s.options,c=l.ticks,u=s.getTicks().length,d=c.minRotation||0,h=c.maxRotation,f=d;!s._isVisible()||!c.display||d>=h||u<=1||!s.isHorizontal()?s.labelRotation=d:(t=(e=s._getLabelSizes()).widest.width,n=e.highest.height-e.highest.offset,i=Math.min(s.maxWidth,s.chart.width-t),t+6>(r=l.offset?s.maxWidth/u:i/(u-1))&&(r=i/(u-(l.offset?.5:1)),o=s.maxHeight-fn(l.gridLines)-c.padding-pn(l.scaleLabel),a=Math.sqrt(t*t+n*n),f=V.toDegrees(Math.min(Math.asin(Math.min((e.highest.height+6)/r,1)),Math.asin(Math.min(o/a,1))-Math.asin(n/a))),f=Math.max(d,Math.min(h,f))),s.labelRotation=f)},afterCalculateTickRotation:function(){V.callback(this.options.afterCalculateTickRotation,[this])},beforeFit:function(){V.callback(this.options.beforeFit,[this])},fit:function(){var e=this,t=e.minSize={width:0,height:0},n=e.chart,i=e.options,r=i.ticks,o=i.scaleLabel,a=i.gridLines,s=e._isVisible(),l="bottom"===i.position,c=e.isHorizontal();if(c?t.width=e.maxWidth:s&&(t.width=fn(a)+pn(o)),c?s&&(t.height=fn(a)+pn(o)):t.height=e.maxHeight,r.display&&s){var u=vn(r),d=e._getLabelSizes(),h=d.first,f=d.last,p=d.widest,m=d.highest,v=.4*u.minor.lineHeight,g=r.padding;if(c){var _=0!==e.labelRotation,b=V.toRadians(e.labelRotation),y=Math.cos(b),w=Math.sin(b),k=w*p.width+y*(m.height-(_?m.offset:0))+(_?0:v);t.height=Math.min(e.maxHeight,t.height+k+g);var x,S,C=e.getPixelForTick(0)-e.left,M=e.right-e.getPixelForTick(e.getTicks().length-1);_?(x=l?y*h.width+w*h.offset:w*(h.height-h.offset),S=l?w*(f.height-f.offset):y*f.width+w*f.offset):(x=h.width/2,S=f.width/2),e.paddingLeft=Math.max((x-C)*e.width/(e.width-C),0)+3,e.paddingRight=Math.max((S-M)*e.width/(e.width-M),0)+3}else{var T=r.mirror?0:p.width+g+v;t.width=Math.min(e.maxWidth,t.width+T),e.paddingTop=h.height/2,e.paddingBottom=f.height/2}}e.handleMargins(),c?(e.width=e._length=n.width-e.margins.left-e.margins.right,e.height=t.height):(e.width=t.width,e.height=e._length=n.height-e.margins.top-e.margins.bottom)},handleMargins:function(){var e=this;e.margins&&(e.margins.left=Math.max(e.paddingLeft,e.margins.left),e.margins.top=Math.max(e.paddingTop,e.margins.top),e.margins.right=Math.max(e.paddingRight,e.margins.right),e.margins.bottom=Math.max(e.paddingBottom,e.margins.bottom))},afterFit:function(){V.callback(this.options.afterFit,[this])},isHorizontal:function(){var e=this.options.position;return"top"===e||"bottom"===e},isFullWidth:function(){return this.options.fullWidth},getRightValue:function(e){if(ln(e))return NaN;if(("number"==typeof e||e instanceof Number)&&!isFinite(e))return NaN;if(e)if(this.isHorizontal()){if(void 0!==e.x)return this.getRightValue(e.x)}else if(void 0!==e.y)return this.getRightValue(e.y);return e},_convertTicksToLabels:function(e){var t,n,i,r=this;for(r.ticks=e.map((function(e){return e.value})),r.beforeTickToLabelConversion(),t=r.convertTicksToLabels(e)||r.ticks,r.afterTickToLabelConversion(),n=0,i=e.length;n<i;++n)e[n].label=t[n];return t},_getLabelSizes:function(){var e=this,t=e._labelSizes;return t||(e._labelSizes=t=hn(e.ctx,vn(e.options.ticks),e.getTicks(),e.longestTextCache),e.longestLabelWidth=t.widest.width),t},_parseValue:function(e){var t,n,i,r;return sn(e)?(t=+this.getRightValue(e[0]),n=+this.getRightValue(e[1]),i=Math.min(t,n),r=Math.max(t,n)):(t=void 0,n=e=+this.getRightValue(e),i=e,r=e),{min:i,max:r,start:t,end:n}},_getScaleLabel:function(e){var t=this._parseValue(e);return void 0!==t.start?"["+t.start+", "+t.end+"]":+this.getRightValue(e)},getLabelForIndex:V.noop,getPixelForValue:V.noop,getValueForPixel:V.noop,getPixelForTick:function(e){var t=this,n=t.options.offset,i=t._ticks.length,r=1/Math.max(i-(n?0:1),1);return e<0||e>i-1?null:t.getPixelForDecimal(e*r+(n?r/2:0))},getPixelForDecimal:function(e){var t=this;return t._reversePixels&&(e=1-e),t._startPixel+e*t._length},getDecimalForPixel:function(e){var t=(e-this._startPixel)/this._length;return this._reversePixels?1-t:t},getBasePixel:function(){return this.getPixelForValue(this.getBaseValue())},getBaseValue:function(){var e=this,t=e.min,n=e.max;return e.beginAtZero?0:t<0&&n<0?n:t>0&&n>0?t:0},_autoSkip:function(e){var t,n,i,r,o=this,a=o.options.ticks,s=o._length,l=a.maxTicksLimit||s/o._tickSize()+1,c=a.major.enabled?function(e){var t,n,i=[];for(t=0,n=e.length;t<n;t++)e[t].major&&i.push(t);return i}(e):[],u=c.length,d=c[0],h=c[u-1];if(u>l)return function(e,t,n){var i,r,o=0,a=t[0];for(n=Math.ceil(n),i=0;i<e.length;i++)r=e[i],i===a?(r._index=i,a=t[++o*n]):delete r.label}(e,c,u/l),gn(e);if(i=function(e,t,n,i){var r,o,a,s,l=function(e){var t,n,i=e.length;if(i<2)return!1;for(n=e[0],t=1;t<i;++t)if(e[t]-e[t-1]!==n)return!1;return n}(e),c=(t.length-1)/i;if(!l)return Math.max(c,1);for(a=0,s=(r=V.math._factorize(l)).length-1;a<s;a++)if((o=r[a])>c)return o;return Math.max(c,1)}(c,e,0,l),u>0){for(t=0,n=u-1;t<n;t++)_n(e,i,c[t],c[t+1]);return r=u>1?(h-d)/(u-1):null,_n(e,i,V.isNullOrUndef(r)?0:d-r,d),_n(e,i,h,V.isNullOrUndef(r)?e.length:h+r),gn(e)}return _n(e,i),gn(e)},_tickSize:function(){var e=this,t=e.options.ticks,n=V.toRadians(e.labelRotation),i=Math.abs(Math.cos(n)),r=Math.abs(Math.sin(n)),o=e._getLabelSizes(),a=t.autoSkipPadding||0,s=o?o.widest.width+a:0,l=o?o.highest.height+a:0;return e.isHorizontal()?l*i>s*r?s/i:l/r:l*r<s*i?l/i:s/r},_isVisible:function(){var e,t,n,i=this,r=i.chart,o=i.options.display;if("auto"!==o)return!!o;for(e=0,t=r.data.datasets.length;e<t;++e)if(r.isDatasetVisible(e)&&((n=r.getDatasetMeta(e)).xAxisID===i.id||n.yAxisID===i.id))return!0;return!1},_computeGridLineItems:function(e){var t,n,i,r,o,a,s,l,c,u,d,h,f,p,m,v,g,_=this,b=_.chart,y=_.options,w=y.gridLines,k=y.position,x=w.offsetGridLines,S=_.isHorizontal(),C=_._ticksToDraw,M=C.length+(x?1:0),T=fn(w),A=[],P=w.drawBorder?un(w.lineWidth,0,0):0,L=P/2,O=V._alignPixel,q=function(e){return O(b,e,P)};for("top"===k?(t=q(_.bottom),s=_.bottom-T,c=t-L,d=q(e.top)+L,f=e.bottom):"bottom"===k?(t=q(_.top),d=e.top,f=q(e.bottom)-L,s=t+L,c=_.top+T):"left"===k?(t=q(_.right),a=_.right-T,l=t-L,u=q(e.left)+L,h=e.right):(t=q(_.left),u=e.left,h=q(e.right)-L,a=t+L,l=_.left+T),n=0;n<M;++n)i=C[n]||{},ln(i.label)&&n<C.length||(n===_.zeroLineIndex&&y.offset===x?(p=w.zeroLineWidth,m=w.zeroLineColor,v=w.zeroLineBorderDash||[],g=w.zeroLineBorderDashOffset||0):(p=un(w.lineWidth,n,1),m=un(w.color,n,"rgba(0,0,0,0.1)"),v=w.borderDash||[],g=w.borderDashOffset||0),void 0!==(r=dn(_,i._index||n,x))&&(o=O(b,r,p),S?a=l=u=h=o:s=c=d=f=o,A.push({tx1:a,ty1:s,tx2:l,ty2:c,x1:u,y1:d,x2:h,y2:f,width:p,color:m,borderDash:v,borderDashOffset:g})));return A.ticksLength=M,A.borderValue=t,A},_computeLabelItems:function(){var e,t,n,i,r,o,a,s,l,c,u,d,h=this,f=h.options,p=f.ticks,m=f.position,v=p.mirror,g=h.isHorizontal(),_=h._ticksToDraw,b=vn(p),y=p.padding,w=fn(f.gridLines),k=-V.toRadians(h.labelRotation),x=[];for("top"===m?(o=h.bottom-w-y,a=k?"left":"center"):"bottom"===m?(o=h.top+w+y,a=k?"right":"center"):"left"===m?(r=h.right-(v?0:w)-y,a=v?"left":"right"):(r=h.left+(v?0:w)+y,a=v?"right":"left"),e=0,t=_.length;e<t;++e)i=(n=_[e]).label,ln(i)||(s=h.getPixelForTick(n._index||e)+p.labelOffset,c=(l=n.major?b.major:b.minor).lineHeight,u=sn(i)?i.length:1,g?(r=s,d="top"===m?((k?1:.5)-u)*c:(k?0:.5)*c):(o=s,d=(1-u)*c/2),x.push({x:r,y:o,rotation:k,label:i,font:l,textOffset:d,textAlign:a}));return x},_drawGrid:function(e){var t=this,n=t.options.gridLines;if(n.display){var i,r,o,a,s,l=t.ctx,c=t.chart,u=V._alignPixel,d=n.drawBorder?un(n.lineWidth,0,0):0,h=t._gridLineItems||(t._gridLineItems=t._computeGridLineItems(e));for(o=0,a=h.length;o<a;++o)i=(s=h[o]).width,r=s.color,i&&r&&(l.save(),l.lineWidth=i,l.strokeStyle=r,l.setLineDash&&(l.setLineDash(s.borderDash),l.lineDashOffset=s.borderDashOffset),l.beginPath(),n.drawTicks&&(l.moveTo(s.tx1,s.ty1),l.lineTo(s.tx2,s.ty2)),n.drawOnChartArea&&(l.moveTo(s.x1,s.y1),l.lineTo(s.x2,s.y2)),l.stroke(),l.restore());if(d){var f,p,m,v,g=d,_=un(n.lineWidth,h.ticksLength-1,1),b=h.borderValue;t.isHorizontal()?(f=u(c,t.left,g)-g/2,p=u(c,t.right,_)+_/2,m=v=b):(m=u(c,t.top,g)-g/2,v=u(c,t.bottom,_)+_/2,f=p=b),l.lineWidth=d,l.strokeStyle=un(n.color,0),l.beginPath(),l.moveTo(f,m),l.lineTo(p,v),l.stroke()}}},_drawLabels:function(){var e=this;if(e.options.ticks.display){var t,n,i,r,o,a,s,l,c=e.ctx,u=e._labelItems||(e._labelItems=e._computeLabelItems());for(t=0,i=u.length;t<i;++t){if(a=(o=u[t]).font,c.save(),c.translate(o.x,o.y),c.rotate(o.rotation),c.font=a.string,c.fillStyle=a.color,c.textBaseline="middle",c.textAlign=o.textAlign,s=o.label,l=o.textOffset,sn(s))for(n=0,r=s.length;n<r;++n)c.fillText(""+s[n],0,l),l+=a.lineHeight;else c.fillText(s,0,l);c.restore()}}},_drawTitle:function(){var e=this,t=e.ctx,n=e.options,i=n.scaleLabel;if(i.display){var r,o,a=cn(i.fontColor,j.global.defaultFontColor),s=V.options._parseFont(i),l=V.options.toPadding(i.padding),c=s.lineHeight/2,u=n.position,d=0;if(e.isHorizontal())r=e.left+e.width/2,o="bottom"===u?e.bottom-c-l.bottom:e.top+c+l.top;else{var h="left"===u;r=h?e.left+c+l.top:e.right-c-l.top,o=e.top+e.height/2,d=h?-.5*Math.PI:.5*Math.PI}t.save(),t.translate(r,o),t.rotate(d),t.textAlign="center",t.textBaseline="middle",t.fillStyle=a,t.font=s.string,t.fillText(i.labelString,0,0),t.restore()}},draw:function(e){var t=this;t._isVisible()&&(t._drawGrid(e),t._drawTitle(),t._drawLabels())},_layers:function(){var e=this,t=e.options,n=t.ticks&&t.ticks.z||0,i=t.gridLines&&t.gridLines.z||0;return e._isVisible()&&n!==i&&e.draw===e._draw?[{z:i,draw:function(){e._drawGrid.apply(e,arguments),e._drawTitle.apply(e,arguments)}},{z:n,draw:function(){e._drawLabels.apply(e,arguments)}}]:[{z:n,draw:function(){e.draw.apply(e,arguments)}}]},_getMatchingVisibleMetas:function(e){var t=this,n=t.isHorizontal();return t.chart._getSortedVisibleDatasetMetas().filter((function(i){return(!e||i.type===e)&&(n?i.xAxisID===t.id:i.yAxisID===t.id)}))}});bn.prototype._draw=bn.prototype.draw;var yn=bn,wn=V.isNullOrUndef,kn=yn.extend({determineDataLimits:function(){var e,t=this,n=t._getLabels(),i=t.options.ticks,r=i.min,o=i.max,a=0,s=n.length-1;void 0!==r&&(e=n.indexOf(r))>=0&&(a=e),void 0!==o&&(e=n.indexOf(o))>=0&&(s=e),t.minIndex=a,t.maxIndex=s,t.min=n[a],t.max=n[s]},buildTicks:function(){var e=this,t=e._getLabels(),n=e.minIndex,i=e.maxIndex;e.ticks=0===n&&i===t.length-1?t:t.slice(n,i+1)},getLabelForIndex:function(e,t){var n=this,i=n.chart;return i.getDatasetMeta(t).controller._getValueScaleId()===n.id?n.getRightValue(i.data.datasets[t].data[e]):n._getLabels()[e]},_configure:function(){var e=this,t=e.options.offset,n=e.ticks;yn.prototype._configure.call(e),e.isHorizontal()||(e._reversePixels=!e._reversePixels),n&&(e._startValue=e.minIndex-(t?.5:0),e._valueRange=Math.max(n.length-(t?0:1),1))},getPixelForValue:function(e,t,n){var i,r,o,a=this;return wn(t)||wn(n)||(e=a.chart.data.datasets[n].data[t]),wn(e)||(i=a.isHorizontal()?e.x:e.y),(void 0!==i||void 0!==e&&isNaN(t))&&(r=a._getLabels(),e=V.valueOrDefault(i,e),t=-1!==(o=r.indexOf(e))?o:t,isNaN(t)&&(t=e)),a.getPixelForDecimal((t-a._startValue)/a._valueRange)},getPixelForTick:function(e){var t=this.ticks;return e<0||e>t.length-1?null:this.getPixelForValue(t[e],e+this.minIndex)},getValueForPixel:function(e){var t=this,n=Math.round(t._startValue+t.getDecimalForPixel(e)*t._valueRange);return Math.min(Math.max(n,0),t.ticks.length-1)},getBasePixel:function(){return this.bottom}}),xn={position:"bottom"};kn._defaults=xn;var Sn=V.noop,Cn=V.isNullOrUndef;var Mn=yn.extend({getRightValue:function(e){return"string"==typeof e?+e:yn.prototype.getRightValue.call(this,e)},handleTickRangeOptions:function(){var e=this,t=e.options.ticks;if(t.beginAtZero){var n=V.sign(e.min),i=V.sign(e.max);n<0&&i<0?e.max=0:n>0&&i>0&&(e.min=0)}var r=void 0!==t.min||void 0!==t.suggestedMin,o=void 0!==t.max||void 0!==t.suggestedMax;void 0!==t.min?e.min=t.min:void 0!==t.suggestedMin&&(null===e.min?e.min=t.suggestedMin:e.min=Math.min(e.min,t.suggestedMin)),void 0!==t.max?e.max=t.max:void 0!==t.suggestedMax&&(null===e.max?e.max=t.suggestedMax:e.max=Math.max(e.max,t.suggestedMax)),r!==o&&e.min>=e.max&&(r?e.max=e.min+1:e.min=e.max-1),e.min===e.max&&(e.max++,t.beginAtZero||e.min--)},getTickLimit:function(){var e,t=this,n=t.options.ticks,i=n.stepSize,r=n.maxTicksLimit;return i?e=Math.ceil(t.max/i)-Math.floor(t.min/i)+1:(e=t._computeTickLimit(),r=r||11),r&&(e=Math.min(r,e)),e},_computeTickLimit:function(){return Number.POSITIVE_INFINITY},handleDirectionalChanges:Sn,buildTicks:function(){var e=this,t=e.options.ticks,n=e.getTickLimit(),i={maxTicks:n=Math.max(2,n),min:t.min,max:t.max,precision:t.precision,stepSize:V.valueOrDefault(t.fixedStepSize,t.stepSize)},r=e.ticks=function(e,t){var n,i,r,o,a=[],s=e.stepSize,l=s||1,c=e.maxTicks-1,u=e.min,d=e.max,h=e.precision,f=t.min,p=t.max,m=V.niceNum((p-f)/c/l)*l;if(m<1e-14&&Cn(u)&&Cn(d))return[f,p];(o=Math.ceil(p/m)-Math.floor(f/m))>c&&(m=V.niceNum(o*m/c/l)*l),s||Cn(h)?n=Math.pow(10,V._decimalPlaces(m)):(n=Math.pow(10,h),m=Math.ceil(m*n)/n),i=Math.floor(f/m)*m,r=Math.ceil(p/m)*m,s&&(!Cn(u)&&V.almostWhole(u/m,m/1e3)&&(i=u),!Cn(d)&&V.almostWhole(d/m,m/1e3)&&(r=d)),o=(r-i)/m,o=V.almostEquals(o,Math.round(o),m/1e3)?Math.round(o):Math.ceil(o),i=Math.round(i*n)/n,r=Math.round(r*n)/n,a.push(Cn(u)?i:u);for(var v=1;v<o;++v)a.push(Math.round((i+v*m)*n)/n);return a.push(Cn(d)?r:d),a}(i,e);e.handleDirectionalChanges(),e.max=V.max(r),e.min=V.min(r),t.reverse?(r.reverse(),e.start=e.max,e.end=e.min):(e.start=e.min,e.end=e.max)},convertTicksToLabels:function(){var e=this;e.ticksAsNumbers=e.ticks.slice(),e.zeroLineIndex=e.ticks.indexOf(0),yn.prototype.convertTicksToLabels.call(e)},_configure:function(){var e,t=this,n=t.getTicks(),i=t.min,r=t.max;yn.prototype._configure.call(t),t.options.offset&&n.length&&(i-=e=(r-i)/Math.max(n.length-1,1)/2,r+=e),t._startValue=i,t._endValue=r,t._valueRange=r-i}}),Tn={position:"left",ticks:{callback:an.formatters.linear}};function An(e,t,n,i){var r,o,a=e.options,s=function(e,t,n){var i=[n.type,void 0===t&&void 0===n.stack?n.index:"",n.stack].join(".");return void 0===e[i]&&(e[i]={pos:[],neg:[]}),e[i]}(t,a.stacked,n),l=s.pos,c=s.neg,u=i.length;for(r=0;r<u;++r)o=e._parseValue(i[r]),isNaN(o.min)||isNaN(o.max)||n.data[r].hidden||(l[r]=l[r]||0,c[r]=c[r]||0,a.relativePoints?l[r]=100:o.min<0||o.max<0?c[r]+=o.min:l[r]+=o.max)}function Pn(e,t,n){var i,r,o=n.length;for(i=0;i<o;++i)r=e._parseValue(n[i]),isNaN(r.min)||isNaN(r.max)||t.data[i].hidden||(e.min=Math.min(e.min,r.min),e.max=Math.max(e.max,r.max))}var Ln=Mn.extend({determineDataLimits:function(){var e,t,n,i,r=this,o=r.options,a=r.chart.data.datasets,s=r._getMatchingVisibleMetas(),l=o.stacked,c={},u=s.length;if(r.min=Number.POSITIVE_INFINITY,r.max=Number.NEGATIVE_INFINITY,void 0===l)for(e=0;!l&&e<u;++e)l=void 0!==(t=s[e]).stack;for(e=0;e<u;++e)n=a[(t=s[e]).index].data,l?An(r,c,t,n):Pn(r,t,n);V.each(c,(function(e){i=e.pos.concat(e.neg),r.min=Math.min(r.min,V.min(i)),r.max=Math.max(r.max,V.max(i))})),r.min=V.isFinite(r.min)&&!isNaN(r.min)?r.min:0,r.max=V.isFinite(r.max)&&!isNaN(r.max)?r.max:1,r.handleTickRangeOptions()},_computeTickLimit:function(){var e,t=this;return t.isHorizontal()?Math.ceil(t.width/40):(e=V.options._parseFont(t.options.ticks),Math.ceil(t.height/e.lineHeight))},handleDirectionalChanges:function(){this.isHorizontal()||this.ticks.reverse()},getLabelForIndex:function(e,t){return this._getScaleLabel(this.chart.data.datasets[t].data[e])},getPixelForValue:function(e){var t=this;return t.getPixelForDecimal((+t.getRightValue(e)-t._startValue)/t._valueRange)},getValueForPixel:function(e){return this._startValue+this.getDecimalForPixel(e)*this._valueRange},getPixelForTick:function(e){var t=this.ticksAsNumbers;return e<0||e>t.length-1?null:this.getPixelForValue(t[e])}}),On=Tn;Ln._defaults=On;var qn=V.valueOrDefault,En=V.math.log10;var Dn={position:"left",ticks:{callback:an.formatters.logarithmic}};function zn(e,t){return V.isFinite(e)&&e>=0?e:t}var Nn=yn.extend({determineDataLimits:function(){var e,t,n,i,r,o,a=this,s=a.options,l=a.chart,c=l.data.datasets,u=a.isHorizontal();function d(e){return u?e.xAxisID===a.id:e.yAxisID===a.id}a.min=Number.POSITIVE_INFINITY,a.max=Number.NEGATIVE_INFINITY,a.minNotZero=Number.POSITIVE_INFINITY;var h=s.stacked;if(void 0===h)for(e=0;e<c.length;e++)if(t=l.getDatasetMeta(e),l.isDatasetVisible(e)&&d(t)&&void 0!==t.stack){h=!0;break}if(s.stacked||h){var f={};for(e=0;e<c.length;e++){var p=[(t=l.getDatasetMeta(e)).type,void 0===s.stacked&&void 0===t.stack?e:"",t.stack].join(".");if(l.isDatasetVisible(e)&&d(t))for(void 0===f[p]&&(f[p]=[]),r=0,o=(i=c[e].data).length;r<o;r++){var m=f[p];n=a._parseValue(i[r]),isNaN(n.min)||isNaN(n.max)||t.data[r].hidden||n.min<0||n.max<0||(m[r]=m[r]||0,m[r]+=n.max)}}V.each(f,(function(e){if(e.length>0){var t=V.min(e),n=V.max(e);a.min=Math.min(a.min,t),a.max=Math.max(a.max,n)}}))}else for(e=0;e<c.length;e++)if(t=l.getDatasetMeta(e),l.isDatasetVisible(e)&&d(t))for(r=0,o=(i=c[e].data).length;r<o;r++)n=a._parseValue(i[r]),isNaN(n.min)||isNaN(n.max)||t.data[r].hidden||n.min<0||n.max<0||(a.min=Math.min(n.min,a.min),a.max=Math.max(n.max,a.max),0!==n.min&&(a.minNotZero=Math.min(n.min,a.minNotZero)));a.min=V.isFinite(a.min)?a.min:null,a.max=V.isFinite(a.max)?a.max:null,a.minNotZero=V.isFinite(a.minNotZero)?a.minNotZero:null,this.handleTickRangeOptions()},handleTickRangeOptions:function(){var e=this,t=e.options.ticks;e.min=zn(t.min,e.min),e.max=zn(t.max,e.max),e.min===e.max&&(0!==e.min&&null!==e.min?(e.min=Math.pow(10,Math.floor(En(e.min))-1),e.max=Math.pow(10,Math.floor(En(e.max))+1)):(e.min=1,e.max=10)),null===e.min&&(e.min=Math.pow(10,Math.floor(En(e.max))-1)),null===e.max&&(e.max=0!==e.min?Math.pow(10,Math.floor(En(e.min))+1):10),null===e.minNotZero&&(e.min>0?e.minNotZero=e.min:e.max<1?e.minNotZero=Math.pow(10,Math.floor(En(e.max))):e.minNotZero=1)},buildTicks:function(){var e=this,t=e.options.ticks,n=!e.isHorizontal(),i={min:zn(t.min),max:zn(t.max)},r=e.ticks=function(e,t){var n,i,r=[],o=qn(e.min,Math.pow(10,Math.floor(En(t.min)))),a=Math.floor(En(t.max)),s=Math.ceil(t.max/Math.pow(10,a));0===o?(n=Math.floor(En(t.minNotZero)),i=Math.floor(t.minNotZero/Math.pow(10,n)),r.push(o),o=i*Math.pow(10,n)):(n=Math.floor(En(o)),i=Math.floor(o/Math.pow(10,n)));var l=n<0?Math.pow(10,Math.abs(n)):1;do{r.push(o),10==++i&&(i=1,l=++n>=0?1:l),o=Math.round(i*Math.pow(10,n)*l)/l}while(n<a||n===a&&i<s);var c=qn(e.max,o);return r.push(c),r}(i,e);e.max=V.max(r),e.min=V.min(r),t.reverse?(n=!n,e.start=e.max,e.end=e.min):(e.start=e.min,e.end=e.max),n&&r.reverse()},convertTicksToLabels:function(){this.tickValues=this.ticks.slice(),yn.prototype.convertTicksToLabels.call(this)},getLabelForIndex:function(e,t){return this._getScaleLabel(this.chart.data.datasets[t].data[e])},getPixelForTick:function(e){var t=this.tickValues;return e<0||e>t.length-1?null:this.getPixelForValue(t[e])},_getFirstTickValue:function(e){var t=Math.floor(En(e));return Math.floor(e/Math.pow(10,t))*Math.pow(10,t)},_configure:function(){var e=this,t=e.min,n=0;yn.prototype._configure.call(e),0===t&&(t=e._getFirstTickValue(e.minNotZero),n=qn(e.options.ticks.fontSize,j.global.defaultFontSize)/e._length),e._startValue=En(t),e._valueOffset=n,e._valueRange=(En(e.max)-En(t))/(1-n)},getPixelForValue:function(e){var t=this,n=0;return(e=+t.getRightValue(e))>t.min&&e>0&&(n=(En(e)-t._startValue)/t._valueRange+t._valueOffset),t.getPixelForDecimal(n)},getValueForPixel:function(e){var t=this,n=t.getDecimalForPixel(e);return 0===n&&0===t.min?0:Math.pow(10,t._startValue+(n-t._valueOffset)*t._valueRange)}}),jn=Dn;Nn._defaults=jn;var Rn=V.valueOrDefault,In=V.valueAtIndexOrDefault,$n=V.options.resolve,Fn={display:!0,animate:!0,position:"chartArea",angleLines:{display:!0,color:"rgba(0,0,0,0.1)",lineWidth:1,borderDash:[],borderDashOffset:0},gridLines:{circular:!1},ticks:{showLabelBackdrop:!0,backdropColor:"rgba(255,255,255,0.75)",backdropPaddingY:2,backdropPaddingX:2,callback:an.formatters.linear},pointLabels:{display:!0,fontSize:10,callback:function(e){return e}}};function Bn(e){var t=e.ticks;return t.display&&e.display?Rn(t.fontSize,j.global.defaultFontSize)+2*t.backdropPaddingY:0}function Vn(e,t,n,i,r){return e===i||e===r?{start:t-n/2,end:t+n/2}:e<i||e>r?{start:t-n,end:t}:{start:t,end:t+n}}function Hn(e){return 0===e||180===e?"center":e<180?"left":"right"}function Wn(e,t,n,i){var r,o,a=n.y+i/2;if(V.isArray(t))for(r=0,o=t.length;r<o;++r)e.fillText(t[r],n.x,a),a+=i;else e.fillText(t,n.x,a)}function Un(e,t,n){90===e||270===e?n.y-=t.h/2:(e>270||e<90)&&(n.y-=t.h)}function Yn(e){return V.isNumber(e)?e:0}var Gn=Mn.extend({setDimensions:function(){var e=this;e.width=e.maxWidth,e.height=e.maxHeight,e.paddingTop=Bn(e.options)/2,e.xCenter=Math.floor(e.width/2),e.yCenter=Math.floor((e.height-e.paddingTop)/2),e.drawingArea=Math.min(e.height-e.paddingTop,e.width)/2},determineDataLimits:function(){var e=this,t=e.chart,n=Number.POSITIVE_INFINITY,i=Number.NEGATIVE_INFINITY;V.each(t.data.datasets,(function(r,o){if(t.isDatasetVisible(o)){var a=t.getDatasetMeta(o);V.each(r.data,(function(t,r){var o=+e.getRightValue(t);isNaN(o)||a.data[r].hidden||(n=Math.min(o,n),i=Math.max(o,i))}))}})),e.min=n===Number.POSITIVE_INFINITY?0:n,e.max=i===Number.NEGATIVE_INFINITY?0:i,e.handleTickRangeOptions()},_computeTickLimit:function(){return Math.ceil(this.drawingArea/Bn(this.options))},convertTicksToLabels:function(){var e=this;Mn.prototype.convertTicksToLabels.call(e),e.pointLabels=e.chart.data.labels.map((function(){var t=V.callback(e.options.pointLabels.callback,arguments,e);return t||0===t?t:""}))},getLabelForIndex:function(e,t){return+this.getRightValue(this.chart.data.datasets[t].data[e])},fit:function(){var e=this,t=e.options;t.display&&t.pointLabels.display?function(e){var t,n,i,r=V.options._parseFont(e.options.pointLabels),o={l:0,r:e.width,t:0,b:e.height-e.paddingTop},a={};e.ctx.font=r.string,e._pointLabelSizes=[];var s,l,c,u=e.chart.data.labels.length;for(t=0;t<u;t++){i=e.getPointPosition(t,e.drawingArea+5),s=e.ctx,l=r.lineHeight,c=e.pointLabels[t],n=V.isArray(c)?{w:V.longestText(s,s.font,c),h:c.length*l}:{w:s.measureText(c).width,h:l},e._pointLabelSizes[t]=n;var d=e.getIndexAngle(t),h=V.toDegrees(d)%360,f=Vn(h,i.x,n.w,0,180),p=Vn(h,i.y,n.h,90,270);f.start<o.l&&(o.l=f.start,a.l=d),f.end>o.r&&(o.r=f.end,a.r=d),p.start<o.t&&(o.t=p.start,a.t=d),p.end>o.b&&(o.b=p.end,a.b=d)}e.setReductions(e.drawingArea,o,a)}(e):e.setCenterPoint(0,0,0,0)},setReductions:function(e,t,n){var i=this,r=t.l/Math.sin(n.l),o=Math.max(t.r-i.width,0)/Math.sin(n.r),a=-t.t/Math.cos(n.t),s=-Math.max(t.b-(i.height-i.paddingTop),0)/Math.cos(n.b);r=Yn(r),o=Yn(o),a=Yn(a),s=Yn(s),i.drawingArea=Math.min(Math.floor(e-(r+o)/2),Math.floor(e-(a+s)/2)),i.setCenterPoint(r,o,a,s)},setCenterPoint:function(e,t,n,i){var r=this,o=r.width-t-r.drawingArea,a=e+r.drawingArea,s=n+r.drawingArea,l=r.height-r.paddingTop-i-r.drawingArea;r.xCenter=Math.floor((a+o)/2+r.left),r.yCenter=Math.floor((s+l)/2+r.top+r.paddingTop)},getIndexAngle:function(e){var t=this.chart,n=(e*(360/t.data.labels.length)+((t.options||{}).startAngle||0))%360;return(n<0?n+360:n)*Math.PI*2/360},getDistanceFromCenterForValue:function(e){var t=this;if(V.isNullOrUndef(e))return NaN;var n=t.drawingArea/(t.max-t.min);return t.options.ticks.reverse?(t.max-e)*n:(e-t.min)*n},getPointPosition:function(e,t){var n=this,i=n.getIndexAngle(e)-Math.PI/2;return{x:Math.cos(i)*t+n.xCenter,y:Math.sin(i)*t+n.yCenter}},getPointPositionForValue:function(e,t){return this.getPointPosition(e,this.getDistanceFromCenterForValue(t))},getBasePosition:function(e){var t=this,n=t.min,i=t.max;return t.getPointPositionForValue(e||0,t.beginAtZero?0:n<0&&i<0?i:n>0&&i>0?n:0)},_drawGrid:function(){var e,t,n,i=this,r=i.ctx,o=i.options,a=o.gridLines,s=o.angleLines,l=Rn(s.lineWidth,a.lineWidth),c=Rn(s.color,a.color);if(o.pointLabels.display&&function(e){var t=e.ctx,n=e.options,i=n.pointLabels,r=Bn(n),o=e.getDistanceFromCenterForValue(n.ticks.reverse?e.min:e.max),a=V.options._parseFont(i);t.save(),t.font=a.string,t.textBaseline="middle";for(var s=e.chart.data.labels.length-1;s>=0;s--){var l=0===s?r/2:0,c=e.getPointPosition(s,o+l+5),u=In(i.fontColor,s,j.global.defaultFontColor);t.fillStyle=u;var d=e.getIndexAngle(s),h=V.toDegrees(d);t.textAlign=Hn(h),Un(h,e._pointLabelSizes[s],c),Wn(t,e.pointLabels[s],c,a.lineHeight)}t.restore()}(i),a.display&&V.each(i.ticks,(function(e,n){0!==n&&(t=i.getDistanceFromCenterForValue(i.ticksAsNumbers[n]),function(e,t,n,i){var r,o=e.ctx,a=t.circular,s=e.chart.data.labels.length,l=In(t.color,i-1),c=In(t.lineWidth,i-1);if((a||s)&&l&&c){if(o.save(),o.strokeStyle=l,o.lineWidth=c,o.setLineDash&&(o.setLineDash(t.borderDash||[]),o.lineDashOffset=t.borderDashOffset||0),o.beginPath(),a)o.arc(e.xCenter,e.yCenter,n,0,2*Math.PI);else{r=e.getPointPosition(0,n),o.moveTo(r.x,r.y);for(var u=1;u<s;u++)r=e.getPointPosition(u,n),o.lineTo(r.x,r.y)}o.closePath(),o.stroke(),o.restore()}}(i,a,t,n))})),s.display&&l&&c){for(r.save(),r.lineWidth=l,r.strokeStyle=c,r.setLineDash&&(r.setLineDash($n([s.borderDash,a.borderDash,[]])),r.lineDashOffset=$n([s.borderDashOffset,a.borderDashOffset,0])),e=i.chart.data.labels.length-1;e>=0;e--)t=i.getDistanceFromCenterForValue(o.ticks.reverse?i.min:i.max),n=i.getPointPosition(e,t),r.beginPath(),r.moveTo(i.xCenter,i.yCenter),r.lineTo(n.x,n.y),r.stroke();r.restore()}},_drawLabels:function(){var e=this,t=e.ctx,n=e.options.ticks;if(n.display){var i,r,o=e.getIndexAngle(0),a=V.options._parseFont(n),s=Rn(n.fontColor,j.global.defaultFontColor);t.save(),t.font=a.string,t.translate(e.xCenter,e.yCenter),t.rotate(o),t.textAlign="center",t.textBaseline="middle",V.each(e.ticks,(function(o,l){(0!==l||n.reverse)&&(i=e.getDistanceFromCenterForValue(e.ticksAsNumbers[l]),n.showLabelBackdrop&&(r=t.measureText(o).width,t.fillStyle=n.backdropColor,t.fillRect(-r/2-n.backdropPaddingX,-i-a.size/2-n.backdropPaddingY,r+2*n.backdropPaddingX,a.size+2*n.backdropPaddingY)),t.fillStyle=s,t.fillText(o,0,-i))})),t.restore()}},_drawTitle:V.noop}),Qn=Fn;Gn._defaults=Qn;var Kn=V._deprecated,Zn=V.options.resolve,Jn=V.valueOrDefault,Xn=Number.MIN_SAFE_INTEGER||-9007199254740991,ei=Number.MAX_SAFE_INTEGER||9007199254740991,ti={millisecond:{common:!0,size:1,steps:1e3},second:{common:!0,size:1e3,steps:60},minute:{common:!0,size:6e4,steps:60},hour:{common:!0,size:36e5,steps:24},day:{common:!0,size:864e5,steps:30},week:{common:!1,size:6048e5,steps:4},month:{common:!0,size:2628e6,steps:12},quarter:{common:!1,size:7884e6,steps:4},year:{common:!0,size:3154e7}},ni=Object.keys(ti);function ii(e,t){return e-t}function ri(e){return V.valueOrDefault(e.time.min,e.ticks.min)}function oi(e){return V.valueOrDefault(e.time.max,e.ticks.max)}function ai(e,t,n,i){var r=function(e,t,n){for(var i,r,o,a=0,s=e.length-1;a>=0&&a<=s;){if(r=e[(i=a+s>>1)-1]||null,o=e[i],!r)return{lo:null,hi:o};if(o[t]<n)a=i+1;else{if(!(r[t]>n))return{lo:r,hi:o};s=i-1}}return{lo:o,hi:null}}(e,t,n),o=r.lo?r.hi?r.lo:e[e.length-2]:e[0],a=r.lo?r.hi?r.hi:e[e.length-1]:e[1],s=a[t]-o[t],l=s?(n-o[t])/s:0,c=(a[i]-o[i])*l;return o[i]+c}function si(e,t){var n=e._adapter,i=e.options.time,r=i.parser,o=r||i.format,a=t;return"function"==typeof r&&(a=r(a)),V.isFinite(a)||(a="string"==typeof o?n.parse(a,o):n.parse(a)),null!==a?+a:(r||"function"!=typeof o||(a=o(t),V.isFinite(a)||(a=n.parse(a))),a)}function li(e,t){if(V.isNullOrUndef(t))return null;var n=e.options.time,i=si(e,e.getRightValue(t));return null===i||n.round&&(i=+e._adapter.startOf(i,n.round)),i}function ci(e,t,n,i){var r,o,a,s=ni.length;for(r=ni.indexOf(e);r<s-1;++r)if(a=(o=ti[ni[r]]).steps?o.steps:ei,o.common&&Math.ceil((n-t)/(a*o.size))<=i)return ni[r];return ni[s-1]}function ui(e,t,n){var i,r,o=[],a={},s=t.length;for(i=0;i<s;++i)a[r=t[i]]=i,o.push({value:r,major:!1});return 0!==s&&n?function(e,t,n,i){var r,o,a=e._adapter,s=+a.startOf(t[0].value,i),l=t[t.length-1].value;for(r=s;r<=l;r=+a.add(r,1,i))(o=n[r])>=0&&(t[o].major=!0);return t}(e,o,a,n):o}var di=yn.extend({initialize:function(){this.mergeTicksOptions(),yn.prototype.initialize.call(this)},update:function(){var e=this,t=e.options,n=t.time||(t.time={}),i=e._adapter=new on._date(t.adapters.date);return Kn("time scale",n.format,"time.format","time.parser"),Kn("time scale",n.min,"time.min","ticks.min"),Kn("time scale",n.max,"time.max","ticks.max"),V.mergeIf(n.displayFormats,i.formats()),yn.prototype.update.apply(e,arguments)},getRightValue:function(e){return e&&void 0!==e.t&&(e=e.t),yn.prototype.getRightValue.call(this,e)},determineDataLimits:function(){var e,t,n,i,r,o,a,s=this,l=s.chart,c=s._adapter,u=s.options,d=u.time.unit||"day",h=ei,f=Xn,p=[],m=[],v=[],g=s._getLabels();for(e=0,n=g.length;e<n;++e)v.push(li(s,g[e]));for(e=0,n=(l.data.datasets||[]).length;e<n;++e)if(l.isDatasetVisible(e))if(r=l.data.datasets[e].data,V.isObject(r[0]))for(m[e]=[],t=0,i=r.length;t<i;++t)o=li(s,r[t]),p.push(o),m[e][t]=o;else m[e]=v.slice(0),a||(p=p.concat(v),a=!0);else m[e]=[];v.length&&(h=Math.min(h,v[0]),f=Math.max(f,v[v.length-1])),p.length&&(p=n>1?function(e){var t,n,i,r={},o=[];for(t=0,n=e.length;t<n;++t)r[i=e[t]]||(r[i]=!0,o.push(i));return o}(p).sort(ii):p.sort(ii),h=Math.min(h,p[0]),f=Math.max(f,p[p.length-1])),h=li(s,ri(u))||h,f=li(s,oi(u))||f,h=h===ei?+c.startOf(Date.now(),d):h,f=f===Xn?+c.endOf(Date.now(),d)+1:f,s.min=Math.min(h,f),s.max=Math.max(h+1,f),s._table=[],s._timestamps={data:p,datasets:m,labels:v}},buildTicks:function(){var e,t,n,i=this,r=i.min,o=i.max,a=i.options,s=a.ticks,l=a.time,c=i._timestamps,u=[],d=i.getLabelCapacity(r),h=s.source,f=a.distribution;for(c="data"===h||"auto"===h&&"series"===f?c.data:"labels"===h?c.labels:function(e,t,n,i){var r,o=e._adapter,a=e.options,s=a.time,l=s.unit||ci(s.minUnit,t,n,i),c=Zn([s.stepSize,s.unitStepSize,1]),u="week"===l&&s.isoWeekday,d=t,h=[];if(u&&(d=+o.startOf(d,"isoWeek",u)),d=+o.startOf(d,u?"day":l),o.diff(n,t,l)>1e5*c)throw t+" and "+n+" are too far apart with stepSize of "+c+" "+l;for(r=d;r<n;r=+o.add(r,c,l))h.push(r);return r!==n&&"ticks"!==a.bounds||h.push(r),h}(i,r,o,d),"ticks"===a.bounds&&c.length&&(r=c[0],o=c[c.length-1]),r=li(i,ri(a))||r,o=li(i,oi(a))||o,e=0,t=c.length;e<t;++e)(n=c[e])>=r&&n<=o&&u.push(n);return i.min=r,i.max=o,i._unit=l.unit||(s.autoSkip?ci(l.minUnit,i.min,i.max,d):function(e,t,n,i,r){var o,a;for(o=ni.length-1;o>=ni.indexOf(n);o--)if(a=ni[o],ti[a].common&&e._adapter.diff(r,i,a)>=t-1)return a;return ni[n?ni.indexOf(n):0]}(i,u.length,l.minUnit,i.min,i.max)),i._majorUnit=s.major.enabled&&"year"!==i._unit?function(e){for(var t=ni.indexOf(e)+1,n=ni.length;t<n;++t)if(ti[ni[t]].common)return ni[t]}(i._unit):void 0,i._table=function(e,t,n,i){if("linear"===i||!e.length)return[{time:t,pos:0},{time:n,pos:1}];var r,o,a,s,l,c=[],u=[t];for(r=0,o=e.length;r<o;++r)(s=e[r])>t&&s<n&&u.push(s);for(u.push(n),r=0,o=u.length;r<o;++r)l=u[r+1],a=u[r-1],s=u[r],void 0!==a&&void 0!==l&&Math.round((l+a)/2)===s||c.push({time:s,pos:r/(o-1)});return c}(i._timestamps.data,r,o,f),i._offsets=function(e,t,n,i,r){var o,a,s=0,l=0;return r.offset&&t.length&&(o=ai(e,"time",t[0],"pos"),s=1===t.length?1-o:(ai(e,"time",t[1],"pos")-o)/2,a=ai(e,"time",t[t.length-1],"pos"),l=1===t.length?a:(a-ai(e,"time",t[t.length-2],"pos"))/2),{start:s,end:l,factor:1/(s+1+l)}}(i._table,u,0,0,a),s.reverse&&u.reverse(),ui(i,u,i._majorUnit)},getLabelForIndex:function(e,t){var n=this,i=n._adapter,r=n.chart.data,o=n.options.time,a=r.labels&&e<r.labels.length?r.labels[e]:"",s=r.datasets[t].data[e];return V.isObject(s)&&(a=n.getRightValue(s)),o.tooltipFormat?i.format(si(n,a),o.tooltipFormat):"string"==typeof a?a:i.format(si(n,a),o.displayFormats.datetime)},tickFormatFunction:function(e,t,n,i){var r=this,o=r._adapter,a=r.options,s=a.time.displayFormats,l=s[r._unit],c=r._majorUnit,u=s[c],d=n[t],h=a.ticks,f=c&&u&&d&&d.major,p=o.format(e,i||(f?u:l)),m=f?h.major:h.minor,v=Zn([m.callback,m.userCallback,h.callback,h.userCallback]);return v?v(p,t,n):p},convertTicksToLabels:function(e){var t,n,i=[];for(t=0,n=e.length;t<n;++t)i.push(this.tickFormatFunction(e[t].value,t,e));return i},getPixelForOffset:function(e){var t=this,n=t._offsets,i=ai(t._table,"time",e,"pos");return t.getPixelForDecimal((n.start+i)*n.factor)},getPixelForValue:function(e,t,n){var i=this,r=null;if(void 0!==t&&void 0!==n&&(r=i._timestamps.datasets[n][t]),null===r&&(r=li(i,e)),null!==r)return i.getPixelForOffset(r)},getPixelForTick:function(e){var t=this.getTicks();return e>=0&&e<t.length?this.getPixelForOffset(t[e].value):null},getValueForPixel:function(e){var t=this,n=t._offsets,i=t.getDecimalForPixel(e)/n.factor-n.end,r=ai(t._table,"pos",i,"time");return t._adapter._create(r)},_getLabelSize:function(e){var t=this,n=t.options.ticks,i=t.ctx.measureText(e).width,r=V.toRadians(t.isHorizontal()?n.maxRotation:n.minRotation),o=Math.cos(r),a=Math.sin(r),s=Jn(n.fontSize,j.global.defaultFontSize);return{w:i*o+s*a,h:i*a+s*o}},getLabelWidth:function(e){return this._getLabelSize(e).w},getLabelCapacity:function(e){var t=this,n=t.options.time,i=n.displayFormats,r=i[n.unit]||i.millisecond,o=t.tickFormatFunction(e,0,ui(t,[e],t._majorUnit),r),a=t._getLabelSize(o),s=Math.floor(t.isHorizontal()?t.width/a.w:t.height/a.h);return t.options.offset&&s--,s>0?s:1}}),hi={position:"bottom",distribution:"linear",bounds:"data",adapters:{},time:{parser:!1,unit:!1,round:!1,displayFormat:!1,isoWeekday:!1,minUnit:"millisecond",displayFormats:{}},ticks:{autoSkip:!1,source:"auto",major:{enabled:!1}}};di._defaults=hi;var fi={category:kn,linear:Ln,logarithmic:Nn,radialLinear:Gn,time:di},pi=t((function(t,n){t.exports=function(){var n,i;function r(){return n.apply(null,arguments)}function o(e){n=e}function a(e){return e instanceof Array||"[object Array]"===Object.prototype.toString.call(e)}function s(e){return null!=e&&"[object Object]"===Object.prototype.toString.call(e)}function l(e){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(e).length;var t;for(t in e)if(e.hasOwnProperty(t))return!1;return!0}function c(e){return void 0===e}function u(e){return"number"==typeof e||"[object Number]"===Object.prototype.toString.call(e)}function d(e){return e instanceof Date||"[object Date]"===Object.prototype.toString.call(e)}function h(e,t){var n,i=[];for(n=0;n<e.length;++n)i.push(t(e[n],n));return i}function f(e,t){return Object.prototype.hasOwnProperty.call(e,t)}function p(e,t){for(var n in t)f(t,n)&&(e[n]=t[n]);return f(t,"toString")&&(e.toString=t.toString),f(t,"valueOf")&&(e.valueOf=t.valueOf),e}function m(e,t,n,i){return Gn(e,t,n,i,!0).utc()}function v(){return{empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],meridiem:null,rfc2822:!1,weekdayMismatch:!1}}function g(e){return null==e._pf&&(e._pf=v()),e._pf}function _(e){if(null==e._isValid){var t=g(e),n=i.call(t.parsedDateParts,(function(e){return null!=e})),r=!isNaN(e._d.getTime())&&t.overflow<0&&!t.empty&&!t.invalidMonth&&!t.invalidWeekday&&!t.weekdayMismatch&&!t.nullInput&&!t.invalidFormat&&!t.userInvalidated&&(!t.meridiem||t.meridiem&&n);if(e._strict&&(r=r&&0===t.charsLeftOver&&0===t.unusedTokens.length&&void 0===t.bigHour),null!=Object.isFrozen&&Object.isFrozen(e))return r;e._isValid=r}return e._isValid}function b(e){var t=m(NaN);return null!=e?p(g(t),e):g(t).userInvalidated=!0,t}i=Array.prototype.some?Array.prototype.some:function(e){for(var t=Object(this),n=t.length>>>0,i=0;i<n;i++)if(i in t&&e.call(this,t[i],i,t))return!0;return!1};var y=r.momentProperties=[];function w(e,t){var n,i,r;if(c(t._isAMomentObject)||(e._isAMomentObject=t._isAMomentObject),c(t._i)||(e._i=t._i),c(t._f)||(e._f=t._f),c(t._l)||(e._l=t._l),c(t._strict)||(e._strict=t._strict),c(t._tzm)||(e._tzm=t._tzm),c(t._isUTC)||(e._isUTC=t._isUTC),c(t._offset)||(e._offset=t._offset),c(t._pf)||(e._pf=g(t)),c(t._locale)||(e._locale=t._locale),y.length>0)for(n=0;n<y.length;n++)c(r=t[i=y[n]])||(e[i]=r);return e}var k=!1;function x(e){w(this,e),this._d=new Date(null!=e._d?e._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===k&&(k=!0,r.updateOffset(this),k=!1)}function S(e){return e instanceof x||null!=e&&null!=e._isAMomentObject}function C(e){return e<0?Math.ceil(e)||0:Math.floor(e)}function M(e){var t=+e,n=0;return 0!==t&&isFinite(t)&&(n=C(t)),n}function T(e,t,n){var i,r=Math.min(e.length,t.length),o=Math.abs(e.length-t.length),a=0;for(i=0;i<r;i++)(n&&e[i]!==t[i]||!n&&M(e[i])!==M(t[i]))&&a++;return a+o}function A(e){!1===r.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+e)}function P(e,t){var n=!0;return p((function(){if(null!=r.deprecationHandler&&r.deprecationHandler(null,e),n){for(var i,o=[],a=0;a<arguments.length;a++){if(i="","object"==typeof arguments[a]){for(var s in i+="\n["+a+"] ",arguments[0])i+=s+": "+arguments[0][s]+", ";i=i.slice(0,-2)}else i=arguments[a];o.push(i)}A(e+"\nArguments: "+Array.prototype.slice.call(o).join("")+"\n"+(new Error).stack),n=!1}return t.apply(this,arguments)}),t)}var L,O={};function q(e,t){null!=r.deprecationHandler&&r.deprecationHandler(e,t),O[e]||(A(t),O[e]=!0)}function E(e){return e instanceof Function||"[object Function]"===Object.prototype.toString.call(e)}function D(e){var t,n;for(n in e)E(t=e[n])?this[n]=t:this["_"+n]=t;this._config=e,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)}function z(e,t){var n,i=p({},e);for(n in t)f(t,n)&&(s(e[n])&&s(t[n])?(i[n]={},p(i[n],e[n]),p(i[n],t[n])):null!=t[n]?i[n]=t[n]:delete i[n]);for(n in e)f(e,n)&&!f(t,n)&&s(e[n])&&(i[n]=p({},i[n]));return i}function N(e){null!=e&&this.set(e)}r.suppressDeprecationWarnings=!1,r.deprecationHandler=null,L=Object.keys?Object.keys:function(e){var t,n=[];for(t in e)f(e,t)&&n.push(t);return n};var j={sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"};function R(e,t,n){var i=this._calendar[e]||this._calendar.sameElse;return E(i)?i.call(t,n):i}var I={LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"};function $(e){var t=this._longDateFormat[e],n=this._longDateFormat[e.toUpperCase()];return t||!n?t:(this._longDateFormat[e]=n.replace(/MMMM|MM|DD|dddd/g,(function(e){return e.slice(1)})),this._longDateFormat[e])}var F="Invalid date";function B(){return this._invalidDate}var V="%d",H=/\d{1,2}/;function W(e){return this._ordinal.replace("%d",e)}var U={future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",M:"a month",MM:"%d months",y:"a year",yy:"%d years"};function Y(e,t,n,i){var r=this._relativeTime[n];return E(r)?r(e,t,n,i):r.replace(/%d/i,e)}function G(e,t){var n=this._relativeTime[e>0?"future":"past"];return E(n)?n(t):n.replace(/%s/i,t)}var Q={};function K(e,t){var n=e.toLowerCase();Q[n]=Q[n+"s"]=Q[t]=e}function Z(e){return"string"==typeof e?Q[e]||Q[e.toLowerCase()]:void 0}function J(e){var t,n,i={};for(n in e)f(e,n)&&(t=Z(n))&&(i[t]=e[n]);return i}var X={};function ee(e,t){X[e]=t}function te(e){var t=[];for(var n in e)t.push({unit:n,priority:X[n]});return t.sort((function(e,t){return e.priority-t.priority})),t}function ne(e,t,n){var i=""+Math.abs(e),r=t-i.length;return(e>=0?n?"+":"":"-")+Math.pow(10,Math.max(0,r)).toString().substr(1)+i}var ie=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|YYYYYY|YYYYY|YYYY|YY|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,re=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,oe={},ae={};function se(e,t,n,i){var r=i;"string"==typeof i&&(r=function(){return this[i]()}),e&&(ae[e]=r),t&&(ae[t[0]]=function(){return ne(r.apply(this,arguments),t[1],t[2])}),n&&(ae[n]=function(){return this.localeData().ordinal(r.apply(this,arguments),e)})}function le(e){return e.match(/\[[\s\S]/)?e.replace(/^\[|\]$/g,""):e.replace(/\\/g,"")}function ce(e){var t,n,i=e.match(ie);for(t=0,n=i.length;t<n;t++)ae[i[t]]?i[t]=ae[i[t]]:i[t]=le(i[t]);return function(t){var r,o="";for(r=0;r<n;r++)o+=E(i[r])?i[r].call(t,e):i[r];return o}}function ue(e,t){return e.isValid()?(t=de(t,e.localeData()),oe[t]=oe[t]||ce(t),oe[t](e)):e.localeData().invalidDate()}function de(e,t){var n=5;function i(e){return t.longDateFormat(e)||e}for(re.lastIndex=0;n>=0&&re.test(e);)e=e.replace(re,i),re.lastIndex=0,n-=1;return e}var he=/\d/,fe=/\d\d/,pe=/\d{3}/,me=/\d{4}/,ve=/[+-]?\d{6}/,ge=/\d\d?/,_e=/\d\d\d\d?/,be=/\d\d\d\d\d\d?/,ye=/\d{1,3}/,we=/\d{1,4}/,ke=/[+-]?\d{1,6}/,xe=/\d+/,Se=/[+-]?\d+/,Ce=/Z|[+-]\d\d:?\d\d/gi,Me=/Z|[+-]\d\d(?::?\d\d)?/gi,Te=/[+-]?\d+(\.\d{1,3})?/,Ae=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i,Pe={};function Le(e,t,n){Pe[e]=E(t)?t:function(e,i){return e&&n?n:t}}function Oe(e,t){return f(Pe,e)?Pe[e](t._strict,t._locale):new RegExp(qe(e))}function qe(e){return Ee(e.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(e,t,n,i,r){return t||n||i||r})))}function Ee(e){return e.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}var De={};function ze(e,t){var n,i=t;for("string"==typeof e&&(e=[e]),u(t)&&(i=function(e,n){n[t]=M(e)}),n=0;n<e.length;n++)De[e[n]]=i}function Ne(e,t){ze(e,(function(e,n,i,r){i._w=i._w||{},t(e,i._w,i,r)}))}function je(e,t,n){null!=t&&f(De,e)&&De[e](t,n._a,n,e)}var Re=0,Ie=1,$e=2,Fe=3,Be=4,Ve=5,He=6,We=7,Ue=8;function Ye(e){return Ge(e)?366:365}function Ge(e){return e%4==0&&e%100!=0||e%400==0}se("Y",0,0,(function(){var e=this.year();return e<=9999?""+e:"+"+e})),se(0,["YY",2],0,(function(){return this.year()%100})),se(0,["YYYY",4],0,"year"),se(0,["YYYYY",5],0,"year"),se(0,["YYYYYY",6,!0],0,"year"),K("year","y"),ee("year",1),Le("Y",Se),Le("YY",ge,fe),Le("YYYY",we,me),Le("YYYYY",ke,ve),Le("YYYYYY",ke,ve),ze(["YYYYY","YYYYYY"],Re),ze("YYYY",(function(e,t){t[Re]=2===e.length?r.parseTwoDigitYear(e):M(e)})),ze("YY",(function(e,t){t[Re]=r.parseTwoDigitYear(e)})),ze("Y",(function(e,t){t[Re]=parseInt(e,10)})),r.parseTwoDigitYear=function(e){return M(e)+(M(e)>68?1900:2e3)};var Qe,Ke=Je("FullYear",!0);function Ze(){return Ge(this.year())}function Je(e,t){return function(n){return null!=n?(et(this,e,n),r.updateOffset(this,t),this):Xe(this,e)}}function Xe(e,t){return e.isValid()?e._d["get"+(e._isUTC?"UTC":"")+t]():NaN}function et(e,t,n){e.isValid()&&!isNaN(n)&&("FullYear"===t&&Ge(e.year())&&1===e.month()&&29===e.date()?e._d["set"+(e._isUTC?"UTC":"")+t](n,e.month(),rt(n,e.month())):e._d["set"+(e._isUTC?"UTC":"")+t](n))}function tt(e){return E(this[e=Z(e)])?this[e]():this}function nt(e,t){if("object"==typeof e)for(var n=te(e=J(e)),i=0;i<n.length;i++)this[n[i].unit](e[n[i].unit]);else if(E(this[e=Z(e)]))return this[e](t);return this}function it(e,t){return(e%t+t)%t}function rt(e,t){if(isNaN(e)||isNaN(t))return NaN;var n=it(t,12);return e+=(t-n)/12,1===n?Ge(e)?29:28:31-n%7%2}Qe=Array.prototype.indexOf?Array.prototype.indexOf:function(e){var t;for(t=0;t<this.length;++t)if(this[t]===e)return t;return-1},se("M",["MM",2],"Mo",(function(){return this.month()+1})),se("MMM",0,0,(function(e){return this.localeData().monthsShort(this,e)})),se("MMMM",0,0,(function(e){return this.localeData().months(this,e)})),K("month","M"),ee("month",8),Le("M",ge),Le("MM",ge,fe),Le("MMM",(function(e,t){return t.monthsShortRegex(e)})),Le("MMMM",(function(e,t){return t.monthsRegex(e)})),ze(["M","MM"],(function(e,t){t[Ie]=M(e)-1})),ze(["MMM","MMMM"],(function(e,t,n,i){var r=n._locale.monthsParse(e,i,n._strict);null!=r?t[Ie]=r:g(n).invalidMonth=e}));var ot=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,at="January_February_March_April_May_June_July_August_September_October_November_December".split("_");function st(e,t){return e?a(this._months)?this._months[e.month()]:this._months[(this._months.isFormat||ot).test(t)?"format":"standalone"][e.month()]:a(this._months)?this._months:this._months.standalone}var lt="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_");function ct(e,t){return e?a(this._monthsShort)?this._monthsShort[e.month()]:this._monthsShort[ot.test(t)?"format":"standalone"][e.month()]:a(this._monthsShort)?this._monthsShort:this._monthsShort.standalone}function ut(e,t,n){var i,r,o,a=e.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],i=0;i<12;++i)o=m([2e3,i]),this._shortMonthsParse[i]=this.monthsShort(o,"").toLocaleLowerCase(),this._longMonthsParse[i]=this.months(o,"").toLocaleLowerCase();return n?"MMM"===t?-1!==(r=Qe.call(this._shortMonthsParse,a))?r:null:-1!==(r=Qe.call(this._longMonthsParse,a))?r:null:"MMM"===t?-1!==(r=Qe.call(this._shortMonthsParse,a))||-1!==(r=Qe.call(this._longMonthsParse,a))?r:null:-1!==(r=Qe.call(this._longMonthsParse,a))||-1!==(r=Qe.call(this._shortMonthsParse,a))?r:null}function dt(e,t,n){var i,r,o;if(this._monthsParseExact)return ut.call(this,e,t,n);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),i=0;i<12;i++){if(r=m([2e3,i]),n&&!this._longMonthsParse[i]&&(this._longMonthsParse[i]=new RegExp("^"+this.months(r,"").replace(".","")+"$","i"),this._shortMonthsParse[i]=new RegExp("^"+this.monthsShort(r,"").replace(".","")+"$","i")),n||this._monthsParse[i]||(o="^"+this.months(r,"")+"|^"+this.monthsShort(r,""),this._monthsParse[i]=new RegExp(o.replace(".",""),"i")),n&&"MMMM"===t&&this._longMonthsParse[i].test(e))return i;if(n&&"MMM"===t&&this._shortMonthsParse[i].test(e))return i;if(!n&&this._monthsParse[i].test(e))return i}}function ht(e,t){var n;if(!e.isValid())return e;if("string"==typeof t)if(/^\d+$/.test(t))t=M(t);else if(!u(t=e.localeData().monthsParse(t)))return e;return n=Math.min(e.date(),rt(e.year(),t)),e._d["set"+(e._isUTC?"UTC":"")+"Month"](t,n),e}function ft(e){return null!=e?(ht(this,e),r.updateOffset(this,!0),this):Xe(this,"Month")}function pt(){return rt(this.year(),this.month())}var mt=Ae;function vt(e){return this._monthsParseExact?(f(this,"_monthsRegex")||bt.call(this),e?this._monthsShortStrictRegex:this._monthsShortRegex):(f(this,"_monthsShortRegex")||(this._monthsShortRegex=mt),this._monthsShortStrictRegex&&e?this._monthsShortStrictRegex:this._monthsShortRegex)}var gt=Ae;function _t(e){return this._monthsParseExact?(f(this,"_monthsRegex")||bt.call(this),e?this._monthsStrictRegex:this._monthsRegex):(f(this,"_monthsRegex")||(this._monthsRegex=gt),this._monthsStrictRegex&&e?this._monthsStrictRegex:this._monthsRegex)}function bt(){function e(e,t){return t.length-e.length}var t,n,i=[],r=[],o=[];for(t=0;t<12;t++)n=m([2e3,t]),i.push(this.monthsShort(n,"")),r.push(this.months(n,"")),o.push(this.months(n,"")),o.push(this.monthsShort(n,""));for(i.sort(e),r.sort(e),o.sort(e),t=0;t<12;t++)i[t]=Ee(i[t]),r[t]=Ee(r[t]);for(t=0;t<24;t++)o[t]=Ee(o[t]);this._monthsRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+r.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+i.join("|")+")","i")}function yt(e,t,n,i,r,o,a){var s;return e<100&&e>=0?(s=new Date(e+400,t,n,i,r,o,a),isFinite(s.getFullYear())&&s.setFullYear(e)):s=new Date(e,t,n,i,r,o,a),s}function wt(e){var t;if(e<100&&e>=0){var n=Array.prototype.slice.call(arguments);n[0]=e+400,t=new Date(Date.UTC.apply(null,n)),isFinite(t.getUTCFullYear())&&t.setUTCFullYear(e)}else t=new Date(Date.UTC.apply(null,arguments));return t}function kt(e,t,n){var i=7+t-n;return-(7+wt(e,0,i).getUTCDay()-t)%7+i-1}function xt(e,t,n,i,r){var o,a,s=1+7*(t-1)+(7+n-i)%7+kt(e,i,r);return s<=0?a=Ye(o=e-1)+s:s>Ye(e)?(o=e+1,a=s-Ye(e)):(o=e,a=s),{year:o,dayOfYear:a}}function St(e,t,n){var i,r,o=kt(e.year(),t,n),a=Math.floor((e.dayOfYear()-o-1)/7)+1;return a<1?i=a+Ct(r=e.year()-1,t,n):a>Ct(e.year(),t,n)?(i=a-Ct(e.year(),t,n),r=e.year()+1):(r=e.year(),i=a),{week:i,year:r}}function Ct(e,t,n){var i=kt(e,t,n),r=kt(e+1,t,n);return(Ye(e)-i+r)/7}function Mt(e){return St(e,this._week.dow,this._week.doy).week}se("w",["ww",2],"wo","week"),se("W",["WW",2],"Wo","isoWeek"),K("week","w"),K("isoWeek","W"),ee("week",5),ee("isoWeek",5),Le("w",ge),Le("ww",ge,fe),Le("W",ge),Le("WW",ge,fe),Ne(["w","ww","W","WW"],(function(e,t,n,i){t[i.substr(0,1)]=M(e)}));var Tt={dow:0,doy:6};function At(){return this._week.dow}function Pt(){return this._week.doy}function Lt(e){var t=this.localeData().week(this);return null==e?t:this.add(7*(e-t),"d")}function Ot(e){var t=St(this,1,4).week;return null==e?t:this.add(7*(e-t),"d")}function qt(e,t){return"string"!=typeof e?e:isNaN(e)?"number"==typeof(e=t.weekdaysParse(e))?e:null:parseInt(e,10)}function Et(e,t){return"string"==typeof e?t.weekdaysParse(e)%7||7:isNaN(e)?null:e}function Dt(e,t){return e.slice(t,7).concat(e.slice(0,t))}se("d",0,"do","day"),se("dd",0,0,(function(e){return this.localeData().weekdaysMin(this,e)})),se("ddd",0,0,(function(e){return this.localeData().weekdaysShort(this,e)})),se("dddd",0,0,(function(e){return this.localeData().weekdays(this,e)})),se("e",0,0,"weekday"),se("E",0,0,"isoWeekday"),K("day","d"),K("weekday","e"),K("isoWeekday","E"),ee("day",11),ee("weekday",11),ee("isoWeekday",11),Le("d",ge),Le("e",ge),Le("E",ge),Le("dd",(function(e,t){return t.weekdaysMinRegex(e)})),Le("ddd",(function(e,t){return t.weekdaysShortRegex(e)})),Le("dddd",(function(e,t){return t.weekdaysRegex(e)})),Ne(["dd","ddd","dddd"],(function(e,t,n,i){var r=n._locale.weekdaysParse(e,i,n._strict);null!=r?t.d=r:g(n).invalidWeekday=e})),Ne(["d","e","E"],(function(e,t,n,i){t[i]=M(e)}));var zt="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_");function Nt(e,t){var n=a(this._weekdays)?this._weekdays:this._weekdays[e&&!0!==e&&this._weekdays.isFormat.test(t)?"format":"standalone"];return!0===e?Dt(n,this._week.dow):e?n[e.day()]:n}var jt="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_");function Rt(e){return!0===e?Dt(this._weekdaysShort,this._week.dow):e?this._weekdaysShort[e.day()]:this._weekdaysShort}var It="Su_Mo_Tu_We_Th_Fr_Sa".split("_");function $t(e){return!0===e?Dt(this._weekdaysMin,this._week.dow):e?this._weekdaysMin[e.day()]:this._weekdaysMin}function Ft(e,t,n){var i,r,o,a=e.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],i=0;i<7;++i)o=m([2e3,1]).day(i),this._minWeekdaysParse[i]=this.weekdaysMin(o,"").toLocaleLowerCase(),this._shortWeekdaysParse[i]=this.weekdaysShort(o,"").toLocaleLowerCase(),this._weekdaysParse[i]=this.weekdays(o,"").toLocaleLowerCase();return n?"dddd"===t?-1!==(r=Qe.call(this._weekdaysParse,a))?r:null:"ddd"===t?-1!==(r=Qe.call(this._shortWeekdaysParse,a))?r:null:-1!==(r=Qe.call(this._minWeekdaysParse,a))?r:null:"dddd"===t?-1!==(r=Qe.call(this._weekdaysParse,a))||-1!==(r=Qe.call(this._shortWeekdaysParse,a))||-1!==(r=Qe.call(this._minWeekdaysParse,a))?r:null:"ddd"===t?-1!==(r=Qe.call(this._shortWeekdaysParse,a))||-1!==(r=Qe.call(this._weekdaysParse,a))||-1!==(r=Qe.call(this._minWeekdaysParse,a))?r:null:-1!==(r=Qe.call(this._minWeekdaysParse,a))||-1!==(r=Qe.call(this._weekdaysParse,a))||-1!==(r=Qe.call(this._shortWeekdaysParse,a))?r:null}function Bt(e,t,n){var i,r,o;if(this._weekdaysParseExact)return Ft.call(this,e,t,n);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),i=0;i<7;i++){if(r=m([2e3,1]).day(i),n&&!this._fullWeekdaysParse[i]&&(this._fullWeekdaysParse[i]=new RegExp("^"+this.weekdays(r,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[i]=new RegExp("^"+this.weekdaysShort(r,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[i]=new RegExp("^"+this.weekdaysMin(r,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[i]||(o="^"+this.weekdays(r,"")+"|^"+this.weekdaysShort(r,"")+"|^"+this.weekdaysMin(r,""),this._weekdaysParse[i]=new RegExp(o.replace(".",""),"i")),n&&"dddd"===t&&this._fullWeekdaysParse[i].test(e))return i;if(n&&"ddd"===t&&this._shortWeekdaysParse[i].test(e))return i;if(n&&"dd"===t&&this._minWeekdaysParse[i].test(e))return i;if(!n&&this._weekdaysParse[i].test(e))return i}}function Vt(e){if(!this.isValid())return null!=e?this:NaN;var t=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=e?(e=qt(e,this.localeData()),this.add(e-t,"d")):t}function Ht(e){if(!this.isValid())return null!=e?this:NaN;var t=(this.day()+7-this.localeData()._week.dow)%7;return null==e?t:this.add(e-t,"d")}function Wt(e){if(!this.isValid())return null!=e?this:NaN;if(null!=e){var t=Et(e,this.localeData());return this.day(this.day()%7?t:t-7)}return this.day()||7}var Ut=Ae;function Yt(e){return this._weekdaysParseExact?(f(this,"_weekdaysRegex")||Jt.call(this),e?this._weekdaysStrictRegex:this._weekdaysRegex):(f(this,"_weekdaysRegex")||(this._weekdaysRegex=Ut),this._weekdaysStrictRegex&&e?this._weekdaysStrictRegex:this._weekdaysRegex)}var Gt=Ae;function Qt(e){return this._weekdaysParseExact?(f(this,"_weekdaysRegex")||Jt.call(this),e?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(f(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=Gt),this._weekdaysShortStrictRegex&&e?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)}var Kt=Ae;function Zt(e){return this._weekdaysParseExact?(f(this,"_weekdaysRegex")||Jt.call(this),e?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(f(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=Kt),this._weekdaysMinStrictRegex&&e?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)}function Jt(){function e(e,t){return t.length-e.length}var t,n,i,r,o,a=[],s=[],l=[],c=[];for(t=0;t<7;t++)n=m([2e3,1]).day(t),i=this.weekdaysMin(n,""),r=this.weekdaysShort(n,""),o=this.weekdays(n,""),a.push(i),s.push(r),l.push(o),c.push(i),c.push(r),c.push(o);for(a.sort(e),s.sort(e),l.sort(e),c.sort(e),t=0;t<7;t++)s[t]=Ee(s[t]),l[t]=Ee(l[t]),c[t]=Ee(c[t]);this._weekdaysRegex=new RegExp("^("+c.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+l.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+s.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+a.join("|")+")","i")}function Xt(){return this.hours()%12||12}function en(){return this.hours()||24}function tn(e,t){se(e,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),t)}))}function nn(e,t){return t._meridiemParse}function rn(e){return"p"===(e+"").toLowerCase().charAt(0)}se("H",["HH",2],0,"hour"),se("h",["hh",2],0,Xt),se("k",["kk",2],0,en),se("hmm",0,0,(function(){return""+Xt.apply(this)+ne(this.minutes(),2)})),se("hmmss",0,0,(function(){return""+Xt.apply(this)+ne(this.minutes(),2)+ne(this.seconds(),2)})),se("Hmm",0,0,(function(){return""+this.hours()+ne(this.minutes(),2)})),se("Hmmss",0,0,(function(){return""+this.hours()+ne(this.minutes(),2)+ne(this.seconds(),2)})),tn("a",!0),tn("A",!1),K("hour","h"),ee("hour",13),Le("a",nn),Le("A",nn),Le("H",ge),Le("h",ge),Le("k",ge),Le("HH",ge,fe),Le("hh",ge,fe),Le("kk",ge,fe),Le("hmm",_e),Le("hmmss",be),Le("Hmm",_e),Le("Hmmss",be),ze(["H","HH"],Fe),ze(["k","kk"],(function(e,t,n){var i=M(e);t[Fe]=24===i?0:i})),ze(["a","A"],(function(e,t,n){n._isPm=n._locale.isPM(e),n._meridiem=e})),ze(["h","hh"],(function(e,t,n){t[Fe]=M(e),g(n).bigHour=!0})),ze("hmm",(function(e,t,n){var i=e.length-2;t[Fe]=M(e.substr(0,i)),t[Be]=M(e.substr(i)),g(n).bigHour=!0})),ze("hmmss",(function(e,t,n){var i=e.length-4,r=e.length-2;t[Fe]=M(e.substr(0,i)),t[Be]=M(e.substr(i,2)),t[Ve]=M(e.substr(r)),g(n).bigHour=!0})),ze("Hmm",(function(e,t,n){var i=e.length-2;t[Fe]=M(e.substr(0,i)),t[Be]=M(e.substr(i))})),ze("Hmmss",(function(e,t,n){var i=e.length-4,r=e.length-2;t[Fe]=M(e.substr(0,i)),t[Be]=M(e.substr(i,2)),t[Ve]=M(e.substr(r))}));var on=/[ap]\.?m?\.?/i;function an(e,t,n){return e>11?n?"pm":"PM":n?"am":"AM"}var sn,ln=Je("Hours",!0),cn={calendar:j,longDateFormat:I,invalidDate:F,ordinal:V,dayOfMonthOrdinalParse:H,relativeTime:U,months:at,monthsShort:lt,week:Tt,weekdays:zt,weekdaysMin:It,weekdaysShort:jt,meridiemParse:on},un={},dn={};function hn(e){return e?e.toLowerCase().replace("_","-"):e}function fn(e){for(var t,n,i,r,o=0;o<e.length;){for(t=(r=hn(e[o]).split("-")).length,n=(n=hn(e[o+1]))?n.split("-"):null;t>0;){if(i=pn(r.slice(0,t).join("-")))return i;if(n&&n.length>=t&&T(r,n,!0)>=t-1)break;t--}o++}return sn}function pn(n){var i=null;if(!un[n]&&t&&t.exports)try{i=sn._abbr,e(),mn(i)}catch(e){}return un[n]}function mn(e,t){var n;return e&&((n=c(t)?_n(e):vn(e,t))?sn=n:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+e+" not found. Did you forget to load it?")),sn._abbr}function vn(e,t){if(null!==t){var n,i=cn;if(t.abbr=e,null!=un[e])q("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),i=un[e]._config;else if(null!=t.parentLocale)if(null!=un[t.parentLocale])i=un[t.parentLocale]._config;else{if(null==(n=pn(t.parentLocale)))return dn[t.parentLocale]||(dn[t.parentLocale]=[]),dn[t.parentLocale].push({name:e,config:t}),null;i=n._config}return un[e]=new N(z(i,t)),dn[e]&&dn[e].forEach((function(e){vn(e.name,e.config)})),mn(e),un[e]}return delete un[e],null}function gn(e,t){if(null!=t){var n,i,r=cn;null!=(i=pn(e))&&(r=i._config),(n=new N(t=z(r,t))).parentLocale=un[e],un[e]=n,mn(e)}else null!=un[e]&&(null!=un[e].parentLocale?un[e]=un[e].parentLocale:null!=un[e]&&delete un[e]);return un[e]}function _n(e){var t;if(e&&e._locale&&e._locale._abbr&&(e=e._locale._abbr),!e)return sn;if(!a(e)){if(t=pn(e))return t;e=[e]}return fn(e)}function bn(){return L(un)}function yn(e){var t,n=e._a;return n&&-2===g(e).overflow&&(t=n[Ie]<0||n[Ie]>11?Ie:n[$e]<1||n[$e]>rt(n[Re],n[Ie])?$e:n[Fe]<0||n[Fe]>24||24===n[Fe]&&(0!==n[Be]||0!==n[Ve]||0!==n[He])?Fe:n[Be]<0||n[Be]>59?Be:n[Ve]<0||n[Ve]>59?Ve:n[He]<0||n[He]>999?He:-1,g(e)._overflowDayOfYear&&(t<Re||t>$e)&&(t=$e),g(e)._overflowWeeks&&-1===t&&(t=We),g(e)._overflowWeekday&&-1===t&&(t=Ue),g(e).overflow=t),e}function wn(e,t,n){return null!=e?e:null!=t?t:n}function kn(e){var t=new Date(r.now());return e._useUTC?[t.getUTCFullYear(),t.getUTCMonth(),t.getUTCDate()]:[t.getFullYear(),t.getMonth(),t.getDate()]}function xn(e){var t,n,i,r,o,a=[];if(!e._d){for(i=kn(e),e._w&&null==e._a[$e]&&null==e._a[Ie]&&Sn(e),null!=e._dayOfYear&&(o=wn(e._a[Re],i[Re]),(e._dayOfYear>Ye(o)||0===e._dayOfYear)&&(g(e)._overflowDayOfYear=!0),n=wt(o,0,e._dayOfYear),e._a[Ie]=n.getUTCMonth(),e._a[$e]=n.getUTCDate()),t=0;t<3&&null==e._a[t];++t)e._a[t]=a[t]=i[t];for(;t<7;t++)e._a[t]=a[t]=null==e._a[t]?2===t?1:0:e._a[t];24===e._a[Fe]&&0===e._a[Be]&&0===e._a[Ve]&&0===e._a[He]&&(e._nextDay=!0,e._a[Fe]=0),e._d=(e._useUTC?wt:yt).apply(null,a),r=e._useUTC?e._d.getUTCDay():e._d.getDay(),null!=e._tzm&&e._d.setUTCMinutes(e._d.getUTCMinutes()-e._tzm),e._nextDay&&(e._a[Fe]=24),e._w&&void 0!==e._w.d&&e._w.d!==r&&(g(e).weekdayMismatch=!0)}}function Sn(e){var t,n,i,r,o,a,s,l;if(null!=(t=e._w).GG||null!=t.W||null!=t.E)o=1,a=4,n=wn(t.GG,e._a[Re],St(Qn(),1,4).year),i=wn(t.W,1),((r=wn(t.E,1))<1||r>7)&&(l=!0);else{o=e._locale._week.dow,a=e._locale._week.doy;var c=St(Qn(),o,a);n=wn(t.gg,e._a[Re],c.year),i=wn(t.w,c.week),null!=t.d?((r=t.d)<0||r>6)&&(l=!0):null!=t.e?(r=t.e+o,(t.e<0||t.e>6)&&(l=!0)):r=o}i<1||i>Ct(n,o,a)?g(e)._overflowWeeks=!0:null!=l?g(e)._overflowWeekday=!0:(s=xt(n,i,r,o,a),e._a[Re]=s.year,e._dayOfYear=s.dayOfYear)}var Cn=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,Mn=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([\+\-]\d\d(?::?\d\d)?|\s*Z)?)?$/,Tn=/Z|[+-]\d\d(?::?\d\d)?/,An=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/]],Pn=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],Ln=/^\/?Date\((\-?\d+)/i;function On(e){var t,n,i,r,o,a,s=e._i,l=Cn.exec(s)||Mn.exec(s);if(l){for(g(e).iso=!0,t=0,n=An.length;t<n;t++)if(An[t][1].exec(l[1])){r=An[t][0],i=!1!==An[t][2];break}if(null==r)return void(e._isValid=!1);if(l[3]){for(t=0,n=Pn.length;t<n;t++)if(Pn[t][1].exec(l[3])){o=(l[2]||" ")+Pn[t][0];break}if(null==o)return void(e._isValid=!1)}if(!i&&null!=o)return void(e._isValid=!1);if(l[4]){if(!Tn.exec(l[4]))return void(e._isValid=!1);a="Z"}e._f=r+(o||"")+(a||""),Fn(e)}else e._isValid=!1}var qn=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/;function En(e,t,n,i,r,o){var a=[Dn(e),lt.indexOf(t),parseInt(n,10),parseInt(i,10),parseInt(r,10)];return o&&a.push(parseInt(o,10)),a}function Dn(e){var t=parseInt(e,10);return t<=49?2e3+t:t<=999?1900+t:t}function zn(e){return e.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,"")}function Nn(e,t,n){return!e||jt.indexOf(e)===new Date(t[0],t[1],t[2]).getDay()||(g(n).weekdayMismatch=!0,n._isValid=!1,!1)}var jn={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function Rn(e,t,n){if(e)return jn[e];if(t)return 0;var i=parseInt(n,10),r=i%100;return(i-r)/100*60+r}function In(e){var t=qn.exec(zn(e._i));if(t){var n=En(t[4],t[3],t[2],t[5],t[6],t[7]);if(!Nn(t[1],n,e))return;e._a=n,e._tzm=Rn(t[8],t[9],t[10]),e._d=wt.apply(null,e._a),e._d.setUTCMinutes(e._d.getUTCMinutes()-e._tzm),g(e).rfc2822=!0}else e._isValid=!1}function $n(e){var t=Ln.exec(e._i);null===t?(On(e),!1===e._isValid&&(delete e._isValid,In(e),!1===e._isValid&&(delete e._isValid,r.createFromInputFallback(e)))):e._d=new Date(+t[1])}function Fn(e){if(e._f!==r.ISO_8601)if(e._f!==r.RFC_2822){e._a=[],g(e).empty=!0;var t,n,i,o,a,s=""+e._i,l=s.length,c=0;for(i=de(e._f,e._locale).match(ie)||[],t=0;t<i.length;t++)o=i[t],(n=(s.match(Oe(o,e))||[])[0])&&((a=s.substr(0,s.indexOf(n))).length>0&&g(e).unusedInput.push(a),s=s.slice(s.indexOf(n)+n.length),c+=n.length),ae[o]?(n?g(e).empty=!1:g(e).unusedTokens.push(o),je(o,n,e)):e._strict&&!n&&g(e).unusedTokens.push(o);g(e).charsLeftOver=l-c,s.length>0&&g(e).unusedInput.push(s),e._a[Fe]<=12&&!0===g(e).bigHour&&e._a[Fe]>0&&(g(e).bigHour=void 0),g(e).parsedDateParts=e._a.slice(0),g(e).meridiem=e._meridiem,e._a[Fe]=Bn(e._locale,e._a[Fe],e._meridiem),xn(e),yn(e)}else In(e);else On(e)}function Bn(e,t,n){var i;return null==n?t:null!=e.meridiemHour?e.meridiemHour(t,n):null!=e.isPM?((i=e.isPM(n))&&t<12&&(t+=12),i||12!==t||(t=0),t):t}function Vn(e){var t,n,i,r,o;if(0===e._f.length)return g(e).invalidFormat=!0,void(e._d=new Date(NaN));for(r=0;r<e._f.length;r++)o=0,t=w({},e),null!=e._useUTC&&(t._useUTC=e._useUTC),t._f=e._f[r],Fn(t),_(t)&&(o+=g(t).charsLeftOver,o+=10*g(t).unusedTokens.length,g(t).score=o,(null==i||o<i)&&(i=o,n=t));p(e,n||t)}function Hn(e){if(!e._d){var t=J(e._i);e._a=h([t.year,t.month,t.day||t.date,t.hour,t.minute,t.second,t.millisecond],(function(e){return e&&parseInt(e,10)})),xn(e)}}function Wn(e){var t=new x(yn(Un(e)));return t._nextDay&&(t.add(1,"d"),t._nextDay=void 0),t}function Un(e){var t=e._i,n=e._f;return e._locale=e._locale||_n(e._l),null===t||void 0===n&&""===t?b({nullInput:!0}):("string"==typeof t&&(e._i=t=e._locale.preparse(t)),S(t)?new x(yn(t)):(d(t)?e._d=t:a(n)?Vn(e):n?Fn(e):Yn(e),_(e)||(e._d=null),e))}function Yn(e){var t=e._i;c(t)?e._d=new Date(r.now()):d(t)?e._d=new Date(t.valueOf()):"string"==typeof t?$n(e):a(t)?(e._a=h(t.slice(0),(function(e){return parseInt(e,10)})),xn(e)):s(t)?Hn(e):u(t)?e._d=new Date(t):r.createFromInputFallback(e)}function Gn(e,t,n,i,r){var o={};return!0!==n&&!1!==n||(i=n,n=void 0),(s(e)&&l(e)||a(e)&&0===e.length)&&(e=void 0),o._isAMomentObject=!0,o._useUTC=o._isUTC=r,o._l=n,o._i=e,o._f=t,o._strict=i,Wn(o)}function Qn(e,t,n,i){return Gn(e,t,n,i,!1)}r.createFromInputFallback=P("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(e){e._d=new Date(e._i+(e._useUTC?" UTC":""))})),r.ISO_8601=function(){},r.RFC_2822=function(){};var Kn=P("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var e=Qn.apply(null,arguments);return this.isValid()&&e.isValid()?e<this?this:e:b()})),Zn=P("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var e=Qn.apply(null,arguments);return this.isValid()&&e.isValid()?e>this?this:e:b()}));function Jn(e,t){var n,i;if(1===t.length&&a(t[0])&&(t=t[0]),!t.length)return Qn();for(n=t[0],i=1;i<t.length;++i)t[i].isValid()&&!t[i][e](n)||(n=t[i]);return n}function Xn(){return Jn("isBefore",[].slice.call(arguments,0))}function ei(){return Jn("isAfter",[].slice.call(arguments,0))}var ti=function(){return Date.now?Date.now():+new Date},ni=["year","quarter","month","week","day","hour","minute","second","millisecond"];function ii(e){for(var t in e)if(-1===Qe.call(ni,t)||null!=e[t]&&isNaN(e[t]))return!1;for(var n=!1,i=0;i<ni.length;++i)if(e[ni[i]]){if(n)return!1;parseFloat(e[ni[i]])!==M(e[ni[i]])&&(n=!0)}return!0}function ri(){return this._isValid}function oi(){return Ti(NaN)}function ai(e){var t=J(e),n=t.year||0,i=t.quarter||0,r=t.month||0,o=t.week||t.isoWeek||0,a=t.day||0,s=t.hour||0,l=t.minute||0,c=t.second||0,u=t.millisecond||0;this._isValid=ii(t),this._milliseconds=+u+1e3*c+6e4*l+1e3*s*60*60,this._days=+a+7*o,this._months=+r+3*i+12*n,this._data={},this._locale=_n(),this._bubble()}function si(e){return e instanceof ai}function li(e){return e<0?-1*Math.round(-1*e):Math.round(e)}function ci(e,t){se(e,0,0,(function(){var e=this.utcOffset(),n="+";return e<0&&(e=-e,n="-"),n+ne(~~(e/60),2)+t+ne(~~e%60,2)}))}ci("Z",":"),ci("ZZ",""),Le("Z",Me),Le("ZZ",Me),ze(["Z","ZZ"],(function(e,t,n){n._useUTC=!0,n._tzm=di(Me,e)}));var ui=/([\+\-]|\d\d)/gi;function di(e,t){var n=(t||"").match(e);if(null===n)return null;var i=((n[n.length-1]||[])+"").match(ui)||["-",0,0],r=60*i[1]+M(i[2]);return 0===r?0:"+"===i[0]?r:-r}function hi(e,t){var n,i;return t._isUTC?(n=t.clone(),i=(S(e)||d(e)?e.valueOf():Qn(e).valueOf())-n.valueOf(),n._d.setTime(n._d.valueOf()+i),r.updateOffset(n,!1),n):Qn(e).local()}function fi(e){return 15*-Math.round(e._d.getTimezoneOffset()/15)}function pi(e,t,n){var i,o=this._offset||0;if(!this.isValid())return null!=e?this:NaN;if(null!=e){if("string"==typeof e){if(null===(e=di(Me,e)))return this}else Math.abs(e)<16&&!n&&(e*=60);return!this._isUTC&&t&&(i=fi(this)),this._offset=e,this._isUTC=!0,null!=i&&this.add(i,"m"),o!==e&&(!t||this._changeInProgress?qi(this,Ti(e-o,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,r.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?o:fi(this)}function mi(e,t){return null!=e?("string"!=typeof e&&(e=-e),this.utcOffset(e,t),this):-this.utcOffset()}function vi(e){return this.utcOffset(0,e)}function gi(e){return this._isUTC&&(this.utcOffset(0,e),this._isUTC=!1,e&&this.subtract(fi(this),"m")),this}function _i(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var e=di(Ce,this._i);null!=e?this.utcOffset(e):this.utcOffset(0,!0)}return this}function bi(e){return!!this.isValid()&&(e=e?Qn(e).utcOffset():0,(this.utcOffset()-e)%60==0)}function yi(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()}function wi(){if(!c(this._isDSTShifted))return this._isDSTShifted;var e={};if(w(e,this),(e=Un(e))._a){var t=e._isUTC?m(e._a):Qn(e._a);this._isDSTShifted=this.isValid()&&T(e._a,t.toArray())>0}else this._isDSTShifted=!1;return this._isDSTShifted}function ki(){return!!this.isValid()&&!this._isUTC}function xi(){return!!this.isValid()&&this._isUTC}function Si(){return!!this.isValid()&&this._isUTC&&0===this._offset}r.updateOffset=function(){};var Ci=/^(\-|\+)?(?:(\d*)[. ])?(\d+)\:(\d+)(?:\:(\d+)(\.\d*)?)?$/,Mi=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function Ti(e,t){var n,i,r,o=e,a=null;return si(e)?o={ms:e._milliseconds,d:e._days,M:e._months}:u(e)?(o={},t?o[t]=e:o.milliseconds=e):(a=Ci.exec(e))?(n="-"===a[1]?-1:1,o={y:0,d:M(a[$e])*n,h:M(a[Fe])*n,m:M(a[Be])*n,s:M(a[Ve])*n,ms:M(li(1e3*a[He]))*n}):(a=Mi.exec(e))?(n="-"===a[1]?-1:1,o={y:Ai(a[2],n),M:Ai(a[3],n),w:Ai(a[4],n),d:Ai(a[5],n),h:Ai(a[6],n),m:Ai(a[7],n),s:Ai(a[8],n)}):null==o?o={}:"object"==typeof o&&("from"in o||"to"in o)&&(r=Li(Qn(o.from),Qn(o.to)),(o={}).ms=r.milliseconds,o.M=r.months),i=new ai(o),si(e)&&f(e,"_locale")&&(i._locale=e._locale),i}function Ai(e,t){var n=e&&parseFloat(e.replace(",","."));return(isNaN(n)?0:n)*t}function Pi(e,t){var n={};return n.months=t.month()-e.month()+12*(t.year()-e.year()),e.clone().add(n.months,"M").isAfter(t)&&--n.months,n.milliseconds=+t-+e.clone().add(n.months,"M"),n}function Li(e,t){var n;return e.isValid()&&t.isValid()?(t=hi(t,e),e.isBefore(t)?n=Pi(e,t):((n=Pi(t,e)).milliseconds=-n.milliseconds,n.months=-n.months),n):{milliseconds:0,months:0}}function Oi(e,t){return function(n,i){var r;return null===i||isNaN(+i)||(q(t,"moment()."+t+"(period, number) is deprecated. Please use moment()."+t+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),r=n,n=i,i=r),qi(this,Ti(n="string"==typeof n?+n:n,i),e),this}}function qi(e,t,n,i){var o=t._milliseconds,a=li(t._days),s=li(t._months);e.isValid()&&(i=null==i||i,s&&ht(e,Xe(e,"Month")+s*n),a&&et(e,"Date",Xe(e,"Date")+a*n),o&&e._d.setTime(e._d.valueOf()+o*n),i&&r.updateOffset(e,a||s))}Ti.fn=ai.prototype,Ti.invalid=oi;var Ei=Oi(1,"add"),Di=Oi(-1,"subtract");function zi(e,t){var n=e.diff(t,"days",!0);return n<-6?"sameElse":n<-1?"lastWeek":n<0?"lastDay":n<1?"sameDay":n<2?"nextDay":n<7?"nextWeek":"sameElse"}function Ni(e,t){var n=e||Qn(),i=hi(n,this).startOf("day"),o=r.calendarFormat(this,i)||"sameElse",a=t&&(E(t[o])?t[o].call(this,n):t[o]);return this.format(a||this.localeData().calendar(o,this,Qn(n)))}function ji(){return new x(this)}function Ri(e,t){var n=S(e)?e:Qn(e);return!(!this.isValid()||!n.isValid())&&("millisecond"===(t=Z(t)||"millisecond")?this.valueOf()>n.valueOf():n.valueOf()<this.clone().startOf(t).valueOf())}function Ii(e,t){var n=S(e)?e:Qn(e);return!(!this.isValid()||!n.isValid())&&("millisecond"===(t=Z(t)||"millisecond")?this.valueOf()<n.valueOf():this.clone().endOf(t).valueOf()<n.valueOf())}function $i(e,t,n,i){var r=S(e)?e:Qn(e),o=S(t)?t:Qn(t);return!!(this.isValid()&&r.isValid()&&o.isValid())&&("("===(i=i||"()")[0]?this.isAfter(r,n):!this.isBefore(r,n))&&(")"===i[1]?this.isBefore(o,n):!this.isAfter(o,n))}function Fi(e,t){var n,i=S(e)?e:Qn(e);return!(!this.isValid()||!i.isValid())&&("millisecond"===(t=Z(t)||"millisecond")?this.valueOf()===i.valueOf():(n=i.valueOf(),this.clone().startOf(t).valueOf()<=n&&n<=this.clone().endOf(t).valueOf()))}function Bi(e,t){return this.isSame(e,t)||this.isAfter(e,t)}function Vi(e,t){return this.isSame(e,t)||this.isBefore(e,t)}function Hi(e,t,n){var i,r,o;if(!this.isValid())return NaN;if(!(i=hi(e,this)).isValid())return NaN;switch(r=6e4*(i.utcOffset()-this.utcOffset()),t=Z(t)){case"year":o=Wi(this,i)/12;break;case"month":o=Wi(this,i);break;case"quarter":o=Wi(this,i)/3;break;case"second":o=(this-i)/1e3;break;case"minute":o=(this-i)/6e4;break;case"hour":o=(this-i)/36e5;break;case"day":o=(this-i-r)/864e5;break;case"week":o=(this-i-r)/6048e5;break;default:o=this-i}return n?o:C(o)}function Wi(e,t){var n=12*(t.year()-e.year())+(t.month()-e.month()),i=e.clone().add(n,"months");return-(n+(t-i<0?(t-i)/(i-e.clone().add(n-1,"months")):(t-i)/(e.clone().add(n+1,"months")-i)))||0}function Ui(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")}function Yi(e){if(!this.isValid())return null;var t=!0!==e,n=t?this.clone().utc():this;return n.year()<0||n.year()>9999?ue(n,t?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):E(Date.prototype.toISOString)?t?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",ue(n,"Z")):ue(n,t?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")}function Gi(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var e="moment",t="";this.isLocal()||(e=0===this.utcOffset()?"moment.utc":"moment.parseZone",t="Z");var n="["+e+'("]',i=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",r="-MM-DD[T]HH:mm:ss.SSS",o=t+'[")]';return this.format(n+i+r+o)}function Qi(e){e||(e=this.isUtc()?r.defaultFormatUtc:r.defaultFormat);var t=ue(this,e);return this.localeData().postformat(t)}function Ki(e,t){return this.isValid()&&(S(e)&&e.isValid()||Qn(e).isValid())?Ti({to:this,from:e}).locale(this.locale()).humanize(!t):this.localeData().invalidDate()}function Zi(e){return this.from(Qn(),e)}function Ji(e,t){return this.isValid()&&(S(e)&&e.isValid()||Qn(e).isValid())?Ti({from:this,to:e}).locale(this.locale()).humanize(!t):this.localeData().invalidDate()}function Xi(e){return this.to(Qn(),e)}function er(e){var t;return void 0===e?this._locale._abbr:(null!=(t=_n(e))&&(this._locale=t),this)}r.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",r.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var tr=P("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(e){return void 0===e?this.localeData():this.locale(e)}));function nr(){return this._locale}var ir=1e3,rr=60*ir,or=60*rr,ar=3506328*or;function sr(e,t){return(e%t+t)%t}function lr(e,t,n){return e<100&&e>=0?new Date(e+400,t,n)-ar:new Date(e,t,n).valueOf()}function cr(e,t,n){return e<100&&e>=0?Date.UTC(e+400,t,n)-ar:Date.UTC(e,t,n)}function ur(e){var t;if(void 0===(e=Z(e))||"millisecond"===e||!this.isValid())return this;var n=this._isUTC?cr:lr;switch(e){case"year":t=n(this.year(),0,1);break;case"quarter":t=n(this.year(),this.month()-this.month()%3,1);break;case"month":t=n(this.year(),this.month(),1);break;case"week":t=n(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":t=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":t=n(this.year(),this.month(),this.date());break;case"hour":t=this._d.valueOf(),t-=sr(t+(this._isUTC?0:this.utcOffset()*rr),or);break;case"minute":t=this._d.valueOf(),t-=sr(t,rr);break;case"second":t=this._d.valueOf(),t-=sr(t,ir)}return this._d.setTime(t),r.updateOffset(this,!0),this}function dr(e){var t;if(void 0===(e=Z(e))||"millisecond"===e||!this.isValid())return this;var n=this._isUTC?cr:lr;switch(e){case"year":t=n(this.year()+1,0,1)-1;break;case"quarter":t=n(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":t=n(this.year(),this.month()+1,1)-1;break;case"week":t=n(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":t=n(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":t=n(this.year(),this.month(),this.date()+1)-1;break;case"hour":t=this._d.valueOf(),t+=or-sr(t+(this._isUTC?0:this.utcOffset()*rr),or)-1;break;case"minute":t=this._d.valueOf(),t+=rr-sr(t,rr)-1;break;case"second":t=this._d.valueOf(),t+=ir-sr(t,ir)-1}return this._d.setTime(t),r.updateOffset(this,!0),this}function hr(){return this._d.valueOf()-6e4*(this._offset||0)}function fr(){return Math.floor(this.valueOf()/1e3)}function pr(){return new Date(this.valueOf())}function mr(){var e=this;return[e.year(),e.month(),e.date(),e.hour(),e.minute(),e.second(),e.millisecond()]}function vr(){var e=this;return{years:e.year(),months:e.month(),date:e.date(),hours:e.hours(),minutes:e.minutes(),seconds:e.seconds(),milliseconds:e.milliseconds()}}function gr(){return this.isValid()?this.toISOString():null}function _r(){return _(this)}function br(){return p({},g(this))}function yr(){return g(this).overflow}function wr(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}}function kr(e,t){se(0,[e,e.length],0,t)}function xr(e){return Tr.call(this,e,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)}function Sr(e){return Tr.call(this,e,this.isoWeek(),this.isoWeekday(),1,4)}function Cr(){return Ct(this.year(),1,4)}function Mr(){var e=this.localeData()._week;return Ct(this.year(),e.dow,e.doy)}function Tr(e,t,n,i,r){var o;return null==e?St(this,i,r).year:(t>(o=Ct(e,i,r))&&(t=o),Ar.call(this,e,t,n,i,r))}function Ar(e,t,n,i,r){var o=xt(e,t,n,i,r),a=wt(o.year,0,o.dayOfYear);return this.year(a.getUTCFullYear()),this.month(a.getUTCMonth()),this.date(a.getUTCDate()),this}function Pr(e){return null==e?Math.ceil((this.month()+1)/3):this.month(3*(e-1)+this.month()%3)}se(0,["gg",2],0,(function(){return this.weekYear()%100})),se(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),kr("gggg","weekYear"),kr("ggggg","weekYear"),kr("GGGG","isoWeekYear"),kr("GGGGG","isoWeekYear"),K("weekYear","gg"),K("isoWeekYear","GG"),ee("weekYear",1),ee("isoWeekYear",1),Le("G",Se),Le("g",Se),Le("GG",ge,fe),Le("gg",ge,fe),Le("GGGG",we,me),Le("gggg",we,me),Le("GGGGG",ke,ve),Le("ggggg",ke,ve),Ne(["gggg","ggggg","GGGG","GGGGG"],(function(e,t,n,i){t[i.substr(0,2)]=M(e)})),Ne(["gg","GG"],(function(e,t,n,i){t[i]=r.parseTwoDigitYear(e)})),se("Q",0,"Qo","quarter"),K("quarter","Q"),ee("quarter",7),Le("Q",he),ze("Q",(function(e,t){t[Ie]=3*(M(e)-1)})),se("D",["DD",2],"Do","date"),K("date","D"),ee("date",9),Le("D",ge),Le("DD",ge,fe),Le("Do",(function(e,t){return e?t._dayOfMonthOrdinalParse||t._ordinalParse:t._dayOfMonthOrdinalParseLenient})),ze(["D","DD"],$e),ze("Do",(function(e,t){t[$e]=M(e.match(ge)[0])}));var Lr=Je("Date",!0);function Or(e){var t=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==e?t:this.add(e-t,"d")}se("DDD",["DDDD",3],"DDDo","dayOfYear"),K("dayOfYear","DDD"),ee("dayOfYear",4),Le("DDD",ye),Le("DDDD",pe),ze(["DDD","DDDD"],(function(e,t,n){n._dayOfYear=M(e)})),se("m",["mm",2],0,"minute"),K("minute","m"),ee("minute",14),Le("m",ge),Le("mm",ge,fe),ze(["m","mm"],Be);var qr=Je("Minutes",!1);se("s",["ss",2],0,"second"),K("second","s"),ee("second",15),Le("s",ge),Le("ss",ge,fe),ze(["s","ss"],Ve);var Er,Dr=Je("Seconds",!1);for(se("S",0,0,(function(){return~~(this.millisecond()/100)})),se(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),se(0,["SSS",3],0,"millisecond"),se(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),se(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),se(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),se(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),se(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),se(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),K("millisecond","ms"),ee("millisecond",16),Le("S",ye,he),Le("SS",ye,fe),Le("SSS",ye,pe),Er="SSSS";Er.length<=9;Er+="S")Le(Er,xe);function zr(e,t){t[He]=M(1e3*("0."+e))}for(Er="S";Er.length<=9;Er+="S")ze(Er,zr);var Nr=Je("Milliseconds",!1);function jr(){return this._isUTC?"UTC":""}function Rr(){return this._isUTC?"Coordinated Universal Time":""}se("z",0,0,"zoneAbbr"),se("zz",0,0,"zoneName");var Ir=x.prototype;function $r(e){return Qn(1e3*e)}function Fr(){return Qn.apply(null,arguments).parseZone()}function Br(e){return e}Ir.add=Ei,Ir.calendar=Ni,Ir.clone=ji,Ir.diff=Hi,Ir.endOf=dr,Ir.format=Qi,Ir.from=Ki,Ir.fromNow=Zi,Ir.to=Ji,Ir.toNow=Xi,Ir.get=tt,Ir.invalidAt=yr,Ir.isAfter=Ri,Ir.isBefore=Ii,Ir.isBetween=$i,Ir.isSame=Fi,Ir.isSameOrAfter=Bi,Ir.isSameOrBefore=Vi,Ir.isValid=_r,Ir.lang=tr,Ir.locale=er,Ir.localeData=nr,Ir.max=Zn,Ir.min=Kn,Ir.parsingFlags=br,Ir.set=nt,Ir.startOf=ur,Ir.subtract=Di,Ir.toArray=mr,Ir.toObject=vr,Ir.toDate=pr,Ir.toISOString=Yi,Ir.inspect=Gi,Ir.toJSON=gr,Ir.toString=Ui,Ir.unix=fr,Ir.valueOf=hr,Ir.creationData=wr,Ir.year=Ke,Ir.isLeapYear=Ze,Ir.weekYear=xr,Ir.isoWeekYear=Sr,Ir.quarter=Ir.quarters=Pr,Ir.month=ft,Ir.daysInMonth=pt,Ir.week=Ir.weeks=Lt,Ir.isoWeek=Ir.isoWeeks=Ot,Ir.weeksInYear=Mr,Ir.isoWeeksInYear=Cr,Ir.date=Lr,Ir.day=Ir.days=Vt,Ir.weekday=Ht,Ir.isoWeekday=Wt,Ir.dayOfYear=Or,Ir.hour=Ir.hours=ln,Ir.minute=Ir.minutes=qr,Ir.second=Ir.seconds=Dr,Ir.millisecond=Ir.milliseconds=Nr,Ir.utcOffset=pi,Ir.utc=vi,Ir.local=gi,Ir.parseZone=_i,Ir.hasAlignedHourOffset=bi,Ir.isDST=yi,Ir.isLocal=ki,Ir.isUtcOffset=xi,Ir.isUtc=Si,Ir.isUTC=Si,Ir.zoneAbbr=jr,Ir.zoneName=Rr,Ir.dates=P("dates accessor is deprecated. Use date instead.",Lr),Ir.months=P("months accessor is deprecated. Use month instead",ft),Ir.years=P("years accessor is deprecated. Use year instead",Ke),Ir.zone=P("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",mi),Ir.isDSTShifted=P("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",wi);var Vr=N.prototype;function Hr(e,t,n,i){var r=_n(),o=m().set(i,t);return r[n](o,e)}function Wr(e,t,n){if(u(e)&&(t=e,e=void 0),e=e||"",null!=t)return Hr(e,t,n,"month");var i,r=[];for(i=0;i<12;i++)r[i]=Hr(e,i,n,"month");return r}function Ur(e,t,n,i){"boolean"==typeof e?(u(t)&&(n=t,t=void 0),t=t||""):(n=t=e,e=!1,u(t)&&(n=t,t=void 0),t=t||"");var r,o=_n(),a=e?o._week.dow:0;if(null!=n)return Hr(t,(n+a)%7,i,"day");var s=[];for(r=0;r<7;r++)s[r]=Hr(t,(r+a)%7,i,"day");return s}function Yr(e,t){return Wr(e,t,"months")}function Gr(e,t){return Wr(e,t,"monthsShort")}function Qr(e,t,n){return Ur(e,t,n,"weekdays")}function Kr(e,t,n){return Ur(e,t,n,"weekdaysShort")}function Zr(e,t,n){return Ur(e,t,n,"weekdaysMin")}Vr.calendar=R,Vr.longDateFormat=$,Vr.invalidDate=B,Vr.ordinal=W,Vr.preparse=Br,Vr.postformat=Br,Vr.relativeTime=Y,Vr.pastFuture=G,Vr.set=D,Vr.months=st,Vr.monthsShort=ct,Vr.monthsParse=dt,Vr.monthsRegex=_t,Vr.monthsShortRegex=vt,Vr.week=Mt,Vr.firstDayOfYear=Pt,Vr.firstDayOfWeek=At,Vr.weekdays=Nt,Vr.weekdaysMin=$t,Vr.weekdaysShort=Rt,Vr.weekdaysParse=Bt,Vr.weekdaysRegex=Yt,Vr.weekdaysShortRegex=Qt,Vr.weekdaysMinRegex=Zt,Vr.isPM=rn,Vr.meridiem=an,mn("en",{dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(e){var t=e%10;return e+(1===M(e%100/10)?"th":1===t?"st":2===t?"nd":3===t?"rd":"th")}}),r.lang=P("moment.lang is deprecated. Use moment.locale instead.",mn),r.langData=P("moment.langData is deprecated. Use moment.localeData instead.",_n);var Jr=Math.abs;function Xr(){var e=this._data;return this._milliseconds=Jr(this._milliseconds),this._days=Jr(this._days),this._months=Jr(this._months),e.milliseconds=Jr(e.milliseconds),e.seconds=Jr(e.seconds),e.minutes=Jr(e.minutes),e.hours=Jr(e.hours),e.months=Jr(e.months),e.years=Jr(e.years),this}function eo(e,t,n,i){var r=Ti(t,n);return e._milliseconds+=i*r._milliseconds,e._days+=i*r._days,e._months+=i*r._months,e._bubble()}function to(e,t){return eo(this,e,t,1)}function no(e,t){return eo(this,e,t,-1)}function io(e){return e<0?Math.floor(e):Math.ceil(e)}function ro(){var e,t,n,i,r,o=this._milliseconds,a=this._days,s=this._months,l=this._data;return o>=0&&a>=0&&s>=0||o<=0&&a<=0&&s<=0||(o+=864e5*io(ao(s)+a),a=0,s=0),l.milliseconds=o%1e3,e=C(o/1e3),l.seconds=e%60,t=C(e/60),l.minutes=t%60,n=C(t/60),l.hours=n%24,a+=C(n/24),s+=r=C(oo(a)),a-=io(ao(r)),i=C(s/12),s%=12,l.days=a,l.months=s,l.years=i,this}function oo(e){return 4800*e/146097}function ao(e){return 146097*e/4800}function so(e){if(!this.isValid())return NaN;var t,n,i=this._milliseconds;if("month"===(e=Z(e))||"quarter"===e||"year"===e)switch(t=this._days+i/864e5,n=this._months+oo(t),e){case"month":return n;case"quarter":return n/3;case"year":return n/12}else switch(t=this._days+Math.round(ao(this._months)),e){case"week":return t/7+i/6048e5;case"day":return t+i/864e5;case"hour":return 24*t+i/36e5;case"minute":return 1440*t+i/6e4;case"second":return 86400*t+i/1e3;case"millisecond":return Math.floor(864e5*t)+i;default:throw new Error("Unknown unit "+e)}}function lo(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*M(this._months/12):NaN}function co(e){return function(){return this.as(e)}}var uo=co("ms"),ho=co("s"),fo=co("m"),po=co("h"),mo=co("d"),vo=co("w"),go=co("M"),_o=co("Q"),bo=co("y");function yo(){return Ti(this)}function wo(e){return e=Z(e),this.isValid()?this[e+"s"]():NaN}function ko(e){return function(){return this.isValid()?this._data[e]:NaN}}var xo=ko("milliseconds"),So=ko("seconds"),Co=ko("minutes"),Mo=ko("hours"),To=ko("days"),Ao=ko("months"),Po=ko("years");function Lo(){return C(this.days()/7)}var Oo=Math.round,qo={ss:44,s:45,m:45,h:22,d:26,M:11};function Eo(e,t,n,i,r){return r.relativeTime(t||1,!!n,e,i)}function Do(e,t,n){var i=Ti(e).abs(),r=Oo(i.as("s")),o=Oo(i.as("m")),a=Oo(i.as("h")),s=Oo(i.as("d")),l=Oo(i.as("M")),c=Oo(i.as("y")),u=r<=qo.ss&&["s",r]||r<qo.s&&["ss",r]||o<=1&&["m"]||o<qo.m&&["mm",o]||a<=1&&["h"]||a<qo.h&&["hh",a]||s<=1&&["d"]||s<qo.d&&["dd",s]||l<=1&&["M"]||l<qo.M&&["MM",l]||c<=1&&["y"]||["yy",c];return u[2]=t,u[3]=+e>0,u[4]=n,Eo.apply(null,u)}function zo(e){return void 0===e?Oo:"function"==typeof e&&(Oo=e,!0)}function No(e,t){return void 0!==qo[e]&&(void 0===t?qo[e]:(qo[e]=t,"s"===e&&(qo.ss=t-1),!0))}function jo(e){if(!this.isValid())return this.localeData().invalidDate();var t=this.localeData(),n=Do(this,!e,t);return e&&(n=t.pastFuture(+this,n)),t.postformat(n)}var Ro=Math.abs;function Io(e){return(e>0)-(e<0)||+e}function $o(){if(!this.isValid())return this.localeData().invalidDate();var e,t,n=Ro(this._milliseconds)/1e3,i=Ro(this._days),r=Ro(this._months);e=C(n/60),t=C(e/60),n%=60,e%=60;var o=C(r/12),a=r%=12,s=i,l=t,c=e,u=n?n.toFixed(3).replace(/\.?0+$/,""):"",d=this.asSeconds();if(!d)return"P0D";var h=d<0?"-":"",f=Io(this._months)!==Io(d)?"-":"",p=Io(this._days)!==Io(d)?"-":"",m=Io(this._milliseconds)!==Io(d)?"-":"";return h+"P"+(o?f+o+"Y":"")+(a?f+a+"M":"")+(s?p+s+"D":"")+(l||c||u?"T":"")+(l?m+l+"H":"")+(c?m+c+"M":"")+(u?m+u+"S":"")}var Fo=ai.prototype;return Fo.isValid=ri,Fo.abs=Xr,Fo.add=to,Fo.subtract=no,Fo.as=so,Fo.asMilliseconds=uo,Fo.asSeconds=ho,Fo.asMinutes=fo,Fo.asHours=po,Fo.asDays=mo,Fo.asWeeks=vo,Fo.asMonths=go,Fo.asQuarters=_o,Fo.asYears=bo,Fo.valueOf=lo,Fo._bubble=ro,Fo.clone=yo,Fo.get=wo,Fo.milliseconds=xo,Fo.seconds=So,Fo.minutes=Co,Fo.hours=Mo,Fo.days=To,Fo.weeks=Lo,Fo.months=Ao,Fo.years=Po,Fo.humanize=jo,Fo.toISOString=$o,Fo.toString=$o,Fo.toJSON=$o,Fo.locale=er,Fo.localeData=nr,Fo.toIsoString=P("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",$o),Fo.lang=tr,se("X",0,0,"unix"),se("x",0,0,"valueOf"),Le("x",Se),Le("X",Te),ze("X",(function(e,t,n){n._d=new Date(1e3*parseFloat(e,10))})),ze("x",(function(e,t,n){n._d=new Date(M(e))})),r.version="2.24.0",o(Qn),r.fn=Ir,r.min=Xn,r.max=ei,r.now=ti,r.utc=m,r.unix=$r,r.months=Yr,r.isDate=d,r.locale=mn,r.invalid=b,r.duration=Ti,r.isMoment=S,r.weekdays=Qr,r.parseZone=Fr,r.localeData=_n,r.isDuration=si,r.monthsShort=Gr,r.weekdaysMin=Zr,r.defineLocale=vn,r.updateLocale=gn,r.locales=bn,r.weekdaysShort=Kr,r.normalizeUnits=Z,r.relativeTimeRounding=zo,r.relativeTimeThreshold=No,r.calendarFormat=zi,r.prototype=Ir,r.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},r}()})),mi={datetime:"MMM D, YYYY, h:mm:ss a",millisecond:"h:mm:ss.SSS a",second:"h:mm:ss a",minute:"h:mm a",hour:"hA",day:"MMM D",week:"ll",month:"MMM YYYY",quarter:"[Q]Q - YYYY",year:"YYYY"};on._date.override("function"==typeof pi?{_id:"moment",formats:function(){return mi},parse:function(e,t){return"string"==typeof e&&"string"==typeof t?e=pi(e,t):e instanceof pi||(e=pi(e)),e.isValid()?e.valueOf():null},format:function(e,t){return pi(e).format(t)},add:function(e,t,n){return pi(e).add(t,n).valueOf()},diff:function(e,t,n){return pi(e).diff(pi(t),n)},startOf:function(e,t,n){return e=pi(e),"isoWeek"===t?e.isoWeekday(n).valueOf():e.startOf(t).valueOf()},endOf:function(e,t){return pi(e).endOf(t).valueOf()},_create:function(e){return pi(e)}}:{}),j._set("global",{plugins:{filler:{propagate:!0}}});var vi={dataset:function(e){var t=e.fill,n=e.chart,i=n.getDatasetMeta(t),r=i&&n.isDatasetVisible(t)&&i.dataset._children||[],o=r.length||0;return o?function(e,t){return t<o&&r[t]._view||null}:null},boundary:function(e){var t=e.boundary,n=t?t.x:null,i=t?t.y:null;return V.isArray(t)?function(e,n){return t[n]}:function(e){return{x:null===n?e.x:n,y:null===i?e.y:i}}}};function gi(e,t,n){var i,r=e._model||{},o=r.fill;if(void 0===o&&(o=!!r.backgroundColor),!1===o||null===o)return!1;if(!0===o)return"origin";if(i=parseFloat(o,10),isFinite(i)&&Math.floor(i)===i)return"-"!==o[0]&&"+"!==o[0]||(i=t+i),!(i===t||i<0||i>=n)&&i;switch(o){case"bottom":return"start";case"top":return"end";case"zero":return"origin";case"origin":case"start":case"end":return o;default:return!1}}function _i(e){return(e.el._scale||{}).getPointPositionForValue?function(e){var t,n,i,r,o,a=e.el._scale,s=a.options,l=a.chart.data.labels.length,c=e.fill,u=[];if(!l)return null;for(t=s.ticks.reverse?a.max:a.min,n=s.ticks.reverse?a.min:a.max,i=a.getPointPositionForValue(0,t),r=0;r<l;++r)o="start"===c||"end"===c?a.getPointPositionForValue(r,"start"===c?t:n):a.getBasePosition(r),s.gridLines.circular&&(o.cx=i.x,o.cy=i.y,o.angle=a.getIndexAngle(r)-Math.PI/2),u.push(o);return u}(e):function(e){var t,n=e.el._model||{},i=e.el._scale||{},r=e.fill,o=null;if(isFinite(r))return null;if("start"===r?o=void 0===n.scaleBottom?i.bottom:n.scaleBottom:"end"===r?o=void 0===n.scaleTop?i.top:n.scaleTop:void 0!==n.scaleZero?o=n.scaleZero:i.getBasePixel&&(o=i.getBasePixel()),null!=o){if(void 0!==o.x&&void 0!==o.y)return o;if(V.isFinite(o))return{x:(t=i.isHorizontal())?o:null,y:t?null:o}}return null}(e)}function bi(e,t,n){var i,r=e[t].fill,o=[t];if(!n)return r;for(;!1!==r&&-1===o.indexOf(r);){if(!isFinite(r))return r;if(!(i=e[r]))return!1;if(i.visible)return r;o.push(r),r=i.fill}return!1}function yi(e){var t=e.fill,n="dataset";return!1===t?null:(isFinite(t)||(n="boundary"),vi[n](e))}function wi(e){return e&&!e.skip}function ki(e,t,n,i,r){var o,a,s,l;if(i&&r){for(e.moveTo(t[0].x,t[0].y),o=1;o<i;++o)V.canvas.lineTo(e,t[o-1],t[o]);if(void 0===n[0].angle)for(e.lineTo(n[r-1].x,n[r-1].y),o=r-1;o>0;--o)V.canvas.lineTo(e,n[o],n[o-1],!0);else for(a=n[0].cx,s=n[0].cy,l=Math.sqrt(Math.pow(n[0].x-a,2)+Math.pow(n[0].y-s,2)),o=r-1;o>0;--o)e.arc(a,s,l,n[o].angle,n[o-1].angle,!0)}}function xi(e,t,n,i,r,o){var a,s,l,c,u,d,h,f,p=t.length,m=i.spanGaps,v=[],g=[],_=0,b=0;for(e.beginPath(),a=0,s=p;a<s;++a)u=n(c=t[l=a%p]._view,l,i),d=wi(c),h=wi(u),o&&void 0===f&&d&&(s=p+(f=a+1)),d&&h?(_=v.push(c),b=g.push(u)):_&&b&&(m?(d&&v.push(c),h&&g.push(u)):(ki(e,v,g,_,b),_=b=0,v=[],g=[]));ki(e,v,g,_,b),e.closePath(),e.fillStyle=r,e.fill()}var Si={id:"filler",afterDatasetsUpdate:function(e,t){var n,i,r,o,a=(e.data.datasets||[]).length,s=t.propagate,l=[];for(i=0;i<a;++i)o=null,(r=(n=e.getDatasetMeta(i)).dataset)&&r._model&&r instanceof xe.Line&&(o={visible:e.isDatasetVisible(i),fill:gi(r,i,a),chart:e,el:r}),n.$filler=o,l.push(o);for(i=0;i<a;++i)(o=l[i])&&(o.fill=bi(l,i,s),o.boundary=_i(o),o.mapper=yi(o))},beforeDatasetsDraw:function(e){var t,n,i,r,o,a,s,l=e._getSortedVisibleDatasetMetas(),c=e.ctx;for(n=l.length-1;n>=0;--n)(t=l[n].$filler)&&t.visible&&(r=(i=t.el)._view,o=i._children||[],a=t.mapper,s=r.backgroundColor||j.global.defaultColor,a&&s&&o.length&&(V.canvas.clipArea(c,e.chartArea),xi(c,o,a,r,s,i._loop),V.canvas.unclipArea(c)))}},Ci=V.rtl.getRtlAdapter,Mi=V.noop,Ti=V.valueOrDefault;function Ai(e,t){return e.usePointStyle&&e.boxWidth>t?t:e.boxWidth}j._set("global",{legend:{display:!0,position:"top",align:"center",fullWidth:!0,reverse:!1,weight:1e3,onClick:function(e,t){var n=t.datasetIndex,i=this.chart,r=i.getDatasetMeta(n);r.hidden=null===r.hidden?!i.data.datasets[n].hidden:null,i.update()},onHover:null,onLeave:null,labels:{boxWidth:40,padding:10,generateLabels:function(e){var t=e.data.datasets,n=e.options.legend||{},i=n.labels&&n.labels.usePointStyle;return e._getSortedDatasetMetas().map((function(n){var r=n.controller.getStyle(i?0:void 0);return{text:t[n.index].label,fillStyle:r.backgroundColor,hidden:!e.isDatasetVisible(n.index),lineCap:r.borderCapStyle,lineDash:r.borderDash,lineDashOffset:r.borderDashOffset,lineJoin:r.borderJoinStyle,lineWidth:r.borderWidth,strokeStyle:r.borderColor,pointStyle:r.pointStyle,rotation:r.rotation,datasetIndex:n.index}}),this)}}},legendCallback:function(e){var t,n,i,r=document.createElement("ul"),o=e.data.datasets;for(r.setAttribute("class",e.id+"-legend"),t=0,n=o.length;t<n;t++)(i=r.appendChild(document.createElement("li"))).appendChild(document.createElement("span")).style.backgroundColor=o[t].backgroundColor,o[t].label&&i.appendChild(document.createTextNode(o[t].label));return r.outerHTML}});var Pi=K.extend({initialize:function(e){var t=this;V.extend(t,e),t.legendHitBoxes=[],t._hoveredItem=null,t.doughnutMode=!1},beforeUpdate:Mi,update:function(e,t,n){var i=this;return i.beforeUpdate(),i.maxWidth=e,i.maxHeight=t,i.margins=n,i.beforeSetDimensions(),i.setDimensions(),i.afterSetDimensions(),i.beforeBuildLabels(),i.buildLabels(),i.afterBuildLabels(),i.beforeFit(),i.fit(),i.afterFit(),i.afterUpdate(),i.minSize},afterUpdate:Mi,beforeSetDimensions:Mi,setDimensions:function(){var e=this;e.isHorizontal()?(e.width=e.maxWidth,e.left=0,e.right=e.width):(e.height=e.maxHeight,e.top=0,e.bottom=e.height),e.paddingLeft=0,e.paddingTop=0,e.paddingRight=0,e.paddingBottom=0,e.minSize={width:0,height:0}},afterSetDimensions:Mi,beforeBuildLabels:Mi,buildLabels:function(){var e=this,t=e.options.labels||{},n=V.callback(t.generateLabels,[e.chart],e)||[];t.filter&&(n=n.filter((function(n){return t.filter(n,e.chart.data)}))),e.options.reverse&&n.reverse(),e.legendItems=n},afterBuildLabels:Mi,beforeFit:Mi,fit:function(){var e=this,t=e.options,n=t.labels,i=t.display,r=e.ctx,o=V.options._parseFont(n),a=o.size,s=e.legendHitBoxes=[],l=e.minSize,c=e.isHorizontal();if(c?(l.width=e.maxWidth,l.height=i?10:0):(l.width=i?10:0,l.height=e.maxHeight),i){if(r.font=o.string,c){var u=e.lineWidths=[0],d=0;r.textAlign="left",r.textBaseline="middle",V.each(e.legendItems,(function(e,t){var i=Ai(n,a)+a/2+r.measureText(e.text).width;(0===t||u[u.length-1]+i+2*n.padding>l.width)&&(d+=a+n.padding,u[u.length-(t>0?0:1)]=0),s[t]={left:0,top:0,width:i,height:a},u[u.length-1]+=i+n.padding})),l.height+=d}else{var h=n.padding,f=e.columnWidths=[],p=e.columnHeights=[],m=n.padding,v=0,g=0;V.each(e.legendItems,(function(e,t){var i=Ai(n,a)+a/2+r.measureText(e.text).width;t>0&&g+a+2*h>l.height&&(m+=v+n.padding,f.push(v),p.push(g),v=0,g=0),v=Math.max(v,i),g+=a+h,s[t]={left:0,top:0,width:i,height:a}})),m+=v,f.push(v),p.push(g),l.width+=m}e.width=l.width,e.height=l.height}else e.width=l.width=e.height=l.height=0},afterFit:Mi,isHorizontal:function(){return"top"===this.options.position||"bottom"===this.options.position},draw:function(){var e=this,t=e.options,n=t.labels,i=j.global,r=i.defaultColor,o=i.elements.line,a=e.height,s=e.columnHeights,l=e.width,c=e.lineWidths;if(t.display){var u,d=Ci(t.rtl,e.left,e.minSize.width),h=e.ctx,f=Ti(n.fontColor,i.defaultFontColor),p=V.options._parseFont(n),m=p.size;h.textAlign=d.textAlign("left"),h.textBaseline="middle",h.lineWidth=.5,h.strokeStyle=f,h.fillStyle=f,h.font=p.string;var v=Ai(n,m),g=e.legendHitBoxes,_=function(e,i){switch(t.align){case"start":return n.padding;case"end":return e-i;default:return(e-i+n.padding)/2}},b=e.isHorizontal();u=b?{x:e.left+_(l,c[0]),y:e.top+n.padding,line:0}:{x:e.left+n.padding,y:e.top+_(a,s[0]),line:0},V.rtl.overrideTextDirection(e.ctx,t.textDirection);var y=m+n.padding;V.each(e.legendItems,(function(t,i){var f=h.measureText(t.text).width,p=v+m/2+f,w=u.x,k=u.y;d.setWidth(e.minSize.width),b?i>0&&w+p+n.padding>e.left+e.minSize.width&&(k=u.y+=y,u.line++,w=u.x=e.left+_(l,c[u.line])):i>0&&k+y>e.top+e.minSize.height&&(w=u.x=w+e.columnWidths[u.line]+n.padding,u.line++,k=u.y=e.top+_(a,s[u.line]));var x=d.x(w);!function(e,t,i){if(!(isNaN(v)||v<=0)){h.save();var a=Ti(i.lineWidth,o.borderWidth);if(h.fillStyle=Ti(i.fillStyle,r),h.lineCap=Ti(i.lineCap,o.borderCapStyle),h.lineDashOffset=Ti(i.lineDashOffset,o.borderDashOffset),h.lineJoin=Ti(i.lineJoin,o.borderJoinStyle),h.lineWidth=a,h.strokeStyle=Ti(i.strokeStyle,r),h.setLineDash&&h.setLineDash(Ti(i.lineDash,o.borderDash)),n&&n.usePointStyle){var s=v*Math.SQRT2/2,l=d.xPlus(e,v/2),c=t+m/2;V.canvas.drawPoint(h,i.pointStyle,s,l,c,i.rotation)}else h.fillRect(d.leftForLtr(e,v),t,v,m),0!==a&&h.strokeRect(d.leftForLtr(e,v),t,v,m);h.restore()}}(x,k,t),g[i].left=d.leftForLtr(x,g[i].width),g[i].top=k,function(e,t,n,i){var r=m/2,o=d.xPlus(e,v+r),a=t+r;h.fillText(n.text,o,a),n.hidden&&(h.beginPath(),h.lineWidth=2,h.moveTo(o,a),h.lineTo(d.xPlus(o,i),a),h.stroke())}(x,k,t,f),b?u.x+=p+n.padding:u.y+=y})),V.rtl.restoreTextDirection(e.ctx,t.textDirection)}},_getLegendItemAt:function(e,t){var n,i,r,o=this;if(e>=o.left&&e<=o.right&&t>=o.top&&t<=o.bottom)for(r=o.legendHitBoxes,n=0;n<r.length;++n)if(e>=(i=r[n]).left&&e<=i.left+i.width&&t>=i.top&&t<=i.top+i.height)return o.legendItems[n];return null},handleEvent:function(e){var t,n=this,i=n.options,r="mouseup"===e.type?"click":e.type;if("mousemove"===r){if(!i.onHover&&!i.onLeave)return}else{if("click"!==r)return;if(!i.onClick)return}t=n._getLegendItemAt(e.x,e.y),"click"===r?t&&i.onClick&&i.onClick.call(n,e.native,t):(i.onLeave&&t!==n._hoveredItem&&(n._hoveredItem&&i.onLeave.call(n,e.native,n._hoveredItem),n._hoveredItem=t),i.onHover&&t&&i.onHover.call(n,e.native,t))}});function Li(e,t){var n=new Pi({ctx:e.ctx,options:t,chart:e});pt.configure(e,n,t),pt.addBox(e,n),e.legend=n}var Oi={id:"legend",_element:Pi,beforeInit:function(e){var t=e.options.legend;t&&Li(e,t)},beforeUpdate:function(e){var t=e.options.legend,n=e.legend;t?(V.mergeIf(t,j.global.legend),n?(pt.configure(e,n,t),n.options=t):Li(e,t)):n&&(pt.removeBox(e,n),delete e.legend)},afterEvent:function(e,t){var n=e.legend;n&&n.handleEvent(t)}},qi=V.noop;j._set("global",{title:{display:!1,fontStyle:"bold",fullWidth:!0,padding:10,position:"top",text:"",weight:2e3}});var Ei=K.extend({initialize:function(e){V.extend(this,e),this.legendHitBoxes=[]},beforeUpdate:qi,update:function(e,t,n){var i=this;return i.beforeUpdate(),i.maxWidth=e,i.maxHeight=t,i.margins=n,i.beforeSetDimensions(),i.setDimensions(),i.afterSetDimensions(),i.beforeBuildLabels(),i.buildLabels(),i.afterBuildLabels(),i.beforeFit(),i.fit(),i.afterFit(),i.afterUpdate(),i.minSize},afterUpdate:qi,beforeSetDimensions:qi,setDimensions:function(){var e=this;e.isHorizontal()?(e.width=e.maxWidth,e.left=0,e.right=e.width):(e.height=e.maxHeight,e.top=0,e.bottom=e.height),e.paddingLeft=0,e.paddingTop=0,e.paddingRight=0,e.paddingBottom=0,e.minSize={width:0,height:0}},afterSetDimensions:qi,beforeBuildLabels:qi,buildLabels:qi,afterBuildLabels:qi,beforeFit:qi,fit:function(){var e,t=this,n=t.options,i=t.minSize={},r=t.isHorizontal();n.display?(e=(V.isArray(n.text)?n.text.length:1)*V.options._parseFont(n).lineHeight+2*n.padding,t.width=i.width=r?t.maxWidth:e,t.height=i.height=r?e:t.maxHeight):t.width=i.width=t.height=i.height=0},afterFit:qi,isHorizontal:function(){var e=this.options.position;return"top"===e||"bottom"===e},draw:function(){var e=this,t=e.ctx,n=e.options;if(n.display){var i,r,o,a=V.options._parseFont(n),s=a.lineHeight,l=s/2+n.padding,c=0,u=e.top,d=e.left,h=e.bottom,f=e.right;t.fillStyle=V.valueOrDefault(n.fontColor,j.global.defaultFontColor),t.font=a.string,e.isHorizontal()?(r=d+(f-d)/2,o=u+l,i=f-d):(r="left"===n.position?d+l:f-l,o=u+(h-u)/2,i=h-u,c=Math.PI*("left"===n.position?-.5:.5)),t.save(),t.translate(r,o),t.rotate(c),t.textAlign="center",t.textBaseline="middle";var p=n.text;if(V.isArray(p))for(var m=0,v=0;v<p.length;++v)t.fillText(p[v],0,m,i),m+=s;else t.fillText(p,0,0,i);t.restore()}}});function Di(e,t){var n=new Ei({ctx:e.ctx,options:t,chart:e});pt.configure(e,n,t),pt.addBox(e,n),e.titleBlock=n}var zi={},Ni=Si,ji=Oi,Ri={id:"title",_element:Ei,beforeInit:function(e){var t=e.options.title;t&&Di(e,t)},beforeUpdate:function(e){var t=e.options.title,n=e.titleBlock;t?(V.mergeIf(t,j.global.title),n?(pt.configure(e,n,t),n.options=t):Di(e,t)):n&&(pt.removeBox(e,n),delete e.titleBlock)}};for(var Ii in zi.filler=Ni,zi.legend=ji,zi.title=Ri,tn.helpers=V,function(){function e(e,t,n){var i;return"string"==typeof e?(i=parseInt(e,10),-1!==e.indexOf("%")&&(i=i/100*t.parentNode[n])):i=e,i}function t(e){return null!=e&&"none"!==e}function n(n,i,r){var o=document.defaultView,a=V._getParentNode(n),s=o.getComputedStyle(n)[i],l=o.getComputedStyle(a)[i],c=t(s),u=t(l),d=Number.POSITIVE_INFINITY;return c||u?Math.min(c?e(s,n,r):d,u?e(l,a,r):d):"none"}V.where=function(e,t){if(V.isArray(e)&&Array.prototype.filter)return e.filter(t);var n=[];return V.each(e,(function(e){t(e)&&n.push(e)})),n},V.findIndex=Array.prototype.findIndex?function(e,t,n){return e.findIndex(t,n)}:function(e,t,n){n=void 0===n?e:n;for(var i=0,r=e.length;i<r;++i)if(t.call(n,e[i],i,e))return i;return-1},V.findNextWhere=function(e,t,n){V.isNullOrUndef(n)&&(n=-1);for(var i=n+1;i<e.length;i++){var r=e[i];if(t(r))return r}},V.findPreviousWhere=function(e,t,n){V.isNullOrUndef(n)&&(n=e.length);for(var i=n-1;i>=0;i--){var r=e[i];if(t(r))return r}},V.isNumber=function(e){return!isNaN(parseFloat(e))&&isFinite(e)},V.almostEquals=function(e,t,n){return Math.abs(e-t)<n},V.almostWhole=function(e,t){var n=Math.round(e);return n-t<=e&&n+t>=e},V.max=function(e){return e.reduce((function(e,t){return isNaN(t)?e:Math.max(e,t)}),Number.NEGATIVE_INFINITY)},V.min=function(e){return e.reduce((function(e,t){return isNaN(t)?e:Math.min(e,t)}),Number.POSITIVE_INFINITY)},V.sign=Math.sign?function(e){return Math.sign(e)}:function(e){return 0===(e=+e)||isNaN(e)?e:e>0?1:-1},V.toRadians=function(e){return e*(Math.PI/180)},V.toDegrees=function(e){return e*(180/Math.PI)},V._decimalPlaces=function(e){if(V.isFinite(e)){for(var t=1,n=0;Math.round(e*t)/t!==e;)t*=10,n++;return n}},V.getAngleFromPoint=function(e,t){var n=t.x-e.x,i=t.y-e.y,r=Math.sqrt(n*n+i*i),o=Math.atan2(i,n);return o<-.5*Math.PI&&(o+=2*Math.PI),{angle:o,distance:r}},V.distanceBetweenPoints=function(e,t){return Math.sqrt(Math.pow(t.x-e.x,2)+Math.pow(t.y-e.y,2))},V.aliasPixel=function(e){return e%2==0?0:.5},V._alignPixel=function(e,t,n){var i=e.currentDevicePixelRatio,r=n/2;return Math.round((t-r)*i)/i+r},V.splineCurve=function(e,t,n,i){var r=e.skip?t:e,o=t,a=n.skip?t:n,s=Math.sqrt(Math.pow(o.x-r.x,2)+Math.pow(o.y-r.y,2)),l=Math.sqrt(Math.pow(a.x-o.x,2)+Math.pow(a.y-o.y,2)),c=s/(s+l),u=l/(s+l),d=i*(c=isNaN(c)?0:c),h=i*(u=isNaN(u)?0:u);return{previous:{x:o.x-d*(a.x-r.x),y:o.y-d*(a.y-r.y)},next:{x:o.x+h*(a.x-r.x),y:o.y+h*(a.y-r.y)}}},V.EPSILON=Number.EPSILON||1e-14,V.splineCurveMonotone=function(e){var t,n,i,r,o,a,s,l,c,u=(e||[]).map((function(e){return{model:e._model,deltaK:0,mK:0}})),d=u.length;for(t=0;t<d;++t)if(!(i=u[t]).model.skip){if(n=t>0?u[t-1]:null,(r=t<d-1?u[t+1]:null)&&!r.model.skip){var h=r.model.x-i.model.x;i.deltaK=0!==h?(r.model.y-i.model.y)/h:0}!n||n.model.skip?i.mK=i.deltaK:!r||r.model.skip?i.mK=n.deltaK:this.sign(n.deltaK)!==this.sign(i.deltaK)?i.mK=0:i.mK=(n.deltaK+i.deltaK)/2}for(t=0;t<d-1;++t)i=u[t],r=u[t+1],i.model.skip||r.model.skip||(V.almostEquals(i.deltaK,0,this.EPSILON)?i.mK=r.mK=0:(o=i.mK/i.deltaK,a=r.mK/i.deltaK,(l=Math.pow(o,2)+Math.pow(a,2))<=9||(s=3/Math.sqrt(l),i.mK=o*s*i.deltaK,r.mK=a*s*i.deltaK)));for(t=0;t<d;++t)(i=u[t]).model.skip||(n=t>0?u[t-1]:null,r=t<d-1?u[t+1]:null,n&&!n.model.skip&&(c=(i.model.x-n.model.x)/3,i.model.controlPointPreviousX=i.model.x-c,i.model.controlPointPreviousY=i.model.y-c*i.mK),r&&!r.model.skip&&(c=(r.model.x-i.model.x)/3,i.model.controlPointNextX=i.model.x+c,i.model.controlPointNextY=i.model.y+c*i.mK))},V.nextItem=function(e,t,n){return n?t>=e.length-1?e[0]:e[t+1]:t>=e.length-1?e[e.length-1]:e[t+1]},V.previousItem=function(e,t,n){return n?t<=0?e[e.length-1]:e[t-1]:t<=0?e[0]:e[t-1]},V.niceNum=function(e,t){var n=Math.floor(V.log10(e)),i=e/Math.pow(10,n);return(t?i<1.5?1:i<3?2:i<7?5:10:i<=1?1:i<=2?2:i<=5?5:10)*Math.pow(10,n)},V.requestAnimFrame="undefined"==typeof window?function(e){e()}:window.requestAnimationFrame||window.webkitRequestAnimationFrame||window.mozRequestAnimationFrame||window.oRequestAnimationFrame||window.msRequestAnimationFrame||function(e){return window.setTimeout(e,1e3/60)},V.getRelativePosition=function(e,t){var n,i,r=e.originalEvent||e,o=e.target||e.srcElement,a=o.getBoundingClientRect(),s=r.touches;s&&s.length>0?(n=s[0].clientX,i=s[0].clientY):(n=r.clientX,i=r.clientY);var l=parseFloat(V.getStyle(o,"padding-left")),c=parseFloat(V.getStyle(o,"padding-top")),u=parseFloat(V.getStyle(o,"padding-right")),d=parseFloat(V.getStyle(o,"padding-bottom")),h=a.right-a.left-l-u,f=a.bottom-a.top-c-d;return{x:n=Math.round((n-a.left-l)/h*o.width/t.currentDevicePixelRatio),y:i=Math.round((i-a.top-c)/f*o.height/t.currentDevicePixelRatio)}},V.getConstraintWidth=function(e){return n(e,"max-width","clientWidth")},V.getConstraintHeight=function(e){return n(e,"max-height","clientHeight")},V._calculatePadding=function(e,t,n){return(t=V.getStyle(e,t)).indexOf("%")>-1?n*parseInt(t,10)/100:parseInt(t,10)},V._getParentNode=function(e){var t=e.parentNode;return t&&"[object ShadowRoot]"===t.toString()&&(t=t.host),t},V.getMaximumWidth=function(e){var t=V._getParentNode(e);if(!t)return e.clientWidth;var n=t.clientWidth,i=n-V._calculatePadding(t,"padding-left",n)-V._calculatePadding(t,"padding-right",n),r=V.getConstraintWidth(e);return isNaN(r)?i:Math.min(i,r)},V.getMaximumHeight=function(e){var t=V._getParentNode(e);if(!t)return e.clientHeight;var n=t.clientHeight,i=n-V._calculatePadding(t,"padding-top",n)-V._calculatePadding(t,"padding-bottom",n),r=V.getConstraintHeight(e);return isNaN(r)?i:Math.min(i,r)},V.getStyle=function(e,t){return e.currentStyle?e.currentStyle[t]:document.defaultView.getComputedStyle(e,null).getPropertyValue(t)},V.retinaScale=function(e,t){var n=e.currentDevicePixelRatio=t||"undefined"!=typeof window&&window.devicePixelRatio||1;if(1!==n){var i=e.canvas,r=e.height,o=e.width;i.height=r*n,i.width=o*n,e.ctx.scale(n,n),i.style.height||i.style.width||(i.style.height=r+"px",i.style.width=o+"px")}},V.fontString=function(e,t,n){return t+" "+e+"px "+n},V.longestText=function(e,t,n,i){var r=(i=i||{}).data=i.data||{},o=i.garbageCollect=i.garbageCollect||[];i.font!==t&&(r=i.data={},o=i.garbageCollect=[],i.font=t),e.font=t;var a,s,l,c,u,d=0,h=n.length;for(a=0;a<h;a++)if(null!=(c=n[a])&&!0!==V.isArray(c))d=V.measureText(e,r,o,d,c);else if(V.isArray(c))for(s=0,l=c.length;s<l;s++)null==(u=c[s])||V.isArray(u)||(d=V.measureText(e,r,o,d,u));var f=o.length/2;if(f>n.length){for(a=0;a<f;a++)delete r[o[a]];o.splice(0,f)}return d},V.measureText=function(e,t,n,i,r){var o=t[r];return o||(o=t[r]=e.measureText(r).width,n.push(r)),o>i&&(i=o),i},V.numberOfLabelLines=function(e){var t=1;return V.each(e,(function(e){V.isArray(e)&&e.length>t&&(t=e.length)})),t},V.color=k?function(e){return e instanceof CanvasGradient&&(e=j.global.defaultColor),k(e)}:function(e){return console.error("Color.js not found!"),e},V.getHoverColor=function(e){return e instanceof CanvasPattern||e instanceof CanvasGradient?e:V.color(e).saturate(.5).darken(.1).rgbString()}}(),tn._adapters=on,tn.Animation=J,tn.animationService=X,tn.controllers=Ze,tn.DatasetController=re,tn.defaults=j,tn.Element=K,tn.elements=xe,tn.Interaction=rt,tn.layouts=pt,tn.platform=Dt,tn.plugins=zt,tn.Scale=yn,tn.scaleService=Nt,tn.Ticks=an,tn.Tooltip=Yt,tn.helpers.each(fi,(function(e,t){tn.scaleService.registerScaleType(t,e,e._defaults)})),zi)zi.hasOwnProperty(Ii)&&tn.plugins.register(zi[Ii]);tn.platform.initialize();var $i=tn;return"undefined"!=typeof window&&(window.Chart=tn),tn.Chart=tn,tn.Legend=zi.legend._element,tn.Title=zi.title._element,tn.pluginService=tn.plugins,tn.PluginBase=tn.Element.extend({}),tn.canvasHelpers=tn.helpers.canvas,tn.layoutService=tn.layouts,tn.LinearScaleBase=Mn,tn.helpers.each(["Bar","Bubble","Doughnut","Line","PolarArea","Radar","Scatter"],(function(e){tn[e]=function(t,n){return new tn(t,tn.helpers.merge(n||{},{type:e.charAt(0).toLowerCase()+e.slice(1)}))}})),$i})),
/*!
 * vue-i18n v8.28.2 
 * (c) 2022 kazuya kawaguchi
 * Released under the MIT License.
 */
function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.VueI18n=t()}(this,(function(){"use strict";var e=["compactDisplay","currency","currencyDisplay","currencySign","localeMatcher","notation","numberingSystem","signDisplay","style","unit","unitDisplay","useGrouping","minimumIntegerDigits","minimumFractionDigits","maximumFractionDigits","minimumSignificantDigits","maximumSignificantDigits"],t=["dateStyle","timeStyle","calendar","localeMatcher","hour12","hourCycle","timeZone","formatMatcher","weekday","era","year","month","day","hour","minute","second","timeZoneName"];function n(e,t){"undefined"!=typeof console&&(console.warn("[vue-i18n] "+e),t&&console.warn(t.stack))}function i(e,t){"undefined"!=typeof console&&(console.error("[vue-i18n] "+e),t&&console.error(t.stack))}var r=Array.isArray;function o(e){return null!==e&&"object"==typeof e}function a(e){return"string"==typeof e}var s=Object.prototype.toString,l="[object Object]";function c(e){return s.call(e)===l}function u(e){return null==e}function d(e){return"function"==typeof e}function h(){for(var e=[],t=arguments.length;t--;)e[t]=arguments[t];var n=null,i=null;return 1===e.length?o(e[0])||r(e[0])?i=e[0]:"string"==typeof e[0]&&(n=e[0]):2===e.length&&("string"==typeof e[0]&&(n=e[0]),(o(e[1])||r(e[1]))&&(i=e[1])),{locale:n,params:i}}function f(e){return JSON.parse(JSON.stringify(e))}function p(e,t){return!!~e.indexOf(t)}var m=Object.prototype.hasOwnProperty;function v(e,t){return m.call(e,t)}function g(e){for(var t=arguments,n=Object(e),i=1;i<arguments.length;i++){var r=t[i];if(null!=r){var a=void 0;for(a in r)v(r,a)&&(o(r[a])?n[a]=g(n[a],r[a]):n[a]=r[a])}}return n}function _(e,t){if(e===t)return!0;var n=o(e),i=o(t);if(!n||!i)return!n&&!i&&String(e)===String(t);try{var a=r(e),s=r(t);if(a&&s)return e.length===t.length&&e.every((function(e,n){return _(e,t[n])}));if(a||s)return!1;var l=Object.keys(e),c=Object.keys(t);return l.length===c.length&&l.every((function(n){return _(e[n],t[n])}))}catch(e){return!1}}var b={name:"i18n",functional:!0,props:{tag:{type:[String,Boolean,Object],default:"span"},path:{type:String,required:!0},locale:{type:String},places:{type:[Array,Object]}},render:function(e,t){var i=t.data,r=t.parent,o=t.props,a=t.slots,s=r.$i18n;if(s){var l=o.path,c=o.locale,u=o.places,d=a(),h=s.i(l,c,function(e){var t;for(t in e)if("default"!==t)return!1;return Boolean(t)}(d)||u?function(e,t){var i=t?function(e){return n("`places` prop is deprecated in next major version. Please switch to Vue slots."),Array.isArray(e)?e.reduce(w,{}):Object.assign({},e)}(t):{};if(!e)return i;e=e.filter((function(e){return e.tag||""!==e.text.trim()}));var r=e.every(k);r&&n("`place` attribute is deprecated in next major version. Please switch to Vue slots.");return e.reduce(r?y:w,i)}(d.default,u):d),f=o.tag&&!0!==o.tag||!1===o.tag?o.tag:"span";return f?e(f,i,h):h}n("Cannot find VueI18n instance!")}};function y(e,t){return t.data&&t.data.attrs&&t.data.attrs.place&&(e[t.data.attrs.place]=t),e}function w(e,t,n){return e[n]=t,e}function k(e){return Boolean(e.data&&e.data.attrs&&e.data.attrs.place)}var x,S={name:"i18n-n",functional:!0,props:{tag:{type:[String,Boolean,Object],default:"span"},value:{type:Number,required:!0},format:{type:[String,Object]},locale:{type:String}},render:function(t,i){var r=i.props,s=i.parent,l=i.data,c=s.$i18n;if(!c)return n("Cannot find VueI18n instance!"),null;var u=null,d=null;a(r.format)?u=r.format:o(r.format)&&(r.format.key&&(u=r.format.key),d=Object.keys(r.format).reduce((function(t,n){var i;return p(e,n)?Object.assign({},t,((i={})[n]=r.format[n],i)):t}),null));var h=r.locale||c.locale,f=c._ntp(r.value,h,u,d),m=f.map((function(e,t){var n,i=l.scopedSlots&&l.scopedSlots[e.type];return i?i(((n={})[e.type]=e.value,n.index=t,n.parts=f,n)):e.value})),v=r.tag&&!0!==r.tag||!1===r.tag?r.tag:"span";return v?t(v,{attrs:l.attrs,class:l.class,staticClass:l.staticClass},m):m}};function C(e,t,n){A(e,n)&&P(e,t,n)}function M(e,t,n,i){if(A(e,n)){var r=n.context.$i18n;(function(e,t){var n=t.context;return e._locale===n.$i18n.locale})(e,n)&&_(t.value,t.oldValue)&&_(e._localeMessage,r.getLocaleMessage(r.locale))||P(e,t,n)}}function T(e,t,i,r){if(i.context){var o=i.context.$i18n||{};t.modifiers.preserve||o.preserveDirectiveContent||(e.textContent=""),e._vt=void 0,delete e._vt,e._locale=void 0,delete e._locale,e._localeMessage=void 0,delete e._localeMessage}else n("Vue instance does not exists in VNode context")}function A(e,t){var i=t.context;return i?!!i.$i18n||(n("VueI18n instance does not exists in Vue instance"),!1):(n("Vue instance does not exists in VNode context"),!1)}function P(e,t,i){var r,o,s=function(e){var t,n,i,r;a(e)?t=e:c(e)&&(t=e.path,n=e.locale,i=e.args,r=e.choice);return{path:t,locale:n,args:i,choice:r}}(t.value),l=s.path,u=s.locale,d=s.args,h=s.choice;if(l||u||d)if(l){var f=i.context;e._vt=e.textContent=null!=h?(r=f.$i18n).tc.apply(r,[l,h].concat(L(u,d))):(o=f.$i18n).t.apply(o,[l].concat(L(u,d))),e._locale=f.$i18n.locale,e._localeMessage=f.$i18n.getLocaleMessage(f.$i18n.locale)}else n("`path` is required in v-t directive");else n("value type not supported")}function L(e,t){var n=[];return e&&n.push(e),t&&(Array.isArray(t)||c(t))&&n.push(t),n}function O(e,t){(void 0===t&&(t={bridge:!1}),O.installed&&e===x)?n("already installed."):(O.installed=!0,((x=e).version&&Number(x.version.split(".")[0])||-1)<2?n("vue-i18n ("+O.version+") need to use Vue 2.0 or later (Vue: "+x.version+")."):(!function(e){e.prototype.hasOwnProperty("$i18n")||Object.defineProperty(e.prototype,"$i18n",{get:function(){return this._i18n}}),e.prototype.$t=function(e){for(var t=[],n=arguments.length-1;n-- >0;)t[n]=arguments[n+1];var i=this.$i18n;return i._t.apply(i,[e,i.locale,i._getMessages(),this].concat(t))},e.prototype.$tc=function(e,t){for(var n=[],i=arguments.length-2;i-- >0;)n[i]=arguments[i+2];var r=this.$i18n;return r._tc.apply(r,[e,r.locale,r._getMessages(),this,t].concat(n))},e.prototype.$te=function(e,t){var n=this.$i18n;return n._te(e,n.locale,n._getMessages(),t)},e.prototype.$d=function(e){for(var t,n=[],i=arguments.length-1;i-- >0;)n[i]=arguments[i+1];return(t=this.$i18n).d.apply(t,[e].concat(n))},e.prototype.$n=function(e){for(var t,n=[],i=arguments.length-1;i-- >0;)n[i]=arguments[i+1];return(t=this.$i18n).n.apply(t,[e].concat(n))}}(x),x.mixin(function(e){function t(){this!==this.$root&&this.$options.__INTLIFY_META__&&this.$el&&this.$el.setAttribute("data-intlify",this.$options.__INTLIFY_META__)}return void 0===e&&(e=!1),e?{mounted:t}:{beforeCreate:function(){var e=this.$options;if(e.i18n=e.i18n||(e.__i18nBridge||e.__i18n?{}:null),e.i18n)if(e.i18n instanceof Y){if(e.__i18nBridge||e.__i18n)try{var t=e.i18n&&e.i18n.messages?e.i18n.messages:{};(e.__i18nBridge||e.__i18n).forEach((function(e){t=g(t,JSON.parse(e))})),Object.keys(t).forEach((function(n){e.i18n.mergeLocaleMessage(n,t[n])}))}catch(e){i("Cannot parse locale messages via custom blocks.",e)}this._i18n=e.i18n,this._i18nWatcher=this._i18n.watchI18nData()}else if(c(e.i18n)){var r=this.$root&&this.$root.$i18n&&this.$root.$i18n instanceof Y?this.$root.$i18n:null;if(r&&(e.i18n.root=this.$root,e.i18n.formatter=r.formatter,e.i18n.fallbackLocale=r.fallbackLocale,e.i18n.formatFallbackMessages=r.formatFallbackMessages,e.i18n.silentTranslationWarn=r.silentTranslationWarn,e.i18n.silentFallbackWarn=r.silentFallbackWarn,e.i18n.pluralizationRules=r.pluralizationRules,e.i18n.preserveDirectiveContent=r.preserveDirectiveContent),e.__i18nBridge||e.__i18n)try{var o=e.i18n&&e.i18n.messages?e.i18n.messages:{};(e.__i18nBridge||e.__i18n).forEach((function(e){o=g(o,JSON.parse(e))})),e.i18n.messages=o}catch(e){n("Cannot parse locale messages via custom blocks.",e)}var a=e.i18n.sharedMessages;a&&c(a)&&(e.i18n.messages=g(e.i18n.messages,a)),this._i18n=new Y(e.i18n),this._i18nWatcher=this._i18n.watchI18nData(),(void 0===e.i18n.sync||e.i18n.sync)&&(this._localeWatcher=this.$i18n.watchLocale()),r&&r.onComponentInstanceCreated(this._i18n)}else n("Cannot be interpreted 'i18n' option.");else this.$root&&this.$root.$i18n&&this.$root.$i18n instanceof Y?this._i18n=this.$root.$i18n:e.parent&&e.parent.$i18n&&e.parent.$i18n instanceof Y&&(this._i18n=e.parent.$i18n)},beforeMount:function(){var e=this.$options;e.i18n=e.i18n||(e.__i18nBridge||e.__i18n?{}:null),e.i18n?e.i18n instanceof Y||c(e.i18n)?(this._i18n.subscribeDataChanging(this),this._subscribing=!0):n("Cannot be interpreted 'i18n' option."):(this.$root&&this.$root.$i18n&&this.$root.$i18n instanceof Y||e.parent&&e.parent.$i18n&&e.parent.$i18n instanceof Y)&&(this._i18n.subscribeDataChanging(this),this._subscribing=!0)},mounted:t,beforeDestroy:function(){if(this._i18n){var e=this;this.$nextTick((function(){e._subscribing&&(e._i18n.unsubscribeDataChanging(e),delete e._subscribing),e._i18nWatcher&&(e._i18nWatcher(),e._i18n.destroyVM(),delete e._i18nWatcher),e._localeWatcher&&(e._localeWatcher(),delete e._localeWatcher)}))}}}}(t.bridge)),x.directive("t",{bind:C,update:M,unbind:T}),x.component(b.name,b),x.component(S.name,S),x.config.optionMergeStrategies.i18n=function(e,t){return void 0===t?e:t}))}var q=function(){this._caches=Object.create(null)};q.prototype.interpolate=function(e,t){if(!t)return[e];var i=this._caches[e];return i||(i=function(e){var t=[],n=0,i="";for(;n<e.length;){var r=e[n++];if("{"===r){i&&t.push({type:"text",value:i}),i="";var o="";for(r=e[n++];void 0!==r&&"}"!==r;)o+=r,r=e[n++];var a="}"===r,s=E.test(o)?"list":a&&D.test(o)?"named":"unknown";t.push({value:o,type:s})}else"%"===r?"{"!==e[n]&&(i+=r):i+=r}return i&&t.push({type:"text",value:i}),t}(e),this._caches[e]=i),function(e,t){var i=[],r=0,a=Array.isArray(t)?"list":o(t)?"named":"unknown";if("unknown"===a)return i;for(;r<e.length;){var s=e[r];switch(s.type){case"text":i.push(s.value);break;case"list":i.push(t[parseInt(s.value,10)]);break;case"named":"named"===a?i.push(t[s.value]):n("Type of token '"+s.type+"' and format of value '"+a+"' don't match!");break;case"unknown":n("Detect 'unknown' type of token!")}r++}return i}(i,t)};var E=/^(?:\d)+/,D=/^(?:\w)+/;var z=[];z[0]={ws:[0],ident:[3,0],"[":[4],eof:[7]},z[1]={ws:[1],".":[2],"[":[4],eof:[7]},z[2]={ws:[2],ident:[3,0],0:[3,0],number:[3,0]},z[3]={ident:[3,0],0:[3,0],number:[3,0],ws:[1,1],".":[2,1],"[":[4,1],eof:[7,1]},z[4]={"'":[5,0],'"':[6,0],"[":[4,2],"]":[1,3],eof:8,else:[4,0]},z[5]={"'":[4,0],eof:8,else:[5,0]},z[6]={'"':[4,0],eof:8,else:[6,0]};var N=/^\s?(?:true|false|-?[\d.]+|'[^']*'|"[^"]*")\s?$/;function j(e){if(null==e)return"eof";switch(e.charCodeAt(0)){case 91:case 93:case 46:case 34:case 39:return e;case 95:case 36:case 45:return"ident";case 9:case 10:case 13:case 160:case 65279:case 8232:case 8233:return"ws"}return"ident"}function R(e){var t,n,i,r=e.trim();return("0"!==e.charAt(0)||!isNaN(e))&&(i=r,N.test(i)?(n=(t=r).charCodeAt(0))!==t.charCodeAt(t.length-1)||34!==n&&39!==n?t:t.slice(1,-1):"*"+r)}var I=function(){this._cache=Object.create(null)};I.prototype.parsePath=function(e){var t=this._cache[e];return t||(t=function(e){var t,n,i,r,o,a,s,l=[],c=-1,u=0,d=0,h=[];function f(){var t=e[c+1];if(5===u&&"'"===t||6===u&&'"'===t)return c++,i="\\"+t,h[0](),!0}for(h[1]=function(){void 0!==n&&(l.push(n),n=void 0)},h[0]=function(){void 0===n?n=i:n+=i},h[2]=function(){h[0](),d++},h[3]=function(){if(d>0)d--,u=4,h[0]();else{if(d=0,void 0===n)return!1;if(!1===(n=R(n)))return!1;h[1]()}};null!==u;)if(c++,"\\"!==(t=e[c])||!f()){if(r=j(t),8===(o=(s=z[u])[r]||s.else||8))return;if(u=o[0],(a=h[o[1]])&&(i=void 0===(i=o[2])?t:i,!1===a()))return;if(7===u)return l}}(e),t&&(this._cache[e]=t)),t||[]},I.prototype.getPathValue=function(e,t){if(!o(e))return null;var n=this.parsePath(t);if(0===n.length)return null;for(var i=n.length,r=e,a=0;a<i;){var s=r[n[a]];if(null==s)return null;r=s,a++}return r};var $,F=/<\/?[\w\s="/.':;#-\/]+>/,B=/(?:@(?:\.[a-zA-Z]+)?:(?:[\w\-_|./]+|\([\w\-_:|./]+\)))/g,V=/^@(?:\.([a-zA-Z]+))?:/,H=/[()]/g,W={upper:function(e){return e.toLocaleUpperCase()},lower:function(e){return e.toLocaleLowerCase()},capitalize:function(e){return""+e.charAt(0).toLocaleUpperCase()+e.substr(1)}},U=new q,Y=function(e){var t=this;void 0===e&&(e={}),!x&&"undefined"!=typeof window&&window.Vue&&O(window.Vue);var n=e.locale||"en-US",i=!1!==e.fallbackLocale&&(e.fallbackLocale||"en-US"),r=e.messages||{},o=e.dateTimeFormats||e.datetimeFormats||{},a=e.numberFormats||{};this._vm=null,this._formatter=e.formatter||U,this._modifiers=e.modifiers||{},this._missing=e.missing||null,this._root=e.root||null,this._sync=void 0===e.sync||!!e.sync,this._fallbackRoot=void 0===e.fallbackRoot||!!e.fallbackRoot,this._fallbackRootWithEmptyString=void 0===e.fallbackRootWithEmptyString||!!e.fallbackRootWithEmptyString,this._formatFallbackMessages=void 0!==e.formatFallbackMessages&&!!e.formatFallbackMessages,this._silentTranslationWarn=void 0!==e.silentTranslationWarn&&e.silentTranslationWarn,this._silentFallbackWarn=void 0!==e.silentFallbackWarn&&!!e.silentFallbackWarn,this._dateTimeFormatters={},this._numberFormatters={},this._path=new I,this._dataListeners=new Set,this._componentInstanceCreatedListener=e.componentInstanceCreatedListener||null,this._preserveDirectiveContent=void 0!==e.preserveDirectiveContent&&!!e.preserveDirectiveContent,this.pluralizationRules=e.pluralizationRules||{},this._warnHtmlInMessage=e.warnHtmlInMessage||"off",this._postTranslation=e.postTranslation||null,this._escapeParameterHtml=e.escapeParameterHtml||!1,"__VUE_I18N_BRIDGE__"in e&&(this.__VUE_I18N_BRIDGE__=e.__VUE_I18N_BRIDGE__),this.getChoiceIndex=function(e,n){var i=Object.getPrototypeOf(t);if(i&&i.getChoiceIndex)return i.getChoiceIndex.call(t,e,n);var r,o;return t.locale in t.pluralizationRules?t.pluralizationRules[t.locale].apply(t,[e,n]):(r=e,o=n,r=Math.abs(r),2===o?r?r>1?1:0:1:r?Math.min(r,2):0)},this._exist=function(e,n){return!(!e||!n)&&(!u(t._path.getPathValue(e,n))||!!e[n])},"warn"!==this._warnHtmlInMessage&&"error"!==this._warnHtmlInMessage||Object.keys(r).forEach((function(e){t._checkLocaleMessage(e,t._warnHtmlInMessage,r[e])})),this._initVM({locale:n,fallbackLocale:i,messages:r,dateTimeFormats:o,numberFormats:a})},G={vm:{configurable:!0},messages:{configurable:!0},dateTimeFormats:{configurable:!0},numberFormats:{configurable:!0},availableLocales:{configurable:!0},locale:{configurable:!0},fallbackLocale:{configurable:!0},formatFallbackMessages:{configurable:!0},missing:{configurable:!0},formatter:{configurable:!0},silentTranslationWarn:{configurable:!0},silentFallbackWarn:{configurable:!0},preserveDirectiveContent:{configurable:!0},warnHtmlInMessage:{configurable:!0},postTranslation:{configurable:!0},sync:{configurable:!0}};return Y.prototype._checkLocaleMessage=function(e,t,o){var s=function(e,t,o,l){if(c(o))Object.keys(o).forEach((function(n){var i=o[n];c(i)?(l.push(n),l.push("."),s(e,t,i,l),l.pop(),l.pop()):(l.push(n),s(e,t,i,l),l.pop())}));else if(r(o))o.forEach((function(n,i){c(n)?(l.push("["+i+"]"),l.push("."),s(e,t,n,l),l.pop(),l.pop()):(l.push("["+i+"]"),s(e,t,n,l),l.pop())}));else if(a(o)){if(F.test(o)){var u="Detected HTML in message '"+o+"' of keypath '"+l.join("")+"' at '"+t+"'. Consider component interpolation with '<i18n>' to avoid XSS. See https://bit.ly/2ZqJzkp";"warn"===e?n(u):"error"===e&&i(u)}}};s(t,e,o,[])},Y.prototype._initVM=function(e){var t=x.config.silent;x.config.silent=!0,this._vm=new x({data:e,__VUE18N__INSTANCE__:!0}),x.config.silent=t},Y.prototype.destroyVM=function(){this._vm.$destroy()},Y.prototype.subscribeDataChanging=function(e){this._dataListeners.add(e)},Y.prototype.unsubscribeDataChanging=function(e){!function(e,t){if(e.delete(t));}(this._dataListeners,e)},Y.prototype.watchI18nData=function(){var e=this;return this._vm.$watch("$data",(function(){for(var t,n,i=(t=e._dataListeners,n=[],t.forEach((function(e){return n.push(e)})),n),r=i.length;r--;)x.nextTick((function(){i[r]&&i[r].$forceUpdate()}))}),{deep:!0})},Y.prototype.watchLocale=function(e){if(e){if(!this.__VUE_I18N_BRIDGE__)return null;var t=this,n=this._vm;return this.vm.$watch("locale",(function(i){n.$set(n,"locale",i),t.__VUE_I18N_BRIDGE__&&e&&(e.locale.value=i),n.$forceUpdate()}),{immediate:!0})}if(!this._sync||!this._root)return null;var i=this._vm;return this._root.$i18n.vm.$watch("locale",(function(e){i.$set(i,"locale",e),i.$forceUpdate()}),{immediate:!0})},Y.prototype.onComponentInstanceCreated=function(e){this._componentInstanceCreatedListener&&this._componentInstanceCreatedListener(e,this)},G.vm.get=function(){return this._vm},G.messages.get=function(){return f(this._getMessages())},G.dateTimeFormats.get=function(){return f(this._getDateTimeFormats())},G.numberFormats.get=function(){return f(this._getNumberFormats())},G.availableLocales.get=function(){return Object.keys(this.messages).sort()},G.locale.get=function(){return this._vm.locale},G.locale.set=function(e){this._vm.$set(this._vm,"locale",e)},G.fallbackLocale.get=function(){return this._vm.fallbackLocale},G.fallbackLocale.set=function(e){this._localeChainCache={},this._vm.$set(this._vm,"fallbackLocale",e)},G.formatFallbackMessages.get=function(){return this._formatFallbackMessages},G.formatFallbackMessages.set=function(e){this._formatFallbackMessages=e},G.missing.get=function(){return this._missing},G.missing.set=function(e){this._missing=e},G.formatter.get=function(){return this._formatter},G.formatter.set=function(e){this._formatter=e},G.silentTranslationWarn.get=function(){return this._silentTranslationWarn},G.silentTranslationWarn.set=function(e){this._silentTranslationWarn=e},G.silentFallbackWarn.get=function(){return this._silentFallbackWarn},G.silentFallbackWarn.set=function(e){this._silentFallbackWarn=e},G.preserveDirectiveContent.get=function(){return this._preserveDirectiveContent},G.preserveDirectiveContent.set=function(e){this._preserveDirectiveContent=e},G.warnHtmlInMessage.get=function(){return this._warnHtmlInMessage},G.warnHtmlInMessage.set=function(e){var t=this,n=this._warnHtmlInMessage;if(this._warnHtmlInMessage=e,n!==e&&("warn"===e||"error"===e)){var i=this._getMessages();Object.keys(i).forEach((function(e){t._checkLocaleMessage(e,t._warnHtmlInMessage,i[e])}))}},G.postTranslation.get=function(){return this._postTranslation},G.postTranslation.set=function(e){this._postTranslation=e},G.sync.get=function(){return this._sync},G.sync.set=function(e){this._sync=e},Y.prototype._getMessages=function(){return this._vm.messages},Y.prototype._getDateTimeFormats=function(){return this._vm.dateTimeFormats},Y.prototype._getNumberFormats=function(){return this._vm.numberFormats},Y.prototype._warnDefault=function(e,t,i,r,o,s){if(!u(i))return i;if(this._missing){var l=this._missing.apply(null,[e,t,r,o]);if(a(l))return l}else this._isSilentTranslationWarn(t)||n("Cannot translate the value of keypath '"+t+"'. Use the value of keypath as default.");if(this._formatFallbackMessages){var c=h.apply(void 0,o);return this._render(t,s,c.params,t)}return t},Y.prototype._isFallbackRoot=function(e){return(this._fallbackRootWithEmptyString?!e:u(e))&&!u(this._root)&&this._fallbackRoot},Y.prototype._isSilentFallbackWarn=function(e){return this._silentFallbackWarn instanceof RegExp?this._silentFallbackWarn.test(e):this._silentFallbackWarn},Y.prototype._isSilentFallback=function(e,t){return this._isSilentFallbackWarn(t)&&(this._isFallbackRoot()||e!==this.fallbackLocale)},Y.prototype._isSilentTranslationWarn=function(e){return this._silentTranslationWarn instanceof RegExp?this._silentTranslationWarn.test(e):this._silentTranslationWarn},Y.prototype._interpolate=function(e,t,i,o,s,l,h){if(!t)return null;var f,p=this._path.getPathValue(t,i);if(r(p)||c(p))return p;if(u(p)){if(!c(t))return null;if(!a(f=t[i])&&!d(f))return this._isSilentTranslationWarn(i)||this._isSilentFallback(e,i)||n("Value of key '"+i+"' is not a string or function !"),null}else{if(!a(p)&&!d(p))return this._isSilentTranslationWarn(i)||this._isSilentFallback(e,i)||n("Value of key '"+i+"' is not a string or function!"),null;f=p}return a(f)&&(f.indexOf("@:")>=0||f.indexOf("@.")>=0)&&(f=this._link(e,t,f,o,"raw",l,h)),this._render(f,s,l,i)},Y.prototype._link=function(e,t,i,o,a,s,l){var c=i,u=c.match(B);for(var d in u)if(u.hasOwnProperty(d)){var h=u[d],f=h.match(V),m=f[0],v=f[1],g=h.replace(m,"").replace(H,"");if(p(l,g))return n('Circular reference found. "'+h+'" is already visited in the chain of '+l.reverse().join(" <- ")),c;l.push(g);var _=this._interpolate(e,t,g,o,"raw"===a?"string":a,"raw"===a?void 0:s,l);if(this._isFallbackRoot(_)){if(this._isSilentTranslationWarn(g)||n("Fall back to translate the link placeholder '"+g+"' with root locale."),!this._root)throw Error("unexpected error");var b=this._root.$i18n;_=b._translate(b._getMessages(),b.locale,b.fallbackLocale,g,o,a,s)}_=this._warnDefault(e,g,_,o,r(s)?s:[s],a),this._modifiers.hasOwnProperty(v)?_=this._modifiers[v](_):W.hasOwnProperty(v)&&(_=W[v](_)),l.pop(),c=_?c.replace(h,_):c}return c},Y.prototype._createMessageContext=function(e,t,n,i){var a=this,s=r(e)?e:[],l=o(e)?e:{},c=this._getMessages(),u=this.locale;return{list:function(e){return s[e]},named:function(e){return l[e]},values:e,formatter:t,path:n,messages:c,locale:u,linked:function(e){return a._interpolate(u,c[u]||{},e,null,i,void 0,[e])}}},Y.prototype._render=function(e,t,n,i){if(d(e))return e(this._createMessageContext(n,this._formatter||U,i,t));var r=this._formatter.interpolate(e,n,i);return r||(r=U.interpolate(e,n,i)),"string"!==t||a(r)?r:r.join("")},Y.prototype._appendItemToChain=function(e,t,n){var i=!1;return p(e,t)||(i=!0,t&&(i="!"!==t[t.length-1],t=t.replace(/!/g,""),e.push(t),n&&n[t]&&(i=n[t]))),i},Y.prototype._appendLocaleToChain=function(e,t,n){var i,r=t.split("-");do{var o=r.join("-");i=this._appendItemToChain(e,o,n),r.splice(-1,1)}while(r.length&&!0===i);return i},Y.prototype._appendBlockToChain=function(e,t,n){for(var i=!0,r=0;r<t.length&&"boolean"==typeof i;r++){var o=t[r];a(o)&&(i=this._appendLocaleToChain(e,o,n))}return i},Y.prototype._getLocaleChain=function(e,t){if(""===e)return[];this._localeChainCache||(this._localeChainCache={});var n=this._localeChainCache[e];if(!n){t||(t=this.fallbackLocale),n=[];for(var i,s=[e];r(s);)s=this._appendBlockToChain(n,s,t);(s=a(i=r(t)?t:o(t)?t.default?t.default:null:t)?[i]:i)&&this._appendBlockToChain(n,s,null),this._localeChainCache[e]=n}return n},Y.prototype._translate=function(e,t,i,r,o,a,s){for(var l,c=this._getLocaleChain(t,i),d=0;d<c.length;d++){var h=c[d];if(!u(l=this._interpolate(h,e[h],r,o,a,s,[r])))return h===t||this._isSilentTranslationWarn(r)||this._isSilentFallbackWarn(r)||n("Fall back to translate the keypath '"+r+"' with '"+h+"' locale."),l}return null},Y.prototype._t=function(e,t,i,r){for(var o,a=[],s=arguments.length-4;s-- >0;)a[s]=arguments[s+4];if(!e)return"";var l,c=h.apply(void 0,a);this._escapeParameterHtml&&(c.params=(null!=(l=c.params)&&Object.keys(l).forEach((function(e){"string"==typeof l[e]&&(l[e]=l[e].replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&apos;"))})),l));var u=c.locale||t,d=this._translate(i,u,this.fallbackLocale,e,r,"string",c.params);if(this._isFallbackRoot(d)){if(this._isSilentTranslationWarn(e)||this._isSilentFallbackWarn(e)||n("Fall back to translate the keypath '"+e+"' with root locale."),!this._root)throw Error("unexpected error");return(o=this._root).$t.apply(o,[e].concat(a))}return d=this._warnDefault(u,e,d,r,a,"string"),this._postTranslation&&null!=d&&(d=this._postTranslation(d,e)),d},Y.prototype.t=function(e){for(var t,n=[],i=arguments.length-1;i-- >0;)n[i]=arguments[i+1];return(t=this)._t.apply(t,[e,this.locale,this._getMessages(),null].concat(n))},Y.prototype._i=function(e,t,i,r,o){var a=this._translate(i,t,this.fallbackLocale,e,r,"raw",o);if(this._isFallbackRoot(a)){if(this._isSilentTranslationWarn(e)||n("Fall back to interpolate the keypath '"+e+"' with root locale."),!this._root)throw Error("unexpected error");return this._root.$i18n.i(e,t,o)}return this._warnDefault(t,e,a,r,[o],"raw")},Y.prototype.i=function(e,t,n){return e?(a(t)||(t=this.locale),this._i(e,t,this._getMessages(),null,n)):""},Y.prototype._tc=function(e,t,n,i,r){for(var o,a=[],s=arguments.length-5;s-- >0;)a[s]=arguments[s+5];if(!e)return"";void 0===r&&(r=1);var l={count:r,n:r},c=h.apply(void 0,a);return c.params=Object.assign(l,c.params),a=null===c.locale?[c.params]:[c.locale,c.params],this.fetchChoice((o=this)._t.apply(o,[e,t,n,i].concat(a)),r)},Y.prototype.fetchChoice=function(e,t){if(!e||!a(e))return null;var n=e.split("|");return n[t=this.getChoiceIndex(t,n.length)]?n[t].trim():e},Y.prototype.tc=function(e,t){for(var n,i=[],r=arguments.length-2;r-- >0;)i[r]=arguments[r+2];return(n=this)._tc.apply(n,[e,this.locale,this._getMessages(),null,t].concat(i))},Y.prototype._te=function(e,t,n){for(var i=[],r=arguments.length-3;r-- >0;)i[r]=arguments[r+3];var o=h.apply(void 0,i).locale||t;return this._exist(n[o],e)},Y.prototype.te=function(e,t){return this._te(e,this.locale,this._getMessages(),t)},Y.prototype.getLocaleMessage=function(e){return f(this._vm.messages[e]||{})},Y.prototype.setLocaleMessage=function(e,t){"warn"!==this._warnHtmlInMessage&&"error"!==this._warnHtmlInMessage||this._checkLocaleMessage(e,this._warnHtmlInMessage,t),this._vm.$set(this._vm.messages,e,t)},Y.prototype.mergeLocaleMessage=function(e,t){"warn"!==this._warnHtmlInMessage&&"error"!==this._warnHtmlInMessage||this._checkLocaleMessage(e,this._warnHtmlInMessage,t),this._vm.$set(this._vm.messages,e,g(void 0!==this._vm.messages[e]&&Object.keys(this._vm.messages[e]).length?Object.assign({},this._vm.messages[e]):{},t))},Y.prototype.getDateTimeFormat=function(e){return f(this._vm.dateTimeFormats[e]||{})},Y.prototype.setDateTimeFormat=function(e,t){this._vm.$set(this._vm.dateTimeFormats,e,t),this._clearDateTimeFormat(e,t)},Y.prototype.mergeDateTimeFormat=function(e,t){this._vm.$set(this._vm.dateTimeFormats,e,g(this._vm.dateTimeFormats[e]||{},t)),this._clearDateTimeFormat(e,t)},Y.prototype._clearDateTimeFormat=function(e,t){for(var n in t){var i=e+"__"+n;this._dateTimeFormatters.hasOwnProperty(i)&&delete this._dateTimeFormatters[i]}},Y.prototype._localizeDateTime=function(e,t,i,r,o,a){for(var s=t,l=r[s],c=this._getLocaleChain(t,i),d=0;d<c.length;d++){var h=s,f=c[d];if(s=f,!u(l=r[f])&&!u(l[o]))break;f===t||this._isSilentTranslationWarn(o)||this._isSilentFallbackWarn(o)||n("Fall back to '"+f+"' datetime formats from '"+h+"' datetime formats.")}if(u(l)||u(l[o]))return null;var p,m=l[o];if(a)p=new Intl.DateTimeFormat(s,Object.assign({},m,a));else{var v=s+"__"+o;(p=this._dateTimeFormatters[v])||(p=this._dateTimeFormatters[v]=new Intl.DateTimeFormat(s,m))}return p.format(e)},Y.prototype._d=function(e,t,i,r){if(!Y.availabilities.dateTimeFormat)return n("Cannot format a Date value due to not supported Intl.DateTimeFormat."),"";if(!i)return(r?new Intl.DateTimeFormat(t,r):new Intl.DateTimeFormat(t)).format(e);var o=this._localizeDateTime(e,t,this.fallbackLocale,this._getDateTimeFormats(),i,r);if(this._isFallbackRoot(o)){if(this._isSilentTranslationWarn(i)||this._isSilentFallbackWarn(i)||n("Fall back to datetime localization of root: key '"+i+"'."),!this._root)throw Error("unexpected error");return this._root.$i18n.d(e,i,t)}return o||""},Y.prototype.d=function(e){for(var n=[],i=arguments.length-1;i-- >0;)n[i]=arguments[i+1];var r=this.locale,s=null,l=null;return 1===n.length?(a(n[0])?s=n[0]:o(n[0])&&(n[0].locale&&(r=n[0].locale),n[0].key&&(s=n[0].key)),l=Object.keys(n[0]).reduce((function(e,i){var r;return p(t,i)?Object.assign({},e,((r={})[i]=n[0][i],r)):e}),null)):2===n.length&&(a(n[0])&&(s=n[0]),a(n[1])&&(r=n[1])),this._d(e,r,s,l)},Y.prototype.getNumberFormat=function(e){return f(this._vm.numberFormats[e]||{})},Y.prototype.setNumberFormat=function(e,t){this._vm.$set(this._vm.numberFormats,e,t),this._clearNumberFormat(e,t)},Y.prototype.mergeNumberFormat=function(e,t){this._vm.$set(this._vm.numberFormats,e,g(this._vm.numberFormats[e]||{},t)),this._clearNumberFormat(e,t)},Y.prototype._clearNumberFormat=function(e,t){for(var n in t){var i=e+"__"+n;this._numberFormatters.hasOwnProperty(i)&&delete this._numberFormatters[i]}},Y.prototype._getNumberFormatter=function(e,t,i,r,o,a){for(var s=t,l=r[s],c=this._getLocaleChain(t,i),d=0;d<c.length;d++){var h=s,f=c[d];if(s=f,!u(l=r[f])&&!u(l[o]))break;f===t||this._isSilentTranslationWarn(o)||this._isSilentFallbackWarn(o)||n("Fall back to '"+f+"' number formats from '"+h+"' number formats.")}if(u(l)||u(l[o]))return null;var p,m=l[o];if(a)p=new Intl.NumberFormat(s,Object.assign({},m,a));else{var v=s+"__"+o;(p=this._numberFormatters[v])||(p=this._numberFormatters[v]=new Intl.NumberFormat(s,m))}return p},Y.prototype._n=function(e,t,i,r){if(!Y.availabilities.numberFormat)return n("Cannot format a Number value due to not supported Intl.NumberFormat."),"";if(!i)return(r?new Intl.NumberFormat(t,r):new Intl.NumberFormat(t)).format(e);var o=this._getNumberFormatter(e,t,this.fallbackLocale,this._getNumberFormats(),i,r),a=o&&o.format(e);if(this._isFallbackRoot(a)){if(this._isSilentTranslationWarn(i)||this._isSilentFallbackWarn(i)||n("Fall back to number localization of root: key '"+i+"'."),!this._root)throw Error("unexpected error");return this._root.$i18n.n(e,Object.assign({},{key:i,locale:t},r))}return a||""},Y.prototype.n=function(t){for(var n=[],i=arguments.length-1;i-- >0;)n[i]=arguments[i+1];var r=this.locale,s=null,l=null;return 1===n.length?a(n[0])?s=n[0]:o(n[0])&&(n[0].locale&&(r=n[0].locale),n[0].key&&(s=n[0].key),l=Object.keys(n[0]).reduce((function(t,i){var r;return p(e,i)?Object.assign({},t,((r={})[i]=n[0][i],r)):t}),null)):2===n.length&&(a(n[0])&&(s=n[0]),a(n[1])&&(r=n[1])),this._n(t,r,s,l)},Y.prototype._ntp=function(e,t,i,r){if(!Y.availabilities.numberFormat)return n("Cannot format to parts a Number value due to not supported Intl.NumberFormat."),[];if(!i)return(r?new Intl.NumberFormat(t,r):new Intl.NumberFormat(t)).formatToParts(e);var o=this._getNumberFormatter(e,t,this.fallbackLocale,this._getNumberFormats(),i,r),a=o&&o.formatToParts(e);if(this._isFallbackRoot(a)){if(this._isSilentTranslationWarn(i)||n("Fall back to format number to parts of root: key '"+i+"' ."),!this._root)throw Error("unexpected error");return this._root.$i18n._ntp(e,t,i,r)}return a||[]},Object.defineProperties(Y.prototype,G),Object.defineProperty(Y,"availabilities",{get:function(){if(!$){var e="undefined"!=typeof Intl;$={dateTimeFormat:e&&void 0!==Intl.DateTimeFormat,numberFormat:e&&void 0!==Intl.NumberFormat}}return $}}),Y.install=O,Y.version="8.28.2",Y})),/*! showdown v 2.1.0 - 21-04-2022 */
function(){function e(e){"use strict";var t={omitExtraWLInCodeBlocks:{defaultValue:!1,describe:"Omit the default extra whiteline added to code blocks",type:"boolean"},noHeaderId:{defaultValue:!1,describe:"Turn on/off generated header id",type:"boolean"},prefixHeaderId:{defaultValue:!1,describe:"Add a prefix to the generated header ids. Passing a string will prefix that string to the header id. Setting to true will add a generic 'section-' prefix",type:"string"},rawPrefixHeaderId:{defaultValue:!1,describe:'Setting this option to true will prevent showdown from modifying the prefix. This might result in malformed IDs (if, for instance, the " char is used in the prefix)',type:"boolean"},ghCompatibleHeaderId:{defaultValue:!1,describe:"Generate header ids compatible with github style (spaces are replaced with dashes, a bunch of non alphanumeric chars are removed)",type:"boolean"},rawHeaderId:{defaultValue:!1,describe:"Remove only spaces, ' and \" from generated header ids (including prefixes), replacing them with dashes (-). WARNING: This might result in malformed ids",type:"boolean"},headerLevelStart:{defaultValue:!1,describe:"The header blocks level start",type:"integer"},parseImgDimensions:{defaultValue:!1,describe:"Turn on/off image dimension parsing",type:"boolean"},simplifiedAutoLink:{defaultValue:!1,describe:"Turn on/off GFM autolink style",type:"boolean"},excludeTrailingPunctuationFromURLs:{defaultValue:!1,describe:"Excludes trailing punctuation from links generated with autoLinking",type:"boolean"},literalMidWordUnderscores:{defaultValue:!1,describe:"Parse midword underscores as literal underscores",type:"boolean"},literalMidWordAsterisks:{defaultValue:!1,describe:"Parse midword asterisks as literal asterisks",type:"boolean"},strikethrough:{defaultValue:!1,describe:"Turn on/off strikethrough support",type:"boolean"},tables:{defaultValue:!1,describe:"Turn on/off tables support",type:"boolean"},tablesHeaderId:{defaultValue:!1,describe:"Add an id to table headers",type:"boolean"},ghCodeBlocks:{defaultValue:!0,describe:"Turn on/off GFM fenced code blocks support",type:"boolean"},tasklists:{defaultValue:!1,describe:"Turn on/off GFM tasklist support",type:"boolean"},smoothLivePreview:{defaultValue:!1,describe:"Prevents weird effects in live previews due to incomplete input",type:"boolean"},smartIndentationFix:{defaultValue:!1,describe:"Tries to smartly fix indentation in es6 strings",type:"boolean"},disableForced4SpacesIndentedSublists:{defaultValue:!1,describe:"Disables the requirement of indenting nested sublists by 4 spaces",type:"boolean"},simpleLineBreaks:{defaultValue:!1,describe:"Parses simple line breaks as <br> (GFM Style)",type:"boolean"},requireSpaceBeforeHeadingText:{defaultValue:!1,describe:"Makes adding a space between `#` and the header text mandatory (GFM Style)",type:"boolean"},ghMentions:{defaultValue:!1,describe:"Enables github @mentions",type:"boolean"},ghMentionsLink:{defaultValue:"https://github.com/{u}",describe:"Changes the link generated by @mentions. Only applies if ghMentions option is enabled.",type:"string"},encodeEmails:{defaultValue:!0,describe:"Encode e-mail addresses through the use of Character Entities, transforming ASCII e-mail addresses into its equivalent decimal entities",type:"boolean"},openLinksInNewWindow:{defaultValue:!1,describe:"Open all links in new windows",type:"boolean"},backslashEscapesHTMLTags:{defaultValue:!1,describe:"Support for HTML Tag escaping. ex: <div>foo</div>",type:"boolean"},emoji:{defaultValue:!1,describe:"Enable emoji support. Ex: `this is a :smile: emoji`",type:"boolean"},underline:{defaultValue:!1,describe:"Enable support for underline. Syntax is double or triple underscores: `__underline word__`. With this option enabled, underscores no longer parses into `<em>` and `<strong>`",type:"boolean"},ellipsis:{defaultValue:!0,describe:"Replaces three dots with the ellipsis unicode character",type:"boolean"},completeHTMLDocument:{defaultValue:!1,describe:"Outputs a complete html document, including `<html>`, `<head>` and `<body>` tags",type:"boolean"},metadata:{defaultValue:!1,describe:"Enable support for document metadata (defined at the top of the document between `«««` and `»»»` or between `---` and `---`).",type:"boolean"},splitAdjacentBlockquotes:{defaultValue:!1,describe:"Split adjacent blockquote blocks",type:"boolean"}};if(!1===e)return JSON.parse(JSON.stringify(t));var n={};for(var i in t)t.hasOwnProperty(i)&&(n[i]=t[i].defaultValue);return n}var t={},n={},i={},r=e(!0),o="vanilla",a={github:{omitExtraWLInCodeBlocks:!0,simplifiedAutoLink:!0,excludeTrailingPunctuationFromURLs:!0,literalMidWordUnderscores:!0,strikethrough:!0,tables:!0,tablesHeaderId:!0,ghCodeBlocks:!0,tasklists:!0,disableForced4SpacesIndentedSublists:!0,simpleLineBreaks:!0,requireSpaceBeforeHeadingText:!0,ghCompatibleHeaderId:!0,ghMentions:!0,backslashEscapesHTMLTags:!0,emoji:!0,splitAdjacentBlockquotes:!0},original:{noHeaderId:!0,ghCodeBlocks:!1},ghost:{omitExtraWLInCodeBlocks:!0,parseImgDimensions:!0,simplifiedAutoLink:!0,excludeTrailingPunctuationFromURLs:!0,literalMidWordUnderscores:!0,strikethrough:!0,tables:!0,tablesHeaderId:!0,ghCodeBlocks:!0,tasklists:!0,smoothLivePreview:!0,simpleLineBreaks:!0,requireSpaceBeforeHeadingText:!0,ghMentions:!1,encodeEmails:!0},vanilla:e(!0),allOn:function(){"use strict";var t=e(!0),n={};for(var i in t)t.hasOwnProperty(i)&&(n[i]=!0);return n}()};function s(e,n){"use strict";var i=n?"Error in "+n+" extension->":"Error in unnamed extension",r={valid:!0,error:""};t.helper.isArray(e)||(e=[e]);for(var o=0;o<e.length;++o){var a=i+" sub-extension "+o+": ",s=e[o];if("object"!=typeof s)return r.valid=!1,r.error=a+"must be an object, but "+typeof s+" given",r;if(!t.helper.isString(s.type))return r.valid=!1,r.error=a+'property "type" must be a string, but '+typeof s.type+" given",r;var l=s.type=s.type.toLowerCase();if("language"===l&&(l=s.type="lang"),"html"===l&&(l=s.type="output"),"lang"!==l&&"output"!==l&&"listener"!==l)return r.valid=!1,r.error=a+"type "+l+' is not recognized. Valid values: "lang/language", "output/html" or "listener"',r;if("listener"===l){if(t.helper.isUndefined(s.listeners))return r.valid=!1,r.error=a+'. Extensions of type "listener" must have a property called "listeners"',r}else if(t.helper.isUndefined(s.filter)&&t.helper.isUndefined(s.regex))return r.valid=!1,r.error=a+l+' extensions must define either a "regex" property or a "filter" method',r;if(s.listeners){if("object"!=typeof s.listeners)return r.valid=!1,r.error=a+'"listeners" property must be an object but '+typeof s.listeners+" given",r;for(var c in s.listeners)if(s.listeners.hasOwnProperty(c)&&"function"!=typeof s.listeners[c])return r.valid=!1,r.error=a+'"listeners" property must be an hash of [event name]: [callback]. listeners.'+c+" must be a function but "+typeof s.listeners[c]+" given",r}if(s.filter){if("function"!=typeof s.filter)return r.valid=!1,r.error=a+'"filter" must be a function, but '+typeof s.filter+" given",r}else if(s.regex){if(t.helper.isString(s.regex)&&(s.regex=new RegExp(s.regex,"g")),!(s.regex instanceof RegExp))return r.valid=!1,r.error=a+'"regex" property must either be a string or a RegExp object, but '+typeof s.regex+" given",r;if(t.helper.isUndefined(s.replace))return r.valid=!1,r.error=a+'"regex" extensions must implement a replace string or function',r}}return r}function l(e,t){"use strict";return"¨E"+t.charCodeAt(0)+"E"}t.helper={},t.extensions={},t.setOption=function(e,t){"use strict";return r[e]=t,this},t.getOption=function(e){"use strict";return r[e]},t.getOptions=function(){"use strict";return r},t.resetOptions=function(){"use strict";r=e(!0)},t.setFlavor=function(e){"use strict";if(!a.hasOwnProperty(e))throw Error(e+" flavor was not found");t.resetOptions();var n=a[e];for(var i in o=e,n)n.hasOwnProperty(i)&&(r[i]=n[i])},t.getFlavor=function(){"use strict";return o},t.getFlavorOptions=function(e){"use strict";if(a.hasOwnProperty(e))return a[e]},t.getDefaultOptions=function(t){"use strict";return e(t)},t.subParser=function(e,i){"use strict";if(t.helper.isString(e)){if(void 0===i){if(n.hasOwnProperty(e))return n[e];throw Error("SubParser named "+e+" not registered!")}n[e]=i}},t.extension=function(e,n){"use strict";if(!t.helper.isString(e))throw Error("Extension 'name' must be a string");if(e=t.helper.stdExtName(e),t.helper.isUndefined(n)){if(!i.hasOwnProperty(e))throw Error("Extension named "+e+" is not registered!");return i[e]}"function"==typeof n&&(n=n()),t.helper.isArray(n)||(n=[n]);var r=s(n,e);if(!r.valid)throw Error(r.error);i[e]=n},t.getAllExtensions=function(){"use strict";return i},t.removeExtension=function(e){"use strict";delete i[e]},t.resetExtensions=function(){"use strict";i={}},t.validateExtension=function(e){"use strict";var t=s(e,null);return!!t.valid||(console.warn(t.error),!1)},t.hasOwnProperty("helper")||(t.helper={}),t.helper.isString=function(e){"use strict";return"string"==typeof e||e instanceof String},t.helper.isFunction=function(e){"use strict";return e&&"[object Function]"==={}.toString.call(e)},t.helper.isArray=function(e){"use strict";return Array.isArray(e)},t.helper.isUndefined=function(e){"use strict";return void 0===e},t.helper.forEach=function(e,n){"use strict";if(t.helper.isUndefined(e))throw new Error("obj param is required");if(t.helper.isUndefined(n))throw new Error("callback param is required");if(!t.helper.isFunction(n))throw new Error("callback param must be a function/closure");if("function"==typeof e.forEach)e.forEach(n);else if(t.helper.isArray(e))for(var i=0;i<e.length;i++)n(e[i],i,e);else{if("object"!=typeof e)throw new Error("obj does not seem to be an array or an iterable object");for(var r in e)e.hasOwnProperty(r)&&n(e[r],r,e)}},t.helper.stdExtName=function(e){"use strict";return e.replace(/[_?*+\/\\.^-]/g,"").replace(/\s/g,"").toLowerCase()},t.helper.escapeCharactersCallback=l,t.helper.escapeCharacters=function(e,t,n){"use strict";var i="(["+t.replace(/([\[\]\\])/g,"\\$1")+"])";n&&(i="\\\\"+i);var r=new RegExp(i,"g");return e=e.replace(r,l)},t.helper.unescapeHTMLEntities=function(e){"use strict";return e.replace(/&quot;/g,'"').replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&amp;/g,"&")};var c=function(e,t,n,i){"use strict";var r,o,a,s,l,c=i||"",u=c.indexOf("g")>-1,d=new RegExp(t+"|"+n,"g"+c.replace(/g/g,"")),h=new RegExp(t,c.replace(/g/g,"")),f=[];do{for(r=0;a=d.exec(e);)if(h.test(a[0]))r++||(s=(o=d.lastIndex)-a[0].length);else if(r&&!--r){l=a.index+a[0].length;var p={left:{start:s,end:o},match:{start:o,end:a.index},right:{start:a.index,end:l},wholeMatch:{start:s,end:l}};if(f.push(p),!u)return f}}while(r&&(d.lastIndex=o));return f};t.helper.matchRecursiveRegExp=function(e,t,n,i){"use strict";for(var r=c(e,t,n,i),o=[],a=0;a<r.length;++a)o.push([e.slice(r[a].wholeMatch.start,r[a].wholeMatch.end),e.slice(r[a].match.start,r[a].match.end),e.slice(r[a].left.start,r[a].left.end),e.slice(r[a].right.start,r[a].right.end)]);return o},t.helper.replaceRecursiveRegExp=function(e,n,i,r,o){"use strict";if(!t.helper.isFunction(n)){var a=n;n=function(){return a}}var s=c(e,i,r,o),l=e,u=s.length;if(u>0){var d=[];0!==s[0].wholeMatch.start&&d.push(e.slice(0,s[0].wholeMatch.start));for(var h=0;h<u;++h)d.push(n(e.slice(s[h].wholeMatch.start,s[h].wholeMatch.end),e.slice(s[h].match.start,s[h].match.end),e.slice(s[h].left.start,s[h].left.end),e.slice(s[h].right.start,s[h].right.end))),h<u-1&&d.push(e.slice(s[h].wholeMatch.end,s[h+1].wholeMatch.start));s[u-1].wholeMatch.end<e.length&&d.push(e.slice(s[u-1].wholeMatch.end)),l=d.join("")}return l},t.helper.regexIndexOf=function(e,n,i){"use strict";if(!t.helper.isString(e))throw"InvalidArgumentError: first parameter of showdown.helper.regexIndexOf function must be a string";if(n instanceof RegExp==!1)throw"InvalidArgumentError: second parameter of showdown.helper.regexIndexOf function must be an instance of RegExp";var r=e.substring(i||0).search(n);return r>=0?r+(i||0):r},t.helper.splitAtIndex=function(e,n){"use strict";if(!t.helper.isString(e))throw"InvalidArgumentError: first parameter of showdown.helper.regexIndexOf function must be a string";return[e.substring(0,n),e.substring(n)]},t.helper.encodeEmailAddress=function(e){"use strict";var t=[function(e){return"&#"+e.charCodeAt(0)+";"},function(e){return"&#x"+e.charCodeAt(0).toString(16)+";"},function(e){return e}];return e=e.replace(/./g,(function(e){if("@"===e)e=t[Math.floor(2*Math.random())](e);else{var n=Math.random();e=n>.9?t[2](e):n>.45?t[1](e):t[0](e)}return e}))},t.helper.padEnd=function(e,t,n){"use strict";return t>>=0,n=String(n||" "),e.length>t?String(e):((t-=e.length)>n.length&&(n+=n.repeat(t/n.length)),String(e)+n.slice(0,t))},"undefined"==typeof console&&(console={warn:function(e){"use strict";alert(e)},log:function(e){"use strict";alert(e)},error:function(e){"use strict";throw e}}),t.helper.regexes={asteriskDashAndColon:/([*_:~])/g},t.helper.emojis={"+1":"👍","-1":"👎",100:"💯",1234:"🔢","1st_place_medal":"🥇","2nd_place_medal":"🥈","3rd_place_medal":"🥉","8ball":"🎱",a:"🅰️",ab:"🆎",abc:"🔤",abcd:"🔡",accept:"🉑",aerial_tramway:"🚡",airplane:"✈️",alarm_clock:"⏰",alembic:"⚗️",alien:"👽",ambulance:"🚑",amphora:"🏺",anchor:"⚓️",angel:"👼",anger:"💢",angry:"😠",anguished:"😧",ant:"🐜",apple:"🍎",aquarius:"♒️",aries:"♈️",arrow_backward:"◀️",arrow_double_down:"⏬",arrow_double_up:"⏫",arrow_down:"⬇️",arrow_down_small:"🔽",arrow_forward:"▶️",arrow_heading_down:"⤵️",arrow_heading_up:"⤴️",arrow_left:"⬅️",arrow_lower_left:"↙️",arrow_lower_right:"↘️",arrow_right:"➡️",arrow_right_hook:"↪️",arrow_up:"⬆️",arrow_up_down:"↕️",arrow_up_small:"🔼",arrow_upper_left:"↖️",arrow_upper_right:"↗️",arrows_clockwise:"🔃",arrows_counterclockwise:"🔄",art:"🎨",articulated_lorry:"🚛",artificial_satellite:"🛰",astonished:"😲",athletic_shoe:"👟",atm:"🏧",atom_symbol:"⚛️",avocado:"🥑",b:"🅱️",baby:"👶",baby_bottle:"🍼",baby_chick:"🐤",baby_symbol:"🚼",back:"🔙",bacon:"🥓",badminton:"🏸",baggage_claim:"🛄",baguette_bread:"🥖",balance_scale:"⚖️",balloon:"🎈",ballot_box:"🗳",ballot_box_with_check:"☑️",bamboo:"🎍",banana:"🍌",bangbang:"‼️",bank:"🏦",bar_chart:"📊",barber:"💈",baseball:"⚾️",basketball:"🏀",basketball_man:"⛹️",basketball_woman:"⛹️&zwj;♀️",bat:"🦇",bath:"🛀",bathtub:"🛁",battery:"🔋",beach_umbrella:"🏖",bear:"🐻",bed:"🛏",bee:"🐝",beer:"🍺",beers:"🍻",beetle:"🐞",beginner:"🔰",bell:"🔔",bellhop_bell:"🛎",bento:"🍱",biking_man:"🚴",bike:"🚲",biking_woman:"🚴&zwj;♀️",bikini:"👙",biohazard:"☣️",bird:"🐦",birthday:"🎂",black_circle:"⚫️",black_flag:"🏴",black_heart:"🖤",black_joker:"🃏",black_large_square:"⬛️",black_medium_small_square:"◾️",black_medium_square:"◼️",black_nib:"✒️",black_small_square:"▪️",black_square_button:"🔲",blonde_man:"👱",blonde_woman:"👱&zwj;♀️",blossom:"🌼",blowfish:"🐡",blue_book:"📘",blue_car:"🚙",blue_heart:"💙",blush:"😊",boar:"🐗",boat:"⛵️",bomb:"💣",book:"📖",bookmark:"🔖",bookmark_tabs:"📑",books:"📚",boom:"💥",boot:"👢",bouquet:"💐",bowing_man:"🙇",bow_and_arrow:"🏹",bowing_woman:"🙇&zwj;♀️",bowling:"🎳",boxing_glove:"🥊",boy:"👦",bread:"🍞",bride_with_veil:"👰",bridge_at_night:"🌉",briefcase:"💼",broken_heart:"💔",bug:"🐛",building_construction:"🏗",bulb:"💡",bullettrain_front:"🚅",bullettrain_side:"🚄",burrito:"🌯",bus:"🚌",business_suit_levitating:"🕴",busstop:"🚏",bust_in_silhouette:"👤",busts_in_silhouette:"👥",butterfly:"🦋",cactus:"🌵",cake:"🍰",calendar:"📆",call_me_hand:"🤙",calling:"📲",camel:"🐫",camera:"📷",camera_flash:"📸",camping:"🏕",cancer:"♋️",candle:"🕯",candy:"🍬",canoe:"🛶",capital_abcd:"🔠",capricorn:"♑️",car:"🚗",card_file_box:"🗃",card_index:"📇",card_index_dividers:"🗂",carousel_horse:"🎠",carrot:"🥕",cat:"🐱",cat2:"🐈",cd:"💿",chains:"⛓",champagne:"🍾",chart:"💹",chart_with_downwards_trend:"📉",chart_with_upwards_trend:"📈",checkered_flag:"🏁",cheese:"🧀",cherries:"🍒",cherry_blossom:"🌸",chestnut:"🌰",chicken:"🐔",children_crossing:"🚸",chipmunk:"🐿",chocolate_bar:"🍫",christmas_tree:"🎄",church:"⛪️",cinema:"🎦",circus_tent:"🎪",city_sunrise:"🌇",city_sunset:"🌆",cityscape:"🏙",cl:"🆑",clamp:"🗜",clap:"👏",clapper:"🎬",classical_building:"🏛",clinking_glasses:"🥂",clipboard:"📋",clock1:"🕐",clock10:"🕙",clock1030:"🕥",clock11:"🕚",clock1130:"🕦",clock12:"🕛",clock1230:"🕧",clock130:"🕜",clock2:"🕑",clock230:"🕝",clock3:"🕒",clock330:"🕞",clock4:"🕓",clock430:"🕟",clock5:"🕔",clock530:"🕠",clock6:"🕕",clock630:"🕡",clock7:"🕖",clock730:"🕢",clock8:"🕗",clock830:"🕣",clock9:"🕘",clock930:"🕤",closed_book:"📕",closed_lock_with_key:"🔐",closed_umbrella:"🌂",cloud:"☁️",cloud_with_lightning:"🌩",cloud_with_lightning_and_rain:"⛈",cloud_with_rain:"🌧",cloud_with_snow:"🌨",clown_face:"🤡",clubs:"♣️",cocktail:"🍸",coffee:"☕️",coffin:"⚰️",cold_sweat:"😰",comet:"☄️",computer:"💻",computer_mouse:"🖱",confetti_ball:"🎊",confounded:"😖",confused:"😕",congratulations:"㊗️",construction:"🚧",construction_worker_man:"👷",construction_worker_woman:"👷&zwj;♀️",control_knobs:"🎛",convenience_store:"🏪",cookie:"🍪",cool:"🆒",policeman:"👮",copyright:"©️",corn:"🌽",couch_and_lamp:"🛋",couple:"👫",couple_with_heart_woman_man:"💑",couple_with_heart_man_man:"👨&zwj;❤️&zwj;👨",couple_with_heart_woman_woman:"👩&zwj;❤️&zwj;👩",couplekiss_man_man:"👨&zwj;❤️&zwj;💋&zwj;👨",couplekiss_man_woman:"💏",couplekiss_woman_woman:"👩&zwj;❤️&zwj;💋&zwj;👩",cow:"🐮",cow2:"🐄",cowboy_hat_face:"🤠",crab:"🦀",crayon:"🖍",credit_card:"💳",crescent_moon:"🌙",cricket:"🏏",crocodile:"🐊",croissant:"🥐",crossed_fingers:"🤞",crossed_flags:"🎌",crossed_swords:"⚔️",crown:"👑",cry:"😢",crying_cat_face:"😿",crystal_ball:"🔮",cucumber:"🥒",cupid:"💘",curly_loop:"➰",currency_exchange:"💱",curry:"🍛",custard:"🍮",customs:"🛃",cyclone:"🌀",dagger:"🗡",dancer:"💃",dancing_women:"👯",dancing_men:"👯&zwj;♂️",dango:"🍡",dark_sunglasses:"🕶",dart:"🎯",dash:"💨",date:"📅",deciduous_tree:"🌳",deer:"🦌",department_store:"🏬",derelict_house:"🏚",desert:"🏜",desert_island:"🏝",desktop_computer:"🖥",male_detective:"🕵️",diamond_shape_with_a_dot_inside:"💠",diamonds:"♦️",disappointed:"😞",disappointed_relieved:"😥",dizzy:"💫",dizzy_face:"😵",do_not_litter:"🚯",dog:"🐶",dog2:"🐕",dollar:"💵",dolls:"🎎",dolphin:"🐬",door:"🚪",doughnut:"🍩",dove:"🕊",dragon:"🐉",dragon_face:"🐲",dress:"👗",dromedary_camel:"🐪",drooling_face:"🤤",droplet:"💧",drum:"🥁",duck:"🦆",dvd:"📀","e-mail":"📧",eagle:"🦅",ear:"👂",ear_of_rice:"🌾",earth_africa:"🌍",earth_americas:"🌎",earth_asia:"🌏",egg:"🥚",eggplant:"🍆",eight_pointed_black_star:"✴️",eight_spoked_asterisk:"✳️",electric_plug:"🔌",elephant:"🐘",email:"✉️",end:"🔚",envelope_with_arrow:"📩",euro:"💶",european_castle:"🏰",european_post_office:"🏤",evergreen_tree:"🌲",exclamation:"❗️",expressionless:"😑",eye:"👁",eye_speech_bubble:"👁&zwj;🗨",eyeglasses:"👓",eyes:"👀",face_with_head_bandage:"🤕",face_with_thermometer:"🤒",fist_oncoming:"👊",factory:"🏭",fallen_leaf:"🍂",family_man_woman_boy:"👪",family_man_boy:"👨&zwj;👦",family_man_boy_boy:"👨&zwj;👦&zwj;👦",family_man_girl:"👨&zwj;👧",family_man_girl_boy:"👨&zwj;👧&zwj;👦",family_man_girl_girl:"👨&zwj;👧&zwj;👧",family_man_man_boy:"👨&zwj;👨&zwj;👦",family_man_man_boy_boy:"👨&zwj;👨&zwj;👦&zwj;👦",family_man_man_girl:"👨&zwj;👨&zwj;👧",family_man_man_girl_boy:"👨&zwj;👨&zwj;👧&zwj;👦",family_man_man_girl_girl:"👨&zwj;👨&zwj;👧&zwj;👧",family_man_woman_boy_boy:"👨&zwj;👩&zwj;👦&zwj;👦",family_man_woman_girl:"👨&zwj;👩&zwj;👧",family_man_woman_girl_boy:"👨&zwj;👩&zwj;👧&zwj;👦",family_man_woman_girl_girl:"👨&zwj;👩&zwj;👧&zwj;👧",family_woman_boy:"👩&zwj;👦",family_woman_boy_boy:"👩&zwj;👦&zwj;👦",family_woman_girl:"👩&zwj;👧",family_woman_girl_boy:"👩&zwj;👧&zwj;👦",family_woman_girl_girl:"👩&zwj;👧&zwj;👧",family_woman_woman_boy:"👩&zwj;👩&zwj;👦",family_woman_woman_boy_boy:"👩&zwj;👩&zwj;👦&zwj;👦",family_woman_woman_girl:"👩&zwj;👩&zwj;👧",family_woman_woman_girl_boy:"👩&zwj;👩&zwj;👧&zwj;👦",family_woman_woman_girl_girl:"👩&zwj;👩&zwj;👧&zwj;👧",fast_forward:"⏩",fax:"📠",fearful:"😨",feet:"🐾",female_detective:"🕵️&zwj;♀️",ferris_wheel:"🎡",ferry:"⛴",field_hockey:"🏑",file_cabinet:"🗄",file_folder:"📁",film_projector:"📽",film_strip:"🎞",fire:"🔥",fire_engine:"🚒",fireworks:"🎆",first_quarter_moon:"🌓",first_quarter_moon_with_face:"🌛",fish:"🐟",fish_cake:"🍥",fishing_pole_and_fish:"🎣",fist_raised:"✊",fist_left:"🤛",fist_right:"🤜",flags:"🎏",flashlight:"🔦",fleur_de_lis:"⚜️",flight_arrival:"🛬",flight_departure:"🛫",floppy_disk:"💾",flower_playing_cards:"🎴",flushed:"😳",fog:"🌫",foggy:"🌁",football:"🏈",footprints:"👣",fork_and_knife:"🍴",fountain:"⛲️",fountain_pen:"🖋",four_leaf_clover:"🍀",fox_face:"🦊",framed_picture:"🖼",free:"🆓",fried_egg:"🍳",fried_shrimp:"🍤",fries:"🍟",frog:"🐸",frowning:"😦",frowning_face:"☹️",frowning_man:"🙍&zwj;♂️",frowning_woman:"🙍",middle_finger:"🖕",fuelpump:"⛽️",full_moon:"🌕",full_moon_with_face:"🌝",funeral_urn:"⚱️",game_die:"🎲",gear:"⚙️",gem:"💎",gemini:"♊️",ghost:"👻",gift:"🎁",gift_heart:"💝",girl:"👧",globe_with_meridians:"🌐",goal_net:"🥅",goat:"🐐",golf:"⛳️",golfing_man:"🏌️",golfing_woman:"🏌️&zwj;♀️",gorilla:"🦍",grapes:"🍇",green_apple:"🍏",green_book:"📗",green_heart:"💚",green_salad:"🥗",grey_exclamation:"❕",grey_question:"❔",grimacing:"😬",grin:"😁",grinning:"😀",guardsman:"💂",guardswoman:"💂&zwj;♀️",guitar:"🎸",gun:"🔫",haircut_woman:"💇",haircut_man:"💇&zwj;♂️",hamburger:"🍔",hammer:"🔨",hammer_and_pick:"⚒",hammer_and_wrench:"🛠",hamster:"🐹",hand:"✋",handbag:"👜",handshake:"🤝",hankey:"💩",hatched_chick:"🐥",hatching_chick:"🐣",headphones:"🎧",hear_no_evil:"🙉",heart:"❤️",heart_decoration:"💟",heart_eyes:"😍",heart_eyes_cat:"😻",heartbeat:"💓",heartpulse:"💗",hearts:"♥️",heavy_check_mark:"✔️",heavy_division_sign:"➗",heavy_dollar_sign:"💲",heavy_heart_exclamation:"❣️",heavy_minus_sign:"➖",heavy_multiplication_x:"✖️",heavy_plus_sign:"➕",helicopter:"🚁",herb:"🌿",hibiscus:"🌺",high_brightness:"🔆",high_heel:"👠",hocho:"🔪",hole:"🕳",honey_pot:"🍯",horse:"🐴",horse_racing:"🏇",hospital:"🏥",hot_pepper:"🌶",hotdog:"🌭",hotel:"🏨",hotsprings:"♨️",hourglass:"⌛️",hourglass_flowing_sand:"⏳",house:"🏠",house_with_garden:"🏡",houses:"🏘",hugs:"🤗",hushed:"😯",ice_cream:"🍨",ice_hockey:"🏒",ice_skate:"⛸",icecream:"🍦",id:"🆔",ideograph_advantage:"🉐",imp:"👿",inbox_tray:"📥",incoming_envelope:"📨",tipping_hand_woman:"💁",information_source:"ℹ️",innocent:"😇",interrobang:"⁉️",iphone:"📱",izakaya_lantern:"🏮",jack_o_lantern:"🎃",japan:"🗾",japanese_castle:"🏯",japanese_goblin:"👺",japanese_ogre:"👹",jeans:"👖",joy:"😂",joy_cat:"😹",joystick:"🕹",kaaba:"🕋",key:"🔑",keyboard:"⌨️",keycap_ten:"🔟",kick_scooter:"🛴",kimono:"👘",kiss:"💋",kissing:"😗",kissing_cat:"😽",kissing_closed_eyes:"😚",kissing_heart:"😘",kissing_smiling_eyes:"😙",kiwi_fruit:"🥝",koala:"🐨",koko:"🈁",label:"🏷",large_blue_circle:"🔵",large_blue_diamond:"🔷",large_orange_diamond:"🔶",last_quarter_moon:"🌗",last_quarter_moon_with_face:"🌜",latin_cross:"✝️",laughing:"😆",leaves:"🍃",ledger:"📒",left_luggage:"🛅",left_right_arrow:"↔️",leftwards_arrow_with_hook:"↩️",lemon:"🍋",leo:"♌️",leopard:"🐆",level_slider:"🎚",libra:"♎️",light_rail:"🚈",link:"🔗",lion:"🦁",lips:"👄",lipstick:"💄",lizard:"🦎",lock:"🔒",lock_with_ink_pen:"🔏",lollipop:"🍭",loop:"➿",loud_sound:"🔊",loudspeaker:"📢",love_hotel:"🏩",love_letter:"💌",low_brightness:"🔅",lying_face:"🤥",m:"Ⓜ️",mag:"🔍",mag_right:"🔎",mahjong:"🀄️",mailbox:"📫",mailbox_closed:"📪",mailbox_with_mail:"📬",mailbox_with_no_mail:"📭",man:"👨",man_artist:"👨&zwj;🎨",man_astronaut:"👨&zwj;🚀",man_cartwheeling:"🤸&zwj;♂️",man_cook:"👨&zwj;🍳",man_dancing:"🕺",man_facepalming:"🤦&zwj;♂️",man_factory_worker:"👨&zwj;🏭",man_farmer:"👨&zwj;🌾",man_firefighter:"👨&zwj;🚒",man_health_worker:"👨&zwj;⚕️",man_in_tuxedo:"🤵",man_judge:"👨&zwj;⚖️",man_juggling:"🤹&zwj;♂️",man_mechanic:"👨&zwj;🔧",man_office_worker:"👨&zwj;💼",man_pilot:"👨&zwj;✈️",man_playing_handball:"🤾&zwj;♂️",man_playing_water_polo:"🤽&zwj;♂️",man_scientist:"👨&zwj;🔬",man_shrugging:"🤷&zwj;♂️",man_singer:"👨&zwj;🎤",man_student:"👨&zwj;🎓",man_teacher:"👨&zwj;🏫",man_technologist:"👨&zwj;💻",man_with_gua_pi_mao:"👲",man_with_turban:"👳",tangerine:"🍊",mans_shoe:"👞",mantelpiece_clock:"🕰",maple_leaf:"🍁",martial_arts_uniform:"🥋",mask:"😷",massage_woman:"💆",massage_man:"💆&zwj;♂️",meat_on_bone:"🍖",medal_military:"🎖",medal_sports:"🏅",mega:"📣",melon:"🍈",memo:"📝",men_wrestling:"🤼&zwj;♂️",menorah:"🕎",mens:"🚹",metal:"🤘",metro:"🚇",microphone:"🎤",microscope:"🔬",milk_glass:"🥛",milky_way:"🌌",minibus:"🚐",minidisc:"💽",mobile_phone_off:"📴",money_mouth_face:"🤑",money_with_wings:"💸",moneybag:"💰",monkey:"🐒",monkey_face:"🐵",monorail:"🚝",moon:"🌔",mortar_board:"🎓",mosque:"🕌",motor_boat:"🛥",motor_scooter:"🛵",motorcycle:"🏍",motorway:"🛣",mount_fuji:"🗻",mountain:"⛰",mountain_biking_man:"🚵",mountain_biking_woman:"🚵&zwj;♀️",mountain_cableway:"🚠",mountain_railway:"🚞",mountain_snow:"🏔",mouse:"🐭",mouse2:"🐁",movie_camera:"🎥",moyai:"🗿",mrs_claus:"🤶",muscle:"💪",mushroom:"🍄",musical_keyboard:"🎹",musical_note:"🎵",musical_score:"🎼",mute:"🔇",nail_care:"💅",name_badge:"📛",national_park:"🏞",nauseated_face:"🤢",necktie:"👔",negative_squared_cross_mark:"❎",nerd_face:"🤓",neutral_face:"😐",new:"🆕",new_moon:"🌑",new_moon_with_face:"🌚",newspaper:"📰",newspaper_roll:"🗞",next_track_button:"⏭",ng:"🆖",no_good_man:"🙅&zwj;♂️",no_good_woman:"🙅",night_with_stars:"🌃",no_bell:"🔕",no_bicycles:"🚳",no_entry:"⛔️",no_entry_sign:"🚫",no_mobile_phones:"📵",no_mouth:"😶",no_pedestrians:"🚷",no_smoking:"🚭","non-potable_water":"🚱",nose:"👃",notebook:"📓",notebook_with_decorative_cover:"📔",notes:"🎶",nut_and_bolt:"🔩",o:"⭕️",o2:"🅾️",ocean:"🌊",octopus:"🐙",oden:"🍢",office:"🏢",oil_drum:"🛢",ok:"🆗",ok_hand:"👌",ok_man:"🙆&zwj;♂️",ok_woman:"🙆",old_key:"🗝",older_man:"👴",older_woman:"👵",om:"🕉",on:"🔛",oncoming_automobile:"🚘",oncoming_bus:"🚍",oncoming_police_car:"🚔",oncoming_taxi:"🚖",open_file_folder:"📂",open_hands:"👐",open_mouth:"😮",open_umbrella:"☂️",ophiuchus:"⛎",orange_book:"📙",orthodox_cross:"☦️",outbox_tray:"📤",owl:"🦉",ox:"🐂",package:"📦",page_facing_up:"📄",page_with_curl:"📃",pager:"📟",paintbrush:"🖌",palm_tree:"🌴",pancakes:"🥞",panda_face:"🐼",paperclip:"📎",paperclips:"🖇",parasol_on_ground:"⛱",parking:"🅿️",part_alternation_mark:"〽️",partly_sunny:"⛅️",passenger_ship:"🛳",passport_control:"🛂",pause_button:"⏸",peace_symbol:"☮️",peach:"🍑",peanuts:"🥜",pear:"🍐",pen:"🖊",pencil2:"✏️",penguin:"🐧",pensive:"😔",performing_arts:"🎭",persevere:"😣",person_fencing:"🤺",pouting_woman:"🙎",phone:"☎️",pick:"⛏",pig:"🐷",pig2:"🐖",pig_nose:"🐽",pill:"💊",pineapple:"🍍",ping_pong:"🏓",pisces:"♓️",pizza:"🍕",place_of_worship:"🛐",plate_with_cutlery:"🍽",play_or_pause_button:"⏯",point_down:"👇",point_left:"👈",point_right:"👉",point_up:"☝️",point_up_2:"👆",police_car:"🚓",policewoman:"👮&zwj;♀️",poodle:"🐩",popcorn:"🍿",post_office:"🏣",postal_horn:"📯",postbox:"📮",potable_water:"🚰",potato:"🥔",pouch:"👝",poultry_leg:"🍗",pound:"💷",rage:"😡",pouting_cat:"😾",pouting_man:"🙎&zwj;♂️",pray:"🙏",prayer_beads:"📿",pregnant_woman:"🤰",previous_track_button:"⏮",prince:"🤴",princess:"👸",printer:"🖨",purple_heart:"💜",purse:"👛",pushpin:"📌",put_litter_in_its_place:"🚮",question:"❓",rabbit:"🐰",rabbit2:"🐇",racehorse:"🐎",racing_car:"🏎",radio:"📻",radio_button:"🔘",radioactive:"☢️",railway_car:"🚃",railway_track:"🛤",rainbow:"🌈",rainbow_flag:"🏳️&zwj;🌈",raised_back_of_hand:"🤚",raised_hand_with_fingers_splayed:"🖐",raised_hands:"🙌",raising_hand_woman:"🙋",raising_hand_man:"🙋&zwj;♂️",ram:"🐏",ramen:"🍜",rat:"🐀",record_button:"⏺",recycle:"♻️",red_circle:"🔴",registered:"®️",relaxed:"☺️",relieved:"😌",reminder_ribbon:"🎗",repeat:"🔁",repeat_one:"🔂",rescue_worker_helmet:"⛑",restroom:"🚻",revolving_hearts:"💞",rewind:"⏪",rhinoceros:"🦏",ribbon:"🎀",rice:"🍚",rice_ball:"🍙",rice_cracker:"🍘",rice_scene:"🎑",right_anger_bubble:"🗯",ring:"💍",robot:"🤖",rocket:"🚀",rofl:"🤣",roll_eyes:"🙄",roller_coaster:"🎢",rooster:"🐓",rose:"🌹",rosette:"🏵",rotating_light:"🚨",round_pushpin:"📍",rowing_man:"🚣",rowing_woman:"🚣&zwj;♀️",rugby_football:"🏉",running_man:"🏃",running_shirt_with_sash:"🎽",running_woman:"🏃&zwj;♀️",sa:"🈂️",sagittarius:"♐️",sake:"🍶",sandal:"👡",santa:"🎅",satellite:"📡",saxophone:"🎷",school:"🏫",school_satchel:"🎒",scissors:"✂️",scorpion:"🦂",scorpius:"♏️",scream:"😱",scream_cat:"🙀",scroll:"📜",seat:"💺",secret:"㊙️",see_no_evil:"🙈",seedling:"🌱",selfie:"🤳",shallow_pan_of_food:"🥘",shamrock:"☘️",shark:"🦈",shaved_ice:"🍧",sheep:"🐑",shell:"🐚",shield:"🛡",shinto_shrine:"⛩",ship:"🚢",shirt:"👕",shopping:"🛍",shopping_cart:"🛒",shower:"🚿",shrimp:"🦐",signal_strength:"📶",six_pointed_star:"🔯",ski:"🎿",skier:"⛷",skull:"💀",skull_and_crossbones:"☠️",sleeping:"😴",sleeping_bed:"🛌",sleepy:"😪",slightly_frowning_face:"🙁",slightly_smiling_face:"🙂",slot_machine:"🎰",small_airplane:"🛩",small_blue_diamond:"🔹",small_orange_diamond:"🔸",small_red_triangle:"🔺",small_red_triangle_down:"🔻",smile:"😄",smile_cat:"😸",smiley:"😃",smiley_cat:"😺",smiling_imp:"😈",smirk:"😏",smirk_cat:"😼",smoking:"🚬",snail:"🐌",snake:"🐍",sneezing_face:"🤧",snowboarder:"🏂",snowflake:"❄️",snowman:"⛄️",snowman_with_snow:"☃️",sob:"😭",soccer:"⚽️",soon:"🔜",sos:"🆘",sound:"🔉",space_invader:"👾",spades:"♠️",spaghetti:"🍝",sparkle:"❇️",sparkler:"🎇",sparkles:"✨",sparkling_heart:"💖",speak_no_evil:"🙊",speaker:"🔈",speaking_head:"🗣",speech_balloon:"💬",speedboat:"🚤",spider:"🕷",spider_web:"🕸",spiral_calendar:"🗓",spiral_notepad:"🗒",spoon:"🥄",squid:"🦑",stadium:"🏟",star:"⭐️",star2:"🌟",star_and_crescent:"☪️",star_of_david:"✡️",stars:"🌠",station:"🚉",statue_of_liberty:"🗽",steam_locomotive:"🚂",stew:"🍲",stop_button:"⏹",stop_sign:"🛑",stopwatch:"⏱",straight_ruler:"📏",strawberry:"🍓",stuck_out_tongue:"😛",stuck_out_tongue_closed_eyes:"😝",stuck_out_tongue_winking_eye:"😜",studio_microphone:"🎙",stuffed_flatbread:"🥙",sun_behind_large_cloud:"🌥",sun_behind_rain_cloud:"🌦",sun_behind_small_cloud:"🌤",sun_with_face:"🌞",sunflower:"🌻",sunglasses:"😎",sunny:"☀️",sunrise:"🌅",sunrise_over_mountains:"🌄",surfing_man:"🏄",surfing_woman:"🏄&zwj;♀️",sushi:"🍣",suspension_railway:"🚟",sweat:"😓",sweat_drops:"💦",sweat_smile:"😅",sweet_potato:"🍠",swimming_man:"🏊",swimming_woman:"🏊&zwj;♀️",symbols:"🔣",synagogue:"🕍",syringe:"💉",taco:"🌮",tada:"🎉",tanabata_tree:"🎋",taurus:"♉️",taxi:"🚕",tea:"🍵",telephone_receiver:"📞",telescope:"🔭",tennis:"🎾",tent:"⛺️",thermometer:"🌡",thinking:"🤔",thought_balloon:"💭",ticket:"🎫",tickets:"🎟",tiger:"🐯",tiger2:"🐅",timer_clock:"⏲",tipping_hand_man:"💁&zwj;♂️",tired_face:"😫",tm:"™️",toilet:"🚽",tokyo_tower:"🗼",tomato:"🍅",tongue:"👅",top:"🔝",tophat:"🎩",tornado:"🌪",trackball:"🖲",tractor:"🚜",traffic_light:"🚥",train:"🚋",train2:"🚆",tram:"🚊",triangular_flag_on_post:"🚩",triangular_ruler:"📐",trident:"🔱",triumph:"😤",trolleybus:"🚎",trophy:"🏆",tropical_drink:"🍹",tropical_fish:"🐠",truck:"🚚",trumpet:"🎺",tulip:"🌷",tumbler_glass:"🥃",turkey:"🦃",turtle:"🐢",tv:"📺",twisted_rightwards_arrows:"🔀",two_hearts:"💕",two_men_holding_hands:"👬",two_women_holding_hands:"👭",u5272:"🈹",u5408:"🈴",u55b6:"🈺",u6307:"🈯️",u6708:"🈷️",u6709:"🈶",u6e80:"🈵",u7121:"🈚️",u7533:"🈸",u7981:"🈲",u7a7a:"🈳",umbrella:"☔️",unamused:"😒",underage:"🔞",unicorn:"🦄",unlock:"🔓",up:"🆙",upside_down_face:"🙃",v:"✌️",vertical_traffic_light:"🚦",vhs:"📼",vibration_mode:"📳",video_camera:"📹",video_game:"🎮",violin:"🎻",virgo:"♍️",volcano:"🌋",volleyball:"🏐",vs:"🆚",vulcan_salute:"🖖",walking_man:"🚶",walking_woman:"🚶&zwj;♀️",waning_crescent_moon:"🌘",waning_gibbous_moon:"🌖",warning:"⚠️",wastebasket:"🗑",watch:"⌚️",water_buffalo:"🐃",watermelon:"🍉",wave:"👋",wavy_dash:"〰️",waxing_crescent_moon:"🌒",wc:"🚾",weary:"😩",wedding:"💒",weight_lifting_man:"🏋️",weight_lifting_woman:"🏋️&zwj;♀️",whale:"🐳",whale2:"🐋",wheel_of_dharma:"☸️",wheelchair:"♿️",white_check_mark:"✅",white_circle:"⚪️",white_flag:"🏳️",white_flower:"💮",white_large_square:"⬜️",white_medium_small_square:"◽️",white_medium_square:"◻️",white_small_square:"▫️",white_square_button:"🔳",wilted_flower:"🥀",wind_chime:"🎐",wind_face:"🌬",wine_glass:"🍷",wink:"😉",wolf:"🐺",woman:"👩",woman_artist:"👩&zwj;🎨",woman_astronaut:"👩&zwj;🚀",woman_cartwheeling:"🤸&zwj;♀️",woman_cook:"👩&zwj;🍳",woman_facepalming:"🤦&zwj;♀️",woman_factory_worker:"👩&zwj;🏭",woman_farmer:"👩&zwj;🌾",woman_firefighter:"👩&zwj;🚒",woman_health_worker:"👩&zwj;⚕️",woman_judge:"👩&zwj;⚖️",woman_juggling:"🤹&zwj;♀️",woman_mechanic:"👩&zwj;🔧",woman_office_worker:"👩&zwj;💼",woman_pilot:"👩&zwj;✈️",woman_playing_handball:"🤾&zwj;♀️",woman_playing_water_polo:"🤽&zwj;♀️",woman_scientist:"👩&zwj;🔬",woman_shrugging:"🤷&zwj;♀️",woman_singer:"👩&zwj;🎤",woman_student:"👩&zwj;🎓",woman_teacher:"👩&zwj;🏫",woman_technologist:"👩&zwj;💻",woman_with_turban:"👳&zwj;♀️",womans_clothes:"👚",womans_hat:"👒",women_wrestling:"🤼&zwj;♀️",womens:"🚺",world_map:"🗺",worried:"😟",wrench:"🔧",writing_hand:"✍️",x:"❌",yellow_heart:"💛",yen:"💴",yin_yang:"☯️",yum:"😋",zap:"⚡️",zipper_mouth_face:"🤐",zzz:"💤",octocat:'<img alt=":octocat:" height="20" width="20" align="absmiddle" src="https://assets-cdn.github.com/images/icons/emoji/octocat.png">',showdown:"<span style=\"font-family: 'Anonymous Pro', monospace; text-decoration: underline; text-decoration-style: dashed; text-decoration-color: #3e8b8a;text-underline-position: under;\">S</span>"},t.Converter=function(e){"use strict";var n={},l=[],c=[],u={},d=o,h={parsed:{},raw:"",format:""};function f(e,n){if(n=n||null,t.helper.isString(e)){if(n=e=t.helper.stdExtName(e),t.extensions[e])return console.warn("DEPRECATION WARNING: "+e+" is an old extension that uses a deprecated loading method.Please inform the developer that the extension should be updated!"),void function(e,n){"function"==typeof e&&(e=e(new t.Converter));t.helper.isArray(e)||(e=[e]);var i=s(e,n);if(!i.valid)throw Error(i.error);for(var r=0;r<e.length;++r)switch(e[r].type){case"lang":l.push(e[r]);break;case"output":c.push(e[r]);break;default:throw Error("Extension loader error: Type unrecognized!!!")}}(t.extensions[e],e);if(t.helper.isUndefined(i[e]))throw Error('Extension "'+e+'" could not be loaded. It was either not found or is not a valid extension.');e=i[e]}"function"==typeof e&&(e=e()),t.helper.isArray(e)||(e=[e]);var r=s(e,n);if(!r.valid)throw Error(r.error);for(var o=0;o<e.length;++o){switch(e[o].type){case"lang":l.push(e[o]);break;case"output":c.push(e[o])}if(e[o].hasOwnProperty("listeners"))for(var a in e[o].listeners)e[o].listeners.hasOwnProperty(a)&&p(a,e[o].listeners[a])}}function p(e,n){if(!t.helper.isString(e))throw Error("Invalid argument in converter.listen() method: name must be a string, but "+typeof e+" given");if("function"!=typeof n)throw Error("Invalid argument in converter.listen() method: callback must be a function, but "+typeof n+" given");u.hasOwnProperty(e)||(u[e]=[]),u[e].push(n)}!function(){for(var i in e=e||{},r)r.hasOwnProperty(i)&&(n[i]=r[i]);if("object"!=typeof e)throw Error("Converter expects the passed parameter to be an object, but "+typeof e+" was passed instead.");for(var o in e)e.hasOwnProperty(o)&&(n[o]=e[o]);n.extensions&&t.helper.forEach(n.extensions,f)}(),this._dispatch=function(e,t,n,i){if(u.hasOwnProperty(e))for(var r=0;r<u[e].length;++r){var o=u[e][r](e,t,this,n,i);o&&void 0!==o&&(t=o)}return t},this.listen=function(e,t){return p(e,t),this},this.makeHtml=function(e){if(!e)return e;var i={gHtmlBlocks:[],gHtmlMdBlocks:[],gHtmlSpans:[],gUrls:{},gTitles:{},gDimensions:{},gListLevel:0,hashLinkCounts:{},langExtensions:l,outputModifiers:c,converter:this,ghCodeBlocks:[],metadata:{parsed:{},raw:"",format:""}};return e=(e=(e=(e=(e=e.replace(/¨/g,"¨T")).replace(/\$/g,"¨D")).replace(/\r\n/g,"\n")).replace(/\r/g,"\n")).replace(/\u00A0/g,"&nbsp;"),n.smartIndentationFix&&(e=function(e){var t=e.match(/^\s*/)[0].length,n=new RegExp("^\\s{0,"+t+"}","gm");return e.replace(n,"")}(e)),e="\n\n"+e+"\n\n",e=(e=t.subParser("detab")(e,n,i)).replace(/^[ \t]+$/gm,""),t.helper.forEach(l,(function(r){e=t.subParser("runExtension")(r,e,n,i)})),e=t.subParser("metadata")(e,n,i),e=t.subParser("hashPreCodeTags")(e,n,i),e=t.subParser("githubCodeBlocks")(e,n,i),e=t.subParser("hashHTMLBlocks")(e,n,i),e=t.subParser("hashCodeTags")(e,n,i),e=t.subParser("stripLinkDefinitions")(e,n,i),e=t.subParser("blockGamut")(e,n,i),e=t.subParser("unhashHTMLSpans")(e,n,i),e=(e=(e=t.subParser("unescapeSpecialChars")(e,n,i)).replace(/¨D/g,"$$")).replace(/¨T/g,"¨"),e=t.subParser("completeHTMLDocument")(e,n,i),t.helper.forEach(c,(function(r){e=t.subParser("runExtension")(r,e,n,i)})),h=i.metadata,e},this.makeMarkdown=this.makeMd=function(e,n){if(e=(e=(e=e.replace(/\r\n/g,"\n")).replace(/\r/g,"\n")).replace(/>[ \t]+</,">¨NBSP;<"),!n){if(!window||!window.document)throw new Error("HTMLParser is undefined. If in a webworker or nodejs environment, you need to provide a WHATWG DOM and HTML such as JSDOM");n=window.document}var i=n.createElement("div");i.innerHTML=e;var r={preList:function(e){for(var n=e.querySelectorAll("pre"),i=[],r=0;r<n.length;++r)if(1===n[r].childElementCount&&"code"===n[r].firstChild.tagName.toLowerCase()){var o=n[r].firstChild.innerHTML.trim(),a=n[r].firstChild.getAttribute("data-language")||"";if(""===a)for(var s=n[r].firstChild.className.split(" "),l=0;l<s.length;++l){var c=s[l].match(/^language-(.+)$/);if(null!==c){a=c[1];break}}o=t.helper.unescapeHTMLEntities(o),i.push(o),n[r].outerHTML='<precode language="'+a+'" precodenum="'+r.toString()+'"></precode>'}else i.push(n[r].innerHTML),n[r].innerHTML="",n[r].setAttribute("prenum",r.toString());return i}(i)};!function e(t){for(var n=0;n<t.childNodes.length;++n){var i=t.childNodes[n];3===i.nodeType?/\S/.test(i.nodeValue)||/^[ ]+$/.test(i.nodeValue)?(i.nodeValue=i.nodeValue.split("\n").join(" "),i.nodeValue=i.nodeValue.replace(/(\s)+/g,"$1")):(t.removeChild(i),--n):1===i.nodeType&&e(i)}}(i);for(var o=i.childNodes,a="",s=0;s<o.length;s++)a+=t.subParser("makeMarkdown.node")(o[s],r);return a},this.setOption=function(e,t){n[e]=t},this.getOption=function(e){return n[e]},this.getOptions=function(){return n},this.addExtension=function(e,t){f(e,t=t||null)},this.useExtension=function(e){f(e)},this.setFlavor=function(e){if(!a.hasOwnProperty(e))throw Error(e+" flavor was not found");var t=a[e];for(var i in d=e,t)t.hasOwnProperty(i)&&(n[i]=t[i])},this.getFlavor=function(){return d},this.removeExtension=function(e){t.helper.isArray(e)||(e=[e]);for(var n=0;n<e.length;++n){for(var i=e[n],r=0;r<l.length;++r)l[r]===i&&l.splice(r,1);for(var o=0;o<c.length;++o)c[o]===i&&c.splice(o,1)}},this.getAllExtensions=function(){return{language:l,output:c}},this.getMetadata=function(e){return e?h.raw:h.parsed},this.getMetadataFormat=function(){return h.format},this._setMetadataPair=function(e,t){h.parsed[e]=t},this._setMetadataFormat=function(e){h.format=e},this._setMetadataRaw=function(e){h.raw=e}},t.subParser("anchors",(function(e,n,i){"use strict";var r=function(e,r,o,a,s,l,c){if(t.helper.isUndefined(c)&&(c=""),o=o.toLowerCase(),e.search(/\(<?\s*>? ?(['"].*['"])?\)$/m)>-1)a="";else if(!a){if(o||(o=r.toLowerCase().replace(/ ?\n/g," ")),a="#"+o,t.helper.isUndefined(i.gUrls[o]))return e;a=i.gUrls[o],t.helper.isUndefined(i.gTitles[o])||(c=i.gTitles[o])}var u='<a href="'+(a=a.replace(t.helper.regexes.asteriskDashAndColon,t.helper.escapeCharactersCallback))+'"';return""!==c&&null!==c&&(u+=' title="'+(c=(c=c.replace(/"/g,"&quot;")).replace(t.helper.regexes.asteriskDashAndColon,t.helper.escapeCharactersCallback))+'"'),n.openLinksInNewWindow&&!/^#/.test(a)&&(u+=' rel="noopener noreferrer" target="¨E95Eblank"'),u+=">"+r+"</a>"};return e=(e=(e=(e=(e=i.converter._dispatch("anchors.before",e,n,i)).replace(/\[((?:\[[^\]]*]|[^\[\]])*)] ?(?:\n *)?\[(.*?)]()()()()/g,r)).replace(/\[((?:\[[^\]]*]|[^\[\]])*)]()[ \t]*\([ \t]?<([^>]*)>(?:[ \t]*((["'])([^"]*?)\5))?[ \t]?\)/g,r)).replace(/\[((?:\[[^\]]*]|[^\[\]])*)]()[ \t]*\([ \t]?<?([\S]+?(?:\([\S]*?\)[\S]*?)?)>?(?:[ \t]*((["'])([^"]*?)\5))?[ \t]?\)/g,r)).replace(/\[([^\[\]]+)]()()()()()/g,r),n.ghMentions&&(e=e.replace(/(^|\s)(\\)?(@([a-z\d]+(?:[a-z\d.-]+?[a-z\d]+)*))/gim,(function(e,i,r,o,a){if("\\"===r)return i+o;if(!t.helper.isString(n.ghMentionsLink))throw new Error("ghMentionsLink option must be a string");var s=n.ghMentionsLink.replace(/\{u}/g,a),l="";return n.openLinksInNewWindow&&(l=' rel="noopener noreferrer" target="¨E95Eblank"'),i+'<a href="'+s+'"'+l+">"+o+"</a>"}))),e=i.converter._dispatch("anchors.after",e,n,i)}));var u=/([*~_]+|\b)(((https?|ftp|dict):\/\/|www\.)[^'">\s]+?\.[^'">\s]+?)()(\1)?(?=\s|$)(?!["<>])/gi,d=/([*~_]+|\b)(((https?|ftp|dict):\/\/|www\.)[^'">\s]+\.[^'">\s]+?)([.!?,()\[\]])?(\1)?(?=\s|$)(?!["<>])/gi,h=/()<(((https?|ftp|dict):\/\/|www\.)[^'">\s]+)()>()/gi,f=/(^|\s)(?:mailto:)?([A-Za-z0-9!#$%&'*+-/=?^_`{|}~.]+@[-a-z0-9]+(\.[-a-z0-9]+)*\.[a-z]+)(?=$|\s)/gim,p=/<()(?:mailto:)?([-.\w]+@[-a-z0-9]+(\.[-a-z0-9]+)*\.[a-z]+)>/gi,m=function(e){"use strict";return function(n,i,r,o,a,s,l){var c=r=r.replace(t.helper.regexes.asteriskDashAndColon,t.helper.escapeCharactersCallback),u="",d="",h=i||"",f=l||"";return/^www\./i.test(r)&&(r=r.replace(/^www\./i,"http://www.")),e.excludeTrailingPunctuationFromURLs&&s&&(u=s),e.openLinksInNewWindow&&(d=' rel="noopener noreferrer" target="¨E95Eblank"'),h+'<a href="'+r+'"'+d+">"+c+"</a>"+u+f}},v=function(e,n){"use strict";return function(i,r,o){var a="mailto:";return r=r||"",o=t.subParser("unescapeSpecialChars")(o,e,n),e.encodeEmails?(a=t.helper.encodeEmailAddress(a+o),o=t.helper.encodeEmailAddress(o)):a+=o,r+'<a href="'+a+'">'+o+"</a>"}};t.subParser("autoLinks",(function(e,t,n){"use strict";return e=(e=(e=n.converter._dispatch("autoLinks.before",e,t,n)).replace(h,m(t))).replace(p,v(t,n)),e=n.converter._dispatch("autoLinks.after",e,t,n)})),t.subParser("simplifiedAutoLinks",(function(e,t,n){"use strict";return t.simplifiedAutoLink?(e=n.converter._dispatch("simplifiedAutoLinks.before",e,t,n),e=(e=t.excludeTrailingPunctuationFromURLs?e.replace(d,m(t)):e.replace(u,m(t))).replace(f,v(t,n)),e=n.converter._dispatch("simplifiedAutoLinks.after",e,t,n)):e})),t.subParser("blockGamut",(function(e,n,i){"use strict";return e=i.converter._dispatch("blockGamut.before",e,n,i),e=t.subParser("blockQuotes")(e,n,i),e=t.subParser("headers")(e,n,i),e=t.subParser("horizontalRule")(e,n,i),e=t.subParser("lists")(e,n,i),e=t.subParser("codeBlocks")(e,n,i),e=t.subParser("tables")(e,n,i),e=t.subParser("hashHTMLBlocks")(e,n,i),e=t.subParser("paragraphs")(e,n,i),e=i.converter._dispatch("blockGamut.after",e,n,i)})),t.subParser("blockQuotes",(function(e,n,i){"use strict";e=i.converter._dispatch("blockQuotes.before",e,n,i),e+="\n\n";var r=/(^ {0,3}>[ \t]?.+\n(.+\n)*\n*)+/gm;return n.splitAdjacentBlockquotes&&(r=/^ {0,3}>[\s\S]*?(?:\n\n)/gm),e=e.replace(r,(function(e){return e=(e=(e=e.replace(/^[ \t]*>[ \t]?/gm,"")).replace(/¨0/g,"")).replace(/^[ \t]+$/gm,""),e=t.subParser("githubCodeBlocks")(e,n,i),e=(e=(e=t.subParser("blockGamut")(e,n,i)).replace(/(^|\n)/g,"$1  ")).replace(/(\s*<pre>[^\r]+?<\/pre>)/gm,(function(e,t){var n=t;return n=(n=n.replace(/^  /gm,"¨0")).replace(/¨0/g,"")})),t.subParser("hashBlock")("<blockquote>\n"+e+"\n</blockquote>",n,i)})),e=i.converter._dispatch("blockQuotes.after",e,n,i)})),t.subParser("codeBlocks",(function(e,n,i){"use strict";e=i.converter._dispatch("codeBlocks.before",e,n,i);return e=(e=(e+="¨0").replace(/(?:\n\n|^)((?:(?:[ ]{4}|\t).*\n+)+)(\n*[ ]{0,3}[^ \t\n]|(?=¨0))/g,(function(e,r,o){var a=r,s=o,l="\n";return a=t.subParser("outdent")(a,n,i),a=t.subParser("encodeCode")(a,n,i),a=(a=(a=t.subParser("detab")(a,n,i)).replace(/^\n+/g,"")).replace(/\n+$/g,""),n.omitExtraWLInCodeBlocks&&(l=""),a="<pre><code>"+a+l+"</code></pre>",t.subParser("hashBlock")(a,n,i)+s}))).replace(/¨0/,""),e=i.converter._dispatch("codeBlocks.after",e,n,i)})),t.subParser("codeSpans",(function(e,n,i){"use strict";return void 0===(e=i.converter._dispatch("codeSpans.before",e,n,i))&&(e=""),e=e.replace(/(^|[^\\])(`+)([^\r]*?[^`])\2(?!`)/gm,(function(e,r,o,a){var s=a;return s=(s=s.replace(/^([ \t]*)/g,"")).replace(/[ \t]*$/g,""),s=r+"<code>"+(s=t.subParser("encodeCode")(s,n,i))+"</code>",s=t.subParser("hashHTMLSpans")(s,n,i)})),e=i.converter._dispatch("codeSpans.after",e,n,i)})),t.subParser("completeHTMLDocument",(function(e,t,n){"use strict";if(!t.completeHTMLDocument)return e;e=n.converter._dispatch("completeHTMLDocument.before",e,t,n);var i="html",r="<!DOCTYPE HTML>\n",o="",a='<meta charset="utf-8">\n',s="",l="";for(var c in void 0!==n.metadata.parsed.doctype&&(r="<!DOCTYPE "+n.metadata.parsed.doctype+">\n","html"!==(i=n.metadata.parsed.doctype.toString().toLowerCase())&&"html5"!==i||(a='<meta charset="utf-8">')),n.metadata.parsed)if(n.metadata.parsed.hasOwnProperty(c))switch(c.toLowerCase()){case"doctype":break;case"title":o="<title>"+n.metadata.parsed.title+"</title>\n";break;case"charset":a="html"===i||"html5"===i?'<meta charset="'+n.metadata.parsed.charset+'">\n':'<meta name="charset" content="'+n.metadata.parsed.charset+'">\n';break;case"language":case"lang":s=' lang="'+n.metadata.parsed[c]+'"',l+='<meta name="'+c+'" content="'+n.metadata.parsed[c]+'">\n';break;default:l+='<meta name="'+c+'" content="'+n.metadata.parsed[c]+'">\n'}return e=r+"<html"+s+">\n<head>\n"+o+a+l+"</head>\n<body>\n"+e.trim()+"\n</body>\n</html>",e=n.converter._dispatch("completeHTMLDocument.after",e,t,n)})),t.subParser("detab",(function(e,t,n){"use strict";return e=(e=(e=(e=(e=(e=n.converter._dispatch("detab.before",e,t,n)).replace(/\t(?=\t)/g,"    ")).replace(/\t/g,"¨A¨B")).replace(/¨B(.+?)¨A/g,(function(e,t){for(var n=t,i=4-n.length%4,r=0;r<i;r++)n+=" ";return n}))).replace(/¨A/g,"    ")).replace(/¨B/g,""),e=n.converter._dispatch("detab.after",e,t,n)})),t.subParser("ellipsis",(function(e,t,n){"use strict";return t.ellipsis?(e=(e=n.converter._dispatch("ellipsis.before",e,t,n)).replace(/\.\.\./g,"…"),e=n.converter._dispatch("ellipsis.after",e,t,n)):e})),t.subParser("emoji",(function(e,n,i){"use strict";if(!n.emoji)return e;return e=(e=i.converter._dispatch("emoji.before",e,n,i)).replace(/:([\S]+?):/g,(function(e,n){return t.helper.emojis.hasOwnProperty(n)?t.helper.emojis[n]:e})),e=i.converter._dispatch("emoji.after",e,n,i)})),t.subParser("encodeAmpsAndAngles",(function(e,t,n){"use strict";return e=(e=(e=(e=(e=n.converter._dispatch("encodeAmpsAndAngles.before",e,t,n)).replace(/&(?!#?[xX]?(?:[0-9a-fA-F]+|\w+);)/g,"&amp;")).replace(/<(?![a-z\/?$!])/gi,"&lt;")).replace(/</g,"&lt;")).replace(/>/g,"&gt;"),e=n.converter._dispatch("encodeAmpsAndAngles.after",e,t,n)})),t.subParser("encodeBackslashEscapes",(function(e,n,i){"use strict";return e=(e=(e=i.converter._dispatch("encodeBackslashEscapes.before",e,n,i)).replace(/\\(\\)/g,t.helper.escapeCharactersCallback)).replace(/\\([`*_{}\[\]()>#+.!~=|:-])/g,t.helper.escapeCharactersCallback),e=i.converter._dispatch("encodeBackslashEscapes.after",e,n,i)})),t.subParser("encodeCode",(function(e,n,i){"use strict";return e=(e=i.converter._dispatch("encodeCode.before",e,n,i)).replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/([*_{}\[\]\\=~-])/g,t.helper.escapeCharactersCallback),e=i.converter._dispatch("encodeCode.after",e,n,i)})),t.subParser("escapeSpecialCharsWithinTagAttributes",(function(e,n,i){"use strict";return e=(e=(e=i.converter._dispatch("escapeSpecialCharsWithinTagAttributes.before",e,n,i)).replace(/<\/?[a-z\d_:-]+(?:[\s]+[\s\S]+?)?>/gi,(function(e){return e.replace(/(.)<\/?code>(?=.)/g,"$1`").replace(/([\\`*_~=|])/g,t.helper.escapeCharactersCallback)}))).replace(/<!(--(?:(?:[^>-]|-[^>])(?:[^-]|-[^-])*)--)>/gi,(function(e){return e.replace(/([\\`*_~=|])/g,t.helper.escapeCharactersCallback)})),e=i.converter._dispatch("escapeSpecialCharsWithinTagAttributes.after",e,n,i)})),t.subParser("githubCodeBlocks",(function(e,n,i){"use strict";return n.ghCodeBlocks?(e=i.converter._dispatch("githubCodeBlocks.before",e,n,i),e=(e=(e+="¨0").replace(/(?:^|\n)(?: {0,3})(```+|~~~+)(?: *)([^\s`~]*)\n([\s\S]*?)\n(?: {0,3})\1/g,(function(e,r,o,a){var s=n.omitExtraWLInCodeBlocks?"":"\n";return a=t.subParser("encodeCode")(a,n,i),a="<pre><code"+(o?' class="'+o+" language-"+o+'"':"")+">"+(a=(a=(a=t.subParser("detab")(a,n,i)).replace(/^\n+/g,"")).replace(/\n+$/g,""))+s+"</code></pre>",a=t.subParser("hashBlock")(a,n,i),"\n\n¨G"+(i.ghCodeBlocks.push({text:e,codeblock:a})-1)+"G\n\n"}))).replace(/¨0/,""),i.converter._dispatch("githubCodeBlocks.after",e,n,i)):e})),t.subParser("hashBlock",(function(e,t,n){"use strict";return e=(e=n.converter._dispatch("hashBlock.before",e,t,n)).replace(/(^\n+|\n+$)/g,""),e="\n\n¨K"+(n.gHtmlBlocks.push(e)-1)+"K\n\n",e=n.converter._dispatch("hashBlock.after",e,t,n)})),t.subParser("hashCodeTags",(function(e,n,i){"use strict";e=i.converter._dispatch("hashCodeTags.before",e,n,i);return e=t.helper.replaceRecursiveRegExp(e,(function(e,r,o,a){var s=o+t.subParser("encodeCode")(r,n,i)+a;return"¨C"+(i.gHtmlSpans.push(s)-1)+"C"}),"<code\\b[^>]*>","</code>","gim"),e=i.converter._dispatch("hashCodeTags.after",e,n,i)})),t.subParser("hashElement",(function(e,t,n){"use strict";return function(e,t){var i=t;return i=(i=(i=i.replace(/\n\n/g,"\n")).replace(/^\n/,"")).replace(/\n+$/g,""),i="\n\n¨K"+(n.gHtmlBlocks.push(i)-1)+"K\n\n"}})),t.subParser("hashHTMLBlocks",(function(e,n,i){"use strict";e=i.converter._dispatch("hashHTMLBlocks.before",e,n,i);var r=["pre","div","h1","h2","h3","h4","h5","h6","blockquote","table","dl","ol","ul","script","noscript","form","fieldset","iframe","math","style","section","header","footer","nav","article","aside","address","audio","canvas","figure","hgroup","output","video","p"],o=function(e,t,n,r){var o=e;return-1!==n.search(/\bmarkdown\b/)&&(o=n+i.converter.makeHtml(t)+r),"\n\n¨K"+(i.gHtmlBlocks.push(o)-1)+"K\n\n"};n.backslashEscapesHTMLTags&&(e=e.replace(/\\<(\/?[^>]+?)>/g,(function(e,t){return"&lt;"+t+"&gt;"})));for(var a=0;a<r.length;++a)for(var s,l=new RegExp("^ {0,3}(<"+r[a]+"\\b[^>]*>)","im"),c="<"+r[a]+"\\b[^>]*>",u="</"+r[a]+">";-1!==(s=t.helper.regexIndexOf(e,l));){var d=t.helper.splitAtIndex(e,s),h=t.helper.replaceRecursiveRegExp(d[1],o,c,u,"im");if(h===d[1])break;e=d[0].concat(h)}return e=e.replace(/(\n {0,3}(<(hr)\b([^<>])*?\/?>)[ \t]*(?=\n{2,}))/g,t.subParser("hashElement")(e,n,i)),e=(e=t.helper.replaceRecursiveRegExp(e,(function(e){return"\n\n¨K"+(i.gHtmlBlocks.push(e)-1)+"K\n\n"}),"^ {0,3}\x3c!--","--\x3e","gm")).replace(/(?:\n\n)( {0,3}(?:<([?%])[^\r]*?\2>)[ \t]*(?=\n{2,}))/g,t.subParser("hashElement")(e,n,i)),e=i.converter._dispatch("hashHTMLBlocks.after",e,n,i)})),t.subParser("hashHTMLSpans",(function(e,t,n){"use strict";function i(e){return"¨C"+(n.gHtmlSpans.push(e)-1)+"C"}return e=(e=(e=(e=(e=n.converter._dispatch("hashHTMLSpans.before",e,t,n)).replace(/<[^>]+?\/>/gi,(function(e){return i(e)}))).replace(/<([^>]+?)>[\s\S]*?<\/\1>/g,(function(e){return i(e)}))).replace(/<([^>]+?)\s[^>]+?>[\s\S]*?<\/\1>/g,(function(e){return i(e)}))).replace(/<[^>]+?>/gi,(function(e){return i(e)})),e=n.converter._dispatch("hashHTMLSpans.after",e,t,n)})),t.subParser("unhashHTMLSpans",(function(e,t,n){"use strict";e=n.converter._dispatch("unhashHTMLSpans.before",e,t,n);for(var i=0;i<n.gHtmlSpans.length;++i){for(var r=n.gHtmlSpans[i],o=0;/¨C(\d+)C/.test(r);){var a=RegExp.$1;if(r=r.replace("¨C"+a+"C",n.gHtmlSpans[a]),10===o){console.error("maximum nesting of 10 spans reached!!!");break}++o}e=e.replace("¨C"+i+"C",r)}return e=n.converter._dispatch("unhashHTMLSpans.after",e,t,n)})),t.subParser("hashPreCodeTags",(function(e,n,i){"use strict";e=i.converter._dispatch("hashPreCodeTags.before",e,n,i);return e=t.helper.replaceRecursiveRegExp(e,(function(e,r,o,a){var s=o+t.subParser("encodeCode")(r,n,i)+a;return"\n\n¨G"+(i.ghCodeBlocks.push({text:e,codeblock:s})-1)+"G\n\n"}),"^ {0,3}<pre\\b[^>]*>\\s*<code\\b[^>]*>","^ {0,3}</code>\\s*</pre>","gim"),e=i.converter._dispatch("hashPreCodeTags.after",e,n,i)})),t.subParser("headers",(function(e,n,i){"use strict";e=i.converter._dispatch("headers.before",e,n,i);var r=isNaN(parseInt(n.headerLevelStart))?1:parseInt(n.headerLevelStart),o=n.smoothLivePreview?/^(.+)[ \t]*\n={2,}[ \t]*\n+/gm:/^(.+)[ \t]*\n=+[ \t]*\n+/gm,a=n.smoothLivePreview?/^(.+)[ \t]*\n-{2,}[ \t]*\n+/gm:/^(.+)[ \t]*\n-+[ \t]*\n+/gm;e=(e=e.replace(o,(function(e,o){var a=t.subParser("spanGamut")(o,n,i),s=n.noHeaderId?"":' id="'+l(o)+'"',c="<h"+r+s+">"+a+"</h"+r+">";return t.subParser("hashBlock")(c,n,i)}))).replace(a,(function(e,o){var a=t.subParser("spanGamut")(o,n,i),s=n.noHeaderId?"":' id="'+l(o)+'"',c=r+1,u="<h"+c+s+">"+a+"</h"+c+">";return t.subParser("hashBlock")(u,n,i)}));var s=n.requireSpaceBeforeHeadingText?/^(#{1,6})[ \t]+(.+?)[ \t]*#*\n+/gm:/^(#{1,6})[ \t]*(.+?)[ \t]*#*\n+/gm;function l(e){var r,o;if(n.customizedHeaderId){var a=e.match(/\{([^{]+?)}\s*$/);a&&a[1]&&(e=a[1])}return r=e,o=t.helper.isString(n.prefixHeaderId)?n.prefixHeaderId:!0===n.prefixHeaderId?"section-":"",n.rawPrefixHeaderId||(r=o+r),r=n.ghCompatibleHeaderId?r.replace(/ /g,"-").replace(/&amp;/g,"").replace(/¨T/g,"").replace(/¨D/g,"").replace(/[&+$,\/:;=?@"#{}|^¨~\[\]`\\*)(%.!'<>]/g,"").toLowerCase():n.rawHeaderId?r.replace(/ /g,"-").replace(/&amp;/g,"&").replace(/¨T/g,"¨").replace(/¨D/g,"$").replace(/["']/g,"-").toLowerCase():r.replace(/[^\w]/g,"").toLowerCase(),n.rawPrefixHeaderId&&(r=o+r),i.hashLinkCounts[r]?r=r+"-"+i.hashLinkCounts[r]++:i.hashLinkCounts[r]=1,r}return e=e.replace(s,(function(e,o,a){var s=a;n.customizedHeaderId&&(s=a.replace(/\s?\{([^{]+?)}\s*$/,""));var c=t.subParser("spanGamut")(s,n,i),u=n.noHeaderId?"":' id="'+l(a)+'"',d=r-1+o.length,h="<h"+d+u+">"+c+"</h"+d+">";return t.subParser("hashBlock")(h,n,i)})),e=i.converter._dispatch("headers.after",e,n,i)})),t.subParser("horizontalRule",(function(e,n,i){"use strict";e=i.converter._dispatch("horizontalRule.before",e,n,i);var r=t.subParser("hashBlock")("<hr />",n,i);return e=(e=(e=e.replace(/^ {0,2}( ?-){3,}[ \t]*$/gm,r)).replace(/^ {0,2}( ?\*){3,}[ \t]*$/gm,r)).replace(/^ {0,2}( ?_){3,}[ \t]*$/gm,r),e=i.converter._dispatch("horizontalRule.after",e,n,i)})),t.subParser("images",(function(e,n,i){"use strict";function r(e,n,r,o,a,s,l,c){var u=i.gUrls,d=i.gTitles,h=i.gDimensions;if(r=r.toLowerCase(),c||(c=""),e.search(/\(<?\s*>? ?(['"].*['"])?\)$/m)>-1)o="";else if(""===o||null===o){if(""!==r&&null!==r||(r=n.toLowerCase().replace(/ ?\n/g," ")),o="#"+r,t.helper.isUndefined(u[r]))return e;o=u[r],t.helper.isUndefined(d[r])||(c=d[r]),t.helper.isUndefined(h[r])||(a=h[r].width,s=h[r].height)}n=n.replace(/"/g,"&quot;").replace(t.helper.regexes.asteriskDashAndColon,t.helper.escapeCharactersCallback);var f='<img src="'+(o=o.replace(t.helper.regexes.asteriskDashAndColon,t.helper.escapeCharactersCallback))+'" alt="'+n+'"';return c&&t.helper.isString(c)&&(f+=' title="'+(c=c.replace(/"/g,"&quot;").replace(t.helper.regexes.asteriskDashAndColon,t.helper.escapeCharactersCallback))+'"'),a&&s&&(f+=' width="'+(a="*"===a?"auto":a)+'"',f+=' height="'+(s="*"===s?"auto":s)+'"'),f+=" />"}return e=(e=(e=(e=(e=(e=i.converter._dispatch("images.before",e,n,i)).replace(/!\[([^\]]*?)] ?(?:\n *)?\[([\s\S]*?)]()()()()()/g,r)).replace(/!\[([^\]]*?)][ \t]*()\([ \t]?<?(data:.+?\/.+?;base64,[A-Za-z0-9+/=\n]+?)>?(?: =([*\d]+[A-Za-z%]{0,4})x([*\d]+[A-Za-z%]{0,4}))?[ \t]*(?:(["'])([^"]*?)\6)?[ \t]?\)/g,(function(e,t,n,i,o,a,s,l){return r(e,t,n,i=i.replace(/\s/g,""),o,a,s,l)}))).replace(/!\[([^\]]*?)][ \t]*()\([ \t]?<([^>]*)>(?: =([*\d]+[A-Za-z%]{0,4})x([*\d]+[A-Za-z%]{0,4}))?[ \t]*(?:(?:(["'])([^"]*?)\6))?[ \t]?\)/g,r)).replace(/!\[([^\]]*?)][ \t]*()\([ \t]?<?([\S]+?(?:\([\S]*?\)[\S]*?)?)>?(?: =([*\d]+[A-Za-z%]{0,4})x([*\d]+[A-Za-z%]{0,4}))?[ \t]*(?:(["'])([^"]*?)\6)?[ \t]?\)/g,r)).replace(/!\[([^\[\]]+)]()()()()()/g,r),e=i.converter._dispatch("images.after",e,n,i)})),t.subParser("italicsAndBold",(function(e,t,n){"use strict";function i(e,t,n){return t+e+n}return e=n.converter._dispatch("italicsAndBold.before",e,t,n),e=t.literalMidWordUnderscores?(e=(e=e.replace(/\b___(\S[\s\S]*?)___\b/g,(function(e,t){return i(t,"<strong><em>","</em></strong>")}))).replace(/\b__(\S[\s\S]*?)__\b/g,(function(e,t){return i(t,"<strong>","</strong>")}))).replace(/\b_(\S[\s\S]*?)_\b/g,(function(e,t){return i(t,"<em>","</em>")})):(e=(e=e.replace(/___(\S[\s\S]*?)___/g,(function(e,t){return/\S$/.test(t)?i(t,"<strong><em>","</em></strong>"):e}))).replace(/__(\S[\s\S]*?)__/g,(function(e,t){return/\S$/.test(t)?i(t,"<strong>","</strong>"):e}))).replace(/_([^\s_][\s\S]*?)_/g,(function(e,t){return/\S$/.test(t)?i(t,"<em>","</em>"):e})),e=t.literalMidWordAsterisks?(e=(e=e.replace(/([^*]|^)\B\*\*\*(\S[\s\S]*?)\*\*\*\B(?!\*)/g,(function(e,t,n){return i(n,t+"<strong><em>","</em></strong>")}))).replace(/([^*]|^)\B\*\*(\S[\s\S]*?)\*\*\B(?!\*)/g,(function(e,t,n){return i(n,t+"<strong>","</strong>")}))).replace(/([^*]|^)\B\*(\S[\s\S]*?)\*\B(?!\*)/g,(function(e,t,n){return i(n,t+"<em>","</em>")})):(e=(e=e.replace(/\*\*\*(\S[\s\S]*?)\*\*\*/g,(function(e,t){return/\S$/.test(t)?i(t,"<strong><em>","</em></strong>"):e}))).replace(/\*\*(\S[\s\S]*?)\*\*/g,(function(e,t){return/\S$/.test(t)?i(t,"<strong>","</strong>"):e}))).replace(/\*([^\s*][\s\S]*?)\*/g,(function(e,t){return/\S$/.test(t)?i(t,"<em>","</em>"):e})),e=n.converter._dispatch("italicsAndBold.after",e,t,n)})),t.subParser("lists",(function(e,n,i){"use strict";function r(e,r){i.gListLevel++,e=e.replace(/\n{2,}$/,"\n");var o=/(\n)?(^ {0,3})([*+-]|\d+[.])[ \t]+((\[(x|X| )?])?[ \t]*[^\r]+?(\n{1,2}))(?=\n*(¨0| {0,3}([*+-]|\d+[.])[ \t]+))/gm,a=/\n[ \t]*\n(?!¨0)/.test(e+="¨0");return n.disableForced4SpacesIndentedSublists&&(o=/(\n)?(^ {0,3})([*+-]|\d+[.])[ \t]+((\[(x|X| )?])?[ \t]*[^\r]+?(\n{1,2}))(?=\n*(¨0|\2([*+-]|\d+[.])[ \t]+))/gm),e=(e=e.replace(o,(function(e,r,o,s,l,c,u){u=u&&""!==u.trim();var d=t.subParser("outdent")(l,n,i),h="";return c&&n.tasklists&&(h=' class="task-list-item" style="list-style-type: none;"',d=d.replace(/^[ \t]*\[(x|X| )?]/m,(function(){var e='<input type="checkbox" disabled style="margin: 0px 0.35em 0.25em -1.6em; vertical-align: middle;"';return u&&(e+=" checked"),e+=">"}))),d=d.replace(/^([-*+]|\d\.)[ \t]+[\S\n ]*/g,(function(e){return"¨A"+e})),r||d.search(/\n{2,}/)>-1?(d=t.subParser("githubCodeBlocks")(d,n,i),d=t.subParser("blockGamut")(d,n,i)):(d=(d=t.subParser("lists")(d,n,i)).replace(/\n$/,""),d=(d=t.subParser("hashHTMLBlocks")(d,n,i)).replace(/\n\n+/g,"\n\n"),d=a?t.subParser("paragraphs")(d,n,i):t.subParser("spanGamut")(d,n,i)),d="<li"+h+">"+(d=d.replace("¨A",""))+"</li>\n"}))).replace(/¨0/g,""),i.gListLevel--,r&&(e=e.replace(/\s+$/,"")),e}function o(e,t){if("ol"===t){var n=e.match(/^ *(\d+)\./);if(n&&"1"!==n[1])return' start="'+n[1]+'"'}return""}function a(e,t,i){var a=n.disableForced4SpacesIndentedSublists?/^ ?\d+\.[ \t]/gm:/^ {0,3}\d+\.[ \t]/gm,s=n.disableForced4SpacesIndentedSublists?/^ ?[*+-][ \t]/gm:/^ {0,3}[*+-][ \t]/gm,l="ul"===t?a:s,c="";if(-1!==e.search(l))!function n(u){var d=u.search(l),h=o(e,t);-1!==d?(c+="\n\n<"+t+h+">\n"+r(u.slice(0,d),!!i)+"</"+t+">\n",l="ul"===(t="ul"===t?"ol":"ul")?a:s,n(u.slice(d))):c+="\n\n<"+t+h+">\n"+r(u,!!i)+"</"+t+">\n"}(e);else{var u=o(e,t);c="\n\n<"+t+u+">\n"+r(e,!!i)+"</"+t+">\n"}return c}return e=i.converter._dispatch("lists.before",e,n,i),e+="¨0",e=(e=i.gListLevel?e.replace(/^(( {0,3}([*+-]|\d+[.])[ \t]+)[^\r]+?(¨0|\n{2,}(?=\S)(?![ \t]*(?:[*+-]|\d+[.])[ \t]+)))/gm,(function(e,t,n){return a(t,n.search(/[*+-]/g)>-1?"ul":"ol",!0)})):e.replace(/(\n\n|^\n?)(( {0,3}([*+-]|\d+[.])[ \t]+)[^\r]+?(¨0|\n{2,}(?=\S)(?![ \t]*(?:[*+-]|\d+[.])[ \t]+)))/gm,(function(e,t,n,i){return a(n,i.search(/[*+-]/g)>-1?"ul":"ol",!1)}))).replace(/¨0/,""),e=i.converter._dispatch("lists.after",e,n,i)})),t.subParser("metadata",(function(e,t,n){"use strict";if(!t.metadata)return e;function i(e){n.metadata.raw=e,(e=(e=e.replace(/&/g,"&amp;").replace(/"/g,"&quot;")).replace(/\n {4}/g," ")).replace(/^([\S ]+): +([\s\S]+?)$/gm,(function(e,t,i){return n.metadata.parsed[t]=i,""}))}return e=(e=(e=(e=n.converter._dispatch("metadata.before",e,t,n)).replace(/^\s*«««+(\S*?)\n([\s\S]+?)\n»»»+\n/,(function(e,t,n){return i(n),"¨M"}))).replace(/^\s*---+(\S*?)\n([\s\S]+?)\n---+\n/,(function(e,t,r){return t&&(n.metadata.format=t),i(r),"¨M"}))).replace(/¨M/g,""),e=n.converter._dispatch("metadata.after",e,t,n)})),t.subParser("outdent",(function(e,t,n){"use strict";return e=(e=(e=n.converter._dispatch("outdent.before",e,t,n)).replace(/^(\t|[ ]{1,4})/gm,"¨0")).replace(/¨0/g,""),e=n.converter._dispatch("outdent.after",e,t,n)})),t.subParser("paragraphs",(function(e,n,i){"use strict";for(var r=(e=(e=(e=i.converter._dispatch("paragraphs.before",e,n,i)).replace(/^\n+/g,"")).replace(/\n+$/g,"")).split(/\n{2,}/g),o=[],a=r.length,s=0;s<a;s++){var l=r[s];l.search(/¨(K|G)(\d+)\1/g)>=0?o.push(l):l.search(/\S/)>=0&&(l=(l=t.subParser("spanGamut")(l,n,i)).replace(/^([ \t]*)/g,"<p>"),l+="</p>",o.push(l))}for(a=o.length,s=0;s<a;s++){for(var c="",u=o[s],d=!1;/¨(K|G)(\d+)\1/.test(u);){var h=RegExp.$1,f=RegExp.$2;c=(c="K"===h?i.gHtmlBlocks[f]:d?t.subParser("encodeCode")(i.ghCodeBlocks[f].text,n,i):i.ghCodeBlocks[f].codeblock).replace(/\$/g,"$$$$"),u=u.replace(/(\n\n)?¨(K|G)\d+\2(\n\n)?/,c),/^<pre\b[^>]*>\s*<code\b[^>]*>/.test(u)&&(d=!0)}o[s]=u}return e=(e=(e=o.join("\n")).replace(/^\n+/g,"")).replace(/\n+$/g,""),i.converter._dispatch("paragraphs.after",e,n,i)})),t.subParser("runExtension",(function(e,t,n,i){"use strict";if(e.filter)t=e.filter(t,i.converter,n);else if(e.regex){var r=e.regex;r instanceof RegExp||(r=new RegExp(r,"g")),t=t.replace(r,e.replace)}return t})),t.subParser("spanGamut",(function(e,n,i){"use strict";return e=i.converter._dispatch("spanGamut.before",e,n,i),e=t.subParser("codeSpans")(e,n,i),e=t.subParser("escapeSpecialCharsWithinTagAttributes")(e,n,i),e=t.subParser("encodeBackslashEscapes")(e,n,i),e=t.subParser("images")(e,n,i),e=t.subParser("anchors")(e,n,i),e=t.subParser("autoLinks")(e,n,i),e=t.subParser("simplifiedAutoLinks")(e,n,i),e=t.subParser("emoji")(e,n,i),e=t.subParser("underline")(e,n,i),e=t.subParser("italicsAndBold")(e,n,i),e=t.subParser("strikethrough")(e,n,i),e=t.subParser("ellipsis")(e,n,i),e=t.subParser("hashHTMLSpans")(e,n,i),e=t.subParser("encodeAmpsAndAngles")(e,n,i),n.simpleLineBreaks?/\n\n¨K/.test(e)||(e=e.replace(/\n+/g,"<br />\n")):e=e.replace(/  +\n/g,"<br />\n"),e=i.converter._dispatch("spanGamut.after",e,n,i)})),t.subParser("strikethrough",(function(e,n,i){"use strict";return n.strikethrough&&(e=(e=i.converter._dispatch("strikethrough.before",e,n,i)).replace(/(?:~){2}([\s\S]+?)(?:~){2}/g,(function(e,r){return function(e){return n.simplifiedAutoLink&&(e=t.subParser("simplifiedAutoLinks")(e,n,i)),"<del>"+e+"</del>"}(r)})),e=i.converter._dispatch("strikethrough.after",e,n,i)),e})),t.subParser("stripLinkDefinitions",(function(e,n,i){"use strict";var r=function(r,o,a,s,l,c,u){return o=o.toLowerCase(),e.toLowerCase().split(o).length-1<2?r:(a.match(/^data:.+?\/.+?;base64,/)?i.gUrls[o]=a.replace(/\s/g,""):i.gUrls[o]=t.subParser("encodeAmpsAndAngles")(a,n,i),c?c+u:(u&&(i.gTitles[o]=u.replace(/"|'/g,"&quot;")),n.parseImgDimensions&&s&&l&&(i.gDimensions[o]={width:s,height:l}),""))};return e=(e=(e=(e+="¨0").replace(/^ {0,3}\[([^\]]+)]:[ \t]*\n?[ \t]*<?(data:.+?\/.+?;base64,[A-Za-z0-9+/=\n]+?)>?(?: =([*\d]+[A-Za-z%]{0,4})x([*\d]+[A-Za-z%]{0,4}))?[ \t]*\n?[ \t]*(?:(\n*)["|'(](.+?)["|')][ \t]*)?(?:\n\n|(?=¨0)|(?=\n\[))/gm,r)).replace(/^ {0,3}\[([^\]]+)]:[ \t]*\n?[ \t]*<?([^>\s]+)>?(?: =([*\d]+[A-Za-z%]{0,4})x([*\d]+[A-Za-z%]{0,4}))?[ \t]*\n?[ \t]*(?:(\n*)["|'(](.+?)["|')][ \t]*)?(?:\n+|(?=¨0))/gm,r)).replace(/¨0/,"")})),t.subParser("tables",(function(e,n,i){"use strict";if(!n.tables)return e;function r(e,r){var o="";return e=e.trim(),(n.tablesHeaderId||n.tableHeaderId)&&(o=' id="'+e.replace(/ /g,"_").toLowerCase()+'"'),"<th"+o+r+">"+(e=t.subParser("spanGamut")(e,n,i))+"</th>\n"}function o(e){var o,a=e.split("\n");for(o=0;o<a.length;++o)/^ {0,3}\|/.test(a[o])&&(a[o]=a[o].replace(/^ {0,3}\|/,"")),/\|[ \t]*$/.test(a[o])&&(a[o]=a[o].replace(/\|[ \t]*$/,"")),a[o]=t.subParser("codeSpans")(a[o],n,i);var s,l,c=a[0].split("|").map((function(e){return e.trim()})),u=a[1].split("|").map((function(e){return e.trim()})),d=[],h=[],f=[],p=[];for(a.shift(),a.shift(),o=0;o<a.length;++o)""!==a[o].trim()&&d.push(a[o].split("|").map((function(e){return e.trim()})));if(c.length<u.length)return e;for(o=0;o<u.length;++o)f.push((s=u[o],/^:[ \t]*--*$/.test(s)?' style="text-align:left;"':/^--*[ \t]*:[ \t]*$/.test(s)?' style="text-align:right;"':/^:[ \t]*--*[ \t]*:$/.test(s)?' style="text-align:center;"':""));for(o=0;o<c.length;++o)t.helper.isUndefined(f[o])&&(f[o]=""),h.push(r(c[o],f[o]));for(o=0;o<d.length;++o){for(var m=[],v=0;v<h.length;++v)t.helper.isUndefined(d[o][v]),m.push((l=d[o][v],"<td"+f[v]+">"+t.subParser("spanGamut")(l,n,i)+"</td>\n"));p.push(m)}return function(e,t){for(var n="<table>\n<thead>\n<tr>\n",i=e.length,r=0;r<i;++r)n+=e[r];for(n+="</tr>\n</thead>\n<tbody>\n",r=0;r<t.length;++r){n+="<tr>\n";for(var o=0;o<i;++o)n+=t[r][o];n+="</tr>\n"}return n+"</tbody>\n</table>\n"}(h,p)}return e=(e=(e=(e=i.converter._dispatch("tables.before",e,n,i)).replace(/\\(\|)/g,t.helper.escapeCharactersCallback)).replace(/^ {0,3}\|?.+\|.+\n {0,3}\|?[ \t]*:?[ \t]*(?:[-=]){2,}[ \t]*:?[ \t]*\|[ \t]*:?[ \t]*(?:[-=]){2,}[\s\S]+?(?:\n\n|¨0)/gm,o)).replace(/^ {0,3}\|.+\|[ \t]*\n {0,3}\|[ \t]*:?[ \t]*(?:[-=]){2,}[ \t]*:?[ \t]*\|[ \t]*\n( {0,3}\|.+\|[ \t]*\n)*(?:\n|¨0)/gm,o),e=i.converter._dispatch("tables.after",e,n,i)})),t.subParser("underline",(function(e,n,i){"use strict";return n.underline?(e=i.converter._dispatch("underline.before",e,n,i),e=(e=n.literalMidWordUnderscores?(e=e.replace(/\b___(\S[\s\S]*?)___\b/g,(function(e,t){return"<u>"+t+"</u>"}))).replace(/\b__(\S[\s\S]*?)__\b/g,(function(e,t){return"<u>"+t+"</u>"})):(e=e.replace(/___(\S[\s\S]*?)___/g,(function(e,t){return/\S$/.test(t)?"<u>"+t+"</u>":e}))).replace(/__(\S[\s\S]*?)__/g,(function(e,t){return/\S$/.test(t)?"<u>"+t+"</u>":e}))).replace(/(_)/g,t.helper.escapeCharactersCallback),e=i.converter._dispatch("underline.after",e,n,i)):e})),t.subParser("unescapeSpecialChars",(function(e,t,n){"use strict";return e=(e=n.converter._dispatch("unescapeSpecialChars.before",e,t,n)).replace(/¨E(\d+)E/g,(function(e,t){var n=parseInt(t);return String.fromCharCode(n)})),e=n.converter._dispatch("unescapeSpecialChars.after",e,t,n)})),t.subParser("makeMarkdown.blockquote",(function(e,n){"use strict";var i="";if(e.hasChildNodes())for(var r=e.childNodes,o=r.length,a=0;a<o;++a){var s=t.subParser("makeMarkdown.node")(r[a],n);""!==s&&(i+=s)}return i="> "+(i=i.trim()).split("\n").join("\n> ")})),t.subParser("makeMarkdown.codeBlock",(function(e,t){"use strict";var n=e.getAttribute("language"),i=e.getAttribute("precodenum");return"```"+n+"\n"+t.preList[i]+"\n```"})),t.subParser("makeMarkdown.codeSpan",(function(e){"use strict";return"`"+e.innerHTML+"`"})),t.subParser("makeMarkdown.emphasis",(function(e,n){"use strict";var i="";if(e.hasChildNodes()){i+="*";for(var r=e.childNodes,o=r.length,a=0;a<o;++a)i+=t.subParser("makeMarkdown.node")(r[a],n);i+="*"}return i})),t.subParser("makeMarkdown.header",(function(e,n,i){"use strict";var r=new Array(i+1).join("#"),o="";if(e.hasChildNodes()){o=r+" ";for(var a=e.childNodes,s=a.length,l=0;l<s;++l)o+=t.subParser("makeMarkdown.node")(a[l],n)}return o})),t.subParser("makeMarkdown.hr",(function(){"use strict";return"---"})),t.subParser("makeMarkdown.image",(function(e){"use strict";var t="";return e.hasAttribute("src")&&(t+="!["+e.getAttribute("alt")+"](",t+="<"+e.getAttribute("src")+">",e.hasAttribute("width")&&e.hasAttribute("height")&&(t+=" ="+e.getAttribute("width")+"x"+e.getAttribute("height")),e.hasAttribute("title")&&(t+=' "'+e.getAttribute("title")+'"'),t+=")"),t})),t.subParser("makeMarkdown.links",(function(e,n){"use strict";var i="";if(e.hasChildNodes()&&e.hasAttribute("href")){var r=e.childNodes,o=r.length;i="[";for(var a=0;a<o;++a)i+=t.subParser("makeMarkdown.node")(r[a],n);i+="](",i+="<"+e.getAttribute("href")+">",e.hasAttribute("title")&&(i+=' "'+e.getAttribute("title")+'"'),i+=")"}return i})),t.subParser("makeMarkdown.list",(function(e,n,i){"use strict";var r="";if(!e.hasChildNodes())return"";for(var o=e.childNodes,a=o.length,s=e.getAttribute("start")||1,l=0;l<a;++l)if(void 0!==o[l].tagName&&"li"===o[l].tagName.toLowerCase()){r+=("ol"===i?s.toString()+". ":"- ")+t.subParser("makeMarkdown.listItem")(o[l],n),++s}return(r+="\n\x3c!-- --\x3e\n").trim()})),t.subParser("makeMarkdown.listItem",(function(e,n){"use strict";for(var i="",r=e.childNodes,o=r.length,a=0;a<o;++a)i+=t.subParser("makeMarkdown.node")(r[a],n);return/\n$/.test(i)?i=i.split("\n").join("\n    ").replace(/^ {4}$/gm,"").replace(/\n\n+/g,"\n\n"):i+="\n",i})),t.subParser("makeMarkdown.node",(function(e,n,i){"use strict";i=i||!1;var r="";if(3===e.nodeType)return t.subParser("makeMarkdown.txt")(e,n);if(8===e.nodeType)return"\x3c!--"+e.data+"--\x3e\n\n";if(1!==e.nodeType)return"";switch(e.tagName.toLowerCase()){case"h1":i||(r=t.subParser("makeMarkdown.header")(e,n,1)+"\n\n");break;case"h2":i||(r=t.subParser("makeMarkdown.header")(e,n,2)+"\n\n");break;case"h3":i||(r=t.subParser("makeMarkdown.header")(e,n,3)+"\n\n");break;case"h4":i||(r=t.subParser("makeMarkdown.header")(e,n,4)+"\n\n");break;case"h5":i||(r=t.subParser("makeMarkdown.header")(e,n,5)+"\n\n");break;case"h6":i||(r=t.subParser("makeMarkdown.header")(e,n,6)+"\n\n");break;case"p":i||(r=t.subParser("makeMarkdown.paragraph")(e,n)+"\n\n");break;case"blockquote":i||(r=t.subParser("makeMarkdown.blockquote")(e,n)+"\n\n");break;case"hr":i||(r=t.subParser("makeMarkdown.hr")(e,n)+"\n\n");break;case"ol":i||(r=t.subParser("makeMarkdown.list")(e,n,"ol")+"\n\n");break;case"ul":i||(r=t.subParser("makeMarkdown.list")(e,n,"ul")+"\n\n");break;case"precode":i||(r=t.subParser("makeMarkdown.codeBlock")(e,n)+"\n\n");break;case"pre":i||(r=t.subParser("makeMarkdown.pre")(e,n)+"\n\n");break;case"table":i||(r=t.subParser("makeMarkdown.table")(e,n)+"\n\n");break;case"code":r=t.subParser("makeMarkdown.codeSpan")(e,n);break;case"em":case"i":r=t.subParser("makeMarkdown.emphasis")(e,n);break;case"strong":case"b":r=t.subParser("makeMarkdown.strong")(e,n);break;case"del":r=t.subParser("makeMarkdown.strikethrough")(e,n);break;case"a":r=t.subParser("makeMarkdown.links")(e,n);break;case"img":r=t.subParser("makeMarkdown.image")(e,n);break;default:r=e.outerHTML+"\n\n"}return r})),t.subParser("makeMarkdown.paragraph",(function(e,n){"use strict";var i="";if(e.hasChildNodes())for(var r=e.childNodes,o=r.length,a=0;a<o;++a)i+=t.subParser("makeMarkdown.node")(r[a],n);return i=i.trim()})),t.subParser("makeMarkdown.pre",(function(e,t){"use strict";var n=e.getAttribute("prenum");return"<pre>"+t.preList[n]+"</pre>"})),t.subParser("makeMarkdown.strikethrough",(function(e,n){"use strict";var i="";if(e.hasChildNodes()){i+="~~";for(var r=e.childNodes,o=r.length,a=0;a<o;++a)i+=t.subParser("makeMarkdown.node")(r[a],n);i+="~~"}return i})),t.subParser("makeMarkdown.strong",(function(e,n){"use strict";var i="";if(e.hasChildNodes()){i+="**";for(var r=e.childNodes,o=r.length,a=0;a<o;++a)i+=t.subParser("makeMarkdown.node")(r[a],n);i+="**"}return i})),t.subParser("makeMarkdown.table",(function(e,n){"use strict";var i,r,o="",a=[[],[]],s=e.querySelectorAll("thead>tr>th"),l=e.querySelectorAll("tbody>tr");for(i=0;i<s.length;++i){var c=t.subParser("makeMarkdown.tableCell")(s[i],n),u="---";if(s[i].hasAttribute("style"))switch(s[i].getAttribute("style").toLowerCase().replace(/\s/g,"")){case"text-align:left;":u=":---";break;case"text-align:right;":u="---:";break;case"text-align:center;":u=":---:"}a[0][i]=c.trim(),a[1][i]=u}for(i=0;i<l.length;++i){var d=a.push([])-1,h=l[i].getElementsByTagName("td");for(r=0;r<s.length;++r){var f=" ";void 0!==h[r]&&(f=t.subParser("makeMarkdown.tableCell")(h[r],n)),a[d].push(f)}}var p=3;for(i=0;i<a.length;++i)for(r=0;r<a[i].length;++r){var m=a[i][r].length;m>p&&(p=m)}for(i=0;i<a.length;++i){for(r=0;r<a[i].length;++r)1===i?":"===a[i][r].slice(-1)?a[i][r]=t.helper.padEnd(a[i][r].slice(-1),p-1,"-")+":":a[i][r]=t.helper.padEnd(a[i][r],p,"-"):a[i][r]=t.helper.padEnd(a[i][r],p);o+="| "+a[i].join(" | ")+" |\n"}return o.trim()})),t.subParser("makeMarkdown.tableCell",(function(e,n){"use strict";var i="";if(!e.hasChildNodes())return"";for(var r=e.childNodes,o=r.length,a=0;a<o;++a)i+=t.subParser("makeMarkdown.node")(r[a],n,!0);return i.trim()})),t.subParser("makeMarkdown.txt",(function(e){"use strict";var n=e.nodeValue;return n=(n=n.replace(/ +/g," ")).replace(/¨NBSP;/g," "),n=(n=(n=(n=(n=(n=(n=(n=(n=t.helper.unescapeHTMLEntities(n)).replace(/([*_~|`])/g,"\\$1")).replace(/^(\s*)>/g,"\\$1>")).replace(/^#/gm,"\\#")).replace(/^(\s*)([-=]{3,})(\s*)$/,"$1\\$2$3")).replace(/^( {0,3}\d+)\./gm,"$1\\.")).replace(/^( {0,3})([+-])/gm,"$1\\$2")).replace(/]([\s]*)\(/g,"\\]$1\\(")).replace(/^ {0,3}\[([\S \t]*?)]:/gm,"\\[$1]:")}));"function"==typeof define&&define.amd?define((function(){"use strict";return t})):"undefined"!=typeof module&&module.exports?module.exports=t:this.showdown=t}.call(this),window.localisation={},window.localisation.de={confirm:"Ja",server:"Server",theme:"Theme",funding:"Funding",users:"Benutzer",apps:"Apps",channels:"Kanäle",transactions:"Transaktionen",dashboard:"Armaturenbrett",node:"Knoten",total_capacity:"Gesamtkapazität",avg_channel_size:"Durchschn. Kanalgröße",biggest_channel_size:"Größte Kanalgröße",smallest_channel_size:"Kleinste Kanalgröße",number_of_channels:"Anzahl der Kanäle",active_channels:"Aktive Kanäle",connect_peer:"Peer verbinden",connect:"Verbinden",open_channel:"Offener Kanal",open:"Öffnen",close_channel:"Kanal schließen",close:"Schließen",restart:"Server neu starten",save:"Speichern",save_tooltip:"Änderungen speichern",topup:"Aufladen",topup_wallet:"Wallet aufladen",topup_hint:"Nutze die Wallet-ID, um eine beliebige Wallet aufzuladen",restart_tooltip:"Starte den Server neu, um die Änderungen zu übernehmen",add_funds_tooltip:"Füge Geld zu einer Wallet hinzu.",reset_defaults:"Zurücksetzen",reset_defaults_tooltip:"Alle Einstellungen auf die Standardeinstellungen zurücksetzen.",download_backup:"Datenbank-Backup herunterladen",name_your_wallet:"Vergib deiner %{name} Wallet einen Namen",paste_invoice_label:"Füge eine Rechnung, Zahlungsanforderung oder LNURL ein *",lnbits_description:"Einfach zu installieren und kompakt, LNbits kann auf jeder Funding-Quelle im Lightning Netzwerk aufsetzen. Derzeit unterstützt: LND, Core Lightning, OpenNode, Alby, LNPay und sogar LNbits selbst! Du kannst LNbits für dich selbst betreiben oder anderen die Verwaltung durch dich anbieten. Jede Wallet hat ihre eigenen API-Schlüssel und die Anzahl der Wallets ist unbegrenzt. Die Möglichkeit, Gelder auf verschiedene Accounts mit unterschiedlicher Logik aufteilen zu können macht LNbits zu einem nützlichen Werkzeug für deine Buchhaltung - aber auch als Entwicklungswerkzeug. Erweiterungen bereichern LNbits Accounts um zusätzliche Funktionalität, so dass du mit einer Reihe von neuartigen Technologien auf dem Lightning-Netzwerk experimentieren kannst. Wir haben es so einfach wie möglich gemacht, Erweiterungen zu entwickeln, und als freies und Open-Source-Projekt möchten wir Menschen ermutigen, sich selbst hieran zu versuchen und gemeinsam mit uns neue Funktionalitäten zu entwickeln.",export_to_phone:"Auf dem Telefon öffnen",export_to_phone_desc:"Dieser QR-Code beinhaltet vollständige Rechte auf deine Wallet. Du kannst den QR-Code mit Deinem Telefon scannen, um deine Wallet dort zu öffnen.",wallets:"Wallets",add_wallet:"Wallet hinzufügen",delete_wallet:"Wallet löschen",delete_wallet_desc:"Die Wallet wird gelöscht, die hierin beinhalteten Daten hierin oder innerhalb einer Erweiterung sind UNWIEDERBRINGLICH.",rename_wallet:"Wallet umbenennen",update_name:"Namen aktualisieren",fiat_tracking:"Fiat-Tracking",currency:"Währung",update_currency:"Währung aktualisieren",press_to_claim:"Klicken, um Bitcoin einzufordern.",donate:"Spenden",view_github:"Auf GitHub anzeigen",voidwallet_active:"VoidWallet ist aktiv! Zahlungen deaktiviert",use_with_caution:"BITTE MIT VORSICHT BENUTZEN - %{name} Wallet ist noch BETA",service_fee:"Dienstleistungsgebühr: %{amount} % pro Transaktion",service_fee_max:"Servicegebühr: %{amount} % pro Transaktion (max %{max} Sats)",service_fee_tooltip:"Bearbeitungsgebühr, die vom LNbits Server-Administrator pro ausgehender Transaktion berechnet wird",toggle_darkmode:"Auf Dark Mode umschalten",view_swagger_docs:"LNbits Swagger API-Dokumente",api_docs:"API docs",lnbits_version:"LNbits-Version",runs_on:"Läuft auf",credit_hint:"Klicke Enter, um das Konto zu belasten",credit_label:"%{denomination} zu belasten",paste:"Einfügen",paste_from_clipboard:"Einfügen aus der Zwischenablage",paste_request:"Anfrage einfügen",create_invoice:"Rechnung erstellen",camera_tooltip:"Verwende die Kamera, um eine Rechnung oder einen QR-Code zu scannen",export_csv:"Exportieren als CSV",chart_tooltip:"Diagramm anzeigen",pending:"Ausstehend",copy_invoice:"Rechnung kopieren",withdraw_from:"Abheben von",cancel:"Stornieren",scan:"Scannen",read:"Lesen",pay:"Zahlen",memo:"Memo",date:"Datum",processing_payment:"Zahlung wird verarbeitet ...",not_enough_funds:"Geldmittel sind erschöpft!",search_by_tag_memo_amount:"Suche nach Tag, Memo, Betrag",invoice_waiting:"Rechnung wartend auf Zahlung",payment_received:"Zahlung erhalten",payment_sent:"Zahlung gesendet",receive:"erhalten",send:"schicken",outgoing_payment_pending:"Ausgehende Zahlung wartend",drain_funds:"Sats abziehen",drain_funds_desc:"LNURL-withdraw QR-Code, der das Abziehen aller Geldmittel aus dieser Wallet erlaubt. Teile ihn mit niemandem! Kompatibel mit balanceCheck und balanceNotify, so dass dein Wallet die Sats nach dem ersten Abzug kontinuierlich von hier abziehen kann.",i_understand:"Ich verstehe",copy_wallet_url:"Wallet-URL kopieren",disclaimer_dialog:"Login-Funktionalität wird in einem zukünftigen Update veröffentlicht. Bis dahin ist die Speicherung der Wallet-URL als Lesezeichen absolut notwendig, um Zugriff auf die Wallet zu erhalten! Dieser Service ist in BETA und wir übernehmen keine Verantwortung für Verluste durch verlorene Zugriffe.",no_transactions:"Keine Transaktionen",manage:"Verwalten",extensions:"Erweiterungen",no_extensions:"Du hast noch keine Erweiterungen installiert :(",created:"Erstellt",search_extensions:"Sucherweiterungen",warning:"Warnung",repository:"Repository",confirm_continue:"Bist du sicher, dass du fortfahren möchtest?",manage_extension_details:"Erweiterung installieren/deinstallieren",install:"Installieren",uninstall:"Deinstallieren",drop_db:"Daten löschen",enable:"Aktivieren",enable_extension_details:"Erweiterung für aktuellen Benutzer aktivieren",disable:"Deaktivieren",installed:"Installiert",activated:"Aktiviert",deactivated:"Deaktiviert",release_notes:"Versionshinweise",activate_extension_details:"Erweiterung für Benutzer verfügbar/nicht verfügbar machen",featured:"Vorgestellt",all:"Alle",only_admins_can_install:"(Nur Administratorkonten können Erweiterungen installieren)",admin_only:"Nur für Admins",new_version:"Neue Version",extension_depends_on:"Hängt ab von:",extension_rating_soon:"Bewertungen sind bald verfügbar",extension_installed_version:"Installierte Version",extension_uninstall_warning:"Sie sind dabei, die Erweiterung für alle Benutzer zu entfernen.",uninstall_confirm:"Ja, deinstallieren",extension_db_drop_info:"Alle Daten für die Erweiterung werden dauerhaft gelöscht. Es gibt keine Möglichkeit, diesen Vorgang rückgängig zu machen!",extension_db_drop_warning:"Sie sind dabei, alle Daten für die Erweiterung zu entfernen. Bitte geben Sie den Namen der Erweiterung ein, um fortzufahren:",extension_min_lnbits_version:"Diese Version erfordert mindestens die LNbits-Version",payment_hash:"Zahlungs-Hash",fee:"Gebühr",amount:"Menge",tag:"Tag",unit:"Einheit",description:"Beschreibung",expiry:"Ablauf",webhook:"Webhook",payment_proof:"Beleg",update_available:"Aktualisierung %{version} verfügbar!",latest_update:"Sie sind auf der neuesten Version %{version}.",notifications:"Benachrichtigungen",no_notifications:"Keine Benachrichtigungen",notifications_disabled:"LNbits Statusbenachrichtigungen sind deaktiviert.",enable_notifications:"Aktiviere Benachrichtigungen",enable_notifications_desc:"Wenn aktiviert, werden die neuesten LNbits-Statusaktualisierungen, wie Sicherheitsvorfälle und Updates, abgerufen.",enable_killswitch:"Aktivieren Sie den Notausschalter",enable_killswitch_desc:"Falls aktiviert, wird Ihre Zahlungsquelle automatisch auf VoidWallet umgestellt, wenn LNbits ein Killswitch-Signal sendet. Nach einem Update müssen Sie dies manuell wieder aktivieren.",killswitch_interval:"Intervall für den Notausschalter",killswitch_interval_desc:"Wie oft die Hintergrundaufgabe nach dem LNBits-Killswitch-Signal aus der Statusquelle suchen soll (in Minuten).",enable_watchdog:"Aktiviere Watchdog",enable_watchdog_desc:"Wenn aktiviert, wird Ihre Zahlungsquelle automatisch auf VoidWallet umgestellt, wenn Ihr Guthaben niedriger als das LNbits-Guthaben ist. Nach einem Update müssen Sie dies manuell aktivieren.",watchdog_interval:"Überwachungszeitintervall",watchdog_interval_desc:"Wie oft die Hintergrundaufgabe nach einem Abschaltsignal im Wachhund-Delta [node_balance - lnbits_balance] suchen soll (in Minuten).",watchdog_delta:"Watchdog Delta",watchdog_delta_desc:"Limit, bevor der Notausschalter die Finanzierungsquelle auf VoidWallet ändert [lnbits_balance - node_balance > delta]",status:"Status",notification_source:"Benachrichtigungsquelle",notification_source_label:"Quell-URL (verwenden Sie nur die offizielle LNbits-Statusquelle und Quellen, denen Sie vertrauen können)",more:"mehr",releases:"Veröffentlichungen",killswitch:"Killswitch",watchdog:"Wachhund",server_logs:"Serverprotokolle",ip_blocker:"IP-Sperre",security:"Sicherheit",security_tools:"Sicherheitstools",block_access_hint:"Zugriff per IP sperren",allow_access_hint:"Zugriff durch IP erlauben (überschreibt blockierte IPs)",enter_ip:"Geben Sie die IP ein und drücken Sie die Eingabetaste",rate_limiter:"Ratenbegrenzer",number_of_requests:"Anzahl der Anfragen",time_unit:"Zeiteinheit",minute:"Minute",second:"Sekunde",hour:"Stunde",disable_server_log:"Server-Log deaktivieren",enable_server_log:"Serverprotokollierung aktivieren",coming_soon:"Funktion demnächst verfügbar",session_has_expired:"Ihre Sitzung ist abgelaufen. Bitte melden Sie sich erneut an.",instant_access_question:"Möchten Sie sofortigen Zugang?",login_with_user_id:"Mit Benutzer-ID anmelden",or:"oder",create_new_wallet:"Neue Geldbörse erstellen",login_to_account:"Melden Sie sich bei Ihrem Konto an",create_account:"Konto erstellen",account_settings:"Kontoeinstellungen",signin_with_google:"Mit Google anmelden",signin_with_github:"Anmelden mit GitHub",username_or_email:"Benutzername oder E-Mail",password:"Passwort",password_config:"Passwortkonfiguration",password_repeat:"Passwortwiederholung",change_password:"Passwort ändern",set_password:"Passwort festlegen",invalid_password:"Das Passwort muss mindestens 8 Zeichen haben.",login:"Anmelden",register:"Registrieren",username:"Benutzername",user_id:"Benutzer-ID",email:"E-Mail",first_name:"Vorname",last_name:"Nachname",picture:"Bild",verify_email:"E-Mail verifizieren mit",account:"Konto",update_account:"Konto aktualisieren",invalid_username:"Ungültiger Benutzername",auth_provider:"Anbieter für Authentifizierung",my_account:"Mein Konto",back:"Zurück",logout:"Abmelden"},window.localisation.en={confirm:"Yes",server:"Server",theme:"Theme",funding:"Funding",users:"Users",apps:"Apps",channels:"Channels",transactions:"Transactions",dashboard:"Dashboard",node:"Node",total_capacity:"Total Capacity",avg_channel_size:"Avg. Channel Size",biggest_channel_size:"Biggest Channel Size",smallest_channel_size:"Smallest Channel Size",number_of_channels:"Number of Channels",active_channels:"Active Channels",connect_peer:"Connect Peer",connect:"Connect",open_channel:"Open Channel",open:"Open",close_channel:"Close Channel",close:"Close",restart:"Restart server",save:"Save",save_tooltip:"Save your changes",topup:"Topup",topup_wallet:"Topup a wallet",topup_hint:"Use the wallet ID to topup any wallet",restart_tooltip:"Restart the server for changes to take effect",add_funds_tooltip:"Add funds to a wallet.",reset_defaults:"Reset to defaults",reset_defaults_tooltip:"Delete all settings and reset to defaults.",download_backup:"Download database backup",name_your_wallet:"Name your %{name} wallet",paste_invoice_label:"Paste an invoice, payment request or lnurl code *",lnbits_description:"Easy to set up and lightweight, LNbits can run on any lightning-network funding source, currently supporting LND, Core Lightning, OpenNode, Alby, LNPay and even LNbits itself! You can run LNbits for yourself, or easily offer a custodian solution for others. Each wallet has its own API keys and there is no limit to the number of wallets you can make. Being able to partition funds makes LNbits a useful tool for money management and as a development tool. Extensions add extra functionality to LNbits so you can experiment with a range of cutting-edge technologies on the lightning network. We have made developing extensions as easy as possible, and as a free and open-source project, we encourage people to develop and submit their own.",export_to_phone:"Export to Phone with QR Code",export_to_phone_desc:"This QR code contains your wallet URL with full access. You can scan it from your phone to open your wallet from there.",wallets:"Wallets",add_wallet:"Add a new wallet",delete_wallet:"Delete wallet",delete_wallet_desc:"This whole wallet will be deleted, the funds will be UNRECOVERABLE.",rename_wallet:"Rename wallet",update_name:"Update name",fiat_tracking:"Fiat tracking",currency:"Currency",update_currency:"Update currency",press_to_claim:"Press to claim bitcoin",donate:"Donate",view_github:"View on GitHub",voidwallet_active:"VoidWallet is active! Payments disabled",use_with_caution:"USE WITH CAUTION - %{name} wallet is still in BETA",service_fee:"Service fee: %{amount} % per transaction",service_fee_max:"Service fee: %{amount} % per transaction (max %{max} sats)",service_fee_tooltip:"Service fee charged by the LNbits server admin per outgoing transaction",toggle_darkmode:"Toggle Dark Mode",view_swagger_docs:"View LNbits Swagger API docs",api_docs:"API docs",lnbits_version:"LNbits version",runs_on:"Runs on",credit_hint:"Press Enter to credit account",credit_label:"%{denomination} to credit",paste:"Paste",paste_from_clipboard:"Paste from clipboard",paste_request:"Paste Request",create_invoice:"Create Invoice",camera_tooltip:"Use camera to scan an invoice/QR",export_csv:"Export to CSV",chart_tooltip:"Show chart",pending:"Pending",copy_invoice:"Copy invoice",withdraw_from:"Withdraw from",cancel:"Cancel",scan:"Scan",read:"Read",pay:"Pay",memo:"Memo",date:"Date",processing_payment:"Processing payment...",not_enough_funds:"Not enough funds!",search_by_tag_memo_amount:"Search by tag, memo, amount",invoice_waiting:"Invoice waiting to be paid",payment_received:"Payment Received",payment_sent:"Payment Sent",receive:"receive",send:"send",outgoing_payment_pending:"Outgoing payment pending",drain_funds:"Drain Funds",drain_funds_desc:"This is an LNURL-withdraw QR code for slurping everything from this wallet. Do not share with anyone. It is compatible with balanceCheck and balanceNotify so your wallet may keep pulling the funds continuously from here after the first withdraw.",i_understand:"I understand",copy_wallet_url:"Copy wallet URL",disclaimer_dialog:'To ensure continuous access to your wallets, please remember to securely store your login credentials! Please visit the "My Account" page. This service is in BETA, and we hold no responsibility for people losing access to funds.',no_transactions:"No transactions made yet",manage:"Manage",extensions:"Extensions",no_extensions:"You don't have any extensions installed :(",created:"Created",search_extensions:"Search extensions",warning:"Warning",repository:"Repository",confirm_continue:"Are you sure you want to continue?",manage_extension_details:"Install/uninstall extension",install:"Install",uninstall:"Uninstall",drop_db:"Remove Data",enable:"Enable",enable_extension_details:"Enable extension for current user",disable:"Disable",installed:"Installed",activated:"Activated",deactivated:"Deactivated",release_notes:"Release Notes",activate_extension_details:"Make extension available/unavailable for users",featured:"Featured",all:"All",only_admins_can_install:"(Only admin accounts can install extensions)",admin_only:"Admin Only",new_version:"New Version",extension_depends_on:"Depends on:",extension_rating_soon:"Ratings coming soon",extension_installed_version:"Installed version",extension_uninstall_warning:"You are about to remove the extension for all users.",uninstall_confirm:"Yes, Uninstall",extension_db_drop_info:"All data for the extension will be permanently deleted. There is no way to undo this operation!",extension_db_drop_warning:"You are about to remove all data for the extension. Please type the extension name to continue:",extension_min_lnbits_version:"This release requires at least LNbits version",payment_hash:"Payment Hash",fee:"Fee",amount:"Amount",tag:"Tag",unit:"Unit",description:"Description",expiry:"Expiry",webhook:"Webhook",payment_proof:"Payment Proof",update_available:"Update %{version} available!",latest_update:"You are on the latest version %{version}.",notifications:"Notifications",no_notifications:"No notifications",notifications_disabled:"LNbits status notifications are disabled.",enable_notifications:"Enable Notifications",enable_notifications_desc:"If enabled it will fetch the latest LNbits Status updates, like security incidents and updates.",enable_killswitch:"Enable Killswitch",enable_killswitch_desc:"If enabled it will change your funding source to VoidWallet automatically if LNbits sends out a killswitch signal. You will need to enable manually after an update.",killswitch_interval:"Killswitch Interval",killswitch_interval_desc:"How often the background task should check for the LNBits killswitch signal from the status source (in minutes).",enable_watchdog:"Enable Watchdog",enable_watchdog_desc:"If enabled it will change your funding source to VoidWallet automatically if your balance is lower than the LNbits balance. You will need to enable manually after an update.",watchdog_interval:"Watchdog Interval",watchdog_interval_desc:"How often the background task should check for a killswitch signal in the watchdog delta [node_balance - lnbits_balance] (in minutes).",watchdog_delta:"Watchdog Delta",watchdog_delta_desc:"Limit before killswitch changes funding source to VoidWallet [lnbits_balance - node_balance > delta]",status:"Status",notification_source:"Notification Source",notification_source_label:"Source URL (only use the official LNbits status source, and sources you can trust)",more:"more",releases:"Releases",killswitch:"Killswitch",watchdog:"Watchdog",server_logs:"Server Logs",ip_blocker:"IP Blocker",security:"Security",security_tools:"Security tools",block_access_hint:"Block access by IP",allow_access_hint:"Allow access by IP (will override blocked IPs)",enter_ip:"Enter IP and hit enter",rate_limiter:"Rate Limiter",number_of_requests:"Number of requests",time_unit:"Time unit",minute:"minute",second:"second",hour:"hour",disable_server_log:"Disable Server Log",enable_server_log:"Enable Server Log",coming_soon:"Feature coming soon",session_has_expired:"Your session has expired. Please login again.",instant_access_question:"Want instant access?",login_with_user_id:"Login with user ID",or:"or",create_new_wallet:"Create New Wallet",login_to_account:"Login to your account",create_account:"Create account",account_settings:"Account Settings",signin_with_google:"Sign in with Google",signin_with_github:"Sign in with GitHub",username_or_email:"Username or Email",password:"Password",password_config:"Password Config",password_repeat:"Password repeat",change_password:"Change Password",set_password:"Set Password",invalid_password:"Password must have at least 8 characters",login:"Login",register:"Register",username:"Username",user_id:"User ID",email:"Email",first_name:"First Name",last_name:"Last Name",picture:"Picture",verify_email:"Verify email with",account:"Account",update_account:"Update Account",invalid_username:"Invalid Username",auth_provider:"Auth Provider",my_account:"My Account",back:"Back",logout:"Logout"},window.localisation.es={confirm:"Sí",server:"Servidor",theme:"Tema",funding:"Financiación",users:"Usuarios",apps:"Aplicaciones",channels:"Canales",transactions:"Transacciones",dashboard:"Tablero de instrumentos",node:"Nodo",total_capacity:"Capacidad Total",avg_channel_size:"Tamaño Medio del Canal",biggest_channel_size:"Tamaño del Canal Más Grande",smallest_channel_size:"Tamaño de canal más pequeño",number_of_channels:"Número de canales",active_channels:"Canales activos",connect_peer:"Conectar Par",connect:"Conectar",open_channel:"Canal Abierto",open:"Abrir",close_channel:"Cerrar canal",close:"Cerrar",restart:"Reiniciar el servidor",save:"Guardar",save_tooltip:"Guardar cambios",topup:"Recargar",topup_wallet:"Recargar billetera",topup_hint:"Utilice el ID de billetera para recargar cualquier billetera",restart_tooltip:"Reinicie el servidor para aplicar los cambios",add_funds_tooltip:"Agregue fondos a una billetera.",reset_defaults:"Restablecer",reset_defaults_tooltip:"Borrar todas las configuraciones y restablecer a los valores predeterminados.",download_backup:"Descargar copia de seguridad de la base de datos",name_your_wallet:"Nombre de su billetera %{name}",paste_invoice_label:"Pegue la factura aquí",lnbits_description:"Fácil de instalar y liviano, LNbits puede ejecutarse en cualquier fuente de financiación de la red Lightning, actualmente compatible con LND, Core Lightning, OpenNode, Alby, LNPay y hasta LNbits mismo! Puede ejecutar LNbits para usted mismo o ofrecer una solución competente a otros. Cada billetera tiene su propia clave API y no hay límite para la cantidad de billeteras que puede crear. La capacidad de particionar fondos hace de LNbits una herramienta útil para la administración de fondos y como herramienta de desarrollo. Las extensiones agregan funcionalidad adicional a LNbits, por lo que puede experimentar con una variedad de tecnologías de vanguardia en la red Lightning. Lo hemos hecho lo más simple posible para desarrollar extensiones y, como un proyecto gratuito y de código abierto, animamos a las personas a que se desarrollen a sí mismas y envíen sus propios contribuciones.",export_to_phone:"Exportar a teléfono con código QR",export_to_phone_desc:"Este código QR contiene su URL de billetera con acceso completo. Puede escanearlo desde su teléfono para abrir su billetera allí.",wallets:"Billeteras",add_wallet:"Agregar nueva billetera",delete_wallet:"Eliminar billetera",delete_wallet_desc:"Esta billetera completa se eliminará, los fondos son IRREVERSIBLES.",rename_wallet:"Cambiar el nombre de la billetera",update_name:"Actualizar nombre",fiat_tracking:"Seguimiento Fiat",currency:"Moneda",update_currency:"Actualizar moneda",press_to_claim:"Presione para reclamar Bitcoin",donate:"Donar",view_github:"Ver en GitHub",voidwallet_active:"¡VoidWallet está activo! Pagos desactivados",use_with_caution:"USAR CON CUIDADO - %{name} Wallet aún está en BETA",service_fee:"Tarifa de servicio: %{amount} % por transacción",service_fee_max:"Tarifa de servicio: %{amount} % por transacción (máx %{max} sats)",service_fee_tooltip:"Comisión de servicio cobrada por el administrador del servidor LNbits por cada transacción saliente",toggle_darkmode:"Cambiar modo oscuro",view_swagger_docs:"Ver documentos de API de LNbits Swagger",api_docs:"Documentos de API",lnbits_version:"Versión de LNbits",runs_on:"Corre en",credit_hint:"Presione Enter para cargar la cuenta",credit_label:"Cargar %{denomination}",paste:"Pegar",paste_from_clipboard:"Pegar desde el portapapeles",paste_request:"Pegar solicitud",create_invoice:"Crear factura",camera_tooltip:"Utilice la cámara para escanear una factura / código QR",export_csv:"Exportar a CSV",chart_tooltip:"Mostrar gráfico",pending:"Pendiente",copy_invoice:"Copiar factura",withdraw_from:"Retirar de",cancel:"Cancelar",scan:"Escanear",read:"Leer",pay:"Pagar",memo:"Memo",date:"Fecha",processing_payment:"Procesando pago ...",not_enough_funds:"¡No hay suficientes fondos!",search_by_tag_memo_amount:"Buscar por etiqueta, memo, cantidad",invoice_waiting:"Factura esperando pago",payment_received:"Pago recibido",payment_sent:"Pago enviado",receive:"recibir",send:"enviar",outgoing_payment_pending:"Pago saliente pendiente",drain_funds:"Drenar fondos",drain_funds_desc:"Este es un código QR LNURL-withdraw para drenar todos los fondos de esta billetera. No lo comparta con nadie. Es compatible con balanceCheck y balanceNotify, por lo que su billetera puede continuar drenando los fondos de aquí después del primer drenaje.",i_understand:"Lo entiendo",copy_wallet_url:"Copiar URL de billetera",disclaimer_dialog:"La funcionalidad de inicio de sesión se lanzará en una actualización futura, por ahora, asegúrese de guardar esta página como marcador para acceder a su billetera en el futuro. Este servicio está en BETA y no asumimos ninguna responsabilidad por personas que pierdan el acceso a sus fondos.",no_transactions:"No hay transacciones todavía",manage:"Administrar",extensions:"Extensiones",no_extensions:"No tienes extensiones instaladas :(",created:"Creado",search_extensions:"Extensiones de búsqueda",warning:"Advertencia",repository:"Repositorio",confirm_continue:"¿Está seguro de que desea continuar?",manage_extension_details:"Instalar/desinstalar extensión",install:"Instalar",uninstall:"Desinstalar",drop_db:"Eliminar datos",enable:"Habilitar",enable_extension_details:"Habilitar extensión para el usuario actual",disable:"Deshabilitar",installed:"Instalado",activated:"Activado",deactivated:"Desactivado",release_notes:"Notas de la versión",activate_extension_details:"Hacer que la extensión esté disponible/no disponible para los usuarios",featured:"Destacado",all:"Todos",only_admins_can_install:"(Solo las cuentas de administrador pueden instalar extensiones)",admin_only:"Solo administradores",new_version:"Nueva Versión",extension_depends_on:"Depende de:",extension_rating_soon:"Calificaciones próximamente",extension_installed_version:"Versión instalada",extension_uninstall_warning:"Está a punto de eliminar la extensión para todos los usuarios.",uninstall_confirm:"Sí, desinstalar",extension_db_drop_info:"Todos los datos para la extensión se eliminarán permanentemente. ¡No hay manera de deshacer esta operación!",extension_db_drop_warning:"Está a punto de eliminar todos los datos para la extensión. Por favor, escriba el nombre de la extensión para continuar:",extension_min_lnbits_version:"Esta versión requiere al menos una versión de LNbits",payment_hash:"Hash de pago",fee:"Cuota",amount:"Cantidad",tag:"Etiqueta",unit:"Unidad",description:"Descripción",expiry:"Expiración",webhook:"Webhook",payment_proof:"Prueba de pago",update_available:"¡Actualización %{version} disponible!",latest_update:"Usted está en la última versión %{version}.",notifications:"Notificaciones",no_notifications:"No hay notificaciones",notifications_disabled:"Las notificaciones de estado de LNbits están desactivadas.",enable_notifications:"Activar notificaciones",enable_notifications_desc:"Si está activado, buscará las últimas actualizaciones del estado de LNbits, como incidentes de seguridad y actualizaciones.",enable_killswitch:"Activar Killswitch",enable_killswitch_desc:"Si está activado, cambiará automáticamente su fuente de financiamiento a VoidWallet si LNbits envía una señal de parada de emergencia. Necesitará activarlo manualmente después de una actualización.",killswitch_interval:"Intervalo de Killswitch",killswitch_interval_desc:"Con qué frecuencia la tarea en segundo plano debe verificar la señal de interruptor de emergencia de LNBits desde la fuente de estado (en minutos).",enable_watchdog:"Activar Watchdog",enable_watchdog_desc:"Si está activado, cambiará automáticamente su fuente de financiamiento a VoidWallet si su saldo es inferior al saldo de LNbits. Tendrá que activarlo manualmente después de una actualización.",watchdog_interval:"Intervalo de vigilancia",watchdog_interval_desc:"Con qué frecuencia la tarea de fondo debe verificar la señal de killswitch en el delta del watchdog [node_balance - lnbits_balance] (en minutos).",watchdog_delta:"Vigilante Delta",watchdog_delta_desc:"Límite antes de que el interruptor de apagado cambie la fuente de financiamiento a VoidWallet [lnbits_balance - node_balance > delta]",status:"Estado",notification_source:"Fuente de notificación",notification_source_label:"URL de origen (solo use la fuente oficial de estado de LNbits y fuentes en las que confíe)",more:"más",releases:"Lanzamientos",killswitch:"Interruptor de apagado",watchdog:"Perro guardián",server_logs:"Registros del Servidor",ip_blocker:"Bloqueador de IP",security:"Seguridad",security_tools:"Herramientas de seguridad",block_access_hint:"Bloquear acceso por IP",allow_access_hint:"Permitir acceso por IP (anulará las IPs bloqueadas)",enter_ip:"Ingrese la IP y presione enter",rate_limiter:"Limitador de tasa",number_of_requests:"Número de solicitudes",time_unit:"Unidad de tiempo",minute:"minuto",second:"segundo",hour:"hora",disable_server_log:"Desactivar registro del servidor",enable_server_log:"Activar registro del servidor",coming_soon:"Función próximamente disponible",session_has_expired:"Tu sesión ha expirado. Por favor, inicia sesión de nuevo.",instant_access_question:"¿Quieres acceso instantáneo?",login_with_user_id:"Iniciar sesión con ID de usuario",or:"o",create_new_wallet:"Crear Nueva Cartera",login_to_account:"Inicie sesión en su cuenta",create_account:"Crear cuenta",account_settings:"Configuración de la cuenta",signin_with_google:"Inicia sesión con Google",signin_with_github:"Inicia sesión con GitHub",username_or_email:"Nombre de usuario o correo electrónico",password:"Contraseña",password_config:"Configuración de Contraseña",password_repeat:"Repetición de contraseña",change_password:"Cambiar contraseña",set_password:"Establecer contraseña",invalid_password:"La contraseña debe tener al menos 8 caracteres.",login:"Iniciar sesión",register:"Registrarse",username:"Nombre de usuario",user_id:"Identificación de usuario",email:"Correo electrónico",first_name:"Nombre de pila",last_name:"Apellido",picture:"Imagen",verify_email:"Verifique el correo electrónico con",account:"Cuenta",update_account:"Actualizar cuenta",invalid_username:"Nombre de usuario inválido",auth_provider:"Proveedor de Autenticación",my_account:"Mi cuenta",back:"Atrás",logout:"Cerrar sesión"},window.localisation.fr={confirm:"Oui",server:"Serveur",theme:"Thème",funding:"Financement",users:"Utilisateurs",apps:"Applications",channels:"Canaux",transactions:"Transactions",dashboard:"Tableau de bord",node:"Noeud",total_capacity:"Capacité totale",avg_channel_size:"Taille moyenne du canal",biggest_channel_size:"Taille de canal maximale",smallest_channel_size:"Taille de canal la plus petite",number_of_channels:"Nombre de canaux",active_channels:"Canaux actifs",connect_peer:"Connecter un pair",connect:"Connecter",open_channel:"Ouvrir le canal",open:"Ouvrir",close_channel:"Fermer le canal",close:"Fermer",restart:"Redémarrer le serveur",save:"Enregistrer",save_tooltip:"Enregistrer vos modifications",topup:"Renflouer",topup_wallet:"Reflouer un portefeuille",topup_hint:"Utilisez l'ID du portefeuille pour recharger n'importe quel portefeuille",restart_tooltip:"Redémarrez le serveur pour que les changements prennent effet",add_funds_tooltip:"Ajouter des fonds à un portefeuille.",reset_defaults:"Réinitialiser aux valeurs par défaut",reset_defaults_tooltip:"Supprimer tous les paramètres et les réinitialiser aux valeurs par défaut.",download_backup:"Télécharger la sauvegarde de la base de données",name_your_wallet:"Nommez votre portefeuille %{name}",paste_invoice_label:"Coller une facture, une demande de paiement ou un code lnurl *",lnbits_description:"Facile à installer et léger, LNbits peut fonctionner sur n'importe quelle source de financement du réseau Lightning, prenant actuellement en charge LND, Core Lightning, OpenNode, Alby, LNPay et même LNbits lui-même! Vous pouvez exécuter LNbits pour vous-même ou offrir facilement une solution de gardien pour les autres. Chaque portefeuille a ses propres clés API et il n'y a pas de limite au nombre de portefeuilles que vous pouvez créer. La capacité de partitionner les fonds rend LNbits un outil utile pour la gestion de l'argent et comme outil de développement. Les extensions ajoutent une fonctionnalité supplémentaire à LNbits afin que vous puissiez expérimenter une gamme de technologies de pointe sur le réseau Lightning. Nous avons rendu le développement d'extensions aussi simple que possible et, en tant que projet gratuit et open source, nous encourageons les gens à développer et à soumettre les leurs.",export_to_phone:"Exporter vers le téléphone avec un code QR",export_to_phone_desc:"Ce code QR contient l'URL de votre portefeuille avec un accès complet. Vous pouvez le scanner depuis votre téléphone pour ouvrir votre portefeuille depuis là-bas.",wallets:"Portefeuilles",add_wallet:"Ajouter un nouveau portefeuille",delete_wallet:"Supprimer le portefeuille",delete_wallet_desc:"Ce portefeuille entier sera supprimé et les fonds seront IRRECUPERABLES.",rename_wallet:"Renommer le portefeuille",update_name:"Mettre à jour le nom",fiat_tracking:"Suivi Fiat",currency:"Devise",update_currency:"Mettre à jour la devise",press_to_claim:"Appuyez pour demander du Bitcoin",donate:"Donner",view_github:"Voir sur GitHub",voidwallet_active:"VoidWallet est actif! Paiements désactivés",use_with_caution:"UTILISER AVEC PRUDENCE - Le portefeuille %{name} est toujours en version BETA",service_fee:"Frais de service : %{amount} % par transaction",service_fee_max:"Frais de service : %{amount} % par transaction (max %{max} sats)",service_fee_tooltip:"Frais de service facturés par l'administrateur du serveur LNbits pour chaque transaction sortante",toggle_darkmode:"Basculer le mode sombre",view_swagger_docs:"Voir les documents de l'API Swagger de LNbits",api_docs:"Documents de l'API",lnbits_version:"Version de LNbits",runs_on:"Fonctionne sur",credit_hint:"Appuyez sur Entrée pour créditer le compte",credit_label:"%{denomination} à créditer",paste:"Coller",paste_from_clipboard:"Coller depuis le presse-papiers",paste_request:"Coller la requête",create_invoice:"Créer une facture",camera_tooltip:"Utiliser la caméra pour scanner une facture / un code QR",export_csv:"Exporter vers CSV",chart_tooltip:"Afficher le graphique",pending:"En attente",copy_invoice:"Copier la facture",withdraw_from:"Retirer de",cancel:"Annuler",scan:"Scanner",read:"Lire",pay:"Payer",memo:"Mémo",date:"Date",processing_payment:"Traitement du paiement...",not_enough_funds:"Fonds insuffisants !",search_by_tag_memo_amount:"Rechercher par tag, mémo, montant",invoice_waiting:"Facture en attente de paiement",payment_received:"Paiement reçu",payment_sent:"Paiement envoyé",receive:"recevoir",send:"envoyer",outgoing_payment_pending:"Paiement sortant en attente",drain_funds:"Vider les fonds",drain_funds_desc:"Il s'agit d'un code QR LNURL-withdraw pour tout aspirer de ce portefeuille. Ne le partagez avec personne. Il est compatible avec balanceCheck et balanceNotify, de sorte que votre portefeuille peut continuer à retirer les fonds continuellement à partir d'ici après le premier retrait.",i_understand:"J'ai compris",copy_wallet_url:"Copier l'URL du portefeuille",disclaimer_dialog:"La fonctionnalité de connexion sera publiée dans une future mise à jour, pour l'instant, assurez-vous de mettre cette page en favori pour accéder à votre portefeuille ultérieurement ! Ce service est en BETA, et nous ne sommes pas responsables des personnes qui perdent l'accès à leurs fonds.",no_transactions:"Aucune transaction effectuée pour le moment",manage:"Gérer",extensions:"Extensions",no_extensions:"Vous n'avez installé aucune extension :(",created:"Créé",search_extensions:"Rechercher des extensions",warning:"Avertissement",repository:"Référentiel",confirm_continue:"Êtes-vous sûr de vouloir continuer ?",manage_extension_details:"Installer/désinstaller l'extension",install:"Installer",uninstall:"Désinstaller",drop_db:"Supprimer les données",enable:"Activer",enable_extension_details:"Activer l'extension pour l'utilisateur actuel",disable:"Désactiver",installed:"Installé",activated:"Activé",deactivated:"Désactivé",release_notes:"Notes de version",activate_extension_details:"Rendre l'extension disponible/indisponible pour les utilisateurs",featured:"Mis en avant",all:"Tout",only_admins_can_install:"Seuls les comptes administrateurs peuvent installer des extensions",admin_only:"Réservé aux administrateurs",new_version:"Nouvelle version",extension_depends_on:"Dépend de :",extension_rating_soon:"Notes des utilisateurs à venir bientôt",extension_installed_version:"Version installée",extension_uninstall_warning:"Vous êtes sur le point de supprimer l'extension pour tous les utilisateurs.",uninstall_confirm:"Oui, Désinstaller",extension_db_drop_info:"Toutes les données pour l'extension seront supprimées de manière permanente. Il n'est pas possible d'annuler cette opération !",extension_db_drop_warning:"Vous êtes sur le point de supprimer toutes les données de l'extension. Veuillez taper le nom de l'extension pour continuer :",extension_min_lnbits_version:"Cette version nécessite au moins LNbits version",payment_hash:"Hash de paiement",fee:"Frais",amount:"Montant",tag:"Étiqueter",unit:"Unité",description:"Description",expiry:"Expiration",webhook:"Webhook",payment_proof:"Preuve de paiement",update_available:"Mise à jour %{version} disponible !",latest_update:"Vous êtes sur la dernière version %{version}.",notifications:"Notifications",no_notifications:"Aucune notification",notifications_disabled:"Les notifications de statut LNbits sont désactivées.",enable_notifications:"Activer les notifications",enable_notifications_desc:"Si activé, il récupérera les dernières mises à jour du statut LNbits, telles que les incidents de sécurité et les mises à jour.",enable_killswitch:"Activer le Killswitch",enable_killswitch_desc:"Si activé, il changera automatiquement votre source de financement en VoidWallet si LNbits envoie un signal de coupure. Vous devrez activer manuellement après une mise à jour.",killswitch_interval:"Intervalle du Killswitch",killswitch_interval_desc:"À quelle fréquence la tâche de fond doit-elle vérifier le signal d'arrêt d'urgence LNBits provenant de la source de statut (en minutes).",enable_watchdog:"Activer le Watchdog",enable_watchdog_desc:"Si elle est activée, elle changera automatiquement votre source de financement en VoidWallet si votre solde est inférieur au solde LNbits. Vous devrez activer manuellement après une mise à jour.",watchdog_interval:"Intervalle du gardien",watchdog_interval_desc:"À quelle fréquence la tâche en arrière-plan doit-elle vérifier la présence d'un signal d'arrêt d'urgence dans le delta du gardien [node_balance - lnbits_balance] (en minutes).",watchdog_delta:"Chien de garde Delta",watchdog_delta_desc:"Limite avant que l'interrupteur d'arrêt ne change la source de financement pour VoidWallet [lnbits_balance - node_balance > delta]",status:"Statut",notification_source:"Source de notification",notification_source_label:"URL source (utilisez uniquement la source officielle de statut LNbits et des sources de confiance)",more:"plus",releases:"Versions",killswitch:"Interrupteur d'arrêt",watchdog:"Chien de garde",server_logs:"Journaux du serveur",ip_blocker:"Bloqueur d'IP",security:"Sécurité",security_tools:"Outils de sécurité",block_access_hint:"Bloquer l'accès par IP",allow_access_hint:"Autoriser l'accès par IP (cela passera outre les IP bloquées)",enter_ip:"Entrez l'adresse IP et appuyez sur Entrée",rate_limiter:"Limiteur de débit",number_of_requests:"Nombre de requêtes",time_unit:"Unité de temps",minute:"minute",second:"seconde",hour:"heure",disable_server_log:"Désactiver le journal du serveur",enable_server_log:"Activer le journal du serveur",coming_soon:"Fonctionnalité à venir bientôt",session_has_expired:"Votre session a expiré. Veuillez vous reconnecter.",instant_access_question:"Voulez-vous un accès instantané ?",login_with_user_id:"Connexion avec l'identifiant utilisateur",or:"ou",create_new_wallet:"Créer un nouveau portefeuille",login_to_account:"Connectez-vous à votre compte",create_account:"Créer un compte",account_settings:"Paramètres du compte",signin_with_google:"Connectez-vous avec Google",signin_with_github:"Connectez-vous avec GitHub",username_or_email:"Nom d'utilisateur ou e-mail",password:"Mot de passe",password_config:"Configuration du mot de passe",password_repeat:"Répétition du mot de passe",change_password:"Changer le mot de passe",set_password:"Définir le mot de passe",invalid_password:"Le mot de passe doit comporter au moins 8 caractères",login:"Connexion",register:"Inscrire",username:"Nom d'utilisateur",user_id:"Identifiant utilisateur",email:"E-mail",first_name:"Prénom",last_name:"Nom de famille",picture:"Image",verify_email:"Vérifiez l'e-mail avec",account:"Compte",update_account:"Mettre à jour le compte",invalid_username:"Nom d'utilisateur invalide",auth_provider:"Fournisseur d'authentification",my_account:"Mon compte",back:"Retour",logout:"Déconnexion"},window.localisation.it={confirm:"Sì",server:"Server",theme:"Tema",funding:"Funding",users:"Utenti",apps:"Applicazioni",channels:"Canali",transactions:"Transazioni",dashboard:"Pannello di controllo",node:"Interruttore",total_capacity:"Capacità Totale",avg_channel_size:"Dimensione media del canale",biggest_channel_size:"Dimensione del canale più grande",smallest_channel_size:"Dimensione Più Piccola del Canale",number_of_channels:"Numero di Canali",active_channels:"Canali Attivi",connect_peer:"Connetti Peer",connect:"Connetti",open_channel:"Canale aperto",open:"Apri",close_channel:"Chiudi Canale",close:"Chiudi",restart:"Riavvia il server",save:"Salva",save_tooltip:"Salva le modifiche",topup:"Ricarica",topup_wallet:"Ricarica un portafoglio",topup_hint:"Usa l'ID del portafoglio per ricaricare qualsiasi portafoglio",restart_tooltip:"Riavvia il server affinché le modifiche abbiano effetto",add_funds_tooltip:"Aggiungere fondi a un portafoglio",reset_defaults:"Ripristina le impostazioni predefinite",reset_defaults_tooltip:"Cancella tutte le impostazioni e ripristina i valori predefiniti",download_backup:"Scarica il backup del database",name_your_wallet:"Dai un nome al tuo portafoglio %{name}",paste_invoice_label:"Incolla una fattura, una richiesta di pagamento o un codice lnurl *",lnbits_description:"Leggero e facile da configurare, LNbits può funzionare su qualsiasi fonte di finanziamento lightning-network, attualmente supporta LND, Core Lightning, OpenNode, Alby, LNPay e persino LNbits stesso! Potete gestire LNbits per conto vostro o offrire facilmente una soluzione di custodia per altri. Ogni portafoglio ha le proprie chiavi API e non c'è limite al numero di portafogli che si possono creare. La possibilità di suddividere i fondi rende LNbits uno strumento utile per la gestione del denaro e come strumento di sviluppo. Le estensioni aggiungono ulteriori funzionalità a LNbits, consentendo di sperimentare una serie di tecnologie all'avanguardia sulla rete Lightning. Abbiamo reso lo sviluppo delle estensioni il più semplice possibile e, in quanto progetto libero e open-source, incoraggiamo le persone a sviluppare e inviare le proprie",export_to_phone:"Esportazione su telefono con codice QR",export_to_phone_desc:"Questo codice QR contiene l'URL del portafoglio con accesso da amministratore. È possibile scansionarlo dal telefono per aprire il portafoglio da lì.",wallets:"Portafogli",add_wallet:"Aggiungi un nuovo portafoglio",delete_wallet:"Elimina il portafoglio",delete_wallet_desc:"L'intero portafoglio sarà cancellato, i fondi saranno irrecuperabili",rename_wallet:"Rinomina il portafoglio",update_name:"Aggiorna il nome",fiat_tracking:"Tracciamento Fiat",currency:"Valuta",update_currency:"Aggiorna valuta",press_to_claim:"Premi per richiedere bitcoin",donate:"Donazioni",view_github:"Visualizza su GitHub",voidwallet_active:"VoidWallet è attivo! Pagamenti disabilitati",use_with_caution:"USARE CON CAUTELA - %{name} portafoglio è ancora in BETA",service_fee:"Commissione di servizio: %{amount} % per transazione",service_fee_max:"Commissione di servizio: %{amount} % per transazione (max %{max} sats)",service_fee_tooltip:"Commissione di servizio addebitata dall'amministratore del server LNbits per ogni transazione in uscita",toggle_darkmode:"Attiva la modalità notturna",view_swagger_docs:"Visualizza i documenti dell'API Swagger di LNbits",api_docs:"Documenti API",lnbits_version:"Versione di LNbits",runs_on:"Esegue su",credit_hint:"Premere Invio per accreditare i fondi",credit_label:"%{denomination} da accreditare",paste:"Incolla",paste_from_clipboard:"Incolla dagli appunti",paste_request:"Richiesta di pagamento",create_invoice:"Crea fattura",camera_tooltip:"Usa la fotocamera per scansionare la fattura/QR",export_csv:"Esporta CSV",chart_tooltip:"Mostra grafico",pending:"In attesa",copy_invoice:"Copia fattura",withdraw_from:"Prelevare da",cancel:"Annulla",scan:"Scansiona",read:"Leggi",pay:"Paga",memo:"Memo",date:"Dati",processing_payment:"Elaborazione pagamento...",not_enough_funds:"Non ci sono abbastanza fondi!",search_by_tag_memo_amount:"Cerca per tag, memo, importo...",invoice_waiting:"Fattura in attesa di pagamento",payment_received:"Pagamento ricevuto",payment_sent:"Pagamento inviato",receive:"ricevere",send:"inviare",outgoing_payment_pending:"Pagamento in uscita in attesa",drain_funds:"Fondi di drenaggio",drain_funds_desc:"Questo è un codice QR <code>LNURL-withdraw</code> per prelevare tutti i fondi da questo portafoglio. Non condividerlo con nessuno. È compatibile con <code>balanceCheck</code> e <code>balanceNotify</code>, di conseguenza il vostro portafoglio può continuare a prelevare continuamente i fondi da qui dopo il primo prelievo",i_understand:"Ho capito",copy_wallet_url:"Copia URL portafoglio",disclaimer_dialog:"La funzionalità di login sarà rilasciata in un futuro aggiornamento; per ora, assicuratevi di salvare tra i preferiti questa pagina per accedere nuovamente in futuro a questo portafoglio! Questo servizio è in fase BETA e non ci assumiamo alcuna responsabilità per la perdita all'accesso dei fondi",no_transactions:"Nessuna transazione effettuata",manage:"Gestisci",extensions:"Estensioni",no_extensions:"Non ci sono estensioni installate :(",created:"Creato",search_extensions:"Estensioni di ricerca",warning:"Attenzione",repository:"Deposito",confirm_continue:"Sei sicuro di voler continuare?",manage_extension_details:"Installa/disinstalla estensione",install:"Installare",uninstall:"Disinstalla",drop_db:"Rimuovi Dati",enable:"Abilita",enable_extension_details:"Attiva l'estensione per l'utente corrente",disable:"Disabilita",installed:"Installato",activated:"Attivato",deactivated:"Disattivato",release_notes:"Note di Rilascio",activate_extension_details:"Rendi l'estensione disponibile/non disponibile per gli utenti",featured:"In primo piano",all:"Tutto",only_admins_can_install:"Solo gli account amministratore possono installare estensioni.",admin_only:"Solo amministratore",new_version:"Nuova Versione",extension_depends_on:"Dipende da:",extension_rating_soon:"Valutazioni in arrivo",extension_installed_version:"Versione installata",extension_uninstall_warning:"Stai per rimuovere l'estensione per tutti gli utenti.",uninstall_confirm:"Sì, Disinstalla",extension_db_drop_info:"Tutti i dati relativi all'estensione saranno cancellati permanentemente. Non c'è modo di annullare questa operazione!",extension_db_drop_warning:"Stai per rimuovere tutti i dati per l'estensione. Digita il nome dell'estensione per continuare:",extension_min_lnbits_version:"Questa versione richiede almeno la versione LNbits",payment_hash:"Hash del pagamento",fee:"Tariffa",amount:"Importo",tag:"Etichetta",unit:"Unità",description:"Descrizione",expiry:"Scadenza",webhook:"Webhook",payment_proof:"Prova di pagamento",update_available:"Aggiornamento %{version} disponibile!",latest_update:"Sei sulla versione più recente %{version}.",notifications:"Notifiche",no_notifications:"Nessuna notifica",notifications_disabled:"Le notifiche di stato di LNbits sono disattivate.",enable_notifications:"Attiva le notifiche",enable_notifications_desc:"Se attivato, recupererà gli ultimi aggiornamenti sullo stato di LNbits, come incidenti di sicurezza e aggiornamenti.",enable_killswitch:"Attiva Killswitch",enable_killswitch_desc:"Se attivato, cambierà automaticamente la tua fonte di finanziamento in VoidWallet se LNbits invia un segnale di killswitch. Dovrai attivare manualmente dopo un aggiornamento.",killswitch_interval:"Intervallo Killswitch",killswitch_interval_desc:"Quanto spesso il compito in background dovrebbe controllare il segnale di killswitch LNBits dalla fonte di stato (in minuti).",enable_watchdog:"Attiva Watchdog",enable_watchdog_desc:"Se abilitato, cambierà automaticamente la tua fonte di finanziamento in VoidWallet se il tuo saldo è inferiore al saldo LNbits. Dovrai abilitarlo manualmente dopo un aggiornamento.",watchdog_interval:"Intervallo Watchdog",watchdog_interval_desc:"Quanto spesso il task in background dovrebbe controllare un segnale di killswitch nel delta del watchdog [node_balance - lnbits_balance] (in minuti).",watchdog_delta:"Guardiano Delta",watchdog_delta_desc:"Limite prima che l'interruttore di sicurezza modifichi la fonte di finanziamento in VoidWallet [lnbits_balance - node_balance > delta]",status:"Stato",notification_source:"Sorgente di notifica",notification_source_label:"URL sorgente (utilizzare solo la fonte ufficiale di stato LNbits e fonti di cui ti puoi fidare)",more:"più",releases:"Pubblicazioni",killswitch:"Interruttore di spegnimento",watchdog:"Cane da guardia",server_logs:"Registri del server",ip_blocker:"Blocco IP",security:"Sicurezza",security_tools:"Strumenti di sicurezza",block_access_hint:"Blocca l'accesso per IP",allow_access_hint:"Consenti l'accesso per IP (sovrascriverà gli IP bloccati)",enter_ip:"Inserisci l'IP e premi invio",rate_limiter:"Limitatore di frequenza",number_of_requests:"Numero di richieste",time_unit:"Unità di tempo",minute:"minuto",second:"secondo",hour:"ora",disable_server_log:"Disabilita Registro Server",enable_server_log:"Attiva Registro Server",coming_soon:"Caratteristica in arrivo prossimamente",session_has_expired:"La tua sessione è scaduta. Per favore, effettua nuovamente il login.",instant_access_question:"Vuoi accesso immediato?",login_with_user_id:"Accedi con ID utente",or:"oppure",create_new_wallet:"Crea nuovo portafoglio",login_to_account:"Accedi al tuo account",create_account:"Crea un account",account_settings:"Impostazioni dell'account",signin_with_google:"Accedi con Google",signin_with_github:"Accedi con GitHub",username_or_email:"Nome utente o Email",password:"Password",password_config:"Configurazione della password",password_repeat:"Ripeti la password",change_password:"Cambia Password",set_password:"Imposta password",invalid_password:"La password deve contenere almeno 8 caratteri",login:"Accesso",register:"Registrati",username:"Nome utente",user_id:"ID utente",email:"Email",first_name:"Nome",last_name:"Cognome",picture:"Immagine",verify_email:"Verifica email con",account:"Conto",update_account:"Aggiorna Account",invalid_username:"Nome utente non valido",auth_provider:"Provider di Autenticazione",my_account:"Il mio account",back:"Indietro",logout:"Esci"},window.localisation.jp={confirm:"はい",server:"サーバー",theme:"テーマ",funding:"資金調達",users:"ユーザー",apps:"アプリ",channels:"チャンネル",transactions:"トランザクション",dashboard:"ダッシュボード",node:"ノード",total_capacity:"合計容量",avg_channel_size:"平均チャンネルサイズ",biggest_channel_size:"最大チャネルサイズ",smallest_channel_size:"最小チャンネルサイズ",number_of_channels:"チャンネル数",active_channels:"アクティブチャンネル",connect_peer:"ピアを接続",connect:"接続",open_channel:"オープンチャンネル",open:"開く",close_channel:"チャンネルを閉じる",close:"閉じる",restart:"サーバーを再起動する",save:"保存",save_tooltip:"変更を保存する",topup:"トップアップ",topup_wallet:"ウォレットをトップアップする",topup_hint:"ウォレットIDを使用して、任意のウォレットをトップアップできます",restart_tooltip:"サーバーを再起動して変更を適用します",add_funds_tooltip:"ウォレットに資金を追加します。",reset_defaults:"リセット",reset_defaults_tooltip:"すべての設定を削除してデフォルトに戻します。",download_backup:"データベースのバックアップをダウンロードする",name_your_wallet:"あなたのウォレットの名前 %{name}",paste_invoice_label:"請求書を貼り付けてください",lnbits_description:"簡単にインストールでき、軽量で、LNbitsは現在LND、Core Lightning、OpenNode、Alby, LNPay、さらにLNbits自身で動作する任意のLightningネットワークの資金源で実行できます！ LNbitsを自分で実行することも、他の人に優れたソリューションを提供することもできます。各ウォレットには独自のAPIキーがあり、作成できるウォレットの数に制限はありません。資金を分割する機能は、LNbitsを資金管理ツールとして使用したり、開発ツールとして使用したりするための便利なツールです。拡張機能は、LNbitsに追加の機能を追加します。そのため、LNbitsは最先端の技術をネットワークLightningで試すことができます。拡張機能を開発するのは簡単で、無料でオープンソースのプロジェクトであるため、人々が自分で開発し、自分の貢献を送信することを奨励しています。",export_to_phone:"電話にエクスポート",export_to_phone_desc:"ウォレットを電話にエクスポートすると、ウォレットを削除する前にウォレットを復元できます。ウォレットを削除すると、ウォレットの秘密鍵が削除され、ウォレットを復元することはできません。",wallets:"ウォレット",add_wallet:"ウォレットを追加",delete_wallet:"ウォレットを削除",delete_wallet_desc:"ウォレットを削除すると、ウォレットの秘密鍵が削除され、ウォレットを復元することはできません。",rename_wallet:"ウォレットの名前を変更",update_name:"名前を更新",fiat_tracking:"フィアット追跡",currency:"通貨",update_currency:"通貨を更新する",press_to_claim:"クレームするには押してください",donate:"寄付",view_github:"GitHubで表示",voidwallet_active:"Voidwalletアクティブ",use_with_caution:"注意して使用してください - %{name} ウォレットはまだベータ版です",service_fee:"取引ごとのサービス手数料: %{amount} %",service_fee_max:"取引手数料：%{amount}%（最大%{max}サトシ）",service_fee_tooltip:"LNbitsサーバー管理者が発生する送金ごとの手数料",toggle_darkmode:"ダークモードを切り替える",view_swagger_docs:"Swaggerドキュメントを表示",api_docs:"APIドキュメント",lnbits_version:"LNbits バージョン",runs_on:"で実行",credit_hint:"クレジットカードを使用して資金を追加するには、LNbitsを使用してください。",credit_label:"%{denomination} をクレジットに",paste:"貼り付け",paste_from_clipboard:"クリップボードから貼り付け",paste_request:"リクエストを貼り付ける",create_invoice:"請求書を作成する",camera_tooltip:"QRコードを読み取る",export_csv:"CSVでエクスポート",chart_tooltip:"チャートを表示するには、グラフの上にカーソルを合わせます",pending:"保留中",copy_invoice:"請求書をコピー",withdraw_from:"出金",cancel:"キャンセル",scan:"スキャン",read:"読む",pay:"支払う",memo:"メモ",date:"日付",processing_payment:"支払い処理中",not_enough_funds:"資金が不足しています",search_by_tag_memo_amount:"タグ、メモ、金額で検索",invoice_waiting:"請求書を待っています",payment_received:"お支払いありがとうございます",payment_sent:"支払いが完了しました",receive:"受け取る",send:"送信",outgoing_payment_pending:"支払い保留中",drain_funds:"資金を排出する",drain_funds_desc:"ウォレットの残高をすべて他のウォレットに送金します",i_understand:"理解した",copy_wallet_url:"ウォレットURLをコピー",disclaimer_dialog:"ウォレットを削除すると、ウォレットの秘密鍵が削除され、ウォレットを復元することはできません。ウォレットを削除する前に、ウォレットをエクスポートしてください。",no_transactions:"トランザクションはありません",manage:"管理",extensions:"拡張機能",no_extensions:"拡張機能はありません",created:"作成済み",search_extensions:"検索拡張機能",warning:"警告",repository:"リポジトリ",confirm_continue:"続行してもよろしいですか?",manage_extension_details:"拡張機能のインストール/アンインストール",install:"インストール",uninstall:"アンインストール",drop_db:"データを削除",enable:"有効",enable_extension_details:"現在のユーザーの拡張機能を有効にする",disable:"無効",installed:"インストール済み",activated:"有効化",deactivated:"無効化",release_notes:"リリースノート",activate_extension_details:"拡張機能をユーザーが利用できるようにする/利用できないようにする",featured:"特集",all:"すべて",only_admins_can_install:"(管理者アカウントのみが拡張機能をインストールできます)",admin_only:"管理者のみ",new_version:"新しいバージョン",extension_depends_on:"依存先:",extension_rating_soon:"評価は近日公開",extension_installed_version:"インストール済みバージョン",extension_uninstall_warning:"すべてのユーザーの拡張機能を削除しようとしています.",uninstall_confirm:"はい、アンインストールします",extension_db_drop_info:"エクステンションのすべてのデータが完全に削除されます。この操作を元に戻す方法はありません！",extension_db_drop_warning:"エクステンションのすべてのデータを削除しようとしています。続行するには、エクステンションの名前を入力してください：",extension_min_lnbits_version:"このリリースには少なくとも LNbits バージョンが必要です",payment_hash:"支払いハッシュ",fee:"料金",amount:"量",tag:"タグ",unit:"単位",description:"説明",expiry:"有効期限",webhook:"ウェブフック",payment_proof:"支払い証明",update_available:"アップデート%{version}が利用可能です！",latest_update:"あなたは最新バージョン%{version}を使用しています。",notifications:"通知",no_notifications:"通知はありません",notifications_disabled:"LNbitsステータス通知は無効です。",enable_notifications:"通知を有効にする",enable_notifications_desc:"有効にすると、セキュリティインシデントやアップデートのような最新のLNbitsステータス更新を取得します。",enable_killswitch:"キルスイッチを有効にする",enable_killswitch_desc:"有効にすると、LNbitsからキルスイッチ信号が送信された場合に自動的に資金源をVoidWalletに切り替えます。更新後には手動で有効にする必要があります。",killswitch_interval:"キルスイッチ間隔",killswitch_interval_desc:"バックグラウンドタスクがステータスソースからLNBitsキルスイッチ信号を確認する頻度（分単位）。",enable_watchdog:"ウォッチドッグを有効にする",enable_watchdog_desc:"有効にすると、残高がLNbitsの残高より少ない場合に、資金源を自動的にVoidWalletに変更します。アップデート後は手動で有効にする必要があります。",watchdog_interval:"ウォッチドッグ・インターバル",watchdog_interval_desc:"バックグラウンドタスクがウォッチドッグデルタ[node_balance - lnbits_balance]でキルスイッチシグナルを確認する頻度（分単位）。",watchdog_delta:"ウォッチドッグデルタ",watchdog_delta_desc:"キルスイッチが資金源をVoidWalletに変更する前の限界 [lnbits_balance - node_balance > delta]",status:"ステータス",notification_source:"通知ソース",notification_source_label:"ソースURL（公式のLNbitsステータスソースのみを使用し、信頼できるソースのみを利用してください）",more:"より多くの",releases:"リリース",killswitch:"キルスイッチ",watchdog:"ウォッチドッグ",server_logs:"サーバーログ",ip_blocker:"IPブロッカー",security:"セキュリティ",security_tools:"セキュリティツール",block_access_hint:"IPによるアクセスをブロック",allow_access_hint:"IPによるアクセスを許可する（ブロックされたIPを上書きします）",enter_ip:"IPを入力してエンターキーを押してください",rate_limiter:"レートリミッター",number_of_requests:"リクエストの数",time_unit:"時間単位",minute:"分",second:"秒",hour:"時間",disable_server_log:"サーバーログを無効にする",enable_server_log:"サーバーログを有効にする",coming_soon:"機能は間もなく登場します",session_has_expired:"あなたのセッションは期限切れです。もう一度ログインしてください。",instant_access_question:"即時アクセスをご希望ですか？",login_with_user_id:"ユーザーIDでログイン",or:"または",create_new_wallet:"新しいウォレットを作成",login_to_account:"アカウントにログインしてください",create_account:"アカウントを作成",account_settings:"アカウント設定",signin_with_google:"Googleでサインイン",signin_with_github:"GitHubでサインイン",username_or_email:"ユーザー名またはメールアドレス",password:"パスワード",password_config:"パスワード設定",password_repeat:"パスワードの再入力",change_password:"パスワードを変更",set_password:"パスワードを設定",invalid_password:"パスワードは少なくとも8文字必要です",login:"ログイン",register:"登録",username:"ユーザー名",user_id:"ユーザーID",email:"メール",first_name:"名",last_name:"姓",picture:"写真",verify_email:"メールアドレスの確認を行ってください",account:"アカウント",update_account:"アカウントを更新",invalid_username:"無効なユーザー名",auth_provider:"認証プロバイダ",my_account:"マイアカウント",back:"戻る",logout:"ログアウト"},window.localisation.cn={confirm:"确定",server:"服务器",theme:"主题",funding:"资金",users:"用户",apps:"应用程序",channels:"频道",transactions:"交易记录",dashboard:"控制面板",node:"节点",total_capacity:"总容量",avg_channel_size:"平均频道大小",biggest_channel_size:"最大通道大小",smallest_channel_size:"最小频道尺寸",number_of_channels:"频道数量",active_channels:"活跃频道",connect_peer:"连接对等",connect:"连接",open_channel:"打开频道",open:"打开",close_channel:"关闭频道",close:"关闭",restart:"重新启动服务器",save:"保存",save_tooltip:"保存更改",topup:"充值",topup_wallet:"给钱包充值",topup_hint:"使用钱包ID为任何钱包充值",restart_tooltip:"重新启动服务器以使更改生效",add_funds_tooltip:"为钱包添加资金",reset_defaults:"重置为默认设置",reset_defaults_tooltip:"删除所有设置并重置为默认设置",download_backup:"下载数据库备份",name_your_wallet:"给你的 %{name}钱包起个名字",paste_invoice_label:"粘贴发票，付款请求或lnurl*",lnbits_description:"LNbits 设置简单、轻量级，可以运行在任何闪电网络的版本上，目前支持 LND、Core Lightning、OpenNode、Alby, LNPay，甚至 LNbits 本身！您可以为自己运行 LNbits，或者为他人轻松提供资金托管。每个钱包都有自己的 API 密钥，你可以创建的钱包数量没有限制。能够把资金分开管理使 LNbits 成为一款有用的资金管理和开发工具。扩展程序增加了 LNbits 的额外功能，所以你可以在闪电网络上尝试各种尖端技术。我们已经尽可能简化了开发扩展程序的过程，作为一个免费和开源的项目，我们鼓励人们开发并提交自己的扩展程序。",export_to_phone:"通过二维码导出到手机",export_to_phone_desc:"这个二维码包含您钱包的URL。您可以使用手机扫描的方式打开您的钱包。",wallets:"钱包",add_wallet:"添加新钱包",delete_wallet:"删除钱包",delete_wallet_desc:"整个钱包将被删除，资金将无法恢复",rename_wallet:"重命名钱包",update_name:"更新名称",fiat_tracking:"菲亚特追踪",currency:"货币",update_currency:"更新货币",press_to_claim:"点击领取比特币",donate:"捐献",view_github:"在GitHub上查看",voidwallet_active:"VoidWallet 已激活！付款功能已禁用。",use_with_caution:"请谨慎使用 - %{name}钱包还处于测试版阶段",service_fee:"服务费：%{amount}% 每笔交易",service_fee_max:"服务费：%{amount}% 每笔交易（最高 %{max} sats）",service_fee_tooltip:"LNbits服务器管理员每笔外发交易收取的服务费",toggle_darkmode:"切换暗黑模式",view_swagger_docs:"查看 LNbits Swagger API 文档",api_docs:"API文档",lnbits_version:"LNbits版本",runs_on:"可运行在",credit_hint:"按 Enter 键充值账户",credit_label:"%{denomination} 充值",paste:"粘贴",paste_from_clipboard:"从剪贴板粘贴",paste_request:"粘贴请求",create_invoice:"创建发票",camera_tooltip:"用相机扫描发票/二维码",export_csv:"导出为CSV",chart_tooltip:"显示图表",pending:"待处理",copy_invoice:"复制发票",withdraw_from:"从",cancel:"取消",scan:"扫描",read:"读取",pay:"付款",memo:"备注",date:"日期",processing_payment:"正在处理支付...",not_enough_funds:"资金不足！",search_by_tag_memo_amount:"按标签、备注、金额搜索",invoice_waiting:"待支付的发票",payment_received:"收到付款",payment_sent:"付款已发送",receive:"收款",send:"付款",outgoing_payment_pending:"付款正在等待处理",drain_funds:"清空资金",drain_funds_desc:"这是一个 LNURL-取款的二维码，用于从该钱包中提取全部资金。请不要与他人分享。它与 balanceCheck 和 balanceNotify 兼容，因此在第一次取款后，您的钱包还可能会持续从这里提取资金",i_understand:"我明白",copy_wallet_url:"复制钱包URL",disclaimer_dialog:"登录功能将在以后的更新中发布，请将此页面加为书签，以便将来访问您的钱包！此服务处于测试阶段，我们不对资金的丢失承担任何责任。",no_transactions:"尚未进行任何交易",manage:"管理",extensions:"扩展程序",no_extensions:"你没有安装任何扩展程序 :(",created:"已创建",search_extensions:"搜索扩展程序",warning:"警告",repository:"代码库",confirm_continue:"你确定要继续吗?",manage_extension_details:"安装/卸载扩展程序",install:"安装",uninstall:"卸载",drop_db:"删除数据",enable:"启用",enable_extension_details:"为当前用户启用扩展程序",disable:"禁用",installed:"已安装",activated:"已激活",deactivated:"已停用",release_notes:"发布说明",activate_extension_details:"对用户开放或禁用扩展程序",featured:"精选",all:"全部",only_admins_can_install:"（只有管理员账户可以安装扩展）",admin_only:"仅限管理员",new_version:"新版本",extension_depends_on:"依赖于:",extension_rating_soon:"即将推出评分",extension_installed_version:"已安装的版本",extension_uninstall_warning:"您即将对所有用户删除该扩展程序。",uninstall_confirm:"是的，卸载",extension_db_drop_info:"该扩展程序的所有数据将被永久删除。此操作无法撤销！",extension_db_drop_warning:"您即将删除该扩展的所有数据。请继续输入扩展程序名称以确认操作：",extension_min_lnbits_version:"此版本要求最低的 LNbits 版本为",payment_hash:"付款哈希",fee:"费",amount:"金额",tag:"标签",unit:"单位",description:"详情",expiry:"过期时间",webhook:"Webhook",payment_proof:"付款证明",update_available:"更新%{version}可用！",latest_update:"您当前使用的是最新版本%{version}。",notifications:"通知",no_notifications:"没有通知",notifications_disabled:"LNbits状态通知已禁用。",enable_notifications:"启用通知",enable_notifications_desc:"如果启用，它将获取最新的LNbits状态更新，如安全事件和更新。",enable_killswitch:"启用紧急停止开关",enable_killswitch_desc:"如果启用，当LNbits发送终止信号时，系统将自动将您的资金来源更改为VoidWallet。更新后，您将需要手动启用。",killswitch_interval:"Killswitch 间隔",killswitch_interval_desc:"后台任务应该多久检查一次来自状态源的LNBits断路信号（以分钟为单位）。",enable_watchdog:"启用看门狗",enable_watchdog_desc:"如果启用，当您的余额低于LNbits余额时，系统将自动将您的资金来源更改为VoidWallet。更新后您将需要手动启用。",watchdog_interval:"看门狗间隔",watchdog_interval_desc:"后台任务应该多久检查一次看门狗增量中的 killswitch 信号 [node_balance - lnbits_balance]（以分钟计）。",watchdog_delta:"看门狗德尔塔",watchdog_delta_desc:"在触发紧急停止前切换资金来源至VoidWallet的限制 [lnbits_balance - node_balance > delta]",status:"状态",notification_source:"通知来源",notification_source_label:"来源 URL（仅使用官方LNbits状态源和您信任的源）",more:"更多",releases:"版本",killswitch:"杀手锏",watchdog:"监控程序",server_logs:"服务器日志",ip_blocker:"IP 阻止器",security:"安全",security_tools:"安全工具",block_access_hint:"屏蔽IP访问",allow_access_hint:"允许通过IP访问（将覆盖被屏蔽的IP）",enter_ip:"输入IP地址并按回车键",rate_limiter:"速率限制器",number_of_requests:"请求次数",time_unit:"时间单位",minute:"分钟",second:"秒",hour:"小时",disable_server_log:"禁用服务器日志",enable_server_log:"启用服务器日志",coming_soon:"功能即将推出",session_has_expired:"您的会话已过期。请重新登录。",instant_access_question:"想要即时访问吗？",login_with_user_id:"使用用户ID登录",or:"或",create_new_wallet:"创建新钱包",login_to_account:"登录您的账户",create_account:"创建账户",account_settings:"账户设置",signin_with_google:"使用谷歌账号登录",signin_with_github:"使用 GitHub 登录",username_or_email:"用户名或电子邮箱",password:"密码",password_config:"密码配置",password_repeat:"密码重复",change_password:"修改密码",set_password:"设置密码",invalid_password:"密码至少需要有8个字符",login:"登录",register:"注册",username:"用户名",user_id:"用户ID",email:"电子邮件",first_name:"名字",last_name:"姓氏",picture:"图片",verify_email:"验证电子邮件与",account:"账户",update_account:"更新帐户",invalid_username:"无效用户名",auth_provider:"认证提供者",my_account:"我的账户",back:"返回",logout:"注销"},window.localisation.nl={confirm:"Ja",server:"Server",theme:"Thema",funding:"Financiering",users:"Gebruikers",apps:"Apps",channels:"Kanalen",transactions:"Transacties",dashboard:"Dashboard",node:"Knooppunt",total_capacity:"Totale capaciteit",avg_channel_size:"Gem. Kanaalgrootte",biggest_channel_size:"Grootste Kanaalgrootte",smallest_channel_size:"Kleinste Kanaalgrootte",number_of_channels:"Aantal kanalen",active_channels:"Actieve Kanalen",connect_peer:"Peer verbinden",connect:"Verbinden",open_channel:"Open Kanaal",open:"Open",close_channel:"Kanaal Sluiten",close:"Sluiten",restart:"Server opnieuw opstarten",save:"Opslaan",save_tooltip:"Sla uw wijzigingen op",topup:"Bijvullen",topup_wallet:"Een portemonnee bijvullen",topup_hint:"Gebruik de portemonnee-ID om elke portemonnee bij te vullen",restart_tooltip:"Start de server opnieuw op zodat wijzigingen van kracht worden",add_funds_tooltip:"Voeg geld toe aan een portemonnee.",reset_defaults:"Standaardinstellingen herstellen",reset_defaults_tooltip:"Wis alle instellingen en herstel de standaardinstellingen.",download_backup:"Databaseback-up downloaden",name_your_wallet:"Geef je %{name} portemonnee een naam",paste_invoice_label:"Plak een factuur, betalingsverzoek of lnurl-code*",lnbits_description:"Gemakkelijk in te stellen en lichtgewicht, LNbits kan op elke lightning-netwerkfinancieringsbron draaien, ondersteunt op dit moment LND, Core Lightning, OpenNode, Alby, LNPay en zelfs LNbits zelf! U kunt LNbits voor uzelf laten draaien of gemakkelijk een bewaardersoplossing voor anderen bieden. Elke portemonnee heeft zijn eigen API-sleutels en er is geen limiet aan het aantal portemonnees dat u kunt maken. Het kunnen partitioneren van fondsen maakt LNbits een nuttige tool voor geldbeheer en als ontwikkelingstool. Extensies voegen extra functionaliteit toe aan LNbits, zodat u kunt experimenteren met een reeks toonaangevende technologieën op het bliksemschichtnetwerk. We hebben het ontwikkelen van extensies zo eenvoudig mogelijk gemaakt en als een gratis en opensource-project moedigen we mensen aan om hun eigen ontwikkelingen in te dienen.",export_to_phone:"Exporteren naar telefoon met QR-code",export_to_phone_desc:"Deze QR-code bevat uw portemonnee-URL met volledige toegang. U kunt het vanaf uw telefoon scannen om uw portemonnee van daaruit te openen.",wallets:"Portemonnees",add_wallet:"Een nieuwe portemonnee toevoegen",delete_wallet:"Portemonnee verwijderen",delete_wallet_desc:"Deze hele portemonnee wordt verwijderd, de fondsen worden NIET TERUGGEVONDEN.",rename_wallet:"Portemonnee hernoemen",update_name:"Naam bijwerken",fiat_tracking:"Volgfunctie voor fiat-valuata",currency:"Valuta",update_currency:"Valuta bijwerken",press_to_claim:"Druk om bitcoin te claimen",donate:"Doneren",view_github:"Bekijken op GitHub",voidwallet_active:"VoidWallet is actief! Betalingen uitgeschakeld",use_with_caution:"GEBRUIK MET VOORZICHTIGHEID - %{name} portemonnee is nog in BETA",service_fee:"Servicekosten: %{amount} % per transactie",service_fee_max:"Servicekosten: %{amount} % per transactie (max %{max} sats)",service_fee_tooltip:"Transactiekosten in rekening gebracht door de LNbits serverbeheerder per uitgaande transactie",toggle_darkmode:"Donkere modus aan/uit",view_swagger_docs:"Bekijk LNbits Swagger API-documentatie",api_docs:"API-documentatie",lnbits_version:"LNbits-versie",runs_on:"Draait op",credit_hint:"Druk op Enter om de rekening te crediteren",credit_label:"%{denomination} te crediteren",paste:"Plakken",paste_from_clipboard:"Plakken van klembord",paste_request:"Verzoek plakken",create_invoice:"Factuur aanmaken",camera_tooltip:"Gebruik de camera om een factuur/QR-code te scannen",export_csv:"Exporteer naar CSV",chart_tooltip:"Toon grafiek",pending:"In behandeling",copy_invoice:"Kopieer factuur",withdraw_from:"Opnemen van",cancel:"Annuleren",scan:"Scannen",read:"Lezen",pay:"Betalen",memo:"Memo",date:"Datum",processing_payment:"Verwerking betaling...",not_enough_funds:"Onvoldoende saldo!",search_by_tag_memo_amount:"Zoeken op tag, memo, bedrag",invoice_waiting:"Factuur wachtend op betaling",payment_received:"Betaling ontvangen",payment_sent:"Betaling verzonden",receive:"ontvangen",send:"versturen",outgoing_payment_pending:"Uitgaande betaling in behandeling",drain_funds:"Geld opnemen",drain_funds_desc:"Dit is een LNURL-withdraw QR-code om alles uit deze portemonnee te halen. Deel deze code niet met anderen. Het is compatibel met balanceCheck en balanceNotify zodat jouw portemonnee continu geld kan blijven opnemen vanaf hier na de eerste opname.",i_understand:"Ik begrijp het",copy_wallet_url:"Kopieer portemonnee-URL",disclaimer_dialog:"Inlogfunctionaliteit wordt uitgebracht in een toekomstige update. Zorg er nu voor dat je deze pagina als favoriet markeert om in de toekomst toegang te krijgen tot je portemonnee! Deze service is in BETA en we zijn niet verantwoordelijk voor mensen die de toegang tot hun fondsen verliezen.",no_transactions:"Er zijn nog geen transacties gedaan",manage:"Beheer",extensions:"Extensies",no_extensions:"Je hebt geen extensies geïnstalleerd :(",created:"Aangemaakt",search_extensions:"Zoekextensies",warning:"Waarschuwing",repository:"Repository",confirm_continue:"Weet je zeker dat je wilt doorgaan?",manage_extension_details:"Installeren/verwijderen van extensie",install:"Installeren",uninstall:"Deïnstalleren",drop_db:"Gegevens verwijderen",enable:"Inschakelen",enable_extension_details:"Schakel extensie in voor huidige gebruiker",disable:"Uitschakelen",installed:"Geïnstalleerd",activated:"Geactiveerd",deactivated:"Gedeactiveerd",release_notes:"Release-opmerkingen",activate_extension_details:"Maak extensie beschikbaar/niet beschikbaar voor gebruikers",featured:"Uitgelicht",all:"Alles",only_admins_can_install:"Alleen beheerdersaccounts kunnen extensies installeren",admin_only:"Alleen beheerder",new_version:"Nieuwe Versie",extension_depends_on:"Afhankelijk van:",extension_rating_soon:"Beoordelingen binnenkort beschikbaar",extension_installed_version:"Geïnstalleerde versie",extension_uninstall_warning:"U staat op het punt de extensie voor alle gebruikers te verwijderen.",uninstall_confirm:"Ja, de-installeren",extension_db_drop_info:"Alle gegevens voor de extensie zullen permanent worden verwijderd. Er is geen manier om deze bewerking ongedaan te maken!",extension_db_drop_warning:"U staat op het punt alle gegevens voor de extensie te verwijderen. Typ de naam van de extensie om door te gaan:",extension_min_lnbits_version:"Deze release vereist ten minste LNbits-versie",payment_hash:"Betalings-hash",fee:"Kosten",amount:"Bedrag",tag:"Label",unit:"Eenheid",description:"Beschrijving",expiry:"Vervaldatum",webhook:"Webhook",payment_proof:"Betalingsbewijs",update_available:"Update %{version} beschikbaar!",latest_update:"U bent op de nieuwste versie %{version}.",notifications:"Meldingen",no_notifications:"Geen meldingen",notifications_disabled:"LNbits-statusmeldingen zijn uitgeschakeld.",enable_notifications:"Schakel meldingen in",enable_notifications_desc:"Indien ingeschakeld zal het de laatste LNbits Status updates ophalen, zoals veiligheidsincidenten en updates.",enable_killswitch:"Activeer Killswitch",enable_killswitch_desc:"Indien ingeschakeld, zal het uw financieringsbron automatisch wijzigen naar VoidWallet als LNbits een killswitch-signaal verzendt. U zult het na een update handmatig moeten inschakelen.",killswitch_interval:"Uitschakelschakelaar-interval",killswitch_interval_desc:"Hoe vaak de achtergrondtaak moet controleren op het LNBits killswitch signaal van de statusbron (in minuten).",enable_watchdog:"Inschakelen Watchdog",enable_watchdog_desc:"Indien ingeschakeld, wordt uw betaalbron automatisch gewijzigd naar VoidWallet als uw saldo lager is dan het saldo van LNbits. U zult dit na een update handmatig moeten inschakelen.",watchdog_interval:"Watchdog-interval",watchdog_interval_desc:"Hoe vaak de achtergrondtaak moet controleren op een killswitch signaal in het watchdog verschil [node_balance - lnbits_balance] (in minuten).",watchdog_delta:"Waakhond Delta",watchdog_delta_desc:"Limiet voordat de killswitch de financieringsbron verandert naar VoidWallet [lnbits_balance - node_balance > delta]",status:"Status",notification_source:"Notificatiebron",notification_source_label:"Bron-URL (gebruik alleen de officiële LNbits-statusbron en bronnen die u vertrouwt)",more:"meer",releases:"Uitgaven",killswitch:"Killswitch",watchdog:"Waakhond",server_logs:"Serverlogboeken",ip_blocker:"IP-blokkering",security:"Beveiliging",security_tools:"Beveiligingstools",block_access_hint:"Toegang blokkeren per IP",allow_access_hint:"Toegang verlenen op basis van IP (zal geblokkeerde IP's overschrijven)",enter_ip:"Voer IP in en druk op enter",rate_limiter:"Snelheidsbegrenzer",number_of_requests:"Aantal verzoeken",time_unit:"Tijdeenheid",minute:"minuut",second:"seconde",hour:"uur",disable_server_log:"Serverlog uitschakelen",enable_server_log:"Activeer Serverlog",coming_soon:"Functie binnenkort beschikbaar",session_has_expired:"Uw sessie is verlopen. Log alstublieft opnieuw in.",instant_access_question:"Wil je directe toegang?",login_with_user_id:"Inloggen met gebruikers-ID",or:"of",create_new_wallet:"Nieuwe portemonnee aanmaken",login_to_account:"Log in op je account",create_account:"Account aanmaken",account_settings:"Accountinstellingen",signin_with_google:"Inloggen met Google",signin_with_github:"Inloggen met GitHub",username_or_email:"Gebruikersnaam of e-mail",password:"Wachtwoord",password_config:"Wachtwoordconfiguratie",password_repeat:"Wachtwoord herhalen",change_password:"Wachtwoord wijzigen",set_password:"Wachtwoord instellen",invalid_password:"Wachtwoord moet ten minste 8 tekens bevatten",login:"Inloggen",register:"Registreren",username:"Gebruikersnaam",user_id:"Gebruikers-ID",email:"E-mail",first_name:"Voornaam",last_name:"Achternaam",picture:"Foto",verify_email:"E-mail verifiëren met",account:"Account",update_account:"Account bijwerken",invalid_username:"Ongeldige gebruikersnaam",auth_provider:"Auth Provider",my_account:"Mijn Account",back:"Terug",logout:"Afmelden"},window.localisation.pi={confirm:"Aye",server:"Cap`n",theme:"Theme",funding:"Funding",users:"Buccaneers",apps:"Arrrrplications",channels:"Channels",transactions:"Pirate Transactions and loot",dashboard:"Arrr-board",node:"Node",total_capacity:"Total Capacity",avg_channel_size:"Avg. Channel Size",biggest_channel_size:"Largest Bilge Size",smallest_channel_size:"Smallest Channel Size",number_of_channels:"Nummer o' Channels",active_channels:"Active Channels",connect_peer:"Connect Peer",connect:"Connect",open_channel:"Open Channel",open:"Open yer hatches",close_channel:"Shut Yer Gob Channel",close:"Batten down the hatches, we be closin",restart:"Arr, restart Cap`n",save:"Bury Treasure",save_tooltip:"Bury yer changes, matey",topup:"Top up the Chest",topup_wallet:"Add more doubloons to the chest",topup_hint:"Use the chest ID to top up any chest",restart_tooltip:"Restart the Cap`n for changes to take effect, arr!",add_funds_tooltip:"Add doubloons to a chest and make it heavier",reset_defaults:"Reset to Davy Jones Locker",reset_defaults_tooltip:"Scuttle all settings and reset to Davy Jones Locker. Aye, start anew!",download_backup:"Download database booty",name_your_wallet:"Name yer %{name} treasure chest",paste_invoice_label:"Paste a booty, payment request or lnurl code, matey!",lnbits_description:"Arr, easy to set up and lightweight, LNbits can run on any lightning-network funding source, currently supporting LND, Core Lightning, OpenNode, Alby, LNPay and even LNbits itself! Ye can run LNbits for yourself, or easily offer a custodian solution for others. Each chest has its own API keys and there be no limit to the number of chests ye can make. Being able to partition booty makes LNbits a useful tool for money management and as a development tool. Arr, extensions add extra functionality to LNbits so ye can experiment with a range of cutting-edge technologies on the lightning network. We have made developing extensions as easy as possible, and as a free and open-source project, we encourage scallywags to develop and submit their own.",export_to_phone:"Export to Phone with QR Code, me hearties",export_to_phone_desc:"This QR code contains yer chest URL with full access. Ye can scan it from yer phone to open yer chest from there, arr!",wallets:"Treasure Chests",add_wallet:"Add a new chest and fill it with doubloons!",delete_wallet:"Scuttle the Chest",delete_wallet_desc:"This whole chest will be scuttled, the booty will be UNRECOVERABLE. Aye, be warned!",rename_wallet:"Rename the Chest, me hearty",update_name:"Update name like a captain",fiat_tracking:"Trackin' o' the treasure",currency:"Curr'nsey",update_currency:"Update doubloons",press_to_claim:"Press to claim gold doubloons, matey!",donate:"Donate like a true pirate!",view_github:"View on GitHub and find treasures",voidwallet_active:"VoidWallet be active! Payments disabled",use_with_caution:"USE WITH CAUTION - %{name} chest be still in BETA. Aye, be careful!",service_fee:"Service fee: %{amount} % per transaction",service_fee_max:"Service fee: %{amount} % per transaction (max %{max} sats)",service_fee_tooltip:"Service fee charged by the LNbits server admin per goin' transaction",toggle_darkmode:"Toggle Dark Mode, arr!",view_swagger_docs:"View LNbits Swagger API docs and learn the secrets",api_docs:"API docs for the scallywags",lnbits_version:"LNbits version, arr!",runs_on:"Runs on, matey",credit_hint:"Press Enter to credit account and make it richer",credit_label:"%{denomination} to credit, arr!",paste:"Stow",paste_from_clipboard:"Paste from clipboard",paste_request:"Paste Request and find treasures",create_invoice:"Create Booty Request and get rich, me hearties!",camera_tooltip:"Use spyglass to scan a booty/QR, arr!",export_csv:"Export to CSV and keep track of the booty",chart_tooltip:"Show ye chart, me hearty",pending:"Pendin like a ship at anchor",copy_invoice:"Copy booty request, arrr",withdraw_from:"Withdraw from",cancel:"Abandon ship! We be retreatin",scan:"Avast! Scan me beauty, arrr",read:"Read it, if ye dare",pay:"Pay up or walk the plank, ye scallywag",memo:"Message in a bottle, argh",date:"Date of the map, me matey",processing_payment:"Processing yer payment... don´t make me say it again",not_enough_funds:"Arrr, ye don´t have enough doubloons! Walk the plank!",search_by_tag_memo_amount:"Search by tag, message, or booty amount, savvy",invoice_waiting:"Invoice waiting to be plundered, arrr",payment_received:"Payment Received like a treasure, argh",payment_sent:"Payment Sent, hoist the colors! We´ve got some doubloons!",receive:"booty",send:"hoist",outgoing_payment_pending:"Outgoing payment pending in the port, ye scurvy dog",drain_funds:"Plunder all the doubloons, ye buccaneer",drain_funds_desc:"This be an LNURL-withdraw QR code for slurpin everything from this wallet. Don`t share with anyone. It be compatible with balanceCheck and balanceNotify so yer wallet may keep pullin` the funds continuously from here after the first withdraw.",i_understand:"I understand, yo ho ho and a bottle of rum!",copy_wallet_url:"Copy wallet URL like a map, savvy",disclaimer_dialog:"Login functionality to be released in a future update, for now, make sure ye bookmark this page for future access to your booty! This service be in BETA, and we hold no responsibility for people losing access to doubloons.",no_transactions:"No transactions made yet, me hearties. Belay that!",manage:"Manage, me hearty",extensions:"Yer Extensions, ye scurvy dog",no_extensions:"Ye don't have any extensions installed, ye scallywag :(. Where be yer loot?",created:"Created like a legend, savvy",search_extensions:"Search fer extensions",warning:"Avast",repository:"Repository",confirm_continue:"Be ye sure ye want t' proceed?",manage_extension_details:"Install/uninstall extension",install:"Set sail",uninstall:"Avaast",drop_db:"Scuttle Data",enable:"Enable",enable_extension_details:"Enable extension fer th' current user",disable:"Disablin'",installed:"Installed",activated:"Activated",deactivated:"Deactivated",release_notes:"Release Notes",activate_extension_details:"Make extension available/unavailable fer users",featured:"Featured",all:"Arr",only_admins_can_install:"(Only admin accounts can install extensions)",admin_only:"Cap'n Only",new_version:"New Version",extension_depends_on:"Depends on:",extension_rating_soon:"Ratings a'comin' soon",extension_installed_version:"Installed version",extension_uninstall_warning:"Ye be about t' remove th' extension fer all hands.",uninstall_confirm:"Aye, Uninstall",extension_db_drop_info:"All data fer th' extension will be permanently deleted. There be no way to undo this operation!",extension_db_drop_warning:"Ye be about to scuttle all data fer th' extension. Please scribble th' extension name to continue:",extension_min_lnbits_version:"This release be needin' at least LNbits version",payment_hash:"Payment Hash like a treasure map, arrr",fee:"Fee like a toll to cross a strait, matey",amount:"Amount of doubloons, arrr",tag:"Tag",unit:"Unit of measurement like a fathom, ye buccaneer",description:"Description like a tale of adventure, arrr",expiry:"Expiry like the food on a ship, ye landlubber",webhook:"Webhook like a fishing line, arrr",payment_proof:"Payment Proof like a seal of authenticity, argh",update_available:"Update %{version} available, me matey!",latest_update:"Ye be on th' latest version %{version}.",notifications:"Notificashuns",no_notifications:"No noticin's",notifications_disabled:"LNbits status notifications be disabled, arr!",enable_notifications:"Enable Notifications",enable_notifications_desc:"If ye be allowin' it, it'll be fetchin' the latest LNbits Status updates, like security incidents and updates.",enable_killswitch:"Enabl' th' Killswitch",enable_killswitch_desc:"If enabled it'll be changin' yer fundin' source to VoidWallet automatically if LNbits sends out a killswitch signal, ye will. Ye'll be needin' t' enable manually after an update, arr.",killswitch_interval:"Killswitch Interval",killswitch_interval_desc:"How oft th' background task should be checkin' fer th' LNBits killswitch signal from th' status source (in minutes).",enable_watchdog:"Enable Seadog",enable_watchdog_desc:"If enabled, it will swap yer treasure source t' VoidWallet on its own if yer balance be lower than th' LNbits balance. Ye'll need t' enable by hand after an update.",watchdog_interval:"Seadog Interval",watchdog_interval_desc:"How oft th' background task should be checkin' fer a killswitch signal in th' seadog delta [node_balance - lnbits_balance] (in minutes), arr.",watchdog_delta:"Seadog Delta",watchdog_delta_desc:"Limit afore killswitch changes fundin' source to VoidWallet [lnbits_balance - node_balance > delta]",status:"Status",notification_source:"Notification Source",notification_source_label:"Source URL (only use th' official LNbits status source, and sources ye can trust)",more:"Arr, 'tis more.",releases:"Releases",killswitch:"Killswitch",watchdog:"Seadog",server_logs:"Server Logs",ip_blocker:"IP Blockar",security:"Securrrity",security_tools:"Securrrity tools",block_access_hint:"Block access by IP",allow_access_hint:"Grant permission by IP (will override barred IPs)",enter_ip:"Enter IP and hit enter",rate_limiter:"Rate Limiter",number_of_requests:"Number o' requests",time_unit:"time bein'",minute:"minnit",second:"second",hour:"hour",disable_server_log:"Disabl' %{Server} Log",enable_server_log:"Enable Server Log",coming_soon:"Feature comin' soon",session_has_expired:"Yer session has expired. Please login again.",instant_access_question:"Be wantin' quick entry, aye?",login_with_user_id:"Login with user ID",or:"arr",create_new_wallet:"Create New Wallet",login_to_account:"Log in to yer account",create_account:"Create account",account_settings:"Account Settin's",signin_with_google:"Sign in wit' Google",signin_with_github:"Sign in wit' GitHub",username_or_email:"Usarrrname or Email",password:"Passwarrd",password_config:"Passwarrd Config",password_repeat:"Passwarrd repeat",change_password:"Change Passwarrd",set_password:"Set yer Secret Code",invalid_password:"Passwarrd must be havin' at leest 8 charrracters",login:"Log in",register:"Sign on",username:"Username",user_id:"User ID",email:"Email",first_name:"Firrrst Name",last_name:"Surname",picture:"pictur'",verify_email:"Verify email with",account:"Arrrccount",update_account:"Updatin' Arrrccount",invalid_username:"Username be not valid, matey!",auth_provider:"Auth Provider becometh Auth Provider, ye see?",my_account:"Me Arrrccount",back:"Return",logout:"Log out yer session"},window.localisation.pl={confirm:"Tak",server:"Serwer",theme:"Motyw",funding:"Finansowanie",users:"Użytkownicy",apps:"Aplikacje",channels:"Kanały",transactions:"Transakcje",dashboard:"Panel kontrolny",node:"Węzeł",total_capacity:"Całkowita Pojemność",avg_channel_size:"Średni rozmiar kanału",biggest_channel_size:"Największy Rozmiar Kanału",smallest_channel_size:"Najmniejszy Rozmiar Kanału",number_of_channels:"Ilość kanałów",active_channels:"Aktywne kanały",connect_peer:"Połącz z węzłem równorzędnym",connect:"Połącz",open_channel:"Otwarty Kanał",open:"Otwórz",close_channel:"Zamknij kanał",close:"Zamknij",restart:"Restart serwera",save:"Zapisz",save_tooltip:"Zapisz zmiany",topup:"Doładowanie",topup_wallet:"Doładuj portfel",topup_hint:"Użyj ID portfela aby go doładować",restart_tooltip:"Zrestartuj serwer aby aktywować zmiany",add_funds_tooltip:"Dodaj środki do portfela.",reset_defaults:"Powrót do ustawień domyślnych",reset_defaults_tooltip:"Wymaż wszystkie ustawienia i ustaw domyślne.",download_backup:"Pobierz kopię zapasową bazy danych",name_your_wallet:"Nazwij swój portfel %{name}",paste_invoice_label:"Wklej fakturę, żądanie zapłaty lub kod lnurl *",lnbits_description:"Łatwy i lekki w konfiguracji, LNbits może działać w oparciu o dowolne źródło finansowania w sieci lightning, obecnie wspiera LND, Core Lightning, OpenNode, Alby, LNPay czy nawet inną instancję LNbits! Możesz uruchomić instancję LNbits dla siebie lub dla innych. Każdy portfel ma swoje klucze API i nie ma ograniczeń jeśli chodzi o ilość portfeli. LNbits umożliwia dzielenie środków w celu zarządzania nimi, jest również dobrym narzędziem deweloperskim. Rozszerzenia zwiększają funkcjonalność LNbits co umożliwia eksperymentowanie z nowym technologiami w sieci lightning. Tworzenie rozszerzeń jest proste dlatego zachęcamy innych deweloperów do tworzenia dodatkowych funkcjonalności i wysyłanie do nas PR",export_to_phone:"Eksport kodu QR na telefon",export_to_phone_desc:"Ten kod QR zawiera adres URL Twojego portfela z pełnym dostępem do niego. Możesz go zeskanować na swoim telefonie aby otworzyć na nim ten portfel.",wallets:"Portfele",add_wallet:"Dodaj portfel",delete_wallet:"Usuń portfel",delete_wallet_desc:"Ten portfel zostanie usunięty, środków na nim zgromadzonych NIE BĘDZIE MOŻNA ODZYSKAĆ.",rename_wallet:"Zmień nazwę portfela",update_name:"Zaktualizuj nazwę",fiat_tracking:"Śledzenie Fiata",currency:"Waluta",update_currency:"Aktualizuj walutę",press_to_claim:"Naciśnij aby odebrać Bitcoiny",donate:"Podaruj",view_github:"Otwórz GitHub",voidwallet_active:"VoidWallet jest aktywny! Płatności są niemożliwe",use_with_caution:"KORZYSTAJ Z ROZWAGĄ - portfel %{name} jest w wersji BETA",service_fee:"Opłata serwisowa: %{amount} % za transakcję",service_fee_max:"Opłata serwisowa: %{amount} % za transakcję (maks %{max} sat)",service_fee_tooltip:"Opłata serwisowa pobierana przez administratora serwera LNbits za każdą wychodzącą transakcję",toggle_darkmode:"Tryb nocny",view_swagger_docs:"Dokumentacja Swagger API",api_docs:"Dokumentacja API",lnbits_version:"Wersja LNbits",runs_on:"Działa na",credit_hint:"Naciśnij Enter aby doładować konto",credit_label:"%{denomination} doładowanie",paste:"Wklej",paste_from_clipboard:"Wklej ze schowka",paste_request:"Wklej żądanie",create_invoice:"Utwórz fakturę",camera_tooltip:"Użyj kamery aby zeskanować fakturę lub kod QR",export_csv:"Eksport do CSV",chart_tooltip:"Wykres",pending:"W toku",copy_invoice:"Skopiuj fakturę",withdraw_from:"Wypłać z",cancel:"Anuluj",scan:"Skanuj",read:"Odczytaj",pay:"Zapłać",memo:"Memo",date:"Data",processing_payment:"Przetwarzam płatność...",not_enough_funds:"Brak wystarczających środków!",search_by_tag_memo_amount:"Szukaj po tagu, memo czy wartości",invoice_waiting:"Faktura oczekuje na zapłatę",payment_received:"Otrzymano płatność",payment_sent:"Wysłano płatność",receive:"odbierać",send:"wysłać",outgoing_payment_pending:"Płatność wychodząca w toku",drain_funds:"Opróżnij środki",drain_funds_desc:"To jest kod QR służący do opróżnienia portfela (LNURL-withdraw). Nie udostępniaj go nikomu. Ten kod jest kompatybilny z funkcjami, które umożliwiają wielokrotne żądania aż do zupełnego opróżnienia portfela.",i_understand:"Rozumiem",copy_wallet_url:"Skopiuj URL portfela",disclaimer_dialog:"Funkcja logowania zostanie uruchomiona w przyszłości. Póki co upewnij się, że zapisałeś adres URL tej strony aby mieć dostęp do tego portfela. Nie udostępniaj adresu tej strony nikomu, kto nie ma mieć do tego portfela dostępu! Ta usługa działa w wersji BETA, nie odpowiadamy za utratę dostępu do środków przez osoby używające LNbits.",no_transactions:"Brak transakcji",manage:"Zarządzaj",extensions:"Rozszerzenia",no_extensions:"Nie masz zainstalowanych żadnych rozszerzeń :(",created:"Utworzono",search_extensions:"Szukaj rozszerzeń",warning:"Ostrzeżenie",repository:"Repozytorium",confirm_continue:"Czy na pewno chcesz kontynuować?",manage_extension_details:"Instaluj/odinstaluj rozszerzenie",install:"Zainstaluj",uninstall:"Odinstaluj",drop_db:"Usuń dane",enable:"Włącz",enable_extension_details:"Włącz rozszerzenie dla aktualnego użytkownika",disable:"Wyłącz",installed:"Zainstalowano",activated:"Aktywowany",deactivated:"Dezaktywowany",release_notes:"Informacje o wydaniu",activate_extension_details:"Udostępnij/nie udostępniaj rozszerzenia użytkownikom",featured:"Polecane",all:"Wszystko",only_admins_can_install:"Tylko konta administratorów mogą instalować rozszerzenia",admin_only:"Tylko dla administratora",new_version:"Nowa wersja",extension_depends_on:"Zależy od:",extension_rating_soon:"Oceny będą dostępne wkrótce",extension_installed_version:"Zainstalowana wersja",extension_uninstall_warning:"Za chwilę usuniesz rozszerzenie dla wszystkich użytkowników.",uninstall_confirm:"Tak, Odinstaluj",extension_db_drop_info:"Wszystkie dane dla rozszerzenia zostaną trwale usunięte. Nie ma sposobu, aby cofnąć tę operację!",extension_db_drop_warning:"Za chwilę usuniesz wszystkie dane dla rozszerzenia. Proszę wpisz nazwę rozszerzenia, aby kontynuować:",extension_min_lnbits_version:"To wymaga przynajmniej wersji LNbits",payment_hash:"Hash Płatności",fee:"Opłata",amount:"Wartość",tag:"Etykieta",unit:"Jednostka",description:"Opis",expiry:"Wygasa",webhook:"Webhook",payment_proof:"Potwierdzenie płatności",update_available:"Aktualizacja %{version} dostępna!",latest_update:"Korzystasz z najnowszej wersji %{version}.",notifications:"Powiadomienia",no_notifications:"Brak powiadomień",notifications_disabled:"Powiadomienia o statusie LNbits są wyłączone.",enable_notifications:"Włącz powiadomienia",enable_notifications_desc:"Jeśli ta opcja zostanie włączona, będzie pobierać najnowsze informacje o statusie LNbits, takie jak incydenty bezpieczeństwa i aktualizacje.",enable_killswitch:"Włącz Killswitch",enable_killswitch_desc:"Jeśli zostanie włączone, automatycznie zmieni źródło finansowania na VoidWallet, jeśli LNbits wyśle sygnał wyłączający. Po aktualizacji będziesz musiał włączyć to ręcznie.",killswitch_interval:"Interwał wyłącznika awaryjnego",killswitch_interval_desc:"Jak często zadanie w tle powinno sprawdzać sygnał wyłącznika awaryjnego LNBits ze źródła statusu (w minutach).",enable_watchdog:"Włącz Watchdog",enable_watchdog_desc:"Jeśli zostanie włączone, automatycznie zmieni źródło finansowania na VoidWallet, jeśli saldo jest niższe niż saldo LNbits. Po aktualizacji trzeba będzie włączyć ręcznie.",watchdog_interval:"Interwał Watchdog",watchdog_interval_desc:"Jak często zadanie w tle powinno sprawdzać sygnał wyłącznika awaryjnego w delcie strażnika [node_balance - lnbits_balance] (w minutach).",watchdog_delta:"Strażnik Delta",watchdog_delta_desc:"Limit przed aktywacją wyłącznika zmienia źródło finansowania na VoidWallet [lnbits_balance - node_balance > delta]",status:"Stan",notification_source:"Źródło powiadomień",notification_source_label:"Adres URL źródła (używaj tylko oficjalnego źródła statusu LNbits oraz źródeł, którym możesz zaufać)",more:"więcej",releases:"Wydania",killswitch:"Killswitch",watchdog:"Pies gończy",server_logs:"Dzienniki serwera",ip_blocker:"Blokada IP",security:"Bezpieczeństwo",security_tools:"Narzędzia bezpieczeństwa",block_access_hint:"Zablokuj dostęp przez IP",allow_access_hint:"Zezwól na dostęp przez IP (zignoruje zablokowane adresy IP)",enter_ip:"Wpisz adres IP i naciśnij enter",rate_limiter:"Ogranicznik Częstotliwości",number_of_requests:"Liczba żądań",time_unit:"Jednostka czasu",minute:"minuta",second:"sekunda",hour:"godzina",disable_server_log:"Wyłącz log serwera",enable_server_log:"Włącz dziennik serwera",coming_soon:"Funkcja wkrótce będzie dostępna",session_has_expired:"Twoja sesja wygasła. Proszę zaloguj się ponownie.",instant_access_question:"Chcesz mieć natychmiastowy dostęp?",login_with_user_id:"Zaloguj się za pomocą identyfikatora użytkownika",or:"lub",create_new_wallet:"Utwórz nowy portfel",login_to_account:"Zaloguj się do swojego konta",create_account:"Załóż konto",account_settings:"Ustawienia konta",signin_with_google:"Zaloguj się przez Google",signin_with_github:"Zaloguj się przez GitHub",username_or_email:"Nazwa użytkownika lub Email",password:"Hasło",password_config:"Konfiguracja Hasła",password_repeat:"Powtórz hasło",change_password:"Zmień hasło",set_password:"Ustaw hasło",invalid_password:"Hasło musi zawierać co najmniej 8 znaków",login:"Logowanie",register:"Zarejestruj",username:"Nazwa użytkownika",user_id:"Identyfikator użytkownika",email:"Email",first_name:"Imię",last_name:"Nazwisko",picture:"Zdjęcie",verify_email:"Zweryfikuj email za pomocą",account:"Konto",update_account:"Aktualizuj konto",invalid_username:"Nieprawidłowa nazwa użytkownika",auth_provider:"Dostawca uwierzytelniania",my_account:"Moje Konto",back:"Wstecz",logout:"Wyloguj"},window.localisation.fr={confirm:"Oui",server:"Serveur",theme:"Thème",funding:"Financement",users:"Utilisateurs",apps:"Applications",channels:"Canaux",transactions:"Transactions",dashboard:"Tableau de bord",node:"Noeud",total_capacity:"Capacité totale",avg_channel_size:"Taille moyenne du canal",biggest_channel_size:"Taille de canal maximale",smallest_channel_size:"Taille de canal la plus petite",number_of_channels:"Nombre de canaux",active_channels:"Canaux actifs",connect_peer:"Connecter un pair",connect:"Connecter",open_channel:"Ouvrir le canal",open:"Ouvrir",close_channel:"Fermer le canal",close:"Fermer",restart:"Redémarrer le serveur",save:"Enregistrer",save_tooltip:"Enregistrer vos modifications",topup:"Renflouer",topup_wallet:"Reflouer un portefeuille",topup_hint:"Utilisez l'ID du portefeuille pour recharger n'importe quel portefeuille",restart_tooltip:"Redémarrez le serveur pour que les changements prennent effet",add_funds_tooltip:"Ajouter des fonds à un portefeuille.",reset_defaults:"Réinitialiser aux valeurs par défaut",reset_defaults_tooltip:"Supprimer tous les paramètres et les réinitialiser aux valeurs par défaut.",download_backup:"Télécharger la sauvegarde de la base de données",name_your_wallet:"Nommez votre portefeuille %{name}",paste_invoice_label:"Coller une facture, une demande de paiement ou un code lnurl *",lnbits_description:"Facile à installer et léger, LNbits peut fonctionner sur n'importe quelle source de financement du réseau Lightning, prenant actuellement en charge LND, Core Lightning, OpenNode, Alby, LNPay et même LNbits lui-même! Vous pouvez exécuter LNbits pour vous-même ou offrir facilement une solution de gardien pour les autres. Chaque portefeuille a ses propres clés API et il n'y a pas de limite au nombre de portefeuilles que vous pouvez créer. La capacité de partitionner les fonds rend LNbits un outil utile pour la gestion de l'argent et comme outil de développement. Les extensions ajoutent une fonctionnalité supplémentaire à LNbits afin que vous puissiez expérimenter une gamme de technologies de pointe sur le réseau Lightning. Nous avons rendu le développement d'extensions aussi simple que possible et, en tant que projet gratuit et open source, nous encourageons les gens à développer et à soumettre les leurs.",export_to_phone:"Exporter vers le téléphone avec un code QR",export_to_phone_desc:"Ce code QR contient l'URL de votre portefeuille avec un accès complet. Vous pouvez le scanner depuis votre téléphone pour ouvrir votre portefeuille depuis là-bas.",wallets:"Portefeuilles",add_wallet:"Ajouter un nouveau portefeuille",delete_wallet:"Supprimer le portefeuille",delete_wallet_desc:"Ce portefeuille entier sera supprimé et les fonds seront IRRECUPERABLES.",rename_wallet:"Renommer le portefeuille",update_name:"Mettre à jour le nom",fiat_tracking:"Suivi Fiat",currency:"Devise",update_currency:"Mettre à jour la devise",press_to_claim:"Appuyez pour demander du Bitcoin",donate:"Donner",view_github:"Voir sur GitHub",voidwallet_active:"VoidWallet est actif! Paiements désactivés",use_with_caution:"UTILISER AVEC PRUDENCE - Le portefeuille %{name} est toujours en version BETA",service_fee:"Frais de service : %{amount} % par transaction",service_fee_max:"Frais de service : %{amount} % par transaction (max %{max} sats)",service_fee_tooltip:"Frais de service facturés par l'administrateur du serveur LNbits pour chaque transaction sortante",toggle_darkmode:"Basculer le mode sombre",view_swagger_docs:"Voir les documents de l'API Swagger de LNbits",api_docs:"Documents de l'API",lnbits_version:"Version de LNbits",runs_on:"Fonctionne sur",credit_hint:"Appuyez sur Entrée pour créditer le compte",credit_label:"%{denomination} à créditer",paste:"Coller",paste_from_clipboard:"Coller depuis le presse-papiers",paste_request:"Coller la requête",create_invoice:"Créer une facture",camera_tooltip:"Utiliser la caméra pour scanner une facture / un code QR",export_csv:"Exporter vers CSV",chart_tooltip:"Afficher le graphique",pending:"En attente",copy_invoice:"Copier la facture",withdraw_from:"Retirer de",cancel:"Annuler",scan:"Scanner",read:"Lire",pay:"Payer",memo:"Mémo",date:"Date",processing_payment:"Traitement du paiement...",not_enough_funds:"Fonds insuffisants !",search_by_tag_memo_amount:"Rechercher par tag, mémo, montant",invoice_waiting:"Facture en attente de paiement",payment_received:"Paiement reçu",payment_sent:"Paiement envoyé",receive:"recevoir",send:"envoyer",outgoing_payment_pending:"Paiement sortant en attente",drain_funds:"Vider les fonds",drain_funds_desc:"Il s'agit d'un code QR LNURL-withdraw pour tout aspirer de ce portefeuille. Ne le partagez avec personne. Il est compatible avec balanceCheck et balanceNotify, de sorte que votre portefeuille peut continuer à retirer les fonds continuellement à partir d'ici après le premier retrait.",i_understand:"J'ai compris",copy_wallet_url:"Copier l'URL du portefeuille",disclaimer_dialog:"La fonctionnalité de connexion sera publiée dans une future mise à jour, pour l'instant, assurez-vous de mettre cette page en favori pour accéder à votre portefeuille ultérieurement ! Ce service est en BETA, et nous ne sommes pas responsables des personnes qui perdent l'accès à leurs fonds.",no_transactions:"Aucune transaction effectuée pour le moment",manage:"Gérer",extensions:"Extensions",no_extensions:"Vous n'avez installé aucune extension :(",created:"Créé",search_extensions:"Rechercher des extensions",warning:"Avertissement",repository:"Référentiel",confirm_continue:"Êtes-vous sûr de vouloir continuer ?",manage_extension_details:"Installer/désinstaller l'extension",install:"Installer",uninstall:"Désinstaller",drop_db:"Supprimer les données",enable:"Activer",enable_extension_details:"Activer l'extension pour l'utilisateur actuel",disable:"Désactiver",installed:"Installé",activated:"Activé",deactivated:"Désactivé",release_notes:"Notes de version",activate_extension_details:"Rendre l'extension disponible/indisponible pour les utilisateurs",featured:"Mis en avant",all:"Tout",only_admins_can_install:"Seuls les comptes administrateurs peuvent installer des extensions",admin_only:"Réservé aux administrateurs",new_version:"Nouvelle version",extension_depends_on:"Dépend de :",extension_rating_soon:"Notes des utilisateurs à venir bientôt",extension_installed_version:"Version installée",extension_uninstall_warning:"Vous êtes sur le point de supprimer l'extension pour tous les utilisateurs.",uninstall_confirm:"Oui, Désinstaller",extension_db_drop_info:"Toutes les données pour l'extension seront supprimées de manière permanente. Il n'est pas possible d'annuler cette opération !",extension_db_drop_warning:"Vous êtes sur le point de supprimer toutes les données de l'extension. Veuillez taper le nom de l'extension pour continuer :",extension_min_lnbits_version:"Cette version nécessite au moins LNbits version",payment_hash:"Hash de paiement",fee:"Frais",amount:"Montant",tag:"Étiqueter",unit:"Unité",description:"Description",expiry:"Expiration",webhook:"Webhook",payment_proof:"Preuve de paiement",update_available:"Mise à jour %{version} disponible !",latest_update:"Vous êtes sur la dernière version %{version}.",notifications:"Notifications",no_notifications:"Aucune notification",notifications_disabled:"Les notifications de statut LNbits sont désactivées.",enable_notifications:"Activer les notifications",enable_notifications_desc:"Si activé, il récupérera les dernières mises à jour du statut LNbits, telles que les incidents de sécurité et les mises à jour.",enable_killswitch:"Activer le Killswitch",enable_killswitch_desc:"Si activé, il changera automatiquement votre source de financement en VoidWallet si LNbits envoie un signal de coupure. Vous devrez activer manuellement après une mise à jour.",killswitch_interval:"Intervalle du Killswitch",killswitch_interval_desc:"À quelle fréquence la tâche de fond doit-elle vérifier le signal d'arrêt d'urgence LNBits provenant de la source de statut (en minutes).",enable_watchdog:"Activer le Watchdog",enable_watchdog_desc:"Si elle est activée, elle changera automatiquement votre source de financement en VoidWallet si votre solde est inférieur au solde LNbits. Vous devrez activer manuellement après une mise à jour.",watchdog_interval:"Intervalle du gardien",watchdog_interval_desc:"À quelle fréquence la tâche en arrière-plan doit-elle vérifier la présence d'un signal d'arrêt d'urgence dans le delta du gardien [node_balance - lnbits_balance] (en minutes).",watchdog_delta:"Chien de garde Delta",watchdog_delta_desc:"Limite avant que l'interrupteur d'arrêt ne change la source de financement pour VoidWallet [lnbits_balance - node_balance > delta]",status:"Statut",notification_source:"Source de notification",notification_source_label:"URL source (utilisez uniquement la source officielle de statut LNbits et des sources de confiance)",more:"plus",releases:"Versions",killswitch:"Interrupteur d'arrêt",watchdog:"Chien de garde",server_logs:"Journaux du serveur",ip_blocker:"Bloqueur d'IP",security:"Sécurité",security_tools:"Outils de sécurité",block_access_hint:"Bloquer l'accès par IP",allow_access_hint:"Autoriser l'accès par IP (cela passera outre les IP bloquées)",enter_ip:"Entrez l'adresse IP et appuyez sur Entrée",rate_limiter:"Limiteur de débit",number_of_requests:"Nombre de requêtes",time_unit:"Unité de temps",minute:"minute",second:"seconde",hour:"heure",disable_server_log:"Désactiver le journal du serveur",enable_server_log:"Activer le journal du serveur",coming_soon:"Fonctionnalité à venir bientôt",session_has_expired:"Votre session a expiré. Veuillez vous reconnecter.",instant_access_question:"Voulez-vous un accès instantané ?",login_with_user_id:"Connexion avec l'identifiant utilisateur",or:"ou",create_new_wallet:"Créer un nouveau portefeuille",login_to_account:"Connectez-vous à votre compte",create_account:"Créer un compte",account_settings:"Paramètres du compte",signin_with_google:"Connectez-vous avec Google",signin_with_github:"Connectez-vous avec GitHub",username_or_email:"Nom d'utilisateur ou e-mail",password:"Mot de passe",password_config:"Configuration du mot de passe",password_repeat:"Répétition du mot de passe",change_password:"Changer le mot de passe",set_password:"Définir le mot de passe",invalid_password:"Le mot de passe doit comporter au moins 8 caractères",login:"Connexion",register:"Inscrire",username:"Nom d'utilisateur",user_id:"Identifiant utilisateur",email:"E-mail",first_name:"Prénom",last_name:"Nom de famille",picture:"Image",verify_email:"Vérifiez l'e-mail avec",account:"Compte",update_account:"Mettre à jour le compte",invalid_username:"Nom d'utilisateur invalide",auth_provider:"Fournisseur d'authentification",my_account:"Mon compte",back:"Retour",logout:"Déconnexion"},window.localisation.nl={confirm:"Ja",server:"Server",theme:"Thema",funding:"Financiering",users:"Gebruikers",apps:"Apps",channels:"Kanalen",transactions:"Transacties",dashboard:"Dashboard",node:"Knooppunt",total_capacity:"Totale capaciteit",avg_channel_size:"Gem. Kanaalgrootte",biggest_channel_size:"Grootste Kanaalgrootte",smallest_channel_size:"Kleinste Kanaalgrootte",number_of_channels:"Aantal kanalen",active_channels:"Actieve Kanalen",connect_peer:"Peer verbinden",connect:"Verbinden",open_channel:"Open Kanaal",open:"Open",close_channel:"Kanaal Sluiten",close:"Sluiten",restart:"Server opnieuw opstarten",save:"Opslaan",save_tooltip:"Sla uw wijzigingen op",topup:"Bijvullen",topup_wallet:"Een portemonnee bijvullen",topup_hint:"Gebruik de portemonnee-ID om elke portemonnee bij te vullen",restart_tooltip:"Start de server opnieuw op zodat wijzigingen van kracht worden",add_funds_tooltip:"Voeg geld toe aan een portemonnee.",reset_defaults:"Standaardinstellingen herstellen",reset_defaults_tooltip:"Wis alle instellingen en herstel de standaardinstellingen.",download_backup:"Databaseback-up downloaden",name_your_wallet:"Geef je %{name} portemonnee een naam",paste_invoice_label:"Plak een factuur, betalingsverzoek of lnurl-code*",lnbits_description:"Gemakkelijk in te stellen en lichtgewicht, LNbits kan op elke lightning-netwerkfinancieringsbron draaien, ondersteunt op dit moment LND, Core Lightning, OpenNode, Alby, LNPay en zelfs LNbits zelf! U kunt LNbits voor uzelf laten draaien of gemakkelijk een bewaardersoplossing voor anderen bieden. Elke portemonnee heeft zijn eigen API-sleutels en er is geen limiet aan het aantal portemonnees dat u kunt maken. Het kunnen partitioneren van fondsen maakt LNbits een nuttige tool voor geldbeheer en als ontwikkelingstool. Extensies voegen extra functionaliteit toe aan LNbits, zodat u kunt experimenteren met een reeks toonaangevende technologieën op het bliksemschichtnetwerk. We hebben het ontwikkelen van extensies zo eenvoudig mogelijk gemaakt en als een gratis en opensource-project moedigen we mensen aan om hun eigen ontwikkelingen in te dienen.",export_to_phone:"Exporteren naar telefoon met QR-code",export_to_phone_desc:"Deze QR-code bevat uw portemonnee-URL met volledige toegang. U kunt het vanaf uw telefoon scannen om uw portemonnee van daaruit te openen.",wallets:"Portemonnees",add_wallet:"Een nieuwe portemonnee toevoegen",delete_wallet:"Portemonnee verwijderen",delete_wallet_desc:"Deze hele portemonnee wordt verwijderd, de fondsen worden NIET TERUGGEVONDEN.",rename_wallet:"Portemonnee hernoemen",update_name:"Naam bijwerken",fiat_tracking:"Volgfunctie voor fiat-valuata",currency:"Valuta",update_currency:"Valuta bijwerken",press_to_claim:"Druk om bitcoin te claimen",donate:"Doneren",view_github:"Bekijken op GitHub",voidwallet_active:"VoidWallet is actief! Betalingen uitgeschakeld",use_with_caution:"GEBRUIK MET VOORZICHTIGHEID - %{name} portemonnee is nog in BETA",service_fee:"Servicekosten: %{amount} % per transactie",service_fee_max:"Servicekosten: %{amount} % per transactie (max %{max} sats)",service_fee_tooltip:"Transactiekosten in rekening gebracht door de LNbits serverbeheerder per uitgaande transactie",toggle_darkmode:"Donkere modus aan/uit",view_swagger_docs:"Bekijk LNbits Swagger API-documentatie",api_docs:"API-documentatie",lnbits_version:"LNbits-versie",runs_on:"Draait op",credit_hint:"Druk op Enter om de rekening te crediteren",credit_label:"%{denomination} te crediteren",paste:"Plakken",paste_from_clipboard:"Plakken van klembord",paste_request:"Verzoek plakken",create_invoice:"Factuur aanmaken",camera_tooltip:"Gebruik de camera om een factuur/QR-code te scannen",export_csv:"Exporteer naar CSV",chart_tooltip:"Toon grafiek",pending:"In behandeling",copy_invoice:"Kopieer factuur",withdraw_from:"Opnemen van",cancel:"Annuleren",scan:"Scannen",read:"Lezen",pay:"Betalen",memo:"Memo",date:"Datum",processing_payment:"Verwerking betaling...",not_enough_funds:"Onvoldoende saldo!",search_by_tag_memo_amount:"Zoeken op tag, memo, bedrag",invoice_waiting:"Factuur wachtend op betaling",payment_received:"Betaling ontvangen",payment_sent:"Betaling verzonden",receive:"ontvangen",send:"versturen",outgoing_payment_pending:"Uitgaande betaling in behandeling",drain_funds:"Geld opnemen",drain_funds_desc:"Dit is een LNURL-withdraw QR-code om alles uit deze portemonnee te halen. Deel deze code niet met anderen. Het is compatibel met balanceCheck en balanceNotify zodat jouw portemonnee continu geld kan blijven opnemen vanaf hier na de eerste opname.",i_understand:"Ik begrijp het",copy_wallet_url:"Kopieer portemonnee-URL",disclaimer_dialog:"Inlogfunctionaliteit wordt uitgebracht in een toekomstige update. Zorg er nu voor dat je deze pagina als favoriet markeert om in de toekomst toegang te krijgen tot je portemonnee! Deze service is in BETA en we zijn niet verantwoordelijk voor mensen die de toegang tot hun fondsen verliezen.",no_transactions:"Er zijn nog geen transacties gedaan",manage:"Beheer",extensions:"Extensies",no_extensions:"Je hebt geen extensies geïnstalleerd :(",created:"Aangemaakt",search_extensions:"Zoekextensies",warning:"Waarschuwing",repository:"Repository",confirm_continue:"Weet je zeker dat je wilt doorgaan?",manage_extension_details:"Installeren/verwijderen van extensie",install:"Installeren",uninstall:"Deïnstalleren",drop_db:"Gegevens verwijderen",enable:"Inschakelen",enable_extension_details:"Schakel extensie in voor huidige gebruiker",disable:"Uitschakelen",installed:"Geïnstalleerd",activated:"Geactiveerd",deactivated:"Gedeactiveerd",release_notes:"Release-opmerkingen",activate_extension_details:"Maak extensie beschikbaar/niet beschikbaar voor gebruikers",featured:"Uitgelicht",all:"Alles",only_admins_can_install:"Alleen beheerdersaccounts kunnen extensies installeren",admin_only:"Alleen beheerder",new_version:"Nieuwe Versie",extension_depends_on:"Afhankelijk van:",extension_rating_soon:"Beoordelingen binnenkort beschikbaar",extension_installed_version:"Geïnstalleerde versie",extension_uninstall_warning:"U staat op het punt de extensie voor alle gebruikers te verwijderen.",uninstall_confirm:"Ja, de-installeren",extension_db_drop_info:"Alle gegevens voor de extensie zullen permanent worden verwijderd. Er is geen manier om deze bewerking ongedaan te maken!",extension_db_drop_warning:"U staat op het punt alle gegevens voor de extensie te verwijderen. Typ de naam van de extensie om door te gaan:",extension_min_lnbits_version:"Deze release vereist ten minste LNbits-versie",payment_hash:"Betalings-hash",fee:"Kosten",amount:"Bedrag",tag:"Label",unit:"Eenheid",description:"Beschrijving",expiry:"Vervaldatum",webhook:"Webhook",payment_proof:"Betalingsbewijs",update_available:"Update %{version} beschikbaar!",latest_update:"U bent op de nieuwste versie %{version}.",notifications:"Meldingen",no_notifications:"Geen meldingen",notifications_disabled:"LNbits-statusmeldingen zijn uitgeschakeld.",enable_notifications:"Schakel meldingen in",enable_notifications_desc:"Indien ingeschakeld zal het de laatste LNbits Status updates ophalen, zoals veiligheidsincidenten en updates.",enable_killswitch:"Activeer Killswitch",enable_killswitch_desc:"Indien ingeschakeld, zal het uw financieringsbron automatisch wijzigen naar VoidWallet als LNbits een killswitch-signaal verzendt. U zult het na een update handmatig moeten inschakelen.",killswitch_interval:"Uitschakelschakelaar-interval",killswitch_interval_desc:"Hoe vaak de achtergrondtaak moet controleren op het LNBits killswitch signaal van de statusbron (in minuten).",enable_watchdog:"Inschakelen Watchdog",enable_watchdog_desc:"Indien ingeschakeld, wordt uw betaalbron automatisch gewijzigd naar VoidWallet als uw saldo lager is dan het saldo van LNbits. U zult dit na een update handmatig moeten inschakelen.",watchdog_interval:"Watchdog-interval",watchdog_interval_desc:"Hoe vaak de achtergrondtaak moet controleren op een killswitch signaal in het watchdog verschil [node_balance - lnbits_balance] (in minuten).",watchdog_delta:"Waakhond Delta",watchdog_delta_desc:"Limiet voordat de killswitch de financieringsbron verandert naar VoidWallet [lnbits_balance - node_balance > delta]",status:"Status",notification_source:"Notificatiebron",notification_source_label:"Bron-URL (gebruik alleen de officiële LNbits-statusbron en bronnen die u vertrouwt)",more:"meer",releases:"Uitgaven",killswitch:"Killswitch",watchdog:"Waakhond",server_logs:"Serverlogboeken",ip_blocker:"IP-blokkering",security:"Beveiliging",security_tools:"Beveiligingstools",block_access_hint:"Toegang blokkeren per IP",allow_access_hint:"Toegang verlenen op basis van IP (zal geblokkeerde IP's overschrijven)",enter_ip:"Voer IP in en druk op enter",rate_limiter:"Snelheidsbegrenzer",number_of_requests:"Aantal verzoeken",time_unit:"Tijdeenheid",minute:"minuut",second:"seconde",hour:"uur",disable_server_log:"Serverlog uitschakelen",enable_server_log:"Activeer Serverlog",coming_soon:"Functie binnenkort beschikbaar",session_has_expired:"Uw sessie is verlopen. Log alstublieft opnieuw in.",instant_access_question:"Wil je directe toegang?",login_with_user_id:"Inloggen met gebruikers-ID",or:"of",create_new_wallet:"Nieuwe portemonnee aanmaken",login_to_account:"Log in op je account",create_account:"Account aanmaken",account_settings:"Accountinstellingen",signin_with_google:"Inloggen met Google",signin_with_github:"Inloggen met GitHub",username_or_email:"Gebruikersnaam of e-mail",password:"Wachtwoord",password_config:"Wachtwoordconfiguratie",password_repeat:"Wachtwoord herhalen",change_password:"Wachtwoord wijzigen",set_password:"Wachtwoord instellen",invalid_password:"Wachtwoord moet ten minste 8 tekens bevatten",login:"Inloggen",register:"Registreren",username:"Gebruikersnaam",user_id:"Gebruikers-ID",email:"E-mail",first_name:"Voornaam",last_name:"Achternaam",picture:"Foto",verify_email:"E-mail verifiëren met",account:"Account",update_account:"Account bijwerken",invalid_username:"Ongeldige gebruikersnaam",auth_provider:"Auth Provider",my_account:"Mijn Account",back:"Terug",logout:"Afmelden"},window.localisation.we={confirm:"Ydw",server:"Gweinydd",theme:"Thema",funding:"Arian fyndio",users:"Defnyddwyr",apps:"Apiau",channels:"Sianelau",transactions:"Trafodion",dashboard:"Panel Gweinyddol",node:"Nod",total_capacity:"Capasiti Cyfanswm",avg_channel_size:"Maint Sianel Cyf.",biggest_channel_size:"Maint Sianel Fwyaf",smallest_channel_size:"Maint Sianel Lleiaf",number_of_channels:"Nifer y Sianeli",active_channels:"Sianeli Gweithredol",connect_peer:"Cysylltu â Chymar",connect:"Cysylltu",open_channel:"Sianel Agored",open:"Agor",close_channel:"Cau Sianel",close:"cau",restart:"Ailgychwyn gweinydd",save:"Save",save_tooltip:"cadw eich newidiadau",topup:"Topup",topup_wallet:"Atodi waled",topup_hint:"Defnyddiwch ID y waled i ychwanegu at unrhyw waled",restart_tooltip:"Ailgychwyn y gweinydd er mwyn i newidiadau ddod i rym",add_funds_tooltip:"Ychwanegu arian at waled.",reset_defaults:"Ailosod i`r rhagosodiadau",reset_defaults_tooltip:"Dileu pob gosodiad ac ailosod i`r rhagosodiadau.",download_backup:"Lawrlwytho copi wrth gefn cronfa ddata",name_your_wallet:"Enwch eich waled %{name}",paste_invoice_label:"Gludwch anfoneb, cais am daliad neu god lnurl *",lnbits_description:"Yn hawdd iw sefydlu ac yn ysgafn, gall LNbits redeg ar unrhyw ffynhonnell ariannu rhwydwaith mellt, ar hyn o bryd yn cefnogi LND, Core Lightning, OpenNode, Alby, LNPay a hyd yn oed LNbits ei hun! Gallwch redeg LNbits i chi`ch hun, neu gynnig datrysiad ceidwad i eraill yn hawdd. Mae gan bob waled ei allweddi API ei hun ac nid oes cyfyngiad ar nifer y waledi y gallwch eu gwneud. Mae gallu rhannu cronfeydd yn gwneud LNbits yn arf defnyddiol ar gyfer rheoli arian ac fel offeryn datblygu. Mae estyniadau yn ychwanegu ymarferoldeb ychwanegol at LNbits fel y gallwch arbrofi gydag ystod o dechnolegau blaengar ar y rhwydwaith mellt. Rydym wedi gwneud datblygu estyniadau mor hawdd â phosibl, ac fel prosiect ffynhonnell agored am ddim, rydym yn annog pobl i ddatblygu a chyflwyno eu rhai eu hunain.",export_to_phone:"Allforio i Ffôn gyda chod QR",export_to_phone_desc:"Mae`r cod QR hwn yn cynnwys URL eich waled gyda mynediad llawn. Gallwch ei sganio o`ch ffôn i agor eich waled oddi yno.",wallets:"Waledi",add_wallet:"Ychwanegu waled newydd",delete_wallet:"Dileu waled",delete_wallet_desc:"Bydd y waled gyfan hon yn cael ei dileu, ni fydd modd adennill yr arian.",rename_wallet:"Ailenwi waled",update_name:"Diweddaru enw",fiat_tracking:"Olrhain Fiat",currency:"Arian Cyfred",update_currency:"Diweddaru arian cyfred",press_to_claim:"Pwyswch i hawlio bitcoin",donate:"Rhoi",view_github:"Gweld ar GitHub",voidwallet_active:" Mae VoidWallet yn weithredol! Taliadau wedi`u hanalluogi",use_with_caution:"DEFNYDDIO GYDA GOFAL - mae waled %{name} yn dal yn BETA",service_fee:"Ffi gwasanaeth: %{amount} % y trafodiad",service_fee_max:"Ffi gwasanaeth: %{amount} % y trafodiad (uchafswm %{max} sats)",service_fee_tooltip:"Ffi gwasanaeth a godir gan weinyddwr gweinydd LNbits ym mhob trafodiad sy'n mynd allan",toggle_darkmode:"Toglo Modd Tywyll",view_swagger_docs:"Gweld dogfennau API LNbits Swagger",api_docs:"API docs",lnbits_version:"Fersiwn LNbits",runs_on:"Yn rhedeg ymlaen",credit_hint:"Pwyswch Enter i gyfrif credyd",credit_label:"%{denomination} i gredyd",paste:"Gludo",paste_from_clipboard:"Gludo o'r clipfwrdd",paste_request:"Gludo Cais",create_invoice:"Creu Anfoneb",camera_tooltip:"Defnyddio camera i sganio anfoneb/QR",export_csv:"Allforio i CSV",chart_tooltip:"Dangos siart",pending:"yn yr arfaeth",copy_invoice:"Copi anfoneb",withdraw_from:"Tynnu oddi ar",cancel:"Canslo",scan:"Sgan",read:"Darllen",pay:"Talu",memo:"Memo",date:"Dyddiad",processing_payment:"Prosesu taliad...",not_enough_funds:"Dim digon o arian!",search_by_tag_memo_amount:"Chwilio yn ôl tag, memo, swm",invoice_waiting:"Anfoneb yn aros i gael ei thalu",payment_received:"Taliad a Dderbyniwyd",payment_sent:"Taliad a Anfonwyd",receive:"derbyn",send:"anfon",outgoing_payment_pending:"Taliad sy`n aros yn yr arfaeth",drain_funds:"Cronfeydd Draenio",drain_funds_desc:"Cod QR Tynnu`n ôl LNURL yw hwn ar gyfer slurpio popeth o`r waled hon. Peidiwch â rhannu gyda neb. Mae`n gydnaws â balanceCheck a balanceNotify felly efallai y bydd eich waled yn tynnu`r arian yn barhaus o`r fan hon ar ôl y codiad cyntaf.",i_understand:"Rwy`n deall",copy_wallet_url:"Copi URL waled",disclaimer_dialog:"Swyddogaeth mewngofnodi i`w ryddhau mewn diweddariad yn y dyfodol, am y tro, gwnewch yn siŵr eich bod yn rhoi nod tudalen ar y dudalen hon ar gyfer mynediad i`ch waled yn y dyfodol! Mae`r gwasanaeth hwn yn BETA, ac nid ydym yn gyfrifol am bobl sy`n colli mynediad at arian.",no_transactions:"Dim trafodion wedi`u gwneud eto",manage:"Rheoli",extensions:"Estyniadau",no_extensions:"Nid oes gennych unrhyw estyniadau wedi'u gosod :(",created:"Crëwyd",search_extensions:"Chwilio estyniadau",warning:"Rhybudd",repository:"Ystorfa",confirm_continue:"Ydych chi'n siŵr eich bod chi eisiau parhau?",manage_extension_details:"Gosod/dadosod estyniad",install:"Gosod",uninstall:"Dadgymhwyso",drop_db:"Dileu Data",enable:"Galluogi",enable_extension_details:"Galluogi estyniad ar gyfer y defnyddiwr presennol",disable:"Analluogi",installed:"Gosodwyd",activated:"Wedi'i actifadu",deactivated:"Anweithredol",release_notes:"Nodiadau Rhyddhau",activate_extension_details:"Gwneud estyniad ar gael/anar gael i ddefnyddwyr",featured:"Nodweddwyd",all:"Pob",only_admins_can_install:"Dim ond cyfrifon gweinyddwr all osod estyniadau",admin_only:"Dim ond Gweinyddwr",new_version:"Fersiwn Newydd",extension_depends_on:"Dibynnu ar:",extension_rating_soon:"Sgôr yn dod yn fuan",extension_installed_version:"Fersiwn wedi'i gosod",extension_uninstall_warning:"Rydych chi ar fin dileu'r estyniad ar gyfer pob defnyddiwr.",uninstall_confirm:"Ie, Dad-osod",extension_db_drop_info:"Bydd yr holl ddata ar gyfer yr estyniad yn cael ei ddileu'n barhaol. Does dim ffordd o dadwneud y weithrediad hwn!",extension_db_drop_warning:"Rydych chi ar fin dileu'r holl ddata ar gyfer yr estyniad. Teipiwch enw'r estyniad i barhau:",extension_min_lnbits_version:"Mae'r rhyddhau hwn yn gofyn o leiaf am fersiwn LNbits",payment_hash:"Hais Taliad",fee:"Fee",amount:"swm",tag:"Tag",unit:"Uned",description:"Disgrifiad",expiry:"dod i ben",webhook:"bachyn we",payment_proof:"prawf taliad",update_available:"Diweddariad %{version} ar gael!",latest_update:"Rydych chi ar y fersiwn diweddaraf %{version}.",notifications:"Hysbysiadau",no_notifications:"Dim hysbysiadau",notifications_disabled:"Hysbysiadau statws LNbits wedi'u analluogi.",enable_notifications:"Galluogi Hysbysiadau",enable_notifications_desc:"Os bydd wedi'i alluogi bydd yn nôl y diweddariadau Statws LNbits diweddaraf, fel digwyddiadau diogelwch a diweddariadau.",enable_killswitch:"Galluogi Killswitch",enable_killswitch_desc:"Os bydd yn galluogi, bydd yn newid eich ffynhonnell arian i VoidWallet yn awtomatig os bydd LNbits yn anfon arwydd killswitch. Bydd angen i chi alluogi â llaw ar ôl diweddariad.",killswitch_interval:"Amlder Cyllell Dorri",killswitch_interval_desc:"Pa mor aml y dylai'r dasg gefndir wirio am signal killswitch LNBits o'r ffynhonnell statws (mewn munudau).",enable_watchdog:"Galluogi Watchdog",enable_watchdog_desc:"Os bydd yn cael ei alluogi bydd yn newid eich ffynhonnell ariannu i VoidWallet yn awtomatig os bydd eich balans yn is na balans LNbits. Bydd angen i chi alluogi â llaw ar ôl diweddariad.",watchdog_interval:"Amserlennu Gwylio",watchdog_interval_desc:"Pa mor aml y dylai'r dasg gefndir wirio am signal torri yn y gwarchodfa delta [node_balance - lnbits_balance] (mewn munudau).",watchdog_delta:"Watchdog Delta",watchdog_delta_desc:"Terfyn cyn i'r switshladd newid ffynhonnell ariannu i VoidWallet [lnbits_balance - node_balance > delta]",status:"Statws",notification_source:"Ffynhonnell Hysbysiad",notification_source_label:"URL Ffynhonnell (defnyddiwch yn unig ffynhonnell statws swyddogol LNbits, a ffynonellau y gallwch ymddiried ynddynt)",more:"mwy",releases:"Rhyddhau",killswitch:"Killswitch",watchdog:"Gwyliwr",server_logs:"Logiau Gweinydd",ip_blocker:"Rheolydd IP",security:"Diogelwch",security_tools:"Offer teclynnau diogelwch",block_access_hint:"Atal mynediad gan IP",allow_access_hint:"Caniatáu mynediad gan IP (bydd yn diystyru IPs sydd wedi'u blocio)",enter_ip:"Rhowch IP a gwasgwch enter",rate_limiter:"Cyfyngydd Cyfradd",number_of_requests:"Nifer y ceisiadau",time_unit:"Uned amser",minute:"munud",second:"ail",hour:"awr",disable_server_log:"Analluogi Log Gweinydd",enable_server_log:"Galluogi Log Gweinydd",coming_soon:"Nodwedd yn dod yn fuan",session_has_expired:"Mae eich sesiwn wedi dod i ben. Mewngofnodwch eto.",instant_access_question:"Eisiau mynediad ar unwaith?",login_with_user_id:"Mewngofnodi gyda ID y defnyddiwr",or:"neu",create_new_wallet:"Creu Waled Newydd",login_to_account:"Mewngofnodwch i'ch cyfrif",create_account:"Creu cyfrif",account_settings:"Gosodiadau Cyfrif",signin_with_google:"Mewngofnodi gyda Google",signin_with_github:"Mewngofnodi gyda GitHub",username_or_email:"Defnyddiwr neu E-bost",password:"Cyfrinair",password_config:"Ffurfweddiad Cyfrinair",password_repeat:"Ailadrodd cyfrinair",change_password:"Newid Cyfrinair",set_password:"Gosod Cyfrinair",invalid_password:"Rhaid i'r cyfrinair gynnwys o leiaf 8 nod.",login:"Mewngofnodi",register:"Cofrestru",username:"Enw defnyddiwr",user_id:"ID Defnyddiwr",email:"E-bost",first_name:"Enw Cyntaf",last_name:"Cyfenw",picture:"Llun",verify_email:"Gwirio e-bost gyda",account:"Cyfrif",update_account:"Diweddaru Cyfrif",invalid_username:"Enw Defnyddiwr Annilys",auth_provider:"Darparwr Dilysiad",my_account:"Fy Nghyfrif",back:"Yn ôl",logout:"Allgofnodi"},window.localisation.pt={confirm:"Sim",server:"Servidor",theme:"Tema",funding:"Financiamento",users:"Usuários",apps:"Aplicativos",channels:"Canais",transactions:"Transações",dashboard:"Painel de Controle",node:"Nó",total_capacity:"Capacidade Total",avg_channel_size:"Tamanho Médio do Canal",biggest_channel_size:"Maior Tamanho do Canal",smallest_channel_size:"Menor Tamanho de Canal",number_of_channels:"Número de Canais",active_channels:"Canais Ativos",connect_peer:"Conectar Par",connect:"Conectar",open_channel:"Canal Aberto",open:"Abrir",close_channel:"Fechar Canal",close:"Fechar",restart:"Reiniciar servidor",save:"Gravar",save_tooltip:"Gravar as alterações",topup:"Reforçar conta",topup_wallet:"Recarregar uma carteira",topup_hint:"Use o ID da carteira para recarregar qualquer carteira",restart_tooltip:"Reinicie o servidor para que as alterações tenham efeito",add_funds_tooltip:"Adicionar fundos a uma carteira.",reset_defaults:"Redefinir para padrões",reset_defaults_tooltip:"Apagar todas as configurações e redefinir para os padrões.",download_backup:"Fazer backup da base de dados",name_your_wallet:"Nomeie sua carteira %{name}",paste_invoice_label:"Cole uma fatura, pedido de pagamento ou código lnurl *",lnbits_description:"Fácil de configurar e leve, o LNbits pode ser executado em qualquer fonte de financiamento da lightning-network, atualmente suportando LND, c-lightning, OpenNode, Alby, LNPay e até mesmo o LNbits em si! Você pode executar o LNbits para si mesmo ou oferecer facilmente uma solução de custódia para outros. Cada carteira tem suas próprias chaves de API e não há limite para o número de carteiras que você pode criar. Ser capaz de particionar fundos torna o LNbits uma ferramenta útil para gerenciamento de dinheiro e como uma ferramenta de desenvolvimento. As extensões adicionam funcionalidades extras ao LNbits para que você possa experimentar uma série de tecnologias de ponta na rede lightning. Nós tornamos o desenvolvimento de extensões o mais fácil possível e, como um projeto gratuito e de código aberto, incentivamos as pessoas a desenvolver e enviar as suas próprias.",export_to_phone:"Exportar para o telefone com código QR",export_to_phone_desc:"Este código QR contém a URL da sua carteira com acesso total. Você pode escaneá-lo do seu telefone para abrir sua carteira a partir dele.",wallets:"Carteiras",add_wallet:"Adicionar nova carteira",delete_wallet:"Excluir carteira",delete_wallet_desc:"Toda a carteira será excluída, os fundos serão IRRECUPERÁVEIS.",rename_wallet:"Renomear carteira",update_name:"Atualizar nome",fiat_tracking:"Rastreamento Fiat",currency:"Moeda",update_currency:"Atualizar moeda",press_to_claim:"Pressione para solicitar bitcoin",donate:"Doar",view_github:"Ver no GitHub",voidwallet_active:"VoidWallet está ativo! Pagamentos desabilitados",use_with_caution:"USE COM CAUTELA - a carteira %{name} ainda está em BETA",service_fee:"Taxa de serviço: %{amount} % por transação",service_fee_max:"Taxa de serviço: %{amount} % por transação (máximo de %{max} sats)",service_fee_tooltip:"Taxa de serviço cobrada pelo administrador do servidor LNbits por transação de saída",toggle_darkmode:"Alternar modo escuro",view_swagger_docs:"Ver a documentação da API do LNbits Swagger",api_docs:"Documentação da API",lnbits_version:"Versão do LNbits",runs_on:"Executa em",credit_hint:"Pressione Enter para creditar a conta",credit_label:"%{denomination} para creditar",paste:"Colar",paste_from_clipboard:"Colar da área de transferência",paste_request:"Colar Pedido",create_invoice:"Criar Fatura",camera_tooltip:"Usar a câmara para escanear uma fatura / QR",export_csv:"Exportar para CSV",chart_tooltip:"Mostrar gráfico",pending:"Pendente",copy_invoice:"Copiar fatura",withdraw_from:"Retirar de",cancel:"Cancelar",scan:"Escanear",read:"Ler",pay:"Pagar",memo:"Memo",date:"Data",processing_payment:"Processando pagamento...",not_enough_funds:"Fundos insuficientes!",search_by_tag_memo_amount:"Pesquisar por tag, memo, quantidade",invoice_waiting:"Fatura aguardando pagamento",payment_received:"Pagamento Recebido",payment_sent:"Pagamento Enviado",receive:"receber",send:"enviar",outgoing_payment_pending:"Pagamento de saída pendente",drain_funds:"Esvasiar carteira",drain_funds_desc:"Este é um código QR de saque LNURL para sacar tudo desta carteira. Não o partilhe com ninguém. É compatível com balanceCheck e balanceNotify para que a sua carteira possa continuar levantando os fundos continuamente daqui após o primeiro saque.",i_understand:"Eu entendo",copy_wallet_url:"Copiar URL da carteira",disclaimer_dialog:"Funcionalidade de login a ser lançada numa atualização futura, por enquanto, certifique-se que marca esta página para acesso futuro à sua carteira! Este serviço está em BETA, e não nos responsabilizamos por pessoas que perderem o acesso aos fundos.",no_transactions:"Ainda não foram feitas transações",manage:"Gerir",extensions:"Extensões",no_extensions:"Não há nenhuma extensão instalada :(",created:"Criado",search_extensions:"Pesquisar extensões",warning:"Aviso",repository:"Repositório",confirm_continue:"Tem certeza de que deseja continuar?",manage_extension_details:"Instalar/desinstalar extensão",install:"Instalar",uninstall:"Desinstalar",drop_db:"Remover Dados",enable:"Ativar",enable_extension_details:"Ativar extensão para o usuário atual",disable:"Desativar",installed:"Instalado",activated:"Ativado",deactivated:"Desativado",release_notes:"Notas de Lançamento",activate_extension_details:"Torne a extensão disponível/indisponível para usuários",featured:"Destacado",all:"Todos",only_admins_can_install:"Apenas contas de administrador podem instalar extensões.",admin_only:"Apenas para administradores",new_version:"Nova Versão",extension_depends_on:"Depende de:",extension_rating_soon:"Avaliações em breve",extension_installed_version:"Versão instalada",extension_uninstall_warning:"Você está prestes a remover a extensão para todos os usuários.",uninstall_confirm:"Sim, Desinstalar",extension_db_drop_info:"Todos os dados da extensão serão permanentemente excluídos. Não há como desfazer essa operação!",extension_db_drop_warning:"Você está prestes a remover todos os dados para a extensão. Por favor, digite o nome da extensão para continuar:",extension_min_lnbits_version:"Esta versão requer pelo menos a versão LNbits",payment_hash:"Hash de pagamento",fee:"Taxa",amount:"Quantidade",tag:"Etiqueta",unit:"Unidade",description:"Descrição",expiry:"Validade",webhook:"Webhook",payment_proof:"Comprovativo de pagamento",update_available:"Atualização %{version} disponível!",latest_update:"Você está na última versão %{version}.",notifications:"Notificações",no_notifications:"Sem notificações",notifications_disabled:"As notificações de status do LNbits estão desativadas.",enable_notifications:"Ativar Notificações",enable_notifications_desc:"Se ativado, ele buscará as últimas atualizações de status do LNbits, como incidentes de segurança e atualizações.",enable_killswitch:"Ativar Killswitch",enable_killswitch_desc:"Se ativado, ele mudará sua fonte de financiamento para VoidWallet automaticamente se o LNbits enviar um sinal de desativação. Você precisará ativar manualmente após uma atualização.",killswitch_interval:"Intervalo do Killswitch",killswitch_interval_desc:"Com que frequência a tarefa de fundo deve verificar o sinal de desativação do LNBits proveniente da fonte de status (em minutos).",enable_watchdog:"Ativar Watchdog",enable_watchdog_desc:"Se ativado, mudará automaticamente a sua fonte de financiamento para VoidWallet caso o seu saldo seja inferior ao saldo LNbits. Você precisará ativar manualmente após uma atualização.",watchdog_interval:"Intervalo do Watchdog",watchdog_interval_desc:"Com que frequência a tarefa de fundo deve verificar um sinal de desligamento no delta do watchdog [node_balance - lnbits_balance] (em minutos).",watchdog_delta:"Observador Delta",watchdog_delta_desc:"Limite antes que o killswitch altere a fonte de financiamento para VoidWallet [lnbits_balance - node_balance > delta]",status:"Estado",notification_source:"Fonte de Notificação",notification_source_label:"URL de Origem (use apenas a fonte oficial de status do LNbits e fontes em que confia)",more:"mais",releases:"Lançamentos",killswitch:"Interruptor de desativação",watchdog:"Cão de guarda",server_logs:"Registros do Servidor",ip_blocker:"Bloqueador de IP",security:"Segurança",security_tools:"Ferramentas de segurança",block_access_hint:"Bloquear acesso por IP",allow_access_hint:"Permitir acesso por IP (substituirá IPs bloqueados)",enter_ip:"Digite o IP e pressione enter.",rate_limiter:"Limitador de Taxa",number_of_requests:"Número de solicitações",time_unit:"Unidade de tempo",minute:"minuto",second:"segundo",hour:"hora",disable_server_log:"Desativar Log do Servidor",enable_server_log:"Ativar Log do Servidor",coming_soon:"Funcionalidade em breve",session_has_expired:"Sua sessão expirou. Por favor, faça login novamente.",instant_access_question:"Quer acesso imediato?",login_with_user_id:"Entrar com ID do usuário",or:"ou",create_new_wallet:"Criar Nova Carteira",login_to_account:"Faça login na sua conta",create_account:"Criar conta",account_settings:"Configurações da Conta",signin_with_google:"Entrar com o Google",signin_with_github:"Entrar com o GitHub",username_or_email:"Nome de usuário ou Email",password:"Senha",password_config:"Configuração de Senha",password_repeat:"Repetição de senha",change_password:"Alterar Senha",set_password:"Definir Senha",invalid_password:"A senha deve ter pelo menos 8 caracteres",login:"Entrar",register:"Registrar",username:"Nome de usuário",user_id:"ID do Usuário",email:"E-mail",first_name:"Nome próprio",last_name:"Sobrenome",picture:"Foto",verify_email:"Verifique o e-mail com",account:"Conta",update_account:"Atualizar Conta",invalid_username:"Nome de usuário inválido",auth_provider:"Provedor de Autenticação",my_account:"Minha Conta",back:"Voltar",logout:"Sair"},window.localisation.br={confirm:"Sim",server:"Servidor",theme:"Tema",funding:"Financiamento",users:"Usuários",apps:"Aplicativos",channels:"Canais",transactions:"Transações",dashboard:"Painel de Controle",node:"Nó",total_capacity:"Capacidade Total",avg_channel_size:"Tamanho médio do canal",biggest_channel_size:"Maior Tamanho de Canal",smallest_channel_size:"Tamanho Mínimo do Canal",number_of_channels:"Número de Canais",active_channels:"Canais Ativos",connect_peer:"Conectar Par",connect:"Conectar",open_channel:"Canal Aberto",open:"Abrir",close_channel:"Fechar Canal",close:"Fechar",restart:"Reiniciar servidor",save:"Salvar",save_tooltip:"Salvar suas alterações",topup:"Recarregar",topup_wallet:"Recarregar uma carteira",topup_hint:"Use o ID da carteira para recarregar qualquer carteira",restart_tooltip:"Reinicie o servidor para que as alterações tenham efeito",add_funds_tooltip:"Adicionar fundos a uma carteira.",reset_defaults:"Redefinir para padrões",reset_defaults_tooltip:"Apagar todas as configurações e redefinir para os padrões.",download_backup:"Fazer backup do banco de dados",name_your_wallet:"Nomeie sua carteira %{name}",paste_invoice_label:"Cole uma fatura, pedido de pagamento ou código lnurl *",lnbits_description:"Fácil de configurar e leve, o LNbits pode ser executado em qualquer fonte de financiamento da lightning-network, atualmente suportando LND, c-lightning, OpenNode, Alby, LNPay e até mesmo o LNbits em si! Você pode executar o LNbits para si mesmo ou oferecer facilmente uma solução de custódia para outros. Cada carteira tem suas próprias chaves de API e não há limite para o número de carteiras que você pode criar. Ser capaz de particionar fundos torna o LNbits uma ferramenta útil para gerenciamento de dinheiro e como uma ferramenta de desenvolvimento. As extensões adicionam funcionalidades extras ao LNbits para que você possa experimentar uma série de tecnologias de ponta na rede lightning. Nós tornamos o desenvolvimento de extensões o mais fácil possível e, como um projeto gratuito e de código aberto, incentivamos as pessoas a desenvolver e enviar as suas próprias.",export_to_phone:"Exportar para o telefone com código QR",export_to_phone_desc:"Este código QR contém a URL da sua carteira com acesso total. Você pode escaneá-lo do seu telefone para abrir sua carteira a partir dele.",wallets:"Carteiras",add_wallet:"Adicionar nova carteira",delete_wallet:"Excluir carteira",delete_wallet_desc:"Toda a carteira será excluída, os fundos serão IRRECUPERÁVEIS.",rename_wallet:"Renomear carteira",update_name:"Atualizar nome",fiat_tracking:"Rastreamento Fiat",currency:"Moeda",update_currency:"Atualizar moeda",press_to_claim:"Pressione para solicitar bitcoin",donate:"Doar",view_github:"Ver no GitHub",voidwallet_active:"VoidWallet está ativo! Pagamentos desabilitados",use_with_caution:"USE COM CAUTELA - a carteira %{name} ainda está em BETA",service_fee:"Taxa de serviço: %{amount} % por transação",service_fee_max:"Taxa de serviço: %{amount} % por transação (máx %{max} sats)",service_fee_tooltip:"Taxa de serviço cobrada pelo administrador do servidor LNbits por transação de saída",toggle_darkmode:"Alternar modo escuro",view_swagger_docs:"Ver a documentação da API do LNbits Swagger",api_docs:"Documentação da API",lnbits_version:"Versão do LNbits",runs_on:"Executa em",credit_hint:"Pressione Enter para creditar a conta",credit_label:"%{denomination} para creditar",paste:"Colar",paste_from_clipboard:"Cole do clipboard",paste_request:"Colar Pedido",create_invoice:"Criar Fatura",camera_tooltip:"Usar a câmara para escanear uma fatura / QR",export_csv:"Exportar para CSV",chart_tooltip:"Mostrar gráfico",pending:"Pendente",copy_invoice:"Copiar fatura",withdraw_from:"Sacar de",cancel:"Cancelar",scan:"Escanear",read:"Ler",pay:"Pagar",memo:"Memo",date:"Data",processing_payment:"Processando pagamento...",not_enough_funds:"Fundos insuficientes!",search_by_tag_memo_amount:"Pesquisar por tag, memo, quantidade",invoice_waiting:"Fatura aguardando pagamento",payment_received:"Pagamento Recebido",payment_sent:"Pagamento Enviado",receive:"receber",send:"enviar",outgoing_payment_pending:"Pagamento pendente de saída",drain_funds:"Drenar Fundos",drain_funds_desc:"Este é um código QR de retirada do LNURL para sugar tudo desta carteira. Não compartilhe com ninguém. É compatível com balanceCheck e balanceNotify para que sua carteira possa continuar retirando os fundos continuamente daqui após a primeira retirada.",i_understand:"Eu entendo",copy_wallet_url:"Copiar URL da carteira",disclaimer_dialog:"Funcionalidade de login a ser lançada em uma atualização futura, por enquanto, certifique-se de marcar esta página para acesso futuro à sua carteira! Este serviço está em BETA, e não nos responsabilizamos por pessoas que perderem o acesso aos fundos.",no_transactions:"Ainda não foram feitas transações",manage:"Gerenciar",extensions:"Extensões",no_extensions:"Você não possui nenhuma extensão instalada :(",created:"Criado",search_extensions:"Extensões de pesquisa",warning:"Aviso",repository:"Repositório",confirm_continue:"Você tem certeza de que deseja continuar?",manage_extension_details:"Instalar/desinstalar extensão",install:"Instalar",uninstall:"Desinstalar",drop_db:"Remover Dados",enable:"Ativar",enable_extension_details:"Ativar extensão para o usuário atual",disable:"Desativar",installed:"Instalado",activated:"Ativado",deactivated:"Desativado",release_notes:"Notas de Lançamento",activate_extension_details:"Tornar a extensão disponível/indisponível para usuários",featured:"Destacado",all:"Tudo",only_admins_can_install:"Apenas contas de administrador podem instalar extensões.",admin_only:"Apenas para Administração",new_version:"Nova Versão",extension_depends_on:"Depende de:",extension_rating_soon:"Avaliações estarão disponíveis em breve",extension_installed_version:"Versão instalada",extension_uninstall_warning:"Você está prestes a remover a extensão para todos os usuários.",uninstall_confirm:"Sim, Desinstalar",extension_db_drop_info:"Todos os dados da extensão serão permanentemente excluídos. Não há como desfazer essa operação!",extension_db_drop_warning:"Você está prestes a remover todos os dados para a extensão. Por favor, digite o nome da extensão para continuar:",extension_min_lnbits_version:"Esta versão requer no mínimo a versão do LNbits",payment_hash:"Hash de pagamento",fee:"Taxa",amount:"Quantidade",tag:"Etiqueta",unit:"Unidade",description:"Descrição",expiry:"Validade",webhook:"Webhook",payment_proof:"Comprovante de pagamento",update_available:"Atualização %{version} disponível!",latest_update:"Você está na versão mais recente %{version}.",notifications:"Notificações",no_notifications:"Sem notificações",notifications_disabled:"As notificações de status do LNbits estão desativadas.",enable_notifications:"Ativar notificações",enable_notifications_desc:"Se ativado, ele buscará as últimas atualizações de status do LNbits, como incidentes de segurança e atualizações.",enable_killswitch:"Ativar Killswitch",enable_killswitch_desc:"Se ativado, mudará sua fonte de fundos para VoidWallet automaticamente se o LNbits enviar um sinal de desativação. Você precisará ativar manualmente após uma atualização.",killswitch_interval:"Intervalo do Killswitch",killswitch_interval_desc:"Com que frequência a tarefa de fundo deve verificar o sinal de desativação do LNBits proveniente da fonte de status (em minutos).",enable_watchdog:"Ativar Watchdog",enable_watchdog_desc:"Se ativado, ele mudará automaticamente sua fonte de financiamento para VoidWallet se o seu saldo for inferior ao saldo do LNbits. Você precisará ativar manualmente após uma atualização.",watchdog_interval:"Intervalo do Watchdog",watchdog_interval_desc:"Com que frequência a tarefa de fundo deve verificar um sinal de interrupção no delta do monitor [node_balance - lnbits_balance] (em minutos).",watchdog_delta:"Observador Delta",watchdog_delta_desc:"Limite antes da mudança do mecanismo de segurança alterar a fonte de financiamento para VoidWallet [lnbits_balance - node_balance > delta]",status:"Estado",notification_source:"Fonte de Notificação",notification_source_label:"URL de origem (use apenas a fonte de status oficial do LNbits e fontes de confiança)",more:"mais",releases:"Lançamentos",killswitch:"Dispositivo de desativação",watchdog:"Cão de guarda",server_logs:"Registros do Servidor",ip_blocker:"Bloqueador de IP",security:"Segurança",security_tools:"Ferramentas de segurança",block_access_hint:"Bloquear acesso por IP",allow_access_hint:"Permitir acesso por IP (substituirá os IPs bloqueados)",enter_ip:"Digite o IP e pressione enter",rate_limiter:"Limitador de Taxa",number_of_requests:"Número de solicitações",time_unit:"Unidade de tempo",minute:"minuto",second:"segundo",hour:"hora",disable_server_log:"Desativar Log do Servidor",enable_server_log:"Ativar Registro do Servidor",coming_soon:"Funcionalidade em breve",session_has_expired:"Sua sessão expirou. Por favor, faça login novamente.",instant_access_question:"Quer acesso imediato?",login_with_user_id:"Faça login com ID do usuário",or:"ou",create_new_wallet:"Criar Nova Carteira",login_to_account:"Faça login na sua conta",create_account:"Criar conta",account_settings:"Configurações da Conta",signin_with_google:"Entrar com o Google",signin_with_github:"Entrar com GitHub",username_or_email:"Nome de usuário ou E-mail",password:"Senha",password_config:"Configuração de Senha",password_repeat:"Repetição de senha",change_password:"Alterar Senha",set_password:"Definir Senha",invalid_password:"A senha deve ter pelo menos 8 caracteres",login:"Entrar",register:"Registrar",username:"Nome de usuário",user_id:"ID do Usuário",email:"E-mail",first_name:"Primeiro Nome",last_name:"Sobrenome",picture:"Foto",verify_email:"Verifique o e-mail com",account:"Conta",update_account:"Atualizar Conta",invalid_username:"Nome de usuário inválido",auth_provider:"Provedor de Autenticação",my_account:"Minha Conta",back:"Voltar",logout:"Sair"},window.localisation.cs={confirm:"Ano",server:"Server",theme:"Téma",funding:"Financování",users:"Uživatelé",apps:"Aplikace",channels:"Kanály",transactions:"Transakce",dashboard:"Přehled",node:"Uzel",total_capacity:"Celková kapacita",avg_channel_size:"Průmerná velikost kanálu",biggest_channel_size:"Největší velikost kanálu",smallest_channel_size:"Nejmenší velikost kanálu",number_of_channels:"Počet kanálů",active_channels:"Aktivní kanály",connect_peer:"Připojit peer",connect:"Připojit",open_channel:"Otevřít kanál",open:"Otevřít",close_channel:"Zavřít kanál",close:"Zavřít",restart:"Restartovat server",save:"Uložit",save_tooltip:"Uložit změny",topup:"Dobít",topup_wallet:"Dobít peněženku",topup_hint:"Použijte ID peněženky pro dobíjení jakékoliv peněženky",restart_tooltip:"Restartujte server pro aplikaci změn",add_funds_tooltip:"Přidat prostředky do peněženky.",reset_defaults:"Obnovit výchozí",reset_defaults_tooltip:"Smazat všechna nastavení a obnovit výchozí.",download_backup:"Stáhnout zálohu databáze",name_your_wallet:"Pojmenujte svou %{name} peněženku",paste_invoice_label:"Vložte fakturu, platební požadavek nebo lnurl kód *",lnbits_description:"Snadno nastavitelný a lehkotonážní, LNbits může běžet na jakémkoliv zdroji financování lightning-network, v současné době podporuje LND, Core Lightning, OpenNode, Alby, LNPay a dokonce LNbits samotné! LNbits můžete provozovat pro sebe, nebo snadno nabízet správu peněženek pro ostatní. Každá peněženka má své vlastní API klíče a není omezen počet peněženek, které můžete vytvořit. Možnost rozdělení prostředků dělá z LNbits užitečný nástroj pro správu peněz a jako vývojový nástroj. Rozšíření přidávají extra funkčnost k LNbits, takže můžete experimentovat s řadou špičkových technologií na lightning network. Vývoj rozšíření jsme učinili co nejjednodušší a jako svobodný a open-source projekt podporujeme lidi ve vývoji a zasílání vlastních rozšíření.",export_to_phone:"Exportovat do telefonu pomocí QR kódu",export_to_phone_desc:"Tento QR kód obsahuje URL vaší peněženky s plným přístupem. Můžete jej naskenovat z telefonu a otevřít peněženku odtamtud.",wallets:"Peněženky",add_wallet:"Přidat novou peněženku",delete_wallet:"Smazat peněženku",delete_wallet_desc:"Celá peněženka bude smazána, prostředky budou NEOBNOVITELNÉ.",rename_wallet:"Přejmenovat peněženku",update_name:"Aktualizovat název",fiat_tracking:"Sledování fiatu",currency:"Měna",update_currency:"Aktualizovat měnu",press_to_claim:"Stiskněte pro nárokování bitcoinu",donate:"Darovat",view_github:"Zobrazit na GitHubu",voidwallet_active:"VoidWallet je aktivní! Platby zakázány",use_with_caution:"POUŽÍVEJTE S OBEZŘETNOSTÍ - %{name} peněženka je stále v BETĚ",service_fee:"Servisný poplatek: %{amount} % za transakci",service_fee_max:"Servisný poplatek: %{amount} % za transakci (max %{max} satoshi)",service_fee_tooltip:"Servisní poplatek účtovaný správcem LNbits serveru za odchozí transakci",toggle_darkmode:"Přepnout tmavý režim",view_swagger_docs:"Zobrazit LNbits Swagger API dokumentaci",api_docs:"API dokumentace",lnbits_version:"Verze LNbits",runs_on:"Běží na",credit_hint:"Stiskněte Enter pro připsání na účet",credit_label:"%{denomination} k připsání",paste:"Vložit",paste_from_clipboard:"Vložit ze schránky",paste_request:"Vložit požadavek",create_invoice:"Vytvořit fakturu",camera_tooltip:"Použijte kameru pro skenování faktury/QR",export_csv:"Exportovat do CSV",chart_tooltip:"Zobrazit graf",pending:"Čeká na vyřízení",copy_invoice:"Kopírovat fakturu",withdraw_from:"Vybrat z",cancel:"Zrušit",scan:"Skenovat",read:"Číst",pay:"Platit",memo:"Poznámka",date:"Datum",processing_payment:"Zpracování platby...",not_enough_funds:"Nedostatek prostředků!",search_by_tag_memo_amount:"Hledat podle tagu, poznámky, částky",invoice_waiting:"Faktura čeká na platbu",payment_received:"Platba přijata",payment_sent:"Platba odeslána",receive:"přijmout",send:"odeslat",outgoing_payment_pending:"Odchozí platba čeká na vyřízení",drain_funds:"Vyčerpat prostředky",drain_funds_desc:"Toto je LNURL-withdraw QR kód pro vyčerpání všeho z této peněženky. Nesdílejte s nikým. Je kompatibilní s balanceCheck a balanceNotify, takže vaše peněženka může kontinuálně čerpat prostředky odsud po prvním výběru.",i_understand:"Rozumím",copy_wallet_url:"Kopírovat URL peněženky",disclaimer_dialog:"Funkcionalita přihlášení bude vydána v budoucí aktualizaci, zatím si ujistěte, že jste si tuto stránku uložili do záložek pro budoucí přístup k vaší peněžence! Tato služba je v BETA verzi a nepřebíráme žádnou zodpovědnost za ztrátu přístupu k prostředkům.",no_transactions:"Zatím žádné transakce",manage:"Spravovat",extensions:"Rozšíření",no_extensions:"Nemáte nainstalováno žádné rozšíření :(",created:"Vytvořeno",search_extensions:"Hledat rozšíření",warning:"Varování",repository:"Repositář",confirm_continue:"Jste si jistí, že chcete pokračovat?",manage_extension_details:"Instalovat/odinstalovat rozšíření",install:"Instalovat",uninstall:"Odinstalovat",drop_db:"Odstranit data",enable:"Povolit",enable_extension_details:"Povolit rozšíření pro aktuálního uživatele",disable:"Zakázat",installed:"Nainstalováno",activated:"Aktivováno",deactivated:"Deaktivováno",release_notes:"Poznámky k vydání",activate_extension_details:"Zpřístupnit/zakázat rozšíření pro uživatele",featured:"Doporučené",all:"Vše",only_admins_can_install:"(Pouze administrátorské účty mohou instalovat rozšíření)",admin_only:"Pouze pro adminy",new_version:"Nová verze",extension_depends_on:"Závisí na:",extension_rating_soon:"Hodnocení brzy dostupné",extension_installed_version:"Nainstalovaná verze",extension_uninstall_warning:"Chystáte se odstranit rozšíření pro všechny uživatele.",uninstall_confirm:"Ano, odinstalovat",extension_db_drop_info:"Všechna data pro rozšíření budou trvale odstraněna. Tuto operaci nelze vrátit zpět!",extension_db_drop_warning:"Chystáte se odstranit všechna data pro rozšíření. Prosím, pokračujte zadáním názvu rozšíření:",extension_min_lnbits_version:"Toto vydání vyžaduje alespoň verzi LNbits",payment_hash:"Hash platby",fee:"Poplatek",amount:"Částka",tag:"Tag",unit:"Jednotka",description:"Popis",expiry:"Expirace",webhook:"Webhook",payment_proof:"Důkaz platby",update_available:"Dostupná aktualizace %{version}!",latest_update:"Máte nejnovější verzi %{version}.",notifications:"Notifikace",no_notifications:"Žádné notifikace",notifications_disabled:"Notifikace stavu LNbits jsou zakázány.",enable_notifications:"Povolit notifikace",enable_notifications_desc:"Pokud je povoleno, bude stahovat nejnovější aktualizace stavu LNbits, jako jsou bezpečnostní incidenty a aktualizace.",enable_killswitch:"Povolit Killswitch",enable_killswitch_desc:"Pokud je povoleno, automaticky změní zdroj financování na VoidWallet pokud LNbits odešle signál killswitch. Po aktualizaci budete muset povolit ručně.",killswitch_interval:"Interval Killswitch",killswitch_interval_desc:"Jak často by měl úkol na pozadí kontrolovat signál killswitch od LNBits ze zdroje stavu (v minutách).",enable_watchdog:"Povolit Watchdog",enable_watchdog_desc:"Pokud je povoleno, automaticky změní zdroj financování na VoidWallet pokud je váš zůstatek nižší než zůstatek LNbits. Po aktualizaci budete muset povolit ručně.",watchdog_interval:"Interval Watchdog",watchdog_interval_desc:"Jak často by měl úkol na pozadí kontrolovat signál killswitch v watchdog delta [node_balance - lnbits_balance] (v minutách).",watchdog_delta:"Delta Watchdog",watchdog_delta_desc:"Limit předtím, než killswitch změní zdroj financování na VoidWallet [lnbits_balance - node_balance > delta]",status:"Stav",notification_source:"Zdroj notifikací",notification_source_label:"URL zdroje (používejte pouze oficiální zdroj stavu LNbits a zdroje, kterým můžete věřit)",more:"více",releases:"Vydání",killswitch:"Killswitch",watchdog:"Watchdog",server_logs:"Logy serveru",ip_blocker:"Blokování IP",security:"Bezpečnost",security_tools:"Nástroje bezpečnosti",block_access_hint:"Blokovat přístup podle IP",allow_access_hint:"Povolit přístup podle IP (přepíše blokované IP)",enter_ip:"Zadejte IP a stiskněte enter",rate_limiter:"Omezovač počtu požadavků",number_of_requests:"Počet požadavků",time_unit:"Časová jednotka",minute:"minuta",second:"sekunda",hour:"hodina",disable_server_log:"Zakázat log serveru",enable_server_log:"Povolit log serveru",coming_soon:"Funkce brzy dostupná",session_has_expired:"Vaše relace vypršela. Prosím, přihlašte se znovu.",instant_access_question:"Chcete okamžitý přístup?",login_with_user_id:"Přihlásit se s uživatelským ID",or:"nebo",create_new_wallet:"Vytvořit novou peněženku",login_to_account:"Přihlaste se ke svému účtu",create_account:"Vytvořit účet",account_settings:"Nastavení účtu",signin_with_google:"Přihlásit se přes Google",signin_with_github:"Přihlásit se přes GitHub",username_or_email:"Uživatelské jméno nebo Email",password:"Heslo",password_config:"Konfigurace hesla",password_repeat:"Opakujte heslo",change_password:"Změnit heslo",set_password:"Nastavit heslo",invalid_password:"Heslo musí mít alespoň 8 znaků",login:"Přihlášení",register:"Registrovat",username:"Uživatelské jméno",user_id:"ID uživatele",email:"Email",first_name:"Křestní jméno",last_name:"Příjmení",picture:"Obrázek",verify_email:"Ověřte e-mail s",account:"Účet",update_account:"Aktualizovat účet",invalid_username:"Neplatné uživatelské jméno",auth_provider:"Poskytovatel ověření",my_account:"Můj účet",back:"Zpět",logout:"Odhlásit se"},window.localisation.sk={confirm:"Áno",server:"Server",theme:"Téma",funding:"Financovanie",users:"Používatelia",apps:"Aplikácie",channels:"Kanály",transactions:"Transakcie",dashboard:"Prehľad",node:"Uzol",total_capacity:"Celková kapacita",avg_channel_size:"Priemerná veľkosť kanálu",biggest_channel_size:"Najväčší kanál",smallest_channel_size:"Najmenší kanál",number_of_channels:"Počet kanálov",active_channels:"Aktívne kanály",connect_peer:"Pripojiť peer",connect:"Pripojiť",open_channel:"Otvoriť kanál",open:"Otvoriť",close_channel:"Zatvoriť kanál",close:"Zatvoriť",restart:"Reštartovať server",save:"Uložiť",save_tooltip:"Uložiť vaše zmeny",topup:"Doplniť",topup_wallet:"Doplniť peňaženku",topup_hint:"Použite ID peňaženky na doplnenie ľubovoľnej peňaženky",restart_tooltip:"Pre prejavenie zmien reštartujte server",add_funds_tooltip:"Pridať prostriedky do peňaženky.",reset_defaults:"Obnoviť predvolené",reset_defaults_tooltip:"Odstrániť všetky nastavenia a obnoviť predvolené.",download_backup:"Stiahnuť zálohu databázy",name_your_wallet:"Pomenujte vašu %{name} peňaženku",paste_invoice_label:"Vložte faktúru, platobnú požiadavku alebo lnurl kód *",lnbits_description:"Ľahko nastaviteľný a ľahkotonážny, LNbits môže bežať na akomkoľvek zdroji financovania lightning-network, momentálne podporuje LND, Core Lightning, OpenNode, Alby, LNPay a dokonca LNbits samotný! LNbits môžete používať pre seba, alebo ľahko ponúknuť správcovské riešenie pre iných. Každá peňaženka má svoje vlastné API kľúče a nie je limit na počet peňaženiek, ktoré môžete vytvoriť. Schopnosť rozdeľovať finančné prostriedky robí z LNbits užitočný nástroj pre správu peňazí a ako vývojový nástroj. Rozšírenia pridávajú extra funkčnosť do LNbits, takže môžete experimentovať s radou najnovších technológií na lightning sieti. Vývoj rozšírení sme urobili čo najjednoduchší a ako voľný a open-source projekt, podporujeme ľudí vývoj a odovzdávanie vlastných rozšírení.",export_to_phone:"Exportovať do telefónu s QR kódom",export_to_phone_desc:"Tento QR kód obsahuje URL vašej peňaženky s plným prístupom. Môžete ho naskenovať z vášho telefónu a otvoriť vašu peňaženku odtiaľ.",wallets:"Peňaženky",add_wallet:"Pridať novú peňaženku",delete_wallet:"Zmazať peňaženku",delete_wallet_desc:"Celá peňaženka bude zmazaná, prostriedky budú NEOBNOVITEĽNÉ.",rename_wallet:"Premenovať peňaženku",update_name:"Aktualizovať meno",fiat_tracking:"Sledovanie fiat",currency:"Mena",update_currency:"Aktualizovať menu",press_to_claim:"Stlačte pre nárok na bitcoin",donate:"Prispieť",view_github:"Zobraziť na GitHube",voidwallet_active:"VoidWallet je aktívny! Platby zakázané",use_with_caution:"POUŽÍVAJTE OPATRNE - %{name} peňaženka je stále v BETE",service_fee:"Servisný poplatok: %{amount} % za transakciu",service_fee_max:"Servisný poplatok: %{amount} % za transakciu (max %{max} satoshi)",service_fee_tooltip:"Servisný poplatok účtovaný správcom LNbits servera za odchádzajúcu transakciu",toggle_darkmode:"Prepnúť Tmavý režim",view_swagger_docs:"Zobraziť LNbits Swagger API dokumentáciu",api_docs:"API dokumentácia",lnbits_version:"Verzia LNbits",runs_on:"Beží na",credit_hint:"Stlačte Enter pre pripísanie na účet",credit_label:"%{denomination} na pripísanie",paste:"Vložiť",paste_from_clipboard:"Vložiť zo schránky",paste_request:"Vložiť požiadavku",create_invoice:"Vytvoriť faktúru",camera_tooltip:"Použite kameru na naskenovanie faktúry/QR",export_csv:"Exportovať do CSV",chart_tooltip:"Zobraziť graf",pending:"Čakajúce",copy_invoice:"Kopírovať faktúru",withdraw_from:"Vybrať z",cancel:"Zrušiť",scan:"Skenovať",read:"Čítať",pay:"Platiť",memo:"Poznámka",date:"Dátum",processing_payment:"Spracovávanie platby...",not_enough_funds:"Nedostatok prostriedkov!",search_by_tag_memo_amount:"Vyhľadať podľa značky, poznámky, sumy",invoice_waiting:"Faktúra čakajúca na zaplatenie",payment_received:"Platba prijatá",payment_sent:"Platba odoslaná",receive:"prijímať",send:"posielať",outgoing_payment_pending:"Odchádzajúca platba čaká",drain_funds:"Vyprázdniť prostriedky",drain_funds_desc:"Toto je LNURL-withdraw QR kód pre vyprázdnienie všetkého z tejto peňaženky. S nikým ho nezdieľajte. Je kompatibilný s balanceCheck a balanceNotify, takže vaša peňaženka môže naďalej kontinuálne vyťahovať prostriedky odtiaľto po prvom výbere.",i_understand:"Rozumiem",copy_wallet_url:"Kopírovať URL peňaženky",disclaimer_dialog:"Funkcionalita prihlásenia bude vydaná v budúcej aktualizácii, zatiaľ si uistite, že ste si túto stránku pridali medzi záložky pre budúci prístup k vašej peňaženke! Táto služba je v BETA verzii a nenesieme zodpovednosť za stratu prístupu k prostriedkom.",no_transactions:"Zatiaľ žiadne transakcie",manage:"Spravovať",extensions:"Rozšírenia",no_extensions:"Nemáte nainštalované žiadne rozšírenia :(",created:"Vytvorené",search_extensions:"Hľadať rozšírenia",warning:"Upozornenie",repository:"Repozitár",confirm_continue:"Ste si istí, že chcete pokračovať?",manage_extension_details:"Inštalovať/odinštalovať rozšírenie",install:"Inštalovať",uninstall:"Odinštalovať",drop_db:"Odstrániť údaje",enable:"Povoliť",enable_extension_details:"Povoliť rozšírenie pre aktuálneho používateľa",disable:"Zakázať",installed:"Nainštalované",activated:"Aktivované",deactivated:"Deaktivované",release_notes:"Poznámky k vydaniu",activate_extension_details:"Sprístupniť/neprístupniť rozšírenie pre používateľov",featured:"Odporúčané",all:"Všetky",only_admins_can_install:"(Iba administrátorské účty môžu inštalovať rozšírenia)",admin_only:"Iba pre administrátorov",new_version:"Nová verzia",extension_depends_on:"Závisí na:",extension_rating_soon:"Hodnotenia budú čoskoro dostupné",extension_installed_version:"Nainštalovaná verzia",extension_uninstall_warning:"Chystáte sa odstrániť rozšírenie pre všetkých používateľov.",uninstall_confirm:"Áno, Odinštalovať",extension_db_drop_info:"Všetky údaje pre rozšírenie budú trvalo vymazané. Túto operáciu nie je možné vrátiť!",extension_db_drop_warning:"Chystáte sa odstrániť všetky údaje pre rozšírenie. Pre pokračovanie prosím napíšte názov rozšírenia:",extension_min_lnbits_version:"Toto vydanie vyžaduje aspoň verziu LNbits",payment_hash:"Hash platby",fee:"Poplatok",amount:"Suma",tag:"Tag",unit:"Jednotka",description:"Popis",expiry:"Expirácia",webhook:"Webhook",payment_proof:"Dôkaz platby",update_available:"Dostupná aktualizácia %{version}!",latest_update:"Máte najnovšiu verziu %{version}.",notifications:"Notifikácie",no_notifications:"Žiadne notifikácie",notifications_disabled:"Notifikácie stavu LNbits sú zakázané.",enable_notifications:"Povoliť Notifikácie",enable_notifications_desc:"Ak povolené, budú sa načítavať najnovšie aktualizácie stavu LNbits, ako sú bezpečnostné incidenty a aktualizácie.",enable_killswitch:"Povoliť Killswitch",enable_killswitch_desc:"Ak povolené, vaš zdroj financovania sa automaticky zmení na VoidWallet, ak LNbits vysielajú signál killswitch. Po aktualizácii bude treba povoliť manuálne.",killswitch_interval:"Interval Killswitch",killswitch_interval_desc:"Ako často by malo pozadie kontrolovať signál killswitch od LNbits zo zdroja stavu (v minútach).",enable_watchdog:"Povoliť Watchdog",enable_watchdog_desc:"Ak povolené, vaš zdroj financovania sa automaticky zmení na VoidWallet, ak je váš zostatok nižší ako zostatok LNbits. Po aktualizácii bude treba povoliť manuálne.",watchdog_interval:"Interval Watchdog",watchdog_interval_desc:"Ako často by malo pozadie kontrolovať signál killswitch v watchdog delta [node_balance - lnbits_balance] (v minútach).",watchdog_delta:"Delta Watchdog",watchdog_delta_desc:"Limit pred zmenou zdroja financovania na VoidWallet [lnbits_balance - node_balance > delta]",status:"Stav",notification_source:"Zdroj notifikácií",notification_source_label:"URL zdroja (používajte len oficiálny LNbits zdroj stavu a zdroje, ktorým môžete dôverovať)",more:"viac",releases:"Vydania",killswitch:"Killswitch",watchdog:"Watchdog",server_logs:"Logy servera",ip_blocker:"Blokovanie IP",security:"Bezpečnosť",security_tools:"Nástroje bezpečnosti",block_access_hint:"Blokovať prístup podľa IP",allow_access_hint:"Povoliť prístup podľa IP (prebije blokované IP)",enter_ip:"Zadajte IP a stlačte enter",rate_limiter:"Obmedzovač počtu požiadaviek",number_of_requests:"Počet požiadaviek",time_unit:"Časová jednotka",minute:"minúta",second:"sekunda",hour:"hodina",disable_server_log:"Zakázať Log servera",enable_server_log:"Povoliť Log servera",coming_soon:"Funkcia bude čoskoro dostupná",session_has_expired:"Vaša relácia vypršala. Prosím, prihláste sa znova.",instant_access_question:"Chcete okamžitý prístup?",login_with_user_id:"Prihlásiť sa s používateľským ID",or:"alebo",create_new_wallet:"Vytvoriť novú peňaženku",login_to_account:"Prihláste sa do vášho účtu",create_account:"Vytvoriť účet",account_settings:"Nastavenia účtu",signin_with_google:"Prihlásiť sa cez Google",signin_with_github:"Prihláste sa pomocou GitHub",username_or_email:"Používateľské meno alebo email",password:"Heslo",password_config:"Konfigurácia hesla",password_repeat:"Opakovanie hesla",change_password:"Zmeniť heslo",set_password:"Nastaviť heslo",invalid_password:"Heslo musí mať aspoň 8 znakov",login:"Prihlásenie",register:"Registrovať",username:"Používateľské meno",user_id:"ID používateľa",email:"Email",first_name:"Meno",last_name:"Priezvisko",picture:"Obrázok",verify_email:"Overiť e-mail s",account:"Účet",update_account:"Aktualizovať účet",invalid_username:"Neplatné užívateľské meno",auth_provider:"Poskytovateľ autentifikácie",my_account:"Môj účet",back:"Späť",logout:"Odhlásiť sa"},window.localisation.kr={confirm:"확인",server:"서버",theme:"테마",funding:"자금",users:"사용자",apps:"앱",channels:"채널",transactions:"거래 내역",dashboard:"현황판",node:"노드",total_capacity:"총 용량",avg_channel_size:"평균 채널 용량",biggest_channel_size:"가장 큰 채널 용량",smallest_channel_size:"가장 작은 채널 용량",number_of_channels:"채널 수",active_channels:"활성화된 채널",connect_peer:"피어 연결하기",connect:"연결하기",open_channel:"채널 개설하기",open:"개설",close_channel:"채널 폐쇄하기",close:"폐쇄",restart:"서버 재시작",save:"저장",save_tooltip:"변경 사항 저장",topup:"자금 추가",topup_wallet:"지갑에 자금 추가",topup_hint:"자금을 추가할 지갑의 ID를 넣어주세요",restart_tooltip:"변경 사항을 적용하려면 서버를 재시작해야 합니다.",add_funds_tooltip:"지갑에 자금을 추가합니다.",reset_defaults:"기본 설정으로 돌아가기",reset_defaults_tooltip:"설정했던 내용들을 모두 지우고, 기본 설정으로 돌아갑니다.",download_backup:"데이터베이스 백업 다운로드",name_your_wallet:"사용할 %{name}지갑의 이름을 정하세요",paste_invoice_label:"인보이스, 결제 요청, 혹은 lnurl 코드를 붙여넣으세요 *",lnbits_description:"설정이 쉽고 가벼운 LNBits는 어떤 라이트닝 네트워크의 예산 자원 위에서든 돌아갈 수 있습니다. 현재 지원하는 예산 자원의 형태는 LND, Core Lightning, OpenNode, Alby, LNPay, 그리고 다른 LNBits 지갑들입니다. 스스로 사용하기 위해, 또는 다른 사람들에게 수탁형 솔루션을 제공하기 위해 LNBits를 운영할 수 있습니다. 각 지갑들은 자신만의 API key를 가지며, 생성 가능한 지갑의 수에는 제한이 없습니다. 자금을 분할할 수 있는 기능으로 인해, LNBits는 자금 운영 도구로써뿐만 아니라 개발 도구로써도 유용합니다. 확장 기능들은 LNBits에 여러분들이 라이트닝 네트워크의 다양한 최신 기술들을 수행해볼 수 있게 하는 추가 기능을 제공합니다. LNBits 개발진들은 확장 기능들의 개발 또한 가능한 쉽게 만들었으며, 무료 오픈 소스 프로젝트답게 사람들이 자신만의 확장 기능들을 개발하고 제출하기를 응원합니다.",export_to_phone:"QR 코드를 이용해 모바일 기기로 내보내기",export_to_phone_desc:"이 QR 코드는 선택된 지갑의 최대 접근 권한을 가진 전체 URL을 담고 있습니다. 스캔 후, 모바일 기기에서 지갑을 열 수 있습니다.",wallets:"지갑",add_wallet:"새로운 지갑을 추가합니다",delete_wallet:"지갑을 삭제합니다",delete_wallet_desc:"이 지갑은 삭제될 것이며, 삭제 시 지갑 내 자금은 복구가 불가능합니다.",rename_wallet:"지갑 이름 변경",update_name:"이름 변경하기",fiat_tracking:"법정통화 가격 표시",currency:"통화",update_currency:"통화 수정하기",press_to_claim:"비트코인을 수령하려면 눌러주세요",donate:"기부",view_github:"GitHub 페이지 보기",voidwallet_active:"VoidWallet이 활성화되었습니다! 결제가 불가능합니다.",use_with_caution:"주의하세요 - %{name} 지갑은 아직 BETA 단계입니다.",service_fee:"서비스 수수료: 거래액의 %{amount} %",service_fee_max:"서비스 수수료: 거래액의 %{amount} % (최대 %{max} sats)",service_fee_tooltip:"지불 결제 시마다 LNBits 서버 관리자에게 납부되는 서비스 수수료",toggle_darkmode:"다크 모드 전환",view_swagger_docs:"LNbits Swagger API 문서를 봅니다",api_docs:"API 문서",lnbits_version:"LNbits 버전",runs_on:"Runs on",credit_hint:"계정에 자금을 넣으려면 Enter를 눌러주세요",credit_label:"%{denomination} 단위로 충전하기",paste:"붙여넣기",paste_from_clipboard:"클립보드에서 붙여넣기",paste_request:"지불 요청 붙여넣기",create_invoice:"인보이스 생성하기",camera_tooltip:"카메라를 이용해서 인보이스/QR을 스캔하세요",export_csv:"CSV 형태로 내보내기",chart_tooltip:"그래프로 보여주기",pending:"대기 중",copy_invoice:"인보이스 복사하기",withdraw_from:"출금",cancel:"취소",scan:"스캔",read:"분석하기",pay:"지불하기",memo:"Memo",date:"일시",processing_payment:"결제 처리 중...",not_enough_funds:"자금이 부족합니다!",search_by_tag_memo_amount:"태그, memo, 수량으로 검색하기",invoice_waiting:"결제를 기다리는 인보이스",payment_received:"받은 결제액",payment_sent:"보낸 결제액",receive:"받기",send:"보내기",outgoing_payment_pending:"지불 대기 중",drain_funds:"자금 비우기",drain_funds_desc:"이는 선택된 지갑으로부터 모든 자금을 인출하는 LNURL-withdraw QR 코드입니다. 그 누구와도 공유하지 마세요. balanceCheck 및 balanceNotify 기능과 호환되며, 당신의 지갑은 첫 출금 이후로도 계속 자금을 끌어당기고 있을 수 있습니다.",i_understand:"이해하였습니다",copy_wallet_url:"지갑 URL 복사하기",disclaimer_dialog:"로그인 기능은 향후 업데이트를 통해 지원될 계획이지만, 현재로써는 이 페이지에 향후 다시 접속하기 위해 북마크 설정하는 것을 잊지 마세요! 이 서비스는 아직 BETA 과정에 있고, LNbits 개발자들은 자금 손실에 대해 전혀 책임을 지지 않습니다.",no_transactions:"아직 아무런 거래도 이루어지지 않았습니다",manage:"관리",extensions:"확장 기능",no_extensions:"아직 설치된 확장 기능들이 없네요 :(",created:"생성됨",search_extensions:"확장 기능 검색하기",warning:"주의",repository:"저장소",confirm_continue:"정말로 계속할까요?",manage_extension_details:"확장 기능 설치/삭제하기",install:"설치",uninstall:"삭제",drop_db:"데이터 삭제",enable:"활성화",enable_extension_details:"현재 사용자 계정에 해당 확장 기능을 활성화합니다",disable:"비활성화",installed:"설치됨",activated:"작동됨",deactivated:"작동 중지",release_notes:"배포 노트",activate_extension_details:"사용자들의 확장 기능 사용 가능 여부를 결정합니다",featured:"추천",all:"전체",only_admins_can_install:"(관리자 계정만이 확장 기능을 설치할 수 있습니다)",admin_only:"관리자 전용",new_version:"새로운 버전",extension_depends_on:"의존성 존재:",extension_rating_soon:"평점 기능도 곧 구현됩니다",extension_installed_version:"설치된 버전",extension_uninstall_warning:"모든 사용자들로부터 이 확장 기능을 제거한다는 점에 유의하세요.",uninstall_confirm:"네, 삭제합니다",extension_db_drop_info:"해당 확장 기능의 모든 데이터가 영구적으로 삭제됩니다. 작업 수행 후에는 되돌릴 수 없습니다!",extension_db_drop_warning:"해당 확장 기능의 모든 데이터가 영구적으로 삭제될 겁니다. 계속하려면 확장 기능의 이름을 입력해주세요:",extension_min_lnbits_version:"이 배포 버전은 더 높은 버전의 lnbits가 설치되어 있어야 합니다.",payment_hash:"결제 해쉬값",fee:"수수료",amount:"액수",tag:"태그",unit:"단위",description:"상세",expiry:"만료",webhook:"Webhook",payment_proof:"Payment 증거",update_available:"%{version}으로 업데이트가 가능합니다.",latest_update:"이미 %{version} 버전으로 업데이트되었습니다.",notifications:"알림",no_notifications:"알림 없음",notifications_disabled:"LNbits 상태 알림이 비활성화되었습니다.",enable_notifications:"알림 활성화",enable_notifications_desc:"활성화 시, 가장 최신의 보안 사고나 소프트웨어 업데이트 등의 LNbits 상황 업데이트를 불러옵니다.",enable_killswitch:"비상 정지 활성화",enable_killswitch_desc:"활성화 시, LNbits 메인 서버에서 비상 정지 신호를 보내면 자동으로 자금의 원천을 VoidWallet으로 변경합니다. 업데이트 이후 수동으로 활성화해 주어야 합니다.",killswitch_interval:"비상 정지 시간 간격",killswitch_interval_desc:"LNbits 메인 서버에서 나오는 비상 정지 신호를 백그라운드 작업으로 얼마나 자주 확인할 것인지를 결정합니다. (분 단위)",enable_watchdog:"와치독 활성화",enable_watchdog_desc:"활성화 시, LNbits 잔금보다 당신의 잔금이 지정한 수준보다 더 낮아질 경우 자동으로 자금의 원천을 VoidWallet으로 변경합니다. 업데이트 이후 수동으로 활성화해 주어야 합니다.",watchdog_interval:"와치독 시간 간격",watchdog_interval_desc:"와치독 델타 값을 기반으로 하여 당신의 LNbits 서버에서 나오는 비상 정지 신호를 백그라운드 작업으로 얼마나 자주 확인할 것인지를 결정합니다. (분 단위)",watchdog_delta:"와치독 델타",watchdog_delta_desc:"당신의 자금 원천을 VoidWallet으로 변경하기까지의 기준 값 [LNbits 잔액 - 노드 잔액 > 델타 값]",status:"상황",notification_source:"알림 메세지 출처",notification_source_label:"알림 메세지를 가져올 URL (공식 LNbits 상황판 출처나, 당신이 신뢰할 수 있는 출처만을 사용하세요)",more:"더 알아보기",releases:"배포 버전들",killswitch:"비상 정지",watchdog:"와치독",server_logs:"서버 로그",ip_blocker:"IP 기반 차단기",security:"보안",security_tools:"보안 도구들",block_access_hint:"IP 기준으로 접속 차단하기",allow_access_hint:"IP 기준으로 접속 허용하기 (차단한 IP들을 무시합니다)",enter_ip:"IP 주소를 입력하고 Enter를 눌러주세요",rate_limiter:"횟수로 제한하기",number_of_requests:"요청 횟수",time_unit:"시간 단위",minute:"분",second:"초",hour:"시간",disable_server_log:"서버 로깅 중단하기",enable_server_log:"서버 로깅 활성화하기",coming_soon:"곧 구현될 기능들입니다",session_has_expired:"세션 유효 기간이 만료되었습니다. 다시 로그인해 주세요.",instant_access_question:"즉시 액세스하시겠습니까?",login_with_user_id:"사용자 ID로 로그인",or:"또는",create_new_wallet:"새 지갑 만들기",login_to_account:"계정에 로그인하세요.",create_account:"계정 생성",account_settings:"계정 설정",signin_with_google:"Google으로 로그인",signin_with_github:"GitHub으로 로그인",username_or_email:"사용자 이름 또는 이메일",password:"비밀번호",password_config:"비밀번호 설정",password_repeat:"비밀번호 재입력",change_password:"비밀번호 변경",set_password:"비밀번호 설정",invalid_password:"비밀번호는 최소 8자 이상이어야 합니다",login:"로그인",register:"등록",username:"사용자 이름",user_id:"사용자 ID",email:"이메일",first_name:"성명",last_name:"성",picture:"사진",verify_email:"이메일을 인증하려면",account:"계정",update_account:"계정 업데이트",invalid_username:"잘못된 사용자 이름",auth_provider:"인증 제공자",my_account:"내 계정",back:"뒤로",logout:"로그아웃"},Vue.use(VueI18n),window.LOCALE="en",window.i18n=new VueI18n({locale:window.LOCALE,fallbackLocale:window.LOCALE,messages:window.localisation}),window.EventHub=new Vue,window.LNbits={api:{request:function(e,t,n,i){return axios({method:e,url:t,headers:{"X-Api-Key":n},data:i})},createInvoice:async function(e,t,n,i="sat",r=null){return this.request("post","/api/v1/payments",e.inkey,{out:!1,amount:t,memo:n,unit:i,lnurl_callback:r})},payInvoice:function(e,t){return this.request("post","/api/v1/payments",e.adminkey,{out:!0,bolt11:t})},payLnurl:function(e,t,n,i,r="",o=""){return this.request("post","/api/v1/payments/lnurl",e.adminkey,{callback:t,description_hash:n,amount:i,comment:o,description:r})},authLnurl:function(e,t){return this.request("post","/api/v1/lnurlauth",e.adminkey,{callback:t})},createAccount:function(e){return this.request("post","/api/v1/account",null,{name:e})},register:function(e,t,n,i){return axios({method:"POST",url:"/api/v1/auth/register",data:{username:e,email:t,password:n,password_repeat:i}})},login:function(e,t){return axios({method:"POST",url:"/api/v1/auth",data:{username:e,password:t}})},loginUsr:function(e){return axios({method:"POST",url:"/api/v1/auth/usr",data:{usr:e}})},logout:function(){return axios({method:"POST",url:"/api/v1/auth/logout"})},getAuthenticatedUser:function(){return this.request("get","/api/v1/auth")},getWallet:function(e){return this.request("get","/api/v1/wallet",e.inkey)},createWallet:function(e,t){return this.request("post","/api/v1/wallet",e.adminkey,{name:t}).then((e=>{window.location="/wallet?wal="+e.data.id}))},updateWallet:function(e,t){return this.request("patch","/api/v1/wallet",t.adminkey,{name:e})},deleteWallet:function(e){return this.request("delete","/api/v1/wallet",e.adminkey).then((e=>{let t=new URL(window.location.href);t.searchParams.delete("wal"),window.location=t}))},getPayments:function(e,t){const n=new URLSearchParams(t);return this.request("get","/api/v1/payments/paginated?"+n,e.inkey)},getPayment:function(e,t){return this.request("get","/api/v1/payments/"+t,e.inkey)}},events:{onInvoicePaid:function(e,t){let n=e=>{t(JSON.parse(e.data))};return this.listenersCount=this.listenersCount||{[e.inkey]:0},this.listenersCount[e.inkey]++,this.listeners=this.listeners||{},e.inkey in this.listeners||(this.listeners[e.inkey]=new EventSource("/api/v1/payments/sse?api-key="+e.inkey)),this.listeners[e.inkey].addEventListener("payment-received",n),()=>{this.listeners[e.inkey].removeEventListener("payment-received",n),this.listenersCount[e.inkey]--,this.listenersCount[e.inkey]<=0&&(this.listeners[e.inkey].close(),delete this.listeners[e.inkey])}}},map:{extension:function(e){var t=_.object(["code","isValid","isAdminOnly","name","shortDescription","tile","contributors","hidden"],e);return t.url=["/",t.code,"/"].join(""),t},user:function(e){var t={id:e.id,admin:e.admin,email:e.email,extensions:e.extensions,wallets:e.wallets,admin:e.admin},n=this.wallet;return t.wallets=t.wallets.map((function(e){return n(e)})).sort((function(e,t){return e.name.localeCompare(t.name)})),t.walletOptions=t.wallets.map((function(e){return{label:[e.name," - ",e.id].join(""),value:e.id}})),t},wallet:function(e){return newWallet={id:e.id,name:e.name,adminkey:e.adminkey,inkey:e.inkey,currency:e.currency},newWallet.msat=e.balance_msat,newWallet.sat=Math.floor(e.balance_msat/1e3),newWallet.fsat=new Intl.NumberFormat(window.LOCALE).format(newWallet.sat),newWallet.url=`/wallet?&wal=${e.id}`,newWallet},payment:function(e){return obj={checking_id:e.checking_id,pending:e.pending,amount:e.amount,fee:e.fee,memo:e.memo,time:e.time,bolt11:e.bolt11,preimage:e.preimage,payment_hash:e.payment_hash,expiry:e.expiry,extra:e.extra,wallet_id:e.wallet_id,webhook:e.webhook,webhook_status:e.webhook_status,fiat_amount:e.fiat_amount,fiat_currency:e.fiat_currency},obj.date=Quasar.utils.date.formatDate(new Date(1e3*obj.time),"YYYY-MM-DD HH:mm"),obj.dateFrom=moment(obj.date).fromNow(),obj.expirydate=Quasar.utils.date.formatDate(new Date(1e3*obj.expiry),"YYYY-MM-DD HH:mm"),obj.expirydateFrom=moment(obj.expirydate).fromNow(),obj.msat=obj.amount,obj.sat=obj.msat/1e3,obj.tag=obj.extra?.tag,obj.fsat=new Intl.NumberFormat(window.LOCALE).format(obj.sat),obj.isIn=obj.amount>0,obj.isOut=obj.amount<0,obj.isPaid=!obj.pending,obj._q=[obj.memo,obj.sat].join(" ").toLowerCase(),obj}},utils:{confirmDialog:function(e){return Quasar.plugins.Dialog.create({message:e,ok:{flat:!0,color:"orange"},cancel:{flat:!0,color:"grey"}})},digestMessage:async function(e){const t=(new TextEncoder).encode(e),n=await crypto.subtle.digest("SHA-256",t);return Array.from(new Uint8Array(n)).map((e=>e.toString(16).padStart(2,"0"))).join("")},formatCurrency:function(e,t){return new Intl.NumberFormat(window.LOCALE,{style:"currency",currency:t}).format(e)},formatSat:function(e){return new Intl.NumberFormat(window.LOCALE).format(e)},formatMsat:function(e){return this.formatSat(e/1e3)},notifyApiError:function(e){Quasar.plugins.Notify.create({timeout:5e3,type:{400:"warning",401:"warning",500:"negative"}[e.response.status]||"warning",message:e.response.data.message||e.response.data.detail||null,caption:[e.response.status," ",e.response.statusText].join("").toUpperCase()||null,icon:null})},search:function(e,t,n,i){try{var r=t.toLowerCase().split(i||" ");return e.filter((function(e){var t=0;return _.each(r,(function(i){-1!==e[n].indexOf(i)&&t++})),t===r.length}))}catch(t){return e}},exportCSV:function(e,t,n){var i=function(e,t){var n=void 0!==t?t(e):e;return`"${n=(n=null==n?"":String(n)).split('"').join('""')}"`},r=[e.map((function(e){return i(e.label)}))].concat(t.map((function(t){return e.map((function(e){return i("function"==typeof e.field?e.field(t):t[void 0===e.field?e.name:e.field],e.format)})).join(",")}))).join("\r\n");!0!==Quasar.utils.exportFile(`${n||"table-export"}.csv`,r,"text/csv")&&Quasar.plugins.Notify.create({message:"Browser denied file download...",color:"negative",icon:null})},convertMarkdown(e){const t=new showdown.Converter;return t.setFlavor("github"),t.setOption("simpleLineBreaks",!0),t.makeHtml(e)}}},window.windowMixin={i18n:window.i18n,data:function(){return{toggleSubs:!0,isUserAuthorized:!1,g:{offline:!navigator.onLine,visibleDrawer:!1,extensions:[],user:null,wallet:null,payments:[],allowedThemes:null,langs:[]}}},methods:{activeLanguage:function(e){return window.i18n.locale===e},changeLanguage:function(e){window.i18n.locale=e,this.$q.localStorage.set("lnbits.lang",e)},changeColor:function(e){document.body.setAttribute("data-theme",e),this.$q.localStorage.set("lnbits.theme",e)},toggleDarkMode:function(){this.$q.dark.toggle(),this.$q.localStorage.set("lnbits.darkMode",this.$q.dark.isActive)},copyText:function(e,t,n){var i=this.$q.notify;Quasar.utils.copyToClipboard(e).then((function(){i({message:t||"Copied to clipboard!",position:n||"bottom"})}))},checkUsrInUrl:async function(){try{const e=new URLSearchParams(window.location.search),t=e.get("usr");if(!t)return;this.isUserAuthorized||await LNbits.api.loginUsr(t),e.delete("usr");const n=e.size?`?${e.toString()}`:"";window.history.replaceState({},document.title,window.location.pathname+n)}finally{this.isUserAuthorized=!!this.$q.cookies.get("is_lnbits_user_authorized")}},logout:async function(){LNbits.utils.confirmDialog('Do you really want to logout? Please visit "My Account" page to check your credentials!').onOk((async()=>{try{await LNbits.api.logout(),window.location="/"}catch(e){LNbits.utils.notifyApiError(e)}}))}},created:async function(){1==this.$q.localStorage.getItem("lnbits.darkMode")||0==this.$q.localStorage.getItem("lnbits.darkMode")?this.$q.dark.set(this.$q.localStorage.getItem("lnbits.darkMode")):this.$q.dark.set(!0),this.g.allowedThemes=window.allowedThemes??["bitcoin"];let e=this.$q.localStorage.getItem("lnbits.lang");if(e&&(window.LOCALE=e,window.i18n.locale=e),this.g.langs=window.langs??[],addEventListener("offline",(e=>{this.g.offline=!0})),addEventListener("online",(e=>{this.g.offline=!1})),this.$q.localStorage.getItem("lnbits.theme")||this.changeColor(this.g.allowedThemes[0]),this.$q.localStorage.getItem("lnbits.theme")&&!this.g.allowedThemes.includes(this.$q.localStorage.getItem("lnbits.theme"))&&this.changeColor(this.g.allowedThemes[0]),this.$q.localStorage.getItem("lnbits.theme")&&document.body.setAttribute("data-theme",this.$q.localStorage.getItem("lnbits.theme")),window.user&&(this.g.user=Object.freeze(window.LNbits.map.user(window.user))),window.wallet&&(this.g.wallet=Object.freeze(window.LNbits.map.wallet(window.wallet))),window.extensions){var t=this.g.user;const e=Object.freeze(window.extensions.map((function(e){return window.LNbits.map.extension(e)})).filter((function(e){return!e.hidden})).filter((function(e){return window.user?.admin?e:!e.isAdminOnly})).map((function(e){return e.isEnabled=!!t&&-1!==t.extensions.indexOf(e.code),e})).sort((function(e,t){const n=e.name.toUpperCase(),i=t.name.toUpperCase();return n<i?-1:n>i?1:0})));this.g.extensions=e}await this.checkUsrInUrl()}},window.decryptLnurlPayAES=function(e,t){let n=new Uint8Array(t.match(/[\da-f]{2}/gi).map((e=>parseInt(e,16))));return crypto.subtle.importKey("raw",n,{name:"AES-CBC",length:256},!1,["decrypt"]).then((t=>{let n=Uint8Array.from(window.atob(e.iv),(e=>e.charCodeAt(0))),i=Uint8Array.from(window.atob(e.ciphertext),(e=>e.charCodeAt(0)));return crypto.subtle.decrypt({name:"AES-CBC",iv:n},t,i)})).then((e=>new TextDecoder("utf-8").decode(e)))},Vue.component("lnbits-fsat",{props:{amount:{type:Number,default:0}},template:"<span>{{ fsat }}</span>",computed:{fsat:function(){return LNbits.utils.formatSat(this.amount)}}}),Vue.component("lnbits-wallet-list",{data:function(){return{user:null,activeWallet:null,activeBalance:[],showForm:!1,walletName:"",LNBITS_DENOMINATION:LNBITS_DENOMINATION}},template:'\n    <q-list v-if="user && user.wallets.length" dense class="lnbits-drawer__q-list">\n      <q-item-label header v-text="$t(\'wallets\')"></q-item-label>\n      <q-item v-for="wallet in wallets" :key="wallet.id"\n        clickable\n        :active="activeWallet && activeWallet.id === wallet.id"\n        tag="a" :href="wallet.url">\n        <q-item-section side>\n          <q-avatar size="md"\n            :color="(activeWallet && activeWallet.id === wallet.id)\n              ? (($q.dark.isActive) ? \'primary\' : \'primary\')\n              : \'grey-5\'">\n            <q-icon name="flash_on" :size="($q.dark.isActive) ? \'21px\' : \'20px\'"\n              :color="($q.dark.isActive) ? \'blue-grey-10\' : \'grey-3\'"></q-icon>\n          </q-avatar>\n        </q-item-section>\n        <q-item-section>\n          <q-item-label lines="1">{{ wallet.name }}</q-item-label>\n          <q-item-label v-if="LNBITS_DENOMINATION != \'sats\'" caption>{{ parseFloat(String(wallet.live_fsat).replaceAll(",", "")) / 100  }} {{ LNBITS_DENOMINATION }}</q-item-label>\n          <q-item-label v-else caption>{{ wallet.live_fsat }} {{ LNBITS_DENOMINATION }}</q-item-label>\n        </q-item-section>\n        <q-item-section side v-show="activeWallet && activeWallet.id === wallet.id">\n          <q-icon name="chevron_right" color="grey-5" size="md"></q-icon>\n        </q-item-section>\n      </q-item>\n      <q-item clickable @click="showForm = !showForm">\n        <q-item-section side>\n          <q-icon :name="(showForm) ? \'remove\' : \'add\'" color="grey-5" size="md"></q-icon>\n        </q-item-section>\n        <q-item-section>\n          <q-item-label lines="1" class="text-caption" v-text="$t(\'add_wallet\')"></q-item-label>\n        </q-item-section>\n      </q-item>\n      <q-item v-if="showForm">\n        <q-item-section>\n          <q-form @submit="createWallet">\n            <q-input filled dense v-model="walletName" label="Name wallet *">\n              <template v-slot:append>\n                <q-btn round dense flat icon="send" size="sm" @click="createWallet" :disable="walletName === \'\'"></q-btn>\n              </template>\n            </q-input>\n          </q-form>\n        </q-item-section>\n      </q-item>\n    </q-list>\n  ',computed:{wallets:function(){var e=this.activeBalance;return this.user.wallets.map((function(t){return t.live_fsat=e.length&&e[0]===t.id?LNbits.utils.formatSat(e[1]):t.fsat,t}))}},methods:{createWallet:function(){LNbits.api.createWallet(this.user.wallets[0],this.walletName)},updateWalletBalance:function(e){this.activeBalance=e}},created:function(){window.user&&(this.user=LNbits.map.user(window.user)),window.wallet&&(this.activeWallet=LNbits.map.wallet(window.wallet)),EventHub.$on("update-wallet-balance",this.updateWalletBalance)}}),Vue.component("lnbits-extension-list",{data:function(){return{extensions:[],user:null}},template:'\n    <q-list v-if="user && userExtensions.length > 0" dense class="lnbits-drawer__q-list">\n      <q-item-label header v-text="$t(\'extensions\')"></q-item-label>\n      <q-item v-for="extension in userExtensions" :key="extension.code"\n        clickable\n        :active="extension.isActive"\n        tag="a" :href="extension.url">\n        <q-item-section side>\n          <q-avatar size="md">\n            <q-img\n              :src="extension.tile"\n              style="max-width:20px"\n            ></q-img>\n          </q-avatar>\n        </q-item-section>\n        <q-item-section>\n          <q-item-label lines="1">{{ extension.name }} </q-item-label>\n        </q-item-section>\n        <q-item-section side v-show="extension.isActive">\n          <q-icon name="chevron_right" color="grey-5" size="md"></q-icon>\n        </q-item-section>\n      </q-item>\n      <div class="lt-md q-mt-xl q-mb-xl"></div>\n    </q-list>\n  ',computed:{userExtensions:function(){if(!this.user)return[];var e=window.location.pathname,t=this.user.extensions;return this.extensions.filter((function(e){return-1!==t.indexOf(e.code)})).map((function(t){return t.isActive=e.startsWith(t.url),t}))}},created:function(){window.extensions&&(this.extensions=window.extensions.map((function(e){return LNbits.map.extension(e)})).sort((function(e,t){return e.name.localeCompare(t.name)}))),window.user&&(this.user=LNbits.map.user(window.user))}}),Vue.component("lnbits-manage",{props:["showAdmin","showNode"],data:function(){return{extensions:[],user:null}},template:'\n    <q-list v-if="user" dense class="lnbits-drawer__q-list">\n      <q-item-label header v-text="$t(\'manage\')"></q-item-label>\n      <div v-if="user.admin">\n        <q-item v-if=\'showAdmin\' clickable tag="a" href="/admin">\n          <q-item-section side>\n            <q-icon name="admin_panel_settings" color="grey-5" size="md"></q-icon>\n          </q-item-section>\n          <q-item-section>\n            <q-item-label lines="1" class="text-caption" v-text="$t(\'server\')"></q-item-label>\n          </q-item-section>\n        </q-item>\n        <q-item v-if=\'showNode\' clickable tag="a" href="/node">\n          <q-item-section side>\n            <q-icon name="developer_board" color="grey-5" size="md"></q-icon>\n          </q-item-section>\n          <q-item-section>\n            <q-item-label lines="1" class="text-caption" v-text="$t(\'node\')"></q-item-label>\n          </q-item-section>\n        </q-item>\n      </div>\n      <q-item clickable tag="a" href="/extensions">\n        <q-item-section side>\n          <q-icon name="extension" color="grey-5" size="md"></q-icon>\n        </q-item-section>\n        <q-item-section>\n          <q-item-label lines="1" class="text-caption" v-text="$t(\'extensions\')"></q-item-label>\n        </q-item-section>\n      </q-item>\n    </q-list>\n  ',created:function(){window.user&&(this.user=LNbits.map.user(window.user))}}),Vue.component("lnbits-payment-details",{props:["payment"],mixins:[windowMixin],data:function(){return{LNBITS_DENOMINATION:LNBITS_DENOMINATION}},template:'\n  <div class="q-py-md" style="text-align: left">\n\n  <div v-if="payment.tag" class="row justify-center q-mb-md">\n    <q-badge v-if="hasTag" color="yellow" text-color="black">\n      #{{ payment.tag }}\n    </q-badge>\n  </div>\n\n  <div class="row">\n    <b v-text="$t(\'created\')"></b>:\n    {{ payment.date }} ({{ payment.dateFrom }})\n  </div>\n\n  <div class="row">\n   <b v-text="$t(\'expiry\')"></b>:\n   {{ payment.expirydate }} ({{ payment.expirydateFrom }})\n  </div>\n\n  <div class="row">\n   <b v-text="$t(\'amount\')"></b>:\n    {{ (payment.amount / 1000).toFixed(3) }} {{LNBITS_DENOMINATION}}\n  </div>\n\n  <div class="row">\n    <b v-text="$t(\'fee\')"></b>:\n    {{ (payment.fee / 1000).toFixed(3) }} {{LNBITS_DENOMINATION}}\n  </div>\n\n  <div class="text-wrap">\n    <b style="white-space: nowrap;" v-text="$t(\'payment_hash\')"></b>:&nbsp;{{ payment.payment_hash }}\n        <q-icon name="content_copy" @click="copyText(payment.payment_hash)" size="1em" color="grey" class="q-mb-xs cursor-pointer" />\n  </div>\n\n  <div class="text-wrap">\n    <b style="white-space: nowrap;" v-text="$t(\'memo\')"></b>:&nbsp;{{ payment.memo }}\n  </div>\n\n  <div class="text-wrap" v-if="payment.webhook">\n    <b style="white-space: nowrap;" v-text="$t(\'webhook\')"></b>:&nbsp;{{ payment.webhook }}:&nbsp;<q-badge :color="webhookStatusColor" text-color="white">\n      {{ webhookStatusText }}\n    </q-badge>\n  </div>\n\n  <div class="text-wrap" v-if="hasPreimage">\n    <b style="white-space: nowrap;" v-text="$t(\'payment_proof\')"></b>:&nbsp;{{ payment.preimage }}\n  </div>\n\n  <div class="row" v-for="entry in extras">\n    <q-badge v-if="hasTag" color="secondary" text-color="white">\n      extra\n    </q-badge>\n    <b>{{ entry.key }}</b>:\n    {{ entry.value }}\n  </div>\n\n  <div class="row" v-if="hasSuccessAction">\n    <b>Success action</b>:\n      <lnbits-lnurlpay-success-action\n        :payment="payment"\n        :success_action="payment.extra.success_action"\n      ></lnbits-lnurlpay-success-action>\n  </div>\n\n</div>\n  ',computed:{hasPreimage(){return this.payment.preimage&&"0000000000000000000000000000000000000000000000000000000000000000"!==this.payment.preimage},hasSuccessAction(){return this.hasPreimage&&this.payment.extra&&this.payment.extra.success_action},webhookStatusColor(){return this.payment.webhook_status>=300||this.payment.webhook_status<0?"red-10":this.payment.webhook_status?"green-10":"cyan-7"},webhookStatusText(){return this.payment.webhook_status?this.payment.webhook_status:"not sent yet"},hasTag(){return this.payment.extra&&!!this.payment.extra.tag},extras(){if(!this.payment.extra)return[];let e=_.omit(this.payment.extra,["tag","success_action"]);return Object.keys(e).map((t=>({key:t,value:e[t]})))}}}),Vue.component("lnbits-lnurlpay-success-action",{props:["payment","success_action"],data(){return{decryptedValue:this.success_action.ciphertext}},template:'\n    <div>\n      <p class="q-mb-sm">{{ success_action.message || success_action.description }}</p>\n      <code v-if="decryptedValue" class="text-h6 q-mt-sm q-mb-none">\n        {{ decryptedValue }}\n      </code>\n      <p v-else-if="success_action.url" class="text-h6 q-mt-sm q-mb-none">\n        <a target="_blank" style="color: inherit;" :href="success_action.url">{{ success_action.url }}</a>\n      </p>\n    </div>\n  ',mounted:function(){if("aes"!==this.success_action.tag)return null;decryptLnurlPayAES(this.success_action,this.payment.preimage).then((e=>{this.decryptedValue=e}))}}),Vue.component("lnbits-qrcode",{mixins:[windowMixin],props:["value"],components:{[VueQrcode.name]:VueQrcode},data:()=>({logo:LNBITS_QR_LOGO}),template:'\n  <div class="qrcode__wrapper">\n    <qrcode :value="value"\n    :options="{errorCorrectionLevel: \'Q\', width: 800}" class="rounded-borders"></qrcode>\n    <img class="qrcode__image" :src="logo" alt="..." />\n  </div>\n  '}),Vue.component("lnbits-notifications-btn",{mixins:[windowMixin],props:["pubkey"],data:()=>({isSupported:!1,isSubscribed:!1,isPermissionGranted:!1,isPermissionDenied:!1}),template:'\n    <q-btn\n      v-if="g.user.wallets"\n      :disabled="!this.isSupported"\n      dense\n      flat\n      round\n      @click="toggleNotifications()"\n      :icon="this.isSubscribed ? \'notifications_active\' : \'notifications_off\'"\n      size="sm"\n      type="a"\n    >\n      <q-tooltip v-if="this.isSupported && !this.isSubscribed">Subscribe to notifications</q-tooltip>\n      <q-tooltip v-if="this.isSupported && this.isSubscribed">Unsubscribe from notifications</q-tooltip>\n      <q-tooltip v-if="this.isSupported && this.isPermissionDenied">\n          Notifications are disabled,<br/>please enable or reset permissions\n      </q-tooltip>\n      <q-tooltip v-if="!this.isSupported">Notifications are not supported</q-tooltip>\n    </q-btn>\n  ',methods:{urlB64ToUint8Array(e){const t=(e+"=".repeat((4-e.length%4)%4)).replace(/\-/g,"+").replace(/_/g,"/"),n=atob(t),i=new Uint8Array(n.length);for(let e=0;e<n.length;++e)i[e]=n.charCodeAt(e);return i},toggleNotifications(){this.isSubscribed?this.unsubscribe():this.subscribe()},saveUserSubscribed(e){let t=JSON.parse(this.$q.localStorage.getItem("lnbits.webpush.subscribedUsers"))||[];t.includes(e)||t.push(e),this.$q.localStorage.set("lnbits.webpush.subscribedUsers",JSON.stringify(t))},removeUserSubscribed(e){let t=JSON.parse(this.$q.localStorage.getItem("lnbits.webpush.subscribedUsers"))||[];t=t.filter((t=>t!==e)),this.$q.localStorage.set("lnbits.webpush.subscribedUsers",JSON.stringify(t))},isUserSubscribed(e){return(JSON.parse(this.$q.localStorage.getItem("lnbits.webpush.subscribedUsers"))||[]).includes(e)},subscribe(){var e=this;this.isSupported&&!this.isPermissionDenied&&(Notification.requestPermission().then((e=>{this.isPermissionGranted="granted"===e,this.isPermissionDenied="denied"===e})).catch((function(e){console.log(e)})),navigator.serviceWorker.ready.then((t=>{navigator.serviceWorker.getRegistration().then((t=>{t.pushManager.getSubscription().then((function(n){if(null===n||!e.isUserSubscribed(e.g.user.id)){const n={applicationServerKey:e.urlB64ToUint8Array(e.pubkey),userVisibleOnly:!0};t.pushManager.subscribe(n).then((function(t){LNbits.api.request("POST","/api/v1/webpush",e.g.user.wallets[0].adminkey,{subscription:JSON.stringify(t)}).then((function(t){e.saveUserSubscribed(t.data.user),e.isSubscribed=!0})).catch((function(e){LNbits.utils.notifyApiError(e)}))}))}})).catch((function(e){console.log(e)}))}))})))},unsubscribe(){var e=this;navigator.serviceWorker.ready.then((t=>{t.pushManager.getSubscription().then((t=>{t&&LNbits.api.request("DELETE","/api/v1/webpush?endpoint="+btoa(t.endpoint),e.g.user.wallets[0].adminkey).then((function(){e.removeUserSubscribed(e.g.user.id),e.isSubscribed=!1})).catch((function(e){LNbits.utils.notifyApiError(e)}))}))})).catch((function(e){console.log(e)}))},checkSupported:function(){let e="https:"===window.location.protocol,t="serviceWorker"in navigator,n="Notification"in window,i="PushManager"in window;return this.isSupported=e&&t&&n&&i,this.isSupported||console.log("Notifications disabled because requirements are not met:",{HTTPS:e,"Service Worker API":t,"Notification API":n,"Push API":i}),this.isSupported},updateSubscriptionStatus:async function(){var e=this;await navigator.serviceWorker.ready.then((t=>{t.pushManager.getSubscription().then((t=>{e.isSubscribed=!!t&&e.isUserSubscribed(e.g.user.id)}))})).catch((function(e){console.log(e)}))}},created:function(){this.isPermissionDenied="denied"===Notification.permission,this.checkSupported()&&this.updateSubscriptionStatus()}}),Vue.component("lnbits-dynamic-fields",{mixins:[windowMixin],props:["options","value"],data:()=>({formData:null}),template:'\n    <div v-if="formData">\n      <div class="row q-mb-lg" v-for="o in options">\n        <div class="col auto-width">\n          <p v-if=o.options?.length class="q-ml-xl">\n            <span v-text="o.name"></span> <small v-if="o.description"> (<span v-text="o.description"></span>)</small>\n          </p>\n          <lnbits-dynamic-fields v-if="o.options?.length" :options="o.options" v-model="formData[o.name]"\n            @input="handleValueChanged" class="q-ml-xl">\n          </lnbits-dynamic-fields>\n          <div v-else>\n            <q-input v-if="o.type === \'number\'" v-model="formData[o.name]" @input="handleValueChanged" type="number"\n              :label="o.name" :hint="o.description" filled dense>\n            </q-input>\n            <q-input v-else-if="o.type === \'text\'" v-model="formData[o.name]" @input="handleValueChanged" type="textarea"\n              rows="5" :label="o.name" :hint="o.description" filled dense>\n            </q-input>\n            <q-input v-else-if="o.type === \'password\'" v-model="formData[o.name]" @input="handleValueChanged" type="password"\n                :label="o.name" :hint="o.description" filled dense>\n            </q-input>\n            <div v-else-if="o.type === \'bool\'">\n              <q-item tag="label" v-ripple>\n                <q-item-section avatar top>\n                  <q-checkbox v-model="formData[o.name]" @input="handleValueChanged" />\n                </q-item-section>\n                <q-item-section>\n                  <q-item-label><span v-text="o.name"></span></q-item-label>\n                  <q-item-label caption> <span v-text="o.description"></span> </q-item-label>\n                </q-item-section>\n              </q-item>\n            </div>\n            <q-select v-else-if="o.type === \'select\'" v-model="formData[o.name]" @input="handleValueChanged" :label="o.name"\n              :hint="o.description" :options="o.values"></q-select>\n\n            <q-select v-else-if="o.isList" filled multiple dense v-model.trim="formData[o.name]" use-input use-chips\n              @input="handleValueChanged" multiple hide-dropdown-icon input-debounce="0" new-value-mode="add-unique"\n              :label="o.name" :hint="o.description">\n            </q-select>\n            <q-input v-else v-model="formData[o.name]" @input="handleValueChanged" :label="o.name" :hint="o.description"\n              filled dense>\n            </q-input>\n\n          </div>\n        </div>\n      </div>\n    </div>\n  ',methods:{buildData(e,t={}){return e.reduce(((e,n)=>(n.options?.length?e[n.name]=this.buildData(n.options,t[n.name]):e[n.name]=t[n.name]??n.default,e)),{})},handleValueChanged(){this.$emit("input",this.formData)}},created:function(){this.formData=this.buildData(this.options,this.value)}}),Vue.component("lnbits-funding-sources",{mixins:[windowMixin],props:["form-data","allowed-funding-sources"],computed:{fundingSources(){let e=[];for(const[t,n,i]of this.rawFundingSources){const n={};if(null!==i)for(let[e,t]of Object.entries(i))n[e]={label:t,value:null};e.push([t,n])}return new Map(e)}},data:()=>({rawFundingSources:[["VoidWallet","Void Wallet",null],["FakeWallet","Fake Wallet",{fake_wallet_secret:"Secret"}],["CoreLightningWallet","Core Lightning",{corelightning_rpc:"Endpoint"}],["CoreLightningRestWallet","Core Lightning Rest",{corelightning_rest_url:"Endpoint",corelightning_rest_cert:"Certificate",corelightning_rest_macaroon:"Macaroon"}],["LndRestWallet","Lightning Network Daemon (LND Rest)",{lnd_rest_endpoint:"Endpoint",lnd_rest_cert:"Certificate",lnd_rest_macaroon:"Macaroon",lnd_rest_macaroon_encrypted:"Encrypted Macaroon"}],["LndWallet","Lightning Network Daemon (LND)",{lnd_grpc_endpoint:"Endpoint",lnd_grpc_cert:"Certificate",lnd_grpc_port:"Port",lnd_grpc_admin_macaroon:"Admin Macaroon",lnd_grpc_macaroon_encrypted:"Encrypted Macaroon"}],["LnTipsWallet","LN.Tips",{lntips_api_endpoint:"Endpoint",lntips_api_key:"API Key"}],["LNPayWallet","LN Pay",{lnpay_api_endpoint:"Endpoint",lnpay_api_key:"API Key",lnpay_wallet_key:"Wallet Key"}],["EclairWallet","Eclair (ACINQ)",{eclair_url:"URL",eclair_pass:"Password"}],["LNbitsWallet","LNBits",{lnbits_endpoint:"Endpoint",lnbits_key:"Admin Key"}],["AlbyWallet","Alby",{alby_api_endpoint:"Endpoint",alby_access_token:"Key"}],["OpenNodeWallet","OpenNode",{opennode_api_endpoint:"Endpoint",opennode_key:"Key"}],["ClicheWallet","Cliche (NBD)",{cliche_endpoint:"Endpoint"}],["SparkWallet","Spark",{spark_url:"Endpoint",spark_token:"Token"}]]}),template:'\n    <div class="funding-sources">\n        <h6 class="q-mt-xl q-mb-md">Funding Sources</h6>\n        <div class="row">\n          <div class="col-12">\n            <p>Active Funding<small> (Requires server restart)</small></p>\n            <q-select\n              filled\n              v-model="formData.lnbits_backend_wallet_class"\n              hint="Select the active funding wallet"\n              :options="allowedFundingSources"\n            ></q-select>\n          </div>\n        </div>\n        <q-list\n          class="q-mt-md"\n          v-for="(fund, idx) in allowedFundingSources"\n          :key="idx"\n        >\n          <div v-if="fundingSources.get(fund) && fund === formData.lnbits_backend_wallet_class">\n            <div class="row"\n              v-for="([key, prop], i) in Object.entries(fundingSources.get(fund))"\n              :key="i"\n            >\n              <div class="col-12">\n                <q-input\n                  filled\n                  type="text"\n                  class="q-mt-sm"\n                  v-model="formData[key]"\n                  :label="prop.label"\n                  :hint="prop.hint"\n                ></q-input>\n              </div>\n            </div>\n          </div>\n        </q-list>\n    </div>\n  '}),Vue.component("lnbits-extension-settings-form",{name:"lnbits-extension-settings-form",props:["options","adminkey","endpoint"],methods:{updateSettings:async function(){if(!this.settings)return Quasar.plugins.Notify.create({message:"No settings to update",type:"negative"});try{const{data:e}=await LNbits.api.request("PUT",this.endpoint,this.adminkey,this.settings);this.settings=e}catch(e){LNbits.utils.notifyApiError(e)}},getSettings:async function(){try{const{data:e}=await LNbits.api.request("GET",this.endpoint,this.adminkey);this.settings=e}catch(e){LNbits.utils.notifyApiError(e)}},resetSettings:async function(){LNbits.utils.confirmDialog("Are you sure you want to reset the settings?").onOk((async()=>{try{await LNbits.api.request("DELETE",this.endpoint,this.adminkey),await this.getSettings()}catch(e){LNbits.utils.notifyApiError(e)}}))}},created:async function(){await this.getSettings()},template:'\n    <q-form v-if="settings" @submit="updateSettings" class="q-gutter-md">\n      <lnbits-dynamic-fields :options="options" v-model="settings"></lnbits-dynamic-fields>\n      <div class="row q-mt-lg">\n        <q-btn v-close-popup unelevated color="primary" type="submit">Update</q-btn>\n        <q-btn v-close-popup unelevated color="danger" @click="resetSettings" >Reset</q-btn>\n        <slot name="actions"></slot>\n      </div>\n    </q-form>\n  ',data:function(){return{settings:void 0}}}),Vue.component("lnbits-extension-settings-btn-dialog",{name:"lnbits-extension-settings-btn-dialog",props:["options","adminkey","endpoint"],template:'\n    <q-btn v-if="options" unelevated @click="show = true" color="primary" icon="settings" class="float-right">\n        <q-dialog v-model="show" position="top">\n          <q-card class="q-pa-lg q-pt-xl lnbits__dialog-card">\n            <lnbits-extension-settings-form :options="options" :adminkey="adminkey" :endpoint="endpoint">\n                <template v-slot:actions>\n                    <q-btn v-close-popup flat color="grey" class="q-ml-auto">Close</q-btn>\n                </template>\n            </lnbits-extension-settings-form>\n          </q-card>\n        </q-dialog>\n    </q-btn>\n  ',data:function(){return{show:!1}}});const bech32CharValues="qpzry9x8gf2tvdw0s3jn54khce6mua7l";function byteArrayToInt(e){let t=0;for(let n=0;n<e.length;++n)t=(t<<8)+e[n];return t}function bech32ToInt(e){let t=0;for(let n=0;n<e.length;n++)t*=32,t+=bech32CharValues.indexOf(e.charAt(n));return t}function bech32ToFiveBitArray(e){let t=[];for(let n=0;n<e.length;n++)t.push(bech32CharValues.indexOf(e.charAt(n)));return t}function fiveBitArrayTo8BitArray(e,t){let n=0,i=0,r=[];return e.forEach((e=>{i=(i<<5)+e,n+=5,n>=8&&(r.push(i>>n-8&255),n-=8)})),t&&n>0&&r.push(i<<8-n&255),r}function bech32ToUTF8String(e){let t=fiveBitArrayTo8BitArray(bech32ToFiveBitArray(e)),n="";for(let e=0;e<t.length;e++)n+="%"+("0"+t[e].toString(16)).slice(-2);return decodeURIComponent(n)}function byteArrayToHexString(e){return Array.prototype.map.call(e,(function(e){return("0"+(255&e).toString(16)).slice(-2)})).join("")}function textToHexString(e){let t="";for(let n=0;n<e.length;n++)t+=e.charCodeAt(n).toString(16);return t}function epochToDate(e){return new Date(1e3*e).toUTCString()}function isEmptyOrSpaces(e){return null===e||null!==e.match(/^ *$/)}function toFixed(e){var t;Math.abs(e)<1?(t=parseInt(e.toString().split("e-")[1]))&&(e*=Math.pow(10,t-1),e="0."+new Array(t).join("0")+e.toString().substring(2)):(t=parseInt(e.toString().split("+")[1]))>20&&(t-=20,e/=Math.pow(10,t),e+=new Array(t+1).join("0"));return e}
